package require Tk

################################################################################
# Select
# Copyright ©  2012 Dujardin J.-P. dujardin@mpl.ird.fr
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
################################################################################
global S

global fogver
set fogver "fogdraw 5.1"

# PROCEDURE gribouille - Debut
#
proc gribouille {specimens args} {
    #
    global S infile references base_fogeffectifs fogeffectifs fogindividus fogver
    #
    #set fogeffectifs $S(groupes)
    set fogeffectifs $args
    #debug "\nPROCEDURE GRIBOUILLE FOG5a \nfogeffectifs = $fogeffectifs\nindividus \n$specimens"
    
    global gr
    #
    # Pour ne pas interferer avec les "individus" de jpdraw.tcl
    set fogindividus $specimens;#liste de matrices de Hume
    #
    #global gr pad verjpd adda_lignes lignes polygone
    global gr pad verjpd lignes polygone
    
    if {[info exists adda_lignes]} {
        #tk_messageBox -message "adda_lignes existe ! $adda_lignes" -type ok
        unset adda_lignes
        #tk_messageBox -message "adda_lignes n'existe plus ! [info exists adda_lines]" -type ok
    } else  {
        #tk_messageBox -message "adda_lignes n'existe PAS ! [info exists adda_lines]" -type ok
    }
    
    #
    global etiquette;# il se peut qu'on ait demande a etiqueter chaque individu (ET)
    global doc;#dans ce cas 'doc' contient les etiquettes
    #
    #Histogramme
    global valclass fogenvind
    set fogenvind $fogindividus
    #
    if {[info exists gr] == 1} {global gr}
    global lm
    
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    #
    update idletasks
    flush stdout
    
    destroy .muestreo.entree
    destroy .muestreo.boutonBac
    destroy .progres
    destroy .subd
    
    set subdipop $fogindividus
    
    #debug Nov 2012
    #if {[info exists S(groupes)]} {debug "S(groupes) : $S(groupes)"}
    
    # VALEUR MINIMUM de l'abscisse
    # -----------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minpc1 [lindex $ordre 0]
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de l'ordonnee
    # -----------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minpc2 [lindex $ordre 0]
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # CENTRAGE DES VALEURS SUR ZERO pour l'abscisse
    # ---------------------------------------------
    set  fogindividuscentPC1 ""
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 3] - $minpc1]
        lappend fogindividuscentPC1 $somme
    }
    #debug
    #tk_messageBox -message "gribouille [llength $fogindividuscentPC1]  fogindividuscentPC1 <-> [llength $fogindividus] fogindividus" -type ok
    
    # CENTRAGE DES VALEURS SUR ZERO pour l'ordonnee
    # ---------------------------------------------
    set fogindividuscentPC2 ""
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 4] - $minpc2]
        lappend fogindividuscentPC2 $somme
    }
    #debug
    #tk_messageBox -message "gribouille [llength $fogindividuscentPC2]  fogindividuscentPC2 <-> [llength $fogindividus] fogindividus" -type ok
    
    #VALEUR MAXIMUM de l'abscisse centree
    # ------------------------------------
    set ordre [lsort -real $fogindividuscentPC1]
    set maxpcc1 [lindex $ordre end]
    set minpcc1 [lindex $ordre 0]
    
    #VALEUR MAXIMUM de l'ordonnee centree
    # ------------------------------------
    set ordre [lsort -real $fogindividuscentPC2]
    set maxpcc2 [lindex $ordre end]
    set minpcc2 [lindex $ordre 0]
    
    set corrx [expr {300.0/$maxpcc1}]
    set corry [expr {300.0/$maxpcc2}]
    
    
    # ------------------------------------------------
    # preparation du graphique de la procedure gribouille
    # ------------------------------------------------
    #
    # Un nom different pour le canvas en fonction des modules qui appellent ?
    # Par exemple ADplottgribouille
    # Par exemple MOGADplottgribouille
    # Par exemple COVplottgribouille
    #
    #
    set w .plottgribouille
    
    set fogc .plottgribouille.c
    # La variable w contient .plottgribouille (global S; set S(wc) $w.c ?)
    
    set S(w) $w
    set S(wc) $w.c
    
    catch {destroy $w}
    toplevel $w
    wm geometry $w 650x580+205+10
    # Adapter le titre de .plottgribouille selon l'analyse
    if {[info exists pad]} {
        if {$pad == 1} {
            set iconom "CVA X=CV1, Y=CV2"
        } else  {
            set iconom "PCA X=PC1, Y=PC2"
        }
    } else  {
        set iconom "PCA X=PC1, Y=PC2"
    }
    wm title $w $iconom
    wm iconname $w [lrange $iconom 0 0]
    
    #wm title $w "X = factor 1, Y = factor 2"
    #wm iconname $w "factor 1 en X, factor 2 en Y"
    
    set Font {Helvetica 10}
    
    frame $w.buttons;# les boutons de gribouille
    pack $w.buttons -side bottom -fill x -pady 2m
    #
    button $w.buttons.color -background red -foreground white -text "Color" -command {
                if {[info exists adda_lignes]} {unset adda_lignes}
                global S polygone references base_fogeffectifs;# adda_lignes enleve
                global gr;#attention au contenu de ce 'gr': ce doit etre le NOMBRE de groupes, PAS leur composition
                if {[info exists adda_lignes]} {
                    type "adda_lignes $adda_lignes ??"
                    set fogeffectifs $base_fogeffectifs
                }
                set polygone 0
                fogsubextractcol $fogindividus
            }
    #
    button $w.buttons.jecolor -background red -foreground white -text "SC" \
            -command {
                global jepeins fogeffectifs
                set jepeins 1
                
                if { [catch {dalton $fogeffectifs $fogindividus} fid] } {
                    tk_messageBox -message "\"SC\" cannot paint undefined groups \n(use the \"Color\" button first)" -type ok
                    return
                }
                #dalton $fogeffectifs $fogindividus
                #jecolore $fogeffectifs $fogindividus
            }
    balloonhelp_for $w.buttons.jecolor "seleccionar los colores\nTo select the color"
    #
    button $w.buttons.group -background red -foreground white -text "Num" \
            -command {
                global polygone references base_fogeffectifs
                if {[info exists adda_lignes]} {unset adda_lignes}
                set polygone 0
                if {[info exists adda_lignes]} {
                    set fogeffectifs $base_fogeffectifs
                }
                fogsubextractgro $fogindividus
            }
    balloonhelp_for $w.buttons.group "Numbered groups\nGrupos enumerados"
    #
    button $w.buttons.chull -background red -foreground white -text "C. Hulls" \
            -command {
                global base_fogeffectifs fogeffectifs fogenvind
                #
                #set fogeffectifs $base_fogeffectifs
                # Effectifs ou pas
                destroy .subd
                set fen .subd
                catch {destroy $fen}
                toplevel $fen
                wm geometry $fen 220x90+280+380
                if {[info exists fogeffectifs]} {wm iconname $fen "$fogeffectifs"}
                set llamada [entry .subd.entree -background white -textvariable subd_fogeffectifs]
                set orden [button .subd.bouton -background grey25 -foreground white \
                    -text "Enter group sizes separated \nby a space, \nthen press me" \
                    -font "Helvetica 12" \
                    -command {
                        global fogeffectifs fogenvind
                        set fogeffectifs $subd_fogeffectifs
                        debug "CHuls : on a entre $subd_effectifs soit [llength $fogeffectifs] groupes]"
                        #
                        gribouille $fogenvind}]
                pack $llamada $orden
            }
    balloonhelp_for $w.buttons.chull "Convex hulls\nPoligonos externos"
    #
    button $w.buttons.indiv -background red -foreground white -text "Indiv" \
            -command {
                global polygone references
                set polygone 0
                enum $fogindividus
            }
    balloonhelp_for $w.buttons.indiv "Individuals\nIndividuos"
    
    if {[info exists etiquette] != 0} {
        # On peut zoomer si on a ecrit les etiquettes
        button $w.buttons.zoomet -text "Z" -command {
            global S fogindividus etiquette doc
            #.plottgribouille.c scale all 0 0 1.5 1.5;# global S; $S(wc) scale all ?
            $S(wc) scale all
            #.plottgribouille.c itemconfigure ovalitem -fill red
            $S(wc) itemconfigure ovalitem -fill red
            #.plottgribouille.c configure -scrollregion [.plottgribouille.c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
            $S(wc) configure -scrollregion [.plottgribouille.c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
            $S(wc) configure -scrollregion [ $S(wc) bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
            #zoomet $fogindividus
            balloonhelp_for $w.buttons.zoomet "Zoom"
        }
        #
    }
    #
    button $w.buttons.nd -text ". ?" -bg red -fg white\
            -command {
                # nd = no dots
                set lc [.plottgribouille.c find withtag ovalitem]
                foreach item $lc {.plottgribouille.c delete $item}
            }
    balloonhelp_for $w.buttons.nd "sin puntos ?\nwithout dots?"
    #
    button $w.buttons.nc -background red -foreground white -text "# ?" \
            -command {
                set dc [$S(wc) find withtag centroide]
                foreach item $dc {
                    $S(wc) delete $item
                }
            }
    balloonhelp_for $w.buttons.nc "No centroid(s)"
    #
    button $w.buttons.esqu -background red -foreground white -text "--?" \
            -command {
                global polygone references
                set polygone 0
                set dc [$S(wc) find withtag allhulls]
                foreach item $dc {
                    $S(wc) delete $item
                }
            }
    balloonhelp_for $w.buttons.esqu "No polygons"
    #
    #
    button $w.buttons.doc -background red -foreground white -text "Lbl" -command {
        global S infile polygone fogindividus etiquette doc references
        set S(etiquettes) 1
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        # ne sais quoi faire de ce polygone en ce moment
        set polygone 0
        # gribouille: seulette suis, seulette veux etre, seulette m'a mon doux ami laissee
        #
        ## ouvrir un fichier contenant les etiquettes, et en creer la liste doc
        # # On va chercher les etiquettes
        set typeList {
            {{"Text files"} {.txt .TXT} }
        }
        set docinfile [tk_getOpenFile -filetypes $typeList -initialdir $dirinfile]
        set S(docinfile) $docinfile
        #docinfile contient le chemin et le nom du fichier des donnees
        #set fin "etiquettes.txt"
        #set docinfile $dirinfile$fin
        
        # On verifie l'existence d'un fichier
        catch [set ano [glob -nocomplain $docinfile]] ici
        if {[string first $docinfile $ano] > -1} {
            set oui 1
        } else {
            set oui 0
        }
        if {$oui == 1} {
            # Si le fichier existe,
            set doc [etiquetage $docinfile]
            # recommencer le dessin avec le drapeau etiquette hisse
            set etiquette 1
            # etiquette = 1, donc info exists etc. = [info exists etiquette]
            gribouille $fogindividus
        }
        if {$oui == 0} {
            tk_messageBox -message "$docinfile\nnot created" -type ok
        }
        
    }
    #
    update
    balloonhelp_for $w.buttons.doc "This option requires a one column file containing labels\
            \n (except first row which is a comment), in\
            $dirinfile"
    
    ################################################################################
    button $w.buttons.zoom -text "Z" -command {
        .plottgribouille.c scale all 0 0 1.5 1.5
        .plottgribouille.c configure -scrollregion [.plottgribouille.c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    }
    balloonhelp_for $w.buttons.zoom "ZOOM"
    ################################################################################
    
    set flecheht [file join $S(dirclic) "+/fleche_haut.xbm"]
    set flechebs [file join $S(dirclic) "+/fleche_bas.xbm"]
    image create bitmap fleche_haut -file $flecheht
    image create bitmap fleche_bas -file $flechebs
    #
    button $w.buttons.class_haut -image  fleche_haut -command {
        global valclass fogeffectifs
        set valclass [expr {$valclass + 2}]
        if {$valclass > 50} {
            tk_messageBox -message "50 instead of $valclass classes have been accepted" -icon warning -type ok
            set valclass 50
        }
        gribouille $fogindividus $fogeffectifs
    }
    #
    button $w.buttons.class_bas -image  fleche_bas -command {
        global valclass fogeffectifs
        set valclass [expr {$valclass - 2}]
        if {$valclass < 6} {
            tk_messageBox -message "1 instead of $valclass classes have been accepted" -icon warning -type ok
            set valclass 6
        }
        gribouille $fogindividus $fogeffectifs
    }
    #
    button $w.buttons.cancel -foreground black -text "X " -command {
        global S
        if {[info exists etiquette] != 0} {unset etiquette}
        destroy .plottgribouille
    }
    #
    button $w.buttons.ps -text "save (.ps)" -command {
        # #debug
        # Pour etre sur de ce que j'enregistre en postscript
        # je vais placer ici une procedure de verification
        # qui montrera ce que presente le canvas .plottgribouille.c
        # verifdebug
        # fin du debug
        update idletasks
        flush stdout
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile \
                -defaultextension .eps]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottgribouille.c postscript];# ( global S; ... $S(wc) ? )
        close $outputGraphe
    }
    #
    #
    if {[info exists gr]} {
        
        if {$gr == 2} {
            #tk_messageBox -message "groupes $gr" -type ok
            if {[info exists pad] && $pad == 1} {
                if {[llength $fogeffectifs] > 2} {
                    pack $w.buttons.ps $w.buttons.esqu $w.buttons.nc $w.buttons.cancel -side left -expand 1
                } else  {
                    #tk_messageBox -message "(else) gr = $gr" -type ok
                    pack $w.buttons.ps $w.buttons.class_haut  $w.buttons.class_bas  $w.buttons.cancel \
                            -side left -expand 1
                }
            } else  {
                pack $w.buttons.ps $w.buttons.doc $w.buttons.color $w.buttons.jecolor $w.buttons.group\
                        $w.buttons.indiv $w.buttons.nd $w.buttons.esqu $w.buttons.nc $w.buttons.zoom $w.buttons.cancel \
                        -side left -expand 1
            }
        } else  {
            pack $w.buttons.ps $w.buttons.doc $w.buttons.color $w.buttons.jecolor $w.buttons.group $w.buttons.indiv \
                    $w.buttons.nd $w.buttons.esqu $w.buttons.nc $w.buttons.zoom $w.buttons.cancel -side left -expand 1
        }
    } else  {
        #tk_messageBox -message "etiquettes = $etiquette" -type ok
        if {[info exists etiquette] == 0} {
            pack $w.buttons.ps $w.buttons.doc $w.buttons.color $w.buttons.jecolor $w.buttons.group\
                    $w.buttons.indiv $w.buttons.nd $w.buttons.esqu $w.buttons.cancel\
                    -side left -expand 1
        } else  {
            pack $w.buttons.ps $w.buttons.doc $w.buttons.zoomet $w.buttons.chull $w.buttons.color $w.buttons.jecolor $w.buttons.group \
                    $w.buttons.indiv $w.buttons.nd $w.buttons.esqu $w.buttons.cancel \
                    -side left -expand 1
        }
    }
    
    
    # On dresse le trepied sur lequel poser la toile
    #
    canvas $fogc -width 450 -height 450 -relief raised -background "light yellow"\
            -yscrollcommand "$w.v_scroll_tut set" \
            -xscrollcommand "$w.h_scroll_tut set"
    scrollbar $w.v_scroll_tut -command "$fogc yview" -orient vertical
    scrollbar $w.h_scroll_tut -command "$fogc xview" -orient horizontal
    pack $w.v_scroll_tut -side right -fill y
    pack $w.h_scroll_tut -side bottom -fill x
    pack $fogc -side top -expand yes -fill both
    
    
    set plotFont {Helvetica 16}
    
    #################################################################################
    # Si c'est une AD, ou si on ne veut pas d'axes proportionnels, le plot est carre
    if {[info exists pad] && $pad == 1} {
        #tk_messageBox -message "pad..." -type ok
        set blup 300.0
        set xgauche 100
        set plic [expr (400 - $blup)/2]
        $fogc create line 100 [expr 400 - $plic] 400 [expr 400 - $plic]\
                -width 1 -fill blue -tag axe_x
        ##### axe des x croit de g a droite (procedure gribouille)
        $fogc create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)]\
                -width 1 -fill blue -tag axe_y
        ##### axe des y decroit de bas en ht
        set corry [expr ($blup/$maxpcc2)]
        for {set i 0} {$i <= 10} {incr i} {
            set x [expr {100 + ($i*30)}]
            $fogc create line $x [expr 400 - $plic] $x [expr 395 - $plic] \
                    -width 1 -fill blue -tag axe_x
        }
        set hauteurY [expr ($blup)]
        set subdivisionY [expr $hauteurY/10]
        for {set i 0} {$i <= 10} {incr i} {
            set y [expr {400 - $plic - ($i*$subdivisionY)}]
            $fogc create line 100 $y 105 $y -width 1 -fill blue -tag axe_y
        }
        # sinon on fait un plot aux axes proportionels
    } else  {
        #################################################################################
        # il ne s'agit pas d'une AD
        if {$maxpcc1 > $maxpcc2} {
            set blup [expr 300.0 * $maxpcc2/$maxpcc1]
            set xgauche 100
            set plic [expr (400 - $blup)/2]
            $fogc create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] \
                    -width 1  -fill blue;##### axe des x croit de g a droite (procedure gribouille)
            $fogc create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] \
                    -width 1  -fill blue;##### axe des y decroit de bas en ht
            set corry [expr ($blup/$maxpcc2)]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {100 + ($i*30)}]
                $fogc create line $x [expr 400 - $plic] $x [expr 395 - $plic] \
                        -width 1 -fill blue -tag axe_x
            }
            set hauteurY [expr ($blup)]
            set subdivisionY [expr $hauteurY/10]
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {400 - $plic - ($i*$subdivisionY)}]
                $fogc create line 100 $y 105 $y -width 1 -fill blue -tag axe_y
            }
        } else {
            set blup [expr 300.0 * $maxpcc1/$maxpcc2]
            set plic  50
            set ploc [expr (450 - $blup)/2]
            set xgauche [expr 450-$ploc-$blup]
            $fogc create line [expr 450-$ploc-$blup] 350 [expr 450 - $ploc] 350 \
                    -width 2  -fill blue;##### axe des x croit de g a droite (procedure gribouille)
            $fogc create line [expr 450-$ploc-$blup] 350 [expr 450-$ploc-$blup] 50 \
                    -width 2  -fill blue;##### axe des y decroit de bas en ht
            set corrx [expr ($blup/$maxpcc1)]
            
            set longueurX [expr ($blup)]
            set subdivisionX [expr $longueurX/10]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {(450-$ploc-$blup) + ($i*$subdivisionX)}]
                $fogc create line $x 350 $x 345 -width 2 -fill blue -tag axe_x
            }
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {350 - ($i*30)}]
                $fogc create line $xgauche $y [expr $xgauche + 5] $y -width 2 -fill blue -tag axe_y
            }
        }
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update idletasks
    set textFont {Helvetica 8}
    
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr $sumpc1 + [lindex $pc1 $i]]
    }
    set moypc1 [expr $sumpc1 * 1.0/$npc]
    set minMpc1 [expr $minpc1 - $moypc1]
    set maxMpc1 [expr $maxpc1 - $moypc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr $sumpc2 + [lindex $pc2 $i]]
    }
    set moypc2 [expr $sumpc2 * 1.0/$npc]
    set minMpc2 [expr $minpc2 - $moypc1]
    set maxMpc2 [expr $maxpc2 - $moypc1]
    ## Fin du centrage sur les moyennes ------------------
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    
    if {[info exists S(docinfile)]} {
        set tc "L A B E L S: $S(docinfile)"
        $fogc create text 40 415 -text $tc -font $textFont -anchor w -fill "dark green" -tag facteurs
    } else  {
        set tc "$iconom \n\nFactor 1 = desde $minF1  a  $maxF1  -  \nFactor 2 = desde $minF2  a  $maxF2 \
                \n\nFactor 1, range: [expr {abs($minF1  -  $maxF1)}]\
                \nFactor 2, range: [expr {abs($minF2  -  $maxF2)}]"
        $fogc create text 40 425 -text $tc -font $textFont -anchor w -fill blue -tag facteurs
    }
    #
    
    $fogc create text 40 465 -text $references -font "Courrier 7" -anchor w -fill black -tag data_info
    $fogc itemconfigure data_info -anchor nw -justify left -width 450
    
    ########################################################################
    # S'il ne s'agit pas d'une autre analyse que l'AD, et s'il n' y a que deux groupes,
    # Effacer ce qu'il y a deja sur le canvas, et gribouiller un histogramme
    #
    if {[info exists pad] && $pad == 1} {
        #
        if {$gr == 2} {
            #debug "2 groupes cfr gr = $gr"
            if {[info exists adda_lignes]} {
                global base_gr base_fogeffectifs;# adda_lignes enleve
                set fogeffectifs [concat $base_fogeffectifs $adda_lignes];#on insiste pour autoriser un autre bouton
                set fogeffectifs [regsub -all {\{|\}} $fogeffectifs ""]
                #debug "2 groupes cfr gr = $gr -- et -- 'info exists adda_lignes' = [info exists adda_lignes]"
                debug "Il existe adda_lignes... fogeffectifs = $fogeffectifs"
            } else  {
                #debug
                set je debug
                #debug "else AVANT: Existerait-il adda_lignes?? fogeffectifs = $fogeffectifs"
                set fogeffectifs [regsub -all {\{|\}} $fogeffectifs ""]
                #debug "else APRES: Existerait-il adda_lignes?? fogeffectifs = $fogeffectifs"
            }
            # J'efface
            set fogc .plottgribouille.c;#set fogc $S(wc) ?
            set lc [$fogc find withtag axe_y]
            foreach item $lc {$fogc delete $item}
            set lc [$fogc find withtag axe_x]
            foreach item $lc {$fogc delete $item}
            set lc [$fogc find withtag facteurs]
            foreach item $lc {$fogc delete $item}
            # Je gribouille l'histogramme
            #
            #debug "fogeffectifs = $fogeffectifs\nllength fogeffectifs = [llength $fogeffectifs]  "
            #
            if {[llength $fogeffectifs] > 2} {
                # s'il y a des donnees supplementaires
                foreach item $fogindividuscentPC1 {
                    append new "[expr {$item * 100}] "
                }
                #debug
                #aa "2 groupes cfr gr = $gr -- et -- des donnees supplementaires 'llength fogeffectifs' = [llength $fogeffectifs]"
                set fogindividuscentPC1 $new
                #
                set compteur 0
                for {set i 0} {$i < [llength $fogeffectifs]} {incr i} {
                    lappend donnees [lrange $fogindividuscentPC1 $compteur [expr {$compteur + [lindex $fogeffectifs $i]-1}]]
                    #debug
                    #tk_messageBox -message "compteur $compteur to  [expr {$compteur + [lindex $fogeffectifs $i]-1}] = data [expr {$i+1}] = [lindex $donnees $i]" -type okcancel
                    set compteur [expr {$compteur + [lindex $fogeffectifs $i]}]
                }
                #
                # ... les arguments de l'appel a HISTOGRAVE incluent le nom du canvas
                if {[info exists valclass] == 0} {set valclass 10}
                set alpha  [lindex $donnees 0]
                set beta [lindex $donnees 1]
                set gamma  [lindex $donnees 2]
                set fogeffectifs "[llength [lindex $donnees 0] ] [llength [lindex $donnees 1] ] [llength [lindex $donnees 2] ]"
                #debug
                #tk_messageBox -message "fogeffectifs $fogeffectifs" -type okcancel
                histograve $alpha $beta $gamma $valclass $c
                return
            } else  {
                # s'il n'y a pas eu appel a des donnees externes
                set coul 0
                set quidam 0
                set fogeffectifs [regsub -all {\{|\}} $fogeffectifs ""]
                set legion [lindex $fogeffectifs $coul]
                set long [llength $fogindividuscentPC1]
                #debug "legion = $legion ...\n2 groupes cfr gr = $gr -- et -- pas eu appel a des donnees externes\
                        \nlong = [llength $fogindividuscentPC1]\
                        \nfogeffectifs = $fogeffectifs"
                for {set i 0} {$i < $long} {incr i} {
                    #
                    incr quidam
                    #debug "ind. $i : quidam (indiv) $quidam \t legion (groupe) $legion"
                    if {$quidam > $legion} {
                        set ind [ lindex $fogindividuscentPC1 $i ]
                        lappend data2 [expr {$ind * 100}]
                    } else  {
                        set ind [ lindex $fogindividuscentPC1 $i ]
                        lappend data1 [expr {$ind * 100}]
                    }
                }
            }
            # ... les arguments de l'appel a HISTOGRABE incluent le nom du canvas ('fogc')
            if {[info exists valclass] == 0} {set valclass 10}
            #
            #debug "data1: \n$data1 \ndata2: \n$data2 \nfogc \n$fogc"
            histograbe $data1 $data2 $valclass $fogc
            #
            return
        }
    }
    #
    ########################################################################
    
    # -------------------------------------------------------------------------------
    # Ecriture sur fond jaunatre des points bleus de la carte factorielle
    # ------------------------------------------------------------------------------
    set ovo 3
    set long [llength $fogindividuscentPC1]
    #debug
    #aa "long $long - == - [llength $fogindividuscentPC1] --  4243: Ecriture sur fond jaunatre ..."
    set coul 0
    set quidam 0
    #chull
    # Si le bouton CHULL est active

    if {[info exists fogeffectifs]} {
        if {[llength $fogeffectifs] > 1} {
            set legion [lindex $fogeffectifs $coul]
            set canvas_g ""
        }
    }
    if {[info exists adda_lignes] == 1} {
        #debug
        #tk_messageBox -message "adda_lignes ? [info exists adda_lignes]" -type ok
        if {$adda_lignes < $long} {set long [expr {$long - $adda_lignes}]} else {
            #tk_messageBox -message "adda_lignes = $adda_lignes\nlong = $long\nCorrection de bug buggisante en jpdraw 14 ligne 4366"
            unset adda_lignes
            #return
        }
        #DEBUG
        #aa "long = expr 'lon -> $long       -      adda_lignes -> $adda_lignes' -- 4366"
    }
    # ------------------------------------------------------------
    # D'un individu 'i'  a l'autre
    # ------------------------------------------------------------
    set sumindpc1 0
    set sumindpc2 0
    set listex "";# futur calcul du plus petit et du plus grand CP1 pour les labels choisis
    set listey "";# futur calcul du plus petit et du plus grand CP2 pour les labels choisis
    #
    #
    for {set i 0} {$i < $long} {incr i} {
        #
        incr quidam
        #debug
        #aa "quidam $quidam long $long"
        # Si le bouton CHULL est active
        if {[info exists fogeffectifs]} {
            if {[llength $fogeffectifs] > 1} {
                if {$quidam > $legion} {
                    #chull
                    set convexhulls [env::chull $canvas_g]
                    $fogc create line $convexhulls  -fill red -tag allhulls
                    set canvas_g ""
                    incr coul
                    incr legion [lindex $fogeffectifs $coul]
                    #debug
                    #aa "Ecriture sur fond jaunatre des points bleus de la carte factorielle\nfogeffectifs |$fogeffectifs| coul |$coul| \nlegion |$legion|"
                }
            }
        }
        # BOUTON chull, fin
        
        # Calcul de la position et affichage de l'objet $i ------------------------ debut -----
        #
        set indpc1 [ lindex $fogindividuscentPC1 $i ]
        set indpc2 [ lindex $fogindividuscentPC2 $i ]
        
        # pour le calcul du point centroide - debut
        set sumindpc1 [expr {$sumindpc1 + $indpc1}]
        set sumindpc2 [expr {$sumindpc2 + $indpc2}]
        # pour le calcul du point centroide - fin
        
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        
        # On affiche un cercle, bleu
        if {[info exists etiquette] == 0} {
            set item [$fogc create oval [expr {$x-$ovo}] [expr {$y+$ovo}] [expr {$x+$ovo}] [expr {$y-$ovo}] \
                    -width 1 -outline blue -tag ovalitem]
            $fogc addtag point withtag $item
            append canvas_g "$x $y "
        } else  {
            # ou alors on affiche une etiquette
            set eti [lindex $doc $i]
            if {$eti != "."} {
                lappend listex $indpc1;# futur calcul du plus petit et du plus grand CP1 pour les labels choisis
                lappend listey $indpc2;# futur calcul du plus petit et du plus grand CP2 pour les labels choisis
            }
            set item [$fogc create text $x $y -text $eti -fill blue -tag tzou]
            $fogc addtag point withtag $item
            append canvas_g "$x $y "
        }
        #
        # Calcul de la position et affichage du point $i ------------------------ fin -----
        #debug $listex
    }
    # Fin des boutons bleus
    
    if {[info exists etiquette]} {
        set listexordre [lsort -real $listex]
        set listeyordre [lsort -real $listey]
        #
        set rangex [expr {abs([lindex $listexordre end] - [lindex $listexordre 0])}]
        set rangey [expr {abs([lindex $listeyordre end] - [lindex $listeyordre 0])}]
        set tcc "\
                \n\nFactor 1, range: $rangex\
                \nFactor 2, range: $rangey"
        $fogc create text 40 435 -text $tcc -font "Courrier 7" -anchor w -fill "dark green" -tag data_info
    }
    
    # pour le calcul et l'affichage du point centroide --- debut
    set moyindpc1 [expr {$sumindpc1 * 1 / $long}]
    set moyindpc2 [expr {$sumindpc2 * 1 / $long}]
    set x [ expr { $xgauche + ( $corrx * $moyindpc1 ) } ]
    set y [ expr { 400 - $plic - ( $corry * $moyindpc2 ) } ]
    set item [$fogc create rectangle [expr {$x-5}] [expr {$y+5}] [expr {$x+5}] [expr {$y-5}] \
            -width 2 -outline "dark blue" -tag centroide]
    #
    #
    # pour le calcul et l'affichage du point centroide --- fin
    
    if {[info exists fogeffectifs]} {
        if {[llength $fogeffectifs] > 1} {
            #puts $canvas_g
            set convexhulls [env::chull $canvas_g]
            $fogc create line $convexhulls -fill red -tag allhulls
            set canvas_g ""
        }
    }
    
    # s'il y a des fogindividus supplementaires apres une analyse discriminante
    if {[info exists adda_lignes] == 1} {
        # Projet njaram - debut
        # Si on veut documenter les fogindividus sur le graphique
        # il faut ici charger les donnees incluant les fogindividus additionnels
        # Projet njaram - fin
        set adda_long $long
        # je suppose que long contenait le numero d'fogindividus sans les externes
        # on lui donne ensuite la valeur du nombre total d'fogindividus
        set long [llength $fogindividuscentPC1]
        #debug
        #tk_messageBox -message "long $long - == - [llength $fogindividuscentPC1] <- IL Y A DES INDIV SUPPL -- 4347" -type ok
        for {set i $adda_long} {$i < $long} {incr i} {
            set indpc1 [ lindex $fogindividuscentPC1 $i ]
            set indpc2 [ lindex $fogindividuscentPC2 $i ]
            set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
            set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
            set item [$fogc create oval $x [expr {$y-10}] [expr {$x+10}] $y -width 1 -fill blue -tag ovalitem]
            $fogc addtag point withtag $item
        }
    }
    
    set plot(lastX) 0
    set plot(lastY) 0
    
    if  {[info exists adda_lignes] != 0} {
        $fogc configure -cursor dot
        bind $fogc <ButtonPress> { datosext }
        balloonhelp_for .plottgribouille.c "Clic sobre la figura -> etapas y comentarios";# ... for  $S(wc) ?
    }
    
    $fogc configure -scrollregion [$fogc bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    
}
#
# PROCEDURE gribouille   ## FIN ###

proc cannevas {} {
    global fogc
    # ------------------------------------------------
    # preparation du graphique de la procedure ebauche
    # ------------------------------------------------
    #
    # Un nom different pour le canvas en fonction des modules qui appellent ?
    # Par exemple ADplottebauche
    # Par exemple MOGADplottebauche
    # Par exemple COVplottebauche
    #
    set w .plottebauche
    
    set fogc .plottebauche.c
    # La variable w contient .plottebauche (global S; set S(wc) $w.c ?)
    
    set S(w) $w
    set S(wc) $w.c
    
    catch {destroy $w}
    toplevel $w
    wm geometry $w 550x480+205+10
    wm title $w "X = factor 1, Y = factor 2"
    wm iconname $w "factor 1 en X, factor 2 en Y"
    
    set Font {Helvetica 10}
    
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    
    button $w.buttons.color -background red -foreground white -text "Color" \
            -command {
                global polygone references base_fogeffectifs;#adda_lignes enleve
                if {[info exists adda_lignes]} {
                    set fogeffectifs $base_fogeffectifs
                    set fogeffectifs [regsub -all {\{|\}} $fogeffectifs ""]
                }
                set polygone 0
                fogsubextractcol $fogindividus
            }
    #
    button $w.buttons.jecolor -background red -foreground white -text "SC" \
            -command {
                global jepeins
                set jepeins 1
                dalton $fogeffectifs $fogindividus
                #jecolore $fogeffectifs $fogindividus
            }
    balloonhelp_for $w.buttons.jecolor "seleccionar los colores\nTo select the color"
    button $w.buttons.group -background red -foreground white -text "Num" \
            -command {
                global polygone references base_fogeffectifs
                set polygone 0
                if {[info exists adda_lignes]} {
                    set fogeffectifs $base_fogeffectifs
                    set fogeffectifs [regsub -all {\{|\}} $fogeffectifs ""]
                }
                fogsubextractgro $fogindividus
            }
    balloonhelp_for $w.buttons.group "Numbered groups\nGrupos enumerados"
    
    button $w.buttons.indiv -background red -foreground white -text "Indiv" \
            -command {
                global polygone references
                set polygone 0
                enum $fogindividus
            }
    balloonhelp_for $w.buttons.indiv "Individuals\nIndividuos"
    
    button $w.buttons.esqu -background red -foreground white -text "S" \
            -command {
                global polygone references
                set polygone 0
                griffonne $fogindividus;# ebauche avec le total des indiv et enlever le centroide !!
            }
    balloonhelp_for $w.buttons.esqu "Without polygons, without centroids"
    
    ################################################################################
    button $w.buttons.zoom -text "Z" -command {
        .plottebauche.c scale all 0 0 1.5 1.5
        .plottebauche.c configure -scrollregion [.plottebauche.c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    }
    balloonhelp_for $w.buttons.zoom "ZOOM"
    ################################################################################
    
    #set flecheht [file join $S(dirclic) "+/fleche_haut.xbm"]
    #set flechebs [file join $S(dirclic) "+/fleche_bas.xbm"]
    #image create bitmap fleche_haut -file $flecheht
    #image create bitmap fleche_bas -file $flechebs
    #image create bitmap fleche_haut -file +/fleche_haut.xbm
    #image create bitmap fleche_bas -file +/fleche_bas.xbm
    
    ################################################################################
    #     button $w.buttons.class_haut -image  fleche_haut -command {
    #         global valclass
    #         set valclass [expr {$valclass + 2}]
    #         if {$valclass > 50} {
    #             tk_messageBox -message "50 instead of $valclass classes have been accepted" -icon warning -type ok
    #             set valclass 50
    #         }
    #         ebauche $fogindividus
    #     }
    ################################################################################
    
    ################################################################################
    #     button $w.buttons.class_bas -image  fleche_bas -command {
    #         global valclass
    #         set valclass [expr {$valclass - 2}]
    #         if {$valclass < 6} {
    #             tk_messageBox -message "1 instead of $valclass classes have been accepted" -icon warning -type ok
    #             set valclass 6
    #         }
    #         ebauche $fogindividus
    #     }
    ################################################################################
    
    button $w.buttons.cancel -foreground black -text "X " -command {
        global S
        if {[info exists etiquette] != 0} {unset etiquette}
        #destroy .plottebauche;# destroy $w ?
        destroy $S(w)
    }
    
    button $w.buttons.ps -text "guardar/save (.ps)" -command {
        # #debug
        # Pour etre sur de ce que j'enregistre en postscript
        # je vais placer ici une procedure de verification
        # qui montrera ce que presente le canvas .plottebauche.c
        # verifdebug
        # fin du debug
        update idletasks
        flush stdout
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile \
                -defaultextension .eps]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottebauche.c postscript];# ( global S; ... $S(wc) ? )
        close $outputGraphe
    }
    
    pack $w.buttons.color $w.buttons.jecolor $w.buttons.group\
            $w.buttons.indiv $w.buttons.esqu $w.buttons.cancel\
            -side left -expand 1
    
    
    # 'fogc' contient '.plottebauche.c'
    #
    canvas $fogc -width 450 -height 450 -relief raised -background "light yellow"\
            -yscrollcommand "$w.v_scroll_tut set" \
            -xscrollcommand "$w.h_scroll_tut set"
    scrollbar $w.v_scroll_tut -command "$fogc yview" -orient vertical
    scrollbar $w.h_scroll_tut -command "$fogc xview" -orient horizontal
    pack $w.v_scroll_tut -side right -fill y
    pack $w.h_scroll_tut -side bottom -fill x
    pack $fogc -side top -expand yes -fill both
    
    
    set plotFont {Helvetica 16}
    
}
#
# PROCEDURE cannevas - fin -

# PROCEDURE ebauche - Debut (suivante = davinci)
#
proc ebauche {fogindividus} {
    #debug
    #aa "fogindividus [llength $fogindividus] ?? -- 3717"
    #
    global S p infile references base_fogeffectifs fogeffectifs fogc
    #
    #
    global gr pad verjpd lignes polygone;#adda_lignes enleve
    #
    global etiquette;# il se peut qu'on ait demande a etiqueter chaque individu (ET)
    global doc;#dans ce cas 'doc' contient les etiquettes
    #
    #Histogramme
    global valclass fogenvind
    set fogenvind $fogindividus
    #
    if {[info exists gr] == 1} {global gr}
    global lm
    
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    #
    update idletasks
    flush stdout
    
    destroy .muestreo.entree
    destroy .muestreo.boutonBac
    destroy .progres
    destroy .subd
    
    set subdipop $fogindividus
    
    # VALEUR MINIMUM de l'abscisse
    # -----------------------------
    set ordre ""
    foreach item $fogindividus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C;# ordre contient la liste des coordonnees X
        
    }
    
    set ordre [lsort -real $ordre];# ordre contient la liste CROISSANTE des coordonnees X
    set minpc1 [lindex $ordre 0];# X MINIMUM
    set maxpc1 [lindex $ordre end];# X MAXIMUM
    set pc1 $ordre;# pc1 contient la liste CROISSANTE des coordonnees X
    
    # VALEUR MINIMUM de l'ordonnee
    # -----------------------------
    set ordre ""
    foreach item $fogindividus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minpc2 [lindex $ordre 0];# Y MINIMUM
    set maxpc2 [lindex $ordre end];# Y MAXIMUM
    set pc2 $ordre
    
    $p insert end "\nX: $minpc1 <-> $maxpc1\t\tY: $minpc2 <-> $maxpc2"
    
    
    # CENTRAGE DES VALEURS SUR ZERO pour l'abscisse
    # ---------------------------------------------
    set  fogindividuscentPC1 ""
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 3] - $minpc1];# on enleve le X MINIMUM
        lappend fogindividuscentPC1 $somme
    }
    
    # CENTRAGE DES VALEURS SUR ZERO pour l'ordonnee
    # ---------------------------------------------
    set fogindividuscentPC2 ""
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 4] - $minpc2];# on enleve le Y MINIMUM
        lappend fogindividuscentPC2 $somme
    }
    
    #VALEUR MAXIMUM de l'abscisse centree
    # ------------------------------------
    set ordre [lsort -real $fogindividuscentPC1]
    set maxpcc1 [lindex $ordre end]
    set minpcc1 [lindex $ordre 0]
    
    #VALEUR MAXIMUM de l'ordonnee centree
    # ------------------------------------
    set ordre [lsort -real $fogindividuscentPC2]
    set maxpcc2 [lindex $ordre end]
    set minpcc2 [lindex $ordre 0]
    
    
    $p insert end "\nXc: $minpcc1 <-> $maxpcc1\t\tYc: $minpcc2 <-> $maxpcc2"
    
    set corrx [expr {400.0/$maxpcc1}]
    set corry [expr {400.0/$maxpcc2}]
    
    ###############################################################################
    
    #cannevas
    
    ###############################################################################
    
    # Axes proportionnesls
    if {$maxpcc1 > $maxpcc2} {
        set blup [expr 400.0 * $maxpcc2/$maxpcc1]
        set xgauche 100
        set plic [expr (400 - $blup)/2]
        set corry [expr ($blup/$maxpcc2)]
        set hauteurY [expr ($blup)]
        set subdivisionY [expr $hauteurY/10]
    } else {
        set blup [expr 400.0 * $maxpcc1/$maxpcc2]
        set plic  50
        set ploc [expr {(450 - $blup)/2}]
        set xgauche [expr {450-$ploc-$blup}]
        set corrx [expr ($blup/$maxpcc1)]
        set longueurX [expr ($blup)]
        set subdivisionX [expr $longueurX/10]
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update idletasks
    set textFont {Helvetica 8}
    
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr $sumpc1 + [lindex $pc1 $i]]
    }
    set moypc1 [expr $sumpc1 * 1.0/$npc]
    set minMpc1 [expr $minpc1 - $moypc1]
    set maxMpc1 [expr $maxpc1 - $moypc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr $sumpc2 + [lindex $pc2 $i]]
    }
    set moypc2 [expr $sumpc2 * 1.0/$npc]
    set minMpc2 [expr $minpc2 - $moypc1]
    set maxMpc2 [expr $maxpc2 - $moypc1]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    
    $fogc create text 40 425 -text $references -font "Courrier 7" -anchor w -fill red -tag data_info
    $fogc itemconfigure data_info -anchor nw -justify left -width 450
    
    # -------------------------------------------------------------------------------
    # Ecriture sur fond jaunatre des points blacks du contour
    # ------------------------------------------------------------------------------
    set ovo 1;# taille des points ovales
    set long [llength $fogindividuscentPC1]
    #
    set coul 0
    set quidam 0
    #
    
    # ------------------------------------------------------------
    # D'un individu 'i'  a l'autre
    # ------------------------------------------------------------
    set sumindpc1 0
    set sumindpc2 0
    #
    for {set i 0} {$i < $long} {incr i 3} {
        #
        incr quidam
        
        # Calcul de la position et affichage de l'objet $i ------------------------ debut -----
        #
        set indpc1 [ lindex $fogindividuscentPC1 $i ]
        set indpc2 [ lindex $fogindividuscentPC2 $i ]
        
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        
        #set x [ expr { $xgauche + ( $indpc1 ) } ]
        #set y [ expr { 400 - $plic - ( $indpc2 ) } ]
        
        # On affiche un contour noir
        set item [$fogc create oval [expr {$x-$ovo}] [expr {$y+$ovo}] [expr {$x+$ovo}] [expr {$y-$ovo}] \
                -width 1 -outline black -tag zou -tag peinture]
        $fogc addtag point withtag $item
        append canvas_g "$x $y "
        #
        # Calcul de la position et affichage du point $i ------------------------ fin -----
        
        
        
    }
    # Fin des boutons blacks
    #tk_messageBox -message "on continue?" -type ok
    
    #$fogc delete peinture;#effacement du contour
    
    set plot(lastX) 0
    set plot(lastY) 0
    
    $fogc configure -scrollregion [$fogc bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    
}
#
# PROCEDURE ebauche   ## FIN ###


# PROCEDURE davinci - Debut
#
proc davinci {fogindividus} {
    #
    global c S infile references base_fogeffectifs fogeffectifs lignes polygone lm
    #
    canne
    #
    # VALEUR MINIMUM de l'abscisse
    # -----------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    #
    set ordre [lsort -real $ordre]
    set minpc1 [lindex $ordre 0]
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    # VALEUR MINIMUM de l'ordonnee
    # -----------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    #
    set ordre [lsort -real $ordre]
    set minpc2 [lindex $ordre 0]
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    #
    # CENTRAGE DES VALEURS SUR ZERO pour l'abscisse
    # ---------------------------------------------
    set  fogindividuscentPC1 ""
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 3] - $minpc1]
        lappend fogindividuscentPC1 $somme
    }
    # CENTRAGE DES VALEURS SUR ZERO pour l'ordonnee
    # ---------------------------------------------
    set fogindividuscentPC2 ""
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 4] - $minpc2]
        lappend fogindividuscentPC2 $somme
    }
    #VALEUR MAXIMUM de l'abscisse centree
    # ------------------------------------
    set ordre [lsort -real $fogindividuscentPC1]
    set maxpcc1 [lindex $ordre end]
    set minpcc1 [lindex $ordre 0]
    #VALEUR MAXIMUM de l'ordonnee centree
    # ------------------------------------
    set ordre [lsort -real $fogindividuscentPC2]
    set maxpcc2 [lindex $ordre end]
    set minpcc2 [lindex $ordre 0]
    #
    set corrx [expr {300.0/$maxpcc1}]
    set corry [expr {300.0/$maxpcc2}]
    #
    # Axes proportionnesls
    if {$maxpcc1 > $maxpcc2} {
        set blup [expr 300.0 * $maxpcc2/$maxpcc1]
        set plic [expr (400 - $blup)/2]
        set xgauche 100
        set corry [expr ($blup/$maxpcc2)]
    } else {
        set blup [expr 300.0 * $maxpcc1/$maxpcc2]
        set plic  50
        set ploc [expr (450 - $blup)/2]
        set xgauche [expr 450-$ploc-$blup]
        set corrx [expr ($blup/$maxpcc1)]
    }
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr $sumpc1 + [lindex $pc1 $i]]
    }
    set moypc1 [expr $sumpc1 * 1.0/$npc]
    set minMpc1 [expr $minpc1 - $moypc1]
    set maxMpc1 [expr $maxpc1 - $moypc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr $sumpc2 + [lindex $pc2 $i]]
    }
    set moypc2 [expr $sumpc2 * 1.0/$npc]
    set minMpc2 [expr $minpc2 - $moypc1]
    set maxMpc2 [expr $maxpc2 - $moypc1]
    ## Fin du centrage sur les moyennes
    # -------------------------------------------------------------------------------
    # Ecriture sur fond jaunatre des points bleus de la carte factorielle
    # ------------------------------------------------------------------------------
    set ovo 1;# taille des points ovales
    set long [llength $fogindividuscentPC1]
    #
    for {set i 0} {$i < $long} {incr i} {
        # D' un indiv a l'autre
        #
        set indpc1 [ lindex $fogindividuscentPC1 $i ]
        set indpc2 [ lindex $fogindividuscentPC2 $i ]
        #
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        # On affiche un contour bleu
        set item [$fogc create oval [expr {$x-$ovo}] [expr {$y+$ovo}] [expr {$x+$ovo}] [expr {$y-$ovo}] -width 1 -outline black -tag zou -tag peinture]
        $fogc addtag point withtag $item
        append canvas_g "$x $y "
    }
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    set plotFont {Helvetica 16}
    set textFont {Helvetica 8}
    $fogc create text 40 425 -text $references -font "Courrier 7" -anchor w -fill red -tag data_info
    $fogc itemconfigure data_info -anchor nw -justify left -width 450
}
#
# Procedure DAVINCI  - FIN

# Procedure CANNE # start
#
proc canne {} {
    global c w S
    # Un nom different pour le canvas en fonction des modules qui appellent ?
    # Par exemple ADplottcanne
    # Par exemple MOGADplottcanne
    # Par exemple COVplottcanne
    #
    set w .plottcanne
    
    set fogc .plottcanne.c
    # La variable w contient .plottcanne (global S; set S(wc) $w.c ?)
    
    set S(w) $w
    set S(wc) $w.c
    
    catch {destroy $w}
    toplevel $w
    wm geometry $w 550x480+205+10
    wm title $w "X = factor 1, Y = factor 2"
    wm iconname $w "factor 1 en X, factor 2 en Y"
    
    set Font {Helvetica 10}
    
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    
    button $w.buttons.color -background red -foreground white -text "Color" \
            -command {
                global polygone references base_fogeffectifs;# adda_lignes enleve
                if {[info exists adda_lignes]} {
                    set fogeffectifs $base_fogeffectifs
                    set fogeffectifs [regsub -all {\{|\}} $fogeffectifs ""]
                }
                set polygone 0
                fogsubextractcol $fogindividus
            }
    #
    button $w.buttons.jecolor -background red -foreground white -text "SC" \
            -command {
                global jepeins
                set jepeins 1
                dalton $fogeffectifs $fogindividus
                #jedalton $fogeffectifs $fogindividus
            }
    balloonhelp_for $w.buttons.jecolor "seleccionar los colores\nTo select the color"
    button $w.buttons.group -background red -foreground white -text "Num" \
            -command {
                global polygone references base_fogeffectifs
                set polygone 0
                if {[info exists adda_lignes]} {
                    set fogeffectifs $base_fogeffectifs
                    set fogeffectifs [regsub -all {\{|\}} $fogeffectifs ""]
                }
                fogsubextractgro $fogindividus
            }
    balloonhelp_for $w.buttons.group "Numbered groups\nGrupos enumerados"
    
    button $w.buttons.indiv -background red -foreground white -text "Indiv" \
            -command {
                global polygone references
                set polygone 0
                enum $fogindividus
            }
    balloonhelp_for $w.buttons.indiv "Individuals\nIndividuos"
    
    button $w.buttons.esqu -background red -foreground white -text "S" \
            -command {
                global polygone references
                set polygone 0
                griffonne $fogindividus;# canne avec le total des indiv et enlever le centroide !!
            }
    balloonhelp_for $w.buttons.esqu "Without polygons, without centroids"
    
    ################################################################################
    button $w.buttons.zoom -text "Z" -command {
        .plottcanne.c scale all 0 0 1.5 1.5
        .plottcanne.c configure -scrollregion [.plottcanne.c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    }
    balloonhelp_for $w.buttons.zoom "ZOOM"
    ################################################################################
    
    set flecheht [file join $S(dirclic) "+/fleche_haut.xbm"]
    set flechebs [file join $S(dirclic) "+/fleche_bas.xbm"]
    image create bitmap fleche_haut -file $flecheht
    image create bitmap fleche_bas -file $flechebs
    #image create bitmap fleche_haut -file +/fleche_haut.xbm
    #image create bitmap fleche_bas -file +/fleche_bas.xbm
    
    button $w.buttons.class_haut -image  fleche_haut -command {
        global valclass
        set valclass [expr {$valclass + 2}]
        if {$valclass > 50} {
            tk_messageBox -message "50 instead of $valclass classes have been accepted" -icon warning -type ok
            set valclass 50
        }
        canne $fogindividus
    }
    
    button $w.buttons.class_bas -image  fleche_bas -command {
        global valclass
        set valclass [expr {$valclass - 2}]
        if {$valclass < 6} {
            tk_messageBox -message "1 instead of $valclass classes have been accepted" -icon warning -type ok
            set valclass 6
        }
        canne $fogindividus
    }
    
    button $w.buttons.cancel -foreground black -text "X " -command {
        global S
        if {[info exists etiquette] != 0} {unset etiquette}
        #destroy .plottcanne;# destroy $w ?
        destroy $S(w)
    }
    
    button $w.buttons.ps -text "guardar/save (.ps)" -command {
        # #debug
        # Pour etre sur de ce que j'enregistre en postscript
        # je vais placer ici une procedure de verification
        # qui montrera ce que presente le canvas .plottcanne.c
        # verifdebug
        # fin du debug
        update idletasks
        flush stdout
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile \
                -defaultextension .eps]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottcanne.c postscript];# ( global S; ... $S(wc) ? )
        close $outputGraphe
    }
    
    pack $w.buttons.color $w.buttons.jecolor $w.buttons.group\
            $w.buttons.indiv $w.buttons.esqu $w.buttons.cancel\
            -side left -expand 1
    
    
    # 'c' contient '.plottcanne.c'
    #
    canvas $fogc -width 450 -height 450 -relief raised -background "light yellow"\
            -yscrollcommand "$w.v_scroll_tut set" \
            -xscrollcommand "$w.h_scroll_tut set"
    scrollbar $w.v_scroll_tut -command "$fogc yview" -orient vertical
    scrollbar $w.h_scroll_tut -command "$fogc xview" -orient horizontal
    pack $w.v_scroll_tut -side right -fill y
    pack $w.h_scroll_tut -side bottom -fill x
    pack $fogc -side top -expand yes -fill both
    
    
    set plot(lastX) 0
    set plot(lastY) 0
    
    $fogc configure -scrollregion [$fogc bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
}
#
# Procedure CANNE # end


######################## PROCEDURE enum #### DEBUT###
proc enum {fogindividus} {
    #debug "ENUM\tfogindividus\n$fogindividus"
    destroy .subd
    
    #chull
    global fogeffectifs
    global fogenvind
    #global adda_lignes;#nov2009
    set fogenvind $fogindividus
    #debug chull
    #if {[info exists fogeffectifs]} {puts "fogeffectifs \n$fogeffectifs\nfogindividus\n$fogenvind"}
    global gr pad verjpd references
    
    if {[info exists adda_lignes] } {lappend fogeffectifs " $adda_lignes"};#nov2009
    #tk_messageBox -message "adda_lignes $adda_lignes - Effectifs $fogeffectifs" -type ok
    
    update
    flush stdout
    
    # VALEUR MINIMUM de l'abscisse
    # -----------------------------------------------
    set ordre {}
    
    foreach item $fogindividus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc1 [lindex $ordre 0]
    ## ajout August 2002
    set minpc1 $minimumpc1
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de l'ordonnee
    # (procedure enum)
    # -----------------------------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc2 [lindex $ordre 0]
    ## ajout August 2002
    set minpc2 $minimumpc2
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # MINIMUM SUR ZERO pour l'abscisse
    # (procedure enum)
    # --------------------------------------
    
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr {[lindex $item 3] - $minimumpc1}]
        lappend fogindividuscentPC1 $somme
    }
    
    
    # MINIMUM SUR ZERO pour l'ordonnee
    # (procedure enum)
    # --------------------------------------
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr {[lindex $item 4] - $minimumpc2}]
        lappend fogindividuscentPC2 $somme
    }
    
    #debug "debug enum fogindividuscentPC1 $fogindividuscentPC1\nfogindividuscentPC2 $fogindividuscentPC2"
    
    # VALEUR MAXIMUM DE l'abscisse centree
    # (procedure enum)
    # -------------------------------------------------------
    set ordre [lsort -real $fogindividuscentPC1]
    set maximumpc1 [lindex $ordre end]
    
    # VALEUR MAXIMUM de l'ordonnee centree
    # (procedure enum)
    # -------------------------------------------------------
    set ordre [lsort -real $fogindividuscentPC2]
    set maximumpc2 [lindex $ordre end]
    
    set corrx [expr {300.0/$maximumpc1}]
    set corry [expr {300.0/$maximumpc2}]
    
    ###################################################
    # preparation du graphique de la procedure enum
    ###################################################
    
    set w .plottenum
    catch {destroy $w}
    toplevel $w
    wm geometry $w 650x580+205+10
    wm title $w "X = factor 1, Y = factor 2"
    wm iconname $w "factor 1 en X, factor 2 en Y"
    
    set fogc $w.c
    
    set Font {Helvetica 6}
    
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    # chull
    button $w.buttons.chull -background red -foreground white -text "C. Hulls" \
            -command {
                global fogeffectifs fogenvind
                # Effectifs ou pas
                destroy .subd
                set fen .subd
                catch {destroy $fen}
                toplevel $fen
                wm geometry $fen 220x90+280+380
                if {[info exists fogeffectifs]} {wm iconname $fen "$fogeffectifs"}
                set appel [entry .subd.entree -background white -textvariable valeurs]
                set commando [button .subd.bouton -background grey25 -foreground white \
                -text "Enter group sizes separated \nby a space, \nthen press me" \
                -font "Helvetica 12" \
                -command {
                    global fogeffectifs fogenvind
                    set fogeffectifs $valeurs
                    set fogeffectifs [regsub -all {\{|\}} $fogeffectifs ""]
                    enum $fogenvind}]
                pack $appel $commando
            }
    button $w.buttons.cancel -text "<-" -command "destroy $w"
    button $w.buttons.zoom -text "Z" -command {
        .plottenum.c scale all 0 0 1.5 1.5
        .plottenum.c configure -scrollregion [.plottenum.c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    }
    button $w.buttons.ps -text "Save (.ps)" -bg white -command {
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile\
                -defaultextension .ps]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottenum.c postscript]
        close $outputGraphe
    }
    
    button $w.buttons.nc -background red -foreground white -text "# ?" \
            -command {
                global w
                set dc [.plottenum.c find withtag centroide]
                foreach item $dc {
                    .plottenum.c delete $item
                }
            }
    balloonhelp_for $w.buttons.nc "No centroid(s)"
    
    button $w.buttons.esqu -background red -foreground white -text "--?" \
            -command {
                global polygone references
                set polygone 0
                set dc [.plottenum.c find withtag allhulls]
                foreach item $dc {
                    .plottenum.c delete $item
                }
                #griffonne $fogindividus;# dessine avec le total des indiv et enlever le centroide !!
            }
    balloonhelp_for $w.buttons.esqu "No polygons"
    
    pack $w.buttons.ps $w.buttons.chull $w.buttons.esqu $w.buttons.nc $w.buttons.zoom $w.buttons.cancel -side left -expand 1
    balloonhelp_for $w.buttons.chull "Convex Hulls \nConnexion de los valores mas externos de cada grupo"
    
    canvas $fogc -width 450 -height 450 -relief raised -background white\
            -yscrollcommand "$w.v_scroll_tut set" \
            -xscrollcommand "$w.h_scroll_tut set"
    scrollbar $w.v_scroll_tut -command "$fogc yview" -orient vertical
    scrollbar $w.h_scroll_tut -command "$fogc xview" -orient horizontal
    pack $w.v_scroll_tut -side right -fill y
    pack $w.h_scroll_tut -side bottom -fill x
    pack $fogc -side top -expand yes -fill both
    
    pack $w.c -side top -expand yes -fill both
    
    set plotFont {Helvetica 8}
    
    ########################################################################
    # SSi c'est una AD, le plot est carre
    if {[info exists pad] && $pad == 1} {
        set blup 300.0
        set xgauche 100
        set plic [expr {(400 - $blup)/2}]
        $fogc create line 100 [expr {400 - $plic}] 400 [expr {400 - $plic}] \
                -width 1 -tag axe_x
        ##### axe des x croit de g a droite (procedure DESSINE)
        $fogc create line 100 [expr {400 - $plic}] 100 [expr {(400 - $plic - $blup)}] \
                -width 1 -tag axe_y
        ##### axe des y decroit de bas en ht
        set corry [expr {($blup/$maximumpc2)}]
        
        for {set i 0} {$i <= 10} {incr i} {
            set x [expr {100 + ($i*30)}]
            $fogc create line $x [expr {400 - $plic}] $x [expr {395 - $plic}] -width 1 -tag axe_x
            ##### subdividions sur l'axe des x
        }
        set hauteurY $blup
        set subdivisionY [expr {$hauteurY / 10}]
        for {set i 0} {$i <= 10} {incr i} {
            set y [expr {400 - $plic - ($i*$subdivisionY)}]
            $fogc create line 100 $y 105 $y -width 1 -tag axe_y
            ##### subdividions sur l'axe des y
        }
        # sinon on fait un plot aux axes proportionels
    } else  {
        
        if {$maximumpc1 > $maximumpc2} {
            set blup [expr {300.0 * $maximumpc2 / $maximumpc1}]
            set xgauche 100
            set plic [expr {(400 - $blup) / 2}]
            $fogc create line 100 [expr {400 - $plic}] 400 [expr {400 - $plic}] \
                    -width 1 -tag axe_x
            ##### axe des x croit de g a droite (procedure enum)
            $fogc create line 100 [expr {400 - $plic}] 100 [expr {(400 - $plic - $blup)}] \
                    -width 1 -tag axe_y
            ##### axe des y decroit de bas en ht
            set corry [expr ($blup/$maximumpc2)]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {100 + ($i*30)}]
                $fogc create line $x [expr {400 - $plic}] $x [expr {395 - $plic}] -width 1 -tag axe_x
                ##### subdividions sur l'axe des x
            }
            set hauteurY $blup
            set subdivisionY [expr {$hauteurY / 10}]
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {400 - $plic - ($i * $subdivisionY)}]
                $fogc create line 100 $y 105 $y -width 1 -tag axe_y
                ##### subdividions sur l'axe des y
            }
        } else {
            set blup [expr {300.0 * $maximumpc1 / $maximumpc2}]
            set plic  50
            set ploc [expr {(450 - $blup) / 2}]
            set xgauche [expr {450 - $ploc - $blup}]
            $fogc create line [expr {450 - $ploc - $blup}] 350 [expr {450 - $ploc}] 350 \
                    -width 2 -tag axe_x
            ##### axe des x croit de g a droite (procedure enum)
            $fogc create line [expr {450 - $ploc - $blup}] 350 [expr {450 - $ploc - $blup}] 50 \
                    -width 2 -tag axe_y
            ##### axe des y croit de ht en bas
            set corrx [expr {($blup / $maximumpc1)}]
            
            set longueurX $blup
            set subdivisionX [expr {$longueurX / 10}]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {(450 - $ploc - $blup) + ($i * $subdivisionX)}]
                $fogc create line $x 350 $x 345 -width 2 -tag axe_x
                ##### subdividions sur l'axe des x
            }
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {350 - ($i * 30)}]
                $fogc create line $xgauche $y [expr {$xgauche + 5}] $y -width 2 -tag axe_y
                ##### subdividions sur l'axe des y
            }
        }
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update
    set textFont {Helvetica 8}
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr {$sumpc1 + [lindex $pc1 $i] } ]
    }
    set moypc1 [expr {$sumpc1 * 1.0 / $npc}]
    set minMpc1 [expr {$minpc1 - $moypc1}]
    set maxMpc1 [expr {$maxpc1 - $moypc1}]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr {$sumpc2 + [lindex $pc2 $i] } ]
    }
    set moypc2 [expr {$sumpc2 * 1.0 / $npc}]
    set minMpc2 [expr {$minpc2 - $moypc1}]
    set maxMpc2 [expr {$maxpc2 - $moypc1}]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    
    set tc "Factor 1 = desde $minF1  a  $maxF1  -  Factor 2 = desde $minF2  a  $maxF2"
    $fogc create text 45 375 -text "$tc ($verjpd)" -font $textFont -anchor w -fill black
    $fogc create text 45 425 -text $references -font "Courrier 9" -anchor w -fill red -tag data_info
    $fogc itemconfigure data_info -width 450
    
    ########################################################################
    # S'il n'y a que deux groupes, et s'il s'agit d'une AD
    # signaler que le facteur 2 est une plaisanterie
    set iciFont "Helvetica 10"
    if {[info exists gr]} {
        if {$gr == 2} {
            if {[info exists pad] && $pad == 1} {
                if  {[info exists lm] == 0} {
                    update
                    set fogc .plottenum.c
                    set lc [$fogc find withtag axe_y]
                    foreach item $lc {$fogc delete $item}
                    $fogc create text 260 10 -text "El segundo factor (vertical) no es valido" \
                            -anchor n -font "Helvetica 18" -fill red
                }
            }
        }
    }
    ########################################################################
    
    
    set long [llength $fogindividuscentPC1]
    set coul 0
    set quidam 0
    #chull
    # Si le bouton CHULL est active
    if {[info exists fogeffectifs]} {
        if {[llength $fogeffectifs] > 1} {
            set legion [lindex $fogeffectifs $coul]
            set canvas_g ""
        }
    }
    
    # Pour le calcul des centroides -- debut
    set sumindpc1 0
    set sumindpc2 0
    #
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        # Si le bouton CHULL est active
        if {[info exists fogeffectifs]} {
            if {[llength $fogeffectifs] > 1} {
                if {$quidam > $legion} {
                    # calcul et affichage du centroide du groupe -- debut
                    #
                    # calcul du centroide du groupe
                    #
                    set total_groupe [lindex $fogeffectifs $coul]
                    set moyindpc1 [expr {$sumindpc1 * 1 / $total_groupe}]
                    set moyindpc2 [expr {$sumindpc2 * 1 / $total_groupe}]
                    # calcul et affichage du centroide du groupe -- fin
                    #
                    set x [ expr { $xgauche + ( $corrx * $moyindpc1 ) } ]
                    set y [ expr { 400 - $plic - ( $corry * $moyindpc2 ) } ]
                    set item [$fogc create rectangle [expr {$x-5}] [expr {$y+5}] [expr {$x+5}] [expr {$y-5}]\
                            -width 3 -outline red -tag centroide]
                    # mise a zero des variables sumindpc1 et sumindpc2
                    #
                    set sumindpc1 0
                    set sumindpc2 0
                    #chull
                    set convexhulls [env::chull $canvas_g]
                    $fogc create line $convexhulls  -fill red -tag allhulls
                    set canvas_g ""
                    incr coul
                    incr legion [lindex $fogeffectifs $coul]
                }
            }
        }
        # BOUTON chull, fin
        
        # Calcul et affichage des points $i
        set indpc1 [ lindex $fogindividuscentPC1 $i ]
        set indpc2 [ lindex $fogindividuscentPC2 $i ]
        # Pour le calcul des centroides -- debut
        set sumindpc1 [expr {$sumindpc1 + $indpc1}]
        set sumindpc2 [expr {$sumindpc2 + $indpc2}]
        # Pour le calcul des centroides -- fin
        
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        #set item [$fogc create oval [expr {$x-1}] [expr {$y-1}] [expr {$x+1}] [expr {$y+1}] \
        #        -width 1 -outline black]
        $fogc create text [expr $x+7] $y -text $quidam -anchor n -font "Helvetica 8"
        #$fogc addtag point withtag $item
        # chull
        append canvas_g "$x $y "
    }
    # Si le bouton CHULL est active
    if {[info exists fogeffectifs]} {
        if {[llength $fogeffectifs] > 1} {
            # calcul et affichage du centroide du DERNIER groupe -- debut
            #
            # calcul du centroide du groupe
            #
            set total_groupe [lindex $fogeffectifs $coul]
            set moyindpc1 [expr {$sumindpc1 * 1 / $total_groupe}]
            set moyindpc2 [expr {$sumindpc2 * 1 / $total_groupe}]
            # calcul et affichage du centroide du groupe -- fin
            #
            set x [ expr { $xgauche + ( $corrx * $moyindpc1 ) } ]
            set y [ expr { 400 - $plic - ( $corry * $moyindpc2 ) } ]
            set item [$fogc create rectangle [expr {$x-5}] [expr {$y+5}] [expr {$x+5}] [expr {$y-5}]\
                    -width 3 -outline red -tag centroide]
            #
            # CALCUL ET DE L'AFFICHAGE DU dernier CENTROIDE  -- fin
        }
    }
    
    #---------- Fin des numeros individuels
    
    if {[info exists fogeffectifs]} {
        if {[llength $fogeffectifs] > 1} {
            set convexhulls [env::chull $canvas_g]
            $fogc create line $convexhulls -fill red -tag allhulls
            set canvas_g ""
        }
    }
}
####################enum######## PROCEDURE ## FIN ###

#################### fogsubextractcol ######## PROCEDURE ## DEBUT ##
proc fogsubextractcol {fogindividus} {
    global S lm lignes fogeffectifs references;# adda_lignes enleve
    #global gr
    #
    destroy .subd
    set fen .subd
    catch {destroy $fen}
    toplevel $fen
    wm geometry $fen 220x90+280+380
    #
    if {[info exists fogeffectifs] == 1} {
        if {[info exists adda_lignes]} {lappend fogeffectifs $adda_lignes}
        wm title $fen "$fogeffectifs"
    } else  {
        wm title $fen "$lignes indiv."
    }
    wm iconname $fen "Subdivisions"
    #
    entry .subd.entree -background white -textvariable fogvaleurs
    #
    button .subd.bouton -background black -foreground white \
            -text "Enter group sizes separated \nby a space,\
            \nthen press me" \
            -font "Helvetica 10" \
            -command {
                global S fogeffectifs infile 
                if {[info exists fogeffectifs]} {set oldeff $fogeffectifs}
                # bug du FOG
                #set S(grupos) [string trim $valeurs];#reserve a viewing
                set S(groupes) [string trim $fogvaleurs];#reserve a NEF
		set S(grupos) $S(groupes);# QUITO jan 2016
                #set group_nb [llength $valeurs]
                #tk_messageBox -message "group_nb $group_nb" -type ok
                # bug du FOG
                if {$fogvaleurs == ""} {
                    if {[string first "_OTL" $infile] > 0} {
                        type "$infile\nUnder FOG, please enter manually the sample sizes"
                        return
                    }
                    #
                    set fogvaleurs [string trim $oldeff]
                    set fogvaleurs [fogtremplincol $fogvaleurs]
                } else  {
                    set fogvaleurs [string trim $fogvaleurs]
                    set fogvaleurs [fogtremplincol $fogvaleurs]
                }
            }
    pack  .subd.entree .subd.bouton
}
####################fogsubextractcol######## PROCEDURE ## FIN ###


####################fogsubextractgro######## PROCEDURE ## DEBUT ###
proc fogsubextractgro {fogindividus} {
    global lm lignes fogeffectifs references;# adda_lignes enleve
    destroy .subd
    toplevel .subd
    set fen .subd
    catch {destroy $fen}
    toplevel $fen
    wm geometry $fen 170x90+330+380
    if {[info exists fogeffectifs] == 1} {
        if {[info exists adda_lignes]} {lappend fogeffectifs $adda_lignes}
        wm title $fen "$fogeffectifs"
    } else  {
        wm title $fen "$lignes indiv."
    }
    wm iconname $fen "Subdivisions"
    
    set appel [entry .subd.entree -background white -textvariable fogvaleurs]
    set commando [button .subd.bouton -background grey25 -foreground white \
            -text "Enter group sizes separated \nby a space, \
            \nthen press me" \
            -font "Helvetica 10" \
            -command {
                global fogeffectifs
                if {[info exists fogeffectifs]} {set oldeff $fogeffectifs} else {set fogeffectifs [string trim $fogvaleurs]}
                # 29 mai 2012 ... 'else set fogeffectifs fogvaleurs...'
                #set S(grupos) $fogeffectifs;#reserve a viewing
                set S(groupes) $fogeffectifs;#reserve a NEF
                if {$fogvaleurs == ""} {
                    set fogvaleurs [string trim $oldeff]
                    set fogvaleurs [fogtremplingro $fogvaleurs]
                } else  {
                    set fogvaleurs [string trim $fogvaleurs];
                    set fogvaleurs [fogtremplingro $fogvaleurs]
                }
            }
    ]
    pack  $appel $commando
}
####################fogsubextractgro######## PROCEDURE ## FIN ###


####################fogtremplincol######## PROCEDURE ## DEBUT ###
proc fogtremplincol {fogvaleurs} {
    global fogindividus references lignes;# adda_lignes enleve
    #global gr
    dalton $fogvaleurs $fogindividus;# dalton = colore
}
####################fogtremplincol######## PROCEDURE ## FIN ###


####################fogtremplingro######## PROCEDURE ## DEBUT ###
proc fogtremplingro {fogvaleurs} {
    global fogindividus references
    genum $fogvaleurs $fogindividus;# genum = numgroup
}
#####################fogtremplingro######## PROCEDURE ## FIN ###



######################## PROCEDURE dalton #### DEBUT###
proc dalton {fogeffectifs points args} {
    
    # L'appel dit ... 'dalton $fogvaleurs $fogindividus' (cfr. fogtremplincol)
    #tk_messageBox -message "Effectifs $fogeffectifs  ... et 'points'\n$points" -type ok
    
    # Cette procedure est appelee par fogtrempincol
    #
    global S;# debug buggisant from fog
    global fogeffectifs_dalton fogindividus_dalton references fogindividus fogver
    global adda lignes;# adda_lignes enleve
    #
    global etiquette doc
    
    
    set fogeffectifs_dalton $fogeffectifs;# ex 'fogvaleurs'
    set fogindividus_dalton $points;# ex 'fogindividus'
    # Cette procedure est appelee par ' fogtremplincol $valeurs $fogindividus '
    # valeurs devient (inutilement) la variable ' fogeffectifs ' puis la variable ' fogeffectifs_dalton '
    # de meme, fogindividus devient (inutilement) la variable points puis la variable ' fogindividus_dalton ' puis ' fogindividus ' ensuite, bref ...
    destroy .subd .plottdalton
    global  p lm gr pad verjpd polygone lignes fogindividus coul
    global suit_rot suit_cons consensus objet_cons susnesnoc
    global fogindividuscentPC1 fogindividuscentPC2 xgauche corrx corry plic c
    #debug
    #puts $fogindividuscentPC1
    # points redevient fogindividus
    set fogindividus $points
    #--------------------------------------------------------------------
    # Assigner AU HASARD des couleurs differentes a chaque groupe
    # -----------------------------------------------------------
    global gilimana jepeins
    set gilimana ""
    if {[info exists jepeins] == 0} {
        set coul 0
        foreach item [split $fogeffectifs] {
            set rcol [expr {int(rand() * 65535)}]
            set gcol [expr {int(rand() * 65535)}]
            set bcol [expr {int(rand() * 65535)}]
            set name($coul) [format "#%.4x%.4x%.4x" $rcol $gcol $bcol]
            lappend gilimana $name($coul)
            incr coul
        }
    } else {
        if {$jepeins == 1} {
            # Assigner des couleurs differentes a chaque groupe
            set coul 0
            foreach item [split $fogeffectifs] {
                set name($coul) [tk_chooseColor]
                incr coul
            }
            unset jepeins
        } else  {
            tk_messageBox "Peindre maintenant?" -type ok
        }
    }
    
    # VALEUR MINIMUM de l'abscisse
    # -----------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    set ordre [lsort -real $ordre]
    set minimumpc1 [lindex $ordre 0]
    ## ajout August 2002
    set minpc1 $minimumpc1
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de l'ordonnee
    # -----------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    set ordre [lsort -real $ordre]
    set minimumpc2 [lindex $ordre 0]
    ## ajout August 2002
    set minpc2 $minimumpc2
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # CENTRAGE DES VALEURS SUR ZERO pour l'abscisse
    # ---------------------------------------------
    set fogindividuscentPC1 ""
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr {[lindex $item 3] - $minimumpc1}]
        lappend fogindividuscentPC1 $somme
    }
    
    # CENTRAGE DES VALEURS SUR ZERO pour l'ordonnee
    # ---------------------------------------------
    set fogindividuscentPC2 ""
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr {[lindex $item 4] - $minimumpc2}]
        lappend fogindividuscentPC2 $somme
    }
    
    # VALEUR MAXIMUM l'abscisse centree
    # -----------------------------------
    set ordre [lsort -real $fogindividuscentPC1]
    set maximumpc1 [lindex $ordre end]
    ## ajout August 2002
    set maxpc1centre $maximumpc1
    set minpc1centre [lindex $ordre 0]
    
    # VALEUR MAXIMUM DE l'ordonnee centree
    # -------------------------------------
    set ordre [lsort -real $fogindividuscentPC2]
    set maximumpc2 [lindex $ordre end]
    ## ajout August 2002
    set maxpc1centre $maximumpc2
    set minpc2centre [lindex $ordre 0]
    
    set corrx [expr {300.0/$maximumpc1}]
    set corry [expr {300.0/$maximumpc2}]
    
    #################################################
    # preparation du graphique de la procedure dalton
    #################################################
    
    set w .plottdalton
    catch {destroy $w}
    toplevel $w
    wm geometry $w 650x580+205+10
    # Adapter le titre de .plottdalton selon l'analyse
    if {[info exists pad]} {
        if {$pad == 1} {
            set iconom "CVA X=CV1, Y=CV2"
        } else  {
            set iconom "PCA X=PC1, Y=PC2"
        }
    } else  {
        set iconom "PCA X=PC1, Y=PC2"
    }
    wm title $w $iconom
    wm iconname $w [lrange $iconom 0 0]
    
    
    #wm title $w "X = factor 1, Y = factor 2"
    
    #wm iconname $w "X = factor 1, Y = factor 2"
    
    set fogc $w.c ; # donc c = .plottdalton.c
    
    set Font {Helvetica 10}
    
    # Une frame pour les boutons
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    
    # Boutons quand la procedure n'est pas appelee par MOG
    button $w.buttons.zoom -text "Z" -command {
        set w .plottdalton
        $w.buttons.gris configure -state disabled
        $w.buttons.colgr configure -state disabled
        $w.buttons.jepeins configure -state disabled
        $w.buttons.color configure -state disabled
        $w.buttons.nude configure -state disabled
        
        set fogc .plottdalton.c
        $fogc scale all 0 0 1.5 1.5
        set lc [$fogc find withtag zou]
        foreach item $lc {
            set x [lindex [$fogc coords $item] 0]
            set y [lindex [$fogc coords $item] 1]
            $fogc create oval $x [expr {$y-10}] [expr {$x+10}] $y \
                    -fill [lindex [$fogc itemconfigure $item -fill ] end] -outline black -tag zou
            $fogc delete $item
        }
        $fogc configure -scrollregion [$fogc bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    }
    
    button $w.buttons.colgr -text "OG" -bg red -fg white \
            -command "global fogindividus;fogsubextractcol {$fogindividus}"
    button $w.buttons.color -text "OC ?" -bg red -fg white\
            -command "global fogindividus;dalton {$fogeffectifs} {$fogindividus}"
    button $w.buttons.colsp -text ". ?" -bg red -fg white\
            -command {
                set lc [.plottdalton.c find withtag ovalitem]
                foreach item $lc {.plottdalton.c delete $item}
            }
    balloonhelp_for $w.buttons.colsp "sin puntos ?\nwithout dots?"
    button $w.buttons.nohu -text "-- ?" -bg red -fg white\
            -command {
                set lc [.plottdalton.c find withtag allhulls]
                foreach item $lc {.plottdalton.c delete $item}
            }
    button $w.buttons.gris -text "TG" -bg red -fg white\
            -command "gris {$fogeffectifs} {$fogindividus}"
    button $w.buttons.jepeins -text "SC" -bg red -fg white\
            -command {
                global jepeins fogeffectifs
                set jepeins 1
                dalton $fogeffectifs_dalton $fogindividus
            }
    button $w.buttons.nude -text "N" -bg red -fg white \
            -command {fognudegroup $fogeffectifs_dalton $fogindividus}
    button $w.buttons.cancel -text " X " -command {
        destroy .plottdalton
        set polygone 0
        #global gr
        #dessine $fogindividus
    }
    button $w.buttons.ps -text "Save (.ps)" -bg white -command {
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottdalton.c postscript]
        close $outputGraphe
    }
    
    
    if {[llength $fogeffectifs] < 8} {
        pack $w.buttons.ps $w.buttons.colgr $w.buttons.color $w.buttons.colsp $w.buttons.nohu\
                $w.buttons.jepeins $w.buttons.gris $w.buttons.nude \
                $w.buttons.zoom $w.buttons.cancel -side left -expand 1
    } else  {
        pack $w.buttons.ps $w.buttons.colgr $w.buttons.color $w.buttons.colsp  $w.buttons.nohu\
                $w.buttons.jepeins $w.buttons.zoom $w.buttons.cancel -side left -expand 1
    }
    
    
    balloonhelp_for $w.buttons.colgr "seleccionar otros grupos ?\nto select other groups?"
    balloonhelp_for $w.buttons.color "otros colores ?\nother colors?"
    
    balloonhelp_for $w.buttons.nohu "sin contornos ?\nwithout hulls?"
    balloonhelp_for $w.buttons.gris "tonos de gris ?\nrange of greys?"
    balloonhelp_for $w.buttons.jepeins "seleccionar los daltons ?\nto select the colors?"
    balloonhelp_for $w.buttons.nude "sin colores ?\nwithout colors?"
    balloonhelp_for $w.buttons.zoom "zoom ?"
    
    # On pose a present la toile sur le trepied
    #
    canvas $fogc -width 450 -height 450 -relief raised -background white -cursor cross\
            -yscrollcommand "$w.v_scroll_tut set" \
            -xscrollcommand "$w.h_scroll_tut set"
    scrollbar $w.v_scroll_tut -command "$fogc yview"
    scrollbar $w.h_scroll_tut -command "$fogc xview" -orient horizontal
    pack $w.v_scroll_tut -side right -fill y
    pack $w.h_scroll_tut -side bottom -fill x
    
    pack $fogc -side top -fill both -expand 1
    
    $fogc configure -scrollregion [$fogc bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    
    
    set plotFont {Helvetica 12}
    
    ########################################################################
    # Si c'est une AD, on reste carre
    if {[info exists pad] && $pad == 1} {
        set blup 300.0
        set xgauche 100
        set plic [expr {(400 - $blup) / 2}]
        $fogc create line 100 [expr {400 - $plic}] 400 [expr {400 - $plic}] -width 1 -tag axe_x
        ##### axe des x croit de g a droite
        $fogc create line 100 [expr {400 - $plic}] 100 [expr {(400 - $plic - $blup)}] -width 1 -tag axe_y
        ##### axe des y decroit de bas en ht
        
        set corry [expr $blup/$maximumpc2]
        for {set i 0} {$i <= 10} {incr i} {
            set x [expr {100 + ($i * 30)}]
            $fogc create line $x [expr {400 - $plic}] $x [expr {395 - $plic}] -width 1 -tag axe_x
        }
        
        set hauteurY $blup
        set subdivisionY [expr {$hauteurY / 10}]
        for {set i 0} {$i <= 10} {incr i} {
            set y [expr {400 - $plic - ($i * $subdivisionY)}]
            $fogc create line 100 $y 105 $y -width 1 -tag axe_y
        }
        # sinon on devient proportionel
    } else  {
        if {$maximumpc1 > $maximumpc2} {
            set blup [expr {300.0 * $maximumpc2 / $maximumpc1}]
            set xgauche 100
            set plic [expr (400 - $blup)/2]
            #if {[info exists lm] == 0} {
            $fogc create line 100 [expr {400 - $plic}] 400 [expr {400 - $plic}] \
                    -width 1 -tag axe_x
            ##### axe des x croit de g a droite (procedure dalton)
            $fogc create line 100 [expr {400 - $plic}] 100 [expr {400 - $plic - $blup}] \
                    -width 1 -tag axe_y
            ##### axe des y decroit de bas en ht
            #}
            set corry [expr {$blup / $maximumpc2}]
            #if {[info exists lm] == 0} {
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {100 + ($i * 30)}]
                $fogc create line $x [expr {400 - $plic}] $x [expr {395 - $plic}] -width 1 -tag axe_x
            }
            #}
            set hauteurY $blup
            set subdivisionY [expr {$hauteurY / 10}]
            #if {[info exists lm] == 0} {
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {400 - $plic - ($i * $subdivisionY)}]
                $fogc create line 100 $y 105 $y -width 1 -tag axe_y
            }
            #}
        } else {
            set blup [expr {300.0 * $maximumpc1 / $maximumpc2}]
            set plic  50
            set ploc [expr {(450 - $blup) / 2}]
            set xgauche [expr {450 - $ploc - $blup}]
            #if {[info exists lm] == 0} {
            $fogc create line [expr {450 - $ploc - $blup}] 350 [expr {450 - $ploc}] 350 \
                    -width 2 -tag axe_x
            ##### axe des x croit de g a droite (procedure dalton)
            $fogc create line [expr {450 - $ploc - $blup}] 350 [expr {450 - $ploc - $blup}] 50\
                    -width 2 -tag axe_y
            ##### axe des y decroit de bas en ht
            #}
            set corrx [expr {$blup / $maximumpc1}]
            
            set longueurX $blup
            set subdivisionX [expr {$longueurX / 10}]
            #if {[info exists lm] == 0} {
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {(450- $ploc - $blup) + ($i * $subdivisionX)}]
                $fogc create line $x 350 $x 345 -width 2 -tag axe_x
            }
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {350 - ($i * 30)}]
                $fogc create line $xgauche $y [expr {$xgauche + 5}] $y -width 2 -tag axe_y
            }
            #}
        }
    }
    
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update
    set textFont {Helvetica 8}
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr {$sumpc1 + [lindex $pc1 $i]}]
    }
    set moypc1 [expr {$sumpc1 * (1.0 / $npc)}]
    set minMpc1 [expr {$minpc1 - $moypc1}]
    set maxMpc1 [expr {$maxpc1 - $moypc1}]
    for  {set i 0} {$i < $npc} {incr i} {
        set sumpc2 [expr {$sumpc2 + [lindex $pc2 $i]}]
    }
    set moypc2 [expr {$sumpc2 * (1.0 / $npc)}]
    set minMpc2 [expr {$minpc2 - $moypc1}]
    set maxMpc2 [expr {$maxpc2 - $moypc1}]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    #
    set tc "$iconom \n\nX (Factor I) = desde $minF1  a  $maxF1\tY (Factor II)= desde $minF2  a  $maxF2"
    #
    $fogc create text 45 375 -text "$tc ($fogver)" -font $textFont -anchor nw -justify left  -fill black
    $fogc create text 45 425 -text "CANVAS $fogc $references" -font "Courrier 7" -anchor nw -justify left  -fill red -tag data_info
    $fogc itemconfigure data_info -anchor nw -justify left -width 450
    
    ############################################################################
    # S'il ny a que deux groupes pour une AD, signaler que le facteur 2 est une plaisanterie
    #if {[info exists lm] == 0} {
    if {[info exists pad] && $pad == 1} {
        if {$gr == 2} {
            update
            set fogc .plottdalton.c
            set lc [$fogc find withtag axe_y]
            foreach item $lc {$fogc delete $item}
            $fogc create text 260 10 -text "El segundo factor (vertical) no es valido" \
                    -anchor n -font "Helvetica 18" -fill red
        }
    }
    #}
    ########################################################################
    
    ########################################################################
    # Indiquer sur le cote et dans l'ordre les differentes couleurs choisies
    
    
    
    set coul [llength $fogeffectifs]
    
    for {set i 0} {$i < $coul} {incr i} {
        set item [$fogc create oval 40 [expr {60 + ($i * 20)}]  50 [expr {70 + ($i * 20)}]  -width 1 -outline black -fill $name($i) -tag hehe]
        $fogc addtag point withtag $item
        $fogc create text 20 [expr {56 + ($i * 20)}] -text [lindex $fogeffectifs $i] -anchor n -font "helvetica 18"
    }
    
    # -------- coloriage des points
    
    # Colorier quoi
    set ovo 3
    set long [ llength $fogindividuscentPC1 ]
    set coul 0
    set quidam 0
    set legion [lindex $fogeffectifs $coul]
    set onpresente [lformat %1.3f $fogindividuscentPC1]
    #chull
    set canvas_g ""
    # centroides --- mise a zero des variables sumindpc1 et sumindpc2
    #
    set sumindpc1 0
    set sumindpc2 0
    # centroides --- fin
    
    #debug
    #tk_messageBox -message "info exists etiquette ==  [info exists etiquette] " -type ok
    
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        if {$quidam > $legion} {
            # calcul et affichage du centroide du groupe -- debut
            #
            # calcul du centroide du groupe
            #
            set total_groupe [lindex $fogeffectifs $coul]
            set moyindpc1 [expr {$sumindpc1 * 1 / $total_groupe}]
            set moyindpc2 [expr {$sumindpc2 * 1 / $total_groupe}]
            #
            set x [ expr { $xgauche + ( $corrx * $moyindpc1 ) } ]
            set y [ expr { 400 - $plic - ( $corry * $moyindpc2 ) } ]
            set item [$fogc create rectangle [expr {$x-5}] [expr {$y+5}] [expr {$x+5}] [expr {$y-5}]\
                    -width 3 -outline $name($coul) -fill $name($coul) -tag all]
            # mise a zero des variables sumindpc1 et sumindpc2
            #
            set sumindpc1 0
            set sumindpc2 0
            # calcul et affichage du centroide du groupe -- fin
            #
            #chull
            set convexhulls [env::chull $canvas_g]
            $fogc create line $convexhulls  -fill $name($coul) -tag allhulls
            set canvas_g ""
            incr coul
            incr legion [lindex $fogeffectifs $coul]
        }
        #debug
        #puts "On en est AU POINT $quidam, a l'effectif $legion, a la couleur $name($coul)"
        #
        # Calcul et affichage des points colories -- debut
        #
        set indpc1 [ lindex $fogindividuscentPC1 $i ]
        set indpc2 [ lindex $fogindividuscentPC2 $i ]
        
        # Pour le calcul des centroides -- debut
        set sumindpc1 [expr {$sumindpc1 + $indpc1}]
        set sumindpc2 [expr {$sumindpc2 + $indpc2}]
        # Pour le calcul des centroides -- fin
        
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        
        
        set item [$fogc create oval [expr {$x-$ovo}] [expr {$y+$ovo}] [expr {$x+$ovo}] [expr {$y-$ovo}]\
                -width 1 -outline black -fill $name($coul) -tag ovalitem]
        $fogc addtag point withtag $item
        append canvas_g "$x $y "
        
    }
    
    # calcul et affichage du centroide du DERNIER groupe -- debut
    #
    # calcul du centroide du groupe
    #
    set total_groupe [lindex $fogeffectifs $coul]
    set moyindpc1 [expr {$sumindpc1 * 1 / $total_groupe}]
    set moyindpc2 [expr {$sumindpc2 * 1 / $total_groupe}]
    # calcul et affichage du centroide du groupe -- fin
    #
    set x [ expr { $xgauche + ( $corrx * $moyindpc1 ) } ]
    set y [ expr { 400 - $plic - ( $corry * $moyindpc2 ) } ]
    set item [$fogc create rectangle [expr {$x-5}] [expr {$y+5}] [expr {$x+5}] [expr {$y-5}]\
            -width 3 -outline $name($coul) -fill $name($coul) -tag all]
    #
    # CALCUL ET DE L'AFFICHAGE DU dernier CENTROIDE  -- fin
    
    #-----------FIN DU COLORIAGE DES POINTS
    set convexhulls [env::chull $canvas_g]
    $fogc create line $convexhulls -fill $name($coul) -tag allhulls
    set canvas_g ""
    
    ###############################
    # Documentation
    if {[info exists pad] && $pad == 1} {
        if {[info exists S(DA)] != 1} {
            # debug peut-etre buggisant from fog
            #tk_messageBox -message "S(DA) ne devrait pas exister ? $S(DA)" -type ok
            bind $fogc <ButtonPress> { discrimine }
            balloonhelp_for .plottdalton.c "Clic sobre la figura -> etapas y comentarios"
        }
    }
}
#
####################dalton######## PROCEDURE ## FIN ####

#################### tudalton ##########
#
proc tudalton {fogeffectifs fogindividus } {
    # debug centroid
    #tk_messageBox -message "PROCEDURE tu dalton" -type ok
    
    update
    
    global lm polygone fogindividuscentPC1 fogindividuscentPC2 xgauche corrx corry plic c name consensus
    global lignes nosi
    
    set lc [$fogc find withtag zou]
    #debug
    #puts "Avant tudalton delete tag: zou =\n$lc"
    foreach item $lc {$fogc delete $item}
    
    #debug
    #puts "debug tudalton fogindividuscentPC1 $fogindividuscentPC1"
    #puts "Apres tudalton delete tag:zou =\n$lc"
    
    # Colorier quoi
    set ovo 3
    set coul 0
    foreach item [split $fogeffectifs] {
        set rcol [expr {int( rand() * 65535)}]
        set gcol [expr {int( rand() * 65535)}]
        set bcol [expr {int( rand() * 65535)}]
        set name($coul) [format "#%.4x%.4x%.4x" $rcol $gcol $bcol]
        incr coul
    }
    
    ########################################################################
    # Indiquer sur le cote et dans l'ordre les differentes couleurs choisies
    set coul [llength $fogeffectifs]
    for {set i 0} {$i < $coul} {incr i} {
        set item [$fogc create oval 40 [expr 60 + ($i * 20)]  50 [expr 70 + ($i * 20)]  \
                -width 1 -outline black -fill $name($i)]
        $fogc addtag point withtag $item
        #if  {[info exists lm] == 1} {
        #   set indic ""
        #   foreach item $fogeffectifs {lappend indic [expr $item/$lm]}
        #   $fogc create text 20 [expr 56 + ($i * 20)] -text [lindex $indic $i] -anchor n \
        #           -font "Helvetica 18"
        #} else  {
        $fogc create text 20 [expr 56 + ($i * 20)] -text [lindex $fogeffectifs $i] -anchor n \
                -font "Helvetica 18"
        #}
    }
    ########################################################################
    
    
    set long [llength $fogindividuscentPC1]
    #puts "\nlong = $long"
    set coul 0
    set quidam 0
    set legion [lindex $fogeffectifs $coul]
    set onpresente [lformat %1.3f $fogindividuscentPC1]
    
    # centroides --- mise a zero des variables sumindpc1 et sumindpc2
    #
    set sumindpc1 0
    set sumindpc2 0
    # centroides --- fin
    #
    #puts "\nlong $long"
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        #puts "Tudaltons \nquidam $quidam\nlegion $legion\nfogeffectifs $fogeffectifs \ncoul $coul"
        if {$quidam > $legion} {
            # calcul et affichage du centroide du groupe -- debut
            #
            # calcul du centroide du groupe
            #
            set total_groupe [lindex $fogeffectifs $coul]
            set moyindpc1 [expr {$sumindpc1 * 1 / $total_groupe}]
            set moyindpc2 [expr {$sumindpc2 * 1 / $total_groupe}]
            #
            set x [ expr { $xgauche + ( $corrx * $moyindpc1 ) } ]
            set y [ expr { 400 - $plic - ( $corry * $moyindpc2 ) } ]
            set item [$fogc create rectangle [expr {$x-5}] [expr {$y+5}] [expr {$x+5}] [expr {$y-5}]\
                    -width 3 -outline $name($coul) -fill $name($coul) -tag all]
            # mise a zero des variables sumindpc1 et sumindpc2
            #
            set sumindpc1 0
            set sumindpc2 0
            # calcul et affichage du centroide du groupe -- fin
            #
            #
            incr coul
            incr legion [lindex $fogeffectifs $coul]
        }
        set indpc1 [ lindex $fogindividuscentPC1 $i ]
        set indpc2 [ lindex $fogindividuscentPC2 $i ]
        # Pour le calcul des centroides -- debut
        set sumindpc1 [expr {$sumindpc1 + $indpc1}]
        set sumindpc2 [expr {$sumindpc2 + $indpc2}]
        # Pour le calcul des centroides -- fin
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        set item [$fogc create oval [expr {$x-$ovo}] [expr {$y-$ovo}] [expr {$x+$ovo}] [expr {$y+$ovo}] \
                -width 1 -outline black -fill $name($coul) -tag zou]
        $fogc addtag point withtag $item
    }
}
######################################### tudalton ##############3####



######################## PROCEDURE grey #### DEBUT###
proc grey {fogeffectifs fogindividus args} {
    
    destroy .subd .plotintin
    global gr pad verjpd references
    global etiquette doc
    
    # Assigner des couleurs differentes a chaque groupe
    # -------------------------------------------------
    #set coul 0
    #foreach item [split $fogeffectifs] {
    #    set name($coul) [tk_chooseColor]
    #    incr coul
    #   }
    # Assigner AU HASARD des couleurs differentes a chaque groupe
    # -----------------------------------------------------------
    
    set grey(0) grey35
    set grey(1) grey50
    set grey(2) grey90
    set grey(3) black
    set grey(5) grey75
    set grey(4) grey25
    set grey(6) grey95
    
    set coul 0
    foreach item [split $fogeffectifs] {
        set name($coul) $grey($coul)
        incr coul
    }
    
    # VALEUR MINIMUM de la 1ere COMPOSANTE PRINCIPALE
    # -----------------------------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc1 [lindex $ordre 0]
    ## ajout August 2002
    set minpc1 $minimumpc1
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de la 2eme COMPOSANTE PRINCIPALE
    # (procedure COLORE)
    # -----------------------------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc2 [lindex $ordre 0]
    ## ajout August 2002
    set minpc2 $minimumpc2
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # CENTRAGE DES VALEURS SUR ZERO pour PC1
    # --------------------------------------
    
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 3] - $minimumpc1]
        lappend fogindividuscentPC1 $somme
    }
    
    # CENTRAGE DES VALEURS SUR ZERO pour PC2
    # (procedure COLORE)
    # --------------------------------------
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 4] - $minimumpc2]
        lappend fogindividuscentPC2 $somme
    }
    
    # VALEUR MAXIMUM DE la 1ere COMPOSANTE PRINCIPALE centree
    # ----------------------------------------------
    set ordre [lsort -real $fogindividuscentPC1]
    set maximumpc1 [lindex $ordre end]
    ## ajout August 2002
    set maxpc1centre $maximumpc1
    set minpc1centre [lindex $ordre 0]
    
    # VALEUR MAXIMUM DE la 2eme COMPOSANTE PRINCIPALE centree
    # ----------------------------------------------
    set ordre [lsort -real $fogindividuscentPC2]
    set maximumpc2 [lindex $ordre end]
    ## ajout August 2002
    set maxpc1centre $maximumpc2
    set minpc2centre [lindex $ordre 0]
    
    set corrx [expr {300.0/$maximumpc1}]
    set corry [expr {300.0/$maximumpc2}]
    
    #################################################
    # preparation du graphique de la procedure COLORE
    #################################################
    
    set w .plotintin
    catch {destroy $w}
    toplevel $w
    wm geometry $w 580x580+205+10
    wm title $w "X = factor 1, Y = factor 2"
    wm iconname $w "X = factor 1, Y = factor 2"
    
    set fogc $w.c
    
    set Font {Helvetica 10}
    
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    
    button $w.buttons.indiv -background red -foreground white -text "INDIVIDUOS ?" \
            -command "enum {$fogindividus}"
    
    button $w.buttons.zoom -text "Z" -bg red -fg white\
            -command {
                set w .plotintin
                $w.buttons.indiv configure -state disabled
                #$w.buttons.colgr configure -state disabled
                #$w.buttons.jepeins configure -state disabled
                #$w.buttons.color configure -state disabled
                #$w.buttons.nude configure -state disabled
                
                set fogc .plotintin.c
                $fogc scale all 0 0 1.5 1.5
                set lc [$fogc find withtag zou]
                foreach item $lc {
                    set x [lindex [$fogc coords $item] 0]
                    set y [lindex [$fogc coords $item] 1]
                    $fogc create oval $x [expr {$y-10}] [expr {$x+10}] $y \
                    -fill [lindex [$fogc itemconfigure $item -fill ] end] -outline black -tag zou
                    $fogc delete $item
                }
                $fogc configure -scrollregion [$fogc bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
            }
    
    button $w.buttons.cancel -text "<-" -command "destroy $w"
    
    #button $w.buttons.aide -text "AYUDA" -background white -foreground blue -command "graphelp"
    
    button $w.buttons.ps -bg white -text "save" -command {
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile \
                -defaultextension .ps]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plotintin.c postscript]
        close $outputGraphe
    }
    pack $w.buttons.ps $w.buttons.indiv $w.buttons.zoom $w.buttons.cancel -side left -expand 1
    
    balloonhelp_for $w.buttons.ps "Guardar ? / Save ?"
    balloonhelp_for $w.buttons.indiv "Individuos / Individuals"
    balloonhelp_for $w.buttons.zoom "Zoom"
    balloonhelp_for $w.buttons.cancel "Back"
    
    canvas $fogc -width 450 -height 450 -relief raised -background "light yellow"; #####-relief raised
    pack $w.c -side top -expand yes -fill both
    
    set plotFont {Helvetica 12}
    
    
    ########################################################################
    # Si c'est une AD, on reste carre
    if {[info exists pad] && $pad == 1} {
        set blup 300.0
        set xgauche 100
        set plic [expr (400 - $blup)/2]
        $fogc create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] -width 1 ;##### axe des x croit de g a droite (procedure DESSINE)
        $fogc create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] -width 1 ;##### axe des y decroit de bas en ht
        set corry [expr ($blup/$maximumpc2)]
        for {set i 0} {$i <= 10} {incr i} {
            set x [expr {100 + ($i*30)}]
            $fogc create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1
        }
        set hauteurY [expr ($blup)]
        set subdivisionY [expr $hauteurY/10]
        for {set i 0} {$i <= 10} {incr i} {
            set y [expr {400 - $plic - ($i*$subdivisionY)}]
            $fogc create line 100 $y 105 $y -width 1
        }
        # sinon on devient proportionel
    } else  {
        if {$maximumpc1 > $maximumpc2} {
            set blup [expr 300.0 * $maximumpc2/$maximumpc1]
            set xgauche 100
            set plic [expr (400 - $blup)/2]
            $fogc create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] -width 1 ;##### axe des x croit de g a droite (procedure DESSINE)
            $fogc create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] -width 1 ;##### axe des y decroit de bas en ht
            set corry [expr ($blup/$maximumpc2)]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {100 + ($i*30)}]
                $fogc create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1
            }
            set hauteurY [expr ($blup)]
            set subdivisionY [expr $hauteurY/10]
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {400 - $plic - ($i*$subdivisionY)}]
                $fogc create line 100 $y 105 $y -width 1
            }
        } else {
            set blup [expr 300.0 * $maximumpc1/$maximumpc2]
            set plic  50
            set ploc [expr (450 - $blup)/2]
            set xgauche [expr 450-$ploc-$blup]
            $fogc create line [expr 450-$ploc-$blup] 350 [expr 450 - $ploc] 350 -width 2 ;##### axe des x croit de g a droite (procedure DESSINE)
            $fogc create line [expr 450-$ploc-$blup] 350 [expr 450-$ploc-$blup] 50 -width 2 ;##### axe des y decroit de bas en ht
            set corrx [expr ($blup/$maximumpc1)]
            
            set longueurX [expr ($blup)]
            set subdivisionX [expr $longueurX/10]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {(450-$ploc-$blup) + ($i*$subdivisionX)}]
                $fogc create line $x 350 $x 345 -width 2
            }
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {350 - ($i*30)}]
                $fogc create line $xgauche $y [expr $xgauche + 5] $y -width 2
            }
        }
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update
    set textFont {Helvetica 8}
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr $sumpc1 + [lindex $pc1 $i]]
    }
    set moypc1 [expr $sumpc1 * 1.0/$npc]
    set minMpc1 [expr $minpc1 - $moypc1]
    set maxMpc1 [expr $maxpc1 - $moypc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr $sumpc2 + [lindex $pc2 $i]]
    }
    set moypc2 [expr $sumpc2 * 1.0/$npc]
    set minMpc2 [expr $minpc2 - $moypc1]
    set maxMpc2 [expr $maxpc2 - $moypc1]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    
    set tc "Factor 1 = desde $minF1  a  $maxF1  -  Factor 2 = desde $minF2  a  $maxF2"
    $fogc create text 45 375 -text "$tc ($verjpd)" -font $textFont -anchor nw -justify left  -fill black
    $fogc create text 45 425 -text $references -font "Courrier 9" -anchor nw -justify left  -fill red -tag data_info
    $fogc itemconfigure data_info -anchor nw -justify left -width 450
    
    ############################################################################
    # S'il ny a que deux groupes, signaler que le facteur 2 est une plaisanterie
    if {[info exists pad] && $pad == 1} {
        update
        if {$gr == 2} {$fogc create text 260 10 \
                    -text "El segundo factor (vertical) no es valido" -anchor n -font $textFont}
    }
    ########################################################################
    
    ########################################################################
    # Indiquer sur le cote et dans l'ordre les differentes couleurs choisies
    
    for {set i 0} {$i < $coul} {incr i} {
        set item [$fogc create oval 40 [expr 60 + ($i * 20)]  50 [expr 70 + ($i * 20)]  \
                -width 1 -outline $name($i) -fill $name($i)]
        $fogc addtag point withtag $item
        $fogc create text 20 [expr 56 + ($i * 20)] -text [lindex $fogeffectifs $i] -anchor n \
                -font $plotFont
    }
    
    ########################################################################
    # Colorier quoi
    
    set ovo 3
    set long [llength $fogindividuscentPC1]
    set coul 0
    set quidam 0
    set legion [lindex $fogeffectifs $coul]
    #chull
    set canvas_g ""
    
    #debug
    #tk_messageBox -message "jpDraw11_3: Procedure grey fogeffectifs     $fogeffectifs     coul  $coul" -type ok
    
    # centroides --- mise a zero des variables sumindpc1 et sumindpc2
    #
    set sumindpc1 0
    set sumindpc2 0
    # centroides --- fin
    
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        if {$quidam > $legion} {
            # calcul et affichage du centroide du groupe -- debut
            #
            # calcul du centroide du groupe
            #
            set total_groupe [lindex $fogeffectifs $coul]
            set moyindpc1 [expr {$sumindpc1 * 1 / $total_groupe}]
            set moyindpc2 [expr {$sumindpc2 * 1 / $total_groupe}]
            #
            set x [ expr { $xgauche + ( $corrx * $moyindpc1 ) } ]
            set y [ expr { 400 - $plic - ( $corry * $moyindpc2 ) } ]
            set item [$fogc create rectangle [expr {$x-5}] [expr {$y+5}] [expr {$x+5}] [expr {$y-5}]\
                    -width 3 -outline $name($coul)  -fill $name($coul) -tag all]
            # mise a zero des variables sumindpc1 et sumindpc2
            #
            set sumindpc1 0
            set sumindpc2 0
            # calcul et affichage du centroide du groupe -- fin
            #
            
            #chull
            set convexhulls [env::chull $canvas_g]
            $fogc create line $convexhulls  -fill $name($coul) -tag allhulls
            set canvas_g ""
            incr coul
            incr legion [lindex $fogeffectifs $coul]
        }
        #puts "\nOn en est a l'individu $quidam, a l'effectif $legion et a la couleur $name($coul)"
        set indpc1 [ lindex $fogindividuscentPC1 $i ]
        set indpc2 [ lindex $fogindividuscentPC2 $i ]
        
        # Pour le calcul des centroides -- debut
        set sumindpc1 [expr {$sumindpc1 + $indpc1}]
        set sumindpc2 [expr {$sumindpc2 + $indpc2}]
        # Pour le calcul des centroides -- fin
        
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        
        # NEW
        #
        if {[info exists etiquette]} {
            #set ovo 2
            #set item [$fogc create oval [expr {$x-$ovo}] [expr {$y+$ovo}] [expr {$x+$ovo}] [expr {$y-$ovo}]\
            -width 1 -outline $name($coul) -fill $name($coul) -tag all]
            #$fogc addtag point withtag $item
            set eti [lindex $doc $i]
            set item [$fogc create text [expr {$x+3}] [expr {$y-3}] -text $eti -fill $name($coul)]
            $fogc addtag point withtag $item
            append canvas_g "$x $y "
        } else  {
            set item [$fogc create oval [expr {$x-$ovo}] [expr {$y+$ovo}] [expr {$x+$ovo}] [expr {$y-$ovo}]\
                    -width 1 -outline black -fill $name($coul) -tag all]
            $fogc addtag point withtag $item
            append canvas_g "$x $y "
        }
        
    }
    
    # calcul et affichage du centroide du DERNIER groupe -- debut
    #
    # calcul du centroide du groupe
    #
    set total_groupe [lindex $fogeffectifs $coul]
    set moyindpc1 [expr {$sumindpc1 * 1 / $total_groupe}]
    set moyindpc2 [expr {$sumindpc2 * 1 / $total_groupe}]
    # calcul et affichage du centroide du groupe -- fin
    #
    set x [ expr { $xgauche + ( $corrx * $moyindpc1 ) } ]
    set y [ expr { 400 - $plic - ( $corry * $moyindpc2 ) } ]
    set item [$fogc create rectangle [expr {$x-5}] [expr {$y+5}] [expr {$x+5}] [expr {$y-5}]\
            -width 1 -outline grey35 -fill $name($coul) -tag all]
    #
    # CALCUL ET DE L'AFFICHAGE DU dernier CENTROIDE  -- fin
    #
    #----------- fin de la greyaille
    set convexhulls [env::chull $canvas_g]
    $fogc create line $convexhulls -fill grey35 -tag allhulls
    set canvas_g ""
}

#################### grey ######## PROCEDURE ## FIN ####


######################## PROCEDURE genum #### DEBUT###
proc genum {fogeffectifs fogindividus args} {
    #
    global fogeffectifs_genum references
    #
    set fogeffectifs_genum $fogeffectifs
    #
    destroy .subd
    #
    global gr pad verjpd
    
    # VALEUR MINIMUM de la 1ere COMPOSANTE PRINCIPALE
    # -----------------------------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc1 [lindex $ordre 0]
    ## ajout August 2002
    set minpc1 $minimumpc1
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de la 2eme COMPOSANTE PRINCIPALE
    # (procedure genum)
    # -----------------------------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc2 [lindex $ordre 0]
    ## ajout August 2002
    set minpc2 $minimumpc2
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # CENTRAGE DES VALEURS SUR ZERO pour PC1
    # --------------------------------------
    
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 3] - $minimumpc1]
        lappend fogindividuscentPC1 $somme
    }
    
    # CENTRAGE DES VALEURS SUR ZERO pour PC2
    # (procedure genum)
    # --------------------------------------
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 4] - $minimumpc2]
        lappend fogindividuscentPC2 $somme
    }
    
    # VALEUR MAXIMUM DE la 1ere COMPOSANTE PRINCIPALE
    # ----------------------------------------------
    set ordre [lsort -real $fogindividuscentPC1]
    set maximumpc1 [lindex $ordre end]
    
    
    # VALEUR MAXIMUM DE la 2eme COMPOSANTE PRINCIPALE
    # ----------------------------------------------
    set ordre [lsort -real $fogindividuscentPC2]
    set maximumpc2 [lindex $ordre end]
    
    set corrx [expr {300.0/$maximumpc1}]
    set corry [expr {300.0/$maximumpc2}]
    
    ###################################################
    # preparation du graphique de la procedure genum
    ###################################################
    
    set w .plottgenum
    catch {destroy $w}
    toplevel $w
    wm geometry $w 580x580+205+10
    wm title $w "X = factor 1, Y = factor 2"
    wm iconname $w "factor 1 en X, factor 2 en Y"
    
    set fogc $w.c
    
    set Font {Helvetica 6}
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    
    button $w.buttons.group -text "OG ?" -bg red -fg white \
            -command "fogsubextractgro {$fogindividus}"
    
    button $w.buttons.nude -text "Nude" -bg red -fg white \
            -command {
                set dc [.plottgenum.c find withtag genum]
                foreach item $dc {
                    .plottgenum.c delete $item
                }
            }
    button $w.buttons.nudeold -text "Nude" -bg red -fg white \
            -command {fognudegroup $fogeffectifs_genum $fogindividus}
    
    button $w.buttons.nc -background red -foreground white -text "# ?" \
            -command {
                global w
                set dc [.plottgenum.c find withtag centroide]
                foreach item $dc {
                    .plottgenum.c delete $item
                }
            }
    balloonhelp_for $w.buttons.nc "No centroid(s)"
    
    button $w.buttons.esqu -background red -foreground white -text "--?" \
            -command {
                global polygone references
                set polygone 0
                set dc [.plottgenum.c find withtag allhulls]
                foreach item $dc {
                    .plottgenum.c delete $item
                }
                #
            }
    balloonhelp_for $w.buttons.esqu "No polygons"
    button $w.buttons.zoom -text "Z" \
            -command {
                .plottgenum.c scale all 0 0 1.5 1.5
                .plottgenum.c configure -scrollregion [.plottgenum.c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
                #
            }
    button $w.buttons.cancel -text "<-" -command "destroy $w"
    button $w.buttons.ps -text "Save (post-script)" -bg white -command {
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile\
                -defaultextension .ps]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottgenum.c postscript]
        close $outputGraphe
    }
    pack $w.buttons.ps $w.buttons.group  $w.buttons.nude $w.buttons.esqu $w.buttons.nc $w.buttons.zoom $w.buttons.cancel -side left -expand 1
    
    balloonhelp_for $w.buttons.group "Seleccionar otros grupos ? \nOther groups ?"
    balloonhelp_for $w.buttons.nude "Sin numeros ? \nWithout numbers ?"
    balloonhelp_for $w.buttons.ps "Guardar ? \nSave graph ?"
    balloonhelp_for $w.buttons.cancel "Back"
    balloonhelp_for $w.buttons.zoom "Zoom ?"
    
    
    canvas $fogc -width 450 -height 450 -relief raised -background white
    pack $w.c -side top -expand yes -fill both
    
    set plotFont {Helvetica 8}
    ########################################################################
    # SSi c'est una AD, le plot est carre
    if {[info exists pad] && $pad == 1} {
        set blup 300.0
        set xgauche 100
        set plic [expr (400 - $blup)/2]
        $fogc create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] -width 1 -tag axe_x
        ##### axe des x croit de g a droite (procedure DESSINE)
        $fogc create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] -width 1 -tag axe_y
        ##### axe des y decroit de bas en ht
        set corry [expr ($blup/$maximumpc2)]
        
        for {set i 0} {$i <= 10} {incr i} {
            set x [expr {100 + ($i*30)}]
            $fogc create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1 -tag axe_x
            ##### subdividions sur l'axe des x
        }
        set hauteurY [expr ($blup)]
        set subdivisionY [expr $hauteurY/10]
        for {set i 0} {$i <= 10} {incr i} {
            set y [expr {400 - $plic - ($i*$subdivisionY)}]
            $fogc create line 100 $y 105 $y -width 1 -tag axe_y
            ##### subdividions sur l'axe des y
        }
        # sinon on fait un plot aux axes proportionels
    } else  {
        
        if {$maximumpc1 > $maximumpc2} {
            set blup [expr 300.0 * $maximumpc2/$maximumpc1]
            set xgauche 100
            set plic [expr (400 - $blup)/2]
            $fogc create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] \
                    -width 1 -tag axe_x
            ##### axe des x croit de g a droite (procedure DESSINE)
            $fogc create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] \
                    -width 1 -tag axe_y
            ##### axe des y decroit de bas en ht
            set corry [expr ($blup/$maximumpc2)]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {100 + ($i*30)}]
                $fogc create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1 -tag axe_x
                ##### subdividions sur l'axe des x
            }
            set hauteurY [expr ($blup)]
            set subdivisionY [expr $hauteurY/10]
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {400 - $plic - ($i*$subdivisionY)}]
                $fogc create line 100 $y 105 $y -width 1 -tag axe_y
                ##### subdividions sur l'axe des y
            }
        } else {
            set blup [expr 300.0 * $maximumpc1/$maximumpc2]
            set plic  50
            set ploc [expr (450 - $blup)/2]
            set xgauche [expr 450-$ploc-$blup]
            $fogc create line [expr 450-$ploc-$blup] 350 [expr 450 - $ploc] 350 \
                    -width 2 -tag axe_x
            ##### axe des x croit de g a droite (procedure genum)
            $fogc create line [expr 450-$ploc-$blup] 350 [expr 450-$ploc-$blup] 50 \
                    -width 2 -tag axe_y
            ##### axe des y decroit de bas en ht
            set corrx [expr ($blup/$maximumpc1)]
            
            set longueurX [expr ($blup)]
            set subdivisionX [expr $longueurX/10]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {(450-$ploc-$blup) + ($i*$subdivisionX)}]
                $fogc create line $x 350 $x 345 -width 2  -tag axe_x
                ##### subdividions sur l'axe des x
            }
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {350 - ($i*30)}]
                $fogc create line $xgauche $y [expr $xgauche + 5] $y -width 2 -tag axe_y
                ##### subdividions sur l'axe des y
            }
        }
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update
    set textFont {Helvetica 8}
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr $sumpc1 + [lindex $pc1 $i]]
    }
    set moypc1 [expr $sumpc1 * 1.0/$npc]
    set minMpc1 [expr $minpc1 - $moypc1]
    set maxMpc1 [expr $maxpc1 - $moypc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr $sumpc2 + [lindex $pc2 $i]]
    }
    set moypc2 [expr $sumpc2 * 1.0/$npc]
    set minMpc2 [expr $minpc2 - $moypc1]
    set maxMpc2 [expr $maxpc2 - $moypc1]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    
    set tc "Factor 1 = desde $minF1  a  $maxF1  -  Factor 2 = desde $minF2  a  $maxF2"
    $fogc create text 45 375 -text "CANVAS $fogc $tc ($verjpd)" -font $textFont -anchor w -fill black
    $fogc create text 45 425 -text $references -font "Courrier 9" -anchor w -fill red -tag data_info
    $fogc itemconfigure data_info -width 450
    
    ########################################################################
    # S'il ny a que deux groupes, signaler que le facteur 2 est une plaisanterie
    set iciFont "Helvetica 8"
    if {[info exists pad] && $pad == 1} {
        if {$gr == 2} {
            update
            set fogc .plottgenum.c
            set lc [$fogc find withtag axe_y]
            foreach item $lc {$fogc delete $item}
            $fogc create text 260 10 -text "El segundo factor (vertical) no es valido" \
                    -anchor n -font "Helvetica 18" -fill red
        }
    }
    ########################################################################
    
    set long [llength $fogindividuscentPC1]
    set coul 0
    set quidam 0
    set legion [lindex $fogeffectifs $coul]
    #chull
    set canvas_g ""
    
    # CENTROIDES --- mise a zero des variables sumindpc1 et sumindpc2
    #
    set sumindpc1 0
    set sumindpc2 0
    # centroides --- fin
    
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        if {$quidam > $legion} {
            # calcul et affichage du centroide du groupe -- debut
            #
            # calcul du centroide du groupe
            #
            set total_groupe [lindex $fogeffectifs $coul]
            set moyindpc1 [expr {$sumindpc1 * 1 / $total_groupe}]
            set moyindpc2 [expr {$sumindpc2 * 1 / $total_groupe}]
            #
            set x [ expr { $xgauche + ( $corrx * $moyindpc1 ) } ]
            set y [ expr { 400 - $plic - ( $corry * $moyindpc2 ) } ]
            set item [$fogc create rectangle [expr {$x-5}] [expr {$y+5}] [expr {$x+5}] [expr {$y-5}]\
                    -width 3 -outline black -fill white -tag centroide]
            # mise a zero des variables sumindpc1 et sumindpc2
            #
            set sumindpc1 0
            set sumindpc2 0
            # calcul et affichage du centroide du groupe -- fin
            #
            #chull
            set convexhulls [env::chull $canvas_g]
            $fogc create line $convexhulls  -fill black -tag allhulls
            set canvas_g ""
            incr coul
            incr legion [lindex $fogeffectifs $coul]
        }
        #puts "\nOn en est a l'individu $quidam, a l'effectif $legion et a la couleur $name($coul)"
        set indpc1 [ lindex $fogindividuscentPC1 $i ]
        set indpc2 [ lindex $fogindividuscentPC2 $i ]
        # Pour le calcul des centroides -- debut
        set sumindpc1 [expr {$sumindpc1 + $indpc1}]
        set sumindpc2 [expr {$sumindpc2 + $indpc2}]
        # Pour le calcul des centroides -- fin
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        set item [$fogc create oval [expr {$x-1}] [expr {$y-1}] [expr {$x+1}] [expr {$y+1}] -width 1 -outline black]
        $fogc create text [expr $x+7] $y -text [expr $coul + 1] -anchor n -font "Helvetica 10" -tag genum
        $fogc addtag point withtag $item
        # chull
        append canvas_g "$x $y "
    }
    # CALCUL ET AFFICHAGE DU dernier CENTROIDE -- debut
    #
    # calcul du centroide du groupe
    #
    set total_groupe [lindex $fogeffectifs $coul]
    set moyindpc1 [expr {$sumindpc1 * 1 / $total_groupe}]
    set moyindpc2 [expr {$sumindpc2 * 1 / $total_groupe}]
    # calcul et affichage du centroide du groupe -- fin
    #
    set x [ expr { $xgauche + ( $corrx * $moyindpc1 ) } ]
    set y [ expr { 400 - $plic - ( $corry * $moyindpc2 ) } ]
    set item [$fogc create rectangle [expr {$x-5}] [expr {$y+5}] [expr {$x+5}] [expr {$y-5}]\
            -width 3 -outline black -fill white -tag centroide]
    #
    # CALCUL ET AFFICHAGE DU dernier CENTROIDE  -- fin
    
    
    # Fin de la numeration
    set convexhulls [env::chull $canvas_g]
    $fogc create line $convexhulls -fill black -tag allhulls
    set canvas_g ""
}

################### genum ##### PROCEDURE ## FIN ###


################### PROCEDURE fognudegroup #### DEBUT###
proc fognudegroup {fogeffectifs fogindividus args} {
    global fogeffectifs_genum references
    set fogeffectifs_genum $fogeffectifs
    destroy .subd
    global gr pad verjpd
    
    # VALEUR MINIMUM de la 1ere COMPOSANTE PRINCIPALE
    # -----------------------------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc1 [lindex $ordre 0]
    ## ajout August 2002
    set minpc1 $minimumpc1
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de la 2eme COMPOSANTE PRINCIPALE
    # (procedure genum)
    # -----------------------------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc2 [lindex $ordre 0]
    ## ajout August 2002
    set minpc2 $minimumpc2
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # CENTRAGE DES VALEURS SUR ZERO pour PC1
    # --------------------------------------
    
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 3] - $minimumpc1]
        lappend fogindividuscentPC1 $somme
    }
    
    
    
    
    # CENTRAGE DES VALEURS SUR ZERO pour PC2
    # (procedure COLORE)
    # --------------------------------------
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 4] - $minimumpc2]
        lappend fogindividuscentPC2 $somme
    }
    
    # VALEUR MAXIMUM DE la 1ere COMPOSANTE PRINCIPALE
    # ----------------------------------------------
    set ordre [lsort -real $fogindividuscentPC1]
    set maximumpc1 [lindex $ordre end]
    
    
    
    # VALEUR MAXIMUM DE la 2eme COMPOSANTE PRINCIPALE
    # ----------------------------------------------
    set ordre [lsort -real $fogindividuscentPC2]
    set maximumpc2 [lindex $ordre end]
    
    set corrx [expr {300.0/$maximumpc1}]
    set corry [expr {300.0/$maximumpc2}]
    
    ###################################################
    # preparation du graphique de la procedure NUMGROUP
    ###################################################
    
    set w .plottgenum
    catch {destroy $w}
    toplevel $w
    wm geometry $w 580x580+205+10
    wm title $w "X = factor 1, Y = factor 2"
    wm iconname $w "factor 1 en X, factor 2 en Y"
    
    set fogc $w.c
    
    set Font {Helvetica 6}
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    button $w.buttons.group -text "OG ?" -bg red -fg white \
            -command "fogsubextractgro {$fogindividus}"
    button $w.buttons.nude -text "Nude" -bg red -fg white -state disabled \
            -command {fognudegroup $fogeffectifs $fogindividus}
    button $w.buttons.zoom -text "Z" \
            -command {
                .plottgenum.c scale all 0 0 1.5 1.5
                .plottgenum.c configure -scrollregion [.plottgenum.c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
                #zoomgenum $fogeffectifs_genum $fogindividus
            }
    button $w.buttons.cancel -text "<-" -command "destroy $w"
    button $w.buttons.ps -text "Save (post-script)" -bg white -command {
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile\
                -defaultextension .ps]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottgenum.c postscript]
        close $outputGraphe
    }
    pack $w.buttons.ps $w.buttons.group  $w.buttons.nude $w.buttons.zoom $w.buttons.cancel -side left -expand 1
    
    balloonhelp_for $w.buttons.group "Seleccionar otros grupos ? \nOther groups ?"
    balloonhelp_for $w.buttons.nude "Sin numeros ? \nWithout numbers ?"
    balloonhelp_for $w.buttons.ps "Guardar?\nSave graph?"
    balloonhelp_for $w.buttons.cancel "Back"
    balloonhelp_for $w.buttons.zoom "Zoom ?"
    
    
    canvas $fogc -width 450 -height 450 -relief raised -background white
    pack $w.c -side top -expand yes -fill both
    
    set plotFont {Helvetica 8}
    ########################################################################
    # SSi c'est una AD, le plot est carre
    if {[info exists pad] && $pad == 1} {
        set blup 300.0
        set xgauche 100
        set plic [expr (400 - $blup)/2]
        $fogc create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] -width 1 -tag axe_x
        ##### axe des x croit de g a droite (procedure DESSINE)
        $fogc create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] -width 1 -tag axe_y
        ##### axe des y decroit de bas en ht
        set corry [expr ($blup/$maximumpc2)]
        
        for {set i 0} {$i <= 10} {incr i} {
            set x [expr {100 + ($i*30)}]
            $fogc create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1 -tag axe_x
            ##### subdividions sur l'axe des x
        }
        set hauteurY [expr ($blup)]
        set subdivisionY [expr $hauteurY/10]
        for {set i 0} {$i <= 10} {incr i} {
            set y [expr {400 - $plic - ($i*$subdivisionY)}]
            $fogc create line 100 $y 105 $y -width 1 -tag axe_y
            ##### subdividions sur l'axe des y
        }
        # sinon on fait un plot aux axes proportionels
    } else  {
        
        if {$maximumpc1 > $maximumpc2} {
            set blup [expr 300.0 * $maximumpc2/$maximumpc1]
            set xgauche 100
            set plic [expr (400 - $blup)/2]
            $fogc create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] \
                    -width 1 -tag axe_x
            ##### axe des x croit de g a droite (procedure DESSINE)
            $fogc create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] \
                    -width 1 -tag axe_y
            ##### axe des y decroit de bas en ht
            set corry [expr ($blup/$maximumpc2)]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {100 + ($i*30)}]
                $fogc create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1 -tag axe_x
                ##### subdividions sur l'axe des x
            }
            set hauteurY [expr ($blup)]
            set subdivisionY [expr $hauteurY/10]
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {400 - $plic - ($i*$subdivisionY)}]
                $fogc create line 100 $y 105 $y -width 1 -tag axe_y
                ##### subdividions sur l'axe des y
            }
        } else {
            set blup [expr 300.0 * $maximumpc1/$maximumpc2]
            set plic  50
            set ploc [expr (450 - $blup)/2]
            set xgauche [expr 450-$ploc-$blup]
            $fogc create line [expr 450-$ploc-$blup] 350 [expr 450 - $ploc] 350 \
                    -width 2 -tag axe_x
            ##### axe des x croit de g a droite (procedure genum)
            $fogc create line [expr 450-$ploc-$blup] 350 [expr 450-$ploc-$blup] 50 \
                    -width 2 -tag axe_y
            ##### axe des y decroit de bas en ht
            set corrx [expr ($blup/$maximumpc1)]
            
            set longueurX [expr ($blup)]
            set subdivisionX [expr $longueurX/10]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {(450-$ploc-$blup) + ($i*$subdivisionX)}]
                $fogc create line $x 350 $x 345 -width 2  -tag axe_x
                ##### subdividions sur l'axe des x
            }
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {350 - ($i*30)}]
                $fogc create line $xgauche $y [expr $xgauche + 5] $y -width 2 -tag axe_y
                ##### subdividions sur l'axe des y
            }
        }
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update
    set textFont {Helvetica 8}
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr $sumpc1 + [lindex $pc1 $i]]
    }
    set moypc1 [expr $sumpc1 * 1.0/$npc]
    set minMpc1 [expr $minpc1 - $moypc1]
    set maxMpc1 [expr $maxpc1 - $moypc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr $sumpc2 + [lindex $pc2 $i]]
    }
    set moypc2 [expr $sumpc2 * 1.0/$npc]
    set minMpc2 [expr $minpc2 - $moypc1]
    set maxMpc2 [expr $maxpc2 - $moypc1]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    
    set tc "Factor 1 = desde $minF1  a  $maxF1  -  Factor 2 = desde $minF2  a  $maxF2"
    $fogc create text 45 375 -text "$tc ($verjpd)" -font $textFont -anchor w -fill black
    $fogc create text 45 425 -text $references -font "Courrier 9" -anchor w -fill red -tag data_info
    $fogc itemconfigure data_info -width 450
    
    ########################################################################
    # S'il ny a que deux groupes, signaler que le facteur 2 est une plaisanterie
    set iciFont "Helvetica 8"
    if {[info exists pad] && $pad == 1} {
        if {$gr == 2} {
            update
            set fogc .plottgenum.c
            set lc [$fogc find withtag axe_y]
            foreach item $lc {$fogc delete $item}
            $fogc create text 260 10 -text "El segundo factor (vertical) no es valido" \
                    -anchor n -font "Helvetica 18" -fill red
        }
    }
    ########################################################################
    
    set long [llength $fogindividuscentPC1]
    set coul 0
    set quidam 0
    set legion [lindex $fogeffectifs $coul]
    #chull
    set canvas_g ""
    
    # centroides --- mise a zero des variables sumindpc1 et sumindpc2
    #
    set sumindpc1 0
    set sumindpc2 0
    # centroides --- fin
    
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        if {$quidam > $legion} {
            # calcul et affichage du centroide du groupe -- debut
            #
            # calcul du centroide du groupe
            #
            set total_groupe [lindex $fogeffectifs $coul]
            set moyindpc1 [expr {$sumindpc1 * 1 / $total_groupe}]
            set moyindpc2 [expr {$sumindpc2 * 1 / $total_groupe}]
            #
            set x [ expr { $xgauche + ( $corrx * $moyindpc1 ) } ]
            set y [ expr { 400 - $plic - ( $corry * $moyindpc2 ) } ]
            set item [$fogc create rectangle [expr {$x-5}] [expr {$y+5}] [expr {$x+5}] [expr {$y-5}]\
                    -width 3 -outline black -fill white -tag all]
            #$fogc create text [expr $x+9] $y -text [expr $coul + 1] -anchor n -font "Helvetica 10"
            $fogc addtag point withtag $item
            # mise a zero des variables sumindpc1 et sumindpc2
            #
            set sumindpc1 0
            set sumindpc2 0
            # calcul et affichage du centroide du groupe -- fin
            #
            #chull
            set convexhulls [env::chull $canvas_g]
            $fogc create line $convexhulls  -fill black -tag allhulls
            set canvas_g ""
            incr coul
            incr legion [lindex $fogeffectifs $coul]
        }
        #puts "\nOn en est a l'individu $quidam, a l'effectif $legion et a la couleur $name($coul)"
        set indpc1 [ lindex $fogindividuscentPC1 $i ]
        set indpc2 [ lindex $fogindividuscentPC2 $i ]
        # Pour le calcul des centroides -- debut
        set sumindpc1 [expr {$sumindpc1 + $indpc1}]
        set sumindpc2 [expr {$sumindpc2 + $indpc2}]
        ## Pour le calcul des centroides -- fin
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        set item [$fogc create oval [expr {$x-1}] [expr {$y-1}] [expr {$x+1}] [expr {$y+1}] -width 1 -outline black]
        #$fogc create text [expr $x+7] $y -text [expr $coul + 1] -anchor n -font "Helvetica 10"
        $fogc addtag point withtag $item
        # chull
        append canvas_g "$x $y "
    }
    
    
    # calcul et affichage du centroide du DERNIER groupe -- debut
    #
    # calcul du centroide du groupe
    #
    set total_groupe [lindex $fogeffectifs $coul]
    set moyindpc1 [expr {$sumindpc1 * 1 / $total_groupe}]
    set moyindpc2 [expr {$sumindpc2 * 1 / $total_groupe}]
    # calcul et affichage du centroide du groupe -- fin
    #
    set x [ expr { $xgauche + ( $corrx * $moyindpc1 ) } ]
    set y [ expr { 400 - $plic - ( $corry * $moyindpc2 ) } ]
    set item [$fogc create rectangle [expr {$x-5}] [expr {$y+5}] [expr {$x+5}] [expr {$y-5}]\
            -width 3 -outline black -fill white -tag all]
    #$fogc create text [expr $x+9] $y -text [expr $coul + 1] -anchor n -font "Helvetica 10"
    $fogc addtag point withtag $item
    #
    # CALCUL ET AFFICHAGE DU dernier CENTROIDE  -- fin
    
    # Fin de la numeration
    set convexhulls [env::chull $canvas_g]
    $fogc create line $convexhulls -fill black -tag allhulls
    set canvas_g ""
}

#################### fognudegroup ######## PROCEDURE ## FIN ###



# PROCEDURE griffonne - Debut
#
proc griffonne {fogindividus} {
    
    # 
    global S infile references base_fogeffectifs rowcount
    
    set fogeffectifs $rowcount
    
    #Histogramme
    global valclass
    
    global fogenvind
    set fogenvind $fogindividus
    
    global gr pad verjpd lignes polygone;# adda_lignes enleve
    global etiquette;# il se peut qu'on ait demande a etiqueter chaque individu (ET)
    global doc;#dans ce cas 'doc' contient les etiquettes
    
    #debug
    #tk_messageBox -message "(debut dessine) gr = $gr" -type ok
    
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    
    update idletasks
    flush stdout
    
    if {[info exists gr] == 1} {global gr}
    global lm
    
    destroy .muestreo.entree
    destroy .muestreo.boutonBac
    destroy .progres
    destroy .subd
    
    set subdipop $fogindividus
    
    # VALEUR MINIMUM de l'abscisse
    # -----------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minpc1 [lindex $ordre 0]
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de l'ordonnee
    # -----------------------------
    set ordre {}
    foreach item $fogindividus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minpc2 [lindex $ordre 0]
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # CENTRAGE DES VALEURS SUR ZERO pour l'abscisse
    # ---------------------------------------------
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 3] - $minpc1]
        lappend fogindividuscentPC1 $somme
    }
    #debug
    #puts "debug dessine fogindividuscentPC1 $fogindividuscentPC1"
    
    # CENTRAGE DES VALEURS SUR ZERO pour l'ordonnee
    # ---------------------------------------------
    
    foreach item $fogindividus {
        set somme {}
        lappend somme [expr [lindex $item 4] - $minpc2]
        lappend fogindividuscentPC2 $somme
    }
    
    #debug chull
    #puts "fogindividus PC1 = \n$fogindividuscentPC1\nfogindividus PC2 = \n$fogindividuscentPC2"
    
    #VALEUR MAXIMUM de l'abscisse centree
    # ------------------------------------
    set ordre [lsort -real $fogindividuscentPC1]
    set maxpcc1 [lindex $ordre end]
    set minpcc1 [lindex $ordre 0]
    
    #VALEUR MAXIMUM de l'ordonnee centree
    # ------------------------------------
    set ordre [lsort -real $fogindividuscentPC2]
    set maxpcc2 [lindex $ordre end]
    set minpcc2 [lindex $ordre 0]
    
    set corrx [expr {300.0/$maxpcc1}]
    set corry [expr {300.0/$maxpcc2}]
    
    
    # -------------------------------------------------
    # preparation du graphique de la procedure griffonne
    # -------------------------------------------------
    set w .plottgriffonne
    catch {destroy $w}
    toplevel $w
    wm geometry $w 580x580+205+10
    wm title $w "X = factor 1, Y = factor 2"
    wm iconname $w "factor 1 en X, factor 2 en Y"
    
    set Font {Helvetica 10}
    
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    button $w.buttons.color -background red -foreground white -text "Colores" \
            -command {
                global polygone references base_fogeffectifs;# adda_lignes enleve
                if {[info exists adda_lignes]} {
                    set fogeffectifs $base_fogeffectifs
                    set fogeffectifs [regsub -all {\{|\}} $fogeffectifs ""]
                }
                set polygone 0
                fogsubextractcol $fogindividus
            }
    button $w.buttons.group -background red -foreground white -text "Numeros" \
            -command {
                global polygone references base_fogeffectifs
                set polygone 0
                if {[info exists adda_lignes]} {
                    set fogeffectifs $base_fogeffectifs
                    set fogeffectifs [regsub -all {\{|\}} $fogeffectifs ""]
                }
                fogsubextractgro $fogindividus
            }
    # chull
    button $w.buttons.chull -background red -foreground white -text "C. Hulls" \
            -command {
                global base_fogeffectifs fogeffectifs fogenvind
                #set fogeffectifs $base_fogeffectifs
                # Effectifs ou pas
                destroy .subd
                set fen .subd
                catch {destroy $fen}
                toplevel $fen
                wm geometry $fen 220x90+280+380
                if {[info exists fogeffectifs]} {wm iconname $fen "$fogeffectifs"}
                set llamada [entry .subd.entree -background white -textvariable subd_fogeffectifs]
                set orden [button .subd.bouton -background grey25 -foreground white \
                -text "Enter group sizes separated \nby a space, \nthen press me" \
                -font "Helvetica 12" \
                -command {
                    global fogeffectifs fogenvind
                    set fogeffectifs $subd_fogeffectifs
                    set fogeffectifs [regsub -all {\{|\}} $fogeffectifs ""]
                    dessine $fogenvind}]
                pack $llamada $orden
            }
    button $w.buttons.indiv -background red -foreground white -text "Individuos" \
            -command {
                global polygone references
                set polygone 0
                enum $fogindividus
            }
    
    if {[info exists etiquette] != 0} {
        # On peut zoomer si on a ecrit les etiquettes
        button $w.buttons.zoomet -text "Z" -command {
            global fogindividus etiquette doc
            .plottgriffonne.c scale all 0 0 1.5 1.5
            .plottgriffonne.c itemconfigure zou -fill red
            .plottgriffonne.c configure -scrollregion [.plottgriffonne.c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
            
            #zoomet $fogindividus
        }
    } else  {
        #tk_messageBox -message "else ... [info exists etiquette] "
    }
    
    
    
    
    button $w.buttons.doc -background red -foreground white -text "ET" -command {
        global infile polygone fogindividus etiquette doc references
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        # ne sais quoi faire de ce polygone en ce moment
        set polygone 0
        # seulette suis, seulette veux etre, seulette m'a mon doux ami laissee
        #
        ## ouvrir le fichier des etiquettes, et creer la liste doc
        #
        # On va chercher les etiquettes
        set typeList {
            {{"Text files"} {.txt .TXT} }
        }
        set docinfile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
        #docinfile contient le chemin et le nom du fichier des donnees
        #
        #set fin "etiquettes.txt"
        #set docinfile $dirinfile$fin
        
        # On verifie l'existence d'un fichier
        catch [set ano [glob -nocomplain $docinfile]] ici
        if {[string first $docinfile $ano] > -1} {
            set oui 1
        } else {
            set oui 0
        }
        if {$oui == 1} {
            # Si le fichier existe,
            set doc [etiquetage $docinfile]
            # recommencer le dessin avec le drapeau etiquette hisse
            set etiquette 1
            # etiquette = 1, donc info exists etc. = [info exists etiquette]
            dessine $fogindividus
        }
        if {$oui == 0} {
            tk_messageBox -message "$docinfile\nnot created" -type ok
        }
        
    }
    
    update
    balloonhelp_for $w.buttons.doc "Etiquetas...\nThis option requires a one column file containing labels \
            \n(except first row which is a comment), in\
            $dirinfile"
    
    ################################################################################
    #     set flecheht [file join $S(dirscript) "+/fleche_haut.xbm"]
    #     set flechebs [file join $S(dirscript) "+/fleche_bas.xbm"]
    ################################################################################
    set flecheht [file join $S(dirclic) "+/fleche_haut.xbm"]
    set flechebs [file join $S(dirclic) "+/fleche_bas.xbm"]
    image create bitmap fleche_haut -file $flecheht
    image create bitmap fleche_bas -file $flechebs
    #image create bitmap fleche_haut -file +/fleche_haut.xbm
    #image create bitmap fleche_bas -file +/fleche_bas.xbm
    
    button $w.buttons.class_haut -image  fleche_haut -command {
        global valclass
        set valclass [expr {$valclass + 2}]
        if {$valclass > 50} {
            tk_messageBox -message "50 instead of $valclass classes have been accepted" -icon warning -type ok
            set valclass 50
        }
        dessine $fogindividus
    }
    
    button $w.buttons.class_bas -image  fleche_bas -command {
        global valclass
        set valclass [expr {$valclass - 2}]
        if {$valclass < 6} {
            tk_messageBox -message "1 instead of $valclass classes have been accepted" -icon warning -type ok
            set valclass 6
        }
        dessine $fogindividus
    }
    
    button $w.buttons.cancel -foreground black -text "X " -command {
        if {[info exists etiquette] != 0} {unset etiquette}
        destroy .plottgriffonne
    }
    
    button $w.buttons.ps -text "save (.ps)" -command {
        # #debug
        # Pour etre sur de ce que j'enregistre en postscript
        # je vais placer ici une procedure de verification
        # qui montrera ce que presente le canvas .plottgriffonne.c
        # verifdebug
        # fin du debug
        update idletasks
        flush stdout
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile \
                -defaultextension .eps]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottgriffonne.c postscript]
        close $outputGraphe
    }
    
    
    #if {[info exists lm] == 0} {
    if {[info exists gr]} {
        if {$gr == 2} {
            if {[info exists pad] && $pad == 1} {
                if {[llength $fogeffectifs] > 2} {
                    pack $w.buttons.ps $w.buttons.cancel -side left -expand 1
                } else  {
                    #tk_messageBox -message "(else) gr = $gr" -type ok
                    pack $w.buttons.ps $w.buttons.class_haut  $w.buttons.class_bas  $w.buttons.cancel \
                            -side left -expand 1
                }
            } else  {
                pack $w.buttons.ps $w.buttons.doc $w.buttons.color $w.buttons.group\
                        $w.buttons.indiv $w.buttons.cancel \
                        -side left -expand 1
            }
        } else  {
            pack $w.buttons.ps $w.buttons.doc $w.buttons.color $w.buttons.group $w.buttons.indiv \
                    $w.buttons.cancel  -side left -expand 1
        }
    } else  {
        if {[info exists etiquette] == 0} {
            pack $w.buttons.ps $w.buttons.doc $w.buttons.color $w.buttons.group\
                    $w.buttons.indiv $w.buttons.cancel\
                    -side left -expand 1
        } else  {
            pack $w.buttons.ps $w.buttons.doc $w.buttons.zoomet $w.buttons.chull $w.buttons.color $w.buttons.group \
                    $w.buttons.indiv $w.buttons.cancel\
                    -side left -expand 1
        }
    }
    #} else {
    #  pack $w.buttons.ps $w.buttons.doc $w.buttons.connecter $w.buttons.color $w.buttons.group \
    $w.buttons.indiv $w.buttons.cancel -side left -expand 1
    #}
    
    set fogc .plottgriffonne.c
    # La variable w contient .plottgriffonne
    
    canvas $fogc -width 450 -height 450 -relief raised -background "light yellow"\
            -yscrollcommand "$w.v_scroll_tut set" \
            -xscrollcommand "$w.h_scroll_tut set"
    scrollbar $w.v_scroll_tut -command "$fogc yview" -orient vertical
    scrollbar $w.h_scroll_tut -command "$fogc xview" -orient horizontal
    pack $w.v_scroll_tut -side right -fill y
    pack $w.h_scroll_tut -side bottom -fill x
    pack $fogc -side top -expand yes -fill both
    
    
    set plotFont {Helvetica 16}
    
    #################################################################################
    # Si c'est une AD, ou si on ne veut pas d'axes proportionnels, le plot est carre
    if {[info exists pad] && $pad == 1} {
        set blup 300.0
        set xgauche 100
        set plic [expr (400 - $blup)/2]
        $fogc create line 100 [expr 400 - $plic] 400 [expr 400 - $plic]\
                -width 1 -fill blue -tag axe_x
        ##### axe des x croit de g a droite (procedure DESSINE)
        $fogc create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)]\
                -width 1 -fill blue -tag axe_y
        ##### axe des y decroit de bas en ht
        set corry [expr ($blup/$maxpcc2)]
        for {set i 0} {$i <= 10} {incr i} {
            set x [expr {100 + ($i*30)}]
            $fogc create line $x [expr 400 - $plic] $x [expr 395 - $plic] \
                    -width 1 -fill blue -tag axe_x
        }
        set hauteurY [expr ($blup)]
        set subdivisionY [expr $hauteurY/10]
        for {set i 0} {$i <= 10} {incr i} {
            set y [expr {400 - $plic - ($i*$subdivisionY)}]
            $fogc create line 100 $y 105 $y -width 1 -fill blue -tag axe_y
        }
        # sinon on fait un plot aux axes proportionels
    } else  {
        if {$maxpcc1 > $maxpcc2} {
            set blup [expr 300.0 * $maxpcc2/$maxpcc1]
            set xgauche 100
            set plic [expr (400 - $blup)/2]
            $fogc create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] \
                    -width 1  -fill blue;##### axe des x croit de g a droite (procedure DESSINE)
            $fogc create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] \
                    -width 1  -fill blue;##### axe des y decroit de bas en ht
            set corry [expr ($blup/$maxpcc2)]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {100 + ($i*30)}]
                $fogc create line $x [expr 400 - $plic] $x [expr 395 - $plic] \
                        -width 1 -fill blue -tag axe_x
            }
            set hauteurY [expr ($blup)]
            set subdivisionY [expr $hauteurY/10]
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {400 - $plic - ($i*$subdivisionY)}]
                $fogc create line 100 $y 105 $y -width 1 -fill blue -tag axe_y
            }
        } else {
            set blup [expr 300.0 * $maxpcc1/$maxpcc2]
            set plic  50
            set ploc [expr (450 - $blup)/2]
            set xgauche [expr 450-$ploc-$blup]
            $fogc create line [expr 450-$ploc-$blup] 350 [expr 450 - $ploc] 350 \
                    -width 2  -fill blue;##### axe des x croit de g a droite (procedure DESSINE)
            $fogc create line [expr 450-$ploc-$blup] 350 [expr 450-$ploc-$blup] 50 \
                    -width 2  -fill blue;##### axe des y decroit de bas en ht
            set corrx [expr ($blup/$maxpcc1)]
            
            set longueurX [expr ($blup)]
            set subdivisionX [expr $longueurX/10]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {(450-$ploc-$blup) + ($i*$subdivisionX)}]
                $fogc create line $x 350 $x 345 -width 2 -fill blue -tag axe_x
            }
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {350 - ($i*30)}]
                $fogc create line $xgauche $y [expr $xgauche + 5] $y -width 2 -fill blue -tag axe_y
            }
        }
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update idletasks
    set textFont {Helvetica 8}
    
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr $sumpc1 + [lindex $pc1 $i]]
    }
    set moypc1 [expr $sumpc1 * 1.0/$npc]
    set minMpc1 [expr $minpc1 - $moypc1]
    set maxMpc1 [expr $maxpc1 - $moypc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr $sumpc2 + [lindex $pc2 $i]]
    }
    set moypc2 [expr $sumpc2 * 1.0/$npc]
    set minMpc2 [expr $minpc2 - $moypc1]
    set maxMpc2 [expr $maxpc2 - $moypc1]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    
    set tc "Factor 1 = desde $minF1  a  $maxF1  -  \nFactor 2 = desde $minF2  a  $maxF2"
    $fogc create text 40 375 -text "$tc ($verjpd)" -font $textFont -anchor w -fill blue -tag facteurs
    $fogc create text 40 435 -text $references -font "Courrier 7" -anchor w -fill red -tag data_info
    $fogc itemconfigure data_info -anchor nw -justify left -width 450
    
    ########################################################################
    # S'il ne s'agit pas d'une autre analyse que l'AD, et s'il n' y a que deux groupes,
    # Effacer ce qu'il y a deja sur le canvas, et dessiner un histogramme
    #if  {[info exists lm] == 0} {
    if {[info exists pad] && $pad == 1} {
        
        if {$gr == 2} {
            if {[info exists adda_lignes]} {
                global base_gr base_fogeffectifs;# adda_lignes enleve
                set fogeffectifs [concat $base_fogeffectifs $adda_lignes];#on insiste pour autoriser un autre bouton
                set fogeffectifs [regsub -all {\{|\}} $fogeffectifs ""]
                #debug
                #set aax "\nbase_fogeffectifs  $base_fogeffectifs\t fogeffectifs $fogeffectifs\n adda_lignes $adda_lignes\nbase_gr $base_gr \t gr $gr\
                \n \n \n"
                #aa $aax
            } else  {
                #debug
                set je debug
            }
            # J'efface
            set fogc .plottgriffonne.c
            set lc [$fogc find withtag axe_y]
            foreach item $lc {$fogc delete $item}
            set lc [$fogc find withtag axe_x]
            foreach item $lc {$fogc delete $item}
            set lc [$fogc find withtag facteurs]
            foreach item $lc {$fogc delete $item}
            # Je dessine l'histogramme
            #
            #
            if {[llength $fogeffectifs] > 2} {
                # s'il y a des donnees supplementaires
                foreach item $fogindividuscentPC1 {
                    append new "[expr {$item * 100}] "
                }
                set fogindividuscentPC1 $new
                #
                set compteur 0
                for {set i 0} {$i < [llength $fogeffectifs]} {incr i} {
                    lappend donnees [lrange $fogindividuscentPC1 $compteur [expr {$compteur + [lindex $fogeffectifs $i]-1}]]
                    #debug
                    #tk_messageBox -message "compteur $compteur to  [expr {$compteur + [lindex $fogeffectifs $i]-1}] = data [expr {$i+1}] = [lindex $donnees $i]" -type okcancel
                    set compteur [expr {$compteur + [lindex $fogeffectifs $i]}]
                }
                #
                # ... les arguments de l'appel a HISTOGRAVE incluent le nom du canvas
                if {[info exists valclass] == 0} {set valclass 10}
                set alpha  [lindex $donnees 0]
                set beta [lindex $donnees 1]
                set gamma  [lindex $donnees 2]
                set fogeffectifs "[llength [lindex $donnees 0] ] [llength [lindex $donnees 1] ] [llength [lindex $donnees 2] ]"
                #debug
                #tk_messageBox -message "fogeffectifs $fogeffectifs" -type okcancel
                histograve $alpha $beta $gamma $valclass $c
                return
            } else  {
                # s'il n'y a pas eu appel a des donnees externes
                set coul 0
                set quidam 0
                set legion [lindex $fogeffectifs $coul]
                set long [llength $fogindividuscentPC1]
                for {set i 0} {$i < $long} {incr i} {
                    incr quidam
                    if {$quidam > $legion} {
                        set ind [ lindex $fogindividuscentPC1 $i ]
                        lappend data2 [expr {$ind * 100}]
                    } else  {
                        set ind [ lindex $fogindividuscentPC1 $i ]
                        lappend data1 [expr {$ind * 100}]
                    }
                }
            }
            # ... les arguments de l'appel a HISTOGRABE incluent le nom du canvas
            if {[info exists valclass] == 0} {set valclass 10}
            histograbe $data1 $data2 $valclass $c
            return
        }
    }
    #}
    ########################################################################
    
    # -------------------------------------------------------------------------------
    # Ecriture sur fond jaunatre des points bleus de la carte factorielle
    # ------------------------------------------------------------------------------
    set ovo 3
    set long [llength $fogindividuscentPC1]
    set coul 0
    set quidam 0
    #chull
    # Si le bouton CHULL est active
    if {[info exists fogeffectifs]} {
        if {[llength $fogeffectifs] > 1} {
            set legion [lindex $fogeffectifs $coul]
            set canvas_g ""
        }
    }
    if {[info exists adda_lignes] == 1} {
        set long [expr {$long - $adda_lignes}]
    }
    
    # ------------------------------------------------------------
    # D'un individu 'i'  a l'autre
    # ------------------------------------------------------------
    set sumindpc1 0
    set sumindpc2 0
    #
    for {set i 0} {$i < $long} {incr i} {
        #
        incr quidam
        # Si le bouton CHULL est active
        if {[info exists fogeffectifs]} {
            if {[llength $fogeffectifs] > 1} {
                if {$quidam > $legion} {
                    #chull
                    set convexhulls [env::chull $canvas_g]
                    $fogc create line $convexhulls  -fill red -tag all
                    set canvas_g ""
                    incr coul
                    incr legion [lindex $fogeffectifs $coul]
                }
            }
        }
        # BOUTON chull, fin
        
        # Calcul de la position et affichage de l'objet $i ------------------------ debut -----
        #
        set indpc1 [ lindex $fogindividuscentPC1 $i ]
        set indpc2 [ lindex $fogindividuscentPC2 $i ]
        
        # pour le calcul du point centroide - debut
        set sumindpc1 [expr {$sumindpc1 + $indpc1}]
        set sumindpc2 [expr {$sumindpc2 + $indpc2}]
        # pour le calcul du point centroide - fin
        
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        
        # On affiche un cercle, bleu
        if {[info exists etiquette] == 0} {
            set item [$fogc create oval [expr {$x-$ovo}] [expr {$y+$ovo}] [expr {$x+$ovo}] [expr {$y-$ovo}] \
                    -width 1 -outline blue -tag zou -tag peinture]
            $fogc addtag point withtag $item
            append canvas_g "$x $y "
        } else  {
            # ou alors on affiche une etiquette
            set eti [lindex $doc $i]
            set item [$fogc create text $x $y -text $eti -fill blue]
            $fogc addtag point withtag $item
            append canvas_g "$x $y "
        }
        #
        # Calcul de la position et affichage du point $i ------------------------ fin -----
    }
    # Fin des boutons bleus
    
    # pour le calcul et l'affichage du point centroide --- debut
    set moyindpc1 [expr {$sumindpc1 * 1 / $long}]
    set moyindpc2 [expr {$sumindpc2 * 1 / $long}]
    set x [ expr { $xgauche + ( $corrx * $moyindpc1 ) } ]
    set y [ expr { 400 - $plic - ( $corry * $moyindpc2 ) } ]
    #set item [$fogc create rectangle [expr {$x-5}] [expr {$y+5}] [expr {$x+5}] [expr {$y-5}] \
    -width 2 -outline "dark blue" -tag zou -tag peinture]
    #
    #
    # pour le calcul et l'affichage du point centroide --- fin
    
    if {[info exists fogeffectifs]} {
        if {[llength $fogeffectifs] > 1} {
            #puts $canvas_g
            set convexhulls [env::chull $canvas_g]
            $fogc create line $convexhulls -fill red -tag allhulls
            set canvas_g ""
        }
    }
    
    # s'il y a des fogindividus supplementaires apres une analyse discriminante
    if {[info exists adda_lignes] == 1} {
        # Projet njaram - debut
        # Si on veut documenter les fogindividus sur le graphique
        # il faut ici charger les donnees incluant les fogindividus additionnels
        # Projet njaram - fin
        set adda_long $long
        # je suppose que long contenait le numero d'fogindividus sans les externes
        # on lui donne ensuite la valeur du nombre total d'fogindividus
        set long [llength $fogindividuscentPC1]
        for {set i $adda_long} {$i < $long} {incr i} {
            set indpc1 [ lindex $fogindividuscentPC1 $i ]
            set indpc2 [ lindex $fogindividuscentPC2 $i ]
            set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
            set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
            set item [$fogc create oval $x [expr {$y-10}] [expr {$x+10}] $y -width 1 -fill red -tag zou -tag peinture]
            $fogc addtag point withtag $item
        }
    }
    
    set plot(lastX) 0
    set plot(lastY) 0
    
    if  {[info exists adda_lignes] != 0} {
        $fogc configure -cursor dot
        bind $fogc <ButtonPress> { datosext }
        balloonhelp_for .plottgriffonne.c "Clic sobre la figura -> etapas y comentarios"
    }
    
    $fogc configure -scrollregion [$fogc bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    
}
#
# PROCEDURE griffonne   ## FIN ###
