package require Tk
# 
source [pwd]/math/statistics.tcl

# procedure DEBUG
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x600+205+66
        set memo [text .debug.t -wrap word -height 22 -font "courier 13" \
                -bg grey88 \
                -fg black\
                -tabs "3c left"\
                -yscrollcommand ".debug.v_scroll set" \
                -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
            if {$flag == 1} {
                .debug.t configure -wrap none
                set flag 0
            } else  {
                .debug.t configure -wrap word
                set flag 1
            }
        }
        #
        $memo insert end $bugatti
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG fin


proc print-histogram {counts limits} {
   foreach count $counts limit $limits {
      if { $limit != {} } {
	  debug [format "<%12.4g\t%d" $limit $count]
         set prev_limit $limit
      } else {
         debug [format ">%12.4g\t%d" $prev_limit $count]
      }
   }
}

proc tcllibhist {data} {
    # data <- signed differences
    #
    #console show
    canvas .plot
    pack   .plot
    #
    debug "Basic statistics:"
    set b [::math::statistics::basic-stats $data]
    foreach label {mean min max number stdev var} v $b {
	debug "$label\t$v"
    }
    #
    debug "Print and Plot histograms"
    set min [lindex $b 1]
    set max [lindex $b 2]
    ::math::statistics::plot-scale .plot  $min $max 0 100
    set limits         [::math::statistics::minmax-histogram-limits $min $max]
    debug "limits $limits"
    set histogram_data [::math::statistics::histogram $limits $data]
    debug "histogram_data $histogram_data"
    print-histogram $histogram_data $limits
    ::math::statistics::plot-histogram .plot $histogram_data $limits
}

set data "1 1 2 2 2 2 2 3 3 3 3 3 3 4 5 6 5 4 3 4 5 5 5 5 5 5 5 5 6 6 6 6 6 6 6 6 6 6 6 7  7 7 7 7 7 7 7 7 7 7 8 9 9 9 9 9 8 8 8 8 7 7 7 6 5 4 3 2"
tcllibhist $data