# MICROGRAAL
# decoupage - bin2gray - oncalcvec
#

if 0 {
    1 - rendre plus visible l'algoritme du SEUIL et le CHOIX qui en decoule (vert, bleu)
    2 - bleu: en faire une troisieme methode, car une autre methode pourrait bien devenir la deuxieme
    la deuxieme serait la totalite des '1' avec le minimum de blocs
    en fait la totalite des '1' sur une rangee serait preferee si sa composition etait un grand bloc et des petits blocs ...
    (pas deux blocs a peu pres egaux ...)
}

# cfr. procedure DECOUPAGE
# # Des rectangles sont definis dans l'image initiale, 'fotoa', autour de chaque LM
#    # On cree une image de type photo, appelee 'dec' (pour decoupe)
#    # On copie dans l'image 'dec' le rectangle défini dans la grande image 'fotoa'
#
#
# cfr. procedure BIN2GRAY
# # Cette procedure transforme une image couleur (un rectangle) en noir et blanc (la moyenne des RGB de chaque pixel)
#
#
# # Apres chgt des pixels, on copie l'image source dans l'image de depart (cfr. INSTRUCTION "fotoa copy $res")
# # # Ce n'est d'ailleurs pas indispensable, on peut travailler d'emblee sur le tableau (liste de listes, cfr. ci-dessous)
#
#
# cfr. procedure ONCALCVEC
# # On place alors dans une liste de listes (vector2) la premiere valeur de chaque pixel -
#

# -------------
# Image sampling
# --------------
# BIN2GRAY et ONCALCVEC sont appliques en fait a chaque rectangle de l'image initiale, ce qui va accelerer le processus
# car les rectangles sont obligatoirement petits
#
# La vitesse de la procedure (GR)AAL sera fonction du nombre de LM et de la taille des rectangles

# User configuration
# ------------------
# cote_rect
# rgb_max
# distanciation
#
# ----------------

global p


# procedure MICROGRAAL
#
proc micrograal {coord_obs} {
    
    global p
    
    
    
    
    # PROCEDURE bin2gray -- start
    #
    proc bin2gray {image subfactor} {
	
	global p
	
	set iota [lrange {- 0 1 2 3 4 5 6 7 8 9} 1 $subfactor]
	set h0 [image height $image]; set w0 [image width $image]
	set th [expr {round(1.*$h0/$subfactor)}]
	set tw [expr {round(1.*$w0/$subfactor)}]
	set res [image create photo -height $th -width $tw]
	for {set tx 0} {$tx<$tw} {incr tx} {
	    set pix ""
	    for {set ty 0} {$ty<$th} {incr ty} {
		set y [expr {$ty*$subfactor}]
		set sum 0
		foreach i $iota {
		    set x [expr {$tx*$subfactor}]
		    foreach j $iota {
			incr sum [lindex [$image get $x $y] 0]
			incr x
			if {$x>=$w0} break
		    }
		    incr y
		    if {$y>=$h0} break
		}
		# R = G = B = moyenne des pixels
		set g [expr {round(1.0*$sum/($subfactor*$subfactor))}]
		lappend pix [
			     format #%02x%02x%02x $g $g $g
			    ]
		
	    }
	    # On rentre les valeurs RGB de chaque pixel de l'image
	    $res put $pix -to $tx 0
	}
	
	return $res
    }
    #
    # PROCEDURE bin2gray -- end
    
    
    
    
    # procedure ONCALCVEC # debut
    #
    # ... sur le bloc d'image grise (le bloc est grise, pas l'image)
    # On y peche les valeurs RBG pour chaque pixel
    # R = G = B parce que bin2gray
    # On en prend la premiere
    # On la divise par 25.5 (pour avoir qch entre 0 et 10 - Note: 0 = noir) <- par 12.75 si on veut plus de nuances
    # le tout est place dans une liste de listes
    #
    proc oncalcvec {dec wi he} {
	
	global p rgb_max
	
	# set rgb_max 1
	# rgb_max 25.5  Pixels simplifies de 0 a 10
	# rgb_max 12.75 Pixels simplifies de 0 a 20
	# rgb_max 6.375 Pixels simplifies de 0 a 40
	# rgb_max 3.1875 Pixels simplifies de 0 a 80
	# rgb_max 1.59375 Pixels simplifies de 0 a 160
	# rgb_max 1 Pixels simplifies de 0 a 255
	
	for {set i 0} {$i < [expr $he-1]} {incr i} {
	    for {set j 0} {$j < [expr $wi-1]} {incr j} {
		set point [lindex [$dec get $j $i] 0]
		set point [expr {round($point * 1.0/$rgb_max)}]
		append vector "$point "
	    }
	    update
	    append vector "\n"
	}
	return $vector
    }
    #
    # Procedure ONCALCVEC # fin
    
    
    
    # Procedure DECOUPAGE - debut
    #
    # On y procede au decoupage de l'image en rectangles
    # Ces rectangles sont supposes contenir le point recherche (sans quoi ...)
    #
    proc decoupage {compteur x y cote} {
	
	global p
	
	if {[llength $cote] == 1} {
	    set bas $cote
	    set ht $cote
	    set gch $cote
	    set dt $gch
	    set th [expr {int($ht + $bas)}]
	    set tw [expr {$dt + $gch}]
	} else  {
	    set bas [lindex $cote 1]
	    set ht [lindex $cote 1]
	    set gch [lindex $cote 0]
	    set dt [lindex $cote 0]
	    set th [expr {int($ht + $bas)}]
	    set tw [expr {$dt + $gch}]
	}
	
	set xgch [expr {$x - $gch}]
	set xdt [expr {$x + $dt}]
	set yht [expr {$y - $bas}]
	set ybas [expr {$y + $ht}]
	
	set rectangle($compteur) [list $xgch $yht $xdt $ybas]
	
	# On cree une image de type photo, appelee 'dec' (pour decoupe)
	set dec [image create photo -height $th -width $tw]
	# On copie dans l'image 'dec' le rectangle défini dans la grande image 'fotoa'
	$dec copy fotoa -from  $xgch $yht $xdt $ybas
	
	return $dec
    }
    #
    # Procedure DECOUPAGE - FIN
    
    
    
    
    # PROCEDURE seuil_1
    #
    # appelee par la procedure TRESHOLD (situee en dessous de la procedure SEUIL_2 qui suit)
    #
    proc seuil_1 {stat_rgb} {
	global p landmark nocontrast
	# Valeurs ordonnees par les frequences R=G=B, afin de faire ensuite la diff entre max et min
	set ordre [lsort -real -index 1 $stat_rgb]
	# On retire les accolades
	regsub -all {\{||\}} $ordre "" ordre
	# On range R=G=B et sa freq dans des var separees (rgb et qte); 'qte' ne sert a rien, pour le moment
	foreach {hip hop} $ordre {append rgb "$hip "; append qte "$hop "}
	# Valeurs R=G=B min et max
	set rgb_min [lindex [lsort -real $rgb] 0]
	set rgb_max [lindex [lsort -real $rgb] end]
	# S'il n'y a pas de contraste, alerte
	if {$rgb_min == $rgb_max} {
	    set nocontrast [expr {$nocontrast + 1}]
	    tk_messageBox -message "No contrast for LM $landmark" -icon warning -type ok
	}
	# seuil = min + (max-min)/2)
	#
	set seuil [expr {$rgb_min + ($rgb_max-$rgb_min)/2}]
	
    }
    #
    # PROCEDURE seuil_1
    
    
    # PROCEDURE seuil_2
    #
    # appelee par la procedure TRESHOLD (ci-dessous)
    #
    proc seuil_2 {pix_freq} {
	global p landmark candidats
	# 'candidats' liste des pixels de freq max
	# On retire les accolades
	regsub -all {\{||\}} $pix_freq "" pix_freq
	set pix_nb [expr {[llength $pix_freq]/2}]
	#debug
	#$p insert end "\n\nALGO 2 :\t$pix_freq et nbre diff de r=g=b $pix_nb "
	# attention, que se passe-t-il si pas de 'candidats' ???
	set candidats ""
	set candidature ""
	for {set i 3} {$i < [expr {$pix_nb*2}]} {incr i 2} {
	    set a [lindex $pix_freq $i]
	    set b [lindex $pix_freq [expr {$i-2}]]
	    #debug
	    #$p insert end "\na < b ?? $a < $b ?"
	    if {$a < $b} {append candidature "[lindex $pix_freq  [expr {$i-3}]] "}
	}
	set candidats_nb [expr {[llength $candidature]/2}]
	set compteur 0
	foreach item $candidature {
	    incr compteur
	    if {$compteur <= $candidats_nb} {append candidats "$item "} else {break}
	}
	#debug
	#$p insert end "\ncandidats $candidats"
	if {$candidats != ""} {
	    set choix [lindex $candidats 0]
	} else  {
	    set choix ""
	}
	return $choix
    }
    #
    # PROCEDURE seuil_2
    
    
    # Procedure TRESHOLD - start
    #
    proc treshold {vector_table lm} {
	#
	# Qui appelle treshold ?? (Rep/ SCRIPT PRINCIPAL de la superprocedure MICROGRAAL)
	#
	global p cote_rect tucol tulig landmark rgb_max
	#
	set x [expr {[lindex $cote_rect($lm) 0] * 2 -1}]
	set y [expr {[lindex $cote_rect($lm) 1] * 2 -1}]
	
	# HUME matrix -  liste des listes ('vector_table') transformee en matrice de Hume ('hume_table')
	set hume_table "2 $x $y "
	foreach item $vector_table {if {$item != "\n"} {append hume_table "$item "}}
	
	#
	# HISTOGRAMME des pixels - debut
	#
	set data_pix [vtrim $hume_table]
	set tot_pix [llength $data_pix]
	#debug
	#$p insert end "total $tot_pix"
	
	# Valeur maximum d'un pixel r=g=b
	set max [expr {round(255 * 1.0/$rgb_max)}]
	
	set epaisseur 1
	for {set i 0} {$i < [expr {$max + $epaisseur}]} {incr i $epaisseur} {
	    lappend limits $i
	}
	#debug
	#$p insert end "\nProcedure TRESHOLD max = $max\nLimits \t$limits"
	set limits_correction [lrange $limits 0 end-1]
	# Calcul des hauteurs des barres de l'histogramme pour les limites choisies
	set counts [::math::statistics::histogram $limits_correction $data_pix]
	#debug
	#$p insert end "\nCounts \t$counts"
	foreach item $counts {append freq_counts "[expr {round(($item * 1.0 / $tot_pix) * 100)}] "}
	#
	# ASCII visualization of HISTOGRAM - start
	# 
	#set compteur 0
	#foreach item $freq_counts {
	#    if {$item > 0} {
	##        for {set i 0} {$i < $item} {incr i} {
	#            $p insert end "|"
	#        }
	#        $p insert end "\t\t\t\t[lindex $limits $compteur]\n"
	#    }
	#    incr compteur
	#}
	#
	# ASCII visualization of HISTOGRAM - end
	
	
	for {set i 0} {$i < [expr {$max + 1}]} {incr i} {
	    set a($i) [lindex $freq_counts $i]
	}
	
	# Histogramme des pixels - fin
	
	#
	# Moyenne, a tout hasard (ne sert pas a l'algo du seuil)
	#
	set nbtot [expr {[mcols $hume_table]*[mrows $hume_table]}]
	set totsum [msum [msum $hume_table]]
	set moy [expr {$totsum * 1.0 / $nbtot}]
	#debug
	#$p insert end  "$totsum / $nbtot = ? $moy"
	
	# PREFILTRAGE, qui devrait enlever les toutes petites zones (trop petites pour etre des veines)
	#
	# On elimine les R=G=B dont la frequence est nulle. On elimine aussi ceux dont la frequence est proche de zero
	# Elimination des valeurs dont la freq < 0.005 - ce choix est fixe, il est pour l'instant subjectif
	set stat_rgb ""
	for {set i 0} {$i < [expr {$max + 1}]} {incr i} {
	    set freq [expr {$a($i) * 1.0 / 100}]
	    if {$freq > 0.005} {lappend stat_rgb "$i $freq"}
	}
	#debug
	#$p insert end "RECHERCHE DU SEUIL - deux algoritmes produisant seuil_1 et/ou seuil_2\nALGO 1 :\t"
	#
	# 'stat-rgb' contient la valeur d'un pixel et sa frequence (> 0.005)
	# Les valeurs informatives ET le fond sont a present dans la liste 'stat_rgb'
	
	
	# ALGO DU SEUIL num 1 - ... seuil = min + (max-min)/2) ... - debut
	#
	set seuil_1 [seuil_1 $stat_rgb]
	#
	#debug
	#$p insert end "\nalgo 1 : seuil = min + (max-min)/2)\t$seuil_1"
	#
	# ALGO DU SEUIL num 1 - fin
	
	# debug
	#$p insert end "\nMoyenne (ne sert pas a l'algo du seuil)\t[expr {round($moy)}] <- $moy"
	
	
	# ALGO DU SEUIL num 2 - ... le premier maximum - debut
	#
	set seuil_2 [seuil_2 $stat_rgb]
	# debug
	#$p insert end "\nalgo 2 : seuil\t$seuil_2\n"
	# debug - fin
	#
	# ALGO DU SEUIL num 2 - fin
	# Il faudrait garder tous les maxiumms, avec le pixel correspondant, pour revenir au deuxieme, troisieme, etc. max
	# au fur et a mesure que la methode verte flanche ... YES !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	
	# Correction si le seuil est superieur a la moyenne (tres peu de contraste, ou nervure plus claire que le fond)
	if {$seuil_2 > $moy} {set seuil_2 [expr {int($moy)}]}
	if {$seuil_1 > $moy} {set seuil_1 [expr {int($moy-1)}]}
	
	# Les deux seuils seront utilises dans la procedure TO_Z_O, mais la on revient au SCRIPT principal
	return [list $seuil_1 $seuil_2]
    }
    #
    # Procedure TRESHOLD - end
    
    
    # Procedure TO_Z_0 - start
    #
    # "0" et "1" separent le bruit du signal ... Cette procedure est critique.
    #
    proc to_z_o {vector_table seuil} {
	global p
	set seuil_1 [lindex $seuil 0];# je ne l'utilise que si seuil_2 est vide
	set seuil_2 [lindex $seuil 1]
	# Mise a zero initiale
	set zero_un ""
	# Values to zero un - Attention, l'algo 2 peut ne pas generer de seuil_2 !
	if {$seuil_2 != ""} {
	    foreach line [split $vector_table "\n"] {
		foreach item $line {
		    if {$seuil_2 > 2} {
			if {$item <= $seuil_2} {
			    append zero_un "1 "
			} else {
			    append zero_un "0 "
			}
		    } else  {
			if {$item == $seuil_2} {
			    append zero_un "1 "
			} else {
			    append zero_un "0 "
			}
		    }
		}
		append zero_un "\n"
	    }
	} else  {
	    foreach line [split $vector_table "\n"] {
		foreach item $line {
		    if {$item <= $seuil_1} {
			append zero_un "1 "
		    } else {
			append zero_un "0 "
		    }
		}
		append zero_un "\n"
	    }
	}
	return $zero_un
    }
    #
    # Procedure TO_Z_0 - end
    
    
    
    # Procedure BLUEPOINT - debut
    #
    proc bluepoint {vector_table seuillist lm} {
	
	# ----------------------- Methode BLEUE --------------- debut -----------
	#
	global p cote_rect tucol tulig landmark rgb_max
	
	set x [expr {[lindex $cote_rect($lm) 0] * 2 -1}]
	set y [expr {[lindex $cote_rect($lm) 1] * 2 -1}]
	
	# HUME matrix -  liste des listes ('vector_table') transformee en matrice de Hume ('hume_table')
	set hume_table "2 $x $y "
	foreach item $vector_table {if {$item != "\n"} {append hume_table "$item "}}
	#
	# Les points bleus se calculent sur la liste des listes transformee en matrice de Hume
	mnorms_br hume_table means_col sigma_col
	
	set hume_table_t [transpose $hume_table]
	mnorms_br hume_table_t means_lig sigma_lig
	
	
	#debug
	#$p insert end "\nMethode BLEUE"
	#$p insert end "\nMEANS_COL\n[show $means_col %8.2f]"
	#$p insert end "\nMEANS_LIG\n[show $means_lig %8.2f]"
	
	
	# CACULER LA VALEUR MOYENNE ET LA VAR DES COLONNES
	#
	set means_col_r [lreplace $means_col 2 2 1]
	
	mnorms_br means_col_r moy_col var_col
	set moy_col [vtrim $moy_col]
	set var_col [vtrim $var_col]
	#debug
	#$p insert end "\nmoyenne de toutes les colonnes\t$moy_col\variance de toutes les colonnes\t$var_col"
	#
	# CALCULER LA VALEUR MOYENNE ET LA VAR DES LIGNES
	#
	set means_lig_r [lreplace $means_lig 2 2 1]
	
	mnorms_br means_lig_r moy_lig var_lig
	set moy_lig [vtrim $moy_lig]
	set var_lig [vtrim $var_lig]
	#debug
	#$p insert end "\nmoyenne de toutes les lignes\t$moy_lig\variance de toutes les lignes\t$var_lig"
	
	#
	# CONSTRUIRE UNE LISTE {VAR MOY}, LIGNES (varmoy_lig) et COLONNES (varmoy_col)
	#
	# LIGNES
	#
	set v_lig [vtrim $sigma_lig]
	set m_lig [vtrim $means_lig]
	set compteur 0
	set varmoy_lig ""
	foreach item $v_lig {
	    lappend varmoy_lig "$item [lindex $m_lig $compteur]"
	    incr compteur
	}
	#
	# COLONNES
	#
	set v_col [vtrim $sigma_col]
	set m_col [vtrim $means_col]
	set compteur 0
	set varmoy_col ""
	foreach item $v_col {
	    lappend varmoy_col "$item [lindex $m_col $compteur]"
	    incr compteur
	}
	
	#
	# # En evitant les bords, trouver la position de la moyenne la plus proche du seuil
	#
	set seuil_1 [lindex $seuillist 0]
	set seuil_2 [lindex $seuillist 1]
	if {$seuil_2 != ""} {set seuil $seuil_2} {set seuil $seuil_1}
	#
	# COLONNES
	#
	set compteur 0
	set diff_col ""
	foreach item $varmoy_col {
	    incr compteur
	    set m [lindex $item 1]
	    set diff [expr {abs($m - $seuil)}]
	    lappend diff_col "$diff $compteur"
	}
	#debug
	#$p insert end "diff_col (moy - seuil) *** \n$diff_col"
	set diff_col_ordre [lsort -index 0 -real $diff_col]
	#$p insert end "\nMethode BLEUE, suite: diff_col_ordre (moy - seuil)\n$diff_col_ordre"
	foreach item $diff_col_ordre {
	    #debug
	    #$p insert end "\n$item <--  [lindex $item 1]"
	    set hors_bord [lindex $item 1]
	    if {$hors_bord > 5 && $hors_bord < 19} {
		set tucol $hors_bord
		break}
	}
	if {[info exists tucol] < 1} {tk_messageBox  -message "des embrouilles dans les col" -type ok}
	
	#
	# LIGNES
	#
	set compteur 0
	set diff_lig ""
	foreach item $varmoy_lig {
	    incr compteur
	    set m [lindex $item 1]
	    set diff [expr {abs($m - $seuil)}]
	    lappend diff_lig "$diff $compteur"
	}
	#debug
	#$p insert end "\ndiff_lig (moy - seuil) ### \n$diff_lig"
	set diff_lig_ordre [lsort -index 0 -real $diff_lig]
	#$p insert end "\nMethode BLEUE, suite: diff_lig_ordre (moy - seuil)\n$diff_lig_ordre"
	foreach item $diff_lig_ordre {
	    set hors_bord [lindex $item 1]
	    if {$hors_bord > 5 && $hors_bord < 19} {
		set tulig $hors_bord
		break
	    }
	}
	if {[info exists tulig] < 1} {tk_messageBox  -message "des embrouilles dans les lig" -type ok}
	
	#$p insert end "\nMethode BLEUE, suite et fin : x = $tulig et y = $tucol\n"
	# Choisir la moy la moins eloignee de seuil_2 et eviter les bords
	#
	#
	#
	#debug
	#$p insert end "\nMATRIX hume_table\n"
	#$p insert end "Colonnes hume_table\n[show $means_col %8.1f]\t$moy_col\n[show $sigma_col %8.1f]\n"
	#$p insert end "Lignes   hume_table\n[show $means_lig %8.1f]\t$moy_lig\n[show $sigma_lig %8.1f]\n"
	
	#------------------ Methode BLEUE --------------- fin -----------
	#
	return [list $tulig $tucol]
    }
    #
    # procedure BLUEPOINT
    
    # Procedure COUTURE -start
    #
    # La 'couture' consiste a reunir des blocs positifs (d'une ligne ou d'une colonne) separes par seulement un pixel nul
    # Elle vient apres treshold et to_z_o
    # Ensuite on passera a la classification des rectangles (blocs, et nb de 1)
    
    # Utilite supposee: reveler des zones importantes maltraitees par le treshold choisi
    proc couture {vector_table lm} {
	
	global p
	
	foreach line [split $vector_table "\n"] {
	    append vector_table_new "[lindex $line 0] "
	    set colonnes [llength $line]
	    for {set k 1} {$k < $colonnes} {incr k} {
		set prec [expr {$k-1}]
		set suiv [expr {$k+1}]
		if {[lindex $line $k] == 0 && [lindex $line $prec] > 0 && [lindex $line $suiv] > 0} {
		    append vector_table_new "1 "
		    #$p insert end "\n\tposition $i: [lindex $ligne $i] = $compteur_uns"
		} else  {
		    append vector_table_new "[lindex $line $k] "
		}
	    }
	    append vector_table_new "\n"
	}
	#debug
	#$p insert end "\nLM $lm Apres couture vector_table_new \n$vector_table_new"
	return $vector_table_new
    }
    
    
    #
    # Procedure couture - stop
    
    
    # Procedure BLOC -start
    #
    # Apres decoupage - bin2gray - oncalcvec, treshold, to_z_o et couture,
    # la procedure BLOC classe chaque rectangle en nb de blocs et qte de 1 (horiz et vertic)
    #
    proc bloc {ligne colonnes} {
	
	# La variable 'ligne' est une liste qui contient une suite de r=g=b
	# La variable 'colonnes' correspond au nombre de pixels de cette ligne
	
	global p
	
	set total_uns 0
	set total_null 0
	set compteur_uns 0
	set compteur_null 0
	set liste_uns ""
	set local_uns ""
	# On parcourt la ligne indiquee par la procedure 'un_zero' (la procedure qui appelle 'bloc')
	#
	for {set i 1} {$i < $colonnes} {incr i} {
	    set j [expr {$i - 1}]
	    #$p insert end "\nON EXAMINE: [lindex $ligne $j] [lindex $ligne $i]"
	    # si " 1 1 " se suivent, le bloc se construit
	    if {[lindex $ligne $i] > 0 && [lindex $ligne $j] > 0} {
		incr total_uns
		incr compteur_uns
		set compteur_null 0
		append liste_uns "$compteur_uns "
		append local_uns "$i "
		#$p insert end "\n\tposition $i: [lindex $ligne $i] = $compteur_uns"
	    }
	    # si " 1 0 ", le dernier 1 est pris en compte, puis le compteur des uns est remis a zero, on passe a un autre bloc
	    if {[lindex $ligne $i] == 0 && [lindex $ligne $j] > 0} {
		incr total_uns
		incr compteur_uns
		append liste_uns "$compteur_uns "
		append local_uns "$i "
		#$p insert end "\n\tposition $i: [lindex $ligne $i] = $compteur_uns"
		set compteur_uns 0
	    }
	    # si " 0 0 " se suivent, un autre bloc est suppose, le compteur des uns est remis a zero,
	    if {[lindex $ligne $i] == 0 && [lindex $ligne $j] == 0} {
		incr compteur_null
		set compteur_uns 0
		append liste_null "$compteur_null "
		#$p insert end "\n\tposition $i: [lindex $ligne $i] = $compteur_null"
	    }
	}
	return [list $liste_uns $total_uns $local_uns]
    }
    #
    # Procedure BLOC - stop
    
    
    # Procedure UN_ZERO - table
    #
    # que fait cette procedure ?
    # Elle compte les blocs de "1", elle compte les "1" dans ces blocs, et sur une ligne
    #
    # qui appelle cette procedure ?
    # Reponse: la procedure CLASSEMENT
    #
    proc un_zero {vector_table} {
	
	global p
	
	set ligne 0
	set blocs_doc ""
	#
	# On va parcourir chaque ligne du vector_table
	#
	foreach line [split $vector_table "\n"] {
	    incr ligne
	    #$p insert end "\n---------------\nline $line\n--------------\n"
	    set colonnes [llength $line]
	    set compteur_ligne 1
	    set depart $compteur_ligne
	    
	    # Appel a la procedure BLOC ... (ci-dessus)
	    # Cette derniere classe chaque rectangle en nb de blocs et qte de 1 (horiz et vertic)
	    #
	    set examen [bloc $line $colonnes]
	    #
	    # La liste retournee ('examen') contient 3 listes :
	    # _ les '1'
	    # _ le nbre total de '1' de la ligne
	    # _ et les colonnes correspondantes aux '1' des blocs (localisation du loc)
	    
	    if {[lindex $examen 1] > 0} {
		#debug
		#$p insert end "Procedure un_zero\tLigne $ligne: 'examen' \t$examen"
		#debug important
		#$p insert end "\n---------------\nLigne $ligne"
	    };# {$examen (blocs de 1 et NOMBRE de uns)}
	    
	    # Reccueil des 3 listes dans 3 variables differentes
	    #
	    set blocs_liste [lindex $examen 0]
	    set total_uns [lindex $examen 1]
	    set blocs_local  [lindex $examen 2]
	    #
	    
	    
	    #regsub -all {\{||\}} $bloc_liste "" bloc_liste
	    
	    # --------------------------
	    # On compte les blocs de "1" a partir de 'bloc_liste'
	    #
	    set bloc 0
	    for {set i 0} {$i < $total_uns} {incr i} {
		#debug
		#$p insert end "\ni = $i: Element $i de $blocs_liste soit : [lindex $blocs_liste $i]"
		if {[lindex $blocs_liste $i] == 1} {
		    incr bloc
		}
	    }
	    #
	    # fin du comptage des blocs
	    # ---------------------------
	    
	    if {[lindex $examen 1] > 0} {}
	    
	    # -----------------------------------------
	    # On compte les elements "1" de chaque bloc
	    #
	    set segment 0
	    set compteur 0
	    set bloc_accu ""
	    set lignes_doc ""
	    #
	    for {set i 1} {$i < [expr {$total_uns+1}]} {incr i} {
		if {[lindex $blocs_liste $i] == 1} {
		    incr compteur
		    set suite($compteur) [expr {$i+1-$segment}]
		    set segment [expr {$segment + $suite($compteur)}]
		    #debug important
		    #$p insert end "\nbloc $compteur $suite($compteur)"
		    append bloc_accu "$suite($compteur) "
		}
		if {$i == [expr {$total_uns}]} {
		    incr compteur
		    set suite($compteur) [expr {$i+1-$segment}]
		    set segment [expr {$segment + $suite($compteur)}]
		    #debug important
		    #$p insert end "\nbloc-fin $compteur $suite($compteur)"
		    append bloc_accu "$suite($compteur) "
		}
		
	    };# fin du compte des elements de chaque bloc
	    # --------------------------------------------
	    
	    #debug
	    #$p insert end "\nnb total de pixels + = $segment"
	    
	    
	    # 'lines_doc' contient (pos 0) num ligne (pos 1) nb blocs (pos suiv) nb elem / bloc (pos end) nb total elem
	    append lignes_doc "$ligne $compteur $bloc_accu $segment "
	    if {[lindex $lignes_doc 1] > 0} {
		#debug
		#$p insert end "\n--- $lignes_doc"
		lappend blocs_doc [list $lignes_doc [list $ligne $blocs_local]]
	    }
	    
	};# fin des lignes du vecteur (line vector)
	return $blocs_doc
    }
    #
    # Procedure UN_ZERO - table
    
    
    # # procedure CROIX - debut
    #
    proc croix {local_mono_dabord local_mono_dapres lm} {
	
	global p cote_rect
	
	set monoblocs ""
	
	set gch [lindex $cote_rect($lm) 0]
	set dt  [lindex $cote_rect($lm) 0]
	set ht  [lindex $cote_rect($lm) 1]
	set bas  [lindex $cote_rect($lm) 1]
	set col_max [expr {$gch+$dt}]
	set lig_max [expr {$bas+$ht}]
	
	
	
	# 'dabord' et 'dapres' en fonction de l'ordre des arguments de l'appel a procedure: 'lig col' ou 'col lig'
	# local_mono_dabord remplace 'local_mono_lig($i)' ou 'local_mono_col($i)'
	# local_mono_dapres remplace 'local_mono_col($i)' ou 'local_mono_lig($i)'
	
	foreach item $local_mono_dabord {
	    set local_dabord [lindex $item 0]
	    # EVITER LES BORDS
	    # local_dabord remplace 'local_lig' ou 'local_col'
	    # local_dapres remplace 'local_col' ou 'local_lig'
	    if {$local_dabord > [expr {$gch/2}] && $local_dabord < [expr {$gch * 2 - $gch / 2 + 1}]} {
		#$p insert end "\nitem $item \tlocal_dabord $local_dabord"
		foreach truc $local_mono_dapres {
		    set local_dapres [lindex $truc 1]
		    set ldapres [lindex $truc 0]
		    #$p insert end "\ntruc $truc \tlocal_col $local_col"
		    # EVITER LES BORDS
		    if {$ldapres > [expr {$gch/2}] && $ldapres < [expr {$gch * 2 - $gch / 2 + 1}]} {
			
			foreach vrt $local_dapres {
			    #$p insert end "\nvrt = local : $vrt = $local ?"
			    
			    # EVITER LES BORDS
			    if {$vrt == $local_dabord} {
				set choix_dabord $local_dabord
				set choix_dapres [lindex $truc 0]
				break
			    }
			    
			    if {[info exists choix_dabord ]} {break}
			}
			if {[info exists choix_dabord ]} {break}
			
		    }
		}
		if {[info exists choix_dabord ]} {break}
	    }
	    # EVITER LES BORDS
	}
	
	if {[info exists choix_dabord]} {
	    return [list $choix_dabord $choix_dapres]
	} else  {
	    set choix_dabord "none"
	    set choix_dapres "none"
	    return [list $choix_dabord $choix_dapres]
	}
    }
    #
    # procedure CROIX - fin
    
    
    
    # Proc MONO - fin
    #
    proc mono {vector lm} {
	
	global p cote_rect
	
	set monoblocs ""
	
	set gch [lindex $cote_rect($lm) 0]
	set dt  [lindex $cote_rect($lm) 0]
	set ht  [lindex $cote_rect($lm) 1]
	set bas  [lindex $cote_rect($lm) 1]
	set col_max [expr {$gch+$dt}]
	set lig_max [expr {$bas+$ht}]
	
	
	# Classement des lignes - debut - PROCEDURE classement
	#
	set choix [classement $vector $lig_max]
	#
	set lignes_mono_lig [lindex $choix 0]
	set local_mono_lig [lindex $choix 1]
	
	lappend monoblocs $local_mono_lig
	
	#debug
	#$p insert end "\nlocal_mono_lig\t$local_mono_lig"
	# Classement des lignes - fin
	
	
	# Transposition - debut
	#
	# Je transpose 'vector($i)' dans une nouvelle 'vector_table' pour utiliser sur les colonnes les memes procedures de classement
	set colonnes_compte 0
	set compteur 0
	foreach line [split $vector "\n"] {
	    if {$compteur < 1} {
		foreach item $line {incr colonnes_compte}
	    }
	    incr compteur
	}
	set lignes_compte 0
	foreach line [split $vector "\n"] {
	    if {[llength $line] == $colonnes_compte} {incr lignes_compte}
	}
	set lignes 0
	set colonnes 0
	foreach line [split $vector "\n"] {
	    if {$line != ""} {set colonnes 0}
	    foreach item $line {
		set table($lignes,$colonnes) $item
		incr colonnes
	    }
	    if {$line != ""} {incr lignes} else {incr lignes -1}
	}
	
	for {set k 0} {$k < $colonnes_compte} {incr k} {
	    for {set j 0} {$j < $lignes_compte} {incr j} {
		append vector_table_transp "$table($j,$k) "
	    }
	    append vector_table_transp "\n"
	}
	#
	# Fin de la transposition
	
	# (on est toujours dans le SCRIPT PRINCIPAL de la superprocedure MICROGRAAL)
	#
	# Classement des colonnes - debut - PROCEDURE classement
	#
	#
	set choix [classement $vector_table_transp $col_max]
	#
	set lignes_mono_col [lindex $choix 0]
	set local_mono_col [lindex $choix 1]
	
	lappend monoblocs $local_mono_col
	
	#debug
	#$p insert end "\nlocal_mono_col\t$local_mono_col"
	# Classement des colonnes - fin
	
	return $monoblocs
	
    }
    #
    # Proc MONO - fin
    
    
    
    
    
    
    
    
    # Proc CLASSEMENT - debut
    #
    proc classement  {vector_table max} {
	
	global p
	
	# Connaitre la definition des lignes en termes de blocs
	set pro_doc [un_zero $vector_table]
	#debug
	#$p insert end "\n\n==============="
	#$p insert end "\npro DOC == $pro_doc"
	
	set doc ""
	set fit ""
	foreach element $pro_doc {
	    lappend doc [lindex $element 0];# ligne - nbbloc - elbloc - tot
	    lappend fit [lindex $element 1];# ligne - localisation du bloc
	    #debug
	    #$p insert end "\n$element\t<- $doc \t<-> $fit"
	}
	# Statistiques sur ces blocs et leur contenu
	set doc_ordre_nbbloc [lsort -real -index 1 $doc]
	set doc_ordre_nbelem [lsort -real -decreasing -index end $doc]
	#debug
	#$p insert end "\nLignes ordonnees par nbre de blocs\n$doc_ordre_nbbloc"
	#$p insert end "\n"
	#$p insert end "\nLignes ordonnees par nbre TOTAL d'elem (ordre decroissant) \n$doc_ordre_nbelem"
	#$p insert end "\n==============="
	
	set lignes_mono ""
	foreach item $doc_ordre_nbbloc {
	    if {[lindex $item 1] == 1} {
		lappend lignes_mono $item
	    }
	}
	set lignes_mono [lsort -real -decreasing -index 2 $lignes_mono]
	#debug
	#$p insert end "\nLignes mono bloc ordonnees par nombre decroissant d'elements / bloc\n$lignes_mono"
	
	set local_mono ""
	foreach item $lignes_mono {
	    foreach truc $fit {
		if {[lindex $truc 0] == [lindex $item 0]} {
		    lappend local_mono $truc
		}
	    }
	}
	
	return [list $lignes_mono $local_mono]
    }
    #
    # Procedure CLASSEMENT - fin
    
    
    
    # Procedure CRUCE -debut
    #
    #
    #
    proc cruce {vector seuil lm} {
	
	global p candidats
	
	# Utilisation du seuil pour separer le bruit du signal - PROCEDURE to_z_o
	set vector_aprestozo [to_z_o $vector $seuil]
	# Un peu de couture - PROCEDURE couture
	set vector_cousu [couture $vector_aprestozo $lm]
	
	# METHODE VERTE
	# Les lignes et colonnes qui ne contiennent qu'un seul bloc sont identifiees, et classees par importance du bloc
	#
	set monoblocs [mono $vector_cousu $lm]
	#
	set local_mono_lig [lindex $monoblocs 0]
	set local_mono_col [lindex $monoblocs 1]
	# Croisements de monoblocs, en deux questions complementaires
	#     - le plus grand monobloc en ligne croise avec quel plus grand monobloc en colonne ?
	#     - le plus grand monobloc en colonne croise avec quel plus grand monobloc en ligne ?
	
	# On commence l'examen lignes d'abord - appel a la procedure CROIX
	set croisement [croix $local_mono_lig $local_mono_col $lm]
	#$p insert end "\nCROISEMENT en commencant la lecture par les lignes $croisement"
	set prem_choix_lig [lindex $croisement 0]
	set prem_choix_col [lindex $croisement 1]
	# Les colonnes ensuite
	set croisement [croix $local_mono_col $local_mono_lig $lm]
	#$p insert end "\nCROISEMENT en commencant la lecture par les colonnes $croisement"
	set deux_choix_lig [lindex $croisement 1]
	set deux_choix_col [lindex $croisement 0]
	#
	set choix_plusieurs [list $prem_choix_lig $prem_choix_col $deux_choix_lig $deux_choix_col]
	
	return $choix_plusieurs
    }
    #
    #
    #
    # Procedure CRUCE - fin
    
    
    # Procedure CONFIG_RECTAILLE - debut
    #
    proc config_rectaille {} {
	
	set typeList {
	    {{"Text files"} {.seq .txt .nts .TXT .NTS .csv .CSV .tps .TPS} }
	}
	global infile_rectaille dossier_rectaille texte references
	
	# Chercher la route dans un fichier de configuration
	# 1. verifier que le fichier de configuration existe
	set route "[pwd]/dossier_rectaille.txt"
	#puts "route $route"
	# 2. s'il n'existe pas, voir ci-dessus
	if {[file exists $route] == 0} {
	    set candidat_dossier_rectaille [pwd]
	} else  {
	    #puts "La conf existe"
	    # 3. s'il existe reccueillir la derniere route parcourue
	    # open le fichier pour lire
	    catch [
		   set fid [open $route r]
		   set candidat_dossier_rectaille [read -nonewline $fid]
		   close $fid
		  ] ici
	    #puts "candidat_dossier $candidat_dossier"
	    set candidat_dossier_rectaille [lindex [split $candidat_dossier_rectaille \n] 1]
	    # debug
	    #puts "dossier_rectaille = $candidat_dossier_rectaille"
	}
	
	# On va chercher les donnees
	#catch [
	set infile_rectaille [tk_getOpenFile -initialdir $candidat_dossier_rectaille -filetypes $typeList]
	set fid [open $infile_rectaille]
	set texte [read -nonewline $fid]
	close $fid
	#] ici
	
	#infile contient la route et le nom du fichier des donnees
	set dossier_rectaille "[file dirname $infile_rectaille]/";#repertoire des donnees
	# 4 si ce n'est pas la route indiquee par candidat_dossier_rectaille, il faut reecrire le fichier de configuration
	if {$dossier_rectaille != $candidat_dossier_rectaille} {
	    # open le fichier de conf pour ecrire
	    catch [
		   set fid [open $route w+]
		   puts -nonewline $fid "Dernier dossier de donnees utilisees par RECTAILLE:\n"
		   puts -nonewline $fid $dossier_rectaille
		   close $fid
		  ] ici
	}
	#debug
	#puts "route = $dirinfile"
	set tailfile [file tail $infile_rectaille];#fichier nu, avec l'extension
	#debug
	#puts "\ntail = $tailfile"
	set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
	#debug
	#puts "root = $rootfile"
	
	return $texte
    }
    #
    # procedure CONFIG_RECTAILLE - fin
    
    
    
    
    # SCRIPT SOURCE PRINCIPAL de la superprocedure MICROGRAAL
    #
    global wi he;# largeur et hauteur de la grande image
    global ho ha;# 'ho' et 'ha' le chgt de coord si la gde image est bougee ?
    global landmark
    global plaquex plaquey;# contiennent listes des tags (points colores) correspondant aux LM
    global nocontrast
    global rgb_max
    global candidats;# contient la liste des seuils possibles
    global cote_rect
    # ATTENTION
    global tucol tulig
    global defect
    
    
    # Debut probable de la procedure infeodee a la taille d'un rectangle
    #
    # du genre sampling {taillerect} {}
    #
    # 
    
    # Les valeurs des pixels r=g=b sont non modifiees (0 a 255)
    if {[info exists rgb_max] < 1} {set rgb_max 1}
    
    set nocontrast 0;# to record and count uncontrasted images
    
    # On efface ce qui a deja ete ecrit sur la grande image
    #$p insert end "\nPLAQUEX \n$plaquex \nPLAQUEY \n$plaquey"
    foreach tagitem $plaquex {
	.can delete $tagitem
    }
    foreach tagitem $plaquey {
	.can delete $tagitem
    }
    
    #set coord_predites $coord_obs
    #$p insert end "\n**** coord_predites ****\n$coord_predites"
    
    foreach item $coord_obs {
	append coord_predites "[expr {int($item)}] "
    }
    #$p insert end "\n**** coord_obs ****\n$coord_obs\n**** coord_predites ****\n$coord_predites\n"
    
    # Nombre total de LM
    set lm_nb [expr {[llength $coord_predites] * 1/2}]
    
    # les valeurs predites (ou observees si micrograal au lieu de mini) sont placees dans des variables indicees: lmixe et lmigr
    set compteur 0
    for {set i 1} {$i < [expr {$lm_nb + 1}]} {incr i} {
	set a [lindex $coord_predites $compteur]
	set b [lindex $coord_predites [expr {$compteur+1}]]
	set lmixe($i) $a
	set lmigr($i) $b
	# Dessin du landmark sur la grande image - n'est pas necessaire a l'usage final
	#set ixe $a
	#set igr $b
	#.can create oval [expr {$ixe-3}] [expr {$igr-3}] [expr {$ixe+3}] [expr {$igr+3}] -fill red
	# Dessin du landmark sur la grande image -fin
	incr compteur 2
    }
    
    # (on est toujours dans le SCRIPT PRINCIPAL de la superprocedure)
    
    # les valeurs gch = dt et bas = ht faisaient appel aux minima et maxima
    #
    
    #
    set xmax $lmixe($lm_nb)
    set k [expr {$lm_nb - 1}]
    set xmin $lmixe($k)
    for {set i [expr {$lm_nb - 2}]} {$i > 0} {incr i -1} {
	set j [expr {$i - 1}]
	if {$lmixe($i) > $xmax} {set xmax $lmixe($i)}
	if {$lmixe($i) < $xmin} {set xmin $lmixe($i)}
    }
    #
    set ymax $lmigr($lm_nb)
    set k [expr {$lm_nb - 1}]
    set ymin $lmigr($k)
    for {set i [expr {$lm_nb - 2}]} {$i > 0} {incr i -1} {
	set j [expr {$i - 1}]
	if {$lmigr($i) > $ymax} {set ymax $lmigr($i)}
	if {$lmigr($i) < $ymin} {set ymin $lmigr($i)}
    }
    #
    set range_x [expr {int($xmax - $xmin)}]
    set range_y [expr {int($ymax - $ymin)}]
    set range_rapport [expr {$range_x * 1.0 / $range_y}]
    #
    # (on est toujours dans le SCRIPT PRINCIPAL de la superprocedure)
    #
    
    # Appel a la PROCEDURE config_rectaille qui gere la taille des rectanges a decouper (image sampling))
    # Cette procedure doit faire elle-meme l'objet d'une procedure de choix
    # set rect [config_rectaille]
    if {[info exists rect]} {
	set compteur 0
	foreach item $rect {
	    incr compteur
	    set larg($compteur) [expr {int(abs([lindex $item 1]-  [lindex $item 3])/2)}]
	    set haut($compteur) [expr {int(abs([lindex $item 2]-  [lindex $item 4])/2)}]
	}
	for {set i 1} {$i < [expr {$lm_nb+1}]} {incr i} {
	    set cote_rect($i) "$larg($i) $haut($i)"
	}
    } else  {
	for {set i 1} {$i < [expr {$lm_nb+1}]} {incr i} {
	    set cote_rect($i) "48 48"
	}
    }
    
    #$p insert end "\n$cote_rect(1)\n"
    set cote [lindex $cote_rect(1) 0]
    
    # On se prepare
    set coord_aal ""
    
    #
    # ------------------------------
    #
    # D'un LM a l'autre -- start --- (on est toujours dans le SCRIPT PRINCIPAL de la superprocedure MINIGRAAL)
    #
    # ------------------------------
    #
    # ...
    #
    for {set i 1} {$i < [expr {$lm_nb + 1}]} {incr i 1} {
	
	set landmark $i
	
	# Les valeurs approximatives du LM sont rentrees dans x et y
	set x $lmixe($i)
	set y $lmigr($i)
	
	# On DECOUPE un rectangle autour du landmark approximatif - PROCEDURE decoupage
	#
	# 17 dec 2006: ce rectangle pourrait etre DIFFERENT pour chaque LM, DESSINE par l'UTILISATEUR !! cfr procedure USERECT config_rectaille
	#
	set dec($i) [decoupage 1 $x $y $cote_rect($i)]
	
	# TRANSFORMATION EN GRIS de chaque rectangle - PROCEDURE bin2gray
	#
	set res [bin2gray $dec($i) 1]
	$dec($i) copy $res
	
	# Recuperation de la valeur unique R=G=B dans vector - PROCEDURE oncalcvec
	set wi [image width $dec($i)]
	set he [image height $dec($i)]
	set vector($i) [oncalcvec $dec($i) $wi $he]
	
	#
	# ================ Vers le classement ================
	#
	# (on est toujours dans le SCRIPT PRINCIPAL de la superprocedure MICROGRAAL)
	
	# Recherche du seuil, ou treshold - PROCEDURE treshold, qui, prudente, renvoie une liste de seuils ... !
	#$p insert end "\n\n----------\nLM $i - - - \n$vector($i)\n"
	set seuil($i) [treshold $vector($i) $i]
	#$p insert end "\n------------\nLM $i :\n\
	    \nseuil selon l'algoritme 1 (min + (max-min)/2))  = [lindex $seuil($i) 0]\
	\nseuil selon l'algoritme 2 (premiere valeur max) = [lindex $seuil($i) 1]\
	\ncandidats = $candidats"
            
            # Depart du classement base sur la premiere proposition de seuils
            set vector_bckup $vector($i)
            
            
            # METHODE BLEUE
            set methode_bleue [bluepoint $vector_bckup $item $i]
            #$p insert end "\nMETHODE BLEUE lig = $tulig et col = $tucol"
            
            # CE QUI SUIT DEVRAIT ETRE UNE PROCEDURE --- --- --- --- DEBUT
            #
            #
            set choix_plusieurs [cruce $vector($i) $seuil($i) $i]
            #$p insert end "\nAPRES C R U C E, on a:\ncandidats = $candidats"
            set prem_choix_lig($i) [lindex $choix_plusieurs 0]
            set prem_choix_col($i) [lindex $choix_plusieurs 1]
            set deux_choix_lig($i) [lindex $choix_plusieurs 2]
            set deux_choix_col($i) [lindex $choix_plusieurs 3]
            
            #$p insert end "\nprem_choix_lig [lindex $choix_plusieurs 0]\
	\nprem_choix_col [lindex $choix_plusieurs 1]\
	\ndeux_choix_lig [lindex $choix_plusieurs 2]\
	\ndeux_choix_col [lindex $choix_plusieurs 3]\n"
            
            # ATTENTION
            set taill 3
            
            set gch [lindex $cote_rect($i) 0]
            set dt  [lindex $cote_rect($i) 0]
            set ht  [lindex $cote_rect($i) 1]
            set bas  [lindex $cote_rect($i) 1]
            set col_max [expr {$gch+$dt}]
            set lig_max [expr {$bas+$ht}]
            # ATTENTION
            
            # couleur et taille du futur LM calcule
            set color "green"
            set taill "3"
            
            #debug - debut
            if {$prem_choix_lig($i) == "none" || $prem_choix_col($i) == "none" || $deux_choix_lig($i) == "none" || $deux_choix_col($i) == "none"} {
                #$p insert end "\nLM $i : echec de la methode verte au premier choix PROBLEME en commencant par les LIGNES"
                unset prem_choix_lig($i)
                unset prem_choix_col($i)
                unset deux_choix_lig($i)
                unset deux_choix_col($i)
            }
            #debug - fin
            
            if {[info exists prem_choix_lig($i)] < 1 || [info exists deux_choix_lig($i)] < 1 \
                        || $prem_choix_lig($i)!= $deux_choix_lig($i) || $prem_choix_col($i) != $deux_choix_col($i)} {
                
                # chgt de seuil jusqu'a extinction des possibilites, en cas d'echec passer a la methode bleue
                set boulier 0
                foreach item $candidats {
                    
                    if {$boulier > 0} {
                        
                        
                        #$p insert end "\nEssai avec un NOUVEAU SEUIL = $item\n"
                        
                        set choix_plusieurs [cruce $vector_bckup $item $i]
                        
                        set prem_choix_lig($i) [lindex $choix_plusieurs 0]
                        set prem_choix_col($i) [lindex $choix_plusieurs 1]
                        set deux_choix_lig($i) [lindex $choix_plusieurs 2]
                        set deux_choix_col($i) [lindex $choix_plusieurs 3]
                        
                        #$p insert end "\nAPRES C R U C E, seuil = $item, on a:\ncandidats = $candidats"
                        #$p insert end "\
	\nprem_choix_lig $prem_choix_lig($i) \
	\nprem_choix_col $prem_choix_col($i) \
	\ndeux_choix_lig $deux_choix_lig($i) \
	\ndeux_choix_col $deux_choix_col($i) \n"
                        
                        if {$prem_choix_lig($i) == "none" || $prem_choix_col($i) == "none" || $deux_choix_lig($i) == "none" || $deux_choix_col($i) == "none"} {
                            #$p insert end "\nLM $i : Methode verte, PROBLEME : pas de croisement trouve"
                            unset prem_choix_lig($i)
                            unset prem_choix_col($i)
                            unset deux_choix_lig($i)
                            unset deux_choix_col($i)
                        } else  {
                            # Les deux choix doivent etre identiques
                            #debug
                            #$p insert end "\n$prem_choix_lig($i) = $deux_choix_lig($i)  E T  $prem_choix_col($i) = $deux_choix_col($i) ??\n"
                            if {$prem_choix_lig($i) == $deux_choix_lig($i) && $prem_choix_col($i) == $deux_choix_col($i)} {
                                break
                            } else  {
                                #$p insert end "\nLM $i : Methode verte, PROBLEME : 2 solutions differentes"
                                unset prem_choix_lig($i)
                                unset prem_choix_col($i)
                                unset deux_choix_lig($i)
                                unset deux_choix_col($i)
                            }
                        }
                    }
                    incr boulier
                }
                
            }
            
            if {[info exists prem_choix_lig($i)] < 1 || [info exists deux_choix_lig($i)] < 1} {
                
                # !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                # en cas d'echec de la methode verte, passer a la methode bleue
                
                if {[info exists tulig] < 1 || [info exists tucol] < 1} {
                    set prem_choix_lig($i) $gch
                    set prem_choix_col($i) $ht
                    set deux_choix_lig($i) $gch
                    set deux_choix_col($i) $ht
                    set color "orange"
                    ##debug
                    #$p insert end "\npremier choix x LM$i = choix de l'utilisateur - JAUNE"
                } else {
                    # #debug
                    #$p insert end "\nchoix x LM$i = choix de la METHODE BLEUE ($tulig)"
                    #$p insert end "\nchoix y LM$i = choix de la METHODE BLEUE ($tucol)"
                    set prem_choix_lig($i) $tulig
                    set prem_choix_col($i) $tucol
                    set deux_choix_lig($i) $tulig
                    set deux_choix_col($i) $tucol
                    set choix_l_3($i) $tulig
                    set choix_c_3($i) $tucol
                    set color "sky blue"
                }
                # !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                
            } else  {
                #debug
                #$p insert end "\nMETHODE VERTE premier choix  lig LM$i = $prem_choix_lig($i)"
                #$p insert end "\nMETHODE VERTE premier choix  col LM$i = $prem_choix_col($i)"
                #$p insert end "\nMETHODE VERTE deuxieme choix -x- LM$i = $deux_choix_lig($i)"
                #$p insert end "\nMETHODE VERTE deuxieme choix -y- LM$i = $deux_choix_col($i)"
            }
            
            # (on est toujours dans le SCRIPT PRINCIPAL de la superprocedure MICROGRAAL)
            # si aucun croisement n'est trouve par la methode 'green' - passer a la methode 'blue' - fin

        # On pass a un autre nom de variable
        set choix_lig($i) $prem_choix_lig($i)
        set choix_col($i) $prem_choix_col($i)
        
        # debug
        #$p insert end "\n\n---- L'heure des GRANDS choix: x = $choix_lig($i)\t et y = $choix_col($i)"
        # debug
        #$p insert end "\n---- L'heure du troisieme oeil (methode bleue): x = $tulig\t et y = $tucol"
        
        
        # Derniere precaution !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        #Si la distance est trop gde avec le choix de l'utilisateur,
        #1. colorer le point et
        #2. si possible, prendre une moyenne entre choix green et blue
        set ixe [expr {$lmixe($i) - ($lmixe($i) - $gch + $choix_col($i) + 1)}]
        set igr [expr {$lmigr($i) - ($lmigr($i) - $ht + $choix_lig($i))}]
        set distanciation($i) [expr {hypot($ixe,$igr)}]
        if {$distanciation($i) > 6.3} {
            set avis "?"
        } else  {
            set avis ""
        }
        
        # ================ Vers le classement ================ FIN
        #
        
        # (on est toujours dans le SCRIPT PRINCIPAL de la superprocedure MICROGRAAL)
        #
        # PRESENTATION de l'IMAGE
        #destroy .top($i)
        #toplevel .top($i)
        #set horz 850
        #set vert [expr {$i*90}]
        #wm geometry .top($i) 250x65+$horz+$vert
        
        # scrolling canvas
        #destroy .top($i).can .top($i).v_scroll .top($i).h_scroll
        #canvas .top($i).can -width $wi -height $he \
                -yscrollcommand ".top($i).v_scroll set" \
                -xscrollcommand ".top($i).h_scroll set"
        
        #scrollbar .top($i).v_scroll -command ".top($i).can yview"
        #scrollbar .top($i).h_scroll -command ".top($i).can xview" -orient horizontal
        #.top($i).can create image 0 0 -image $dec($i) -anchor nw
        #
        # A present l'astuce pour configurer automatiquement le deroulement du canvas
        #.top($i).can configure -scrollregion [.top($i).can bbox all]
        #
        #pack .top($i).v_scroll -side right -fill y
        #pack .top($i).h_scroll -side bottom -fill x
        #pack .top($i).can -side left -expand 1
        
        # Dessin du landmark sur la petite image
        #.top($i).can create oval [expr {$choix_col($i)-2}] [expr {$choix_lig($i)-2}] [expr {$choix_col($i)+2}] [expr {$choix_lig($i)+2}] -fill $color
        #if {[info exists tulig]} {
        #    .top($i).can create oval [expr {$tucol-2}] [expr {$tulig-2}] [expr {$tucol+2}] [expr {$tulig+2}] -fill blue
        #}
        # (on est toujours dans le SCRIPT PRINCIPAL de la superprocedure MICROGRAAL)
        
        # Nouveau
        set tagger "lm_"
        set xaal $tagger$i
        set yaal $tagger$i
        
        # Dessin du landmark sur la grande image
        set ixe [expr {$lmixe($i) - $gch + $choix_col($i) + 1}]
        set igr [expr {$lmigr($i) - $ht + $choix_lig($i)}]
        .can create oval [expr {$ixe - $taill}] [expr {$igr - $taill}] [expr {$ixe + $taill}] [expr {$igr + $taill}] -fill $color;# -tag $xaal
        .can create text [expr {$ixe-3}] [expr {$igr-8}] -fill $color -text "$i $avis";# -tag $yaal
        
        #set ixe_3 [expr {$lmixe($i) - $gch + $choix_c_3($i) + 1}]
        #set igr_3 [expr {$lmigr($i) - $ht + $choix_l_3($i)}]
        #.can create oval [expr {$ixe_3 - $taill}] [expr {$igr_3 - $taill}] [expr {$ixe_3 + $taill}] [expr {$igr_3 + $taill}] -fill $col_3
        
        # Pour l'enregistrement des coordonnees produites par micrograal
        append coord_aal "$ixe\t$igr\n"
        
        #bind  .top($i).can <Button-1> {
        #    set onvoit [$dec($i) get %x %y]
        #    set x %x
        #    set y %y
        #    .t.bd insert end "\nLM $i \t $x $y \t$choix_lig($i) $choix_col($i)"
        #}
        
        #tkwait window .top($i)
        
        ## --------------------------------------------------------------------
        ## CHAQUE LM PRESENTE SUR LE MEME CANVAS - PROBL DE SCROLL - START
        ## --------------------------------------------------------------------
        ##
        ## scrolling canvas
        #destroy .can .v_scroll .h_scroll
        #
        #canvas .can($i) -width $wi -height $he \
        #        -yscrollcommand ".v_scroll set" \
        #        -xscrollcommand ".h_scroll set"
        #
        ##scrollbar .v_scroll -command ".can($i) yview"
        #scrollbar .h_scroll -command ".can($i) xview" -orient horizontal
        #
        ## Fill in canvas, ON PEINT L'IMAGE SUR LE CANVAS
        ##
        #.can($i) create image 0 0 -image $dec($i) -anchor nw
        ##
        ## A present l'astuce pour configurer automatiquement le deroulement du canvas
        #.can($i) configure -scrollregion [.can($i) bbox all]
        ##
        #pack .v_scroll -side right -fill y
        #pack .h_scroll -side bottom -fill x
        #pack .can($i) -side left -expand 1
        ## --------------------------------------------------------------------
        ## CHAQUE LM PRESENTE SUR LE MEME CANVAS - PROBL DE SCROLL - END
        ## --------------------------------------------------------------------
        
        #balloonhelp_for .can "$ffile"
    }
    # # ------------------------------
    #
    # D'un LM a l'autre -- end ---
    #
    # # ------------------------------
    
    # (on est toujours dans le SCRIPT PRINCIPAL de la superprocedure MICROGRAAL)
    #
    # AAL prend le risque ou se retire
    #
    
    #$p insert end "\n\n------------------------------------------"
    #$p insert end "\n-   P  E  R  F  O  R  M  A  N  C  E  S   -"
    #$p insert end "\n------------------------------------------"
    set somme 0
    for {set i 1} {$i <  [expr {$lm_nb + 1}]} {incr i} {
        set somme [expr {$somme + $distanciation($i)}]
        #$p insert end "\nLM $i: $distanciation($i)"
    }
    set acceptabilite [expr {$somme / $i}]
    if {$acceptabilite > 7} {
        tk_messageBox -message "Please make manual corrections" -icon warning -type ok
    }
    if {$nocontrast >  [expr {$lm_nb / 4}]} {
        tk_messageBox -message "The image lacks of contrast and should not be retained" -icon warning -type ok
    }
    set defect $acceptabilite
    #$p insert end "\n------------------------------------------"
    #$p insert end "\nDefect level\t$acceptabilite"
    #$p insert end "\nContrast    \t[expr {1 - ($nocontrast * 1.0/$lm_nb)}]"
    #$p insert end "\n------------------------------------------"
    
    # PREFERENCES
    
    # rgb_max OPTION RETIREE, CAR 255 >>>>>> 25.5 !!
    #destroy .question
    #toplevel .question
    #wm geometry .question 180x50+300+300
    ##wm title .question "group sizes"
    #entry .question.groupe -bg "light yellow" -relief sunken -textvariable subdivision
    #    pack .question.groupe
    #button .question.cancel -text CANCEL -command {destroy .question .avis}
    #button .question.ok -bg green -text OK -command {
    #    set rgb_max $subdivision
    #    $p insert end "valeur maximum du pixel r=g=b $rgb_max"
    #    set coord_aal [micrograal $coord_obs]
    #}
    #pack .question.cancel .question.ok -side left
    
    # COTE_RECT OPTION A L'ETUDE
    # de 8 a 12-13 pas de chgt
    # 6 est meilleur, mais n'est-ce pas trop pres du choix de l'utilisateur ?
    # Baisse a partir de 14, et 15 nettement moins bon ... !
    #destroy .question
    #toplevel .question
    #wm geometry .question 280x50+300+300
    #wm title .question "Image sampling"
    #entry .question.groupe -bg "light yellow" -relief sunken -textvariable subdivision
    #pack .question.groupe
    #button .question.cancel -text CANCEL -command {destroy .question}
    #button .question.ok -bg green -text OK -command {
    #    set cote_rect $subdivision
    #    $p insert end "\nPREFERENCES : cote_rect = $cote_rect\N"
    #    set coord_aal [micrograal $coord_obs]
    #}
    #pack .question.cancel .question.ok -side left
    
    return $coord_aal

}
