package require Tk
################################################################################
# Select
# Copyright ©  2003 Dujardin J.-P. dujardin@mpl.ird.fr
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
################################################################################


cd [file dirname [info script]]
#tk_messageBox -message "pwd = [pwd]" -type ok
global S
set S(dirscript) [pwd];#attention, il n'y a pas de "/" a la fin du nom du dossier du script (utiliser "file join etc")

set dirName [pwd]



# procedure DEBUG - debut
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x480+205+44
        set memo [text .debug.t -wrap none -height 22 -font "courier 13" \
                -bg grey88 \
                -fg black\
                -tabs "3c left"\
                -yscrollcommand ".debug.v_scroll set" \
                -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
            if {$flag == 1} {
                .debug.t configure -wrap word
                set flag 0
            } else  {
                .debug.t configure -wrap none
                set flag 1
            }
        }
        #
        $memo insert end $bugatti
        $memo see end
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG - fin


# Procedure LOADDIR - debut
#
proc loadDir {w} {
    # "w" contient : ".foto"
    global dirName
    # dirName contient le dossier choisi dans la Procedure SELECTANDLOADDIR
    $w.f.list delete 0 end
    if { [catch {
            foreach i [lsort [glob -directory $dirName *]] {
                if {[string first ".tiff" $i] > 0 || [string first ".TIFF" $i] > 0} {
                    if {[string first ".tiff" $i] > 0} {
                        set j [file rootname $i].tif
                        debug "file rename $i $j"
                        [file rename $i $j]
                        $w.f.list insert end [file tail $j]
                    }
                    if {[string first ".TIFF" $i] > 0} {
                        set j [file rootname $i].TIF
                        debug "file rename $i $j"
                        [file rename $i $j]
                        $w.f.list insert end [file tail $j]
                    }
                } else  {
                    $w.f.list insert end [file tail $i]
                }
            }
        } here] }  {tk_messageBox -message "Nothing here" -type ok; return}
}
#
# Procedure LOADDIR - fin

# Procedure RUN - debut
#
proc Run {} {
    global dirName log w a force
    $log insert end "\n\
            -----------------------\n\
            Conversion de fichiers:\n\
            -----------------------\n\n\
            Le message suivant n'indique pas (vraiment) une erreur :\n\
            \"can't read output from command: standard output was redirected\"\n\n"
    set a [$w.f.list get 0 end]
    $log insert end "Files to convert:\n$a\n"
    set compteur 0
    if {$a == ""} {
        tk_messageBox -message "Did you select a directory containing images ?" -type ok
    }
    foreach i $a {
        update
        incr compteur
        $log insert end "\n$compteur:\t$i : "
        global tcl_platform
        switch $tcl_platform(platform) {
            "unix" {
                set instruction {exec convert $dirName/$i $dirName/TOeps/[file rootname $i].eps}
            }
            "windows" {
                set instruction {exec cmd.exe /c convert $dirName/$i $dirName/TOEPS/[file rootname $i].eps}
            }
        }
        
        catch {[eval $instruction] here}
        $log see end
        $log insert end ".../TOEPS/[file rootname $i].eps"
    }
    if {$compteur > 0} {
        $log insert end "\n\nThe End"
        $log see end
    }
}
#
# Procedure RUN - end

# Procedure SELECTANDLOADDIR - start
#
proc selectAndLoadDir {w} {
    global dirName log
    set dir [tk_chooseDirectory -initialdir $dirName -parent $w -mustexist 1]
    if {[string length $dir] != 0} {
        set dirName $dir
        loadDir $w;# Appel a la procedure LOADDIR (charge la liste des images)
    }
    $log insert end "If the content of \n$dirName \nis not what you look for, please hit the SELECT DIRECTORY button again\
            \notherwise, hit GO!\n\nIf you hit GO!, image files will be converted to .eps format\
            unless there is already a TOEPS folder..."
    $log see end
}
#
# Procedure SELECTANDLOADDIR - end


#
# SCRIPT PRINCIPAL ---------------------------------------------------------------------------
#


set w .foto
catch {destroy $w}
toplevel $w
wm title $w "The converted image has .eps extension"
wm iconname $w "PHOTO"
# positionWindow $w

label $w.msg -font "helvetica 14" -wraplength 12i -justify left \
        -text "New files are put in a local TOEPS folder of the selected directory ..."
pack $w.msg -side top

frame $w.buttons
pack $w.buttons -side bottom -fill x -pady 2m

#global force

button $w.buttons.dismiss -text {exit} -command {exit}
#label $w.buttons.percent -text "% ?"
#entry $w.buttons.force -textvariable force
button $w.buttons.run -text "go!" -command {
    set verification [glob -nocomplain $dirName/*]
    if {[string first "." $verification] > 0} {
        if {[string first "TOEPS" $verification] < 0} {
            set nouvdoss [file mkdir $dirName/TOEPS]
            eval $nouvdoss
        } else  {
            tk_messageBox -message "There is already a TOEPS directory in \n$dirName\n" -type ok
            return
        }
    }
    Run
}

#pack $w.buttons.dismiss $w.buttons.force $w.buttons.percent  $w.buttons.run -side left -expand 1
pack $w.buttons.dismiss  $w.buttons.run -side left -expand 1

frame $w.mid
pack $w.mid -fill both -expand 1

labelframe $w.dir -text "Current directory:"
# set dirName [file join $tk_library demos images]
set dirName [pwd];#"/home/jepi/Test/"

entry $w.dir.e -width 30 -textvariable dirName

button $w.dir.b -pady 0 -padx 2m -text "Select Directory" -command {selectAndLoadDir $w}

pack $w.dir.e -side left -fill both -padx 2m     -pady 2m -expand true
pack $w.dir.b -side left -fill y    -padx {0 2m} -pady 2m

labelframe $w.f -text "File:" -padx 2m -pady 2m

listbox $w.f.list -width 65 -height 10 -yscrollcommand "$w.f.scroll set"
scrollbar $w.f.scroll -command "$w.f.list yview"
pack $w.f.list $w.f.scroll -side left -fill y -expand 1
#$w.f.list insert 0 earth.gif earthris.gif teapot.ppm


# text widget to log the output
frame $w.t
pack $w.t -padx 2m -pady 2m
set log [text $w.t.t -wrap word  -width 5 -height 10 -font "courier 13" -bg white -fg black\
        -tabs "3c left"\
        -yscrollcommand "$w.t.v_scroll set"\
        -xscrollcommand "$w.t.h_scroll set"]
scrollbar $w.t.v_scroll -command "$w.t.t yview"
scrollbar $w.t.h_scroll -command "$w.t.t xview" -orient horizontal
pack $w.t.v_scroll -side right -fill y
pack $w.t.h_scroll -side bottom -fill x
pack $w.t.t -side left -fill both -expand 1
pack $w.t -fill both -expand 1


grid $w.dir -        -sticky ew -padx 1m -pady 1m -in $w.mid
grid $w.f    -sticky nw -padx 1m -pady 1m -in $w.mid
grid columnconfigure $w.mid 1 -weight 1

$log insert end "The script needs the IMAGEMAGICK software to run\n--\n"

#puts "en cas de bind sur la liste ... a devient \n$a ?"
#bind $w.f.list <Button-1> Run; #{$log insert end "a=\n$a"};#"Run"




