lappend auto_path [file join [file dirname [info script]]]
global S

proc infomanco {} {
    
    toplevel .im
    wm geometry .im 600x550+200+100
    
    frame .im.frht -bd 4 -relief raised
    pack .im.frht -fill x
    frame .im.frmd
    frame .im.frbs
    pack .im.frmd .im.frbs -side top
    
    # Frames gauche, milieu et droite (boutons : nb de perm) sur celle du haut
    frame .im.frht.g
    frame .im.frht.m
    frame .im.frht.d
    pack .im.frht.g .im.frht.m .im.frht.d -side left -padx 15 -pady 10
    
    # Choix du nombre des permutations sur la droite de la frame du haut (on peut jouer avec voltaire etc.)
    label .im.frht.g.nbperm -width 25 -text "Permute : how many runs ?"
    label .im.frht.g.400 -width 25 -text "------------------------------------"
    button .im.frht.g.1000 -width 23 -image [image create photo -file "exit.gif"] -command {
        set S(perm) "on sort"
        destroy .im
        exit
    }
    pack .im.frht.g.nbperm .im.frht.g.400 .im.frht.g.1000 -side top -anchor e
    
    # Choix du nombre des permutations sur la droite de la frame du haut
    button .im.frht.m.100 -width 20 -text " 100" -command {
        global S
        set S(perm) 100
        destroy .im
    }
    button .im.frht.m.400 -width 20 -text " 400" -command {
        global S
        set S(perm) 400
        destroy .im
    }
    button .im.frht.m.1000 -width 20 -text "1000" -command {
        global S
        set S(perm) 1000
        destroy .im
    }
    pack .im.frht.m.100 .im.frht.m.400 .im.frht.m.1000 -side top -anchor e
    
    # Choix du nombre des permutations sur la droite de la frame du haut
    button .im.frht.d.400 -width 20 -text "2000" -command {
        global S
        set S(perm) 2000
        destroy .im
    }
    button .im.frht.d.1000 -width 20 -text "5000" -command {
        global S
        set S(perm) 5000
        destroy .im
    }
    button .im.frht.d.5000 -width 20 -text "10000" -command {
        global S
        set S(perm) 10000
        destroy .im
    }
    pack .im.frht.d.400 .im.frht.d.1000 .im.frht.d.5000 -side top -anchor e
    
    # Choix des langues sur la frame du bas
    
    button .im.frbs.sp -image [image create photo -file flag_sp.gif]  -command {madrid}
    button .im.frbs.fr -image [image create photo -file flag_fr.gif] -command {paris}
    button .im.frbs.en -image [image create photo -file flag_uk.gif] -command {newyork}
    pack .im.frbs.fr .im.frbs.sp .im.frbs.en -side left -padx 25
    
    proc newyork {} {
        
        .im.frht.g.nbperm configure -text "Permute : number of runs ?"
        
        # Texte choisi sur la frame du milieu
        destroy .im.frmd.texte  .im.frmd.scrollA
        
        set scb [scrollbar .im.frmd.scrollA -command ".im.frmd.texte yview"]
        pack $scb -side left -fill y
        text .im.frmd.texte -width 80 -height 30 -wrap word  -yscrollcommand ".im.frmd.scrollA set"
        pack .im.frmd.texte
        
        .im.frmd.texte insert end "\n\nPERMUTATIONS will estimate statistical significance of:\
                \n  - Euclidian distances \
                \n  - Linear regression of PW with CS\
                \nThis starts immediately after file input.
        \nA set of independent variables combining size and groups\
                will be arranged according to \n(1) the model of a common allometric slope and to \
                \n(2) the model of different slopes among groups.\
                \nThe sums of squares of residuals will be saved in ..._Ematrix_diff.txt and ..._Ematrix_common.txt.\
                \nThey will be used to compute the Wilks multivariate test of significance.\
                \n(TPSregr could be used also (see 'external software') using then as input \
                \n..._diffSlopes_TPRregr.nts and ..._commonSlope_TPRregr.nts generated by COV (see TPSregr help) )\
                \n\nObserved and predicted relative warps (RW) will be computed with graphical output\
                \n(embedded button 'PCA on PW', see mid of report).\
                \n\nEuclidian distances among groups will be computed based on Partial warps.\
                \n(see 'External Software' to construct corresponding tree).\
                "
    }
    
    
    proc paris {} {
        
        
        
        .im.frht.g.nbperm configure -text "Permuter : combien de fois ?"
        
        # Texte choisi sur la frame du milieu
        destroy .im.frmd.texte  .im.frmd.scrollA
        
        set scb [scrollbar .im.frmd.scrollA -command ".im.frmd.texte yview"]
        pack $scb -side left -fill y
        text .im.frmd.texte -width 80 -height 30 -wrap word  -yscrollcommand ".im.frmd.scrollA set"
        pack .im.frmd.texte
        
        
        set haha {
            Les permutations estiment la signification statistique :
            - des distances euclidiennes entre groupes, basées sur les  'Partial Warps'\
                    (ou les Relative Warps, le résultat est identique)
            - de la régression multivariée des PW sur le 'Centroid Size'
            Ces permutations démarrent dès l'entrée des données.
            
            Les données sont en principe le fichier ..._PW_CS.txt tel qu'il est produit par MOG.
            Il contient en première ligne un commentaire de format libre, les données quant à elles\
                    sont listées à partir de la deuxième ligne. En première colonne de ces données se\
                    trouve la taille centroide, les autres colonnes sont les 'PW'.
            
            Outre le rapport, le programme génère ou peut générer les 9 fichiers suivant:
            
            ..._Ematrix_diff.txt, et ..._Ematrix_common.txt
            qui contiennent les 'sums of squares and cross products' des résidus après prédiction des PW\
                    (en fonction de la taille) selon le modele d'un axe allométrique commun aux groupes\
                    (fichier _Ematrix_common.txt) ou selon celui d'allométries différentes entre groupes\
                    (fichier _Ematrix_common.txt).
            
            ..._EUCLphylip_RelW.txt e et ..._EUCLphylip_comm.txt
            qui contiennent les distances euclidiennes entre consensus (moyennes des groupes) soit sur les\
                    valeurs observées de 'PW' (ou 'RW', le résultat est le même), soit sur les valeurs\
                    prédites en fonction de la taille de chaque individu dans un modèle de relation\
                    allométrique significative, commune à tous les groupes.
            
            
            Les valeurs prédites par la taille dans un modèle allométrique commun se trouvent dans le\
                    fichier ..._predictedRW_commonSlope.txt
            
            
            ..._diffSlopes_design.txt et ..._commonSlope_design.txt
            ..._diffSlopes_TPSregr.nts et ..._commonSlope_TPSregr.nts
            Il s'agit des matrices qui codent les variables indépendantes, avec une première colonne\
                    de 1 ('intercept') et la (ou les) dernière(s) colonne(s) de variable de taille\
                    ('covariate'). Ces matrices sont proposées aussi sous format .nts, telles qu'elles\
                    devraient être utilisées par TPSregr.
        }
        
    }
    
    proc madrid {} {
        
        
        .im.frht.g.nbperm configure -text "Permutar : cuantas veces ?"
        
        # Texte choisi sur la frame du milieu
        destroy .im.frmd.texte  .im.frmd.scrollA
        
        set scb [scrollbar .im.frmd.scrollA -command ".im.frmd.texte yview"]
        pack $scb -side left -fill y
        text .im.frmd.texte -width 80 -height 30 -wrap word  -yscrollcommand ".im.frmd.scrollA set"
        pack .im.frmd.texte
        
        .im.frmd.texte insert end {
            
            Las permutaciones estiman el significado estadístico de:
            - las distancias euclidianas entre grupos, basadas sobre 'Partial Warps'\
                    (o Relative Warps, lo cual da resultados idénticos)
            - de la regresión multivariada de los PW sobre el 'Centroid Size'
            Estas permutaciones arrancan desde la entrada completa de los datos.
            
            Los datos son típicamente los del archivo ..._PW_CS.txt tal como producido por MOG.
            Contienen en primera linea un comentario de formato libre, con los datos empezando a \
                    la linea siguiente. La primera columna de los datos es la de los tamaños centroides \
                    (CS), las otras columnas son los PW.
            
            
            El programa genera o puede generar los 9 archivos siguientes:
            
            ..._Ematrix_diff.txt, et ..._Ematrix_common.txt
            Estos archivos contienen los 'sums of squares and cross products' de los residuos obtenidos\
                    después de hacer la predicción de los PW (el programa trabaja en realidad sobre los\
                    RW) en base al tamaño de cada individuo, respetando un modelo alometrico común\
                    (archivo _Ematrix_common.txt) o en base al modelo de alometrias diferentes por grupo\
                    (archivo _Ematrix_common.txt).
            
            ..._EUCLphylip_comm.txt et ..._EUCLphylip_RelW.txt
            Estos  archivos contienen las distancias euclidianas entre grupos (en realidad el consenso\
                    de cada grupo) en base a los 'PW' observados (o 'RW') o en base a los valores\
                    predichos en función un tamaño fijo para todos los individuos dentro de la hipótesis\
                    de un modelo alometrico común.
            
            Los valores predichos en función un tamaño fijo para todos los individuos dentro de la\
                    hipotesis de un modelo alometrico común se encuentran en el archivo\
                    ..._predictedRW_commonSlope.txt
            
            ..._diffSlopes_design.txt et ..._commonSlope_design.txt
            ..._diffSlopes_TPSregr.nts et ..._commonSlope_TPSregr.nts
            Son las matrices que codifican las variables independientes (los 'grupos', generalmente\
                    localidades), con el intercepto en la primera columna y el tamaño (la 'covariate')\
                    en la(s) ultima(s).
            
            Estas matrices están propuestas también en el formato .nts, tales como las necesitan el\
                    programa TPSregr de J. Rohlf.
        }
    }
    
    newyork
    vwait S(perm)
}

infomanco
if {[info exists S(perm)]} {puts "Nb de permutations : $S(perm)";exit}