# ballons.tcl est une procedure tiree d'un livre sur TclTk dont j'indiquerai 
# les references des que je remettrai la main dessus (sur le livre).
# Sous license GPL bien sur

option add *Balloonhelp*background yellow widgetDefault
option add *Balloonhelp*foreground black widgetDefault
option add *Balloonhelp.info.wraplength 3i widgetDefault
option add *Balloonhelp.info.justify left widgetDefault
option add *Balloonhelp.info.font \
        -*-courrier-medium-r-normal-sans-* widgetDefault

toplevel .balloonhelp -class Balloonhelp -background black \
        -borderwidth 1 -relief flat
label .balloonhelp.info
pack .balloonhelp.info -side left -fill y

wm overrideredirect .balloonhelp 1
wm withdraw .balloonhelp

proc balloonhelp_for {win mesg} {
    global bhInfo
    set bhInfo($win) $mesg
    bind $win <Enter> {balloonhelp_pending %W}
    bind $win <Leave> {balloonhelp_cancel}
}

proc balloonhelp_pending  {win} {
    global bhInfo
    balloonhelp_cancel
    set bhInfo(pending) [after 500 [list balloonhelp_show $win]]
}


proc balloonhelp_cancel  {} {
    global bhInfo
    if {[info exists bhInfo(pending)]} {
        after cancel $bhInfo(pending)
        unset bhInfo(pending)
    }
    wm withdraw .balloonhelp
}


proc balloonhelp_show {win} {
    global bhInfo
    catch {
        if {$bhInfo(active)} {
            .balloonhelp.info configure -text $bhInfo($win)
            set x [expr [winfo rootx $win] - 25]
            set y [expr [winfo rooty $win] + [winfo height $win]]
            wm geometry .balloonhelp +$x+$y
            wm deiconify .balloonhelp
            raise .balloonhelp
        }
    } ici
    unset bhInfo(pending)
}

proc balloonhelp_control {state} {
    global bhInfo
    if {$state} {
        set bhInfo(active) 1
    } else  {
        balloonhelp_cancel
        set bhInfo(active) 0
    }
}


set bhInfo(active) 1