
proc lacets {a bootstrap} {
    # Standard error of MD
    for {set j 0} {$j < $bootstrap} {incr j} {
        update
        .bmat.suivi configure -fg red -text "$j / $bootstrap"
        set rana [ranmat $a]
        set ranamd [mdispar $rana]
        lappend ranamdlist $ranamd
    }
    set ramdordre [lsort -real $ranamdlist]
    return $ramdordre
}

destroy .bmat
toplevel .bmat
wm geometry .bmat +250+250
entry .bmat.nb -text "Number of bootstraps ?" -textvariable bootentry
button .bmat.pop -text n
button .bmat.ok -text OK -command {
    update
    global p
    set bootstrap $bootentry
    set S(md_list) ""
    destroy .bmat.nb .bmat.ok .bmat.cancel .bmat.comp
    pack .bmat.pop .bmat.suivi -side left
    
    for {set i 1} {$i < [llength $subdivision]} {incr i} {
        
        
        # Appel a la procedure de bootstrap
        set ramdordre [lacets $hume_subm_pw($i) $bootstrap]
        
        set percentile5   [expr {int(0.05 * $bootstrap)}]
        set percentile95  [expr {int(0.95 * $bootstrap)}]
        set lefttail [lindex $ramdordre $percentile5]
        set righttail [lindex $ramdordre $percentile95]
        
        set ranasum 0
        for {set k 0} {$k < $bootstrap} {incr k} {
            set ranasum [expr {$ranasum + [lindex $ramdordre $k]}]
        }
        
        if {$bootstrap > 0} {
            
            destroy .bmat
            rouge "\nSUBMATRIX  $i"
            $p insert end "\nMean of randomized values:  [expr {$ranasum *1.0/$bootstrap}]\
                    \t(min [lindex $ramdordre 0], max [lindex $ramdordre end])"
            $p insert end "\nMD: left tail \t\t$lefttail"
            $p insert end "\nMD: right tail \t\t$righttail"
            set se [expr {($righttail - $lefttail)/2}]
            $p insert end "\nMD: standard error\t $se\n"
            lappend S(md_list) "Submatrix $i $subm_pw_md($i) $se [mrows $hume_subm_pw($i)]"
        }
        #vert "\n$S(md_list)"
    }
}

button .bmat.cancel -text CANCEL  -command {
    set bootstrap 0
    destroy .bmat.nb 
}


pack .bmat.nb
focus .bmat.nb
pack .bmat.ok .bmat.cancel -side left

    vert "\n ............ STATISTICAL COMPARISONS ....................................\n"
    for {set i 0} {$i < [expr {$S(md_num)-1}]} {incr i} {
        for {set j [expr {$i+1}]} {$j < $S(md_num)} {incr j} {
            vert "\n\n[lindex [lindex $S(md_list) $i] 0] \
                    and [lindex [lindex $S(md_list) $j] 0]\n\
                    ([lindex [lindex $S(md_list) $i] 1] \
                    and [lindex [lindex $S(md_list) $j] 1])\n"
            
            set md1 [lindex [lindex $S(md_list) $i] 2]
            set md2 [lindex [lindex $S(md_list) $j] 2]
            set se1 [lindex [lindex $S(md_list) $i] 3]
            set se2 [lindex [lindex $S(md_list) $j] 3]
            set n1 [lindex [lindex $S(md_list) $i] 4]
            set n2 [lindex [lindex $S(md_list) $j] 4]
            
            set se12 [expr {pow($se1,2)}]
            set se22 [expr {pow($se1,2)}]
            set n1Mun [expr {$n1 - 1}]
            set n2Mun [expr {$n2 - 1}]
            set gauche_num [expr {(($n1Mun * $n1 * $se12) + ($n2Mun * $n2 * $se22))}]
            set gauche_den [expr {$n1 + $n2 - 2}]
            set gauche [expr {$gauche_num * 1.0 / $gauche_den}]
            set droite [expr {($n1 + $n2) * 1.0 / ($n1 * $n2)}]
            set num_t [expr {abs($md1 - $md2)}]
            set den_t [expr {sqrt($gauche * $droite)}]
            set t [expr {$num_t * 1.0 / $den_t}]
            rouge "t = $t \twith $gauche_den degress of freedom\n\n"
            
        }
    }
    vert "\n ............ STATISTICAL COMPARISONS ....................................\n"
