
load /opt/ActiveTcl-8.4/lib/Mk4tcl/Mk4tcl.so

#Create a datafile: "mk::file open tag filename"
mk::file open db datafile.mk

#Create a view (this is the Metakit term for "table"):
set vw [mk::view layout db.people {first last shoesize:I}]
#To specify a view for a certain type of data, first identify all the properties that you would want to store
# for objects of that type. Make sure to break things up into as small pieces as make sense for your application,
#rather than combining several items into a single property.

#Add two rows (this is the Metakit term for "record"):
mk::row append $vw first "John" last "Lennon" shoesize 44
mk::row append $vw first "Flash" last "Gordon" shoesize 42

#Commit the changes to file:
mk::file commit db
#As you make changes, you should periodically call "mk::file commit tag" to flush your changes to disk.

#Show a list of all people:
mk::loop c $vw {puts [mk::get $c first last shoesize]}

#Show a list of all people, sorted by last name:
foreach r [mk::select $vw -sort last] {puts [mk::get $vw!$r]}

#Show a list of all people with first name 'John':
foreach r [mk::select $vw first "John"] {puts [mk::get $vw!$r]}

#Close datafile: 'mk::file close tag'
mk::file close db