source 100La.tcl
source math/statistics.tcl;#n'est pas necessaire actuellement

# Procedure COPrI -- debut
#
proc copri {x} {
    # Cette procedure obtient les composantes principales
    # et pourrait s'appeler silent_pca
    set pop $x
    set colonnes [mcols $pop]
    set lignes [mrows $pop]
    set cellules [expr {$lignes * $colonnes}]
    #CREER n-1 POUR CALCULER (plus tard) LES VARIANCES (eigenvalues)
    set obsminusone [expr {$lignes - 1}]
    # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
    mnorms_br pop popmeans popsigmas
    # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
    # IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
    set popones "2 1 $colonnes 1"
    set x 1
    set y $colonnes
    while {$x < $y} {lappend popones 1; set x [expr {$x + 1} ] }
    # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
    #Les donnees sont ensuite 'centrees' (chaque colonne par sa moyenne)\
    #cfr. Hume |'normalizing each column by substracting its corresponding mean'|\n"
    set Z [mnormalize $pop $popmeans $popones]
    set ZZ [mmult [transpose $Z] $Z]
    # The varcov matrix, or matrix of mean square VCM = (Zt)(Z)/(n-1) :
    # Il s'agit d'une multiplication de la matrice des donnees centrees par sa transposee,
    # chaque element de la matrice resultante ([mrows $ZZ] x [mcols $ZZ]) est divise ensuite
    # par le nombre d'individus moins un.
    set nless1 [expr {1./$obsminusone}]
    set vcm [mscale $ZZ $nless1]
    # Continuing the naive example use V = VARCOV for the eigensolution
    # SINGULAR VALUE DECOMPOSITION SUR LA MATRICE varcov (vcm)
    #
    set V $vcm
    mevsvd_br V evals
    # evals contient les eigenvalues
    # V contient les eigenvectors (coefficients)
    #
    # COMPOSANTES PRINCIPALES (cp)
    # ---------------------------------------------
    global cp
    set cp [mmult $pop $V ]
    #
    # CENTRER LES COMPOSANTES PRINCIPALES ...
    mnorms_br cp cpmeans cpsigma
    set copri [mnormalize $cp $cpmeans $popones]
    # Scores individuels = individus
    global individus
    set individus ""
    for {set u 0} {$u < $lignes} {incr u} {
        lappend individus [mrange $copri 0 end $u $u]
    }
    return $copri
}
#
# Procedure COPRI - end



# Procedure WHICHMATRIX - start
#
proc whichmatrix {} {
    global p infile dossier
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [chemin];# usage de la procedure CHEMIN : memoire des dossiers anterieurs
    set x [loadfile $infile]; # usage de la procedure LOADFILE
    entrada $x $infile;# usage de la procedure ENTRADA: presentation de la matrice loadee
    $p insert end "\nMatrix X:\t----------------------------------start---\n"
    #$p insert end [show $x %8.3f]
    if {[mrows $x] < 30} {
        $p insert end "\n\n[show $x %8.3f]"
    } else  {
        $p insert end "\n\n[show [mrange $x 0 end 0 29] %8.3f] \n...\netc. etc.\n"
    }
    $p insert end "\nMatrix X:\t----------------------------------end----\n\n"
    return $x
}
#
# Procedure WHICHMATRIX - end


# Procedure XDESIGN -- start
proc xdesign {covariate subdivision} {
    
    # Cette procedure va construire la X matrix selon deux hypotheses,
    #
    # l'axe commun -> common_slope, LSM_common_slope
    # ou
    # l'hypothese d'allometries differentes -> diff_slopes, LSM_diff_slopes
    #
    # Les matrices correspondantes seront stockees dans des variables globales de type : S()
    #
    # La procedure d'appel (mod) les placera dans g_design et P_design
    #
    #
    global p infile
    global S
    
    set nbgr [llength $subdivision]
    set dg [expr {$nbgr-1}]
    for {set i 0} {$i < $dg} {incr i} {
        append lsm_e "\t0\t"
        append lsm_e_dl "-1\t"
    }
    #debug
    #rouge "\nPetit (pre)design (pour [llength $subdivision] groupes)\n"
    for {set i 0} {$i < $nbgr} {incr i} {
        #for {set j 0} {$j < $dg} {incr j} {
        if {$i < $dg} {
            set lsme_l($i) [lreplace $lsm_e $i $i 1]
            #debug
            #rouge $lsme_l($i)
        } else  {
            set lsme_l($i) $lsm_e_dl
            #debug
            #rouge $lsme_l($i)
        }
        #}
    }
    # intercept is 1
    #debug
    #rouge "\nPetit design (pour [llength $subdivision] groupes) avec INTERCEPT = 1\n"
    for {set i 0} {$i < $nbgr} {incr i} {
        set lsme_l($i) [concat "1\t" $lsme_l($i)]
        #debug
        #rouge $lsme_l($i)
    }
    
    ######################
    update
    .question.ok configure -text "Design matrix: diferent slopes"
    
    # grande design matrix - common slope
    #debug
    #bleu "\nGroupes grand design (pour les groupes d'effectifs $subdivision)"
    set compteur 0
    foreach item $subdivision {
        #debug
        #bleu "Groupe [expr {$compteur + 1}]: [lindex $subdivision $compteur]"
        for {set i 0} {$i < $item} {incr i} {
            append pre_g_design "$lsme_l($compteur)\n"
        }
        incr compteur
    }
    #debug
    #bleu "predesign \n $pre_g_design"
    
    # size is disons 'cs', on le prend de PW_CS.txt set cs [mrange $pw_cs 0]
    # on l'attache (concat) sur la grande design matrice
    rouge "\nX design - common slope, or slopes constrained to be the same in each group\n"
    
    set compteur 0
    foreach item [split $pre_g_design "\n"] {
        set cs [lindex $covariate [expr {3+$compteur}]]
        set futurelem [concat $item " $cs"]
        if {$item != ""} {append g_design "$futurelem "}
        incr compteur
        # Pour garder cette colonne des tailles dans une liste, puis une matrice
        append cs_liste "$cs "
    }
    set lignes [mrows $covariate]
    #debug
    #$p insert end "\nHEYHEYHEY $cs_liste"
    set cs_matrix "2 [expr {$compteur-1}] 1 $cs_liste"
    #debug
    #$p insert end "\nHEYHEYHEY \n[show $cs_matrix]"
    
    set g_design [concat "2 $lignes [expr {$nbgr+1}] " $g_design]
    set S(common_slope) $g_design
    $p insert end "\n[show $g_design]\n"
    
    
    # Construction de la LSM_common_slope matrix
    #
    # On attache la moyenne totale des tailles sur la petite design matrice - common slope design
    # size total mean is disons mean_cs
    set mean_cs [lindex [mnorms $covariate] 3]
    rouge "\n\nLS means, common slope design\n"
    for {set i 0} {$i < $nbgr} {incr i} {
        set lsme_l($i) [concat $lsme_l($i) " $mean_cs"]
        append  p_design "$lsme_l($i) "
    }
    set p_design [concat "2 $nbgr [expr {$nbgr+1}] " $p_design]
    $p insert end "\n[show $p_design]\n"
    #
    set S(LSM_common_slope) $p_design
    # --------------------------------- fin de la COMMON_SLOPE design matrix, grande et petite
    
    ######################
    update
    .question.ok configure -text "Design matrix: diferent slopes"
    
    # --------------------------------------- DEBUT de la diff_slopes design, grande et petite
    #
    # Pour preparer la diff_slopes design matrix
    #
    # On enleve la derniere colonne, qui contient les tailles
    set pre_1_diff_slopes [mrange $g_design 0 [expr {[mcols $g_design]-2}] 0 end]
    #debug
    #$p insert end "\nHEYHEYHEY pre_1\n[show $pre_1_diff_slopes]"
    #
    # On enleve la premiere colonne, qui oblige a un common intercept (on la replacera tout de suite)
    set pre_2_diff_slopes [mrange $pre_1_diff_slopes 1 end]
    # On cree une matrice a usage local identique a pre_1_diff_slopes
    set pre_3_diff_slopes $pre_1_diff_slopes
    #debug
    #$p insert end "\nHEYHEYHEY pre_2\n[show $pre_2_diff_slopes]"
    set colonnes [mcols $pre_2_diff_slopes]
    for {set i 0} {$i < $colonnes} {incr i} {
        set pour_diff_slopes [mprod $cs_matrix [mrange $pre_2_diff_slopes $i $i]]
        set pre_3_diff_slopes [join_cols $pre_3_diff_slopes $pour_diff_slopes]
        #debug
        #$p insert end "\ni = $i\nyehyehyeh\n[show [mrange $pre_2_diff_slopes $i $i]]\nHEYHEYHEY \n[show $pre_3_diff_slopes]"
    }
    #debug
    #$p insert end "\nHEYHEYHEY \n[show $pre_3_diff_slopes]"
    # On s'occupe a present de la partie basse de la matrice initiale, avec des -1
    # ...
    # 1. On va l'enlever de pre_3_diff_slopes -> submatplus + submatmoins
    # 2. On va rajouter une colonne de zero : submatplus -> matplus
    # 3. On va reconstruire la partie submatmoins separement -> submatmoins -> matmoins
    # 4. On va ensuite tout recoller -> join-rows matplus matmoins
    
    # 1. pre_3_diff_slopes -> submatplus + submatmoins
    #debug
    #$p insert end "\npartie basse [lindex $subdivision end]\n"
    set echtot 0
    foreach item $subdivision {set echtot [expr {$echtot + $item}]}
    #debug
    #$p insert end "\nEchantillon total $echtot - \
    On cree une sous-matrice avec les  [expr {$echtot - [lindex $subdivision end]}] premieres lignes\
            et une autre avec les [lindex $subdivision end] dernieres lignes\n"
    set separation [expr {$echtot - [lindex $subdivision end]}]
    set separationmoinsun [expr {$echtot - [lindex $subdivision end]-1}]
    set submatplus [mrange $pre_3_diff_slopes 0 end 0 $separationmoinsun]
    #debug
    #$p insert end "\n Partie superieure, positive \n[show $submatplus]"
    # 2. On va rajouter une colonne de zero : submatplus -> matplus
    for {set i 0} {$i < $separation} {incr i} {append subzeroplus " 0"}
    set matdef "2 $separation 1"
    set subzeroplus $matdef$subzeroplus
    #debug
    #$p insert end "\n On va rajouter une colonne de zeros, que voici:\n[show $subzeroplus]"
    set matplus [join_cols $submatplus $subzeroplus]
    #debug
    #$p insert end "\n Partie superieure, positive COMPLETE\n[show $matplus]"
    # 3. On va reconstruire de meme la partie submatmoins : submatmoins -> matmoins
    set submatmoins [mrange $pre_3_diff_slopes 0 end $separation end]
    #debug
    #$p insert end "\n Partie inferieure, negative \n[show $submatmoins]"
    # 3.1 une matrice de zero :
    for {set i 0} {$i < [expr {$nbgr-1}]} {incr i} {append zeromoins " 0"}
    #debug
    #$p insert end "\nzeromoins\t$zeromoins"
    for {set i 0} {$i < [lindex $subdivision end]} {incr i} {append subzeromoins $zeromoins}
    set matdef "2 [lindex $subdivision end] [expr {$nbgr-1}]"
    set subzeromoins $matdef$subzeromoins
    #debug
    #$p insert end "\nsubzeromoins\n$subzeromoins"
    #$p insert end "\nsubzeromoins\n[show $subzeromoins]"
    # 3.2 une matrice submatmoins sans les tailles negatives
    set submatmoins [mrange $submatmoins 0 [expr {$nbgr-1}]]
    set pre_matmoins [join_cols $submatmoins $subzeromoins]
    #debug
    #$p insert end "\npre_matmoins\n[show $pre_matmoins]"
    # 3.2 une matrice submatmoins avec les tailles en derniere colonne
    set tailles_derncol_derngr [mrange $covariate end end $separation end]
    #$p insert end $covariate
    #debug
    #$p insert end "\ntailles_derncol_derngrp\n[show $tailles_derncol_derngr]"
    set matmoins [join_cols $pre_matmoins $tailles_derncol_derngr]
    #debug
    #$p insert end "\nmatmoins\n[show $matmoins]"
    # 4. On va ensuite tout recoller -> join-rows matplus matmoins
    set diff_slopes [join_rows $matplus $matmoins]
    rouge "\nX design - Different slopes design matrix\n"
    $p insert end "\n[show $diff_slopes]"
    #
    set S(diff_slopes) $diff_slopes
    #
    # A present, construire la LSM_diff_slopes matrix (petite design matrix)
    # Soit la moyenne de chaque groupe mais une seule valeur de taille (moyenne totale
    #
    set compteur 0
    set coche($compteur) 0
    foreach item $subdivision {
        incr compteur
        set coche($compteur) [expr {$coche([expr {$compteur-1}]) + $item}]
    }
    rouge "\n\nLS means, different slopes design\n"
    for {set i 0} {$i < $nbgr} {incr i} {
        set liste "\n[show [mrange $diff_slopes 0 end $coche($i) $coche($i)]]"
        # remplacer la valeur de taille par la taille moyenne
        set liste_mean_cs [lassign $liste [expr {$nbgr+$i}] $mean_cs]
        append  p_design_diff_slopes "$liste_mean_cs "
    }
    # formater (et montrer) la matrice
    set p_design_diff_slopes "2 $nbgr [mcols $diff_slopes] $p_design_diff_slopes"
    $p insert end "\n[show $p_design_diff_slopes]"
    #
    set S(LSM_diff_slopes) $p_design_diff_slopes
    #
    # --------------------------------------- FIN de la diff_slopes design
    
    
    
    
    
    # Enregistrement de la common_slope design matrix
    set sub "_commonSlope_design"
    set end ".txt"
    set ajout $sub$end
    set infilesub "[file root $infile]$ajout"
    # Enregistrement de la sous-matrice
    set fid [open $infilesub w]
    puts -nonewline $fid "X design, common slope, from $infile\n"
    puts -nonewline $fid [show $S(common_slope)]
    close $fid
    
    vert "\n\nX design, common slope... saved as ... \n$infilesub"
    
    # Enregistrement de la diff_slopes design matrix
    set sub "_diffSlopes_design"
    set end ".txt"
    set ajout $sub$end
    set infilesub "[file root $infile]$ajout"
    # Enregistrement de la sous-matrice
    set fid [open $infilesub w]
    puts -nonewline $fid "X design, different slopes, from $infile\n"
    puts -nonewline $fid [show $S(diff_slopes)]
    close $fid
    
    vert "\n\nX design, different slopes, saved as ... \n$infilesub"
    
    # Enregistrement de la LS means p_design matrix, under the common slope assumption
    set sub "_LSM_commonSlope"
    set end ".txt"
    set ajout $sub$end
    set infilesub "[file root $infile]$ajout"
    # Enregistrement de la sous-matrice
    set fid [open $infilesub w]
    puts -nonewline $fid "Expected LS means, common slope design, from $infile\n"
    puts -nonewline $fid [show $S(LSM_common_slope)]
    close $fid
    
    vert "\n\nExpected LS means, common slope design ... saved as ... \n$infilesub"
    
    # Enregistrement de la LS means p_design matrix, under the different slopes assumption
    set sub "_LSM_diffSlope"
    set end ".txt"
    set ajout $sub$end
    set infilesub "[file root $infile]$ajout"
    # Enregistrement de la sous-matrice
    set fid [open $infilesub w]
    puts -nonewline $fid "Expected LS means, different slopes design, from $infile\n"
    puts -nonewline $fid [show $S(LSM_diff_slopes)]
    close $fid
    
    vert "\n\nExpected LS means, different slopes design ... saved as ... \n$infilesub"
    
    # Pour les utilisateurs de TPSregr,
    # presentation modifiee des matrices S(common-slope) et S(diff_slopes)
    #
    # S(common_slope) -> S(common_slope_tpsregr)
    # S(diff_slopes)   -> S(diff_slopes_tpsregr)
    
    # pour les deux matrices, enlever la colonne des 1
    set common_slope_tpsregr [mrange $S(common_slope) 1 end 0 end]
    set S(diff_slopes_tpsregr) [mrange $S(diff_slopes) 1 end 0 end]
    # la (diff-slopes) est presque deja prete, il faut remplacer les espaces par une tabulation
    #$p insert end "\nFacon TPS regr \n[show $S(diff_slopes_tpsregr)]"
    #
    # space -> tab from Hume matrix to tcl list ---- debut
    #rouge "\nS(diff_slopes_tpsregr)\n [show $S(diff_slopes_tpsregr)]\n\n"
    set lineas ""
    for {set lig 0} {$lig < [mrows $S(diff_slopes_tpsregr)]} {incr lig} {
        set a [show [mrange $S(diff_slopes_tpsregr) 0 end $lig $lig]]
        append lineas "\n$a"
    }
    #$p insert end $lineas
    foreach item [split $lineas "\n"] {
        foreach truc $item {
            append newlineas "$truc\t"
        }
        append newlineas "\n"
    }
    #rouge $newlineas
    #
    # space -> tab from Hume matrix to tcl list ---- fin
    #
    # Enregistrement de la diff_slopes design matrix facon TPS
    set sub "_diffSlopes_TPSregr"
    set end ".nts"
    set ajout $sub$end
    set infilesub "[file root $infile]$ajout"
    # Enregistrement de la sous-matrice, avec le code ntsys pour tps
    set rows [mrows $S(diff_slopes_tpsregr)]
    set cols [mcols $S(diff_slopes_tpsregr)]
    set code "1 $rows $cols 0 "
    set fid [open $infilesub w]
    puts -nonewline $fid "\"different slopes, TPSregr design, from $infile\n$code"
    puts -nonewline $fid $newlineas
    #puts -nonewline $fid [show $S(diff_slopes_tpsregr)]
    close $fid
    
    vert "\n\ndifferent slopes design matrix, as for use in TPSregr, saved as ... \n$infilesub\
            \n------------------------------------------------\n"
    
    # pour la (common slope), placer la taille en colonne des 1
    set col_tailles [mrange $S(common_slope) end end 0 end]
    set avtdrn [expr {[mcols $common_slope_tpsregr] - 2}]
    set pre_common_slope_tpsregr [mrange $common_slope_tpsregr 0 $avtdrn 0 end]
    set S(common_slope_tpsregr) [join_cols $col_tailles $pre_common_slope_tpsregr]
    #$p insert end "\n\n------------------------------------------------\
    #        \nFacon TPS regr \n[show $S(common_slope_tpsregr)]"
    
    #
    # space -> tab from Hume matrix to tcl list ---- debut
    #
    set lineas ""
    for {set lig 0} {$lig < [mrows $S(common_slope_tpsregr)]} {incr lig} {
        set a [show [mrange $S(common_slope_tpsregr) 0 end $lig $lig]]
        append lineas "\n$a"
    }
    #
    foreach item [split $lineas "\n"] {
        foreach truc $item {
            append nuevlineas "$truc\t"
        }
        append nuevlineas "\n"
    }
    #rouge $nuevlineas
    #
    # space -> tab from Hume matrix to tcl list ---- fin
    #
    
    
    # Enregistrement de la common_slope, TPS design matrix
    set sub "_commonSlope_TPSregr"
    set end ".nts"
    set ajout $sub$end
    set infilesub "[file root $infile]$ajout"
    # Enregistrement de la sous-matrice, avec le code ntsys pour tps
    set rows [mrows $S(common_slope_tpsregr)]
    set cols [mcols $S(common_slope_tpsregr)]
    set code "1 $rows $cols 0 "
    set fid [open $infilesub w]
    puts -nonewline $fid "\"common slope, TPS design, from $infile\n$code\n"
    puts -nonewline $fid $nuevlineas
    close $fid
    
    vert "\n\ncommon slope design matrix, as for use in TPSregr, saved as ... \n$infilesub\
            \n------------------------------------------------\n"
    
}
#
# Procedure XDESIGN ---- end

# Procedure XDESIGN_2levels -- start
proc xdesign_2levels {subdivision1 subdivision2} {
    
    # Cette procedure va construire la X matrix selon deux modeles,
    #
    # full (avec interactions) -> , LSM_f
    # ou
    # reduced  -> , LSM_r
    #
    # Les matrices correspondantes seront stockees dans des variables globales de type : S()
    #
    # La procedure d'appel (mod) les placera dans Xf et Xr
    #
    #
    global p infile
    global S
    # ------------------
    # MATRICE REDUCED XR
    # ------------------
    #
    
    # PREMIER GROUPE
    #set subdivision1 "13 5"
    set numcol1 [llength $subdivision1]
    # SECOND GROUPE
    #set subdivision2 "10 3 3 2"
    set numcol2 [llength $subdivision2]
    
    # Verification
    set sum1 0
    set sum2 0
    foreach item $subdivision1 {set sum1 [expr {$sum1 + $item}]}
    foreach item $subdivision2 {set sum2 [expr {$sum2 + $item}]}
    if {$sum1 != $sum2} {tk_messageBox -message "unbalanced data";exit}
    
    bleu "\nFirst group (level of subdivision) : $subdivision1"
    bleu "\nSecond group (level of subdivision) : $subdivision2"
    
    # -----------------------------
    # PREMIER NIVEAU DE SUBDIVISION
    #
    if {$numcol1 > 2} {
        for {set h 0} {$h < $numcol1} {incr h}  {
            set compteur 0
            foreach group $subdivision1 {
                if {$h == $compteur} {set sym " 1 "} else {set sym " 0 "}
                incr compteur
                if {$compteur == [expr {[llength $subdivision1]}]} {set sym " -1 "}
                set c($compteur) "2 1 $group"
                for {set i 0} {$i < $group} {incr i} {
                    append c($compteur) $sym
                }
                #puts "col $h: $c($compteur)"
            }
            # concatener
            for {set d 1} {$d < [llength $subdivision1]} {incr d} {
                set s [expr {$d + 1}]
                if {$d == 1} {
                    set cfinal($h) "[concat [vtrim $c($d)] [vtrim $c($s)]] "
                    #puts "\nd = $d: concat [vtrim $c($d)] ... et ... [vtrim $c($s)] --> $cfinal($h)"
                } else {
                    #puts "\nd = $d: concat  $cfinal($h)... et ... [vtrim $c($s)]"
                    set cfinal($h) "[concat $cfinal($h) [vtrim $c($s)]] "
                    #puts  "... --> $cfinal($h)"
                }
            }
            set cfinal($h) [concat "2 1 [llength $cfinal($h)]" $cfinal($h)]
        };# passage a la colonne suivante
        
        # Concatener les lignes, puis transposer
        set h 0
        set codematrix "2 $numcol1 [llength [vtrim $cfinal($h)]] "
        for {set h 0} {$h < $numcol1} {incr h}  {
            #puts "h = $h"
            append prexr "[vtrim $cfinal($h)] "
        }
        set xr [concat $codematrix $prexr]
        set xr [transpose $xr]
        $p insert end [show $xr]
        
    } elseif {$numcol1 == 2} {
        for {set h 0} {$h < [expr {$numcol1-1}]} {incr h}  {
            set compteur 0
            foreach group $subdivision1 {
                if {$h == $compteur} {set sym " 1 "} else {set sym " -1 "}
                incr compteur
                set c($compteur) "2 1 $group"
                for {set i 0} {$i < $group} {incr i} {
                    append c($compteur) $sym
                }
                #puts "col $h: $c($compteur)"
            }
            # concatener
            for {set d 1} {$d < [llength $subdivision1]} {incr d} {
                set s [expr {$d + 1}]
                if {$d == 1} {
                    set cfinal($h) "[concat [vtrim $c($d)] [vtrim $c($s)]] "
                    #puts "\nd = $d: concat [vtrim $c($d)] ... et ... [vtrim $c($s)] --> $cfinal($h)"
                } else {
                    #puts "\nd = $d: concat  $cfinal($h)... et ... [vtrim $c($s)]"
                    set cfinal($h) "[concat $cfinal($h) [vtrim $c($s)]] "
                    #puts  "... --> $cfinal($h)"
                }
            }
            set cfinal($h) [concat "2 1 [llength $cfinal($h)]" $cfinal($h)]
        }
        #puts $cfinal(0)
        set xr1 [transpose $cfinal(0)]
        #puts [show $xr1];# ceci met fin au design du premier groupe
        
    } else {
        tk_messageBox -message "More than one category expected"
    }
    
    
    # ----------------------------
    # SECOND NIVEAU DE SUBDIVISION
    #
    # A present le deuxieme niveau de design
    
    if {$numcol2 > [expr {$numcol1 * 2}]} {
        tk_messageBox -message "Only two groups are tolerated by COV at the second level of subdivision"
    }
    if {$numcol2 == 1} {
        tk_messageBox -message "More than one category expected by COV at any of the two levels"
    }
    if {$numcol2 == [expr {$numcol1 * 2}]} {
        #puts "On est ici"
        set d 0
        set part 0
        foreach group $subdivision1 {
            incr d
            set subsub [lrange $subdivision2 $part [expr {$part + 1}]]
            #puts "part $part subsub $subsub"
            set compteur 0
            foreach group2 $subsub {
                if {$compteur == 0} {set sym " 1 "} else {set sym " -1 "}
                incr compteur
                set c2($compteur) "2 1 $group2"
                for {set i 0} {$i < $group2} {incr i} {
                    append c2($compteur) $sym
                }
                #puts "col Level2 c2($compteur): $c2($compteur)"
            }
            # concatener
            set cfinal2($d) [join_cols $c2(1) $c2(2)]
            #puts "cfinal2($d) $cfinal2($d)"
            
            incr part 2
        }
        set cfinale [join_cols $cfinal2(1) $cfinal2(2)]
        #puts $cfinale
        set xr2 [transpose $cfinale]
        #puts [show $xr2];# ceci met fin au design du deuxieme groupe
    }
    
    
    
    # REDUCED MATRIX
    # --------------
    #
    # Construction of the R matrix
    set xr [join_cols $xr1 $xr2]
    
    
    # MATRICE FULL
    # ------------
    #
    # Construction of the full matrix
    set xf [join_cols $xr [mprod [mrange $xr 0 0 0 end] [mrange $xr 1 1 0 end]]]
    
    
    #set S(xf) $xf
    #set S(xr) $xr
    
    # INTERCEPT COLUMN
    # ----------------
    #
    # une simple colonne de 1
    set codehume "2 1 [mrows $xr] "
    for {set i 0} {$i < [mrows $xr]} {incr i} {
        append intercept "1 "
    }
    
    set intercept [concat $codehume $intercept]
    #puts $intercept
    set intercept [transpose $intercept]
    set xr [join_cols $intercept $xr]
    set xf [join_cols $intercept $xf]
    
    rouge "\nXr or reduced design matrix"
    $p insert end "\n[show $xr]"
    
    rouge "\nXf or full design matrix"
    $p insert end "\n[show $xf]"
    
    set S(xf) $xf
    set S(xr) $xr
}
#
# Procedure XDESIGN_2levels ---- end


# Procedure RESID_PERM - debut (permuter les lignes d'une matrice)
#
# Knuth, D. E. 1981. The Art of Computer Programming, vol. 2. Semi-numerical Algorithms,
# Addison-Wesley, Reading, Massachusetts.
# in
# Manly, B. F. J. 1994. Randomization and Monte Carlo Methods in Biology. Chapman & Hall, London, UK.
#
proc resid_perm {y_resid j} {
    
    global p infile S
    
    set colonnes [mcols $y_resid]
    #puts "\ncolonnes [mcols $y_resid] \tlignes [mrows $y_resid] ou $j"
    
    set depart ""
    set arrivee ""
    set autre [vtrim $y_resid]
    for {set i 0} {$i < [expr {$j * $colonnes}]} {incr i $colonnes} {
        lappend depart [lrange $autre $i [expr {$i + $colonnes - 1}]]
    }
    set arrivee $depart
    puts $depart
    set hume "2 $j $colonnes "
    set lignes $j
    set j [expr {$j-1}]
    
    while {$j > -1} {
        set alea [expr {$j * rand()}]
        set k [expr {int($alea)+0}]
        set arrivee [lreplace $arrivee $j $j [lindex $depart $k]]
        set arrivee [lreplace $arrivee $k $k [lindex $depart $j]]
        set depart $arrivee
        incr j -1
    }
    # Enlever les curved brackets
    set arrivee [regsub -all {\{|\}} $arrivee ""]
    set arrivee [concat $hume $arrivee]
    #debug
    #puts "\n$j: arrivee [show $arrivee]"
    return $arrivee
}
#
# Procedure RESID_PERM - fin

# Procedure PRAN
#
proc pran {y_means} {
    
    global p infile S
    
    # Petite fenetre de suivi
    destroy $p.suivi
    toplevel $p.suivi
    wm geometry $p.suivi +200+200
    button $p.suivi.l -text $S(perm) -command {}
    pack $p.suivi.l
    
    destroy $p.embed_aman
    
    rouge "\n\n==================================================================================="
    $p insert end "\nAMOUNT and DIRECTION of SHAPE CHANGE"
    # Angle et longueurs a partir des donnees observees
    rouge "\n===================================================================================\n"
    #$p insert end "\nAngle et longueurs sur (full design) predicted values from the observed data\
    \n[show $y_means %8.6f]"
    
    # Appel a la procedure 'angledean'
    # Soustraire seconde ligne de la premiere -> vecteur 1 (vect1)-> longueur1
    # Soustraire quatrieme ligne de la troisieme -> vecteur 2 (vect2) -> longueur2
    # Angle entre vect1 et vect2
    set serie [angledean $y_means]
    set vect_obs1 [lindex $serie 0]
    set vect_obs2 [lindex $serie 1]
    set angle_obs12 [lindex $serie 2]
    $p insert end "\nAmount of change in group 1 [format %1.5f $vect_obs1]"
    $p insert end "\nAmount of change in group 2 [format %1.5f $vect_obs2]"
    set vect_obs12 [expr {abs($vect_obs1 - $vect_obs2)}]
    rouge "\nChanges within groups: Difference in magnitude from one group to another:\t[format %1.5f $vect_obs12]"
    vert "\nChanges within groups: Difference in direction from one group to another"
    rouge "\t[format %1.5f $angle_obs12]\n"
    # Enregistrement des valeurs observees dans la future distribution randomisee
    append vect1 "$vect_obs1 "
    append vect2 "$vect_obs2 "
    append vect12 "$vect_obs12 "
    append angle "$angle_obs12 "
    
    # The reduced model is used to determine predicted values (y_hat_xr = xr . b_xr)
    #debug
    #$p insert end "\nPredicted values (y_hat_rw_xr) from reduced model already computed\
    \n[show $S(y_hat_rw_xr) %8.6f]"
    #$p insert end "\nResiduals (y_res_xr) from reduced model already computed\
    \n[show $S(y_res_xr) %8.6f]"
    
    # Residuals are then submitted to permutation procedure S(perm)
    for {set i 0} {$i < $S(perm)} {incr i} {
        # ...
        #debug
        #rouge "\nresidus reduced\n[show $S(y_res_xr)]"
        set perm_resid [resid_perm $S(y_res_xr) [mrows $S(y_res_xr)]]
        
        # Random data are created by adding randomized residuals to predicted values in reduced model
        set y_ran_xr [madd $S(y_hat_rw_xr) $perm_resid]
        
        # The full model is used to calculate PREDICTED values from 'random data'
        set y_ran_xr_hat_xf [glm_randata $S(xf) $y_ran_xr];# pq puisque LSM means igual aux 'observes' ?
        
        #rouge "\n\n=========== permutation $i ===============\n"
        #rouge "\nperm_resid \n[show [mrange $perm_resid 0 7 0 5]]\n...\n..."
        #vert "\nperm_resid \n[show [mrange $perm_resid 0 7 45 50]]\n...\n..."
        #rouge "\n=========== permutation $i ===============\n\n"
        
        # LSM
        set y_means [description_silent $y_ran_xr_hat_xf $S(subdivision2)]
        
        # Angle entre vect1 et vect2, et longueurs (procedure 'angledean')
        set serie [angledean $y_means]
        set vect_ran1 [lindex $serie 0]
        set vect_ran2 [lindex $serie 1]
        set vect_ran12 [expr {abs($vect_ran1 - $vect_ran2)}]
        set angle_ran [lindex $serie 2]
        #debug
        #rouge "\nvect1 $vect_ran1 et vect2 $vect_ran2"
        # Enregistrement des valeurs observees dans la distribution randomisee
        append vect1 "$vect_ran1 "
        append vect2 "$vect_ran2 "
        append vect12 "$vect_ran12 "
        append angle "$angle_ran "
        
        update
        $p.suivi.l configure -text "$i / $S(perm)"
    }
    
    
    # Fin de permutations
    destroy $p.suivi
    
    # Affichage du bilan et des significations
    vert "\n-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-"
    set P_vect12 0
    set P_angle 0
    set vect12 [lsort -real $vect12]
    set angle [lsort -real $angle]
    for {set i $S(perm)} {$i > 0} {incr i -1} {
        if {[lindex $vect12 $i] >= $vect_obs12} {incr P_vect12} else {break}
    }
    for {set i $S(perm)} {$i > 0} {incr i -1} {
        if {[lindex $angle $i]  >= $angle_obs12} {incr P_angle} else {break}
    }
    
    $p insert end "\nDifference in the amount of change"
    rouge "\n[format %1.5f $vect_obs12] \t P = [format %1.4f [expr {$P_vect12 * 1.0/$S(perm)}]]"
    $p insert end "\nAngle "
    vert "\n[format %1.5f $angle_obs12] \t P = [format %1.4f [expr {$P_angle * 1.0/$S(perm)}]]"
    rouge "\n==================================================================================\n"
}
#
# Procedure PRAN


# Procedure CHEMIN -start
#
proc chemin {} {
    
    global p dossier
    
    if {[info exists dirinfile] == 0} {
        set dirinfile [pwd]
    }
    
    # ----------------------------------------------------
    # Nom du FICHIER et son CHEMIN (path) CORRESPONDANT
    # ---------------------------------------------------
    
    
    # Chercher le chemin dans un fichier de configuration
    # 1. verifier que le fichier de configuration existe
    set chemin "[pwd]/dossier_cov.txt"
    #puts "chemin $chemin"
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
        set candidat_dossier [pwd]
    } else  {
        #puts "La conf existe"
        # 3. s'il existe reccueillir le dernier chemin parcouru
        # open le fichier pour lire
        catch [
        set fid [open $chemin r]
        set candidat_dossier [read -nonewline $fid]
        close $fid
        ] ici
        #puts "candidat_dossier $candidat_dossier"
        set candidat_dossier [lindex [split $candidat_dossier \n] 1]
        # debug
        #puts "dossier = $candidat_dossier"
    }
    
    # On va chercher les donnees
    
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
    
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
        # open le fichier de conf pour ecrire
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilisees par COV:\n"
        puts -nonewline $fid $dossier
        close $fid
        ] ici
    }
    
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    
    # --------------------------------------------------------
    # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE pop
    # --------------------------------------------------------
    return $infile
}
#
# Procedure CHEMIN - end

# Procedure d1d2 - debut
#
proc  d1d2 {dist1 dist2} {
    # calcul du coefficient de correlation entre deux tableaux de distances
    # la correlation se fait donc entre distances correspondant aux memes groupes
    
    set pairnb [expr {[mrows $dist1] * [mcols $dist1]}]
    #puts $pairnb
    
    # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
    # IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
    set popones "2 1 [mcols $dist1] 1"
    set x 1
    set y [mcols $dist1]
    while {$x < $y} {lappend popones 1; set x [expr {$x + 1} ] }
    
    # CALCULER LES MOYENNES
    # ------------------------------------
    mnorms_br dist1 dist1means dist1sigmas
    mnorms_br dist2 dist2means dist2sigmas
    
    # CENTRER LES DONNEES
    # --------------------------------
    # Centrer la premiere table
    set C1 [mnormalize $dist1 $dist1means $popones]
    # Centrer la deuxieme tables
    set C2 [mnormalize $dist2 $dist2means $popones]
    
    set sumx2 0
    set sumy2 0
    set sumxy 0
    for {set i 0} {$i < $pairnb} {incr i} {
        if {[lindex $C1 [expr $i+3]] != 0 || [lindex $C2 [expr $i+3]] !=0} {
            #puts " [lindex $C1 [expr {$i+3}]] versus [lindex $C2 [expr {$i+3}]]"
            set x [lindex $C1 [expr {$i+3}]]
            set y [lindex $C2 [expr {$i+3}]]
            set xy [expr {$x * $y}]
            set xcarre [expr {$x * $x}]
            set ycarre [expr {$y * $y}]; #puts "xy $xy et x2 $xcarre et y2 $ycarre"
            set sumx2 [expr {$sumx2 + $xcarre}]
            set sumy2 [expr {$sumy2 + $ycarre}]
            set sumxy [expr {$sumxy + $xy}]
        }
    }
    set numerateur $sumxy
    set denominateur [expr {$sumx2 * $sumy2}]
    set denominateur [expr {sqrt($denominateur)}]
    set corr [expr {$numerateur * 1.0 / $denominateur}]
    return $corr
}
#
# Procedure d1d2 - fin


# Procedure ENTRADA - start
#
proc entrada {pop infile} {
    
    global p references
    # En rouge on ecrit le commentaire du fichier de donnees
    rouge "\n\n$infile \n"
    rouge "\n$references\n"
    update
    set colonnes [mcols $pop]
    set lignes [mrows $pop]
    
    # En bleu on ecrit les premieres lignes et colonnes du fichier de donnees ...
    #bleu "\nArchivo contenido (parcialmente):"
    #$p insert end "\n[show [mrange $pop 0 [expr {$colonnes - 1} ] 0 4 ] ] \netc. \n"
    update
    #vert "\nSON LOS DATOS LOGARITMOS NATURALES ? \n"
    
    # ... et d'autres infos sur ce fichier
    bleu "\nNumero de variables =\t"
    $p insert end "$colonnes\n"
    
    bleu "\nNumero de individuos =\t"
    $p insert end "$lignes\n"
}
#
# Procedure ENTRADA - fin


# Procedure determinant det + msolve - START
#
# extracted from Hume LA library, msolve procedure
# MANQUE UN MORCEAU

proc det {A p} {
    promote_br p    ;# a vector becomes Nx1
    
    set N [lindex $A 2]
    # paste the rhs columns on the end
    join_cols_br A p
    
    return [det_msolve_br A]
}

proc det_msolve_br {A_in {tolerance 2.3e-16}} {
    upvar $A_in A
    set n [lindex $A 1]
    set NC [lindex $A 2]
    set p [expr {$NC - $n}]
    set Det 1.0
    for {set j 0} {$j <= [expr {$n - 2}]} {incr j} {
        set j_plus1 [expr {$j + 1}]
        set jj [expr {3 + $j * $NC + $j}]
        set Ajj [lindex $A $jj]
        set s [expr {abs($Ajj)}]
        set k $j
        for {set h $j_plus1} {$h < $n} {incr h} {
            set Ahj [lindex $A [expr {3+ $h * $NC + $j}]]
            set Ahj [expr {abs($Ahj)}]
            if { $Ahj > $s } {
                set s $Ahj
                set k $h
            }
        } ;# end pivot search
        if { $k != $j } { ;# row interchange
            for {set i $j} {$i < $NC} {incr i} {
                set ki [expr {3+$k*$NC + $i}]
                set ji [expr {3+$j*$NC + $i}]
                set Aki [lindex $A $ki]
                set Aji [lindex $A $ji]
                lassign_br A $ki $Aji
                lassign_br A $ji $Aki
            }
            set Det [expr {0.0-$Det}]
        }
        set Ajj [lindex $A $jj]
        set Det [expr {$Det * $Ajj}]
        if { abs($Ajj) <= $tolerance } {
            error "matrix is computationally singular at a tolerance of $tolerance"
        }
        for {set k $j_plus1} {$k < $n} {incr k} {
            set kj [expr {3+$k*$NC + $j}]
            set Akj [lindex $A $kj]
            set Akj [expr {double($Akj)/$Ajj}]
            lassign_br A $kj $Akj ;# to form multiplier mkj
            for {set i $j_plus1} {$i < $NC} {incr i} {
                set ki [expr {3+$k*$NC + $i}]
                set Aki [lindex $A $ki]
                set ji [expr {3+$j*$NC + $i}]
                set Aji [lindex $A $ji]
                lassign_br A $ki [expr {$Aki - double($Akj)*$Aji}]
            }
        } ;# k
    } ;# j
    set nn [expr {3+($n-1)*$NC+($n-1)}]  ;# n-1,n-1
    set Ann [lindex $A $nn]
    set Det [expr {$Det * $Ann}]
    if { abs($Ann) < $tolerance } {
        error "matrix is computationally singular at a tolerance of $tolerance"
    }
    # factoring completed
    #    mij stored in i>j
    #    Rij stored in i<=j < n
    #    fij stored in j= n ... n+p-1
    # Back substitution for Rx=f
    for {set i $n} {$i < $NC} {incr i} {
        set ni [expr {3+($n-1)*$NC + $i}]  ;# really n-1,i
        set Ani [lindex $A $ni]
        set Ani [expr {double($Ani)/$Ann}]
        lassign_br A $ni $Ani
        for {set j [expr {$n-2}]} {$j >= 0} {incr j -1} {
            set ji [expr {3+$j*$NC+$i}]
            set s [lindex $A $ji]
            for {set k [expr {$j+1}]} {$k < $n} {incr k} {
                set jk [expr {3+$j*$NC+$k}]
                set Ajk [lindex $A $jk]
                set ki [expr {3+$k*$NC+$i}]
                set Aki [lindex $A $ki]
                set s [expr {$s - $Ajk*$Aki}]
            }
            set jj [expr {3+$j*$NC+$j}]
            set Ajj [lindex $A $jj]
            lassign_br A $ji [expr {double($s)/$Ajj}]
        }
    }
    #return $A_in
    return $Det
}
#
# Procedure determinant det et msolve - END





# Procedure INFOMANCO - start
#
# appelee si on choisit "Mancova design" dans le menu
#
proc infomanco {} {
    
    global S
    
    toplevel .im
    #wm geometry .im 600x550+200+100
    wm geometry .im +200+100
    
    frame .im.frht -bd 4 -relief raised
    pack .im.frht -fill x
    frame .im.frmd
    frame .im.frbs
    pack .im.frmd .im.frbs -side top
    
    # Frames gauche, milieu et droite (boutons : nb de perm) sur celle du haut
    frame .im.frht.g
    frame .im.frht.m
    frame .im.frht.d
    pack .im.frht.g .im.frht.m .im.frht.d -side left -padx 15 -pady 10
    
    # Choix du nombre des permutations sur la droite de la frame du haut (on peut jouer avec voltaire etc.)
    label .im.frht.g.nbperm -text "Permute : how many runs ?"
    label .im.frht.g.400 -text "------------------------------------"
    button .im.frht.g.1000 -image [image create photo -file "exit.gif"] -command {
        set S(perm) "on sort"
        destroy .im
        exit
    }
    pack .im.frht.g.nbperm .im.frht.g.400 .im.frht.g.1000 -fill x -side top -anchor e
    
    # Choix du nombre des permutations sur la droite de la frame du haut
    button .im.frht.m.100 -bg "light yellow" -text " 1 0 0" -command {
        global S
        set S(perm) 100
        destroy .im
    }
    button .im.frht.m.400 -bg "light yellow" -text " 4 0 0" -command {
        global S
        set S(perm) 400
        destroy .im
    }
    button .im.frht.m.1000 -bg "light yellow" -text "1 0 0 0" -command {
        global S
        set S(perm) 1000
        destroy .im
    }
    pack .im.frht.m.100 .im.frht.m.400 .im.frht.m.1000 -fill x -side top -anchor e
    
    # Choix du nombre des permutations sur la droite de la frame du haut
    button .im.frht.d.400 -bg "light yellow" -text "2 0 0 0" -command {
        global S
        set S(perm) 2000
        destroy .im
    }
    button .im.frht.d.1000 -bg "light yellow" -text "5 0 0 0" -command {
        global S
        set S(perm) 5000
        destroy .im
    }
    button .im.frht.d.5000 -bg "light yellow"  -text "1 0  0 0 0" -command {
        global S
        set S(perm) 10000
        destroy .im
    }
    pack .im.frht.d.400 .im.frht.d.1000 .im.frht.d.5000 -fill x -side top -anchor e
    
    # Choix des langues sur la frame du bas
    button .im.frbs.sp -image [image create photo -file flag_sp.gif]  -command {madrid}
    button .im.frbs.fr -image [image create photo -file flag_fr.gif] -command {paris}
    button .im.frbs.en -image [image create photo -file flag_uk.gif] -command {newyork}
    pack .im.frbs.fr .im.frbs.sp .im.frbs.en -side right -padx 25
    
    # Texte choisi sur la frame du milieu
    destroy .im.frmd.texte  .im.frmd.scrollA
    
    set scb [scrollbar .im.frmd.scrollA -command ".im.frmd.texte yview"]
    pack $scb -side left -fill y
    text .im.frmd.texte -wrap word  -yscrollcommand ".im.frmd.scrollA set"
    pack .im.frmd.texte -fill x -expand yes
    
    
    proc newyork {} {
        
        .im.frht.g.nbperm configure -fg red -text "Permute : number of runs ?"
        .im.frmd.texte delete 0.0 end
        
        ################### rouge ##### Procedure ## Debut ##
        proc rouge_ici {mesg args} {
            .im.frmd.texte insert end $mesg "rouge"
        }
        .im.frmd.texte tag configure rouge -foreground red
        ################### rouge ####### PROCEDURE ## FIN ###
        
        .im.frmd.texte insert end {
            
            Permutations estimate statistical significance of:
            - Euclidian distances among groups based on  'Partial Warps' (or 'Relative Warps')
            - Multivariate regression of PW on 'Centroid Size' (total sample).
            
            These permutations start immediately after opening the data file.
            
            Data are those of the ..._PW_CS.txt file as produced by MOG (http://www.mpl.ird.fr/morphometrics).
            Its content is as follows: first row any comment, next rows the data; the first column\
                    of data is the centroid size, the remaining columns are 'PW'.
            
            The program produces (or may produce) the following 9 files
        }
        
        rouge_ici    "..._Ematrix_diff.txt, and ..._Ematrix_common.txt"
        
        .im.frmd.texte insert end {
            These two files contain the sums of squares and cross products after predicting the PW\
                    (actually here, the RW) according to size in the model of a common allometric\
                    axis (file ..._Ematrix_common.txt) or different slopes among groups\
                    (file ..._Ematrix_common.txt)
        }
        
        rouge_ici   "..._EUCLphylip_comm.txt, and ..._EUCLphylip_RelW.txt"
        
        .im.frmd.texte insert end {
            These files contain the Euclidian distances among consensus (the average shape of\
                    each group, using 'RW'), based on either the observed 'RW' (using observed\
                    'PW' is equivalent) or predicted 'RW' when size is fixed to the same value\
                    for all individuals, under the model of a common allometric slope.
        }
        
        
        rouge_ici    "..._predictedRW_commonSlope.txt"
        .im.frmd.texte insert end {
            This file contains the predicted 'RW' according to the 'common slope model'.
        }
        
        rouge_ici "..._diffSlopes_design.txt, and ..._commonSlope_design.txt"
        
        
        
        .im.frmd.texte insert end {
            A set of independent variables combining size and groups is arranged ('x-design matrix')\
                    according to (1) the model of a common allometric slope\
                    (..._commonSlope_design.txt) or to (2) the model of different slopes among groups\
                    (..._diffSlopes_design.txt).
        }
        rouge_ici "..._diffSlopes_TPSregr.nts, and ..._commonSlope_TPSregr.nts"
        
        .im.frmd.texte insert end {
            The same x-design matrices are also presented in the .nts format as used by TPSregr.
        }
    }
    
    
    proc paris {} {
        
        
        .im.frht.g.nbperm configure -fg blue -text "Permuter : combien de fois ?"
        
        # Texte choisi sur la frame du milieu
        #destroy .im.frmd.texte  .im.frmd.scrollA
        .im.frmd.texte delete 0.0 end
        
        ################### rouge ##### Procedure ## Debut ##
        proc bleu_ici {mesg args} {
            .im.frmd.texte insert end $mesg "bleu"
        }
        .im.frmd.texte tag configure bleu -foreground blue
        ################### rouge ####### PROCEDURE ## FIN ###
        
        .im.frmd.texte insert end {
            Les permutations estiment la signification statistique :
            - des distances euclidiennes entre groupes, basées sur les  'Partial Warps'\
                    (ou les Relative Warps, le résultat est identique)
            - de la régression multivariée des PW sur le 'Centroid Size'
            Ces permutations démarrent dès l'entrée des données.
            
            Les données sont en principe le fichier ..._PW_CS.txt tel qu'il est produit par MOG.
            Il contient en première ligne un commentaire de format libre, les données quant à elles\
                    sont listées à partir de la deuxième ligne. En première colonne de ces données se\
                    trouve la taille centroide, les autres colonnes sont les 'PW'.
            
            Outre le rapport, le programme génère ou peut générer les 9 fichiers suivant:
        }
        bleu_ici "..._Ematrix_diff.txt, et ..._Ematrix_common.txt"
        .im.frmd.texte insert end {
            qui contiennent les 'sums of squares and cross products' des résidus après prédiction des PW\
                    (en fonction de la taille) selon le modele d'un axe allométrique commun aux groupes\
                    (fichier _Ematrix_common.txt) ou selon celui d'allométries différentes entre groupes\
                    (fichier _Ematrix_common.txt).
        }
        bleu_ici "..._EUCLphylip_RelW.txt e et ..._EUCLphylip_comm.txt"
        .im.frmd.texte insert end {
            qui contiennent les distances euclidiennes entre consensus (moyennes des groupes) soit sur les\
                    valeurs observées de 'PW' (ou 'RW', le résultat est le même), soit sur les valeurs\
                    prédites en fonction d'une taille unique pour tous les individus selon un modèle \
                    de relation allométrique significative, commune à tous les groupes.
        }
        bleu_ici "..._predictedRW_commonSlope.txt"
        .im.frmd.texte insert end {
            Ce fichier contient les valeurs prédites par la taille dans un modèle allométrique commun.
        }
        
        bleu_ici "..._diffSlopes_design.txt et ..._commonSlope_design.txt"
        .im.frmd.texte insert end {
            Il s'agit des matrices qui codent les variables indépendantes, avec une première colonne\
                    de 1 ('intercept') et la (ou les) dernière(s) colonne(s) de variable de taille\
                    ('covariate').
        }
        bleu_ici "..._diffSlopes_TPSregr.nts et ..._commonSlope_TPSregr.nts"
        
        .im.frmd.texte insert end {
            Ces matrices sont proposées aussi sous format .nts, telles qu'elles\
                    devraient être utilisées par TPSregr.
        }
    }
    
    proc madrid {} {
        
        
        .im.frht.g.nbperm configure -fg orange -text "Permutar : cuantas veces ?"
        
        # Texte choisi sur la frame du milieu
        #destroy .im.frmd.texte  .im.frmd.scrollA
        .im.frmd.texte delete 0.0 end
        
        ################### rouge ##### Procedure ## Debut ##
        proc orange_ici {mesg args} {
            .im.frmd.texte insert end $mesg "orange"
        }
        .im.frmd.texte tag configure orange -foreground orange
        ################### rouge ####### PROCEDURE ## FIN ###
        
        .im.frmd.texte insert end {
            
            Las permutaciones estiman el significado estadístico de:
            - las distancias euclidianas entre grupos, basadas sobre 'Partial Warps'\
                    (o Relative Warps, lo cual da resultados idénticos)
            - de la regresión multivariada de los PW sobre el 'Centroid Size'
            Estas permutaciones arrancan desde la entrada completa de los datos.
            
            Los datos son típicamente los del archivo ..._PW_CS.txt tal como producido por MOG.
            Contienen en primera linea un comentario de formato libre, con los datos empezando a \
                    la linea siguiente. La primera columna de los datos es la de los tamaños centroides \
                    (CS), las otras columnas son los PW.
            
            
            El programa genera o puede generar los 9 archivos siguientes:
        }
        orange_ici "..._Ematrix_diff.txt, et ..._Ematrix_common.txt"
        .im.frmd.texte insert end {
            Estos archivos contienen los 'sums of squares and cross products' de los residuos obtenidos\
                    después de hacer la predicción de los PW (el programa trabaja en realidad sobre los\
                    RW) en base al tamaño de cada individuo, respetando un modelo alometrico común\
                    (archivo _Ematrix_common.txt) o en base al modelo de alometrias diferentes por grupo\
                    (archivo _Ematrix_common.txt).
        }
        orange_ici "..._EUCLphylip_comm.txt et ..._EUCLphylip_RelW.txt"
        .im.frmd.texte insert end {
            Estos  archivos contienen las distancias euclidianas entre grupos (en realidad el consenso\
                    de cada grupo) en base a los 'PW' observados (o 'RW') o en base a los valores\
                    predichos en función un tamaño fijo para todos los individuos dentro de la hipótesis\
                    de un modelo alometrico común.
        }
        orange_ici " ..._predictedRW_commonSlope.txt"
        
        .im.frmd.texte insert end {
            Los valores predichos en función un tamaño fijo para todos los individuos dentro de la\
                    hipotesis de un modelo alometrico común se encuentran en el archivo
        }
        
        
        orange_ici "..._diffSlopes_design.txt et ..._commonSlope_design.txt"
        
        .im.frmd.texte insert end {
            Son las matrices que codifican las variables independientes (los 'grupos', generalmente\
                    localidades), con el intercepto en la primera columna y el tamaño (la 'covariate')\
                    en la(s) ultima(s).
        }
        orange_ici "..._diffSlopes_TPSregr.nts, and ..._commonSlope_TPSregr.nts"
        .im.frmd.texte insert end {
            Estas matrices están propuestas también en el formato .nts, tales como las necesitan el\
                    programa TPSregr de J. Rohlf.
        }
    }
    
    newyork
    vwait S(perm)
}
#
# Procedure INFOMANCO - end


# PROCEDURE loadfile - DEBUT
#
proc loadfile {pathname} {
    global S
    set S(dist_nopar) 0
    set S(datadir) $pathname
    set fid [open $pathname]
    set text [read -nonewline $fid]
    close $fid
    set rowcount 0
    set colcount 0
    global references
    set compteur 0
    set lignes 0
    set data ""
    foreach line [split $text \n] {
        incr compteur
        if {$compteur >1} {
            if  {$line != ""} {
                set colcount [llength $line]
            }
        }
        if {$compteur>1} {
            foreach item [split $line] { if {$item != ""} {
                    incr lignes;lappend data $item
                }
            }
        } else {set references $line}
    }
    set rowcount [expr {$lignes / $colcount}]
    set result [concat 2 $rowcount $colcount $data]
    #debug
    #puts "Commentaire brut :\n$references"
    # -- Formater le commentaire
    # -- 1. Enlever d'eventuelles tabulations
    foreach mot $references {
        if {$mot != ""} {
            append comentario_sin_tab "$mot "
        }
    }
    set references $comentario_sin_tab
    # -- FIN du formatage de la premiere ligne
    
    # Il faudrait creer le meme fichier en .nts (pour TPSregr) - debut
    # Le fichier cree est _PW_CS.nts, ce n'est pas tres utile ...
    set datos ""
    set compteur 0
    foreach truc [split $text "\n"] {
        if {$compteur > 0} {
            if {$truc != ""} {lappend datos "$truc\n"}
        } else {
            lappend datos "\"$truc\n"
        }
        incr compteur
    }
    # Enlever les curved brackets
    set datos [regsub -all {\{|\}} $datos ""]
    
    set ntscode "1 $rowcount $colcount 0\n"
    set ntsmatrix $ntscode$datos
    # puis l'enregistrer ...
    # OPEN THE FILE
    set extension ".nts"
    set nameoffile "/[file tail [file rootname $pathname]]"
    set filename [file dirname $pathname]$nameoffile$extension
    set fileid [open $filename w]
    # FILL THE FILE
    puts -nonewline $fileid $ntsmatrix
    # CLOSE THE FILE
    close $fileid
    #
    # Il faudrait creer le meme fichier en .nts (pour TPSregr) - fin
    # Le fichier cree est _PW_CS.nts, ce n'est pas tres utile ...
    
    
    return $result
}
#
# PROCEDURE loadfile - FIN

# Procedure ANGLEDEAN - debut
#
proc angledean {ymeanf} {
    
    global p infile S
    
    # Calcule l'angle entre les vecteurs qui definissent les differences \
    # entre sous-groupes de deux groupes
    
    # ymeanf contient les moyennes des valeurs des quatres subdivisions (deux groupes A et B
    # avec chacun deux sous-groupes a1 a2 et b1 b2)
    # L'ordre des lignes de la matrice 'ymeanf' est celle de la matrice design moyenne
    # A a1, A a2, B b1 et B b2
    #
    #set ymeanf "2 4 3 0.024 -0.029 0.003 -0.058 -.005 -.008 0.020 0.049 0.004 -0.063 -0.002 -0.011"
    #$p insert end "\n[show $ymeanf]\n"
    #
    
    set saf1 [msub [mrange $ymeanf 0 end 0 0] [mrange $ymeanf 0 end 1 1]]
    #puts "saf1 vect2 - vect1 = $saf1"
    set saf2 [msub [mrange $ymeanf 0 end 2 2] [mrange $ymeanf 0 end 3 3]]
    #puts "saf2 vect4 - vect 2 = $saf2"
    
    set def1 [vtrim [mmult $saf1 [transpose $saf1]]]
    set def1 [expr {sqrt($def1)}]
    #debug
    #puts "\nlongueur du vect 1 = $def1"
    set def2 [vtrim [mmult $saf2 [transpose $saf2]]]
    set def2 [expr {sqrt($def2)}]
    #debug
    #puts "\nlongueur du vect 2 = $def2"
    
    # Calcul de l'angle
    set tsaf1 [transpose $saf1]
    set a [mscale $tsaf1 [expr {1.00/$def1}]]
    set b  [mscale $saf2 [expr {1.00/$def2}]]
    set theta [mmult $b $a]
    set theta [vtrim $theta]
    set radian [expr {acos($theta)}]
    set degre [expr {$radian*180/3.1416}]
    return [list $def1 $def2 $degre]
}
#
# Procedure ANGLEDEAN - fin


# Procedure GLM_RANDATA x = xdesign, y = dependent
#
# Cette procedure calcule la matrice des coefficients de regression partiels
# et sur cette base predit la valeurs theoriques ou attendues
#
proc glm_randata {x y} {
    # x = matrice des variables independantes - design matrix
    # y = matrice des variables dependantes
    global p infile S
    # On multiplie la transposee de la design matrice ('tx') par la matrice initiale ('x') -> xtx
    set xtx [mmult [transpose $x] $x]
    # On inverse la matrice obtenue 'xtx' -> 'ixtx'
    set colonnes [mcols $xtx]
    set ixtx [msolve $xtx [mident $colonnes]]
    # On multiplie la design matrice transposee ('xt') par la matrice des variables dependantes ('y')
    set xty [mmult [transpose $x] $y]
    # On calcule la matrice 'b' des coefficients de regression (b n'est pas ici un vecteur,
    # mais une matrice)
    global b
    set b [mmult $ixtx $xty]
    # ON CALCULE LES VALEURS PREDITES
    set y_hat [mmult $x $b]
    return $y_hat
}
#
# procedure GLM_RANDATA


# Procedure GLM_2levels x = xdesign, y = dependent
#
proc glm_2levels {x y} {
    
    # x = matrice des variables independantes - g_design matrix
    # y = matrice des variables dependantes
    
    global p infile
    global S
    
    # On multiplie la transposee de la g_design matrice ('tx') par la matrice initiale ('x') -> xtx
    set xtx [mmult [transpose $x] $x]
    
    # On va inverser la matrice obtenue 'xtx' -> 'ixtx'
    set colonnes [mcols $xtx]
    set ixtx [msolve $xtx [mident $colonnes]]
    
    # On multiplie la g_design matrice transposee ('xt') par la matrice des variables dependantes ('y')
    set xty [mmult [transpose $x] $y]
    
    # On calcule la matrice 'b' des coefficients de regression (b n'est pas ici un vecteur,
    # mais une matrice)
    global b
    set b [mmult $ixtx $xty]
    
    
    # Feb11 2006: distinction ci-dessous entre modeles
    if {$S(drapeau) != 3} {
        rouge $S(model)
        rouge "\n-----  b\t of b = invXtX XtY -----------(Y = RW) ------start-----\n"
        $p insert end [show $b %8.6f]
        rouge "\n-----  b\t of b = invXtX XtY ------------(Y = RW) ----- END -----\n"
        
        # Feb11 2006: distinction ci-dessous entre modeles
        vert $S(model)
        vert "\n----- Predicted RW -----start-----\n"
    }
    
    set y_hat [mmult $x $b];# c'est ce qui sera retourne par la procedure
    
    if {$S(drapeau) != 3} {
        $p insert end [show $y_hat %8.6f]
        
        mnorms_br y_hat y_hat_means y_hat_sigmas
        # Feb11 2006: distinction ci-dessous entre modeles
        rouge $S(model)
        rouge "\n\nLS means \n---\n[show $y_hat_means %8.6f]"
        vert "\n----- Predicted RW  ---- end -----\n"
        
        # Feb11 2006: distinction ci-dessous entre modeles
        vert $S(model)
        vert "\n----- TOTAL sum of squares-----------------start-----\n"
    }
    
    set ss_total [mmult [transpose $y] $y]
    
    if {$S(drapeau) != 3} {
        $p insert end [show $ss_total %8.6f]
        vert "\n----- TOTAL sum of squares  -----------------end -----\n"
        
        # Feb11 2006: distinction ci-dessous entre modeles
        vert $S(model)
        vert "\n----- MODEL sum of squares------- H  matrix (JMP) ---start-----\n"
    }
    
    set ss_model [mmult [mmult [transpose $b] [transpose $x]] $y]
    
    if {$S(drapeau) != 3} {
        $p insert end [show $ss_model %8.6f]
        vert "\n----- MODEL sum of squares -----------------end -----\n"
        
        # Feb11 2006: distinction ci-dessous entre modeles
        vert $S(model)
        vert "\n-----  ERROR sum of squares------- E matrix (JMP) ----start-----\n"
    }
    
    set ss_error [msub $ss_total $ss_model]
    
    if {$S(drapeau) != 3} {
        $p insert end [show $ss_error %8.9f]
        vert "\n-----  ERROR sum of squares  -----------------end -----\n"
    }
    

    
    # Enregistrement de la E matrix error sum of squares (ss_error)
    if {$S(model) == "\nreduced\n"} {set sub "_Ematrix_reduced"} else {set sub "_Ematrix_full"}
    set end ".txt"
    set ajout $sub$end
    set infilesub "[file root $infile]$ajout"
    if {$S(model) == "\nfull\n"} {
        set S(ematdiff) $ss_error
        set model "Full design matrix"
    } else {
        set S(ematcom) $ss_error
        set model "Reduced design model"
    }
    # Enregistrement de la E matrix
    set fid [open $infilesub w]
    puts -nonewline $fid "Error sum of squares (E matrix) - $model - from $infile\n"
    puts -nonewline $fid [show $ss_error]
    close $fid
    
    vert "\n\nX design, $S(model)... saved as ... $infilesub"
    $p insert end "\n ------------------------------------------------\n"
    
    return $y_hat
}
#
# procedure GLM_2levels --- fin

# Procedure silent_DESCRIPTION pop subdivision - debut
#
proc description_silent {pop subdivision} {
    global S lignes colonnes
    set colonnes [mcols $pop]
    set lignes [mrows $pop]
    #puts "Procedure description_silent : colonnes = $colonnes et lignes = $lignes"
    set effectifs $subdivision
    set gr [llength $subdivision]
    # B prepare la table des moyennes
    set B "2 $gr $colonnes"
    # SEPARER LA MATRICE DE CHAQUE GROUPE
    set compte 0
    set correction 0
    set x-subd ""; # superliste contenant les differentes sous-matrices
    foreach item [split $subdivision] {
        set correction [expr {$correction + $item}]
        set newpop [mrange $pop 0 [expr {$colonnes - 1}] [expr {$correction - $item}] [expr {$correction - 1}] ]
        lappend x_subd $newpop
        # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
        mnorms_br newpop newpopmeans newpopsigmas
        if {$S(dist_nopar) == 0} {
            # Appel a la procedure VARCOV pour le calcul de la matrice des variances-covariances
            set ZZ [varcov $newpop]
        }
        incr compte
        # Ici, on prepare une table des moyennes de chaque sous-matrice
        set newpopmeans [lrange $newpopmeans 3 end]
        foreach item [split $newpopmeans] {lappend B $item}
    }
    # Table des moyennes
    foreach item [split $B] {lappend newB $item}
    return $newB
}
#
# Procedure silent_DESCRIPTION - fin

# Procedure VARCOV - debut
#
proc varcov  {newpop} {
    
    set newcolonnes [mcols $newpop]
    set newlignes [mrows $newpop]
    
    # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
    # IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
    set popones "2 1 $newcolonnes 1"
    set x 1
    set y $newcolonnes
    while {$x < $y} {lappend popones 1; set x [expr {$x + 1} ] }
    
    # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
    mnorms_br newpop newpopmeans newpopsigmas
    
    # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
    set Z [mnormalize $newpop $newpopmeans $popones]
    # ici, div vaut en fait [expr {$newlignes -1}]]
    #set div  [expr {$eff($compte) - 1}]
    set div [expr {$newlignes -1}]
    set scale [expr {1.0 / $div}]
    ## BUG CORRIGE LE 19 AVRIL 2006
    ##$p insert end "\n++++++++++++++++++++++++++ scale $div -> $scale\n"
    #set Zsc [mscale $Z $scale]
    ## MATRICE des VARIANCES - COVARIANCES du GROUPE
    #set ZZ [mmult [transpose $Zsc] $Zsc]
    # MATRICE des VARIANCES - COVARIANCES du GROUPE
    set ZZ [mmult [transpose $Z] $Z]
    set ZZsc [mscale $ZZ $scale]
    return $ZZsc
}
#
# Procedure VARCOV - fin

# Procedure MOD_1_2
#
proc mod_1_2 {} {
    
    global p infile S
    
    set S(drapeau) 3
    
    # reduced matrix S(xr)
    # full matrix S(xf)
    # data as Relative Warps S(y_rw)
    
    set S_0 [mrange $S(xf) 0 0 0 end]
    set S_1 [mrange $S(xf) 1 1 0 end]
    set S_2 [mrange $S(xf) 2 2 0 end]
    set S_3 [mrange $S(xf) 3 3 0 end]
    
    set S(model) "reduced"
    set S(xr_1) [join_cols [join_cols $S_0 $S_2] $S_3]
    #$p insert end "Sans l'effet du groupe 1\n[show $S(xr_1)]"
    
    glm_2levels $S(xr_1) $S(y_rw)
    
    # -------------------------------------------------------------------------
    # Test de WILKS, calcul des df, calcul du F, et (j'espere) probabilites
    # -------------------------------------------------------------------------
    #
    rouge "\n-----------------------------------------------------------------"
    rouge "\nTesting for significance of factor 1 (or group 1, effect 1, etc.)"
    rouge "\n-----------------------------------------------------------------"
    set ematdiff $S(ematdiff)
    vert "\nFull design - Error sum of squares:\n[show $ematdiff]"
    
    set ematcom $S(ematcom)
    vert "\nReduced design - Error sum of squares (Er):\
            \n(The full model error sum of squares (Ef) already known, see above)\
            \n[show $ematcom]"
    
    # Determinant
    set detdiff [det $ematdiff [mident [mcols $ematdiff]]]
    set detcom [det $ematcom [mident [mcols $ematcom]]]
    
    # Calcul du lambda de Wilks
    #
    set wilks_diffcom [expr {$detdiff / $detcom}]
    
    # Calcul de F
    #
    # avec
    # dv = nbre de DV
    # et
    # q = nbre de groupes MOINS 1
    # et
    # n = nombre de lignes - nbre de groupes - 1
    
    
    set dv [mcols $S(y_rw)]; # nbre de DV; la premiere colonne est la taille <> DV
    set nbgroups [llength $S(subdivision1)]; #nbre de groupes
    set q [expr { $nbgroups - 1}]; #nbre de groupes - 1
    set n [expr {[mrows $S(y_rw) ] - $nbgroups - 1}]; #nbre de lignes - nbre de groupes -1
    # --------------------------------------------------------------------------
    
    
    # degres de liberte du numerateur (deviations par rapport a la prediction)
    set v1 [expr {$dv*$q}]
    
    # valeur de l'exposant b
    if {[expr {pow($dv,2) + pow($q,2) - 5}] > 0} {
        set num [expr {pow($v1,2) - 4}]
        set den [expr {pow($dv,2) + pow($q,2) - 5}]
        set b [expr {sqrt($num / $den)}]
        
    } else {
        tk_messageBox -text "NO WAY" -type OK
    }
    
    # degres de liberte de sums of squares and cross-products matrix for the prediction of shape
    # given one or more independent variables (the "explained" matrix)
    set vw [expr {$n-$q}]
    
    # degres de liberte par rapport au denominateur
    set t1 [expr {$b * ($vw - ($dv-$q+1) * 1.0/2)}]
    set t2 [expr {($v1 - 2)  * 1.0/2}]
    set v2 [expr {$t1 - $t2}]
    
    # Pour le calcul de F
    set t3 [expr {pow($wilks_diffcom,(1/$b))}]
    set F [expr {((1 - $t3) * 1.0/$t3) * ($v2 * 1.0/$v1)}]
    
    # Calcul de la signification
    set P_diffcom  [::math::statistics::Cdf-toms322 $v1 $v2 $F]
    set P_display [expr {1-$P_diffcom}]
    
    # Dans une variable globale pour decider du 'predicted shape under common slope'
    set S(P_diffcom) $P_display
    
    update
    flush stdout
    
    rouge "\n\nWilks lambda: \t$wilks_diffcom"
    $p insert end "\n(expected value of 1 under the null hypothsesis that Ef = Er)\
            - or null hypothesis of group 1 without effect"
    bleu "\nF: $F \tv1: $v1 \tv2: $v2 \tP: $P_display"
    rouge "\n----------------------------------------------------------------------\n\n"
    

    # Examining the effect of the second factor
    
    set S_0 [mrange $S(xf) 0 0 0 end]
    set S_1 [mrange $S(xf) 1 1 0 end]
    set S_2 [mrange $S(xf) 2 2 0 end]
    set S_3 [mrange $S(xf) 3 3 0 end]
    
    set S(model) "reduced"
    set S(xr_2) [join_cols [join_cols $S_0 $S_1] $S_3]
    #$p insert end "Sans l'effet du groupe 2\n[show $S(xr_1)]"
    
    glm_2levels $S(xr_2) $S(y_rw)
    
    # -------------------------------------------------------------------------
    # Test de WILKS, calcul des df, calcul du F, et (j'espere) probabilites
    # -------------------------------------------------------------------------
    #
    rouge "\n-----------------------------------------------------------------"
    rouge "\nTesting for significance of factor 2 (or group 2, effect 2, etc.)"
    rouge "\n-----------------------------------------------------------------"
    set ematdiff $S(ematdiff)
    #vert "\nFull design - Error sum of squares:\n[show $ematdiff]"
    
    set ematcom $S(ematcom)
    vert "\nReduced design - Error sum of squares (Er):\
            \n(The full model error sum of squares (Ef) already known, see above)\
            \n[show $ematcom]"
    # Determinant
    set detdiff [det $ematdiff [mident [mcols $ematdiff]]]
    set detcom [det $ematcom [mident [mcols $ematcom]]]
    
    # Calcul du lambda de Wilks
    #
    set wilks_diffcom [expr {$detdiff / $detcom}]
    
    # Calcul de F
    #
    # avec
    # dv = nbre de DV
    # et
    # q = nbre de groupes MOINS 1
    # et
    # n = nombre de lignes - nbre de groupes - 1
    
    
    set dv [mcols $S(y_rw)]; # nbre de DV; la premiere colonne est la taille <> DV
    set nbgroups [llength $S(subdivision1)]; #nbre de groupes
    set q [expr { $nbgroups - 1}]; #nbre de groupes - 1
    set n [expr {[mrows $S(y_rw) ] - $nbgroups - 1}]; #nbre de lignes - nbre de groupes -1
    # --------------------------------------------------------------------------
    
    
    # degres de liberte du numerateur (deviations par rapport a la prediction)
    set v1 [expr {$dv*$q}]
    
    # valeur de l'exposant b
    if {[expr {pow($dv,2) + pow($q,2) - 5}] > 0} {
        set num [expr {pow($v1,2) - 4}]
        set den [expr {pow($dv,2) + pow($q,2) - 5}]
        set b [expr {sqrt($num / $den)}]
        
    } else {
        tk_messageBox -text "NO WAY" -type OK
    }
    
    # degres de liberte de sums of squares and cross-products matrix for the prediction of shape
    # given one or more independent variables (the "explained" matrix)
    set vw [expr {$n-$q}]
    
    # degres de liberte par rapport au denominateur
    set t1 [expr {$b * ($vw - ($dv-$q+1) * 1.0/2)}]
    set t2 [expr {($v1 - 2)  * 1.0/2}]
    set v2 [expr {$t1 - $t2}]
    
    # Pour le calcul de F
    set t3 [expr {pow($wilks_diffcom,(1/$b))}]
    set F [expr {((1 - $t3) * 1.0/$t3) * ($v2 * 1.0/$v1)}]
    
    # Calcul de la signification
    set P_diffcom  [::math::statistics::Cdf-toms322 $v1 $v2 $F]
    set P_display [expr {1-$P_diffcom}]
    
    # Dans une variable globale pour decider du 'predicted shape under common slope'
    set S(P_diffcom) $P_display
    
    update
    flush stdout
    
    rouge "\n\nWilks lambda: \t$wilks_diffcom"
    $p insert end "\n(expected value of 1 under the null hypothsesis that Ef = Er)\
            - or null hypothesis of group 2 without effect"
    bleu "\nF: $F \tv1: $v1 \tv2: $v2 \tP: $P_display"
    rouge "\n----------------------------------------------------------------------\n\n"
    
    if {[info exists P_display]} {
        destroy .question
        .muestreo.debut configure -wrap none
    }
}
#
# Procedure MOD_1_2

# Procedure MOD_2LEVELS - debut
#
proc mod_2levels {} {
    
    global p drapeau S
    
    set S(drapeau) 1
    
    # -----------------------------------------------------------------------------
    # FENETRE PRESENTATION de la MATRICE (procedure mod)
    # ------------------------------------------------------------------------------
    wm iconify .
    set fp .muestreo
    catch {destroy $fp}
    catch {toplevel .muestreo}
    
    #set titre [file tail $infile]
    #wm title .muestreo $titre
    wm geometry $fp 800x600+50+10
    
    frame $fp.buttons
    pack $fp.buttons -side bottom -fill x -pady 2m
    
    button $fp.buttons.informe -text "Save report ?" -command {
        savelisting "_INFO_COV.txt"
    }
    
    button $fp.buttons.wrap -text "Wrap" -command {
        global drapeau
        if {$drapeau == 1} {
            .muestreo.debut configure -wrap word; set drapeau 0
        } else {
            .muestreo.debut configure -wrap none; set drapeau 1
        }
    }
    
    pack $fp.buttons.wrap $fp.buttons.informe -side left -expand 1
    
    set scb [scrollbar .muestreo.scrollA -command ".muestreo.debut yview"]
    pack $scb -side left -fill y
    #set pres [text .muestreo.debut -background white -font "courier 12" \
    -width 82 -height 20 -wrap word -yscrollcommand ".muestreo.scrollA set"]
    set pres [text .muestreo.debut -background "light yellow" -font "courier 12" \
            -wrap word -yscrollcommand ".muestreo.scrollA set"]
    pack $pres -side right -fill both -expand yes
    
    
    # --------------------------------------------------------------------------------
    # ------------------------------ MENU --------------------------- DEBUT ----------
    #
    # **********************procedure menu bar***********DEBUT******************
    #
    proc CreateMenubar {ttoplevel menubar} {
        set toplevel $ttoplevel
        menu $menubar -type menubar
        $toplevel configure -menu $menubar
    }
    # **********************procedure menu bar ***********FIN******************
    
    # **********************procedure menu ***********DEBUT******************
    #
    proc CreateMenu {menubar basename ttext mnemonic} {
        set text $ttext
        set menu_name "$menubar.$basename"
        $menubar add cascade -label $text -menu $menu_name -underline $mnemonic
        menu $menu_name
        return $menu_name
    }
    # **********************procedure menu ***********FIN******************
    destroy .menubar
    CreateMenubar .muestreo .menubar
    set menu_name [CreateMenu .menubar filemenu1 "MANOVA 2 factors" 0]
    
    $menu_name add command -label "Two groups with two subgroups each" -command {
        
        global p
        global S
        infomanco
        if {[info exists S(perm)]} {puts "Nb permutations = $S(perm)"}
        
        
        set y [whichmatrix]
        if {[string first "_PW_CS" $infile] < 0 } {
            set nm [tk_messageBox -message "your file does not seem to fit the required format\n\
                    do you want to go on ?" -icon warning -type yesno]
            if {$nm == no} {exit}
        }
        
        if {[info exists nm]} {
            if {$nm == yes} {
                set avertissement "\nWARNING:\t This analysis was performed on an unrecognized data format"
            }
        }
        
        destroy .question
        toplevel .question
        wm geometry .question +700+220
        wm title .question "group sizes"
        entry .question.groupe1 -textvariable subdivision1
        pack .question.groupe1
        entry .question.groupe2 -textvariable subdivision2
        pack .question.groupe2
        focus .question.groupe1
        button .question.ok -text "Please press the RETURN key"
        pack .question.ok
        destroy .avis
        # On appuie sur la touche ENTER apres avoir rentre les effectifs
        bind .question <Return> {
            
            set S(subdivision1) $subdivision1
            set S(subdivision2) $subdivision2
            
            ###################
            update
            .question.ok configure -text "Partitioning the _PW_CS matrix"
            
            # La premiere colonne contient les tailles
            set covariate [mrange $y 0 0]
            #puts "covariate [show $covariate]"
            # On en montre un echantillon
            if {[mrows $covariate] < 30} {
                $p insert end "\n\nCovariate \n[show $covariate]"
            } else  {
                $p insert end "\nCovariate \n[show [mrange $covariate 0 0 0 29]] \n...\netc. etc.\n"
            }
            
            #rouge "\n[llength $subdivision] groups, with sample sizes $subdivision\n"
            
            ###################
            update
            .question.ok configure -text "Design matrices"
            
            # Appel a la procedure xdesign: grand (g_design) et petit (p_design) design
            # recevront les valeurs des variables globales S() correspondantes
            xdesign_2levels $subdivision1 $subdivision2
            
            ###################
            update
            .question.ok configure -text "Partial and Relative warps scores"
            
            # Extraction des PARTIAL WARPS (PW) = 'y_pw' a partir de la matrice '..._PW_CS.txt'
            set y_pw [mrange $y 1 end 0 end]
            #debug
            #puts "Partial warps\n$y_pw"
            
            
            # on montre ces partial warps
            bleu "\n\nPartial warps\n\n[show [mrange $y_pw 0 end 0 9]]\n... ... ... ..."
            # ensuite, pour info,  une matrice des MEANS y_bar_pw; cfr. la variable subdivision
            set y_bar_pw [description_silent $y_pw $subdivision2]
            # on montre cette matrice des moyennes
            bleu "\n\nPartial warps: general table of means"
            rouge "\n[show $y_bar_pw]\n"
            
            # Appel a la procedure COPRI pour le calcul des RELATIVE WARPS (RW) = 'y_rw'
            set y_rw [copri $y_pw]
            set S(y_rw) $y_rw
            # on montre les relative warps
            rouge "\n\nRelative warps\n\n[show [mrange $y_rw 0 end 0 9]]\n... ... ... ..."
            
            # Un BOUTON apparait pour le cas ou l'on veut voir la carte factorielle - FACTOR MAP
            global lignes
            set lignes [mrows $y_rw]
            #Embedded button - FACTOR MAP (sur RW) - la procedure COPRI calcule la valeur des 'individus'
            destroy $p.embed_plot
            button $p.embed_plot -text "Plot (PCA on PW)" -command {dessine $individus; destroy $p.embed_plot}
            $p window create {end lineend} -window $p.embed_plot
            bind $p.embed_plot <Motion> {$p.embed_plot configure -cursor hand1}
            
            vert "\n----------------------------------------\n"
            vert "\n\n$infile \n"
            vert "\n$references\n"
            vert "\n----------------------------------------\n"
            
            # ensuite une matrice des MEANS y_bar_rw; cfr. la variable subdivision
            # il s'agit cette fois-ci des moyennes de la matrice des Relative Warps
            set y_bar_rw [description_silent $y_rw $subdivision2]
            bleu "\n\nRelative warps: general table of means"
            rouge "\n[show $y_bar_rw]\n"
            
            # AJOUT 21 AVRIL -debut ------------------------------------------------------
            #
            # on calcule les 'PREDICTED' RW y_hat_rw; avec 'g'_design pour 'grand'_design
            # # Feb11 2006: on le fait ici pour different modeles
            set S(model) "\nfull\n"
            set g_design $S(xf)
            
            global b;# pour garder la matrice des coeff. de regression definie dans la procedure 'glm'
            set y_hat_rw_xf [glm_2levels $g_design $y_rw]
            set S(full) $b
            #
            # AJOUT 21 AVRIL - fin ----------------------------------------------------------
            
            # ensuite on calcule les 'PREDICTED' RW y_hat_rw; avec 'Xr'_design pour 'reduced'_design
            # Feb11 2006: on le fait pour "common slope"
            set S(model) "\nreduced\n"
            set g_design $S(xr)
            
            global b
            #... pour garder la matrice b des coefficients de regression definie dans la procedure 'glm'
            set y_hat_rw_xr [glm_2levels $g_design $y_rw]
            set S(reduced) $b
            set S(y_hat_rw_xr) $y_hat_rw_xr
            
            # Enregistrement
            set sub "_PredictedRW_reduced"
            set end ".txt"
            set ajout $sub$end
            set infilesub "[file root $infile]$ajout"
            set fid [open $infilesub w]
            puts -nonewline $fid "Predicted Relative warps without interaction, from $infile\n"
            puts -nonewline $fid [show $y_hat_rw_xr]
            close $fid
            
            # Ici, on devrait calculer les RESIDUALS - la difference entre la matrice observee et predite
            #
            # RESIDUALS - debut
            set y_res_xr [msub $y_hat_rw_xr $y_rw]
            # Feb11 2006: distinction ci-dessous entre modeles
            rouge  "\n\nRESIDUALS - reduced matrix design model\
                    \n[show $y_res_xr]\n-------------------------------------------------\n"
            set S(y_res_xr) $y_res_xr
            #
            # RESIDUALS - fin
            
            #
            # RESIDUALS - debut
            set y_res_xf [msub $y_hat_rw_xf $y_rw]
            # Feb11 2006: distinction ci-dessous entre modeles
            rouge  "\n\nRESIDUALS - full matrix design model"
            rouge  "\n\nRESIDUALS\n[show $y_res_xf]\n-------------------------------------------------\n"
            #
            # RESIDUALS - fin
            
            # Feb11 2006: distinction ci-dessous entre full et reduced design matrix models
            #vert $S(slope)
            #vert "\n\nPredicted Relative warps according to size, saved as ... \n$infilesub"
            #
            # ensuite une matrice des predicted MEANS y_hat_bar_rw_xr sur modele reduit
            #
            #puts "y_hat_rw_xr \n$y_hat_rw_xr"
            set y_hat_bar_rw_xr [description_silent $y_hat_rw_xr $subdivision2]
            bleu "\n\nPredicted RW according to reduced design matrix model: general table of means\
                    \nFor your information: these means differ from observed means\n"
            # Feb11 2006: reduced design matrix model
            rouge "\n[show $y_hat_bar_rw_xr]\n"
            
            set y_hat_bar_rw_xf [description_silent $y_hat_rw_xf $subdivision2]
            bleu "\n\nPredicted RW according to full design matrix model: general table of means\
                    \nFor your information: these means do not differ from means obtained\
                    from 'observed' data\n"
            # Feb11 2006: reduced design matrix model
            rouge "\n[show $y_hat_bar_rw_xf]\n"
            
            # ensuite une matrice des ADJUSTED MEANS: mmult {Xls;Bf} {expLSmeans.b}
            # 'p_design' recoit ici la valeur de la variable globale S(LSM_common_slope)
            #set p_design $S(LSM_common_slope)
            #set y_ls_means_rw [mmult $p_design $S(reduced)]
            
            # -------------------------------------------------------------------------
            # Test de WILKS, calcul des df, calcul du F, et (j'espere) probabilites
            # -------------------------------------------------------------------------
            #
            rouge "\n----------------------------------------------------------------------"
            rouge "\nDifferent models: Testing for significance of an interaction effect"
            rouge "\n----------------------------------------------------------------------"
            set ematdiff $S(ematdiff)
            #vert "\nfull:\n[show $ematdiff]"
            
            set ematcom $S(ematcom)
            #vert "\nreduced:\n[show $ematcom]"
            
            # Determinant
            set detdiff [det $ematdiff [mident [mcols $ematdiff]]]
            set detcom [det $ematcom [mident [mcols $ematcom]]]
            
            # Calcul du lambda de Wilks
            #
            set wilks_diffcom [expr {$detdiff / $detcom}]
            
            # Calcul de F
            #
            # avec
            # dv = nbre de DV
            # et
            # q = nbre de groupes MOINS 1
            # et
            # n = nombre de lignes - nbre de groupes - 1
            
            
            set dv [expr {[mcols $y] - 1}]; # nbre de DV; la premiere colonne est la taille <> DV
            set nbgroups [llength $subdivision1]; #nbre de groupes
            set q [expr { $nbgroups - 1}]; #nbre de groupes - 1
            set n [expr {[mrows $y ] - $nbgroups - 1}]; #nbre de lignes - nbre de groupes -1
            # --------------------------------------------------------------------------
            
            
            # degres de liberte du numerateur (deviations par rapport a la prediction)
            set v1 [expr {$dv*$q}]
            
            # valeur de l'exposant b
            if {[expr {pow($dv,2) + pow($q,2) - 5}] > 0} {
                set num [expr {pow($v1,2) - 4}]
                set den [expr {pow($dv,2) + pow($q,2) - 5}]
                set b [expr {sqrt($num / $den)}]
                
            } else {
                tk_messageBox -text "NO WAY" -type OK
            }
            
            # degres de liberte de sums of squares and cross-products matrix for the prediction of shape
            # given one or more independent variables (the "explained" matrix)
            set vw [expr {$n-$q}]
            
            # degres de liberte par rapport au denominateur
            set t1 [expr {$b * ($vw - ($dv-$q+1) * 1.0/2)}]
            set t2 [expr {($v1 - 2)  * 1.0/2}]
            set v2 [expr {$t1 - $t2}]
            
            # Pour le calcul de F
            set t3 [expr {pow($wilks_diffcom,(1/$b))}]
            set F [expr {((1 - $t3) * 1.0/$t3) * ($v2 * 1.0/$v1)}]
            
            # Calcul de la signification
            set P_diffcom  [::math::statistics::Cdf-toms322 $v1 $v2 $F]
            set P_display [expr {1-$P_diffcom}]
            
            # Dans une variable globale pour decider du 'predicted shape under common slope'
            set S(P_diffcom) $P_display
            
            update
            flush stdout
            
            rouge "\n\nWilks lambda: \t$wilks_diffcom"
            $p insert end "\n(expected value of 1 under the null hypothsesis that Ef = Er, \
                    i.e. here no interaction effect)"
            bleu "\nF: $F \tv1: $v1 \tv2: $v2 \tP: $P_display"
            rouge "\n----------------------------------------------------------------------\n\n"
            
            if {[info exists P_display]} {
                destroy .question
                .muestreo.debut configure -wrap none
            }
            
            # ============== ecrire les longueurs et angle, de toutes facons ================
            #
            # Appel a la procedure 'angledean'
            # Soustraire seconde ligne de la premiere -> vecteur 1 (vect1)-> longueur1
            # Soustraire quatrieme ligne de la troisieme -> vecteur 2 (vect2) -> longueur2
            # Angle entre vect1 et vect2
            set y_means $y_hat_bar_rw_xf
            set serie [angledean $y_means]
            set vect_obs1 [lindex $serie 0]
            set vect_obs2 [lindex $serie 1]
            set angle_obs12 [lindex $serie 2]
            $p insert end "\nAmount of change in group 1 $vect_obs1"
            $p insert end "\nAmount of change in group 2 $vect_obs2"
            set vect_obs12 [expr {abs($vect_obs1 - $vect_obs2)}]
            rouge "\nChanges within groups: Difference in magnitude from one group to another:\t$vect_obs12"
            vert "\nChanges within groups: Difference in direction from one group to another"
            rouge "\t$angle_obs12\n"
            # ============== ecrire les longueurs et angle, de toutes facons ================
            
            mod_1_2
            
            
            # Un BOUTON apparait pour le cas ou P est significatif
            if {$P_display < 0.05} {
                #Embedded button - length and angle
                destroy $p.embed_aman
                button $p.embed_aman -text "Amount and Direction of changes" -command {
                    pran $y_hat_bar_rw_xf
                    destroy $p.embed_plot}
                $p window create {end lineend} -window $p.embed_aman
                bind $p.embed_aman <Motion> {$p.embed_aman configure -cursor hand1}
            }
        }
    }
    
    # le widget texte dans la variable 'p'
    set p .muestreo.debut
    
    ################### bleu ##### Procedure ## Debut ##
    proc bleu {mesg args} {
        global p
        $p insert end $mesg "bleu"
    }
    $p tag configure bleu -foreground blue
    ################### bleu ####### PROCEDURE ## FIN ###
    
    ################### rouge ##### Procedure ## Debut ##
    proc rouge {mesg args} {
        global p
        $p insert end $mesg "rouge"
    }
    $p tag configure rouge -foreground red
    ################### rouge ####### PROCEDURE ## FIN ###
    
    ################### vert ##### Procedure ## Debut ##
    proc vert {mesg args} {
        global p
        $p insert end $mesg "vert"
    }
    $p tag configure vert -foreground "dark green"
    ################### vert ####### PROCEDURE ## FIN ###
    
    
    
};# fin mod_2levels
mod_2levels