source 100La.tcl
source math/statistics.tcl

toplevel .question
button  .question.l -text "hey"
pack  .question.l

# Procedure SUBDIVIDED_MATRIX_PW - debut
#
proc subdivided_matrix_pw {mdonnees} {
    
    global p S
    
    # A present une boucle sur ces groupes ....................
    # ---------------------------------------------------------
    # On va calculer les PW de chaque groupe, appele 'mdonnees'
    
    # ----------------------------------------------- debut ---
    #
    # 'mdonnees' est une HUME matrice
    
    global lignes colonnes lm rawindividus tablind reference
    #$p insert end "\nDONNEES INITIALES\n[show $mdonnees %1.3f]\n"
    set matinit [lrange $mdonnees 0 2]
    set colonnes [lindex $matinit 2]
    set lignes [lindex $matinit 1]
    set lm [expr {$colonnes/2}]
    #$p insert end "\n\n$lignes\tconfiguraciones\n$lm\tlandmarks\n"
    
    # calcul du consensus (configuration moyenne)
    set consensus [mnorms $mdonnees]
    set consensus [lrange $consensus 3 [expr {3+$colonnes-1}]]
    set consensus [lformat %1.3f $consensus]
    set donnees [lrange $mdonnees 3 end]
    set data ""
    for  {set i 0} {$i < [expr {$lignes*$colonnes}]} {incr i $colonnes} {
        set tranche [lrange $donnees $i [expr {$i+$colonnes-1}]]
        append data "$tranche\n"
    }
    
    # On classe les coordonnees successives par individu dans la table tablind()
    if {[info exists tablind]} {unset tablind}
    set i -1
    set compteur 0
    set tablind(0) $consensus
    foreach item [split $data "\n"] {
        #$p insert end "\n\nPour tablind:\n$item\n"
        if {$item != ""} {
            # On saute la premiere ligne
            incr compteur
            if {$compteur > 0} {
                #verification du nombre de lm de chaque individu
                if  {$colonnes != [llength $item]} {
                    $p insert end "$lm <> [llength $item]"
                    exit
                }
                incr i
                set tablind($compteur) $item
            }
        }
    }
    
    #$p insert end "\n\nCONFIGURATION CONSENSUS \n$tablind(0)"
    
    # On cree une LISTE (un individu) de MATRICES (de coordonnees)
    # (une matrice est un couple de coordonnees, elle a 1 ligne et 2 colonnes)
    # (chaque 'landmark' est une 'matrice')
    if {[info exists rawindividus]} {unset rawindividus} else {set rawindividus ""}
    set n [llength $data]
    #$p insert end "\nCREATION DES INDIVIDUS"
    for  {set i 0} {$i < $n} {incr i 2} {
        set item [lrange $data $i [expr {$i+1}]]
        #$p insert end "\nITEM = \t$item"
        lappend rawindividus "2 1 2 $item"
    }
    
    # calculs PW proprement dits
    
    set preindividus [translation $lm]
    set proindividus [scaling $lm]
    set S(ctr) $proindividus
    
    rotation
    return [partialite $reference];# a placer dans une variable indicee
    
    # ---------------------------------------------------------
    # Et a present on fait la meme chose pour le groupe suivant
    #
    # ----------- fin de la boucle sur les groupes -------------
}
#
# Procedure SUBDIVIDED_MATRIX_PW - fin

# Procedure LFORMAT # debut
#
proc lformat {ainsi liste} {
    foreach item $liste {
        set item [format $ainsi $item]
        lappend fliste $item
    }
    return $fliste
}
#
# Procedure LFORMAT # fin

# Procedure SEPARATION pop subdivision - debut
#
proc separation {pop subdivision} {
    
    global p
    
    set effectifs $subdivision
    puts "\nGroupes $subdivision\n"
    
    set colonnes [mcols $pop]
    set lignes [mrows $pop]
    
    # Le nombre de groupes dans la variable 'gr'
    # Les effectifs dans la variable indicee eff($gr) - aussi deja dans la liste 'effectifs' et/ou 'subdivision'
    set gr 0
    foreach item [split $subdivision] {
        incr gr
        set eff($gr) $item
    }
    
    # B prepare la table des moyennes
    set B "2 $gr $colonnes"
    #debug
    #puts "B (future table des moyennes) aura la structure 2 $gr $colonnes - Il y a $gr groupes"
    
    # - - - - - - - - - - - - - - - - - - - - - - -
    # SEPARER LA MATRICE DE CHAQUE GROUPE - - - - - start - -
    # - - - - - - - - - - - - - - - - - - - - - - -
    set compte 0
    set correction 0
    set x-subd ""; # superliste contenant les differentes sous-matrices
    foreach item [split $subdivision] {
        set correction [expr {$correction + $item}]
        set newpop [mrange $pop 0 [expr {$colonnes-1}] [expr {$correction - $item}] [expr {$correction - 1}] ]
        lappend x_subd $newpop
    }
    return $x_subd
}
#
# procedure SEPARATION


# Procedure EUCLID - start
#
proc euclid {table} {
    # La table est probablement une table des moyennes
    #
    # Une variable globale si le but est d'obtenir la liste non formatée des distances
    global S
    set S(euclist) ""
    #
    # En lignes, les groupes ou populations
    set gro [mrows $table]
    # En colonnes, les variables ou characteres
    set var [mcols $table]
    
    # fenetre de suivi (celle des effectifs des groupes)- debut
    .question.l configure -text "0/$gro"
    # fenetre de suivi - debut
    
    # Quelles sont les distances euclidiennes entre les lignes (gro) sur la base de toutes les colonnes (var) ?
    set tableucl "0 "
    set zero " 0 "
    for {set l 0} {$l < $gro} {incr l} {
        for {set k [expr {$l+1}]} {$k < $gro} {incr k} {
            set bonclid 0
            
            for {set c 0} {$c < $var} {incr c} {
                # valeurs de chaque individu sur un axe factoriel
                set m1 [lindex [mrange $table $c $c $l $l] 3]
                set m2 [lindex [mrange $table $c $c $k $k ] 3 ]
                # difference arithmetique entre deux moyennes (celles de deux populations)
                set diff [expr {$m1  -  $m2}]
                # cette difference elevee au carre
                set cardiff [expr {$diff * $diff}]
                # cette valeur ajoutee a la distance totale (pour toutes les variables) entre ces deux populations
                set bonclid [expr {$bonclid + $cardiff}]
            }
            # fenetre de suivi - debut
            update
            .question.l configure -text "$l/$gro"
            # fenetre de suivi - fin
            
            set bonclid [expr {sqrt($bonclid)} ]
            lappend tableucl $bonclid
            # Une variable globale si le but est d'obtenir la liste non formatée des distances
            lappend S(euclist) $bonclid
        }
        
        # Pour gérer les zeros
        if {$l < [expr {$gro-1}]} {
            append zero " 0 "
            append tableucl $zero
        }
    }
    # Une matrice des distances
    set matdist [concat 2 $gro $gro $tableucl]
    set matdist [transpose $matdist]
    return $matdist
}
#
# Procedure EUCLID - fin

# Procedure EUCLID_B - start
#
proc euclid_B {table subdivision} {
    # La matrice ('table') est subdivisée
    #
    
    # Très important pour dégager ce qui est within
    set accum 0
    for {set i 0} {$i < [llength $subdivision]} {incr i} {
        set accum [expr {$accum + [lindex $subdivision $i]}]
        append subdivision_accum "$accum "
    }
    
    # Cette variable contiendra la taille de la matrice des distances between
    set matrice_dist_between_taille 0
    # Prédiction de la la taille de la matrice des distances between
    set ici 0
    for {set i 0} {$i < [expr {[llength $subdivision]-1}]} {incr i} {
        set ici [expr {$ici + [lindex $subdivision $i] * ([lindex $subdivision_accum end] - [lindex $subdivision_accum $i])}]
    }

    # Une variable globale si le but est d'obtenir la liste non formatée des distances
    global S
    set S(euclist) ""
    #
    # En lignes, les groupes ou populations
    set gro [mrows $table]
    # En colonnes, les variables ou characteres
    set var [mcols $table]
    
    
    # fenetre de suivi (celle des effectifs des groupes)- debut
    .question.l configure -text "0/$gro"
    # fenetre de suivi - debut
    
    # Quelles sont les distances euclidiennes entre les lignes (gro) sur la base de toutes les colonnes (var) ?
    set tableucl "0 "
    set zero " 0 "
    set chapulin 0
    for {set l 0} {$l < $gro} {incr l} {
        set didi ""
        for {set k [expr {$l+1}]} {$k < $gro} {incr k} {
            set bonclid 0
            
            for {set c 0} {$c < $var} {incr c} {
                # valeurs de chaque individu sur un axe factoriel
                set m1 [lindex [mrange $table $c $c $l $l] 3]
                set m2 [lindex [mrange $table $c $c $k $k ] 3 ]
                # difference arithmetique entre deux moyennes (celles de deux populations)
                set diff [expr {$m1  -  $m2}]
                # cette difference elevee au carre
                set cardiff [expr {$diff * $diff}]
                # cette valeur ajoutee a la distance totale (pour toutes les variables) entre ces deux populations
                set bonclid [expr {$bonclid + $cardiff}]
            }
            # fenetre de suivi - debut
            update
            .question.l configure -text "$l/$gro"
            # fenetre de suivi - fin
            
            set bonclid [expr {sqrt($bonclid)} ]
            
            #puts "$subdivision_accum et $chapulin :::: $l et $k  --  \
            'lindex subdivision $chapulin'  [lindex $subdivision_accum $chapulin]"
            set seuil [lindex $subdivision_accum $chapulin]
            set seuil [expr {$seuil-1}]
            
            if {$k > $seuil} {
                incr matrice_dist_between_taille
                #debug important
                # puts "$matrice_dist_between_taille: $l et $k, \
                        avec $k > seuil ($seuil) <- $subdivision_accum ... $chapulin"
                #debug - fin
                lappend tableucl $bonclid
                lappend didi $bonclid
                # Une variable globale si le but est d'obtenir la liste non formatée des distances
                lappend S(euclist) $bonclid
            } else  {
                #lappend tableucl " 0 "
                #lappend S(euclist) " 0 "
            }
        }
        # debug
        #puts "$l = seuil $seuil ? ---------------------------------- [llength $didi] distances"
        
        if {$l == $seuil} {incr chapulin}
        if {[lindex $subdivision_accum $chapulin] == [lindex $subdivision_accum end]} {
            break
        }
        # Pour gérer les zeros
        if {$l < [expr {$ici-1}]} {
            append zero " 0 "
            append tableucl $zero
        }
    }

    return $tableucl
}
#
# Procedure EUCLID_B - fin

# Procedure DISTDIST_WITHIN - start
#
# Les distances INTERNES sont inscrites dans une LISTE pour chaque subsample
# et sont accumulées dans les mêmes classes
#
proc distdist_within {x pop} {
    global p S subdivision
    
    # Nombre de classes pour l'histogramme des distances
    set S(dist_nb_classes) 4
    
    # Total number of cells
    set cells [mrows $x]
    set nMoins1 [expr {$cells - 1}]
    # each value is squared
    set xprodx [mprod $x $x]
    # to compute the sum of each row, (i) transpose (ii) msum
    # (i)
    set txprodx [transpose $xprodx]
    # (ii)
    set listsumrows [msum $txprodx]
    set listsumrows_scaled [mscale $listsumrows 1000000]
    # On ordonne la liste
    set dist_liste [lsort -r [vtrim $listsumrows_scaled]]
    
    ## Autre calcul de la distribution des distances (complet, mais plus long)
    
    set dist_euclid [euclid $x]
    
    
    set dist_liste_autre [lsort -r $S(euclist)]
    set dist_liste_new ""
    foreach item $dist_liste_autre {
        append dist_liste_new "[expr {int($item * 1000)}] "
        
    }
    set dist_liste $dist_liste_new
    
    set min [expr {int([lindex $dist_liste 0])}]
    set max [expr {int([lindex $dist_liste end])}]
    
    # Calcul des hauteurs des limites de classe
    puts "\nSubsample [expr {$pop+1}]: \nDistance min is $min \t Distance max is $max \n"
    set limits [::math::statistics::minmax-histogram-limits $min $max $S(dist_nb_classes)]
    
    # Calcul des hauteurs des rectangles ("barres") pour les limites choisies
    set counts [::math::statistics::histogram $limits $dist_liste]
    
    puts "Group $pop :\t$counts"
    # valider cette pu de var
    if {$pop == 0} {
        set collier 0
        foreach item $counts {
            set S(dist_liste_accum,$collier) 0
            incr collier
        }
    }
    
    set collier 0
    foreach item $counts {
        set S(dist_liste_accum,$collier) [expr {$S(dist_liste_accum,$collier) + $item}]
        
        incr collier
    }
    
    for {set i 0} {$i < $collier} {incr i} {
        append counts_accum "$S(dist_liste_accum,$i) "
        #debug
        #puts "counts_accum $counts_accum"
    }
    
    # Pour le graphique d'ensemble
    append S(dist_effectifs) "[llength $dist_liste] "
    append S(dist_valeurs) "$dist_liste "
    append S(dist_min) "$min "
    append S(dist_max) "$max "
    append S(limits) "$limits "
    append S(counts) "$counts "
    
    return $counts_accum
}
#
# Procedure DISTDIST

# Les distances EXTERNES sont inscrites dans une LISTE pour chaque subsample
# et sont accumulées dans les mêmes classes
#
proc distdist_between {x} {
    global p S subdivision
    
    # Nombre de classes pour l'histogramme des distances
    set S(dist_nb_classes) 4
    
    # Total number of cells
    set cells [mrows $x]
    set nMoins1 [expr {$cells - 1}]
    # each value is squared
    set xprodx [mprod $x $x]
    # to compute the sum of each row, (i) transpose (ii) msum
    # (i)
    set txprodx [transpose $xprodx]
    # (ii)
    set listsumrows [msum $txprodx]
    set listsumrows_scaled [mscale $listsumrows 1000000]
    # On ordonne la liste
    set dist_liste [lsort -r [vtrim $listsumrows_scaled]]
    
    ## Autre calcul de la distribution des distances (complet, mais plus long)
    # Distances entre subsamples serait
    set dist_euclid [euclid_B $x $subdivision]
    set dist_liste_autre [lsort -r $S(euclist)]
    set dist_liste_new ""
    foreach item $dist_liste_autre {
        append dist_liste_new "[expr {int($item * 1000)}] "
    }
    set dist_liste $dist_liste_new
    
    set min [expr {int([lindex $dist_liste 0])}]
    set max [expr {int([lindex $dist_liste end])}]
    
    # Calcul des hauteurs des limites de classe
    puts "\nTotal sample : \nDistance min is $min \t Distance max is $max \n"
    set limits [::math::statistics::minmax-histogram-limits $min $max $S(dist_nb_classes)]
    
    # Calcul des hauteurs des rectangles ("barres") pour les limites choisies
    set counts [::math::statistics::histogram $limits $dist_liste]
    
    puts "Group total :\t$counts"
    
    # Pour le graphique d'ensemble
    append S(dist_effectifs) "[llength $dist_liste] "
    append S(dist_valeurs) "$dist_liste "
    append S(dist_min) "$min "
    append S(dist_max) "$max "
    append S(limits) "$limits "
    append S(counts) "$counts "
    
    return $counts
}
#
# Procedure DISTDIST_BETWEEN - end


global S
set x_total "2 12 12 31	76	6	43	35	36	61	45	41	81	99	1
49	27	31	77	48	4	17	48	31	6	98	46
76	75	8	49	81	35	96	12	11	56	55	47
92	16	92	34	97	9	43	46	18	74	24	66
14	4	14	45	46	12	91	22	87	99	71	68
34	67	8	46	23	35	92	15	51	84	49	49
74	92	95	92	66	19	58	81	59	72	26	5
83	17	27	7	16	98	38	5	65	18	96	88
53	88	4	5	72	53	53	46	45	48	38	12
67	95	92	26	67	18	31	5	35	58	21	51
56	59	1	22	76	97	1	3	85	14	34	57
67	88	3	12	36	4	24	3	36	16	28	3
"

global subdivision
set subdivision "4 4 4"

# les groupes (sous-matrices) seront rassembles dans une (super)liste x_subd
set x_subd [separation $x_total $subdivision]

set compteur 0
foreach item $x_subd {
    puts [distdist_within $item $compteur]
    incr compteur
}

puts [distdist_between $x_total]

exit