package require Tk
set tcl_precision 14
cd [file dirname [info script]]
#
global S
set S(dirscript) [pwd];#attention, il n'y a pas de "/" a la fin du nom du dossier du script (utiliser "file join etc")
#
cd ..
set S(dirclic) [pwd]
cd $S(dirscript)

source [file join $S(dirclic) "+/101La.tcl"]
source [file join $S(dirclic) "+/math/statistics.tcl"]
source [file join $S(dirclic) "+/math/math.tcl"]
source [file join $S(dirclic) "+/math/optimize.tcl"]
source [file join $S(dirclic) "+/math/linalg.tcl"]
source [file join $S(dirclic) "+/jpdraw_15.tcl"]


# procedure DEBUG
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x600+205+66
        set memo [text .debug.t -wrap word -height 22 -font "courier 13" \
		      -bg grey88 \
		      -fg black\
		      -tabs "3c left"\
		      -yscrollcommand ".debug.v_scroll set" \
		      -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
            if {$flag == 1} {
                .debug.t configure -wrap none
                set flag 0
            } else  {
                .debug.t configure -wrap word
                set flag 1
            }
        }
        #
        $memo insert end $bugatti
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG fin

# Procedure LSUM -début
proc lsum {liste} {
    # calcule la somme des éléments d'une liste (numerique, bien entendu)
    set compteur 0
    foreach item $liste {
        set compteur [expr {$compteur+ $item} ]
    }
    return $compteur
}
#
# Procedure LSUM -fin

# Procedure ESCOUFIER
#
proc escoufier {v21 v12 v11 v22} {
    set v21v12 [mmult $v21 $v12]
    debug "v21v12 \n[show $v21v12]"
    set trace_v21v12 [trace $v21v12]
    set trace_v11 [trace $v11]
    set trace_v22 [trace $v22]
    set trace_v11_squared [expr {pow($trace_v11,2)}]
    set trace_v22_squared [expr {pow($trace_v22,2)}]
    set product [expr {$trace_v11_squared * $trace_v22_squared}]
    set denominateur [expr {sqrt($product)}]
    set rv [expr {$trace_v21v12 * 1.0 / $denominateur}]
    return $rv
}
#
# Procedure ESCOUFIER

# Procedure TRACE - start
#
proc trace {v} {
set col [mcols $v]
    set row [mrows $v]
    for {set i 0} {$i<$col} {incr i} {
	append trace "[vtrim [mrange $v $i $i $i $i]] "
	#debug ">>>> $i $i: $trace"
    }
    set trace [lsum $trace]
}
#
# Procedure TRACE - fin

set xtx "2 5 5 1 2 3 4 5  1 3 3 1 5 2 3 4 3 2 3 1 2 4 2 4 1 1 2 5"
#debug "R, o V \n[show $xtx]"
set p1 3
set p2 2
set R12 [mrange $xtx $p1 end 0 [expr {$p1-1}]]
#debug "R12 $p1 end 0 [expr {$p1-1}] \n[show $R12]"
set R21 [mrange $xtx 0 [expr {$p1-1}] $p1 end]
#debug "R21 0 [expr {$p1-1}] $p1 end \n[show $R21]"
set R11 [mrange $xtx 0 [expr {$p1-1}] 0 [expr {$p1-1}]]
#debug "R11 0 [expr {$p1-1}] 0 [expr {$p1-1}] \n[show $R11]"
set R22 [mrange $xtx $p1 end $p1 end]
#debug "R22 \n[show $R22]"
set Rv [escoufier $R21 $R12 $R11 $R22]
#debug "Rv $Rv"
