package require Tk
cd [file dirname [info script]]

set tcl_precision 14

source chull.tcl
source math/statistics.tcl
source math/math.tcl
source math/optimize.tcl
source math/linalg.tcl
source 101La.tcl
source jpdraw_11_3A.tcl
source ballons.tcl

# Procedure ENTRADA - start
#
proc entrada {pop infile} {
    
    global p references
    # En rouge on ecrit le commentaire du fichier de donnees
    rouge "\n\n$infile \n"
    rouge "\n$references\n"
    update
    set colonnes [mcols $pop]
    set lignes [mrows $pop]
    
    # En bleu on ecrit les premieres lignes et colonnes du fichier de donnees ...
    #bleu "\nArchivo contenido (parcialmente):"
    #$p insert end "\n[show [mrange $pop 0 [expr {$colonnes - 1} ] 0 4 ] ] \netc. \n"
    update
    #vert "\nSON LOS DATOS LOGARITMOS NATURALES ? \n"
    
    # ... et d'autres infos sur ce fichier
    bleu "\nNumero de variables =\t"
    $p insert end "$colonnes\n"
    
    bleu "\nNumero de individuos =\t"
    $p insert end "$lignes\n"
}
#
# Procedure ENTRADA - fin


# PROCEDURE loadfile - DEBUT
#
proc loadfile {pathname} {
    
    if {$pathname != ""} {
        global S
        set S(dist_nopar) 0
        set S(datadir) $pathname
        set fid [open $pathname]
        set text [read -nonewline $fid]
        close $fid
        set rowcount 0
        set colcount 0
        global references
        set compteur 0
        set lignes 0
        set data ""
        foreach line [split $text \n] {
            incr compteur
            if {$compteur >1} {
                if  {$line != ""} {
                    set colcount [llength $line]
                }
            }
            if {$compteur>1} {
                foreach item [split $line] { if {$item != ""} {
                        incr lignes;lappend data $item
                    }
                }
            } else {set references $line}
        }
        set rowcount [expr {$lignes / $colcount}]
        set result [concat 2 $rowcount $colcount $data]
        #debug
        #puts "Commentaire brut :\n$references"
        # -- Formater le commentaire
        # -- 1. Enlever d'eventuelles tabulations
        foreach mot $references {
            if {$mot != ""} {
                append comentario_sin_tab "$mot "
            }
        }
        set references $comentario_sin_tab
        set S(references) $references
        # -- FIN du formatage de la premiere ligne
        
        # Il faudrait creer le meme fichier en .nts (pour TPSregr) - debut
        # Le fichier cree est _PW_CS.nts, ce n'est pas tres utile ...
        set datos ""
        set compteur 0
        foreach truc [split $text "\n"] {
            if {$compteur > 0} {
                if {$truc != ""} {lappend datos "$truc\n"}
            } else {
                lappend datos "\"$truc\n"
            }
            incr compteur
        }
        # Enlever les curved brackets
        set datos [regsub -all {\{|\}} $datos ""]
        #
        set ntscode "1 $rowcount $colcount 0\n"
        set ntsmatrix $ntscode$datos
        # puis l'enregistrer ...
        # OPEN THE FILE
        set extension ".nts"
        set nameoffile "/[file tail [file rootname $pathname]]"
        set filename [file dirname $pathname]$nameoffile$extension
        set fileid [open $filename w]
        # FILL THE FILE
        puts -nonewline $fileid $ntsmatrix
        # CLOSE THE FILE
        close $fileid
        #
        # Il faudrait creer le meme fichier en .nts (pour TPSregr) - fin
        # Le fichier cree est _PW_CS.nts, ce n'est pas tres utile ...
        return $result
    }
}
#
# PROCEDURE loadfile - FIN


# Procedure CHEMIN -start
#
proc chemin {} {
    
    global p dossier
    
    if {[info exists dirinfile] == 0} {
        set dirinfile [pwd]
    }
    
    # ----------------------------------------------------
    # Nom du FICHIER et son CHEMIN (path) CORRESPONDANT
    # ---------------------------------------------------
    
    
    # Chercher le chemin dans un fichier de configuration
    # 1. verifier que le fichier de configuration existe
    set chemin "[pwd]/dossier_cov.txt"
    #puts "chemin $chemin"
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
        set candidat_dossier [pwd]
    } else  {
        #puts "La conf existe"
        # 3. s'il existe reccueillir le dernier chemin parcouru
        # open le fichier pour lire
        catch [
        set fid [open $chemin r]
        set candidat_dossier [read -nonewline $fid]
        close $fid
        ] ici
        #puts "candidat_dossier $candidat_dossier"
        set candidat_dossier [lindex [split $candidat_dossier \n] 1]
        # debug
        #puts "dossier = $candidat_dossier"
    }
    
    # On va chercher les donnees
    
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
    
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
        # open le fichier de conf pour ecrire
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilisees par COV:\n"
        puts -nonewline $fid $dossier
        close $fid
        ] ici
    }
    
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    
    # --------------------------------------------------------
    # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE pop
    # --------------------------------------------------------
    return $infile
}
#
# Procedure CHEMIN - end

# Procedure WHICHMATRIX - start
#
proc whichmatrix {} {
    global p infile dossier
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [chemin];# usage de la procedure CHEMIN : memoire des dossiers anterieurs
    set x [loadfile $infile]; # usage de la procedure LOADFILE
    
    if {$x != ""} {
        
        entrada $x $infile;# usage de la procedure ENTRADA: presentation de la matrice loadee
        $p insert end "\nMatrix X:\t----------------------------------start---\n"
        #$p insert end [show $x %8.3f]
        if {[mrows $x] < 30} {
            $p insert end "\n\n[show $x %8.3f]"
        } else  {
            $p insert end "\n\n[show [mrange $x 0 end 0 29] %8.3f] \n...\netc. etc.\n"
        }
        $p insert end "\nMatrix X:\t----------------------------------end----\n\n"
    }
    return $x
}
#
# Procedure WHICHMATRIX - end


# Procedure COPrI -- debut
#
proc copri {x} {
    global S
    # Cette procedure obtient les composantes principales
    # et pourrait s'appeler silent_pca
    set pop $x
    set colonnes [mcols $pop]
    set lignes [mrows $pop]
    set cellules [expr {$lignes * $colonnes}]
    #CREER n-1 POUR CALCULER (plus tard) LES VARIANCES (eigenvalues)
    set obsminusone [expr {$lignes - 1}]
    # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
    mnorms_br pop popmeans popsigmas
    # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
    # IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
    set popones "2 1 $colonnes 1"
    set x 1
    set y $colonnes
    while {$x < $y} {lappend popones 1; set x [expr {$x + 1} ] }
    # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
    #Les donnees sont ensuite 'centrees' (chaque colonne par sa moyenne)\
    #cfr. Hume |'normalizing each column by substracting its corresponding mean'|\n"
    set Z [mnormalize $pop $popmeans $popones]
    set ZZ [mmult [transpose $Z] $Z]
    # The varcov matrix, or matrix of mean square VCM = (Zt)(Z)/(n-1) :
    # Il s'agit d'une multiplication de la matrice des donnees centrees par sa transposee,
    # chaque element de la matrice resultante ([mrows $ZZ] x [mcols $ZZ]) est divise ensuite
    # par le nombre d'individus moins un.
    set nless1 [expr {1./$obsminusone}]
    set vcm [mscale $ZZ $nless1]
    # Continuing the naive example use V = VARCOV for the eigensolution
    # SINGULAR VALUE DECOMPOSITION SUR LA MATRICE varcov (vcm)
    #
    set V $vcm
    mevsvd_br V evals
    # evals contient les eigenvalues
    set S(eigen) $evals
    # V contient les eigenvectors (coefficients)
    #
    # COMPOSANTES PRINCIPALES (cp)
    # ---------------------------------------------
    global cp
    set cp [mmult $pop $V ]
    #
    # CENTRER LES COMPOSANTES PRINCIPALES ...
    mnorms_br cp cpmeans cpsigma
    set copri [mnormalize $cp $cpmeans $popones]
    # Scores individuels = individus
    global individus
    set individus ""
    for {set u 0} {$u < $lignes} {incr u} {
        lappend individus [mrange $copri 0 end $u $u]
    }
    return $copri
}
#
# Procedure COPRI - end


# Procedure COMPOSANTES - start
#
proc composantes {pop} {
    global p suit_rot pxpu
    set lignes [lindex $pop 1]
    set colonnes [lindex $pop 2]
    set obsminusone [expr {$lignes - 1}]
    # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
    mnorms_br pop popmeans popsigmas
    # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
    # IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
    set popones "2 1 $colonnes 1"
    set x 1
    set y $colonnes
    while {$x < $y} {lappend popones 1; set x [expr {$x + 1}]}
    # CENTRER LES DONNEES PLUTOT QUE LES NORMALISER
    # ------------------------------------------------
    set Z [mnormalize $pop $popmeans $popones]
    # SINGULAR VALUE DECOMPOSITION using VARCOV for the eigensolution
    # ---------------------------------------------------------------
    set Z [mnormalize $pop $popmeans $popones]
    set ZZ [mmult [transpose $Z] $Z]
    set nless1 [expr {1./$obsminusone}]
    set vcm [mscale $ZZ $nless1]
    set V $vcm
    mevsvd_br V evals
    # V     : contient les eigenvecteurs (non ajustes)
    # evals : contient les eigen values
    
    return $V
}
#
# Procedure COMPOSANTES - fin



# Procedure PARTIALW - (partial warps scores) - debut
#
# 1. Calcul des pw scores, composante uniforme
#
# 2. Calcul des partial warps scores selon '1/sqrt(n) . Vi . E. (alpha = 0, donc scale = 1)'
#
### 'Partial warps scores are the inner product of each row of Vi = Xi - Xc with the p-k-1 columns of E (Rohlf, 1996).'
#
proc partialw {i objet matrefer prinw} {
    
    global p lm
    
    # L'objet et la reference
    set grandxi [transpose $objet]
    set reference [transpose $matrefer]
    # Vi = difference entre objet et reference
    set grandvi [msub $grandxi $reference]
    
    # -------------------------------------------------------------------
    #
    # Composante AFFINE, ou UNIFORME, de la CONFORMATION
    #
    # -------------------------------------------------------------------
    
    # -------------------------------------------------------------------
    # Toujours le calcul des U1 et U2 commence dans la procedure rotation
    # -------------------------------------------------------------------
    # Preparation du calcul de U1 et U2
    set grandxi2 [mprod $grandxi $grandxi]
    set grandxi2 [transpose $grandxi2]
    set prelambda [msum $grandxi2]
    set l1 [lindex $prelambda 3]
    set l2 [lindex $prelambda 4]
    set raizl1l2 [expr {sqrt($l1 * $l2)}]
    
    set col2 [mrange $grandxi 0 [expr {$lm-1}] 0 0]
    set col1 [mrange $grandxi 0 [expr {$lm-1}] 1 1]
    set ixdnarg [join_rows $col1 $col2]
    
    # ---------------------------------
    # Le calul de U2
    # ---------------------------------
    #
    set proU2 [mprod $grandxi $grandvi]
    
    set proU2 [transpose $proU2]
    set preU2 [lindex [msum $proU2] 4]
    set U2($i) [expr {$preU2/$raizl1l2}]
    #
    # ---------------------------------
    # Le calul de U1
    # ---------------------------------
    #
    # Le calcul de U1 est plus alambique !
    set presydeltax [mprod $ixdnarg $grandvi]
    set presydeltax [transpose $presydeltax]
    set sydeltax [lindex [msum $presydeltax] 3]
    # debug
    # $p insert end "\n\nsydeltax $sydeltax"
    set sxdeltay [lindex [msum $presydeltax] 4]
    set sumoins [expr {$sxdeltay - $sydeltax}]
    set l2moins [expr {$l2 * $sumoins}]
    set U1($i) [expr {($sydeltax + $l2moins)/$raizl1l2}]
    # debug
    # $p insert end "\n\nsydeltax $sydeltax"
    # $p insert end "\n\nIndividu $i \nU1\t $U1($i)\nU2\t $U2($i)"
    set uniform "2 1 2 $U1($i) $U2($i)"
    #
    # --------------------------------------------------------------------
    #
    # Composante NON AFFINE ou NON UNIFORME de la CONFORMATION
    #
    # --------------------------------------------------------------------
    # RETRAIT DU SCALEFACTOR Juillet 2006
    set scalefactor 1
    ## 1/sqrt(n)
    #set scalefactor [expr {1.0*(1.0/sqrt(2))}]
    ## 1/sqrt(n) . Vi
    set propw [mscale $grandvi $scalefactor]
    # 1/sqrt(n) . Vi . E. (alpha = 0, donc scale = 1)
    set prepw [mmult $propw $prinw]
    set partialwarps($i) [transpose $prepw]
    #
    # --------------------------------------------------------------------
    #
    # Les deux composantes AFFINE, et NON AFFINE, dans une meme matrice
    #
    # --------------------------------------------------------------------
    #
    set partialwarps($i) [join_rows $partialwarps($i) $uniform]
    # debug
    #$p insert end "\n\npartialwarps de $i\n$partialwarps($i)"
    return $partialwarps($i)
}
#
# procedure PARTIAL warps


# Procedure PRINWARPS = principal warps ## Debut
#
proc prinwarps {reference} {
    global p lm
    # D'abord construire la L matrix, puis l'inverser, puis prendre le bloc pxp
    #
    # L matrix Etape 1.
    # ----------------------
    # Le bloc 'pxp' en haut a gauche est la matrice 'U'
    for {set i 0} {$i < [expr {$lm*2}]} {incr i 2} {
        set x1 [lindex $reference $i]
        set y1 [lindex $reference [expr {$i+1}]]
        #$p insert end "\n\n---- x$i = $x1\ty$i = $y1\n\n"
        for {set j 0} {$j < [expr {$lm*2}]} {incr j 2} {
            set x2 [lindex $reference $j]
            set y2 [lindex $reference [expr {$j+1}]]
            #$p insert end "x$j = $x2\ty$j = $y2\n"
            #$p insert end "r2 = [expr ( pow(($x1-$x2),2))] + [expr (pow(($y1-$y2),2 ) ) ]\n"
            set r2 [expr {pow(($x1-$x2),2) + pow(($y1-$y2),2)} ]
            if {$r2 != 0} {set lnr2 [expr {log($r2)}]}
            if {$r2 != 0} {set r2lnr2 [expr {$r2*$lnr2}]}
            if {$r2 != 0} {append preU "$r2lnr2 "} else {append preU "0.000000 "}
        }
    }
    set U "2 $lm $lm $preU"
    
    # L matrix Etape 2.
    # ---------------------
    # A cette matrice 'U' de distances je joins 3 colonnes,
    # l'une de 1 et les deux autres contenant la reference (l'objet consensus)
    set popones "2 $lm 1 1 "
    set x 1
    set y $lm
    while {$x < $y} {lappend popones 1; set x [expr {$x + 1}]}
    set consens "2 $lm 2 $reference"
    # debug
    # $p insert end "\n On va tenter de fusionner\n[show $popones]\net\n[show $consens %1.4f]"
    set ajoutdroit [join_cols $popones $consens]
    # debug
    # $p insert end "\n On va  la lui ajouter a droite \n[show $ajoutdroit %1.4f]"
    set U_droit [join_cols $U $ajoutdroit]
    # debug
    # $p insert end "\nSoit:\n[show $U_droit %1.4f]"
    #
    # L matrix Etape 3.
    # ----------------------
    # A cette nouvelle matrice de lm+3 colonnes j'ajoute 3 lignes bas,
    # l'une de 1 et les deux autres contenant la reference (l'objet consensus)
    # puis je termine la matrice par des zeros (dans le coin inferieur droit)
    set preajoutbas [transpose $ajoutdroit]
    set leszeros "2 3 3 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0"
    set ajoutbas [join_cols $preajoutbas $leszeros]
    # debug
    # $p insert end "\n On va lui ajouter en bas \n[show $ajoutbas %1.4f]"
    set U_droit_bas [join_rows $U_droit $ajoutbas]
    # debug
    # $p insert end "\n Soit alors \n[show $U_droit_bas %1.4f]"
    
    # Inverse de la matrice L
    set Lmatrix $U_droit_bas
    
    set identite [mident [expr {$lm+3}]]
    set invLmatrix [msolve $Lmatrix $identite]
    # debug
    #$p insert end "\n Inverse of L \n[show $invLmatrix %1.6f]"
    # set verification [mmult $Lmatrix $invLmatrix]
    # $p insert end "\nVERIFICATION DE L'INVERSE\n[show $verification %1.0f]"
    
    # Upper left 'p x p' bloc of this matrix as the bending energy matrix
    set bendingenergy [mrange $invLmatrix 0 $lm 0 $lm]
    
    # APPEL a  COMPOSANTES
    # Principal warps (appel a la procedure 'composantes')
    global pxpu
    set pxpu 1
    set V [composantes $bendingenergy]
    set prinW [mrange $V 0 [expr {$lm-4}] 0 [expr {$lm-1}]]
    #$p insert end "\n\nPRINCIPAL WARPS\n(eigenvectores of bending energy matrix)\
    \n\tMatrix size is 'p x (p - k - 1)'\
            \n\t(p = number of landmarks; k = number of dimensions)\
            \n[show $prinW %1.4f]"
    return $prinW
}
#
# Procedure PRINCIPAL warps




# Procedure PARTIALITE ## Debut ###
#
proc partialite {reference} {
    # reference (au singulier) contient le consensus
    global p suit_part
    global rawindividus;#en general pour calculer le nombre d'individus (lignes)
    global rot;#variable monoindicee, contient les coordonnees apres ROTATION
    global lm
    global infile l1 l2 raizl1l2 ecnerefer prinw
    global tailles_base;#la liste des tailles centroides
    set consensus 0
    #
    set mmm [llength $rawindividus]
    set lignes [expr {$mmm/$lm}]
    #puts "lignes de la base = $lignes"
    #
    if {[info exists suit_part] == 0} {
        #$p insert end "\n\n--------------------------------------------"
        #$p insert end "\nNow computing PARTIAL WARPS SCORES ...\
        \n...according to '1/sqrt(n) . Vi . E. (alpha = 0, hence scale = 1)', see Rohlf (1996)"
        #$p insert end "\n--------------------------------------------\n\n"
    }
    
    # APPEL a PRINW
    # Calcul des 'principal' warps a l'aide de la procedure PRINW (eigenvectors of the inverse of Lp)
    set prinw [prinwarps $reference]
    
    # APPEL a PARTIALW
    # Calcul des 'partial' warps 'scores' a l'aide de la procedure PARTIALW
    for  {set i 1} {$i < [expr {$lignes+1}]} {incr i} {
        set objet $rot($i)
        set matrefer [concat "2 $lm 2" $reference]
        set partialwarps($i) [partialw $i $objet $matrefer $prinw]
    }
    if {[info exists suit_part] == 0} {
        set compteur 0;#il n'existe pas un individu consensus rote
        while {$compteur < $lignes} {
            incr compteur
            if {[info exists suit_part] == 0} {
                append partindiv "[lrange $partialwarps($compteur) 3 end]\n"
                append cs_pw_base "[lindex $tailles_base $compteur] [lrange $partialwarps($compteur) 3 end]\n"
            }
        }
    }
    if {[info exists suit_part] == 0} {
        return $partindiv
    }
    
    set suit_part "1"
    return $partindiv
}
#
# Procedure PARTIALITE - fin


# Procedure TRANSLATION # debut
#
proc translation {lm} {
    global p
    #
    global rawindividus;# on en a besoin pour le calcul du nombre de lignes
    set mmm [llength $rawindividus]
    set lignes [expr {$mmm/$lm}]
    #
    global polygone;#sert a quoi ?
    #
    global suit_tran suit_cons nosi suit_rot susnesnoc references
    set susnesnoc 0
    set nosi 0
    if {[info exists suit_tran] == 0} {#$p insert end "\n\nTRANSLACION de los OBJETOS \
                sobre UN mismo CENTROIDE\n"}
    if {[info exists objet_cons]} {unset objet_cons}
    set suit_cons 0
    #
    # Matrices I, P, I-P
    global  grandp imoinsp
    set identite [mident $lm]
    set unsurp [expr {1.0 / $lm}]
    set grandp "2 $lm $lm"
    for {set i 0} {$i < [expr {$lm*$lm}]} {incr i} {
        append grandp " $unsurp"
    }
    set imoinsp [msub $identite $grandp]
    #
    # Translation ou pre-multiplication des matrices par I-P
    global translatedx
    global tablind
    for  {set i 0} {$i < [expr {$lignes+1}]} {incr i} {
        set x "2 $lm 2 $tablind($i)"
        set translatedx($i) [mmult $imoinsp $x]
        if {[info exists suit_tran] == 0} {#$p insert end "\nTranslated matrix object $i\
                    \n[show $translatedx($i)]\n"}
    }
    # Il n'y a pas de 'return', les donnees apres translation sont dans une variable globale monoindicee = 'translatedx()'
}
#
# Procedure TRANSLATION- fin


# Procedure SCALING - debut
#
proc scaling {lm} {
    global references
    global p imoinsp;#pour calculer proctr
    
    global translatedx preindividus;# Ce sont les coordonnees obtenues apres la TRANSLATION
    
    global polygone;#sert a quoi ?
    global suit_rot neweff centroid;#sert a quoi ?
    #
    global transcaledindiv transcaledtotal
    global tailles_base
    global consensus
    global susnesnoc nosi
    # Aout 2006 Mise a zero des variables d'accumulation
    set transcaledtotal ""
    set centroide ""
    set tailles_base ""
    set consensus 0
    set susnesnoc 0
    set nosi 0
    #set suit_rot 0
    #
    global rawindividus;# pour compter le nombre de lignes
    set mmm [llength $rawindividus]
    set lignes [expr {$mmm/$lm}]
    #
    # informe
    global suit_scal
    if {[info exists suit_scal] == 0} {#$p insert end "\n\n\nSCALING to UNIT Centroid Size\n"}
    
    set suit_cons 0
    #
    # UNIT CTR Scaling to unit centroid size
    global translatedx;# contient les coordonnees de chaque individu apres translation - c'est une variable monoindicee
    for  {set i 0} {$i < [expr {$lignes+1}]} {incr i} {
        set ttranslatedx($i) [transpose $translatedx($i)]
        set prectr [mmult $translatedx($i) $ttranslatedx($i)]
        set proctr [mmult $prectr $imoinsp]
        set presquectr [transpose $proctr]
        # La taille centroide elevee au carre est la trace de presquectr
        set prectr2 [vdiag $presquectr]
        set proctr2 [vtrim $prectr2]
        set ctr2 0
        foreach item $proctr2 {set ctr2 [expr {$ctr2+$item}]}
        set ctr [expr {sqrt($ctr2)}]
        set centroid($i) $ctr
        set scalefactor [expr {1.00000/$ctr}]
        set transcaledindiv($i) [mscale $ttranslatedx($i) $scalefactor]
        set transcaledindiv($i) [transpose $transcaledindiv($i)]
        #
        # informe
        if {[info exists suit_scal] == 0} {
            append transcaledtotal "[lrange $transcaledindiv($i) 3 end]\n"
            append centroide "$ctr\n"
            append tailles_base "$ctr "
        }
    }
    # JUILLET 2006
    return $tailles_base;# a qui est destine ce return ?
}
#
# Procedure SCALING - fin


# Procedure ROTATION - debut
#
proc rotation {} {
    #
    # procedure appelee par SUBDIVIDED_MATRIX_PW
    #
    global p infile
    global  lm colonnes
    global polygone;#sert a quoi ?
    global references;# contient les COMMENTAIRES, attention ! la variable existe aussi au singulier (elle contient alors le consensus)
    
    #
    global rawindividus
    set mmm [llength $rawindividus]
    set lignes [expr {$mmm/$lm}]
    #
    global consensus susnesnoc suit_cons nosi indivmoy suit_rot
    set consensus 0
    set susnesnoc 1
    set suit_cons 1
    set nosi 0
    set indivmoy 0;#pour ne pas repeter les rapports du bouton jpdraw/moyens
    if {[info exists suit_rot] == 0} {#$p insert end "\n\nROTATION (aligned specimens)"}
    #
    global transcaledindiv
    set V [composantes $transcaledindiv(0)];# V contient les eigenvecteurs
    set prex1t [mmult $transcaledindiv(0) $V ]
    #
    # Debug
    if {[info exists suit_rot] == 0} {$p insert end  "\n\nConsensus aligned to its \
                principal component axes\n\n[show $prex1t %1.4f]\n"}
    #
    # formation des points (individus) du consensus prex1t
    global objet_cons
    set landmark 0
    for  {set i 3} {$i < [expr {$lm*2+2}]} {incr i 2} {
        incr landmark
        set item [lrange $prex1t $i [expr {$i+1}]]
        if {$item != ""} {lappend objet_cons "2 1 2 $item"}
        if {[info exists suit_rot] == 0} {append aligned "$item "}
    }
    if {[info exists suit_rot] == 0} {append aligned "\n"}
    #$p insert end "\n$objet_cons"
    #
    # Le consensus dans la variable reference (ici le mot reference est au singulier)
    global reference
    if {[info exists suit_rot] == 0} {set reference $aligned}
    if {[info exists suit_rot] == 0} {$p insert end  "\nConsensus de la variable 'reference' \n $aligned \n"}
    #
    # Donc, le consensus aligne sur ses composantes principales est dans une matrice de Hume 'prex1t' et dans une liste 'reference'
    #
    # references au pluriel c'est la premiere ligne du fichier de donnees (cfr loadfile)
    #
    # Rotations proprement dites
    global rot;# variable globale monoindicee, contient les coordonnees apres rotation
    set x1t [transpose $prex1t]
    for  {set i 1} {$i < [expr {$lignes+1}]} {incr i} {
        set ttrantran($i) [mmult $x1t $transcaledindiv($i)]
        # singular value decomposition
        set U $ttrantran($i)
        msvd_br U S V
        set S "2 2 2 1 0 0 1"
        set H [mmult [mmult $V $S] $U]
        set rot($i) [mmult $transcaledindiv($i) $H]
        #debug oct 2008 -- start
        rouge "\ncoord resid indiv $i : $rot($i)"
        # Pour une distance entre deux individus, il n'y a que deux individus
        # Une iteration ne sera necessaire que pour plus de deux individus
        #    #    Somme des distance de Procrustes entre les rot() et le consensus qui devrait etre dans rot(0) ??
        # Consensus dans rot(0);# rouge"rot(zero) :\n[show $prex1t %1.4f]\n" ?
        #debug oct 2008 -- end
    }
    #debug
    #rouge "aligned $aligned"
}
#
# Procedure ROTATION - fin

# Procedure SUBDIVIDED_MATRIX_PW_sansPartialite - debut
#
proc subdivided_matrix_pw_sansPartialite {mdonnees} {
    # 'mdonnees' est une matrice au format HUME
    #
    #$p insert end "\nDONNEES INITIALES\n[show $mdonnees %1.3f]\n"
    #
    # procedure appelee par la COMMANDE : Menu -> Single matrix -> Partial and Relative Warps scores
    #
    #  procedure appelee par la COMMANDE : Menu -> Subdivided matrix -> "Sub-matrix: Partial and Relative Warps scores."
    #
    # procedure appelee par la COMMANDE : Menu -> Subdivided matrix -> Metric disparity of Shape
    #
    # procedure appelee par la COMMANDE : Menu -> Subdivided matrix -> Qst
    #
    
    # la SUPERPOSITION DE PROCRUSTES ci-dessous aboutit au calcul du consensus 'reference'
    #
    # lequel est alors envoye dans la procedure PARTIALITE
    #
    # La procedure PARTIALITE devrait etre externe, non interne, car en interne on devrait se concentrer sur le calcul de 'reference'
    # (ou vice versa)
    #
    # du style
    # set reference [superposition_procruste mdonnees] <- contiendrait la procedure sauf l'appel a PARTIALITE
    # on pourrait alors
    # 1. calculer les distances de procruste entre chaque objet et reference
    # 2. garder en memoire 'mindist'
    # du style WHILE DIFFMINDIST > 0.00001
    # 3. reiterer set reference [superposition_procruste mdonnees] <- la procedure sauf l'appel a PARTIALITE mais avec les donnees nouvelles
    # 1a. calculer les distances de procruste entre chaque objet et reference
    # 2a. garder en memoire 'mindist' comparer avec la premiere mindist
    # ... s'arreter si 'diffmindist' < 0.00001 (par exemple)
    
    global p S
    global reference;# au singulier, ce mot designe la variable qui contient le consensus
    #
    # ----------------------------------------------- debut ---
    # ... ?
    global lignes colonnes lm
    set matinit [lrange $mdonnees 0 2]
    set lignes [lindex $matinit 1]
    set colonnes [lindex $matinit 2]
    set lm [expr {$colonnes/2}]
    #$p insert end "\n\n$lignes\tconfiguraciones\n$lm\tlandmarks\n"
    #
    # calcul du consensus (configuration moyenne)
    set consensus [mnorms $mdonnees]
    set consensus [lrange $consensus 3 [expr {3 + $colonnes - 1}]]
    set consensus [lformat %1.9f $consensus];# pourquoi tronquer ?
    set donnees [lrange $mdonnees 3 end]
    set data ""
    for  {set i 0} {$i < [expr {$lignes * $colonnes}]} {incr i $colonnes} {
        set tranche [lrange $donnees $i [expr {$i+$colonnes-1}]]
        append data "$tranche\n"
    }
    #
    # On classe les coordonnees successives par individu dans la table tablind()
    global tablind
    if {[info exists tablind]} {unset tablind}
    set i -1
    set compteur 0
    set tablind(0) $consensus
    foreach item [split $data "\n"] {
        #$p insert end "\n\nPour tablind:\n$item\n"
        if {$item != ""} {
            # On saute la premiere ligne
            incr compteur
            if {$compteur > 0} {
                #verification du nombre de lm de chaque individu
                if  {$colonnes != [llength $item]} {
                    $p insert end "$lm <> [llength $item]"
                    exit
                }
                incr i
                set tablind($compteur) $item
            }
        }
    }
    # Le consensus se trouve, ici ou la, dans 3 variables, consensus, reference, tablind(0) ... ??
    $p insert end "\n\nCONFIGURATION CONSENSUS \n$tablind(0)\n"
    
    # On cree une LISTE (un individu) de MATRICES (de coordonnees)
    # (une matrice est un couple de coordonnees, elle a 1 ligne et 2 colonnes)
    # (chaque 'landmark' est une 'matrice')
    global rawindividus
    #
    if {[info exists rawindividus]} {unset rawindividus} else {set rawindividus ""}
    set n [llength $data]
    #$p insert end "\nCREATION DES INDIVIDUS"
    for  {set i 0} {$i < $n} {incr i 2} {
        set item [lrange $data $i [expr {$i+1}]]
        #$p insert end "\nITEM = \t$item"
        lappend rawindividus "2 1 2 $item"
    }
    
    # debug oct 2008
    #
    
    #
    # SUPERPOSITION DE PROCRUSTES
    #
    # 1. TRANSLATION
    # ... la procedure TRANSLATION travaillera sur 'rawindividus' pour calculer le nb de lignes de la matrice (variable globale)
    # ... et sur la table 'tablind()' pour operer la translation; c'est une variable (globale) monoindicee, 'tablind(0)' contient le consensus
    set preindividus [translation $lm]
    # 2. SCALING
    set proindividus [scaling $lm]
    set S(ctr) $proindividus
    # 3. ROTATION
    rotation;# Les coordonnees apres ROTATION se trouvent dans la variable globale monoindicee 'rot'
    
    #JE NE L'AI PAS ENCORE ENLEVE ! ! !
    
    # Calculs PW proprement dits
    #
    vert "\n$reference\n"
    return [partialite $reference];# a placer dans une variable indicee - 'reference' contient le consensus (moyenne des individus) APRES rotation
    # ---------------------------------------------------------
}
#
# Procedure SUBDIVIDED_MATRIX_PW - fin

# Procedure CALCUL_PW
#
proc  calcul_PW {} {
    #Une fois que le consensus est etabli, fixe (variable 'reference'), on peut passer au calcul des PW
    vert "\n$reference\n"
    return [partialite $reference];# a placer dans une variable indicee - 'reference' contient le consensus (moyenne des individus) APRES rotation
    # ---------------------------------------------------------
}


# Procedure MOD - debut
#
proc mod {} {
    
    global p drapeau S references version bID_Inter
    
    set drapeau 1
    set S(drapeau) 1
    
    #set S(save) "_INFO_COV.txt"
    
    # -----------------------------------------------------------------------------
    # FENETRE PRESENTATION de la MATRICE (procedure mod)
    # ------------------------------------------------------------------------------
    
    set fp .muestreo
    catch {destroy $fp}
    catch {toplevel .muestreo}
    wm state . withdrawn
    
    set titre "COV version iteration"
    wm title .muestreo $titre
    wm geometry $fp 800x600+50+10
    
    frame $fp.buttons
    pack $fp.buttons -side bottom -fill x -pady 2m
    
    button $fp.buttons.informe -text "Save report ?" -command {
        global S
        if {$S(save) != "_INFO_COV.txt"} {
            savelisting $S(save)
        } else  {
            savelisting "_INFO_COV.txt"
        }
        
        
    }
    
    button $fp.buttons.wrap -text "Wrap" -command {
        global drapeau
        if {[info exists drapeau]} {
            if {$drapeau == 1} {
                .muestreo.debut configure -wrap word; set drapeau 0
            } else {
                .muestreo.debut configure -wrap none; set drapeau 1
            }
        } else  {
            set drapeau 1
        }
    }
    
    button $fp.buttons.clean -text "Clean Output" -command {
        global p
        $p delete 0.0 end
    }
    
    button $fp.buttons.reset -fg red -text "Reset" -command {
        set avertisse "Memory will be cleared (except current output)"
        set answer [tk_messageBox -message $avertisse -title "SURE ?" -type okcancel -icon warning]
        switch -- $answer {
            ok {unot;arranco}
            cancel {}
        }
    }
    
    button $fp.buttons.exit -fg red  -text "EXIT" -command {
        exit
    }
    
    pack $fp.buttons.wrap $fp.buttons.informe $fp.buttons.clean  $fp.buttons.reset $fp.buttons.exit \
            -side left -expand 1
    
    set scb [scrollbar .muestreo.scrollA -command ".muestreo.debut yview"]
    pack $scb -side left -fill y
    #set pres [text .muestreo.debut -background "light yellow" -font "courier 12" \
    -wrap word -yscrollcommand ".muestreo.scrollA set"]
    set p [text .muestreo.debut -background "light yellow" -font "courier 12" \
            -wrap word -yscrollcommand ".muestreo.scrollA set"]
    #pack $pres -side right -fill both -expand yes
    pack $p -side right -fill both -expand yes
    
    
    ################### bleu ##### Procedure ## Debut ##
    proc bleu {mesg args} {
        global p
        $p insert end $mesg "bleu"
    }
    $p tag configure bleu -foreground blue
    ################### bleu ####### PROCEDURE ## FIN ###
    
    ################### rouge ##### Procedure ## Debut ##
    proc rouge {mesg args} {
        global p
        $p insert end $mesg "rouge"
    }
    $p tag configure rouge -foreground red
    ################### rouge ####### PROCEDURE ## FIN ###
    
    ################### vert ##### Procedure ## Debut ##
    proc vert {mesg args} {
        global p
        $p insert end $mesg "vert"
    }
    $p tag configure vert -foreground "dark green"
    ################### vert ####### PROCEDURE ## FIN ###
    
    # --------------------------------------------------------------------------------
    # ------------------------------ MENU --------------------------- DEBUT ----------
    #
    # **********************procedure menu bar***********DEBUT******************
    #
    proc CreateMenubar {ttoplevel menubar} {
        set toplevel $ttoplevel
        menu $menubar -type menubar
        $toplevel configure -menu $menubar
    }
    # **********************procedure menu bar ***********FIN******************
    
    # **********************procedure menu ***********DEBUT******************
    #
    proc CreateMenu {menubar basename ttext mnemonic} {
        set text $ttext
        set menu_name "$menubar.$basename"
        $menubar add cascade -label $text -menu $menu_name -underline $mnemonic
        menu $menu_name
        return $menu_name
    }
    # **********************procedure menu ***********FIN******************
    destroy .menubar
    CreateMenubar .muestreo .menubar
    
    ## MENU POSIT 1  ------------------------------- start
    
    set menu_name [CreateMenu .menubar filemenu2 "One single matrix" 0]
    
    $menu_name add command -label "Partial and Relative Warps scores" -command {
        
        # On est dans le menu SINGLE MATRIX
        # La procedure qui calcule les PW a partir d'une matrice de coordonnees = 'SUBDIVIDED_MATRIX_PW',
        # meme si elle ne 'subdivise' pas la matrice.
        
        $p insert end "\nOutput file will be saved as 'name_of_file_INFO_COVpwrw.txt', if requested "
        
        global p S drapeau x_subd x_total individus
        # debug octobre 2008 - start
        global reference
        # debug octobre 2008 - end
        
        set S(save) "_INFO_COVpwrw.txt"
        
        # Remise a zero des variables utilisees
        set x_subd ""
        set x_total ""
        set x_total_pw ""
        set ctr_x_total_pw ""
        set ctr ""
        set S(ctr) ""
        set hume ""
        set hume_pw ""
        set hume_rw ""
        #debug
        #puts "S(ctr) $S(ctr)"
        #puts "\n **** Et une, une ! ***"
        
        tk_messageBox -message "Please open a file with RAW COORDINATES x,y"
        
        bleu "\nComputes PARTIAL WARPS scores, and RELATIVE WARPS.\n\
                \nThe PW are computed relative to the matrix consensus.\n"
        
        #la variable 'x_total' est une matrice au format HUME
        set x_total [whichmatrix]
        
        # Attention, ici le terme 'subdivided' s'applique bien à l'échantillon total ... et il ne le subdivise pas
        set x_total_pw [subdivided_matrix_pw_sansPartialite $x_total]
        
        # debug octobre 2008 - start
        set hume "2 [expr [mcols $x_total] * 1/2] 2"
        set reference [concat $hume $reference]
        rouge "consensus \n[show $reference]"
        # debug octobre 2008 - end
        
        # Organisation HUME des tailles
        set hume "2 [mrows $x_total] 1"
        set ctr [lrange $S(ctr) 1 end];# enlever le consensus
        #debug
        #puts "... et ctr ... \n$ctr"
        set ctr [concat $hume $ctr]
        #debug
        #puts "\nctr \n$ctr"
        $p insert end "\nCentroid sizes\n[show $ctr]\n"
        
        # calcul des RW - debut
        set hume "[lrange $x_total 0 1] [expr {[lindex $x_total  2]-4}]"
        set hume_pw [concat $hume $x_total_pw]
        set hume_rw [copri $hume_pw]
        
        # calcul des RW - fin
        
        set ctr_x_total_pw [join_cols $ctr $hume_pw]
        # Creation du contenu de _PW.CS.txt
        
        rouge "\n\nPARTIAL WARPS\n$x_total_pw\n"
        vert "\n\nRELATIVE WARPS \n[show $hume_rw]\n"
        
        # Embedded button pour voir un graphe
        destroy $p.embed_saplot
        button $p.embed_saplot -text "FACTOR MAP RW1 (horizontal) RW2 (vertical axis)" -command {
            global lignes colonnes effectifs
            if {[info exists individus] == 1} {
                unset lm;# sans quoi le JPDRAW refuse de trouver les 'effectifs' - cfr subextractcol
                dessine $individus
            }
        }
        #
        #
        $p insert end "\n"
        $p window create {end lineend} -window $p.embed_saplot
        bind $p.embed_saplot <Motion> {$p.embed_saplot configure -cursor hand1}
        #
        balloonhelp_for $p.embed_saplot "Graph RELATIVE WARPS scores"
        #
        #
        # Nom du fichier
        set sub "_PW"
        set end ".txt"
        set ajout $sub$end
        set infilesub "[file root $infile]$ajout"
        # Enregistrement de la sous-matrice de PARTIAL WARPS
        set fid [open $infilesub w]
        puts -nonewline $fid "$S(references): PARTIAL WARPS scores from $infile\n"
        puts -nonewline $fid $x_total_pw
        close $fid
        
        # Nom du fichier
        set sub "_PW_CS"
        set end ".txt"
        set ajout $sub$end
        set infilesub "[file root $infile]$ajout"
        # Enregistrement de la sous-matrice de PARTIAL WARPS
        set fid [open $infilesub w]
        puts -nonewline $fid "$S(references): CENTROID SIZES and PARTIAL WARPS scores from $infile\n"
        puts -nonewline $fid [show $ctr_x_total_pw]
        close $fid
        
        # Nom du fichier
        set sub "_RW"
        set end ".txt"
        set ajout $sub$end
        set infilesub "[file root $infile]$ajout"
        # Enregistrement de la sous-matrice de RELATIVE WARPS
        set fid [open $infilesub w]
        puts -nonewline $fid "$S(references): RELATIVE WARPS scores from $infile\n"
        puts -nonewline $fid [show $hume_rw]
        close $fid
        
    }
    
    $menu_name add separator
    
}
#
# Procedure MOD - fin

global p
mod




#set p [text .output -bg blue -fg white]
#pack .output
##
#set x 0
#set sdpp(0) 1;# sdpp = sumdistprocr_precedente - devrait envoyer a la procedure SUBDIVIDED_MATRIX_PW (mdonnees) sans PARTIALITE
#set dmd 1
#while {$dmd > 0.00001} {
#    incr x
#    set sdpp($x) [expr {$sdpp([expr {$x-1}]) - 0.1}];# nouvelle somme des dist de Procr, devient la precedente pour le cycle suivant
#    # La nouvelle somme dist de Procr devrait PROVENIR DE la procedure SUBDIVIDED_MATRIX_PW  (mdonnees), sans PARTIALITE
#    # mais avec les MDONNEES nouvelles, i.e. les valeurs apres rotation
#    # du style 'set mdonnees $rot', avant d'appeler : set sdpp($x) [SUBDIVIDED_MATRIX_PW (mdonnees)]
#    set dmd  $sdpp($x);# difference entre l'ancienne et la nouvelle dist de Procr
#    $p insert end "dmd vaut $sdpp([expr {$x-1}]) - 0.1, soit $dmd"
#    $p insert end "\n--------------------------------------\n"
#}
