source chull.tcl
source math/statistics.tcl;#n'est pas necessaire actuellement
source 100La.tcl
source jpdraw_10a.tcl
source ballons.tcl


# Procedure CHEMIN -start
#
proc chemin {} {
    
    global p dossier
    
    if {[info exists dirinfile] == 0} {
        set dirinfile [pwd]
    }
    
    # ----------------------------------------------------
    # Nom du FICHIER et son CHEMIN (path) CORRESPONDANT
    # ---------------------------------------------------
    
    
    # Chercher le chemin dans un fichier de configuration
    # 1. verifier que le fichier de configuration existe
    set chemin "[pwd]/dossier_cov.txt"
    #puts "chemin $chemin"
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
        set candidat_dossier [pwd]
    } else  {
        #puts "La conf existe"
        # 3. s'il existe reccueillir le dernier chemin parcouru
        # open le fichier pour lire
        catch [
        set fid [open $chemin r]
        set candidat_dossier [read -nonewline $fid]
        close $fid
        ] ici
        #puts "candidat_dossier $candidat_dossier"
        set candidat_dossier [lindex [split $candidat_dossier \n] 1]
        # debug
        #puts "dossier = $candidat_dossier"
    }
    
    # On va chercher les donnees
    
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
    
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
        # open le fichier de conf pour ecrire
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilisees par COV:\n"
        puts -nonewline $fid $dossier
        close $fid
        ] ici
    }
    
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    
    # --------------------------------------------------------
    # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE pop
    # --------------------------------------------------------
    return $infile
}
#
# Procedure CHEMIN - end


# PROCEDURE loadfile - DEBUT
#
proc loadfile {pathname} {
    global S
    set S(dist_nopar) 0
    set S(datadir) $pathname
    set fid [open $pathname]
    set text [read -nonewline $fid]
    close $fid
    set rowcount 0
    set colcount 0
    global references
    set compteur 0
    set lignes 0
    set data ""
    foreach line [split $text \n] {
        incr compteur
        if {$compteur >1} {
            if  {$line != ""} {
                set colcount [llength $line]
            }
        }
        if {$compteur>1} {
            foreach item [split $line] { if {$item != ""} {
                    incr lignes;lappend data $item
                }
            }
        } else {set references $line}
    }
    set rowcount [expr {$lignes / $colcount}]
    set result [concat 2 $rowcount $colcount $data]
    #debug
    #puts "Commentaire brut :\n$references"
    # -- Formater le commentaire
    # -- 1. Enlever d'eventuelles tabulations
    foreach mot $references {
        if {$mot != ""} {
            append comentario_sin_tab "$mot "
        }
    }
    set references $comentario_sin_tab
    # -- FIN du formatage de la premiere ligne
    
    # Il faudrait creer le meme fichier en .nts (pour TPSregr) - debut
    # Le fichier cree est _PW_CS.nts, ce n'est pas tres utile ...
    set datos ""
    set compteur 0
    foreach truc [split $text "\n"] {
        if {$compteur > 0} {
            if {$truc != ""} {lappend datos "$truc\n"}
        } else {
            lappend datos "\"$truc\n"
        }
        incr compteur
    }
    # Enlever les curved brackets
    set datos [regsub -all {\{|\}} $datos ""]
    
    set ntscode "1 $rowcount $colcount 0\n"
    set ntsmatrix $ntscode$datos
    # puis l'enregistrer ...
    # OPEN THE FILE
    set extension ".nts"
    set nameoffile "/[file tail [file rootname $pathname]]"
    set filename [file dirname $pathname]$nameoffile$extension
    set fileid [open $filename w]
    # FILL THE FILE
    puts -nonewline $fileid $ntsmatrix
    # CLOSE THE FILE
    close $fileid
    #
    # Il faudrait creer le meme fichier en .nts (pour TPSregr) - fin
    # Le fichier cree est _PW_CS.nts, ce n'est pas tres utile ...
    
    
    return $result
}
#
# PROCEDURE loadfile - FIN





proc kusk {liste} {

set mean [::math::statistics::mean $liste]
set stdev [::math::statistics::stdev $liste]
set n [llength $liste]

# KURTOSIS
#
# Le rapport entre le moment d'ordre 4 centré et le carré de la variance
set pre_kur 0
foreach item $liste {
    set pre_kur [expr {$pre_kur + pow((($item-$mean)*1/$stdev),4)}]
}
set pro_kur $pre_kur
#debug
puts "pre_kur $pre_kur n = $n \t 1/(n-1)  =  [expr {1.0 / ($n-1)}]"

set pre_kur [expr {$pre_kur * 1.0 / ($n-1)}]
puts $pre_kur
set a [expr {$n*($n+1) * (1.0 / (($n-1)*($n-2)*($n-3)))}]
set b [expr { (3 * pow( ($n-1),2) )  * (1.0 / ( ($n-2)*($n-3) ) )}]
set kur [expr {($a*$pro_kur) - $b}]

#A normal random variable has a kurtosis of 3 irrespective of its mean or standard deviation.
# If a random variable’s kurtosis is greater than 3, it is said to be  leptokurtic.
# If its kurtosis is less than 3, it is said to be platykurtic.



# SKEWNESS
# 
# Calcul du moment d'ordre 3 centré sur le cube de l'écart type
set ssk 0
foreach item $liste {
    set ssk [expr {$ssk + pow((($item-$mean)*1/$stdev),3)}]
}
set ssk [expr {$ssk * $n * 1.0 /(($n-1)*($n-2))}]

# The skewness takes on a positive value if 'liste' is positively skewed - right tail -
# and a negative value if 'liste'  is negatively skewed.


# REMARK
# Just as the mean and standard deviation can be distorted by extreme values in the tails,
# so too can the skewness and kurtosis measures.

set retour "$kur $ssk"
return $retour
}


global p infile dossier
set typeList {
    {{"Text files"} {.txt .nts .TXT .NTS} }
}
set infile [chemin];# usage de la procedure CHEMIN : memoire des dossiers anterieurs
set liste [vtrim [loadfile $infile]]
set kurske [kusk $liste]
puts "kurtosis [lindex $kurske 0]"
puts "skewness [lindex $kurske 1]"
exit