set euclist_doc "{10 1 2} {22 1 3} {192 1 4} {109 1 5} {210 1 6} {18 1 7} {180 1 8} \
        {113 2 3} {181 2 4} {132 2 5} {142 2 6} {192 2 7} {12 2 8} \
        {183 3 4} {171 3 5} {139 3 6} {172 3 7} {152 3 8} \
        {193 4 5}  {161 4 6} {196 4 7} {143 4 8} \
        {141 5 6} {122 5 7} {115 5 8} \
        {132 6 7} {101 6 8} {151 7 8}"

# AVANT, et pour PREPARER, les PERMUTATIONS
#
# Il faut avoir une LISTE des individus dans l'ordre des observation initiales
set total 8;#supposons un total de 8 individus,
# on crée alors la liste '1 2 3 ... 8' dans S(ind)
for {set i 0} {$i < $total} {incr i} {append S(ind) "[expr {$i+1}] "}
# Il faut que l'ordre de ces individus, au départ, corresponde à des groupes successifs (cfr. 'subdivision')
set subdivision "3 2 3"
# On crée alors la succession des effectifs cumulés (cfr 'subdaccum')
set compteur 0
foreach item $subdivision {
    if {$compteur > 0} {
        set zou [expr {$zou  + [lindex $subdivision $compteur]}]
        append subdaccum "$zou "
    } else {
        set zou [lindex $subdivision $compteur]
        append subdaccum "$zou "
    }
    incr compteur
}

# Vérification, SANS permutation
#
puts "---------------------\n$S(ind)\n---------------------"
set w ""
set b ""
foreach dist $euclist_doc {
    set bingo 0
    #On cherche d'abord la position permutée de chaque individu
    for {set i 0} {$i < [llength $S(ind)]} {incr i} {
        if {[lindex $dist 1] == [lindex $S(ind) $i]} {set pos_1 [expr {$i+1}]}
        if {[lindex $dist 2] == [lindex $S(ind) $i]} {set pos_2  [expr {$i+1}]}
    }
    #
    foreach item $subdivision truc $subdaccum {
        if {$pos_1 <= $truc && $pos_1 > [expr {$truc - $item}] } {incr bingo}
        if {$pos_2 <= $truc && $pos_2 >  [expr {$truc - $item}] } {incr bingo}
        if {$bingo == 2} {append w "[lindex $dist 0] "; break} else {set bingo 0}
    }
    if {$bingo < 2} {append b "[lindex $dist 0] "}
}
puts "w $w"
puts "b $b"

puts [list $w $b]

# A présent on essaye les pairwise: par exemple entre les indiv 1 2 3 et 6 7 8
# Supposons une autre permutation

# Entre le groupe 1 et 3
set ss 0
set zz 1

# Il faut que le numéro d'ordre des individus soit préservé (cfr. 'S(ind)')
set ind_part1_total [lindex $subdaccum $ss]
if {$ss == 0} {set depart 0} else {set depart [lindex $subdaccum [expr {$ss - 1}]]}
puts "depart $depart"
for {set i $depart} {$i < $ind_part1_total} {incr i} {append ind_pwise "[expr {$i+1}] "}
set ind_part2_total [lindex $subdaccum $zz]
if {$zz == 0} {set depart $ss} else {set depart [lindex $subdaccum [expr {$zz - 1}]]}
puts "depart $depart"
for {set i $depart} {$i < $ind_part2_total} {incr i} {append ind_pwise "[expr {$i+1}] "}
puts "ind_pwise !!!!! $ind_pwise"
#set ind_pwise "1 2 3 6 7 8"


# Il faut que la subdivision soit adaptée au nombre de groupes et à leur effectif correct
set subdivision_pwise "[lindex $subdivision $ss] [lindex $subdivision $zz]"
puts "subdivision_pwise $subdivision_pwise"


# Il faut enfin que le subdaccum compte le ou les groupes intermédiaires absents ...
puts "subdaccum $subdaccum"
set subdaccum_pwise "[lindex $subdaccum $ss] [lindex $subdaccum $zz]"


puts "-------------------------\nPwise $S(ind)\n-------------------------"
set w ""
set b ""
puts "subdivision_pwise $subdivision_pwise subdaccum_pwise $subdaccum_pwise"
foreach dist $euclist_doc {
    set pos_1 0
    set pos_2 0
    set bingo 0
    #0n cherche d'abord la position permutée de chaque individu
    for {set i 0} {$i < [llength $S(ind)]} {incr i} {
        puts "CYCLE des i : i = $i"
        if {[lindex $dist 1] == [lindex $S(ind) $i]} {
            puts "individu [lindex $S(ind) $i]\t'dist $dist ( [lindex $dist 1])' == 'lindex S(ind) $i' ?  \
                    [lindex $dist 1] == [lindex $S(ind) $i] ?"
            set pos_1 [expr {$i+1}]
            puts "pos_1 = $pos_1"
        }
        if {[lindex $dist 2] == [lindex $S(ind) $i]} {
            puts "individu [lindex $S(ind) $i]\t'dist $dist ( [lindex $dist 2])' == 'lindex S(ind) $i' ?  \
                    [lindex $dist 2] == [lindex $S(ind) $i] ?"
            set pos_2  [expr {$i+1}]
            puts "pos_2 = $pos_2"
        }
    }
    #
    set boulier 0
    set pos1 $pos_1
    set pos2 $pos_2
    foreach item $subdivision_pwise truc $subdaccum_pwise {
        incr boulier
        if {$pos1 > 0} {puts "pos1 $pos1"; set pos_1 [lindex $S(ind) [expr {$pos1 - 1}] ]} else {break}
        if {$pos2 > 0} {puts "pos2 $pos2"; set pos_2 [lindex $S(ind) [expr {$pos2 - 1}] ]} else {break}
        
        if {$pos1 <= $truc && $pos1 > [expr {$truc - $item}] } {incr bingo}
        if {$pos2 <= $truc && $pos2 >  [expr {$truc - $item}] } {incr bingo}
        puts "$boulier: gui $pos1 <= $truc && Individu $pos1 > [expr {$truc - $item}] ? Bingo $bingo"
        puts "$boulier: gui $pos2 <= $truc && Individu $pos2 > [expr {$truc - $item}] ? Bingo $bingo"
        if {$bingo == 2} {puts "INTRA\n"; append w "[lindex $dist 0] "; break} else {set bingo 0}
    }
    if {$bingo < 2 && $pos_1 > 0 && $pos_2 > 0} {puts "intER\n"; append b "[lindex $dist 0] "} else {puts "\n"}
}
puts "PAIRWISE w $w"
puts "PAIRWISE b $b"

exit