source 101La.tcl

# Procedure LLLPERMUTE - debut
#
# colonnes vaut toujours 1
# colonnesmoinsun toujours 0
proc lllpermute {chagre lignes} {
    set v $chagre
    for {set i [expr {$lignes-1}]} {$i > -1 } {incr i -1} {
        set debut 1
        set choix [expr {int($i * rand())}]
        set v [lset v $i [lindex $chagre $choix ]]
        set chagre [lreplace $chagre $choix $choix ]
    }
    return $v
}

#
# Procedure LLLPERMUTE - fin


# ---------------------------------------------- série des individus - debut
for {set i 1} {$i < 17} {incr i} {
    lappend a $i
}

set a "2 16 1 $a"
# --------------------------------------------- série des individus - fin

# --------------------------------------------- on suppose qu'il y a la moitie de distances INTRA
set lignes [mrows $a]
set w_nb [expr {int($lignes * 1.0/2) -1}]

set vta [vtrim $a]
# --------------------------------------------- Toutes les distances correspondant à ces individus
for {set i 0} {$i < $lignes} {incr i} {
    for {set j [expr {$i+1}]} {$j < $lignes} {incr j} {
        lappend dist "[lindex $vta $i] [lindex $vta $j]"
    }
}
set chagredist $dist

# ========================================
#
# On va chercher le package manu militari
load /opt/ActiveTcl-8.4/lib/Mk4tcl/Mk4tcl.so
#
#Create a datafile: "mk::file open tag filename"
mk::file open db distfile.mk
#
#Create a view (this is the Metakit term for "table"):
set vw1 [mk::view layout db.dist {eluno:I elotro:I}]
if {[mk::view size $vw1] > 0} {mk::row delete db.dist!0 [mk::view size $vw1]}
#
set vta [vtrim $a]
for {set i 0} {$i < $lignes} {incr i} {
    for {set j [expr {$i+1}]} {$j < $lignes} {incr j} {
        mk::row append $vw1 eluno [lindex $vta $i] elotro [lindex $vta $j]
    }
}
#
#Commit the changes to file: 'mk::file commit tag'
mk::file commit db
#
# ========================================

# --------------------------------------------- On permute les individus
set v [lllpermute $vta $lignes]
set elem $v

# --------------------------------------------- Algo de toujours
update
flush stdout
puts "Algo de tjrs\n[time {
    foreach kdist $dist {
        #0n cherche d'abord la position permutée de chaque individu
        for {set i 0} {$i < [llength $elem]} {incr i} {
            if {[lindex $kdist 0] == [lindex $elem $i]} {
                set pos_1 $i
            }
            if {[lindex $kdist 1] == [lindex $elem $i]} {
                set pos_2 $i
            }
        }
        #
        set e1 $w_nb
        if {($pos_1 <= $e1 && $pos_2 <= $e1) || ($pos_1 > $e1 && $pos_2 > $e1)} {
            lappend w [list [lindex $elem $pos_1] [lindex $elem $pos_2]]
        } else  {
            lappend b [list [lindex $elem $pos_1] [lindex $elem $pos_2]]
        }
    }
}]"
puts "w [llength $w] et b [llength $b] ----------- w_nb $w_nb"
puts "w:\n$w"
puts "b:\n$b"


# --------------------------------------------- Algo de toujours modifié ET METAKIT... ?
update
flush stdout
puts $v
puts "\nAlgo de tjrs MODIFIE etMETAKIT\n[time {
    mk::loop kdist $vw1 {
        #0n cherche d'abord la position permutée de chaque individu
        for {set i 0} {$i < [llength $elem]} {incr i} {
            if {[mk::get $kdist eluno] == [lindex $elem $i]} {
                set pos_1 $i
                set i [llength $elem]
            }
        }
        for {set i 0} {$i < [llength $elem]} {incr i} {
            if {[mk::get $kdist elotro] == [lindex $elem $i]} {
                set pos_2  $i
                set i [llength $elem]
            }
        }
        #
        #puts "(pos_1 $pos_1) [lindex $elem $pos_1] ## (pos_2  $pos_2)  [lindex $elem $pos_2]"
        set e1 $w_nb
        if {($pos_1 <= $e1 && $pos_2 <= $e1) || ($pos_1 > $e1 && $pos_2 > $e1)} {
            lappend wmk [list [lindex $elem $pos_1] [lindex $elem $pos_2]]
        } else  {
            lappend bmk [list [lindex $elem $pos_1] [lindex $elem $pos_2]]
        }
    }
}]"
puts "w_mk [llength $wmk] et b_mk [llength $bmk] ----------- w_nb $w_nb"
puts "w_mk:\n$wmk"
puts "b_mk:\n$bmk"

# 'elem' ou 'v' sont les données 'vta' permutées; la matrice hume de 'vta' est 'a'
#
# on va essayer lsearch

# --------------------------------------------- Algo de toujours modifié ET METAKIT... ?
update
flush stdout
puts $v
puts "\nAlgo de tjrs LSEARCH etMETAKIT\n[time {
    mk::loop kdist $vw1 {
        #0n cherche d'abord la position permutée de chaque individu
        set pos_1 [lsearch $elem [mk::get $kdist eluno]]
        set pos_2 [lsearch $elem [mk::get $kdist elotro]]
        #
        #puts "(pos_1 $pos_1) [lindex $elem $pos_1] ## (pos_2  $pos_2)  [lindex $elem $pos_2]"
        set e1 $w_nb
        if {($pos_1 <= $e1 && $pos_2 <= $e1) || ($pos_1 > $e1 && $pos_2 > $e1)} {
            lappend wls [list [lindex $elem $pos_1] [lindex $elem $pos_2]]
        } else  {
            lappend bls [list [lindex $elem $pos_1] [lindex $elem $pos_2]]
        }
    }
}]"
puts "wls [llength $wls] et bls [llength $bls] ----------- w_nb $w_nb"
puts "wls:\n$wls"
puts "bls:\n$bls"

# --------------------------------------------- Algo de toujours modifié ET METAKIT... ?
update
flush stdout
puts $v
puts "\nAlgo de tjrs MODIFIE LSEARCH\n[time {
    foreach kdist $dist {
        #0n cherche d'abord la position permutée de chaque individu
        set pos_1 [lsearch $elem [lindex $kdist 0]]
        set pos_2 [lsearch $elem [lindex $kdist 1]]
        #
        #puts "(pos_1 $pos_1) [lindex $elem $pos_1] ## (pos_2  $pos_2)  [lindex $elem $pos_2]"
        set e1 $w_nb
        if {($pos_1 <= $e1 && $pos_2 <= $e1) || ($pos_1 > $e1 && $pos_2 > $e1)} {
            lappend wlls [list [lindex $elem $pos_1] [lindex $elem $pos_2]]
        } else  {
            lappend blls [list [lindex $elem $pos_1] [lindex $elem $pos_2]]
        }
    }
}]"
puts "wlls [llength $wlls] et bls [llength $blls] ----------- w_nb $w_nb"
puts "wlls:\n$wlls"
puts "blls:\n$blls"



exit