source 100La.tcl

# Procedure MDISPAR
#
proc mdispar {x} {
    # Total number of cells
    set cells [mrows $x]
    set nMoins1 [expr {$cells - 1}]
    # each value is squared
    set xprodx [mprod $x $x]
    # total sum of rows and cols
    set md [msum [msum $xprodx]]
    set md [expr {$md * 1.0 / $nMoins1}]
    return $md
}
#
# Procedure MDISPAR

proc ranmat {pop} {
    set lignes [mrows $pop]
    set lignesmoinsun [expr {$lignes - 1}]
    set colonnes [mcols $pop]
    set colonnesmoinsun [expr {$colonnes - 1}]
    
    set popnew "2 $lignes $colonnes"
    # - - - - - - - - - - - - - - - - - - - - - - -
    # MATRICE ALEATOIRE "SAMPLING WITH REPLACEMENT"
    # - - - - - - - - - - - - - - - - - - - - - - -
    for {set i 0} {$i < $lignes} {incr i} {
        set num [expr {round( $lignesmoinsun * rand() ) } ]
        set rowfirst [expr {($colonnes * $num)+3} ]
        set rowlast [expr {$rowfirst + $colonnesmoinsun} ]
        set newline [lrange $pop $rowfirst $rowlast ]
        set popnew [concat $popnew $newline]
    }
    #set newpop $popnew
    return $popnew
}

set a "2 4 4 12 13 12 11 10 12 13 21 23 21 22 32 21 21 54 23"
set amd [mdispar $a]

puts [time {
    set ranasum 0
    set bootstrap 3000
    for {set j 0} {$j < $bootstrap} {incr j} {
        #srand($j)
        set rana [ranmat $a]
        set ranamd [mdispar $rana]
        #puts "$rana <- $ranamd"
        lappend ranamdlist $ranamd
        set ranasum [expr $ranasum + $ranamd]
    }
}
]

puts $a
set ramdordre [lsort -real $ranamdlist]
set percentile5   [expr {int(0.05 * $bootstrap)}]
set percentile95  [expr {int(0.95 * $bootstrap)}]
set lefttail [lindex $ramdordre $percentile5]
set righttail [lindex $ramdordre $percentile95]

puts "observed MD $amd <-> random [expr {$ranasum *1.0/$bootstrap}] \nmin [lindex $ramdordre 0] max [lindex $ramdordre end]"
puts "left tail $lefttail"
puts "right tail $righttail"
puts "standard error [expr {($righttail - $lefttail)/2}]"
exit