


#proc dialogue {top title labels} {}

proc dialogue {gr} {
    global group
    set group [expr {$gr + 1}]
    # (Welsch, p.493)
    #
    # Create a resizable toplevel window
    toplevel .diatree
    set top .diatree
    set title "Naming OTUs"
    wm minsize $top 200 100
    wm title $top $title
    
    #Create a frame for buttons
    set f [frame $top.buttons -bd 4]
    button $f.quit -text "Cancel" -command "destroy $top"
    button $f.save -text "Save" -command {
        global group
        update
        destroy .diatree
        for {set i 1} {$i < $group} {incr i} {
            set row($i) "Name \{ $v($i) \}"
            append metainfo "_$i $row($i)\n"
        }
        # OPEN THE FILE
        set fileid [open $filename1 w]
        # FILL THE FILE
        puts -nonewline $fileid $metainfo
        # CLOSE THE FILE
        close $fileid
        NewickTranslation $filename1 $filename2
    }
    pack $f.quit $f.save -side right
    pack $f -side top -fill x
    
    #Creating a scrolling canvas
    frame $top.c
    canvas $top.c.canvas -width 10 -height 10 \
            -yscrollcommand [list $top.c.yscroll set]
    scrollbar $top.c.yscroll -orient vertical \
            -command [list $top.c.canvas yview]
    pack $top.c.yscroll -side right -fill y
    pack $top.c.canvas -side left -fill both -expand true
    pack $top.c -side top -fill both -expand true
    
    Scrolled_EntrySet $top.c.canvas $gr
    
}

proc Scrolled_EntrySet {canvas gr} {
    
    # (Welsch, p.493)
    #
    # Create one frame to hold everything and position it on the canvas
    set f [frame $canvas.f -bd 0]
    $canvas create window 0 0 -anchor nw -window $f
    
    # Dialogue pour creer le fichier d'annotations 'translat.txt'
    set group [expr {$gr+1}]
    wm geometry .diatree +300+200
    for {set i 1} {$i < $group} {incr i} {
        label $f.l_$i -text "Name(s) for Group $i"
        entry $f.g_$i  -textvariable v($i)
        grid $f.l_$i $f.g_$i
        grid $f.l_$i -sticky w
        grid $f.g_$i -sticky we
    }
    set child $f.g_1
    
    # Wait for the window to become visible and then ...
    
    tkwait visibility $child
    set bbox [grid bbox $f 0 0]
    set incr [lindex $bbox 3]
    set width [winfo reqwidth $f]
    set height [winfo reqheight $f]
    $canvas config -scrollregion "0 0 $width $height"
    $canvas config -yscrollincrement $incr
    set max $group
    if {$max > 10} {set max 10}
    set height [expr {$incr * $max}]
    $canvas config -width $width -height $height
}

dialogue 38