source 100La.tcl
set infile "/media/ext/Formation/Jean-Pierre/MANCOVA/diffSlopes/test_diffSlope_PW_CS.txt"

###loadfile# PROCEDURE ## DEBUT###
proc loadfile {pathname} {
    set fid [open $pathname]
    set text [read -nonewline $fid]
    close $fid
    set rowcount 0
    set colcount 0
    global references
    set compteur 0
    set lignes 0
    set data ""
    foreach line [split $text \n] {
        incr compteur
        if {$compteur >1} {
            if  {$line != ""} {
                set colcount [llength $line]
            }
        }
        if {$compteur>1} {
            foreach item [split $line] { if {$item != ""} {
                    incr lignes;lappend data $item
                }
            }
        } else {set references $line}
    }
    set rowcount [expr {$lignes / $colcount}]
    set result [concat 2 $rowcount $colcount $data]
    #debug
    #puts "Commentaire brut :\n$references"
    # -- Formater le commentaire
    # -- 1. Enlever d'eventuelles tabulations
    foreach mot $references {
        if {$mot != ""} {
            append comentario_sin_tab "$mot "
        }
    }
    set references $comentario_sin_tab
    # -- FIN du formatage de la premiere ligne
    puts "result = $result"
    return $result
}
########################loadfile# PROCEDURE ## FIN ###


# Procedure det - START
#
# extracted from Hume LA library, msolve procedure
# MANQUE UN MORCEAU

proc det {A p} {
    promote_br p    ;# a vector becomes Nx1
    
    set N [lindex $A 2]
    # paste the rhs columns on the end
    join_cols_br A p
    
    return [msolve_br A]
    
    ## now peel off the solution which replaced the rhs columns
    #mrange_br A x $N end
    #return $x
}

proc msolve_br {A_in {tolerance 2.3e-16}} {
    upvar $A_in A
    set n [lindex $A 1]
    set NC [lindex $A 2]
    set p [expr {$NC - $n}]
    set Det 1.0
    for {set j 0} {$j <= [expr {$n - 2}]} {incr j} {
        set j_plus1 [expr {$j + 1}]
        set jj [expr {3 + $j * $NC + $j}]
        set Ajj [lindex $A $jj]
        set s [expr {abs($Ajj)}]
        set k $j
        for {set h $j_plus1} {$h < $n} {incr h} {
            set Ahj [lindex $A [expr {3+ $h * $NC + $j}]]
            set Ahj [expr {abs($Ahj)}]
            if { $Ahj > $s } {
                set s $Ahj
                set k $h
            }
        } ;# end pivot search
        if { $k != $j } { ;# row interchange
            for {set i $j} {$i < $NC} {incr i} {
                set ki [expr {3+$k*$NC + $i}]
                set ji [expr {3+$j*$NC + $i}]
                set Aki [lindex $A $ki]
                set Aji [lindex $A $ji]
                lassign_br A $ki $Aji
                lassign_br A $ji $Aki
            }
            set Det [expr {0.0-$Det}]
        }
        set Ajj [lindex $A $jj]
        set Det [expr {$Det * $Ajj}]
        #if { abs($Ajj) <= $tolerance } {
        #    error "matrix is computationally singular at a tolerance of $tolerance"
        #}
        for {set k $j_plus1} {$k < $n} {incr k} {
            set kj [expr {3+$k*$NC + $j}]
            set Akj [lindex $A $kj]
            set Akj [expr {double($Akj)/$Ajj}]
            lassign_br A $kj $Akj ;# to form multiplier mkj
            for {set i $j_plus1} {$i < $NC} {incr i} {
                set ki [expr {3+$k*$NC + $i}]
                set Aki [lindex $A $ki]
                set ji [expr {3+$j*$NC + $i}]
                set Aji [lindex $A $ji]
                lassign_br A $ki [expr {$Aki - double($Akj)*$Aji}]
            }
        } ;# k
    } ;# j
    set nn [expr {3+($n-1)*$NC+($n-1)}]  ;# n-1,n-1
    set Ann [lindex $A $nn]
    set Det [expr {$Det * $Ann}]
    #if { abs($Ann) < $tolerance } {
    #    error "matrix is computationally singular at a tolerance of $tolerance"
    #}
    # factoring completed
    #    mij stored in i>j
    #    Rij stored in i<=j < n
    #    fij stored in j= n ... n+p-1
    # Back substitution for Rx=f
    for {set i $n} {$i < $NC} {incr i} {
        set ni [expr {3+($n-1)*$NC + $i}]  ;# really n-1,i
        set Ani [lindex $A $ni]
        set Ani [expr {double($Ani)/$Ann}]
        lassign_br A $ni $Ani
        for {set j [expr {$n-2}]} {$j >= 0} {incr j -1} {
            set ji [expr {3+$j*$NC+$i}]
            set s [lindex $A $ji]
            for {set k [expr {$j+1}]} {$k < $n} {incr k} {
                set jk [expr {3+$j*$NC+$k}]
                set Ajk [lindex $A $jk]
                set ki [expr {3+$k*$NC+$i}]
                set Aki [lindex $A $ki]
                set s [expr {$s - $Ajk*$Aki}]
            }
            set jj [expr {3+$j*$NC+$j}]
            set Ajj [lindex $A $jj]
            lassign_br A $ji [expr {double($s)/$Ajj}]
        }
    }
    #return $A_in
    return $Det
}
#
# Procedure det - END



set infilesub [file root $infile]
set com "_Ematrix_common.txt"
set diff "_Ematrix_diff.txt"
set ematcom [loadfile $infilesub$com]
set ematdiff [loadfile $infilesub$diff]
puts "common slope:\n[show $ematcom]"
puts "different slopes:\n[show $ematdiff]"

# Pour comparer avec ntsys
#set testmatrix $ematdiff
set testmatrix $ematcom
#puts "Test matrix:\n[show $testmatrix]"
# Pour comparer avec ntsys

#set testmatrix [msub $ematdiff $ematcom]
#puts "Test matrix:\n[show $testmatrix]"

# Eigenvalues de la matrice de test
set V $testmatrix
mevsvd_br V S

puts "eigenvalues S \n[show $S]"

# Note si on utilise mvsvd_br V S, on obtient les singular values (^2/(m-1)) -> eigenvalues


puts "Determinant [det $testmatrix [mident [mcols $testmatrix]]]"

set lambda [show $S]

################ estimation du Test de WILKS
set long [llength $lambda]
global wilks
set wilks 1
for {set i 0} {$i < $long} {incr i} {
    set fact [expr 1.0/(1.0+[lindex $lambda $i])]
    set wilks [expr $fact * $wilks]
}
puts "WILKS $wilks"
###############WILKS observe