source 100La.tcl


# Procedure CHEMIN -start
#
proc chemin {} {
    
    global p dossier
    
    if {[info exists dirinfile] == 0} {
        set dirinfile [pwd]
    }
    
    # ----------------------------------------------------
    # Nom du FICHIER et son CHEMIN (path) CORRESPONDANT
    # ---------------------------------------------------
    
    
    # Chercher le chemin dans un fichier de configuration
    # 1. verifier que le fichier de configuration existe
    set chemin "[pwd]/dossier_cov.txt"
    #puts "chemin $chemin"
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
        set candidat_dossier [pwd]
    } else  {
        #puts "La conf existe"
        # 3. s'il existe reccueillir le dernier chemin parcouru
        # open le fichier pour lire
        catch [
        set fid [open $chemin r]
        set candidat_dossier [read -nonewline $fid]
        close $fid
        ] ici
        #puts "candidat_dossier $candidat_dossier"
        set candidat_dossier [lindex [split $candidat_dossier \n] 1]
        # debug
        #puts "dossier = $candidat_dossier"
    }
    
    # On va chercher les donnees
    
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
    
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
        # open le fichier de conf pour ecrire
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilisees par signifTests:\n"
        puts -nonewline $fid $dossier
        close $fid
        ] ici
    }
    
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    
    # --------------------------------------------------------
    # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE pop
    # --------------------------------------------------------
    return $infile
}
#
# Procedure CHEMIN - end


# Procedure WHICHMATRIX - start
#
proc whichmatrix {} {
    global p infile dossier
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [chemin];# usage de la procedure CHEMIN : memoire des dossiers anterieurs
    set x [loadfile $infile]; # usage de la procedure LOADFILE
    entrada $x $infile;# usage de la procedure ENTRADA: presentation de la matrice loadee
    $p insert end "\nMatrix X:\t----------------------------------start---\n"
    #$p insert end [show $x %8.3f]
    if {[mrows $x] < 30} {
        $p insert end "\n\n[show $x %8.3f]"
    } else  {
        $p insert end "\n\n[show [mrange $x 0 end 0 29] %8.3f] \n...\netc. etc.\n"
    }
    $p insert end "\nMatrix X:\t----------------------------------end----\n\n"
    return $x
}
#
# Procedure WHICHMATRIX - end

###loadfile# PROCEDURE ## DEBUT###
proc loadfile {pathname} {
    set fid [open $pathname]
    set text [read -nonewline $fid]
    close $fid
    set rowcount 0
    set colcount 0
    global references
    set compteur 0
    set lignes 0
    set data ""
    foreach line [split $text \n] {
        incr compteur
        if {$compteur >1} {
            if  {$line != ""} {
                set colcount [llength $line]
            }
        }
        if {$compteur>1} {
            foreach item [split $line] { if {$item != ""} {
                    incr lignes;lappend data $item
                }
            }
        } else {set references $line}
    }
    set rowcount [expr {$lignes / $colcount}]
    set result [concat 2 $rowcount $colcount $data]
    #debug
    #puts "Commentaire brut :\n$references"
    # -- Formater le commentaire
    # -- 1. Enlever d'eventuelles tabulations
    foreach mot $references {
        if {$mot != ""} {
            append comentario_sin_tab "$mot "
        }
    }
    set references $comentario_sin_tab
    # -- FIN du formatage de la premiere ligne
    #puts "result = $result"
    return $result
}
########################loadfile# PROCEDURE ## FIN ###



# Procedure determinant det + msolve - START
#
# extracted from Hume LA library, msolve procedure
# MANQUE UN MORCEAU

proc det {A p} {
    promote_br p    ;# a vector becomes Nx1
    
    set N [lindex $A 2]
    # paste the rhs columns on the end
    join_cols_br A p
    
    return [msolve_br A]
}

proc msolve_br {A_in {tolerance 2.3e-16}} {
    upvar $A_in A
    set n [lindex $A 1]
    set NC [lindex $A 2]
    set p [expr {$NC - $n}]
    set Det 1.0
    for {set j 0} {$j <= [expr {$n - 2}]} {incr j} {
        set j_plus1 [expr {$j + 1}]
        set jj [expr {3 + $j * $NC + $j}]
        set Ajj [lindex $A $jj]
        set s [expr {abs($Ajj)}]
        set k $j
        for {set h $j_plus1} {$h < $n} {incr h} {
            set Ahj [lindex $A [expr {3+ $h * $NC + $j}]]
            set Ahj [expr {abs($Ahj)}]
            if { $Ahj > $s } {
                set s $Ahj
                set k $h
            }
        } ;# end pivot search
        if { $k != $j } { ;# row interchange
            for {set i $j} {$i < $NC} {incr i} {
                set ki [expr {3+$k*$NC + $i}]
                set ji [expr {3+$j*$NC + $i}]
                set Aki [lindex $A $ki]
                set Aji [lindex $A $ji]
                lassign_br A $ki $Aji
                lassign_br A $ji $Aki
            }
            set Det [expr {0.0-$Det}]
        }
        set Ajj [lindex $A $jj]
        set Det [expr {$Det * $Ajj}]
        if { abs($Ajj) <= $tolerance } {
            error "matrix is computationally singular at a tolerance of $tolerance"
        }
        for {set k $j_plus1} {$k < $n} {incr k} {
            set kj [expr {3+$k*$NC + $j}]
            set Akj [lindex $A $kj]
            set Akj [expr {double($Akj)/$Ajj}]
            lassign_br A $kj $Akj ;# to form multiplier mkj
            for {set i $j_plus1} {$i < $NC} {incr i} {
                set ki [expr {3+$k*$NC + $i}]
                set Aki [lindex $A $ki]
                set ji [expr {3+$j*$NC + $i}]
                set Aji [lindex $A $ji]
                lassign_br A $ki [expr {$Aki - double($Akj)*$Aji}]
            }
        } ;# k
    } ;# j
    set nn [expr {3+($n-1)*$NC+($n-1)}]  ;# n-1,n-1
    set Ann [lindex $A $nn]
    set Det [expr {$Det * $Ann}]
    if { abs($Ann) < $tolerance } {
        error "matrix is computationally singular at a tolerance of $tolerance"
    }
    # factoring completed
    #    mij stored in i>j
    #    Rij stored in i<=j < n
    #    fij stored in j= n ... n+p-1
    # Back substitution for Rx=f
    for {set i $n} {$i < $NC} {incr i} {
        set ni [expr {3+($n-1)*$NC + $i}]  ;# really n-1,i
        set Ani [lindex $A $ni]
        set Ani [expr {double($Ani)/$Ann}]
        lassign_br A $ni $Ani
        for {set j [expr {$n-2}]} {$j >= 0} {incr j -1} {
            set ji [expr {3+$j*$NC+$i}]
            set s [lindex $A $ji]
            for {set k [expr {$j+1}]} {$k < $n} {incr k} {
                set jk [expr {3+$j*$NC+$k}]
                set Ajk [lindex $A $jk]
                set ki [expr {3+$k*$NC+$i}]
                set Aki [lindex $A $ki]
                set s [expr {$s - $Ajk*$Aki}]
            }
            set jj [expr {3+$j*$NC+$j}]
            set Ajj [lindex $A $jj]
            lassign_br A $ji [expr {double($s)/$Ajj}]
        }
    }
    #return $A_in
    return $Det
}
#
# Procedure det - END


# Entree des matrices X et Y
destroy .a&b
toplevel .a&b
set e ".a&b"
wm geometry $e +300+300

proc e_mat_diff {} {
    global dossier
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [chemin]
    set x [loadfile $infile]
    return $x
}

proc e_mat_com {} {
    global dossier
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [chemin]
    set y [loadfile $infile]
    return $y
}


set ematdiff [e_mat_diff]
#puts "\ndifferent slopes:\n[show $ematdiff]"

set ematcom [e_mat_com]
#puts "\ncommon slope:\n[show $ematcom]"


puts [time {
    # Note si on utilise mvsvd_br V S, on obtient les singular values (^2/(m-1)) -> eigenvalues
    puts "detdiff/detcom\t[expr {[det $ematdiff [mident [mcols $ematdiff]]] / [det $ematcom [mident [mcols $ematcom]]]}]"
}]

puts [time {
    # On va inverser la matrice obtenue 'ematcom' -> 'iematcom'
    set colonnes [mcols $ematcom]
    set iematcom [msolve $ematcom [mident $colonnes]]
    # On multiplie ematdiff par iematcom
    set testmatrix [mmult $iematcom $ematdiff]
    puts "\ntestmatrix\t[expr {[det $testmatrix [mident [mcols $testmatrix]]]}]"
    set wilks_det [expr {[det $testmatrix [mident [mcols $testmatrix]]]}]
}]
################ estimation du Test de WILKS sur la testmatrix
#
# Eigenvalues de la matrice de test
# Note si on utilise mvsvd_br V S, on obtient les singular values (^2/(m-1)) -> eigenvalues
set V $testmatrix
mevsvd_br V S

set SS [mprod $S $S]
set eigenvalues [mscale $SS [expr {1.0/35}] ]
puts "eigenvalues $eigenvalues"
#puts "eigenvalues diff - com\tS \n[show $S]" <-> singular values ???
set lambda [show $eigenvalues]
# L'ensemble des eigenvalues (lambda) <-> o singular values ????
#puts "\nlambda $lambda\n"

# Wilks
set long [llength $lambda]
global wilks
set wilks 1
for {set i 0} {$i < $long} {incr i} {
    if {[lindex $lambda $i] != 0} {
        set fact [expr 1.0/(1.0+[lindex $lambda $i])]
        set wilks [expr $fact * $wilks]
    }
}
# Avec les determinants j'ai le Wilks,
# mais pas avec les eigenvaues !! pcq que ce sont des singular values, pas des eigenvalues ??
puts "WILKS testmatrix\t$wilks\n"
###############WILKS observe

# On multiplie ematdiff par iematcom
set matrixtest [mmult $ematdiff $iematcom]
puts "\nmatrixtest\t[expr {[det $matrixtest [mident [mcols $matrixtest]]]}]"

################ estimation du Test de WILKS sur la testmatrix
#
# Eigenvalues de la matrice de test
set V $matrixtest
mevsvd_br V S

#puts "eigenvalues diff - com\tS \n[show $S]"
set lambda [show $S]
#puts "\nlambda $lambda\n"

# Wilks
set long [llength $lambda]
global wilks
set wilks 1
for {set i 0} {$i < $long} {incr i} {
    if {[lindex $lambda $i] != 0} {
        set fact [expr 1.0/(1.0+[lindex $lambda $i])]
        set wilks [expr $fact * $wilks]
    }
}
puts "\nWILKS matrixtest\t$wilks"
###############WILKS observe


# Calcul de F
# -------------------------------------------------------------------------
# VARIABLES A ADAPTER A CHAQUE TEST
# -------------------------------------------------------------------------
# Calcul de F
# avec
# p = nbre de DV = 22
# et
# q = nbre de groupes MOINS 1 = 5 - 1 = 4
# et
# n = nombre de lignes - nbre de groupes - 1 = 73 - 5 - 1 = 67


set p 22
set q 4; #nbre de groupes (5) - 1
set n 67; #nbre de lignes (73) - nbre de groupes(5) -1
# --------------------------------------------------------------------------


# degres de liberte du numerateur (deviations par rapport a la prediction)
set v1 [expr {$p*$q}]

# valeur de l'exposant b
if {[expr {pow($p,2) + pow($q,2) - 5}] > 0} {
    set num [expr {pow($v1,2) - 4}]
    set den [expr {pow($p,2) + pow($q,2) - 5}]
    set b [expr {sqrt($num / $den)}]
    
} else {
    tk_messageBox -text "NO WAY" -type OK 
}

# degres de liberte de sums of squares and cross-products matrix for the prediction of shape
# given one or more independent variables (the "explained" matrix)
set vw [expr {$n-$q}]

# degres de liberte par rapport au denominateur
set t1 [expr {$b * ($vw - ($p-$q+1) * 1.0/2)}]
set t2 [expr {($v1 - 2)  * 1.0/2}]
set v2 [expr {$t1 - $t2}]

# Pour le calcule de F
set t3 [expr {pow($wilks_det,(1/$b))}]
set F [expr {((1 - $t3) * 1.0/$t3) * ($v2 * 1.0/$v1)}]
#set f1 [expr {pow((1-$wilks_det),$b)}]
#set F [expr {($f1 * 1.0/$t3) * ($v2 * 1.0/$v1)}]
puts "----------------------- Results ------------------"
puts "\n\nWilks \n$wilks_det"
puts "F\t$F"
puts "v1\t$v1"
puts "v2\t$v2"
puts "vw = $vw, n = $n, t1 = $t1, t2 = $t2, t3 = $t3, num = $num, den = $den, b = $b"
exit