


# procedure DEBUG
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x600+205+66
        set memo [text .debug.t -wrap word -height 22 -font "courier 13" \
                -bg grey88 \
                -fg black\
                -tabs "3c left"\
                -yscrollcommand ".debug.v_scroll set" \
                -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
            if {$flag == 1} {
                .debug.t configure -wrap none
                set flag 0
            } else  {
                .debug.t configure -wrap word
                set flag 1
            }
        }
        #
        $memo insert end $bugatti
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG fin


# Procedure SUBDIVIDED_MATRIX_PW - debut
#
proc subdivided_matrix_pw {mdonnees} {
    # 'mdonnees' est une matrice au format HUME
    #
    debug"\nDONNEES INITIALES\n[show $mdonnees %1.3f]\n"
    #
    # procedure appelee par la COMMANDE : Menu -> Single matrix -> Partial and Relative Warps scores
    #
    #  procedure appelee par la COMMANDE : Menu -> Subdivided matrix -> "Sub-matrix: Partial and Relative Warps scores."
    #
    # procedure appelee par la COMMANDE : Menu -> Subdivided matrix -> Metric disparity of Shape
    #
    # procedure appelee par la COMMANDE : Menu -> Subdivided matrix -> Qst
    #
    
    # la SUPERPOSITION DE PROCRUSTES ci-dessous aboutit au calcul du consensus 'reference'
    #
    # lequel est alors envoye dans la procedure PARTIALITE
    #
    # La procedure PARTIALITE devrait etre externe, non interne,
    # car en interne on devrait se concentrer sur le calcul de 'reference' (ou vice versa)
    #
    # du style
    # set reference [superposition_procruste mdonnees] <- contiendrait la procedure
    #                                                                                 sauf l'appel a PARTIALITE
    # on pourrait alors
    # 1. calculer les distances de Procruste entre chaque objet et reference
    # 2. garder en memoire 'mindist'
    # du style WHILE DIFFMINDIST > 0.00001
    # 3. reiterer set reference [superposition_procruste mdonnees] <- la procedure sauf l'appel a PARTIALITE mais avec les donnees nouvelles
    # 1a. calculer les distances de procruste entre chaque objet et reference
    # 2a. garder en memoire 'mindist' comparer avec la premiere mindist
    # ... s'arreter si 'diffmindist' < 0.00001 (par exemple)
    
    global p S
    global reference;# au singulier, ce mot designe la variable qui contient le consensus
    #
    # ----------------------------------------------- debut ---
    # ... ?
    global lignes colonnes lm
    set matinit [lrange $mdonnees 0 2]
    set lignes [lindex $matinit 1]
    set colonnes [lindex $matinit 2]
    set lm [expr {$colonnes/2}]
    #$p insert end "\n\n$lignes\tconfiguraciones\n$lm\tlandmarks\n"
    #
    # calcul du consensus (configuration moyenne)
    set consensus [mnorms $mdonnees]
    set consensus [lrange $consensus 3 [expr {3 + $colonnes - 1}]]
    set consensus [lformat %1.9f $consensus];# pourquoi tronquer ?
    set donnees [lrange $mdonnees 3 end]
    set data ""
    for  {set i 0} {$i < [expr {$lignes * $colonnes}]} {incr i $colonnes} {
        set tranche [lrange $donnees $i [expr {$i+$colonnes-1}]]
        append data "$tranche\n"
    }
    #
    # On classe les coordonnees successives par individu dans la table tablind()
    global tablind
    if {[info exists tablind]} {unset tablind}
    set i -1
    set compteur 0
    set tablind(0) $consensus
    foreach item [split $data "\n"] {
        #$p insert end "\n\nPour tablind:\n$item\n"
        if {$item != ""} {
            # On saute la premiere ligne
            incr compteur
            if {$compteur > 0} {
                #verification du nombre de lm de chaque individu
                if  {$colonnes != [llength $item]} {
                    $p insert end "$lm <> [llength $item]"
                    exit
                }
                incr i
                set tablind($compteur) $item
            }
        }
    }
    # Le consensus se trouve, ici ou la, dans 3 variables, consensus, reference, tablind(0) ... ??
    $p insert end "\n\nCONFIGURATION CONSENSUS \n$tablind(0)\n"
    
    # On cree une LISTE (un individu) de MATRICES (de coordonnees)
    # (une matrice est un couple de coordonnees, elle a 1 ligne et 2 colonnes)
    # (chaque 'landmark' est une 'matrice')
    global rawindividus
    #
    if {[info exists rawindividus]} {unset rawindividus} else {set rawindividus ""}
    set n [llength $data]
    #$p insert end "\nCREATION DES INDIVIDUS"
    for  {set i 0} {$i < $n} {incr i 2} {
        set item [lrange $data $i [expr {$i+1}]]
        #$p insert end "\nITEM = \t$item"
        lappend rawindividus "2 1 2 $item"
    }
    
    # debug oct 2008
    #
    
    #
    # SUPERPOSITION DE PROCRUSTES
    #
    # 1. TRANSLATION
    # ... la procedure TRANSLATION travaillera sur 'rawindividus'
    # pour calculer le nb de lignes de la matrice (variable globale)
    # ... et sur la table 'tablind()' pour operer la translation;
    # 'tablind()' est une variable (globale) monoindicee, 'tablind(0)' contient le consensus
    set preindividus [translation $lm]
    # 2. SCALING
    set proindividus [scaling $lm]
    set S(ctr) $proindividus
    # 3. ROTATION
    rotation;# Les coordonnees apres ROTATION se trouvent dans la variable globale monoindicee 'rot'
    # Calculs PW proprement dits
    #
    vert "\n$reference\n"
    return [partialite $reference];# a placer dans une variable indicee -
    #                                             'reference' contient le consensus (moyenne des individus)
    #                                             APRES rotation
    # ---------------------------------------------------------
}
#
# Procedure SUBDIVIDED_MATRIX_PW - fin



# Procedure TRANSLATION # debut
#
proc translation {lm} {
    global p
    #
    global rawindividus;# on en a besoin pour le calcul du nombre de lignes
    set mmm [llength $rawindividus]
    set lignes [expr {$mmm/$lm}]
    #
    global polygone;#sert a quoi ?
    #
    global suit_tran suit_cons nosi suit_rot susnesnoc references
    set susnesnoc 0
    set nosi 0
    if {[info exists suit_tran] == 0} {#$p insert end "\n\nTRANSLACION de los OBJETOS \
                sobre UN mismo CENTROIDE\n"}
    if {[info exists objet_cons]} {unset objet_cons}
    set suit_cons 0
    #
    # Matrices I, P, I-P
    global  grandp imoinsp
    set identite [mident $lm]
    set unsurp [expr {1.0 / $lm}]
    set grandp "2 $lm $lm"
    for {set i 0} {$i < [expr {$lm*$lm}]} {incr i} {
        append grandp " $unsurp"
    }
    set imoinsp [msub $identite $grandp]
    #
    # Translation ou pre-multiplication des matrices par I-P
    global translatedx
    global tablind
    for  {set i 0} {$i < [expr {$lignes+1}]} {incr i} {
        set x "2 $lm 2 $tablind($i)"
        set translatedx($i) [mmult $imoinsp $x]
        if {[info exists suit_tran] == 0} {#$p insert end "\nTranslated matrix object $i\
                    \n[show $translatedx($i)]\n"}
    }
    # Il n'y a pas de 'return', les donnees apres translation sont dans une variable globale monoindicee = 'translatedx()'
}
#
# Procedure TRANSLATION- fin


# Procedure SCALING - debut
#
proc scaling {lm} {
    global references
    global p imoinsp;#pour calculer proctr
    
    global translatedx preindividus;# Ce sont les coordonnees obtenues apres la TRANSLATION
    
    global polygone;#sert a quoi ?
    global suit_rot neweff centroid;#sert a quoi ?
    #
    global transcaledindiv transcaledtotal
    global tailles_base
    global consensus
    global susnesnoc nosi
    # Aout 2006 Mise a zero des variables d'accumulation
    set transcaledtotal ""
    set centroide ""
    set tailles_base ""
    set consensus 0
    set susnesnoc 0
    set nosi 0
    #set suit_rot 0
    #
    global rawindividus;# pour compter le nombre de lignes
    set mmm [llength $rawindividus]
    set lignes [expr {$mmm/$lm}]
    #
    # informe
    global suit_scal
    if {[info exists suit_scal] == 0} {#$p insert end "\n\n\nSCALING to UNIT Centroid Size\n"}
    
    set suit_cons 0
    #
    # UNIT CTR Scaling to unit centroid size
    global translatedx;# contient les coordonnees de chaque individu apres translation - c'est une variable monoindicee
    for  {set i 0} {$i < [expr {$lignes+1}]} {incr i} {
        set ttranslatedx($i) [transpose $translatedx($i)]
        set prectr [mmult $translatedx($i) $ttranslatedx($i)]
        set proctr [mmult $prectr $imoinsp]
        set presquectr [transpose $proctr]
        # La taille centroide elevee au carre est la trace de presquectr
        set prectr2 [vdiag $presquectr]
        set proctr2 [vtrim $prectr2]
        set ctr2 0
        foreach item $proctr2 {set ctr2 [expr {$ctr2+$item}]}
        set ctr [expr {sqrt($ctr2)}]
        set centroid($i) $ctr
        set scalefactor [expr {1.00000/$ctr}]
        set transcaledindiv($i) [mscale $ttranslatedx($i) $scalefactor]
        set transcaledindiv($i) [transpose $transcaledindiv($i)]
        #
        # informe
        if {[info exists suit_scal] == 0} {
            append transcaledtotal "[lrange $transcaledindiv($i) 3 end]\n"
            append centroide "$ctr\n"
            append tailles_base "$ctr "
        }
    }
    # JUILLET 2006
    return $tailles_base;# a qui est destine ce return ?
}
#
# Procedure SCALING - fin


# Procedure ROTATION - debut
#
proc rotation {} {
    #
    # procedure appelee par SUBDIVIDED_MATRIX_PW
    #
    global p infile
    global  lm colonnes
    global polygone;#sert a quoi ?
    global references;# contient les COMMENTAIRES, attention ! la variable existe aussi au singulier (elle contient alors le consensus)
    
    #
    global rawindividus
    set mmm [llength $rawindividus]
    set lignes [expr {$mmm/$lm}]
    #
    global consensus susnesnoc suit_cons nosi indivmoy suit_rot
    set consensus 0
    set susnesnoc 1
    set suit_cons 1
    set nosi 0
    set indivmoy 0;#pour ne pas repeter les rapports du bouton jpdraw/moyens
    if {[info exists suit_rot] == 0} {#$p insert end "\n\nROTATION (aligned specimens)"}
    #
    global transcaledindiv
    set V [composantes $transcaledindiv(0)];# V contient les eigenvecteurs
    set prex1t [mmult $transcaledindiv(0) $V ]
    #
    # Debug
    #if {[info exists suit_rot] == 0} {$p insert end  "\n\nConsensus aligned to its \
    principal component axes\n\n[show $prex1t %1.4f]\n"}
#
# formation des points (individus) du consensus prex1t
global objet_cons
set landmark 0
for  {set i 3} {$i < [expr {$lm*2+2}]} {incr i 2} {
    incr landmark
    set item [lrange $prex1t $i [expr {$i+1}]]
    if {$item != ""} {lappend objet_cons "2 1 2 $item"}
    if {[info exists suit_rot] == 0} {append aligned "$item "}
}
if {[info exists suit_rot] == 0} {append aligned "\n"}
#$p insert end "\n$objet_cons"
#
# Le consensus dans la variable reference (ici le mot reference est au singulier)
global reference
if {[info exists suit_rot] == 0} {set reference $aligned}
#if {[info exists suit_rot] == 0} {$p insert end  "\nConsensus de la variable 'reference' \n $aligned \n"}
#
# Donc, le consensus aligne sur ses composantes principales est dans une matrice de Hume 'prex1t' et dans une liste 'reference'
#
# references au pluriel c'est la premiere ligne du fichier de donnees (cfr loadfile)
#
# Rotations proprement dites
global rot;# variable globale monoindicee, contient les coordonnees apres rotation
set x1t [transpose $prex1t]
for  {set i 1} {$i < [expr {$lignes+1}]} {incr i} {
    set ttrantran($i) [mmult $x1t $transcaledindiv($i)]
    # singular value decomposition
    set U $ttrantran($i)
    msvd_br U S V
    set S "2 2 2 1 0 0 1"
    set H [mmult [mmult $V $S] $U]
    set rot($i) [mmult $transcaledindiv($i) $H]
    #debug oct 2008 -- start
    #rouge "\ncoord resid indiv $i : $rot($i)"
    # Pour une distance entre deux individus, il n'y a que deux individus
    # Une iteration ne sera necessaire que pour plus de deux individus
    #    #    Somme des distance de Procrustes entre les rot() et le consensus qui devrait etre dans rot(0) ??
    # Consensus dans rot(0);# rouge"rot(zero) :\n[show $prex1t %1.4f]\n" ?
    #debug oct 2008 -- end
}
#debug
#rouge "aligned $aligned"
}
#
# Procedure ROTATION - fin
