
namespace eval newpw {
    
    # Jean-Pierre Dujardin
    # -----------------------------------------------------------------------------------------------------------------------
    # Aug_2009 - debut des nouveaux calculs de PW ------------------  debut -----------------
    #
    global p lm colonnes individus partindiv
    
    # Procedure LFORMAT # debut
    #
    proc lformat {ainsi liste} {
        foreach item $liste {
            set item [format $ainsi $item]
            lappend fliste $item
        }
        return $fliste
    }
    #
    # Procedure LFORMAT # fin
    
    
    # Procedure TRANSLATION # debut
    #
    proc translation {lm} {
        global  p grandp imoinsp rawindividus tablind polygone
        global suit_tran suit_cons nosi suit_rot susnesnoc references
        set susnesnoc 0
        set nosi 0
        set mmm [llength $rawindividus]
        set lignes [expr {$mmm/$lm}]
        if {[info exists suit_tran] == 0} {#$p insert end "\n\nTRANSLACION de los OBJETOS \
                    sobre UN mismo CENTROIDE\n"}
        if {[info exists objet_cons]} {unset objet_cons}
        set suit_cons 0
        # Matrices I, P, I-P
        set identite [mident $lm]
        set unsurp [expr {1.0/$lm}]
        set grandp "2 $lm $lm"
        for {set i 0} {$i < [expr {$lm*$lm}]} {incr i} {
            append grandp " $unsurp"
        }
        set imoinsp [msub $identite $grandp]
        
        # Translation ou pre-multiplication des matrices par I-P
        global translatedx
        
        for  {set i 0} {$i < [expr {$lignes+1}]} {incr i} {
            set x "2 $lm 2 $tablind($i)"
            set translatedx($i) [mmult $imoinsp $x]
            if {[info exists suit_tran] == 0} {#$p insert end "\nTranslated matrix object $i\
                        \n[show $translatedx($i)]\n"}
        }
    }
    #
    # Procedure TRANSLATION- fin
    
    
    # Procedure SCALING - debut
    #
    proc scaling {lm} {
        global tailles_base references
        global p imoinsp rawindividus translatedx transcaledtotal transcaledindiv preindividus
        global suit_scal polygone nosi suit_rot neweff consensus susnesnoc centroid
        set consensus 0
        set susnesnoc 0
        set nosi 0
        #set suit_rot 0
        set mmm [llength $rawindividus]
        set lignes [expr {$mmm/$lm}]
        # informe
        if {[info exists suit_scal] == 0} {#$p insert end "\n\n\nSCALING to UNIT Centroid Size\n"}
        
        set suit_cons 0
        # UNIT CTR Scaling to unit centroid size
        for  {set i 0} {$i < [expr {$lignes+1}]} {incr i} {
            set ttranslatedx($i) [transpose $translatedx($i)]
            set prectr [mmult $translatedx($i) $ttranslatedx($i)]
            set proctr [mmult $prectr $imoinsp]
            set presquectr [transpose $proctr]
            # La taille centroide elevee au carre est la trace de presquectr
            set prectr2 [vdiag $presquectr]
            set proctr2 [vtrim $prectr2]
            set ctr2 0
            foreach item $proctr2 {set ctr2 [expr {$ctr2+$item}]}
            set ctr [expr {sqrt($ctr2)}]
            set centroid($i) $ctr
            set scalefactor [expr {1.00000/$ctr}]
            set transcaledindiv($i) [mscale $ttranslatedx($i) $scalefactor]
            set transcaledindiv($i) [transpose $transcaledindiv($i)]
            # informe
            if {[info exists suit_scal] == 0} {
                append transcaledtotal "[lrange $transcaledindiv($i) 3 end]\n"
                append centroide "$ctr\n"
                append tailles_base "$ctr "
            }
        }
        
    }
    #
    # Procedure SCALING - fin
    
    
    # Procedure ROTATION - debut
    #
    proc rotation {} {
        global p transcaledindiv colonnes lm suit_rot suit_cons consensus objet_cons
        global infile reference rot indivmoy polygone rawindividus nosi susnesnoc
        global references
        set mmm [llength $rawindividus]
        set lignes [expr {$mmm/$lm}]
        set consensus 0
        set susnesnoc 1
        set suit_cons 1
        set nosi 0
        set indivmoy 0;#pour ne pas repeter les rapports du bouton jpdraw/moyens
        
        if {[info exists suit_rot] == 0} {#$p insert end "\n\nROTATION (aligned specimens)"}
        
        set V [composantes $transcaledindiv(0)]
        set prex1t [mmult $transcaledindiv(0) $V ]
        
        if {[info exists suit_rot] == 0} {#$p insert end  "\n\nConsensus aligned to its \
                    principal component axes\n\n[show $prex1t %1.4f]\n"}
        
        # formation des points (individus) du consensus prex1t
        set landmark 0
        for  {set i 3} {$i<[expr {$lm*2+2}]} {incr i 2} {
            incr landmark
            set item [lrange $prex1t $i [expr {$i+1}]]
            if {$item != ""} {lappend objet_cons "2 1 2 $item"}
            if {[info exists suit_rot] == 0} {append aligned "$item "}
        }
        if {[info exists suit_rot] == 0} {append aligned "\n"}
        #$p insert end "\n$objet_cons"
        
        # Le consensus dans la variable reference (ici le mot reference est au singulier)
        debug $suit_rot
        if {[info exists suit_rot] == 0} {set reference $aligned}
        # references au pluriel c'est la premiere ligne du fichier de donnees (cfr loadfile)
        
        # Rotations proprement dites
        set x1t [transpose $prex1t]
        for  {set i 1} {$i < [expr {$lignes+1}]} {incr i} {
            set ttrantran($i) [mmult $x1t $transcaledindiv($i)]
            # singular value decomposition
            set U $ttrantran($i)
            msvd_br U S V
            set S "2 2 2 1 0 0 1"
            set H [mmult [mmult $V $S] $U]
            set rot($i) [mmult $transcaledindiv($i) $H]
            append rotind " [lrange $rot($i) 3 end]";#pour creer une liste des bascules
        }
        return $rotind
    }
    #
    # Procedure ROTATION - fin
    
    
    # Procedure COMPOSANTES - start
    #
    proc composantes {pop} {
        global p suit_rot pxpu
        set lignes [lindex $pop 1]
        set colonnes [lindex $pop 2]
        set obsminusone [expr {$lignes - 1}]
        # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
        mnorms_br pop popmeans popsigmas
        # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
        # IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
        set popones "2 1 $colonnes 1"
        set x 1
        set y $colonnes
        while {$x < $y} {lappend popones 1; set x [expr {$x + 1}]}
        # CENTRER LES DONNEES PLUTOT QUE LES NORMALISER
        # ------------------------------------------------
        set Z [mnormalize $pop $popmeans $popones]
        # SINGULAR VALUE DECOMPOSITION using VARCOV for the eigensolution
        # ---------------------------------------------------------------
        set Z [mnormalize $pop $popmeans $popones]
        set ZZ [mmult [transpose $Z] $Z]
        set nless1 [expr {1./$obsminusone}]
        set vcm [mscale $ZZ $nless1]
        set V $vcm
        mevsvd_br V evals
        
        return $V
    }
    #
    # Procedure COMPOSANTES - fin
    
    
    
    # Procedure PARTIALITE ## Debut ###
    #
    proc partialite {reference} {
        global partindiv;# ajout Aug_2009
        global p suit_part rawindividus rot lm
        global infile l1 l2 raizl1l2 ecnerefer prinw
        global tailles_base
        set consensus 0
        set mmm [llength $rawindividus]
        set lignes [expr {$mmm/$lm}]
        #puts "lignes de la base = $lignes"
        if {[info exists suit_part] == 0} {
            #$p insert end "\n\n--------------------------------------------"
            #$p insert end "\nNow computing PARTIAL WARPS SCORES ...\
            \n...according to '1/sqrt(n) . Vi . E. (alpha = 0, hence scale = 1)', see Rohlf (1996)"
            #$p insert end "\n--------------------------------------------\n\n"
        }
        # APPEL a PRINW
        # Calcul des 'principal' warps a l'aide de la procedure PRINW (eigenvectors of the inverse of Lp)
        set prinw [prinwarps $reference]
        # APPEL a PARTIALW
        # Calcul des 'partial' warps 'scores' a l'aide de la procedure PARTIALW
        for  {set i 1} {$i < [expr {$lignes+1}]} {incr i} {
            set objet $rot($i)
            set matrefer [concat "2 $lm 2" $reference]
            set partialwarps($i) [partialw $i $objet $matrefer $prinw]
        }
        if {[info exists suit_part] == 0} {
            set partindiv "";# ajoute Aug2009
            set compteur 0;#il n'existe pas un individu consensus rote
            while {$compteur < $lignes} {
                incr compteur
                if {[info exists suit_part] == 0} {
                    append partindiv "[lrange $partialwarps($compteur) 3 end]\n"
                    append cs_pw_base "[lindex $tailles_base $compteur] [lrange $partialwarps($compteur) 3 end]\n"
                }
            }
        }
        if {[info exists suit_part] == 0} {
            return $partindiv
        }
        set suit_part "1"
        return $partindiv
    }
    #
    # Procedure PARTIALITE - fin
    
    
    # Procedure PRINWARPS = principal warps ## Debut
    #
    proc prinwarps {reference} {
        global p lm
        # D'abord construire la L matrix, puis l'inverser, puis prendre le bloc pxp
        #
        # L matrix Etape 1.
        # ----------------------
        # Le bloc 'pxp' en haut a gauche est la matrice 'U'
        for {set i 0} {$i < [expr {$lm*2}]} {incr i 2} {
            set x1 [lindex $reference $i]
            set y1 [lindex $reference [expr {$i+1}]]
            #$p insert end "\n\n---- x$i = $x1\ty$i = $y1\n\n"
            for {set j 0} {$j < [expr {$lm*2}]} {incr j 2} {
                set x2 [lindex $reference $j]
                set y2 [lindex $reference [expr {$j+1}]]
                #$p insert end "x$j = $x2\ty$j = $y2\n"
                #$p insert end "r2 = [expr ( pow(($x1-$x2),2))] + [expr (pow(($y1-$y2),2 ) ) ]\n"
                set r2 [expr {pow(($x1-$x2),2) + pow(($y1-$y2),2)} ]
                if {$r2 != 0} {set lnr2 [expr {log($r2)}]}
                if {$r2 != 0} {set r2lnr2 [expr {$r2*$lnr2}]}
                if {$r2 != 0} {append preU "$r2lnr2 "} else {append preU "0.000000 "}
            }
        }
        set U "2 $lm $lm $preU"
        
        # L matrix Etape 2.
        # ---------------------
        # A cette matrice 'U' de distances je joins 3 colonnes,
        # l'une de 1 et les deux autres contenant la reference (l'objet consensus)
        set popones "2 $lm 1 1 "
        set x 1
        set y $lm
        while {$x < $y} {lappend popones 1; set x [expr {$x + 1}]}
        set consens "2 $lm 2 $reference"
        # debug
        # $p insert end "\n On va tenter de fusionner\n[show $popones]\net\n[show $consens %1.4f]"
        set ajoutdroit [join_cols $popones $consens]
        # debug
        # $p insert end "\n On va  la lui ajouter a droite \n[show $ajoutdroit %1.4f]"
        set U_droit [join_cols $U $ajoutdroit]
        # debug
        # $p insert end "\nSoit:\n[show $U_droit %1.4f]"
        #
        # L matrix Etape 3.
        # ----------------------
        # A cette nouvelle matrice de lm+3 colonnes j'ajoute 3 lignes bas,
        # l'une de 1 et les deux autres contenant la reference (l'objet consensus)
        # puis je termine la matrice par des zeros (dans le coin inferieur droit)
        set preajoutbas [transpose $ajoutdroit]
        set leszeros "2 3 3 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0"
        set ajoutbas [join_cols $preajoutbas $leszeros]
        # debug
        # $p insert end "\n On va lui ajouter en bas \n[show $ajoutbas %1.4f]"
        set U_droit_bas [join_rows $U_droit $ajoutbas]
        # debug
        # $p insert end "\n Soit alors \n[show $U_droit_bas %1.4f]"
        
        # Inverse de la matrice L
        set Lmatrix $U_droit_bas
        
        set identite [mident [expr {$lm+3}]]
        set invLmatrix [msolve $Lmatrix $identite]
        # debug
        #$p insert end "\n Inverse of L \n[show $invLmatrix %1.6f]"
        # set verification [mmult $Lmatrix $invLmatrix]
        # $p insert end "\nVERIFICATION DE L'INVERSE\n[show $verification %1.0f]"
        
        # Upper left 'p x p' bloc of this matrix as the bending energy matrix
        set bendingenergy [mrange $invLmatrix 0 $lm 0 $lm]
        
        # APPEL a  COMPOSANTES
        # Principal warps (appel a la procedure 'composantes')
        global pxpu
        set pxpu 1
        set V [composantes $bendingenergy]
        set prinW [mrange $V 0 [expr {$lm-4}] 0 [expr {$lm-1}]]
        #$p insert end "\n\nPRINCIPAL WARPS\n(eigenvectores of bending energy matrix)\
        \n\tMatrix size is 'p x (p - k - 1)'\
                \n\t(p = number of landmarks; k = number of dimensions)\
                \n[show $prinW %1.4f]"
        return $prinW
    }
    #
    # Procedure PRINCIPAL warps
    
    
    # Procedure PARTIALW - (partial warps scores) - debut
    #
    # 1. Calcul des pw scores, composante uniforme
    #
    # 2. Calcul des partial warps scores selon '1/sqrt(n) . Vi . E. (alpha = 0, donc scale = 1)'
    #
    ### 'Partial warps scores are the inner product of each row of Vi = Xi - Xc
    ### 'with the p-k-1 columns of E (Rohlf, 1996).'
    #
    proc partialw {i objet matrefer prinw} {
        
        global p lm
        
        # L'objet et la reference
        set grandxi [transpose $objet]
        set reference [transpose $matrefer]
        # Vi = difference entre objet et reference
        set grandvi [msub $grandxi $reference]
        
        # Zeldich et al -------------------------- start -----------------------------
        set ajout "2 3 2 0 0 0 0 0 0"
        set tgrandvi [transpose $grandvi]
        
        #$p insert end "\n\ntransposed GRANDVi (difference entre objet et reference)\
        #        \n$tgrandvi\
        #        \n[show $tgrandvi]"
        set grandve [join_rows $tgrandvi $ajout]
        #debug
        #$p insert end "\nZ. et al.\n[show [mmult $invLmatrix $grandve]]\n"
        # Zeldich et al --------------------------  fin  -----------------------------
        
        # -------------------------------------------------------------------
        #
        # Composante AFFINE, ou UNIFORME, de la CONFORMATION
        #
        # -------------------------------------------------------------------
        
        # -------------------------------------------------------------------
        # Toujours le calcul des U1 et U2 commence dans la procedure rotation
        # -------------------------------------------------------------------
        # Preparation du calcul de U1 et U2
        set grandxi2 [mprod $grandxi $grandxi]
        set grandxi2 [transpose $grandxi2]
        set prelambda [msum $grandxi2]
        set l1 [lindex $prelambda 3]
        set l2 [lindex $prelambda 4]
        set raizl1l2 [expr {sqrt($l1 * $l2)}]
        
        set col2 [mrange $grandxi 0 [expr {$lm-1}] 0 0]
        set col1 [mrange $grandxi 0 [expr {$lm-1}] 1 1]
        set ixdnarg [join_rows $col1 $col2]
        
        # ---------------------------------
        # Le calul de U2
        # ---------------------------------
        #
        set proU2 [mprod $grandxi $grandvi]
        
        set proU2 [transpose $proU2]
        set preU2 [lindex [msum $proU2] 4]
        set U2($i) [expr {$preU2/$raizl1l2}]
        #
        # ---------------------------------
        # Le calul de U1
        # ---------------------------------
        #
        # Le calcul de U1 est plus alambique !
        set presydeltax [mprod $ixdnarg $grandvi]
        set presydeltax [transpose $presydeltax]
        set sydeltax [lindex [msum $presydeltax] 3]
        # debug
        # $p insert end "\n\nsydeltax $sydeltax"
        set sxdeltay [lindex [msum $presydeltax] 4]
        set sumoins [expr {$sxdeltay - $sydeltax}]
        set l2moins [expr {$l2 * $sumoins}]
        set U1($i) [expr {($sydeltax + $l2moins)/$raizl1l2}]
        # debug
        # $p insert end "\n\nsydeltax $sydeltax"
        # $p insert end "\n\nIndividu $i \nU1\t $U1($i)\nU2\t $U2($i)"
        set uniform "2 1 2 $U1($i) $U2($i)"
        #
        # --------------------------------------------------------------------
        #
        # Composante NON AFFINE ou NON UNIFORME de la CONFORMATION
        #
        # --------------------------------------------------------------------
        # #     ATTENTION TEST 4 JUILLET 2006 RETRAIT DU SCALE FACTOR
        set scalefactor 1
        ## 1/sqrt(n)
        #set scalefactor [expr {1.0*(1.0/sqrt(2))}]
        ## 1/sqrt(n) . Vi
        set propw [mscale $grandvi $scalefactor]
        # 1/sqrt(n) . Vi . E. (alpha = 0, donc scale = 1)
        set prepw [mmult $propw $prinw]
        set partialwarps($i) [transpose $prepw]
        #
        # --------------------------------------------------------------------
        #
        # Les deux composantes AFFINE, et NON AFFINE, dans une meme matrice
        #
        # --------------------------------------------------------------------
        #
        set partialwarps($i) [join_rows $partialwarps($i) $uniform]
        # debug
        #$p insert end "\n\npartialwarps de $i\n$partialwarps($i)"
        return $partialwarps($i)
    }
    #
    # procedure PARTIAL warps
    
    
    
    # Procedure SUBDIVIDED_MATRIX_PW - debut
    #
    proc subdivided_matrix_pw {mdonnees} {
        # 'mdonnees' est une HUME matrice
        global lignes colonnes lm rawindividus tablind reference
        #$p insert end "\nDONNEES INITIALES\n[show $mdonnees %1.3f]\n"
        set matinit [lrange $mdonnees 0 2]
        set colonnes [lindex $matinit 2]
        set lignes [lindex $matinit 1]
        set lm [expr {$colonnes/2}]
        #
        #debug "\n$lignes\tconfiguraciones\t\t$lm\tlandmarks\n"
        
        # calcul du consensus (configuration moyenne)
        set consensus [mnorms $mdonnees];# a ce stade, 'consensus' est une matrice de Hume
        set consensus [lrange $consensus 3 [expr {3+$colonnes-1}]];# a present, 'consensus' est une liste
        set consensus [lformat %1.3f $consensus]
        set donnees [lrange $mdonnees 3 end];# les donnees sous forme de liste, egalement
        set data "";# data deviendra une liste de listes ayant l'aspect d'un tableau
        for  {set i 0} {$i < [expr {$lignes*$colonnes}]} {incr i $colonnes} {
            set tranche [lrange $donnees $i [expr {$i+$colonnes-1}]]
            append data "$tranche\n"
        }
        
        # On classe les coordonnees successives par individu dans la table tablind()
        if {[info exists tablind]} {unset tablind}
        set i -1
        set compteur 0
        set tablind(0) $consensus
        foreach item [split $data "\n"] {
            #$p insert end "\n\nPour tablind:\n$item\n"
            if {$item != ""} {
                # On saute la premiere ligne
                incr compteur
                if {$compteur > 0} {
                    #verification du nombre de lm de chaque individu
                    if  {$colonnes != [llength $item]} {
                        puts "$lm <> [llength $item]"
                        exit
                    }
                    incr i
                    set tablind($compteur) $item
                }
            }
        }
        #
        #debug "CONFIGURATION CONSENSUS \n$tablind(0)"
        
        # AJOUTE EN SEPTEMBRE 2008
        # On cree une LISTE (un individu) de MATRICES (de coordonnees)
        # (une matrice est un couple de coordonnees, elle a 1 ligne et 2 colonnes)
        # (chaque 'landmark' est une 'matrice')
        if {[info exists rawindividus]} {unset rawindividus} else {set rawindividus ""}
        set n [llength $data]
        #debug "\nCREATION DES INDIVIDUS ($data)"
        for  {set i 0} {$i < $n} {incr i 2} {
            set item [lrange $data $i [expr {$i+1}]]
            lappend rawindividus "2 1 2 $item"
        }
        #
        debug "rawindividus\n[lrange $rawindividus 0 4]\tetc."
        # calculs PW proprement dits
        set preindividus [translation $lm]
        set proindividus [scaling $lm]
        set rotindividus [rotation]
        #
        set hume "2 [expr {$colonnes / 2}] 2 "
        set montref $hume$reference;# 'reference' apportee comme variable globale
        #
        set part [partialite $reference]
        set hume "2 $lignes [expr {$colonnes - 4}] "
        set montpart $hume$part
        #debug "Procedure SUBDIVIDED_MATRIX_PW: reference\n[show $montref]\
        \n\nPARTIALWARPS (classique)\n[show [mrange $montpart 0 2 0 1]]\netc..."
        return $rotindividus;# CE SONT LES INDIVIDUS ALIGNES
    }
    #
    # Procedure SUBDIVIDED_MATRIX_PW - fin
    
    
    #
    # PROCEDURES d'ITERATION
    #
    proc iteration_aligned {x_mat_aligned hume} {
        debug "Procedure iteration_aligned \n$x_mat_aligned \
                \nlongueur [llength $x_mat_aligned]"
        # Alignement des individus (ce que renvoie la procedure 'subdivided_matrix_pw' )
        # ... procedure qui porte mal son nom, je sais - de plus elle calcule de PW !
        set x_mat_aligned [subdivided_matrix_pw $x_mat_aligned]
        set x_input "$hume $x_mat_aligned"
        return $x_input;# les alignes dans une nouvelle variable pour iteration
    }
    
    #
    # PROCEDURES d'ITERATION
    #
    proc iteration_reference {x_input} {
        # Calcul du nouveau consensus, et donc des PW correspondant
        set reftrac [mnorms_br x_input reftruc std]
        set reference [lrange $reftruc 3 end];# 'reftruc', pas 'reftrac'
        #debug "\nnouvelle reference \n[show $reftruc]"
        return [partialite $reference]
    }
    #
    
    proc pw {x_total} {
        set x_mat $x_total
        set hume [lrange $x_total 0 2];# pour liste -> matrice
        # Pour le premier tour, les PW sont calcules par  'subdivided_matrix_pw', mais on s'en fout,
        # ce qui nous interesse, c'est que la procedure  'subdivided_matrix_pw' renvoie les individus alignes
        ##debug "\nnew PW computation suit_rot = $suit_rot"
        set aligned [subdivided_matrix_pw $x_mat]
        set aligned "$hume $aligned"
        debug "Ces dollars aligned, c'est quoi ? \nRep $aligned"
        # La moyenne de ces aligned deviendra la nouvelle reference (le nouveau consensus)
        # ... qu'on enverra dans la procedure 'partialite'
        #
        # La procedure subdivided_matrix_pw calcule aussi les PW, places dans la variable 'partindiv'
        set PW_hume "2 $lignes [expr {$colonnes - 4}] "
        set PW_iteration(0) "$PW_hume $partindiv"
        #debug "\n%%%%%%%%%%%%%% \n[show $PW_iteration(0)] \n%%%%%%%%%%%%"
        debug "\nPeut-etre puis-je voir les premiers PW: \n[lrange $partindiv 0 12]\n"
        #
        # La premiere reference est  montree ici pour presentation
        debug "\nPrem ref $reference\n"
        #
        set sum 0.001
        set i 1
        while {[expr {abs([show $sum])}]  > 0.0001} {
            global partindiv
            #for {set i 1} {$i < 3} {incr i} {}
            debug "ITERATION $i:\n [lrange $aligned 0 4]\n$hume"
            set new_aligned [iteration_aligned $aligned $hume]
            set aligned $new_aligned
            set PW_iteration(0) "$PW_hume $partindiv"
            debug "\nITERATION $i: PW iteration [expr $i - 1]\
                    \n [lrange $PW_iteration(0) 0 3] \tlongueur [llength $PW_iteration(0)]"
            #
            set new_ref [iteration_reference $new_aligned]
            set PW_iteration($i) "$PW_hume $partindiv"
            debug "\nITERATION $i: PW iteration $i\
                    \n [lrange $PW_iteration($i) 0 3] \tlongueur [llength $PW_iteration($i)]"
            debug "\nPW iteration [expr $i ]\n [show  $PW_iteration($i)]"
            #
            set a [msub $PW_iteration($i) $PW_iteration([expr $i - 1]) ]
            set sum [msum [msum $a]]
            debug "\n$i\tSOMME\t[show $sum] et [expr {abs([show $sum])}] "
            if {[show $sum] < 0.000} {debug "ET VOILAAAA"}
            incr i
        }
    }
    #
    # Aug_2009 - fin des nouveaux calculs de PW -----------------------  fin ---------------------
    # -----------------------------------------------------------------------------------------------------------------------
}