# En faire un "bouton" a partir de jpdraw_15.tcl, procedure dessine

# package require Tk


################### rouge ##### Procedure ## Debut ##
proc rouge {mesg args} {
    global q
    $q insert end $mesg "rouge"
    $q tag configure rouge -foreground red
    $q see end
}
################### rouge ####### PROCEDURE ## FIN ###

################### orange ##### Procedure ## Debut ##
proc orange {mesg args} {
    global q
    $q insert end $mesg "orange"
    $q tag configure orange -foreground orange
    $q see end
}
################### orange ####### PROCEDURE ## FIN ###

################### vert ##### Procedure ## Debut ##
proc vert {mesg args} {
    global q
    $q insert end $mesg "vert"
    $q tag configure vert -foreground "dark green"
    $q see end
}
################### vert ####### PROCEDURE ## FIN ###


#
# procedure DEBUG
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti q
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x600+205+66
        set memo [text .debug.t -wrap word -height 22 -font "courier 13" \
                -bg grey88 \
                -fg black\
                -tabs "3c left"\
                -yscrollcommand ".debug.v_scroll set" \
                -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici q
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag q
            if {$flag == 1} {
                .debug.t configure -wrap none
                set flag 0
            } else  {
                .debug.t configure -wrap word
                set flag 1
            }
        }
        
        #
        $memo insert end $bugatti
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG fin



# Procedure LLOADFILE ##### debut
proc lloadfile {pathname} {
    global references premligne colcount rowcount S q
    set fid [open $pathname]
    set text [read -nonewline $fid]
    close $fid
    set rowcount 0
    set colcount 0
    set compteur 0
    set lignes 0
    set datos ""
    foreach line [split $text \n] {
        #
        incr compteur
        #debug "$compteur $line\n"
        if {$compteur >1} {
            # SI CE N'EST PAS LA PREMIERE LIGNE
            if  {[llength $line] > 0} {
                # SI LA LIGNE N'EST PAS VIDE
                set colcount [llength $line]
                #
                foreach item [split $line] { if {$item != ""} {
                        incr lignes
                        lappend datos $item
                    }
                }
                #debug "compteur > 1 ($compteur) et la ligne (ligne $lignes) n'est pas vide; il y a $colcount colonnes"
                #
                if {[expr {$lignes/$colcount}] != [expr {$compteur-1}] } {
                    # SI UNE DONNEE MANQUE
                    if {[info exists ici] == 0} {set ici [expr {$compteur-1}]}
                }
            } else  {
                incr compteur -1
                #debug "compteur > 1 ($compteur) et la ligne EST vide"
            }
        } else {set references $line}
    }
    
    if {[info exists ici]} {
        tk_messageBox -message "Missing data near row $ici?" -type ok
    }
    
    #set colcount [llength $line]
    set rowcount [expr {$lignes/$colcount}]
    #set rowcount [expr {$compteur - 1}]
    set result [concat 2 $rowcount $colcount $datos]
    
    #debug "Commentaire brut :\nNOMBRE DE CONFIGURATIONS $compteur??? $rowcount\n$result"
    set premligne $references
    # -- Formater le commentaire
    # -- 1. Enlever d'eventuelles tabulations
    foreach mot $references {
        if {$mot != ""} {
            append comentario_sin_tab "$mot "
        }
    }
    set references $comentario_sin_tab
    #debug "commentaire sans tabulations;\n $references"
    # -- 2. Introduire des passages a la ligne (\n)
    set compteur 0
    set nbcaract [string length $references]
    #debug "$references\nNombre de caracteres de a premiere ligne $nbcaract"
    if {$nbcaract > 80} {
        while {$compteur < $nbcaract} {
            incr compteur
            if {[expr $compteur % 80] != 0} {
                #debug "string index references $compteur -> [string index $references $compteur]"
                append newref [string index $references [expr {$compteur-1}] ]
            } else {
                append newref "[string index $references [expr {$compteur-1}] ] - \n"
            }
        }
    } else  {
        set newref $references
    }
    # v 74f: J'annule ce formatage, sauf l'enlevement des tabulations
    #set references $newref
    set references $comentario_sin_tab
    #debug "Commentaire formate\n$references"
    
    # -- FIN du formatage de la premiere ligne
    #set S(colcount) $colcount
    #set S(rowcount) $rowcount
    
    return $result;# C'est une matrice de  HUME qui est retournee
}
#
# Procedure LLOADFILE # fin


# Procedure LLOADFILE_CS - debut
#
proc lloadfile_cs {pathname} {
    global S q
    global text_cs data_cs references_cs premligne_cs
    set fid [open $pathname]
    set text_cs [read -nonewline $fid]
    
    close $fid
    set rowcount_cs 0
    set colcount_cs 0
    
    set compteur 0
    set lignes_cs 0
    set data_cs ""
    ################################################################################
    #     # Au cas ou le fichier de donnees contient les tailles centroides
    #     # la premiere valeur (deuxieme ligne) pourrait etre le consensus
    #     if {$S(cs) == 1} {set seuil [trebuche]} else {set seuil 1}
    ################################################################################
    set seuil 1
    foreach line [split $text_cs \n] {
        incr compteur
        if {$compteur > $seuil} {
            if  {$line != ""} {
                set colcount_cs [llength $line]
            }
        }
        if {$compteur > $seuil} {
            foreach item [split $line] { if {$item != ""} {
                    incr lignes_cs
                    lappend data_cs $item
                }
            }
        } else {append premligne_cs "SAMPLE INFO: $line\n"}
    }
    set rowcount_cs [expr $lignes_cs/$colcount_cs]
    set result [concat 2 $rowcount_cs $colcount_cs $data_cs]
    set references_cs $premligne_cs
    return $result
}
#
# Procedure LLOADFILE_CS - fin

# Procedure RANMAT
#
proc rranmat {pop} {
    set lignes [mrows $pop]
    set lignesmoinsun [expr {$lignes - 1}]
    set colonnes [mcols $pop]
    set colonnesmoinsun [expr {$colonnes - 1}]
    
    set popnew "2 $lignes $colonnes "
    # - - - - - - - - - - - - - - - - - - - - - - -
    # MATRICE ALEATOIRE "SAMPLING WITH REPLACEMENT"
    # - - - - - - - - - - - - - - - - - - - - - - -
    for {set i 0} {$i < $lignes} {incr i} {
        set num [expr {round( $lignesmoinsun * rand() ) } ]
        set rowfirst [expr {($colonnes * $num)+3} ]
        set rowlast [expr {$rowfirst + $colonnesmoinsun} ]
        set newline [lrange $pop $rowfirst $rowlast ]
        #set popnew [concat $popnew $newline]
        append popnew "$newline "
    }
    #set newpop $popnew
    return $popnew
}
#
# Procedure RANMAT



########################ppermute# PROCEDURE ## DEBUT ###
proc ppermute {chagrin args} {
    global distperm p gr effectifs distobs popones wiwi q
    # bug avril 2004
    set distperm ""
    # ce bug n'a pas eu d'effet sur les versions PAD56 et anterieures,
    # ou la procedure mahala n'existe pas ...
    set colonnes [mcols $chagrin]
    set lignes [mrows $chagrin]
    set fin [expr $lignes + 1]
    set newpop "2 $lignes $colonnes"
    set colonnesmoinsun [expr $colonnes - 1]
    for {set i 0} {$i < [expr $lignes-1]} {incr i} {
        set nouvelordre {}
        set debut 1
        set choix [expr int(($fin-1)*rand())]
        set newwline [lrange $chagrin [expr 3+($colonnes*$choix)] \
                [expr 3+($colonnes*$choix)+$colonnesmoinsun]]
        foreach item [split $newwline] {lappend newpop $item}
        set fin [expr $fin - 1]
        set chagrin [lreplace $chagrin [expr 3+($colonnes*$choix)] \
                [expr 3+($colonnes*$choix)+$colonnesmoinsun] ]
    }
    for {set i 0} {$i < $colonnes} {incr i} {
        set mouchoir [lindex $chagrin [expr 3+$i]]
        set newpop [lappend newpop $mouchoir]
    }
    return $newpop
}
########################ppermute # PROCEDURE ## FIN ###

##########################################
# DEBUT DE LA PROCEDURE PREHISTOGRAMME
#
proc prehistogramme {X args} {
    global colonnes
    global dhist
    global p25
    global p95
    global lamoy
    global q
    
    #debug  "PROC pre-HISTOGRAMME"
    debug "colonnes \t $colonnes"
    #debug [parray dhist]
    #debug"\nMoyenne sur $X individus apres ...permutations \t$lamoy\np25\t$p25\np95\t$p95"
    # -----
    
    for {set i 0} {$i < $colonnes} {incr i} {
        set kleur [expr {$i*9}]
        set ventana($args) fen$args
        set orderedalometries [ lsort -real [lrange $dhist($i) 3 end] ]
        #debug $orderedalometries
        
        set varp25($i) [lindex $orderedalometries $p25]
        set varp95($i) [lindex $orderedalometries $p95]
        #debug "Dans l'ordre ... \n$orderedalometries\np25 = $varp25($i)\np95 = $varp95($i)"
        set allal $orderedalometries
        set longueur [llength $orderedalometries]
        set min [lindex $allal 0]
        set max [lindex $allal end]
        set nbh 12;# Nombre de barres de l'histogramme --- #
        set intervalle [expr {round(($max - $min) * 1.0/$nbh)}]
        set intervalle [expr {($max - $min) * 1.0/$nbh}]
        if {$intervalle == 0} {set intervalle 1}
        
        #debug "intervalle $intervalle"
        
        set a 0
        foreach item $allal {set alomdissec($a) $item; incr a}
        set barruc [expr {$min + $intervalle - ($intervalle * 1.0/10)}]
        
        #debug  "barruc $barruc"
        
        set accum(0) 0
        set compte 0
        for {set k 0} {$k < [expr $nbh+1]} {incr k} {
            for {set j 0} {$j < $X} {incr j} {
                if {$alomdissec($j) < $barruc} {
                    if {$alomdissec($j) > [expr $barruc - $intervalle]} \
                            {set compte [expr $compte + 1]}
                }
            };
            set accum($k) $compte;
            set compte 0;
            set barruc [expr $barruc + $intervalle]
        }
        set P $i*2
        set allob [lindex $lamoy [expr 3+$i]]
        global barres
        set barres {};# Liste des effectifs de classes accum(0-12) --- #
        for {set b 0} {$b < [expr $nbh+1]} {incr b} {
            lappend barres $accum($b)
        }
        set fenetre $ventana($args)
        histogramme $barres $allal $allob $P $fenetre $varp25($i) $varp95($i)
    }
}
############## fin de la procedure PREHISTOGRAMME #######


########################Histogramme## PROCEDURE ## DEBUT###

proc histogramme {Pbarres Pallal Pallob P fenetre Pp25 Pp95} {
    global lucarne q qte prePp25 pourplustard corrx_subsp intervalle_subsp
    
    #debug
    #debug "\n----------------\nPROC HISTOGRAMME"
    #debug "Pbarres\t$Pbarres"
    #debug "Pallal\t$Pallal"
    #debug "Pallob\t$Pallob"
    #debug "P\t$P\tfenetre\t$fenetre\tPp25\t$Pp25\tPp95\t$Pp95"
    
    set ordre [lsort -real $Pbarres]
    set nbh [llength $Pbarres]; # on recupere la valeur de nbh en variable locale --- #
    set minimumbarre [lindex $ordre 0]
    set maximumbarre [lindex $ordre end]
    
    #debug "maximumbarre $maximumbarre"
    
    set corrx_subsp [expr {300.0/$nbh}]
    set corry [expr {300.0/$maximumbarre}]
    
    set minal [lindex $Pallal 0]
    set maxal [lindex $Pallal end]
    set preintervalle [expr $maxal - $minal]
    set intervalle_subsp [expr {round($preintervalle * (1.0/$nbh))}]
    set intervalle_subsp [expr {$preintervalle * (1.0/$nbh)}]
    #debug "(Proc HIST)intervalle_subsp = $intervalle_subsp"
    set prexobs [expr ($Pallob - $minal) * (1.0/$intervalle_subsp)]
    set xobs [expr 100 + ($corrx_subsp * $prexobs)]
    
    set w .$fenetre
    set lucarne $fenetre
    catch {destroy $w}
    toplevel $w
    wm title $w "Distribucion [string index $fenetre end]"
    
    set ar [expr $P+198]
    set rg [expr $P+10]
    wm geometry $w 500x500+$ar+$rg
    wm geometry $w 500x500+700+50
    wm iconname $w "Plot"
    
    set c $w.c$fenetre
    #tk_messageBox -message $c -type ok
    set Font13 {Helvetica 13}
    set Font18 {Helvetica 18}
    
    frame $w.tirette
    pack $w.tirette -side top -fill x -pady 2m
    
    if {$qte == "no"} {
        label $w.tirette.msg -font $Font13 -wraplength 4i -foreground yellow -justify left -text "Metric disparities"
    } else  {
        label $w.tirette.msg -font $Font18 -wraplength 4i -foreground yellow -justify left -text "subspaces"
    }
    
    set aide [button $w.tirette.aide -text "AYUDA" -background grey22 -foreground green -command "graphelp"]
    pack $w.tirette.msg $w.tirette.aide -side left -expand 1
    
    button $w.tirette.cancel -background grey22 -foreground green -text "ICONIFY" -command "wm iconify $w"
    button $w.tirette.ps -text "save graph" -command {
        global lucarne q
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        set filename [tk_getSaveFile -filetypes $file_types -initialdir pwd -defaultextension .gra]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.$lucarne.c$lucarne postscript]
        close $outputGraphe
    }
    button $w.tirette.ex -background grey22 -foreground green -text "EXIT" -command "destroy $w"
    pack $w.tirette.cancel $w.tirette.ps $w.tirette.ex -side left -expand 1
    
    canvas $c -width 450 -height 450 -relief raised -background black
    
    pack $c -side top -fill x
    
    #tk_messageBox -message "minal = $minal" -type ok
    
    set plotFont {Helvetica 12}
    set prePp25 [expr ($Pp25 - $minal) * (1.0/$intervalle_subsp)]
    set prePp95 [expr ($Pp95 - $minal) * (1.0/$intervalle_subsp)]
    
    for {set i 0} {$i < $nbh} {incr i} {
        set contbarre [ lindex $Pbarres $i ];
        set x [ expr 100 + ($corrx_subsp * $i) ];
        set y [ expr 350 - ( $corry * $contbarre ) ];
        set item [$c create rect [expr $x-10] 350 [expr $x+10] [expr $y] \
                -width 1 -outline yellow -fill black];
        $c addtag point withtag $item
    }
    $c create line 10 350 450 350 -fill orange -width 4
    ##### axe des x croit de g a droite (procedure HISTOGRAMME)
    $c create line [expr 100 + ($corrx_subsp * $prePp25)] 350\
            [expr 100 + ($corrx_subsp * $prePp95)] 350 -fill yellow -width 4
    set minal [format "%2.3f" $minal]
    #$c create text 25 360 -text "$minal" -fill orange -anchor n -font $plotFont;# <- MINIMUM DES SUBSPACES ECRIT EN orange
    set maxal [format "%2.3f" $maxal]
    #$c create text 450 360 -text "$maxal" -fill orange -anchor n -font $plotFont;# <- MAXIMUM DES SUBSPACES ECRIT EN ornage
    
    set cool [format "%2.5f" $Pp25]
    set xcool [expr 100 + ($corrx_subsp * $prePp25)]
    $c create text $xcool 360 -text $cool -fill yellow -anchor n -font $plotFont;#<- MAXIMUM DES SUBSPACES en jaune
    $c create line $xcool 348 $xcool 357 -fill yellow -width 4
    
    set cool [format "%2.5f" $Pp95]
    set xcool [expr 100 + ($corrx_subsp * $prePp95)]
    $c create text $xcool 360 -text $cool -fill yellow -anchor n -font $plotFont;#<- MINIMUM DES SUBSPACES en jaune
    $c create line $xcool 348 $xcool 357 -fill yellow -width 4
    
    set Pallob [format "%2.5f" $Pallob]
    ################################################################################
    #     if {$Pallob > $maxal} {
    #         $c create line 460 350 460 50 -fill orange -width 1
    #         $c create text 460 10 -text [format "%2.5f" $Pallob] -fill blue -anchor n -font $plotFont
    #     } elseif {$Pallob < $minal} {
    #         $c create line 5 350 5 50 -fill orange -width 1
    #         $c create text 20 10 -text [format "%2.5f" $Pallob] -fill blue -anchor n -font $plotFont
    #     } else {
    #         $c create line $xobs 350 $xobs 50 -fill orange -width 4
    #         $c create text $xobs 10 -text [format "%2.5f" $Pallob] -fill yellow -anchor n -font $plotFont;# <- MOYENNE DES SUBSPACES
    #     }
    ################################################################################
    $c create line $xobs 350 $xobs 50 -fill orange -width 4
    $c create text $xobs 10 -text [format "%2.5f" $Pallob] -fill yellow -anchor n -font $plotFont;# <- MOYENNE DES SUBSPACES
}
#
# Procedure histogramme  - FIN



# Procedure MDISPAR
#
# calcul de la disparité métrique (md)
#
proc mmdispar {sample} {
    #
    # sample matrice de Hume, Partial Warps d'un certain nombre d'individus (cfr. 'set sample |mrange $sample 0 end 0 $x|' du bouton 'GO')
    #
    # Total number of cells
    set n [mrows $sample]
    set nMoins1 [expr {$n - 1}]
    # each value is squared
    set xprodx [mprod $sample $sample]
    # total sum of rows and cols
    set md [msum [msum $xprodx]]
    set md [expr {$md * 1.0 / $nMoins1}]
    return $md
}
#
# Procedure MDISPAR


# Procedure QUANTITY
#
# Mesure de l'aire d'un sous-espace morphologique
#
proc quantity {sample} {
    #
    # sample matrice de Hume, prem. col. PC1, deuxième col. PC2 (cfr. 'set sample |mrange $sample 0 end 0 $x|' du bouton 'GO')
    #
    for {set i 0} {$i < [mrows $sample]} {incr i} {
        append pc1 "[vtrim [mrange $sample 0 0 $i $i]] "
        append pc2 "[vtrim [mrange $sample 1 1 $i $i]] "
    }
    #debug "PC1\n$pc1\nPC2\n$pc2"
    # On extrait les valeurs minimum et maximum de chaque liste
    set listexordre [lsort -real $pc1]
    set listeyordre [lsort -real $pc2]
    #debug "Ordrepc1\n$listexordre\nOrdrepc2\n$listeyordre"
    #
    # Ecart des x, ecart des y
    set rangex [expr {abs([lindex $listexordre end] - [lindex $listexordre 0])}]
    set rangey [expr {abs([lindex $listeyordre end] - [lindex $listeyordre 0])}]
    set tcc "\
            \n\nFactor 1, range: $rangex\
            \nFactor 2, range: $rangey"
    #$c create text 40 435 -text $tcc -font "Courrier 7" -anchor w -fill "dark green" -tag data_info
    #debug $tcc
    set quantite [expr {$rangex * $rangey}]
}
#
# Procedure QUANTITY


# ----------------------------------------------------------------------------------------------
#
# SCRIPT PRINCIPAL
#
# 0. Sources... doivent etre appelees apres que le PWD soit bien defini
#
# 1. Data input (matrice de Hume) = infile
#
# 2. Sampling WITHOUT replacement of X individuals from the total, P times
#    2.a permutation of the total data (infile)
#    2.b sampling of X first data
#    2.c computing of a given Q quantity (for instance the mean of the X randomly sampled data)
#
# 3. Histogram of the Q quantities P times
#
# ----------------------------------------------------------------------------------------------


#
#
# ATTENTION jpdraw_15!!
# cd [file dirname [info script]]
#
global q S flag

set flag 1


# FENETRE SUR COURS

toplevel .cours
wm geometry .cours 800x600+50+50
set q [text .cours.t -wrap word -height 22 -font "courier 13" \
        -bg "light yellow" \
        -fg "dark blue"\
        -tabs "3c left"\
        -yscrollcommand ".cours.v_scroll set" \
        -xscrollcommand ".cours.h_scroll set"]
scrollbar .cours.v_scroll -command ".cours.t yview"
scrollbar .cours.h_scroll -command ".cours.t xview" -orient horizontal
pack .cours.v_scroll -side right -fill y
pack .cours.h_scroll -side bottom -fill x
pack .cours.t -side bottom -fill both -expand 1
button .cours.exit -fg red -text "Exit" -command {
    global find_last_indx pointf ici
    destroy .cours .head
}

button .cours.wrap -fg red -text "Wrap" -command {
    global flag
    if {$flag == 1} {
        .cours.t configure -wrap none
        set flag 0
    } else  {
        .cours.t configure -wrap word
        set flag 1
    }
}
set nbp "100 10"

entry .cours.nbp -text "Permutations, Sample size " -fg red -textvariable nbp

button .cours.go -fg red -text "Go" -command {
    
    # CHOIX DU NB DE PERM ET DU NB D'INDIVIDUS - A TRANSFORMER EN BOUTONS
    set nbP [lindex $nbp 0]
    set Q "2 $nbP 1 "
    #
    set X [lindex $nbp 1]
    set x [expr {$X-1}]
    
    #tk_messageBox -message "nbp $nbp\nnbP $nbP\nX $X" -type ok
    
    #
    set compteur 0
    for {set i 0} {$i < $nbP} {incr i} {
        incr compteur
        #    2.a permutation of the total data (infile)
        #    2.b sampling of X first data
        set sample [rranmat $mdonnees];# ici je cherche le bootstrap
        #debug "$compteur / Permutation [expr {$i+1}]:\n[show $sample]"
        set sample [mrange $sample 0 end 0 $x]
        #debug "$compteur / Permutation [expr {$i+1}]:\n[show $sample]"
        #    2.c computing ...
        if {$qte == "no"} {
	    # ... of the metric disparity
            set quantite [mmdispar $sample];# calcul de la disparité métrique
        } else  {
	    #  ... of a given quantity: PC1 and PC2 values of each individual of the sample
            set quantite [quantity $sample];# calcul de l'aire dans un sous-espace de composantes principales
        }
        #set quantite [quantity $sample];# voir ligne 759
        #set quantite [mmdispar $sample];# voir ligne 760
        #
        append Q "$quantite "
        update
        .cours.go configure -text $i
    }
    .cours.go configure -text "Go"
    #debug "Quantity for the total data: [lindex [vtrim [mnorms $mdonnees]] 0]"
    #debug "Quantity Q for $X randomly selected data \n$Q"
    #debug "ordre Q \n[lsort -increasing [vtrim $Q]]\n"
    mnorms_br Q moy sigm
    if {$qte == "no"} {
        $q insert end "\n\nMetric disparity, total: [mrows $mdonnees] individuals: \
                \n\t$qte_reference"
        $q insert end "\n\n$nbP Metric disparities for $X individuals: \
                \nmean \t[vtrim $moy]\
                \nminimum \t[lindex [lsort -real -increasing [vtrim $Q]] 0] \
                \nmaximum \t[lindex [lsort -real -increasing [vtrim $Q]] end]\n"
    } else  {
        $q insert end "\n\nEspace total, [mrows $mdonnees] individus: \
                \n$qte_reference"
        debug "Q\n$Q\nvtrim Q \n[vtrim $Q]\n'lsort -real -increasing 'vtrim Q'' \n[lsort -real -increasing [vtrim $Q]]"
        $q insert end "\n\n$nbP sous-espaces de $X individus: \
                \nmoyenne [vtrim $moy]\
                \nminimum [lindex [lsort -real -increasing [vtrim $Q]] 0] \
                \nmaximum [lindex [lsort -real -increasing [vtrim $Q]] end]\n"
        orange "\nIf you want to estimate the probability of a given value, enter it in "
        rouge "the second entry"
        orange " and hit the "
        vert "'Compute'"
        orange " button\n"
    }
    
    
    
    #
    # A present que nous avons toutes les quantites obtenues sur l'ensemble des permutations, nous pouvons passer a l'histogramme
    # Ici, l'histogramme va presenter l'eventail des sous espaces obtenus avec un recrutemenr de X individus
    #
    #
    set colonnes 1
    set dhist(0) $Q
    #mnorms_br Q moy sigm
    ################################################################################
    #     #tk_messageBox -message "moy $moy \nsim $sigm" -type ok
    #     # Frequence ('freq') des echantillonnages dont le subespace (liste Q) est egal ou inferieur a la moyenne moins 1 ecart-types (moymuet)
    #     set moymuet [expr {[vtrim $moy] - (1 * [vtrim $sigm])}]
    set orderQ [lsort -real -increasing [vtrim $Q]]
    #     set freq 0
    #     foreach item $orderQ {
    #         if {$item <= $moymuet} {incr freq} else {break}
    #     }
    #     set probfreq [expr {$freq * 1.0 / $nbP}]
    #     $q insert end "\n\nProbability of a subspace =< $moymuet for $X individuals \n$probfreq ($freq / $nbP)"
    #
    #
    #     # Frequence ('freq') des echantillonnages dont le subespace (liste Q) est egal ou inferieur au tiers de l'espace total (qte_reference)
    #     #tk_messageBox -message "qte_reference\n$qte_reference" -type ok
    #     set eoitet [expr {$qte_reference * 1.0 / 3}]
    #     #set orderQ [lsort -real -increasing $Q]
    #     set freq 0
    #     foreach item $orderQ {
    #         if {$item <= $eoitet} {incr freq} else {break}
    #     }
    #     set probfreq [expr {$freq * 1.0 / $nbP}]
    #     $q insert end "\n\nProbability of a subspace =< $eoitet for $X individuals \n$probfreq ($freq / $nbP)"
    ################################################################################
    
    
    mnorms_br dhist(0) moy sigm
    set lamoy "2 1 1 [lindex $moy 3]"
    set p25 [expr {[lindex $dhist(0) 1] - 1}]
    set p95 0
    prehistogramme [lindex $dhist(0) 1] 2
}

entry .cours.seuil -textvariable seuil

button .cours.comp -fg "dark green" -text "Compute" -command {
    if [info exists Q] {
        #
        set freq 0
        foreach item $orderQ {
            # orderQ etait HUME, a ete converti en liste
            if {$item <= $seuil} {incr freq} else {break}
        }
        set probfreq [expr {$freq * 1.0 / $nbP}]
        
        if {$qte == "no"} {
            rouge "\n\nProbability of a metric disparity =< $seuil for $X individuals \n$probfreq ($freq / $nbP)"
        } else  {
            rouge "\n\nProbability of a subspace =< $seuil for $X individuals \n$probfreq ($freq / $nbP)"
        }
        # On modifie le graphique
        set min [lindex $orderQ 0]
        set max [lindex $orderQ end]
        set slct [expr {$seuil * 1.0 / abs($max - $min)}]
        
        set c .fen2.cfen2
        $c delete subt subgt
        global corrx_subsp intervalle_subsp
        set prePp25 [expr ($seuil - $min) * (1.0/$intervalle_subsp)]
        set cool [format "%2.4f" $max]
        set xcool [expr 100 + ($corrx_subsp * $prePp25)]
        $c create text $xcool 380 -text $seuil -fill red -anchor n -font "Helvetica 12" -tag subt;#<- SEUIL DES SUBSPACES en jaune
        $c create line $xcool 50 $xcool 357 -fill red -width 4 -tag subgt
        # On a modifie le graphique
        
        
    } else  {
        tk_messageBox -message "Please compute sub-spaces first" -type ok
    }
}
#
pack .cours.exit .cours.wrap .cours.nbp .cours.go .cours.seuil .cours.comp -side left -padx 5 -fill x


$q insert end "\n\nEspace morphologique et probabilites de sous-espaces \n"
vert "\nPlease open a '..._PW.txt' file (partial warps), \
        \nor,alternatively, a file containing principal components\n"



# 0. Sources....
# debug "'file dirname 'info script'' [file dirname [info script]]\n'info script' [info script] \npwd \n[pwd]"
#source 101La.tcl
#source ballons.tcl
#
balloonhelp_for .cours.nbp "First value is the number of permutations\nSecond value is the sample size"
balloonhelp_for .cours.go "Compute many times (see first value on the left) the morphological subspace\
        \n(or the metric disparity) of a randomly selected set of individuals"
balloonhelp_for .cours.seuil "Subspace or metric disparity value for which \
        \nthe empirical probability can be computed"
balloonhelp_for .cours.comp "Permutations-based probablility\
        \nfor selected subspace or metric disparity when occupied by\
        \na given subsample of individuals"
#
# 1. Data input (matrice de Hume) = infile
#
update

# Chercher le chemin dans un fichier de configuration
# 1. verifier que le fichier de configuration existe
set chemin "[pwd]/dossier_fileopen.txt"
#debug "chemin $chemin"
# 2. s'il n'existe pas, voir ci-dessus
if {[file exists $chemin] == 0} {
    set candidat_dossier [pwd]
} else  {
    # 3. s'il existe reccueillir le dernier chemin parcouru
    # open le fichier pour lire
    catch [
    set fid [open $chemin r]
    set candidat_dossier [read -nonewline $fid]
    close $fid
    ] ici
    #debug "candidat_dossier $candidat_dossier"
    set candidat_dossier [lindex [split $candidat_dossier \n] 1]
    #debug "dossier = $candidat_dossier"
}

# On va chercher les donnees
#if {[info exists S(mispl)]} {
#    if {$S(mispl) != "exit"} {
set typeList {
    {{"Text files"} {.txt .nts .TXT .NTS} }
}
set infile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
#    } else  {
#        puts "mispl $S(mispl)"
#        exit
#    }
#}
#infile contient le chemin et le nom du fichier des donnees
#
#set S(infile) $infile
#
set dossier "[file dirname $infile]/";#repertoire des donnees
# 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration

#debug "\n\ndossier != candidat_dossier???\n$dossier != $candidat_dossier ????"

if {$dossier != $candidat_dossier} {
    # open le fichier de conf pour ecrire
    catch [
    set fid [open $chemin w+]
    puts -nonewline $fid "Dernier dossier de donnees utilisees par FILEOPEN:\n"
    puts -nonewline $fid $dossier
    close $fid
    ] ici
}
#debug
#puts "chemin = $dirinfile"
#---------------------------------------------------------------------------------------------
# Nom du FICHIER et son CHEMIN (path) CORRESPONDANT - fin
#---------------------------------------------------------------------------------------------

set sentier [file dirname $infile]

#---------------------------------------------------------------------------------------------
# EXTENSION du FICHIER ..._PW.txt ou ...ProcrCp.txt ? - fin
#---------------------------------------------------------------------------------------------

global qte
if {[string first "_PW.txt" $infile] < 0 } {
    set nm [tk_messageBox -message "Your file does not seem to be a PARTIAL WARPS file (..._PW.txt)\n\
            Do you want to go on ?" -icon warning -type yesno]
    if {$nm == no} {exit}
    if {$nm == yes} {
        set qte [tk_messageBox -message "Your file, if not a PW file, must contain PRINCIPAL COMPONENTS: \
                \nDo you want to compute the empirical probability of PC1-PC2 subspaces?" -icon warning -type yesno]
        if {$qte == no} {exit}
    }
} else  {
    tk_messageBox -message "Your file is supposed to contain Partial Warps, \
                            \nthe \"subspace\" instruction will explore the empirical probability\
                            \nof a given METRIC DISPARITY for random sets of individuals" -type ok 
    set qte "no"
}

#-------------------------------------------------------------------------------------------
# On cree une le fichier MDONNEES des coordonnees brutes
#-------------------------------------------------------------------------------------------

global mdonnees

if {$infile != ""} {
    # Appel à la procédure LLOADFILE
    set mdonnees [lloadfile $infile] ;# c'est une matrice de HUME
    # une LISTE des coordonnees sera generee plus bas dans la variable 'donnees' (liste, par opposition à une matrice de HUME)
    # une table de listes (chaque liste se terminant par \n) sera faite dans la variable 'data' (chaque liste est un individu)
    # une TABLE sera aussi construite dans la variable indicee 'tablind()'
    # enfin une liste 'rawindividus' de matrices de HUME (2 1 2 $item) sera faite, chaque matrice de HUME est un individu
}

# Espace morphologique total
if {$qte == "no"} {
    set qte_reference [mmdispar $mdonnees]
} else  {
    set qte_reference [quantity $mdonnees]
}
#
$q insert end "\n$infile"
#
$q insert end "\n\n\nAbout the "
rouge "\"GO\" button\n"
#
if {$qte == "no"} {
    # PW file (PM because metric disparity is computed from PW)
    orange "\nWith the above "
    rouge "100 10"
    orange " default values, the 'GO' button (not the 'compute' button) will start 100 sampling with replacements of 10 individuals from your total sample ([file tail $infile])\
            \nAt each run, it will estimate the METRIC DISPARITY of the sub-SAMPLE of 10 individuals.\
            \nAt the end, it will provide you with an empirical distribution of possible values.\n"
    orange "\nPlease modify "
    rouge "100 10"
    orange " with the values of your choice\n"
} else  {
    # PC file
    orange "\nWith the above "
    rouge "100 10"
    orange " default values, the 'GO' button  (not the 'compute' button) will start 100 sampling with replacements of 10 individuals from your total sample ([file tail $infile])\
            \nAt each run, it will estimate the SUB AREA occupied by the SAMPLE of 10 individuals in their PC1-PC2 morphospace.\
            \nAt the end, it will provide you with an empirical distribution of possible values.\n"
    orange "\nPlease modify "
    rouge "100 10"
    orange " with the values of your choice\n"
}

$q insert end "\n\nAbout the "
vert "\"Compute\" button\n"
#
vert "\nThe \"Compute\" button estimates the empirical probability of a given value of metric disparity or morphological subspace. This vale has to be entered by you in the entry-rectangle left to the \"compute\" button. The probability will be estimated for 10 individuals and 100 bootstraps, or for a modified number of individuals and/or bootstraps. Note that if you ask this for let us say 12 individuals, and 1000 bootstraps, you have to indicate these values in place of 100 10, then you have to hit the \"GO\" button before to hit the \"Compute\" button. Remember that the  \"GO\" button estimates the empirical distribution of possible values"

$q insert end "\n\nINFOS\n$references\n\n"

#debug "\nDATA\n[show [mrange $mdonnees 0 end 0 3]]\nEtc.\n\n"

################################################################################
# set colonnes 1
# set dhist(0) $mdonnees
# mnorms_br dhist(0) moy sigm
# set lamoy "2 1 1 [lindex $moy 3]"
# set p25 [expr {[lindex $dhist(0) 1] - 1}]
# set p95 0
# prehistogramme [lindex $dhist(0) 1] 1
################################################################################

#

#
# 2. Sampling WITHOUT replacement X individuals P times
#
#    2.a permutation of the total data (infile)
#    2.b sampling of X first data
#    2.c computing of a given Q quantity (for instance the mean of the X randomly sampled data)
#


# see BUTTON "GO"