# replace $p insert end by puts
# replace type by puts

# Procedure CHEMIN -start
#
proc chemin {} {
    
    global p S dossier
    
    if {[info exists dirinfile] == 0} {
        set dirinfile [pwd]
    }
    
    # ----------------------------------------------------
    # Nom du FICHIER et son CHEMIN (path) CORRESPONDANT
    # ---------------------------------------------------
    
    # Chercher sa route dans un fichier de configuration: il y en a un dans le dossier MOG (chemin), et un dans le dossier CLIC (route)
    # dans le dossier MOG
    set chemin "[pwd]/dossier_cov.txt"
    # dans le dossier CLIC
    set route $S(dirclic)/dossier_CLIC.txt
    #
    # On lit d'abord le fichier dossier_CLIC, s'il existe
    # sinon
    # on lit le fichier du script, s'il existe
    #
    # 1. verifier que les fichiers de routage existent
    if {[file exists $route] == 0} {
        # dans le cas ou il n'y a pas de fichier de routage dans le dossier CLIC
        set candidat_dossier_CLIC [pwd]
        catch [
	       set fid [open $route w+]
	       puts -nonewline $fid "Dernier dossier de donnees:\n"
	       puts -nonewline $fid [pwd]
	       close $fid
	      ] ici
    } else  {
        # 3. si le fichier de routage existe dans le dossier CLIC, reccueillir alors le dernier chemin parcouru
        # open le fichier pour lire
        catch [
	       set fid [open $route r]
	       set candidat_dossier_CLIC [read -nonewline $fid]
	       close $fid
	      ] ici
        set candidat_dossier_CLIC [lindex [split $candidat_dossier_CLIC \n] 1]
        #debug "\ndossier selon CLIC = $candidat_dossier_CLIC"
    }
    
    #debug "chemin $chemin"
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
        set candidat_dossier [pwd]
    } else  {
        # 3. si le fichier de routage du MODULE existe reccueillir le dernier chemin parcouru
        # open le fichier pour lire
        catch [
	       set fid [open $chemin r]
	       set candidat_dossier [read -nonewline $fid]
	       close $fid
	      ] ici
        set candidat_dossier [lindex [split $candidat_dossier \n] 1]
    }
    
    # A present, on a le choix entre candidat_dossier_CLIC et candidat_dossier
    if {$candidat_dossier_CLIC != "./"} {
        #debug "Pas PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        # si le dossier_CLIC n'est pas le dossier en cours (CLIC_XX)
        set candidat_dossier $candidat_dossier_CLIC
        #debug "Pas PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        catch [
	       set fid [open $chemin w+]
	       puts -nonewline $fid "Dernier dossier de donnees utilise par COV:\n"
	       puts -nonewline $fid $candidat_dossier
	       close $fid
	      ] ici
    } else  {
        # sinon, on adopte le candidat_dossier
        #debug "PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        set candidat_dossier_CLIC $candidat_dossier
        #debug "PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        catch [
	       set fid [open $route w+]
	       puts -nonewline $fid "Dernier dossier de donnees:\n"
	       puts -nonewline $fid $candidat_dossier_CLIC
	       close $fid
	      ] ici
    }
    
    
    # On va chercher les donnees
    
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
    
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
        # open le fichier de conf pour ecrire
        catch [
	       set fid [open $chemin w+]
	       puts -nonewline $fid "Dernier dossier de donnees utilisees par COV:\n"
	       puts -nonewline $fid $dossier
	       close $fid
	      ] ici
        # open le fichier de routage pour ecrire
        catch [
	       set fid [open $route w+]
	       puts -nonewline $fid "Dernier dossier de donnees :\n"
	       puts -nonewline $fid $dossier
	       close $fid
	      ] ici
    }
    
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    
    # --------------------------------------------------------
    # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE pop
    # --------------------------------------------------------
    return $infile
}
#
# Procedure CHEMIN - end


# PROCEDURE loadfile - DEBUT
#
# Ce LOADFILE pour COV n'est pas classique, puisqu'il ajoute une conversion en .nts
#
#
proc loadfile {pathname} {

    if {$pathname != ""} {
        global S
        set S(dist_nopar) 0
        set S(datadir) $pathname
        # Lecture -start
        set fid [open $pathname]
        set text [read -nonewline $fid]
        close $fid
        # Lecture -end
        global rowcount
        set rowcount 0
        set colcount 0
        
        global references
        set compteur 0
        set lignes 0
        set data "";# aussi variable 'data' dans PAD, 'datos' dans MOG
        set text [string trim $text]
        foreach line [split $text \n] {
            if  {[llength $line] > 0} {
                incr compteur
                if {$compteur >1} {
                    #if  {[llength $line] > 0} {
		    set colcount [llength $line]
                    #}
                    foreach item [split $line] { 
                        if {$item != ""} {
			    incr lignes
			    append data "[string trim $item]\t"
		        }
                    }
                } else {
                    set references $line
                }
            }
        }
        set rowcount [expr {$lignes / $colcount}]
	#
	# Matrice de HUME !
        set result [concat 2 $rowcount $colcount $data]
        #
	# ----------------------------------------------------------------
        # -- Formater le commentaire --  Enlever d'eventuelles tabulations
        foreach mot $references {
            if {$mot != ""} {
                append comentario_sin_tab "$mot "
            }
        }
        set references $comentario_sin_tab
        set S(references) $references;# Le LOADFILE de MOG ne le fait pas... pourquoi?
	#
        # -- FIN du formatage de la premiere ligne
	# ---------------------------------------------------------------
        
        # ---------------------------------------------------------------
        # ---------------------------------------------------------------
        # Il faudrait creer le meme fichier en .nts (pour TPSregr) - debut
        #
        set datos ""
        set compteur 0
        foreach truc [split $text "\n"] {
            if {$compteur > 0} {
                if {$truc != ""} {lappend datos "$truc\n"}
            } else {
                #lappend datos "\"$truc\n"
                set premligne $truc
            }
            incr compteur
        }
        # Enlever les curved brackets
        set datos [regsub -all {\{|\}} $datos ""]
        #
        set ntscode "1 $rowcount $colcount 0\n"
        set ntsmatrix $ntscode$datos
        # puis l'enregistrer ...
        # OPEN THE FILE
        set extension ".nts"
        set nameoffile "/[file tail [file rootname $pathname]]"
        set filename [file dirname $pathname]$nameoffile$extension
        set fileid [open $filename w]
        # FILL THE FILE
        puts -nonewline $fileid "\" $premligne \" "
        puts -nonewline $fileid "\n$ntsmatrix"
        # CLOSE THE FILE
        close $fileid
        #
        # Il faudrait creer le meme fichier en .nts (pour TPSregr) - fin
        # ---------------------------------------------------------------
	# ---------------------------------------------------------------
	#
        return $result
    } else  {
        set cancelar [tk_messageBox "LOADFILE: You did not select a file" -type abortretryignore]
        switch -- $cancelar {
            abort {exit}
            retry {return}
            ignore {}
        }
    }
}
#
# PROCEDURE loadfile - FIN



proc {m2p} {} {
    
    #"Procrustes distances between corresponding rows of two matrices" -command {}
    
    global S
    set S(save) "_INFO_2M_procr.txt"
    
    set missive "\nProcrustes distances between corresponding rows will be directly computed from raw coordinates.\n\nThe format of your file must respect the common FORMAT format:\n- first row contains a comment (any lenght or content),\n- next rows are the data."
    puts $missive
    #bleu "\n$missive"
    puts "\nThe two corresponding rows will be superimposed (GPA) and the Procrustes distances computed. At this stage of implementation, the programs does not apply iterations to improve the fit.\n\n"
    
    
    # Entree des matrices X et Y
    destroy .a&b
    toplevel .a&b
    set e ".a&b"
    wm geometry $e +300+300
    
    button $e.b1 -text "Matrix X" -command {
	global dossier
	set putsList {
	    {{"Text files"} {.txt .nts .TXT .NTS} }
	}
	#
	set infile [chemin]
	if {$infile == ""} {
	    return
	} else  {
	    set x [loadfile $infile]
	}
	set fileX $infile
	#
	set x "[lrange $x 0 2] [show $x %8.7f]";# pas > 7 decimales
	entrada $x $infile
	$e.b1 configure -text [file tail $infile]
	puts "\nMatrix X:\t------------------------start---\n"
	puts [show $x %8.3f]
	puts "\nMatrix X:\t-------------------------end----\n"
    }
    
    button $e.b2 -text "Matrix Y" -command {
	global dossier
	set putsList {
	    {{"Text files"} {.txt .nts .TXT .NTS} }
	}
	#
	set infile [chemin]
	if {$infile == ""} {
	    return
	} else  {
	    set y [loadfile $infile]
	}
	set fileY $infile
	#
	set y "[lrange $y 0 2] [show $y %8.7f]";# pas > 7 decimales
	entrada $y $infile
	$e.b2 configure -text [file tail $infile]
	puts "\nMatrix Y:\t-----------------------start---\n"
	puts [show $y %8.3f]
	puts "\nMatrix Y:\t------------------------end----\n"
    }
    
    button $e.b3 -text "Procrustes Distances between corresponding rows" -command {
	
	# VERIFICATION DES FORMATS
	if {[mrows $x] <> [mrows $y] || [mcols $x] <> [mcols $y]} {
	    puts "The 2 matrices do not match \n(either different rows or different columns)"
	    return
	}
	
	# EXTRACTION DES LIGNES QUI SE CORRESPONDENT
	for {set i 0} {$i < [mrows $x]} {incr i} {
	    # extraction des lignes qui se correspondent
	    set a [mrange $x 0 end $i $i]
	    set b [mrange $y 0 end $i $i]
	    # constitution de la matrice input
	    set mdonnees [join_rows $a $b]
	    debug "on compare\n$mdonnees"
	    # calcul de la distance de Procrustes entre les deux configurations
	    set matdist [Procruste_nonEuclid $mdonnees]
	    debug "Procr dist : $matdist"
	}
    }
pack $e.b1 $e.b2 $e.b3 
}

global S
set S(dirclic) [pwd]
m2p

