
package require Tk

################################################################################
# Select
# Copyright ©  2012 Dujardin J.-P. dujardin@mpl.ird.fr
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
################################################################################

cd [file dirname [info script]]
#
global S
set S(drapeau) 0
set S(dirscript) [pwd];#attention, il n'y a pas de "/" a la fin du nom du dossier du script (utiliser "[file join etc]")
#
cd ..
set S(dirclic) [pwd]

cd $S(dirscript)
#

# procedure DEBUG
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x600+605+66
        set memo [text .debug.t -wrap word -height 22 -font "courier 13" \
		      -bg grey88 \
		      -fg black\
		      -tabs "3c left"\
		      -yscrollcommand ".debug.v_scroll set" \
		      -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
            if {$flag == 1} {
                .debug.t configure -wrap none
                set flag 0
            } else  {
                .debug.t configure -wrap word
                set flag 1
            }
        }
        #
        $memo insert end $bugatti
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG fin


# Procedure OUTLINE - start
#
proc outline {coord} {
    global S ligne ptchoix plpdist canvas_compteur
    #
    set ptchoix ""
    # calcul du centroide
    set S(centroid) [centroide $coord]
    #
    set crossx [lindex $S(centroid) 0]
    set crossy [lindex $S(centroid) 1]
    #
    # dessin du centroide comme un gros point rouge
    #$S(f).can create oval [expr {$crossx-6}] [expr {$crossy-6}] [expr {$crossx+6}] [expr {$crossy+6}] -width 1 -outline red -fill red -tags lm
    #
    # calcul des distances du centroide a chacun des points
    set boulier 0;# pour accorder ensuite l'ordre des rayons et des cordes
    foreach {x y} $coord {
        set pt "$x $y"
        set centroide_pt "[disteuclid $S(centroid) $pt] ";# 'centroide_pt' distance du centroide au point 'pt'
        lappend ptchoix "$centroide_pt $pt $boulier";# 'pt_choix' boulier pour associer le point a son ordre de digitalisation
        #debug "distance $centroide_pt\n$ptchoix ..."
        incr boulier
    }
    # Rayon le plus grand
    set ptchoix_ordre [lsort -real -decreasing -index 0 $ptchoix];# liste ordonnée selon le premier élément
    set ptdistant [lrange [lindex $ptchoix_ordre 0] 1 end-1]
    set pointleplusdistant [lindex [lindex $ptchoix_ordre 0] end]
    #type "Le pt le plus distant est le numero: [expr {[lindex [lindex $ptchoix_ordre 0] end] + 1}]"
    #
    # Il faudra ensuite REordonner les cordes selon les rayons (le plus distant est le premier) pour calculer les intersections quitte a creer d'autres variables pour le nouvel ordre des cordes
    #
    set fraction [expr {[llength $coord] * 1/2}];# cela ressemble au nombre de points
    #
    #
    set theta [expr {6.28 * 1.0 / $S(fraction)}]
    set forradii "$S(centroid) $ptdistant"
    #debug "OUTLINE nb points = $fraction\ncentroide [lrange $forradii 0 1]"
    set xcentre [lindex $forradii 0]
    set ycentre [lindex $forradii 1]
    set xx [lindex $forradii 2]
    set yy [lindex $forradii 3]
    #
    set point_new [radius_next $xcentre $ycentre 0 $xx $yy]
    set ligne(0) [regsub -all {\{|\}} [list $S(centroid) $point_new] ""]
    #    
    #$S(f).can create line $ligne(0) -fill green
    #
    #debug "i = 0 : ligne(0) $ligne(0) <- le rayon maximum"
    #
    set chord 0
    #
    # silence on tourne
    for {set i 1} {$i < $S(fraction)} {incr i} {
        #
        incr chord 2
        set xx [lindex $point_new 0]
        set yy [lindex $point_new 1]
        set point_new [radius_next $xcentre $ycentre $theta $xx $yy]
        set ligne($i) [regsub -all {\{|\}} [list $S(centroid) $point_new] ""]
	#        
	#if {$S(fraction) < 200} {$S(f).can create line $ligne($i) -fill orange -tag rayon($i)}
	#
        #debug "i = $i : ligne($i) $ligne($i)"
        set point_new [regsub -all {\{|\}} $point_new ""]
        #
    }
    chords $coord
    synchro $pointleplusdistant
    global plpdist
    set plpdist $pointleplusdistant
    #
    # --------------------------------------------------------------------------
    edp;# <- ELLIPTIC FOURIER
    # --------------------------------------------------------------------------
}
#
# Procedure OUTLINE - end


# Procedure DISTEUCLID - start
#
proc disteuclid {a b} {
    set xa [lindex $a 0]
    set xb [lindex $b 0]
    set ya [lindex $a 1]
    set yb [lindex $b 1]
    set cote1 [expr {$xa - $xb}]
    set cote2 [expr {$ya - $yb}]
    set dist [expr {hypot($cote1,$cote2)}]
    #tk_messageBox -message "$dist <- $cote1 et $cote2"
    return $dist
}
#
# Procedure DISTEUCLID - end


# Procedure RADIUS_NEXT - start
#
# calcule le deuxieme point (le point distal) du rayon suivant
# procedure appelee par la procedure ROULETTE
#
proc radius_next {xcentre ycentre theta xx yy} {
    set X [expr $xx-$xcentre]
    set Y [expr $yy-$ycentre]
    set xp [expr $xcentre + $X * cos($theta) - $Y * sin($theta)]
    set yp [expr $ycentre + $X * sin($theta) + $Y * cos($theta)]
    append next_point "$xp $yp"
    return $next_point
}
#
# Procedure RADIUS_NEXT - end


# Procedure SYNCHRO - start
#
# l'ordre des cordes 'chord()' modifie par celui des rayons, pour devenir 'corde()'
# ce qui permet la maitrise de la procedure INTERSECTIONS
#
proc synchro {plpd} {
    # 'plpd' point le plus distant
    global S coord ligne ptchoix chord corde
    set fraction [expr {[llength $coord] * 1/2}]
    for {set i 0} {$i < $fraction} {incr i} {
        if {[expr {$i + $plpd}] < $fraction} {
            set corde($i) $chord([expr {$i + $plpd}])
            #debug "chord([expr {$i + $plpd}]), soit $chord([expr {$i + $plpd}]) en $i eme position"
        } else  {
            set corde($i) $chord([expr {$plpd - $fraction + $i}])
            #debug "chord([expr {$fraction - $plpd -1}]), soit $chord([expr {$fraction - $plpd -1}]) en $i eme position"
        }
    }
    for {set i 0} {$i < $fraction} {incr i} {
        #debug "chord($i) $chord($i)\ncorde($i) $corde($i)\n--------\n"
    }
}
#
# Procedure SYNCHRO - end


# Procedure CHORDS -start
#
proc chords {coordonnees} {
    global S chord
    set boulier 0
    for {set i 0} {$i < [expr {[llength $coordonnees] * 1 }]} {incr i 2} {
        set x [lindex $coordonnees $i]
        set y [lindex $coordonnees [expr {$i+1}]]
        set v [lindex $coordonnees [expr {$i+2}]]
        set w [lindex $coordonnees [expr {$i+3}]]
        if {$i == [expr { [llength $coordonnees] - 2}]} {
            set v [lindex $coordonnees 0]
            set w [lindex $coordonnees 1]
        }
        set pt1 "$x $y"
        set pt2 "$v $w"
        #tk_messageBox -message "Proc CHORDS\ni = $i:    $x $y $v $w" -type ok
        set chord($boulier) "$x $y $v $w"
        #$S(f).can create line $chord($boulier) -fill green
        #if {$i < 4} {debug "$i: corde $boulier: $chord($boulier)"}
        incr boulier
    }
}
#
# Procedure CHORDS -end


# Procedure CENTROIDE -- debut
#
# Calcul du centroide
#
proc centroide {coord} {
    # On calcule les coordonnees du centroide de l'objet
    foreach {x y} $coord {
        append ixes "$x "
        append igrecs "$y "
    }
    #
    set sumixes 0
    set sumigrecs 0
    for {set i 0} {$i < [llength $ixes]} {incr i} {
        set sumixes [expr {$sumixes + [lindex $ixes $i]}]
    }
    set moyixes [expr {$sumixes * 1.0 / [llength $ixes]}]
    for {set i 0} {$i < [llength $igrecs]} {incr i} {
        set sumigrecs [expr {$sumigrecs + [lindex $igrecs $i]}]
    }
    set moyigrecs [expr {$sumigrecs * 1.0 / [llength $igrecs]}]
    set centroide "$moyixes $moyigrecs"
    return $centroide
}
#
# Procedure CENTROIDE - fin


#+##########################################################################
# #
# cfr. http://wiki.tcl.tk/8447
#
# Intersect -- find where two line intersect given two points on each line
# IntersectV -- same but w/ 2 point/vector pairs
#   we want K,J where p1+K(v1) = p3+J(v3)
#   convert into and solve matrix equation (a b / c d) ( K / J) = ( e / f )
#
proc Intersect {p1 p2 p3 p4} {
    return [IntersectV $p1 [VSub $p2 $p1] $p3 [VSub $p4 $p3]]
}

proc IntersectV {p1 v1 p3 v3} {
    #
    #[catch {
    #
    foreach {x1 y1} $p1 {vx1 vy1} $v1 {x3 y3} $p3 {vx3 vy3} $v3 break
    #
    set a $vx1
    set b [expr {-1 * $vx3}]
    set c $vy1
    set d [expr {-1 * $vy3}]
    set e [expr {$x3 - $x1}]
    set f [expr {$y3 - $y1}]
    
    set det [expr {double($a*$d - $b*$c)}]
    if {$det == 0} {return;#error "Determinant is 0"}
	
	set k [expr {($d*$e - $b*$f) / $det}]
	#set j [expr {($a*$f - $c*$e) / $det}]
	return [VAdd $p1 $v1 $k]
	#
	#} result]
	#if {[info exists result]} {debug "$result\n---\ndet = $det p1 $p1 v1 $v1 p3 $p3 v3 $v3"}
	
    }

    proc VAdd {v1 v2 {scaling 1}} {
	#   VAdd -- adds two vectors w/ scaling of 2nd vector
	foreach {x1 y1} $v1 {x2 y2} $v2 break
	return [list [expr {$x1 + $scaling * $x2}] [expr {$y1 + $scaling * $y2}]]
    }

    proc VSub {v1 v2} {
	#   VSub -- subtract two vectors
	return [VAdd $v1 $v2 -1]
    }
    #
    # cfr. http://wiki.tcl.tk/8447
    #
    #+##########################################################################

    # Procedure EDP - start
    #
    proc edp {} {
	global S coord ligne corde chord plpdist canvas_compteur
	#
	#type "$S(fraction) rayons"
	set S(vert) ""
	set S(verde) ""
	#
	set lerayonauquelonetaitarrive 0;# <- ne sera plus necessaire
	#
	#type "Centroide : $S(centroid)\nCoordonnees :\n $coord"
	#
	set cordes_nb [expr {[llength $coord] * 1/2}]
	#
	for {set r 0} {$r < [expr {$S(fraction)/2}]} {incr r} {
	    
	    for {set i 0} {$i < $cordes_nb} {incr i} {
		#
		set x [lindex $corde($i) 0]
		set y [lindex $corde($i) 1]
		set v [lindex $corde($i) 2]
		set w [lindex $corde($i) 3]
		
		set pt1 "$x $y"
		set pt2 "$v $w"
		#if {$S(fraction) < 200} {$S(f).can create line "$x $y $v $w" -fill blue -width 1}
		#tk_messageBox -message "On est a la corde $i (elle est bleue et epaisse: OK?)" -type ok
		#
		#append S(vertest) "[lindex $corde($i) 0]\t[lindex $corde($i) 1]\t"
		
		#
		#if {$S(fraction) < 200} {$S(f).can create line $ligne($r) -fill blue}
		#individualiser les quatres coordonnees du rayon: ligne($i), a savoir rx, ry, rv et rw
		set rx [lindex $ligne($r) 0]
		set ry [lindex $ligne($r) 1]
		set rv [lindex $ligne($r) 2]
		set rw [lindex $ligne($r) 3]
		# crosspt = intersection point
		#tk_messageBox -message "\ncorde $i et rayon $r, soit:\nIntersect ' $x $y ' ' $v $w ' ' $rx $ry ' '$rv $rw '" -type ok
		set crosspt [Intersect "$x $y" "$v $w" "$rx $ry" "$rv $rw"];# rien si det = 0 ...
		set crossx [lindex $crosspt 0]
		set crossy [lindex $crosspt 1]
		#tk_messageBox -message "Intersection de la corde [expr {$i+1}] avec le rayon $r" -type ok et ... blabla et break/return else on continue
		if {$x == $v} {
		    #$S(f).can create line "$x $y $v $w" -fill blue -width 2
		    if {$y < $w} {
			if {$crossy > $w || $crossy < $y} {
			    #tk_messageBox -message "Verticalite - on descend" -type ok
			    #$S(f).can create oval [expr {$crossx-9}] [expr {$crossy-9}] [expr {$crossx+9}] [expr {$crossy+9}] -width 1 -fill red
			    #append rouge "$crossx $crossy "
			    set lerayonauquelonetaitarrive $r
			    #tk_messageBox -message "lerayon auquel on etait arrive $lerayonauquelonetaitarrive" -type ok
			    #break
			    #set r $S(fraction)
			} else {
			    #$S(f).can create oval [expr {$crossx-12}] [expr {$crossy-12}] [expr {$crossx+1}] [expr {$crossy+1}] -fill green
			    append S(vert) "$crossx $crossy "
			    lappend S(verde) "$crossx $crossy $i"
			    #append S(vertest) "$crossx\t$crossy\t"
			    #$S(f).can create oval [expr {$crossx-1}] [expr {$crossy-1}] [expr {$crossx+1}] [expr {$crossy+1}] -width 1 -fill green -tags lm
			}
		    } else  {
			if {$crossy < $w || $crossy > $y} {
			    #tk_messageBox -message "Verticalite - on monte" -type ok
			    #$S(f).can create oval [expr {$crossx-9}] [expr {$crossy-9}] [expr {$crossx+9}] [expr {$crossy+9}] -width 1 -fill red
			    #append rouge "$crossx $crossy "
			    set lerayonauquelonetaitarrive $r
			    #tk_messageBox -message "lerayonauquelonetaitarrive $lerayonauquelonetaitarrive" -type ok
			    #set r $S(fraction)
			} else {
			    #$S(f).can create oval [expr {$crossx-12}] [expr {$crossy-12}] [expr {$crossx+12}] [expr {$crossy+12}] -fill green
			    append S(vert) "$crossx $crossy "
			    lappend S(verde) "$crossx $crossy $i"
			    #append S(vertest) "$crossx\t$crossy\t"
			    #$S(f).can create oval [expr {$crossx-1}] [expr {$crossy-1}] \
                                [expr {$crossx+1}] [expr {$crossy+1}] -width 1 -fill green -tags lm
			}
		    }
		}
		if {$x > $v} {
		    if {$crossx < $v || $crossx > $x} {
			#$S(f).can create oval [expr {$crossx-3}] [expr {$crossy-3}] [expr {$crossx+3}] [expr {$crossy+3}] -width 1 -fill red
			#append rouge "$crossx $crossy "
			set lerayonauquelonetaitarrive $r
			#tk_messageBox -message "lerayonauquelonetaitarrive $lerayonauquelonetaitarrive" -type ok
			#set r $S(fraction)
		    } else {
			#$S(f).can create oval [expr {$crossx-3}] [expr {$crossy-3}] [expr {$crossx+3}] [expr {$crossy+3}] -fill green
			append S(vert) "$crossx $crossy "
			lappend S(verde) "$crossx $crossy $i"
			#append S(vertest) "$crossx\t$crossy\t"
			#$S(f).can create oval [expr {$crossx-1}] [expr {$crossy-1}] \
                            [expr {$crossx+1}] [expr {$crossy+1}] -width 1 -fill green -tags lm
		    }
		}
		if {$x < $v}  {
		    if {$crossx > $v || $crossx < $x} {
			#$S(f).can create oval [expr {$crossx-3}] [expr {$crossy-3}] [expr {$crossx+3}] [expr {$crossy+3}] -width 1 -fill red
			#append rouge "$crossx $crossy "
			set lerayonauquelonetaitarrive $r
			#tk_messageBox -message "lerayonauquelonetaitarrive $lerayonauquelonetaitarrive" -type ok
			#set r $S(fraction)
		    } else  {
			#$S(f).can create oval [expr {$crossx-6}] [expr {$crossy-6}] [expr {$crossx+6}] [expr {$crossy+6}] -outline green
			append S(vert) "$crossx $crossy "
			lappend S(verde) "$crossx $crossy $i"
			#append S(vertest) "$crossx\t$crossy\t"
			#$S(f).can create oval [expr {$crossx-1}] [expr {$crossy-1}] \
                            [expr {$crossx+1}] [expr {$crossy+1}] -width 1 -fill green -tags lm
		    }
		}
		################################################################################
		###############################################################################
	    };# d'une corde a l'autre
	    
	};# d'un rayon a l'autre
	
	#
	set S(vertignasse) "$S(vert) [lrange $S(vert) 0 1]"
	#debug "\nREPETITIONS A ENLEVER DANS...$S(vertignasse)"
	set fakecoord_nb [llength $S(vertignasse)]
	set fakept_nb [expr {$fakecoord_nb / 2}]
	#debug "\nIl y a $fakept_nb points"
	set S(verde_ordre) [lsort -real -index 2 $S(verde)]
	
	foreach item $S(verde_ordre) {
	    set i [lindex $item 2]
	    lappend intersect($i) [lrange $item 0 1]
	    #debug "i = [lindex $item 2]\tintersect($i) = $intersect($i)"
	}
	################################################################################
	# Avant le CLASSEMENT des intersections dans chaque corde
	set sumintersect 0
	for {set i 0} {$i < $cordes_nb} {incr i} {
	    if {[info exist intersect($i)]} {
		#debug "Corde $i:\n$intersect($i)"
		set sumintersect [expr {$sumintersect + [llength $intersect($i)]}]
	    }
	}
	################################################################################
	# CLASSEMENT des intersections dans chaque corde
	for {set i 0} {$i < $cordes_nb} {incr i} {
	    if {[info exist intersect($i)]} {
		#tk_messageBox -message "Je suis ici" -type ok
		set x [lindex $corde($i) 0]
		set y [lindex $corde($i) 1]
		set v [lindex $corde($i) 2]
		set w [lindex $corde($i) 3]
		if {$x == $v} {
		    #$S(f).can create line "$x $y $v $w" -fill blue -width 2
		    if {$y < $w} {
			#tk_messageBox -message "Corde [expr {$i+1}] Verticalite - on descend, verticalement" -type ok
			set intersect($i) [lsort -real -increasing -index 1 $intersect($i)]
		    } else {
			#tk_messageBox -message "Corde [expr {$i+1}] Verticalite - on monte, verticalement" -type ok
			set intersect($i) [lsort -real -decreasing -index 1 $intersect($i)]
		    }
		}
		if {$x > $v} {
		    #tk_messageBox -message "Corde [expr {$i+1}] a gauche" -type ok
		    set intersect($i) [lsort -real -decreasing -index 0 $intersect($i)]
		} else {
		    #tk_messageBox -message "Corde [expr {$i+1}] a droite" -type ok
		    set intersect($i) [lsort -real -increasing -index 0 $intersect($i)]
		}
	    }
	}
	#
	set onvoit ""
	set onverra ""
	set friction [expr {[llength $coord] * 1/2}];#cfr. projet desynchro
	set ordre_initial 0;#cfr. projet desynchro
	# ###################################################################3
	# Projet DESYNCHRO - start - OUT-10J-12 IL Y A DES PERTES !!!
	set ordre_initial 0
	if {$plpdist != 0} {
	    for {set i 0} {$i < $cordes_nb} {incr i} {
		if {[info exists intersect($i)]} {append onverra "$intersect($i) "}
		#
		set ordre_nouveau [expr {$i + $plpdist}]
		if { [expr {$i + $plpdist}] >= $cordes_nb} {
		    set ordre_nouveau  [expr {$ordre_initial}]
		    if {[info exists intersect($i)]} {
			set iisect($ordre_nouveau) $intersect($i)
			#debug "intersect($i) (cfr. corde($i) ) = $intersect($i)\n$ordre_nouveau > $cordes_nb ? Je place intersect($i) dans iisect($ordre_nouveau)"
		    }
		    incr ordre_initial
		} else  {
		    if {[info exists intersect($i)]} {
			set iisect($ordre_nouveau) $intersect($i)
			#debug "intersect($i) (cfr. corde($i) ) = $intersect($i)\n$ordre_nouveau > $cordes_nb ? Je place intersect($i) dans iisect($ordre_nouveau)"
		    }
		}
	    }
	} else  {
	    for {set i 0} {$i < $cordes_nb} {incr i} {
		#append onvoitest "[lindex $corde($i) 0]\t[lindex $corde($i) 1]\t"
		if {[info exists intersect($i)]} {
		    append onvoit "$intersect($i) "
		    append onverra "$intersect($i) "
		    #append onvoitest "$intersect($i) "
		}
	    }
	}
	#
	if {$plpdist != 0} {
	    for {set i 0} {$i < $cordes_nb} {incr i} {
		#append onvoitest "[lindex $corde($i) 0]\t[lindex $corde($i) 1]\t"
		if {[info exists iisect($i)]} {
		    append onvoit "$iisect($i) "
		    #append onvoitest "$iisect($i) "
		}
	    }
	}
	set onverra [regsub -all {\{|\}} $onverra ""]
	set onvoit [regsub -all {\{|\}} $onvoit ""]
	#set onvoitest [regsub -all {\{|\}} $onvoitest ""]
	#
	# Projet DESYNCHRO - end
	
	#Confrontation AVANT et Apres DESYNCHRO
	set sumisect 0
	for {set i 0} {$i < $cordes_nb} {incr i} {
	    if {[info exist iisect($i)]} {
		#debug "Corde $i:\n$iisect($i)"
		set sumisect [expr {$sumisect + [llength $iisect($i)]}]
	    }
	}
	#
	#
	# A present les intersections sont toutes comptabilisees, unies par une ligne verte, il faut les sauvegarder
	# ... avec les coordonnees du centroide, a placer au debut de la liste
	#
	# Ajout des coordonnees du point centroide
	# set coordonnees_pour_sauvegarde "$S(centroid) $S(vert)" <- !!! S(vert) DIFFERENT DE onverra !!! <- 8 fevrier
	# ------------------------------------------------------------------------------------
	#
	# Les RAYONS
	set coordonnees_pour_sauvegarde "$S(centroid) $onvoit";# <- ATTENTION PREMIER ET DERNIER POINTS = LE MEME POINT ... ?
	set S(coordonnees_pour_sauvegarde) $coordonnees_pour_sauvegarde
	#
	# ------------------------------------------------------------------------------------
	# Les POINTS
	# Pour enregistrer ces coordonnees, il faut leur donner le nom de variable 'coord' qui contient les coordonnees des cordes initiales, tracees par l'utilisateur, les "points":
	set S(coordonnees_utilisateur) $coord;# les clicks le long du contour
	#
	#
	set coord $coordonnees_pour_sauvegarde;# les intersections, AVEC le point CENTROIDE
	#set coord $S(coordonnees_utilisateur);# les points
	#    
	#
	# 'coordonnees_pour_sauvegarde' contient les intersections des rayons avec le polygone, avec le centroide
	#     - les coordonnees du centroide en premieres positions (col.1 et col.2),
	#     - et la repetition du premier landmark en derniere position (col.3, col4. = col.end-1 col.end)
	#
	#
	# 'coordonnees_utilisateur' contient seulement les points qui forment le polygone:
	#     - a/ PLACERla repetition du premier landmark en derniere position (col.3, col4. = col.end-1 col.end)
	#set coord "$coord\t[lrange $coord 0 1]"
	#debug "premier = dernier\n$coord"
	#
	#     - b/ PLACER les coordonnees du centroide en premieres positions (col.1 et col.2),
	#set S(centroide_points) [centroide $S(coordonnees_utilisateur)]
	#set coord "$S(centroide_points)\t$coord"
	#
	# A present, "coord" contient les coordonnes_utilisateur, leur centroide, et le dernier point est le premier
	
	# Il Serait judicieux de verifier s'il existe des doublons
	#
	#
	set S(coordonnees_pour_sauvegarde) [xydbl $S(coordonnees_pour_sauvegarde)];#C'est la variable globale 'coord' qui est importante au sortir d'EDP
	set coord [xydbl $coord];#C'est la variable globale 'coord' qui est importante au sortir d'EDP
	#
	#debug "\n\nPREMIER JET \n$coord\n---\n\n"
	return $coord
	# A present si on appuie sur le bouton 'save' (icone de la disquette), on enregistre le centroide et le contour
	# (bouton "SAVE" -> procedure SUSET -> procedure TPSLIKE ->...)
	# 
    }
    #
    # Procedure EDP - end


    # Procedure XYDBL
    #
    # Appelee par la procedure EDP, XYDBL repere et retire les doublons d'une sequence de landmarks
    #
    proc xydbl {digitizedline args} {
	# digitized line is a sequence of pseudo-landmarks x,y coordinates, a Tcl list containing:"
	#     - les coordonnees x,y du centroide en premieres positions (col.1 et col.2),
	#     - et la repetition du premier landmark en derniere position (col.3, col4. = col.end-1 col.end)
	#
	# La procedure XYDBL repere et retire les doublons d'une sequence de landmarks
	#
	set xy [lrange $digitizedline 2 end];# xy, c'est le contour, sans le centroide
	set prexy [lrange $digitizedline 0 1];# prexy, c'est le centroide
	set ixeigrec "[lrange $xy 0 1] ";# une amorce (pour le 'append ixeigrec' de la boucle ci-dessous)
	#
	set col [expr {[llength $xy]}]
	set compteur 2
	set dbl ""
	foreach {xa ya} $xy {
	    #
	    if {[expr {$compteur}] < $col} {
		#
		if {$xa != [lindex $xy $compteur] || $ya != [lindex $xy [expr {$compteur + 1}]]} {
		    append ixeigrec "[lindex $xy $compteur] [lindex $xy [expr {$compteur + 1}]] "
		} else  {
		    append dbl "[expr {$compteur - 1}] ";# pour permettre une lecture plus aisee des positions (a partir de 1 plutot que de 0)
		}
		incr compteur 2
	    }
	}
	#debug "\nNb de coordonnees [llength $ixeigrec]\nNb de points hors centroide [expr {[llength $ixeigrec]/2}]"
	append prexy " $ixeigrec";# le contour 'prexy' inclut a present le centroide
	#
	if {[llength $dbl] > 0} {
	    #debug "WARNING : [llength $dbl] Identical coordinates at location\n$dbl\
				     \n\nNb de points (en incluant le centroide) : from [expr {[llength $digitizedline]/2}] to [expr {[llength $prexy]/2}]"
    } else  {
        #debug "\nNb de coordonnees [llength $prexy]\nNb de points (en incluant le centroide): [expr {[llength $prexy]/2}]"
    }
    return $prexy
}
# Procedure XYDBL


# Procedure CANNEVAS --- START
#
proc cannevas {numero} {
    global S
    toplevel .z$numero
    wm geometry .z$numero 1200x650+[expr {$numero*3}]+[expr {$numero*6}]
    set S(f) .z$numero
    set f $S(f) 
    #
    # Un cadre pour les images, cadre parfois trop petit (donc, ascenseurs ...)
    # scrolling canvas
    update
    #
    set wi 1200
    set he 650
    # 
    canvas $f.can -width $wi -height $he -yscrollcommand "$f.v_scroll set" -xscrollcommand "$f.h_scroll set"
    #canvas $f.can -yscrollcommand "$f.v_scroll set" -xscrollcommand "$f.h_scroll set"
    
    scrollbar $f.v_scroll -command "$f.can yview"
    scrollbar $f.h_scroll -command "$f.can xview" -orient horizontal

    # Fill in canvas
    #$S(f).can_$numero create image 0 0 -image fotoa -anchor nw -tag objet
    
    # A present l'astuce pour configurer automatiquement le deroulement du canvas
    $f.can configure -scrollregion [$f.can bbox all]
    
    pack $f.v_scroll -side right -fill y
    pack $f.h_scroll -side bottom -fill x
    pack $f.can -side bottom -expand 1

}
#
# Procedure CANNEVAS --- END



# Procedure SUSET ## debut
#
proc suset {ficoord numero lmeff} {
    #
    global lmixe_obs lmigr_obs compteur lmnb coord matisse
    #
    type "Procedure SUSET\ncoord [lrange $coord 0 7]"
    #
    bind all <KeyPress> {}
    #
    set boulier 0
    #
    tpslike $coord $ficoord $numero
}
# Procedure SUSET ## fin


# Procedure TYPE - start
#
proc type {message} {
    tk_messageBox -message $message -type ok 
}
#
# Procedure TYPE - end

# procedure TPSLIKE
#
proc tpslike {coord ficoord numero} {

    # un bugcito sur le nb de coord
    update
    global S

    if {[llength $S(coordonnees_pour_sauvegarde)] > 0} {
	# Pour le fichier _radii_OTL.txt
	#
	# debug "Procedure TPSLIKE coordonnees_utilisateur, ou points: $S(coordonnees_utilisateur)"
	append pour_OTL_radii "\n$S(coordonnees_pour_sauvegarde)"
	## ENREGISTRE ..._points_OTL.txt
	##
	grabar_radii_OTL $pour_OTL_radii
	##
    }
    
    global maison namofile reperes dirimage coord_vraies lmnb plaquex plaquey
    
    .frame.oh configure -text "Image info"
    set S(avis) "ID is automatically assigned as a number; but you can add someting if you want\n\nCOMMENT what you want; please remember that the name of the image is automatically stored in the output file\n\nVAR (for variable) for instance altitude, latitude, etc.\n\n\nYou can also leave it as it is, without writing anything"

    # namofile contient le nom complet du fichier image
    #
    set coord_vraies $coord
    # "A ce stade le nombre de LM =  [llength $plaquex]"
    set reperes [expr {[llength $coord]/2}]
    #
    # Formatage des coordonnees - debut -----------------------------------------------
    #
    set coord_vraies_formatees ""
    set compteur 0
    foreach item  $coord_vraies {
        # ajustement de la taille
        set item [expr $item * $S(size_scale)]
        # ajustement a l'echelle indiquee par l'etalonnage (au choix de l'utilisateur ??)
        # set item [expr $item * [lindex $S(scale) 0]]
        # -----------------------
        incr compteur
        if {[expr {fmod($compteur,2)}] != 0} {
            append coord_vraies_formatees "[format %1.3f $item]\t"
        } else  {
            append coord_vraies_formatees "[format %1.3f $item]\n"
        }
    }
    set coord_vraies $coord_vraies_formatees
    set coord_vraies_formatees ""
    #
    #Formatage des coordonnees - fin ---------------------------------------------------
    
    # Petite fenetre (.boutons) pour entrer les commentaires ID, COMMENT, et VAR
    destroy .boutons
    toplevel .boutons
    #
    wm geometry .boutons +460+220
    wm title .boutons "Image INFO"
    set input1 [entry .boutons.entree1 -background white -textvariable inputval1]
    set input2 [entry .boutons.entree2 -background white -text "comment alors ?" -textvariable inputval2]
    set input3 [entry .boutons.entree3 -background white -textvariable inputval3]
    set label_haut [label .boutons.etiquette4 -background "light yellow" -foreground blue -height 1 -text "[file tail $namofile]"]
    set label1 [label .boutons.etiquette1 -background grey85 -foreground blue -height 1 -text "ID ="]
    set label2 [label .boutons.etiquette2 -background grey85 -foreground blue -height 1 -text "COMMENT = "]
    set label3 [label .boutons.etiquette3 -background grey85 -foreground blue -height 1 -text "VAR ="]
    set action1 [button .boutons.boutonOK -background grey -foreground blue -height 2 -text "O K" -command {
        global ficoord; # Aug. 2009
        set ficoord $fichier_coord
        global dirimage coord_vraies
        set identite $inputval1;# ID
        if {$identite == ""} {set identite $numero} else {set identite "$numero : $identite"}
        set ficelle $inputval2;# COMMENT
        if {$ficelle == ""} {set ficelle "NA"}
        set linotte $inputval3;# VAR
        if {$linotte == ""} {set linotte "NA"}
        if {[info exists S(rapport)]} {
            set etalon "$S(rapport) [lrange $S(scale) 1 end]"
            #debug "zoom correction $S(size_scale)"
            set fixing [expr {[lindex $etalon 0] * $S(size_scale)}]
            #debug "etalon corrige [lreplace $etalon 0 0 $fixing ]"
            set etalon [lreplace $etalon 0 0 $fixing ]
            #debug "etalon corrige $etalon"
        } else {
            set etalon "NA"
        }
        destroy .boutons
        
        # On essaie d'introduire le commentaire (la premiere ligne du fichier de sortie) - debut
        if {[file exists $ficoord]} {set comment ""} else {
            if {$S(outline_ctr) == 1} {
                set comment "OUTLINE DATA, first set of x,y coordinates is the centroid.- Can be converted to other ...OTL.txt and ...OTL_DB.txt format by using TET"
            } else  {
                if {$S(outline_lmk) == 1} {
                    set comment "OUTLINE DATA, first set of x,y coordinates is the starting point.# Can be converted to other ...OTL.txt and ...OTL_DB.txt format by using TET"
                } else  {
                    set comment "TPS like internal (simplified) format - can be converted to other format by using TET"
                }
            }
        }
        # On essaie d'introduire le commentaire - fin
        if {$S(outline_ctr) == 1 || $S(outline_lmk) == 1}  {set un "\n\nPT=$reperes\n"} else {set un "\n\nLM=$reperes\n"}
        set deux "IMAGE=$namofile"
        set trois "\nID=$identite"
        set quatre "\nCOMMENT=$ficelle"
        set cinq "\nVARIABLES=$linotte"
        set six "\nSCALE=$etalon"
        set sauver $comment$un$coord_vraies$deux$trois$quatre$cinq$six
        # Introduction du commentaire -fin
        #
        # NOUVEAU
        #
        # OPEN THE FILE
        set nameoffile $ficoord
        set fileid [open $nameoffile a]
        puts -nonewline $fileid $sauver
        close $fileid
        # CLOSE THE FILE
        update
        flush stdout
        # OPEN THE FILE
        set nameoffile $ficoord
        set fileid [open $nameoffile r]
        set texte [read -nonewline $fileid]
        close $fileid
        # CLOSE THE FILE
        update
        flush stdout
        unset lmeff
        #
        # Enregistrement de la derniere session
        if {![info exists coordonnees]} {
            set heure [clock seconds]
            set date [clock format $heure -format %b%d]
            set qui "_"
            set ext ".txt"
            set dernieresession "coordLast"
            set dernieresession $dernieresession$ext
        }
        #
        set lastsession "[file tail $namofile]\
                \n$lmnb\
                \n$date\
                \n[file dirname $namofile]
        "
	#
	if {$S(outline_ctr) == 1} {
	    set listsession "\n[file tail $namofile] : outline, \tDay: $date  Hour: [clock format $heure -format %R] "
	} else {
	    set listsession "\n[file tail $namofile] : $lmnb LM, \tDay: $date  Hour: [clock format $heure -format %R]"}
        #
        set nomdufichier [file join [file dirname $namofile] $dernieresession]
        # Reconstruction a partir du nom par defaut: 'coord_Date.txt' -> coordLast_Date.txt (soit $nomdufichier)
        set alpha [file tail $ficoord]
        set beta [string range $alpha 0 [expr {[string first "_" $alpha] - 1}]];# le mot 'coord'
        set delta [string range $alpha [string first "_" $alpha] end]";# la '_Date' et l'extension '.txt'
        set gamma "Last"
        set reconstructedfile [file join [file dirname $nameoffile] $beta$gamma$delta]
        #
        #type "listsession $listsession"
        # OPEN THE FILE
        set fileid [open $nomdufichier a]
        puts -nonewline $fileid "$listsession"
        close $fileid
        # CLOSE THE FILE
        update
        flush stdout
        #
        # Il faudra penser aussi a un nom rigide genre 'lastsession.txt' car tout ce qui est plus haut
        # ne vaut presque rien si l'utilisateur a change le nom du fichier 'coordas_Date.txt'
        # Dans ce fichier LASTSESSION, inscrire la date de travail, et placer ce fichier rigide dans COO
        #
        #debug "S(dirscript) $S(dirscript) et S(dirclic) $S(dirclic)"
        set nomdufichier [file join $S(dirclic) "lastsession.txt"]
        set fileid [open $nomdufichier w]
        puts -nonewline $fileid $lastsession
        close $fileid
        # CLOSE THE FILE
        update
        flush stdout
        #
        #
        set S(session) 1
        onemoretime
    }
    ]
    focus -force $input1
    pack $label_haut $label1 $input1 $label2 $input2 $label3 $input3 $action1 -padx 10 -pady 2m -fill x -side top
    #
    bind .boutons <Key-Return> {.boutons.boutonOK invoke}
}
#
# procedure TPSLIKE


# Procedure LSUM -début
proc lsum {liste} {
    # calcule la somme des éléments d'une liste (numerique, bien entendu)
    set compteur 0
    foreach item $liste {
        set compteur [expr {$compteur+ $item} ]
    }
    return $compteur
}
#
# Procedure LSUM -fin

# Procedure  GRABAR_nb_radii_OTL - Debut
#
# enregistre les intersections des rayons avec le polygone digitalisé par l'utilisateur
#
proc grabar_nb_radii_OTL {newtext nb} {
    global S infile
    #
    # Nom du fichier d'output
    set radotl "_radii_OTL"
    set newtext [string trimright $newtext]
    set outfile "[file rootname $infile]_$nb$radotl"
    set filename "$outfile.txt"
    #
    #debug "--->>> $newtext"
    #
    # Ecrire la première ligne de commentaire
    if {[file exists $filename] != 1} {
	#
	# OPEN THE FILE
	set fileid [open $filename a]
	# FILL THE FILE
	puts -nonewline $fileid "$nb RADII, from $infile\n"
	close $fileid
	#
    }
    # Formatage des valeurs en une matrice de deux colonnes - debut ------ (inutile, non?)
    #
    #
    set coordonnees_du_contour ""
    set compteur 0
    foreach item  $newtext {
        # -----------------------
        incr compteur
        if {[expr {fmod($compteur,2)}] != 0} {
            append coordonnees_du_contour "[format %1.1f $item]\t"
        } else  {
            append coordonnees_du_contour "[format %1.1f $item]\n"
        }
    }
    set newtext $coordonnees_du_contour
    #
    # Formatage des valeurs en une matrice de deux colonnes - fin -------

    # De deux colonnes de x et y sur p pseudolandmarks vers des lignes x y de p pseudolandmarks
    set newtext [regsub -all {\n} $newtext "\t"]
    set newtext [regsub -all {\t\t} $newtext "\t"]
    set newtext [string trim $newtext]
    #
    
    # calcul du nbre de points en incluant le point centroide, pour un format FOG compatible
    set nb_points [expr {([llength $newtext] + 2)  * 1 / 2}];# avec le centroide
    #
    
    # Le calcul du centroide, voir ci-dessous
    #
    foreach {x y} $newtext {
        append list_x "$x "
        append list_y "$y "
    }
    set sum_x [lsum $list_x]; set moy_x [expr {$sum_x * 1.0 / $nb_points}]
    set sum_y [lsum $list_y]; set moy_y [expr {$sum_y * 1.0 / $nb_points}]
    set moy_x [format %1.1f $moy_x]
    set moy_y [format %1.1f $moy_y]
    set centroide "$moy_x\t$moy_y"
    #
    set newtext "$nb_points\t$centroide\t$newtext"
    #
    update
    #
    # OPEN THE FILE
    set fileid [open $filename a]
    # FILL THE FILE
    #puts -nonewline $fileid "from $infile\n"
    puts -nonewline $fileid "\n$newtext"
    close $fileid
    #
}
# Procedure  GRABAR_nb_radii_OTL - Fin

# Procedure SAVE --- start
#
proc save {} {
    global S ficoord clic matisse
    #type "[llength $coord] coordonnees";# enleve a la demande de Ph. Bousses
    #type "S(outline_ctr) = $S(outline_ctr) "
    #type "coord = $coord <-default"
    if {$coord != ""} {
	if {![info exists lmeff]} {set lmeff "ok"}
	#
	if {$S(outline_ctr) == 0} {
	    append lm_control " [expr {[llength $coord] / 2}]"
	    set lm_control_ordre [lsort -real $lm_control]
	    if {[lindex $lm_control_ordre 0] != [lindex $lm_control_ordre end]} {
		type "You are trying to save an image with a different number of LM\
                          \n[lrange $lm_control 0 end-1] <-> [lrange $lm_control end end]\nHit the OK button and try to fix the problem "
		set lm_control [lrange $lm_control 0 end-1]
		return
	    } else  {
		#type "Number of LM is [lindex $lm_control 0]"
	    }
	    # Il faudrait ajouter une vérification de la constance du nombre de LM dans l'entièreté du fichier des coordonnées du jour
	    set nomdufichier [file join $S(dirclic) "lastsession.txt"]
	    if {[file exists $nomdufichier]} {
		# si le fichier lastsession existe
		if {[info exists norepeat]} {
		    # si norepeat existe, on ne repete pas
		} else {
		    if {$S(lmnb_anterieur) != [lrange $lm_control end end]} {
			set norepeat 1
			if {[file exists $ficoord]} {
			    type "CLIC tries to avoid coordinates files with different numbers of LM\
                                        \n\nBe aware your output file \n($ficoord)\n has now various configurations of LM...\
                                        \n\nYour output file is located in the same folder as your first digitized pictures."
			} else {
			    type "CLIC tries to avoid coordinates files with different numbers of LM\
                                        \nApparently, your last image was digitized with session used a different number of LM ...\
                                        \n\nNote that this is NOT a problem IF you are starting another session in a new folder"
			    file delete "$S(dirclic)/lastsession.txt"
			}
		    }
		}
	    }
	}
	suset $fichier_coord $numero $lmeff;#SAVE -> suset -> tpslike ->
    } else  {
	set hey "COLLECTION OF COORDINATES, FIRST\n\n\nor use the 'SKIP' button (jumping guy, bottom left)\
                    \n... if you want to skip the present image."
	docu $hey blue
    }
}
#
# Procedure SAVE --- end



# procedure FILENAME_GET
#
proc filename_get { } {
    #
    update
    flush stdout
    global filename extension namofile dirimage chemin route separateur
    
    #debug
    #puts "fienameget  dirimage = $dirimage"
    
    if {[info exists dirimage]} {
        set tes ""
        #debug
        #puts "IF dirimage = $dirimage"
    } else {
        set dirimage [pwd]
        #debug
        #puts "ELSE dirimage = $dirimage"
    }
    
    set file_types {
        { "Picture" { .pnm .PNM .tif .TIF .tiff .TIFF .png .PNG .jpeg .JPEG .jpg .JPG .gif .GIF .bmp .BMP .pgm .PGM} }
    }
    
    set filename [tk_getOpenFile -filetypes $file_types -initialdir $dirimage]
    
    
    if {$filename != ""} {
        set namofile $filename
        # ----------------- configuration du nom de dossier --- ouverture d'un fichier ad hoc
        #filename contient le chemin et le nom du fichier des donnees
        set dossier "[file dirname $filename]/";#repertoire des donnees
        # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
        if {$dossier != $dirimage} {
            # open le fichier de conf pour ecrire
            catch [
		   set fid [open $chemin w+]
		   puts -nonewline $fid "Dernier dossier de donnees utilisees par COO:\n"
		   puts -nonewline $fid $dossier
		   close $fid
		  ] iciggg
            # open le fichier de routage pour ecrire
            catch [
		   set fid [open $route w+]
		   puts -nonewline $fid "Dernier dossier de donnees :\n"
		   puts -nonewline $fid $dossier
		   close $fid
		  ] ici
            set dirimage $dossier
        }
        #debug
        #puts "chemin = $dirinfile"
        # --------------------------------- fin de la configuration du nom de dossier
        return $filename
    } else  {
        tk_messageBox -message "The END" -type ok
        return ""
    }
}
#
# Procedure FILENAME_GET - fin

# PROCEDURE loadotl - DEBUT
#
# LOADOTL genere otl() points, 
#                la liste de coordonnees otl_contour(), 
#                le nb d'individus S(otl_nb) 
#                et le fichier .DTA pour EFAW
#
proc loadotl {pathname} {
    #
    if {$pathname != ""} {
        global p S references otl otl_contour
        set S(dist_nopar) 0
        set S(datadir) $pathname
        #
        set fid [open $pathname]
        set text [read -nonewline $fid]
        close $fid
        #
        set compteur -1
        #
        foreach line [split $text \n] {
            if {[string trim $line] != ""} {
                if {$compteur > -1} {
                    set otl($compteur) [lindex $line 0]
                    set otl_contour($compteur) [lrange $line 1 end]
                    set otl_contour($compteur) [regsub -all {NA} $otl_contour($compteur) ""]
                    #debug "otl($compteur) = $otl($compteur) points\notl_contour($compteur) <- [llength $otl_contour($compteur)] coordonnees"
                    incr compteur
                } else  {
                    set references $line
                    incr compteur
                }
            }
        }
        set S(otl_nb) $compteur
        
        #
        # -- Formater le commentaire ('references') - Enlever d'eventuelles tabulations
        foreach mot $references {
            if {$mot != "\t"} {
                append comentario_sin_tab "$mot "
            }
        }
        if {[info exists comentario_sin_tab]} {set references $comentario_sin_tab}
        set S(references) $references
        # -- FIN du formatage de la premiere ligne
        
        #
        # Il faudrait creer le meme fichier en .DTA (pour EFAW), centroide exclu - debut
        #
        set data ""
        append data "\"$references - Centroid removed\" "
        for {set i 0} {$i < $S(otl_nb)} {incr i} {
            append data "\n[expr {$otl($i) - 1}]\n";# Nombre de points (points, pas coordonnees)
            set compteur 0
            foreach {x y} $otl_contour($i) {
                # on saute les coordonnees du point centroide
                if {$compteur > 0} {append data "$x $y\n"}
                incr compteur
            }
        }
        #
        
        # puis l'enregistrer ...
        # OPEN THE FILE
        set extension ".DTA"
        set nameoffile "/[file tail [file rootname $pathname]]"
        set filename [file dirname $pathname]$nameoffile$extension
        set fileid [open $filename w]
        # FILL THE FILE
        puts -nonewline $fileid "\n$data"
        # CLOSE THE FILE
        close $fileid
        #
        # Il faudrait creer le meme fichier en .DTA (pour EFAW) - fin
        #
        # --------------------------------------------------------------------------------
        return $data
    }
}
#
# PROCEDURE loadotl - FIN


# Procedure WHICHOTL - start
#
# pour entrer les OTL (outlines)
#
proc whichotl {} {
    #
    global p infile dossier otl otl_contour
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
        {{"All Files"} {.*}}
    }
    set infile [chemin];# usage de la procedure CHEMIN : memoire des dossiers anterieurs
    #
    # VERIFIER _OTL.txt
    if {[string first  "_OTL" $infile] < 0} {
        set answer [tk_messageBox -message "Sure this ([file tail $infile]) is an outline contour file to be open by FOG?" -type yesno]
        switch -- $answer {
            yes {}
            no {exit}
        }
    }
    #
    set x [loadotl $infile]; # usage de la procedure LOADOTL
    # LOADOTL genere otl() points, la liste de coordonnees otl_contour(), le nb d'individus S(otl_nb) et le fichier .DTA pour EFAW
    # Le x retourne par LOADOTL sont les coordonnees dans le format .DTA !! avec une premiere ligne = le commentaire
    #debug "x= \n$x"
    #if {$x != ""} {
    #    entrada_otl $x $infile;# usage de la procedure ENTRADA_OTL: presentation breve des donnees
    #}
    # ENTRADA genere otl_liste qui est la liste du nombre de points de chaque figure...
    return $x
}
#
# Procedure WHICHOTL - end



# Procedure CHEMIN -start
#
proc chemin {} {
    
    global S p dossier
    
    if {[info exists dirinfile] == 0} {
	set dirinfile [pwd]
    }
    
    # ----------------------------------------------------
    # Nom du FICHIER et son CHEMIN (path) CORRESPONDANT
    # ---------------------------------------------------
    
    
    # Chercher sa route dans un fichier de configuration: il y en a un dans le dossier FOG (chemin), et un dans le dossier CLIC (route)
    # dans le dossier MOG
    set chemin "[pwd]/dossier_fog.txt"
    # dans le dossier CLIC
    set route $S(dirclic)/dossier_CLIC.txt
    #
    # On lit d'abord le fichier dossier_CLIC, s'il existe
    # sinon
    # on lit le fichier du script, s'il existe
    #
    # 1. verifier que les fichiers de routage existent
    if {[file exists $route] == 0} {
	# dans le cas ou il n'y a pas de fichier de routage dans le dossier CLIC
	set candidat_dossier_CLIC [pwd]
	catch [
	       set fid [open $route w+]
	       puts -nonewline $fid "Dernier dossier de donnees:\n"
	       puts -nonewline $fid [pwd]
	       close $fid
	      ] ici
    } else  {
	# 3. si le fichier de routage existe dans le dossier CLIC, reccueillir alors le dernier chemin parcouru
	# open le fichier pour lire
	catch [
	       set fid [open $route r]
	       set candidat_dossier_CLIC [read -nonewline $fid]
	       close $fid
	      ] ici
	set candidat_dossier_CLIC [lindex [split $candidat_dossier_CLIC \n] 1]
	#debug "\ndossier selon CLIC = $candidat_dossier_CLIC"
    }
    
    #debug "chemin $chemin"
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
	set candidat_dossier [pwd]
    } else  {
	# 3. si le fichier de routage du MODULE existe reccueillir le dernier chemin parcouru
	# open le fichier pour lire
	catch [
	       set fid [open $chemin r]
	       set candidat_dossier [read -nonewline $fid]
	       close $fid
	      ] ici
	set candidat_dossier [lindex [split $candidat_dossier \n] 1]
	#debug "\ndossier selon FOG: $candidat_dossier ... dossier selon CLIC = $candidat_dossier_CLIC"
    }
    
    #debug "si le dossier_CLIC n'est pas le dossier en cours (CLIC_XX): $candidat_dossier_CLIC"
    # A present, on a le choix entre candidat_dossier_CLIC et candidat_dossier
    if {$candidat_dossier_CLIC != [pwd]} {
	#debug "si le dossier_CLIC n'est pas le dossier en cours (CLIC_XX)"
	set candidat_dossier $candidat_dossier_CLIC
    } else  {
	# sinon, on adopte le candidat_dossier
    }
    
    
    
    
    # On va chercher les donnees
    
    set typeList {
	{{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
    
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
	# open le fichier de conf pour ecrire
	catch [
	       set fid [open $chemin w+]
	       puts -nonewline $fid "Dernier dossier de donnees utilisees par COV:\n"
	       puts -nonewline $fid $dossier
	       close $fid
	      ] ici
	# open le fichier de routage pour ecrire
	catch [
	       set fid [open $route w+]
	       puts -nonewline $fid "Dernier dossier de donnees :\n"
	       puts -nonewline $fid $dossier
	       close $fid
	      ] ici
    }
    
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    
    # --------------------------------------------------------
    # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE pop
    # --------------------------------------------------------
    return $infile
}
#
# Procedure CHEMIN - end


# PROCEDURE loadfile - DEBUT
#
proc loadfile {pathname} {
    
    if {$pathname != ""} {
	global S
	set S(dist_nopar) 0
	set S(datadir) $pathname
	#
	# OPEN
	set fid [open $pathname]
	# READ
	set text [read -nonewline $fid]
	# CLOSE
	close $fid
	#
	# Converting to HUME matrix
	set rowcount 0
	set colcount 0
	global references
	set compteur 0
	set lignes 0
	set data ""
	foreach line [split $text \n] {
	    incr compteur
	    if {$compteur >1} {
		if  {$line != ""} {
		    set colcount [llength $line]
		}
	    }
	    if {$compteur>1} {
		foreach item [split $line] { if {$item != ""} {
		    incr lignes
		    append data "[string trim $item]\t"
		}
		}
	    } else {set references $line}
	}
	set rowcount [expr {$lignes / $colcount}]
	set result [concat 2 $rowcount $colcount $data]
	#debug
	#puts "Commentaire brut :\n$references"
	# -- Formater le commentaire
	# -- 1. Enlever d'eventuelles tabulations
	foreach mot $references {
	    if {$mot != ""} {
		append comentario_sin_tab "$mot "
	    }
	}
	set references $comentario_sin_tab
	set S(references) $references
	# -- FIN du formatage de la premiere ligne
	return $result
    }
}
#
# PROCEDURE loadfile - FIN

# ------------------------------------------------------
# Procedure PRINCIPALE 
# ------------------------------------------------------

global S coord otl_contour

# !!!!!!
# On va chercher les coordonnees des points dans un fichier _OTL.txt
set pour_x [whichotl];
# pour_x contient le commentaire puis les coordonnes au format .DTA (mais ce n'est pas utilise ensuite...)
# WHICHOTL a genere pour chaque individu la liste otl_contour() des coordonnees, mais aussi otl() et S(otl_nb)

# !!!!!!
# On proposera une gamme de rayons, peut-être interactivement
set rad_max 360

#set otl_contour(0) "18 10  10 10 15 15 20 15 25 10 20 5 10 5"

# !!!!!!
# On armera un canvas (toplevel+frame+canvas) par rayonnage 
global canvas_compteur

## fenetre de suivi
#button .seguir -text " $S(otl_nb)"
#pack .seguir

#
for {set i 0} {$i < $S(otl_nb)} {incr i} {
    # d'un contour à l'autre

    # (le nombre de points, présent dans le fichier d'input, a déjà été enlevé)
    set coord_ici [lrange $otl_contour($i) 2 end];# ne contient pas le centroide
    #
    set canvas_compteur 0
    #
    for {set rad_nb 60} {$rad_nb < $rad_max} {incr rad_nb 60} {
	# d'un rayonnage à l'autre
	incr canvas_compteur
	set S(fraction) $rad_nb
	#
	#Pour chaque contour... on visionne (ou non, cfr "cannevas") les rayonnages
	#cannevas $canvas_compteur
	#
	set coord $coord_ici
	set coord_rad($rad_nb) [outline $coord]
	# !!!!!!
	# On enregistrera chaque rayonnage dans _$rad_nb_radii_OTL.txt
	#
	## ENREGISTRE ..._points_OTL.txt
	##
	grabar_nb_radii_OTL [lrange $coord_rad($rad_nb) 2 end] $rad_nb;# j'ai enlevé le centroide
    }
    update
    if {[expr {$i+1}] < $S(otl_nb)} {
	.muestreo.buttons.reset configure -bg yellow -text "[expr {$i+1}] / $S(otl_nb) "
    } else {
	.muestreo.buttons.reset configure -bg "grey88" -fg black -text "\"reset\" "
	type "6 files have been created"
    }

}

# ------------------------------------------------------
# Procedure principale 
# ------------------------ end -------------------------