namespace eval env {
    
    proc chull {groupe} {
        
        # Calcule du rapport cote / hypothenuse - au lieu de calculer l'angle ...
        proc rapport_sinus {x0 y0 x1 y1} {
            global fid
            set x [expr {abs($x1-$x0)}]
            set y [expr {abs($y1-$y0)}]
            set hyp [expr {hypot($x,$y)}]
            #debug
            if {$hyp > 0} {
                set presinus [expr {$y * 1.0 / $hyp}]
            } else {
                set presinus [expr {$y * 1.0 / 0.0001}]
            } 
            return $presinus
        }
        #
        # Fin de la procedure
        
        # Procedure LINES'CROSS
        # ou recherche de l'existence d'un point d'INTERSECTION
        proc lines'cross { line1 line2 } {
            foreach { xa ya xb yb } $line1 break
            foreach { xc yc xd yd } $line2 break
            set det [expr { ( $xb - $xa ) * ( $yd - $yc )
                - ( $xd - $xc ) * ( $yb - $ya ) }]
            if { $det == 0 } {
                # line segments are parallel or collinear
                return
            }
            set nump [expr { ( $xd - $xc ) * ( $yb + $ya )
                - ( $xb + $xa ) * ( $yd - $yc )
                + 2. * ( $xc * $yd - $xd * $yc ) }]
            if { abs($nump) > abs($det) } {
                # point of intersection is outside first line segment
                return
            }
            set numq [expr { ( $xd + $xc ) * ( $yb - $ya )
                - ( $xb - $xa ) * ( $yd + $yc )
                + 2. * ( $xb * $ya - $xa * $yb ) }]
            if { abs($numq) > abs($det) } {
                # point of intersction is outside second line segment
                return
            }
            # le calcul du point d'intersection n'est pas necessaire pour le convex hull, je pourrais dire return '1'
            return 1
        }
        # Fin de la procedure
        
        global ptdef ptext card_1
        global ref_g_ymax_xmin ref_g_xmin_ymin ref_g_ymin_xmax ref_g_xmax_ymax
        global canvas_g_ymin canvas_g_ymax canvas_g_xmax canvas_g_xmin
        
        # Donnees du GROUPE
        #set g {{142 74} {197 80} {144 70} {208 72} {149 78} {141 101} {129 76} {209 85} {114 94} {163 90} {122 96} {186 95} {161 86} {164 88} {126 87} {170 85} {140 69} {217 66} {174 100} {134 103} {170 94} {197 70} {215 95} {217 65} {215 88} {195 72} {164 53} {193 73} {120 58} {142 78} {111 80} {189 57} {198 52} {145 67} {156 100} {184 53} {186 61} {209 60} {133 91} {213 75} {156 88} {219 72} {163 67} {177 98} {213 87} {183 69} {162 60} {132 98} {113 87} {197 84} {110 62} {191 75} {153 101} {117 97} {156 82} {130 53} {201 103} {170 61} {158 95} {177 94}}
        set long [llength $groupe]
        for {set i 0} {$i < $long} {incr i 2} {
            lappend g "[lindex $groupe $i] [lindex $groupe [expr {$i + 1}]]"
        }
        
        # En principe, les coordonnees envoyees sont deja converties au canvas de jpdraw
        # Donc, cd qui suit entre =============== ets pour le moment annule
        # sauf en ce qui concerne le calcul des extremes
        # ==========================================
        ## Convertir les points de ce groupe a l'echelle du canvas (x = 800 y = 400)
        ## Conversion
        #     _ 1 connaitre les extremes
        set sort_x  [lsort -real -index 0 $g ]
        set g_xmin [lindex $sort_x 0]
        set g_xmax [lindex $sort_x end]
        set sort_y  [lsort -real -index 1 $g ]
        set g_ymin [lindex $sort_y 0]
        set g_ymax [lindex $sort_y end]

        # pour ne pas changer trop de noms de variables ... je rends equivalents les g et les canvas_g
        set canvas_g $g
        
        # ====================================
        # Correction des valeurs maximales selon l'echelle du canvas
        set sort_canvas_x  [lsort -real -index 0 $canvas_g ]
        set canvas_g_xmin [lindex $sort_canvas_x 0]
        set canvas_g_xmax [lindex $sort_canvas_x end]
        set sort_canvas_y  [lsort -real -index 1 $canvas_g ]
        set canvas_g_ymin [lindex $sort_canvas_y end];# attention, a l'envers sur le canvas
        set canvas_g_ymax [lindex $sort_canvas_y 0];# attention, a l'envers sur le canvas
        # ==========================================
        
        # LISTES  des POINTS DEFINITIFS - Initialement, les points CARDINAUX.
        # Une liste par secteur
        set ptdef(1) ""
        set ptdef(2) ""
        set ptdef(3) ""
        set ptdef(4) ""
        # Chaque liste contient d'emblee le points cardinal initial du secteur
        # Table (secteur, point)
        lappend ptdef(1) $canvas_g_ymax
        # ensuite viendront les points externes retenus dans le secteur 1 (lappend ptdef(1) etc.)
        lappend ptdef(2) $canvas_g_xmin
        # ensuite viendront les points externes retenus dans le secteur 2 (lappend ptdef(2) etc.)
        lappend ptdef(3) $canvas_g_ymin
        # ensuite viendront les points externes retenus dans le secteur 3 (lappend ptdef(3) etc.)
        lappend ptdef(4) $canvas_g_xmax
        # ensuite viendront les points externes retenus dans le secteur 4 (lappend ptdef(4) etc.)
        
        
        # Procedure POINTS_REFERENCE (ptref) d'un groupe
        # Une reference par couple de points cardinaux
        # Paire g_ymax g_xmin
        set ref_g_ymax_xmin "[lindex $canvas_g_ymax 0] [lindex $canvas_g_xmin 1]"
        # Paire g_xmin g_ymin
        set ref_g_xmin_ymin "[lindex $canvas_g_ymin 0] [lindex $canvas_g_xmin 1]"
        # Paire g_ymin g_xmax
        set ref_g_ymin_xmax "[lindex $canvas_g_ymin 0] [lindex $canvas_g_xmax 1]"
        # Paire g_xmax g_ymax
        set ref_g_xmax_ymax "[lindex $canvas_g_ymax 0] [lindex $canvas_g_xmax 1]"
        
        # Total des points
        set total_g [llength $canvas_g]
        #Total des points du graphe: $total_g"
        #Les points par secteur ne comprennent pas ceux qui touchent les limites sectorielles \
        (ces derniers sont obligatoirement hors de la selection finale - hormis les 4 points cardinaux)"
        # POINTS_SECTEURS du groupe
        # il faut connaitre les points qui occupent chaque secteur du groupe examine
        #
        set ptobs_g_s(1) ""
        set ptobs_g_s(2) ""
        set ptobs_g_s(3) ""
        set ptobs_g_s(4) ""
        set s 0
        # Secteur y_max_x_min
        set s [expr {$s+1}]
        foreach item $canvas_g {
            if {[lindex $item 0] < [lindex $ref_g_ymax_xmin 0]} {
                if {[lindex $item 1] < [lindex $ref_g_ymax_xmin 1]} {
                    lappend ptobs_g_s($s) $item
                }
            }
        }
        # Secteur x_min_y_min
        set s [expr {$s+1}]
        foreach item $canvas_g {
            if {[lindex $item 0] < [lindex $ref_g_xmin_ymin 0]} {
                if {[lindex $item 1] > [lindex $ref_g_xmin_ymin 1]} {
                    lappend ptobs_g_s($s) $item
                }
            }
        }
        # Secteur y_min_x_max
        set s [expr {$s+1}]
        foreach item $canvas_g {
            if {[lindex $item 0] > [lindex $ref_g_ymin_xmax 0]} {
                if {[lindex $item 1] > [lindex $ref_g_ymin_xmax 1]} {
                    lappend ptobs_g_s($s) $item
                }
            }
        }
        # Secteur x_max_y_max
        set s [expr {$s+1}]
        foreach item $canvas_g {
            if {[lindex $item 0] > [lindex $ref_g_xmax_ymax 0]} {
                if {[lindex $item 1] < [lindex $ref_g_xmax_ymax 1]} {
                    lappend ptobs_g_s($s) $item
                    #puts "OK"
                }
            }
        }
        #
        set sumext 0
        
        # POINTS EXTERNES
        # Des points observes de chaque cadran, on ne veut retenir
        # que ceux qui sont en dehors de la ligne des points cardinaux
        proc pt_ext {ptobs ptref ptcard1 ptcard2} {
            set line1 [concat $ptcard1 $ptcard2]
            set line2 [concat $ptref $ptobs]
            set ligne [concat $line1 $line2]
            set etalors [lines'cross $line1 $line2]
            return $etalors
        }
        
        # Procedure POUR_PTEXT
        #
        # Pour le choix des points externes de chaque secteur
        proc  pour_ptext {i p_obs ptref card1 card2} {
            global fid
            set ptexter ""
            # choix des points exterieurs a la ligne cardinale
            set nbindiv [llength $p_obs]
            for {set j 0} {$j < $nbindiv} {incr j} {
                set etalors [pt_ext [lindex $p_obs $j] $ptref $card1 $card2]
                if {$etalors != ""} {
                    lappend ptexter [lindex $p_obs $j]
                }
            }
            return $ptexter
        }
        
        # Pour chaque secteur
        # on envoie les individus pertinents a pour_ptext -> ptext, accompagnes des cardinaux pertinents
        # ainsi sont crees ou renouveles les points externes retenus
        # Ceci dessous est le TOUT PREMIER passage
        for {set i 1} {$i < 5} {incr i} {
            set p_obs ""
            append p_obs $ptobs_g_s($i)
            if {$i == 1} {set ptref $ref_g_ymax_xmin;set card1 $canvas_g_ymax; set card2 $canvas_g_xmin}
            if {$i == 2} {set ptref $ref_g_xmin_ymin;set card1 $canvas_g_xmin; set card2 $canvas_g_ymin}
            if {$i == 3} {set ptref $ref_g_ymin_xmax;set card1 $canvas_g_ymin; set card2 $canvas_g_xmax}
            if {$i == 4} {set ptref $ref_g_xmax_ymax;set card1 $canvas_g_xmax; set card2 $canvas_g_ymax}
            # Appel a la procedure pour_ptext
            set ptext($i) [pour_ptext $i $p_obs $ptref $card1 $card2]
        }
        # Je regroupe alors les donnees externes en 4 secteurs, creant des secteurs vides si necessaire
        set sumext 0
        for {set i 1} {$i < 5} {incr i} {
            if {[info exists ptext($i)]} {
                set sumext [expr {$sumext + [llength $ptext($i)]}]
            } else  {
                set ptext($i) ""
            }
        }
        
        # Gestion des listes definitives apres le PREMIER PASSAGE
        # Changement de point cardinal (card1), chaque nouveau 'card1' devenu un point definitif
        
        #puts -nonewline $fid "\n Passage 1\n---------------"
        
        # v. 15 On va tenter de recalculer les angles a partir de l'axe defini par le dernier ptcard
        global card_1
        set card_1(1) $canvas_g_ymax
        set card_1(2) $canvas_g_xmin
        set card_1(3) $canvas_g_ymin
        set card_1(4) $canvas_g_xmax
        
        for {set i 1} {$i < 5} {incr i} {
            if {$i == 1} {
                set rapport ""
                set a $ptext($i)
                if {[llength $a] > 0} {
                    # comparaison des angles (en fait, des sinus)
                    set x0 [lindex $card_1($i) 0]
                    set y0 [lindex $card_1($i) 1]
                    foreach item $a {
                        set x1 [lindex $item 0]
                        set y1 [lindex $item 1]
                        lappend rapport [rapport_sinus $x0 $y0 $x1 $y1]
                    }
                    # J'ordonne la liste initiale pour en connaitre la valeur minimale (ou maximale)
                    set rapport_ordre [lsort -real -increasing $rapport]
                    # Je repere l'endroit (choix) de la valeur minimale dans la liste initiale (rapport)
                    for {set k 0} {$k < [llength $rapport]} {incr k} {
                        if {[lindex $rapport $k] == [lindex $rapport_ordre 0]} {set choix $k}
                    }
                    set card_1($i) [lindex  $a $choix]
                    lappend ptdef($i) [lindex  $a $choix]
                    # J'enleve de la liste intiale la valeur extreme (min, ou max) choisie
                    set a [lreplace $a $choix $choix]
                    set ptext($i) $a
                } else  {
                    set card_1($i) $canvas_g_ymax
                }
            }
            if {$i == 2} {
                set rapport ""
                set a $ptext($i)
                if {[llength $a] > 0} {
                    # comparaison des angles
                    set x0 [lindex $card_1($i) 0]
                    set y0 [lindex $card_1($i) 1]
                    foreach item $a {
                        set x1 [lindex $item 0]
                        set y1 [lindex $item 1]
                        lappend rapport [rapport_sinus $x0 $y0 $x1 $y1]
                    }
                    set rapport_ordre [lsort -real -decreasing $rapport]
                    for {set k 0} {$k < [llength $rapport]} {incr k} {
                        if {[lindex $rapport $k] == [lindex $rapport_ordre 0]} {set choix $k}
                    }
                    set card_1($i) [lindex  $a $choix]
                    lappend ptdef($i) [lindex  $a $choix]
                    set a [lreplace $a $choix $choix]
                    set ptext($i) $a
                } else  {
                    set card_1($i) $canvas_g_xmin
                }
            }
            if {$i == 3} {
                set rapport ""
                set a $ptext($i)
                if {[llength $a] > 0} {
                    # comparaison des angles
                    set x0 [lindex $card_1($i) 0]
                    set y0 [lindex $card_1($i) 1]
                    foreach item $a {
                        set x1 [lindex $item 0]
                        set y1 [lindex $item 1]
                        lappend rapport [rapport_sinus $x0 $y0 $x1 $y1]
                    }
                    set rapport_ordre [lsort -real -increasing $rapport]
                    for {set k 0} {$k < [llength $rapport]} {incr k} {
                        if {[lindex $rapport $k] == [lindex $rapport_ordre 0]} {set choix $k}
                    }
                    set card_1($i) [lindex  $a $choix]
                    lappend ptdef($i) [lindex  $a $choix]
                    set a [lreplace $a $choix $choix]
                    set ptext($i) $a
                } else  {
                    set card_1($i) $canvas_g_ymin
                }
            }
            if {$i == 4} {
                set rapport ""
                set a $ptext($i)
                if {[llength $a] > 0} {
                    # comparaison des angles
                    set x0 [lindex $card_1($i) 0]
                    set y0 [lindex $card_1($i) 1]
                    foreach item $a {
                        set x1 [lindex $item 0]
                        set y1 [lindex $item 1]
                        lappend rapport [rapport_sinus $x0 $y0 $x1 $y1]
                    }
                    set rapport_ordre [lsort -real -decreasing $rapport]
                    for {set k 0} {$k < [llength $rapport]} {incr k} {
                        if {[lindex $rapport $k] == [lindex $rapport_ordre 0]} {set choix $k}
                    }
                    set card_1($i) [lindex  $a $choix]
                    lappend ptdef($i) [lindex  $a $choix]
                    set a [lreplace $a $choix $choix]
                    set ptext($i) $a
                } else  {
                    set card_1($i) $canvas_g_xmax
                }
            }
        }
        
        global autre
        set autre 1
        
        # On devrait alors creer de nouveaux points externes, et recommencer le processus
        # Procedure PHASEFINALE
        proc  phasefinale {sumext} {
            global autre card_1
            set autre [expr {$autre +1}]
            global fid
            global ptdef ptext card_1
            global ref_g_ymax_xmin ref_g_xmin_ymin ref_g_ymin_xmax ref_g_xmax_ymax
            global canvas_g_ymin canvas_g_ymax canvas_g_xmax canvas_g_xmin
            set sumext 0
            # Quels sont les points externes restants
            for {set i 1} {$i < 5} {incr i} {
                set p_obs ""
                append p_obs $ptext($i)
                if {$i == 1} {set ptref $ref_g_ymax_xmin; set card2 $canvas_g_xmin}
                if {$i == 2} {set ptref $ref_g_xmin_ymin; set card2 $canvas_g_ymin}
                if {$i == 3} {set ptref $ref_g_ymin_xmax; set card2 $canvas_g_xmax}
                if {$i == 4} {set ptref $ref_g_xmax_ymax; set card2 $canvas_g_ymax}
                # Appel a la procedure pour_ptext
                set ptext($i) [pour_ptext $i $p_obs $ptref $card_1($i) $card2]
                # ensuite je regroupe les donnees externes : procedure ?
                set sumext [expr {$sumext + [llength $ptext($i)]}]
            }
            
            # Gestion des listes definitives
            # Changement de point cardinal (card1), chaque nouveau 'card1' devenu un point definitif
            if {$sumext > 0} {
                for {set i 1} {$i < 5} {incr i} {
                    if {$i == 1} {
                        set rapport ""
                        set a $ptext($i)
                        if {[llength $a] > 0} {
                            # comparaison des angles
                            set x0 [lindex $card_1($i) 0]
                            set y0 [lindex $card_1($i) 1]
                            foreach item $a {
                                set x1 [lindex $item 0]
                                set y1 [lindex $item 1]
                                lappend rapport [rapport_sinus $x0 $y0 $x1 $y1]
                            }
                            # J'ordonne la liste initiale pour en connaitre la valeur minimale (ou maximale)
                            set rapport_ordre [lsort -real -increasing $rapport]
                            # Je repere l'endroit (choix) de la valeur minimale dans la liste initiale (rapport)
                            for {set k 0} {$k < [llength $rapport]} {incr k} {
                                if {[lindex $rapport $k] == [lindex $rapport_ordre 0]} {set choix $k}
                            }
                            set card_1($i) [lindex  $a $choix]
                            lappend ptdef($i) [lindex  $a $choix]
                            # J'enleve de la liste intiale la valeur extreme (min, ou max) choisie
                            set a [lreplace $a $choix $choix]
                            set ptext($i) $a
                        } else  {
                            set card_1($i) $canvas_g_ymax
                        }
                    }
                    if {$i == 2} {
                        set rapport ""
                        set a $ptext($i)
                        if {[llength $a] > 0} {
                            # comparaison des angles
                            set x0 [lindex $card_1($i) 0]
                            set y0 [lindex $card_1($i) 1]
                            foreach item $a {
                                set x1 [lindex $item 0]
                                set y1 [lindex $item 1]
                                lappend rapport [rapport_sinus $x0 $y0 $x1 $y1]
                            }
                            set rapport_ordre [lsort -real -decreasing $rapport]
                            for {set k 0} {$k < [llength $rapport]} {incr k} {
                                if {[lindex $rapport $k] == [lindex $rapport_ordre 0]} {set choix $k}
                            }
                            set card_1($i) [lindex  $a $choix]
                            lappend ptdef($i) [lindex  $a $choix]
                            set a [lreplace $a $choix $choix]
                            set ptext($i) $a
                        } else  {
                            set card_1($i) $canvas_g_xmin
                        }
                    }
                    if {$i == 3} {
                        set rapport ""
                        set a $ptext($i)
                        if {[llength $a] > 0} {
                            # comparaison des angles
                            set x0 [lindex $card_1($i) 0]
                            set y0 [lindex $card_1($i) 1]
                            foreach item $a {
                                set x1 [lindex $item 0]
                                set y1 [lindex $item 1]
                                lappend rapport [rapport_sinus $x0 $y0 $x1 $y1]
                            }
                            set rapport_ordre [lsort -real -increasing $rapport]
                            for {set k 0} {$k < [llength $rapport]} {incr k} {
                                if {[lindex $rapport $k] == [lindex $rapport_ordre 0]} {set choix $k}
                            }
                            set card_1($i) [lindex  $a $choix]
                            lappend ptdef($i) [lindex  $a $choix]
                            set a [lreplace $a $choix $choix]
                            set ptext($i) $a
                        } else  {
                            set card_1($i) $canvas_g_ymin
                        }
                    }
                    if {$i == 4} {
                        set rapport ""
                        set a $ptext($i)
                        if {[llength $a] > 0} {
                            # comparaison des angles
                            set x0 [lindex $card_1($i) 0]
                            set y0 [lindex $card_1($i) 1]
                            foreach item $a {
                                set x1 [lindex $item 0]
                                set y1 [lindex $item 1]
                                lappend rapport [rapport_sinus $x0 $y0 $x1 $y1]
                            }
                            set rapport_ordre [lsort -real -decreasing $rapport]
                            for {set k 0} {$k < [llength $rapport]} {incr k} {
                                if {[lindex $rapport $k] == [lindex $rapport_ordre 0]} {set choix $k}
                            }
                            set card_1($i) [lindex  $a $choix]
                            lappend ptdef($i) [lindex  $a $choix]
                            set a [lreplace $a $choix $choix]
                            set ptext($i) $a
                        } else  {
                            set card_1($i) $canvas_g_xmax
                        }
                    }
                }
                # Presentation
                phasefinale $sumext
            } else  {
                set polygonefinal [concat $ptdef(1) $ptdef(2) $ptdef(3) $ptdef(4)]
                foreach item $polygonefinal {
                    if {$item != ""} {
                        string trimright $item
                        append convexhull "$item "
                    }
                }
                append convexhull "$canvas_g_ymax "
                #chull
                return $convexhull
                .c create line $convexhull
                #close $fid
            }
        }
        
        phasefinale $sumext
        
    }
    
}