package require Tk

################################################################################
# Select
# Copyright ©  2012 Dujardin J.-P. dujardin@mpl.ird.fr
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
################################################################################

cd [file dirname [info script]]
#
global S
set S(dirscript) [pwd];#attention, il n'y a pas de "/" a la fin du nom du dossier du script (utiliser "file join etc")

set version "NORMALIZED OUTLINE, beta version"

set tcl_precision 14

set dossier [pwd]
#
# la ayuda explica el bootstrap
source chull.tcl
source math/statistics.tcl
source math/math.tcl
source math/optimize.tcl
source math/linalg.tcl
source 101La.tcl
source jpdraw_14.tcl
source ballons.tcl


switch $tcl_platform(platform) {
    "unix" {
        set fin "/+/L"
        set suf "/neighbor"
        set S(appel) "exec xterm $S(dirscript)$fin$suf"
        set suf "/njplot.linux"
        set S(appelnjplotte) "exec xterm $S(dirscript)$fin$suf"
        set S(filename1) [file join $S(dirscript) "+/L/translat.txt"]
        set S(filename2) [file join $S(dirscript) "+/L/treefile"]
        set S(dossierdumod) [file join $S(dirscript) "+" "L" "infile" ]
    }
    "windows" {
        set fin "/+/W"
        set suf "/neighbor.exe"
        set S(appel) "exec cmd.exe /c neighbor.exe"
        set suf "/njplot.exe"
        set S(appelnjplotte) "exec cmd.exe /c njplot.exe"
        set S(filename1) "+/W/translat.txt";#a changer pour translat.txt ??
        set S(filename2) "+/W/outtree";#a changer pour outtree ??
        set S(dossierdumod) [file join $S(dirscript) "+" "W" "infile" ]
    }
    "macintosh" {}
}


# -----------------------------------------------------------------------------
# FENETRE PRESENTATION de la MATRICE (procedure mod)
# ------------------------------------------------------------------------------



global p fp
set fp .muestreo
catch {destroy $fp}
catch {toplevel .muestreo}
wm state . withdrawn

set titre "$version"
wm title .muestreo $titre
wm geometry $fp 1200x600+50+10

frame $fp.buttons
pack $fp.buttons -side bottom -fill x -pady 2m

button $fp.buttons.informe -text "Save report ?" -command {
    global S
    if {$S(save) != "_INFO_FOG.txt"} {
        savelisting $S(save)
    } else  {
        savelisting "_INFO_FOG.txt"
    }
}

button $fp.buttons.wrap -text "Wrap" -command {
    global drapeau
    if {[info exists drapeau]} {
        if {$drapeau == 1} {
            .muestreo.debut configure -wrap word; set drapeau 0
        } else {
            .muestreo.debut configure -wrap none; set drapeau 1
        }
    } else  {
        set drapeau 1
    }
}

button $fp.buttons.clean -text "Clean Output" -command {
    global p
    $p delete 0.0 end
}

button $fp.buttons.reset -fg red -text "Reset" -command {
    set avertisse "Memory will be cleared (except current output). \
            Please be careful with this reset button, it is sometimes deficient."
    set answer [tk_messageBox -message $avertisse -title "SURE ?" -type okcancel -icon warning]
    switch -- $answer {
        ok {unot;arranco}
        cancel {}
    }
}

button $fp.buttons.exit -fg red  -text "EXIT" -command {
    exit
}

button $fp.buttons.suivi -fg red  -text "Suivi" -command {}

pack $fp.buttons.wrap $fp.buttons.informe $fp.buttons.suivi $fp.buttons.exit -side left -expand 1

set scb [scrollbar .muestreo.scrollA -command ".muestreo.debut yview"]
pack $scb -side left -fill y
#
set p [text .muestreo.debut -background "light yellow" -font "courier 12" -wrap word -yscrollcommand ".muestreo.scrollA set"]

$p insert end "\nFOG is slow, sometimes very slow, especially when opening a complex outline contour (..._OTL.txt)\
        captured by many points ( > 1200).  \
        \n\nThe corresponding output files ( ..._FOG, _FOGsf,....) allow you to repeat graphing and statistical tests, if required, \
        in a relatively faster way.\n\n\t - - - \t\t - - - \t\t - - - \t\t - - - \n"
# ---------------------------------------------------------------------------------------------
# Create a menu
# ---------------------------------------------------------------------------------------------
set m1 [menu $fp.popupMenu1]
$m1 add command -label "_OTL.txt         (Outline contour)" -command {otlmain}
$m1 add command -label "_FOG.txt        (Elliptic Fourier coefficients)" -command {fogmain}
$m1 add command -label "-----------------------------"
$m1 add command -label "Save Report" -command {
    global S
    if {$S(save) != "_INFO_FOG.txt"} {
        savelisting $S(save)
    } else  {
        savelisting "_INFO_FOG.txt"
    }
}
$m1 add command -label "-----------------------------"
$m1 add command -label "HELP" -foreground "dark green" -command {
    foghelp "+/fogfile_help.txt"
}
$m1 add command -label "-----------------------------"
$m1 add command -label "E X I T" -command exit

set m2 [menu $fp.popupMenu2]
$m2 add command -label "PCA" -command {
    global p S
    if {[info exists S(pafmatall)] == 1} {
        acpotl_si
    } else  {
        tk_messageBox -message "Please compute harmonics first" -type ok
    }
}
$m2 add command -label "Size-free PCA" -command {
    global p S
    if {[info exists S(pafmatall_sf)]} {
        acpotl_sf
    } else  {
        #loadfile ....FOGsf
        # Lecture des size-free coefficients: nom du fichier ..._OTL_FOGsf.txt, s'il existe
        set a [file dirname $infile]
        set queue [file tail $infile]
        if {[string first "_FOG" $queue] > -1} {
            set b [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
            set c "sf.txt"
        } else {
            set b  [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
            set c "_FOGsf.txt"
        }
        #
        set infile_sf [file join $a $b$c]
        #tk_messageBox -message "EXISTS $infile_sf ??" -type ok
        if {[file exists $infile_sf]} {
            #tk_messageBox -message "EXISTS $infile_sf" -type ok
            set S(pafmatall_sf) [loadfile $infile_sf]
            acpotl_sf
        } else  {
            tk_messageBox -message "Please compute size-free coefficients first" -type ok
        }
    }
}


$m2 add command -label "DA" -command {
    global p S
    if {[info exists S(pafmatall)] == 1} {
        daotl_si
    } else  {
        tk_messageBox -message "Please compute Fourier coefficients first" -type ok
    }
}
$m2 add command -label "Size-free DA" -command {
    global p S
    if {[info exists S(pafmatall_sf)]} {
        daotl_sf
    } else  {
        #loadfile ....FOGsf
        # Lecture des size-free coefficients: nom du fichier ..._OTL_FOGsf.txt, s'il existe
        set a [file dirname $infile]
        set queue [file tail $infile]
        if {[string first "_FOG" $queue] > -1} {
            set b [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
            set c "sf.txt"
        } else {
            set b  [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
            set c "_FOGsf.txt"
        }
        #
        set infile_sf [file join $a $b$c]
        tk_messageBox -message "infile_sf = $infile_sf ??" -type ok
        if {[file exists $infile_sf]} {
            set S(pafmatall_sf) [loadfile $infile_sf]
            daotl_sf
        } else  {
            tk_messageBox -message "Please compute size-free coefficients first" -type ok
        }
    }
}
$m2 add command -label "-----------------------------"
$m2 add command -label "HELP" -foreground "dark green" -command {
    foghelp "+/fogpcada_help.txt"
}

set m3 [menu $fp.popupMenu3]
$m3 add command -label "Perimeter" -command {
    global S
    set S(dequoilsagit) "--- Size estimator is perimeter ---"
    if {[info exists S(cp_sf)]} {
        set S(DA) 0
        set connards ""
        for {set u 0} {$u < [mrows $S(cp_sf)]} {incr u} {
            update
            lappend connards [mrange $S(cp_sf) 0 end $u $u]
            #debug [mrange $S(cp_sf) 0 end $u $u]
        }
        #debug "INDIVIDUS $connards"
        alocs $connards
    } else  {
        tk_messageBox -message "Please perform size-free PCA first" -type ok
    }
}
$m3 add command -label "Area"  -command {
    global S
    set S(dequoilsagit) "--- Size estimator is area ---"
    if {[info exists S(area)]} {
        set S(DA) 0
        alocs $S(cp_sf)
    } else  {
        tk_messageBox -message "Not implemented yet" -type ok
    }
}
$m3 add command -label "-----------------------------"
$m3 add command -label "HELP" -foreground "dark green" -command {
    foghelp "+/fogallometry_help.txt"
}

set m4 [menu $fp.popupMenu4]
$m4   add command -label "SF tree: Neighbor Joining (PHYLIP, J. Felsenstein)" -command {
    global p S infile
    # Ouvrir un fichier ... _FOGcpsf.txt ... s'il existe
    set a [file dirname $infile]
    set queue [file tail $infile]
    if {[string first "_FOG" $queue] > -1} {
        set b [string range $queue 0 [string first "_FOG" $queue] ]
        set c "FOGcpsf.txt"
    } else {
        set b  [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
        set c "_FOGcpsf.txt"
    }
    set infile_cpsf [file join $a $b$c]
    debug "CPSF\na = $a\nqueue = $queue \nb = $b\nc = $c\n$infile_cpsf"
    set filename $infile_cpsf
    #
    if {[file exists $filename]} {
        debug "je charge S(cp_sf)"
        global gr
        set S(cp_sf) [loadfile $filename]
        ##
        if {[info exists S(grupos)] != 1} {
            tk_messageBox -message "Please graph groups first" -type ok
            return
        }
        
        set S(treenj) 1
        tree::tree_nj
    } else  {
        if {[info exists S(cp_sf)]} {
            set S(treenj) 1
            tree::tree_nj
        } else  {
            tk_messageBox -message "Please do the size-free PCA first" -type ok
        }
    }
}
$m4   add command -label "Size-in tree: Neighbor Joining (PHYLIP, J. Felsenstein)" -command {
    global p S
    if {[info exists S(cp_si)]} {
        set S(treenj) 1
        tree::tree_nj
    } else  {
        tk_messageBox -message "Please do the size-in PCA first" -type ok
    }
}
$m4   add command -label " ... Names for the OTUs (Treedyn, Chevenet)" -foreground blue -command {
    global p S
    if {[info exists S(treenj)]} {
        if {$S(treenj) == 1} {
            tree::qui
        } else  {
            tk_messageBox -message "Please build a tree first" -type ok
        }
    } else  {
        tk_messageBox -message "Please build a tree first" -type ok
    }
}
$m4   add command -label " ... NJPLOT, Perriere & Gouy (1996) "  -foreground "blue" -command {
    global p S
    if {[info exists S(treenj)]} {
        if {$S(treenj) == 1} {
            tree::njplotte
        } else  {
            tk_messageBox -message "Please build a tree first" -type ok
        }
    } else  {
        tk_messageBox -message "Please build a tree first" -type ok
    }
}
$m4 add command -label "-----------------------------"
$m4   add command -label "HELP" -foreground "dark green" -command {
    foghelp "+/fogtree_help.txt"
}

set m5 [menu $fp.popupMenu5]
$m5 add command -label "Estimated outlines" -command {
    global S
    if {[info exists S(pafmatall)]} {
        global p S chevalet
        #wm iconify .muestreo
        #wm deiconify .toile
        if {[string first "_FOG" $infile] > -1} {
            paf
            viewing
            #.toile.buttons.con invoke
            # appel a la procedure VIEWING
        } else  {
            if {[info exists S(pafmatall_sf)]} {
                viewing
                #.toile.buttons.con invoke
                # appel a la procedure VIEWING
            } else  {
                paf
                viewing
                #.toile.buttons.con invoke
                #.toile.buttons.spe invoke
                # appel a la procedure PAF
            }
        }
    } else  {
        tk_messageBox -message "Please compute harmonics first" -type ok
    }
}
$m5 add command -label "-----------------------------"
$m5 add command -label "HELP" -foreground "dark green" -command {
    foghelp "+/estimotl_help.txt"
}
#
################################################################################

# Create something to attach it to
frame $fp.f
pack $fp.f $p -side top -fill both -expand yes
pack [label $fp.f.l1 -text "FILE"] [label $fp.f.l2 -text "PCA / DA"]  [label $fp.f.l3 -text "ALLOMETRY"]  [label $fp.f.l4 -text "TREE"]   [label $fp.f.l5 -text "GRAPH"]  -padx 50 -side left
# Arrange for the menu to pop up when the label is clicked
bind $fp.f.l1 <1> {tk_popup $fp.popupMenu1 %X %Y}
bind $fp.f.l2 <1> {tk_popup $fp.popupMenu2 %X %Y}
bind $fp.f.l3 <1> {tk_popup $fp.popupMenu3 %X %Y}
bind $fp.f.l4 <1> {tk_popup $fp.popupMenu4 %X %Y}
bind $fp.f.l5 <1> {tk_popup $fp.popupMenu5 %X %Y}

pack $p -side bottom -fill both -expand yes


# Procedure FOGMAIN - start
#
proc fogmain {} {
    global p S otl otl_contour fp contour fogmat fogmatall harm_nb infile
    #
    set S(pafmatall) [whichfog]
    #debug [show $S(pafmatall)]
    #
    set S(fogfile) 1
    # Nombre de figures
    set S(otl_nb) [mrows $S(pafmatall)]
    $p insert end "\nFrom [file tail $infile] : $S(otl_nb) outlines\n"
    # Les coefficients sans Ao et Co
    set fogmatall [mrange $S(pafmatall) 3 end 0 end]
    $p insert end  "\nFrom [file tail $infile] : [mcols $fogmatall] coefficients (sans Ao ni Co) "
    # Les fogmat individuels
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        set fogmat($j) [mrange $fogmatall 0 end $j $j]
        #debug "Les coefficients (sans Ao ni Co) de l'individu $j\n[show $fogmat($j)] "
    }
    # Les perimetres dans une liste
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        append S(perimeter) "[vtrim [mrange $S(pafmatall) 0 0 $j $j]] "
        #debug "Les perimetres $S(perimeter)"
    }
    # Les Ao dans une liste, les Co dans une liste
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        append S(Ao) "[vtrim [mrange $S(pafmatall) 1 1 $j $j]] "
        append S(Co) "[vtrim [mrange $S(pafmatall) 2 2 $j $j]] "
        #debug "Les Ao $S(Ao)\nLes Co: $S(Co)"
    }
    fognorm $fogmatall
}
#
# Procedure FOGMAIN - fin

# Procedure FOGNORM - start
#
proc fognorm {fogmatall} {
    global p S
    # chacune des 18 harmoniques (a b c d) de chaque individu
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        rouge "\nIndividu $j, "
        set harmonique 0
        for {set i 0} {$i < [mcols $fogmatall]} {incr i 4} {
            incr harmonique
            set abcd($j,$harmonique) [mrange $fogmatall $i [expr {$i+3}] $j $j]
            $p insert end "\nHarmonique $harmonique \t[show $abcd($j,$harmonique)]"
        }
    }
    # Donc, a present, abcd(2,6) donne les 4 coefficients de Fourier de l'harmonique 6 pour l'individu 2 ...
    #
    #Calcul de "NORMALIZED coefficients"
    #
    # Coefficients de la premiere harmonique de chaque individu
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        set a1 [vtrim [mrange $abcd($j,1) 0 0 0 0]]
        set b1 [vtrim [mrange $abcd($j,1) 1 1 0 0]]
        set c1 [vtrim [mrange $abcd($j,1) 2 2 0 0]]
        set d1 [vtrim [mrange $abcd($j,1) 3 3 0 0]]
        debug "\n$abcd($j,1):\na1 = $a1, b1 = $b1, c1 = $c1 et d1 = $d1"
        # Calcul de la fraction
        set a1b1 [expr {$a1 * $b1}]
        set c1d1 [expr {$c1 * $d1}]
        set a12 [expr {$a1 * $a1}]
        set b12 [expr {$b1 * $b1}]
        set c12 [expr {$c1 * $c1}]
        set d12 [expr {$d1 * $d1}]
        set fraction [expr {(2*($a1b1+$c1d1)) * 1.0 / ($a12+$c12-$b12-$d12)}]
        
        # arctan de la fraction
        set arctan_fraction [expr {atan($fraction)}]
        # modulo pi
        set pi 3.1426
        set modpi [expr {fmod($arctan_fraction,$pi)}]
        set pimod [expr {fmod($pi,$arctan_fraction)}]
        debug "fraction = $fraction, et arctan = $arctan_fraction, et modpi = $modpi et pimod $pimod"
        set psi $pimod
        # Calcul de aast2 et de aast
        set aast2 [expr {$a1*cos($psi) + $b1*sin($psi)}]
        set aast [expr {sqrt($aast2)}]
        # Calcul de cast2 et de cast
        set cast2 [expr {$c1*cos($psi) + $d1*sin($psi)}]
        set cast [expr {sqrt($cast2)}]
        # Calcul de theta
        set theta [expr {atan($cast * 1.0 / $aast)}]
        # Calcul de scale
        set scale [expr {sqrt($aast2 + $cast2)}]
        # Calcul de trigopsi
        set trigopsi "2 2 2 [expr {cos($psi)}] [expr {sin($psi)}] [expr {(sin($psi) * -1)}] [expr {cos($psi)}]"
        #
        # NORMALIZED coefficients de l'INDIVIDU j
        #
        set harm 0
        for {set i 0} {$i < [mcols $fogmatall]} {incr i 4} {
            incr harm
            # Matrice des a b c d de chaque harmonique
            set abcd_mat "2 2 2 [vtrim $abcd($j,$harm)]"
            # calcul de trigothe
            set trigothe "2 2 2 [expr {cos($theta * $harm)}] [expr {(sin($theta * $harm) * -1)}] [expr {sin($theta * $harm)}] [expr {cos($theta * $harm)}]"
            #
            set scaling [expr {1 * 1.0 / $scale}]
            debug "\nSCALING $scaling"
            debug "mscale trigopsi scaling\n[mscale $trigopsi $scaling]"
            debug "abcd_mat\n$abcd_mat"
            set part1 [mmult [mscale $trigopsi $scaling ] $abcd_mat]
            debug "mmult mscale trigopsi scaling abcd_mat \n[mmult [mscale $trigopsi $scaling ] $abcd_mat]"
            set ABCD($j,$harm) [mmult $part1 $trigothe]
            debug "ABCD($j,$harm) \n$ABCD($j,$harm)"
            append normfog($j) "[vtrim $ABCD($j,$harm)] "
        }
        
    }
    set S(normfogall) "2 $S(otl_nb) [llength $normfog(1)] "
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        append S(normfogall) "$normfog($j) "
    }
    rouge "\n[show $S(normfogall)]"
}
#
# Procedure FOGNORM - end


# Procedure WHICHFOG - start
#
# pour entrer les coefficients de Fourier
#
proc whichfog {} {
    #
    global p infile dossier otl otl_contour
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [chemin];# usage de la procedure CHEMIN : memoire des dossiers anterieurs
    #
    # VERIFIER _HARM.txt
    if {[string first  "_FOG" $infile] < 0} {
        set answer [tk_messageBox -message "Sure this ([file tail $infile]) is containing Perimeters and Fourier coefficients?" -type yesno]
        switch -- $answer {
            yes {}
            no {exit}
        }
    }
    #
    set x [loadfile $infile]; # usage de la procedure LOADFILE
    #
    if {$x != ""} {
        entrada $x $infile;# usage de la procedure ENTRADA: presentation breve des donnees
    }
    return $x
}
#
# Procedure WHICHFOG - end


# Procedure CHEMIN -start
#
proc chemin {} {
    
    global p dossier
    
    if {[info exists dirinfile] == 0} {
        set dirinfile [pwd]
    }
    
    # ----------------------------------------------------
    # Nom du FICHIER et son CHEMIN (path) CORRESPONDANT
    # ---------------------------------------------------
    
    # Chercher le chemin dans un fichier de configuration
    # 1. verifier que le fichier de configuration existe
    set chemin "[pwd]/dossier_coeffou.txt"
    #puts "chemin $chemin"
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
        set candidat_dossier [pwd]
    } else  {
        #puts "La conf existe"
        # 3. s'il existe reccueillir le dernier chemin parcouru
        # open le fichier pour lire
        catch [
        set fid [open $chemin r]
        set candidat_dossier [read -nonewline $fid]
        close $fid
        ] ici
        #puts "candidat_dossier $candidat_dossier"
        set candidat_dossier [lindex [split $candidat_dossier \n] 1]
        # debug
        #puts "dossier = $candidat_dossier"
    }
    #
    # On va chercher les donnees
    #
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
    #
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    #
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
        # open le fichier de conf pour ecrire
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilisees par COEFFOU:\n"
        puts -nonewline $fid $dossier
        close $fid
        ] ici
    }
    #
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    #
    # --------------------------------------------------------
    # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE pop
    # --------------------------------------------------------
    return $infile
}
#
# Procedure CHEMIN - end


# procedure DEBUG - debut
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x480+205+44
        set memo [text .debug.t -wrap no -height 22 -font "courier 13" \
                -bg grey88 \
                -fg black\
                -tabs "3c left"\
                -yscrollcommand ".debug.v_scroll set" \
                -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
            if {$flag == 1} {
                .debug.t configure -wrap none
                set flag 0
            } else  {
                .debug.t configure -wrap word
                set flag 1
            }
        }
        #
        $memo insert end $bugatti
        $memo see end
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG - fin


# PROCEDURE loadfile - DEBUT
#
proc loadfile {pathname} {
    
    if {$pathname != ""} {
        global S
        set S(dist_nopar) 0
        set S(datadir) $pathname
        set fid [open $pathname]
        set text [read -nonewline $fid]
        close $fid
        set rowcount 0
        set colcount 0
        global references
        set compteur 0
        set lignes 0
        set data ""
        foreach line [split $text \n] {
            incr compteur
            if {$compteur >1} {
                if  {$line != ""} {
                    set colcount [llength $line]
                }
            }
            if {$compteur>1} {
                foreach item [split $line] { if {$item != ""} {
                        incr lignes;lappend data $item
                    }
                }
            } else {set references $line}
        }
        set rowcount [expr {$lignes / $colcount}]
        set result [concat 2 $rowcount $colcount $data]
        #debug
        #puts "Commentaire brut :\n$references"
        # -- Formater le commentaire
        # -- 1. Enlever d'eventuelles tabulations
        foreach mot $references {
            if {$mot != ""} {
                append comentario_sin_tab "$mot "
            }
        }
        set references $comentario_sin_tab
        set S(references) $references
        # -- FIN du formatage de la premiere ligne
        
        # --------------------------------------------------------------------------------
        #
        # Il faudrait creer le meme fichier en .nts (pour TPSregr) - debut
        #
        set datos ""
        set compteur 0
        foreach truc [split $text "\n"] {
            if {$compteur > 0} {
                if {$truc != ""} {lappend datos "$truc\n"}
            } else {
                #lappend datos "\"$truc\n"
                set premligne $truc
            }
            incr compteur
        }
        # Enlever les curved brackets
        set datos [regsub -all {\{|\}} $datos ""]
        #
        set ntscode "1 $rowcount $colcount 0\n"
        set ntsmatrix $ntscode$datos
        #debug
        #rouge "NTSNTSNTS\n$ntsmatrix\nNTSNTSNTS\n"
        # puis l'enregistrer ...
        # OPEN THE FILE
        set extension ".nts"
        set nameoffile "/[file tail [file rootname $pathname]]"
        set filename [file dirname $pathname]$nameoffile$extension
        set fileid [open $filename w]
        # FILL THE FILE
        puts -nonewline $fileid "\" $premligne \" "
        puts -nonewline $fileid "\n$ntsmatrix"
        # CLOSE THE FILE
        close $fileid
        #
        # Il faudrait creer le meme fichier en .nts (pour TPSregr) - fin
        #
        # --------------------------------------------------------------------------------
        
        return $result
    }
}
#
# PROCEDURE loadfile - FIN


# Procedure ENTRADA - start
#
proc entrada {pop infile} {
    
    global p references
    $p insert end "\nCALCUL DES COEFFICIENTS DE FOURIER"
    # En rouge on ecrit le commentaire du fichier de donnees
    rouge "\n\n$infile \n"
    rouge "\n$references\n"
    update
    set colonnes [mcols $pop]
    set lignes [mrows $pop]
    
    # En bleu on ecrit les premieres lignes et colonnes du fichier de donnees ...
    #bleu "\nArchivo contenido (parcialmente):"
    #$p insert end "\n[show [mrange $pop 0 [expr {$colonnes - 1} ] 0 4 ] ] \netc. \n"
    update
    #vert "\nSON LOS DATOS LOGARITMOS NATURALES ? \n"
    
    # ... et d'autres infos sur ce fichier
    bleu "\nNumero de variables =\t"
    $p insert end "$colonnes\n"
    
    bleu "\nNumero de individuos =\t"
    $p insert end "$lignes\n"
}
#
# Procedure ENTRADA - fin



################### bleu ##### Procedure ## Debut ##
proc bleu {mesg args} {
    global p
    $p insert end $mesg "bleu"
    $p tag configure bleu -foreground blue
}

################### bleu ####### PROCEDURE ## FIN ###

################### rouge ##### Procedure ## Debut ##
proc rouge {mesg args} {
    global p
    $p insert end $mesg "rouge"
    $p tag configure rouge -foreground red
}

################### rouge ####### PROCEDURE ## FIN ###

################### vert ##### Procedure ## Debut ##
proc vert {mesg args} {
    global p
    $p insert end $mesg "vert"
    $p tag configure vert -foreground "dark green"
}

################### vert ####### PROCEDURE ## FIN ###
