package require Tk

################################################################################
# Select
# Copyright ©  Richard Suchenwirth 2004-07-23 & Dujardin J.-P. dujardin@ird.fr
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
################################################################################

cd [file dirname [info script]]
set S(dirscript) [pwd];#attention, il n'y a pas de "/" a la fin du nom du dossier du script (utiliser "file join etc")
set S(clicscript) [pwd];#attention, ne se transmet pas aux modules appeles

cd [file dirname [info script]]
#
global S
set S(dirscript) [pwd];#attention, il n'y a pas de "/" a la fin du nom du dossier du script (utiliser "[file join etc]")
#
cd ..
set S(dirclic) [pwd]
cd $S(dirscript)
#
set version "polygarea - beta"



# On s'adapte a l'existence d'un monopole
#
switch -- $tcl_platform(platform) {
    "unix" {}
    "windows" {}
    "macintosh" {}
    default {}
}
#
# 
#########################################################################

# procedure DEBUG
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x600+205+66
        set memo [text .debug.t -wrap word -height 22 -font "courier 13" \
                -bg grey88 \
                -fg black\
                -tabs "3c left"\
                -yscrollcommand ".debug.v_scroll set" \
                -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.enr -fg red -text "Save" -command {
            #global find_last_indx pointf ici
            set outputtosave "AREAS of configurations obtained from the [file tail $infile] file\n$table"
            #debug "\n+++++++++\noutput to save: \n$outputtosave"
            #
            # On enregistre les aires = fichier AIRES, soit un autre fichier des tailles
            set end "_AIRES.txt"
            set are "[file rootname $infile]$end"
            set filename $are
            # OPEN THE FILE
            set fileid [open $filename w]
            # FILL THE FILE
            puts -nonewline $fileid "AREAS of configurations obtained from the [file tail $infile] file\n"
            puts -nonewline $fileid $table
            # CLOSE THE FILE
            close $fileid
            #
            set fin _CS.txt
            set sizes [file rootname $infile]$fin
            set sizes_file [file tail $sizes]
            tk_messageBox -message "Table output now saved in [file tail $filename] \nUse COV and the 'TWO MATRICES' menu to compute correlations with SIZE ($sizes_file)" -type ok
        }
        button .debug.help -fg red -bg "ivory" -text "Help" -command {
            .debug.help configure -fg "dark green" -bg "ivory" -text "Help"
            global memo
            $memo delete 1.0 end
            destroy $memo.m1 $memo.m2
            button $memo.m1 -text "Module" -command {
                .debug.help configure -text " <-- "
                $memo delete 1.0 end
                $memo insert end "
                *** ### ---MODULES --- ### ***
                *
                Modules are COO, TET, MOG, PAD, COV, ASI, VAR and FOG
                In a recent past, they were directories ending by 'win' or by 'lin' according to your system, either Windows or Linux.
                They contain scripts and archives, and they can still be put anywhere in your hard disk (not recommended)
                *
                *** ### ---MODULES --- ### ***
                "}
            button $memo.m2 -text "o . help" -command {
                .debug.help configure -text " <-- "
                $memo delete 1.0 end
                $memo insert end "
                *** ### --- b r o w s e --- ### ***
                *
                Manually find the correct module at its right place;
                when you open its directory, double clic on any file.
                *
                *** ### --- b r o w s e--- ### ***
                "
            }
            $memo window create {end lineend} -window $memo.m1
            $memo window create {end lineend} -window $memo.m2
            bind $memo.m1 <Motion> {$memo.m1 configure -cursor hand1}
            bind $memo.m2 <Motion> {$memo.m2 configure -cursor hand1}
            set aide "
            Possible problems
            --------------------------
            Either
            (1) the correct path was not given to the clic.tcl file (inside the CLIC folder),
            or
            (2) you have an old CLIC
            
            Possible solutions
            --------------------------
            (1) Download the latest module from http://mome-clic.com/the-clic-package/
            "
            $memo insert end "\n *** ### --- HELP --- ### ***\n$aide\n *** ### --- HELP --- ### ***\n"
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
            if {$flag == 1} {
                .debug.t configure -wrap none
                set flag 0
            } else  {
                .debug.t configure -wrap word
                set flag 1
            }
        }
        #
        $memo insert end $bugatti
        pack .debug.wrap .debug.enr .debug.exit -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG fin


# Procedure CHEMIN -start
#
proc chemin {} {
    
    global p S dossier
    
    if {[info exists dirinfile] == 0} {
        set dirinfile [pwd]
    }
    
    # ----------------------------------------------------
    # Nom du FICHIER et son CHEMIN (path) CORRESPONDANT
    # ---------------------------------------------------
    #
    # Chercher sa route dans un fichier de configuration:
    # il y en a un dans le dossier Polygon (chemin), et un dans le dossier CLIC (route)
    # dans le dossier Polygon
    set chemin "[pwd]/dossier_polygarea.txt"
    # dans le dossier CLIC
    set route $S(dirscript)/dossier_polygarea.txt
    #
    # On lit d'abord le fichier dossier_CLIC, s'il existe
    # sinon
    # on lit le fichier du script, s'il existe
    #
    # 1. verifier que les fichiers de routage existent
    if {[file exists $route] == 0} {
        # dans le cas ou il n'y a pas de fichier de routage dans le dossier CLIC
        set candidat_dossier_CLIC [pwd]
        tk_messageBox -message "candidat_dossier_CLIC $candidat_dossier_CLIC" -type ok
        catch [
        set fid [open $route w+]
        puts -nonewline $fid "Dernier dossier de donnees:\n"
        puts -nonewline $fid [pwd]
        close $fid
        ] ici
    } else  {
        # 3. si le fichier de routage existe dans le dossier CLIC, reccueillir alors le dernier chemin parcouru
        # open le fichier pour lire
        tk_messageBox -message "route $route" -type ok
        catch [
        set fid [open $route r]
        set candidat_dossier_CLIC [read -nonewline $fid]
        close $fid
        ] ici
        set candidat_dossier_CLIC [lindex [split $candidat_dossier_CLIC \n] 1]
        tk_messageBox  "\ndossier selon CLIC = $candidat_dossier_CLIC" -type ok
    }
    
    #debug "chemin $chemin"
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
        set candidat_dossier [pwd]
        tk_messageBox -message "candidat_dossier $candidat_dossier" -type ok
    } else  {
        # 3. si le fichier de routage du script POLYGAREA existe, reccueillir le dernier chemin parcouru
        # open le fichier pour lire
        catch [
        set fid [open $chemin r]
        set candidat_dossier [read -nonewline $fid]
        close $fid
        ] ici
        set candidat_dossier [lindex [split $candidat_dossier \n] 1]
        tk_messageBox -message "si le fichier de routage du script POLYGAREA existe\ncandidat_dossier $candidat_dossier" -type ok
    }
    
    # A present, on a le choix entre candidat_dossier_CLIC et candidat_dossier
    if {$candidat_dossier_CLIC != "./"} {
        debug "Pas PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        # si le dossier_CLIC n'est pas le dossier en cours (CLIC_XX)
        set candidat_dossier $candidat_dossier_CLIC
        debug "Pas PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilise par POLYGAREA:\n"
        puts -nonewline $fid $candidat_dossier
        close $fid
        ] ici
    } else  {
        # sinon, on adopte le candidat_dossier
        debug "PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        set candidat_dossier_CLIC $candidat_dossier
        debug "PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        catch [
        set fid [open $route w+]
        puts -nonewline $fid "Dernier dossier de donnees:\n"
        puts -nonewline $fid $candidat_dossier_CLIC
        close $fid
        ] ici
    }
    
    #
    # On va chercher les donnees
    #
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
        {{"All Files"} {.*}}
    }
    set infile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
    
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    #
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
        # open le fichier de conf pour ecrire
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilisees par COEFFOU:\n"
        puts -nonewline $fid $dossier
        close $fid
        ] ici
        # open le fichier de conf pour ecrire
        catch [
        set fid [open $route w+]
        puts -nonewline $fid "Dernier dossier de donnees :\n"
        puts -nonewline $fid $dossier
        close $fid
        ] ici
    }
    #
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    #
    # --------------------------------------------------------
    # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE pop
    # --------------------------------------------------------
    return $infile
}
#
# Procedure CHEMIN - end


# Procedure OUVRIR (de VAR)
#
proc ouvrir {} {
    global p S data
    set typeList {
        {{"Text files"} {.seq .txt .nts .TXT .NTS .csv .CSV .tps .TPS} }
    }
    global infile texte dossier primeralinea
     
    # Chercher sa route dans un fichier de configuration:
    # il y en a un dans le dossier Polygon (chemin), et un dans le dossier CLIC (route)
    # 
    # dans le dossier Polygon
    set chemin "[pwd]/dossier_polygarea.txt"
    debug "pwd = [pwd]"
    # dans le dossier CLIC
    set route $S(dirclic)/dossier_CLIC.txt
    #
    # On lit d'abord le fichier dossier_CLIC, s'il existe
    # sinon
    # on lit le fichier du script, s'il existe
    #
    # 1. verifier que les fichiers de routage existent
    if {[file exists $route] == 0} {
        # dans le cas ou il n'y a pas de fichier de routage dans le dossier CLIC
        set candidat_dossier_CLIC [pwd]
        catch [
        set fid [open $route w+]
        puts -nonewline $fid "Dernier dossier de donnees:\n"
        puts -nonewline $fid [pwd]
        close $fid
        ] ici
    } else  {
        # 3. si le fichier de routage existe dans le dossier CLIC, reccueillir alors le dernier chemin parcouru
        # open le fichier pour lire
        catch [
        set fid [open $route r]
        set candidat_dossier_CLIC [read -nonewline $fid]
        close $fid
        ] ici
        set candidat_dossier_CLIC [lindex [split $candidat_dossier_CLIC \n] 1]
        #debug "\ndossier selon CLIC = $candidat_dossier_CLIC"
    }
    
    #debug "chemin $chemin"
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
        set candidat_dossier [pwd]
    } else  {
        # 3. si le fichier de routage du MODULE existe reccueillir le dernier chemin parcouru
        # open le fichier pour lire
        catch [
        set fid [open $chemin r]
        set candidat_dossier [read -nonewline $fid]
        close $fid
        ] ici
        set candidat_dossier [lindex [split $candidat_dossier \n] 1]
    }
    
    # A present, on a le choix entre candidat_dossier_CLIC et candidat_dossier
    if {$candidat_dossier_CLIC != "./"} {
        #debug "Pas PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        # si le dossier_CLIC n'est pas le dossier en cours (CLIC_XX)
        set candidat_dossier $candidat_dossier_CLIC
        #debug "Pas PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilise par POLYGAREA:\n"
        puts -nonewline $fid $candidat_dossier
        close $fid
        ] ici
    } else  {
        # sinon, on adopte le candidat_dossier
        #debug "PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        set candidat_dossier_CLIC $candidat_dossier
        #debug "PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        catch [
        set fid [open $route w+]
        puts -nonewline $fid "Dernier dossier de donnees:\n"
        puts -nonewline $fid $candidat_dossier_CLIC
        close $fid
        ] ici
    }
    
    
    # On va chercher les donnees ---------------------------------------
    #catch [
    set infile [tk_getOpenFile -initialdir $candidat_dossier -filetypes $typeList]
    set fid [open $infile]
    set texte [read -nonewline $fid]
    close $fid
    set S(infile) $infile
    #] ici
    
    # Enlever la premiere valeur si le fichier a ete cree par MOG
    # set seuil [trebuche]
    set seuil 1
    #debug "seuil $seuil"
    
    # ajoute pour tenter de supprimer les lignes vides
    #
    foreach line [split $texte \n] {
        if  {$line != ""} {
            append newtexte "$line\n"
        }
    }
    set datos ""
    set contador -1
    foreach item [split $newtexte "\n"] {
        if  {$item != ""} {incr contador}
        if {$contador > 0} {
            if  {$item != "" && $contador == $seuil || $contador > $seuil } {
                append datos "$item "
                #debug "contador $contador"
            }
        } else  {
            set primeralinea $item
        }
    }
    
    #debug "\n$primeralinea\n"
    
    #debug "\nNombre de données : $contador\n"
    
    
    #debug "\ndatos--------------- \n$datos\n ----------------\n"
    
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
        # open le fichier de conf pour ecrire
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilisees par POLYGAREA:\n"
        puts -nonewline $fid $dossier
        close $fid
        ] ici
    }
    #debug "chemin = $dirinfile"
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    #debug "\ntail = $tailfile"
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    #debug "root = $rootfile"
    
    #Verification du type de fichier --- debut
    if {[string first "_format" $infile] > 0 || [string first "_FORMAT" $infile] > 0} {set S(fichier_format) 1} else {set S(fichier_format) 0}
    if {$S(fichier_format) == 0} {
        set nm [tk_messageBox -message "[file tail $infile]\nThe name of your file does not suggest it contains landmark coordinates\
                do you want to continue ?" -icon warning -type yesno]
        if {$nm == no} {exit}
    }
    #Verification du type de fichier --- fin
    
    set data $datos
    return $newtexte
}
#
# procedure OUVRIR - fin



if 0 {Richard Suchenwirth 2004-07-23 - Given a convex polygon represented as {x y x y ...} list of its corner coordinates, I wanted to calculate its area. This is simple for the special case of the triangle, using the "Heronic formula":}

proc triangle'area coords {
    foreach {xa ya xb yb xc yc} $coords break
    set a [expr {hypot($yb-$yc, $xb-$xc)}]
    set b [expr {hypot($ya-$yc, $xa-$xc)}]
    set c [expr {hypot($ya-$yb, $xa-$xb)}]
    set s [expr {($a+$b+$c)/2.}]
    expr {sqrt($s*($s-$a)*($s-$b)*($s-$c))} ;# Heronic formula
}

if 0 {For the general polygon I devised this recursive approach, which de facto does a triangulation, by measuring the area between the first three points, and then calling itself with the second corner's coordinates removed from the list: }

proc area coords {
    expr {
        [llength $coords]<6? 0 :
        [triangle'area [lrange $coords 0 5]]
        + [area [lreplace $coords 2 3]]
    }
}

# SRIPT PRINCIPAL
global table
set datos [ouvrir]
debug "Dans l'ordre:\n - Input file content\n - La liste des aires \
        \n - La table des aires (pour l'enregistrer, utiliser le bouton SAVE)\
        \n\n(Utiliser le bouton WRAP pour lire plus vite)\
        \n\n\nInput file content: \n$datos"
set liste ""
set table ""
set compteur -1
foreach polygone [split $datos "\n"] {
    incr compteur
    if {$compteur > 0} {
        if {[llength $polygone] > 5} {
	    #debug "string first NA: [string first NA $polygone]"
	    set limite [expr {[string first NA $polygone]-1}]
	    if {$limite > -1} {
		set polygone [string range $polygone 0 $limite]
	    }
	    set polygone [string trimright $polygone]
	    set polygone [lrange [split $polygone \t] 3 end]
	    #while {[string first "NA" $polygone] > -1} {
	    #	   set polygone [string trimright $polygone "NA"]
	    #}
	    #debug "polygone $compteur \n$polygone"
            set surface [area $polygone]
            #debug "Objet No. $compteur, aire:\t $surface\n --- \n"
            append liste "$surface "
            append table "$surface\n"
        } 
    }
}
debug "\nSous forme de liste : \n\naires\n$liste"
debug "\nSous forme de \"tableau\" \
        \nPour l'enregistrer, utiliser le bouton SAVE\
        \nLe fichier correspondant peut alors etre compare\
        \navec celui des tailles en utilisant le module COV de CLIC\
        \n\[menu TWO MATRICES\]\
        \n\naires\
        \n$table"
