source 101La.tcl

# procedure DEBUG
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x600+205+66
        set memo [text .debug.t -wrap word -height 22 -font "courier 13" \
                -bg grey88 \
                -fg black\
                -tabs "3c left"\
                -yscrollcommand ".debug.v_scroll set" \
                -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
            if {$flag == 1} {
                .debug.t configure -wrap none
                set flag 0
            } else  {
                .debug.t configure -wrap word
                set flag 1
            }
        }
        
        #
        $memo insert end $bugatti
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG fin

# script principal -- prendre la racine carree de chaque element de cette matrice

set proDt " 2 2 4 1 2 10 20 30 40 24 56"
debug [show $proDt]
set compteur 0
set liste [vtrim $proDt]
foreach item $liste {
    #
    set liste [listassign $liste $compteur [expr {sqrt($item)}]]
    #
    incr compteur
    #
}
#
set proDt "2 [mrows $proDt] [mcols $proDt] $liste"
debug [show $proDt]
