# tentative -  On dispose des individus après translation -

# comments from
    # Rohlf & Slice, 1990. Extensions of the Procrustes Method for the optimal superimposition of landmarks. Syst. Zool., 39(1): 40-59

    # Rohlf & Slice, 1990. Extensions of the Procrustes Method for the optimal superimposition of landmarks. Syst. Zool., 39(1): 40-59
    #
    # TAILLES CENTROIDES --> LISTE 'liste_si' pour 'SCALED INDIVIDUALS'
    #
    for  {set i 0} {$i < [expr {$lignes+1}]} {incr i} {
    	# en notant que translated (), c'est imoinsp * x
    	set pre_tc [vdiag [mmult [mmult $translatedx($i) [transpose $x]] $imoinsp]]
    	set pre_tc "2 $lm 1 [vtrim $pre_tc]"
    	#debug "vdiag \n$pre_tc"
    	set pre_tc [lsum [vtrim $pre_tc]];# <- utiliser lsum????
    	#debug "lsum vdiag \n[show $pre_tc]"
    	set tc [expr {sqrt($pre_tc)}]
    	#debug "tc = $tc"
    	append liste_tc "$tc "
    	#debug $liste_tc
    	set si  [mscale $translatedx($i) [expr {1.0/$tc}]]
    	#si = scaled_indiv
    	#debug "si\n[show $si]"
    	append liste_si "$si \n"
    	#debug $liste_si
    }
    
    # ---------full Procrustes fit---- Rohlf & Slice, 1990 ------------
    #
    # Au bout de la boucle, le premier transcaled individu (X) devient Y, le consensus 
    # le premier individu, le voici donc:
    set prem_indiv [lindex [split $liste_si "\n"] 0];# hume matrix!
    #debug "prem indiv, first consensus estimate!\n[show $prem_indiv]"
    # -----------------------------------------------
    # step 2. p.44: Les autres (2,3,...n) sont basculés sur Y (rotation)
    # BOUCLE - least square fitting procedure -
    # -----------------------------------------------
    # on prend les composantes principales du consensus
    #set V [composantes $prem_indiv]
    #set prex1t [mmult $prem_indiv $V ];# Rohlf, 1990... "its PCA axes
    #debug "PCA axes of the 1st consensus estimate\n[show $prex1t]"
    #set x1t [transpose $prex1t]
    set prex1t $prem_indiv
    set x1t [transpose $prex1t]
    # Les "transcaled individuals" sont dans la liste "liste_si"
    for  {set i 1} {$i < [expr {$lignes+1}]} {incr i} {
    	set autre [lindex [split $liste_si "\n"] $i]
    	# on commence par le deuxième individu, car le premier a été choisi
    	# comme consensus
    	set ttrantran($i) [mmult $x1t $autre]
    	# SVD selon linalg, Maximum de 7 DECIMALES, pas plus!!
    	set Z $ttrantran($i)
    	set Z "[lrange $Z 0 2] [show $Z %8.7f]";# pas > 7 decimales
    	set Ztcllib [::math::linearalgebra::from_LA $Z]
    	set svd_tcllib [::math::linearalgebra::determineSVD $Ztcllib]
    	set U [::math::linearalgebra::to_LA [lindex $svd_tcllib 0]]
    	set S [::math::linearalgebra::to_LA [lindex $svd_tcllib 1]]
    	set V [::math::linearalgebra::to_LA [lindex $svd_tcllib 2]]
    	#debug "linalg V,\n[show $V]"
    	set S "2 2 2 1 0 0 1"
    	set H [mmult [mmult $V $S] $U];# Rohlf & Slice, 1990, p.42 (Gower, 1971)
    	set rot_si($i) [mmult $autre $H]
    	# rotated % the first consensus estimate
    	#debug "rotated si (rot_si)\n[show $rot_si($i)]"
    }
    set rot_si(0) $prex1t
    # check results
    # for {set i 0} {$i < $lignes} {incr i} {
    # 	debug $rot_si($i)
    # }

    # -----------------------------------------------
    # step 3. p.44: la moyenne du X1 (prem_indiv) et X' (les suivant) devient le nouveau Y
    # -----------------------------------------------
    set a $prex1t
    for  {set i 1} {$i < [expr {$lignes+1}] } {incr i} {
    	set mat_tot [madd $a $rot_si($i)]
    	set a $mat_tot
    }
    #debug "mat_tot \n[show $mat_tot]"
    set next_consensus [mscale $mat_tot [expr {1.0/$lignes}]]
    #set V [composantes $next_consensus];# il s'agit du consensus
    #set next_consensus [mmult $next_consensus $V ];# Rohlf, 1990
    #debug "next tentative consensus \n[show $next_consensus]"
    # -----------------------------------------------
    # step 4. p.44: Sr=n[expr {1-tr(Y[transpose Y])}];# cfr. convergence
    # -----------------------------------------------
    set YY [mmult $next_consensus [transpose $next_consensus]]
    #debug "YY' \n[show $YY]\ndiagonale [vdiag $YY]"
    set trYY [msum [vdiag $YY]]
    #debug "trYY \n$trYY et (1 - trYY) = [expr {(1 - $trYY)}]"
    set Sr [expr {$lignes * (1 - $trYY)}]
    #debug "Sr,\n$Sr"
    # -----------------------------------------------
    # step 5: 
    # -----------------------------------------------
    set rho 1
    #
    # -----------------------------------------------
    # step 6 <- BOUCLE - probablement basée sur Sr
    # -----------------------------------------------
    set test 1
    while {$test > 0.00000001 } { 
    	#
    	# boucle 6.1 X* = rho X' H (avec Gower H = VStU)
    	# --------------------------
    	# donc, avec X' <- transcaledindiv()
    	#debug "Y =\n[show $next_consensus]"
    	#set V [composantes $next_consensus];# il s'agit du consensus
    	#set prex1t [mmult $next_consensus $V ];# Rohlf, 1990
    	#debug "Y = prex1t = \n[show $prex1t]"
    	# # Rotations proprement dites (les autres individus sont basculés
    	# #           sur les composantes principales du 'next' consensus)
    	set prex1t $next_consensus
    	set x1t [transpose $prex1t]
    	set autre $next_consensus
    	#set autre $prex1t
    	for  {set i 0} {$i < $lignes} {incr i} {
    	    #
    	    #set ttrantran($i) [mmult $x1t $autre]
    	    set ttrantran($i) [mmult [transpose $autre] $autre]
    	    # SVD selon linalg, Maximum de 7 DECIMALES, pas plus!!
    	    set Z $ttrantran($i)
    	    set Z "[lrange $Z 0 2] [show $Z %8.7f]";# pas > 7 decimales
    	    set Ztcllib [::math::linearalgebra::from_LA $Z]
    	    set svd_tcllib [::math::linearalgebra::determineSVD $Ztcllib]
    	    set U [::math::linearalgebra::to_LA [lindex $svd_tcllib 0]]
    	    set S [::math::linearalgebra::to_LA [lindex $svd_tcllib 1]]
    	    set V [::math::linearalgebra::to_LA [lindex $svd_tcllib 2]]
    	    #debug "linalg V,\n[show $V]"
    	    set S "2 2 2 1 0 0 1"
    	    set H [mmult [mmult $V $S] $U];# Rohlf & Slice, 1990, p.42 (Gower, 1971)
    	    set rot_si($i) [mmult $autre $H];# rotated % the first consensus estimate
    	    set autre $rot_si([expr {$i+1}])
    	    #debug "autre \n[show $autre]"
    	}
    	#
    	# boucle 6.2 Y* = mean of X*
    	# --------------------------
    	set a $rot_si(0)
    	for  {set i 0} {$i < [expr {$lignes+1}] } {incr i} {
    	    set mat_tot [madd $a $rot_si($i)]
    	    set a $mat_tot
    	}
    	set next_consensus [mscale $mat_tot [expr {1.0/$lignes}]]
    	#set V [composantes $next_consensus];# il s'agit du consensus
    	#set next_consensus [mmult $next_consensus $V ];# Rohlf, 1990
    	debug "next_consensus \n[show $next_consensus]"
    	#
    	# boucle 6.3 X** = rho**/rho X*
    	# -----------------------------
    	#une boucle sur chaque individu pour calculer 'rhostar_rho * individu'
    	set Y $next_consensus
    	set YY [mmult $Y [transpose $Y]]
    	set trYY [msum [vdiag $YY]]
    	for {set i 0} {$i<$lignes} {incr i} {
    	    set X $rot_si($i)
    	    #
    	    set XY [mmult $X [transpose $Y]]
    	    set trXY [msum [vdiag $XY]]
    	    #
    	    set XX [mmult $X [transpose $X]]
    	    set trXX [msum [vdiag $XX]]
    	    #
    	    set rhostar_rho [expr {sqrt($trXY * 1.0/($trXX*$trYY))}]
    	    set rhostar [expr {$rhostar_rho * $rho}]
    	    set rot_si($i)  [mscale $X $rhostar_rho]
    	    #debug "rot_si($i) \n[show $rot_si($i)]"
    	}  
    	# boucle 6.4 
    	# ----------
    	# next estimate of the consensus
    	set a $rot_si(0)
    	for  {set i 1} {$i < [expr {$lignes+1}] } {incr i} {
    	    set mat_tot [madd $a $rot_si($i)]
    	    set a $mat_tot
    	}
    	set next_consensus [mscale $mat_tot [expr {1.0/$lignes}]]
    	#set V [composantes $next_consensus];# il s'agit du consensus
    	#set next_consensus [mmult $next_consensus $V ];# Rohlf, 1990
    	debug "next estimate of the consensus \n[show $next_consensus]"
    	# boucle 6.5 
    	# ----------
    	# new residual sum of squares
    	set YY [mmult $next_consensus [transpose $next_consensus]]
    	#debug "YY' \n[show $YY]\n\ndiagonale [vdiag $YY]"
    	set trYY [msum [vdiag $YY]]
    	#debug "trYY \n$trYY et (1 - trYY) = [expr {(1 - $trYY)}]"
    	set newSr [expr {$lignes * (1 - $trYY)}]
    	debug "new Sr,\n$newSr"
    	# boucle 6.6 
    	# ----------
    	set rho $rhostar
    	#
    	set test [expr {$Sr - $newSr}]
    	debug "test = $test"
    	set Sr $newSr
    }
    #
    type "fini"
    # set V [composantes $YY];# il s'agit du consensus
    # for {set i 0} {$i<$lignes} {incr i} {
    #     set rot_si($i) [mmult [transpose $rot_si($i)] $V]
    # }
    # for {set i 0} {$i<$lignes} {incr i} {
    #     debug "[expr {$i+1}]:\n[show $rot_si($i)]"
    # }
    for {set i 0} {$i<$lignes} {incr i} {
    	append full  [vtrim $rot_si($i)]
    	append full "\n"
    }
    set hume "2 $lignes [expr {$lm*2}] "
    set full_mat "$hume $full"
    debug "full fit \n[show $full_mat]";# COMPARER AVEC R
    # set full_acp [acp $full_mat]
    # debug "full acp \n$full_acp"
    #
    # tentative (réussie!? CTR from Rohlf & Slice, 1990. etc. - fin
    #
    # --------------------------------------------------------------
