
# Procedure FULLFIT
#
# appelée par ... 
#
proc fullfit {lm} {
    # comments from
    # Rohlf & Slice, 1990. Extensions of the Procrustes Method for the optimal superimposition of landmarks. Syst. Zool., 39(1): 40-59
    global  p grandp imoinsp rawindividus effectifs_mog tablind polygone
    global suit_tran suit_cons nosi suit_rot susnesnoc references
    set susnesnoc 0
    set nosi 0
    #
    set mmm [llength $rawindividus]
    set lignes [expr {$mmm/$lm}]
    if {[info exists suit_tran] == 0} {$p insert end "\n\nTRANSLACION de los OBJETOS sobre UN mismo CENTROIDE\n"}
    if {[info exists objet_cons]} {unset objet_cons}
    set suit_cons 0
    # Matrices I, P, I-P
    set identite [mident $lm];# a pxp identity matrix
    set unsurp [expr {1.0/$lm}]
    set grandp "2 $lm $lm"
    for {set i 0} {$i < [expr {$lm*$lm}]} {incr i} {
        append grandp " $unsurp";# a pxp matrix whith all elements equal to 1/p
    }
    set imoinsp [msub $identite $grandp];# I - P
    
    # Translation ou pre-multiplication des matrices par I-P
    global translatedx
    for  {set i 0} {$i < [expr {$lignes+1}]} {incr i} {
        set x "2 $lm 2 $tablind($i)"
        set translatedx($i) [mmult $imoinsp $x];# (I - P)X
        if {[info exists suit_tran] == 0} {$p insert end "\nTranslated matrix object $i \n[show $translatedx($i)]\n"}
    }
    # tentative CTR from
    # Rohlf & Slice, 1990. Extensions of the Procrustes Method for the optimal superimposition of landmarks. Syst. Zool., 39(1): 40-59
    for  {set i 0} {$i < [expr {$lignes+1}]} {incr i} {
	set pre_tc [vdiag [mmult [mmult $translatedx($i) [transpose $x]] $imoinsp]]
	set pre_tc "2 $lm 1 [vtrim $pre_tc]"
	#debug "vdiag \n$pre_tc"
	set pre_tc [lsum [vtrim $pre_tc]];# <- utiliser lsum????
	#debug "lsum vdiag \n[show $pre_tc]"
	set tc [expr {sqrt($pre_tc)}]
	#debug "tc = $tc"
	append liste_tc "$tc "
	#debug $liste_tc
	set si  [mscale $translatedx($i) [expr {1.0/$tc}]];#si = scaled_indiv
	#debug "si\n[show $si]"
	append liste_si "$si \n"
	#debug $liste_si
    }
    #
    # ---------full Procrustes fit---- Rohlf & Slice, 1990 ------------------------
    #
    # Au bout de la boucle, le premier transcaled individu (X) devient Y, le consensus 
    # le premier individu
    set prem_indiv [lindex [split $liste_si "\n"] 0];# hume matrix!
    debug "prem indiv\n[show $prem_indiv]"
    # -----------------------------------------------
    # step 2. p.44: Les autres (2,3,...n) sont basculés sur Y (rotation) BOUCLE
    # -----------------------------------------------
    set V [composantes $prem_indiv];# il s'agit du consensus de départ
    set prex1t [mmult $prem_indiv $V ];# Rohlf, 1990
    set x1t [transpose $prex1t]
    # Les "transcaled individuals" sont ici dans la liste "liste_si"
    for  {set i 1} {$i < [expr {$lignes+1}]} {incr i} {
	set autre [lindex [split $liste_si "\n"] $i]
	set ttrantran($i) [mmult $x1t $autre]
	# singular value decomposition
	set U $ttrantran($i)
	msvd_br U S V
	#set S "2 2 2 1 0 0 1"
	#set H [mmult [mmult $V $S] $U];# Rohlf & Slice, 1990, p.42 (Gower, 1971)
	set H [mmult $V [transpose $U]];# Julien C.
	set rot_si($i) [mmult $autre $H];# rotated % the first consensus estimate
	#debug "rotated si (rot_si)\n[show $rot_si($i)]"
    }
    # -----------------------------------------------
    # step 3. p.44: la moyenne du X1 (prem_indiv) et X' (les suivant) devient le nouveau Y
    # -----------------------------------------------
    set a $prem_indiv
    for  {set i 1} {$i < [expr {$lignes+1}] } {incr i} {
	set mat_tot [madd $a $rot_si($i)]
	set a $mat_tot
    }
    #debug "mat_tot \n[show $mat_tot]"
    set next_consensus [mscale $mat_tot [expr {1.0/$lignes}]]
    debug "next tentative consensus \n[show $next_consensus]"
    # -----------------------------------------------
    # step 4. p.44: Sr = n [expr {1 - tr(Y[transpose Y]) }];# cfr. convergence
    # -----------------------------------------------
    set YY [mmult $next_consensus [transpose $next_consensus]]
    debug "YY' \n[show $YY]\ndiagonale [vdiag $YY]"
    set trYY [msum [vdiag $YY]]
    debug "trYY \n$trYY et (1 - trYY) = [expr {(1 - $trYY)}]"
    set Sr [expr {$lignes * (1 - $trYY)}]
    debug "Sr,\n$Sr"
    # -----------------------------------------------
    # step 5: 
    # -----------------------------------------------
    set rho 1
    #
    # -----------------------------------------------
    # step 6 <- BOUCLE - probablement basée sur Sr
    # -----------------------------------------------
    set test 1
    while {$test > 0.001 } { 
	#
	# boucle 6.1 X* = rho X' H (avec Gower H = VStU)
	# --------------------------
	# donc, avec X' <- transcaledindiv()
	set V [composantes $next_consensus];# il s'agit du consensus
	set prex1t [mmult $next_consensus $V ];# Rohlf, 1990
	# ###Rotations proprement dites (les autres individus sont basculés
	# sur les composantes principales du 'next' consensus)
	set x1t [transpose $prex1t]
	set autre $next_consensus
	for  {set i 1} {$i < $lignes} {incr i} {
	    #
	    set ttrantran($i) [mmult $x1t $autre]
	    # singular value decomposition
	    set U $ttrantran($i)
	    msvd_br U S V
	    set S "2 2 2 1 0 0 1"
	    set H [mmult [mmult $V $S] $U];# Rohlf & Slice, 1990, p.42 (Gower, 1971)
	    set rot_si($i) [mmult $autre $H];# rotated % the first consensus estimate
	    set autre $rot_si([expr {$i+1}])
	    #debug "autre \n[show $autre]"
	}
	#
	# boucle 6.2 Y* = mean of X*
	# --------------------------
	set rot_si(0) $next_consensus
	set a $next_consensus
	for  {set i 0} {$i < [expr {$lignes+1}] } {incr i} {
	    set mat_tot [madd $a $rot_si($i)]
	    set a $mat_tot
	}
	set next_consensus [mscale $mat_tot [expr {1.0/$lignes}]]
	debug "next_consensus \n[show $next_consensus]"
	#
	# boucle 6.3 X** = rho**/rho X*
	# -----------------------------
	#une boucle sur chaque individu pour calculer 'rhostar_rho * individu'
	set Y $next_consensus
	set YY [mmult $Y [transpose $Y]]
	set trYY [msum [vdiag $YY]]
	for {set i 0} {$i<$lignes} {incr i} {
	    set X $rot_si($i)
	    #
	    set XY [mmult $X [transpose $Y]]
	    set trXY [msum [vdiag $XY]]
	    #
	    set XX [mmult $X [transpose $X]]
	    set trXX [msum [vdiag $XX]]
	    #
	    set rhostar_rho [expr {sqrt($trXY * 1.0/($trXX*$trYY))}]
	    set rhostar [expr {$rhostar_rho * $rho}]
	    set rot_si($i)  [mscale $X $rhostar_rho]
	    #debug "rot_si($i) \n[show $rot_si($i)]"
	}  
	# boucle 6.4 
	# ----------
	# next estimate of the consensus
	set a $rot_si(0)
	for  {set i 1} {$i < [expr {$lignes+1}] } {incr i} {
	    set mat_tot [madd $a $rot_si($i)]
	    set a $mat_tot
	}
	set next_consensus [mscale $mat_tot [expr {1.0/$lignes}]]
	debug "next estimate of the consensus \n[show $next_consensus]"
	# boucle 6.5 
	# ----------
	# new residual sum of squares
	set YY [mmult $next_consensus [transpose $next_consensus]]
	debug "YY' \n[show $YY]\n\ndiagonale [vdiag $YY]"
	set trYY [msum [vdiag $YY]]
	debug "trYY \n$trYY et (1 - trYY) = [expr {(1 - $trYY)}]"
	set newSr [expr {$lignes * (1 - $trYY)}]
	debug "new Sr,\n$newSr"
	# boucle 6.6 
	# ----------
	set rho $rhostar
	#
	set test [expr {$Sr - $newSr}]
	debug "test = $test"
	set Sr $newSr
    }
    #
    #
    # tentative (réussie!) CTR from Rohlf & Slice, 1990... etc. --- fin
}
