
package require Tk

cd [file dirname [info script]]
#
global S
set S(dirscript) [pwd]
# attention, il n'y a pas de "/" a la fin du nom du dossier du script 
# (utiliser "file join etc")
#
cd ..
set S(dirclic) [pwd]
cd $S(dirscript)

set version "gpa 01"

########################################################################
# Select
# Copyright ©  2005 Dujardin J.-P. dujardin@mpl.ird.fr
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
########################################################################

set tcl_precision 14

set dossier [pwd]
#
source chull.tcl
source [file join $S(dirclic) "+/101La.tcl"]
source [file join $S(dirclic) "+/math/statistics.tcl"]
source [file join $S(dirclic) "+/math/math.tcl"]
source [file join $S(dirclic) "+/math/optimize.tcl"]
source [file join $S(dirclic) "+/math/linalg.tcl"]
source [file join $S(dirclic) "+/jpdraw_15.tcl"]
source ballons.tcl


# procedure TYPE_YN -start
#
proc type_yn {message} {
    set mmm [tk_messageBox -message $message -type yesno]
    return $mmm
}
#
# procedure TYPE_YN -start


# procedure TYPE
#
proc type {message} {
    tk_messageBox -message $message -type ok
}
#
# procedure TYPE


# procedure DEBUG
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x600+205+66
        set memo [text .debug.t -wrap none -height 22 -font courier \
		      -bg grey88 \
		      -fg black\
		      -tabs "3c left"\
		      -yscrollcommand ".debug.v_scroll set" \
		      -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
            if {$flag == 1} {
                .debug.t configure -wrap none
                set flag 0
            } else  {
                .debug.t configure -wrap word
                set flag 1
            }
        }
        #
        $memo insert end $bugatti
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG fin


# Procedure CHEMIN -start
#
proc chemin {} {
    
    global p S dossier
    
    if {[info exists dirinfile] == 0} {
        set dirinfile [pwd]
    }
    
    # ----------------------------------------------------
    # Nom du FICHIER et son CHEMIN (path) CORRESPONDANT
    # ---------------------------------------------------
    # Chercher sa route dans un fichier de configuration: il y en a un dans le dossier MOG (chemin), et un dans le dossier CLIC (route)
    # dans le dossier MOG
    set chemin "[pwd]/dossier_cov.txt"
    # dans le dossier CLIC
    set route $S(dirclic)/dossier_CLIC.txt
    #
    # On lit d'abord le fichier dossier_CLIC, s'il existe
    # sinon
    # on lit le fichier du script, s'il existe
    #
    # 1. verifier que les fichiers de routage existent
    if {[file exists $route] == 0} {
        # dans le cas ou il n'y a pas de fichier de routage dans le dossier CLIC
        set candidat_dossier_CLIC [pwd]
        catch [
	       set fid [open $route w+]
	       puts -nonewline $fid "Dernier dossier de donnees:\n"
	       puts -nonewline $fid [pwd]
	       close $fid
	      ] ici
    } else  {
        # 3. si le fichier de routage existe dans le dossier CLIC, reccueillir alors le dernier chemin parcouru
        # open le fichier pour lire
        catch [
	       set fid [open $route r]
	       set candidat_dossier_CLIC [read -nonewline $fid]
	       close $fid
	      ] ici
        set candidat_dossier_CLIC [lindex [split $candidat_dossier_CLIC \n] 1]
        #debug "\ndossier selon CLIC = $candidat_dossier_CLIC"
    }
    #
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
        set candidat_dossier [pwd]
    } else  {
        # 3. si le fichier de routage du MODULE existe reccueillir le dernier chemin parcouru
        # open le fichier pour lire
        catch [
	       set fid [open $chemin r]
	       set candidat_dossier [read -nonewline $fid]
	       close $fid
	      ] ici
        set candidat_dossier [lindex [split $candidat_dossier \n] 1]
    }
    
    # A present, on a le choix entre candidat_dossier_CLIC et candidat_dossier
    if {$candidat_dossier_CLIC != "./"} {
	# si le dossier_CLIC n'est pas le dossier en cours (CLIC_XX)
        set candidat_dossier $candidat_dossier_CLIC
	catch [
	       set fid [open $chemin w+]
	       puts -nonewline $fid "Dernier dossier de donnees utilise par COV:\n"
	       puts -nonewline $fid $candidat_dossier
	       close $fid
	      ] ici
    } else  {
        # sinon, on adopte le candidat_dossier
	set candidat_dossier_CLIC $candidat_dossier
	catch [
	       set fid [open $route w+]
	       puts -nonewline $fid "Dernier dossier de donnees:\n"
	       puts -nonewline $fid $candidat_dossier_CLIC
	       close $fid
	      ] ici
    }
    
    # On va chercher les donnees
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
        # open le fichier de conf pour ecrire
        catch [
	       set fid [open $chemin w+]
	       puts -nonewline $fid "Dernier dossier de donnees utilisees par COV:\n"
	       puts -nonewline $fid $dossier
	       close $fid
	      ] ici
        # open le fichier de routage pour ecrire
        catch [
	       set fid [open $route w+]
	       puts -nonewline $fid "Dernier dossier de donnees :\n"
	       puts -nonewline $fid $dossier
	       close $fid
	      ] ici
    }
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    # --------------------------------------------------------
    # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE pop
    # --------------------------------------------------------
    return $infile
}
#
# Procedure CHEMIN - end


# Procedure LOADFILE # debut
#
# this LOADFILE opens the input file of MOG
#
proc loadfile {pathname} {
    global references premligne colcount rowcount S
    #
    # LECTURE DU FICHIER - debut
    set fid [open $pathname]
    set text [read -nonewline $fid]
    close $fid
    # LECTURE DU FICHIER - fin
    
    set rowcount 0
    set colcount 0
    
    set compteur 0
    set lignes 0
    set datos ""
    foreach line [split $text \n] {
        #
        if  {[llength $line] > 0} {
            incr compteur
	    if {$compteur > 1} {
                # SI CE N'EST PAS LA PREMIERE LIGNE
                if  {[llength $line] > 0} {
                    # SI LA LIGNE N'EST PAS VIDE
                    set colcount [llength $line]
                    #
                    foreach item [split $line] { if {$item != ""} {
			incr lignes
			append datos "[string trim $item]\t"
		    }
                    }
                    #
                    if {[expr {$lignes/$colcount}] != [expr {$compteur-1}] } {
                        # SI UNE DONNEE MANQUE
                        if {[info exists ici] == 0} {set ici [expr {$compteur-1}]}
                    }
                } else  {
                    incr compteur -1
		}
            } else {
                set references $line
            }
        }
    }
    
    if {[info exists ici]} {
        puts "<p> Missing data near row $ici? </p>"
    }
    
    set rowcount [expr {$lignes * 1/$colcount}]
    set result [concat 2 $rowcount $colcount $datos]

    set premligne $references

    # -- Formater le commentaire -- Enlever d'eventuelles tabulations
    foreach mot $references {
        if {$mot != ""} {
            append comentario_sin_tab "$mot "
        }
    }
    set references $comentario_sin_tab
    #
    # Le LOADFILE de COV ajoute: set S(references) $references
    #
    # -- FIN du formatage de la premiere ligne
    
    return $result;# C'est une matrice de  HUME qui est retournee
}
#
# Procedure LOADFILE # fin


# Procedure WHICHMATRIX - start
#
# silent WHICHMATRIX
#
proc whichmatrix {} {
    global p S infile dossier
    #
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile [chemin];# usage de la procedure CHEMIN : memoire des dossiers anterieurs
    #
    if {$infile != ""} {
        set x [loadfile $infile]; # usage de la procedure LOADFILE
    } else  {
        set cancelar [tk_messageBox -message "You did not select a file" -type abortretryignore]
        switch -- $cancelar {
            abort {exit}
            retry {whichmatrix}
            ignore {}
        }
    }
    return $x
}
#
# Procedure WHICHMATRIX - end


# Procedure TRANSLATION <- COL OK
#
proc translation {rawcoord} {
    global grandp imoinsp tablind
    global references

    set lignes [mrows $rawcoord]
    set lm [expr {[mcols $rawcoord]*1/2}]
    set rawcoordXY [transpose $rawcoord]
    set suit_cons 0
    # Matrices I, P, I-P
    set identite [mident $lm];# a pxp identity matrix
    set unsurp [expr {1.0/$lm}]
    set grandp "2 $lm $lm"
    for {set i 0} {$i < [expr {$lm*$lm}]} {incr i} {
	append grandp " $unsurp";# a pxp matrix whith all elements equal to 1/p
    }
    set imoinsp [msub $identite $grandp];# I - P
    #
    # Translation ou pre-multiplication des matrices individuelles par I-P
    global translated
    for  {set i 0} {$i < [expr {$lignes+1}]} {incr i} {
	set x "2 $lm 2 $tablind($i)"
	set translatedx($i) [mmult $imoinsp $x];# (I - P)X
	if {$i > 0} {append translated "[vtrim $translatedx($i)] "}
	# en effet, tablind(0) c'est le consensus
    }
    #
    set retour "2 [mrows $rawcoord] [mcols $rawcoord] $translated"
    return $retour
}
#
# Procedure TRANSLATION - end



# Procedure SCALING - debut
#
proc scaling {x} {

    global imoinsp;# pourrait etre reconstruit ici

    # x = individus après translation, matrice de Hume

    # Aout 2006 Mise a zero des variables d'accumulation
    set transcaledtotal ""
    set centroide ""
    set tailles_base ""
    set consensus 0
    #
    set lignes [mrows $x]
    set lm [expr {[mcols $x] * 1/2}]

    # création de translatedx() <- pourrait etre une variable globale
    for {set i 0} {$i < $lignes} {incr i} {
	set translatedx($i) [mrange $x 0 end $i $i]
	set translatedx($i) "2 $lm 2 [vtrim $translatedx($i)]"
    }
    # translatedx();# contient les coordonnees de chaque individu (lm X col) apres translation - c'est une variable monoindicee (une matrice de deux colonnes)
    #
    # Scaling to unit centroid size
    #
    for  {set i 0} {$i < [expr {$lignes+0}]} {incr i} {
	# le translated consensus n'est pas corrigé ici" 
	set ttranslatedx($i) [transpose $translatedx($i)]
	set prectr [mmult $translatedx($i) $ttranslatedx($i)]
	set proctr [mmult $prectr $imoinsp]
	set presquectr [transpose $proctr]
	# La taille centroide elevee au carre est la trace de presquectr
	set prectr2 [vdiag $presquectr]
	set proctr2 [vtrim $prectr2]
	set ctr2 0
	foreach item $proctr2 {set ctr2 [expr {$ctr2+$item}]}
	set ctr [expr {sqrt($ctr2)}]
	set centroid($i) $ctr
	append mctr "$ctr ";# pour construire la matrice
	set scalefactor [expr {1.00000/$ctr}]
	set transcaledindiv($i) [mscale $ttranslatedx($i) $scalefactor]
	set transcaledindiv($i) [transpose $transcaledindiv($i)]
	#debug "B/ $transcaledindiv($i)"
	append transcaled "[vtrim $transcaledindiv($i)] "
    }
    set retourA "2 [mrows $x] [mcols $x] $transcaled"
    set retourB "2 [mrows $x] 1 $mctr"
    return [list $retourA $retourB]
}
#
# Procedure SCALING - fin

# BASCULE - fin

# BASCULE_INDIVIDUELLE - debut
#
# les objets à basculer sont dans LES ARGUMENTS
#
proc bascule_individuelle {objet prex1t} {
    # objet et prex1t sont deux objets sous forme de x,y matrices
    # #
    set x1t [transpose $prex1t]; #puts "prex1t \n[show $prex1t]"
    set ttrantran [mmult $x1t $objet]
    # Maximum 7 DECIMALES, pas plus!!
    set Z $ttrantran
    #set Z "[lrange $Z 0 2] [show $Z %8.7f]";# pas > 7 decimales
    set Ztcllib [::math::linearalgebra::from_LA $Z]
    set svd_tcllib [::math::linearalgebra::determineSVD $Ztcllib]
    set U [::math::linearalgebra::to_LA [lindex $svd_tcllib 0]]
    set S [::math::linearalgebra::to_LA [lindex $svd_tcllib 1]];#single values?
    set V [::math::linearalgebra::to_LA [lindex $svd_tcllib 2]];#eigenvectors?
    set S "2 2 2 1 0 0 1"
    #set H [mmult [mmult $V $S] $U];# Rohlf & Slice, 1990, p.42 (Gower, 1971)
    set H [mmult $V [transpose $U]];#fonction pPsup de R Julien C.
    return [mmult $objet $H];#aligned individual
}
#
# Procedure BASCULE_INDIVIDUELLE - fin

# Procedure IT2A --- début
#
proc it2a {lm nbind cons_actuel} {
    #
    update
    flush stdout
    #
    global S rot diff_precedent
    set k 2
    #
    # Vectoriser la matrice consensus actuelle (en fait une moyenne) pour creer une amorce
    set cons_actuel_vect "2 1 [expr {$k*$lm}] [vtrim $cons_actuel]"
    set amorce $cons_actuel_vect
    # accumuler les configurations basculées, pour le calcul des distances
    # oui mais il faut vectoriser les bascules pour cette matrice totale
    set basc [join_rows $amorce "2 1 [expr {$k*$lm}] [vtrim $rot(0)]"]
    for {set i 1} {$i < $nbind} {incr i} { 
	set basc [join_rows $basc "2 1 [expr {$k*$lm}] [vtrim $rot($i)]"]
    }
    #
    # Enlever l'amorce, pour le calcul correct des distances
    set basc [mrange $basc 0 end 1 end];# "Individus bascules \n[show $basc]"
    # la matrice basc correspond un peu a 'temp1'
    
    # calcul de la distance de Procrustes avec le consensus
    # (l'ancien, puis le nouveau)
    #
    # Une boucle pour la somme de pd avec le consensus actuel ('cons_actuel')
    #
    set sum_pdactuel 0
    for {set i 0} {$i < $nbind} {incr i} {
	set cfg [mrange $basc 0 end $i $i];#cfg, pour configuration
	set pd [expr {[dotprod [msub $cfg $cons_actuel_vect] [msub $cfg $cons_actuel_vect]]}]
	set sum_pdactuel [expr {$sum_pdactuel + $pd}]
    }
    #
    # --------------------------------------------------------------------
    # pour creer de nouveaux basculés, il faut que chaque config à basculer soit retirée et le cons calculé sur le reste (total symbolique 'abcde')
    # ------------------------------------------------------------------
    #
    # calcul du consensus pour basculer le PREMIER individu (de 'b' à 'e', sans 'a')
    #
    set be [mrange $basc 0 end 1 end];# toutes les lignes, sauf la première
    set cons_nouv [mrange [mnorms $be] 0 end 0 0];# LA MOYENNE DES BASCULES
    set pre_basc_moy [join_rows $amorce $cons_nouv]
    #
    # --------ROTATION-------------bascule ppt dite -------it2a---------
    # 
    set cons "2 $lm $k [vtrim $cons_nouv]"; # "Nouv cons \n[show $cons_nouv]"
    set objet "2 $lm $k [vtrim [mrange $basc 0 end 0 0]]"
    set rot(0) [bascule_individuelle $objet $cons]
    # 
    # -------ROTATION-------appel à la bascule ppt dite-----it2a--------
    # 
    #
    # calcul des consensus pour basculer les autres, sauf le dernier
    #
    for {set i 1} {$i < [expr {$nbind-1}]} {incr i} {
	set ab [mrange $basc 0 end 0 [expr {$i-1}]]
	set de [mrange $basc 0 end [expr {$i+1}] end]
	# le 'c' de 'abcde' est skippée
	set basc_moins [join_rows $ab $de]
	set cons_nouv [mrange [mnorms $basc_moins] 0 end 0 0]
	set pre_basc_moy [join_rows $pre_basc_moy $cons_nouv]
	# -----------------------bascule ppt dite------------------
	set cons "2 $lm $k [vtrim $cons_nouv]"; #puts "Nouv cons \n[show $cons_nouv]"
	set objet "2 $lm $k [vtrim [mrange $basc 0 end $i $i]]"
	set rot($i) [bascule_individuelle $objet $cons]
	# ----------------appel à la bascule ppt dite--------------
    }
    #
    # calcul du consensus pour basculer le DERNIER individu (de 'a' à 'd', sans 'e')
    #    
    set ad [mrange $basc 0 end 0 [expr {$nbind-2}]];#toutes les lignes, sauf la dernière
    set cons_nouv [mrange [mnorms $ad] 0 end 0 0]
    set pre_basc_moy [join_rows $pre_basc_moy $cons_nouv]
    # ----------appel à la bascule ppt dite----------------------
    set cons "2 $lm $k [vtrim $cons_nouv]"; #puts "Nouv cons \n[show $cons_nouv]"
    set objet "2 $lm $k [vtrim [mrange $basc 0 end end end]]"
    set rot([expr {$nbind-1}]) [bascule_individuelle $objet $cons]
    #-----------appel à la bascule ppt dite-------------------
    #
    # accumuler les configurations nouvellement basculées, pour le calcul des distances; oui mais il faut vectoriser les nouvelles bascules
    set basc_nouv [join_rows $amorce "2 1 [expr {$k*$lm}] [vtrim $rot(0)]"]
    for {set i 1} {$i < $nbind} {incr i} { 
	set basc_nouv [join_rows $basc_nouv "2 1 [expr {$k*$lm}] [vtrim $rot($i)]"]
    }
    # Enlever l'amorce, pour le calcul correct des distances
    set basc_nouv [mrange $basc_nouv 0 end 1 end];
    #debug "\nIndividus bascules \n[show $basc]"
    # la matrice basc correspond un peu a 'temp2'
    #
    # le calcul des distances se fait par rapport à la configuration de reference 
    set basc_nouv_moy [mrange [mnorms [mrange $pre_basc_moy 0 end 1 end]] 0 end 0 0]
    set sum_pdnouveau 0
    for {set i 0} {$i < $nbind} {incr i} {
	set cfg [mrange $basc_nouv 0 end $i $i];#cfg, pour un objet
	set pd [expr {[dotprod [msub $cfg $basc_nouv_moy] [msub $cfg $basc_nouv_moy]]}]
	set sum_pdnouveau [expr {$sum_pdnouveau + $pd}]
    }
    set diff_precedent [expr {abs($sum_pdactuel - $sum_pdnouveau)}]
    #debug "Procedure IT2A: actuel-nouveau = $sum_pdactuel - $sum_pdnouveau = $diff_precedent"
    append S(sum_pd) "$sum_pdnouveau "
    #debug "\nNew sum of Procrustes distances to mean shape: $sum_pdnouveau\nConvergence = $diff_precedent"
    update
    flush stdout
    #$p see end
    return [list $diff_precedent $basc_nouv_moy $basc]
}
#
# Procedure IT2A --- fin


# Procedure ROTATION ## debut ### the one
#
proc rotation {x} {
    
    # x matrice de Hume individus transcaled
    
    global consensus objet_cons
    global p infile 
    global reference consensus objet_cons
    global references
    global prex1t rot indivmoy
    
    set lignes [mrows $x]
    set lm [expr {[mcols $x] *1/2}]
    
    set consensus 0
    
    set indivmoy 0;#pour ne pas repeter les rapports du bouton jpdraw/moyens
    
    # création de transscaledx() <- pourrait etre une variable globale
    for {set i 0} {$i < $lignes} {incr i} {
	set transcaledx($i) [mrange $x 0 end $i $i]
	set transcaledx($i) "2 $lm 2 [vtrim $transcaledx($i)]"
    }
    # transcaledx();# contient les coordonnees de chaque individu (lm X col) apres translation et scaling - c'est une variable monoindicee (une matrice de deux colonnes)
    #
    set prex1t $transcaledx(1);# <- ne change rien aux résultats?
#
    # transfert des transcaled, tels quels, dans la variable indicée globale rot()
    for  {set i 0} {$i < $lignes} {incr i} {
	set rot($i) $transcaledx($i)
    }
    # -------------------------ITERATIONS TO ALIGNED ----------------
    #
    set tolerance 0.0000001
    set diff_precedent 0
    set k 2;# en deux dimensions l'image!
    # à ce stade, les objets sont en réalités les transcaled objets
    # diff_precedent = variable globale indispensable pour arreter l'iteration
    
    set seuil [it2a $lm $lignes $prex1t];
    #prex1t etait l'ACP de transcaled(0), la moyenne des transcaled, à présent c'est le premier transcaled objet 
    # seuil (le return de 'it2a') est une liste qui contient
    # 1. la différence (au départ, avec zero)
    # 2. la nouvelle moyenne (elle sera la moyenne des individus basculés sur le premier transcaled objet, et ensuite sur les moyennes successives)
    # 3. les individus basculés ('rotated objects')

    #it2a
    while {[lindex $seuil 0] > $tolerance} {
    	global rot
    	set m  [lindex $seuil 1]
    	set mb "2 $lm $k [vtrim $m]";#puts "nouvelle moyenne \n[show $mb]"
    	set seuil [it2a $lm $lignes $mb];#la moyenne des basculés en colonnes x,y
    }
    # on a fini la rotation, retourner les bascules et le dernier consensus
    # -------------------------ITERATIONS TO ALIGNED-----------------
    #
    #
    set prex1t "2 $lm $k [vtrim [lindex $seuil 1]]"
    # if {[info exists suit_rot] == 0} {
    #     debug  "\nProcedure ROTATION\nLast consensus, \n\n[show $prex1t %1.4f]\n"
    # }
    #
    # ------ les aligned dans rot() --- le consensus dans prex1t ----
    #
    # Return deplace ci-dessous en fev. 2005 (ci-dessus unreachable !)
    set rotated [lindex $seuil 2]
    #debug "rotated from seuil $rotated] <-"
    return $rotated
}
#
### Procedure rotation ## FIN



# ---------------------------------------------------------
# - - - - - - - - - - SCRIPT PRINCIPAL - - - - - - - - - - 
# ---------------------------------------------------------

# On va chercher les donnees
set mdonnees [whichmatrix]

# On chipote, c'est vieux, pas le temps de reprendre tout ca
set donnees [lrange $mdonnees 3 end]
set lignes [mrows $mdonnees]
set colonnes [mcols $mdonnees]
set data ""
for  {set i 0} {$i < [expr {$lignes * $colonnes}]} {incr i $colonnes} {
    set tranche [lrange $donnees $i [expr {$i+$colonnes-1}]]
    append data "$tranche\n"
}
# On classe les coordonnees des individus dans la table tablind()
global tablind
if {[info exists tablind]} {unset tablind}
set i -1
set compteur 0
set consensus [lrange [mnorms $mdonnees] 3 [expr {3 + $colonnes - 1}]]
set tablind(0) $consensus
foreach item [split $data "\n"] {
    #
    if {$item != ""} {
	# On saute la premiere ligne
	incr compteur
	if {$compteur > 0} {
	    #verification du nombre de lm de chaque individu
	    if  {$colonnes != [llength $item]} {
		$p insert end "$lm <> [llength $item]"
		exit
	    }
	    incr i
	    set tablind($compteur) $item
	}
    }
}

set translated [translation $mdonnees];# la procedure utilisera tablind()!
#
set transcaled_ctr [scaling $translated]
set transcaled [lindex $transcaled_ctr 0]
set ctr [lindex $transcaled_ctr 1]
#
set rotatedx [rotation $transcaled]
debug "rotated\n[show $rotatedx]"
