# COPYRIGHTS

# Jean-Pierre Dujardin
# The jpdidac software is copyrighted by Jean-Pierre Dujardin, 2002, Unité de Recherches 062- Unité Mixte de Recherches UMR9926, Institut de Recherches pour le Développement (IRD, France).
# jpdidac is provided under the GPL license'
# Institut de Recherches pour le Développement.
# L'IRD (Institut de Recherches pour le Développement) représenté par Madame Marianne BERTHOD-WURMSER, Directrice du DEV, déclare par la présente ne pas revendiquer de droits patrimoniaux du programme jpdidac.tcl réalisé par Jean-Pierre Dujardin et l'autorise ainsi à en assurer la diffusion sous licence GPL (http://www.fsf.org/copyleft/gpl.html).

# VERSION DU JPDIDAC
# v001

font create onlist -family courier -size 12 -weight normal -slant roman
font create onsearch -family courier -size 12 -weight normal -slant roman
font create onsearchagain -family courier -size 12 -weight normal -slant roman
font create onchange -family courier -size 12 -weight bold -slant italic
font create ontitle -family courier -size 14 -weight normal -slant italic
font create vueglobale -family courier -size 12 -weight normal -slant roman
    
# colle #
proc colle {affiche} {

set did1 .texto
catch {destroy $did1}
toplevel $did1
wm title $did1 "ETAPA"
wm iconname $did1 "text"
wm geometry $did1 +40+200
frame $did1.buttons
pack $did1.buttons -side bottom -fill x -pady 2m
button $did1.buttons.salir -text SALIR -command "destroy $did1"
pack $did1.buttons.salir -side left -expand 1
text $did1.text -wrap word -font onlist -relief sunken -bd 2 \
        -yscrollcommand "$did1.scroll set" -setgrid 1 -width 100 -height 10
scrollbar $did1.scroll -command "$did1.text yview"
pack $did1.scroll -side right -fill y
pack $did1.text -expand yes -fill both
$did1.text insert end [show $affiche %8.4f]
#$did1.text insert end $affiche
}
####### colle #

# cloue #
proc cloue {affiche} {
    set did1 .texte
    catch {destroy $did1}
    toplevel $did1
    wm title $did1 "ETAPA"
    wm iconname $did1 "text"
    wm geometry $did1 20x20+20+120
    frame $did1.buttons
    pack $did1.buttons -side bottom -fill x -pady 2m
    button $did1.buttons.salir -text SALIR -command "destroy $did1"
    pack $did1.buttons.salir -side left -expand 1
    text $did1.text -wrap word -font onlist -relief sunken -bd 2 \
            -yscrollcommand "$did1.scroll set" -setgrid 1 -height 10
    scrollbar $did1.scroll -command "$did1.text yview"
    pack $did1.scroll -side right -fill y
    pack $did1.text -expand yes -fill both
    foreach item $affiche {$did1.text insert end "\n$item"}
}
####### cloue #


####################  residalom #### procedure ## DEBUT
proc residalom {} {
    
    global prepop shapepop pop axeX did
    set did .textconforme
    catch {destroy $did}
    toplevel $did
    wm title $did "Etapas y comentarios"
    wm iconname $did "text"
    wm geometry $did 115x35+10+10
    
    proc heading {mesg args} {
        global did
        $did.text insert end $mesg "heading"
    }
    proc body {mesg args} {
        global did
        $did.text insert end $mesg "body"
    }
    global linkNum
    set linkNum 0
    proc greenlink {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground green -underline 0
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground green"
        $did.text tag bind $tag <ButtonPress> "colle $[lindex $linkCode 0]"
    }
    proc bluelink {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground blue -underline 0
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground blue"
        $did.text tag bind $tag <ButtonPress> "cloue $[lindex $linkCode 0]"
    }
    proc lucarne {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground orange -underline 0
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground orange"
        $did.text tag bind $tag <ButtonPress> "[lindex $linkCode 0]"
    }
    
    
    if {[winfo depth $did] > 1} {
        set bold "-background #43ce80 -relief raised -borderwidth 1"
        set normal "-background {} -relief flat"
    } else {
        set bold "-foreground blue -background white -relief raised -borderwidth 1"
        set normal "-foreground {} -background {}"
    }
    
    
    frame $did.buttons
    pack $did.buttons -side bottom -fill x -pady 2m
    button $did.buttons.salir -text SALIR -command "destroy $did"
    #button $w.buttons.code -text "See Code" -command "showCode $w"
    pack $did.buttons.salir -side left -expand 1
    
    text $did.text -wrap word -font onlist -relief sunken -bd 2 -yscrollcommand "$did.scroll set" \
            -setgrid 1 -height 10 -cursor arrow
    scrollbar $did.scroll -command "$did.text yview"
    pack $did.scroll -side right -fill y
    pack $did.text -expand yes -fill both
    
    heading "\nAlometria residual\n\n"
    body "\tNo es porque se dice que se ha retirado el tamano que se ha logrado hacerlo completamente ...\
            Ademas, hay muchas maneras de retirar el tamano, simplemente porque este ultimo se puede evaluar de varias maneras ...\
            Por consecuencia, siempre se tiene que verificar si la conformacion que hemos extraido de los datos \
            es realmente independiente del tamano tal como lo hemos definido"
    body "\n\tEn estadistica, una relacion de dependencia entre dos variables continuas se aprecia por un analisis de regresion. \
            Tenemos una sola variable para el tamano (segun la definicion del cambio isometrico de tamano)\
            pero tenemos muchos componentes de conformacion. Podriamos hacer un analisis de regresion multiple.\
            Podemos tambien tratar de reducir la conformacion a una o dos variables analizadas separadamente."
    body "\n\tEl interés de hacer un análisis discriminante, es que generalmente tiene menos \
            factores (CV1, CV2, etc.) que el ACP, asi que podemos verificar mas fácilmente \
            y 'a posteriori' la relación entre el factor mas discriminante y la variable de \
            tamaño.\n\tDe esta manera, verificamos si la discriminación principal le debe mucho \
            todavía a possibles diferencias de crecimiento, y hallamos una información indirecta \
            sobre la alometría.
            \n\tEn la grafica, CV1 o CV2 se refieren al primero o segundo factor canónico derivado \
            del análisis discriminante sobre los "
    greenlink "componentes de conformacion" pop
    body ", y SIZE se refiere a la variable de tamano global, estimada como el cambio \
            isometrico de tamano (un cambio que se resume a un solo coefficiente por \
            individuo).
    \nExplicamos aqui los antecedentes a este analisis y el sentido de esta regresion.
    \nEtapa 1: se transforman las variables en logaritmos.
    \nEtapa 2: calculamos el"
    
    bluelink " tamaño" axeX
    
    body " de cada individuo como el promedio de sus caracteres
    \nEtapa 3: calculamos las variables de conformación.\n\n"
    
    lucarne "Etapa 4: producimos los componentes de conformacion " conforme
    
    body "haciendo un ACP sobre las variables de conformacion.\n"
    
    lucarne "Etapa 5 Analisis discriminante" discrimine
    
    body " - El input del analisis discriminante es el juego de COMPONENTES DE CONFORMACIÓN \
            EXCEPTO EL ULTIMO. En funcion a los tamanos muestrales, se puede seleccionar un \
            numero menor de componentes conociendo exactam