proc dist_maha {x y p} {
            
            # p is the name of the text widget for internal report
            
            # --------------------
            # CREER LA MATRICE pop
            # ---------------------
            set pop [join_rows $x $y]
            
            # -------------------------------------------------
            # QUELQUES STATISTIQUES SUR LA MATRICE pop UTILISEE
            # -------------------------------------------------
            
            # NOM DU FICHIER
            $p insert end "\n\nTOTAL MATRIX (X + Y)\n"
            
            # NOMBRE DE VARIABLES
            set colonnes [mcols $pop]
            $p insert end "\n"
            $p insert end "\nNombre de variables =      $colonnes\n"
            
            # NOMBRE D'INDIVIDUS
            #global lignes
            set lignes [mrows $pop]
            $p insert end "\nNombre d'individus =       $lignes"
            
            # NOMBRE TOTAL DE CELLULES
            set cellules [expr {$lignes * $colonnes}]
            
            # MOYENNES ET DEVIATIONS STANDARD DES VARIABLES
            mnorms_br pop popmeans popsigma
            $p insert end "\n\nGrand Means\n[show $popmeans %8.4f]"
            $p insert end "\n\nDeviations standards of the total\n[show $popsigma %8.4f]"
            
            # CREER n-1 POUR CALCULER (plus tard) LES eigenvalues
            set obsminusone [expr {$lignes - 1}]
            #$p insert end "Nombre d'individus - 1 (soit "n-1") =  $obsminusone"
            
            # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
            # IL SERVIRA POUR CREER UNE MATRICE CENTREE plutot que normalisee
            set popones "2 1 $colonnes 1"
            set ixe 1
            set igr $colonnes
            while {$ixe < $igr} {lappend popones 1; set ixe [expr $ixe + 1]}
            
            # ----------------------------------------
            # MATRICE VAR - COVAR de la MATRICE TOTALE
            # ----------------------------------------
            
            # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
            # cfr. plus haut : mnorms_br pop popmeans popsigmas
            
            # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
            set Z [mnormalize $pop $popmeans $popones]
            
            # MATRICE des VARIANCES - COVARIANCES
            set ZZ [mmult [transpose $Z] $Z]
            set covT $ZZ
            
            #$p insert end "\n\n---------------------------------------------------"
            #$p insert end "\nMatrice covT : sums of squares and products \n[show $covT %8.4f]"
            #$p insert end "\n-----------------------------------------------------"
            
            # ---------------------------------------------------------------------"
            # Matrice T = covT corrigee en fonction des degres de liberte (lignes - 1)
            # ---------------------------------------------------------------------"
            set corrddl [expr 1.0/($lignes - 1)]
            set T [mscale $covT $corrddl]
            
            #$p insert end "\n\n---------------------------------------------------"
            #$p insert end "\nMatrice T = covT corrigee en fonction des degres de liberte\
            #       [expr $lignes-1] \n[show $T %8.4f]"
            #$p insert end "\n-----------------------------------------------------"
            
            # Ex 'Petite fenetre d'entree des groupes'
            
            set effectifs "[mrows $x] [mrows $y]"
            #global effectifs
            
            set gr 0
            foreach item [split $effectifs] {
                incr gr
                set eff($gr) $item
            }
            
            set B "2 $gr $colonnes"
            set listeW "2 $lignes $colonnes"
            set listeW [lreplace $listeW 0 end];
            $p insert end "\n\nThere are $gr matrices, with n1 = $eff(1) and n2 = $eff(2)\n"
            
            # - - - - - - - - - - - - - - - - - - - - - - -
            # SEPARER LA MATRICE DE CHAQUE GROUPE
            # - - - - - - - - - - - - - - - - - - - - - - -
            
            set correction 0
            
            foreach item [split $effectifs] {
                set correction [expr $correction + $item]
                set newpop [mrange $pop 0 [expr $colonnes-1] \
                        [expr $correction - $item] [expr $correction - 1]]
                # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
                # item = 1 Introduit en Juin 2005
                if {$item > 1} {
                    mnorms_br newpop newpopmeans newpopsigmas
                } else {
                    set newpopmeans $newpop
                }
                # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
                set partZ [mnormalize $newpop $newpopmeans $popones]
                # STOCKER LA MATRICE CENTREE SUR LE GROUPE DANS LA LISTE preplisteW
                # QUI COMPOSERA LA FUTURE MATRICE des donnees CENTREES listeW
                foreach item [split $partZ] {
                    lappend preplisteW $item
                }
                # effacement des indices matriciels de prepliste
                # (une matrice par groupe)
                set preplisteW [lreplace $preplisteW 0 2]
                # ce qui suit est une sorte de lappend
                set listeW [concat $listeW $preplisteW]
                # mise a zero de prepliste
                set preplisteW [lreplace $preplisteW 0 end]
                # PREPARER LA FUTURE MATRICE DES MOYENNES / GROUPE
                set newpopmeans [lrange $newpopmeans 3 end]
                foreach item [split $newpopmeans] {lappend moyennes $item}
            }
            
            # -----------------------------------------------------------
            # CONSTRUCTION FINALE DE LA MATRICE listeW (donnees centrees)
            # -----------------------------------------------------------
            set listeW [concat 2 $lignes $colonnes $listeW]
            $p insert end "\nCentered data\n\
                    (centered by the corresponding group means)"
            $p insert end "\n[show $listeW %8.5f]\n"
            
            # ----------------------------------------------------------
            # Matrice des variances-covariance covW de la matrice listeW
            # ----------------------------------------------------------
            # MATRICE des VARIANCES - COVARIANCES 'within'
            set covW [mmult [transpose $listeW] $listeW]
            $p insert end "\nVariance-covariance matrix of centered data\n\
                    (centered by the corresponding group means)"
            $p insert end "\n[show $covW %8.5f]\n"
            #$p insert end "\n\n---------------------------------------------"
            #$p insert end "\nMatrice W (ou E, cfr. JMP et SAGE) = covW\
            #               \n[show $covW %8.4f]"
            #$p insert end "\n---------------------------------------------"
            
            # ------------------------------------------------------------"
            #     Matrice W (ou E, cfr. JMP et SAGE) = covW corrigee \
            #            en fonction des degres de liberte (lignes - groupes)
            # ------------------------------------------------------------"
            if {$lignes > $gr} {set corrddl [expr 1.0/($lignes - $gr)]} else {set corrddl 1}
            set W [mscale $covW $corrddl]; # Matrice W (ou E, cfr. JMP et SAGE); c'est la pooled cov de NTSYS;
            $p insert end "\nSame matrix, corrected for degrees of freedom"
            $p insert end "\n[show $W %8.5f]\n"
            
            # ECRITURE DE LA MATRICE DES MOYENNES DE CHAQUE GROUPE
            set Moy "2 $gr $colonnes"
            # pour accueillir dans une matrice Moy la liste des moyennes (UNE LISTE, PAS UNE MATRICE)
            foreach item [split $moyennes] {lappend Moy $item}
            $p insert end "\nVoici la matrice des moyennes de chaque groupe\
                    \n[show $Moy %8.5f]\n"
            
            
            #puts "----------------------------"
            #puts " On va inverser la matrice W"
            #puts "----------------------------"
            set iW [msolve $W [mident $colonnes]]
            $p insert end "\nInverted matrix of scaled within variance-covariance matrix above\
                    \n[show $iW %8.5f]\n"
            # -----------------------------------------------------------
            # Matrice de la difference des moyennes des deux groupes 'md'
            # -----------------------------------------------------------
            # S'il ny a que deux groupes
            set a [transpose [mrange $Moy 0 end 0 0]]
            set b [transpose [mrange $Moy 0 end 1 1]]
            set md [msub $a $b]
            $p insert end "\nMatrix of group means differences between two groups\
                    \n[show $md %8.5f]\n"
            
            # ------------------------------------------------------
            # Calcul du T2 de Hotelling
            # ------------------------------------------------------
            # On transpose md pour le produit mdtCmd
            set mdt [transpose $md]
            # On fait le produit mdCmd
            set prod [expr $eff(1) * $eff(2)]
            set somm [expr $eff(1) + $eff(2)]
            set mdtC [mmult $mdt $iW]
            set mdtCmd [mmult $mdtC $md];# le quatrième élément est la distance généralisée
            set mdCmd [mscale $mdtCmd $prod ]
            # -----------------------------------------------------
            # Voici enfin le T2
            set pret2h [mscale $mdCmd [expr 1.0/$somm] ]
            set t2h [vtrim $pret2h]
            $p insert end "\nT2 de Hotelling is ... \n[format $t2h %8.5f ]\n"
            # ------------------------------------------------------
            
            # ------------------------------------------------------
            # Calcul du F associe
            # ------------------------------------------------------
            
            #debug
            $p insert end "\nsomm = $somm \t colonnes $colonnes"
            #debug - fin
            
            set f [expr (($somm-$colonnes-1)*$t2h)/(($somm-2)*$colonnes)]
            $p insert end "\nF = \n[format $f %8.5f ]\
                    \ncon $colonnes \
                    y [expr $somm - $colonnes - 1] grados de libertad"
            
            $p insert end "\n\nBy the way, the Mahalanobis distance is\
                    \n[expr {sqrt([lindex $mdtCmd 3])}]\n\n"
            
            
        }
        
        
        
            
# procedure WIDGETING
#
proc widgeting {} {
	global mogad_p
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x600+205+66
        set mogad_p [text .debug.t -wrap word -height 22 -font "courier 13" \
                -bg grey88 \
                -fg black\
                -tabs "3c left"\
                -yscrollcommand ".debug.v_scroll set" \
                -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
            if {$flag == 1} {
                .debug.t configure -wrap none
                set flag 0
            } else  {
                .debug.t configure -wrap word
                set flag 1
            }
        }
        #
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
}
#
# Procedure WIDGETING fin
 
    
# SCRIPT        PRINCIPALE

source 101La.tcl

widgeting

set a "2 1 4 131.37 133.6 99.17 50.53"
set b "2 1 4 132.37 132.7 99.07 50.23"

set distance [dist_maha $a $b $mogad_p]

