    package require Tk
    
    cd [file dirname [info script]]
    #tk_messageBox -message "pwd = [pwd]" -type ok
    global S
    set S(dirscript) [pwd];#attention, il n'y a pas de "/" a la fin du nom du dossier du script (utiliser "file join etc")
    
    set versiontree "Tree 02"
    #tk_messageBox -message "pwd = $S(dirs cript)" -type ok
    ################################################################################
    # Select
    # Copyright ©  2005 Dujardin J.-P. dujardin@mpl.ird.fr
    #
    # This program is free software; you can redistribute it and/or
    # modify it under the terms of the GNU General Public License
    # as published by the Free Software Foundation; either version 2
    # of the License, or (at your option) any later version.
    #
    # This program is distributed in the hope that it will be useful,
    # but WITHOUT ANY WARRANTY; without even the implied warranty of
    # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    # GNU General Public License for more details.
    #
    # You should have received a copy of the GNU General Public License
    # along with this program; if not, write to the Free Software
    # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ################################################################################
    
    set tcl_precision 14
    
    switch $tcl_platform(platform) {
        "unix" {
            set fin "/+/L"
            set suf "/neighbor"
            set S(appel) "exec xterm $S(dirscript)$fin$suf"
            set suf "/njplot.linux"
            set S(appelnjplotte) "exec xterm $S(dirscript)$fin$suf"
            set S(filename1) [file join $S(dirscript) "+/L/translat.txt"]
            set S(filename2) [file join $S(dirscript) "+/L/treefile"]
            set S(dossierdumod) [file join $S(dirscript) "+" "L" "infile" ]
        }
        "windows" {
            set fin "/+/W"
            set suf "/neighbor.exe"
            set S(appel) "exec cmd.exe /c neighbor.exe"
            set suf "/njplot.exe"
            set S(appelnjplotte) "exec cmd.exe /c njplot.exe"
            set S(filename1) "+/W/translat.txt";#a changer pour translat.txt ??
            set S(filename2) "+/W/outtree";#a changer pour outtree ??
            set S(dossierdumod) [file join $S(dirscript) "+" "W" "infile" ]
        }
        "macintosh" {}
    }
    
    set dossier [pwd]
    #
    #
    # la ayuda explica el bootstrap
    source chull.tcl
    source math/statistics.tcl
    source math/math.tcl
    #source math/interpolate.tcl
    #source math/calculus.tcl
    source math/optimize.tcl
    source math/linalg.tcl
    source 101La.tcl
    source jpdraw_11_3F.tcl
    source ballons.tcl
    
    # JPDRAW_MOG - debut de l'espace de nommage
    #
    namespace eval arbol {
        
        # Jean-Pierre Dujardin
        # The jpdraw v. 0.991 software is copyrighted by Jean-Pierre Dujardin, 2002, Unité de Recherches 062- Unité Mixte de Recherches UMR9926, Institut de Recherches pour le Développement (IRD, France).
        # jpdraw is provided under the GPL license'
        # Institut de Recherches pour le Développement.
        # L'IRD (Institut de Recherches pour le Développement) représenté par Madame Marianne BERTHOD-WURMSER, Directrice du DEV, déclare par la présente ne pas revendiquer de droits patrimoniaux du programme jpdraw.tcl réalisé par Jean-Pierre Dujardin et l'autorise ainsi à en assurer la diffusion sous licence GPL (http://www.fsf.org/copyleft/gpl.html).
        
        
        
        # Procedure SAVELISTING # debut
        #
        proc savelisting {} {
            #
            global p infile
            # Les rapports se suivent -- d'ou la barre de separation
            $p insert end "\n######################################\n"
                set megatexte [$p get 1.0 {end}]
                #debug "megatexte ...\n$megatexte"
                set ending "_treeINFO.txt"
            set nom [file rootname $infile]
            set filename $nom$ending
            $p insert end "\n\nREPORT saved in \n$filename\n(Previous tree report(s) NOT erased)"
            # OPEN THE FILE
            set fileid [open $filename a]
            # FILL THE FILE
            #puts -nonewline $fileid $megainfo
            puts -nonewline $fileid "$megatexte"
            # CLOSE THE FILE
            close $fileid
            $p see end
        }
        #
        # REPORT SAVELISTING -fin
        
        
        # PROCEDURE NJPLOTTE - debut
        #
        proc njplotte {} {
            global S p dossier infile references
            
            cd [file dirname $S(dossierdumod)];# on se place dans le dossier du script NJPLOT
            
            tk_messageBox -message "Please open the file named\ntreefile \
                    (or outtree if you are Windows)" -type ok
            if {[info exists avis]} {affiche 170 50 $avis}
            
            $p insert end "\nnjplot as external software for CLIC, see: \n"
            bleu {Perrière, G. and Gouy, M. (1996) WWW-Query: An on-line retrieval system for biological sequence banks. Biochimie, 78, 364-369}
            $p insert end "\n"
            
            # Appel de njplot
            #
            eval $S(appelnjplotte)
            
            # On se replace dans le dossier du SCRIPT
            cd $S(dirscript)
            
            destroy .avis
        }
        #
        # PROCEDURE NJPLOTTE -FIN
        
        
        
        
        # PROCEDURE QUI - debut
        #
        proc qui {} {
            
            
            global S p gr dossier infile references subdivision
            
            cd $S(dirscript);# on se place dans le dossier du script MOG
            
            set gr [llength $subdivision]
            
            #set avis "'Giving a name to each OTU' is valid \n... only if you already built a TREE ..."
            #affiche 670 114 $avis
            
            $p insert end "\nUse of NewickTranslation procedure from TREEDYN (by Chevenet, IRD)\
                    \nas external software for CLIC), see: \t"
            bleu {http://www.treedyn.org}
            $p insert end "\n"
            
            # Donner un nom a chaque population (fichier d'annotations treedyn)
            # ... voir ci-dessous, apres la procedure NewickTranslation
            # puis remplacer le fichier treefile par un fichier modifie
            # ... voir ci-apres, la procedure NewickTranslation
            
            proc NewickTranslation {filename1 filename2} {
                #debug "NewickTranslation debut: filename $filename1 et filename2 $filename2"
                update
                flush stdout
                global S
                # Fichier d'annotations (...) filename1 "+/L/translat.txt"
                if [catch {open $filename1 r} fid] {
                    puts stderr "Error Oppening File"
                } else {
                    #debug "Procedure NewickTranslation: filename1 $filename1 et filename2 $filename2"
                    if {[catch {open $filename2 r} fid2]} {
                        puts stderr "Error Opening File"
                    } else {
                        # Lecture du fichier d'annotations "+/L/translat.txt"
                        set translation [read $fid]
                        #debug "translation \n$translation"
                        #Lecture du fichier Newick
                        set source [read $fid2]
                        set source [regsub -all {\n} $source ""]
                        # Fichier modifie (portera le meme nom que le fichier source, cfr. target="")
                        set target "";#"_modif"
                        set S(FSPtransTF) $filename2$target
                        set fidTARGET [open $S(FSPtransTF)  w]
                        # Translation ppt dite
                        foreach {val var trans} $translation {
                            set feuilleFrom [format "%s%s%s" "\\(" $val ":" ]
                            set feuilleVers [format "%s%s%s" "\(" [string toupper $trans] ":" ]
                            set trouve [regsub -- $feuilleFrom $source $feuilleVers source]
                            #debug "\n--feuilleFrom $feuilleFrom\n feuilleVers $feuilleVers\n trouve $trouve"
                            if {$trouve == 0} {
                                set feuilleFrom [format "%s%s%s" , $val : ]
                                set feuilleVers [format "%s%s%s" , [string toupper $trans] : ]
                                regsub  -- $feuilleFrom $source $feuilleVers source
                            }
                        }
                        puts $fidTARGET $source
                        close $fid
                        close $fid2
                        close $fidTARGET
                    }
                }
            }
            
            
            # Dialogue pour creer le fichier d'annotations 'translat.txt'
            proc dialogue {gr} {
                global S group subdivision
                #set group [expr {$gr + 1}];# no se porque, pero $gr no es siempre adecuado, $subdivsion lo es ...
                set group [expr {[llength $subdivision] + 1}]
                #tk_messageBox -message "subdivision = $subdivision\nIl y a $group ... ou [llength $subdivision] ... groupes ?" -type ok
                # (Welsch, p.493)
                #
                # Create a resizable toplevel window
                destroy .diatree
                toplevel .diatree
                set top .diatree
                set title "Naming OTUs"
                wm minsize $top 200 100
                wm title $top $title
                #Create a frame for buttons
                set f [frame $top.buttons -bd 4]
                button $f.quit -text "Cancel" -command "destroy $top"
                button $f.save -text "Save" -command {
                    global group
                    update
                    destroy .diatree
                    for {set i 1} {$i < $group} {incr i} {
                        set row($i) "Name \{ $v($i) \}"
                        append metainfo "_$i $row($i)\n"
                    }
                    # OPEN THE FILE
                    set fileid [open $S(filename1) w+]
                    # FILL THE FILE
                    puts -nonewline $fileid $metainfo
                    # CLOSE THE FILE
                    close $fileid
                    arbol::NewickTranslation $S(filename1) $S(filename2)
                }
                pack $f.quit $f.save -side right
                pack $f -side top -fill x
                
                #Creating a scrolling canvas
                frame $top.c
                canvas $top.c.canvas -width 10 -height 10 \
                        -yscrollcommand [list $top.c.yscroll set]
                scrollbar $top.c.yscroll -orient vertical \
                        -command [list $top.c.canvas yview]
                pack $top.c.yscroll -side right -fill y
                pack $top.c.canvas -side left -fill both -expand true
                pack $top.c -side top -fill both -expand true
                
                arbol::Scrolled_EntrySet $top.c.canvas $gr
                
            }
            
            proc Scrolled_EntrySet {canvas gr} {
                
                # (Welsch, p.493)
                #
                # Create one frame to hold everything and position it on the canvas
                set f [frame $canvas.f -bd 0]
                $canvas create window 0 0 -anchor nw -window $f
                
                # Dialogue pour creer le fichier d'annotations 'translat.txt'
                set group [expr {$gr+1}]
                wm geometry .diatree +300+200
                for {set i 1} {$i < $group} {incr i} {
                    label $f.l_$i -text "Name(s) for Group $i"
                    entry $f.g_$i  -textvariable v($i)
                    grid $f.l_$i $f.g_$i
                    grid $f.l_$i -sticky w
                    grid $f.g_$i -sticky we
                }
                set child $f.g_1
                
                # Wait for the window to become visible and then ...
                
                tkwait visibility $child
                set bbox [grid bbox $f 0 0]
                set incr [lindex $bbox 3]
                set width [winfo reqwidth $f]
                set height [winfo reqheight $f]
                $canvas config -scrollregion "0 0 $width $height"
                $canvas config -yscrollincrement $incr
                set max $group
                if {$max > 10} {set max 10}
                set height [expr {$incr * $max}]
                $canvas config -width $width -height $height
            }
            
            dialogue $gr
            
            bind .diatree <Return> {
                update
                destroy .diatree
                for {set i 1} {$i < $group} {incr i} {
                    set row($i) "Name \{ $v($i) \}"
                    append metainfo "_$i $row($i)\n"
                }
                #
                # OPEN THE FILE
                set fileid [open $S(filename1) w]
                # FILL THE FILE
                puts -nonewline $fileid $metainfo
                # CLOSE THE FILE
                close $fileid
                arbol::NewickTranslation $S(filename1) $S(filename2)
            }
            #
        }
        #
        # PROCEDURE QUI -fin
        
        proc phylip {} {
            #neighbor, from Phylip of J. Felsenstein
            
            global S p dossier infile tclplatform
            #tk_messageBox -message "ARBOL::PHYLIP pwd = $S(dirscript)" -type ok
            cd $S(dirscript);# on se place dans le dossier du script MOG
            
            if {[info exists infile]} {
                
                # Etape 1. se placer dans le dossier du module neighbor (cfr S(appel) en debut de MOG)
                
                # Etape 2 placer le fichier des distances dans le fichier infile du dossier du module (neighbor)
                #set dossierdumod [file join $S(dirscript) "+" "L" "infile" ]
                
                file copy -force $S(infilesub) $S(dossierdumod)
                
                #
                # SE PLACER d'abord DANS le dossier du module Neighbor
                cd [file dirname $S(dossierdumod)]
                # appeler ALORS le programme externe, i.e. le module Neighbor
                eval $S(appel)
                #
                set outfile "[file dirname $S(dossierdumod)]/outfile"
                #
                $p insert end "\noutfile $outfile\n"
                set fid [open $outfile]
                set text [read -nonewline $fid]
                close $fid
                #
                # ATTENTION
                #
                # REVENIR ENSUITE AU DOSSIER DU SCRIPT
                #
                cd $S(dirscript)
                #
                $p insert end "\noutfile = \n$text"
                arbol::vert "\n----------------------------------------\n"
                arbol::vert "\n\n$infile \n"
                arbol::vert "\n----------------------------------------\n"
            } else  {
                tk_messageBox -message "No previous analysis available"
            }
        }
        
        # Procedure ENTRADA - start
        #
        proc entrada {pop infile} {
            
            global p references
            # En rouge on ecrit le commentaire du fichier de donnees
            arbol::rouge "\n\n$infile \n"
            arbol::rouge "\n$references\n"
            update
            set colonnes [mcols $pop]
            set lignes [mrows $pop]
            
            # En bleu on ecrit les premieres lignes et colonnes du fichier de donnees ...
            #bleu "\nArchivo contenido (parcialmente):"
            #$p insert end "\n[show [mrange $pop 0 [expr {$colonnes - 1} ] 0 4 ] ] \netc. \n"
            update
            #vert "\nSON LOS DATOS LOGARITMOS NATURALES ? \n"
            
            # ... et d'autres infos sur ce fichier
            arbol::bleu "\nNumero de variables =\t"
            $p insert end "$colonnes\n"
            
            arbol::bleu "\nNumero de individuos =\t"
            $p insert end "$lignes\n"
        }
        #
        # Procedure ENTRADA - fin
        
        
        ################### arbol::bleu ##### Procedure ## Debut ##
        proc bleu {mesg args} {
            global p
            $p insert end $mesg "bleu"
            $p tag configure bleu -foreground blue
        }
        
        ################### bleu ####### PROCEDURE ## FIN ###
        
        ################### rouge ##### Procedure ## Debut ##
        proc rouge {mesg args} {
            global p
            $p insert end $mesg "rouge"
            $p tag configure rouge -foreground red
        }
        
        ################### rouge ####### PROCEDURE ## FIN ###
        
        ################### vert ##### Procedure ## Debut ##
        proc vert {mesg args} {
            global p
            $p insert end $mesg "vert"
            $p tag configure vert -foreground "dark green"
        }
        
        ################### vert ####### PROCEDURE ## FIN ###
        
        # Procedure WHICHMATRIX - start
        #
        proc whichmatrix {} {
            global p infile dossier
            set typeList {
                {{"Text files"} {.txt .nts .TXT .NTS} }
            }
            set infile [arbol::chemin];# usage de la procedure CHEMIN : memoire des dossiers anterieurs
            set x [arbol::loadfile $infile]; # usage de la procedure LOADFILE
            
            if {$x != ""} {
                
                arbol::entrada $x $infile;# usage de la procedure ENTRADA: presentation de la matrice loadee
                #$p insert end "\nMatrix X:\t----------------------------------start---\n"
                ##$p insert end [show $x %8.3f]
                #if {[mrows $x] < 30} {
                #    $p insert end "\n\n[show $x %8.3f]"
                #} else  {
                #    $p insert end "\n\n[show [mrange $x 0 end 0 29] %8.3f] \n...\netc. etc.\n"
                #}
                #$p insert end "\nMatrix X:\t----------------------------------end----\n\n"
            }
            return $x
        }
        #
        # Procedure WHICHMATRIX - end
        
        
        
        # Procedure CHEMIN -start
        #
        proc chemin {} {
            
            global p dossier
            
            if {[info exists dirinfile] == 0} {
                set dirinfile [pwd]
            }
            
            # ----------------------------------------------------
            # Nom du FICHIER et son CHEMIN (path) CORRESPONDANT
            # ---------------------------------------------------
            
            
            # Chercher le chemin dans un fichier de configuration
            # 1. verifier que le fichier de configuration existe
            set chemin "[pwd]/dossier_cov.txt"
            #puts "chemin $chemin"
            # 2. s'il n'existe pas, voir ci-dessus
            if {[file exists $chemin] == 0} {
                set candidat_dossier [pwd]
            } else  {
                #puts "La conf existe"
                # 3. s'il existe reccueillir le dernier chemin parcouru
                # open le fichier pour lire
                catch [
                set fid [open $chemin r]
                set candidat_dossier [read -nonewline $fid]
                close $fid
                ] ici
                #puts "candidat_dossier $candidat_dossier"
                set candidat_dossier [lindex [split $candidat_dossier \n] 1]
                # debug
                #puts "dossier = $candidat_dossier"
            }
            
            # On va chercher les donnees
            
            set typeList {
                {{"Text files"} {.txt .nts .TXT .NTS} }
            }
            set infile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
            
            #infile contient le chemin et le nom du fichier des donnees
            set dossier "[file dirname $infile]/";#repertoire des donnees
            
            # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
            if {$dossier != $candidat_dossier} {
                # open le fichier de conf pour ecrire
                catch [
                set fid [open $chemin w+]
                puts -nonewline $fid "Dernier dossier de donnees utilisees par COV:\n"
                puts -nonewline $fid $dossier
                close $fid
                ] ici
            }
            
            set dirinfile "[file dirname $infile]/";#repertoire des donnees
            set tailfile [file tail $infile];#fichier nu, avec l'extension
            set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
            
            # --------------------------------------------------------
            # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE pop
            # --------------------------------------------------------
            return $infile
        }
        #
        # Procedure CHEMIN - end
        
        
        # PROCEDURE loadfile - DEBUT
        #
        proc loadfile {pathname} {
            
            if {$pathname != ""} {
                global S
                set S(dist_nopar) 0
                set S(datadir) $pathname
                set fid [open $pathname]
                set text [read -nonewline $fid]
                close $fid
                set rowcount 0
                set colcount 0
                global references
                set compteur 0
                set lignes 0
                set data ""
                foreach line [split $text \n] {
                    incr compteur
                    if {$compteur >1} {
                        if  {$line != ""} {
                            set colcount [llength $line]
                        }
                    }
                    if {$compteur>1} {
                        foreach item [split $line] { if {$item != ""} {
                                incr lignes;lappend data $item
                            }
                        }
                    } else {set references $line}
                }
                set rowcount [expr {$lignes / $colcount}]
                set result [concat 2 $rowcount $colcount $data]
                #debug
                #puts "Commentaire brut :\n$references"
                # -- Formater le commentaire
                # -- 1. Enlever d'eventuelles tabulations
                foreach mot $references {
                    if {$mot != ""} {
                        append comentario_sin_tab "$mot "
                    }
                }
                set references $comentario_sin_tab
                set S(references) $references
                # -- FIN du formatage de la premiere ligne
                
                # Il faudrait creer le meme fichier en .nts (pour TPSregr) - debut
                set datos ""
                set compteur 0
                foreach truc [split $text "\n"] {
                    if {$compteur > 0} {
                        if {$truc != ""} {lappend datos "$truc\n"}
                    } else {
                        #lappend datos "\"$truc\n"
                        set premligne $truc
                    }
                    incr compteur
                }
                # Enlever les curved brackets
                set datos [regsub -all {\{|\}} $datos ""]
                #
                set ntscode "1 $rowcount $colcount 0\n"
                set ntsmatrix $ntscode$datos
                # debug
                #rouge "NTSNTSNTS\n$ntsmatrix\nNTSNTSNTS\n"
                # puis l'enregistrer ...
                # OPEN THE FILE
                set extension ".nts"
                set nameoffile "/[file tail [file rootname $pathname]]"
                set filename [file dirname $pathname]$nameoffile$extension
                set fileid [open $filename w]
                # FILL THE FILE
                puts -nonewline $fileid "\" $premligne \" "
                puts -nonewline $fileid "\n$ntsmatrix"
                # CLOSE THE FILE
                close $fileid
                #
                # Il faudrait creer le meme fichier en .nts (pour TPSregr) - fin
                return $result
            }
        }
        #
        # PROCEDURE loadfile - FIN
        
        
        
        # Procedure COMPOSANTES - start
        #
        proc composantes {pop} {
            global p suit_rot pxpu
            set lignes [lindex $pop 1]
            set colonnes [lindex $pop 2]
            set obsminusone [expr {$lignes - 1}]
            # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
            mnorms_br pop popmeans popsigmas
            # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
            # IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
            set popones "2 1 $colonnes 1"
            set x 1
            set y $colonnes
            while {$x < $y} {lappend popones 1; set x [expr {$x + 1}]}
            # CENTRER LES DONNEES PLUTOT QUE LES NORMALISER
            # ------------------------------------------------
            set Z [mnormalize $pop $popmeans $popones]
            # SINGULAR VALUE DECOMPOSITION using VARCOV for the eigensolution
            # ---------------------------------------------------------------
            set Z [mnormalize $pop $popmeans $popones]
            set ZZ [mmult [transpose $Z] $Z]
            set nless1 [expr {1./$obsminusone}]
            set vcm [mscale $ZZ $nless1]
            set V $vcm
            mevsvd_br V evals
            # V     : contient les eigenvecteurs (non ajustes)
            # evals : contient les eigen values
            
            return $V
        }
        #
        # Procedure COMPOSANTES - fin
        
        
        # Procedure TRANSLATION # debut
        #
        proc translation {lm} {
            global p
            #
            global rawindividus;# on en a besoin pour le calcul du nombre de lignes
            set mmm [llength $rawindividus]
            set lignes [expr {$mmm/$lm}]
            #
            global polygone;#sert a quoi ?
            #
            global suit_tran suit_cons nosi suit_rot susnesnoc references
            set susnesnoc 0
            set nosi 0
            if {[info exists suit_tran] == 0} {#$p insert end "\n\nTRANSLACION de los OBJETOS \
                        sobre UN mismo CENTROIDE\n"}
            if {[info exists objet_cons]} {unset objet_cons}
            set suit_cons 0
            #
            # Matrices I, P, I-P
            global  grandp imoinsp
            set identite [mident $lm]
            set unsurp [expr {1.0 / $lm}]
            set grandp "2 $lm $lm"
            for {set i 0} {$i < [expr {$lm*$lm}]} {incr i} {
                append grandp " $unsurp"
            }
            set imoinsp [msub $identite $grandp]
            #
            # Translation ou pre-multiplication des matrices par I-P
            global translatedx
            global tablind
            for  {set i 0} {$i < [expr {$lignes+1}]} {incr i} {
                set x "2 $lm 2 $tablind($i)"
                set translatedx($i) [mmult $imoinsp $x]
                if {[info exists suit_tran] == 0} {#$p insert end "\nTranslated matrix object $i\
                            \n[show $translatedx($i)]\n"}
            }
            # Il n'y a pas de 'return', les donnees apres translation sont dans une variable globale monoindicee = 'translatedx()'
        }
        #
        # Procedure TRANSLATION- fin
        
        
        # Procedure SCALING - debut
        #
        proc scaling {lm} {
            global references
            global p imoinsp;#pour calculer proctr
            
            global translatedx preindividus;# Ce sont les coordonnees obtenues apres la TRANSLATION
            
            global polygone;#sert a quoi ?
            global suit_rot neweff centroid;#sert a quoi ?
            #
            global transcaledindiv transcaledtotal
            global tailles_base
            global consensus
            global susnesnoc nosi
            # Aout 2006 Mise a zero des variables d'accumulation
            set transcaledtotal ""
            set centroide ""
            set tailles_base ""
            set consensus 0
            set susnesnoc 0
            set nosi 0
            #set suit_rot 0
            #
            global rawindividus;# pour compter le nombre de lignes
            set mmm [llength $rawindividus]
            set lignes [expr {$mmm/$lm}]
            #
            # informe
            global suit_scal
            if {[info exists suit_scal] == 0} {#$p insert end "\n\n\nSCALING to UNIT Centroid Size\n"}
            
            set suit_cons 0
            #
            # UNIT CTR Scaling to unit centroid size
            global translatedx;# contient les coordonnees de chaque individu apres translation - c'est une variable monoindicee
            for  {set i 0} {$i < [expr {$lignes+1}]} {incr i} {
                set ttranslatedx($i) [transpose $translatedx($i)]
                set prectr [mmult $translatedx($i) $ttranslatedx($i)]
                set proctr [mmult $prectr $imoinsp]
                set presquectr [transpose $proctr]
                # La taille centroide elevee au carre est la trace de presquectr
                set prectr2 [vdiag $presquectr]
                set proctr2 [vtrim $prectr2]
                set ctr2 0
                foreach item $proctr2 {set ctr2 [expr {$ctr2+$item}]}
                set ctr [expr {sqrt($ctr2)}]
                set centroid($i) $ctr
                set scalefactor [expr {1.00000/$ctr}]
                set transcaledindiv($i) [mscale $ttranslatedx($i) $scalefactor]
                set transcaledindiv($i) [transpose $transcaledindiv($i)]
                #
                # informe
                if {[info exists suit_scal] == 0} {
                    append transcaledtotal "[lrange $transcaledindiv($i) 3 end]\n"
                    append centroide "$ctr\n"
                    append tailles_base "$ctr "
                }
            }
            # JUILLET 2006
            return $tailles_base;# a qui est destine ce return ?
        }
        #
        # Procedure SCALING - fin
        
        
        # Procedure ROTATION - debut
        #
        proc rotation {} {
            #
            # procedure appelee par SUBDIVIDED_MATRIX_PW
            #
            global p infile
            global  lm colonnes
            global polygone;#sert a quoi ?
            global references;# contient les COMMENTAIRES, attention ! la variable existe aussi au singulier (elle contient alors le consensus)
            
            #
            global rawindividus
            set mmm [llength $rawindividus]
            set lignes [expr {$mmm/$lm}]
            #
            global consensus susnesnoc suit_cons nosi indivmoy suit_rot
            set consensus 0
            set susnesnoc 1
            set suit_cons 1
            set nosi 0
            set indivmoy 0;#pour ne pas repeter les rapports du bouton jpdraw/moyens
            if {[info exists suit_rot] == 0} {#$p insert end "\n\nROTATION (aligned specimens)"}
            #
            global transcaledindiv
            set V [arbol::composantes $transcaledindiv(0)];# V contient les eigenvecteurs
            set prex1t [mmult $transcaledindiv(0) $V ]
            #
            # Debug
            #if {[info exists suit_rot] == 0} {$p insert end  "\n\nConsensus aligned to its \
            principal component axes\n\n[show $prex1t %1.4f]\n"}
        #
        # formation des points (individus) du consensus prex1t
        global objet_cons
        set landmark 0
        for  {set i 3} {$i < [expr {$lm*2+2}]} {incr i 2} {
            incr landmark
            set item [lrange $prex1t $i [expr {$i+1}]]
            if {$item != ""} {lappend objet_cons "2 1 2 $item"}
            if {[info exists suit_rot] == 0} {append aligned "$item "}
        }
        if {[info exists suit_rot] == 0} {append aligned "\n"}
        #$p insert end "\n$objet_cons"
        #
        # Le consensus dans la variable reference (ici le mot reference est au singulier)
        global reference
        if {[info exists suit_rot] == 0} {set reference $aligned}
        #if {[info exists suit_rot] == 0} {$p insert end  "\nConsensus de la variable 'reference' \n $aligned \n"}
        #
        # Donc, le consensus aligne sur ses composantes principales est dans une matrice de Hume 'prex1t' et dans une liste 'reference'
        #
        # references au pluriel c'est la premiere ligne du fichier de donnees (cfr loadfile)
        #
        # Rotations proprement dites
        global rot;# variable globale monoindicee, contient les coordonnees apres rotation
        set x1t [transpose $prex1t]
        for  {set i 1} {$i < [expr {$lignes+1}]} {incr i} {
            set ttrantran($i) [mmult $x1t $transcaledindiv($i)]
            # singular value decomposition
            set U $ttrantran($i)
            msvd_br U S V
            set S "2 2 2 1 0 0 1"
            set H [mmult [mmult $V $S] $U]
            set rot($i) [mmult $transcaledindiv($i) $H]
            #debug oct 2008 -- start
            #rouge "\ncoord resid indiv $i : $rot($i)"
            # Pour une distance entre deux individus, il n'y a que deux individus
            # Une iteration ne sera necessaire que pour plus de deux individus
            #    #    Somme des distance de Procrustes entre les rot() et le consensus qui devrait etre dans rot(0) ??
            # Consensus dans rot(0);# rouge"rot(zero) :\n[show $prex1t %1.4f]\n" ?
            #debug oct 2008 -- end
        }
        #debug
        #rouge "aligned $aligned"
    }
    #
    # Procedure ROTATION - fin
    
    # Procedure PROCRUSTES
    #
    # Calcul de la DISTANCE de Procrustes entre deux jeux de coordonnées BRUTES (procr_mdonnees)
    # DONC, la procedure fait une SUPERPOSITION de PROCRUSTES D'ABORD
    #
    proc procrustes {procr_mdonnees} {
        #
        # procr_mdonnees contient une matrice HUME de deux lignes (individus) et 'lm' colonnes
        #
        global p colcount_ici tablind reference rot rot2 reference reference2
        global nombre lm nombre ts_inconnu_file rotUnknown rotInconnu
        #
        #------------------ script principal tout de suite apres la sub-procedure 'Procrustes_distances' ci-dessous
        
        # Sous-Procedure Procrustes_distances
        #
        proc Procrustes_distances {} {
            global rot rot2 lm fingerprint nombre p
            set sum 0
            set compteur 0
            for  {set i 3} {$i < [expr {$lm*2+3}]} {incr i 2} {
                global fingerprint
                set a1 [lindex $rot(1) $i]
                set a2 [lindex $rot(2) $i]
                set b1 [lindex $rot(1) [expr {$i+1}]]
                set b2 [lindex $rot(2) [expr {$i+1}]]
                set a1moinsa2 [expr {$a1-$a2}]
                set b1moinsb2 [expr {$b1-$b2}]
                #debug
                #$p insert end "\nlandmark [expr {$compteur+1}]\t [format %1.4f $a2] - [format %1.4f $b2] \
                et [format %1.4f $a1] - [format %1.4f $b1]\n[format %1.4f $a1moinsa2]\
                        et [format %1.4f $b1moinsb2]"
                set d [ expr { pow($a1moinsa2,2) + pow($b1moinsb2,2) } ]
                set sum [expr {$sum + $d}]
                set fingerprint($compteur) $d
                incr compteur
            }
            # On renvoie la distance de Procruste (dans la variable 'distancia', voir tout-en-bas)
            return [expr {sqrt($sum)}]
        }
        #
        # Sous-Procedure Procrustes_distances
        
        # ------------------------------------------------------------------------------------------
        # Script de la procédure principale ------------------------------            partie 1
        # ------------------------------------------------------------------------------------------
        set procr_matinit [lrange $procr_mdonnees 0 2]; # on extirpe le prefixe de Hume (dimensions lignes colonnes ...)
        set colonnes [lindex $procr_matinit 2];# on en retire le nb de colonnes
        set lignes [lindex $procr_matinit 1];# on en retire le nb de lignes
        set lm [expr {$colonnes * 1/2}];# on en deduit le nb de landmarks
        #
        # calcul du consensus (configuration moyenne)
        set consensus [mnorms $procr_mdonnees];# a ce stade, 'consensus' est une matrice de Hume
        set consensus [lrange $consensus 3 [expr {3+$colonnes-1}]];# a present, 'consensus' est une liste
        set donnees [lrange $procr_mdonnees 3 end];# les donnees sous forme de liste, egalement
        set data "";# data deviendra une liste de listes ayant l'aspect d'un tableau
        for  {set i 0} {$i < [expr {$lignes*$colonnes}]} {incr i $colonnes} {
            set tranche [lrange $donnees $i [expr {$i+$colonnes-1}]]
            append data "$tranche\n"
        }
        #
        # On classe les coordonnees successives par individu dans la table tablind()
        set i -1
        set compteur 0
        set tablind(0) $consensus
        foreach item [split $data "\n"] {
            if {$item != ""} {
                # On saute la premiere ligne
                incr compteur
                if {$compteur > 0} {
                    #verification du nombre de lm de chaque individu
                    if  {$colonnes != [llength $item]} {
                        exit
                    }
                    incr i
                    set tablind($compteur) $item
                }
            }
        }
        #
        #set lm [expr {$colcount_ici * 1/2}]
        
        # AJOUTE EN SEPTEMBRE 2008
        # On cree une LISTE (un individu) de MATRICES (de coordonnees)
        # Une matrice est un couple de coordonnees, elle a 1 ligne et 2 colonnes
        # (chaque 'landmark' est une 'matrice').
        global rawindividus
        #
        if {[info exists rawindividus]} {unset rawindividus} else {set rawindividus ""}
        set n [llength $data]
        for  {set i 0} {$i < $n} {incr i 2} {
            set item [lrange $data $i [expr {$i+1}]]
            lappend rawindividus "2 1 2 $item"
        }
        
        # SEPTEMBRE 2008: SUPERPOSITION DE PROCRUSTE
        arbol::translation $lm;# utilise les variables globales 'rawindividus' et 'tablind';
        #    tablind(0) contient le consensus
        arbol::scaling $lm
        arbol::rotation
        # SEPTEMBRE 2008
        update
        #
        #  -------------------------------------------------------------------------------------------
        # Script de la procédure principale ---------------------------------------- partie 2
        # --------------------------------------------------------------------------------------------
        #
        # A ce stade, il faut calculer les distances entre coordonnees des deux individus ou de chaque individu avec leur consensus
        # on fera appel a la SUB Procedure Procrustes_distances
        set distancia [Procrustes_distances]
        #  ------------------------------------------------------------------------------------------
        # Script de la procédure principale ------------------------------------------ la fin
        # ------------------------------------------------------------------------------------------
        
        # On renvoie la distance de Procruste
        return $distancia
    }
    #
    # Procedure PROCRUSTES
    
    
    # Procedure PROCRUSTES_nonEUCLID ------------------------------------ start
    #
    # Calcule les distances  de Procruste  entre individus
    #
    # Il faut savoir que les noms des variables globales gardent leur référence
    # à la première distance (euclidienne) utilisée pour le script IDD
    #
    proc Procruste_nonEuclid {table} {
        # La table est une matrice HUME de coordonnees brutes correspondant
        # à un groupe donné
        # (cfr.    foreach table $xsubd    du menu_name add casc IDD)
        #
        # Une variable globale si le but est d'obtenir la liste non formatée des distances
        global p S subdivision groupe_ordre colcount_ici
        #
        set S(euclist) "";# nettoyage important, sans quoi il y a accumulation
        #
        # En lignes, les groupes ou populations
        set gro [mrows $table]
        # En colonnes, les coordonnées des landmarks
        set colcount_ici [mcols $table]
        set lm [expr {$colcount_ici * 1/2}]
        #
        # fenetre de suivi (celle des effectifs des groupes)- debut
        if {[catch { if {$S(perm) == 0} {.question.l1 configure -text "0/$gro"} }] ==1} {
            set on setrompe
        } else  {
            if {$S(perm) == 0} {.question.l1 configure -text "0/$gro"}
        }
        # fenetre de suivi - end
        #
        # Quelles sont les distances de Procruste entre les configurations
        # (gro = nombre de lignes) ?
        set tableucl "0 "
        set zero " 0 "
        
        for {set l 0} {$l < $gro} {incr l} {
            # secouer le curseur
            $p delete 1.0 1.12;$p insert 1.0 "$l < $gro"
            for {set k [expr {$l+1}]} {$k < $gro} {incr k} {
                set bonclid 0
                
                set config1 [mrange $table 0 end $l $l]
                set config2 [mrange $table 0 end $k $k]
                #debug
                
                # Les deux configurations en matrice Hume
                set procr_mdonnees [join_rows $config1  $config2]
                #debug
                #puts "Les deux config ensemble ----\n[show $procr_mdonnees]\n----"
                
                # Calcul de la distance de Procrustes
                set bonclid [arbol::procrustes $procr_mdonnees]
                
                
                # fenetre de suivi - debut
                if {[catch { if {$S(perm) == 0} {.question.l1 configure -text "$l/$gro"} }] ==1} {
                    set on setrompe
                } else  {
                    update
                    if {$S(perm) == 0} {.question.l1 configure -text "... /$gro"}
                }
                # fenetre de suivi - fin
                
                lappend tableucl $bonclid
                # A ne pas enlever !!!!!!!!!!!!!!!!!!!!!
                
                # Une variable globale si le but est d'obtenir la liste non formatée des distances
                lappend S(euclist) $bonclid
                append S(disfo) "\n[expr {$l+1}] - [expr {$k+1}]  :\t $bonclid"
                if {[info exists groupe_ordre]} {
                    lappend S(euclist_doc) "$bonclid [expr {$S(n) + $l}] [expr {$S(n) + $k}] $groupe_ordre $groupe_ordre"
                    #debug "EUCLI: (groupe $groupe_ordre) $l $k distance-w $bonclid >>> \
                    #euclist_doc = $S(euclist_doc)"
                }
            }
            
            # Pour gérer les zeros (si on crée une vraie 'matrice' de distances)
            if {$l < [expr {$gro-1}]} {
                append zero " 0 "
                append tableucl $zero
            }
        }
        
        # Si on veut retourner une matrice des distances
        set matdist [concat 2 $gro $gro $tableucl]
        set matdist [transpose $matdist]
        # La matrice des distances (cfr. RETURN) est sous le format HUME
        # La LISTE des distances se trouve dans la variable globale S(euclist), remise à zero à chaque passage ici
        # debug
        # vert "\nPROCEDURE EUCLID $matdist\n\n"
        return $matdist
    }
    #
    # Procedure Procruste_nonEuclid - fin
    
    
    
    # Procedure EUCLID - start
    #
    proc euclid {table} {
        # La table est une matrice de partial warps correspondant à un groupe donné
        # (cfr.    foreach table $xsubd    du menu_name add casc IDD)
        #
        # Une variable globale si le but est d'obtenir la liste non formatée des distances
        global S subdivision groupe_ordre
        #
        set S(euclist) "";# nettoyage important, sans quoi il y a accumulation
        #
        # En lignes, les groupes ou populations
        set gro [mrows $table]
        # En colonnes, les variables ou characteres
        set var [mcols $table]
        #
        # fenetre de suivi (celle des effectifs des groupes)- debut
        if {[catch { if {$S(perm) == 0} {.question.l1 configure -text "0/$gro"} }] ==1} {
            set on setrompe
        } else  {
            if {$S(perm) == 0} {.question.l1 configure -text "0/$gro"}
        }
        # fenetre de suivi - end
        #
        # Quelles sont les distances euclidiennes entre les lignes (gro) sur la base de toutes les colonnes (var) ?
        set tableucl "0 "
        set zero " 0 "
        for {set l 0} {$l < $gro} {incr l} {
            for {set k [expr {$l+1}]} {$k < $gro} {incr k} {
                set bonclid 0
                #
                for {set c 0} {$c < $var} {incr c} {
                    # valeurs de chaque individu sur un axe factoriel
                    set m1 [lindex [mrange $table $c $c $l $l] 3]
                    set m2 [lindex [mrange $table $c $c $k $k ] 3 ]
                    # difference arithmetique entre deux moyennes (celles de deux populations)
                    set diff [expr {$m1  -  $m2}]
                    # cette difference elevee au carre
                    set cardiff [expr {$diff * $diff}]
                    # cette valeur ajoutee a la distance totale (pour toutes les variables) entre ces deux populations
                    set bonclid [expr {$bonclid + $cardiff}]
                }
                # fenetre de suivi - debut
                if {[catch { if {$S(perm) == 0} {.question.l1 configure -text "$l/$gro"} }] ==1} {
                    set on setrompe
                } else  {
                    update
                    if {$S(perm) == 0} {.question.l1 configure -text "... /$gro"}
                }
                # fenetre de suivi - fin
                
                set bonclid [expr {sqrt($bonclid)} ]
                lappend tableucl $bonclid
                # A ne pas enlever !!!!!!!!!!!!!!!!!!!!!
                
                # Une variable globale si le but est d'obtenir la liste non formatée des distances
                lappend S(euclist) $bonclid
                append S(disfo) "\n[expr {$l+1}] - [expr {$k+1}]  :\t $bonclid"
                if {[info exists groupe_ordre]} {
                    lappend S(euclist_doc) "$bonclid [expr {$S(n) + $l}] [expr {$S(n) + $k}] $groupe_ordre $groupe_ordre"
                    #debug
                    #puts "EUCLI: (groupe $groupe_ordre) $l $k distance-w $bonclid >>> euclist_doc = $S(euclist_doc)"
                }
            }
            
            # Pour gérer les zeros (si on crée une vraie 'matrice' de distances)
            if {$l < [expr {$gro-1}]} {
                append zero " 0 "
                append tableucl $zero
            }
        }
        
        # Si on veut retourner une matrice des distances
        set matdist [concat 2 $gro $gro $tableucl]
        set matdist [transpose $matdist]
        # La matrice des distances (cfr. RETURN) est sous le format HUME
        # La LISTE des distances se trouve dans la variable globale S(euclist), remise à zero à chaque passage ici
        # debug
        # vert "\nPROCEDURE EUCLID $matdist\n\n"
        return $matdist
    }
    #
    # Procedure EUCLID - fin
    
    # Procedure DESCRIPTION-PROCR pop subdivision - debut
    #
    proc description-procr {pop subdivision} {
        
        global p S infile
        
        set effectifs $subdivision
        $p insert end "\nGroupes $subdivision\n"
        
        set colonnes [mcols $pop]
        set lignes [mrows $pop]
        
        # Le nombre de groupes dans la variable 'gr'
        # Les effectifs dans la variable indicee eff($gr) - aussi deja dans la liste 'effectifs' et/ou 'subdivision'
        set gr 0
        foreach item [split $subdivision] {
            incr gr
            set eff($gr) $item
        }
        
        # B prepare la table des moyennes
        set B "2 $gr $colonnes"
        # B prepare la table des variances
        set D "2 $gr $colonnes"
        #debug
        #puts "B (future table des moyennes) aura la structure 2 $gr $colonnes - Il y a $gr groupes"
        #puts "D (future table des variances) aura la structure 2 $gr $colonnes - Il y a $gr groupes"
        
        
        # - - - - - - - - - - - - - - - - - - - - - - -
        # SEPARER LA MATRICE DE CHAQUE GROUPE - -  + varcov + moyennes - - - start - -
        # - - - - - - - - - - - - - - - - - - - - - - -
        set compte 0
        set correction 0
        set x-subd ""; # superliste contenant les differentes sous-matrices
        foreach item [split $subdivision] {
            set correction [expr {$correction + $item}]
            set newpop [mrange $pop 0 [expr {$colonnes-1}] [expr {$correction - $item}] [expr {$correction - 1}] ]
            lappend x_subd $newpop
            
            # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
            mnorms_br newpop newpopmeans newpopsigmas
            
            #
            # Appel a la Procedure VARCOV pour le calcul de la matrice des variances-covariances
            #
            set ZZ [varcov $newpop]
            #
            incr compte
            #arbol::rouge "\nSub-matrix $compte:\t [mrows $newpop] rows \t[mcols $newpop] cols\n"
            #arbol::bleu "\nVarCov Matrix of group $compte \n"
            #$p insert end "\n[show $ZZ %8.7f]\n\n"
            #
            # Ici, on prepare une table des moyennes de chaque variable de chaque sous-matrice
            # B contient au depart la description d'une matrice HUME
            set newpopmeans [lrange $newpopmeans 3 end]
            foreach item [split $newpopmeans] {lappend B $item}
            
            # Ici, on prepare une table des dev. std. de chaque variable de chaque sous-matrice
            # D contient au depart la description d'une matrice HUME
            set newpopsigmas [lrange $newpopsigmas 3 end]
            foreach item [split $newpopsigmas] {lappend D $item}
        }
        # - - - - - - - - - - - - - - - - - - - - - - -
        # SEPARER LA MATRICE DE CHAQUE GROUPE - - + varcov  + moyennes - - fin - -
        # - - - - - - - - - - - - - - - - - - - - - - -
        #
        # -------------------------
        # Table des moyennes
        # -------------------------
        variable newB
        global newB
        set newB ""
        foreach item [split $B] {lappend newB $item}
        #arbol::bleu "\nTable of means of each variable, in each group\n "
        #$p insert end "\n[show $newB %8.3f]\n"
        
        # -------------------------
        # Table des dev. std.
        # -------------------------
        variable newD
        set newD ""
        foreach item [split $D] {lappend newD $item}
        #arbol::bleu "\n\nTable of std. dev. of each variable, in each group\n"
        #$p insert end "\n[show $newD %8.3f]\n"
        
        $p insert end "\n\n"
        
        # S'il y a plus d'un groupe
        if {$gr > 1} {
            
            global newB
            #destroy $p.embed_procr
            #button $p.embed_procr -text "Procrustes distances" -command {
            set S(disfo) "";# pour nettoyer la liste non formatee des distances
            destroy $p.embed_eucl
            #
            set matdist [arbol::Procruste_nonEuclid  $newB]
            #
            #global subdivision; "already exists"
            # Nettoyage puisque 'append' quelque part plus bas
            set subdivision ""
            set elem [mrows  $newB]
            for {set subd 0} {$subd < $elem} {incr subd} {
                append subdivision "1 "
            }
            # Formater pour Phylip
            set procrdist ""
            arbol::vert "PROCRUSTES DISTANCES between groups, formatted to be introduced as infile by a PHYLIP module"
            append procrdist " [mrows $matdist]"
            arbol::bleu "\n [mrows $matdist]"
            for {set i 0} {$i < [mrows $matdist]} {incr i} {
                if {$i <10} {
                    append procrdist "\n_[expr {$i+1}]        [show [mrange $matdist 0 $i $i $i]]"
                    arbol::bleu "\n_[expr {$i+1}]        [show [mrange $matdist 0 $i $i $i]]"
                } else {
                    append procrdist "\n_[expr {$i+1}]       [show [mrange $matdist 0 $i $i $i]]"
                    arbol::bleu "\n_[expr {$i+1}]       [show [mrange $matdist 0 $i $i $i]]"
                }
            }
            
            
            
            arbol::rouge "\n\nYour attention please:"
            arbol::bleu "The distances matrix above has been computed without checking for the nature of the input\
                    variables."
            arbol::rouge "\nIf you wanted PROCRUSTES distances between group's mean shapes, you had to enter \
                    the raw coordinates (formatted by TET _ see COV -> HELP for formatting files)."
            $p insert end "\nThe file you entered was : \n$infile"
            
            $p see end
            
            $p insert end "\n\n---------------------------------------\
                    \nDistances as a list\n---------------------------------------\
                    \n$S(disfo)\
                    \n-------------- E N D ------------------\  \n"
            
            
            
            # Enregistrement de la matrice des distances procr - format PHYLIP
            set sub "_"
            set end ".txt"
            set quoi PROCRUSTESphylip
            set ajout $sub$quoi$end
            set S(infilesub) "[file root $infile]$ajout"
            #debug
            $p insert end "\n\n[file root $infile]\n\n"
            set fid [open $S(infilesub) w]
            #puts -nonewline $fid "Procrustes distances between rows, from $infile\n"
            puts -nonewline $fid $procrdist
            close $fid
            
            destroy $p.embed_procr
            #}
            #$p window create {end lineend} -window $p.embed_procr
            #bind $p.embed_procr <Motion> {$p.embed_procr configure -cursor hand1}
            
            arbol::rouge "\n\nYour attention please:"
            arbol::bleu "The distances matrix above has been computed without checking for the nature of the input\
                    variables."
            arbol::rouge "\nIf you wanted EUCLIDEAN distances between group's mean SHAPES, you had to enter \
                    the PARTIAL or RELATIVE WARPS"
            arbol::bleu "\nThe file you entered was : \n$infile\nThe output distances file is $S(infilesub)\n\n"
        }
        return $x_subd
    }
    #
    # Procedure DESCRIPTION-PROCR - fin
    
    # Procedure VARCOV - debut
    #
    proc varcov  {newpop} {
        
        set newcolonnes [mcols $newpop]
        set newlignes [mrows $newpop]
        
        # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
        # IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
        set popones "2 1 $newcolonnes 1"
        set x 1
        set y $newcolonnes
        while {$x < $y} {lappend popones 1; set x [expr {$x + 1} ] }
        
        # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
        mnorms_br newpop newpopmeans newpopsigmas
        
        # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
        set Z [mnormalize $newpop $newpopmeans $popones]
        #
        set div [expr {$newlignes -1}]
        set scale [expr {1.0 / $div}]
        #
        # MATRICE des VARIANCES - COVARIANCES du GROUPE
        set ZZ [mmult [transpose $Z] $Z]
        set ZZsc [mscale $ZZ $scale]
        return $ZZsc
    }
    #
    # Procedure VARCOV - fin
    
};# fin du NAMESPACE ARBOL

# SRIPT PRINCIPAL
#

global p drapeau S references version bID_Inter

set drapeau 1
set S(drapeau) 1

#set S(save) "_INFO_COV.txt"

# -----------------------------------------------------------------------------
# FENETRE PRESENTATION de la MATRICE (procedure mod)
# ------------------------------------------------------------------------------
#
global p S x_subd x_total
#
set fp .estrade
catch {destroy $fp}
catch {toplevel .estrade}
wm state . withdrawn
#
set titre "tree versiontree $versiontree"
wm title .estrade $titre
wm geometry $fp 800x300+50+10
#
set scb [scrollbar .estrade.scrollA -command ".estrade.debut yview"]
pack $scb -side left -fill y
#


# frame pour boutons
frame .estrade.f
pack .estrade.f -fill x
button .estrade.f.njplot -text "NJPLOT" -command arbol::njplotte
button .estrade.f.name -text "Names for OTUs" -command arbol::qui
button .estrade.f.save -fg blue -text "Save report as: filename._treeINFO.txt" -command arbol::savelisting
button .estrade.f.xxit -text "CANCEL" -command {destroy .estrade .question}
pack .estrade.f.xxit .estrade.f.save .estrade.f.name  .estrade.f.njplot  -side right -expand yes -fill x
#
set pres [text .estrade.debut -background "light grey" -font "courier 12" \
        -wrap word -yscrollcommand ".estrade.scrollA set"]
pack $pres -side right -fill both -expand yes
#
set p $pres
#
set x_total [arbol::whichmatrix]
#set x_total $mdonnees
#
destroy .question
toplevel .question
wm geometry .question +300+300
wm title .question "group sizes"
label .question.l -text "Subdivision ? \n------------- \nGroup sizes separated by space, \nthen press 'Enter'"
entry .question.groupe -textvariable subdivision
pack .question.l .question.groupe -side top
focus .question.groupe

bind .question.groupe <Return> {
    global x_subd
    # les groupes (sous-matrices) seront rassembles dans une (super)liste x_subd
    #
    set x_subd [arbol::description-procr $x_total $subdivision]
    #
    destroy .question
    arbol::phylip
}



