# La package (C)Copyright 2001, Hume Integration Software
# The La package software is being distributed under terms and conditions similar to Tcl/Tk.  The author is providing the package software to the Tcl community as a returned favor for the value of packages received over the years.
# The La package software is copyrighted by Hume Integration Software. The following terms apply to all files associated with the software unless explicitly disclaimed in individual files.
# The authors hereby grant permission to use, copy, modify, distribute, and license this software and its documentation for any purpose, provided that existing copyright notices are retained in all copies and that this notice is included verbatim in any distributions. No written agreement, license, or royalty fee is required for any of the authorized uses. Modifications to this software may be copyrighted by their authors and need not follow the licensing terms described here, provided that the new terms are clearly indicated on the first page of each file where they apply.
# IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
# GOVERNMENT USE: If you are acquiring this software on behalf of the U.S. government, the Government shall have only "Restricted Rights" in the software and related documentation as defined in the Federal Acquisition Regulations (FARs) in Clause 52.227.19 (c) (2).  If you are acquiring the software on behalf of the Department of Defense, the software shall be classified as "Commercial Computer Software" and the Government shall have only "Restricted Rights" as defined in Clause 252.227-7013 (c) (1) of DFARs.  Notwithstanding the foregoing, the authors grant the U.S. Government and others acting in its behalf permission to use and distribute the software in accordance with the terms specified in this license.


# $Header: /usr/cvsroot/la/la.tcl,v 1.3 2001/11/14 13:27:35 hume Exp $
#
# La == Linear Algebra and similar math
#
# Part of the La Package
# (C)Copyright 2001, Hume Integration Software
#
# $Log: la.tcl,v $
# Revision 1.3  2001/11/14 13:27:35  hume
# Changed Services to Software.
#
# Revision 1.2  2001/07/12 23:59:51  hume
# Added K proc and boosted performance bigtime!
#
# Revision 1.1.1.1  2001/07/12 15:50:16  hume
# Initial check-in.
#
#
#
#
# Package scope and addressed requirements:
#

# Procedures cover manipulation of vectors and matrices such as
# scaling, concatenation by rows or columns, subsetting by
# rows or columns, formatted printing, transpose, dot product,
# matrix multiplication, solution of linear equation sets,
# matrix inversion, and eigenvalue/eigenvector solutions.
# The user can mix vectors and arrays in linear algebra operations.
# The logic does reasonable conversion of types.
# Sophisticated operations such as evaluating a custom procedure
# against each element of a matrix are easily possible.
#
# There are typically two calls for a procedure.  A plainly
# named procedure such as "transpose", and another procedure
# with the suffix "_br" such as "transpose_br".  The plainly
# named procedures expect their data arguments to be passed
# by value, which is the usual argument passing convention with
# Tcl programming.  The plain calls are designed for ease of
# interactive use, and in general have been coded to perform
# more conversion of arguments, more error checking, and to
# trade off efficiency for convenience.  The "_br" procedures
# a