# Procedure LOADFILE_CS - debut
#
proc loadfile_cs {pathname} {
    global S
    global text data references premligne
    set fid [open $pathname]
    set text [read -nonewline $fid]
    
    close $fid
    set rowcount 0
    set colcount 0
    
    set compteur 0
    set lignes 0
    set data ""
    # Au cas ou le fichier de donnees contient les tailles centroides
    # la premiere valeur (deuxieme ligne) pourrait etre le consensus
    if {$S(cs) == 1} {set seuil [trebuche]} else {set seuil 1}
    foreach line [split $text \n] {
        incr compteur
        if {$compteur > $seuil} {
            if  {$line != ""} {
                set colcount [llength $line]
            }
        }
        if {$compteur > $seuil} {
            foreach item [split $line] { if {$item != ""} {
                    incr lignes;lappend data $item
                }
            }
        } else {append premligne "SAMPLE INFO: $line\n"}
    }
    set rowcount [expr $lignes/$colcount]
    set result [concat 2 $rowcount $colcount $data]
    set references $premligne
    return $result
}
#
# Procedure LOADFILE_CS - fin

# Procedure ALOCS - debut
#
proc alocs {} {
    global sentier
    # On va chercher les donnees de la taille centroide dans le dernier dossier utilise
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
    }
    set infile_cs [tk_getOpenFile -filetypes $typeList -initialdir $sentier]
    
    
    # usage de loadfile_cs pour chercher les donnees
    set pop_cs [loadfile "$infile_cs"]
    bleu "\n\nArchivo"
    rouge "\t$infile_cs"
    bleu "\nComentario"
    rouge "\n$references\n\n"
    bleu "\nDatos son:\tcentroid size\ttamano centroide\ttaille centroide"
    bleu "\n----------------- - - - - - - - - - - -----------------\n"
    bleu "\nDatos, en parte:\n"
    $p insert end "[show [mrange $pop_cs 0 0 0 3]]\n..."
    
    
    #####################################
    # JE PREPARE LA REGRESSION
    #####################################
    set cv1 ""
    set cv2 ""
    foreach item $individus {
        lappend cv1 [lrange $item 3 3]
        lappend cv2 [lrange $item 4 4]
    }
    set size $pop_cs
    
    #regresse $cv1 size
    #####################################
    # J'AI FINI DE PREPARER LA REGRESSION
    #####################################
    set avis "La palabra 'SIZE' para el eje horizontal se aplica\
            si el archivo [file tail $infile_cs] contiene los tamanos centroide,\
            \n\nLe mot 'SIZE' de l'abscisse ne s'applique que si le fichier\
            \n [file tail $infile_cs] contient les tailles centroides\
            \n\n'SIZE' is size because it is assumed that [file tail $infile_cs] contains centroid size"
    affiche 770 134 $avis
    picasso
    global magritte
    set numero 1
    regresse $cv1 $size
}
#
# Procedure ALOCS - fin
