# COPYRIGHTS

# Jean-Pierre Dujardin
# The jpdidac software is copyrighted by Jean-Pierre Dujardin, 2002, Unité de Recherches 062- Unité Mixte de Recherches UMR9926, Institut de Recherches pour le Développement (IRD, France).
# jpdidac is provided under the GPL license'
# Institut de Recherches pour le Développement.
# L'IRD (Institut de Recherches pour le Développement) représenté par Madame Marianne BERTHOD-WURMSER, Directrice du DEV, déclare par la présente ne pas revendiquer de droits patrimoniaux du programme jpdidac.tcl réalisé par Jean-Pierre Dujardin et l'autorise ainsi à en assurer la diffusion sous licence GPL (http://www.fsf.org/copyleft/gpl.html).

# VERSION DU JPDIDAC
# v001

font create onlist -family courier -size 12 -weight normal -slant roman
font create onsearch -family courier -size 12 -weight normal -slant roman
font create onsearchagain -family courier -size 12 -weight normal -slant roman
font create onchange -family courier -size 12 -weight bold -slant italic
font create ontitle -family courier -size 14 -weight normal -slant italic
font create vueglobale -family courier -size 12 -weight normal -slant roman
    
# colle #
proc colle {affiche} {

set did1 .texto
catch {destroy $did1}
toplevel $did1
wm title $did1 "ETAPA"
wm iconname $did1 "text"
wm geometry $did1 +40+200
frame $did1.buttons
pack $did1.buttons -side bottom -fill x -pady 2m
button $did1.buttons.salir -text SALIR -command "destroy $did1"
pack $did1.buttons.salir -side left -expand 1
text $did1.text -wrap word -font onlist -relief sunken -bd 2 \
        -yscrollcommand "$did1.scroll set" -setgrid 1 -width 100 -height 10
scrollbar $did1.scroll -command "$did1.text yview"
pack $did1.scroll -side right -fill y
pack $did1.text -expand yes -fill both
$did1.text insert end [show $affiche %8.4f]
#$did1.text insert end $affiche
}
####### colle #

# cloue #
proc cloue {affiche} {
    set did1 .texte
    catch {destroy $did1}
    toplevel $did1
    wm title $did1 "ETAPA"
    wm iconname $did1 "text"
    wm geometry $did1 20x20+20+120
    frame $did1.buttons
    pack $did1.buttons -side bottom -fill x -pady 2m
    button $did1.buttons.salir -text SALIR -command "destroy $did1"
    pack $did1.buttons.salir -side left -expand 1
    text $did1.text -wrap word -font onlist -relief sunken -bd 2 \
            -yscrollcommand "$did1.scroll set" -setgrid 1 -height 10
    scrollbar $did1.scroll -command "$did1.text yview"
    pack $did1.scroll -side right -fill y
    pack $did1.text -expand yes -fill both
    foreach item $affiche {$did1.text insert end "\n$item"}
}
####### cloue #


####################  residalom #### procedure ## DEBUT
proc residalom {} {
    
    global prepop shapepop pop axeX did
    set did .textconforme
    catch {destroy $did}
    toplevel $did
    wm title $did "Etapas y comentarios"
    wm iconname $did "text"
    wm geometry $did 115x35+10+10
    
    proc heading {mesg args} {
        global did
        $did.text insert end $mesg "heading"
    }
    proc body {mesg args} {
        global did
        $did.text insert end $mesg "body"
    }
    global linkNum
    set linkNum 0
    proc greenlink {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground green -underline 0
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground green"
        $did.text tag bind $tag <ButtonPress> "colle $[lindex $linkCode 0]"
    }
    proc bluelink {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground blue -underline 0
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground blue"
        $did.text tag bind $tag <ButtonPress> "cloue $[lindex $linkCode 0]"
    }
    proc lucarne {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground orange -underline 0
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground orange"
        $did.text tag bind $tag <ButtonPress> "[lindex $linkCode 0]"
    }
    
    
    if {[winfo depth $did] > 1} {
        set bold "-background #43ce80 -relief raised -borderwidth 1"
        set normal "-background {} -relief flat"
    } else {
        set bold "-foreground blue -background white -relief raised -borderwidth 1"
        set normal "-foreground {} -background {}"
    }
    
    
    frame $did.buttons
    pack $did.buttons -side bottom -fill x -pady 2m
    button $did.buttons.salir -text SALIR -command "destroy $did"
    #button $w.buttons.code -text "See Code" -command "showCode $w"
    pack $did.buttons.salir -side left -expand 1
    
    text $did.text -wrap word -font onlist -relief sunken -bd 2 -yscrollcommand "$did.scroll set" \
            -setgrid 1 -height 10 -cursor arrow
    scrollbar $did.scroll -command "$did.text yview"
    pack $did.scroll -side right -fill y
    pack $did.text -expand yes -fill both
    
    heading "\nAlometria residual\n\n"
    body "\tNo es porque se dice que se ha retirado el tamano que se ha logrado hacerlo completamente ...\
            Ademas, hay muchas maneras de retirar el tamano, simplemente porque este ultimo se puede evaluar de varias maneras ...\
            Por consecuencia, siempre se tiene que verificar si la conformacion que hemos extraido de los datos \
            es realmente independiente del tamano tal como lo hemos definido"
    body "\n\tEn estadistica, una relacion de dependencia entre dos variables continuas se aprecia por un analisis de regresion. \
            Tenemos una sola variable para el tamano (segun la definicion del cambio isometrico de tamano)\
            pero tenemos muchos componentes de conformacion. Podriamos hacer un analisis de regresion multiple.\
            Podemos tambien tratar de reducir la conformacion a una o dos variables analizadas separadamente."
    body "\n\tEl interés de hacer un análisis discriminante, es que generalmente tiene menos \
            factores (CV1, CV2, etc.) que el ACP, asi que podemos verificar mas fácilmente \
            y 'a posteriori' la relación entre el factor mas discriminante y la variable de \
            tamaño.\n\tDe esta manera, verificamos si la discriminación principal le debe mucho \
            todavía a possibles diferencias de crecimiento, y hallamos una información indirecta \
            sobre la alometría.
            \n\tEn la grafica, CV1 o CV2 se refieren al primero o segundo factor canónico derivado \
            del análisis discriminante sobre los "
    greenlink "componentes de conformacion" pop
    body ", y SIZE se refiere a la variable de tamano global, estimada como el cambio \
            isometrico de tamano (un cambio que se resume a un solo coefficiente por \
            individuo).
    \nExplicamos aqui los antecedentes a este analisis y el sentido de esta regresion.
    \nEtapa 1: se transforman las variables en logaritmos.
    \nEtapa 2: calculamos el"
    
    bluelink " tamaño" axeX
    
    body " de cada individuo como el promedio de sus caracteres
    \nEtapa 3: calculamos las variables de conformación.\n\n"
    
    lucarne "Etapa 4: producimos los componentes de conformacion " conforme
    
    body "haciendo un ACP sobre las variables de conformacion.\n"
    
    lucarne "Etapa 5 Analisis discriminante" discrimine
    
    body " - El input del analisis discriminante es el juego de COMPONENTES DE CONFORMACIÓN \
            EXCEPTO EL ULTIMO. En funcion a los tamanos muestrales, se puede seleccionar un \
            numero menor de componentes conociendo exactamente cual es la contribucion del \
            juego seleccionado a la variacion total de la conformacion.
            \nEtapa 6: Verificamos con una simple regresion lineal (ver la grafica) si \
                    el cambio de tamano explica mucho de la variacion de las funciones \
                    discriminantes."
    
    $did.text mark set insert 0.0
    
    $did.text tag configure heading -spacing1 0.1i -spacing3 5 \
            -font ontitle
    $did.text tag configure greenlink -foreground "dark green"
    $did.text tag configure redlink -foreground red
    $did.text tag configure body -background white -foreground black
    $did.text tag configure d1 -font Helvetica
    $did.text tag configure d2 -font Helvetica
    $did.text tag configure d3 -font Helvetica
    $did.text tag configure d4 -font Helvetica
    
    
    
    $did.text tag bind d1 <1> {
        set d "d1"
        set affiche $prepop
        colle $affiche $d
    }
    
    $did.text tag bind d2 <1> {
        set d "d2"
        set affiche $shapepop
        colle $affiche $d
    }
    
    $did.text tag bind d3 <1> {
        set d "d3"
        set affiche $pop
        colle $affiche $d
    }
    
    $did.text tag bind d4 <1> {
        set d "d4"
        set affiche $axeX
        cloue $affiche $d
    }
}


####################  residalom #### procedure ## FIN


####################  residalocs #### procedure ## DEBUT
proc residalocs {} {
    
    global prepop shapepop pop axeX did
    set did .textconforme
    catch {destroy $did}
    toplevel $did
    wm title $did "Etapas y comentarios"
    wm iconname $did "text"
    wm geometry $did 115x35+10+10
    
    proc heading {mesg args} {
        global did
        $did.text insert end $mesg "heading"
    }
    proc body {mesg args} {
        global did
        $did.text insert end $mesg "body"
    }
    global linkNum
    set linkNum 0
    proc greenlink {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground green -underline 0
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground green"
        $did.text tag bind $tag <ButtonPress> "colle $[lindex $linkCode 0]"
    }
    proc bluelink {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground blue -underline 0
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground blue"
        $did.text tag bind $tag <ButtonPress> "cloue $[lindex $linkCode 0]"
    }
    proc lucarne {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground orange -underline 0
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground orange"
        $did.text tag bind $tag <ButtonPress> "[lindex $linkCode 0]"
    }
    
    
    if {[winfo depth $did] > 1} {
        set bold "-background #43ce80 -relief raised -borderwidth 1"
        set normal "-background {} -relief flat"
    } else {
        set bold "-foreground blue -background white -relief raised -borderwidth 1"
        set normal "-foreground {} -background {}"
    }
    
    
    frame $did.buttons
    pack $did.buttons -side bottom -fill x -pady 2m
    button $did.buttons.salir -text SALIR -command "destroy $did"
    #button $w.buttons.code -text "See Code" -command "showCode $w"
    pack $did.buttons.salir -side left -expand 1
    
    text $did.text -wrap word -font onlist -relief sunken -bd 2 -yscrollcommand "$did.scroll set" \
            -setgrid 1 -height 10 -cursor arrow
    scrollbar $did.scroll -command "$did.text yview"
    pack $did.scroll -side right -fill y
    pack $did.text -expand yes -fill both
    
    heading "\nAlometria residual\n\n"
    body "\tLos PW ('partial warps') o deformaciones parciales representan los desplazamientos de LM ('landmarks)\
            o 'puntos anatomicos' en relacion a la posicion de los mismos sobre la configuracion consenso.\
            Previamente, las coordenadas de cada LM han sido corregidas por los efectos de posicion,\
            de orientacion y de tamano. El tamano que se ha removido es el cambio isometrico (es decir. \
            traducido por un solo coeficiente) de un objeto al otro.\
            \nEsta remocion no toma en cuenta el cambio 'natural' de tamano entre organismos biologicos,\
            que es un cambio alometrico (cada parte anatomica crece segun un coeficiente propio).\
            Por consecuencia, los PW no estan libres de efectos alometricos, los cuales pueden ser\
            poco o muy importantes."
            body "\n\tEn estadistica, una relacion de dependencia entre dos variables continuas se aprecia por un analisis de regresion. \
                    Tenemos una sola variable para el tamano (el 'centroid size' en morfometria geometrica)\
                    pero tenemos muchos componentes de conformacion (los 'PW')). \
                    \nPodriamos hacer un analisis de regresion multivariado (ver el futuro programa COV).\
            \nPodemos tambien tratar de reducir la conformacion a una o dos variables analizadas separadamente."
    body "\n\tEl interés de hacer un análisis discriminante, es que generalmente tiene menos \
            factores (CV1, CV2, etc.) que el ACP, asi que podemos verificar mas fácilmente \
            y 'a posteriori' la relación entre el factor mas discriminante y la variable de \
            tamaño.\n\tDe esta manera, verificamos si la discriminación principal le debe mucho \
            todavía a possibles diferencias de crecimiento, y hallamos una información indirecta \
            sobre la alometría.
            \n\tEn la grafica, CV1 o CV2 se refieren al primero o segundo factor canónico derivado \
                    del análisis discriminante sobre los 'PARTIAL WARPS', o los 'RESIDUOS PROCRUSTEANOS' \
                    (aligned specimens)"
    #greenlink "componentes de conformacion" pop
    body ", y SIZE se refiere a la variable de tamano global, estimada como el cambio \
            isometrico de tamano (un cambio que se resume a un solo coefficiente por \
            individuo, el 'CENTROID SIZE')."

    
    $did.text mark set insert 0.0
    
    $did.text tag configure heading -spacing1 0.1i -spacing3 5 \
            -font ontitle
    $did.text tag configure greenlink -foreground "dark green"
    $did.text tag configure redlink -foreground red
    $did.text tag configure body -background white -foreground black
    $did.text tag configure d1 -font Helvetica
    $did.text tag configure d2 -font Helvetica
    $did.text tag configure d3 -font Helvetica
    $did.text tag configure d4 -font Helvetica
    
    
    
    $did.text tag bind d1 <1> {
        set d "d1"
        set affiche $prepop
        colle $affiche $d
    }
    
    $did.text tag bind d2 <1> {
        set d "d2"
        set affiche $shapepop
        colle $affiche $d
    }
    
    $did.text tag bind d3 <1> {
        set d "d3"
        set affiche $pop
        colle $affiche $d
    }
    
    $did.text tag bind d4 <1> {
        set d "d4"
        set affiche $axeX
        cloue $affiche $d
    }
}


####################  residalocs #### procedure ## FIN

####################  conforme #### procedure ## DEBUT
proc conforme {} {
    
global prepop shapepop pop axeX did
set did .textconforme
catch {destroy $did}
toplevel $did
wm title $did "Etapas y comentarios"
wm iconname $did "text"
wm geometry $did 115x35+10+10

        proc heading {mesg args} {
            global did
            $did.text insert end $mesg "heading"
        }
        proc body {mesg args} {
            global did
            $did.text insert end $mesg "body"
        }
        global linkNum
        set linkNum 0
        proc greenlink {mesg linkCode args} {
            global did linkNum prepop shapepop pop axeX
            set tag "link[incr linkNum]"
            $did.text insert end $mesg [list body $tag]
            $did.text tag configure $tag -foreground green -underline 0
            $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
            $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground green"
            $did.text tag bind $tag <ButtonPress> "colle $[lindex $linkCode 0]"
        }
        proc bluelink {mesg linkCode args} {
            global did linkNum prepop shapepop pop axeX
            set tag "link[incr linkNum]"
            $did.text insert end $mesg [list body $tag]
            $did.text tag configure $tag -foreground blue -underline 0
            $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
            $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground blue"
            $did.text tag bind $tag <ButtonPress> "cloue $[lindex $linkCode 0]"
        }
        proc lucarne {mesg linkCode args} {
            global did linkNum prepop shapepop pop axeX
            set tag "link[incr linkNum]"
            $did.text insert end $mesg [list body $tag]
            $did.text tag configure $tag -foreground orange -underline 0
            $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
            $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground orange"
            $did.text tag bind $tag <ButtonPress> "[lindex $linkCode 0]"
        }


if {[winfo depth $did] > 1} {
    set bold "-background #43ce80 -relief raised -borderwidth 1"
    set normal "-background {} -relief flat"
} else {
    set bold "-foreground blue -background white -relief raised -borderwidth 1"
    set normal "-foreground {} -background {}"
}


    frame $did.buttons
    pack $did.buttons -side bottom -fill x -pady 2m
    button $did.buttons.salir -text SALIR -command "destroy $did"
    #button $w.buttons.code -text "See Code" -command "showCode $w"
    pack $did.buttons.salir -side left -expand 1
    
    text $did.text -wrap word -font onlist -relief sunken -bd 2 -yscrollcommand "$did.scroll set" \
            -setgrid 1 -height 10 -cursor arrow
    scrollbar $did.scroll -command "$did.text yview"
    pack $did.scroll -side right -fill y
    pack $did.text -expand yes -fill both
    

    
    heading "\nLa conformacion (shape)\n\n"

    body "Los conceptos teóricos sobre los cuales se basan la eliminación del tamaño isométrico en morfometría tradicional se deben a Mosimann (1970), Mosimann & James (1979) y Darroch & Mosimann (1985).
                
                En forma muy resumida, para un conjunto de variables denominado X, y una variable de tamaño global T, la (variable de) conformación C se define a la manera de una proporción:
                
                C = X/T
                
                Si tomamos el logaritmo de las variables, obtenemos:
                
                log (C) = log (X/T) = log (X) - log (T)
                
                
                Haciendo pues una simple sustracción {log (X) - log (T)}, y a la condición de que las variables iniciales hayan sido previamente transformadas en logaritmos eliminaremos en morfometría tradicional el tamaño isométrico de las variables iniciales.
                "
    body "\n\n\tDe la lista de las"
    greenlink " variables iniciales" prepop
    body " se ha retirado una"
    bluelink " variable de tamano (T)" axeX
    body "\n\tT para un individuo puede ser el promedio de las variables definiendo este individuo, o puede ser otra formula similar.
                
                
                Variables iniciales (ejemplo ficticio), transformadas en logaritmo, y calculo del tamaño isométrico.
                
                Individuos\tvble1\tvble2\tvble3\tvble4\tcalculo del tamaño
                        \tlog\tlog\tlog\tlog\tisométrico
                -------------------------------------------------------------------------------------------------------------
                Individuo 1\t3\t4\t2\t6\t(3+4+2+6)/4 = 3.75
                Individuo 2\t4\t5\t2\t7\t(4+5+2+7)/4 = 4.50
                Individuo 3\t5\t6\t3\t8\t(5+6+3+8)/4 = 5.50
                -------------------------------------------------------------------------------------------------------------
                
                Calculo de las"
    greenlink " variables de conformación" shapepop
                
    body "\n\t\tIndividuos\tvble1\t\tvble2\t\tvble3\t\tvble4\t\ttamaño
                        \tlog\t\tlog\t\tlog\t\tlog\t\tisométrico
                -------------------------------------------------------------------------------------------------------------
                Individuo 1	3-3.75 = -0.75\t4-3.75 = 0.25\t2-3.75 = -1.75\t6-3.75 = 2.25\t3.75
                Individuo 2	4-4.50 = -0.50\t5-4.50 = 0.50\t2-4.50 = -2.50\t7-4.50 = 2.50\t4.50
                Individuo 3	5-5.50 = -0.50\t6-5.50 = 0.50\t3-5.50 = -2.50\t8-5.50 = 2.50\t5.50
                ------------------------------------------------------------------------------------------------------------
            "
    body "\tEn las TABLAS arriba, done eliminamos el tamaño isométrico entre 3 individuos definidos por 4 variables.
                - Observamos que después de retirar el tamaño isométrico, los individuos 2 y 3 de tamaño diferente tienen exactamente la misma conformación.
                - Observamos también una perdida de un grado de libertad. Efectivamente, si en la TABLA 10.5 se conocen tres de las cuatro variables de conformación, se puede predecir la cuarta porque la suma de las variables de conformación es siempre nula.
                
                Esto nos da un problema ¿ cuales de las variables de conformación elegir para luego hacer un análisis multivariado, por ejemplo un análisis discriminante ?
                
                Una solución (también utilizada en morfometría geométrica) es de hacer un análisis en componentes principales (ACP) sobre las variables de conformación: esto nos dará automáticamente un numero de componentes menos 1. En nuestro ejemplo de la TABLA 10.5, tendríamos tres componentes principales en vez de cuatro, porque el ultimo, cuarto componente principal, tiene una contribución nula a la variación total.
          "
     body "\tPodemos luego utilizar los componentes principales, llamados ahora"
     greenlink " componentes de conformación" pop
     body ", para hacer un análisis discriminante.

                ---------------
                               
                INTRODUCCION A LA MORFOMETRIA - Cap. 10 Tamaño, Conformación y Forma
                Jean-Pierre Dujardin
           "

$did.text mark set insert 0.0

    $did.text tag configure heading -spacing1 0.1i -spacing3 5 \
        -font ontitle
    $did.text tag configure greenlink -foreground "dark green"
    $did.text tag configure redlink -foreground red
    $did.text tag configure body -background white -foreground black
    $did.text tag configure d1 -font Helvetica
    $did.text tag configure d2 -font Helvetica
    $did.text tag configure d3 -font Helvetica
    $did.text tag configure d4 -font Helvetica
    
            
    $did.text tag bind d1 <1> {
        set d "d1"
        set affiche $prepop
        colle $affiche $d
        }
        
    $did.text tag bind d2 <1> {
        set d "d2"
        set affiche $shapepop
        colle $affiche $d
        }
        
    $did.text tag bind d3 <1> {
        set d "d3"
        set affiche $pop
        colle $affiche $d
        }
            
    $did.text tag bind d4 <1> {
        set d "d4"
        set affiche $axeX
        cloue $affiche $d
        }
}


####################  conforme #### procedure ## FIN







####################  discrimine #### procedure ## DEBUT
proc discrimine {} {
    
    global prepop shapepop pop axeX did
    set did .textdiscrimine
    catch {destroy $did}
    toplevel $did
    wm title $did "Analisis discriminante"
    wm iconname $did "text"
    wm geometry $did 115x35+10+10
    
    proc heading {mesg args} {
        global did
        $did.text insert end $mesg "heading"
    }
    proc body {mesg args} {
        global did
        $did.text insert end $mesg "body"
    }
    global linkNum
    set linkNum 0
    proc greenlink {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground green -underline 1
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground green"
        $did.text tag bind $tag <ButtonPress> "colle $[lindex $linkCode 0]"
    }
    proc bluelink {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground blue -underline 1
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground blue"
        $did.text tag bind $tag <ButtonPress> "cloue $[lindex $linkCode 0]"
    }
    proc lucarne {mesg linkCode args} {
         global did linkNum prepop shapepop pop axeX
         set tag "link[incr linkNum]"
         $did.text insert end $mesg [list body $tag]
         $did.text tag configure $tag -foreground orange -underline 0
         $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
         $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground orange"
         $did.text tag bind $tag <ButtonPress> "[lindex $linkCode 0]"
    }
    
    
    if {[winfo depth $did] > 1} {
        set bold "-background #43ce80 -relief raised -borderwidth 1"
        set normal "-background {} -relief flat"
    } else {
        set bold "-foreground blue -background white -relief raised -borderwidth 1"
        set normal "-foreground {} -background {}"
    }
    
    
    frame $did.buttons
    pack $did.buttons -side bottom -fill x -pady 2m
    button $did.buttons.salir -text SALIR -command "destroy $did"
    #button $w.buttons.code -text "See Code" -command "showCode $w"
    pack $did.buttons.salir -side left -expand 1
    
    text $did.text -wrap word -font onlist -relief sunken -bd 2 -yscrollcommand "$did.scroll set" \
            -setgrid 1 -height 10 -cursor arrow
    scrollbar $did.scroll -command "$did.text yview"
    pack $did.scroll -side right -fill y
    pack $did.text -expand yes -fill both
    
    
    
    heading "\nAnalisis discriminante\n\n"
    body "\n(Las etapas mencionadas abajo son las descritas en la ayuda del software NTSYS (Rohlf) para el analisis discriminante.\n"

    body "\n\nEtapa 1\n\
        . se calcula la matriz B (B, para 'between') de varianza-covarianza ('matriz VCV') \
        de la tabla de promedios; otra manera de calcular B, es de hacer T-W, con T matriza de VCV total, y W ver Etapa 2"

    body "\n\nEtapa 2\n\
    . se calcula la matriz VCV consenso entre grupos: es la matriz W (W, para 'within') \
            estimada en base a las matrices VCV correspondiendo a los diferentes grupos"

    body "\n\nEtapa 3\n\
    . se hace un ACP sobre esta matriz W; hay un nivel mínimo bajo el cual \
            los eigenvectores pueden ser descartados"

    body "\n\nEtapa 4\n\
    . los eigenvectores E se ajustan de manera a que su longitud sea igual a \
        1/raiz(lambda_i) \
        con lambda_i el eigenvalue del componente i \
        J. Rohlf, 17 de Junio 2002: Note that the scaling is so that the length of the vectors \
             equal 1/sqrt(lambda). The length of a vector is the square root of the sum \
             of squared elements. \
             (In your scaling the sum of squared elements equaled 1/sqrt(lambda) so the length is then \
              sqrt(1/sqrt(lambda)). Too many square roots!)"

    body "\n\nEtapa 5\n\
    . se calcula la matriz VCV estandardizada entre grupos\
        B = EtBE (con Et la matriz transpuesta de E)"

    body "\n\nEtapa 6\n\
    . se hace un ACP sobre esta matriz. E* son sus eigenvectores"

    body "\n\nEtapa 7\n\
        . se calcula la matriz de los vectores canónicos (C): C = EE*\n\
        La tabla del valor de cada individuo para cada factor discriminante se consigue multiplicando la matriz de datos por la matriz C\n\
        Son los factores canonicos"

    body "\n\nEtapa 8\n\
        . se calcula la matriz de los escores canónicos (P): P = (Yg - Yt)C\n\
        con Yg el promedio del grupo ('group mean') e Yt el promedio total ('grand mean')\n\
        P es la tabla de las proyecciones de los promedios (promedio de cada grupo) sobre los factores discriminantes\n\
        (las distancias - Etapa 9 - se calculan entre estos puntos llamados centroides)"

    body "\n\nEtapa 9\n\
        . se calculan las distancias generalizadas (Mahalanobis): \
        son las distancias Euclidianas entre escores canónicos, aqui entre los centroides.\n"

    body "\n\nNota\nSe pueden agregar datos A POTERIORI - cfr boton {Datos externos} o el boton {CCC}-, \
        datos que se pueden proyectar sobre el mapa factorial utilizando el modelo estimado \
        sin ellos, para examinar sus relaciones con los grupos estudiados"
    
    $did.text mark set insert 0.0
    
    $did.text tag configure heading -spacing1 0.1i -spacing3 5 \
            -font ontitle
    $did.text tag configure greenlink -foreground "dark green"
    $did.text tag configure redlink -foreground red
    $did.text tag configure body -background white -foreground black
    $did.text tag configure d1 -font Helvetica
    $did.text tag configure d2 -font Helvetica
    $did.text tag configure d3 -font Helvetica
    $did.text tag configure d4 -font Helvetica
    
    
    
    $did.text tag bind d1 <1> {
        set d "d1"
        set affiche $prepop
        colle $affiche $d
    }
    
    $did.text tag bind d2 <1> {
        set d "d2"
        set affiche $shapepop
        colle $affiche $d
    }
    
    $did.text tag bind d3 <1> {
        set d "d3"
        set affiche $pop
        colle $affiche $d
    }
    
    $did.text tag bind d4 <1> {
        set d "d4"
        set affiche $axeX
        cloue $affiche $d
    }
}


####################  discrimine #### procedure ## FIN






####################  datosext #### procedure ## DEBUT
proc datosext {} {
    
    global did
    set did .textdatosext
    catch {destroy $did}
    toplevel $did
    wm title $did "Datos addicionales, externos al analisis - Supplementary data"
    wm iconname $did "text"
    wm geometry $did 115x35+10+10

    frame $did.buttons
    pack $did.buttons -side bottom -fill x -pady 2m
    button $did.buttons.salir -text SALIR -command "destroy $did"
    pack $did.buttons.salir -side left -expand 1
    
    text $did.text -wrap word -font onlist -relief sunken -bd 2 -yscrollcommand "$did.scroll set" \
            -setgrid 1 -height 10 -cursor arrow
    scrollbar $did.scroll -command "$did.text yview"
    pack $did.scroll -side right -fill y
    pack $did.text -expand yes -fill both


    proc heading {mesg args} {
        global did
        $did.text insert end $mesg "heading"
    }
    proc body {mesg args} {
        global did
        $did.text insert end $mesg "body"
    }
    global linkNum
    set linkNum 0
    proc greenlink {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground green -underline 1
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground green"
        $did.text tag bind $tag <ButtonPress> "colle $[lindex $linkCode 0]"
    }
    proc bluelink {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground blue -underline 1
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground blue"
        $did.text tag bind $tag <ButtonPress> "cloue $[lindex $linkCode 0]"
    }
    proc lucarne {mesg linkCode args} {
        global did linkNum prepop shapepop pop axeX
        set tag "link[incr linkNum]"
        $did.text insert end $mesg [list body $tag]
        $did.text tag configure $tag -foreground orange -underline 0
        $did.text tag bind $tag <Enter> "$did.text tag configure $tag -foreground red"
        $did.text tag bind $tag <Leave> "$did.text tag configure $tag -foreground orange"
        $did.text tag bind $tag <ButtonPress> "[lindex $linkCode 0]"
    }
    
    
    if {[winfo depth $did] > 1} {
        set bold "-background #43ce80 -relief raised -borderwidth 1"
        set normal "-background {} -relief flat"
    } else {
        set bold "-foreground blue -background white -relief raised -borderwidth 1"
        set normal "-foreground {} -background {}"
    }
    
 
    heading "\nDatos addicionales para un analisis discriminante\n\n"
    body "\nLos datos addicionales son de individuos que no hicieron parte \
            del analisis discriminante inicial, y que se quieren clasificar. \
            \nSe aplica para ellos el modelo del analisis discriminante construido sin ellos. \
            \nEstos individuos tienen que ser poco numerosos (menos numerosos que el numero de variables) \
            y presentar las mismas variables que las utilizadas para el analisis discriminante.
            \nSi se trata de un analisis de la conformacion, se entran los datos externos transformados a logaritmos, \
                    \nPAD: \
                    \n- calcula las variables de conformacion \
                    \n- utiliza los coeficientes del ACP inicial para producir"
    lucarne "componentes de conformacion" conforme
    body "          \n- selecciona el mismo numero de componentes guardados para el analisis inicial \
                    \n- utiliza los coeficientes del AD inicial para producir los valores de los datos externos sobre"
    lucarne "los factores discriminantes." discrimine
    
    body "\n\nSi se trata de un analisis de residuos Procrusteanos, se entran los datos externos \
            (producidos por MOG, u otro programa), \nPAD: \
            \n- utiliza los coeficientes del ACP inicial para producir los componentes de conformacion\
            \n- selecciona el mismo numero de componentes guardados para el analisis inicial \
            \n- utiliza los coeficientes del AD inicial para producir\
            los valores de los datos externos sobre los factores discriminantes"
    
    body "\n\nSi se trata de un analisis geometrico de la deformaciones relativas a un consenso, \
            \nse entran como datos externos los PARTIAL WARPS calculados separadamente por MOG (boton 'UNKNOWN')\
            \n Por ejemplo:\
            \n El analisis discriminante se hace sobre\t'datos_PW.txt'\
		    \n Los datos addicionales estan en \t'datos_PW_unknown.txt'"

    $did.text mark set insert 0.0
    
    $did.text tag configure heading -spacing1 0.1i -spacing3 5 \
            -font ontitle
    $did.text tag configure greenlink -foreground "dark green"
    $did.text tag configure redlink -foreground red
    $did.text tag configure body -background white -foreground black
    $did.text tag configure d1 -font Helvetica
    $did.text tag configure d2 -font Helvetica
    $did.text tag configure d3 -font Helvetica
    $did.text tag configure d4 -font Helvetica
    
    
    
    $did.text tag bind d1 <1> {
        set d "d1"
        set affiche $prepop
        colle $affiche $d
    }
    
    $did.text tag bind d2 <1> {
        set d "d2"
        set affiche $shapepop
        colle $affiche $d
    }
    
    $did.text tag bind d3 <1> {
        set d "d3"
        set affiche $pop
        colle $affiche $d
    }
    
    $did.text tag bind d4 <1> {
        set d "d4"
        set affiche $axeX
        cloue $affiche $d
    }
}


####################  datosext #### procedure ## FIN



#conforme
#datosext
#residalom

####################  didactique #### procedure ## debut
#proc didactique {} {

#    set pdg .pedagogique
#    catch {destroy $pdg}
#    toplevel $pdg
#    wm title $pdg "Datos addicionales - Supplementary data"
#    wm iconname $pdg "text"
    
#button $pdg.a -text "variables iniciales" -width 20 -height 1 -command "conforme"
#button $pdg.b -text "variables de conformacion" -width 20 -height 1 -command "vbleconf"
#button $pdg.c -text "componentes de conformacion" -width 20 -height 1 -command "compconf"
#button $pdg.d -text "D" -width 10 -height 1 -command ""
#button $pdg.e -text "E" -width 10 -height 1 -command ""
#button $pdg.f -text "F" -width 10 -height 1 -command ""

#pack $pdg.a $pdg.b $pdg.c $pdg.d $pdg.e $pdg.f -side top

#}

####################  didactique #### procedure ## fin

