#source /home/jeaduj/MyTcl/graph.tcl
#source L:/ased/SVD/graph.tcl
source 100La.tcl
#package require La
#namespace import La::*

global references

## FENETRE

global p
#toplevel .;## FENETRE PRINCIPALE, A DROITE DU MENU
#set p .
wm geometry . 600x530+198+10

frame .buttons;## EN BAS DE CETTE FENETRE, UNE FRAME POUR LOGER UN BOUTON
pack .buttons -side bottom -fill x -pady 2m

button .buttons.salir -text "Guardar el informe ?" -command {
    if {[info exists somm] == 1} {savelisting}
    }
## C'EST LE BOUTON
pack .buttons.salir -side left -expand 1

set scb [scrollbar .scrollA -command ".debut yview"];
## A GAUCHE DE LA FENETRE, UNE SCROLLBAR
pack $scb -side left -fill y

set pres [text .debut -background white -yscrollcommand ".scrollA set"];
## PUIS ENFIN LE TEXTE il n'est plus necessaire d'indiquer -SIDE, mais -FILL BOTH
pack $pres -fill both -expand 1

global lignes
global colonnes
set p .debut
## LE NOM DE LA SOUS-FENETRE DE TEXTE (.debut) DANS UNE VARIABLE (p)

update

## fin de la FENETRE PRINCIPALE

#######################loadfile# PROCEDURE ## DEBUT###
proc loadfile {pathname} {
    set fid [open $pathname]
    set text [read -nonewline $fid]
    close $fid
    set rowcount 0
    set colcount 0
    global references
    set compteur 0
    set lignes 0
    set data ""
    foreach line [split $text \n] {
        incr compteur
        if {$compteur ==2} {set colcount [llength $line]}
        if {$compteur>1} {
            foreach item [split $line] { if {$item != ""} {
                    incr lignes;lappend data $item
                }
            }
        } else {set references $line}
    }
    #set colcount [llength $line]
    set rowcount [expr $lignes/$colcount]
    set result [concat 2 $rowcount $colcount $data]
    return $result
}
########################loadfile# PROCEDURE ## FIN ###

###################################################################
proc  savelisting {} {
    # ***************************************************************
    # Tentative d'ecriture d'un fichier DE RAPPORT en CSV
    # ***************************************************************
    global p
    global infile
    set megainfo "\nFichier : $infile\n"
    set megatexte [$p get 1.0 {end -1c}]
    #OPEN A FILE FOR WRITING
    #set outputFile [open "L:/ased/outputfile.txt" "w"]
    # NAME THE FILE
    set file_types {
        {"Text Files" { .txt .TXT .nts} }
        {"All Files" * }
        }
    set filename [tk_getSaveFile -filetypes $file_types -initialdir \
            pwd -defaultextension .txt]
    wm title . $filename
    # OPEN THE FILE
    set fileid [open $filename w]
    # FILL THE FILE
    puts -nonewline $fileid $megainfo
    puts -nonewline $fileid "$megatexte"
    # CLOSE THE FILE
    close $fileid
}
###################################################################



#######################################################

# ----------------------------------------------------
# Nom du FICHIER et son CHEMIN (path) CORRESPONDANT
# ----------------------------------------------------
set typeList {
    {{All Files} {*.txt}}
    }
set infile [tk_getOpenFile -filetypes $typeList]
# --------------------------------------------------------
# USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE pop
# --------------------------------------------------------
set pop [loadfile "$infile"]
$p insert end "Poblacion examinada, parcialmente:\n[show [mrange $pop 0 1 0 5]]\n..."

# -------------------------------------------------
# QUELQUES STATISTIQUES SUR LA MATRICE pop UTILISEE
# -------------------------------------------------

# NOM DU FICHIER
$p insert end "$references\n"

# NOMBRE DE VARIABLES
set colonnes [mcols $pop]
$p insert end "\n"
$p insert end "\nNombre de variables =      $colonnes\n"

# NOMBRE D'INDIVIDUS
global lignes
set lignes [mrows $pop]
$p insert end "\nNombre d'individus =       $lignes"

# NOMBRE TOTAL DE CELLULES
set cellules [expr {$lignes * $colonnes}]

# MOYENNES ET DEVIATIONS STANDARD DES VARIABLES
mnorms_br pop popmeans popsigma
$p insert end "\n\nGrand Means\n[show $popmeans %8.4f]"
$p insert end "\n\nDeviations standards of the total\n[show $popsigma %8.4f]"

# CREER n-1 POUR CALCULER (plus tard) LES eigenvalues
set obsminusone [expr {$lignes - 1}]
#$p insert end "Nombre d'individus - 1 (soit "n-1") =  $obsminusone"

# ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
# IL SERVIRA POUR CREER UNE MATRICE CENTREE plutot que normalisee
set popones "2 1 $colonnes 1"
set x 1
set y $colonnes
while {$x < $y} {lappend popones 1; set x [expr $x + 1]}

# ----------------------------------------
# MATRICE VAR - COVAR de la MATRICE TOTALE
# ----------------------------------------

# CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
set Z [mnormalize $pop $popmeans $popones]

# MATRICE des VARIANCES - COVARIANCES 
set ZZ [mmult [transpose $Z] $Z]
set covT $ZZ

#$p insert end "\n\n---------------------------------------------------"
#$p insert end "\nMatrice covT : sums of squares and products \n[show $covT %8.4f]"
#$p insert end "\n-----------------------------------------------------"

# ---------------------------------------------------------------------"
# Matrice T = covT corrigee en fonction des degres de liberte (lignes - 1)
# ---------------------------------------------------------------------"
set corrddl [expr 1.0/($lignes - 1)]
set T [mscale $covT $corrddl]

#$p insert end "\n\n---------------------------------------------------"
#$p insert end "\nMatrice T = covT corrigee en fonction des degres de liberte\
#       [expr $lignes-1] \n[show $T %8.4f]"
#$p insert end "\n-----------------------------------------------------"

# Petite fenetre d'entree des groupes
# -----------------------------------
# C'est particulierement long pcq la 'commande' associee contient
# tout bonnement le reste du programme
toplevel .fenegro -background grey66
set fng .fenegro
wm geometry $fng 180x210+600+115
wm title $fng "$lignes individus | $colonnes variables"
set label2 [label $fng.etiquette2 -background grey22 \
        -foreground white -text "Grupos \n(separados por un espacio"]
set input2 [entry $fng.entree2 -background grey88 -textvariable inputval2]
set label3 [label $fng.etiquette3 -background grey66]
set action [button $fng.bouton -relief raised -background grey88 \
        -foreground black -width 50 -height 10 \
        -text "Efectivos de cada grupo" \
        -command {
            destroy .fenegro
            set effectifs $inputval2
            global effectifs
            
            set gr 0
            foreach item [split $effectifs] {
                incr gr
                set eff($gr) $item
                }
                
            set B "2 $gr $colonnes"
            set listeW "2 $lignes $colonnes"
            set listeW [lreplace $listeW 0 end];
            $p insert end "\n\nIl y a $gr groupes, d'effectifs $eff(1) et $eff(2)\n"

            # - - - - - - - - - - - - - - - - - - - - - - -
            # SEPARER LA MATRICE DE CHAQUE GROUPE
            # - - - - - - - - - - - - - - - - - - - - - - -

            set correction 0

            foreach item [split $effectifs] {
                set correction [expr $correction + $item]
                set newpop [mrange $pop 0 [expr $colonnes-1] \
                    [expr $correction - $item] [expr $correction - 1]]
                # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
		# item = 1 Introduit en Juin 2005
		if {$item > 1} {
                mnorms_br newpop newpopmeans newpopsigmas
		} else {
		set newpopmeans $newpop
		}
                # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
                set partZ [mnormalize $newpop $newpopmeans $popones]
                # STOCKER LA MATRICE CENTREE SUR LE GROUPE DANS LA LISTE preplisteW
                # QUI COMPOSERA LA FUTURE MATRICE des donnees CENTREES listeW
                foreach item [split $partZ] {
                    lappend preplisteW $item
                }
                # effacement des indices matriciels de prepliste
                # (une matrice par groupe)
                set preplisteW [lreplace $preplisteW 0 2]
                # ce qui suit est une sorte de lappend
                set listeW [concat $listeW $preplisteW]
                # mise a zero de prepliste
                set preplisteW [lreplace $preplisteW 0 end]
                # PREPARER LA FUTURE MATRICE DES MOYENNES / GROUPE
                set newpopmeans [lrange $newpopmeans 3 end]
                foreach item [split $newpopmeans] {lappend moyennes $item}
                #voir ensuite ligne 398 # ECRITURE ...
             }

            # -----------------------------------------------------------
            # CONSTRUCTION FINALE DE LA MATRICE listeW (donnees centrees)
            # -----------------------------------------------------------
            set listeW [concat 2 $lignes $colonnes $listeW]
            $p insert end "\nCentered data\n\
                    (centered by the corresponding group means)"
            $p insert end "\n[show $listeW %8.5f]\n"

            # ----------------------------------------------------------
            # Matrice des variances-covariance covW de la matrice listeW
            # ----------------------------------------------------------
            # MATRICE des VARIANCES - COVARIANCES 'within'
            set covW [mmult [transpose $listeW] $listeW]
            $p insert end "\nVariance-covariance matrix of centered data\n\
                    (centered by the corresponding group means)"
            $p insert end "\n[show $covW %8.5f]\n"
            #$p insert end "\n\n---------------------------------------------"
            #$p insert end "\nMatrice W (ou E, cfr. JMP et SAGE) = covW\
            #               \n[show $covW %8.4f]"
            #$p insert end "\n---------------------------------------------"
            
            # ------------------------------------------------------------"
            #     Matrice W (ou E, cfr. JMP et SAGE) = covW corrigee \
            #            en fonction des degres de liberte (lignes - groupes)
            # ------------------------------------------------------------"
            set corrddl [expr 1.0/($lignes - $gr)]
            set W [mscale $covW $corrddl]
            $p insert end "\nSame matrix, corrected for degrees of freedom"
            $p insert end "\n[show $W %8.5f]\n"
            ##########################
                        ##########################
                                    ##########################
                                                ##########################
            #$p insert end "\n\n---------------------------------------------"
            #$p insert end "\nMatrice W (ou E, cfr. JMP et SAGE)\
            #        \n= covW corrigee en fonction des degres de liberte ($lignes - $gr)\
            #        \n c'est la pooled cov de NTSYS !!\
            #        \n[show $W %8.4f]"
            #$p insert end "\n---------------------------------------------"
                                                ###########################
                                        ###########################
                            #########################
            ##########################
            # ECRITURE DE LA MATRICE DES MOYENNES DE CHAQUE GROUPE
            set Moy "2 $gr $colonnes"
            # pour accueillir dans une matrice Moy la liste des moyennes
            # (UNE LISTE, PAS UNE MATRICE)
            foreach item [split $moyennes] {lappend Moy $item}
            $p insert end "\nVoici la matrice des moyennes de chaque groupe\
                    \n[show $Moy %8.5f]\n"
            #$p insert end "\nOn utilise en fait la matrice des moyennes CENTREES"
            # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
            #set MoyC [mnormalize $Moy $popmeans $popones]
            #set colonnesMoy [mcols $Moy]
            #set lignesMoy [mrows $Moy]

        #puts "----------------------------"
        #puts " On va inverser la matrice W"
        #puts "----------------------------"
        set iW [msolve $W [mident $colonnes]]
        $p insert end "\nInverted matrix of scaled within variance-covariance matrix above\
            \n[show $iW %8.5f]\n"
        # ------------------------------------------------------
        # Matrice de la difference des moyennes des deux groupes
        # ------------------------------------------------------
        # S'il ny a que deux groupes
        set a [transpose [mrange $Moy 0 end 0 0]]
        set b [transpose [mrange $Moy 0 end 1 1]]
        set md [msub $a $b]
        $p insert end "\nMatrix of group means differences between two groups\
                \n[show $md %8.5f]\n"
        # S'il y a plus de deux groupes (cfr module d2m.tcl)
        #set compteur 0
        #for  {set i 0} {$i < [expr {$gr-1}]} {incr i} {
        #    for  {set j [expr {$i+1}]} {$j < $gr} {incr j} {
        #        incr compteur
        #        set a [transpose [mrange $Moy 0 end $i $i]]
        #        set b [transpose [mrange $Moy 0 end $j $j]]
        #        set mmd($compteur) [msub $a $b]
        #        $p insert end "\nmatrix of group means differences\
        #                between groups [expr {$i+1}] and [expr {$j+1}]\n"
        #        $p insert end "\n[show $mmd($compteur) %8.5f]\n"
        #        set mdt [transpose $mmd($compteur)]
        #        set mdtC [mmult $mdt $iW]
        #        set mdtCmd [mmult $mdtC $mmd($compteur)]
        #        $p insert end "\nThe Mahalanobis distance is\
        #                \n[expr {sqrt([lindex $mdtCmd 3])}]\n\n"
        #    }
        #}

        # ------------------------------------------------------
        # Calcul du T2 de Hotelling
        # ------------------------------------------------------
        # On transpose md pour le produit mdtCmd
        set mdt [transpose $md]
        # On fait le produit mdCmd
        set prod [expr $eff(1) * $eff(2)]
        set somm [expr $eff(1) + $eff(2)]
        set mdtC [mmult $mdt $iW]
        set mdtCmd [mmult $mdtC $md]
        set mdCmd [mscale $mdtCmd $prod ]
        # -----------------------------------------------------
        # Voici enfin le T2
        set pret2h [mscale $mdCmd [expr 1.0/$somm] ]
        set t2h [vtrim $pret2h]
        $p insert end "\nT2 de Hotelling is ... \n[format $t2h %8.5f ]\n"
        # ------------------------------------------------------
        
        # ------------------------------------------------------
        # Calcul du F associe
        # ------------------------------------------------------
        set f [expr (($somm-$colonnes-1)*$t2h)/(($somm-2)*$colonnes)]
        $p insert end "\nF = \n[format $f %8.5f ]\
            \ncon $colonnes \
            y [expr $somm - $colonnes - 1] grados de libertad"
            
        $p insert end "\n\nBy the way, the Mahalanobis distance is\
                    \n[expr {sqrt([lindex $mdtCmd 3])}]\n\n"

        }
    ]
    # Fenetre d'entree des groupes: FIN de la COMMANDE ASSOCIEE au BOUTON ...
    # Cette commande n'est autre que le programme lui-meme, finalement !
    ###############################

pack $label2 $input2 $label3 $action -side top


# Fenetre d'entree des groupes: FIN de la CONSTRUCTION de la FENETRE ...
# C'est un peu idiot cette construction d'une fenetre sans importance majeure,
# construction au bout de laquelle le programme est en fait termine ...
###############################







