convex.hull <-
function(x, y)
{
#-------------------------------------
# convex.hull
#-------------------------------------
# renvoie les indices des points (x,y)
# appartenant a l'enveloppe convexe
#-------------------------------------
# mis a jour le 27/07/2006
#-------------------------------------
#
#-----------------	
# declarations
#-----------------
	nbpoints <- length(x)
	pile <- NULL
	i0 <- order(y)[1]
#------------------
# tri (on perd l'indice i0)
#------------------	
	xiss <- cbind(x[ - i0], y[ - i0])
	xuss <- cbind(x[ - i0] - x[i0], y[ - i0] - y[i0])
	tries <- morder(1:(nbpoints - 1), xuss, isleft)
#------------------
# premier et deuxieme points
#------------------
	pile <- c(pile, tries[1], tries[2])
	hautpile <- 2	#
#----------------------
# boucle sur les points
#----------------------	
	for(i in tries[ - c(1, 2)]) {

		while((isLeft(xiss[pile[hautpile - 1],  ], xiss[pile[
			hautpile],  ], xiss[i,  ]) <= 0) & (hautpile > 1)) {
			hautpile <- hautpile - 1	
		}
		hautpile <- hautpile + 1
		pile[hautpile] <- i
	}
#---------------------
# on redecale
#---------------------
	pile[pile >= i0] <- pile[pile >= i0] + 1
	tries[tries >= i0] <- tries[tries >= i0] + 1
	return(list(x = x, y = y, fan = tries, ch = c(i0, pile[1:hautpile])))
}
plot.convex.hull <-
function(convh,add=T)
{
#-------------------------------
# plot.convex.hull
#-------------------------------
  xy<-cbind(convh$x,convh$y)
	nbpoints <- length(convh$ch)
  if (add==T)
	lines(rbind(xy[convh$ch,], xy[convh$ch[1],]))
  else {
    plot(convh$x,convh$y,pch=19,xlab="x",ylab="y")
    lines(rbind(xy[convh$ch,], xy[convh$ch[1],]))
  }
}
morder <-
function (m, x, fu) 
{
    if (length(m) == 1) 
        return(m)
    else {
        middle <- trunc(length(m)/2)
        left <- m[1:middle]
        right <- m[(middle + 1):length(m)]
        left <- morder(left, x, fu)
        right <- morder(right, x, fu)
        result <- interclasse.m(left, right, x, fu)
        return(result)
    }
}
interclasse.m <-
function (left, right, x, fu) 
{
    result <- NULL
    while ((length(left) > 0) && (length(right) > 0)) {
        if (fu(x[left[1], ], x[right[1], ])) {
            result <- c(result, left[1])
            left <- left[-1]
        }
        else {
            result <- c(result, right[1])
            right <- right[-1]
        }
    }
    if (length(left) > 0) 
        result <- c(result, left)
    if (length(right) > 0) 
        result <- c(result, right)
    return(result)
}
isleft <-
function (x1, x2) 
{
    return((x1[1] * x2[2] - x2[1] * x1[2]) > 0)
}
isLeft <-
function (p0, p1, p2) 
{
    return((p1[1] - p0[1]) * (p2[2] - p0[2]) - (p2[1] - p0[1]) * 
        (p1[2] - p0[2]))
}
