
##########################################################################
# Select
# Copyright ©  2016 Dujardin J.-P. jean-pierre.dujardin@ird.fr
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
##########################################################################

#package require Tk
#
#cd [file dirname [info script]]
#
global S 
#set S(dirscript) [pwd]
#attention, il n'y a pas de "/" a la fin du nom du dossier du script (utiliser "file join etc")
#

#global verjpd mirror_version

source [file join [pwd] "+" 101La.tcl];# librairie LA de HUME

# Procedure INSERT_SL - debut
#
# pour combiner "..._format.txt" et "..._SL.txt"
#
proc insert_sl {texte} {
    .fgtexte delete 0.0 end
    global infile
    .fgtexte insert end "\n\nLANDMARKS FILE:\n$infile\n"
    set sltexte [ouvrirnew]
    .fgtexte insert end "\n\nSEMILANDMARKS FILE:\n$infile\n"
    rouge ".fgtexte" "Be careful: each image must have a different name!!"
    #
    set compteur 0
    foreach line [split $texte "\n"] {
	if {$compteur > 0} {
	    set boulier 0
	    foreach {x y} $line {
		incr boulier 
		append newtexte "\n$compteur\t$boulier\t1\t$x\t$y"
	    }
	}
	incr compteur
    }
    set newtexte [string trim $newtexte];# landmarks, one row by landmark   
    #
    # Nombre de lignes, nombre de colonnes
    foreach line [split $newtexte "\n"] {
	append prerow "[lindex $line 0]\t"
	append precol "[lindex $line 1]\t"
    }
    set texte_rows [lindex [lsort -real -increasing $prerow] end] 
    set texte_cols [expr {([lindex [lsort -real -increasing $precol] end])*2}]
    #
    # formation d'une matrice de Hume (..._format.txt): texte_hume
    set hume "2 $texte_rows $texte_cols "
    set table [lrange [split $texte "\n"] 1 end];# comment removed
    # Enlever les curved brackets
    set table [regsub -all {\{|\}} $table ""] 
    set texte_hume "$hume $table"
    .fgtexte insert end "\n\nLANDMARKS file: [mrows $texte_hume] rows and [mcols $texte_hume] columns"
    #
    # Le nombre de lignes (pas le nb de colonnes) pour le sltexte (...SL.txt)
    set lignes 0  
    foreach line [split $sltexte "\n"] {
	if {[llength [regexp -all -inline {\S+} $line]] > 0} {
	    incr lignes
	}
    }
    set simplement [expr {[llength [split $sltexte "\n"]]-1}]
    # A VERIFIER SUR FICHIER TEXTE WINDOWS ... nb lignes SL, $simplement
    set rows_sltexte [expr {$lignes - 1}]
    # Le nombre de colonnes du sltexte peut etre inegal (cfr. 3eme col sltexte)
    #
    .fgtexte insert end "\n\nSEMILANDMARKS file: $rows_sltexte rows\n"
    set jeu [expr {$rows_sltexte * 1 / [mrows $texte_hume]}]
    .fgtexte insert end "This would give you a total of $jeu SL sets per image: is that OK ??\n"
    # prendre la table du sltexte 
    set sltable [comment_table $sltexte]
    set references [lindex $sltable 0];# cfr. saving combined lm file
    set sltable [lindex $sltable 1];# la table du sltexte
    set sltable [string trim $sltable];# on la nettoie
    # On la FORMATE en FONCTION des TABULATIONS (cfr. espaces dans les noms)
    
    foreach ligne  [split $sltable \n] {
	set template 0;# ATTENTION !!!
	set transit ""
	#debug "ligne = $ligne"
	foreach colonne [split $ligne "\t"] {
	    lappend transit $colonne
	}
	append presltable "$transit\n"
	if {[lindex $transit 1] == 1} {
	    set template [lindex $transit 2]
	    #debug "somme des sl : $template"
	    append juegos "$template "
	} else {
	    set template [expr {[lindex $transit 2] + $template}]
	    #debug "else somme des sl : $template"
	    append juegos "$template "
	}
	
    }
    #
    set juegos_ordre [lsort -real $juegos]
    
    set dep 0
    set lineas [mrows $texte_hume]
    set mixedtemplate 0
    for {set i 0} {$i < $jeu} {incr i} {
	#append juegos_olympicos "\n[lrange $juegos $dep [expr {$dep + $lineas - 1}]]\n"
	set ordre($i) [lrange $juegos_ordre $dep [expr {$dep + $lineas - 1}]]
	set dep [expr {$dep + $lineas}]
	append juegos_olympicos "\n$ordre($i)\n"
	if { [ lindex $ordre($i) 0 ] != [ lindex $ordre($i) end ] } {
	    if {$mixedtemplate == 0} {
		set mixedtemplate $i
	    }
	}   
    }
    if {$mixedtemplate > 0} { type "Unequal set $mixedtemplate of SL\nOr \nUnbalanded data (2 files)"}
    #
    set sltable $presltable;# debug "slTABLE \n$sltable"
    # on remplace les images par le numero de l'individu
    set i 1
    set simple -1
    set doublon ""
    set im [lindex [lindex [split $sltable \n] 0] 0]
    foreach slline [split $sltable \n] {
	if {[lindex $slline 0] == $im} {
	    append newsltable "\n[lreplace $slline 0 0 $i]"
	    incr simple
	} else {
	    incr i
	    append doublon " $simple"
	    set simple 0
	    #debug "$i :2. doublon $doublon"
	    if {[llength $doublon] > 1} {
		if {[lindex $doublon end] != [lindex $doublon end-1]} {
		    type "repeated image $im"
		}
	    }
	    set im [lindex $slline 0]
	    append newsltable "\n[lreplace $slline 0 0 $i]"

	}
    }
    set doublon_ordre  [lsort -real $doublon]
    set ado [lindex $doublon_ordre 0]
    set bdo [lindex $doublon_ordre end]
    if {$ado != $bdo} {
	type "It seems that two successive images are the same ones"
    }
    #debug "\nslNEWtable\n$newsltable"
    #debug "NEWTEXT   \n$newtexte"
    set jecompte 0
    foreach line [split $newtexte "\n"] {
	# le newtexte contient le code SL (seulement) et les LM
	incr jecompte
	append debeugue "\nLINE $jecompte: \n$line"
	if {[llength [regexp -all -inline {\S+} $line]] > 0} {
	    append restant "\n[lrange $line 3 end]"
	    append debeugue "\n[llength $restant] éléments dans restant"
	    #debug "\nrestant de la LINE:\n$restant"
	    #debug "line du newtexte = $line\nrestant de la LINE:\n$restant"
	    foreach slline [split $newsltable "\n"] {
		#debug "[lrange $line 0 1] ==  [lrange $slline 0 1]??"
		#append debeugue "\n[lrange $line 0 1] ==  [lrange $slline 0 1]??"
		if {[lrange $line 0 1] ==  [lrange $slline 0 1]} {
		    append debeugue "\nIl y a [lindex $slline 2] semiland apres le lm [lindex $slline 1] de l'image [lindex $slline 0]"
		    append restant " [lrange $slline 3 end]" 
		    #debug "La ssline contient [llength $restant] elem. de plus, elle devient:\n$restant"
		    append finale "\n$line \n$slline\n"
		    break
		} else {
		    #debug "restant $restant";# n'a plus qu'a Hume formater!!	
		}
	    }
	}
    }
    #debug $debeugue
    # pas necessaire
    set newrestant [regsub -all {\n} $restant "\t"]
    set newrestant [string trim $newrestant]
    set lmtotal [llength $restant]
    set newcols [expr {[llength $restant] * 1 / $texte_rows}]
    set combined_lm "2 $texte_rows $newcols $restant"
    #debug "Combined files:\ntexte_rows $texte_rows\nelements restant [llength $restant]\n[llength $combined_lm] moins 3 évidemment\n\n!!!!!"
    #debug "\n[show $combined_lm]"
    # PREVOIR UN CONTROLE DU SL CODE ENTRE LES INDIVIDUS!!
    if {$mixedtemplate > 0} {
	debug "UNBALANCED DATA: the hereunder parsing could help you to understand your problem.\n\nEach separate list represents a SL set (unordered, however) over your entire SL file. IN EACH LIST, THE NUMBERS SHOULD BE IDENTICAL. \n\tA/ If a different number appears in one list, it means that an individual has a different set of SL.\n\tB/ If the different number in one list is the same as the numbers of the following list, it means that you have more individuals in one file (say, the landmarks file) than in another\n\tC/ The number of discrepancies in the first list where they appear corresponds \n\t- to the number (not the position) of individuals having a different set of SL\n\tor\n\t- to a different number of individuals between your two files...\n$juegos_olympicos"
	tkwait variable .debug
	exit
    }
    #debug "\n$$$$$$$$$$$$\tCombined files:\n[show $combined_lm]"
    #
    # On remplace les espaces par des tabulations, oui mais TOUS les espaces!
    set tab_combined_lm ""
    set transitoire [show $combined_lm]
    foreach item [split $transitoire \n] {
	set machin ""
	set item [string trimright $item]
	foreach truc [split $item " "] {
	    append machin "$truc\t"
	}
	append tab_combined_lm "$machin\n"
    }
    set combined_lm "[lrange $combined_lm 0 2] $tab_combined_lm"
    #
    # On enregistre
    global infile
    set putfile [file rootname $infile]
    set out "format.txt"
    set outputfile $putfile$out
    
    # OPEN A FILE FOR WRITING
    set outputFile [open "$outputfile" "w"]
    
    # WRITE TEXT INTO THE FILE
    puts -nonewline $outputFile "$references \n"
    #puts -nonewline $outputFile [show $combined_lm];# humeriser enlève les tab!
    puts -nonewline $outputFile $tab_combined_lm
    # CLOSE THE FILE
    close $outputFile
    #
    #
    type "Combined landmarks and semilandmarks file \n\"[file tail $putfile$out]\" \nsaved in\n[file dirname $putfile$out]"
    #
}
#
# Procedure INSERT_SL - fin


# -------------------------
#
#     Script principal
#
# -------------------------
