
# Preambules ---------- start

package require Tk

# TODO
# SL_DB.txt

#
cd [file dirname [info script]]
#
global S
set S(dirscript) [pwd];#attention, il n'y a pas de "/" a la fin du nom du dossier du script (utiliser "file join etc")
#
cd ..
set S(dirclic) [pwd]
cd $S(dirscript)
# 
lappend auto_path [file dirname [info script]]
#
global version
set version "proTET 0 99"
#

# sources
#source ballons.tcl
source [file join $S(dirclic) "+/101La.tcl"]

switch $tcl_platform(platform) {
    "unix" {
        lappend auto_path [file join [file dirname [info script]] +/L]
    }
    "windows" {
        lappend auto_path [file join [file dirname [info script]] +/W]
    }
    "macintosh" {}
    default {}
}

# Preambules ---------- start

# ---------------------------------------
# Procedures: DEBUG LOADFILE COMMENT_TABLE

# procedure DEBUG
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x600+205+66
        set memo [text .debug.t -wrap word -height 22 -font "courier 13" \
		      -bg grey88 \
		      -fg black\
		      -tabs "3c left"\
		      -yscrollcommand ".debug.v_scroll set" \
		      -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
            if {$flag == 1} {
                .debug.t configure -wrap none
                set flag 0
            } else  {
                .debug.t configure -wrap word
                set flag 1
            }
        }
        
        #
        $memo insert end $bugatti
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG fin


# PROCEDURE loadfile - DEBUT
#
# Ce LOADFILE vient de COV, il retourne une MATRICE de Hume
#
#
proc loadfile {pathname} {
    
    if {$pathname != ""} {
        global S
        set S(dist_nopar) 0
        set S(datadir) $pathname
        # Lecture -start
        set fid [open $pathname]
        set text [read -nonewline $fid]
        close $fid
        # Lecture -end
        global rowcount
        set rowcount 0
        set colcount 0
        
        global references
        set compteur 0
        set lignes 0
        set data "";# aussi variable 'data' dans PAD, 'datos' dans MOG
        foreach line [split $text \n] {
            if  {[llength $line] > 0} {
                incr compteur
                if {$compteur >1} {
                    if  {[llength $line] > 0} {
                        set colcount [llength $line];# faux pour un DB file!!
                    }
                }
                if {$compteur>1} {
                    foreach item [split $line] { if {$item != ""} {
			incr lignes
			append data "[string trim $item]\t"
		    }
                    }
                } else {
                    set references $line
                }
            }
        }
        set rowcount [expr {$lignes / $colcount}]
	#
	# Matrice de HUME !
        set result [concat 2 $rowcount $colcount $data]
        #
	# ----------------------------------------------------------------
        # -- Première ligne --  Enlever d'eventuelles tabulations
        foreach mot $references {
            if {$mot != ""} {
                append comentario_sin_tab "$mot "
            }
        }
        set references $comentario_sin_tab
        set S(references) $references;# Le LOADFILE de MOG ne le fait pas... pourquoi? Pcq pas important
	#
        # -- FIN du formatage de la premiere ligne
	# ---------------------------------------------------------------
        return $result
    } else  {
        set cancelar [tk_messageBox "LOADFILE: You did not select a file" -type abortretryignore]
        switch -- $cancelar {
            abort {exit}
            retry {return}
            ignore {}
        }
    }
}
#
# PROCEDURE loadfile - FIN


# Procedure COMMENT_TABLE - start
#
# separer dans une LISTE la ligne de commentaire et la table
# Note: les lignes vides sont ELIMINEES
# Note: la 1ère ligne est supposée etre le commentaire
#
proc comment_table {texte} {
    set texte [string trim $texte]
    #debug "texte = \n$texte"
    # penser a sauter les lignes vides
    set compteur 0
    set table ""
    foreach line [split $texte "\n"] {
	if {[llength [regexp -all -inline {\S+} $line]] > 0} {
            # si la ligne contient au moins un caractere
            if {$compteur < 1} {
		set comment "[string trim $line]"
            } else {
                append table "\n[string trimright $line]"
            }
            incr compteur
        } else  {
            # sauter la ligne vide
        }
    }
    if {$compteur < 1} {type "texte vide ou dépourvu de '\\n'"}
    #
    return [list $comment $table]
}
#
# Procedure COMMENT_TABLE - end

# ----------------------------
# and new PROCEDURE(S): SLinDB

# Procedure SLinDB - debut
#
# copiar-pegar _SL_format.txt in _DB.txt --> _SL_DB_format.txt
#
# el archivo _SL_DB_format.txt puede entrar a la funcion SCALE de TET 
# para dar _SL_DB_scaled y _SLscaled o algo asi
#
proc slindb {slfile dbtable} {
    # dbtable sans les coordonnees
    set prosldb ""
    set compteur 0
    foreach line [split $dbtable \n] {
	if {[llength $line] > 1} {
	    set ligne [lrange [split $line "\t"] 0 5]
	    #debug "ligne DB\n$ligne"
	    #debug "coord SL [mrange $slfile 0 end $compteur $compteur]"
	    append prosldb "$ligne\t[vtrim [mrange $slfile 0 end $compteur $compteur]]\n"
	    incr compteur
	}
    }
    #debug " DONC ... \n$prosldb"
    foreach item [split $prosldb \n] {
	foreach elem $item {
	    append sldb "$elem\t"
	}
	append sldb "\n"
    }
    #debug "SLDB\n$sldb"
    #stop
    return $sldb 
}
#
# Procedure SL2DB - fin



# SCRIPT PRINCIPAL

# Attention, adressages ABSOLUS !!!
set S(infile) "/home/jepi/BU/Publications/Co-Author/Dramane/PUBLICATIONS/SYSTEMATIQUE_GpgGpp/Sanctuaire/DIGITALISATION_AILES/BERTE/BOBLENOU_DEC15/Avec_alcool_Bobl_2015/Avec-alc_avec-lam_Bobl_2015/Avec-alc_avec-lam_F_Bobl_2015/Avec-alc_avec-lam_FD_Bobl_2015/FD_d1_Boble_2015/coord_Jul23_Format.txt"

# ----------------------
# ouvrir u _format.txt: adressages ABSOLUS !!!
# ----------------------
set pathnameformat $S(infile)
set ffile [loadfile $pathnameformat]
set col [mcols $ffile]
set lig [mrows $ffile]
#debug "colonnes : $col, et lignes : $lig"
#debug "_format.txt \n[show $ffile]"

set S(slfile) "/home/jepi/BU/Publications/Co-Author/Dramane/PUBLICATIONS/SYSTEMATIQUE_GpgGpp/Sanctuaire/DIGITALISATION_AILES/BERTE/BOBLENOU_DEC15/Avec_alcool_Bobl_2015/Avec-alc_avec-lam_Bobl_2015/Avec-alc_avec-lam_F_Bobl_2015/Avec-alc_avec-lam_FD_Bobl_2015/FD_d1_Boble_2015/coord_Jul23_SLformat.txt"

# ----------------------
# ouvrir u _SL_format.txt: adressages ABSOLUS !!!
# ----------------------
set pathnameslformat $S(slfile)
set slfile [loadfile $pathnameslformat]
#debug "_SLformat.txt \n[show $slfile]"

# ----------------------
# ouvrir le _DB.txt de ces donnees: adressages ABSOLUS !!! 
# ----------------------
set prodbfile [file join [file dirname $S(infile)] coord_Jul23_DB.txt]
set fid [open $prodbfile]
set texte [read -nonewline $fid]
close $fid
set dbtable [lindex [comment_table $texte] 1];# 'table', pas 'matrice'
set dbtitres [lindex [comment_table $texte] 0];# le nb de LM va augmenter dans dbSLtitres
for {set i 0} {$i < [expr {[mcols $slfile]/2}]} {incr i} {
    append SLcoord "x[expr {$i+1}] \t y[expr {$i+1}] \t"
}
set dbSLtitres ""
# Placer des tabulatios dans les db
foreach item [lrange $dbtitres 0 5] {
    append dbSLtitres "$item \t"
}
set dbSLtitres [string trimright $dbSLtitres "\t"]
set dbSLtitres "$dbSLtitres\t$SLcoord"

# ----------------------
# appeler SLinDB 
# ----------------------
set profinalfile [slindb $slfile $dbtable]
set finalfile "$dbSLtitres \n$profinalfile"
debug "FINAL FILE \n$finalfile"

# ----------------------
# ENREGISTRER FINALFILE
# ----------------------
# Donner un nom chretien a ce fichier
set fin "_SLDB.txt"
set filename "[file rootname $S(infile)]$fin"
debug $filename
# OPEN THE FILE
set fileid [open $filename w]
# FILL THE FILE
puts -nonewline $fileid $finalfile
# CLOSE THE FILE
close $fileid
