package require Tk


# procedure DEBUG
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x600+205+66
        set memo [text .debug.t -wrap word -height 22 -font "courier 13" \
                -bg grey88 \
                -fg black\
                -tabs "3c left"\
                -yscrollcommand ".debug.v_scroll set" \
                -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
            if {$flag == 1} {
                .debug.t configure -wrap none
                set flag 0
            } else  {
                .debug.t configure -wrap word
                set flag 1
            }
        }
        
        #
        $memo insert end $bugatti
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG fin


################################################################################
# string is class ?-strict?  ?-failindex varname?  string 
# Returns 1 if string is a valid member of the specified character 
# class, otherwise returns 0.   If -strict is specified, then an 
# empty string returns 0, otherwise and empty string will return 1 on 
# any class.   If -failindex is specified, then if the function 
# returns 0, the index in the string where the class was no longer valid 
# will be stored in the variable named varname.   The varname 
# will not be set if the function returns 1.   The following character 
# classes are recognized (the class name can be abbreviated): 
################################################################################

 set s "LM = 18"
    
    
################################################################################
# alnum 
set expl "Any Unicode alphabet or digit character. "
################################################################################
set class alnum
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# alpha 
set expl "Any Unicode alphabet character."
################################################################################
set class alpha
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# ascii 
#set expl "Any character with a value less than \u0080 (those that are in the\
 7-bit ascii range).  "
################################################################################
#set class ascii
#debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# boolean 
set expl "Any of the forms allowed to Tcl_GetBoolean."
################################################################################
set class boolean
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# control 
set expl "Any Unicode control character."
################################################################################
set class control
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# digit 
set expl "Any Unicode digit character.   Note that this includes characters\
outside of the \[0-9\] range.  "
################################################################################
set class digit
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# double 
set expl "Any of the valid forms for a double in Tcl, with optional surrounding\
whitespace.   In case of under/overflow in the value, 0 is returned and \
the varname will contain -1.  "
################################################################################
set class double
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# false 
set expl "Any of the forms allowed to Tcl_GetBoolean where the value is false."  
################################################################################
set class false
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# graph 
#set expl "Any Unicode printing character, except space."
################################################################################
#set class graph
#debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# integer
set expl "Any of the valid forms for a 32-bit integer in Tcl, with optional\
surrounding whitespace.   In case of under/overflow in the value, 0 is \
returned and the varname will contain -1"
##############################################################################
set class integer
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# lower 
set expl "Any Unicode lower case alphabet character."
################################################################################
set class lower
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# print 
#set expl "Any Unicode printing character, including space."
################################################################################
#set class print
#debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# punct 
set expl "Any Unicode punctuation character."
################################################################################
set class punct
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# space 
set expl "Any Unicode space character."
################################################################################
set class space
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# true 
set expl "Any of the forms allowed to Tcl_GetBoolean where the value is\
true.  "
################################################################################
set class alnum
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# upper 
set expl "Any upper case alphabet character in the Unicode character set."
################################################################################
set class upper
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# wordchar 
set expl "Any Unicode word character.   That is any alphanumeric character, and\
any Unicode connector punctuation characters (e.g.  underscore).  "
################################################################################
set class wordchar
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""

################################################################################
# xdigit 
set expl "Any hexadecimal digit character (\[0-9A-Fa-f\])."
################################################################################
set class xdigit
debug "$expl\n$s?\t<-\t\"[string is $class $s]\""
 

