
package require Tk

cd [file dirname [info script]]
global S
set S(dirscript) [pwd];#attention, il n'y a pas de "/" a la fin du nom du dossier du script (utiliser "file join etc")
#
cd ..
set S(dirclic) [pwd]
cd $S(dirscript)

set version "Version 6"
#2.2 prise en compte des fichiers _ARE.txt
#3.3 introduction de R - correction de l'output de Repeatability
#3.6 R graph (procedure bequille_rep)
#4 contributions of RW instead of mobile means
#5 repeatability mean value

source ballons.tcl

source [file join $S(dirclic) "+/101La.tcl"]
source [file join $S(dirclic) "+/math/statistics.tcl"]
#source [file join $S(dirclic) "+/math/math.tcl"]
#source [file join $S(dirclic) "+/math/optimize.tcl"]
#source [file join $S(dirclic) "+/math/linalg.tcl"]
#source math/statistics.tcl
source [file join $S(dirclic) "+/jpdraw_15.tcl"]

global D
set D(permutacion) 0

set tcl_precision 17

#Une definition de font utilisee dans R help
font create onlist -family courier -size 13 -weight normal -slant roman
# Autres exemples:
#font create onlist -family helvetica -size 13 -weight bold -slant roman
#font create onsearch -family helvetica -size 13 -weight normal -slant roman
#font create onsearchagain -family helvetica -size 13 -weight normal -slant roman
#font create onchange -family times -size 15 -weight bold -slant italic
#font create vueglobale -family courier -size 17 -weight bold -slant roman

switch $tcl_platform(platform) {
    "unix" {
        global S
        set S(liwiclic) "linclic"
        set fin [file join $S(dirclic) "+/L"]
        set suf "/neighbor"
        set S(appel) "exec xterm $fin$suf"
        set suf "/njplot.linux"
        set S(appelnjplotte) "exec xterm $fin$suf"
        set S(filename1) [file join $S(dirclic) "+/L/translat.txt"]
        set S(filename2) [file join $S(dirclic) "+/L/treefile"]
        set S(dossierdumod) [file join $S(dirclic) "+" "L" "infile" ]
    }
    "windows" {
        global S
        set S(liwiclic) "winclic"
        set fin "/+/W"
        set suf "/neighbor.exe"
        set S(appel) "exec cmd.exe /c neighbor.exe"
        set suf "/njplot.exe"
        set S(appelnjplotte) "exec cmd.exe /c njplot.exe"
        set S(filename1) [file join $S(dirclic) "+/L/translat.txt"]
        set S(filename2) [file join $S(dirclic) "+/L/outtree"]
        #set S(filename1) "+/W/translat.txt";#a changer pour translat.txt ??
        #set S(filename2) "+/W/outtree";#a changer pour outtree ??
        set S(dossierdumod) [file join $S(dirclic) "+" "W" "infile" ]
    }
    "macintosh" {}
}

# **********************procedure menu bar***********DEBUT******************
#
proc CreateMenubar {topniveau menubar} {
    menu $menubar -type menubar
    $topniveau configure -menu $menubar
}
# **********************procedure menu bar ***********FIN******************

# **********************procedure menu ***********DEBUT******************
#
proc CreateMenu {menubar basename texte mnemonic} {
    set menu_name "$menubar.$basename"
    $menubar add cascade -label $texte -menu $menu_name -underline $mnemonic
    menu $menu_name
    return $menu_name
}
# **********************procedure menu ***********FIN******************

# *******************************************************************************************************************************
# MENU

CreateMenubar . .menubar

#
global menu_name1
set menu_name1 [CreateMenu .menubar filemenu1 "FILE" 0]
$menu_name1 add command -label "EXIT" \
    -command {exit}
$menu_name1 add separator
#
global menu_name2
set menu_name2 [CreateMenu .menubar filemenu2 "HELP" 0]
$menu_name2 add command -foreground "dark green" -label "Last changes" \
    -command {
	global S
	set fin [string wordend $S(dirscript) end]
	set S(ici) [string range $S(dirscript)  0 [expr {$fin-4}]]
	source [file join $S(ici) "lc.tcl"]
    }
$menu_name2 add separator
$menu_name2 add command -foreground "dark green" -label "INPUT DATA" \
    -command {help_inputdata}
$menu_name2 add separator
$menu_name2 add command -foreground "dark green" -label "NI:  Non-parametric comparisons of means and variances" \
    -command {help_np_perm}

$menu_name2 add command -foreground "dark green" -label "NII: Non-parametric ANOVA" \
    -command {help_np_anova}
$menu_name2 add separator
$menu_name2 add command -foreground "dark green" -label "Qst" \
    -command {help_Qst}
$menu_name2 add separator
$menu_name2 add command -foreground "dark green" -label "Repeatability" \
    -command {help_Repeatability}
$menu_name2 add separator
#
global menu_name3
set menu_name3 [CreateMenu .menubar filemenu3 " R " 0]
$menu_name3 add command -foreground "dark green" -label "Median Interquartile Range" \
    -command {
	global S efectivos rin rout
	# Ouvrir un terminal R a chaque fois? Oui si je peux le refermer...
	if {[info exists S(erela)]} {
	    # travailler
	} else  {
	    erela
	    # travailler
	}
	#
	#...fenetre d'aide au R dans la variable globale S(ere)
	#
	faar
	set analyse "Median Interquartile Range"
	set script ""
	$S(ere) insert end "\n INPUT FILE should be\n"
	set aide "[file join [file rootname $infile]].txt"
	r_vert $aide
	#
	set aide "\n\n If the input \"..._CS.txt\" file exists, please copy/paste the following instruction into your R terminal"
	r_bleu $aide
	set aide "\nsize <- scan(\"[file join [file rootname $infile]].txt\", skip=1, dec=\".\", strip.white=TRUE)"
	r_rouge $aide
	append script $aide
	#
	set aide "\nAccording to the groups you indicated, here is the vector of group sizes"
	r_bleu $aide
	#
	if {[info exists efectivos]} {
	    if {[llength $efectivos] > 1} {
		set rep_subdivision [bequille_rep $efectivos]
		#
		set aide "\n$rep_subdivision"
		r_rouge $aide
		append script $aide
		#append script "\n[string range $rep_subdivision 3 end];"
	    } else  {
		tk_messageBox -message "You did not enter the subdivision groups\nPlease close CLIC, restart and enter group sizes" -type ok
		return
	    }
	} else {
	    tk_messageBox -message "You did not enter the subdivision groups" -type ok
	}
	$S(ere) insert end "\n"
	set aide "\ncs<-data.frame(size, gsize)"
	r_rouge $aide
	append script $aide
	$S(ere) insert end "\n"
	set aide "\ntable(cs\$gsize);"
	r_rouge $aide
	append script $aide
	append script "\npng(\"[file dirname $infile]/grout_MIR.png\");"
	set aide "\nboxplot(size~gsize, range=0,data=cs, notch=T,main = \"median interquartile range\");dev.off()"
	r_rouge $aide
	append script $aide
	$S(ere) insert end "\n"
	
	#
	set S(script) $script;# pour que le bouton CLIC+ puisse fonctionner
	
    }

$menu_name3 add command -foreground "dark green" -label "ANOVA" \
    -command {
	global S efectivos rin rout
	# Ouvrir un terminal R a chaque fois? Oui si je peux le refermer...
	if {[info exists S(erela)]} {
	    # travailler
	} else  {
	    erela
	    # travailler
	}
	#
	#...fenetre d'aide au R dans la variable globale S(ere)
	#
	faar
	#
	set script ""
	$S(ere) insert end "\n INPUT FILE should be\n"
	set aide "[file join [file rootname $infile]].txt"
	r_vert $aide
	#
	set aide "\n\n If the input \"..._CS.txt\" file exists, please copy/paste the following instruction into your R terminal"
	r_bleu $aide
	set aide "\nsize <- scan(\"[file join [file rootname $infile]].txt\", skip=1, dec=\".\", strip.white=TRUE)"
	r_rouge $aide
	append script $aide
	#
	set aide "\nAccording to the groups you indicated, here is the vector of group sizes"
	r_bleu $aide
	#
	if {[info exists efectivos]} {
	    if {[llength $efectivos] > 1} {
		set rep_subdivision [bequille_rep $efectivos]
		#
		set aide "\n$rep_subdivision"
		r_rouge $aide
		append script $aide
		#append script "\n[string range $rep_subdivision 3 end];"
	    } else  {
		tk_messageBox -message "You did not enter the subdivision groups\nPlease close CLIC, restart and enter group sizes" -type ok
		return
	    }
	} else {
	    tk_messageBox -message "You did not enter the subdivision groups" -type ok
	}
	$S(ere) insert end "\n"
	set aide "\ngsize <- factor(gsize);"
	r_rouge $aide
	append script $aide
	set aide "\ncs<-data.frame(size, gsize);"
	r_rouge $aide
	append script $aide
	$S(ere) insert end "\n"
	set aide "\ntable(cs\$gsize);"
	r_rouge $aide
	append script $aide
	set aide  "\ntapply(size, gsize, mean);"
	r_rouge $aide
	append script $aide
	set aide "\nfit <- aov(size ~ gsize, cs);"
	# set aide "\nsummary(aov(cs\$size~as.factor(cs\$gsize)))"
	r_rouge $aide
	append script $aide
	set aide "\nsummary(fit);"
	r_rouge $aide
	append script $aide
	

	# Analyse des residus
	set aide "\npng(\"[file dirname $infile]/grout_histRES.png\")"
	append script $aide
	set aide "\nhist(residuals(lm(size~gsize)), nclass=20, xlab=\"Residus\", ylab=\"Frequence\", xlim=c(-200,200), pro=T, col=\"blue\", main=\"Analyse des residus\");"
	r_rouge $aide
	append script $aide
	set aide "\npng(\"[file dirname $infile]/grout_QQ.png\");"
	r_rouge $aide
	append script $aide
	set aide "\nqqnorm(residuals(lm(size~gsize)));qqline(residuals(lm(size~gsize)), col=\"red\");"
	r_rouge $aide
	append script $aide

	
	set S(script) $script;# pour que le bouton CLIC+ puisse fonctionner

	# #
	# set aide "\n\n(2) If the input \"..._RW.txt or ..._PW.txt)\" file exists, please copy/paste \
            #         the following instruction into your R terminal"
	# r_bleu $aide
	# set aide "\nrw <- read.table(\"[file join [file rootname $infile]].txt\", skip=1, header=FALSE, sep=\"\t\", na.strings=\"NA\", dec=\".\", strip.white=TRUE)"
	# r_rouge $aide
	# set aide  "\n\nrw (or pw) is now a \"data.frame\". "
	# r_bleu $aide
	# #
	# set aide "mrw<-as.matrix(rw)"
	# r_rouge $aide
	# #
	# fiar $analyse
	# #
	# #
	
	# set aide "\n\nNOTE:"
	# r_vert $aide
	# $S(ere) insert end "\nYou can also copy/paste the successive instructions separated by \";\""
	# r_vert $aide
    }

$menu_name3 add command -foreground "dark green" -label "Repeatability (centroid size)" \
    -command {
	#
	global S data efectivos
	if {[info exists S(data_hume)] == 0} {
	    type "Please first perform a CLIC repeatability analysis, if indicated"
	} else  {
	    # Ouvrir un terminal R a chaque fois? Oui si je peux le refermer...
	    if {[info exists S(erela)]} {
		# travailler
	    } else  {
		erela
		# travailler
	    }
	    #
	    #...fenetre d'aide au R dans la variable globale S(ere)
	    #
	    faar
	    set analyse "r_repeatability.txt"
	    set aide "\n(1) INPUT FILE should be\n"
	    r_bleu $aide
	    set aide "[file join [file rootname $infile]].txt"
	    r_brun $aide
	    #
	    #set aide "\n\n(2) ANALYSE: if the input \"...CS.txt\" file exists, please copy/paste the following instruction into your R terminal"
	    #r_bleu $aide
	    #set aide "\nCS <- read.table(\"[file join [file rootname $infile]].txt\", header=FALSE, sep=\"\t\", na.strings=\"NA\", dec=\".\", strip.white=TRUE)"
	    #r_brun $aide
	    #
	    #set aide  "\n\nIn case of an R error, it can be helpful to remove trailing characters from the CLIC input file (white spaces, tabs).\nAsk TET to do the job.\n"
	    #r_vert $aide
	    #
	    set aide "\n(2) Please copy-paste your data (measure1, measure2) onto the R terminal...\n"
	    r_bleu $aide
	    set nb_colonnes [lindex $S(data_hume) 2]
	    for {set i 0} {$i < $nb_colonnes} {incr i} {
		set colonne($i)  [vtrim [mrange $S(data_hume) $i $i 0 end]]
		#
		$S(ere) insert end "\nColonne [expr {$i+1}]"
		set ssize [expr {[llength $colonne($i)] / 2}];# ssize for session size
		set start 0
		set total [llength $colonne($i)];# total number of elements (total sample size)
		set n(1) [lrange $colonne($i) 0 [expr {$ssize-1}]];# first session colonne($i)
		set n(2) [lrange $colonne($i) $ssize $total];# second session colonne($i)
		# R formatting
		set n1 "c("
		foreach item $n(1) {
		    append n1 "$item,"
		}
		set n1 [string trimright $n1 ","]
		append n1 ")"
		#
		set n2 "c("
		foreach item $n(2) {
		    append n2 "$item,"
		}
		set n2 [string trimright $n2 ","]
		append n2 ")"
		#
		set aide "\n> measure1 <- $n1"
		r_rouge $aide
		set aide "\n> measure2 <- $n2"
		r_rouge $aide
		#             > sessionfactor<-gl(2,9)
		set aide "\n> sessionfactor<-gl(2,$ssize)"
		r_rouge $aide
		#             > totalobs<-c(measure1,measure2)
		set aide "\n> totalobs<-c(measure1,measure2);summary(aov(totalobs~sessionfactor))"
		r_rouge $aide
		#             > individualfactor<-as.factor(rep(1:9,2))
		set aide "\n> individualfactor<-as.factor(rep(1:$ssize,2));mod<-summary(aov(totalobs~individualfactor))"
		r_rouge $aide
		#
		set aide "\n> s2within<-MSwithin<-mod\[\[1\]\]\[2,3\];MSamong<-mod\[\[1\]\]\[1,3\];s2among<-(MSamong-MSwithin)/2"
		r_rouge $aide
		$S(ere) insert end "\nThe percent measurement error"
		set aide "\n> s2within/(s2within+s2among)*100"
		r_rouge $aide
		$S(ere) insert end "\nThe repeatability (in %)"
		set aide "\n> s2among/(s2within+s2among)*100"
		r_rouge $aide
		#
		$S(ere) insert end "\n\n-----------------------------\n"
	    }
	    
	    #fiar $analyse
	}
    }
# MENU
# *************************************************************************



# Procedure LAST - debut
#
proc last {} {
    update
    set l ".last"
    toplevel $l
    wm geometry $l 540x550+10+10
    focus -force $l
    
    frame $l.buttons; ## EN BAS DE CETTE FENETRE, UNE FRAME POUR LOGER des BOUTONS
    pack $l.buttons -side bottom -fill x -pady 2m
    
    button $l.buttons.start -text "OK" -bg "light yellow" -command {
        destroy .last
        wm deiconify .
    }
    pack $l.buttons.start -side left -expand 1
    
    set scblicayu [scrollbar $l.scrollAlicayu -command "$l.t yview"]
    ## A GAUCHE DE LA FENETRE, UNE SCROLLBAR
    pack $scblicayu -side left -fill y
    
    set preslicayu [text $l.t -background "light green" -wrap word\
			-yscrollcommand "$l.scrollAlicayu set"]
    ## PUIS ENFIN LE TEXTE il n'est plus necessaire d'indiquer -SIDE, mais -FILL BOTH
    pack $preslicayu -fill both -expand 1
    
    lappend auto_path [file join [file dirname [info script]]]
    set fid [open var_lastchanges.txt r]
    set last [read -nonewline $fid]
    close $fid
    $l.t insert end "\n$last"
}
#
# Procedure LAST - fin


################################################################################
# # Procedure DECENTRER - START
# #
# # verifie s'il y a des valeurs negatives dans chacune des deux sessions d'une serie de mesures repetees
# # si oui, deplace les valeurs de la serie de sorte qu'il n'y ait plus de valeurs negatives
# #
# proc decentrer {serie} {
#     debug "SERIE\n$serie"
#     set serie_1 [mrange $serie 0 0 0 [expr {([mrows $serie] / 2) - 1}] ]
#     set serie_2 [mrange $serie 0 0 [expr {[mrows $serie] / 2}] end ]
#     #
#     set serie_ordre [lsort -real -increasing [vtrim $serie_1]]
#     set min [lindex $serie_ordre 0]
#     if {$min < 0} {
#         set min [expr {abs($min)}]
#         set seriedecentree_1 ""
#         foreach element [vtrim $serie_1] {
#             append seriedecentree_1 "[expr {$element + $min}] "
#         }
#         set seriedecentree_1 "2 [mrows $serie_1] [mcols $serie_1] $seriedecentree_1"
#         debug "SERIEDECENTREE\n$seriedecentree_1"
#     } else {
#         set seriedecentree_1 $serie_1
#     }
#     #
#     set serie_ordre [lsort -real -increasing [vtrim $serie_2]]
#     set min [lindex $serie_ordre 0]
#     if {$min < 0} {
#         set min [expr {abs($min)}]
#         set seriedecentree_2 ""
#         foreach element [vtrim $serie_2] {
#             append seriedecentree_2 "[expr {$element + $min}] "
#         }
#         set seriedecentree_2 "2 [mrows $serie_2] [mcols $serie_2] $seriedecentree_2"
#     } else {
#         set seriedecentree_2 $serie_2
#     }
#     return [join_rows $seriedecentree_1 $seriedecentree_2]
# }
# # Procedure DECENTRER - END
################################################################################


# Procedure HELP_INPUTDATA - fin
#
proc help_inputdata {} {
    update
    global l wrapavis
    set l ".npanova"
    toplevel $l
    wm geometry $l 540x550+10+10
    focus -force $l
    
    frame $l.buttons; ## EN BAS DE CETTE FENETRE, UNE FRAME POUR LOGER des BOUTONS
    pack $l.buttons -side bottom -fill x -pady 2m
    #
    set wrapavis 0
    #
    button $l.buttons.wuw -background "light yellow" -text "wrap/unwrap" -command {
	#type "wrapavis $wrapavis"
        #
        if {$wrapavis == 0} {
            $l.t configure -wrap none
            $l.t configure -wrap none
            set wrapavis 1
        } else {
            $l.t configure -wrap word;
            $l.t configure -wrap word
            set wrapavis 0
        }
    }
    button $l.buttons.start -text "OK" -bg "light yellow" -command {
        destroy .npanova
        wm deiconify .
    }
    pack $l.buttons.start $l.buttons.wuw -side left -expand 1
    
    set scblicayu [scrollbar $l.scrollAlicayu -command "$l.t yview"]
    ## A GAUCHE DE LA FENETRE, UNE SCROLLBAR
    pack $scblicayu -side left -fill y
    
    set preslicayu [text $l.t -background "light yellow" -wrap word\
			-yscrollcommand "$l.scrollAlicayu set"]
    ## PUIS ENFIN LE TEXTE il n'est plus necessaire d'indiquer -SIDE, mais -FILL BOTH
    pack $preslicayu -fill both -expand 1
    
    lappend auto_path [file join [file dirname [info script]]]
    set fid [open var_INPUTDATA.txt r]
    set last [read -nonewline $fid]
    close $fid
    $l.t insert end "\n$last"
}
#
# Procedure HELP_INPUTDATA - fin


# Procedure HELP_NP_ANOVA - fin
#
proc help_np_anova {} {
    update
    global l wrapavis
    set l ".npanova"
    toplevel $l
    wm geometry $l 540x550+10+10
    focus -force $l
    
    frame $l.buttons; ## EN BAS DE CETTE FENETRE, UNE FRAME POUR LOGER des BOUTONS
    pack $l.buttons -side bottom -fill x -pady 2m
    #
    set wrapavis 0
    #
    button $l.buttons.wuw -background "light yellow" -text "wrap/unwrap" -command {
        #
        if {$wrapavis == 0} {
            $l.t configure -wrap none
            $l.t configure -wrap none
            set wrapavis 1
        } else {
            $l.t configure -wrap word;
            $l.t configure -wrap word
            set wrapavis 0
        }
    }
    
    button $l.buttons.start -text "OK" -bg "light yellow" -command {
        destroy .npanova
        wm deiconify .
    }
    pack $l.buttons.start $l.buttons.wuw -side left -expand 1
    
    set scblicayu [scrollbar $l.scrollAlicayu -command "$l.t yview"]
    ## A GAUCHE DE LA FENETRE, UNE SCROLLBAR
    pack $scblicayu -side left -fill y
    
    set preslicayu [text $l.t -background "light yellow" -wrap word\
			-yscrollcommand "$l.scrollAlicayu set"]
    ## PUIS ENFIN LE TEXTE il n'est plus necessaire d'indiquer -SIDE, mais -FILL BOTH
    pack $preslicayu -fill both -expand 1
    
    lappend auto_path [file join [file dirname [info script]]]
    set fid [open var_NP_ANOVA.txt r]
    set last [read -nonewline $fid]
    close $fid
    $l.t insert end "\n$last"
}
#
# Procedure HELP_NP_ANOVA - fin


# Procedure HELP_NP_PERM - fin
#
proc help_np_perm {} {
    update
    global l wrapavis
    set l ".npanova"
    toplevel $l
    wm geometry $l 540x550+10+10
    focus -force $l
    
    frame $l.buttons; ## EN BAS DE CETTE FENETRE, UNE FRAME POUR LOGER des BOUTONS
    pack $l.buttons -side bottom -fill x -pady 2m
    #
    set wrapavis 0
    #
    button $l.buttons.wuw -background "light yellow" -text "wrap/unwrap" -command {
        #
        if {$wrapavis == 0} {
            $l.t configure -wrap none
            $l.t configure -wrap none
            set wrapavis 1
        } else {
            $l.t configure -wrap word;
            $l.t configure -wrap word
            set wrapavis 0
        }
    }
    
    
    button $l.buttons.start -text "OK" -bg "light yellow" -command {
        destroy .npperm
        wm deiconify .
    }
    pack $l.buttons.start $l.buttons.wuw -side left -expand 1
    
    set scblicayu [scrollbar $l.scrollAlicayu -command "$l.t yview"]
    ## A GAUCHE DE LA FENETRE, UNE SCROLLBAR
    pack $scblicayu -side left -fill y
    
    set preslicayu [text $l.t -background "light yellow" -wrap word\
			-yscrollcommand "$l.scrollAlicayu set"]
    ## PUIS ENFIN LE TEXTE il n'est plus necessaire d'indiquer -SIDE, mais -FILL BOTH
    pack $preslicayu -fill both -expand 1
    
    lappend auto_path [file join [file dirname [info script]]]
    set fid [open var_NP_PERM.txt r]
    set last [read -nonewline $fid]
    close $fid
    $l.t insert end "\n$last"
}
#
# Procedure HELP_NP_PERM - fin



# Procedure HELP_Qst - debut
#
proc help_Qst {} {
    update
    global l wrapavis
    set l ".npanova"
    toplevel $l
    wm geometry $l 540x550+10+10
    focus -force $l
    
    frame $l.buttons; ## EN BAS DE CETTE FENETRE, UNE FRAME POUR LOGER des BOUTONS
    pack $l.buttons -side bottom -fill x -pady 2m
    #
    set wrapavis 0
    #
    button $l.buttons.wuw -background "light yellow" -text "wrap/unwrap" -command {
        #
        if {$wrapavis == 0} {
            $l.t configure -wrap none
            $l.t configure -wrap none
            set wrapavis 1
        } else {
            $l.t configure -wrap word;
            $l.t configure -wrap word
            set wrapavis 0
        }
    }
    
    button $l.buttons.start -text "OK" -bg "light yellow" -command {
        destroy .npqst
        wm deiconify .
    }
    pack $l.buttons.start $l.buttons.wuw  -side left -expand 1
    
    set scblicayu [scrollbar $l.scrollAlicayu -command "$l.t yview"]
    ## A GAUCHE DE LA FENETRE, UNE SCROLLBAR
    pack $scblicayu -side left -fill y
    
    set preslicayu [text $l.t -background "light yellow" -wrap word\
			-yscrollcommand "$l.scrollAlicayu set"]
    ## PUIS ENFIN LE TEXTE il n'est plus necessaire d'indiquer -SIDE, mais -FILL BOTH
    pack $preslicayu -fill both -expand 1
    
    lappend auto_path [file join [file dirname [info script]]]
    set fid [open var_Qst.txt r]
    set last [read -nonewline $fid]
    close $fid
    $l.t insert end "\n$last"
}
#
# Procedure HELP_NP_Qst - fin



# Procedure help_Repeatability - debut
#
proc help_Repeatability {} {
    update
    global l wrapavis
    set l ".npanova"
    toplevel $l
    wm geometry $l 540x550+10+10
    focus -force $l
    
    frame $l.buttons; ## EN BAS DE CETTE FENETRE, UNE FRAME POUR LOGER des BOUTONS
    pack $l.buttons -side bottom -fill x -pady 2m
    #
    set wrapavis 0
    #
    button $l.buttons.wuw -background "light yellow" -text "wrap/unwrap" -command {
        #
        if {$wrapavis == 0} {
            $l.t configure -wrap none
            $l.t configure -wrap none
            set wrapavis 1
        } else {
            $l.t configure -wrap word;
            $l.t configure -wrap word
            set wrapavis 0
        }
    }
    
    button $l.buttons.start -text "OK" -bg "light yellow" -command {
        destroy $l
        #wm deiconify .
    }
    pack $l.buttons.start $l.buttons.wuw -side left -expand 1
    
    set scblicayu [scrollbar $l.scrollAlicayu -command "$l.t yview"]
    ## A GAUCHE DE LA FENETRE, UNE SCROLLBAR
    pack $scblicayu -side left -fill y
    
    set preslicayu [text $l.t -background "light yellow" -wrap word\
			-yscrollcommand "$l.scrollAlicayu set"]
    ## PUIS ENFIN LE TEXTE il n'est plus necessaire d'indiquer -SIDE, mais -FILL BOTH
    pack $preslicayu -fill both -expand 1
    
    lappend auto_path [file join [file dirname [info script]]]
    set fid [open var_Repeatability.txt r]
    set last [read -nonewline $fid]
    close $fid
    $l.t insert end "\n$last"
}
#
# Procedure HELP_NP_REPEATABILITY - fin

# Procedure SINO - debut
#
proc sino {question} {
    
    if {[info exists reponse_sino]} {unset reponse_sino}
    
    global reponse_sino
    
    destroy .sinon
    toplevel .sinon -relief raised
    wm geometry .sinon +200+290
    wm title .sinon "Remover la primera linea ?"
    
    frame .sinon.frame -relief flat
    pack .sinon.frame -side top -fill y -anchor center
    
    frame .sinon.frame.1
    pack .sinon.frame.1 -side top -pady 2 -anchor e
    
    label .sinon.frame.1.label -text $question -anchor e -font "Courier 12"
    pack .sinon.frame.1.label -side right
    
    frame .sinon.bouton
    pack .sinon.bouton -side bottom -pady 2 -anchor center
    
    button .sinon.bouton.si -text " SI " -command {
        destroy .sinon
        set reponse_sino 1
    }
    button .sinon.bouton.no -text " NO " -command {
        destroy .sinon
        set reponse_sino 0
    }
    pack .sinon.bouton.si .sinon.bouton.no -side left -padx 22
    focus -force .sinon.bouton.no
    vwait reponse_sino
    return $reponse_sino
}
#
# Procedure SINO - fin


# procedure TYPE - debut
#
proc type {message} {
    tk_messageBox -message $message -type ok
}
#
# procedure TYPE - fin

# procedure TYPE_YN - debut
#
proc type_yn {message} {
    set reponse [tk_messageBox -message $message -type yesno]
    return $reponse
}
#
# procedure TYPE_YN - fin

# Procedure TREBUCHE - debut
#
proc trebuche {} {
    
    global S p
    
    set vraiment "The file, if produced by MOG, could contain the consensus as the first value: \ndo you want to remove this consensus individual ?"
    set sujet "'First one is consensus'"
    set confirmer [sino $vraiment]
    
    if {$confirmer == 1} {
        $p insert end "\nWarning: First row will be removed from data\n"
        return 2
    } else  {
        return 1
    }
}
#
# Procedure TREBUCHE - end


# Procedure VERDIA - end
#
proc verdia {diapositiva} {
    # Procedure para ver una diapositiva
    image create photo fotoa
    fotoa configure -file $diapositiva
    set wi [image width fotoa]
    set he [image height fotoa]
    
    destroy .d
    toplevel .d
    wm geometry .d +550+50
    
    destroy .d.can .d.v_scroll .d.h_scroll
    
    canvas .d.can -width $wi -height $he -yscrollcommand ".d.v_scroll set" -xscrollcommand ".d.h_scroll set"
    
    scrollbar .d.v_scroll -command ".d.can yview"
    scrollbar .d.h_scroll -command ".d.can xview" -orient horizontal
    
    # Fill in canvas
    .d.can create image 0 0 -image fotoa -anchor nw
    .d.can configure -scrollregion [.d.can bbox all]
    
    pack .d.v_scroll -side right -fill y
    pack .d.h_scroll -side bottom -fill x
    pack .d.can -side left -expand 1
    
    bind .d.can <Button-3> {destroy .d}
}
#
# Procedure VERDIA - end

# Procedure SAVELISTING - start
#
proc  savelisting {dequoi} {
    # ***************************************************************
    # Tentative d'ecriture d'un fichier DE RAPPORT en CSV
    # ***************************************************************
    global p infile sentier
    set megainfo "\nFichier : $infile\n"
    set megatexte [$p get 1.0 {end}]
    
    global infile
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    #debug
    #puts "chemin = $dirinfile"
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    #debug
    #puts "\ntail = $tailfile"
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    #debug
    #puts "root = $rootfile"
    set fin $dequoi
    set filename "$dirinfile$rootfile$fin"
    #debug
    #puts "filename = $filename"
    
    wm title . $filename
    # OPEN THE FILE
    set fileid [open $filename a]
    # FILL THE FILE
    puts -nonewline $fileid $megainfo
    puts -nonewline $fileid $megatexte
    # CLOSE THE FILE
    close $fileid
}
#
# Procedure SAVELISTING - end


# procedure RANLIST - debut
#
proc ranlist {liste lignes} {
    set  lignesmoinsun [expr {$lignes - 1}]
    #initialisation
    set listnew ""
    #-----------------------------------------------
    #LISTE ALEATOIRE "SAMPLING WITH REPLACEMENT"
    #-----------------------------------------------
    for {set i 0} {$i < $lignes} {incr i} {
        set num [expr {round ($lignesmoinsun * rand () )}]
        set newline [lindex $liste $num]
        set listnew [concat $listnew $newline]
    }
    set newlist $listnew
    #-----------------------------------------------
    #FIN (CREATION D'UNE MATRICE ALEATOIRE)
    #-----------------------------------------------
    return $newlist
}
#
# Procedure RANLIST - fin

proc graphique {datos efectivos} {
    # GRAPHIQUE - start
    global p numfen intervalle colonnes references primeralinea
    set numfen 1
    set intervalle 40
    set colonnes [llength $efectivos]
    set references $primeralinea
    #debug
    #rouge "\nGroupes [llength $efectivos]\nvaleurs $datos\nEffectifs $efectivos "
    range [llength $efectivos] $datos $efectivos
    # GRAPHIQUE - fin
    return 1
}




# procedure DEBUG - debut
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x480+205+44
        set memo [text .debug.t -wrap none -height 22 -font "courier 13" \
		      -bg grey88 \
		      -fg black\
		      -tabs "3c left"\
		      -yscrollcommand ".debug.v_scroll set" \
		      -xscrollcommand ".debug.h_scroll set"]
        
	scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
	    #type "flag = $flag"
            if {$flag == 1} {
                .debug.t configure -wrap none
                set flag 0
            } else  {
                .debug.t configure -wrap word
                set flag 1
            }
        }
        #
        $memo insert end $bugatti
        $memo see end
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG - fin



# Procedure AFFICHE - debut
#
# Permet de faire apparaitre un avis
#
proc affiche {x y avis} {
    # x est la position sur l'axe horizontal de l'ecran
    # y est la position sur l'axe vertical de l'ecran
    # missive contient le message qu'on veut afficher
    #puts "help"
    destroy .avis
    toplevel .avis
    wm geometry .avis +$x+$y
    message .avis.t -aspect 1000 -text $avis
    pack .avis.t
}
#
# Procedure AFFICHE - fin

#
# ################### bleu ##### Procedure ## Debut ##
proc bleu {mesg args} {
    global p
    $p insert end $mesg "bleu"
    update
    flush stdout
}
#$p tag configure bleu -foreground blue
################### bleu ####### PROCEDURE ## FIN ###

################### rouge ##### Procedure ## Debut ##
proc rouge {mesg args} {
    global p
    $p insert end $mesg "rouge"
    update
    flush stdout
}
#$p tag configure rouge -foreground red
################### rouge ####### PROCEDURE ## FIN ###

################### vert ##### Procedure ## Debut ##
proc vert {mesg args} {
    global p
    $p insert end $mesg "vert"
    update
    flush stdout
}
#$p tag configure vert -foreground "dark green"
################### vert ####### PROCEDURE ## FIN ###


# Procedure BEQUILLE_REP
#
proc bequille_rep {subdivision} {
    set nbgr [llength $subdivision]
    #
    # Le nombre de groupes dans la variable 'gr'
    # Les effectifs de chaque groupe dans la variable indicee 'eff($gr)'
    set gr 0
    foreach item [split $subdivision] {
        incr gr
        set eff($gr) $item
    }
    #
    #append avis "Subdivision: \n$subdivision\n"
    set avis "gsize <- c("
    set compteur 0
    foreach item $subdivision {
        incr compteur
        append avis "rep(\"g$compteur\",$item)"
	if {$compteur < $gr} {append avis ","} else {append avis "\)"} 
    }
    #
    return [string trimright $avis ";"]
}
#
# Procedure BEQUILLE_REP



# Procedure COMPNUEV -start
#
proc comparacionesnuevas {listapermutada efectivos} {
    global D
    set data $listapermutada
    # Disseccion de la lista de los datos en bloques: llamada a la procedura DISSECCION
    set result [disseccion $data $efectivos]
    # Ahora tenemos una lista de n (observados)
    set nlist [lindex $result 2]
    # Ahora tenemos una lista de promedios (observados)
    set moylist  [lindex $result 1]
    # Ahora tenemos una lista de varianzas (observadas)
    set varlist  [lindex $result 0]
    # Comparacion de las varianzas entre  bloques: llamada a la procedura COMPVAR
    set permut_f_g1_g2 [compvar $varlist $efectivos]
    # Comparacion de los promedios entre  bloques: llamada a la procedura COMPMOY
    set permut_t_g1_g2 [compmoy $moylist $varlist $nlist]
    set lista_f_t [list $permut_f_g1_g2 $permut_t_g1_g2 ]
    return $lista_f_t
}
#
# Procedure COMPNUEV - end



# Procedure SWAP - start
#
proc  swap {desc k n} {
    # Esta procedura llamada por otra procedure (PERMUTAR)
    set numk [lindex $desc [expr {($k-1)}]]
    set numn [lindex $desc  [expr {($n-1)}]]
    set newdesc [lreplace $desc  [expr {($k-1)}]  [expr {($k-1)}] $numn]
    set neufdesc [lreplace $newdesc [expr {($n-1)}] [expr {($n-1)}] $numk]
}
#
# Procedure SWAP - end


# Procedure PERMUTAR - start
#
proc permutar {total} {
    global p
    # Algorithm Knuth (1981)
    #1
    set n [llength $total]
    # preparacion del ciclo
    set j $n
    #set total $inicio
    # ciclo
    while {$j > 1} {
        #debug
        #update
        #flush stdout
        #$p insert end "perm = $j - "
        #2
        set U [expr {rand()}]
        #3
        set k [expr {int($j * $U)+1}]
        #4
        set newtotal  [swap $total $k $j]
        set total $newtotal
        incr j -1
    }
    return $newtotal
}
#
# Procedure PERMUTAR - end


#procedure ONVAPERMUTER     - debut
#
# arg = datos efectivos fobs tobs numpermut
proc onvapermuter {datos efectivos nbpermut} {
    global p S D tobs fobs
    set inicio $datos
    # calculo del numero total de comparaciones posibles entre g grupos
    set g [llength $efectivos]
    set numcomp [expr {(pow($g,2) - $g)/2}]
    # Calcul approximatif du Bonferroni
    set bonferroni [expr {0.05 * 1.0 / $numcomp}]
    # inicializar dos variables con indice
    for {set i 0} {$i < $numcomp} {incr i} {
        set t($i) 0
        set f($i) 0
    }
    
    # Petite fenetre de suivi des permutations
    destroy $p.permutations
    toplevel $p.permutations
    wm geometry $p.permutations +200+200
    button $p.permutations.l -text $S(perm) -command {}
    pack $p.permutations.l
    # Petite fenetre de suivi des permutations
    
    # Numero de permutaciones
    for {set i 0} {$i < $nbpermut} {incr i} {
        set listapermutada [permutar $inicio]
        #debug
        #puts "Permutacion numero $i: $inicio -> $listapermutada"
        #
        update
        $p.permutations.l configure -text "Non-parametric tests \non means and variances\n [expr {$i+1}] / $nbpermut"
        #
        set lista_f_t [comparacionesnuevas $listapermutada $efectivos]
        #puts "\nPermutacion $i: variances -> [lindex $lista_f_t 0]"
        #puts "Permutacion $i: moyennes -> [lindex $lista_f_t 1]\n"
        # cuantos f randomizados > = f observado
        set compteur 0
        foreach element   [lindex $lista_f_t 0] {
            #debug
            #puts "[lindex $element 0] > $fobs($compteur)"
            if  {[lindex $element 0] > $fobs($compteur)} { incr f($compteur)}
            incr compteur
        }
        # cuantos t randomizados > = t observado
        set compteur 0
        foreach element   [lindex $lista_f_t 1] {
            #debug
            #puts "[lindex $element 0] > $tobs($compteur) "
            if  {[lindex $element 0] > $tobs($compteur)} { incr t($compteur)}
            incr compteur
        }
    }
    
    if {$i == $nbpermut} {tk_messageBox -message "$nbpermut permutations: done" -type ok}
    
    for {set i 0} {$i < $numcomp} {incr i} {
        set element [lindex  $lista_f_t 1]
        set element [lindex $element $i]
        set trandom [expr {$t($i) * 1.0 / $nbpermut}]
        set trandom [format "%1.5f" $trandom]
        set frandom [expr {$f($i) * 1.0 / $nbpermut}]
        set frandom [format "%1.5f" $frandom]
        bleu "\n_____________________________________________________________"
        bleu "\n\nNIVEAU I\tComparaison non parametrique des moyennes"
        bleu "\nentre [lindex $element 1] y [lindex $element 2]:\tP = $trandom"
        .debut insert end "\n t random mas grande $t($i) veces sobre $nbpermut"
        
        
        if {$trandom > $bonferroni || $trandom == $bonferroni} {
            $p insert end "\n-> Starting value for the Bonferroni test : $bonferroni"
            append tabla_t "$trandom "
        } else {
            bleu "\n->SIGNIFICATIF  (< $bonferroni)"
            append tabla_t "$trandom "
        }
        
        
        set element [lindex  $lista_f_t 0]
        set element [lindex $element $i]
        vert "\n_____________________________________________________________"
        vert "\n\nNIVEAU I\tComparaison non parametrique des variances"
        vert "\nentre [lindex $element 1] y [lindex $element 2]:\tP = $frandom"
        .debut insert end "\n f random mas grande $f($i) veces sobre $nbpermut"
        
        
        if {$frandom > $bonferroni || $frandom == $bonferroni} {
            $p insert end "\n->  Starting value for the Bonferroni test : $bonferroni"
            append tabla_f "$frandom "
        } else  {
            vert "\n->SIGNIFICATIF (< $bonferroni)"
            append tabla_f "$frandom "
        }
    }
    
    $p insert end "\n\n_____________________________________________\n"
    
    bleu "\n\nNIVEAU I\tCOMPARAISONS DES MOYENNES\nTable des valeurs de P apres $nbpermut permutations\n"
    table_signif $tabla_t [llength $efectivos]
    
    vert "\n\nNIVEAU I\tCOMPARAISONS DES VARIANCES\nTable des valeurs de P apres $nbpermut permutations\n"
    table_signif $tabla_f [llength $efectivos]
    
    $p insert end "\n\n"
    
}
#
#procedure ONVAPERMUTER     - fin


# PROCEDURE table_signif - debut
# arguments (tabla_t o tabla_f) et "grupos"
#
# Cette procédure est appelée TABLE_OUTPUT dans COV
# Elle transforme une liste de distances en une table
#
proc table_signif {distancias grupos} {
    global p
    
    #Ici je cree une table de ZEROs selon nombre de groupes
    for {set i 1} {$i < [expr {$grupos+1}]} {incr i} {
        for {set j 1} {$j <  [expr {$grupos+1}]} {incr j} {
            set tabdis($i,$j) 0
        }
    }
    # Inscription dans la table des valeurs observees (cfr. "distancias")
    set compteur 0
    for {set i 1} {$i < $grupos} {incr i} {
        for {set j [expr {$i+1}]} {$j < [expr {$grupos + 1}]} {incr j} {
            set tabdis($i,$j)  [lindex $distancias $compteur]
            incr compteur
        }
    }
    # Preparation d'une matrice de fromat HUME
    # step 1
    set numcomp  [expr {($grupos * $grupos - $grupos)  / 2}]
    # step 2
    for {set i 1} {$i < [expr {$grupos+1}]} {incr i} {
        for {set j 1} {$j <  [expr {$grupos+1}]} {incr j} {
            append listdis "$tabdis($i,$j) "
        }
    }
    # step 3
    set codematrix "2 $grupos $grupos"
    # final steps
    set matdis [concat $codematrix $listdis]
    set matdis [transpose $matdis]
    
    # Display
    for {set i 1} {$i < [mrows $matdis]} {incr i} {
        $p insert end "\n_[expr {$i+1}]  [show [mrange $matdis 0 [expr {$i-1}] $i $i] %1.4f]"
    }
}
#
# PROCEDURE table_signif - fin



# Procedure COMPMOY
#
proc compmoy {moylist varlist nlist} {
    global p S D tobs
    set permut_t_g1_g2_p ""
    # ------------------------------------
    # comparacion de promedios
    # ------------------------------------
    # numero de valores en la lista de moyennes
    set moynb [llength $moylist]
    # display only if not permutating
    if {$D(permutacion) < 1} {
        rouge "\nliste $moylist"
    }
    set compteur 0
    #set comparmoy 0
    for {set i 0} {$i < [expr {$moynb - 1}]} {incr i} {
        # premiere moyenne
        #debug
        #puts "\n i ... $i -> [lindex $moylist $i] "
        set va  [lindex $varlist $i]
        set na  [lindex $nlist $i]
        for {set j [expr {$i+1}]} {$j < $moynb} {incr j} {
            #deuxieme moyenne
            #debug
            #puts "\n J ... $j -> [lindex $moylist $j] "
            set vb  [lindex $varlist $j]
            set nb  [lindex $nlist $j]
            set meandif [expr {[lindex $moylist $i] - [lindex $moylist $j]}]
            set meandifabs [expr {abs ($meandif)}]
            
            # Manly p.4
            set vcom [expr {sqrt ( ( ($na-1) * $va + ($nb-1) * $vb ) * 1.0/ ( ($na-1)+($nb-1) ) )}]
            set raiz [expr {sqrt (1.0 / $na + 1.0 / $nb)}]
            set denominator [expr {$vcom * $raiz}]
            set t [expr {$meandifabs *1.0 / $denominator}]
            set moymenus($i,$j) $meandifabs
            #debug
            #puts "D(permutacion) $D(permutacion)"
            
            # set only if not permutating
            if {$D(permutacion) < 1} {
                set tobs($compteur) $t
            }
            # display only if not permutating
            if {$D(permutacion) < 1} {
                rouge "\n\nMoyennes comparées groupe [expr {$i+1}]\
                        avec groupe [expr {$j+1}] ( [lindex $moylist $i] avec [lindex $moylist $j] )"
                rouge ""
                append difta "\n[expr {$i+1}] -  [expr {$j+1}]\t\
                        [expr {abs([lindex $moylist $i] - [lindex $moylist $j])}]"
            }
            # compute P only if means are not equals, sino P vale 1
            if {$t == 0} {
                # Calcul de la signification
                set degrees [expr {$na+$nb - 2}]
                set prob   1
            }
            # compute only if not permutating and if Student > 0
            if {$D(permutacion) < 1 && $t > 0} {
                #debug
                #puts "Si no se permuta se computa"
                # Calcul de la signification
                set degrees [expr {$na+$nb - 2}]
                set prob    [::math::statistics::cdf-students-t $degrees $t]
                set prob [expr {(1 - $prob)*2}]
            }
            
            # display only if not permutating
            if {$D(permutacion) < 1} {
                bleu "\n\nt = $t \nP = $prob \nDegrés de liberté: $degrees"
            }
            
            if {$D(permutacion) < 1} {
                # Si se trata de permutaciones o no, guardar los resultados grupos comparados y t
                lappend permut_t_g1_g2_p [list $t   [expr {$i+1}]  [expr {$j+1}] $prob]
            } else  {
                lappend permut_t_g1_g2_p [list $t   [expr {$i+1}]  [expr {$j+1}]]
            }
            
	    incr compteur
        }
        
    };# fin de la comparaison des moyennes
    #
    #
    if {$D(permutacion) < 1} {
        if {[info exists S(fichier_cs)]} {
            if {$S(fichier_cs) == 1} {
                $p insert end "\n\n---------------------------------------------------------\nAbsolute differences of centroid sizes between groups\n---------------------------------------------------------\n"
                $p insert end $difta
                $p insert end "\n\n-------------------------------------------------------\nAbsolute differences of centroid sizes between groups\n----------------------- E  N  D  --------------------------\n"
            }
        }
    }
    #
    #
    return $permut_t_g1_g2_p
}
#
# Procedure COMPMOY


# Procedure DISSECCION - debut
#
proc disseccion  {listapermutada efectivos} {
    global D
    set data $listapermutada
    set inicio 0
    set final 0
    set varlist ""
    foreach item $efectivos {
        # calculando los limites - inicio, final - de cada grupo
        set final [expr {$final + $item}]
        set obs [lrange $data $inicio [expr {$final-1}]]
        #calculando la varianza del grupo considerado (obs)
        set varmeanum [varianza $obs]
        
        set variance [lindex $varmeanum 0]
        set moyenne [lindex $varmeanum 1]
        set n [lindex $varmeanum 2]
        
        # agregando cada varianza a una lista
        lappend varlist "$variance"
        # agregando cada moyenne a una lista
        lappend moylist "$moyenne"
        # agregando cada n a una lista
        lappend nlist "$n"
        # monstrar los resultados
        # display only if not permutating
        #if {$D(permutacion) < 1} {
        #puts "\nvariance = $variance\n"
        #puts "moyenne = $moyenne\n"
        #}
        #debug
        #puts "De inicio $inicio a  [expr {$final-1}]"
        #puts "variance = $variance\n"
        set inicio $final
    }
    return [list $varlist $moylist $nlist]
}
#
# Procedure DISSECCION - fin


# Procedure COMPVAR - fin
#
proc compvar {varlist efectivos} {
    global D fobs
    set permut_f ""
    # numero de valores en la lista de varianzas
    set varnb [llength $varlist]
    #$p insert end "\nliste $varlist"
    #set comparvar 0
    set compteur 0
    for {set i 0} {$i < [expr {$varnb-1}]} {incr i} {
        #$p insert end "\n i ... $i -> [lindex $varlist $i] "
        for {set j [expr {$i+1}]} {$j < $varnb} {incr j} {
            #$p insert end "\n J ... $j -> [lindex $varlist $j] "
            ;# ---- NOV 2006 THE RATIO IS LARGER / SMALLER
            if {[lindex $varlist $i] >= [lindex $varlist $j] } {
                set ratio [expr {[lindex $varlist $i]  * 1.0/ [lindex $varlist $j]}]
            } else  {
                set ratio [expr {[lindex $varlist $j]  * 1.0/ [lindex $varlist $i]}]
            }
            set varratio($i,$j) $ratio
            
            # set only if not permutating
            if {$D(permutacion) < 1} {
                set fobs($compteur) $ratio
            }
            
            # display only if not permutating
            if {$D(permutacion) < 1} {
                bleu "\n\nVariances comparées groupe [expr {$i+1}]\
                        avec groupe [expr {$j+1}] \n Effectifs  [lindex $efectivos $i] \t<-> [lindex $efectivos $j]\n Variances  [lindex $varlist $i] \t<-> [lindex $varlist $j] )\n Std dev.:  [expr {sqrt([lindex $varlist $i])}] \t<-> [expr {sqrt([lindex $varlist $j])}]\n"
            }
            
            # Calcul de la signification ---- NOV 2006 v1 and v2 IN DIFFERENT ORDER ACCORDING TO WHICH VARIANCE IS LARGER
            if {[lindex $varlist $i] >= [lindex $varlist $j] } {
                set v1  [expr {[lindex $efectivos $i] - 1}]
                set v2  [expr {[lindex $efectivos $j] - 1}]
            } else  {
                set v1  [expr {[lindex $efectivos $j] - 1}]
                set v2  [expr {[lindex $efectivos $i] - 1}]
            }
            set F $ratio
            set P_ratio  [::math::statistics::Cdf-toms322 $v1 $v2 $F]
            set P_display [expr {(1-$P_ratio)*2}];# ---- NOV 2006 multiplied by two because we test for two-tailed inequality
            
            # display only if not permutating
            if {$D(permutacion) < 1} {
                vert "La valeur observée de la statistique de test F: $ratio \nDegrés de liberté: $v1 y $v2 \nP : \
                        $P_display"
            }
            
	    # display only if not permutating
            if {$D(permutacion) < 1} {
                # Si se trata de permutaciones o no, guardar los resultados grupos comparados y F
                lappend permut_f [list $ratio   [expr {$i+1}]  [expr {$j+1}] $P_display]
            } else  {
                lappend permut_f [list $ratio   [expr {$i+1}]  [expr {$j+1}]]
            }
            incr compteur
            
        }
        
        # display only if not permutating
        if {$D(permutacion) < 1} {
            rouge "\n----------------------------\n"
        }
        
    };# fin de la comparaison des variances observées
    return $permut_f
}
#
# Procedure COMPVAR - fin



# Procedure VARIANZA - debut
#
proc varianza {obs} {
    
    global p bootstrap D
    
    #debug
    #$p insert end "\n\n    nuevo calculo    \n\nobs = $obs\n"
    #
    # Nombre d'indiv dans ce bloc
    set n [llength $obs]
    
    if {[info exists bootstrap] && $bootstrap > 0} {
        #nada
    } else  {
        # Hacemos el output si no se trata del bootstrap
        if {$D(permutacion) < 0} {
            rouge "[lrange $obs 0 2] ... [lindex $obs end]"
            puts "\nNombre d'éléments du groupe = "
            puts $n
        }
    }
    
    
    # suma de los datos
    set suma 0
    foreach item $obs {
        set suma [expr {$suma + $item}]
    }
    #debug
    #$p insert end "\nsuma = $suma\n"
    
    # promedio de los datos
    set mean [expr {$suma * 1.0 / $n}]
    
    if {[info exists bootstrap]} {
        #nada
    } else  {
        # Hacemos el output si no se trata del bootstrap
        #if {$D(permutacion) < 1} {
        #    puts "\nMoyenne ="
        #    puts "$mean"
        #}
    }
    
    # centrar los datos
    foreach item $obs {
        lappend centr [expr {$item - $mean}]
    }
    #debug
    #$p insert end "\ncentrado = $centr\n"
    
    # elevar al cuadrado los datos centrados, y sumar
    #
    foreach  item $centr {
        lappend centr_sq [expr pow ($item , 2)]
    }
    #debug
    #$p insert end "\ncentrado al cuadrado = $centr_sq\n"
    
    set suma_centr_sq 0
    foreach  item $centr_sq {
        set suma_centr_sq [expr {$suma_centr_sq + $item}]
    }
    #debug
    #$p insert end "\nsuma de los centrados al cuadrado = $suma_centr_sq\n"
    
    # resultado final: varianza
    set var [expr {$suma_centr_sq / ($n-1)}]
    #debug
    #$p insert end "\nla varianza de la lista es: $var"
    
    # Lo que retorna la procedura 'varianza' ('varmeanum') es una lista de tres valores:
    # la varianza ('var'))
    # el promedio ('mean'))
    # el nimero de individuos del bloque ('n')
    set varmeanum [list $var $mean $n]
    return $varmeanum
}
#
# Procedure VARIANZA - fin

###################### ouvrir ######## PROCEDURE ## DEBUT###


proc ouvrir {} {
    global p S data
    set typeList {
        {{"Text files"} {.seq .txt .nts .TXT .NTS .csv .CSV .tps .TPS} }
    }
    global infile texte dossier primeralinea
    
    # Chercher sa route dans un fichier de configuration: il y en a un dans le dossier MOG (chemin), et un dans le dossier CLIC (route)
    # dans le dossier VAR
    set chemin "[pwd]/dossier_var.txt"
    # dans le dossier CLIC
    set route $S(dirclic)/dossier_CLIC.txt
    #
    # On lit d'abord le fichier dossier_CLIC, s'il existe
    # sinon
    # on lit le fichier du script (VAR), s'il existe
    #
    # 1. verifier que les fichiers de routage CLIC existent
    if {[file exists $route] == 0} {
        # dans le cas ou il n'y a pas de fichier de routage dans le dossier CLIC
        set candidat_dossier_CLIC [pwd]
        catch [
	       set fid [open $route w+]
	       puts -nonewline $fid "Dernier dossier de donnees:\n"
	       puts -nonewline $fid [pwd]
	       close $fid
	      ] ici
    } else  {
        # 3. si le fichier de routage existe dans le dossier CLIC, reccueillir alors le dernier chemin parcouru
        # open le fichier pour lire
        catch [
	       set fid [open $route r]
	       set candidat_dossier_CLIC [read -nonewline $fid]
	       close $fid
	      ] ici
        set candidat_dossier_CLIC [lindex [split $candidat_dossier_CLIC \n] 1]
        #debug "\ndossier selon CLIC = $candidat_dossier_CLIC"
    }
    
    #debug "chemin $chemin"
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
        set candidat_dossier [pwd]
    } else  {
        # 3. si le fichier de routage du script (VAR) existe, reccueillir le dernier chemin parcouru
        # open le fichier pour lire
        catch [
	       set fid [open $chemin r]
	       set candidat_dossier [read -nonewline $fid]
	       close $fid
	      ] ici
        set candidat_dossier [lindex [split $candidat_dossier \n] 1]
    }
    
    # A present, on a le choix entre candidat_dossier_CLIC et candidat_dossier
    if {$candidat_dossier_CLIC != "./"} {
        #debug "Pas PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        # si le dossier_CLIC n'est pas le dossier en cours (CLIC_XX)
        set candidat_dossier $candidat_dossier_CLIC
        #debug "Pas PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        catch [
	       set fid [open $chemin w+]
	       puts -nonewline $fid "Dernier dossier de donnees utilise par VAR:\n"
	       puts -nonewline $fid $candidat_dossier
	       close $fid
	      ] ici
    } else  {
        # sinon, on adopte le candidat_dossier
        #debug "PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        set candidat_dossier_CLIC $candidat_dossier
        #debug "PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        catch [
	       set fid [open $route w+]
	       puts -nonewline $fid "Dernier dossier de donnees:\n"
	       puts -nonewline $fid $candidat_dossier_CLIC
	       close $fid
	      ] ici
    }
    
    
    # On va chercher les donnees --------------------------------------------------------
    #catch [
    set infile [tk_getOpenFile -initialdir $candidat_dossier -filetypes $typeList]
    # LECTURE DU FICHIER
    set fid [open $infile]
    set texte [read -nonewline $fid]
    close $fid
    # LECTURE DU FICHIER
    set S(infile) $infile
    #] ici
    
    # Enlever la premiere valeur si le fichier a ete cree par un vieux MOG
    # set seuil [trebuche]
    set seuil 1
    
    # Supprimer les lignes blanches ------------------------------- debut ------
    #
    set lignesblanches 0
    foreach line [split $texte \n] {
        if  { [regexp {0|1|2|3|4|5|6|7|8|9|[A-Za-z]} $line] == 1} {
            append newtexte "$line\n"
        } else  {
            set lignesblanches [expr {$lignesblanches + 1}]
        }
    }
    #
    # Supprimer les lignes blanches ------------------------------ fin --------
    
    set datos ""
    set contador -1
    foreach item [split $newtexte "\n"] {
        if  {$item != ""} { incr contador}
        if {$contador > 0} {
            if  {$item != "" && $contador == $seuil || $contador > $seuil } {
                append datos "[string trim $item]\t"
                #debug "contador $contador"
            }
        } else  {
            set primeralinea $item
        }
    }
    $p insert end "\n$primeralinea\n"
    $p insert end "\nNombre de données : $contador\n"
    
    #debug "\ndatos--------------- \n$datos\n ----------------\n"
    
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
        # open le fichier de conf pour ecrire
        catch [
	       set fid [open $chemin w+]
	       puts -nonewline $fid "Dernier dossier de donnees utilisees par VAR:\n"
	       puts -nonewline $fid $dossier
	       close $fid
	      ] ici
        # open le fichier de routage pour ecrire
        catch [
	       set fid [open $route w+]
	       puts -nonewline $fid "Dernier dossier de donnees :\n"
	       puts -nonewline $fid $dossier
	       close $fid
	      ] ici
    }
    #debug "chemin = $dirinfile"
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    #debug  "\ntail = $tailfile"
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    #debug "root = $rootfile"
    #Verification du type de fichier --- debut
    if {[string first "_ALIGNED" $infile] < 0 } {set S(fichier_aligned) 0} else {set S(fichier_aligned) 1}
    if {[string first "_CS" $infile] < 0 } {set S(fichier_cs) 0} else {set S(fichier_cs) 1}
    if {[string first "_PER" $infile] < 0 } {set S(fichier_per) 0} else {set S(fichier_per) 1}
    if {[string first "_ARE" $infile] < 0 } {set S(fichier_are) 0} else {set S(fichier_are) 1}
    if {[string first "_RW" $infile] < 0 } {set S(fichier_rw) 0} else {set S(fichier_rw) 1}
    set fichier_pw_cs 0
    if {[string first "_PW_CS" $infile] < 0 } {set S(fichier_pw_cs) 0} else {set S(fichier_pw_cs) 1;set S(fichier_rw) 0;set S(fichier_cs) 0}
    #debug " \nfichier_pw_cs == $fichier_pw_cs\tfichier_cs = $fichier_cs\tfichier_rw = $fichier_rw\n"
    if {$S(fichier_cs) == 0 &&  $S(fichier_rw) == 0 && $S(fichier_aligned) == 0  && $S(fichier_per) == 0 && $S(fichier_are) == 0} {
        set nm [tk_messageBox -message "[file tail $infile]\nyour file does not seem to fit the required format\n\
                do you want to continue ?" -icon warning -type yesno]
        if {$nm == no} {exit}
    }
    #Verification du type de fichier --- fin
    
    set data $datos
    return $datos
}
#
# procedure OUVRIR - fin



# Procedures associees a l'AIDE R ------------------------- start
#
# r_rouge, r_bleu, r_brun, r_vert, faar, fiar, afficheinfo, erela
# Il faut y ajouter en debut de source: "font create onlist -family courier -size 13 -weight normal -slant roman" et S(liwiclic)
#
# Procedures associees a l'AIDE R ------------------------- start
#
# Ces procedures sont appelees a partir du menu R
#
################### r_bleu ##### Procedure ## Debut ##
proc r_bleu {mesg args} {
    global S
    $S(ere) insert end $mesg "bleu"
    $S(ere) tag configure bleu -foreground blue
}
################### r_bleu ####### PROCEDURE ## FIN ###
#
################### r_brun ##### Procedure ## Debut ##
proc r_brun {mesg args} {
    global S
    $S(ere) insert end $mesg "brun"
    $S(ere) tag configure brun -foreground brown
}
################### r_brun ####### PROCEDURE ## FIN ###
#
################### r_vert ##### Procedure ## Debut ##
proc r_vert {mesg args} {
    global S
    $S(ere) insert end $mesg "vert"
    $S(ere) tag configure vert -foreground "dark green"
}
################### r_vert ####### PROCEDURE ## FIN ###
#
################### r_rouge ##### Procedure ## Debut ##
proc r_rouge {mesg args} {
    global S
    $S(ere) insert end $mesg "rouge"
    $S(ere) tag configure rouge -foreground red
}
################### r_rouge ####### PROCEDURE ## FIN ###


# Procedure WRITEINFO - debut - appelee par la procedure CLIC+
#
proc writeinfo {id rout} {
    global S attente fidout infile
    if {[eof $id]} {
        affiche 100 100 "The set of R instructions in [file tail $S(rin)]\nThe TEXT output of R analyses in [file tail $rout]\nPossible GRAPH output in .png format, name starting with 'grout_...'\n\nPlease see THESE FILES IN YOUR WORKING FOLDER\n([file dirname $infile])"
	if { [catch {close $id} result] } {# on laisse passer}
	    return
	}
	gets $id ligne
	# ECRITURE LIGNE PAR LIGNE DE L'OUTPUT R
	set fidout [open $rout a]
	puts $fidout "\n$ligne"
	close $fidout
    }
    #
    # Procedure WRITEINFO - end


    # Procedure CLIC+ - start
    #
    # fait appel a la procedure WRITEINFO
    #
    proc clic+ {script rin rout} {
	global S
	set S(rin) $rin
	### ECRITURE DU SCRIPT R DANS UN FICHIER###
	update
	set rcom [open $rin w]
	puts -nonewline $rcom $script
	close $rcom
	### EXECUTION DE L'INSTRUCTION R ###
	#if {$S(hasmac)} {
        set fid [open "| R --save --slave < $rin"]
        fconfigure $fid -buffering line
        catch [fileevent $fid readable "writeinfo $fid $rout"] mm
	#} else {
	#    set fid [open "| R --save --slave < $rin"]
	#    fconfigure $fid -buffering line
	#    catch [fileevent $fid readable "writeinfo $fid $rout"] mm
	#}
	update
	flush stdout
    }
    #
    # Procedure CLIC+ - end

    # Procedure FAAR - Fenetre d'aide au R - start
    #
    proc faar {} {
	global S infile
	
	#
	wm iconify .
	destroy .rwidget
	toplevel .rwidget
	wm title .rwidget "R help"
	wm geometry .rwidget 850x600+550+50
	global S
	set S(ere) [text .rwidget.t -wrap word -height 22 -font onlist \
			-bg ivory \
			-fg black\
			-tabs "3c left"\
			-yscrollcommand ".rwidget.v_scroll set" \
			-xscrollcommand ".rwidget.h_scroll set"]
	scrollbar .rwidget.v_scroll -command ".rwidget.t yview"
	scrollbar .rwidget.h_scroll -command ".rwidget.t xview" -orient horizontal
	pack .rwidget.v_scroll -side right -fill y
	pack .rwidget.h_scroll -side bottom -fill x
	pack .rwidget.t -side bottom -fill both -expand 1
	#
	set S(rhelp) Rhelp
	button .rwidget.b -text "CLIC+" -command {
	    global S rin rout
	    if {[info exists S(script)]} {
		# ------------------- TENTATIVE CLIC+ - start
		#
		# Appel a la procedure CLIC+, qui va ouvrir des fichiers dont le nom suit:
		set rin [file join [file dirname $infile] rin_var.txt]
		set rout [file join [file dirname $infile] rout_var.txt]
		clic+ $S(script) $rin $rout
		#
		# ------------------- TENTATIVE CLIC+ - end
	    } else {
		tk_messageBox -message "Too soon" -type ok
	    }
	    #
	}
	pack  .rwidget.b -side left 
    }
    # Procedure FAAR - Fenetre d'aide au R - end
    #
    # Procedure FIAR - Fichier d'aide au R - start
    #
    proc fiar {analyse} {
	global S
	set fileraide  [file join $S(dirclic) $S(rhelp) $analyse]
	tk_messageBox -message "$fileraide" -type ok
	set fid [open $fileraide r]
	set raide [read -nonewline $fid]
	close $fid
	#
	$S(ere) insert end $raide
	#
    }
    #
    # Procedure FIAR - Fichier d'aide au R - end
    #
    # Procedure AFFICHEINFO - debut - Appelee par la procedure ERELA
    #
    proc afficheinfo {id} {
	global attente
	if {[eof $id]} {
	    set attente 1
	    close $id
	    return
	}
	gets $id ligne
    }
    #
    # Procedure AFFICHEINFO - fin
    #
    # Procedure ERELA -- DEBUT
    #
    proc erela {} {
	global S
	update
	flush stdout
	
	if { [catch {
	    #
	    if {$S(liwiclic) == "linclic"} {
		global attente numli
		if {$S(hasmac)} {
		    set fid [open "| open /Applications/R.app"]
		    fconfigure $fid -buffering line
		    catch [fileevent $fid readable "afficheinfo $fid"] ici
		} else {
		    set fid [open "| xterm R"]
		    fconfigure $fid -buffering line
		    catch [fileevent $fid readable "afficheinfo $fid"] ici
		}
	    } else  {
		type "Windows users.\nR might open and not work properly.\nIn that case, please open it using your Windows explorer"
		if {[file exists $S(dirclic)/+/W/cfgW/pathR.txt]} {
		    #
		    # open le fichier pour lire
		    #
		    set fid [open $S(dirclic)/+/W/cfgW/pathR.txt r]
		    set S(endroit) [read -nonewline $fid]
		    close $fid
		    #
		    set fid [open "| \"$S(endroit)\""]
		    fconfigure $fid -buffering line
		    catch [fileevent $fid readable "afficheinfo $fid"] ici
		} else {
		    # fichier absent
		    type "CLIC did not find the path of Rgui\nIn case of persistant problem, just go to your Windows explorer to open Rgui, and put it close to the CLIC widget "
		    set onvachercher [type_yn "Do you want to find it for CLIC?"]
		    switch -- $onvachercher {
			yes {
			    set S(endroit) [tk_getOpenFile]
			    set fid [open $S(dirclic)/+/W/cfgW/pathR.txt w]
			    puts -nonewline $fid $S(endroit)
			    close $fid
			}
			no {}
		    }
		    #fichier present
		}
	    }
	    #
	    update
	    flush stdout
	} result] } {
	    # There is an error
	    #
	    if {$S(liwiclic) == "linclic"} {
		tk_messageBox -message "CLIC did not find the 'xterm' terminal, or did not find R\nhttp://cran.r-project.org/" -type ok
		set S(erela) 1
		return
	    } else  {
		set endroit $S(endroit)
		type "CLIC did not find Rgui here: \n$endroit\n\nhttp://cran.r-project.org/ \nIn case of persistant problem, just go to your Windows explorer to open Rgui, and put it close to the CLIC widget"
		set onvachercher [type_yn "Do you want to find it for CLIC?"]
		switch -- $onvachercher {
		    yes {
			set S(endroit) [tk_getOpenFile]
			set fid [open $S(dirclic)/+/W/cfgW/pathR.txt w]
			puts -nonewline $fid $S(endroit)
			close $fid
		    }
		    no {}
		}
	    }
	    # Version future: Proposer d'ecrire le chemin qui conduit au programme
	}
	set S(erela) 1
	return
    }
    #
    # Procedure ERELA -- fin
    #
    #
    # Procedures associees a l'AIDE R --------------------------- end
    # r_rouge, r_bleu, r_brun, r_vert, fiar, farr, afficheinfo, erela
    # Procedures associees a l'AIDE R --------------------------- end




    # SCRIPT PRINCIPAL -----------------------------------------------------

    global bootstrap


    # --------------------------------------- 1 ------------------------------
    # Preparar la ventana salida = WIDGET con SCB, FRAMES, BUTTONS, TEXT widget
    # --------------------------------------- 1 ------------------------------
    wm geometry . 780x600+128+10
    #wm geometry . +128+10
    wm title . "var - $version"

    frame .buttons;## EN BAS DE CETTE FENETRE, UNE FRAME POUR LOGER des BOUTONS
    pack .buttons -side bottom -fill x -pady 2m

    button .buttons.graph -text "GRAPHE  ?  " -command {
	set mmmm [graphique $datos $efectivos]
    }

    button .buttons.informe -text "Save report ?" -command {
	global infile
	savelisting "_INFO_VAR.txt"
	#destroy .buttons.informe
	#pack .buttons.salir -side left -padx 2 -fill x -expand yes
    }

    button .buttons.wrap -text "Wrap" -command {
	global drapeau
	if {[info exists drapeau]} {
	    if {$drapeau == 1} {
		$p configure -wrap none; set drapeau 0
	    } else {
		$p configure -wrap word; set drapeau 1
	    }
	} else  {
	    set drapeau 1
	}
    }
    button .buttons.help -text "Aide (N II)" -command {
	set texto1 {
	    COMPARAISON DES MESURES DE PLASTICITE PHENOTYPIQUE ENTRE DEUX OU PLUSIEURS ESPECES
	    
	    DONNEES
	    Le fichier d'entrée contient une seule colonne de chiffres (par exemple les valeurs de taille), avec en toute première ligne un commentaire libre décrivant l'origine des données.
	    
	    STRUCTURE DES DONNEES
	    Ces données sont les valeurs de taille (ou d'une autre variable continue) mesurée dans deux ou plusieurs espèces elles-mêmes examinées dans deux environnements différents. L'ordre des données est donc, pour chaque espèce, les valeurs dans le premier environnement (e1) suivies de celles observées dans le second environnement (e2). Chaque espèce se suit, et dans chaque espèce les deux environnements se succèdent toujours dans le même ordre (par exemple e1 et e2).
	    Il ne peut pas y avoir plus de deux environnements par espèce, et il ne peut pas n'y en avoir qu'un seul.
	    
	    PLASTICITE PHENOTYPIQUE
	    Il s'agit d'une réponse à un changement externe, ou interne, mesurable sur le phénotype de l'individu, par exemple sur ses dimensions.
	    Cette réponse présente plus ou moins d'ampleur selon le stimulus qui la génère, mais aussi en fonction des espèces (ou des populations géographiques d'une espèce).
	    Cette ampleur peut être définie comme la "norme de réaction", c'est-à-dire le nombre de phénotypes que peut produire un seul génotype.
	    
	}
	
	set texto2 {
	    
	    
	    COMPARAISONS STATISTIQUES
	    Les comparaisons statistiques porteront sur des valeurs de MOYENNES et de VARIANCES.
	    Il y a deux niveaux de comparaison
	}
	
	set texto3 {
	    
	    
	    Un niveau (niveau I) correspond à la comparaison des moyennes et des variance  entre espèces et environnements.
	    Le second niveau (niveau II)  compare les changements de moyenne et de variance entre les espèces (P < 0.001).
	}
	
	toplevel .h
	wm geometry .h 450x600+150+150
	text .h.t -bg "light blue" -fg black -wrap word
	pack .h.t  -side left -fill both -expand yes
	
	# texto sigue, y boton para ilustrar (b)
	.h.t insert end $texto1
	button .h.t.b1 -text "Plasticité phénotypique" -command {verdia plas_phen.gif}
	button .h.b -image [image create photo -file plas_phen.gif]
	.h.t window create {end lineend} -window .h.t.b1
	bind .h.t.b1 <Motion> {.h.t.b1 configure -cursor hand1}
	
	# texto sigue, y nuevo boton (b1)
	.h.t insert end $texto2
	button .h.t.b2 -text "Changement des moyennes et variances" -command {verdia niveaux.gif}
	button .h.b1 -image [image create photo -file niveaux.gif]
	.h.t window create {end lineend} -window .h.t.b2
	bind .h.t.b2 <Motion> {.h.t.b2 configure -cursor hand1}
	
	# nuevo parrafo, texto sigue y nuevo boton (b3)
	.h.t insert end $texto3
	button .h.t.b3 -text "Niveau I, Niveau II" -command {verdia chang_moy_var.gif}
	button .h.b2 -image [image create photo -file chang_moy_var.gif]
	.h.t window create {end lineend} -window .h.t.b3
	bind .h.t.b3 <Motion> {.h.t.b3 configure -cursor hand1}
    }

    button .buttons.salir -fg red -text "EXIT" -command {exit}
    pack .buttons.salir .buttons.informe  .buttons.wrap .buttons.help -side right

    set scb [scrollbar .scrollA -command ".debut yview"];
    ## A GAUCHE DE LA FENETRE, UNE SCROLLBAR
    pack $scb -side left -fill y
    global p
    set p [text .debut -background white -font "courier 12" -wrap word\
	       -yscrollcommand ".scrollA set"];
    ## PUIS ENFIN LE TEXTE il n'est plus necessaire d'indiquer -SIDE, mais -FILL BOTH
    pack $p -fill both -expand 1

    # preparacion de la ventana del informe - fin

    $p tag configure vert -foreground "dark green"
    $p tag configure bleu -foreground blue
    $p tag configure rouge -foreground red


    # --------------------------------------------- 2 --------------------
    # Encabezamiento del informe
    rouge {
	Possible INPUT FILES for VAR:
	..._CS.txt, ..._ARE.txt, ..._PER.txt, or ..._RW.txt.
    }

    bleu {
	For the repeatability (R) estimation, the INPUT FILE must contain the two successive measurements of exactly the same individuals in exactly the same order (please use concatenate by rows with TET to build the file)
    }

    rouge {
	For the non-parametric ANOVA of size (NII button) please enter 4 groups.
    }

    vert {

	NI Button
	---------
	NON PARAMETRIC COMPARISONS OF SIZE AND VARIANCE OF SIZE
	You will be asked to enter a number of permutations to be typed in a small rectangle appearing at the bottom of the widget.

	NII Button
	---------
	COMPARAISON DES MESURES DE PLASTICITE PHENOTYPIQUE ENTRE DEUX OU PLUSIEURS ESPECES
	- Data
	Le fichier d'entrée contient une seule colonne de chiffres (par exemple les valeurs de taille), avec en toute première ligne un commentaire libre décrivant l'origine des données.
	- Data structure
	Ces données sont les valeurs de taille (ou d'une autre variable continue) mesurée dans deux ou plusieurs espèces elles-mêmes examinées dans deux environnements différents. L'ordre des données est donc, pour chaque espèce, les valeurs dans le premier environnement (e1) suivies de celles observées dans le second environnement (e2). Chaque espèce se suit, et dans chaque espèce les deux environnements se succèdent toujours dans le même ordre (par exemple e1 et e2).
	Il ne peut pas y avoir plus de deux environnements par espèce, et il ne peut pas n'y en avoir qu'un seul.

	Qst Button - Button
	-------------------
	Fst equivalent for quantitative, continuous variables. Accepts data from a file containing size, like ...CS.txt or ...ARE.txt or ...PER.txt). Also available for shape in the COV module (menu \"subdivided matrix\") of CLIC.

    Repeatability - Button
    ----------------------
    This button accepts either a one column file (containing size, like ...CS.txt or ...ARE.txt or ...PER.txt) or a relative warps file (..._RW.txt).
}
$p insert end "\n"
# --------------------------------------------- 2 ----------------------



# --------------------------------------------- 3 -----------------------
# Vamos a buscar los datos - llamada a la procedure 'ouvrir'
set datos [ouvrir]

bleu "\nData (vecteur): "
$p insert end "\n[lrange $datos 0 20]\n... etc.\n"
# --------------------------------------------- 3 ----------------------



# ------------------------------------- 4 -------------------------------
# Entrada de los efectivos de cada grupo dentro de los datos - debut
# ------------------------------------- 4 -------------------------------

global efectivos
destroy .t
toplevel .t
wm geometry .t +730+300

entry .t.entrada1 -textvariable efectivos; # 'efectivos' contiene por ejemplo '23 14 25 46'
pack .t.entrada1 -side bottom
balloonhelp_for .t.entrada1 "Entrer les effectifs des groupes séparés d'un espace.\nPlease enter groups (sample sizes) separated by space"
focus -force .t.entrada1

label .t.l -bg "light yellow" -text "Entrer les effectifs des groupes\nséparés d'un espace.\nPlease enter groups (sample sizes) \nseparated by space"
pack .t.l -side bottom
button .t.x -bg "light yellow" -text "Cancel" -command {
    set onfekoi [tk_messageBox -message "Sure you want to exit ?" -type yesno]
    switch -- $onfekoi {
        yes {exit}
        no {}
    }
}

button .t.g -bg "light yellow" -text "OK" -command {
    #
    if {[llength $efectivos] > 0} {
        #
        destroy .t
        # NOMBRE DE COLONNES
        #
        # On compte d'abord le nombre d'elements dans la liste des donnees
        set nb_valeurs [llength $datos]
        #
        # On compte ensuite le total des effectifs (le total des individus) - oct2009
        set individus_nb 0
        foreach item $efectivos {
            set individus_nb [expr {$individus_nb + $item}]
        }
        set nb_lignes $individus_nb;# obligation historique ...
        #
        # On peut alors evaluer le nombre de colonnes par individu
        #
        set nb_colonnes [expr {$nb_valeurs / $nb_lignes}]
        $p insert end "\nTotal number of rows $nb_lignes\nNumber of columns (variables) : $nb_colonnes\n"
        
        
        # S'il y a plus d'une colonne, on suppose qu'il s'agit de la conformation, sinon on suppose CS
        if {$nb_colonnes > 1} {
            rouge "\nThere are more than one column. \nVAR considers this is not the file containing size\nYou may try to perform a REPEATABILITY analysis."
            .buttons.anova configure -state disabled
            .buttons.permutaciones configure -state disabled
            .buttons.bootstrap configure -state disabled
        }
        
	if {$S(fichier_cs) == 1 || $S(fichier_per) == 1 || $S(fichier_are) == 1} {
            
            global tobs fobs primeralinea
            
            #destroy .t
            pack .buttons.graph -side left
            
            # CALCUL DES VARIANCES ET MOYENNES OBSERVEES
            
            # calculo del numero total de comparaciones posibles entre g grupos
            set g [llength $efectivos]
            set numcomp [expr {(pow($g,2) - $g)/2}]
            # inicializar dos variables con indice
            for {set i 0} {$i < $numcomp} {incr i} {
                set tobs($i) 0
                set fobs($i) 0
            }
            # Disseccion de la lista de los datos en bloques: llamada a la procedura DISSECCION
            set result [disseccion $datos $efectivos]
            # Ahora tenemos una lista de n (observados)
            set nlist [lindex $result 2]
            $p insert end "\n\nLISTE de n "
            $p insert end  "\n $nlist\n"
            # Ahora tenemos una lista de promedios (observados)
            set moylist  [lindex $result 1]
            bleu "\n\nLISTE de moyennes "
            bleu "\n $moylist\n"
            # Ahora tenemos una lista de varianzas (observadas)
            set varlist  [lindex $result 0]
            vert "\n\nLISTE de variances "
            vert "\n $varlist\n"
            #$p insert end "\nLISTA de varianzas \t $varlist\n\n"
            rouge "\n\nATTENTION: \nPour les tests parametriques qui suivent, les échantillons utilisés doivent être aléatoires, simples et indépendants.\
                    \nLa variable étudiée doit se distribuer selon une loi normale dans les deux populations\
                    \ndont sont extraits les échantillons\n\n"
            # Comparacion de las varianzas entre  bloques: llamada a la procedura COMPVAR
            set permut_f_g1_g2_p [compvar $varlist $efectivos]
            # Comparacion de los promedios entre  bloques: llamada a la procedura COMPMOY
            set permut_t_g1_g2_p [compmoy $moylist $varlist $nlist]
            
	    # monstrar las dos variables con indice
            #for {set i 0} {$i < $numcomp} {incr i} {
            #    puts "Student t obs $tobs($i) \t y F obs $fobs($i)"
	    #}
        }
        
        #button .t.e -fg red -text dismiss -command {destroy .t}
        #pack .t.e .t.g -side left -fill x -expand yes
    } else  {
        tk_messageBox -message "Please entre group sizes separated by space" -type ok
    }
};# fin de if c'est bien la taille cfr fichier_cs == 1 ou fichier_per == 1 ou bien fichier_are == 1

button .t.e -fg "dark green" -text "Input data?" -command {
    set onfekoi [tk_messageBox -message "Input data are typically sizes (centroid sizes, perimeters, areas).\n\nThey can be relative warps (RW) also\n\nDo you want more information?" -type yesno]
    switch -- $onfekoi {
        yes {help_inputdata}
        no {}
    }
}
pack .t.e .t.g .t.x -side left -fill x -expand yes

bind .t.entrada1 <Key-Return> {
    .t.g invoke
}

#
# Entrada de los efectivos de cada grupo dentro de los datos - fin

# --------------------------------------------- 5 -------------------------------
# Bouton BOOTSTRAP
# --------------------------------------------- 5 ------------------------------


button .buttons.bootstrap -text "N II  " -command {
    
    set levelnb 2
    
    #
    # Hacer desaparecer la entrada anterior, y el boton mismo (era para entrar los efectivos de cada bloque)
    #
    #destroy .buttons.bootstrap
    
    if {[expr {fmod([llength $efectivos],2) > 0}]} {
        tk_messageBox -message "Le nombre de groupe est obligatoirement pair" -type ok
        set levelnb 1
    }
    
    if {$levelnb != 1} {
        
        #
        # Entrada del numero de bootstrap
        #
        entry .buttons.entrada2 -textvariable bootstrap
        pack .buttons.entrada2 -side bottom
        focus -force .buttons.entrada2
        balloonhelp_for .buttons.entrada2 "Entrer le nombre des BOOTSTRAPS\nEnter BOOTSTRAPS number."
        
        set compteur 0
        # inicializar suma() para evitar el error estilo suma(0) no existe
        foreach item $efectivos {
            # efectivos contiene los efectivos de cada grupo (ver boton entry entrada1)
            set sumavar($compteur) 0
            set sumamean($compteur) 0
            set t($compteur,0) 0
            set f($compteur,0) 0
            incr compteur
        }
        
        set compteur 0
        # inicializar suma() para evitar el error estilo suma(0) no existe
        foreach item $efectivos {
            for {set i 0} {$i < $bootstrap} {incr i} {
                set t($compteur,$i) 0
                set f($compteur,$i) 0
            }
            incr compteur
        }
        
        bind .buttons.entrada2 <Key-Return> {
            # El boton entrada2 contiene el numero de bootstrap
            .buttons.entrada2 configure -state disabled
            .buttons.bootstrap configure -state disabled
            #debug
            #puts "bootstrap $bootstrap"
            #puts " efectivos = $lista"
            set inicio 0
            set final 0
            
            
            # Petite fenetre de suivi des bootstraps
            destroy $p.bootstraps
            toplevel $p.bootstraps
            wm geometry $p.bootstraps +200+200
            button $p.bootstraps.l -text "Bootstrap" -command {}
            pack $p.bootstraps.l
            # Petite fenetre de suivi des bootstraps
            
            
            set contador 0
            foreach item $efectivos {
                # calculando los limites - inicio, final - de cada grupo
                set final [expr {$final + $item}]
                set obs [lrange $datos $inicio [expr {$final-1}]]
                # --------------------------------- bootstrap --------------------------------------------------
                set lignes [llength $obs]
                #
                #
                #debug 2008
                #$p insert end "\n ----------------------------------------\nGrupo $item: \n ----------------------------------------"
                for {set j 0} {$j < $bootstrap} {incr j} {
                    #
		    update
                    $p.bootstraps.l configure -text "Non-parametric ANOVA\nGroup [expr {$contador + 1}] (sample size $item): [expr {$j+1}] / $bootstrap"
		    #
                    #inicialisation de la lista aleatoria
                    #
                    #En cada iteracion, el BOOSTRAP genera una lista aleatoria del mismo tamano
                    #
                    set listnew [ranlist $obs $lignes]
                    #puts "bootstrap [expr {$j + 1}] : listnew $listnew"
                    #En cada iteracion (cada lista randomizada), el BOOSTRAP calcula la varianza
                    set bootvarmean [varianza $listnew]
                    #debug 2008
                    #$p insert end "\nBOOT [expr {$j+1}]: [lindex $bootvarmean 1]"
                    # bootvarmean contiene una lista de dos valores: la varianza y el promedio de 'listnew'
                    set bootvar [lindex $bootvarmean 0]
                    set bootmean [lindex $bootvarmean 1]
                    # Pour les tests ultérieurs comparant les comparaisons !
                    set varboot($contador,$j) $bootvar
                    set meanboot($contador,$j) $bootmean
                    #debug
                    #puts "bootvar $bootvar bootmean $bootmean"
                    #Se suman los resultados para despues (del bootstrap) hacer el promedio,
                    # estimacion no parametrica de la varianza (o del promedio) de cada bloque
                    set sumamean($contador) [expr {$sumamean($contador) + $bootmean}]
                    set sumavar($contador) [expr {$sumavar($contador) + $bootvar}]
                    
                }
                set inicio $final
		incr contador
                
            }
            
            # --------------------------------- bootstrap --------------------------------------------------
            
            # Moyenne des variances sur listes aleatoires
            #set contador 0
            #foreach item $efectivos {
            
            #    rouge "\n\nGroupe [expr {$contador + 1}]"
            #    vert "\nEstimation non-parametrique de la variance: [expr {$sumavar($contador) / $bootstrap}]\n"
            #    incr contador
            #"}
            
	    # Moyenne des moyennes sur listes aleatoires
            #set contador 0
            #foreach item $efectivos {
            #    rouge "\n\nGroupe [expr {$contador + 1}]"
            #    bleu "\nEstimation non-parametrique de la moyenne: [expr {$sumamean($contador) / $bootstrap}]\n"
            #    incr contador
            #"}
            
            # TESTS INTER COMPARAISONS
            set numgroup [llength $efectivos]
            
	    for {set b 0} {$b < $bootstrap} {incr b} {
                # debug 2008
                #$p insert end "\n\n---------------------------\nBOOT [expr {$b+1}], D1 y D2\n----------------------------------------\n"
                for {set i 0} {$i < $numgroup} {incr i} {
                    # debug 2008
                    #if { [expr {$i+1}] == 1 ||  [expr {$i+1}] == 3} {$p insert end "\nGRUPO [expr {$i+1}]"}
                    for {set j [expr {$i+1}]} {$j < $numgroup} {incr j} {
                        set diffmean [expr {$meanboot($i,$b) - $meanboot($j,$b) }]
                        # debug 2008
                        #if { [expr {$i+1}] == 1 &&  [expr {$j+1}] == 2} {$p insert end "... con GRUPO [expr {$j+1}] $meanboot($i,$b) - $meanboot($j,$b) = $diffmean"}
                        #if { [expr {$i+1}] == 3 &&  [expr {$j+1}] == 4} {$p insert end "... con GRUPO [expr {$j+1}] $meanboot($i,$b) - $meanboot($j,$b) = $diffmean"}
                        
			lappend diffmlist($b) "[expr {$i+1}] [expr {$j+1}] $diffmean"
                        set diffvar [expr {$varboot($i,$b) - $varboot($j,$b) }]
                        #$p insert end "\ncon GRUPO [expr {$j+1}] $varboot($i,$b) - $varboot($j,$b) = $diffvar"
                        lappend diffvlist($b) "[expr {$i+1}] [expr {$j+1}] $diffvar"
                    }
                }
	    }
            # debug 2008
            #$p insert end "\n"
            #for {set b 0} {$b < $bootstrap} {incr b} {
            #   $p insert end "\nBootstrap [expr {$b+1}]\t"
            #   $p insert end "[lindex $diffmlist($b) 0] [lindex $diffmlist($b) end]"
            #}
            
            # Sélection des paires de groupes comparées
            # Par ex. s'il y a 6 groupes, les paires pertinentes sont 1 et 2, 3 et 4, 5 et 6
            set numgroup [llength $efectivos]
            
            #debug 2008
            #$p insert end "\n\n"
            
            for {set b 0} {$b < $bootstrap} {incr b} {
                for {set i 0} {$i < $numgroup} {incr i 2} {
                    set par_1 [expr {$i + 1}]
                    set par_2 [expr {$i + 2}]
                    # Moyennes
                    set boulier1 0
                    
                    foreach item $diffmlist($b) {
                        if {[lindex $item 0] == $par_1 && [lindex $item 1] == $par_2} {
                            if {$b == [expr {$bootstrap - 1}]} {lappend parmrel $boulier1}
                            lappend diffmrellist($b) $item
                            #debug 2008
                            #$p insert end "\npar relevante : $item\tparrelev $boulier1"
                        }
                        incr boulier1
                        #debug
                        #$p insert end "\nboulier1 = $boulier1"
                    }
                    # Variances
                    set boulier1 0
                    foreach item $diffvlist($b) {
                        if {[lindex $item 0] == $par_1 && [lindex $item 1] == $par_2} {
                            if {$b == [expr {$bootstrap - 1}]} {lappend parvrel $boulier1}
                            lappend diffvrellist($b) $item
                            #debug
                            #$p insert end "\tpar relevante : $item\tparrelev $boulier1"
                        }
                        incr boulier1
                        #debug
                        #$p insert end "\nboulier1 = $boulier1"
                    }
                }
            }
            
            #debug
            #for {set b 0} {$b < $bootstrap } {incr b} {
            #    $p insert end "\nBootstrap [expr {$b+1}] M: $diffmrellist($b)"
            #    $p insert end "\nBootstrap [expr {$b+1}] V: $diffvrellist($b)\n"
            #}
            
            set numparrel [expr {$numgroup / 2}]
            
            # A cada bootstrap, diferencia entre diferencias relevantes
            for {set b 0} {$b < $bootstrap} {incr b} {
                set boulier -1
                # On navigue dans la liste des comparaisons pertinentes pour parcourir toutes les comparaisons
                # ... de comparaisons 1 et 2, 1 et 3, 1 et 4 si numparrel = 4, puis 2 et 3, 2 et 4 et 3 et 4
                for {set i 0} {$i < [expr {$numparrel-1}]} {incr i} {
                    
                    for {set j [expr {$i+1}]} {$j < $numparrel} {incr j} {
                        incr boulier
                        
			# Moyennes
                        set xx [lindex [lindex $diffmrellist($b) $i] end]
                        #set x [expr {abs($xx)}];july2008
                        set x $xx
                        set yy [lindex [lindex $diffmrellist($b) $j] end]
                        #set y [expr {abs($yy)}];july2008
                        set y $yy
                        set xy [expr {$x - $y}]
                        lappend compm($boulier) $xy
                        set relmpar($boulier) "[lrange [lindex $diffmrellist($b) $i] 0 1] and [lrange [lindex $diffmrellist($b) $j] 0 1]"
			#debug 2008
                        #$p insert end "\n$i : [lindex $diffmrellist($b) $i]  et $j  : [lindex $diffmrellist($b) $j]\tDiff = $xy"
                        #$p insert end  "\nlappend compm($boulier) $xy"
                        # Variances
                        set xx [lindex [lindex $diffvrellist($b) $i] end]
                        #set x [expr {abs($xx)}]; July 2008
                        set x $xx
                        set yy [lindex [lindex $diffvrellist($b) $j] end]
                        #set y [expr {abs($yy)}]; July 2008
                        set y $yy
                        set xy [expr {$x - $y}]
			lappend compv($boulier) $xy
                        set relvpar($boulier) "[lrange [lindex $diffvrellist($b) $i] 0 1] and \
							      [lrange [lindex $diffvrellist($b) $j] 0 1]"
                        #debug
                        #$p insert end "\n$i : [lindex $diffvrellist($b) $i]  et $j  : [lindex $diffvrellist($b) $j]\tDiff = $xy"
                        #$p insert end  "\nlappend compv($boulier) $xy"
                    }
		}
		#$p insert end "\n--------------------------------------------------\n"
                
            }
            # lecture des résultats des bootstraps
            
            if {$b == $bootstrap} {tk_messageBox -message "$b bootstraps: done" -type ok}
            
            set numcomp [expr {(($numparrel * $numparrel) - $numparrel)/2}]
            
            
            
            # Moyennes
            bleu "\n__________________________________________________\nNIVEAU II\tMoyennes ($bootstrap bootstraps) P= 0.05\n"
            #$p insert end "\n paires comparées $parmrel\n"
            
            for {set i 0} {$i < $numcomp} {incr i} {
                set sorted [lsort -real $compm($i)]
                # debug 2008
                #$p insert end "\n --------- [lrange $sorted 0 3]  ... etc.\n"
                
                # P = 0.05
                set percentile5   [expr {int(0.025 * $bootstrap)}]
                set percentile95  [expr {int(0.975 * $bootstrap)}]
                set lefttail [lindex $sorted $percentile5]
                set righttail [lindex $sorted $percentile95]
                # P = 0.005
                set percentile05   [expr {int(0.005 * $bootstrap)}]
                set percentile995  [expr {int(0.995 * $bootstrap)}]
                set lefttail05 [lindex $sorted $percentile05]
                set righttail995 [lindex $sorted $percentile995]
                # P = 0.001
                set percentile01   [expr {int(0.001 * $bootstrap)}]
                set percentile999  [expr {int(0.999 * $bootstrap)}]
                set lefttail01 [lindex $sorted $percentile01]
                set righttail999 [lindex $sorted $percentile999]
                
                # resultats: P = 0.05
                $p insert end "\n$relmpar($i) From $lefttail to $righttail"
                if {$lefttail <= 0 && $righttail >= 0} {
                    $p insert end "\n <- Not significant at P = 0.05 (range contains zero)"
                } else  {
                    rouge "\n <- SIGNIFICANT (P <0.05))"
                }
                # resultats: P = 0.005
                $p insert end "\n$relmpar($i) From $lefttail05 to $righttail995"
                if {$lefttail05 <= 0 && $righttail995 >= 0} {
                    $p insert end "\n <- Not significant at P = 0.005 (range contains zero)"
                } else  {
                    rouge "\n <- SIGNIFICANT (P <0.0051))"
                }
                # resultats: P = 0.001
                $p insert end "\n$relmpar($i) From $lefttail01 to $righttail999"
                if {$lefttail01 <= 0 && $righttail999 >= 0} {
                    $p insert end "\n <- Not significant at P = 0.001 (range contains zero)"
                } else  {
                    rouge "\n <- SIGNIFICANT (P <0.001))"
                }
                
            }
            
            # Variances
            vert "\n__________________________________________________\nNIVEAU II\tVariances ($bootstrap bootstraps) P = 0.05\n"
            #$p insert end "\n paires comparées $parvrel\n"
            for {set i 0} {$i < $numcomp} {incr i} {
                set sorted [lsort -real $compv($i)]
                
                # P = 0.05
                set percentile5   [expr {int(0.025 * $bootstrap)}]
                set percentile95  [expr {int(0.975 * $bootstrap)}]
                set lefttail [lindex $sorted $percentile5]
                set righttail [lindex $sorted $percentile95]
                
                # P = 0.005
                set percentile05   [expr {int(0.005 * $bootstrap)}]
                set percentile995  [expr {int(0.995 * $bootstrap)}]
                set lefttail05 [lindex $sorted $percentile05]
                set righttail995 [lindex $sorted $percentile995]
                # P = 0.001
                set percentile01   [expr {int(0.001 * $bootstrap)}]
                set percentile999  [expr {int(0.999 * $bootstrap)}]
                set lefttail01 [lindex $sorted $percentile01]
                set righttail999 [lindex $sorted $percentile999]
                
                
                # resultats: P = 0.05
                $p insert end "\n$relmpar($i) From $lefttail to $righttail"
                if {$lefttail <= 0 && $righttail >= 0} {
                    $p insert end "\n <- Not significant at P = 0.05 (range contains zero)"
                } else  {
                    rouge "\n <- SIGNIFICANT (P <0.05))"
                }
                # resultats: P = 0.005
                $p insert end "\n$relmpar($i) From $lefttail05 to $righttail995"
                if {$lefttail05 <= 0 && $righttail995 >= 0} {
                    $p insert end "\n <- Not significant at P = 0.005 (range contains zero)"
                } else  {
                    rouge "\n <- SIGNIFICANT (P <0.0051))"
                }
                # resultats: P = 0.001
                $p insert end "\n$relmpar($i) From $lefttail01 to $righttail999"
                if {$lefttail01 <= 0 && $righttail999 >= 0} {
                    $p insert end "\n <- Not significant at P = 0.001 (range contains zero)"
                } else  {
                    rouge "\n <- SIGNIFICANT (P <0.001))"
                }
                
            }
            
        }
    }
}
balloonhelp_for  .buttons.bootstrap  "INTERACTION \n(Bootstraps)"
#DEBUT PERMUTACIONES------------------------------------------------------------
destroy .buttons.permutaciones

button .buttons.permutaciones -text "N I  "  -command {
    
    global D tobs fobs
    #
    # Hacer desaparecer la entrada anterior, y el boton mismo (era para entrar los efectivos de cada bloque)
    #
    # destroy .buttons.entrada2
    
    #
    # Entrada del numero de permutaciones
    #
    entry .buttons.entrada3 -background aliceblue -textvariable nbpermut
    pack .buttons.entrada3 -side bottom
    focus -force .buttons.entrada3
    balloonhelp_for .buttons.entrada3 "Entrer le nombre des permutations.\nEnter PERMUTATIONS number"
    
    set compteur 0
    # inicializar suma() para evitar el error estilo suma(0) no existe
    foreach item $efectivos {
        # efectivos contiene los efectivos de cada grupo (ver boton entry entrada1)
        set sumavar($compteur) 0
        set sumamean($compteur) 0
        set t($compteur,0) 0
        set f($compteur,0) 0
        incr compteur
    }
    
    set compteur 0
    # inicializar suma() para evitar el error estilo suma(0) no existe
    foreach item $efectivos {
        for {set i 0} {$i < $nbpermut} {incr i} {
            set t($compteur,$i) 0
            set f($compteur,$i) 0
        }
        incr compteur
    }
    
    bind .buttons.entrada3 <Key-Return> {
        global S D
        set D(permutacion) 1
        set S(perm) 1
        onvapermuter $datos $efectivos $nbpermut
        .buttons.entrada3 configure -state disabled
        .buttons.permutaciones configure -state disabled
    }
    
}
balloonhelp_for  .buttons.permutaciones  "Non-parametric comparisons \n(Permutations)"
#FIN PERMUTACIONES---------------------------------------------------------------

button .buttons.anova -text "- Qst -" -bg "light yellow" -command {
    global p data efectivos
    # Rem. 'data' est globalisée dans 'ouvrir' et prend la valeur de 'datos'
    # 'efectivos' contient la liste des effectifs
    
    set N 0; # 'N' sera le total des individus
    if {$efectivos != ""} {
        $p insert end "\n\n========= oneway ======= ANOVA ================\n"
        set k [llength $efectivos]
        $p insert end "\n\n$k groupes\n"
        for {set i 1} {$i < [expr {$k+1}]} {incr i} {
            set n($i) [lindex $efectivos  [expr {$i-1}]]
            #debug
            $p insert end "\nn($i) = $n($i)"
            set N [expr {$N+$n($i)}]
        }
    } else  {
        tk_messageBox -message "D'abord entrer les effectifs s.v.p\nPlease enter sample sizes first." -type ok
    }
    
    if {$efectivos != ""} {
        #debug
        $p insert end "\n\nN (nb total d'individus)= $N\n"
        #$p insert end "\nDatos $data\n"
        
        set debut 0
        #foreach item $efectivos {
        for {set i 1} {$i < [expr {$k+1}]} {incr i} {
	    set fin [lindex $efectivos [expr {$i-1}]]
            set fin [expr {$debut + $fin - 1}]
            bleu "\ndébut $debut et fin $fin (debut+fin-1)"
            set groupe($i) [lrange $data $debut $fin]
            set debut [expr {$fin + 1}]
            bleu "\ndébut (fin+1) $debut et fin $fin"
            $p insert end "\n\nGroupe $i\n$groupe($i)\n----------------\n"
        }
        #}
        
        # Calcul de la moyenne totale
        set mean_total [::math::statistics::mean $data]
        bleu "\nMoyenne générale : $mean_total\n"
        
        # Calcul des moyennes par traitement / groupes
        for {set i 1} {$i < [expr {$k+1}]} {incr i} {
            set mean_groupe($i) [::math::statistics::mean $groupe($i)]
            bleu "\nMoyenne groupe $i: $mean_groupe($i)"
        }
        
        # Somme des écarts TOTALE
        set sst  0
        for {set i 0} {$i < $N} {incr i} {
            set ecart [expr {pow(([lindex $data $i]- $mean_total),2)}]
            set sst [expr {$sst + $ecart}]
        }
        bleu "\n\nSomme des écarts TOTALE $sst"
        set ddf_tot [expr {$N-1}]
        
        # Somme des écarts SSA (between-among groups / treatments)
        set ssa 0
        for {set i 1} {$i < [expr {$k+1}]} {incr i} {
            set x $mean_groupe($i)
            set ecart [expr {(pow(($x - $mean_total),2))*[llength $groupe($i)]}]
            set ssa [expr {$ssa + $ecart}]
        }
        bleu "\n\nSomme des écarts INTER (among, between - entre) $ssa"
        set ddf_ssa [expr {$k-1}]
        set Va [expr {$ssa * 1.0 / $ddf_ssa}]
        bleu "\nVa $Va \t ddf $ddf_ssa\n"
        
        # Somme des écarts SSE (within groups / treatments)
        set sse 0
        for {set i 1} {$i < [expr {$k+1}]} {incr i} {
            for {set j 0} {$j < [lindex $efectivos [expr {$i-1}]]} {incr j} {
                set x [lindex $groupe($i) $j]
                set ecart [expr {pow(($x - $mean_groupe($i)),2)}]
                set sse [expr {$sse + $ecart}]
            }
            #debug
            #$p insert end "\nsse groupe $i $sse\n"
        }
        bleu "\nSomme des écarts INTRA (within, dentro) \n$sse"
        set ddf_sse [expr {$N-$k}]
        set Vw [expr {$sse * 1.0 / $ddf_sse}]
        bleu "\nVw $Vw \t ddf $ddf_sse"

	bleu "\n\n--------------------------------------------------------"     
	$p insert end "\n         \t\tSSq\t\tMSq\t\tdf\n"
	bleu "----------------------------------------------------------" 
	$p insert end "\nAmong    \t\t[format "%1.4f" $ssa]\t\t[format "%1.4f" $Va]\t\t$ddf_ssa"
	$p insert end "\nResiduals\t\t[format "%1.4f" $sse]\t\t[format "%1.4f" $Vw]\t\t$ddf_sse\n"
	bleu "---------------------------------------------------------\n"
	
        rouge "\n\n\n\t --- Qst ---  --- --- --- Va / (Va + 2 Vw)  --- \n\n"
        set den [expr {$Va + 2 * $Vw}]
        set qst [expr ($Va * 1.0 / $den)]
        rouge "\t --- $qst \n\n\t --- Qst ---  --- --- ---\n\n"
    }
}


button .buttons.repeatability -text "- Repeatability -" -bg "light yellow" -command {
    global p S data efectivos colonne
    # Rem. 'data' est globalisée dans 'ouvrir' et prend la valeur de 'datos'
    # 'efectivos' contient la liste des effectifs
    
    set N 0; # 'N' sera le total des individus
    if {$efectivos != ""} {
	bleu "\n\n\n========= R   =  R  E  P  E  A  T  A  B  I  L  I  T  Y \n\
    \n You are invited to enter a file containing two successive sets of measurements \
    (usually centroid size, or relative warps) on the very same specimens, \
    in the same order"
        vert "\n\n========= R is computed as in Arnqvist & Martinsson, 1998 \n\
    For two groups, it is also called Intraclass correlation.\n\
    It is the interindividual variance divided by the sum of interindividual \
    and intraindividual variance\
    \nIntraindividual variance is possible if the same individuals are \
    'repeated' two times (at least), as for instance in repeated measurements\
    \nin that case, the repeatability indicates how far two measurements \
    of the same individual are correlated.\
    \n\nRepeatability is here the reverse of the measurement error as computed\
    in J. Claude (Morphometrics with R) - try it through the _R Menu"
        set k [llength $efectivos]
        $p insert end "\n\n$k groupes\n"
        for {set i 1} {$i < [expr {$k+1}]} {incr i} {
            set n($i) [lindex $efectivos  [expr {$i-1}]]
            #debug
            $p insert end "\nn($i) = $n($i)"
            set N [expr {$N+$n($i)}]
        }
    } else  {
        # Au cas ou a l'ouverture de VAR on clique tout-de-suite sur le bouton Repeatability
        type "D'abord entrer les effectifs please\nPlease data input first."
    }
    
    if {$efectivos != ""} {
        
        #Verification du type de fichier --- debut
        if {[string first "_ALIGNED" $infile] < 0 } {set fichier_aligned 0} else {set fichier_aligned 1}
        if {[string first "_CS" $infile] < 0 } {set fichier_cs 0} else {set fichier_cs 1}
        if {[string first "_PER" $infile] < 0 } {set fichier_per 0} else {set fichier_per 1}
        if {[string first "_ARE" $infile] < 0 } {set fichier_are 0} else {set fichier_are 1}
        if {[string first "_RW" $infile] < 0 } {set fichier_rw 0} else {set fichier_rw 1}
        set fichier_pw_cs 0
        if {[string first "_PW_CS" $infile] < 0 } {set fichier_pw_cs 0} else {set fichier_pw_cs 1;set fichier_rw 0;set fichier_cs 0}
        #debug
        #rouge " \nfichier_pw_cs == $fichier_pw_cs\tfichier_cs = $fichier_cs\tfichier_rw = $fichier_rw\n"
        if {$fichier_cs == 0 &&  $fichier_rw == 0 && $fichier_aligned == 0 && $fichier_per == 0 && $fichier_are == 0} {
            set nm [tk_messageBox -message "[file tail $infile]\nyour file does not seem to fit the required format\ndo you want to go on ? (computation could fail)" -icon warning -type yesno]
            if {$nm == no} {exit}
        }
        #Verification du type de fichier --- fin
        
        # --------------------------------------------------------------------
        # Verification de la structure des donnees   --- debut
        
        # Nombre de repetitions
        set nb_repetitions [llength $efectivos]
        if {[llength $efectivos] != 2} {
            set nm [type "Repeatability is computed by VAR for 2 sets of measurements, exclusively.\n\nThe VAR script will shut down. \n\nReport is saved as [file tail $S(infile)]_VAR_INFO.txt."]
            .buttons.informe invoke
            exit
        }
        
	if {[lindex $efectivos 0] != [lindex $efectivos 1]} {
            set nm [type "Repeatability (R):sample size must be equals between sets.\n\nThe VAR script will shut down.\n\nReport is saved as  [file tail $S(infile)]_VAR_INFO.txt."]
            exit
        }
        # Nombre de colonnes = en principe, il est deja calcule ligne 1160
        #
        $p insert end "\nTotal number of rows $nb_lignes\nNumber of columns (variables) : $nb_colonnes\n"
        
        # S'il y a plus d'une colonne, on suppose qu'il s'agit de la conformation, sinon on suppose CS
        if {$nb_colonnes > 1} {
            if {$fichier_aligned == 0} {
                if {$fichier_rw == 0} {
		    bleu "\nInput file is : $infile \n\nI am assuming you entered a set of RW (or of PC of shape variables), although the name of your file does not end by _RW\nThis assumption does not affect the calculation of repeatability."
                } else  {
                    bleu "\nInput file is : $infile \n\nI am assuming you entered a set of RW (or of PC of shape variables).\nThis assumption does not affect the calculation of repeatability."
                }
            } else  {
                bleu "\nInput file is : $infile \n\nI am assuming you entered a set of ALIGNED specimens.\nThis assumption does not affect the calculation of repeatability, but it modifies the output presentation."
            }
        } else  {
            if {$fichier_cs == 0 || $fichier_per == 0 || $fichier_are == 0} {
                bleu "\nInput file is : $infile \n\nI am assuming you entered a set of sizes, although the name of your file seems weird to me\nThis assumption could affect the calculation of repeatability."
            } else  {
                bleu "\nInput file is : $infile \n\nI am assuming you entered a set of sizes.\nThis assumption does not affect the calculation of repeatability."
            }
        }
        # Verification de la structure des donnees   --- fin
        # --------------------------------------------------------------------
        
	# Commentaires
        $p insert end "\n\nn1 + n2 = $N\n"
        $p insert end "\nn1 and n2 are two sets of data corresponding to the same specimens ordered in exactly the same way (see your input file). \n---------------"
        
	# # ----------------------------------------------------
        # Preparation des jeux de mesures a comparer  ---  debut
        #
        # Pour chaque colonne, constitution des DEUX jeux de mesures (cfr variable 'nb_repetitions')
        # (ce script n'est pas valable s'il y a plus de deux repetitions; dans ce cas d'ailleurs VAR proteste)
        #
        # On transforme d'abord la liste en matrice HUME
	#debug "Nb lignes $nb_lignes Nb colonnes $nb_colonnes"
        set hume "2 $nb_lignes $nb_colonnes "
	#stop
        set data_hume $hume$data
        set S(data_hume) $data_hume
        # On extrait les colonnes une a une (chaque colonnee represente 2 mesures successives)
        for {set i 0} {$i < $nb_colonnes} {incr i} {
            set colonne($i)  [mrange $data_hume $i $i 0 end]
            #debug "colonne $i:\n $colonne($i)\n[show $colonne($i)]"
        }
        # Pour chaque colonne, on separe les deux jeux de donnees
        for {set i 0} {$i < $nb_colonnes} {incr i} {
            set jeu_1($i)  [mrange $colonne($i) 0 0 0 [expr {[lindex $efectivos 0] - 1}]]
            set jeu_2($i)  [mrange $colonne($i) 0 0 [lindex $efectivos 0] end]
        }
        # Pour chaque colonne on calcule : moyennes individuelles, moyenne totale, et variance par rapport a cette moyenne
	set global_ss_among 0
        for {set i 0} {$i < $nb_colonnes} {incr i} {
            set moy_indiv($i) [madd $jeu_1($i) $jeu_2($i)]
            set moy_indiv($i) [mscale $moy_indiv($i) 0.5]
	    #rouge "\nSS average col $i: \n[show $moy_indiv($i)]"
            #
            set moy_tot($i) [mrange [mnorms $colonne($i)] 0 0 0 0]
            set moyenne_totale [expr {- [lindex $moy_tot($i) 3]}]
	    #rouge "\nSS total average col $i: $moyenne_totale"
            #
            set ss($i) [moffset $moy_indiv($i) $moyenne_totale]
	    #vert "\ndonnées centrées $i: \n[show $ss($i)]"
            set ss($i) [mprod $ss($i) $ss($i)]
	    #vert "\ndonnées centrées $i ^2: \n[show $ss($i)]"
	    set ss_total($i) [msum $ss($i)]
	    #rouge "\nSS among col $i: $ss_total($i)\n---\n"
            #
	    #  PROCRUSTES: Faire la somme des ss_total(i) pour la calculer la Variance among
	    #
	    set global_ss_among [expr {$global_ss_among + $ss_total($i)}]
	    # PROCRUSTES: fin
	    # 
            # mean squares
            set ss_mean($i) [expr {$ss_total($i) * ($nb_repetitions * 1.0 / ([lindex $efectivos 0] - 1) )}]
        }
	#rouge "\nGlobal SS among  : $global_ss_among";# PROCRUSTES
        #
        # Calcul des ecarts aux moyennes individuelles
	set global_ss_within 0
        for {set i 0} {$i < $nb_colonnes} {incr i} {
	    #bleu "\nJEUX $i[show $jeu_1($i)]"
            set ecarts_1 [msub $jeu_1($i) $moy_indiv($i)]
	    #bleu "ECARTS $i\n[show $ecarts_1]"
            set ecarts_2 [msub $jeu_2($i) $moy_indiv($i)]
            # On eleve les ecarts au carre
            set ecarts_1 [mprod $ecarts_1 $ecarts_1]
            set ecarts_2 [mprod $ecarts_2 $ecarts_2]
            # On somme le tout
            set ss_indiv_sum_1 [msum $ecarts_1]
            set ss_indiv_sum_2 [msum $ecarts_2]
            set ss_indiv_sum [expr {$ss_indiv_sum_1 + $ss_indiv_sum_2}]
            set ss_indiv_moy($i)  [expr {$ss_indiv_sum * 1.0 / ( [lindex $efectivos 0]  * $nb_repetitions - [lindex $efectivos 0]  ) }]
	    #rouge "\nWITHIN: $ss_indiv_sum \n"
	    # PROCRUSTES: faire la somme des ss_indiv_sum : c'est la SS within pour calculer la variance de l'ensemble"
	    #
	    # PROCRUSTES: fin
	    # 
	    set global_ss_within [expr {$global_ss_within + $ss_indiv_sum}]
	    #
        }
        #rouge "\nGlobal SS within : $global_ss_within";# PROCRUSTES:
	
        # Tableau des variances
        #


	# IF SHAPE ----------------------------------------------------------
	
	if {$nb_colonnes > 1} {
	    #type "NB COL $nb_colonnes"
	    #
	    bleu "\n\nIntermediate results: Procrustes ANOVA\n"
	    #
	    # Set up the column widths
	    set w1 10
	    set w2 13
	    set w3 13
	    #
	    # Make a nice header (with separator) for the table first
	    set sep +-[string repeat - $w1]-+-[string repeat - $w2]-+-[string repeat - $w3]-+
	    #
	    $p insert end "\n$sep"
	    $p insert end "\n"
	    bleu [format "| %-*s | %-*s | %-*s |" $w1 "Procrustes" $w2 "Among" $w3 "Within"]
	    $p insert end "\n$sep"
	    
	    # IF SHAPE --- start ...
	    # Print Table PROCRUSTES ANOVA
	    set dfa_lignes [expr {($nb_lignes * 1/2) - 1}]
	    set dfa [expr {$nb_colonnes * 1.0 / $dfa_lignes}]
	    set dfw_lignes [expr {$nb_lignes - 1}]
	    set dfw [expr {$nb_colonnes * 1.0 / $dfw_lignes}]
	    set g2a [expr {$global_ss_among * $dfa}]
	    set g2w [expr {$global_ss_within * $dfw}]
	    $p insert end "\n"
	    $p insert end [format "| %*s | %*f | %*f |" $w1 SS $w2 $global_ss_among $w3 $global_ss_within ]
	    $p insert end "\n$sep"
	    $p insert end "\n"
	    $p insert end [format "| %*s | %*f | %*f |" $w1 "* df" $w2 $dfa $w3 $dfw]
	    $p insert end "\n$sep"
	    $p insert end "\n"
	    $p insert end [format "| %*s | %*f | %*f |" $w1 MS $w2 $g2a $w3  $g2w]
	    $p insert end "\n$sep"
	    $p insert end "\n"
	    # IF SHAPE --- end ...
	} else {
	    # IF SIZE -----------------------------------------------------
	    #type "NB COL $nb_colonnes"
	    #
	    bleu "\n\nIntermediate results: ANOVA\n"
	    #
	    # Set up the column widths
	    set w1 5
	    set w2 13
	    set w3 13
	    #
	    # Make a nice header (with separator) for the table first
	    set sep +-[string repeat - $w1]-+-[string repeat - $w2]-+-[string repeat - $w3]-+
	    #
	    $p insert end "\n$sep"
	    $p insert end "\n"
	    bleu [format "| %-*s | %-*s | %-*s |" $w1 "size" $w2 "Among" $w3 "Within"]
	    $p insert end "\n$sep"
	    #
	    # # Print Table among and within for each PC
	    set compteur_col 0
	    for {set i 0} {$i < $nb_colonnes} {incr i} {
		# s2w et s2a
		set s2a [expr {(1.0 / $nb_repetitions) * ($ss_mean($i) - $ss_indiv_moy($i))}]
		set s2w $ss_indiv_moy($i)
		#
		#
		if  {[expr {$s2a + $s2w}] < 0.00001} {
		    $p insert end "\nThe number of variables is shortened (zero values)"
		    break
		}
		#
		incr compteur_col
		set rep($i) [expr {$s2a * 1.0 / ($s2a + $s2w)}];#ici le calcul de la repetabilite
		$p insert end "\n"
		$p insert end [format "| %*d | %*f | %*f |" $w1 [expr {$i+1}] $w2 $s2a $w3  $s2w]
	    }
	    $p insert end "\n$sep"
	    # IF SIZE... --- end
	}

        # Presentation de la repetabilite
        #
        if {$fichier_aligned == 0} {
            
            bleu "\n\nR E P E A T A B I L I T Y"
            #
	    # IF SHAPE ----------------------------------------------
	    if {$nb_colonnes > 1} {
	        set Rshape [expr {$g2a/($g2a+$g2w)}]
		#type "c'est ici $Rshape"
		rouge "\t$Rshape"
		$p see end
	    } else {
		# IF Size ----------------------------------------------
	    #set nb_colonnes [expr {$compteur_col - 1}]
	    set compteur_col 1;# on va se risquer
	    set nb_colonnes $compteur_col
	    #
	    #
	    $p insert end "\n\nFrom Column 1 to Column $nb_colonnes"
	    
	    set repsum 0
	    for {set i 0} {$i < $nb_colonnes} {incr i} {
		set repsum [expr {$repsum + $rep($i)}]
		set repmoyenne [expr {$repsum * 1.0 / ($i+1)}]
		set repmoy($i) $repmoyenne
		#debug "sum $i $repsum, En moyenne: $repmoy($i)"
	    }
	    if {$fichier_cs == 1 || $fichier_per == 1 || $fichier_are == 1} {
		#
		$p insert end "\nAssuming computation of size repeatability"
	    } else {
		# --- formatting mean repeatability value
		set mr $repmoy([expr {$i-1}])
		bleu "\n\nMean repeatability ($nb_colonnes PC): [expr {round(100*$mr)}] %"
		# --- formatting
	    }
	    #
	    # On separe les deux jeux de donnees
	    # a partir de S(data_hume), j1 = jeu 1 et j2 = jeu 2
	    set j1  [mrange $S(data_hume) 0 end 0 [expr {[lindex $efectivos 0] - 1}]]
	    set j2  [mrange $S(data_hume) 0 end [lindex $efectivos 0] end]
	    #
	    set paramj1 [mnorms_br j1 j1means S(j1sigma)]
	    set paramj2 [mnorms_br j2 j2means S(j2sigma)]
	    #debug "Jeu 1\n[show $j1]\nJeu 2\n[show $j2]\nMeans first measurement [show $j1means]\nVariances first measurement \n[show $S(j1sigma)]\n\Means second measurement [show $j2means]\nVariances second measurement \n[show $S(j2sigma)]"
	    set S(vartot1) [msum $S(j1sigma)];# c'est un scalaire!
	    set S(vartot2) [msum $S(j2sigma)];# c'est un scalaire!
	    #debug "$S(vartot1) = sum of : \n$S(j1sigma)\n$S(vartot2) = sum of : \n$S(j2sigma)"
	    # A present la variance de chaque composante principale, et sa contribution au total
	    #
	    #debug "nb col $nb_colonnes"
	    set sum_I(0) 0
	    set sum_II(0) 0
	    for {set i 0} {$i < $nb_colonnes} {incr i} {
		set var1 [vtrim [mrange $S(j1sigma) 0 end $i $i]]
		set var2 [vtrim [mrange $S(j2sigma) 0 end $i $i]]
		#debug "\n[expr {$i+1}]\nvar1 de $S(j1sigma):\t $var1\nvar2 de $S(j2sigma):\t $var2"
		set contj1($i) [format %1.3f [expr {$var1 * 1 / $S(vartot1)}]]
		set contj2($i) [format %1.3f [expr {$var2 * 1 / $S(vartot2)}]]
		
		if {$i > 0} {
		    set sum_I($i) $contj1($i)
		    set sum_I($i) [expr {$sum_I($i) + $sum_I([expr {$i-1}])}]
		    set sum_II($i) $contj2($i)
		    set sum_II($i) [expr {$sum_II($i) + $sum_II([expr {$i-1}])}]
		} else {
		    set sum_I($i) $contj1($i)
		    set sum_II($i) $contj2($i)
		}
		
		#debug "[expr {$i+1}] ( $contj1($i) <- $sum_I($i) et $contj2($i) <- $sum_II($i) )"
	    }
	    if {$fichier_cs == 1 || $fichier_per == 1 || $fichier_are == 1} {
		#
	    } else {
		# --- formatting shape contribution percent (scp)
		rouge "\nContribution of $nb_colonnes PC to shape variation:"
		set scp1 $sum_I([expr {$i-1}])
		rouge "\n- Measurement 1: [expr {round(100*$scp1)}] %"
		set scp2 $sum_II([expr {$i-1}])
		rouge "\n- Measurement 2: [expr {round(100*$scp2)}] %"
		# --- formatting shape contribution percent (scp)
		#
		$p insert end "\n\nContrib. (1) and (2): the contribution of the principal component (RW, or PC) to the total variance in each set of measurement - (1) and (2)."
	    }
	    
	    # Set up the column widths
	    set w1 3
	    set w2 13
	    set w3 13
	    set w4 13
	    
	    $p insert end "\n\n"
	    # Make a nice header (with separator) for the table first
	    set sep +-[string repeat - $w1]-+-[string repeat - $w2]-+-[string repeat - $w3]-+-[string repeat - $w3]-+
	    #
	    if {$fichier_cs == 1 || $fichier_per == 1 || $fichier_are == 1} {
		set sep +-[string repeat - $w1]-+-[string repeat - $w2]-+;# le tableau est prepare autrement
                $p insert end "\n$sep"
                $p insert end "\n"
                bleu [format "| %-*s | %-*s |" $w1 "CS" $w2 "Repeatability"]
            } else  {
                if {$fichier_pw_cs == 0} {
                    if {$fichier_rw == 0} {
                        $p insert end "\n$sep"
                        $p insert end "\n"
                        bleu [format "| %-*s | %-*s | %-*s | %-*s |" $w1 "Col" $w2 "Repeatability" $w3 "Contrib. (1)" $w4 "(and 2)"]
                    } else  {
                        $p insert end "\n\nContrib. (1) and (2): the contribution of the principal component (RW, or PC) to the total variance in each set of measurement - (1) and (2)."
                        $p insert end "\n$sep"
                        $p insert end "\n"
                        bleu [format "| %-*s | %-*s | %-*s | %-*s |" $w1 "RW" $w2 "Repeatability" $w3 "Contrib. (1)" $w4 "Contrib. (2)"]
                    }
                } else  {
                    set w1 5
		    rouge "PW_CS.txt is not the relevant file to enter for computing repeatability; please use separately the ..._CS.txt file for estimating size repeatability and ..._RW.txt for shape (RW, not PW)"
                    set sep +-[string repeat - $w1]+-[string repeat - $w2]-+-[string repeat - $w3]-+-[string repeat - $w4]-+
                    $p insert end "\n$sep"
                    $p insert end "\n"
                    bleu [format "| %-*s | %-*s | %-*s | %-*s |" $w1 "CS_PW" $w2 "Repeatability" $w3 "Contrib. (1)" $w4 " (and 2)"]
                }
            }
            $p insert end "\n$sep"
            
            # Print the contents of the table
            if {$fichier_cs == 1 || $fichier_per == 1 || $fichier_are == 1} {
                for {set i 0} {$i < $nb_colonnes} {incr i} {
                    $p insert end "\n"
                    $p insert end [format "| %*d | %*f |" $w1 [expr {$i+1}] $w2 $rep($i)]
		}
            } else {
		# IF SHAPE? 
		type "if shape?"
                for {set i 0} {$i < $nb_colonnes} {incr i} {
                    $p insert end "\n"
                    $p insert end [format "| %*d | %*f | %*f | %*f |" $w1 [expr {$i+1}] $w2 $rep($i) $w3 $contj1($i) $w4 $contj2($i)]
		}
	    }
	    
	    # Finish off by printing the separator again
	    $p insert end "\n$sep"
	    $p see end
	}
	} else  {
	    bleu "\n\nR E P E A T A B I L I T Y"
	    # Il s'agit des coordonnees residuelles, on cherche a connaitre la R de chaque LM
	    #
	    # Set up the column widths
	    set w1 3
	    set w2 13
	    set w3 13
	    # Make a nice header (with separator) for the table first
	    set sep +-[string repeat - $w1]+-[string repeat - $w2]-+-[string repeat - $w3]-+
	    $p insert end "\n$sep"
	    $p insert end "\n"
	    bleu [format "| %-*s | %-*s | %-*s |" $w1 "LM" $w2 "X coordinate" $w3 "Y coordinate"]
	    $p insert end "\n$sep"
	    set compteur 0
	    for {set i 0} {$i < $nb_colonnes} {incr i 2} {
		incr compteur
		$p insert end "\n"
		bleu [format "| %*d | %*f | %*f |" $w1 $compteur $w2 $rep($i) $w3 $rep([expr {$i+1}])]
	    }
	    $p insert end "\n$sep\n"
	}
	
    };# Fin de "si les effectifs sont bien entres (pas nuls)"
};# Fin du bouton Repeatability

pack .buttons.permutaciones -side left
pack .buttons.bootstrap -side left
pack .buttons.anova -side left
pack .buttons.repeatability -side left

balloonhelp_for  .buttons.repeatability  "REPEATABILITY\nPlease enter file_CS, _ARE, _PER, or _RW, or _ProcrRes_PC or _FOGnefcp"


# SCRIPT PRINCIPAL --------------------------------------------------------
