package require Tk

cd [file dirname [info script]]

# Pour la version DEVELOPPEMENT
if {[file tail [info script]] != "var"} {
    cd "/home/jepi/mytcl/Developpement/VARlin"
}

source math/statistics.tcl
source ballons.tcl
source 101La.tcl
source jpdraw_10b.tcl

global D
set D(permutacion) 0

# Procedure SINO - debut
#
proc sino {question} {
    
    if {[info exists reponse_sino]} {unset reponse_sino}
    
    global reponse_sino
    
    destroy .sinon
    toplevel .sinon -relief raised
    wm geometry .sinon +200+290
    wm title .sinon "Remover la primera linea ?"
    
    frame .sinon.frame -relief flat
    pack .sinon.frame -side top -fill y -anchor center
    
    frame .sinon.frame.1
    pack .sinon.frame.1 -side top -pady 2 -anchor e
    
    label .sinon.frame.1.label -text $question -anchor e -font "Courier 12"
    pack .sinon.frame.1.label -side right
    
    frame .sinon.bouton
    pack .sinon.bouton -side bottom -pady 2 -anchor center
    
    button .sinon.bouton.si -text " SI " -command {
        destroy .sinon
        set reponse_sino 1
    }
    button .sinon.bouton.no -text " NO " -command {
        destroy .sinon
        set reponse_sino 0
    }
    pack .sinon.bouton.si .sinon.bouton.no -side left -padx 22
    focus -force .sinon.bouton.no
    vwait reponse_sino
    return $reponse_sino
}
#
# Procedure SINO - fin


# Procedure TREBUCHE - debut
#
proc trebuche {} {
    
    global S p
    
    set vraiment "The file, if produced by MOG, could contain the consensus as the first value: \
            \ndo you want to remove this consensus individual ?"
    set sujet "'First one is consensus'"
    set confirmer [sino $vraiment]
    
    if {$confirmer == 1} {
        $p insert end "\nWarning: First row will be removed from data\n"
        return 2
    } else  {
        return 1
    }
}
#
# Procedure TREBUCHE - end


# Procedure VERDIA - end
#
proc verdia {diapositiva} {
    # Procedure para ver una diapositiva
    image create photo fotoa
    fotoa configure -file $diapositiva
    set wi [image width fotoa]
    set he [image height fotoa]
    
    destroy .d
    toplevel .d
    wm geometry .d +550+50
    
    destroy .d.can .d.v_scroll .d.h_scroll
    
    canvas .d.can -width $wi -height $he \
            -yscrollcommand ".d.v_scroll set" \
            -xscrollcommand ".d.h_scroll set"
    
    scrollbar .d.v_scroll -command ".d.can yview"
    scrollbar .d.h_scroll -command ".d.can xview" -orient horizontal
    
    # Fill in canvas
    .d.can create image 0 0 -image fotoa -anchor nw
    .d.can configure -scrollregion [.d.can bbox all]
    
    pack .d.v_scroll -side right -fill y
    pack .d.h_scroll -side bottom -fill x
    pack .d.can -side left -expand 1
    
    bind .d.can <Button-3> {destroy .d}
}
#
# Procedure VERDIA - end

# Procedure SAVELISTING - start
#
proc  savelisting {dequoi} {
    # ***************************************************************
    # Tentative d'ecriture d'un fichier DE RAPPORT en CSV
    # ***************************************************************
    global p infile sentier
    set megainfo "\nFichier : $infile\n"
    set megatexte [$p get 1.0 {end}]
    
    global infile
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    #debug
    #puts "chemin = $dirinfile"
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    #debug
    #puts "\ntail = $tailfile"
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    #debug
    #puts "root = $rootfile"
    set fin $dequoi
    set filename "$dirinfile$rootfile$fin"
    #debug
    #puts "filename = $filename"
    
    wm title . $filename
    # OPEN THE FILE
    set fileid [open $filename a]
    # FILL THE FILE
    puts -nonewline $fileid $megainfo
    puts -nonewline $fileid $megatexte
    # CLOSE THE FILE
    close $fileid
}
#
# Procedure SAVELISTING - end


# procedure RANLIST - debut
#
proc ranlist {liste lignes} {
    set  lignesmoinsun [expr {$lignes - 1}]
    #initialisation
    set listnew ""
    #-----------------------------------------------
    #LISTE ALEATOIRE "SAMPLING WITH REPLACEMENT"
    #-----------------------------------------------
    for {set i 0} {$i < $lignes} {incr i} {
        set num [expr {round ($lignesmoinsun * rand () )}]
        set newline [lindex $liste $num]
        set listnew [concat $listnew $newline]
    }
    set newlist $listnew
    #-----------------------------------------------
    #FIN (CREATION D'UNE MATRICE ALEATOIRE)
    #-----------------------------------------------
    return $newlist
}
#
# Procedure RANLIST - fin

proc graphique {datos efectivos} {
    # GRAPHIQUE - start
    global p numfen intervalle colonnes references primeralinea
    set numfen 1
    set intervalle 40
    set colonnes [llength $efectivos]
    set references $primeralinea
    #debug
    #rouge "\nGroupes [llength $efectivos]\nvaleurs $datos\nEffectifs $efectivos "
    range [llength $efectivos] $datos $efectivos
    # GRAPHIQUE - fin
    return 1
}

# Procedure AFFICHE - debut
#
# Permet de faire apparaitre un avis
#
proc affiche {x y avis} {
    # x est la position sur l'axe horizontal de l'ecran
    # y est la position sur l'axe vertical de l'ecran
    # missive contient le message qu'on veut afficher
    #puts "help"
    destroy .avis
    toplevel .avis
    wm geometry .avis +$x+$y
    message .avis.t -aspect 1000 -text $avis
    pack .avis.t
}
#
# Procedure AFFICHE - fin

#
# ################### bleu ##### Procedure ## Debut ##
proc bleu {mesg args} {
    global p
    $p insert end $mesg "bleu"
    update
    flush stdout
}
#$p tag configure bleu -foreground blue
################### bleu ####### PROCEDURE ## FIN ###

################### rouge ##### Procedure ## Debut ##
proc rouge {mesg args} {
    global p
    $p insert end $mesg "rouge"
    update
    flush stdout
}
#$p tag configure rouge -foreground red
################### rouge ####### PROCEDURE ## FIN ###

################### vert ##### Procedure ## Debut ##
proc vert {mesg args} {
    global p
    $p insert end $mesg "vert"
    update
    flush stdout
}
#$p tag configure vert -foreground "dark green"
################### vert ####### PROCEDURE ## FIN ###

# Procedure COMPNUEV -start
#
proc comparacionesnuevas {listapermutada efectivos} {
    global D
    set data $listapermutada
    # Disseccion de la lista de los datos en bloques: llamada a la procedura DISSECCION
    set result [disseccion $data $efectivos]
    # Ahora tenemos una lista de n (observados)
    set nlist [lindex $result 2]
    # Ahora tenemos una lista de promedios (observados)
    set moylist  [lindex $result 1]
    # Ahora tenemos una lista de varianzas (observadas)
    set varlist  [lindex $result 0]
    # Comparacion de las varianzas entre  bloques: llamada a la procedura COMPVAR
    set permut_f_g1_g2 [compvar $varlist $efectivos]
    # Comparacion de los promedios entre  bloques: llamada a la procedura COMPMOY
    set permut_t_g1_g2 [compmoy $moylist $varlist $nlist]
    set lista_f_t [list $permut_f_g1_g2 $permut_t_g1_g2 ]
    return $lista_f_t
}
#
# Procedure COMPNUEV - end



# Procedure SWAP - start
#
proc  swap {desc k n} {
    # Esta procedura llamada por otra procedure (PERMUTAR)
    set numk [lindex $desc [expr {($k-1)}]]
    set numn [lindex $desc  [expr {($n-1)}]]
    set newdesc [lreplace $desc  [expr {($k-1)}]  [expr {($k-1)}] $numn]
    set neufdesc [lreplace $newdesc [expr {($n-1)}] [expr {($n-1)}] $numk]
}
#
# Procedure SWAP - end


# Procedure PERMUTAR - start
#
proc permutar {total} {
    # Algorithm Knuth (1981)
    #1
    set n [llength $total]
    # preparacion del ciclo
    set j $n
    #set total $inicio
    # ciclo
    while {$j > 1} {
        #2
        set U [expr {rand()}]
        #3
        set k [expr {int($j * $U)+1}]
        #4
        set newtotal  [swap $total $k $j]
        set total $newtotal
        incr j -1
    }
    return $newtotal
}
#
# Procedure PERMUTAR - end


#procedure ONVAPERMUTER     - debut
#
# arg = datos efectivos fobs tobs numpermut
proc onvapermuter {datos efectivos nbpermut} {
    global p D tobs fobs
    set inicio $datos
    # calculo del numero total de comparaciones posibles entre g grupos
    set g [llength $efectivos]
    set numcomp [expr {(pow($g,2) - $g)/2}]
    # Calcul approximatif du Bonferroni
    set bonferroni [expr {0.05 * 1.0 / $numcomp}]
    # inicializar dos variables con indice
    for {set i 0} {$i < $numcomp} {incr i} {
        set t($i) 0
        set f($i) 0
    }
    # Numero de permutaciones
    for {set i 0} {$i < $nbpermut} {incr i} {
        set listapermutada [permutar $inicio]
        #debug
        #puts "Permutacion numero $i: $inicio -> $listapermutada"
        set lista_f_t [comparacionesnuevas $listapermutada $efectivos]
        #puts "\nPermutacion $i: variances -> [lindex $lista_f_t 0]"
        #puts "Permutacion $i: moyennes -> [lindex $lista_f_t 1]\n"
        # cuantos f randomizados > = f observado
        set compteur 0
        foreach element   [lindex $lista_f_t 0] {
            #debug
            #puts "[lindex $element 0] > $fobs($compteur)"
            if  {[lindex $element 0] > $fobs($compteur)} { incr f($compteur)}
            incr compteur
        }
        # cuantos t randomizados > = t observado
        set compteur 0
        foreach element   [lindex $lista_f_t 1] {
            #debug
            #puts "[lindex $element 0] > $tobs($compteur) "
            if  {[lindex $element 0] > $tobs($compteur)} { incr t($compteur)}
            incr compteur
        }
    }
    
    if {$i == $nbpermut} {tk_messageBox -message "$nbpermut permutations: done" -type ok}
    
    for {set i 0} {$i < $numcomp} {incr i} {
        set element [lindex  $lista_f_t 1]
        set element [lindex $element $i]
        set trandom [expr {$t($i) * 1.0 / $nbpermut}]
        set trandom [format "%1.5f" $trandom]
        set frandom [expr {$f($i) * 1.0 / $nbpermut}]
        set frandom [format "%1.5f" $frandom]
        bleu "\n_____________________________________________________________"
        bleu "\n\nNIVEAU I\tComparaison non parametrique des moyennes"
        bleu "\nentre [lindex $element 1] y [lindex $element 2]:\tP = $trandom"
        .debut insert end "\n t random mas grande $t($i) veces sobre $nbpermut"
        
        
        if {$trandom > $bonferroni || $trandom == $bonferroni} {
            $p insert end "\n-> Starting value for the Bonferroni test : $bonferroni"
            append tabla_t "$trandom "
        } else {
            bleu "\n->SIGNIFICATIF  (< $bonferroni)"
            append tabla_t "$trandom "
        }
        
        
        set element [lindex  $lista_f_t 0]
        set element [lindex $element $i]
        vert "\n_____________________________________________________________"
        vert "\n\nNIVEAU I\tComparaison non parametrique des variances"
        vert "\nentre [lindex $element 1] y [lindex $element 2]:\tP = $frandom"
        .debut insert end "\n f random mas grande $f($i) veces sobre $nbpermut"
        
        
        if {$frandom > $bonferroni || $frandom == $bonferroni} {
            $p insert end "\n->  Starting value for the Bonferroni test : $bonferroni"
            append tabla_f "$frandom "
        } else  {
            vert "\n->SIGNIFICATIF (< $bonferroni)"
            append tabla_f "$frandom "
        }
    }
    
    $p insert end "\n\n_____________________________________________\n"
    
    bleu "\n\nNIVEAU I\tCOMPARAISONS DES MOYENNES\nTable des valeurs de P apres $nbpermut permutations\n"
    table_signif $tabla_t [llength $efectivos]
    
    vert "\n\nNIVEAU I\tCOMPARAISONS DES VARIANCES\nTable des valeurs de P apres $nbpermut permutations\n"
    table_signif $tabla_f [llength $efectivos]
    
    $p insert end "\n\n"
    
}
#
#procedure ONVAPERMUTER     - fin


# PROCEDURE table_signif - debut
# arguments (tabla_t o tabla_f) et "grupos"
#
# Cette procédure est appelée TABLE_OUTPUT dans COV
# Elle transforme une liste de distances en une table
#
proc table_signif {distancias grupos} {
    global p
    
    #Ici je cree une table de ZEROs selon nombre de groupes
    for {set i 1} {$i < [expr {$grupos+1}]} {incr i} {
        for {set j 1} {$j <  [expr {$grupos+1}]} {incr j} {
            set tabdis($i,$j) 0
        }
    }
    # Inscription dans la table des valeurs observees (cfr. "distancias")
    set compteur 0
    for {set i 1} {$i < $grupos} {incr i} {
        for {set j [expr {$i+1}]} {$j < [expr {$grupos + 1}]} {incr j} {
            set tabdis($i,$j)  [lindex $distancias $compteur]
            incr compteur
        }
    }
    # Preparation d'une matrice de fromat HUME
    # step 1
    set numcomp  [expr {($grupos * $grupos - $grupos)  / 2}]
    # step 2
    for {set i 1} {$i < [expr {$grupos+1}]} {incr i} {
        for {set j 1} {$j <  [expr {$grupos+1}]} {incr j} {
            append listdis "$tabdis($i,$j) "
        }
    }
    # step 3
    set codematrix "2 $grupos $grupos"
    # final steps
    set matdis [concat $codematrix $listdis]
    set matdis [transpose $matdis]
    
    # Display
    for {set i 1} {$i < [mrows $matdis]} {incr i} {
        $p insert end "\n_[expr {$i+1}]  [show [mrange $matdis 0 [expr {$i-1}] $i $i] %1.3f]"
    }
}
#
# PROCEDURE table_signif - fin



# Procedure COMPMOY
#
proc compmoy {moylist varlist nlist} {
    global D tobs
    set permut_t_g1_g2_p ""
    # ------------------------------------
    # comparacion de promedios
    # ------------------------------------
    # numero de valores en la lista de moyennes
    set moynb [llength $moylist]
    # display only if not permutating
    if {$D(permutacion) < 1} {
        rouge "\nliste $moylist"
    }
    set compteur 0
    #set comparmoy 0
    for {set i 0} {$i < [expr {$moynb - 1}]} {incr i} {
        # premiere moyenne
        #debug
        #puts "\n i ... $i -> [lindex $moylist $i] "
        set va  [lindex $varlist $i]
        set na  [lindex $nlist $i]
        for {set j [expr {$i+1}]} {$j < $moynb} {incr j} {
            #deuxieme moyenne
            #debug
            #puts "\n J ... $j -> [lindex $moylist $j] "
            set vb  [lindex $varlist $j]
            set nb  [lindex $nlist $j]
            set meandif [expr {[lindex $moylist $i] - [lindex $moylist $j]}]
            set meandifabs [expr {abs ($meandif)}]
            
            # Manly p.4
            set vcom [expr {sqrt ( ( ($na-1) * $va + ($nb-1) * $vb ) * 1.0/ ( ($na-1)+($nb-1) ) )}]
            set raiz [expr {sqrt (1.0 / $na + 1.0 / $nb)}]
            set denominator [expr {$vcom * $raiz}]
            set t [expr {$meandifabs *1.0 / $denominator}]
            set moymenus($i,$j) $meandifabs
            #debug
            #puts "D(permutacion) $D(permutacion)"
            
            # set only if not permutating
            if {$D(permutacion) < 1} {
                set tobs($compteur) $t
            }
            # display only if not permutating
            if {$D(permutacion) < 1} {
                rouge "\n\nMoyennes comparées groupe [expr {$i+1}]\
                        avec groupe [expr {$j+1}] ( [lindex $moylist $i] avec [lindex $moylist $j] )"
                rouge ""
            }
            # compute P only if means are not equals, sino P vale 1
            if {$t == 0} {
                # Calcul de la signification
                set degrees [expr {$na+$nb - 2}]
                set prob   1
            }
            # compute only if not permutating and if Student > 0
            if {$D(permutacion) < 1 && $t > 0} {
                #debug
                #puts "Si no se permuta se computa"
                # Calcul de la signification
                set degrees [expr {$na+$nb - 2}]
                set prob    [::math::statistics::cdf-students-t $degrees $t]
                set prob [expr {(1 - $prob)*2}]
            }
            
            # display only if not permutating
            if {$D(permutacion) < 1} {
                bleu "\n\nt = $t \
                        \nP = $prob \
                        \nDegrés de liberté: $degrees"
            }
            
            if {$D(permutacion) < 1} {
                # Si se trata de permutaciones o no, guardar los resultados grupos comparados y t
                lappend permut_t_g1_g2_p [list $t   [expr {$i+1}]  [expr {$j+1}] $prob]
            } else  {
                lappend permut_t_g1_g2_p [list $t   [expr {$i+1}]  [expr {$j+1}]]
            }
            
            incr compteur
        }
    };# fin de la comparaison des moyennes
    return $permut_t_g1_g2_p
}
#
# Procedure COMPMOY


# Procedure DISSECCION - debut
#
proc disseccion  {listapermutada efectivos} {
    global D
    set data $listapermutada
    set inicio 0
    set final 0
    set varlist ""
    foreach item $efectivos {
        # calculando los limites - inicio, final - de cada grupo
        set final [expr {$final + $item}]
        set obs [lrange $data $inicio [expr {$final-1}]]
        #calculando la varianza del grupo considerado (obs)
        set varmeanum [varianza $obs]
        
        set variance [lindex $varmeanum 0]
        set moyenne [lindex $varmeanum 1]
        set n [lindex $varmeanum 2]
        
        # agregando cada varianza a una lista
        lappend varlist "$variance"
        # agregando cada moyenne a una lista
        lappend moylist "$moyenne"
        # agregando cada n a una lista
        lappend nlist "$n"
        # monstrar los resultados
        # display only if not permutating
        #if {$D(permutacion) < 1} {
        #puts "\nvariance = $variance\n"
        #puts "moyenne = $moyenne\n"
        #}
        #debug
        #puts "De inicio $inicio a  [expr {$final-1}]"
        #puts "variance = $variance\n"
        set inicio $final
    }
    return [list $varlist $moylist $nlist]
}
#
# Procedure DISSECCION - fin


# Procedure COMPVAR - fin
#
proc compvar {varlist efectivos} {
    global D fobs
    set permut_f ""
    # numero de valores en la lista de varianzas
    set varnb [llength $varlist]
    #$p insert end "\nliste $varlist"
    #set comparvar 0
    set compteur 0
    for {set i 0} {$i < [expr {$varnb-1}]} {incr i} {
        #$p insert end "\n i ... $i -> [lindex $varlist $i] "
        for {set j [expr {$i+1}]} {$j < $varnb} {incr j} {
            #$p insert end "\n J ... $j -> [lindex $varlist $j] "
            ;# ---- NOV 2006 THE RATIO IS LARGER / SMALLER
            if {[lindex $varlist $i] >= [lindex $varlist $j] } {
                set ratio [expr {[lindex $varlist $i]  * 1.0/ [lindex $varlist $j]}]
            } else  {
                set ratio [expr {[lindex $varlist $j]  * 1.0/ [lindex $varlist $i]}]
            }
            set varratio($i,$j) $ratio
            
            # set only if not permutating
            if {$D(permutacion) < 1} {
                set fobs($compteur) $ratio
            }
            
            # display only if not permutating
            if {$D(permutacion) < 1} {
                bleu "\n\nVariances comparées groupe [expr {$i+1}]\
                        avec groupe [expr {$j+1}] \
                        \n Effectifs  [lindex $efectivos $i] \t<-> [lindex $efectivos $j]\
                        \n Variances  [lindex $varlist $i] \t<-> [lindex $varlist $j] )\
                        \n Std dev.:  [expr {sqrt([lindex $varlist $i])}] \t<-> [expr {sqrt([lindex $varlist $j])}]\n"
            }
            
            # Calcul de la signification ---- NOV 2006 v1 and v2 IN DIFFERENT ORDER ACCORDING TO WHICH VARIANCE IS LARGER
            if {[lindex $varlist $i] >= [lindex $varlist $j] } {
                set v1  [expr {[lindex $efectivos $i] - 1}]
                set v2  [expr {[lindex $efectivos $j] - 1}]
            } else  {
                set v1  [expr {[lindex $efectivos $j] - 1}]
                set v2  [expr {[lindex $efectivos $i] - 1}]
            }
            set F $ratio
            set P_ratio  [::math::statistics::Cdf-toms322 $v1 $v2 $F]
            set P_display [expr {(1-$P_ratio)*2}];# ---- NOV 2006 multiplied by two because we test for two-tailed inequality
            
            # display only if not permutating
            if {$D(permutacion) < 1} {
                vert "La valeur observée de la statistique de test F: $ratio \nDegrés de liberté: $v1 y $v2 \nP : \
                        $P_display"
            }
            
            # display only if not permutating
            if {$D(permutacion) < 1} {
                # Si se trata de permutaciones o no, guardar los resultados grupos comparados y F
                lappend permut_f [list $ratio   [expr {$i+1}]  [expr {$j+1}] $P_display]
            } else  {
                lappend permut_f [list $ratio   [expr {$i+1}]  [expr {$j+1}]]
            }
            incr compteur
            
        }
        
        # display only if not permutating
        if {$D(permutacion) < 1} {
            rouge "\n----------------------------\n"
        }
        
    };# fin de la comparaison des variances observées
    return $permut_f
}
#
# Procedure COMPVAR - fin



# Procedure VARIANZA - debut
#
proc varianza {obs} {
    
    global p bootstrap D
    
    #debug
    #$p insert end "\n\n    nuevo calculo    \n\nobs = $obs\n"
    #
    # Nombre d'indiv dans ce bloc
    set n [llength $obs]
    
    if {[info exists bootstrap] && $bootstrap > 0} {
        #nada
    } else  {
        # Hacemos el output si no se trata del bootstrap
        if {$D(permutacion) < 0} {
            rouge "[lrange $obs 0 2] ... [lindex $obs end]"
            puts "\nNombre d'éléments du groupe = "
            puts $n
        }
    }
    
    
    # suma de los datos
    set suma 0
    foreach item $obs {
        set suma [expr {$suma + $item}]
    }
    #debug
    #$p insert end "\nsuma = $suma\n"
    
    # promedio de los datos
    set mean [expr {$suma * 1.0 / $n}]
    
    if {[info exists bootstrap]} {
        #nada
    } else  {
        # Hacemos el output si no se trata del bootstrap
        #if {$D(permutacion) < 1} {
        #    puts "\nMoyenne ="
        #    puts "$mean"
        #}
    }
    
    # centrar los datos
    foreach item $obs {
        lappend centr [expr {$item - $mean}]
    }
    #debug
    #$p insert end "\ncentrado = $centr\n"
    
    # elevar al cuadrado los datos centrados, y sumar
    #
    foreach  item $centr {
        lappend centr_sq [expr pow ($item , 2)]
    }
    #debug
    #$p insert end "\ncentrado al cuadrado = $centr_sq\n"
    
    set suma_centr_sq 0
    foreach  item $centr_sq {
        set suma_centr_sq [expr {$suma_centr_sq + $item}]
    }
    #debug
    #$p insert end "\nsuma de los centrados al cuadrado = $suma_centr_sq\n"
    
    # resultado final: varianza
    set var [expr {$suma_centr_sq / ($n-1)}]
    #debug
    #$p insert end "\nla varianza de la lista es: $var"
    
    # Lo que retorna la procedura 'varianza' ('varmeanum') es una lista de tres valores:
    # la varianza ('var'))
    # el promedio ('mean'))
    # el nimero de individuos del bloque ('n')
    set varmeanum [list $var $mean $n]
    return $varmeanum
}
#
# Procedure VARIANZA - fin

###################### ouvrir ######## PROCEDURE ## DEBUT###


proc ouvrir {} {
    global p data
    set typeList {
        {{"Text files"} {.seq .txt .nts .TXT .NTS .csv .CSV .tps .TPS} }
    }
    global infile texte dossier primeralinea
    
    # Chercher le chemin dans un fichier de configuration
    # 1. verifier que le fichier de configuration existe
    set chemin "[pwd]/dossier_var.txt"
    #puts "chemin $chemin"
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
        set candidat_dossier [pwd]
    } else  {
        #puts "La conf existe"
        # 3. s'il existe reccueillir le dernier chemin parcouru
        # open le fichier pour lire
        catch [
        set fid [open $chemin r]
        set candidat_dossier [read -nonewline $fid]
        close $fid
        ] ici
        #puts "candidat_dossier $candidat_dossier"
        set candidat_dossier [lindex [split $candidat_dossier \n] 1]
        # debug
        #puts "dossier = $candidat_dossier"
    }
    
    # On va chercher les donnees --------------------------------------------------------
    #catch [
    set infile [tk_getOpenFile -initialdir $candidat_dossier -filetypes $typeList]
    set fid [open $infile]
    set texte [read -nonewline $fid]
    close $fid
    #] ici
    
    # Enlever la premiere valeur si le fichier a ete cree par MOG
    # set seuil [trebuche]
    set seuil 1
    #debug
    #puts "seuil $seuil"
    
    # ajoute pour tenter de supprimer les lignes vides
    foreach line [split $texte \n] {
        if  {$line != ""} {
            append newtexte "$line\n"
        }
    }
    set datos ""
    set contador -1
    foreach item [split $newtexte "\n"] {
        if  {$item != ""} { incr contador}
        if {$contador > 0} {
            
            if  {$item != "" && $contador == $seuil || $contador > $seuil } {
                append datos "$item "
                #debug
                #puts "contador $contador"
            }
            
        } else  {
            set primeralinea $item
        }
    }
    
    $p insert end "\n$primeralinea\n"
    
    $p insert end "\nNombre de données : $contador\n"
    
    
    #debug
    #puts "\ndatos--------------- \n$datos\n ----------------\n"
    # ------------------------------------------------------------------------------------------
    
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
        # open le fichier de conf pour ecrire
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilisees par VAR:\n"
        puts -nonewline $fid $dossier
        close $fid
        ] ici
    }
    #debug
    #puts "chemin = $dirinfile"
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    #debug
    #puts "\ntail = $tailfile"
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    #debug
    #puts "root = $rootfile"
    
    #.fdbuttonsdt configure -text $infile
    
    set data $datos
    return $datos
}
#
# procedure OUVRIR - fin



# SCRIPT PRINCIPAL -------------------------------------------------------------------

global bootstrap

set version 01
# --------------------------------------------- 1 -------------------------------------------------
# Preparar la ventana salida = WIDGET con SCB, FRAMES, BUTTONS, TEXT widget
# --------------------------------------------- 1 -------------------------------------------------
wm geometry . 680x600+128+10
wm title . "var - $version"

frame .buttons;## EN BAS DE CETTE FENETRE, UNE FRAME POUR LOGER des BOUTONS
pack .buttons -side bottom -fill x -pady 2m

button .buttons.graph -text "GRAPHE\n  ?  " -command {
    set mmmm [graphique $datos $efectivos]
}

button .buttons.informe -text "Save \nreport ?" -command {
    global infile
    savelisting "_INFO_VAR.txt"
    #destroy .buttons.informe
    #pack .buttons.salir -side left -padx 2 -fill x -expand yes
}

button .buttons.help -text "Aide\nHelp" -command {
    set texto1 {
        COMPARAISON DES MESURES DE PLASTICITE PHENOTYPIQUE ENTRE DEUX OU PLUSIEURS ESPECES
        
        DONNEES
        Le fichier d'entrée contient une seule colonne de chiffres (par exemple les valeurs de taille), avec en toute première ligne un commentaire libre décrivant l'origine des données.
        
        STRUCTURE DES DONNEES
        Ces données sont les valeurs de taille (ou d'une autre variable continue) mesurée dans deux ou plusieurs espèces elles-mêmes examinées dans deux environnements différents. L'ordre des données est donc, pour chaque espèce, les valeurs dans le premier environnement (e1) suivies de celles observées dans le second environnement (e2). Chaque espèce se suit, et dans chaque espèce les deux environnements se succèdent toujours dans le même ordre (par exemple e1 et e2).
        Il ne peut pas y avoir plus de deux environnements par espèce, et il ne peut pas n'y en avoir qu'un seul.
        
        PLASTICITE PHENOTYPIQUE
        Il s'agit d'une réponse à un changement externe, ou interne, mesurable sur le phénotype de l'individu, par exemple sur ses dimensions.
        Cette réponse présente plus ou moins d'ampleur selon le stimulus qui la génère, mais aussi en fonction des espèces (ou des populations géographiques d'une espèce).
        Cette ampleur peut être définie comme la "norme de réaction", c'est-à-dire le nombre de phénotypes que peut produire un seul génotype.
        
    }
    
    set texto2 {
        
        
        COMPARAISONS STATISTIQUES
        Les comparaisons statistiques porteront sur des valeurs de MOYENNES et de VARIANCES.
        Il y a deux niveaux de comparaison
    }
    
    set texto3 {
        
        
        Un niveau (niveau I) correspond à la comparaison des moyennes et des variance  entre espèces et environnements.
        Le second niveau (niveau II)  compare les changements de moyenne et de variance entre les espèces (P = 0.05).
    }
    
    toplevel .h
    wm geometry .h 450x600+150+150
    text .h.t -bg "light blue" -fg black -wrap word
    pack .h.t  -side left -fill both -expand yes
    
    # texto sigue, y boton para ilustrar (b)
    .h.t insert end $texto1
    button .h.t.b1 -text "Plasticité phénotypique" -command {verdia plas_phen.gif}
    button .h.b -image [image create photo -file plas_phen.gif]
    .h.t window create {end lineend} -window .h.t.b1
    bind .h.t.b1 <Motion> {.h.t.b1 configure -cursor hand1}
    
    # texto sigue, y nuevo boton (b1)
    .h.t insert end $texto2
    button .h.t.b2 -text "Changement des moyennes et variances" -command {verdia niveaux.gif}
    button .h.b1 -image [image create photo -file niveaux.gif]
    .h.t window create {end lineend} -window .h.t.b2
    bind .h.t.b2 <Motion> {.h.t.b2 configure -cursor hand1}
    
    # nuevo parrafo, texto sigue y nuevo boton (b3)
    .h.t insert end $texto3
    button .h.t.b3 -text "Niveau I, Niveau II" -command {verdia chang_moy_var.gif}
    button .h.b2 -image [image create photo -file chang_moy_var.gif]
    .h.t window create {end lineend} -window .h.t.b3
    bind .h.t.b3 <Motion> {.h.t.b3 configure -cursor hand1}
}

button .buttons.salir -fg red -text "EXIT\n- - -" -command {exit}
pack .buttons.salir .buttons.informe .buttons.help -side right

set scb [scrollbar .scrollA -command ".debut yview"];
## A GAUCHE DE LA FENETRE, UNE SCROLLBAR
pack $scb -side left -fill y
global p
set p [text .debut -background white -font "courier 12" -wrap word\
        -yscrollcommand ".scrollA set"];
## PUIS ENFIN LE TEXTE il n'est plus necessaire d'indiquer -SIDE, mais -FILL BOTH
pack $p -fill both -expand 1

# preparacion de la ventana del informe - fin

$p tag configure vert -foreground "dark green"
$p tag configure bleu -foreground blue
$p tag configure rouge -foreground red


# --------------------------------------------- 2 -------------------------------------------------
# Encabezamiento del informe
vert {
    COMPARAISON DES MESURES DE PLASTICITE PHENOTYPIQUE ENTRE DEUX OU PLUSIEURS ESPECES
    
    DONNEES
    Le fichier d'entrée contient une seule colonne de chiffres (par exemple les valeurs de taille), avec en toute première ligne un commentaire libre décrivant l'origine des données.
    
    STRUCTURE DES DONNEES
    Ces données sont les valeurs de taille (ou d'une autre variable continue) mesurée dans deux ou plusieurs espèces elles-mêmes examinées dans deux environnements différents. L'ordre des données est donc, pour chaque espèce, les valeurs dans le premier environnement (e1) suivies de celles observées dans le second environnement (e2). Chaque espèce se suit, et dans chaque espèce les deux environnements se succèdent toujours dans le même ordre (par exemple e1 et e2).
    Il ne peut pas y avoir plus de deux environnements par espèce, et il ne peut pas n'y en avoir qu'un seul.
    
}
$p insert end "\n"
# --------------------------------------------- 2 -------------------------------------------------



# --------------------------------------------- 3 -------------------------------------------------
# Vamos a buscar los datos - llamada a la procedure 'ouvrir'
set datos [ouvrir]

bleu "\nDonnées (vecteur): "
$p insert end "\n$datos\n"
# --------------------------------------------- 3 -------------------------------------------------



# --------------------------------------------- 4 -------------------------------------------------
# Entrada de los efectivos de cada grupo dentro de los datos - debut
# --------------------------------------------- 4 -------------------------------------------------

global efectivos
destroy .t
toplevel .t
wm geometry .t +730+300

entry .t.entrada1 -textvariable efectivos; # 'efectivos' contiene por ejemplo '23 14 25 46'
pack .t.entrada1 -side bottom
balloonhelp_for .t.entrada1 "Entrer les effectifs des groupes séparés d'un espace."
focus -force .t.entrada1

label .t.l -bg "light yellow" -text "Entrer les effectifs des groupes\nséparés d'un espace."
pack .t.l -side bottom
button .t.g -bg "light yellow" -text OK -command {
    
    
    global tobs fobs primeralinea
    
    destroy .t
    pack .buttons.graph -side left
    
    # CALCUL DES VARIANCES ET MOYENNES OBSERVEES
    
    # calculo del numero total de comparaciones posibles entre g grupos
    set g [llength $efectivos]
    set numcomp [expr {(pow($g,2) - $g)/2}]
    # inicializar dos variables con indice
    for {set i 0} {$i < $numcomp} {incr i} {
        set tobs($i) 0
        set fobs($i) 0
    }
    # Disseccion de la lista de los datos en bloques: llamada a la procedura DISSECCION
    set result [disseccion $datos $efectivos]
    # Ahora tenemos una lista de n (observados)
    set nlist [lindex $result 2]
    $p insert end "\n\nLISTE de n "
    $p insert end  "\n $nlist\n"
    # Ahora tenemos una lista de promedios (observados)
    set moylist  [lindex $result 1]
    bleu "\n\nLISTE de moyennes "
    bleu "\n $moylist\n"
    # Ahora tenemos una lista de varianzas (observadas)
    set varlist  [lindex $result 0]
    vert "\n\nLISTE de variances "
    vert "\n $varlist\n"
    #$p insert end "\nLISTA de varianzas \t $varlist\n\n"
    rouge "\n\nATTENTION: \nPour les tests parametriques qui suivent, les échantillons utilisés doivent être aléatoires, simples et indépendants.\
            \nLa variable étudiée doit se distribuer selon une loi normale dans les deux populations\
            \ndont sont extraits les échantillons\n\n"
    # Comparacion de las varianzas entre  bloques: llamada a la procedura COMPVAR
    set permut_f_g1_g2_p [compvar $varlist $efectivos]
    # Comparacion de los promedios entre  bloques: llamada a la procedura COMPMOY
    set permut_t_g1_g2_p [compmoy $moylist $varlist $nlist]
    
    # monstrar las dos variables con indice
    #for {set i 0} {$i < $numcomp} {incr i} {
    #    puts "Student t obs $tobs($i) \t y F obs $fobs($i)"
    #}
}

button .t.e -fg red -text exit -command {exit}
pack .t.e .t.g -side left -fill x -expand yes

bind .t.entrada1 <Key-Return> {
    .t.g invoke
}

#
# Entrada de los efectivos de cada grupo dentro de los datos - fin

# --------------------------------------------- 5 -------------------------------------------------
# Bouton BOOTSTRAP
# --------------------------------------------- 5 -------------------------------------------------


button .buttons.bootstrap -text "NIVEAU\n  II  " -command {
    
    set levelnb 2
    
    #
    # Hacer desaparecer la entrada anterior, y el boton mismo (era para entrar los efectivos de cada bloque)
    #
    #destroy .buttons.bootstrap
    
    if {[expr {fmod([llength $efectivos],2) > 0}]} {
        tk_messageBox -message "Le nombre de groupe est obligatoirement pair" -type ok
        set levelnb 1
    }
    
    if {$levelnb != 1} {

        #
        # Entrada del numero de bootstrap
        #
        entry .buttons.entrada2 -textvariable bootstrap
        pack .buttons.entrada2 -side bottom
        focus -force .buttons.entrada2
        balloonhelp_for .buttons.entrada2 "Entrer les nombres des BOOTSTRAPS."
        
        set compteur 0
        # inicializar suma() para evitar el error estilo suma(0) no existe
        foreach item $efectivos {
            # efectivos contiene los efectivos de cada grupo (ver boton entry entrada1)
            set sumavar($compteur) 0
            set sumamean($compteur) 0
            set t($compteur,0) 0
            set f($compteur,0) 0
            incr compteur
        }
        
        set compteur 0
        # inicializar suma() para evitar el error estilo suma(0) no existe
        foreach item $efectivos {
            for {set i 0} {$i < $bootstrap} {incr i} {
                set t($compteur,$i) 0
                set f($compteur,$i) 0
            }
            incr compteur
        }
        
        bind .buttons.entrada2 <Key-Return> {
            # El boton entrada2 contiene el numero de bootstrap
            .buttons.entrada2 configure -state disabled
            .buttons.bootstrap configure -state disabled
            #debug
            #puts "bootstrap $bootstrap"
            #puts " efectivos = $lista"
            set inicio 0
            set final 0
            
            set contador 0
            foreach item $efectivos {
                # calculando los limites - inicio, final - de cada grupo
                set final [expr {$final + $item}]
                set obs [lrange $datos $inicio [expr {$final-1}]]
                # --------------------------------- bootstrap --------------------------------------------------
                set lignes [llength $obs]
                #
                #
                #debug 2008
                #$p insert end "\n ----------------------------------------\nGrupo $item: \n ----------------------------------------"
                for {set j 0} {$j < $bootstrap} {incr j} {
                    #inicialisation de la lista aleatoria
                    # 
                    #En cada iteracion, el BOOSTRAP genera una lista aleatoria del mismo tamano
                    # 
                    set listnew [ranlist $obs $lignes]
                    #puts "bootstrap [expr {$j + 1}] : listnew $listnew"
                    #En cada iteracion (cada lista randomizada), el BOOSTRAP calcula la varianza
                    set bootvarmean [varianza $listnew]
                    #debug 2008
                    #$p insert end "\nBOOT [expr {$j+1}]: [lindex $bootvarmean 1]"
                    # bootvarmean contiene una lista de dos valores: la varianza y el promedio de 'listnew'
                    set bootvar [lindex $bootvarmean 0]
                    set bootmean [lindex $bootvarmean 1]
                    # Pour les tests ultérieurs comparant les comparaisons !
                    set varboot($contador,$j) $bootvar
                    set meanboot($contador,$j) $bootmean
                    #debug
                    #puts "bootvar $bootvar bootmean $bootmean"
                    #Se suman los resultados para despues (del bootstrap) hacer el promedio,
                    # estimacion no parametrica de la varianza (o del promedio) de cada bloque
                    set sumamean($contador) [expr {$sumamean($contador) + $bootmean}]
                    set sumavar($contador) [expr {$sumavar($contador) + $bootvar}]
                    
                }
                set inicio $final
                incr contador
                
            }
            
            # --------------------------------- bootstrap --------------------------------------------------
            
            # Moyenne des variances sur listes aleatoires
            #set contador 0
            #foreach item $efectivos {
            
            #    rouge "\n\nGroupe [expr {$contador + 1}]"
            #    vert "\nEstimation non-parametrique de la variance: [expr {$sumavar($contador) / $bootstrap}]\n"
            #    incr contador
            #"}
            
            # Moyenne des moyennes sur listes aleatoires
            #set contador 0
            #foreach item $efectivos {
            #    rouge "\n\nGroupe [expr {$contador + 1}]"
            #    bleu "\nEstimation non-parametrique de la moyenne: [expr {$sumamean($contador) / $bootstrap}]\n"
            #    incr contador
            #"}
            
            # TESTS INTER COMPARAISONS
            set numgroup [llength $efectivos]
            
            for {set b 0} {$b < $bootstrap} {incr b} {
                # debug 2008
                #$p insert end "\n\n------------------------------------------------------------------------------------\n\
                        BOOT [expr {$b+1}], D1 y D2\n------------------------------------------------------------------------------------\n"
                for {set i 0} {$i < $numgroup} {incr i} {
                    # debug 2008
                    #if { [expr {$i+1}] == 1 ||  [expr {$i+1}] == 3} {$p insert end "\nGRUPO [expr {$i+1}]"}
                    for {set j [expr {$i+1}]} {$j < $numgroup} {incr j} {
                        set diffmean [expr {$meanboot($i,$b) - $meanboot($j,$b) }]
                        # debug 2008
                        #if { [expr {$i+1}] == 1 &&  [expr {$j+1}] == 2} {$p insert end "... con GRUPO [expr {$j+1}] $meanboot($i,$b) - $meanboot($j,$b) = $diffmean"}
                        #if { [expr {$i+1}] == 3 &&  [expr {$j+1}] == 4} {$p insert end "... con GRUPO [expr {$j+1}] $meanboot($i,$b) - $meanboot($j,$b) = $diffmean"}
                        
                        lappend diffmlist($b) "[expr {$i+1}] [expr {$j+1}] $diffmean"
                        set diffvar [expr {$varboot($i,$b) - $varboot($j,$b) }]
                        #$p insert end "\ncon GRUPO [expr {$j+1}] $varboot($i,$b) - $varboot($j,$b) = $diffvar"
                        lappend diffvlist($b) "[expr {$i+1}] [expr {$j+1}] $diffvar"
                    }
                }
            }
            # debug 2008
            #$p insert end "\n"
            #for {set b 0} {$b < $bootstrap} {incr b} {
             #   $p insert end "\nBootstrap [expr {$b+1}]\t"
             #   $p insert end "[lindex $diffmlist($b) 0] [lindex $diffmlist($b) end]"
            #}
            
            # Sélection des paires de groupes comparées
            # Par ex. s'il y a 6 groupes, les paires pertinentes sont 1 et 2, 3 et 4, 5 et 6
            set numgroup [llength $efectivos]
            
            #debug 2008
            #$p insert end "\n\n"
            
            for {set b 0} {$b < $bootstrap} {incr b} {
                for {set i 0} {$i < $numgroup} {incr i 2} {
                    set par_1 [expr {$i + 1}]
                    set par_2 [expr {$i + 2}]
                    # Moyennes
                    set boulier1 0
                    
                    foreach item $diffmlist($b) {
                        if {[lindex $item 0] == $par_1 && [lindex $item 1] == $par_2} {
                            if {$b == [expr {$bootstrap - 1}]} {lappend parmrel $boulier1}
                            lappend diffmrellist($b) $item
                            #debug 2008
                            #$p insert end "\npar relevante : $item\tparrelev $boulier1"
                        }
                        incr boulier1
                        #debug
                        #$p insert end "\nboulier1 = $boulier1"
                    }
                    # Variances
                    set boulier1 0
                    foreach item $diffvlist($b) {
                        if {[lindex $item 0] == $par_1 && [lindex $item 1] == $par_2} {
                            if {$b == [expr {$bootstrap - 1}]} {lappend parvrel $boulier1}
                            lappend diffvrellist($b) $item
                            #debug
                            #$p insert end "\tpar relevante : $item\tparrelev $boulier1"
                        }
                        incr boulier1
                        #debug
                        #$p insert end "\nboulier1 = $boulier1"
                    }
                }
            }
            
            #debug
            #for {set b 0} {$b < $bootstrap } {incr b} {
            #    $p insert end "\nBootstrap [expr {$b+1}] M: $diffmrellist($b)"
            #    $p insert end "\nBootstrap [expr {$b+1}] V: $diffvrellist($b)\n"
            #}
            
            set numparrel [expr {$numgroup / 2}]
            
            # A cada bootstrap, diferencia entre diferencias relevantes
            for {set b 0} {$b < $bootstrap} {incr b} {
                set boulier -1
                # On navigue dans la liste des comparaisons pertinentes pour parcourir toutes les comparaisons
                # ... de comparaisons 1 et 2, 1 et 3, 1 et 4 si numparrel = 4, puis 2 et 3, 2 et 4 et 3 et 4
                for {set i 0} {$i < [expr {$numparrel-1}]} {incr i} {
                    
                    for {set j [expr {$i+1}]} {$j < $numparrel} {incr j} {
                        incr boulier
                        
                        # Moyennes
                        set xx [lindex [lindex $diffmrellist($b) $i] end]
                        #set x [expr {abs($xx)}];july2008
                        set x $xx
                        set yy [lindex [lindex $diffmrellist($b) $j] end]
                        #set y [expr {abs($yy)}];july2008
                        set y $yy
                        set xy [expr {$x - $y}]
                        lappend compm($boulier) $xy
                        set relmpar($boulier) "[lrange [lindex $diffmrellist($b) $i] 0 1] and \
                                [lrange [lindex $diffmrellist($b) $j] 0 1]"
                        #debug 2008
                        #$p insert end "\n$i : [lindex $diffmrellist($b) $i]  et $j  : [lindex $diffmrellist($b) $j]\tDiff = $xy"
                        #$p insert end  "\nlappend compm($boulier) $xy"
                        # Variances
                        set xx [lindex [lindex $diffvrellist($b) $i] end]
                        #set x [expr {abs($xx)}]; July 2008
                        set x $xx
                        set yy [lindex [lindex $diffvrellist($b) $j] end]
                        #set y [expr {abs($yy)}]; July 2008
                        set y $yy
                        set xy [expr {$x - $y}]
                        lappend compv($boulier) $xy
                        set relvpar($boulier) "[lrange [lindex $diffvrellist($b) $i] 0 1] and \
                                [lrange [lindex $diffvrellist($b) $j] 0 1]"
                        #debug
                        #$p insert end "\n$i : [lindex $diffvrellist($b) $i]  et $j  : [lindex $diffvrellist($b) $j]\
                        \tDiff = $xy"
                        #$p insert end  "\nlappend compv($boulier) $xy"
                    }
                }
                #$p insert end "\n--------------------------------------------------\n"
                
            }
            # lecture des résultats des bootstraps
            
            if {$b == $bootstrap} {tk_messageBox -message "$b bootstraps: done" -type ok}
            
            set numcomp [expr {(($numparrel * $numparrel) - $numparrel)/2}]
            
            # Variances
            vert "\n__________________________________________________\nNIVEAU II\tVariances ($bootstrap bootstraps) P = 0.05\n"
            #$p insert end "\n paires comparées $parvrel\n"
            for {set i 0} {$i < $numcomp} {incr i} {
                set sorted [lsort -real $compv($i)]
                set percentile5   [expr {int(0.025 * $bootstrap)}]
                set percentile95  [expr {int(0.975 * $bootstrap)}]
                set lefttail [lindex $sorted $percentile5]
                set righttail [lindex $sorted $percentile95]
                $p insert end "\n$relvpar($i) From $lefttail to $righttail"
                if {$lefttail <= 0 && $righttail >= 0} {
                    $p insert end " <- Not significant (range contains zero)\n"
                } else  {
                    rouge " <- SIGNIFICANT\n"
                }
                
            }
            
            # Moyennes
            bleu "\n__________________________________________________\nNIVEAU II\tMoyennes ($bootstrap bootstraps) P= 0.05\n"
            #$p insert end "\n paires comparées $parmrel\n"
            
            for {set i 0} {$i < $numcomp} {incr i} {
                set sorted [lsort -real $compm($i)]
                # debug 2008
                #$p insert end "\n --------- [lrange $sorted 0 3]  ... etc.\n"
                set percentile5   [expr {int(0.025 * $bootstrap)}]
                set percentile95  [expr {int(0.975 * $bootstrap)}]
                set lefttail [lindex $sorted $percentile5]
                set righttail [lindex $sorted $percentile95]
                $p insert end "\n$relmpar($i) From $lefttail to $righttail"
                if {$lefttail <= 0 && $righttail >= 0} {
                    $p insert end " <- Not significant (range contains zero)\n"
                } else  {
                    rouge " <- SIGNIFICANT\n"
                }
                
            }
            
        }
    }
}
balloonhelp_for  .buttons.bootstrap  "INTERACTION \n(Bootstraps)"
#DEBUT PERMUTACIONES-----------------------------------------------------------------------------------
destroy .buttons.permutaciones

button .buttons.permutaciones -text "NIVEAU\n  I  "  -command {
    
    global D tobs fobs
    #
    # Hacer desaparecer la entrada anterior, y el boton mismo (era para entrar los efectivos de cada bloque)
    #
    # destroy .buttons.entrada2
    
    #
    # Entrada del numero de permutaciones
    #
    entry .buttons.entrada3 -background aliceblue -textvariable nbpermut
    pack .buttons.entrada3 -side bottom
    focus -force .buttons.entrada3
    balloonhelp_for .buttons.entrada3 "Entrer les nombres des permutations."
    
    set compteur 0
    # inicializar suma() para evitar el error estilo suma(0) no existe
    foreach item $efectivos {
        # efectivos contiene los efectivos de cada grupo (ver boton entry entrada1)
        set sumavar($compteur) 0
        set sumamean($compteur) 0
        set t($compteur,0) 0
        set f($compteur,0) 0
        incr compteur
    }
    
    set compteur 0
    # inicializar suma() para evitar el error estilo suma(0) no existe
    foreach item $efectivos {
        for {set i 0} {$i < $nbpermut} {incr i} {
            set t($compteur,$i) 0
            set f($compteur,$i) 0
        }
        incr compteur
    }
    
    bind .buttons.entrada3 <Key-Return> {
        global D
        set D(permutacion) 1
        onvapermuter $datos $efectivos $nbpermut
        .buttons.entrada3 configure -state disabled
        .buttons.permutaciones configure -state disabled
    }
    
}
balloonhelp_for  .buttons.permutaciones  "Non-parametric comparisons \n(Permutations)"
#FIN PERMUTACIONES----------------------------------------------------------------------------------------------

button .buttons.anova -text "\n--- Qst ---" -bg "light yellow" -command {
    global p data efectivos
    # Rem. 'data' est globalisée dans 'ouvrir' et prend la valeur de 'datos'
    # 'efectivos' contient la liste des effectifs
    
    set N 0; # 'N' sera le total des individus
    if {$efectivos != ""} {
        $p insert end "\n\n========= oneway ======= ANOVA ================\n"
        set k [llength $efectivos]
        $p insert end "\n\n$k groupes\n"
        for {set i 1} {$i < [expr {$k+1}]} {incr i} {
            set n($i) [lindex $efectivos  [expr {$i-1}]]
            #debug
            $p insert end "\nn($i) = $n($i)"
            set N [expr {$N+$n($i)}]
        }
    } else  {
        tk_messageBox -message "D'abord entrer les effectifs please" -type ok
    }
    
    if {$efectivos != ""} {
        #debug
        $p insert end "\n\nN (nb total d'individus)= $N\n"
        #$p insert end "\nDatos $data\n"
        
        set debut 0
        #foreach item $efectivos {
        for {set i 1} {$i < [expr {$k+1}]} {incr i} {
            set fin [lindex $efectivos [expr {$i-1}]]
            set fin [expr {$debut + $fin - 1}]
            bleu "\ndébut $debut et fin $fin (debut+fin-1)"
            set groupe($i) [lrange $data $debut $fin]
            set debut [expr {$fin + 1}]
            bleu "\ndébut (fin+1) $debut et fin $fin"
            $p insert end "\n\nGroupe $i\n$groupe($i)\n----------------\n"
        }
        #}
        
        # Calcul de la moyenne totale
        set mean_total [::math::statistics::mean $data]
        bleu "\nMoyenne générale : $mean_total\n"
        
        # Calcul des moyennes par traitement / groupes
        for {set i 1} {$i < [expr {$k+1}]} {incr i} {
            set mean_groupe($i) [::math::statistics::mean $groupe($i)]
            bleu "\nMoyenne groupe $i: $mean_groupe($i)"
        }
        
        # Somme des écarts TOTALE
        set sst  0
        for {set i 0} {$i < $N} {incr i} {
            set ecart [expr {pow(([lindex $data $i]- $mean_total),2)}]
            set sst [expr {$sst + $ecart}]
        }
        bleu "\n\nSomme des écarts TOTALE $sst"
        set ddf_tot [expr {$N-1}]
        
        # Somme des écarts SSA (between-among groups / treatments)
        set ssa 0
        for {set i 1} {$i < [expr {$k+1}]} {incr i} {
            set x $mean_groupe($i)
            set ecart [expr {(pow(($x - $mean_total),2))*[llength $groupe($i)]}]
            set ssa [expr {$ssa + $ecart}]
        }
        bleu "\n\nSomme des écarts INTER (among, between - entre) $ssa"
        set ddf_ssa [expr {$k-1}]
        set Va [expr {$ssa * 1.0 / $ddf_ssa}]
        bleu "\nVa $Va \t ddf $ddf_ssa\n"
        
        # Somme des écarts SSE (within groups / treatments)
        set sse 0
        for {set i 1} {$i < [expr {$k+1}]} {incr i} {
            for {set j 0} {$j < [lindex $efectivos [expr {$i-1}]]} {incr j} {
                set x [lindex $groupe($i) $j]
                set ecart [expr {pow(($x - $mean_groupe($i)),2)}]
                set sse [expr {$sse + $ecart}]
            }
            #debug
            #$p insert end "\nsse groupe $i $sse\n"
        }
        bleu "\nSomme des écarts INTRA (within, dentro) $sse"
        set ddf_sse [expr {$N-$k}]
        set Vw [expr {$sse * 1.0 / $ddf_sse}]
        bleu "\nVw $Vw \t ddf $ddf_sse"
        
        rouge "\n\n\n\t --- Qst ---  --- --- --- Va / (Va + 2 Vw)  --- \n\n"
        set den [expr {$Va + 2 * $Vw}]
        set qst [expr ($Va * 1.0 / $den)]
        rouge "\t --- $qst \n\n\t --- Qst ---  --- --- ---\n\n"
    }
}


pack .buttons.permutaciones -side left
pack .buttons.bootstrap -side left
pack .buttons.anova -side left


# SCRIPT PRINCIPAL -----------------------------------------------------------------------------
