#source http.tcl
package require http
package require Tk


namespace eval Update {
    #François Chevenet - chevenet@ird.fr - 04.67.41.63.57
    #IRD - BP 64501 UMR IRD/CNRS 9926
    #911, Av. Agropolis - 34394 Montpellier cedex 5
    #http://www.treedyn.org/
    #We don’t see things as they are; we see things as we are.
    #
    
    # procedure DEBUG
    #
    proc debug {output} {
        # fichier pour debugging
        global flag memo bugatti
        append bugatti "\n$output\n"
        set flag 1
        # text widget
        if {[info exists .debug]} {
            $memo insert end $bugatti
        } else  {
            destroy .debug .non
            toplevel .debug
            wm geometry .debug 710x600+205+66
            set memo [text .debug.t -wrap word -height 22 -font "courier 13" \
                    -bg grey88 \
                    -fg black\
                    -tabs "3c left"\
                    -yscrollcommand ".debug.v_scroll set" \
                    -xscrollcommand ".debug.h_scroll set"]
            scrollbar .debug.v_scroll -command ".debug.t yview"
            scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
            pack .debug.v_scroll -side right -fill y
            pack .debug.h_scroll -side bottom -fill x
            pack .debug.t -side bottom -fill both -expand 1
            #
            button .debug.exit -fg red -text "Exit" -command {
                global find_last_indx pointf ici
                destroy .debug .head
            }
            button .debug.help -fg red -bg "ivory" -text "Help" -command {}
            button .debug.wrap -fg red -text "Wrap" -command {
                global flag
                if {$flag == 1} {
                    .debug.t configure -wrap none
                    set flag 0
                } else  {
                    .debug.t configure -wrap word
                    set flag 1
                }
            }
            #
            $memo insert end $bugatti
            pack .debug.exit .debug.wrap -side left -padx 5 -fill x
        }
    }
    #
    # Procedure DEBUG fin
    #
    
    proc MOMEUpdate {} {
        global S wmsg
        if {[winfo exists .httpnews] == 1} {destroy .httpnews}
        # TOPLEVEL
        set top [toplevel .httpnews]
        wm title .httpnews "MOME Update"
        #
        set x [expr ([winfo screenwidth $top] - 300) /2]
        set y [expr ([winfo screenheight $top] - 100) /2]
        wm geometry $top "400x170+$x+$y"
        # BUTTONS
        set wb [frame $top.c]
        button $wb.b1 -text "Check for Update(s)" -command "Update::Check"
        button $wb.b3 -text "Exit" -command "destroy .httpnews"
        pack $wb.b1 $wb.b3 -side left -expand true -fill x
        # message dynamique transactions
        set S(httpText) ""
        label $top.l  -textvariable S(httpText)  -foreground black
        #
        set S(momePackCheck) ?
        set S(momePatchCheck) ?
        set S(momeManualCheck) ?
        set wmsg [frame $top.msg]
        #  mesage
        label $wmsg.l01  -text ""
        label $wmsg.l02  -text "Your version:" -foreground blue
        label $wmsg.l03  -text "Current Version:"  -foreground red
        #  Pack un nom
        label $wmsg.l11  -text MOMEPack:
        label $wmsg.l12  -textvariable S(momepack) -foreground blue
        label $wmsg.l13  -textvariable S(momePackCheck) -foreground red
        
        # Patch un numero
        label $wmsg.l21  -text MOMEPatch:
        label $wmsg.l22  -textvariable S(patchnumber)  -foreground blue
        
        label $wmsg.l23  -textvariable S(momePatchCheck) -foreground red
        #
        #
        #button $wmsg.b2  -text Update   -command Update::Patch -state disabled
        button $wmsg.b2  -text Update   -command Update::updatequoi -state disabled
        # Grid
        grid $wmsg.l01 -row 0 -column 0
        grid $wmsg.l02 -row 0 -column 1
        grid $wmsg.l03 -row 0 -column 2
        #
        grid $wmsg.l21 -row 2 -column 0
        grid $wmsg.l22 -row 2 -column 1
        grid $wmsg.l23 -row 2 -column 2
        #
        grid $wmsg.b2 -row 2 -column 3
        # PACK
        pack $wb $wmsg $top.l -expand yes -fill x -anchor n -side top
    }
    
    
    # Procedure COMPARE_VERSION
    #
    proc compare_version {you} {
        global version
        #tk_messageBox -message "On est dans compare_version" -type ok
        #tk_messageBox -message "you = \n$you" -type ok
        #
        # rechercher clicpackage_
        #
        set position [string first "clicpackage_" $you]
        #tk_messageBox -message "position = $position" -type ok
        if {$position != -1} {
            set actuellement [string range $you [expr {$position + 5}] [expr {$position + 6}] ]
            #tk_messageBox -message "Version actuelle = $actuellement" -type ok
            return $actuellement
        } else  {
            tk_messageBox -message "position vaut ... $position !" -type ok
        }
    }
    #
    # Procedure COMPARE_VERSION
    
    # On appuie ici sur le bouton CHECK FOR UPDATE(S)
    proc Check {} {
        global S url version wmsg
        #set url "http://bioinfo-prod.mpl.ird.fr/morphometrics/clic/index.html"
	set url "http://mome-clic.com/?clic-package"
        set S(httpText) "...checking..."
        #http::geturl $url -timeout 15000 -command Update::CheckProcess
        if { [catch {
                #
                # ouverture de la page web
                set r [http::geturl $url -binary 1]
                #
                #
                
                ##set file "updateoutt.tar.gz"
                ##set out [open $file w]
                ##set token [http::geturl $url -channel $out]
                ##close $out
                
                #
                #
                # nom de fichier
                #
                set filename transitindex.txt
                #
                # ecriture de la page web - cfr. $r - dans le fichier
                #
                set fo [open $filename w]
                fconfigure $fo -translation binary
                puts -nonewline $fo [http::data $r]
                close $fo
                ::http::cleanup $r
                #
                # lecture du fichier "r" (contenu de la page web) dans la variable "webpage"
                #
                set fid [open $filename r]
                set webpage [read -nonewline $fid]
                close $fid
                #
                
                # #
                debug $webpage
                # #
                
                #
                # destruction du fichier "r"
                #
                #
                # comparaison des versions
                set S(quid) [compare_version $webpage]
                set S(momePackCheck) $S(quid)
                $wmsg.l13 configure -textvariable $S(quid)
                #tk_messageBox -message "quid = $S(quid) et version = $version" -type ok
                if {$S(quid) < $version} {
                    tk_messageBox -message "Your version $version > $S(quid): are you a smart gui playing with TclTk?" -type ok
                    $wmsg.b2 configure -state active
                    #.prompt.clic configure -image [global clicpath; image create photo -file $clicpath/aal_kc.gif]
                } else  {
                    if {$S(quid) > $version} {
                        tk_messageBox -message "Your version $version should be updated to $S(quid)" -type ok
                        $wmsg.b2 configure -state active
                        #.prompt.clic configure -image [global clicpath; image create photo -file $clicpath/aal_kc.gif]
                    } else  {
                        tk_messageBox -message "Your version CLIC $version is the last version" -type ok
                    }
                }
                #
                update
                flush stdout
            } result] } {
            debug "$result\n---\n$url : NO ACCESS  "
        }
    }
    
    # Apres avoir frappe le bouton CHECK FOR UPDATE(S), et bien on check
    proc Checking {token} {
        global S url
        upvar #0 $token state
        if {$state(status) != "timeout"} {
            # ici on place la lecture de la version en cours ?
            set new [http::data $token]
            set S(momePackCheck) $new
            if {$new > $S(patchnumber)} {.httpnews.msg.b2 configure -state normal}
            set S(httpText) "done"
        } else  {
            set S(httpText) "$url not responding\n Retry later"
        }
    }
    
    #
    # Les dernieres procedures sont appelees si on appuie sur le bouton UPDATE
    #
    proc updateprogress {token total current} {
        #global wmsg S
        #set coul "red yellow blue green ivory ivory green blue yellow red"
        #set coul "black ivory black ivory ivory black ivory black ivory black"
        #set coul [lindex $coul [expr {int(rand()*10)}]]
        #$wmsg.b2 configure -background $coul
        #set crol [length $S(r)]
        #$wmsg.b2 configure -background $crol
        #set pgrs [file size $S(filename)]
        #$wmsg.b2 configure -text $pgrs
        #tk_messageBox -message "." -type ok
        #puts -nonewline "."
        .hey.t insert end "."
        .hey.t see end
    }
    #
    
    
    # Procedure AFFICHEINFO - debut - Appelee par la procedure INSTRUCTION
    #
    proc afficheinfo {id} {
        global attente
        if {[eof $id]} {
            set attente 1
            #.mome.xit.ex configure -state active
            close $id
            return
        }
        gets $id ligne
    }
    #
    # Procedure AFFICHEINFO - FIN
    
    
    proc updatequoi {} {
        global S attente
        set internet_f "firefox"
        if {[info exists internet_f]} {
            if { [catch {
                    #
                    #.mome.xit.ex configure -state disabled
                    #
                    #set url "http://bioinfo-prod.mpl.ird.fr/morphometrics/clic/CLIC_README.txt"
		    set url "http://mome-clic.com/?clic-package"
                    tk_messageBox -message "Go to the download page CLIC_$S(quid).tar.gz" -type ok
                    
                    global attente numli
                    set fid [open "| $internet_f $url"]
                    fconfigure $fid -buffering line
                    fileevent $fid readable "afficheinfo $fid"
                    vwait attente
                    #
                    update
                    flush stdout
                } result]} {
                debug "$result\n---\n$url : NO ACCESS  (no internet browser -Firefox, IE - here ?)"
            }
            debug "============== On a ete sur la page\n$result"
        }
        global S version wmsg
        ##
        toplevel .hey
        text .hey.t -bg black -fg white -height 2 -width 50
        pack .hey.t
        ##
        tk_messageBox -message "Download of the following file:\nCLIC_README.txt" -type ok
        ##
        #set url "http://bioinfo-prod.mpl.ird.fr/morphometrics/clic/CLIC_$S(quid).tar.gz"
        #set url "http://bioinfo-prod.mpl.ird.fr/morphometrics/clic/CLIC_README.txt"
	set url "http://mome-clic.com/?clic-package"
        ##set url "http://bioinfo-prod.mpl.ird.fr/morphometrics/clic/CLIC_24.tar.gz"
        ## ouverture du fichier (j'espere)
        set S(r) [http::geturl $url -blocksize 40960 -progress Update::updateprogress -binary 1]
        ##
        ## nom du fichier sur le disque dur
        ##
        set filename "updatequoi.tar.gz"
        ##
        ## ecriture du fichier en format texte a partir du format binaire
        ##
        set fo [open $filename w]
        fconfigure $fo -translation binary
        puts -nonewline $fo [http::data $S(r)]
        close $fo
        ::http::cleanup $S(r)
        ##
        debug "==============S(r) = \n$S(r)"
    }
    
    # Pour UPDATER (on appuie sur le bouton UPDATE)
    proc Patch {} {
        global S version wmsg
        #
        tk_messageBox -message "Download of the following file:\nCLIC_README.txt" -type ok
        #
        #set url "http://bioinfo-prod.mpl.ird.fr/morphometrics/clic/CLIC_README.txt"
        #set url "http://bioinfo-prod.mpl.ird.fr/morphometrics/clic/clic_howto.html"
        #set query "http://bioinfo-prod.mpl.ird.fr/morphometrics/clic/index.html"
	set url "http://mome-clic.com/?clic-package"
        set S(httpText) "Downloading MOME Patch number CLIC_$S(quid), enfin le README"
        #
        destroy .httpnews.p
        #iwidgets::feedback .httpnews.p  -steps 301  -labelpos w \
        -barheight 5 -barcolor AntiqueWhite3 -troughcolor LightGoldenrodYellow
        #pack .httpnews.p -expand true -fill x
        #.httpnews.p reset
        
        update idletasks
        #after 1000
        #http::geturl $query -blocksize 4096 -timeout 30000 \
        -command Update::Patching \
                -progress Update::httpUpdatePatchProgress
        set filename "updated.tar.gz"
        set S(filename) $filename
        set out [open $filename w]
        $wmsg.b2 configure -text [file stat $filename size]
        set token [http::geturl $url -blocksize 4096 -timeout 300000 -progress Update::updateprogress -channel $out]
        #set token [http::geturl $url -channel $out]
        close $out
    }
    
    # On a appuye sur le bouton UPDATE et ma foi c'est ce qu'on fait ici
    proc Patching {token} {
        global S tcl_platform
        tk_messageBox -message "query = $query" -type ok
        upvar #0 $token state
        if {$state(status) != "timeout"} {
            set S(httpText) "Patching"
            after 1000
            update idletasks
            set file "updateoutt.tar.gz"
            set out [open $file w]
            set token [http::geturl $url -channel $out]
            close $out
            #
            set S(httpText) "MOME updated, please restart MOME"
            destroy .httpnews.p
            set S(patchnumber) $S(momePatchCheck)
            .httpnews.msg.b2 configure -state disable
        } else  {
            set S(httpText) "$query not responding\n Retry later"
        }
    }
    
}

global S version
set version 31
set S(patchnumber) $version
Update::MOMEUpdate
