#source http.tcl
package require http
package require Tk

# procedure TYPE - debut
#
proc type {message} {
    tk_messageBox -message $message -type ok
}
#
# procedure TYPE - fin

# procedure TYPE_YN - debut
#
proc type_yn {message} {
    set reponse [tk_messageBox -message $message -type yesno]
    return $reponse
}
#

namespace eval Update {
    #François Chevenet - chevenet@ird.fr - 04.67.41.63.57
    #IRD - BP 64501 UMR IRD/CNRS 9926
    #911, Av. Agropolis - 34394 Montpellier cedex 5
    #http://www.treedyn.org/
    #We don’t see things as they are; we see things as we are.
    #
    
    # procedure DEBUG
    #
    proc debug {output} {
        # fichier pour debugging
        global flag memo bugatti
        append bugatti "\n$output\n"
        set flag 1
        # text widget
        if {[info exists .debug]} {
            $memo insert end $bugatti
        } else  {
            destroy .debug .non
            toplevel .debug
            wm geometry .debug 710x600+205+66
            set memo [text .debug.t -wrap word -height 22 -font "courier 13" \
                    -bg grey88 \
                    -fg black\
                    -tabs "3c left"\
                    -yscrollcommand ".debug.v_scroll set" \
                    -xscrollcommand ".debug.h_scroll set"]
            scrollbar .debug.v_scroll -command ".debug.t yview"
            scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
            pack .debug.v_scroll -side right -fill y
            pack .debug.h_scroll -side bottom -fill x
            pack .debug.t -side bottom -fill both -expand 1
            #
            button .debug.exit -fg red -text "Exit" -command {
                global find_last_indx pointf ici
                destroy .debug .head
            }
            button .debug.help -fg red -bg "ivory" -text "Help" -command {}
            button .debug.wrap -fg red -text "Wrap" -command {
                global flag
                if {$flag == 1} {
                    .debug.t configure -wrap none
                    set flag 0
                } else  {
                    .debug.t configure -wrap word
                    set flag 1
                }
            }
            #
            $memo insert end $bugatti
            pack .debug.exit .debug.wrap -side left -padx 5 -fill x
        }
    }
    #
    # Procedure DEBUG fin
    #
    
    proc MOMEUpdate {} {
        global S wmsg
        if {[winfo exists .httpnews] == 1} {destroy .httpnews}
        # TOPLEVEL
        set top [toplevel .httpnews]
        wm title .httpnews "MOME Update"
        #
        set x [expr ([winfo screenwidth $top] - 300) /2]
        set y [expr ([winfo screenheight $top] - 100) /2]
        wm geometry $top "400x170+$x+$y"
        # BUTTONS
        set wb [frame $top.c]
        button $wb.b1 -text "Check for Update(s)" -command "Update::httpUpdateCheck"
        button $wb.b3 -text "Exit" -command "destroy .httpnews"
        pack $wb.b1 $wb.b3 -side left -expand true -fill x
        # message dynamique transactions
        set S(httpText) ""
        label $top.l  -textvariable S(httpText)  -foreground black
        #
        set S(momePackCheck) ?
        set S(momePatchCheck) ?
        set S(momeManualCheck) ?
        set wmsg [frame $top.msg]
        #  mesage
        label $wmsg.l01  -text ""
        label $wmsg.l02  -text "Your version:" -foreground blue
        label $wmsg.l03  -text "Current Version:"  -foreground red
        #  Pack un nom
        label $wmsg.l11  -text MOMEPack:
        label $wmsg.l12  -textvariable S(momepack) -foreground blue
        label $wmsg.l13  -textvariable S(momePackCheck) -foreground red
        
        # Patch un numero
        label $wmsg.l21  -text MOMEPatch:
        label $wmsg.l22  -textvariable S(patchnumber)  -foreground blue
        
        label $wmsg.l23  -textvariable S(momePatchCheck) -foreground red
        #
        #
        #button $wmsg.b2  -text Update   -command Update::httpUpdatePatch -state disabled
        button $wmsg.b2  -text Update   -command Update::updatequoi -state disabled
        # Grid
        grid $wmsg.l01 -row 0 -column 0
        grid $wmsg.l02 -row 0 -column 1
        grid $wmsg.l03 -row 0 -column 2
        #
        grid $wmsg.l21 -row 2 -column 0
        grid $wmsg.l22 -row 2 -column 1
        grid $wmsg.l23 -row 2 -column 2
        #
        grid $wmsg.b2 -row 2 -column 3
        # PACK
        pack $wb $wmsg $top.l -expand yes -fill x -anchor n -side top
    }
    
    
    # Procedure COMPARE_VERSION
    #
    proc compare_version {you} {
        global version
        #type "On est dans compare_version" 
        debug "you = \n$you" 
        #
        # rechercher clicpackage_
        #
        set position [string first "CLIC_" $you]
        #type "position = $position" 
        if {$position != -1} {
            set actuellement [string range $you [expr {$position + 5}] [expr {$position + 6}] ]
            type "version actuelle = $actuellement" 
            return $actuellement
        } else  {
            type "position vaut ... $position !" 
# inviter la personne à consulter le site avec son navigateur?
        }
    }
    #
    # Procedure COMPARE_VERSION
    
    # On appuie ici sur le bouton CHECK FOR UPDATE(S)
    proc httpUpdateCheck {} {
        global S url version wmsg
        set url "http://mome-clic.com/?clic-package";#<- bonne page, enfin
        set S(httpText) "...checking..."
        #http::geturl $url -timeout 15000 -command Update::httpUpdateCheckProcess
        if { [catch {
                #
                # ouverture de la page web
                set r [http::geturl $url -binary 1]
                #
                #
                
                ##set file "updateoutt.tar.gz"
                ##set out [open $file w]
                ##set token [http::geturl $url -channel $out]
                ##close $out
                
                #
                #
                # nom de fichier
                #
                set filename transitindex.txt
                #
                # ecriture de la page web - cfr. $r - dans le fichier
                #
                set fo [open $filename w]
                fconfigure $fo -translation binary
                puts -nonewline $fo [http::data $r]
                close $fo
                ::http::cleanup $r
                #
                # lecture du fichier dans la variable webpage
                #
                set fid [open $filename r]
                set webpage [read -nonewline $fid]
                close $fid
                #
                # destruction du fichier
                #
                #
                # comparaison des versions
                set S(quid) [compare_version $webpage]
                set S(momePackCheck) $S(quid)
                $wmsg.l13 configure -textvariable $S(quid)
                #type "quid = $S(quid) et version = $version" 
                if {$S(quid) < $version} {
                    type "Your version $version > $S(quid): a pirate or test version?" 
                    $wmsg.b2 configure -state active
                    #.prompt.clic configure -image [global clicpath; image create photo -file $clicpath/aal_kc.gif]
                } else  {
                    if {$S(quid) > $version} {
                        type "Your version $version should be updated to $S(quid)" 
                        $wmsg.b2 configure -state active
                        #.prompt.clic configure -image [global clicpath; image create photo -file $clicpath/aal_kc.gif]
                    } else  {
                        type "Your version CLIC $version is the last version" 
                    }
                }
                #
                update
                flush stdout
            } result] } {
            debug "$result\n---\n$url : NO ACCESS  "
        }
    }
    
    #
    # Les dernieres procedures sont appelees si on appuie sur le bouton UPDATE
    #

    # Procedure AFFICHEINFO - debut - Appelee par la procedure INSTRUCTION
    #
    proc afficheinfo {id} {
        global attente
        if {[eof $id]} {
            set attente 1
            #.mome.xit.ex configure -state active
            close $id
            return
        }
        gets $id ligne
    }
    #
    # Procedure AFFICHEINFO - FIN
    
    
    proc updatequoi {} {
        global S attente
        # set internet_f "firefox" : a enlever plus tard, pe en faire une var globale?
        set internet_f "firefox"
        if {[info exists internet_f]} {
            if { [catch {
                    #
                    #.mome.xit.ex configure -state disabled
                    #
                    #set url "http://bioinfo-prod.mpl.ird.fr/morphometrics/clic/CLIC_30.tar.gz"
		    set url "http://mome-clic/?clic-package/CLIC_$S(quid).tar.gz"
		    set url "http://mome-clic/?clic-package"
                    #type "Hit 'update'. Go to the download page CLIC_$S(quid).tar.gz" 
                    type "url = $url"
                    global attente numli
                    set fid [open "| $internet_f $url"]
                    fconfigure $fid -buffering line
                    fileevent $fid readable "afficheinfo $fid"
                    vwait attente
                    #
                    update
                    flush stdout
                } result]} {
                debug "$result\n---\n$url: NO ACCESS  (no internet browser -Firefox, IE - here ?)"
            }
        }
    }

}

global S version
set version 94
set S(patchnumber) $version
Update::MOMEUpdate
