package require Tk

################################################################################
# Select
# Copyright ©  2012 Dujardin J.-P. dujardin@mpl.ird.fr
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
################################################################################

cd [file dirname [info script]]
#
global S
set S(dirscript) [pwd];#attention, il n'y a pas de "/" a la fin du nom du dossier du script (utiliser "[file join etc]")
#
cd ..
set S(dirclic) [pwd]
cd $S(dirscript)
#
set version "FOG 075 - beta"
# 007 bug enter group first repare
# 008 disable active
# 009 normalizing coefficients...
# 010 adding fogdraw (or NEF button)
# 011 autre possibilite d'output graphique des outlines
# 012 sequence GRAPH mieux geree
# 013 bugcito 1.3 -- 1.14 corrige
# 14-15 arrondis doublons enleves
# 16-25 MVA programmes separes
# 25 - 45 Histogram DA 2 groups sample distribution error fixed # NEF coefficients retained for PCA fixed
# 55 improved PCA on normalized outlines
# 56 opens the last folder used by MOG or PAD
# 65 less interference between NEF and Procrustes graphs
# 75 improvement of Rhelp and new algorithm for Fourier coefficients

set tcl_precision 14

font create onlist -family courier -size 13 -weight normal -slant roman

set dossier [pwd]
#
source chull.tcl
source ballons.tcl
source [file join $S(dirclic) "+/101La.tcl"]
source [file join $S(dirclic) "+/math/statistics.tcl"]
source [file join $S(dirclic) "+/math/math.tcl"]
source [file join $S(dirclic) "+/math/optimize.tcl"]
source [file join $S(dirclic) "+/math/linalg.tcl"]
source [file join $S(dirclic) "+/jpdraw_15.tcl"]
source [file join $S(dirclic) "+/fogdraw_05.tcl"]

switch $tcl_platform(platform) {
    "unix" {
        global S
        set S(liwiclic) "linclic"
        set fin [file join $S(dirclic) "+/L"]
        set suf "/neighbor"
        set S(appel) "exec xterm $fin$suf"
        set suf "/njplot.linux"
        set S(appelnjplotte) "exec xterm $fin$suf"
        set S(filename1) [file join $S(dirclic) "+/L/translat.txt"]
        set S(filename2) [file join $S(dirclic) "+/L/treefile"]
        set S(dossierdumod) [file join $S(dirclic) "+" "L" "infile" ]
    }
    "windows" {
        global S
        set S(liwiclic) "winclic"
        set fin "/+/W"
        set suf "/neighbor.exe"
        set S(appel) "exec cmd.exe /c neighbor.exe"
        set suf "/njplot.exe"
        set S(appelnjplotte) "exec cmd.exe /c njplot.exe"
        set S(filename1) [file join $S(dirclic) "+/L/translat.txt"]
        set S(filename2) [file join $S(dirclic) "+/L/outtree"]
        #set S(filename1) "+/W/translat.txt";#a changer pour translat.txt ??
        #set S(filename2) "+/W/outtree";#a changer pour outtree ??
        set S(dossierdumod) [file join $S(dirclic) "+" "W" "infile" ]
    }
    "macintosh" {}
}


# -------------------------------------------------
# FENETRE PRESENTATION de la MATRICE
# -------------------------------------------------

global p fp
set fp .muestreo
catch {destroy $fp}
catch {toplevel .muestreo}
wm state . withdrawn

set titre "$version"
wm title .muestreo $titre
wm geometry $fp 800x600+200+10

frame $fp.buttons
pack $fp.buttons -side bottom -fill x -pady 2m
#
button $fp.buttons.informe -text "Save report ?" -command {
    global S
    if {$S(save) != "_INFO_FOG.txt"} {
        savelisting $S(save)
    } else  {
        savelisting "_INFO_FOG.txt"
    }
}
#
button $fp.buttons.wrap -text "Wrap" -command {
    global drapeau
    if {[info exists drapeau]} {
        if {$drapeau == 1} {
            .muestreo.debut configure -wrap word; set drapeau 0
        } else {
            .muestreo.debut configure -wrap none; set drapeau 1
        }
    } else  {
        set drapeau 1
    }
}
#
button $fp.buttons.clean -text "Clean Output" -command {
    global p
    $p delete 0.0 end
}

button $fp.buttons.reset -fg red -text "Reset" -command {
    set avertisse "Memory will be cleared (except current output). \
            Please be careful with this reset button, it is sometimes deficient."
    set answer [tk_messageBox -message $avertisse -title "SURE ?" -type okcancel -icon warning]
    switch -- $answer {
        ok {unot;arranco}
        cancel {}
    }
}
#
button $fp.buttons.exit -fg red  -text "EXIT" -command {
    exit
}
#
button $fp.buttons.suivi -fg red  -text "Suivi" -command {}

pack $fp.buttons.wrap $fp.buttons.informe $fp.buttons.suivi $fp.buttons.exit -side left -expand 1

set scb [scrollbar .muestreo.scrollA -command ".muestreo.debut yview"]
pack $scb -side left -fill y
#
set p [text .muestreo.debut -background "light yellow" -font "courier 12" -wrap none -yscrollcommand ".muestreo.scrollA set"]
#
$p insert end "\nAlthough FOG computes the \"totality\" of elliptic Fourier coefficients, \
        \na maximum of 28 harmonics is considered for estimating outlines and performing multivariate analyses. \
        \nThis will be under the user control in a future version.\
        \n\nFOG provides two ways to normalize the observed outlines: \
        \none through the \"normalized elliptic Fourier coefficients\" (NEF), computed from the observed coefficients themselves (Ao, Co, An, Bn, Cn ,Dn -- n is the harmonic),\
        \nthe other one through a more laborious data processing (button GRAPH)\
        \n(1) computing Fourier coefficients (Ao, Co, An, Bn, Cn ,Dn), \
        \n(2) computing estimated outlines according to these coefficients \
        \n(3) aligning these estimated outlines after a Procrustes superposition procedure\
        \n(4) computing from them the Fourier coefficients again (Ao', Co', An', Bn', Cn', Dn').\
        \n\nThe second procedure supposes your digitized outlines always start \
        \nfrom the same HOMOLOGOUS landmark.\
        \n\nFOG may be slow, especially when computing the coefficients from aligned estimated outlines.\
        \nIt also is relatively slow when computing PCA\
        \n\n\n\t - - - \t\t - - - \t\t - - - \t\t - - - \n\n"
#
# ---------------------------------------------------------------------------------------------
# Create a menu
# ---------------------------------------------------------------------------------------------
#
frame $fp.menus
pack $fp.menus -side top -fill x -pady 2m
#
# -----------------------------------------------------------------------------------------------------
menubutton $fp.menus.files -text "FILES" -menu $fp.menus.files.menu
set m [menu $fp.menus.files.menu -tearoff 1]
$m add radio -label "HELP" -command {
    foghelp [file join $S(dirclic) "+/fogfile_help.txt"]
}
$m add radio -label "..._OTL.txt (Outline contour)" -command {
    $fp.menus.grph configure -state active
    otlmain
}
$m add radio -label "..._OTL_FOG.txt (EFA coefficients)" -command {
    $fp.menus.grph configure -state active
    fogmain
}
$m add radio -label "Save Report" -command {
    global S
    if {$S(save) != "_INFO_FOG.txt"} {
        savelisting $S(save)
    } else  {
        savelisting "_INFO_FOG.txt"
    }
}
$m add radio -label "Exit" -command {exit}

pack $fp.menus.files -side left -fill x -expand yes
# -----------------------------------------------------------------------------------------------------
menubutton $fp.menus.nef -text "MVA on NEF" -state disabled -menu $fp.menus.nef.menu
set m [menu $fp.menus.nef.menu -tearoff 1]
#
$m add radio -label "HELP" -command {
    foghelp [file join $S(dirclic) "+/fognef_help.txt"]
}
#
$m add radio -label "PCA on NEF" -command {
    global p S fogmatall infile
    set S(pcanef) 1
    set S(mvagrap) 0
    if {[info exists effectifs]} {unset effectifs}
    set nefhume [fognorm $fogmatall];# 'nefhume' contient une matrice de Hume <- cfr. 'return S(normfogall)' de la procedure FOGNORM
    # Enregistrer un fichier ..._OTL_NEF.txt - debut
    saveotlnef $nefhume
    # Enregistrer un fichier ..._OTL_NEF.txt - fin
    acpnef $nefhume
}
#
$m add radio -label "DA on NEF" -command {
    #
    global p S fogmatall infile
    set S(danef) 1
    set S(mvagrap) 0
    if {[info exists effectifs]} {unset effectifs}
    if {[info exists S(normfogall)]} {
        danef $S(normfogall)
    } else  {
        set nefhume [fognorm $fogmatall];# 'nefhume' contient une matrice de Hume <- cfr. 'return S(normfogall)' de la procedure FOGNORM
        # Enregistrer un fichier ..._OTL_NEF.txt - debut
        saveotlnef $nefhume
        # Enregistrer un fichier ..._OTL_NEF.txt - fin
        danef $nefhume
    }
}
balloonhelp_for $fp.menus.nef "Multivariate Analyses (MVA) \non Normalized coefficients (NEF) \naccording to Kuhl & Giardina, 1982"

pack $fp.menus.nef -side left -fill x -expand yes
# -------------------------------------------------------------------------------------------------GRAPH----
menubutton $fp.menus.grph -text "GRAPH" -state disabled -menu $fp.menus.grph.menu
set m [menu $fp.menus.grph.menu -tearoff 1]
$m add radio -label "HELP" -command {foghelp [file join $S(dirclic) "+/estimotl_help.txt"]}
$m add radio -label "Viewing" -command {
    global S
    if {[info exists S(pafmatall)]} {
        global p S chevalet
        set S(harm_nb) 29;# aussi dans 'entrada_otl' et dans 'fogmain' ...
        cabale
    } else  {
        tk_messageBox -message "Please compute harmonics first" -type ok
    }
}
balloonhelp_for $fp.menus.grph "View the shape, \nalign the contours"

pack $fp.menus.grph -side left -fill x -expand yes

################################################################################
# # --------------------------------------------------------------------------------------MVA after GRAPH----
# menubutton $fp.menus.mva -text "MVA after GRAPHS" -state disabled -menu $fp.menus.mva.menu
# set m [menu $fp.menus.mva.menu -tearoff 1]
# #
# $m add radio -label "HELP" -command {
#     foghelp [file join $S(dirclic) "+/fogpcada_help.txt"]
# }
# #
# $m add radio -label "PCA on on coefficients derived from superimposed outlines" -command {
#     global p S fp
#     set S(mvagrap) 1
#     if {[info exists effectifs]} {unset effectifs}
#     if {[info exists S(pafmatall_sf)]} {
#         #
#         # Appel a la procedure ACPOTL_SF
#         #
#         acpotl_sf
#     } else  {
#         #loadfile ....FOGsf
#         # Lecture des size-free coefficients: nom du fichier ..._OTL_FOGsf.txt, s'il existe
#         set a [file dirname $infile]
#         set queue [file tail $infile]
#         if {[string first "_FOG" $queue] > -1} {
#             set b [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
#             set c "sf.txt"
#         } else {
#             set b  [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
#             set c "_FOGsf.txt"
#         }
#         #
#         set infile_sf [file join $a $b$c]
#         #tk_messageBox -message "EXISTS $infile_sf ??" -type ok
#         if {[file exists $infile_sf]} {
#             #SF PCA: Je remplis le S(pafmatall_sf)  a partir de $infile_sf
#             tk_messageBox -message "Size-scaled coefficients obtained from the following file: \n$infile_sf" -type ok
#             set S(pafmatall_sf) [loadfile $infile_sf]
#             #debug $S(pafmatall_sf)
#             #
#             update
#             $fp.buttons.suivi configure -text " -- Performing PCA -- ";#seulement 36 coefficients utilises, au lieu de 72
#             #
#             # Appel a la procedure ACPOTL_SF
#             #
#             acpotl_sf
#         } else  {
#             tk_messageBox -message "Please compute size-free coefficients first" -type ok
#         }
#     }
#     $fp.menus.tree configure -state active
# }
# #
# $m add radio -label "DA on coefficients derived from superimposed outlines" -command {
#     global p S
#     set S(DA) 1
#     #if {[info exists effectifs]} {unset effectifs}
#     set S(mvagrap) 1
#     if {[info exists S(pafmatall_sf)]} {
#         daotl_sf
#     } else  {
#         #loadfile ....FOGsf
#         # Lecture des size-free coefficients: nom du fichier ..._OTL_FOGsf.txt, s'il existe
#         set a [file dirname $infile]
#         set queue [file tail $infile]
#         if {[string first "_FOG" $queue] > -1} {
#             set b [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
#             set c "sf.txt"
#         } else {
#             set b  [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
#             set c "_FOGsf.txt"
#         }
#         #
#         set infile_sf [file join $a $b$c]
#         
#         if {[file exists $infile_sf]} {
#             #tk_messageBox -message "SF DA : Je nourris S(pafmatall_sf) a partir de _FOGsf" -type ok
#             set S(pafmatall_sf) [loadfile $infile_sf]
#             daotl_sf
#         } else  {
#             tk_messageBox -message "Please compute size-free coefficients first" -type ok
#         }
#     }
# }
# balloonhelp_for $fp.menus.mva "Multivariate Analyses (MVA) \non coefficients derived from\naligned estimated outlines"
# pack $fp.menus.mva -side left -fill x -expand yes
# # -----------------------------------------------------------------------------------------------------
################################################################################
menubutton $fp.menus.size -text "SIZE"  -state disabled -menu $fp.menus.size.menu
set m [menu $fp.menus.size.menu -tearoff 1]
$m add radio -label "HELP" -command {
    foghelp [file join $S(dirclic) "+/fogallometry_help.txt"]
}
$m add radio -label "Quantile boxes for size" -command {
    global S
    set S(dequoilsagit) "--- Quantile boxes for size ---"
    #tk_messageBox -message "Not implemented yet" -type ok
    
    proc graphique {datos efectivos} {
        # GRAPHIQUE - start
        global p S numfen intervalle colonnes references primeralinea
        set numfen 1
        set intervalle 40
        set colonnes [llength $efectivos]
        #set references $primeralinea
        #debug
        #rouge "\nGroupes [llength $efectivos]\nvaleurs $datos\nEffectifs $efectivos "
        range [llength $efectivos] $datos $efectivos
        # GRAPHIQUE - fin
        return 1
    }
    #
    if {[info exists S(pear)]} {
        set perare "2 $S(otl_nb) 2 $S(pear)"
        # perimetres
        set datos_pe [vtrim [mrange $perare 0 0 0 end]]
        # aires
        set datos_ar [vtrim [mrange $perare 1 1 0 end]]
        
        if {[info exists S(grupos]} {
            set efectivos $S(grupos)
            if {$S(taille) == "p"} {
                graphique $datos_pe $efectivos
            } else  {
                graphique $datos_ar $efectivos
            }
        } else  {
            # entry for groups
            global S
            askforg [llength $datos_pe]
            set efectivos $S(grupos)
            #graphique $datos_pe $efectivos
            if {$S(taille) == "p"} {
                graphique $datos_pe $efectivos
            } else  {
                graphique $datos_ar $efectivos
            }
        }
        
    } else  {
        # entry for groups
        global S
        set datos [ouvrir]
        #tk_messageBox -message "[llength $datos] datos" -type ok
        askforg [llength $datos]
        #tk_messageBox -message "Groups are $S(grupos)" -type ok
        set efectivos $S(grupos)
        graphique $datos $efectivos
    }
}
$m add radio -label "Perimeter / Area : correlation" -command {
    global S
    set S(dequoilsagit) "--- Relationship between contour perimeter and bounded area ---"
    if {[info exists S(taille)]} {
        set S(DA) 0
        set perare "2 $S(otl_nb) 2 $S(pear)"
        set a [mrange $perare 0 0 0 end]
        set b [mrange $perare 1 1 0 end]
        #debug "S(pear)\n$S(pear)\nperare ---------\n$perare\n--- a\n$a"
        set corps [join_cols $a $b]
        set R [correlation $corps]
        #debug "Correlation: [lindex [vtrim $R] 1]"
        set y1 [vtrim $a]
        set y2 [vtrim $a]
        set ixe [vtrim $b]
        #
        set avis "Hello"
        #affiche 770 134 $avis
        picasso
        global magritte effectifs
        if {[info exists S(grupos)]} {set effectifs $S(grupos)} else {
            # entry for groups
            global S
            askforg [llength $y1]
            set effectifs $S(grupos)
            #tk_messageBox -message "Y1: Groups are $S(grupos)" -type ok
        }
        set ny "PERIMETER"
        set nx "AREA"
        fogregresse $y1 $y2 $ixe $nx $ny
    } else  {
        tk_messageBox -message "First compute size: Menu GRAPH  -> \"Viewing\", -> \"SF\" " -type ok
    }
}
#
$m add radio -label "Perimeter Observed outlines / Estimated outlines : correlation" -command {
    global S infile
    set S(dequoilsagit) "--- Relationship between contour perimeter of Observed and Estimated outlines ---"
    if {[info exists S(otl_peri)]} {
        set S(DA) 0
        if {[llength $S(taille)] > 0} {
            #debug "\TAILLE = $S(taille) ('a' si AIRE est choisie, 'p' si PERIMETER est choisi)\n\nPEAR\n$S(pear)"
            set perare "2 $S(otl_nb) 2 $S(pear)"
            set a [mrange $perare 0 0 0 end]
            set b $S(otl_peri)
            #debug "\na = $a\nb = $b\n$S(otl_peri)"
            set corps [join_cols $a $b]
            set R [correlation $corps]
            #debug "\nCorrelation: [lindex [vtrim $R] 1]"
            set y1 [vtrim $a]
            set y2 [vtrim $a]
            set ixe [vtrim $b]
            #
            set avis "Hello"
            #affiche 770 134 $avis
            picasso
            global magritte effectifs
            if {[info exists S(grupos)]} {set effectifs $S(grupos)} else {
                # entry for groups
                global S
                askforg [llength $y1]
                set effectifs $S(grupos)
                tk_messageBox -message "Y1: Groups are $S(grupos)" -type ok
            }
            set ny "EST. SIZE"
            set nx "OBS. SIZE"
            fogregresse $y1 $y2 $ixe $nx $ny
        } else  {
            tk_messageBox -message "First compute size: Menu GRAPH  -> \"Viewing\", -> \"SP\" " -type ok
        }
    } else  {
        # Recuperer le nom du fichier _OTL.txt
        set fileotl [otlfile [file tail [file rootname $infile]]]
        # Puis reconstituer le nom du fichier _OTL_PER.txt
        if {[file exists $fileotl]} {
            set fileare "_PER.txt"
            set fileare [file tail [file rootname $fileotl]]$fileare
            set fileare [file join [file dirname $infile] $fileare]
            # ouvrir et lire le fichier _ARE.txt qui contient les aires des figures observees
            set S(otl_peri) [loadfile_per $fileare]
            # le joindre par colonnes a la colonne des aires des figures estimees (bouton SF = ex SP)
            #
            if {[info exists S(otl_peri)]} {
                set S(DA) 0
                if {[info exists S(taille)]} {
                    #tk_messageBox -message "$S(pear)"
                    set perare "2 $S(otl_nb) 2 $S(pear)"
                    set a [mrange $perare 0 0 0 end]
                    set b $S(otl_peri)
                    #debug "b = \n$S(otl_peri)"
                    set corps [join_cols $a $b]
                    set R [correlation $corps]
                    #debug "Correlation: [lindex [vtrim $R] 1]"
                    set y1 [vtrim $a]
                    set y2 [vtrim $a]
                    set ixe [vtrim $b]
                    #
                    set avis "Hello"
                    #affiche 770 134 $avis
                    picasso
                    global magritte effectifs
                    if {[info exists S(grupos)]} {set effectifs $S(grupos)} else {
                        # entry for groups
                        global S
                        askforg [llength $y1]
                        set effectifs $S(grupos)
                        #tk_messageBox -message "Y1: Groups are $S(grupos)" -type ok
                    }
                    set ny "EST. SIZE"
                    set nx "OBS. SIZE"
                    #debug "fogregresse\n$y1\n$y2\n$ixe\n$nx $ny"
                    fogregresse $y1 $y2 $ixe $nx $ny
                } else  {
                    tk_messageBox -message "First compute size: Menu GRAPH  -> \"Viewing\", -> \"SP\" " -type ok
                }
            }
        }
    }
}
#
$m add radio -label "AREA Observed outlines / Estimated outlines : correlation" -command {
    global S
    set S(dequoilsagit) "--- Relationship between bounded areas of Observed and Estimated outlines ---"
    if {[info exists S(otl_aire)]} {
        set S(DA) 0
        #tk_messageBox -message "S(taille) $S(taille)" -type ok
        if {[info exists S(taille)]} {
            set perare "2 $S(otl_nb) 2 $S(pear)"
            set a [mrange $perare 1 1 0 end]
            set b $S(otl_aire)
            set corps [join_cols $a $b]
            #debug [show $corps]
            set R [correlation $corps]
            #debug "Correlation: [lindex [vtrim $R] 1]"
            set y1 [vtrim $a]
            set y2 [vtrim $a]
            set ixe [vtrim $b]
            #
            set avis "Hello"
            #affiche 770 134 $avis
            picasso
            global magritte effectifs
            if {[info exists S(grupos)]} {set effectifs $S(grupos)} else {
                # entry for groups
                global S
                askforg [llength $y1]
                set effectifs $S(grupos)
                #tk_messageBox -message "Y1: Groups are $S(grupos)" -type ok
            }
            set ny "ESTIMATED AREA"
            set nx "OBSERVED AREA"
            fogregresse $y1 $y2 $ixe $nx $ny
        } else  {
            tk_messageBox -message "Please compute areas of estimated outlines ... \
                    \n(Menu GRAPH  -> button \"Viewing\", -> button \"SF\")\
                    \n... then come back to this menu again" -type ok
            #
        }
    } else  {
        # Recuperer le nom du fichier _OTL.txt
        set fileotl [otlfile [file tail [file rootname $infile]]]
        # Puis reconstituer le nom du fichier _OTL_ARE.txt
        if {[file exists $fileotl]} {
            set fileare "_ARE.txt"
            set fileare [file tail [file rootname $fileotl]]$fileare
            set fileare [file join [file dirname $infile] $fileare]
            # ouvrir et lire le fichier _ARE.txt qui contient les aires des figures observees
            set S(otl_aire) [loadfile_per $fileare]
            # le joindre par colonnes a la colonne des aires des figures estimees (bouton SF = ex SP)
            #
            if {[info exists S(pear)]} {
                set perare "2 $S(otl_nb) 2 $S(pear)"
                set a [mrange $perare 1 1 0 end]
                set b $S(otl_aire)
                set corps [join_cols $a $b]
                set y1 [vtrim $a]
                set y2 [vtrim $a]
                set ixe [vtrim $b]
                #
                set avis "Hello"
                #affiche 770 134 $avis
                picasso
                global magritte effectifs
                if {[info exists S(grupos)]} {set effectifs $S(grupos)} else {
                    # entry for groups
                    global S
                    askforg [llength $y1]
                    set effectifs $S(grupos)
                    #tk_messageBox -message "Y1: Groups are $S(grupos)" -type ok
                }
                set ny "ESTIMATED AREA"
                set nx "OBSERVED AREA"
                fogregresse $y1 $y2 $ixe $nx $ny
            } else  {
                tk_messageBox -message "Please compute areas of estimated outlines ... \
                        \n(Menu GRAPH  -> button \"Viewing\", -> button \"SF\")\
                        \n... then come back to this menu again" -type ok
                #
            }
            
        } else  {
            tk_messageBox "The file name $fileotl does not seem to exist"
            return
        }
        return
    }
}
#
$m add radio -label "ALLOMETRY" -command {
    global S
    set panneau ""
    set S(dequoilsagit) "--- Relationship between shape and size ---"
    append panneau "\n--- Relationship between shape and size ---\n"
    #if {[info exists S(cp_sf)]} {}
    if {[info exists S(nefcp)]} {
        set S(DA) 0
        set connards ""
        #for {set u 0} {$u < [mrows $S(cp_sf)]} {incr u} {}
        for {set u 0} {$u < [mrows $S(nefcp)]} {incr u} {
            update
            #lappend connards [mrange $S(cp_sf) 0 end $u $u]
            lappend connards [mrange $S(nefcp) 0 end $u $u]
        }
        alocs $connards
        append panneau "Y, Y1 or Y2 are principal components derived from NEF coefficients"
        affiche 500 500 $panneau
    } else  {
        tk_messageBox -message "Please perform size-free PCA first" -type ok
    }
}
balloonhelp_for $fp.menus.size "Size (PERIMETER, AREA) and ALLOMETRY, \nPLEASE USE graph FIRST"

pack $fp.menus.size -side left -fill x -expand yes
# -----------------------------------------------------------------------------------------------------
menubutton $fp.menus.tree -text "TREE" -state disabled -menu $fp.menus.tree.menu
set m [menu $fp.menus.tree.menu -tearoff 1]
$m add radio -label "HELP" -command {
    foghelp [file join $S(dirclic) "+/fogtree_help.txt"]
}
$m add radio -label "SF tree: Neighbor Joining (PHYLIP, J. Felsenstein)" -command {
    global p S infile
    # Ouvrir un fichier ... _FOGcpsf.txt ... s'il existe
    set a [file dirname $infile]
    set queue [file tail $infile]
    if {[string first "_FOG" $queue] > -1} {
        set b [string range $queue 0 [string first "_FOG" $queue] ]
        set c "FOGcpsf.txt"
    } else {
        set b  [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
        set c "_FOGcpsf.txt"
    }
    set infile_cpsf [file join $a $b$c]
    #debug "CPSF\na = $a\nqueue = $queue \nb = $b\nc = $c\n$infile_cpsf"
    set filename $infile_cpsf
    #
    if {[file exists $filename]} {
        #debug "je charge S(cp_sf)"
        global gr
        set S(cp_sf) [loadfile $filename]
        ##
        if {[info exists S(grupos)] != 1} {
            tk_messageBox -message "Please graph groups first" -type ok
            return
        }
        set S(treenj) 1
        tree::tree_nj
    } else  {
        if {[info exists S(cp_sf)]} {
            set S(treenj) 1
            tree::tree_nj
        } else  {
            tk_messageBox -message "Please do the size-free PCA first" -type ok
        }
    }
}
$m add radio -label "Name the OTUs  (Treedyn, Chevenet)" -command {
    global p S
    if {[info exists S(treenj)]} {
        if {$S(treenj) == 1} {
            tree::qui
        } else  {
            tk_messageBox -message "Please build a tree first" -type ok
        }
    } else  {
        tk_messageBox -message "Please build a tree first" -type ok
    }
}
$m add radio -label "NJPLOT (Perriere & Gouy, 1996)" -command {
    global p S
    if {[info exists S(treenj)]} {
        if {$S(treenj) == 1} {
            tree::njplotte
        } else  {
            tk_messageBox -message "Please build a tree first" -type ok
        }
    } else  {
        tk_messageBox -message "Please build a tree first" -type ok
    }
}

balloonhelp_for $fp.menus.tree "Use of External software\nPHYLIP\nNJPLOT"

pack $fp.menus.tree -side left -fill x -expand yes


# -----------------------------------------------------------------------------------------------------
menubutton $fp.menus.ere -text " R " -state disabled -menu $fp.menus.ere.menu
set m [menu $fp.menus.ere.menu -tearoff 1]
#
$m add radio -label "Prepare functions and packages" -command {
    global S infile
    # Ouvrir un terminal R a chaque fois? Oui si je peux le refermer...
    if {[info exists S(erela)]} {
        # travailler
    } else  {
        erela
        # travailler
    }
    #
    #...fenetre d'aide au R dans la variable globale S(ere)
    #
    faar
    set analyse "r_pca.txt"
    $S(ere) insert end "\nPlease put yourself in the working folder"
    set aide "\n> setwd(\"[file dirname $infile]\")"
    r_rouge $aide
    $S(ere) insert end "\nTo verify the folder content, type"
    set aide "\n> list.files()"
    r_rouge $aide
    $S(ere) insert end "\nTo install a new package, \
            \n(1) download the source file (ending by ...tar.gz) in your working directory\
            \n(2) use the following instruction:"
    set aide "\n> install.packages(\"...tar.gz\")"
    r_brun $aide
    $S(ere) insert end "\nSome R packages are necessary to perform morphometric analyses. Their intallation is made once for all. However, it is not enough to \"install\" them, you also must upload it into your current R session, like"
    set aide "\n> library(shapes);library(pixmap);library(utils);library(base);library(stats);library(fractaldim)"
    r_brun $aide
    $S(ere) insert end "\n\nMANDATORY: the Rfunctions developped in Claude J. (2008). Morphometrics with R. Springer"
    set aide "\n> source(\"http://www.isem.cnrs.fr/IMG/txt/Rfunctions.txt\")"
    r_rouge $aide
    $S(ere) insert end "\n...or, if you are not connected:"
    set aide "\n> source(\"[file join $S(dirclic) $S(rhelp) Rfunctions.txt]\")"
    r_brun $aide
    $S(ere) insert end "\n\nPlease call also the following function(s):"
    set aide "\n> source(\"[file join $S(dirclic) $S(rhelp) clic2r.txt]\")"
    r_rouge $aide
}
#
$m add radio -label "EFA: single contour" -command {
    global S infile
    # Ouvrir un terminal R a chaque fois? Oui si je peux le refermer...
    if {[info exists S(erela)]} {
        # travailler
    } else  {
        erela
        # travailler
    }
    #
    #...fenetre d'aide au R ("faar") dans la variable globale S(ere)
    #
    faar
    $S(ere) insert end "\nRemember: you had to put yourself in your working directory, and to call several functions"
    set aide "\n> setwd(\"[file dirname $infile]\")\n> source(\"http://www.isem.cnrs.fr/IMG/txt/Rfunctions.txt\")"
    r_brun $aide
    #
    $S(ere) insert end "\n"
    set aide "> otl <- read.delim(\"[file tail [file rootname $infile]].txt\",header=FALSE,skip=1,sep = \"\", dec=\".\",blank.lines.skip=T)"
    append aide "\n> n<-dim(otl)\[1\];  pl <- vector(,n);pl\[1\]<-otl\[1,1\];storing<-(2*round(pl/2)); coef<-matrix(NA,n,storing); coe<-matrix(NA,n,storing)"
    append aide "\n> j<-otl\[1,\];j<-j\[4:length(j)\];k<-(otl\[,1\]\[1\]-1)*2;j<-j\[1:k\];j<-as.matrix(j);j<-matrix(j,k/2,2,byrow=T)"
    append aide "\n> coef<-matrix(NA,n,storing);coe<-matrix(NA,n,storing)"
    append aide "\n> ef<-efourier(j,storing/4);coef\[1,\]<-c(ef\$an,ef\$bn,ef\$cn,ef\$dn);ief<-iefourier(ef\$an,ef\$bn,ef\$cn,ef\$dn,storing/4,150,ao=0,co=0)"
    append aide "\n> plot(ief\$x,ief\$y,asp=1)"
    append aide "\n> N<-NEF(j,storing/4);coe\[1,\]<-c(N\$A,N\$B,N\$C,N\$D);inef<-iefourier(N\$A,N\$B,N\$C,N\$D,storing/4,150,ao=0,co=0)"
    append aide "\n> plot(inef\$x,ief\$y,asp=1)"
    r_rouge $aide
    set analyse "r_efa_single.txt"
    fiar $analyse
}
#
$m add radio -label "EFA: a set of contours" -command {
    global S infile
    # Ouvrir un terminal R a chaque fois? Oui si je peux le refermer...
    if {[info exists S(erela)]} {
        # travailler
    } else  {
        erela
        # ouvrir le terminal R; travailler
    }
    #
    #...fenetre d'aide au R ("faar") dans la variable globale S(ere)
    #
    faar
    $S(ere) insert end "\nRemember: you had to put yourself in your working directory, and to call several functions"
    set aide "\n> setwd(\"[file dirname $infile]\")\n> source(\"[file join $S(dirclic) $S(rhelp) Rfunctions.txt]\")"
    r_brun $aide
    #
    set aide "\n\n(1) INPUT an ..._OTL.txt FILE\nPlease verify the columns are separated by a space \"\" or by a tabulation \"\\t\"\n"
    r_bleu $aide
    #
    $S(ere) insert end "\nThe number of points may be different from one outline to another, we first compute the maximum number of points found among the outlines"
    set aide "\n> ncol <- max(count.fields(\"[file tail [file rootname $infile]].txt\", sep = \"\"))"
    r_rouge $aide
    set aide "\n> ncol  # maximum number of columns"
    r_rouge $aide
    $S(ere) insert end "\nAssuming points are separated by space ' sep = \"\" ...(otherwise sep = \"\\t\" "
    set aide "\n> otl <- read.csv(\"[file tail [file rootname $infile]].txt\", sep=\"\",fill = TRUE,skip=1,header = FALSE,col.names = paste(\"V\", seq_len(ncol)))"
    r_rouge $aide
    #
    set aide "\n\n(1) ANALYZES\n"
    r_bleu $aide
    #
    $S(ere) insert end "\nAn ..._OTL.file contains the coordinates of various (n)) digitized lines with a different number of point (pl),\
            \nthe following instruction will show the number of points of each configuration, as a list: "
    set aide "\n> n<-dim(otl)\[1\];pl <- vector(,n);for (i in 1:n) {pl\[i\]<-otl\[i,1\]};pl"
    r_rouge $aide
    #
    $S(ere) insert end "\n(If the list (\"pl\") contains \"NA\", it means that the input ..._OTL.txt file still contains blank spaces; please remove them with TET)"
    #
    $S(ere) insert end "\nNumber of harmonics (28 if you want to compare the results with CLIC output)"
    set aide "\n> h <- 28"
    r_rouge $aide
    #
    $S(ere) insert end "\n\nPreparing the matrix (conef) to store the normalized Fourier coefficients, \
            \nas well as the matrix (coox, cooy) for future graph using 400 dots:"
    set aide "\n> storing<-h*4;conef<-matrix(NA,n,storing); coox<-matrix(NA,n,400);cooy<-matrix(NA,n,400)"
    r_rouge $aide
    $S(ere) insert end "\n\nComputing \"normalized\" Fourier coefficients:"
    set aide "\n> for (i in 1:n) {j<-otl\[i,\];j<-j\[4:length(j)\];pn<-as.numeric(2*(otl\[i,\]\[1\]-1));j<-j\[1:pn\];j<-j\[1:(length(j)-2)\];j<-as.matrix(j);pn<-as.numeric((dim(j)\[2\])/2);j<-matrix(j,pn,2,byrow=T);N<-NEF(j,h);conef\[i,\]<-c(N\$A,N\$B,N\$C,N\$D);inef<-iefourier(N\$A,N\$B,N\$C,N\$D,h,400,ao=0,co=0);coox\[i,\]<-inef\$x;cooy\[i,\]<-inef\$y}"
    r_rouge $aide
    $S(ere) insert end "\nSee the \"normalized\" outlines - "
    set aide "\n> plot(coox,cooy,asp=1)"
    r_rouge $aide
    $S(ere) insert end "\nSee the 6 first outlines - or the next 14 ones "
    set aide "\n> plot(coox\[1:6,\],cooy\[1:6,\],asp=1)\n> plot(coox\[7:20,\],cooy\[7:20,\],asp=1)"
    r_brun $aide
    $S(ere) insert end "\nSee the 6 first outlines AND the the outlines from the 12th to the 20th"
    set aide "\n> plot(c(coox\[1:6,\],coox\[12:20,\]), c(cooy\[1:6,\],cooy\[12:20,\]),asp=1)"
    r_brun $aide
    $S(ere) insert end "\nIf the two groups are separated, the ' type=\"s\" ' option helps to see it"
    set aide "\n> plot(c(coox\[1:6,\],coox\[12:20,\]), c(cooy\[1:6,\],cooy\[12:20,\]),type=\"s\",asp=1)"
    r_brun $aide
    $S(ere) insert end "\nReformatting the set of Fourier coefficients, if necessary"
    set aide "\n> tcoef<-t(coef);acoef<-array(tcoef,dim=c(h,4,n));"
    r_brun $aide
    $S(ere) insert end "\n\nReformatting the set of NEF coefficients to perform a PCA"
    set aide "\n> tconef<-t(conef);aconef<-array(tconef,dim=c(h,4,n));nefco<-matrix(NA,n,storing);for (i in 1:n) {nefco\[i,\]<-t(aconef\[,,i\])}"
    r_rouge $aide
    set aide "\n> "
    r_rouge $aide
    #
    $S(ere) insert end "\n\nPRINCIPAL COMPONENT ANALYSIS of NEF COEFFICIENTS"
    set aide "\n> PC<-princomp(nefco\[,c(2:n+1)\]);PC\$score; plot(PC\$score,asp=1)"
    r_rouge $aide
    $S(ere) insert end "\n\nIf you want to indicate categories, with for instance two groups A and B of 20 and 24 individuals, type:\
            \n plot(PC\$score,pch=c(rep(\"1\",20),rep(\"2\",24)),asp=1). \
            \nPlease adapt, if necessary, the following instruction to your sample subdivisions"
    #
    if {[info exists S(grupos)]} {
        if {$S(grupos) != ""} {set S(otu) $S(grupos)}  else {
            tk_messageBox -message "pas de S(grupos)" -type ok
            return
        }
    } else  {
        if {[info exists S(groupes)]} {
            if {$S(groupes) != ""} {set S(otu) $S(groupes)} else {
                tk_messageBox -message "pas de S(groupes)" -type ok
                return
            }
        } else  {
            tk_messageBox -message "Please perform a PCA first, and indicate groups" -type ok
            destroy .rwidget
            return
        }
    }
    #
    set otulist ""
    set i 0
    foreach item $S(otu) {
        incr i
        append otulist "$item "
    }
    #
    set pch "pch=c\(rep\(\"1\",[lindex $otulist 0]\),"
    #
    for {set i 1} {$i < [llength $otulist]} {incr i} {
        set appendage "rep\(\"[expr {$i+1}]\",[lindex $otulist $i]\),"
        append pch $appendage
    }
    set pch [string trimright $pch ","]
    set aide "\n> plot\(PC\$score,$pch\),asp=1\)"
    r_rouge "\n$aide"
    #
    #global inputval2
    tk_messageBox -message "otulist $otulist" -type ok
    $S(ere) insert end "\n\nIf you DO NOT CLOSE the graph widget,the plot can be enriched using convex hulls to visualize different groups"
    if {[info exists otulist]} {
        if {[llength $otulist] > 1} {
            set chull_subdivision [bequille_chull $otulist]
            #
            set aide "$chull_subdivision"
            r_rouge $aide
            $S(ere) insert end "\nPlease do not close the graphic widget"
            set aide "\n> "
            set compteur 0
            foreach item $otulist {
                incr compteur
                append aide "plot.convex.hull(c$compteur,add=T);"
            }
            r_rouge [string trimright $aide ";"]
        } else  {
            tk_messageBox -message "You did not enter the subdivision groups\nPlease close CLIC, restart and enter group sizes" -type ok
            wm deiconify .
            wm deiconify .bootmog
            return
        }
    }
    #
    set analyse "r_efa_set.txt"
    fiar $analyse
}

balloonhelp_for $fp.menus.ere "Use R!"

pack $fp.menus.ere -side left -fill x -expand yes
# --------------------------------------------------------------------------------------------------------

################################################################################
# set m1 [menu $fp.popupMenu1]
#
# #
# set m2 [menu $fp.popupMenu2]
# $m2 add command -label "HELP" -foreground "dark green" -command {}
# $m2 add command -label "-----------------------------"
# $m2 add command -label "PCA on size-scaled and aligned figures" -command {}
# $m2 add command -label "DA on size-scaled and aligned figures" -command {}
# #
# set m3 [menu $fp.popupMenu3]
# $m3 add command -label "HELP" -foreground "dark green" -command {
#     foghelp [file join $S(dirclic) "+/fogallometry_help.txt"]
# }
# $m3 add command -label "-----------------------------"
# $m3 add command -label "Size (quantile boxes)" -command {}
# $m3 add command -label "Perimeter / Area : correlation" -command {}
# $m3 add command -label "Perimeter Observed outlines / Estimated outlines : correlation"  -command {}
# $m3 add command -label "AREAS, Observed outlines / Estimated outlines : correlation"  -command {}
# $m3 add command -label "Allometry" -command {
# }
# #
# set m4 [menu $fp.popupMenu4]
# $m4   add command -label "HELP" -foreground "dark green" -command {}
# $m4 add command -label "-----------------------------"
# $m4   add command -label "SF tree: Neighbor Joining (PHYLIP, J. Felsenstein)" -command {}
# $m4   add command -label " ... Names for the OTUs (Treedyn, Chevenet)" -foreground blue -command {}
# $m4   add command -label " ... NJPLOT, Perriere & Gouy (1996) "  -foreground "blue" -command {}
# #
# set m5 [menu $fp.popupMenu5]
# $m5 add command -label "HELP" -foreground "dark green" -command {}
# $m5 add command -label "-----------------------------"
# $m5 add command -label "Estimated outlines" -command {}
# #
# # Create something to attach it to
# #
# frame $fp.f
################################################################################

#pack $fp.f $p -side top -fill both -expand yes
#pack [label $fp.f.l1 -text "FILE"] [label $fp.f.l2 -text "PCA / DA" -state disabled] [label $fp.f.l3 -text "SIZE" -state disabled] [label $fp.f.l4 -text "TREE" -state disabled] [label $fp.f.l5 -text "GRAPH" -state disabled]  -padx 50 -side left
# Arrange for the menu to pop up when the label is clicked
#bind $fp.f.l1 <1> {tk_popup $fp.popupMenu1 %X %Y}
#bind $fp.f.l2 <1> {tk_popup $fp.popupMenu2 %X %Y}
#bind $fp.f.l3 <1> {tk_popup $fp.popupMenu3 %X %Y}
#bind $fp.f.l4 <1> {tk_popup $fp.popupMenu4 %X %Y}
#bind $fp.f.l5 <1> {tk_popup $fp.popupMenu5 %X %Y}
#
pack $p -side bottom -fill both -expand yes


# |||||||||||||||||||||||||||||||||||||
#
# #
# Espace de nommage TREE - DEBUT
# #
#
# ||||||||||||||||||||||||||||||||||||||

#
namespace eval tree {
    #
    #
    #
    # Procedure TREE_NJ - debut
    #
    proc tree_nj {} {
        # -----------------------------------------------------------------------------
        # FENETRE PRESENTATION de la MATRICE (namespace TREE)
        # ------------------------------------------------------------------------------
        #
        global p S
        global infile x_subd x_total mdonnees
        global references version bID_Inter
        
        set subdivision $S(grupos)
        set pop [mrange $S(pafmatall) 1 end 0 end]
        # --------------------------------------------------------------------
        #
        # En principe
        #
        set fogmatmoy [description_silent $pop $subdivision];# renvoie la matrice des moyennes (fogmatmoy)
        #
        set matdist [euclid $fogmatmoy]
        #
        ##
        # Formater pour Phylip
        vert "\nEuclidean distances between rows, based on group means, PHYLIP formatted"
        set eucldist ""
        append eucldist " [mrows $matdist]"
        bleu "\n [mrows $matdist]"
        for {set i 0} {$i < [mrows $matdist]} {incr i} {
            if {$i <10} {
                append eucldist "\n_[expr {$i+1}]        [show [mrange $matdist 0 $i $i $i]]"
                bleu "\n_[expr {$i+1}]        [show [mrange $matdist 0 $i $i $i]]"
            } else {
                append eucldist "\n_[expr {$i+1}]       [show [mrange $matdist 0 $i $i $i]]"
                bleu "\n_[expr {$i+1}]       [show [mrange $matdist 0 $i $i $i]]"
            }
        }
        #
        # Enregistrement de la matrice des distances euclidiennes - format phylip
        set sub "_"
        set end ".txt"
        set quoi "EUCLphylip"
        set ajout $sub$quoi$end
        set S(infilesub) "[file root $infile]$ajout"
        #debug
        $p insert end "\n\n[file root $infile]\n\n"
        set fid [open $S(infilesub) w]
        $p insert end "Euclidian distances between rows, from \n$infile, \nhas been saved in \n$S(infilesub)"
        puts -nonewline $fid $eucldist
        close $fid
        #
        # --------------------------------------------------------------------
        $p see end
        
        
        
        # ce qui est ci-dessous est a changer, sauf sans doute 'arbol::phylip'
        
        ################################################################################
        #         ##
        ################################################################################
        global x_subd
        # les groupes (sous-matrices) seront rassembles dans une (super)liste x_subd
        #
        set S(grtree) $S(grupos)
        #set x_subd [arbol::description-procr $x_total $subdivision_tree];# <-- ??
        destroy .question
        tree::phylip
    }
    #
    # Procedure TREE_NJ - fin
    
    # Procedure PHYLIP - debut
    #
    proc phylip {} {
        #neighbor, from Phylip of J. Felsenstein
        
        global S p dossier infile tclplatform
        #tk_messageBox -message "ARBOL::PHYLIP pwd = $S(dirscript)" -type ok
        cd $S(dirscript);# on se place dans le dossier du script FOG
        
        if {[info exists infile]} {
            
            # Etape 1. se placer dans le dossier du module neighbor (cfr S(appel) en debut de FOG)
            
            # Etape 2 placer le fichier des distances dans le fichier infile du dossier du module (neighbor)
            #set dossierdumod [file join $S(dirscript) "+" "L" "infile" ]
            
            # S(infilesub) = la matrice des distances
            file copy -force $S(infilesub) $S(dossierdumod)
            
            #
            # 1. SE PLACER d'abord DANS le dossier du module Neighbor
            cd [file dirname $S(dossierdumod)]
            # appeler ALORS le programme externe, i.e. le module Neighbor
            eval $S(appel)
            #
            set outfile "[file dirname $S(dossierdumod)]/outfile"
            #
            $p insert end "\noutfile $outfile\n"
            set fid [open $outfile]
            set text [read -nonewline $fid]
            close $fid
            #
            # ATTENTION
            #
            # REVENIR ENSUITE AU DOSSIER DU SCRIPT
            #
            cd $S(dirscript)
            #
            $p insert end "\noutfile = \n$text"
            tree::vert "\n----------------------------------------\n"
            tree::vert "\n\n$infile \n"
            tree::vert "\n----------------------------------------\n"
        } else  {
            tk_messageBox -message "No previous analysis available"
        }
    }
    #
    # Procedure PHYLIP - fin
    
    
    
    # Procedure NJPLOTTE - debut
    #
    proc njplotte {} {
        global S p dossier infile references
        
        cd [file dirname $S(dossierdumod)];# on se place dans le dossier du script NJPLOT
        
        tk_messageBox -message "Please ask NJPLOT to open the file named \"treefile\" \
                \n(or \"outtree\" if you are Windows)" -type ok
        if {[info exists avis]} {affiche 170 50 $avis}
        
        $p insert end "\nnjplot as external software for CLIC, see: \n"
        bleu {Perrière, G. and Gouy, M. (1996) WWW-Query: An on-line retrieval system for biological sequence banks. Biochimie, 78, 364-369}
        $p insert end "\n"
        
        # Appel de njplot
        #
        eval $S(appelnjplotte)
        
        # On se replace dans le dossier du SCRIPT
        cd $S(dirscript)
        
        destroy .avis
    }
    #
    # PROCEDURE NJPLOTTE -FIN
    
    
    # PROCEDURE QUI - debut
    #
    proc qui {} {
        #
        global S p gr dossier infile references subdivision_tree
        set subdivision_tree $S(grupos)
        #
        cd $S(dirscript);# on se place dans le dossier du script MOG
        #
        set gr [llength $subdivision_tree]
        #
        $p insert end "\nUse of NewickTranslation procedure from TREEDYN (by Chevenet, IRD)\
                \nas external software for CLIC), see: \t"
        bleu {http://www.treedyn.org}
        $p insert end "\n"
        
        # Donner un nom a chaque OTU  - fichier d'annotations treedyn = S(filename1) = translat.txt -
        # ... puis remplacer le fichier "treefile" ou "outree"  - soit S(filename2) - par un fichier modifie
        # ... ... voir juste ci-dessous, la procedure NewickTranslation
        
        # Procedure NEWICKTRANSLATION - debut
        # proc NewickTranslation {filename1 filename2} {}
        proc NewickTranslation {} {
            #debug "NewickTranslation debut: filename $filename1 et filename2 $filename2"
            update
            flush stdout
            global S
            #tk_messageBox -message "filename1 $S(filename1) \nfilename2 $S(filename2) " -type ok
            # Fichier d'annotations (...) filename1 "+/L/translat.txt" <- non
            if [catch {open $S(filename1) r} fid] {
                puts stderr "Error Opening File"
            } else {
                #debug "Procedure NewickTranslation: filename1 $filename1 et filename2 $filename2"
                if {[catch {open $S(filename2) r} fid2]} {
                    puts stderr "Error Opening File"
                } else {
                    # Lecture du fichier d'annotations "+/L/translat.txt" <- non
                    set translation [read $fid]
                    #debug "translation (filename1 ... ou translat.txt) \n$translation"
                    #Lecture du fichier Newick
                    set source [read $fid2]
                    set source [regsub -all {\n} $source ""]
                    # Fichier modifie (portera le meme nom que le fichier source, cfr. target="")
                    set target "";#"_modif"
                    set S(FSPtransTF) $S(filename2)$target
                    set fidTARGET [open $S(FSPtransTF)  w]
                    # Translation ppt dite
                    foreach {val var trans} $translation {
                        set feuilleFrom [format "%s%s%s" "\\(" $val ":" ]
                        set feuilleVers [format "%s%s%s" "\(" [string toupper $trans] ":" ]
                        set trouve [regsub -- $feuilleFrom $source $feuilleVers source]
                        #debug "\n--feuilleFrom $feuilleFrom\n feuilleVers $feuilleVers\n trouve $trouve"
                        if {$trouve == 0} {
                            set feuilleFrom [format "%s%s%s" , $val : ]
                            set feuilleVers [format "%s%s%s" , [string toupper $trans] : ]
                            regsub  -- $feuilleFrom $source $feuilleVers source
                        }
                    }
                    puts $fidTARGET $source
                    close $fid
                    close $fid2
                    close $fidTARGET
                }
            }
        }
        #
        # Procedure NEWICKTRANSLATION - fin
        
        # Dialogue pour creer le fichier d'annotations 'translat.txt'
        proc dialogue {gr} {
            global S grp subdivision_tree
            #set grp [expr {$gr + 1}];# no se porque, pero $gr no es siempre adecuado, $subdivsion lo es ...
            set grp [expr {[llength $subdivision_tree] + 1}]
            #tk_messageBox -message "subdivision_tree = $subdivision_tree\nIl y a $grp ... ou [llength $subdivision_tree] ... groupes ?" -type ok
            # (Welsch, p.493)
            #
            # Erase previous naming
            #[file delete $S(filename1)]
            # Create a resizable toplevel window
            destroy .diatree
            toplevel .diatree
            set top .diatree
            set title "Naming OTUs"
            wm minsize $top 200 100
            wm title $top $title
            #Create a frame for buttons
            set f [frame $top.buttons -bd 4]
            button $f.quit -text "Cancel" -command "destroy $top"
            button $f.save -text "Save" -command {
                global group
                update
                set metainfo ""
                destroy .diatree
                for {set i 1} {$i < $grp} {incr i} {
                    set row($i) "Name \{ $v($i) \}"
                    append metainfo "_$i $row($i)\n"
                }
                #
                #[file delete $S(filename1)]
                #
                # OPEN THE FILE
                set fileid [open $S(filename1) w]
                # FILL THE FILE
                puts -nonewline $fileid $metainfo
                # CLOSE THE FILE
                close $fileid
                #arbol::NewickTranslation $S(filename1) $S(filename2)
                tree::NewickTranslation
            }
            pack $f.quit $f.save -side right
            pack $f -side top -fill x
            
            #Creating a scrolling canvas
            frame $top.c
            canvas $top.c.canvas -width 10 -height 10 \
                    -yscrollcommand [list $top.c.yscroll set]
            scrollbar $top.c.yscroll -orient vertical \
                    -command [list $top.c.canvas yview]
            pack $top.c.yscroll -side right -fill y
            pack $top.c.canvas -side left -fill both -expand true
            pack $top.c -side top -fill both -expand true
            
            tree::Scrolled_EntrySet $top.c.canvas $gr
            
        }
        
        proc Scrolled_EntrySet {canvas gr} {
            
            # (Welsch, p.493)
            #
            # Create one frame to hold everything and position it on the canvas
            set f [frame $canvas.f -bd 0]
            $canvas create window 0 0 -anchor nw -window $f
            
            # Dialogue pour creer le fichier d'annotations 'translat.txt'
            set grp [expr {$gr+1}]
            wm geometry .diatree +300+200
            for {set i 1} {$i < $grp} {incr i} {
                label $f.l_$i -text "Name(s) for Group $i"
                entry $f.g_$i  -textvariable v($i)
                grid $f.l_$i $f.g_$i
                grid $f.l_$i -sticky w
                grid $f.g_$i -sticky we
            }
            set child $f.g_1
            
            # Wait for the window to become visible and then ...
            
            tkwait visibility $child
            set bbox [grid bbox $f 0 0]
            set incr [lindex $bbox 3]
            set width [winfo reqwidth $f]
            set height [winfo reqheight $f]
            $canvas config -scrollregion "0 0 $width $height"
            $canvas config -yscrollincrement $incr
            set max $grp
            if {$max > 10} {set max 10}
            set height [expr {$incr * $max}]
            $canvas config -width $width -height $height
        }
        #
        # Procedure Scrolled_EntrySet -end
        
        dialogue $gr
        
        bind .diatree <Return> {
            update
            destroy .diatree
            set metainfo ""
            for {set i 1} {$i < $grp} {incr i} {
                set row($i) "Name \{ $v($i) \}"
                append metainfo "_$i $row($i)\n"
            }
            #tk_messageBox -message "$metainfo" -type ok
            #
            #if {[file exists $S(filename1)]} {set vide  [file delete $S(filename1)]}
            # OPEN THE FILE
            set fileid [open $S(filename1) w]
            # FILL THE FILE
            puts -nonewline $fileid $metainfo
            # CLOSE THE FILE
            close $fileid
            #arbol::NewickTranslation $S(filename1) $S(filename2)
            tree::NewickTranslation
        }
        #
    }
    #
    # Procedure QUI - fin
    
    
    
    # Procedure ENTRADA - start
    #
    proc entrada {pop infile} {
        
        global p references
        # En rouge on ecrit le commentaire du fichier de donnees
        tree::rouge "\n\n$infile \n"
        tree::rouge "\n$references\n"
        update
        set colonnes [mcols $pop]
        set lignes [mrows $pop]
        
        # En bleu on ecrit les premieres lignes et colonnes du fichier de donnees ...
        #bleu "\nArchivo contenido (parcialmente):"
        #$p insert end "\n[show [mrange $pop 0 [expr {$colonnes - 1} ] 0 4 ] ] \netc. \n"
        update
        #vert "\nSON LOS DATOS LOGARITMOS NATURALES ? \n"
        
        # ... et d'autres infos sur ce fichier
        tree::bleu "\nNumero de variables =\t"
        $p insert end "$colonnes\n"
        
        tree::bleu "\nNumero de individuos =\t"
        $p insert end "$lignes\n"
    }
    #
    # Procedure ENTRADA - fin
    
    
    ################### arbol::bleu ##### Procedure ## Debut ##
    proc bleu {mesg args} {
        global p
        $p insert end $mesg "bleu"
        $p tag configure bleu -foreground blue
    }
    
    ################### bleu ####### PROCEDURE ## FIN ###
    
    ################### rouge ##### Procedure ## Debut ##
    proc rouge {mesg args} {
        global p
        $p insert end $mesg "rouge"
        $p tag configure rouge -foreground red
    }
    
    ################### rouge ####### PROCEDURE ## FIN ###
    
    ################### vert ##### Procedure ## Debut ##
    proc vert {mesg args} {
        global p
        $p insert end $mesg "vert"
        $p tag configure vert -foreground "dark green"
    }
    
    ################### vert ####### PROCEDURE ## FIN ###
    
    # Procedure WHICHMATRIX - start
    #
    proc whichmatrix {} {
        global p infile dossier
        set typeList {
            {{"Text files"} {.txt .nts .TXT .NTS} }
        }
        set infile [tree::chemin];# usage de la procedure CHEMIN : memoire des dossiers anterieurs
        set x [tree::loadfile $infile]; # usage de la procedure LOADFILE
        
        if {$x != ""} {
            
            tree::entrada $x $infile;# usage de la procedure ENTRADA: presentation de la matrice loadee
            #$p insert end "\nMatrix X:\t----------------------------------start---\n"
            ##$p insert end [show $x %8.3f]
            #if {[mrows $x] < 30} {
            #    $p insert end "\n\n[show $x %8.3f]"
            #} else  {
            #    $p insert end "\n\n[show [mrange $x 0 end 0 29] %8.3f] \n...\netc. etc.\n"
            #}
            #$p insert end "\nMatrix X:\t----------------------------------end----\n\n"
        }
        return $x
    }
    #
    # Procedure WHICHMATRIX - end
    
    
    
    # Procedure CHEMIN -start
    #
    proc chemin {} {
        
        global p dossier
        
        if {[info exists dirinfile] == 0} {
            set dirinfile [pwd]
        }
        
        # ----------------------------------------------------
        # Nom du FICHIER et son CHEMIN (path) CORRESPONDANT
        # ---------------------------------------------------
        
        
        ################################################################################
        #         # Chercher le chemin dans un fichier de configuration
        #         # 1. verifier que le fichier de configuration existe
        #         set chemin "[pwd]/dossier_fog.txt"
        #         #puts "chemin $chemin"
        #         # 2. s'il n'existe pas, voir ci-dessus
        #         if {[file exists $chemin] == 0} {
        #             set candidat_dossier [pwd]
        #         } else  {
        #             #puts "La conf existe"
        #             # 3. s'il existe reccueillir le dernier chemin parcouru
        #             # open le fichier pour lire
        #             catch [
        #             set fid [open $chemin r]
        #             set candidat_dossier [read -nonewline $fid]
        #             close $fid
        #             ] ici
        #             #debug "candidat_dossier $candidat_dossier"
        #             set candidat_dossier [lindex [split $candidat_dossier \n] 1]
        #             #debug "dossier = $candidat_dossier"
        #         }
        ################################################################################
        
        
        # Chercher sa route dans un fichier de configuration: il y en a un dans le dossier FOG (chemin), et un dans le dossier CLIC (route)
        # dans le dossier MOG
        set chemin "[pwd]/dossier_fog.txt"
        # dans le dossier CLIC
        set route $S(dirclic)/dossier_CLIC.txt
        #
        # On lit d'abord le fichier dossier_CLIC, s'il existe
        # sinon
        # on lit le fichier du script, s'il existe
        #
        # 1. verifier que les fichiers de routage existent
        if {[file exists $route] == 0} {
            # dans le cas ou il n'y a pas de fichier de routage dans le dossier CLIC
            set candidat_dossier_CLIC [pwd]
            catch [
            set fid [open $route w+]
            puts -nonewline $fid "Dernier dossier de donnees:\n"
            puts -nonewline $fid [pwd]
            close $fid
            ] ici
        } else  {
            # 3. si le fichier de routage existe dans le dossier CLIC, reccueillir alors le dernier chemin parcouru
            # open le fichier pour lire
            catch [
            set fid [open $route r]
            set candidat_dossier_CLIC [read -nonewline $fid]
            close $fid
            ] ici
            set candidat_dossier_CLIC [lindex [split $candidat_dossier_CLIC \n] 1]
            #debug "\ndossier selon CLIC = $candidat_dossier_CLIC"
        }
        
        #debug "chemin $chemin"
        # 2. s'il n'existe pas, voir ci-dessus
        if {[file exists $chemin] == 0} {
            set candidat_dossier [pwd]
        } else  {
            # 3. si le fichier de routage du MODULE existe reccueillir le dernier chemin parcouru
            # open le fichier pour lire
            catch [
            set fid [open $chemin r]
            set candidat_dossier [read -nonewline $fid]
            close $fid
            ] ici
            set candidat_dossier [lindex [split $candidat_dossier \n] 1]
            #debug "\ndossier selon FOG: $candidat_dossier ... dossier selon CLIC = $candidat_dossier_CLIC"
        }
        
        #debug "si le dossier_CLIC n'est pas le dossier en cours (CLIC_XX): $candidat_dossier_CLIC"
        # A present, on a le choix entre candidat_dossier_CLIC et candidat_dossier
        if {$candidat_dossier_CLIC != [pwd]} {
            #debug "si le dossier_CLIC n'est pas le dossier en cours (CLIC_XX)"
            set candidat_dossier $candidat_dossier_CLIC
        } else  {
            # sinon, on adopte le candidat_dossier
        }
        
        
        
        
        # On va chercher les donnees
        
        set typeList {
            {{"Text files"} {.txt .nts .TXT .NTS} }
        }
        set infile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
        
        #infile contient le chemin et le nom du fichier des donnees
        set dossier "[file dirname $infile]/";#repertoire des donnees
        
        # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
        if {$dossier != $candidat_dossier} {
            # open le fichier de conf pour ecrire
            catch [
            set fid [open $chemin w+]
            puts -nonewline $fid "Dernier dossier de donnees utilisees par COV:\n"
            puts -nonewline $fid $dossier
            close $fid
            ] ici
            # open le fichier de routage pour ecrire
            catch [
            set fid [open $route w+]
            puts -nonewline $fid "Dernier dossier de donnees :\n"
            puts -nonewline $fid $dossier
            close $fid
            ] ici
        }
        
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        
        # --------------------------------------------------------
        # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE pop
        # --------------------------------------------------------
        return $infile
    }
    #
    # Procedure CHEMIN - end
    
    
    # PROCEDURE loadfile - DEBUT
    #
    proc loadfile {pathname} {
        
        if {$pathname != ""} {
            global S
            set S(dist_nopar) 0
            set S(datadir) $pathname
            #
            # OPEN
            set fid [open $pathname]
            # READ
            set text [read -nonewline $fid]
            # CLOSE
            close $fid
            #
            # Converting to HUME matrix
            set rowcount 0
            set colcount 0
            global references
            set compteur 0
            set lignes 0
            set data ""
            foreach line [split $text \n] {
                incr compteur
                if {$compteur >1} {
                    if  {$line != ""} {
                        set colcount [llength $line]
                    }
                }
                if {$compteur>1} {
                    foreach item [split $line] { if {$item != ""} {
                            incr lignes
                            append data "[string trim $item]\t"
                        }
                    }
                } else {set references $line}
            }
            set rowcount [expr {$lignes / $colcount}]
            set result [concat 2 $rowcount $colcount $data]
            #debug
            #puts "Commentaire brut :\n$references"
            # -- Formater le commentaire
            # -- 1. Enlever d'eventuelles tabulations
            foreach mot $references {
                if {$mot != ""} {
                    append comentario_sin_tab "$mot "
                }
            }
            set references $comentario_sin_tab
            set S(references) $references
            # -- FIN du formatage de la premiere ligne
            return $result
        }
    }
    #
    # PROCEDURE loadfile - FIN
    
}
# |||||||||||||||||||||||||||||||||||||
#
# #
# Espace de nommage TREE - FIN
# #
#
# ||||||||||||||||||||||||||||||||||||||



# ||||||||||||||||||||||||||||||||||||||
#
# #
# MOGADISCIO - debut de l'espace de nommage
# #
#
#|||||||||||||||||||||||||||||||||||||||

namespace eval mogadiscio {
    
    global S
    
    # Procedure MAHALA - debut
    #
    proc mahala {pop gr lignes colonnes effectifs popones} {
        
        # pop -> contient la matrice des donnees;
        # gr -> contient le nombre de groupes;
        # lignes et colonnes -> se referent a la matrice des donnees
        # effectifs -> est une liste des effectifs de chaque groupe, \
        #    dans l'ordre de la matrice des donnees;
        # popones est une liste de 1, autant que de colonnes.
        
        global mogad_p distperm
        
        set listeW "2 $lignes $colonnes"
        set listeW [lreplace $listeW 0 end]
        
        # - - - - - - - - - - - - - - - - - - - - - - -
        # SEPARER LA MATRICE DE CHAQUE GROUPE
        # - - - - - - - - - - - - - - - - - - - - - - -
        
        set correction 0
        set moyennes "";#mogaddiction March 2009
        foreach item [split $effectifs] {
            set correction [expr $correction + $item]
            set newpop [mrange $pop 0 [expr $colonnes-1] \
                    [expr $correction - $item] [expr $correction - 1]]
            # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
            if {$item > 1} {
                mnorms_br newpop newpopmeans newpopsigmas
            } else  {
                set newpopmeans $newpop
            }
            # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
            set partZ [mnormalize $newpop $newpopmeans $popones]
            # STOCKER LA MATRICE CENTREE SUR LE GROUPE DANS LA LISTE preplisteW
            # QUI COMPOSERA LA FUTURE MATRICE des donnees CENTREES listeW
            set preplisteW "";#mogaddiction March 2009
            foreach item [split $partZ] {
                lappend preplisteW $item
            }
            # effacement des indices matriciels de prepliste
            # (une matrice par groupe)
            set preplisteW [lreplace $preplisteW 0 2]
            # ce qui suit est une sorte de lappend
            set listeW [concat $listeW $preplisteW]
            # mise a zero de prepliste
            set preplisteW [lreplace $preplisteW 0 end]
            # PREPARER LA FUTURE MATRICE DES MOYENNES / GROUPE
            set newpopmeans [lrange $newpopmeans 3 end]
            foreach item [split $newpopmeans] {lappend moyennes $item}
            #voir ensuite ligne 398 # ECRITURE ...
        }
        
        # -----------------------------------------------------------
        # CONSTRUCTION FINALE DE LA MATRICE listeW (donnees centrees)
        # -----------------------------------------------------------
        set listeW [concat 2 $lignes $colonnes $listeW]
        
        # ----------------------------------------------------------
        # Matrice des variances-covariance covW de la matrice listeW
        # ----------------------------------------------------------
        # MATRICE des VARIANCES - COVARIANCES 'within'
        set covW [mmult [transpose $listeW] $listeW]
        
        # ------------------------------------------------------------"
        #     Matrice W (ou E, cfr. JMP et SAGE) = covW corrigee \
        #            en fonction des degres de liberte (lignes - groupes)
        # ------------------------------------------------------------"
        set corrddl [expr {1.0 / ($lignes - $gr)}]
        set W [mscale $covW $corrddl]
        
        # ECRITURE DE LA MATRICE DES MOYENNES DE CHAQUE GROUPE
        set Moy "2 $gr $colonnes"
        # pour accueillir dans une matrice Moy la liste des moyennes
        # (UNE LISTE, PAS UNE MATRICE)
        foreach item [split $moyennes] {lappend Moy $item}
        
        #puts "----------------------------"
        #puts " On va inverser la matrice W"
        #puts "----------------------------"
        set iW [msolve $W [mident $colonnes]]
        
        # ------------------------------------------------------
        # Matrice de la difference des moyennes des deux groupes
        # ------------------------------------------------------
        # S'il y a plus de deux groupes
        set compteur 0
        for  {set i 0} {$i < [expr {$gr-1}]} {incr i} {
            for  {set j [expr {$i+1}]} {$j < $gr} {incr j} {
                incr compteur
                set a [transpose [mrange $Moy 0 end $i $i]]
                set b [transpose [mrange $Moy 0 end $j $j]]
                set mmd($compteur) [msub $a $b]
                
                set mdt [transpose $mmd($compteur)]
                set mdtC [mmult $mdt $iW]
                set mdtCmd [mmult $mdtC $mmd($compteur)]
                set maha [expr {sqrt([lindex $mdtCmd 3])}]
                lappend distperm "$maha"
                lappend distmaha "$maha"
                #debug
                #$mogad_p insert end "\nThe Mahalanobis distance between groups \
                #        [expr {$i+1}] and [expr {$j+1}]\
                #       \t$maha"
            }
        }
        return $distmaha
    }
    
    #
    # Procedure MAHALA - fin
    
    # Procedure varCCC - debut
    #
    proc varccc {poudre} {
        
        # Au cas ou varccc est appelee depuis la procedure pause_out
        global pause
        
        # la POUDRE contient la matrice de donnees initiales \ ou les premieres composantes principales utiisees pour l'AD
        #(mais attention, elle contient la premiere ligne d'informations)
        set compteur 0
        set explosif ""
        
        # Creer une liste de sublistes (chaque individu est une subliste) : EXPLOSIF
        foreach line [split $poudre \n] {
            if {$compteur > 0} {
                lappend explosif $line
            } else  {
                set references $line
            }
            if {$line != ""} {incr compteur}
        }
        # l'explosif contient les donnees initiales, ou leurs quelques premieres CP, mais sous une forme differente: une liste de sublistes
        #debug "poudre = \n$poudre\net\nexplosif = \n$explosif\n"
        varcrochecla $poudre $explosif
    }
    #
    # Procedure varCCC - fin
    
    
    # procedure varCROCHECLA - debut
    #
    proc varcrochecla {poudre explosif} {
        
        # Il faudra construire you et lessyou a chaque AD - voir plus bas
        # 'you' , l'individu qu'on enleve; 'lessyou' , les donnees sans cet individu
        
        global S
        global infile end gr lignes colonnes effectifs wiwi ladistance references
        global indiv_lessindiv caillou newdir mogad_p cccindiv
        
        # pour stopper la validation
        set S(stopvalidation) 0
        
        # ajout en vue de la pause - debut
        global pause effectifs_base cccindiv
        #
        global td
        set td "";# pcq il y a un 'append td' plus bas ...
        #
        set effectifs_base $effectifs
        if {[info exists pause] == 0} {set pause 0}
        # ajout en vue de la pause - fin
        
        set caillou $pause;# devrait servir a suivre l'addition des absents, i.e. des individus qui sont en voie de classement
        
        
        # autre petite fenetre de suivi
        destroy .cccabs
        toplevel .cccabs
        wm geometry .cccabs 319x30+350+410
        button .cccabs.buttxt -text "Cross validated classification"
        # Ce qui suit parce que le bouton perd de vue la poudre
        global polvo
        set polvo $poudre
        button .cccabs.butpause -fg red -text "Stop" -command {
            global p
            #pause_in $polvo
            set hey [tk_messageBox -message "Quit the validated classification ?" -type yesno]
            if {$hey == yes} {
                mogadiscio::rouge "\n\nCross Check Classification: interrupted by the user.\n"
                global S(stopvalidation)
                set S(stopvalidation) 1
            }
        }
        pack .cccabs.buttxt .cccabs.butpause -side left -fill both -expand 1
        #pack .cccabs.buttxt -side left -fill both -expand 1
        
        
        set indiv_lessindiv 1
        
        # Pour ne pas calculer le Wilks a chaque cycle
        set wiwi 0
        # Pour calculer les distances a chaque cycle
        set ladistance 1
        
        # Le nombre de lignes sera reduit de un
        set ccclignes [expr {$lignes-1}]
        
        # CREER n-1 POUR CALCULER (plus tard) LES eigenvalues
        set obsminusone [expr {$ccclignes - 1}]
        
        # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
        set cccpopones "2 1 $colonnes 1"
        set x 1
        set y $colonnes
        while {$x < $y} {lappend cccpopones 1; set x [expr $x + 1]}
        
        # Preparation d'une matrice des distances qui seront calculees
        set nbdist [expr {(($gr * $gr) - $gr) / 2}]
        
        rouge "\n\nCross Check Classification\n---------------------------"
        
        $mogad_p insert end "\n(cada individuo clasificado no hizo parte del analisis discriminante)\n\
                each assigned individual did not make part of the discriminant analysis\n"
        $mogad_p see end
        # -------------------------
        # LA GRANDE BOUCLE COMMENCE
        # ----------------------------------------
        # A chaque individu retire, on fait une AD
        # Hmmm...
        # ----------------------------------------
        #
        #aa "pause = $pause"
        # ce 'set i 0' pourrait devenir set i $pause, avec pause = 0 si le bouton n'a pas ete presse, pause = ex $i dans le cas contraire
        for  {set i $pause} {$i < $lignes} {incr i} {
            update idletask
            global S
            if {$S(stopvalidation) == 1} {break}
            ## Il faut a chaque boucle recreer le bouton pause, pour qu'il assimile le numero de l'individu
            #destroy .cccabs.butpause
            #button .cccabs.butpause -text "pause" -command "pause_in [list $poudre $explosif $i]"
            #pack .cccabs.buttxt .cccabs.butpause -side left -fill both -expand 1
            
            
            # Le format des donnees doit etre en matrice Hume
            #
            #debug "On est dans la matrice ... heu dans la grand boucle, i vaut $pause ???"
            # L'individu est une subliste
            set you [lindex $explosif $i]
            # le nombre d'elements de cette subliste est le nombre de variables, a savoir le nombre de colonnes.
            set ccccol [llength $you]
            set you [concat 2 1 $ccccol $you]
            # Les donnees sans cet individu sont
            #debug "POUDRE\n$poudre"
            set boulier 0
            foreach line [split $poudre \n] {
                if  {$boulier != $i} {
                    append lessyou "[lindex $explosif $boulier] "
                }
                incr boulier
            }
            #debug "LESSYOU \n$lessyou"
            # la variable ccclignes definie avant la grande boucle
            set cccpop [concat 2 $ccclignes $ccccol $lessyou]
            unset lessyou
            
            
            # Il faut redefinir les effectifs de chaque groupe (ccceffectifs)
            # a chaque analyse, puisqu'un individu est enleve
            
            # 1_ D'abord savoir a quel groupe (id) appartient l'individu enleve
            set ccceffectifs ""
            set halte 0
            set eff(0) [lindex $effectifs 0]
            # Effectifs cumules dans une variable indicee
            for {set j 1} {$j < $gr} {incr j} {
                set eff($j) [expr {[lindex $effectifs $j] + $eff([expr {$j-1}])}]
            }
            
            #debug
            #puts  "Varcrochecla Ou placer l'individu $i = $pause ???"
            
            # Examen: ou placer l'individu i ?
            for  {set j [expr {$gr-1}]} {$j > -1} {incr j -1} {
                if {$halte == 0} {
                    if {$i > $eff($j)} {
                        set id [expr {$j+1}]
                        set halte 1;# pour interrompre l'examen
                    }
                }
            }
            if {$i < $eff(0)} {set id 0}
            
            # 2_ Ensuite reduire de 1 la taille de ce groupe, on obtient ccceffectifs
            set ccceffectifs [lreplace $effectifs $id $id [expr {[lindex $effectifs $id]-1}]]
            
            
            # Calcul de la matrice totale des covariances ccc_covT
            # MOYENNES ET DEVIATIONS STANDARD DES VARIABLES
            mnorms_br cccpop cccpopmeans cccpopsigma
            #$mogad_p insert end "\n\nGrand Means [show $cccpopmeans %8.12f]"
            
            # ----------------------------------------
            # MATRICE VAR - COVAR de la MATRICE TOTALE
            # ----------------------------------------
            # obsminusone, cree plus haut, en dehors de la boucle
            # cccpopones, voir ci-dessus, en dehors de la boucle
            
            # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
            set Z [mnormalize $cccpop $cccpopmeans $cccpopones]
            
            # MATRICE des VARIANCES - COVARIANCES
            set ZZ [mmult [transpose $Z] $Z]
            set ccc_covT $ZZ
            #puts "Matrice totale des variances - covariances \n$covT"
            update
            flush stdout
            #puts "Cycle $i: var-cov totale OK"
            
            # Appel a la procedure vardiscrimin pour cccpop
            #
            append td "[
            varcccdiscrimin $you $i $cccpop $cccpopmeans $cccpopsigma $cccpopones $gr $ccclignes $colonnes $ccceffectifs $ccc_covT
            ] "
            # je note que colonnes pourrait ici etre remplace par ccccol, ai-je raison ?
        }
        
        if {$S(stopvalidation) == 0} {
            
            # ---------------------------------------------
            # Apres les $lignes cccdiscrimin, les resultats
            # ---------------------------------------------
            update
            flush stdout
            # PRESENTATION GLOBALE DES RESULTATS de la CLASSIFICATION
            # le classement des individus se trouve dans la variable indicee cccindiv(i)
            #puts "gr = $gr"
            rouge "\n\n-----------------------\n"
            rouge "\nCross Checked Classification\n"
            rouge "\nCada individuo clasificado es un dato externo al analisis inicial\n"
            rouge "\nFirst Correct attributions\n"
            rouge "\n------------------------\n"
            set pul 0
            # NOTE
            # 'pul' doit (vraiment) etre nul car on fait ici des calculs sur la table cccindiv()
            # cette table doit donc etre reconstituee en cas de pause_out
            for {set g 0} {$g < $gr} {incr g} {set corrattrOne($g) 0}
            for {set g 0} {$g < $gr} {incr g} {
                
                for  {set i $pul} {$i < [ expr { $pul+[lindex $effectifs $g] } ] } {incr i} {
                    set sel [lindex $cccindiv($i) 0]
                    #debug "i = $i et sel = $sel"
                    if {$sel == [expr {$g+1}]} {
                        incr corrattrOne($g)
                    }
                }
                set pul [ expr { $pul+[lindex $effectifs $g] } ]
            }
            # lecture des resultats
            for  {set g 0} {$g < $gr} {incr g} {
                update
                flush stdout
                $mogad_p insert end "\nPop [expr {$g+1}] : $corrattrOne($g) / [lindex $effectifs $g]\t\
                        ([expr {int($corrattrOne($g)*1.0/[lindex $effectifs $g]*100)}]%)"
            }
            flush stdout
            rouge "\n------------------------\n\n"
            
            ## DISTANCES
            #
            update idletask
            flush stdout
            $mogad_p insert end "\n\n------------------------\nTable des distances\
                    \n------------------------\n\n"
            $mogad_p insert end "Distancias generadas para cada analisis discriminante,\
                    \ncada una con un individuo menos (el individuo que se clasifica despues - ver arriba).\
                    \n\nLa primera columna es la distancia entre 1 y 2, la segunda entre 1 y 3, etc. : \
                    \nEj. con 4 poblaciones; 1-2 1-3 1-4 2-3 2-4 3-4\n\
                    \nEsta tabla da una idea de la variacion estadistica de las distancias de Mahalanobis\
                    \n(ver promedios y desviaciones bajo la tabla).\n\n"
            set tddebut "2 $lignes $nbdist "
            set td $tddebut$td
            #debug
            #puts "varcrochecla: longueur de td [llength $td]\n$td"
            
            $mogad_p insert end "\n[show $td  %8.3f]"
            $mogad_p insert end "\n"
            mnorms_br td tdmeans tdsigmas
            $mogad_p insert end "\n\n- - - - - - - - - - - - - ...\n"
            bleu "Moyennes"
            $mogad_p insert end "\net\n"
            vert "ecart types\n\n"
            bleu [show $tdmeans  %8.3f]
            $mogad_p insert end "\n- - - - - - - - - - - - - ...\n"
            vert [show $tdsigmas  %8.3f]
            $mogad_p insert end "\n- - - - - - - - - - - - - ...\n"
            destroy .cccabs
            $mogad_p see end
        } else  {
            destroy .cccabs
        }
    }
    #
    # procedure varCROCHECLA- fin
    
    
    ### procedure VARcccdiscrimin ## debut
    #
    proc varcccdiscrimin {you absent pop popmeans popsigma popones gr lignes colonnes effectifs covT} {
        
        
        # Individu (you) et donnees sans lui (lessyou) sont au format de matrice Hume
        # Ici, pop est cccpop ou alors lessyou, popmeans est cccpopmeans, etc.
        
        if {[info exists tabdis]} {unset tabdis}
        if {[info exists sortdis]} {unset sortdis}
        global mogad_p distperm wiwi ladistance caillou newdir cccindiv adda_gr
        set B "2 $gr $colonnes"
        set listeW "2 $lignes $colonnes"
        set listeW [lreplace $listeW 0 end]
        
        update
        
        # Les distances de Mahalanobis sont calculees ('mahala' au lieu de 'gendist')
        # pour le jacknife final
        # EN FAIT JE POURRAIS LES RETIRER DE L'ETAPE SUIVANTE
        # (cfr. return en fin de procedure, qui accumule 'mahalanobis' dans 'td' de crochecla)
        set mahalanobis [mahala $pop $gr $lignes $colonnes $effectifs $popones]
        #debug
        #$p insert end "\nApres varcccdiscrimin_1 -> mahala, retour de 'mahalanobis' \n$mahalanobis"
        
        # -------------------------------------------------
        # IL FAUT A PRESENT TESTER L'INDIVIDU ABSENT -debut
        # -------------------------------------------------
        incr caillou
        .cccabs.buttxt configure -text "Cross Checked Classification: $caillou / [expr {$lignes+1}]"
        balloonhelp_for .cccabs.buttxt "Cada individuo clasificado es un analisis discriminante diferente en la cual el individuo no participa."
        update
        flush stdout
        ## -----------------------------------------------
        ## nom de l'individu retire des donnees
        ## -----------------------------------------------
        set adda $you
        
        # ---------------------------------------------------------------
        # Quelques STATISTIQUES sur la matrice des donnees additionnelles
        # ---------------------------------------------------------------
        set adda_colonnes [mcols $adda]
        set adda_lignes [mrows $adda]
        
        
        # 'ccceffectifs' est dans 'effectifs' pour cette procedure !
        lappend effectifs $adda_lignes
        
        # Pas de CCC si shape analysis, du moins a ce stade
        set taco 0;# 'taco' pour 'tamano - conformacion'
        # -------------
        set adda_pop [join_rows $pop $adda]
        set tot_colonnes [mcols $adda_pop]
        set tot_lignes [mrows $adda_pop]
        
        set adda_gr [expr $gr + $adda_lignes]
        set base_gr $gr
        set gr $adda_gr
        
        #debug
        #puts "adda $adda\nadda_colonnes $adda_colonnes\tadda_lignes $adda_lignes\teffectifs $effectifs\
        ##         \nbase_gr $base_gr\tadda_gr $adda_gr"
        
        #$mogad_p insert end "\nApres varcccdiscrimin_2 -> gendist, retour de 'tot_distobs' \n$tot_distobs"
        #debug ============================================ passage a MAHALA ? ====== Debut
        set generalized [mahala $adda_pop $adda_gr $tot_lignes $tot_colonnes $effectifs $popones]
        # QUAND UN GROUPE EST COMPOSE D'UN SEUL INDIVIDU,
        # LA VALEUR ABSOLUE DE LA DISTANCE DE CHAQUE GROUPE AVEC CET INDIVIDU EST INEXACTE,
        # MAIS LES VALEURS RELATIVES SONT CONSERVEES EXACTEMENT
        # et GENERENT UNE CLASSIFICATION ABSOLUMENT CORRECTE ...
        # pop -> contient la matrice des donnees;
        # gr -> contient le nombre de groupes;
        #  et tot_colonnes = lignes et colonnes -> se referent a la matrice des donnees
        # effectifs -> est une liste des effectifs de chaque groupe, \
        #    dans l'ordre de la matrice des donnees;
        # tot_ones = popones est une liste de 1, autant que de colonnes.
        
        #debug
        #$mogad_p insert end "\nApres varcccdiscrimin_2 -> mahala, retour de 'generalized' \n$generalized"
        # ================================================= passage a MAHALA ? ====== Fin
        
        set new_lignes $adda_gr
        
        # PREPARATION DU BILAN DES DISTANCES - debut
        #
        # IDENTIFICATION DES UNKNOWN
        
        #puts "\ntabdis(i,j) avec i ou j = $new_lignes\ngr = $base_gr\n\n"
        set long [llength $generalized]
        set passage -1
        set compteur 0
        for {set i 0} {$i < $long} {incr i} {
            incr passage
            for  {set k 1} {$k < [expr {$new_lignes - $passage}]} {incr k} {
                #set maha [lindex $tot_distobs $compteur]
                # essaigeneralized
                set maha [lindex $generalized $compteur]
                set a [expr $i+1]
                set b [expr $i+$k+1]
                set compteur [expr $compteur + 1]
                #puts "\nEntre _$a et _$b:\t[format %3.2f $maha]"
                if {$a < [expr {$base_gr+1}]} {
                    if {$b > $base_gr} {
                        set tabsortdis($a,$b) $maha
                    }
                }
                set tabdis($i,[expr $i+$k]) $maha
            }
        }
        #puts "\nadda_gr = $adda_gr\n"
        for  {set j [expr {$base_gr+1}]} {$j < [expr {$adda_gr+1}] } {incr j} {
            for  {set i 1} {$i < [expr {$base_gr+1}]} {incr i} {
                #puts "tabsortdis($i,$j) $tabsortdis($i,$j)"
                append sortdis($j) "$tabsortdis($i,$j) "
                #puts "sortdis($j) ===== $sortdis($j)"
            }
        }
        
        # Premier groupe possible (premiere identification)
        for  {set j [expr {$base_gr+1}]} {$j < [expr {$adda_gr+1}] } {incr j} {
            #puts "\n$sortdis($j)\n"
            set ordre [lsort -real $sortdis($j)]
            set min [lindex $ordre 0]
            for  {set k 0} {$k < $base_gr} {incr k} {
                #puts "Comparer min = $min ET lindex sortdis(j) $k = [lindex $sortdis($j) $k]"
                if {$min == [lindex $sortdis($j) $k]} {
                    #$mogad_p insert end "\nUnknown $j assigned to group [expr {$k+1}]"
                    append id_unknown($j) "[expr {$k+1}]"
                }
            }
        }
        # Deuxieme groupe possible (deuxieme identification)
        for  {set j [expr {$base_gr+1}]} {$j < [expr {$adda_gr+1}] } {incr j} {
            #puts "\n$sortdis($j)\n"
            set ordre [lsort -real $sortdis($j)]
            set suivant [lindex $ordre 1]
            for  {set k 0} {$k < $base_gr} {incr k} {
                if {$suivant == [lindex $sortdis($j) $k]} {
                    #$mogad_p insert end "\nUnknown $j assigned to second group [expr {$k+1}]"
                    append id_unknown($j) " , [expr {$k+1}]"
                }
            }
        }
        
        for  {set j [expr {$base_gr+1}]} {$j < [expr {$adda_gr+1}] } {incr j} {
            # a changer
            rouge "\nindividual [expr {$absent+1}] :\t$id_unknown($j)"
            flush stdout
            append cccindiv($absent) $id_unknown($j)
        }
        
        # PREPARATION DU BILAN DES DISTANCES - FIN de l'IDENTIFICATION des UNKNOWN
        
        # ----------------------------------
        # POSITION DE L'INDIVIDU ABSENT -fin
        # ----------------------------------
        #debug
        #puts $mahalanobis
        return $mahalanobis
    }
    #
    # Procedure varCCCdiscrimin - fin
    
    # procedure CLASSIFICATION ... - Debut
    #
    proc classification {pop C taco moyennes gr mogad_p lignes inutile args} {
        #
        # EXPLICATIONS --------------------------------------------------------------------------
        # pop      -> donnees;
        # C        -> vecteurs canoniques, utiles en cas de donnees supplementaires\
        #        'C = EE*', avec 'E*' ajuste a 1\
        #        'mmult $pop $C'        nous donne les facteurs canoniques - cfr. etape 7/10\
        #        'mmult $tot_MoyC $C'   nous donne les scores canoniques ('cansco') - cfr. etape 9/10
        # taco     -> 0 signifie que l'analyse inclut la taille; taco = 1 pour passer par une ACP
        # moyennes -> les moyennes de chaque groupe;
        # gr       -> le nombre de groupes pour l'analyse discriminante;
        # mogad_p  -> je crois que c'est le widget texte pour le rapport de l'analyse (.debut);
        # lignes   -> le nombre total d'individus;
        # inutile  -> se refere aux composantes de conformation inutilisees.
        # -----------------------------------------------------------------------------------------
        #debug "pop\n$pop avec [mcols $pop] colonnes \nC\n$C\nmoyennes $moyennes\n gr\n$gr\nmogad_p\n$mogad_p\nlignes\n$lignes\ninutile\n$inutile"
        global S
        global adda_lignes base_gr CoeffShapeACP cpmeans perper sentier
        global infile end
        global references ouaip classification
        
        # Enlever les curved brackets
        global effectifs
        if {[info exists efectifs]} {
            #tk_messageBox -message "La variable \"effectifs\" existe" -type ok
            set effectifs [regsub -all {\{|\}} $effectifs ""];# pour FOG
        } else  {
            set effectifs [regsub -all {\{|\}} $args ""];# pour FOG
            #tk_messageBox -message "La variable \"effectifs\" n'existe PAS !!!, on vient de la charger: \neffectifs  = $effectifs" -type ok
        }
        
        
        
        #debug
        $mogad_p insert end "\n+++++++++\nclassification \n+++++++\ngr = $gr\
                \npop Rows = [mrows $pop] Cols = [mcols $pop]\ninfile = $infile"
        $mogad_p see end
        append references "\tDatos externos:\t"
        
        # -------------------------------------------------------------
        # La matrice adda_infile contient a nouveau les memes specimens
        # -------------------------------------------------------------
        set namefile [file rootname $infile];# ajout discriminatoire
        set end $end;# ajout discriminatoire
        set inputfile $namefile$end;# ajout discriminatoire
        #
        set adda_infile $inputfile;# le fichier des donnees supplementaires est le fichier initial
        #debug "Le fichier des donnees supplementaires est le fichier initial ? \n cfr $inputfile"
        if {$adda_infile == $inputfile} {set ouaip 1};# ca sert a quoi ca ? ouaip est un drapeau !
        
        # --------------------------------------------------------
        # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE adda <- ce n'est plus le cas ici (FOG)
        # --------------------------------------------------------
        #set adda [loadfile "$adda_infile"]
        #debug "\n$adda"
        # -----------------------------------------------------------------------------------------------------
        # On prend S(damat), le nombre de variable a peut-etre en effet ete reduit <- FOG
        # -----------------------------------------------------------------------------------------------------
        set adda $S(damat)
        # -----------------------------------------------------------------------------------------------------
        # S(damat) est defini dans daotl_sf ou daotl_si  <- FOG
        # -----------------------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------
        # Quelques STATISTIQUES sur la matrice des donnees re-entrees
        # -----------------------------------------------------------
        set adda_colonnes [mcols $adda]
        set adda_lignes [mrows $adda]
        
        $mogad_p insert end "\n\
                \n-----------------------------------------------------\
                \nClasificacion de los $adda_lignes individuos analizados\
                \n-----------------------------------------------------"
        
        set base_effectifs $effectifs
        lappend effectifs $adda_lignes
        # Attention, la variable 'effectifs' ne contient pas le nombre d'individus,
        # elle contient la liste des echantillons de chaque groupe
        # (l'echantillon du dernier groupe est celui des donnees additionnelles,
        # ici, puisqu'il s'agit d'une re-classification, il s'agit du total des individus
        #  de la matrice initiale des donnees).
        
        # -------------
        # redefinir pop
        if {$taco == 1 && $S(aligned) == 0 && $S(pw) == 0} {
            # changer les donnees additionnelles en variables de conformation
            # je crois : set adda_pop $pop; lappend adda_pop $adda
            # refaire une ACP sur les variables de conformation (adda_pop)
            # ... ou alors creer les composantes a partir des coefficients \
            # deja calcules pour C
            # se retouver avec des COMPOSANTES de conformation
            # en retenir le meme nombre que pour l'analyse principale
            
            #===================== programmation en cours ======= debut
            global prepop
            # Une matrice adda_pop contenant les variables initiales de l'analyse princeps
            # et les donnees additionnelles de la matrice adda
            set adda_pop [join_rows $prepop $adda]
            
            #$mogad_p insert end "\n+-+-+-+-+-+-+-+-+-+-+-+-+-+-+"
            #$mogad_p insert end "\n Etapa 1 : datos addicionales como variables de conformacion"
            #$mogad_p insert end "\n Etapa 2 : datos addicionales como componentes de conformacion"
            #$mogad_p insert end "\n Etapa 3 : analisis discriminante - individuos addicionales como grupos"
            #$mogad_p insert end "\n-+-+-+-+-+-+-+-+-+-+-+-+-+-+-"
            
            set lignes_adda_pop [mrows $adda_pop]
            set colonnes [mcols $adda_pop]
            set transpop [transpose $adda_pop]
            mnorms_br transpop transpopmeans transpopsigmas
            # Pour creer la matrice SHAPEPOP des VARIABLES de CONFORMATION
            # ---------------------------------------------------
            # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE D'INDIVIDUS ...
            set ligones "2 1 $lignes_adda_pop 1"
            set x 1
            set y $lignes_adda_pop
            while {$x < $y} {lappend ligones 1; set x [expr $x + 1]}
            set confpop [mnormalize $transpop $transpopmeans $ligones]
            set shapepop [transpose $confpop]
            # pour le rapport ecrit
            set shapeVAR "\nVARIABLES DE CONFORMACION (todos los individuos)\
                    \n[show $shapepop]\n"
            # ---------------------------------------------------------------
            # la matrice de conformation shapepop contient les donnees additionnelles
            # d'ou lignes_adda_pop au lieu de lignes
            set adda_conf [mrange $shapepop 0 end $lignes end]
            #$mogad_p insert end "\nIndividus nouveaux en variables de conformation\n [show $adda_conf]\n"
            #$mogad_p insert end "\nIndividus precedents en composantes [show $pop]\n"
            set adda_comp [mmult $adda_conf $CoeffShapeACP ]
            set cpones "2 1 $adda_colonnes 1"
            set x 1
            set y $adda_colonnes
            while {$x < $y} {lappend cpones 1; set x [expr $x + 1]}
            #mnorms_br cp cpmeans cpsigma
            set adda_comp_copri [mnormalize $adda_comp $cpmeans $cpones]
            #$mogad_p insert end "\nIndividuos nuevos en componentes de conformacion\n [show $adda_comp_copri %8.4f]\n"
            # Retirer les composantes inutilisees dans l'analyse princeps
            #$mogad_p insert end "inutile $inutile"
            set jeretire [expr $inutile + 2]
            set adda_comp [mrange $adda_comp_copri 0 [expr $colonnes - $jeretire] 0 end]
            #debug
            #$mogad_p insert end "\nCOLONNES DE POP: \t [mcols $pop]"
            set adda_pop [join_rows $pop $adda_comp]
            #$mogad_p insert end "\nNouvelle population en composantes\n [show $adda_pop]\n"
            set adda $adda_comp
        } elseif {$taco == 1 && $S(aligned) == 0 && $S(pw) == 1} {
            # NE PAS changer les donnees additionnelles en variables de conformation
            # je crois : set adda_pop [join_rows $prepop $adda]
            # refaire une ACP sur les residus (adda_pop)
            # ... ou alors creer les composantes a partir des coefficients \
            # deja calcules pour C
            # se retouver avec des COMPOSANTES de conformation
            # en retenir le meme nombre que pour l'analyse principale
            
            #===================== programmation en cours ======= debut
            global prepop
            # Une matrice adda_pop contenant les variables initiales de l'analyse princeps
            # et les donnees additionnelles de la matrice adda
            set adda_pop [join_rows $prepop $adda]
            
            #$mogad_p insert end "\n+-+-+-+-+-+-+-+-+-+-+-+-+-+-+"
            #$mogad_p insert end "\n Etapa 1 : datos addicionales son deformaciones parciales (PARTIAL WARPS)"
            #$mogad_p insert end "\n Etapa 2 : datos addicionales como componentes de conformacion centrados (Relative Warps)\
            #        \nEstos componentes 'adicionales' se calculan en base a los coeficientes iniciales\
            #        \ny el mismo numero de componentes se selecciona como para los datos iniciales\
            #        \n"
            #$mogad_p insert end "\n Etapa 3 : analisis discriminante - cada individuo addicional aparece\
            #        como un 'grupo' adicional, cuyo valor en los factores discriminantes se calcula\
            #        en base a los coeficientes iniciales"
            #$mogad_p insert end "\n-+-+-+-+-+-+-+-+-+-+-+-+-+-+-"
            
            set lignes_adda_pop [mrows $adda_pop]
            set colonnes [mcols $adda_pop]
            
            set adda_conf [mrange $adda_pop 0 end $lignes end]
            #$mogad_p insert end "\nIndividus nouveaux en variables de conformation\n [show $adda_conf]\n"
            #$mogad_p insert end "\nIndividus precedents en composantes [show $pop]\n"
            set adda_comp [mmult $adda_conf $CoeffShapeACP ]
            set cpones "2 1 $adda_colonnes 1"
            set x 1
            set y $adda_colonnes
            while {$x < $y} {lappend cpones 1; set x [expr $x + 1]}
            #mnorms_br cp cpmeans cpsigma
            set adda_comp_copri [mnormalize $adda_comp $cpmeans $cpones]
            
            #$mogad_p insert end "\nIndividuos nuevos en componentes de conformacion\n [show $adda_comp_copri %8.4f]\n"
            # Retirer les composantes inutilisees dans l'analyse princeps
            #$mogad_p insert end "inutile $inutile"
            set jeretire [expr $inutile + 2]
            set adda_comp [mrange $adda_comp_copri 0 [expr $colonnes - $jeretire] 0 end]
            #debug
            #$mogad_p insert end "\nCOLONNES DE POP: \t [mcols $pop]"
            set adda_pop [join_rows $pop $adda_comp]
            #$mogad_p insert end "\nNouvelle population en composantes\n [show $adda_pop]\n"
            set adda $adda_comp
        } elseif {$taco == 1 && $S(aligned) == 1} {
            # NE PAS changer les donnees additionnelles en variables de conformation
            # je crois : set adda_pop [join_rows $prepop $adda]
            # refaire une ACP sur les residus (adda_pop)
            # ... ou alors creer les composantes a partir des coefficients \
            # deja calcules pour C
            # se retouver avec des COMPOSANTES de conformation
            # en retenir le meme nombre que pour l'analyse principale
            
            #===================== programmation en cours ======= debut
            global prepop
            # Une matrice adda_pop contenant les variables initiales de l'analyse princeps
            # et les donnees additionnelles de la matrice adda
            set adda_pop [join_rows $prepop $adda]
            
            #$mogad_p insert end "\n+-+-+-+-+-+-+-+-+-+-+-+-+-+-+"
            #$mogad_p insert end "\n Etapa 1 : datos addicionales son residuos Procrusteanos"
            #$mogad_p insert end "\n Etapa 2 : datos addicionales como componentes de conformacion\
            #        \n(el mismo numero de componentes seleccionado como para los datos iniciales)"
            #$mogad_p insert end "\n Etapa 3 : analisis discriminante - cada individuos addicional aparece\
            #        como un 'grupo' adicional"
            #$mogad_p insert end "\n-+-+-+-+-+-+-+-+-+-+-+-+-+-+-"
            
            set lignes_adda_pop [mrows $adda_pop]
            set colonnes [mcols $adda_pop]
            
            set adda_conf [mrange $adda_pop 0 end $lignes end]
            #$mogad_p insert end "\nIndividus nouveaux en variables de conformation\n [show $adda_conf]\n"
            #$mogad_p insert end "\nIndividus precedents en composantes [show $pop]\n"
            set adda_comp [mmult $adda_conf $CoeffShapeACP ]
            set cpones "2 1 $adda_colonnes 1"
            set x 1
            set y $adda_colonnes
            while {$x < $y} {lappend cpones 1; set x [expr $x + 1]}
            #mnorms_br cp cpmeans cpsigma
            set adda_comp_copri [mnormalize $adda_comp $cpmeans $cpones]
            
            #$mogad_p insert end "\nIndividuos nuevos en componentes de conformacion\n [show $adda_comp_copri %8.4f]\n"
            # Retirer les composantes inutilisees dans l'analyse princeps
            #debug
            #aa "inutile $inutile"
            set jeretire [expr $inutile + 2]
            set adda_comp [mrange $adda_comp_copri 0 [expr $colonnes - $jeretire] 0 end]
            #debug
            #$mogad_p insert end "\nCOLONNES DE POP: \t [mcols $pop]"
            set adda_pop [join_rows $pop $adda_comp]
            #$mogad_p insert end "\nNouvelle population en composantes\n [show $adda_pop]\n"
            set adda $adda_comp
            
        } else {
            set adda_pop [join_rows $pop $adda]
        }
        
        # ---------------------------------------------------------------
        # Quelques STATISTIQUES sur la matrice des donnees additionnelles
        set tot_colonnes [mcols $adda_pop]
        set tot_lignes [mrows $adda_pop]
        
        destroy .pad
        toplevel .pad
        wm geometry .pad 270x30+480+410
        button .pad.buttxt -relief sunken -text "Progresion" -anchor w
        pack .pad.buttxt -side left -fill both -expand 1
        
        update
        .pad.buttxt configure -text "7/10 Factores canonicos"
        # -------------------------------
        # Etapa 7/10: Facteurs canoniques
        set tot_facteurs [mmult $adda_pop $C]
        global tot_individus
        for {set u 0} {$u < $tot_lignes} {incr u} {
            update
            lappend tot_individus [mrange $tot_facteurs 0 end $u $u]
        }
        
        update
        flush stdout
        
        set nombredindividus [llength $tot_individus]
        
        global individus
        set individus $tot_individus
        # On dessine ??? Et ben non, pas pour la classification.
        #dessine $tot_individus
        
        # Vecteur de 1
        set tot_ones "2 1 $tot_colonnes 1"
        set x 1
        set y $tot_colonnes
        while {$x < $y} {lappend tot_ones 1; set x [expr $x + 1]}
        
        # --------------------------------
        # Calcul des centres de gravite
        # tout individu supplementaire devient un 'groupe', une 'moyenne' differente
        # donc il faut un nombre de groupes different
        
        set adda_gr [expr $gr + $adda_lignes]
        set base_gr $gr
        # A noter que la difference entre 'gr' et 'adda_gr' peut etre tres grande
        # puisque adda_gr s'est enrichi de la totalite des individus.
        # Par ex., gr = 4 groupes de 50 individus deviennent  adda_gr = 4 + 4x50 soient 204 groupes ...
        
        set tot_Moy "2 $gr $tot_colonnes"
        set gr $adda_gr
        foreach item [split $moyennes] {lappend tot_Moy $item}
        #$mogad_p insert end "\nPrecedentes moyennes [show $tot_Moy]"
        set tot_Moy [join_rows $tot_Moy $adda]
        
        mnorms_br tot_Moy tot_Moymeans tot_Moysigmas
        set tot_MoyC [mnormalize $tot_Moy $tot_Moymeans $tot_ones]
        set groupes [mrows $tot_MoyC]
        
        # -----------------------------------------------------------------------------
        # scores canoniques score canonique = valeur d'un individu sur un axe factoriel
        update
        .pad.buttxt configure -text "9/10: Canonical Scores"
        # -----------------------------------------------------------------
        set cansco [mmult $tot_MoyC $C]
        #$mogad_p insert end "\n\nThe matrix of canonical scores =\n [show $cansco %8.4f]"
        # -------------------------------------------------
        # Etapa 10/10: Calcul des distances de Mahalanobis"
        update
        .pad.buttxt configure -text "10/10: Distancias de Mahalanobis"
        # -----------------------------------------------------------------
        # La procedure GENDIST renvoie la matrice des distances de Mahalanobis
        # Elle utilisera la variable gr, qui a ete changee dans cette procedure en adda_gr
        # mais c'est un changement LOCAL, la variable gr globale est inchangee !
        # Et c'est bien ainsi
        #debug
        #puts "Classification gr = $gr"
        global drapeau
        set drapeau " classification"
        set tot_distobs [gendist $cansco]
        #debug
        #puts "Procedure classification $tot_distobs"
        set new_lignes [mrows $tot_MoyC]
        # -------------------------------------------------
        
        # PREPARATION DU BILAN DES DISTANCES - DEBUT - \
        # IDENTIFICATION DES UNKNOWN
        
        # La longueur de la matrice des distances de Mahalanobis (tot_distobs)
        # nous donne le nombre de groupes compares
        set long [llength $tot_distobs]
        
        set passage -1
        set compteur 0
        for {set i 0} {$i < $long} {incr i} {
            incr passage
            for  {set k 1} {$k < [expr {$new_lignes - $passage}]} {incr k} {
                set maha [lindex $tot_distobs $compteur]
                set a [expr $i+1]
                set b [expr $i+$k+1]
                set compteur [expr $compteur + 1]
                #puts "\nEntre _$a et _$b:\t[format %3.2f $maha]"
                if {$a < [expr {$base_gr+1}]} {
                    if {$b > $base_gr} {
                        set tabsortdis($a,$b) $maha
                    }
                }
                set tabdis($i,[expr $i+$k]) $maha
            }
        }
        #puts "\nadda_gr = $adda_gr\n"
        for  {set j [expr {$base_gr+1}]} {$j < [expr {$adda_gr+1}] } {incr j} {
            for  {set i 1} {$i < [expr {$base_gr+1}]} {incr i} {
                #puts "tabsortdis($i,$j) $tabsortdis($i,$j)"
                append sortdis($j) "$tabsortdis($i,$j) "
                #puts "sortdis($j) ===== $sortdis($j)"
            }
        }
        update
        .pad.buttxt configure -text "Modelo discriminante"
        # -----------------------------------------------------------------
        vert "\n\nIDENTIFICACION EN BASE AL MODELO DISCRIMINANTE\n"
        $mogad_p insert end "The first value indicates the group \
                to which the individual has been assigned by the model"
        $mogad_p insert end "\nThe second value indicates the next closest group"
        # Premiere attribution
        for  {set j [expr {$base_gr+1}]} {$j < [expr {$adda_gr+1}] } {incr j} {
            #puts "\n$sortdis($j)\n"
            set ordre [lsort -real $sortdis($j)]
            set min [lindex $ordre 0]
            for  {set k 0} {$k < $base_gr} {incr k} {
                #puts "Comparer min = $min ET lindex sortdis(j) $k = [lindex $sortdis($j) $k]"
                if {$min == [lindex $sortdis($j) $k]} {
                    #$mogad_p insert end "\nUnknown $j assigned to group [expr {$k+1}]"
                    append id_unknown($j) "[expr {$k+1}]"
                }
            }
        }
        # Deuxieme attribution
        for  {set j [expr {$base_gr+1}]} {$j < [expr {$adda_gr+1}] } {incr j} {
            set ordre [lsort -real $sortdis($j)]
            set suivant [lindex $ordre 1]
            for  {set k 0} {$k < $base_gr} {incr k} {
                if {$suivant == [lindex $sortdis($j) $k]} {
                    append id_unknown($j) " , [expr {$k+1}]"
                    if {$ouaip == 1} {
                        append identindiv($j) $id_unknown($j)
                        #debug
                        #puts "DEBUG identindiv($j) = $identindiv($j)"
                    }
                }
            }
        }
        update
        flush stdout
        for  {set j [expr {$base_gr+1}]} {$j < [expr {$adda_gr+1}] } {incr j} {
            vert "\n(Unknown) _$j :\t"
            vert "$id_unknown($j)"
        }
        # - FIN de l'IDENTIFICATION des UNKNOWN
        
        destroy .pad
        # TABLE D'IDENTIFICATION RESUMEE - DEBUT
        update
        flush stdout
        #puts "gr = $base_gr"
        #tk_messageBox -message "CLASSIFICATION: effectifs $effectifs\nreally $effectifs ??\ngr = $base_gr" -type ok
        vert "\n\n-----------------------\n"
        vert "\nSimple re-classification\n"
        vert "\nLos individuos clasificados hicieron parte del analisis discriminante\n"
        vert "\nFirst Correct assignement\n"
        vert "\n------------------------\n"
        set pul 0
        for {set g 0} {$g < $base_gr} {incr g} {set corrattrUn($g) 0}
        for {set g 0} {$g < $base_gr} {incr g} {
            #debug
            #puts "g = $g - 'lindex effectifs g' = [lindex $effectifs $g]"
            for  {set i $pul} {$i < [ expr { $pul+[lindex $effectifs $g] } ] } {incr i} {
                set sel [lindex $identindiv([expr {$i+1+$base_gr}]) 0]
                #debug
                #puts "identindiv([expr {$i+1+$base_gr}]) = $identindiv([expr {$i+1+$base_gr}])"
                #puts "Indiv $i -> if sel ($sel) == 'g+1' ( [expr {$g+1}])"
                if {$sel == [expr {$g+1}]} {
                    incr corrattrUn($g)
                }
            }
            set pul [ expr { $pul+[lindex $effectifs $g] } ]
            #debug
            #puts "pul = $pul et corrattrUn($g) = $corrattrUn($g)"
        }
        # lecture des resultats
        for  {set g 0} {$g < $base_gr} {incr g} {
            $mogad_p insert end "\nPop [expr {$g+1}] : \
                    $corrattrUn($g) / [lindex $effectifs $g]\t\
                    ([expr {int($corrattrUn($g)*1.0/[lindex $effectifs $g]*100)}]%)"
        }
        
        # TABLE D'IDENTIFICATION RESUMEE - FIN
        
        # restaurer la valeur initiale de certaines variables
        set gr $base_gr
        set effectifs $base_effectifs
        set classification 1
    }
    #
    # Procedure CLASSIFICATION - fin
    
    
    # Procedure INC_DISCRIMINATOIRE ## debut
    #
    proc inc_discriminatoire {pop gr lignes colonnes effectifs covT} {
        global mogad_p Cperm distperm wiwi ladistance lambda moyennes
        global infile end
        global individus base_individus
        #
        # La variable individus contient deja les donnees car elles ont ete utilisees dans MOG
        #
        set individus ""
        #
        set B "2 $gr $colonnes"
        set listeW "2 $lignes $colonnes"
        set listeW [lreplace $listeW 0 end]
        update
        flush stdout
        # MOYENNES ET DEVIATIONS STANDARD DES VARIABLES
        mnorms_br pop popmeans popsigma
        # Vecteur de 1
        set popones "2 1 $colonnes 1"
        set x 1
        set y $colonnes
        while {$x < $y} {lappend popones 1; set x [expr $x + 1]}
        # - - - - - - - - - - - - - - - - - - - - - - -
        # SEPARER LA MATRICE DE CHAQUE GROUPE
        # - - - - - - - - - - - - - - - - - - - - - - -
        set correction 0
        set moyennes "";#mogaddiction March 2009
        foreach item [split $effectifs] {
            update
            flush stdout
            set correction [expr $correction + $item]
            set newpop [mrange $pop 0 [expr $colonnes-1] \
                    [expr $correction - $item] [expr $correction - 1]]
            # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
            mnorms_br newpop newpopmeans newpopsigmas
            # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
            set partZ [mnormalize $newpop $newpopmeans $popones]
            # STOCKER LA MATRICE CENTREE SUR LE GROUPE DANS LA LISTE preplisteW
            # QUI COMPOSERA LA FUTURE MATRICE CENTREE listeW
            set preplisteW "";#mogaddiction March 2009
            foreach item [split $partZ] {lappend preplisteW $item}
            set preplisteW [lreplace $preplisteW 0 2]
            set listeW [concat $listeW $preplisteW]
            set preplisteW [lreplace $preplisteW 0 end]
            # PREPARER LA FUTURE MATRICE DES MOYENNES / GROUPE
            set newpopmeans [lrange $newpopmeans 3 end]
            
            #tk_messageBox -message "discriminatoire, moyennes AVANT\n$moyennes"
            foreach item [split $newpopmeans] {lappend moyennes $item}
            
            #voir ensuite ligne ... # ECRITURE ...
        }
        #debug
        #aa "discriminatoire, moyennes APRES\n$moyennes"
        update
        flush stdout
        # -----------------------------------------------------------
        # CONSTRUCTION FINALE DE LA MATRICE listeW (donnees centrees)
        set listeW [concat 2 $lignes $colonnes $listeW]
        
        # ---------------------------------------------
        # MATRICE des VARIANCES - COVARIANCES 'within'
        set covW [mmult [transpose $listeW] $listeW]
        set corrddl [expr 1.0/($lignes - $gr)]
        set W [mscale $covW $corrddl]
        #$mogad_p insert end "\n------------------------------------------------"
        #$mogad_p insert end "\nA principal component analysis is performed on [show $W]"
        set V $W
        mevsvd_br V evals
        set preloadings [lrange $evals 3 end];# matrice -> liste
        set prelong [llength $preloadings]
        
        ###########################cutoff cutoff cutoff ################# DEBUT
        set loadings ""
        set cutoff 0.000000001
        for {set i 0} {$i < $prelong} {incr i} {
            set item [lindex $preloadings $i]
            if {$item > $cutoff} {lappend loadings $item}
        }
        set long [llength $loadings]
        
        #debug
        if {$long < $prelong} {
            $mogad_p insert end "\n(internal info)\ncutoff :\t$prelong\t->\t$long"
        }
        ###########################cutoff cutoff cutoff #################### FIN
        
        ##-------------------------------------------------------
        # ajustement des eigenvectors de W a 1/LAMBDA
        # S'agit en fait d'une 'length scaling' at 1/sqrt(lambda)
        for {set i 0} {$i < $long} {incr i} {
            lappend weightedevals1surLAMBDA \
                    [expr 1.0/([lindex $loadings $i])]
        }
        #$mogad_p insert end "\nLongeur eigenvalues : $long\n"
        set listeV [vtrim $V]
        #$mogad_p insert end "\nEigenvecteurs V : $listeV\n"
        
        for {set i 0} {$i < [expr $long * $long]} {incr i} {
            if {[expr abs([lindex $listeV $i])] < 0.00000001} \
                    {set listeV [lreplace $listeV $i $i 0.00000001]}
            if {[expr abs([lindex $listeV $i])] > 0.99999999} \
                    {set listeV [lreplace $listeV $i $i 0.99999999]}
        }
        #$mogad_p insert end "\nEigenvecteurs V CORRIGE: $listeV\n"
        
        # bug jan 2003
        # set V [concat "2 $long $long" $listeV]
        # apres jan2003 plus de bug ?
        set V [mrange $V 0 [expr $long-1] 0 end]
        
        set eigenvect $V
        
        set listeE [scaleLengthEigenvect $eigenvect $weightedevals1surLAMBDA]
        # PASSAGE DE LISTE A MATRICE
        # bug jan 2003
        # set Et "2 $colonnes $long $listeE"
        # apres jan2003 plus de bug ?
        set nblignes [mrows $eigenvect]
        set Et "2 $long $nblignes $listeE"
        set sqrtE [transpose $Et]
        
        ##------------------------------------------------------------------------
        ## On construit a present la matrice B des manuels  -------  DEBUT   -----
        set covB [msub $covT $covW]
        set corrddl [expr 1.0/($gr - 1)]
        set B [mscale $covB $corrddl]
        
        ############################
        #####################
        ############
        set E $sqrtE
        #####################
        ############################
        
        # Matrice des moyennes de chaque groupe, puis centrage (MoyC)
        # -----------------------------------------------------------
        set Moy "2 $gr $colonnes";
        foreach item [split $moyennes] {lappend Moy $item}
        set MoyC [mnormalize $Moy $popmeans $popones]
        # The standardized among-groups VarCov matrix (Et B E)
        # --------------------------------------------------
        set Et [transpose $E]
        set EtBE [mmult [mmult $Et $B] $E]
        #$mogad_p insert end "\n\n-------------------------------------------------"
        #$mogad_p insert end "\nA principal component analysis is performed on EtBE"
        set preEstar $EtBE
        mevsvd_br preEstar evalsII
        # Passage d'une matrice (evals) a une liste (Bloadings)
        set EtBEloadings [lrange $evalsII 3 end]
        set prelong [llength $EtBEloadings];# cfr ligne 4905 de PAD
        #---------------------------- cutoffII cutoffII cutoffII -------- DEBUT
        set loadings ""
        set cutoff 0.000000001
        for {set i 0} {$i < $prelong} {incr i} {
            set item [lindex $EtBEloadings $i]
            if {$item > $cutoff} {lappend loadings $item}
        }
        set long [llength $loadings]
        #----------------------------- cutoffII cutoffII cutoffII --------- FIN
        # canonical vectors C
        set Cperm [mmult $E $preEstar]
        set facteurs [mmult $pop $Cperm];# PAD 4962
        #if {$wiwi == 1} {set wilksperm [wilks $facteurs $popones $lignes $colonnes $gr $effectifs]}
        
        ##### Pour obtenir les Eigenvalues, on refait l'analyse discriminante, mais ... sur les facteurs ...
        #############################   D   E   B   U   T   #################################################
        set factpop $facteurs
        #
        mnorms_br factpop factpopmeans factpopsigmas
        #
        set popones "2 1 [mcols $eigenvect] 1"
        set x 1
        set y [mcols $eigenvect]
        while {$x < $y} {lappend popones 1; set x [expr $x + 1]}
        #
        set factZ [mnormalize $factpop $factpopmeans $popones]
        # MATRICE des VARIANCES - COVARIANCES totales
        set factZZ [mmult [transpose $factZ] $factZ]
        set factcovT $factZZ
        #
        set factlisteW "2 $lignes [mcols $eigenvect]"
        set factlisteW [lreplace $factlisteW 0 end]
        # - - - - - - - - - - - - - - - - - - - - - - -
        # SEPARER LA MATRICE DE CHAQUE GROUPE
        # - - - - - - - - - - - - - - - - - - - - - - -
        set correction 0
        foreach item [split $effectifs] {
            set correction [expr $correction + $item]
            set factnewpop [
            mrange $factpop 0 [expr [mcols $eigenvect]-1] \
                    [expr $correction - $item] [expr $correction - 1]
            ]
            # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
            mnorms_br factnewpop factnewpopmeans factnewpopsigmas
            # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
            set factpartZ [mnormalize $factnewpop $factnewpopmeans $popones]
            # STOCKER LA MATRICE CENTREE SUR LE GROUPE DANS LA LISTE preplisteW
            # QUI COMPOSERA LA FUTURE MATRICE CENTREE listeW
            foreach item [split $factpartZ] {lappend factpreplisteW $item}
            set factpreplisteW [lreplace $factpreplisteW 0 2]
            set factlisteW [concat $factlisteW $factpreplisteW]
            set factpreplisteW [lreplace $factpreplisteW 0 end]
            # PREPARER LA FUTURE MATRICE DES MOYENNES / GROUPE
            set factnewpopmeans [lrange $factnewpopmeans 3 end]
            foreach item [split $factnewpopmeans] {lappend factmoyennes $item}
        }
        # -----------------------------------------------------------
        # CONSTRUCTION FINALE DE LA MATRICE listeW (donnees centrees)
        # -----------------------------------------------------------
        set factlisteW [concat 2 $lignes [mcols $eigenvect] $factlisteW]
        # ----------------------------------------------------------
        # Matrice des variances-covariance covW de la matrice listeW
        # ----------------------------------------------------------
        # MATRICE des VARIANCES - COVARIANCES 'within'
        set factcovW [mmult [transpose $factlisteW] $factlisteW]
        # ----------------------------------------------------
        ##### On construit a present la matrice B des facteurs
        # ----------------------------------------------------
        set factcovB [msub $factcovT $factcovW]
        #debug "1937\nfactcovB \n[show $factcovB]\n\nfactcovW \n[show $factcovW]"
        # ----------------------------------
        #     presentation des eigenvalues
        # ----------------------------------
        set prolambda [mdiv $factcovB $factcovW]
        set prelambda [vdiag $prolambda]
        set lambda [vtrim $prelambda]
        #bleu "\n\nEigenvalues : \n"
        if {$gr > 2} {set lambda [lrange $lambda 0 [expr $gr-2]]} \
                else {set lambda [lrange $lambda 0 0]}
        #foreach item $lambda {
        #    set item [format %1.3f $item]
        #    $mogad_p insert end "$item\t"
        #}
        
        set taille [llength $lambda]
        #bleu "\n\nContribuciones, del primer factor al ultimo\n"
        set sumlambda 0
        for {set i 0} {$i < $taille} {incr i} {
            set sumlambda [expr [lindex $lambda $i] + $sumlambda]
        }
        set proplambda(name) 0
        for {set i 0} {$i < $taille} {incr i} {
            set prop [expr [lindex $lambda $i]/$sumlambda]
            set name [expr $i - 3]; set proplambda($name) $prop
        }
        
        ##### Pour obtenir les Eigenvalues, on a refait l'analyse discriminante ... sur les facteurs ...
        #############################   F   I   N   ####################################################
        
        update
        flush stdout
        if {$gr > 2} {set nbfacteurs [expr $gr-1]} else {set nbfacteurs $gr}
        #bleu "\n\nFactores canonicos:\n\n"
        # entrer ici -- debut !!
        set facteurscanoniques [mrange $facteurs 0 [expr $nbfacteurs-1] 0 end]
        #puts "\n\nF A C T E U R S    R E T E N U S \n$facteurscanoniques"
        #debug
        set facteurscanoniques [lrange $facteurscanoniques 3 end]
        set i 0
        
        # FACTOR MAP
        # Les individus qu'on utilisera pour dessiner la carte factorielle
        global individus
        set individus "";# dec 2009
        for {set u 0} {$u < $lignes} {incr u} {
            lappend individus [mrange $facteurs 0 end $u $u]
        }
        set base_individus $individus
        
        # entrer ici -- fin !!!
        
        # canonical scores cansco
        set cansco [mmult $MoyC $Cperm]
        # generalized distances ** APPEL a la PROCEDURE GENDIST
        global drapeau
        set drapeau " discrimin"
        set ladistance 1
        if {$ladistance == 1} {
            set distperm [gendist $cansco]
        }
    }
    # Procedure INC_DISCRIMINATOIRE -- FIN
    
    
    
    # Procedure DISCRIMINATOIRE -- Debut
    #
    proc discriminatoire {pop gr lignes colonnes groupuscules covT} {
        #
        #debug "\npop $pop \ngr $gr\nlignes $lignes \ncolonnes $colonnes \ngroupuscules $groupuscules\ncovT $covT"
        #
        
        # gr = nombre de groupes
        # groupuscules = composition des groupes (p.ex. 20 24 29)
        
        global mogad_p Cperm distperm wiwi ladistance lambda moyennes
        global infile end
        global individus base_individus
        #
        set individus ""
        #
        set B "2 $gr $colonnes"
        set listeW "2 $lignes $colonnes"
        set listeW [lreplace $listeW 0 end]
        #
        update
        flush stdout
        #
        # MOYENNES ET DEVIATIONS STANDARD DES VARIABLES
        mnorms_br pop popmeans popsigma
        # Vecteur de 1
        set popones "2 1 $colonnes 1"
        set x 1
        set y $colonnes
        while {$x < $y} {lappend popones 1; set x [expr $x + 1]}
        # - - - - - - - - - - - - - - - - - - - - - - -
        # SEPARER LA MATRICE DE CHAQUE GROUPE
        # - - - - - - - - - - - - - - - - - - - - - - -
        set correction 0
        set moyennes "";#mogaddiction March 2009
        foreach item [split $groupuscules] {
            update
            flush stdout
            set correction [expr $correction + $item]
            set newpop [mrange $pop 0 [expr $colonnes-1] [expr $correction - $item] [expr $correction - 1]]
            # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
            mnorms_br newpop newpopmeans newpopsigmas
            # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
            set partZ [mnormalize $newpop $newpopmeans $popones]
            # STOCKER LA MATRICE CENTREE SUR LE GROUPE DANS LA LISTE preplisteW
            # QUI COMPOSERA LA FUTURE MATRICE CENTREE listeW
            set preplisteW "";#mogaddiction March 2009
            foreach item [split $partZ] {lappend preplisteW $item}
            set preplisteW [lreplace $preplisteW 0 2]
            set listeW [concat $listeW $preplisteW]
            set preplisteW [lreplace $preplisteW 0 end]
            #
            # PREPARER LA FUTURE MATRICE DES MOYENNES / GROUPE
            set newpopmeans [lrange $newpopmeans 3 end]
            #
            #tk_messageBox -message "discriminatoire, moyennes AVANT\n$moyennes"
            foreach item [split $newpopmeans] {lappend moyennes $item}
            #
            #voir ensuite ligne ... # ECRITURE ...
        }
        #
        update
        flush stdout
        #
        # -----------------------------------------------------------
        # CONSTRUCTION FINALE DE LA MATRICE listeW (donnees centrees)
        set listeW [concat 2 $lignes $colonnes $listeW]
        #debug $listeW
        # ---------------------------------------------
        # MATRICE des VARIANCES - COVARIANCES 'within'
        set covW [mmult [transpose $listeW] $listeW]
        set corrddl [expr 1.0/($lignes - $gr)]
        set W [mscale $covW $corrddl]
        #$mogad_p insert end "\n------------------------------------------------"
        #$mogad_p insert end "\nA principal component analysis is performed on W"
        set V $W
        mevsvd_br V evals
        set preloadings [lrange $evals 3 end];# matrice -> liste
        set prelong [llength $preloadings]
        
        ###########################cutoff cutoff cutoff ################# DEBUT
        set loadings ""
        set cutoff 0.000000001
        for {set i 0} {$i < $prelong} {incr i} {
            set item [lindex $preloadings $i]
            if {$item > $cutoff} {lappend loadings $item}
        }
        set long [llength $loadings]
        
        #
        if {$long < $prelong} {
            $mogad_p insert end "\n(internal info)\ncutoff :\t$prelong\t->\t$long"
        }
        ###########################cutoff cutoff cutoff #################### FIN
        
        ##-------------------------------------------------------
        # ajustement des eigenvectors de W a 1/LAMBDA
        # S'agit en fait d'une 'length scaling' at 1/sqrt(lambda)
        for {set i 0} {$i < $long} {incr i} {
            lappend weightedevals1surLAMBDA \
                    [expr 1.0/([lindex $loadings $i])]
        }
        #$mogad_p insert end "\nLongeur eigenvalues : $long\n"
        set listeV [vtrim $V]
        #$mogad_p insert end "\nEigenvecteurs V : $listeV\n"
        
        for {set i 0} {$i < [expr $long * $long]} {incr i} {
            if {[expr abs([lindex $listeV $i])] < 0.00000001} \
                    {set listeV [lreplace $listeV $i $i 0.00000001]}
            if {[expr abs([lindex $listeV $i])] > 0.99999999} \
                    {set listeV [lreplace $listeV $i $i 0.99999999]}
        }
        #$mogad_p insert end "\nEigenvecteurs V CORRIGE: $listeV\n"
        
        #
        set V [mrange $V 0 [expr $long-1] 0 end]
        #
        set eigenvect $V
        #
        set listeE [scaleLengthEigenvect $eigenvect $weightedevals1surLAMBDA]
        # PASSAGE DE LISTE A MATRICE
        set nblignes [mrows $eigenvect]
        set Et "2 $long $nblignes $listeE"
        set sqrtE [transpose $Et]
        #
        ##------------------------------------------------------------------------
        ## On construit a present la matrice B des manuels  -------  DEBUT   -----
        set covB [msub $covT $covW]
        #debug "covB \n$covB"
        set corrddl [expr 1.0/($gr - 1)]
        set B [mscale $covB $corrddl]
        #
        ############################
        #####################
        set E $sqrtE
        #####################
        ############################
        #
        # Matrice des moyennes de chaque groupe, puis centrage (MoyC)
        # -----------------------------------------------------------
        set Moy "2 $gr $colonnes";
        foreach item [split $moyennes] {lappend Moy $item}
        set MoyC [mnormalize $Moy $popmeans $popones]
        # The standardized among-groups VarCov matrix (Et B E)
        # --------------------------------------------------
        set Et [transpose $E]
        set EtBE [mmult [mmult $Et $B] $E]
        #$mogad_p insert end "\n\n-------------------------------------------------"
        #$mogad_p insert end "\nA principal component analysis is performed on EtBE"
        set preEstar $EtBE
        mevsvd_br preEstar evalsII
        # Passage d'une matrice (evals) a une liste (Bloadings)
        set EtBEloadings [lrange $evalsII 3 end]
        set prelong [llength $EtBEloadings];# cfr ligne 4905 de PAD
        #---------------------------- cutoffII cutoffII cutoffII -------- DEBUT
        set loadings ""
        set cutoff 0.000000001
        for {set i 0} {$i < $prelong} {incr i} {
            set item [lindex $EtBEloadings $i]
            if {$item > $cutoff} {lappend loadings $item}
        }
        set long [llength $loadings]
        #----------------------------- cutoffII cutoffII cutoffII --------- FIN
        # canonical vectors C
        set Cperm [mmult $E $preEstar]
        set facteurs [mmult $pop $Cperm];# PAD 4962
        #if {$wiwi == 1} {set wilksperm [wilks $facteurs $popones $lignes $colonnes $gr $groupuscules]}
        
        ##### Pour obtenir les Eigenvalues, on refait l'analyse discriminante, mais ... sur les facteurs ...
        #############################   D   E   B   U   T   #################################################
        set factpop $facteurs
        #
        mnorms_br factpop factpopmeans factpopsigmas
        #
        set popones "2 1 [mcols $eigenvect] 1"
        set x 1
        set y [mcols $eigenvect]
        while {$x < $y} {lappend popones 1; set x [expr $x + 1]}
        #
        set factZ [mnormalize $factpop $factpopmeans $popones]
        # MATRICE des VARIANCES - COVARIANCES totales
        set factZZ [mmult [transpose $factZ] $factZ]
        set factcovT $factZZ
        #
        set factlisteW "2 $lignes [mcols $eigenvect]"
        set factlisteW [lreplace $factlisteW 0 end]
        # - - - - - - - - - - - - - - - - - - - - - - -
        # SEPARER LA MATRICE DE CHAQUE GROUPE
        # - - - - - - - - - - - - - - - - - - - - - - -
        set correction 0
        foreach item [split $groupuscules] {
            set correction [expr $correction + $item]
            set factnewpop [
            mrange $factpop 0 [expr [mcols $eigenvect]-1] \
                    [expr $correction - $item] [expr $correction - 1]
            ]
            # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
            mnorms_br factnewpop factnewpopmeans factnewpopsigmas
            # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
            set factpartZ [mnormalize $factnewpop $factnewpopmeans $popones]
            # STOCKER LA MATRICE CENTREE SUR LE GROUPE DANS LA LISTE preplisteW
            # QUI COMPOSERA LA FUTURE MATRICE CENTREE listeW
            foreach item [split $factpartZ] {lappend factpreplisteW $item}
            set factpreplisteW [lreplace $factpreplisteW 0 2]
            set factlisteW [concat $factlisteW $factpreplisteW]
            set factpreplisteW [lreplace $factpreplisteW 0 end]
            # PREPARER LA FUTURE MATRICE DES MOYENNES / GROUPE
            set factnewpopmeans [lrange $factnewpopmeans 3 end]
            foreach item [split $factnewpopmeans] {lappend factmoyennes $item}
        }
        # -----------------------------------------------------------
        # CONSTRUCTION FINALE DE LA MATRICE listeW (donnees centrees)
        # -----------------------------------------------------------
        set factlisteW [concat 2 $lignes [mcols $eigenvect] $factlisteW]
        # ----------------------------------------------------------
        # Matrice des variances-covariance covW de la matrice listeW
        # ----------------------------------------------------------
        # MATRICE des VARIANCES - COVARIANCES 'within'
        set factcovW [mmult [transpose $factlisteW] $factlisteW]
        # ----------------------------------------------------
        ##### On construit a present la matrice B des facteurs
        # ----------------------------------------------------
        set factcovB [msub $factcovT $factcovW]
        #debug "factcovB \n[show $factcovB]\n\nfactcovW \n[show $factcovW]"
        # ----------------------------------
        #     presentation des eigenvalues, modifie June 2011 pour EVITER DIVISION PAR ZERO !!
        # ----------------------------------
        if {$gr > 2} {
            set juskouB [mrange $factcovB 0 [expr $gr-2] 0 end]
            set juskouW [mrange $factcovW 0 [expr $gr-2] 0 end]
        } else {
            set juskouB [mrange $factcovB  0 0 0 end]
            set juskouW [mrange $factcovW  0 0 0 end]
        }
        #$mogad_p insert end "\n\njuskouB\n[show $juskouB] \njuskouW\n[show $juskouW]"
        set prolambda [mdiv $juskouB $juskouW]
        #set prolambda [mdiv $factcovB $factcovW];#modifie June 2011 pour EVITER DIVISION PAR ZERO !!
        set prelambda [vdiag $prolambda]
        set lambda [vtrim $prelambda]
        bleu "\n\nEigenvalues : \n"
        #if {$gr > 2} {set lambda [lrange $lambda 0 [expr $gr-2]]} else {set lambda [lrange $lambda 0 0]};#modifie June 2011
        #
        foreach item $lambda {
            set item [format %1.3f $item]
            $mogad_p insert end "$item\t"
        }
        
        set taille [llength $lambda]
        bleu "\n\nContribuciones, del primer factor al ultimo\n"
        set sumlambda 0
        for {set i 0} {$i < $taille} {incr i} {
            set sumlambda [expr [lindex $lambda $i] + $sumlambda]
        }
        set proplambda(name) 0
        for {set i 0} {$i < $taille} {incr i} {
            set prop [expr [lindex $lambda $i]/$sumlambda]
            set name [expr $i - 3]; set proplambda($name) $prop
        }
        for {set i 0} {$i < $taille} {incr i} {
            set name [expr $i - 3]
            $mogad_p insert end "[format %1.2f $proplambda($name)]\t"
        }
        
        ##### Pour obtenir les Eigenvalues, on a refait l'analyse discriminante ... sur les facteurs ...
        #############################   F   I   N   ######################
        
        update
        flush stdout
        if {$gr > 2} {set nbfacteurs [expr $gr-1]} else {set nbfacteurs $gr}
        bleu "\n\nFactores canonicos:\n\n"
        # entrer ici -- debut !!
        set facteurscanoniques [mrange $facteurs 0 [expr $nbfacteurs-1] 0 end]
        #puts "\n\nF A C T E U R S    R E T E N U S \n$facteurscanoniques"
        #
        set facteurscanoniques [lrange $facteurscanoniques 3 end]
        set i 0
        foreach item  [split $facteurscanoniques] {
            incr i
            set item [format %1.3f $item]
            $mogad_p insert end "$item\t"
            lappend boitalettres $item
            if {[expr fmod($i,$nbfacteurs)] == 0} {
                $mogad_p insert end "\n"
                append boitalettres "\n"
            }
        }
        #
        # FACTOR MAP
        #
        global individus
        set individus "";# dec 2009
        for {set u 0} {$u < $lignes} {incr u} {
            lappend individus [mrange $facteurs 0 end $u $u]
        }
        set base_individus $individus
        #
        # canonical scores cansco
        set cansco [mmult $MoyC $Cperm]
        # generalized distances ** Appel a la procedure GENDIST
        global drapeau
        set drapeau " discrimin"
        set ladistance 1
        if {$ladistance == 1} {
            set distperm [gendist $cansco]
        }
        #
        #.mogad.mogad_buttons.factormap invoke
    }
    # Procedure DISCRIMINATOIRE -- Fin
    
    
    
    # Procedure generalized distances  GENDIST - Debut
    #
    proc gendist {cansco} {
        
        update
        flush stdout
        global mogad_p S gr ouaip lignes infile end
        global perper indiv_lessindiv adda_lignes suppl
        #debug - start
        # indiv_lessindiv vaut 1 si c'est varcochecla qui appelle
        #puts "gendist gr = $gr ou $base_gr"
        global drapeau adda_gr
        #puts "Procedure d'appel $drapeau\tgr = $gr"
        #debug - end
        set matridist ""
        set distances ""
        # pour l'ecriture des barres sur le .pad
        # ce compteur correspond au nombre de distances calculees
        set compteur 0
        # ------------
        set lig [mrows $cansco]
        set col [mcols $cansco];#debug "col de cansco $col"
        
        for {set i 0} {$i < $lig} {incr i} {
            for  {set j 0} {$j < $lig} {incr j} {
                set tabdis($i,$j) 0
            }
        }
        set passage -1
        
        
        if {[info exists perper] == 0} {
            # ATTENTION
            #set ouaip 0
            # ATTENTION - FIN
            if {$ouaip == 0} {
                if {[info exists indiv_lessindiv] == 0} {
                    bleu "\n\nDistancias de Mahalanobis (por pares)"
                }
            }
        }
        # pour l'ecriture des barres sur pad
        set tot [expr {(($lig * $lig) - $lig) / 2}]
        if {$tot > 20} {
            set module [expr {int($tot * 0.05)}]
        }
        
        # ----------------------------------------------------------------------------------
        # Trois boucles imbriquees, ce qui prend du temps ... !! (cfr. button CCC)
        # ----------------------------------------------------------------------------------
        # ce qui prend du temps, c'est que vardiscrimin appelle deux fois a chaque analyse !
        # - une fois pour l'AD de lessyou et le nombre de groupes initial,
        # - une autre fois pour l'AD avec 'you' comme 'groupe' additionnel ...
        # #=================================================================================
        # Le nombre de groupes de la matrice initiale, egal a celui de la procedure 'classification'
        set grupo $gr
        # Ce nombre de groupes change quand des donnees additionnelles sont etudiees, ou en cas de CCC
        if {$drapeau == " varcccdiscrimin_2"} {set grupo $adda_gr}
        #puts "procedure d'appel $drapeau \tgrupo = $grupo\tlig = $lig"
        # grupo devient ici le nombre de colonnes de cansco a prendre en consideration
        # Cela nous permet de limiter nos calculs aux axes significatifs ('grupo - 1')
        #
        # 'lig' est le nombre de centres de gravite de cansco, le nombre de groupes en fait ...
        # 5 aout 2006
        # Il peut arriver que 'grupo' soit trop grand par rapport a la dimension de cansco
        if {$col < [expr {$grupo - 1}]} { set colscans $col} else {set colscans [expr {$grupo-1}]}
        
        for  {set l 0} {$l < [expr {$lig - 1}]} {incr l} {
            # Au depart, passage vaut -1, il devient 0 apres 'incr passage', puis 1, 2 , etc ...
            incr passage
            for  {set k 1} {$k < [expr {$lig - $passage}]} {incr k} {
                set maha 0
                for  {set c 0} {$c < $colscans} {incr c} {
                    # valeurs de chaque individu sur un axe factoriel
                    set g1 [lindex [mrange $cansco $c $c $l $l] 3]
                    set g2 [lindex [mrange $cansco $c $c [expr {$l + $k}] [expr {$l + $k}] ] 3]
                    # difference arithmetique entre deux coordonnees
                    # (celles des deux individus examines)
                    set diff [expr {$g1  -  $g2}]
                    # cette difference elevee au carre
                    set cardiff [expr {$diff * $diff}]
                    # cette valeur recalculee pour chaque axe
                    set maha [expr {$maha + $cardiff}]
                    #debug
                    #incr decompte
                    #debug - end
                }
                
                # La racine carree de cette somme (Pythagore)
                incr compteur
                #debug
                #puts "(gendist) compteur = $compteur"
                set maha [expr {sqrt($maha)}]
                
                # A present, on affiche les resultats
                # s'il n'y a pas eu de permutations
                # et
                # s'il ne s'agit pas de CCC (cfr. indiv_lessindiv)
                # et
                # s'il ne s'agit pas de C (cfr. ouaip)
                # ... bref
                # voir en plus le cas special des donnees additionnelles (cfr.adda_lignes)
                if {[info exists perper] == 0} {
                    # ATTENTION
                    #set ouaip 0
                    # ATTENTION - FIN
                    if {$ouaip == 0} {
                        if {[info exists indiv_lessindiv] == 0} {
                            if {[info exists  adda_lignes] } {
                                if {[expr {$l+1}] < [expr {$gr+1}]} {
                                    update
                                    flush stdout
                                    $mogad_p insert end "\nEntre _[expr $l+1] et _[expr $l+$k+1]: \
                                            \t[format %3.2f $maha]"
                                }
                            } else  {
                                update
                                flush stdout
                                $mogad_p insert end "\nEntre _[expr $l+1] et _[expr $l+$k+1]: \
                                        \t[format %3.2f $maha]"
                            }
                        }
                    }
                }
                # si ce n'est pas CCC
                if {[info exists indiv_lessindiv] == 0} {
                    #si ce n'est pas 'Datos externos'
                    if {[info exists suppl] == 0} {
                        # et seulement si c'est une classification
                        if  {[info exists adda_lignes]} {
                            update
                            if  {[expr {fmod($compteur,$module)}] == 0} {
                                append buz " | "
                                set baz "$passage$buz"
                                .pad.buttxt configure -text "$baz" -fg red
                                flush stdout
                            }
                        }
                    }
                }
                lappend matridist $maha
                set tabdis($l,[expr $l+$k]) $maha
            }
        };# fin des trois boucles
        
        #debug
        #puts "Il a fallu $decompte boucles"
        flush stdout
        #debug - end
        
        # tentative (inutile) d'agilisation
        update
        flush stdout
        # fin de la dite tentative (ridicule)
        
        
        # ------------------------------
        if {[info exists perper] == 0} {
            if {[info exists indiv_lessindiv] == 0} {
                # ATTENTION
                #set ouaip 0
                # ATTENTION - FIN
                if {$ouaip == 0} {
                    global infile
                    set mahadist ""
                    bleu "\n\nDistances de Mahalanobis (Tabla _ Phylip format)\n"
                    $mogad_p insert end " $lig"
                    append mahadist " $lig"
                    for {set i 0} {$i < $lig} {incr i} {
                        if {$i > 8} {
                            $mogad_p insert end "\n_[expr {$i+1}]       "
                            append mahadist "\n_[expr {$i+1}]       "
                        } else {
                            # Attention, ici il y a un espace en plus
                            $mogad_p insert end "\n_[expr {$i+1}]        "
                            append mahadist "\n_[expr {$i+1}]        "
                        }
                        for {set j 0} {$j < $lig} {incr j} {
                            set bof [format %3.2f $tabdis($j,$i)]
                            if {$bof > 0.000000001} {$mogad_p insert end "$bof "; append mahadist "$bof "}
                        }
                        $mogad_p insert end "0.00"
                        append mahadist "0.00"
                    }
                    
                    #
                    # Enregistrement de la matrice des distances de Mahalanobis - format phylip
                    set sub "_"
                    set fin ".txt"
                    set quoi MAHAphylip
                    set ajout $sub$quoi$fin
                    set infilesub "[file root $infile]$ajout"
                    #debug
                    $mogad_p insert end "\n\n[file root $infile]\n\n"
                    set fid [open $infilesub w]
                    #puts -nonewline $fid "Euclidian distances between rows, from $infile\n"
                    puts -nonewline $fid $mahadist
                    close $fid
                    
                };# fin de 'if ouaip == 0'
            }
        };# ------------------------------
        update
        flush stdout
        #puts "Distances calculees"
        set buz ""
        return $matridist
    }
    ##########procedure generalized distances GENDIST #### FIN #######
    
    # procedure AA
    #
    proc aa {output} {
        global infile
        set megatexte "\n$output"
        #
        set namefile [file rootname $infile]
        set end "_Debug.txt"
        set filename $namefile$end
        # OPEN THE FILE
        set fileid [open $filename a+]
        # FILL THE FILE
        #puts -nonewline $fileid $megainfo
        puts -nonewline $fileid $megatexte
        # CLOSE THE FILE
        close $fileid
    }
    #
    # Procedure AA fin
    
    
    # Procedure LOADFILE ##### debut
    proc loadfile {pathname} {
        #
        # LOADFILE rentre les donnees d'un fichier dans une matrice de HUME
        #
        global references premligne colcount rowcount S
        set fid [open $pathname]
        set text [read -nonewline $fid]
        close $fid
        #
        # Les donnees sont dans la variable 'text'
        set rowcount 0
        set colcount 0
        set compteur 0
        set lignes 0
        set datos ""
        foreach line [split $text \n] {
            incr compteur
            if {$compteur >1} {
                if  {$line != ""} {
                    set colcount [llength $line]
                }
            }
            if {$compteur>1} {
                foreach item [split $line] { if {$item != ""} {
                        incr lignes
                        append datos "[string trim $item]\t"
                    }
                }
            } else {set references $line}
        }
        #set colcount [llength $line]
        set rowcount [expr {$lignes/$colcount}]
        set result [concat 2 $rowcount $colcount $datos]
        #
        # Les donnees sont dans la variable 'result' sous la forme d'une matrice de HUME
        #
        set premligne $references
        # -- Formater le commentaire
        # -- 1. Enlever d'eventuelles tabulations
        foreach mot $references {
            if {$mot != ""} {
                append comentario_sin_tab "$mot "
            }
        }
        set references $comentario_sin_tab
        # -- 2. Introduire des passages a la ligne (\n)
        set compteur 0
        set nbcaract [string length $references]
        #
        if {$nbcaract > 80} {
            while {$compteur < $nbcaract} {
                incr compteur
                if {[expr $compteur % 80] != 0} {
                    append newref [string index $references [expr {$compteur-1}] ]
                } else {
                    append newref "[string index $references [expr {$compteur-1}] ] - \n"
                }
            }
        } else  {
            set newref $references
        }
        # v 74f: J'annule ce formatage, sauf l'enlevement des tabulations
        set references $comentario_sin_tab
        # -- FIN du formatage de la premiere ligne
        #
        return $result;# C'est la matrice de HUME qui est renvoyee
    }
    #
    # Procedure LOADFILE # fin
    
    
    # Procedure FENETRE # debut
    #
    # (DA report Widget)
    #
    proc fenetrage {} {
        global S
        #
        if {[info exists S(mvagrap)]} {
            if {$S(mvagrap) == 1} {
                #
                destroy .mogad
                toplevel .mogad
                wm geometry .mogad 680x550+328+50
                wm title .mogad "Discriminant analysis (mogad)"
                set S(pda) .mogad
                #
            } else  {
                destroy .fogad
                toplevel .fogad
                wm geometry .fogad 680x550+328+50
                wm title .fogad "Discriminant analysis (fogad)"
                set S(pda) .fogad
            }
        };#
        #
        global mogad_p pop lignes infile end moyennes Cperm lambda effectifs individus base_individus
        #
        frame $S(pda).mogad_buttons;## EN BAS DE CETTE FENETRE, UNE FRAME POUR LOGER des BOUTONS
        pack $S(pda).mogad_buttons -side bottom -fill x -pady 2m
        #
        #
        button $S(pda).mogad_buttons.salir -bg red -fg white -text "EXIT" -command {destroy $S(pda)}
        #
        #
        button $S(pda).mogad_buttons.wrap -text "Wrap/Unwrap" -command {
            global drapeau
            if {$drapeau == 1} {
                $S(pda).mogad_debut configure -wrap word; set drapeau 0
            } else {
                $S(pda).mogad_debut configure -wrap none; set drapeau 1
            }
        }
        #
        #
        button $S(pda).mogad_buttons.informe -text "Informe? (report?)" -command {
            #
            if {[info exists lambda] == 1} {
                global infile mogad
                set mogad 1
                mogadiscio::savelisting
                destroy $S(pda).mogad_buttons.informe
                pack $S(pda).mogad_buttons.salir -side left -padx 2 -fill x -expand yes
            } else  {
                tk_messageBox -message "lambda not computed" -type ok
                global infile mogad
                set mogad 1
                mogadiscio::savelisting
            }
        }
        #
        #
        button $S(pda).mogad_buttons.hlp -bg ivory -fg "dark green" -text "HELP" -command {
            # Offrir un peu d'aide - debut
            set accroche "classif_mahalanobis_help.txt"
            set fichierdaide [file join $S(dirscript) $accroche]
            catch [
            set fid [open $fichierdaide r]
            set aide [read -nonewline $fid]
            close $fid
            ] ici
            destroy .avis
            toplevel .avis
            wm geometry .avis +100+100
            message .avis.t -bg ivory -fg "dark green" -aspect 500 -text $aide
            pack .avis.t
            # Offrir un peu d'aide - fin
        }
        #
        #
        button $S(pda).mogad_buttons.adda -text "UNKNOWN ?" -state disabled -command {
            if  {[info exists S(themall)] } {
                #tk_messageBox -message "pourtant" -type ok
                destroy $S(pda).mogad_buttons.adda $S(pda).mogad_buttons.clas  $S(pda).mogad_buttons.factormap
                global mogad_p references moyennes gr lignes
                #
                set taco 0
                set inutile 0
                set pop  [loadfile "[file rootname $infile]_PW_base.txt"]
                #debug
                #mogadiscio::aa "BUTTON EXT ?\nUNKN ?"
                #
                mahaknn::go $pop $inputval2
                mogadiscio::datosadd $pop $Cperm $taco $moyennes $gr $mogad_p $lignes $inutile
            }
        }
        #
        #
        button $S(pda).mogad_buttons.factormap -text "Factorial map" -command {
            global references lignes individus base_individus
            #
            #tk_messageBox -message "Bouton ....factormap" -type ok
            #
            if {[info exists individus] == 1} {
                #
                $S(pda).mogad_buttons.adda configure -state active
                if {$individus == $base_individus} {
                    global pad
                    set pad 1
                    #
                    # Enregistrement des variables (Canonical Vectors) pour une eventuelle etude allometrique
                    set S(individus_cv) $individus
                    #
                    
                    if {[info exists S(mvagrap)]} {
                        if {$S(mvagrap) == 1} {
                            #debug "S(mvagrap) = $S(mvagrap)\t'S(groupes)' = $S(groupes)"
                            dessine $individus $S(grupos)
                        } else {
                            #debug "S(mvagrap) exists ? $S(mvagrap)\t'S(groupes)' = $S(groupes)"
                            gribouille $individus $S(groupes)
                        }
                    } else  {
                        tk_messageBox -message "S(mvagrap) does not exist \n'S(groupes)' = $S(groupes)" -type ok
                        gribouille $individus $S(groupes)
                    }
                    #
                } else  {
                    # individus contient sans doute des individus supplementaires, il faut corriger
                    global pad
                    set pad 1
                    set individus $base_individus
                    #tk_messageBox -message " 'individus' ou 'base_individus' au rendez-vous\n$individus" -type ok
                    # Enregistrement des variables (Canonical Vectors) pour une eventuelle etude allometrique
                    set S(individus_cv) $base_individus
                    if {[info exists S(mvagrap)]} {
                        if {$S(mvagrap) == 1} {
                            dessine $base_individus $S(grupos)
                        } else {
                            gribouille $base_individus $S(groupes)
                        }
                    } else  {
                        #tk_messageBox -message " 'individus' = 'base_individus' au rendez-vous\n$individus" -type ok
                        gribouille $individus $S(groupes)
                    }
                    #
                    $S(pda).mogad_buttons.clas invoke
                    #$S(pda).mogad_buttons.ccc invoke
                }
            } else  {
                tk_messageBox -message "La variable 'individus' n'est pas au rendez-vous" -type ok
            }
            
        }
        #
        #
        # Bouton C: on veut une table de reclassification -- --- -- Les donnees initiales sont utilisees comme donnees externes
        button $S(pda).mogad_buttons.clas -bg "light yellow" -text "C" -command {
            #
            # Ce bouton fera appel a la procedure MOGADISCIO::CLASSIFICATION
            #
            global S moyennes lambda Cperm
            #
            if {[info exists lambda] == 1} {
                # Pour ne pas perdre mon temps a reparer mes erreurs de programmation, cette reclassification annule les fonctions suivantes:
                # # Re-classification
                # # Permutation (avec ou sans Wilks)
                # # Donnees additionnelles (externes)
                # # Carte factorielle
                destroy $S(pda).mogad_buttons.clas
                destroy $S(pda).mogad_buttons.adda
                destroy $S(pda).mogad_buttons.factormap
                #
                global S references
                set S(taco) 0;#signifie que l'analyse inclut la taille
                # L'analyse porte-t-elle sur des donnees transformees ?
                if {$S(taco) == 0} {
                    # Si l'analyse porte sur des donnees non transformees, on peut prevoir le bouton CCC
                    pack $S(pda).mogad_buttons.ccc -side left -expand yes
                }
                #
                pack $S(pda).mogad_buttons.informe -side left -expand yes
                #
                set taco 0;#signifie que l'analyse inclut la taille
                set inutile 0;# rien d'inutile en ce bas monde
                #
                # Appel a la procedure MOGADISCIO::CLASSIFICATION
                #
                if {[info exists S(mvagrap)]} {
                    if {$S(mvagrap) == 1} {
                        mogadiscio::classification $pop $Cperm $taco $moyennes $gr $mogad_p $lignes $inutile $S(grupos)
                    } else  {
                        mogadiscio::classification $pop $Cperm $taco $moyennes $gr $mogad_p $lignes $inutile $S(groupes)
                    }
                } else  {
                    #tk_messageBox -message "S(mvagrap) n'existe pas ... Normal ca???" -type ok
                    mogadiscio::classification $pop $Cperm $taco $moyennes $gr $mogad_p $lignes $inutile $S(groupes)
                }
                
                #
                #
                # EXPLICATIONS # ----------------------------------------------------------
                #
                # pop            -> donnees;
                # C              -> vecteurs canoniques, utiles en cas de donnees supplementaires;
                #         (Pour rappel, C = EE*, avec E* ajuste a 1);
                #         (Pour rappel : 'mmult pop C' nous donne les facteurs canoniques);
                # taco           -> 0 signifie que l'analyse inclut la taille;
                # moyennes       -> les moyennes dans chaque groupe;
                # gr             -> le nombre de groupes pour l'analyse discriminante;
                # mogad_p        -> fenetre de texte pour le rapport de l'analyse ($S(pda).mogad_debut);
                # lignes         -> le nombre total d'individus;
                # inutile        -> se refere aux composantes de conformation inutilisees.
                #
                # EXPLICATIONS # ----------------------------------------------------------
                #
            }
            if {[info exists S(danef)]} {
                # if {$S(danef) == 1} {tk_messageBox -message "Vaudrait pe mieux pas..." -type ok}
            } else  {
                #tk_messageBox -message "C'etait: DA from MVA after GRAPH" -type ok
            }
            $S(pda).mogad_buttons.ccc invoke;# ce bouton ... ... .ccc "detruit" les (autres) boutons de classification
            #$S(pda).mogad_buttons.ccc configure -state disabled
        }
        #
        # Bouton CCC pour 'Cross Checked Classification'
        # Chaque individu classe a ete retire des donnees avant l'analyse discriminante
        #
        button $S(pda).mogad_buttons.ccc -bg "light yellow" -text "CCC" -command {
            global mogad_p S infile end text lignes colonnes references gr effectifs
            #tk_messageBox -message "Bouton ... ... .CCC..." -type ok
            if {[info exists pop] == 1} {
                # 'pop' est une variable globale annoncee au debut de la procedure FENETRAGE
                global classification
                if {$classification == 1} {
                    #
                    # 'classification' est une variable globale de type "drapeau", creee dans la procedure CLASSIFICATION
                    #
                    # A present on utilise varcrochecla indiv lessindiv dans la procedure varccc
                    #
                    #set namefile [file rootname $infile];#ajout discriminatoire
                    #set filename $namefile$end;#ajout discriminatoire
                    #set fid [open $filename];#ajout discriminatoire
                    #set text [read -nonewline $fid];#ajout discriminatoire
                    #close $fid;#ajout discriminatoire
                    #debug "\nTEXT (old POUDRE)\n$text"
                    #tk_messageBox -message "On ouvre $filename" -type ok;# <- il s'agit de ..._FOGcpsf.txt ou de ... ??
                    # ----------------------------------------------------------------------------------------------------------------------------
                    #  Encore une fois, c'est S(damat) qui s'impose <- FOG ou ??
                    #  ----------------------------------------------------------------------------------------------------------------------------
                    set text ""
                    append text "$references \n[show $S(damat)]"
                    #debug "\n\nTEXT (future POUDRE)\n$text\n"
                    # ----------------------------------------------------------------------------------------------------------------------------
                    # S(damat) est cree dans daotl_sf ou _si ou ??
                    # ----------------------------------------------------------------------------------------------------------------------------
                    mogadiscio::varccc $text
                    set S(daclass) 1;# pour empecher la reapparition des boutons de classification
                    destroy $S(pda).mogad_buttons.clas $S(pda).mogad_buttons.ccc $S(pda).mogad_buttons.adda $S(pda).mogad_buttons.factormap
                } else  {
                    tk_messageBox -message "Simple classification could not be performed" -type ok
                }
            } else  {
                tk_messageBox -message "No 'pop' to work on" -type ok
            }
        };# fin du bouton CCC
        
        
        # Gestion du fenetrage
        #
        if {$S(button_DAclassification) == 1} {
            pack \
                    $S(pda).mogad_buttons.wrap \
                    $S(pda).mogad_buttons.informe \
                    $S(pda).mogad_buttons.hlp\
                    $S(pda).mogad_buttons.salir\
                    -side left -expand 1
            set S(button_DAclassification) 0
        } else  {
            pack \
                    $S(pda).mogad_buttons.wrap \
                    $S(pda).mogad_buttons.informe \
                    $S(pda).mogad_buttons.factormap \
                    $S(pda).mogad_buttons.clas\
                    $S(pda).mogad_buttons.salir\
                    -side left -expand 1
            if {[info exists S(button_DAProcrCp)]} {
                
                if {$S(button_DAProcrCp) == 1} {
                    set S(button_DAProcrCp) 0
                } else  {
                    set S(button_DAPW) 0
                }
            } else  {
                set S(button_DAPW) 0
            }
        }
        #
        # Gestion du fenetrage - fin
        
        ## A GAUCHE DE LA FENETRE, UNE BARRE de PROGRESSION
        set scb [scrollbar $S(pda).mogad_scrollA -command "$S(pda).mogad_debut yview"];
        pack $scb -side left -fill y
        #
        ## PUIS ENFIN LE TEXTE il n'est plus necessaire d'indiquer -SIDE, mais -FILL BOTH
        set pres [text $S(pda).mogad_debut -background ivory -font "courier 12" \
                -yscrollcommand "$S(pda).mogad_scrollA set"];
        pack $pres -fill both -expand 1
        #
        ## LE NOM DE LA SOUS-FENETRE DE TEXTE ($S(pda).mogad_debut) DANS UNE VARIABLE (mogad_p)
        global lignes
        global colonnes
        set mogad_p $S(pda).mogad_debut
        update
        #
        #global individus
        #$S(pda).mogad_buttons.factormap invoke
        
    }
    #
    # Procedure FENETRAGE -- fin
    
    
    #
    # ################### bleu ##### Procedure ## Debut ##
    proc bleu {mesg args} {
        global mogad_p
        $mogad_p insert end $mesg "bleu"
        update
        flush stdout
        $mogad_p tag configure bleu -foreground blue
    }
    
    ################### bleu ####### PROCEDURE ## FIN ###
    
    
    ################### vert ##### Procedure ## Debut ##
    proc vert {mesg args} {
        global mogad_p
        $mogad_p insert end $mesg "vert"
        update
        flush stdout
        $mogad_p tag configure vert -foreground "dark green"
    }
    ################### vert ####### PROCEDURE ## FIN ###
    
    
    ################### rouge ##### Procedure ## Debut ##
    proc rouge {mesg args} {
        global mogad_p
        $mogad_p insert end $mesg "rouge"
        update
        flush stdout
        $mogad_p tag configure rouge -foreground red
    }
    ################### rouge ####### PROCEDURE ## FIN ###
    
    
    
    # Procedure SAVELISTING # debut
    proc savelisting {} {
        # *******************************************
        # Tentative d'ecriture d'un fichier DE RAPPORT
        # *******************************************
        global S p mogad_p mogad
        global infile
        set namefile [file rootname $infile]
        set megainfo "\n$namefile Informe de FOG\n"
        #set megatexte [$p get 1.0 {end}]
        #
        if {[info exists mogad]} {
            set megatexte [$S(pda) get 1.0 {end}]
            #debug "megatexte ...\n$megatexte"
            set ending "_Discrimination_INFO.txt"
            unset mogad
        } else  {
            set megatexte [$p get 1.0 {end}]
            set ending "_FOG_INFO.txt"
        }
        set filename [concat $namefile $ending]
        $p insert end "\n\nINFORME saved in \n$filename\n"
        # OPEN THE FILE
        set fileid [open $filename a]
        # FILL THE FILE
        puts -nonewline $fileid $megainfo
        puts -nonewline $fileid "$megatexte"
        # CLOSE THE FILE
        close $fileid
    }
    ###################################################################
    
    
    
    #######################################################
    #####procedure scaleLengthEigenvect ####debut##########
    proc scaleLengthEigenvect {eigenvect weightedevals} {
        
        update
        flush stdout
        
        global p
        global long
        
        # ---------------------------------------------------------------------------------
        # The eigenvectors weighted so that their lengths are equal to sqrt (weightedevals)
        # ---------------------------------------------------------------------------------
        set colonnes [llength $weightedevals]
        set nblignes [mrows $eigenvect]
        set V $eigenvect
        #$mogad_p insert end "\nPROCEDURE scaleLengthEigenvect (parcialmente)\n[show [mrange $V 0 1 0 1]]\
        #        \n$nblignes lignes \
        #        \n$colonnes colonnes\n"
        
        # 1 - mettre en memoire le signe de chaque coefficient
        set listevect [lrange [transpose $V] 3 end];# passage d'une matrice a une liste
        #$mogad_p insert end "\nVecteur : $listevect"
        for  {set i 0} {$i < [expr $colonnes * $nblignes]} {incr i} {
            set dire [lindex $listevect $i]
            #$mogad_p insert end "\nElement $i du vecteur : $dire"
            catch {
                lappend signedlistevect [expr $dire/abs($dire)]
            }
        }
        
        # 2 - elever chaque coefficient de chaque eigenvect au carre
        set listevect [lrange [transpose $V] 3 end];# passage d'une matrice a une liste
        for  {set i 0} {$i < [expr $colonnes * $nblignes]} {incr i} {
            set dire [lindex $listevect $i]
            lappend carrelistevect [expr ($dire * $dire)]
        }
        
        # 3 - multiplier chaque coefficient par la somme de l'eigenvecteur correspondant\
        #    (weightedevals)
        # 4 - en extraire la racine carree (expr sqrt)
        # 5 - restaurer le signe du coefficient
        
        set listevect [lrange [transpose $V] 3 end];# passage d'une matrice a une liste
        #debug
        # $mogad_p insert end "\n\nLe listevect contient [llength $listevect] elements \tcolonnes = $colonnes"
        for  {set c 0} {$c < $colonnes} {incr c} {
            for  {set i 0} {$i < [expr $nblignes]} {incr i} {
                set ajustement [lindex $weightedevals $c];
                set dire [lindex $carrelistevect [expr $i+($c*$nblignes)]];
                set signe [lindex $signedlistevect [expr $i+($c*$nblignes)]];
                #$mogad_p insert end "\n$dire MULTIPLIE PAR $ajustement ET PAR $signe";
                catch {
                    lappend scaledlistevect [expr sqrt($dire * $ajustement) * $signe]
                }
            }
        }
        #debug
        # $mogad_p insert end "\n\nLe scaledlistevect contient [llength $scaledlistevect] elements"
        return $scaledlistevect
        
    }
    #
    # Procedure scaleLengthEigenvect #### FIN #######
    
    
    
    # Procedure INC_PRINCIPALE # debut
    #
    proc inc_principale {population groupuscules} {
        
        global mogad_p pop infile end covT gr lignes colonnes ouaip effectifs
        global references premligne colcount rowcount S
        global individus base_individus
        
        set pop $population
        set effectifs $groupuscules
        
        set gr [llength $effectifs]
        
        
        #
        # ------------------------------------------------- Procedure mogadiscio::INC_principale
        #
        # QUELQUES STATISTIQUES SUR LA MATRICE pop UTILISEE
        # -------------------------------------------------
        #
        set ouaip 0
        set lignes [mrows $pop]
        #$mogad_p insert end "\n\n$lignes\t"
        #bleu "Nombre total d'individus"
        set colonnes [mcols $pop]
        #$mogad_p insert end "\n$colonnes\t"
        #bleu "Nombre de variables"
        #
        # MOYENNES ET DEVIATIONS STANDARD DES VARIABLES
        mnorms_br pop popmeans popsigma
        #$mogad_p insert end "\n\nGrand Means [show $popmeans %8.6f]"
        #
        # CREER n-1 POUR CALCULER (plus tard) LES eigenvalues
        set obsminusone [expr {$lignes - 1}]
        #
        # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
        # IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
        set popones "2 1 $colonnes 1"
        set x 1
        set y $colonnes
        while {$x < $y} {lappend popones 1; set x [expr $x + 1]}
        #
        # ----------------------------------------
        # MATRICE VAR - COVAR de la MATRICE TOTALE
        # ----------------------------------------
        #
        # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
        set Z [mnormalize $pop $popmeans $popones]
        #
        # MATRICE des VARIANCES - COVARIANCES
        set ZZ [mmult [transpose $Z] $Z]
        set covT $ZZ
        #
        # Appel a la procedure discrimin
        mogadiscio::discriminatoire $pop $gr $lignes $colonnes $effectifs $covT
    }
    # Procedure INC_PRINCIPALE # fin
    
    
    # Procedure PRINCIPALE # debut
    #
    proc principale {population groupuscules} {
        
        global mogad_p S pop
        global infile end
        global covT gr lignes colonnes ouaip
        #global effectifs
        global references premligne colcount rowcount
        global individus base_individus
        
        ################################################################################
        #         if {[info exists S(daclass)] != 1} {
        #             fenetrage
        #         } else {
        #             tk_messageBox -message "Some functions could be abandoned" -type ok
        #             fenetrage
        #         }
        ################################################################################
        fenetrage
        
        set pop $population
        set effectifs $groupuscules;# voila pourquoi votre fille est muette
        #
        set gr [llength $groupuscules]
        
        if {[info exists S(themall)]} {
            if {[info exists S(ProcrCp)]} {
                rouge "\
                        \n-----------------------------------------------------------\
                        \nDiscriminant analysis performed on the Principal Components,\
                        \nIt is the reference, original file without addition of the unknowns.\
                        \n-----------------------------------------------------------\n"
                unset S(ProcrCp)
            } else  {
                rouge "\
                        \n-----------------------------------------------------------\
                        \nThe ... of the reference individuals were computed including the unknown data\
                        \n-----------------------------------------------------------\n"
            }
        } else  {
            if {[info exists S(cp)]} {
                rouge "\
                        \n-----------------------------------------------------------\
                        \nDiscriminant analysis performed on the principal components of the Fourier coefficients,\
                        \n-----------------------------------------------------------\n"
            } else  {
                rouge "\
                        \n-----------------------------------------------------------\
                        \nCheck your sample sizes to verify statistical acceptance.\
                        \n-----------------------------------------------------------\n"
            }
        }
        #
        # -------------------------------------------------
        # Procedure mogadiscio::principale
        # QUELQUES STATISTIQUES SUR LA MATRICE pop UTILISEE
        # -------------------------------------------------
        #
        set ouaip 0
        set lignes [mrows $pop]
        $mogad_p insert end "\n\n$lignes\t\t"
        bleu "Total sample"
        set colonnes [mcols $pop]
        $mogad_p insert end "\n$colonnes\t\t"
        bleu "Number of variables"
        $mogad_p insert end "\n$groupuscules\t\t"
        bleu "Groups"
        $mogad_p insert end "\n(Check sample sizes to verify statistical acceptance)"
        #
        # MOYENNES ET DEVIATIONS STANDARD DES VARIABLES
        mnorms_br pop popmeans popsigma
        $mogad_p insert end "\n\nGrand Means [show $popmeans %8.6f]"
        #
        # CREER n-1 POUR CALCULER (plus tard) LES eigenvalues
        set obsminusone [expr {$lignes - 1}]
        #
        # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
        # IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
        set popones "2 1 $colonnes 1"
        set x 1
        set y $colonnes
        while {$x < $y} {lappend popones 1; set x [expr $x + 1]}
        #
        # ----------------------------------------
        # MATRICE VAR - COVAR de la MATRICE TOTALE
        # ----------------------------------------
        #
        # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
        set Z [mnormalize $pop $popmeans $popones]
        #
        # MATRICE des VARIANCES - COVARIANCES
        set ZZ [mmult [transpose $Z] $Z]
        set covT $ZZ
        #
        # Appel a la procedure discrimin
        #tk_messageBox -message "effectifs = groupuscules == $effectifs == $groupuscules" -type ok
        mogadiscio::discriminatoire $pop $gr $lignes $colonnes $groupuscules $covT
    }
    # procedure PRINCIPALE - fin
    
    
    # Procedure DATOSADD ... - Debut
    #
    # Travail sur des donnees externes (supplementary data)
    #
    proc datosadd {pop C taco moyennes gr mogad_p lignes inutile} {
        
        global S
        global infile references premligne adda
        global CoeffShapeACP cpmeans perper sentier
        global base_lignes base_gr effectifs base_effectifs;# adda_lignes enleve
        global boitalettres suppl
        
        set suppl 1
        
        destroy .pad
        toplevel .pad
        wm geometry .pad 270x30+480+410
        button .pad.buttxt -relief sunken -text "Progresion" -anchor w
        pack .pad.buttxt -side left -fill both -expand 1
        
        append references "\tDatos externos:\t"
        
        # ---------------------------------------------
        # ouvrir le fichier des donnees supplementaires
        # ---------------------------------------------
        set namefile [file rootname $infile]
        set end "_PW_unkn.txt"
        set adda_infile $namefile$end
        # On signale ce qu'on fait
        $mogad_p insert end "\n===============================================\
                \nDiscriminant analysis, supplementary data: $adda_infile \n\
                If you want another external data file, you must create it before the CLIC analysis, \
                \nand preferably give it this extension (_PW_unkn.txt)\
                \n=============================================\n"
        #
        if {$adda_infile == $infile} {set ouaip 1}
        # --------------------------------------------------------
        # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE adda (au format 'Hume')
        # --------------------------------------------------------
        set adda [loadfile "$adda_infile"]
        # ---------------------------------------------------------------
        # Quelques STATISTIQUES sur la matrice des donnees additionnelles
        # ---------------------------------------------------------------
        set adda_colonnes [mcols $adda]
        set adda_lignes [mrows $adda]
        if {$adda_lignes > 1} {
            $mogad_p insert end "\n-----------------------------------------------------------------------------\
                    \nExisten datos additionnelles para $adda_lignes individuos\
                    \n(Estos individuos se llaman ahora : _[expr $gr+1], etc.)\
                    \n(cfr. $adda_infile)\n\
                    \nSupplementary data now exist for $adda_lignes individuos\
                    \n(They are labeled form _[expr $gr+1], etc.)\
                    \n(cfr. $adda_infile)\n"
        } else  {
            $mogad_p insert end "\n\nExisten datos additionnelles para $adda_lignes individuo\
                    \n(Este individuo se llama ahora : _[expr $gr+1])\
                    \n(cfr. $adda_infile)\n\
                    \nThe additional, external individual is labeled  _[expr $gr+1])\
                    \n(cfr. $adda_infile)\n"
        }
        set base_effectifs $effectifs;# les effectifs initiaux, c'est base_effectifs
        set base_gr $gr;# les groupes initiaux, c'est base_gr
        set base_lignes $lignes;# le nombre de lignes initial, c'est base_lignes
        lappend effectifs $adda_lignes;# a present, la variable 'effectifs' inclut les individus additionnels
        $mogad_p insert end "\n\
                \nNuevos grupos : $effectifs (el ultimo es el numero de 'grupos' addicionales)\
                \nNew groups: $effectifs (the last one is the number of supplementary data)\
                \n=================================================="
        # -------------------
        # redefinir pop
        #
        # adda_pop ne serait que ..._PW_base_unkn.txt ?
        #
        set namefile [file rootname $infile]
        set end "_PW_base_unkn.txt"
        set adda_pop_infile $namefile$end
        $mogad_p insert end "\n\nDiscriminant analysis, initial and supplementary data: \
                $adda_pop_infile \n"
        # USAGE DE LA PROCEDURE loadfile
        # --------------------------------------------------------
        set adda_pop [loadfile "$adda_pop_infile"];# MATRICE adda (au format 'Hume')
        # --------------------------------------------------------
        #
        # ---------------------------------------------------------------
        # Quelques STATISTIQUES sur la matrice totale (initiale, plus les donnees supplementaires)
        set tot_colonnes [mcols $adda_pop]
        set tot_lignes [mrows $adda_pop]
        # -------------------------------
        # Etapa 7/10: Facteurs canoniques
        set tot_facteurs [mmult $adda_pop $C]
        global tot_individus
        set tot_individus "";#dec 2009
        for {set u 0} {$u < $tot_lignes} {incr u} {
            lappend tot_individus [mrange $tot_facteurs 0 end $u $u]
        }
        #
        if {$adda_lignes < 2} {
            set nbfact [expr {$base_gr-1}]
            set factcanouvind [lindex $tot_individus end]
            set oualors [show [mrange $factcanouvind 0 [expr {$nbfact-1}]]]
        } else  {
            set nbfact [expr {$base_gr-1}]
            set factcanouvind [lrange $tot_individus $base_lignes end]
            for  {set q 0} {$q < [lindex $effectifs end]} {incr q} {
                set oualors [lindex $factcanouvind $q]
                set oualors [lindex $oualors 3 end]
            }
            # ------------------------------------------------
            # Statistiques sur les attributions dues aux KPPV
            # ------------------------------------------------
            bleu "\n\n----------------------------"
            bleu "\nSummary - Bilan - Resultados\n"
        }
        
        # On regarde ???
        update
        flush stdout
        set nombredindividus [llength $tot_individus]
        global individus
        set individus $tot_individus
        #source jpdraw_11_3Hsp1.tcl
        #source jpdraw_14.tcl
        dessine $tot_individus
        #
        # Vecteur de 1
        set tot_ones "2 1 $tot_colonnes 1"
        set x 1
        set y $tot_colonnes
        while {$x < $y} {lappend tot_ones 1; set x [expr $x + 1]}
        #
        # --------------------------------
        # Calcul des centres de gravite
        # tout individu supplementaire devient une moyenne differente
        # donc il faut un nombre de groupes different
        #
        set adda_gr [expr $gr + $adda_lignes]
        #
        set tot_Moy "2 $gr $tot_colonnes"
        set gr $adda_gr
        foreach item [split $moyennes] {lappend tot_Moy $item}
        set tot_Moy [join_rows $tot_Moy $adda]
        #
        mnorms_br tot_Moy tot_Moymeans tot_Moysigmas
        set tot_MoyC [mnormalize $tot_Moy $tot_Moymeans $tot_ones]
        set groupes [mrows $tot_MoyC]
        #
        # -------------------------------------------------
        # Etapa 10/10: Calcul des distances de Mahalanobis"
        #
        # scores canoniques
        set cansco [mmult $tot_MoyC $C]
        #$p insert end "\n\nThe matrix of canonical scores =\n [show $cansco %8.4f]"
        global drapeau
        set drapeau " datosadd"
        set tot_distobs [gendist $cansco]
        set new_lignes [mrows $tot_MoyC]
        destroy .pad
        # -------------------------------------------------
        # Etapa 11: Presentation LOCALE des distances de Mahalanobis
        # si on a demande l'analyse APRES les permutations cfr. if {info exists perper] == 1}
        if {[info exists perper] == 1} {
            $mp insert end "\n\nDistancias de Mahalanobis (por pares)\n"
            $mogad_p insert end "\n$tot_distobs"
            set long [llength $tot_distobs]
            #Ici je cree une table de ZEROs selon nombre de groupes
            for {set i 0} {$i < $new_lignes} {incr i} {
                for {set j 0} {$j < $new_lignes} {incr j} {
                    set tabdis($i,$j) 0
                }
            }
            #Ici je place les distances en dessous de la diagonale
            set passage -1
            set compteur 0
            for {set i 0} {$i < $long} {incr i} {
                incr passage
                for  {set k 1} {$k < [expr {$new_lignes - $passage}]} {incr k} {
                    set maha [lindex $tot_distobs $compteur]
                    set compteur [expr $compteur + 1]
                    $mogad_p insert end "\nEntre _[expr $i+1] et _[expr $i+$k+1]:\t[format %3.2f $maha]"
                    set tabdis($i,[expr $i+$k]) $maha
                }
            }
            #Ici je cree la table au-dessus de la diagonale
            for {set i 0} {$i < $new_lignes} {incr i} {
                for {set j [expr $i+1]} {$j < $new_lignes} {incr j} {
                    set tabdis($j,$i) $tabdis($i,$j)
                }
            }
            #Ici je presente la table des distances
            $p insert end "\n\nDistances de Mahalanobis (Tabla)"
            for {set i 0} {$i < $new_lignes} {incr i} {
                $mogad_p insert end "\n"
                for {set j 0} {$j < $new_lignes} {incr j} {
                    set bof [format %3.4f $tabdis($j,$i)]
                    $mogad_p insert end "$bof\t"
                }
            }
            $p insert end "\n"
        }
        
        # PREPARATION DU BILAN DES DISTANCES - DEBUT -
        #
        # IDENTIFICATION DES UNKNOWN
        set long [llength $tot_distobs]
        set passage -1
        set compteur 0
        for {set i 0} {$i < $long} {incr i} {
            incr passage
            for  {set k 1} {$k < [expr {$new_lignes - $passage}]} {incr k} {
                set maha [lindex $tot_distobs $compteur]
                set a [expr $i+1]
                set b [expr $i+$k+1]
                set compteur [expr $compteur + 1]
                if {$a < [expr {$base_gr+1}]} {
                    if {$b > $base_gr} {
                        set tabsortdis($a,$b) $maha
                    }
                }
                set tabdis($i,[expr $i+$k]) $maha
            }
        }
        for  {set j [expr {$base_gr+1}]} {$j < [expr {$adda_gr+1}] } {incr j} {
            for  {set i 1} {$i < [expr {$base_gr+1}]} {incr i} {
                append sortdis($j) "$tabsortdis($i,$j) "
            }
        }
        bleu "\n\n\nTENTATIVE IDENTIFICATION of UNKNOWN\n"
        bleu "(using Mahalanobis distances between unknown(s) and each group)\n"
        $mogad_p insert end "The first value indicates the group \
                to which the unknown has been assigned"
        $mogad_p insert end "\nThe second value indicates the next closest group."
        # Premiere attribution
        for  {set j [expr {$base_gr+1}]} {$j < [expr {$adda_gr+1}] } {incr j} {
            # j va du premier individu additionnel au dernier
            #
            # sortdis(j) contient les distances de chaque individu additionnel (j) aux groupes initiaux
            # ces distances sont listees dans l'ordre des groupes auxquels elles se referent
            # donc a present on chosit la plus petite des distances (min)
            set ordre [lsort -real $sortdis($j)]
            set min [lindex $ordre 0]
            for  {set k 0} {$k < $base_gr} {incr k} {
                # et on regarde quelle place (k) occupait cette distance minimum (min)...
                # cette place indique le groupe auquel doit etre identifie l'individu additionnel
                if {$min == [lindex $sortdis($j) $k]} {
                    append id_unknown($j) "[expr {$k+1}]"
                }
            }
        }
        # Deuxieme attribution
        for  {set j [expr {$base_gr+1}]} {$j < [expr {$adda_gr+1}] } {incr j} {
            set ordre [lsort -real $sortdis($j)]
            set suivant [lindex $ordre 1]
            for  {set k 0} {$k < $base_gr} {incr k} {
                if {$suivant == [lindex $sortdis($j) $k]} {
                    append id_unknown($j) ", [expr {$k+1}]"
                    if {$adda_lignes > 1} {
                        lappend addindiv($j) $id_unknown($j)
                    }
                }
            }
        }
        update
        flush stdout
        for  {set j [expr {$base_gr+1}]} {$j < [expr {$adda_gr+1}] } {incr j} {
            bleu "\n(Unknown) _$j :\t"
            bleu "$id_unknown($j)"
        }
        # PREPARATION DU BILAN DES DISTANCES - FIN de l'IDENTIFICATION des UNKNOWN
        
        # TABLE de RAPPORT - debut
        update
        flush stdout
        if {$adda_lignes > 1} {
            set pul 0
            for {set g 0} {$g < $base_gr} {incr g} {
                set repattrFirst($g) 0
                set repattrSecond($g) 0
            }
            for  {set i 0} {$i < $adda_lignes} {incr i} {
                set sel [string range $addindiv([expr {$i+1+$base_gr}]) 1 1]
                # On comptabilise chaque occurence
                # Par exemple 8 pour repattr(4) si le groupe 4 apparait 8 fois
                for {set k 0} {$k < $base_gr} {incr k} {
                    if {$sel == [expr {$k+1}]} {
                        incr repattrFirst($k)
                    }
                }
                # seconde attribution
                set sel [string range $addindiv([expr {$i+1+$base_gr}]) 4 4]
                # On comptabilise chaque occurence
                # Par exemple 8 pour repattr(4) si le groupe 4 apparait 8 fois
                for {set k 0} {$k < $base_gr} {incr k} {
                    if {$sel == [expr {$k+1}]} {
                        incr repattrSecond($k)
                    }
                }
            }
            
            # lecture des resultats de premiere attribution
            bleu "\n\n------------------------\n"
            bleu "\nFIRST instance, Number of assignations to"
            for  {set g 0} {$g < $base_gr} {incr g} {
                bleu "\n group [expr {$g+1}] :\t$repattrFirst($g)\
                        \t([expr {int(100*$repattrFirst($g)*(1.0/$adda_lignes))}] %)"
            }
            bleu "\n------------------------\n"
            # TABLE de RAPPORT - FIN
        }
        #debug
        $mogad_p insert end "\n\nComments of the Files used in this study\
                \nComentarios de los archivos utilizados en este analisis\
                \n$premligne"
        #
        # restaurer la valeur initiale de certaines variables
        set gr $base_gr
        set effectifs $base_effectifs
    }
    #
    # Procedure DATOSADD ... - FIN
}
#
# MOGADISCIO - fin de l'espace de nommage




################### bleu ##### Procedure ## Debut ##
proc bleu {mesg args} {
    global p
    $p insert end $mesg "bleu"
    $p tag configure bleu -foreground blue
}

################### bleu ####### PROCEDURE ## FIN ###

################### rouge ##### Procedure ## Debut ##
proc rouge {mesg args} {
    global p
    $p insert end $mesg "rouge"
    $p tag configure rouge -foreground red
}

################### rouge ####### PROCEDURE ## FIN ###

################### vert ##### Procedure ## Debut ##
proc vert {mesg args} {
    global p
    $p insert end $mesg "vert"
    $p tag configure vert -foreground "dark green"
}

################### vert ####### PROCEDURE ## FIN ###


# Procedure SUMLIST - END
#
proc sumlist {liste} {
    set sommeliste 0
    foreach item $liste {
        set sommeliste [expr {$sommeliste + $item}]
    }
    return $sommeliste
}

#
# Procedure SUMLIST - END


# Procedure ASKFORG
#
proc askforg {long} {
    global S zut
    set zut $long
    destroy .afg
    toplevel .afg
    wm geometry .afg 300x100+300+100
    wm title .afg "group sizes"
    frame .afg.f -bg yellow
    pack .afg.f -expand yes
    label .afg.f.l -text "Subdivision ? ($zut data)"
    entry .afg.f.e -textvariable S(grupos)
    pack .afg.f.l .afg.f.e -side top -expand 1 -fill both
    focus -force .afg.f.e
    button .afg.f.ok -text "OK" -command {
        if {[sumlist $S(grupos)] != $zut} {
            tk_messageBox -message "The sum does not match the total ($zut data)" -type ok
            return
        }
        #tk_messageBox -message "Groups are $S(grupos)" -type ok
        set S(otu) $S(grupos)
        unset zut
        destroy .afg
    }
    pack .afg.f.ok -side bottom -expand 1 -fill both
    tkwait window .afg.f.ok
}
#
# Procedure ASKFORG


# Procedure ENTRADA - start
#
proc entrada {pop infile} {
    
    global p references
    $p insert end "\nCALCUL DES COEFFICIENTS DE FOURIER"
    # En rouge on ecrit le commentaire du fichier de donnees
    rouge "\n\n$infile \n"
    rouge "\n$references\n"
    update
    set colonnes [mcols $pop]
    set lignes [mrows $pop]
    
    # En bleu on ecrit les premieres lignes et colonnes du fichier de donnees ...
    #bleu "\nArchivo contenido (parcialmente):"
    #$p insert end "\n[show [mrange $pop 0 [expr {$colonnes - 1} ] 0 4 ] ] \netc. \n"
    update
    #vert "\nSON LOS DATOS LOGARITMOS NATURALES ? \n"
    
    # ... et d'autres infos sur ce fichier
    bleu "\nNumero de variables =\t"
    $p insert end "$colonnes\n"
    
    bleu "\nNumero de individuos =\t"
    $p insert end "$lignes\n"
}
#
# Procedure ENTRADA - fin


# Procedure WHICHMATRIX - start
#
proc whichmatrix {} {
    global p infile dossier
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
        {{"All Files"} {.*}}
    }
    set infile [chemin];# usage de la procedure CHEMIN : memoire des dossiers anterieurs
    #
    # VERIFIER _OTL.txt
    if {$infile == ""} {
        return
    } else  {
        if {[string first  "_OTL" $infile] < 0} {
            set answer [tk_messageBox -message "Sure this ([file tail $infile]) is an outline contour file to be open by FOG?" -type yesno]
            switch -- $answer {
                yes {}
                no {exit}
            }
        }
    }
    
    #
    set x [loadfile $infile]; # usage de la procedure LOADFILE
    
    if {$x != ""} {
        
        entrada $x $infile;# usage de la procedure ENTRADA: presentation de la matrice loadee
        $p insert end "\nMatrix X:\t----------------------------------start---\n"
        #$p insert end [show $x %8.3f]
        if {[mrows $x] < 30} {
            $p insert end "\nMATRICE des POINTS - LE PREMIER POINT EST LE CENTROIDE\n[show $x %8.1f]"
        } else  {
            $p insert end "\n\n[show [mrange $x 0 end 0 29] %8.3f] \n...\netc. etc.\n"
        }
        $p insert end "\nMatrix X:\t----------------------------------end----\n\n"
    }
    return $x
}
#
# Procedure WHICHMATRIX - end


# Procedure ENTRADA_OTL - start
#
proc entrada_otl {pop infile} {
    #
    global S p fp references otl otl_contour otl_liste harm_nb
    set p .muestreo.debut
    $p insert end "\nCALCUL DES COEFFICIENTS DE FOURIER - METHODE ELLIPTIQUE\n"
    # En rouge on ecrit le commentaire du fichier de donnees
    rouge "\n\n$infile"
    bleu "\n$references\n"
    update
    #tk_messageBox -message "otl_nb = $otl_nb ?" -type ok
    for {set i 0} {$i < $S(otl_nb)} {incr i} {
        append otl_liste "$otl($i) "
    }
    if {$S(otl_nb) < 2} {
        tk_messageBox -message "FOG can estimate a single contour, \nhowever multivariate analyses will generate error messages" -type ok
        $fp.menus.ere configure -state active
    }
    rouge "\n$S(otl_nb) outlines with the following number of points (including centroid point, as first 2 coordinates): \n$otl_liste"
    set otl_liste_ordre [lsort -real -increasing $otl_liste]
    set harm_nb [expr {(([lindex $otl_liste_ordre 0] - 2) * 1 / 2) - 1 }];# pour harmoniser les matrices d'harmoniques
    if {$harm_nb > 29} {set S(harm_nb) 29;set harm_nb 29}
    
}
#
# Procedure ENTRADA_OTL


# Procedure WHICHFOG - start
#
# pour entrer les coefficients de Fourier
#
proc whichfog {} {
    #
    global p infile dossier otl otl_contour
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
        {{"All Files"} {.*}}
    }
    set infile [chemin];# usage de la procedure CHEMIN : memoire des dossiers anterieurs
    #
    # VERIFIER _FOG.txt
    if {$infile == ""} {
        #tk_messageBox -message "On fatigue?" -type ok
        return
    } else  {
        if {[string first  "_FOG" $infile] < 0} {
            set answer [tk_messageBox -message "Sure this ([file tail $infile]) is containing Perimeters and Fourier coefficients?" -type yesno]
            switch -- $answer {
                yes {}
                no {exit}
            }
        }
    }
    
    #
    set x [loadfile $infile]; # usage de la procedure LOADFILE
    #
    if {$x != ""} {
        entrada $x $infile;# usage de la procedure ENTRADA: presentation breve des donnees
    }
    return $x
}
#
# Procedure WHICHFOG - end

# Procedure WHICHOTL - start
#
# pour entrer les OTL (outlines)
#
proc whichotl {} {
    #
    global p infile dossier otl otl_contour
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
        {{"All Files"} {.*}}
    }
    set infile [chemin];# usage de la procedure CHEMIN : memoire des dossiers anterieurs
    #
    # VERIFIER _OTL.txt
    if {[string first  "_OTL" $infile] < 0} {
        set answer [tk_messageBox -message "Sure this ([file tail $infile]) is an outline contour file to be open by FOG?" -type yesno]
        switch -- $answer {
            yes {}
            no {exit}
        }
    }
    #
    set x [loadotl $infile]; # usage de la procedure LOADOTL
    # LOADOTL genere otl() points, la liste de coordonnees otl_contour(), le nb d'individus S(otl_nb) et le fichier .DTA pour EFAW
    # Le x retourne par LOADOTL sont les coordonnees dans le format .DTA !! avec une premiere ligne = le commentaire
    #debug "x= \n$x"
    if {$x != ""} {
        entrada_otl $x $infile;# usage de la procedure ENTRADA_OTL: presentation breve des donnees
    }
    # ENTRADA genere otl_liste qui est la liste du nombre de points de chaque figure...
    return $x
}
#
# Procedure WHICHOTL - end

# Procedure CHEMIN -start
#
proc chemin {} {
    
    global p S dossier
    
    if {[info exists dirinfile] == 0} {
        set dirinfile [pwd]
    }
    
    # ----------------------------------------------------
    # Nom du FICHIER et son CHEMIN (path) CORRESPONDANT
    # ---------------------------------------------------
    #
    # Chercher sa route dans un fichier de configuration:
    # il y en a un dans le dossier FOG (chemin), et un dans le dossier CLIC (route)
    # dans le dossier FOG
    set chemin "[pwd]/dossier_fog.txt"
    # dans le dossier CLIC
    set route $S(dirclic)/dossier_CLIC.txt
    #
    # On lit d'abord le fichier dossier_CLIC, s'il existe
    # sinon
    # on lit le fichier du script, s'il existe
    #
    # 1. verifier que les fichiers de routage existent
    if {[file exists $route] == 0} {
        # dans le cas ou il n'y a pas de fichier de routage dans le dossier CLIC
        set candidat_dossier_CLIC [pwd]
        catch [
        set fid [open $route w+]
        puts -nonewline $fid "Dernier dossier de donnees:\n"
        puts -nonewline $fid [pwd]
        close $fid
        ] ici
    } else  {
        # 3. si le fichier de routage existe dans le dossier CLIC, reccueillir alors le dernier chemin parcouru
        # open le fichier pour lire
        catch [
        set fid [open $route r]
        set candidat_dossier_CLIC [read -nonewline $fid]
        close $fid
        ] ici
        set candidat_dossier_CLIC [lindex [split $candidat_dossier_CLIC \n] 1]
        #debug "\ndossier selon CLIC = $candidat_dossier_CLIC"
    }
    
    #debug "chemin $chemin"
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
        set candidat_dossier [pwd]
    } else  {
        # 3. si le fichier de routage du script FOG existe, reccueillir le dernier chemin parcouru
        # open le fichier pour lire
        catch [
        set fid [open $chemin r]
        set candidat_dossier [read -nonewline $fid]
        close $fid
        ] ici
        set candidat_dossier [lindex [split $candidat_dossier \n] 1]
    }
    
    # A present, on a le choix entre candidat_dossier_CLIC et candidat_dossier
    if {$candidat_dossier_CLIC != "./"} {
        #debug "Pas PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        # si le dossier_CLIC n'est pas le dossier en cours (CLIC_XX)
        set candidat_dossier $candidat_dossier_CLIC
        #debug "Pas PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilise par FOG:\n"
        puts -nonewline $fid $candidat_dossier
        close $fid
        ] ici
    } else  {
        # sinon, on adopte le candidat_dossier
        #debug "PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        set candidat_dossier_CLIC $candidat_dossier
        #debug "PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        catch [
        set fid [open $route w+]
        puts -nonewline $fid "Dernier dossier de donnees:\n"
        puts -nonewline $fid $candidat_dossier_CLIC
        close $fid
        ] ici
    }
    
    #
    # On va chercher les donnees
    #
    set typeList {
        {{"Text files"} {.txt .nts .TXT .NTS} }
        {{"All Files"} {.*}}
    }
    set infile [tk_getOpenFile -filetypes $typeList -initialdir $candidat_dossier]
    
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    #
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
        # open le fichier de conf pour ecrire
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilisees par COEFFOU:\n"
        puts -nonewline $fid $dossier
        close $fid
        ] ici
        # open le fichier de conf pour ecrire
        catch [
        set fid [open $route w+]
        puts -nonewline $fid "Dernier dossier de donnees :\n"
        puts -nonewline $fid $dossier
        close $fid
        ] ici
    }
    #
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    #
    # --------------------------------------------------------
    # USAGE DE LA PROCEDURE loadfile POUR CREER LA MATRICE pop
    # --------------------------------------------------------
    return $infile
}
#
# Procedure CHEMIN - end


# procedure DEBUG - debut
#
proc debug {output} {
    # fichier pour debugging
    global flag memo bugatti
    append bugatti "\n$output\n"
    set flag 1
    # text widget
    if {[info exists .debug]} {
        $memo insert end $bugatti
    } else  {
        destroy .debug .non
        toplevel .debug
        wm geometry .debug 710x480+205+44
        set memo [text .debug.t -wrap none -height 22 -font "courier 13" \
                -bg grey88 \
                -fg black\
                -tabs "3c left"\
                -yscrollcommand ".debug.v_scroll set" \
                -xscrollcommand ".debug.h_scroll set"]
        
        scrollbar .debug.v_scroll -command ".debug.t yview"
        scrollbar .debug.h_scroll -command ".debug.t xview" -orient horizontal
        pack .debug.v_scroll -side right -fill y
        pack .debug.h_scroll -side bottom -fill x
        pack .debug.t -side bottom -fill both -expand 1
        
        button .debug.exit -fg red -text "Exit" -command {
            global find_last_indx pointf ici
            destroy .debug .head
        }
        button .debug.wrap -fg red -text "Wrap" -command {
            global flag
            if {$flag == 1} {
                .debug.t configure -wrap word
                set flag 0
            } else  {
                .debug.t configure -wrap none
                set flag 1
            }
        }
        #
        $memo insert end $bugatti
        $memo see end
        pack .debug.exit .debug.wrap -side left -padx 5 -fill x
    }
}
#
# Procedure DEBUG - fin

# Procedure RECT_TO_POLAR
#
proc rect_to_polar {x y} {
    return [list [expr {hypot($y, $x)}] [expr {atan2($y, $x)}]]
}
# -------------------------------------
# Procedure POLAR_TO_RECT
#
proc polar_to_rect {r theta} {
    return [list [expr {$r * cos($theta)}] [expr {$r * sin($theta)}]]
}
# -------------------------------------

# Procedure DAOTL_SI -- debut
#
proc daotl_si {} {
    global p S
    global infile end fogmatall harm_nb
    global references premligne
    global partindiv end inputval2 rowcount colcount lignes colonnes
    set avis "Please compute Fourier coefficients first ..."
    #
    set S(button_DAProcrCp) 1
    set S(button_DAPW) 0
    set S(button_DAclassification) 0
    set S(ProcrCp) 1
    set end "_FOGcpsf.txt";#ATTENTION
    if {[info exists S(grupos)]} {
        #
        # Matrice totale (des coefficients)
        $p insert end "SIZE in DA on FOURIER COEFFICIENTS\n\nGroups are $S(grupos)"
        tk_messageBox -message "Size in DA on FOURIER COEFFICIENTS\n\nGroups are $S(grupos)" -type ok
        set damat "2 $S(otl_nb) [expr {[llength $S(pafmatall)]  * 1 / $S(otl_nb) }] "
        #
        set damat $S(pafmatall)
        #debug "DAOTL SI [llength $damat] valeurs]\n$damat"
        if {[mcols $damat] > 36} { set damat [mrange $damat 0 35 0 end]}
        $p insert end "\nSize-in DA on [mcols $damat] coefficients"
        #
        # On verifie qu'une AD peut etre faite
        set sgrupos_ordre [lsort -real $S(grupos)]
        if {[lindex $sgrupos_ordre 0] < [mcols $damat]} {
            if {[info exists S(cp_si)]} {
                set damat [mrange $S(cp_si) 0  [expr {[lindex $sgrupos_ordre 0] - 2}]  0 end]
                set end "_FOGcp.txt"
                bleu "\nDA performed on [expr {[lindex $sgrupos_ordre 0] - 2}] first PC derived from $harm_nb first harmonics\n"
                set S(damat) $damat
                #log "\n[file tail $infile] : input data for DA size in \n$damat"
                mogadiscio::principale $damat $S(grupos)
            } else  {
                tk_messageBox -message "Low sample sizes for DA ([lindex $sgrupos_ordre 0] < [mcols $damat])\
                        \nPlease perform a PCA first, the DA will use the first  [expr {[lindex $sgrupos_ordre 0] - 1}] components" -type ok
            }
        } else {
            set S(damat) $damat
            #log "\n[file tail $infile] : input data for DA size in \n$damat"
            mogadiscio::principale $damat $S(grupos)
        }
        
    } else  {
        tk_messageBox -message "A discriminant analysis needs to compute the variance of each group.\
                \nPlease indicate groups after performing a PCA, \nor please graph groups" -type ok
    }
}
#
# Procedure DAOTL_SI - fin


# Procedure DAOTL_SF - debut
#
proc daotl_sf {} {
    global p S
    global infile end fogmatall harm_nb
    global references premligne
    global partindiv end inputval2 rowcount colcount lignes colonnes
    set avis "Please compute Fourier coefficients first ..."
    #
    set S(button_DAProcrCp) 1
    set S(button_DAPW) 0
    set S(button_DAclassification) 0
    set S(ProcrCp) 1
    set end "_FOGcpsf.txt";#ATTENTION
    if {[info exists S(grupos)]} {
        #
        # Matrice totale (des coefficients)
        $p insert end "SIZE FREE DA on FOURIER COEFFICIENTS\n\nGroups are $S(grupos)"
        tk_messageBox -message "Size FREE DA on FOURIER COEFFICIENTS\n\nGroups are $S(grupos)" -type ok
        set damat [mrange $S(pafmatall_sf) 3 end 0 end]
        if {[mcols $damat] > 36} { set damat [mrange $damat 0 35 0 end]}
        #
        # On verifie qu'une AD peut etre faite
        set sgrupos_ordre [lsort -real $S(grupos)]
        $p insert end "\nSize-free DA on [mcols $damat] coefficients ? < [lindex $sgrupos_ordre 0] ?"
        if {[lindex $sgrupos_ordre 0] < [mcols $damat]} {
            if {[info exists S(cp_sf)]} {
                set damat [mrange $S(cp_sf) 0  [expr {[lindex $sgrupos_ordre 0] - 2}]  0 end]
                # Construire le nom du fichier qui contient les composantes principales size-free
                #
                if {[string first "_FOG" [file tail $infile]] > -1} {
                    # Si le fichier d'entree est _OTL_FOG.txt
                    set end "cpsf.txt"
                } else  {
                    # Si le fichier d'entree est _OTL.txt
                    set end "_FOGcpsf.txt"
                }
                
                #
                bleu "\nDA performed on [expr {[lindex $sgrupos_ordre 0] - 2}] first PC derived from $harm_nb first harmonics\n"
                set S(damat) $damat
                #log "\n[file tail $infile] : input data for DA size free \n$damat"
                mogadiscio::principale $damat $S(grupos)
            } else  {
                tk_messageBox -message "Low sample sizes for DA ([lindex $sgrupos_ordre 0] < [mcols $damat])\
                        \nPlease perform a PCA first, the DA will use the first  [expr {[lindex $sgrupos_ordre 0] - 1}] components" -type ok
            }
        } else {
            #log "\n[file tail $infile]  : input data for DA size free \n$damat"
            #
            set S(damat) $damat
            mogadiscio::principale $damat $S(grupos)
        }
        #
    } else  {
        tk_messageBox -message "A discriminant analysis needs to compute the variance of each group.\
                \nPlease indicate groups after performing a PCA, or graph groups" -type ok
    }
}
#
# Procedure DAOTL_SF -- fin


# Procedure DANEF - debut
#
proc danef {nefhume} {
    global p S
    global infile end fogmatall harm_nb
    global references premligne
    global partindiv end inputval2 rowcount colcount lignes colonnes
    set avis "Please compute Fourier coefficients first ..."
    #
    set S(button_DAProcrCp) 1
    set S(button_DAPW) 0
    set S(button_DAclassification) 0
    set S(ProcrCp) 1
    #
    set end "_NEF.txt";# <- pourquoi?
    #
    if {[info exists S(groupes)]} {
        #
        # Matrice totale (des coefficients)
        rouge "SIZE FREE DA on NEF FOURIER COEFFICIENTS\n\nGroups are $S(groupes)"
        set damat [mrange $nefhume 3 end 0 end]
        if {[mcols $damat] > 36} { set damat [mrange $damat 0 35 0 end]}
        #
        # On verifie qu'une AD peut etre faite
        set sgrupos_ordre [lsort -real $S(groupes)];# S(groupes) reservee a NEF
        $p insert end "\nSize-free DA on [mcols $damat] NEF coefficients ? < [lindex $sgrupos_ordre 0] ?"
        #
        if {[lindex $sgrupos_ordre 0] < [mcols $damat]} {
            # Une AD ne peut pas etre faite
            #
            tk_messageBox -message "Low sample sizes for DA ([lindex $sgrupos_ordre 0] < [mcols $damat])\
                    \nFOG will perform a PCA first, the DA will use the first  [expr {[lindex $sgrupos_ordre 0] - 1}] components" -type ok
            # Utiliser les nefcp (les composantes principales size-free)
            set damat [mrange $S(nefcp) 0  [expr {[lindex $sgrupos_ordre 0] - 2}]  0 end]
            bleu "\nDA performed on [expr {[lindex $sgrupos_ordre 0] - 2}] first PC derived from $harm_nb first harmonics\n"
            set S(damat) $damat
            set S(daclass) 0
            mogadiscio::principale $damat $S(groupes)
            
        } else {
            # Une AD peut etre faite
            #
            set S(damat) $damat
            set S(daclass) 0
            mogadiscio::principale $damat $S(groupes)
        }
        #
    } else  {
        tk_messageBox -message "A discriminant analysis needs to compute the variance of each group.\
                \nPlease indicate groups after performing a PCA, or after graphing outlines (button GRAPH)" -type ok
    }
}
#
# Procedure DANEF -- fin



# Procedure CENTROIDE -- debut
#
# Calcul du centroide
#
proc centroide {coord} {
    # On calcule les coordonnees du centroide de l'objet
    foreach {x y} $coord {
        append ixes "$x "
        append igrecs "$y "
    }
    #
    set sumixes 0
    set sumigrecs 0
    for {set i 0} {$i < [llength $ixes]} {incr i} {
        set sumixes [expr {$sumixes + [lindex $ixes $i]}]
    }
    set moyixes [expr {$sumixes * 1.0 / [llength $ixes]}]
    for {set i 0} {$i < [llength $igrecs]} {incr i} {
        set sumigrecs [expr {$sumigrecs + [lindex $igrecs $i]}]
    }
    set moyigrecs [expr {$sumigrecs * 1.0 / [llength $igrecs]}]
    set centroide "$moyixes $moyigrecs"
    return $centroide
}
#
# Procedure CENTROIDE - fin


# Procedure CENTRAGE
#
# une matrice de Hume est centree
#
proc centrage {x centroide} {
    #
    # 'x' est une matrice de Hume
    #
    set x [transpose $x]
    for {set j 0} {$j < [mrows $x]} {incr j} {
        update
        set translate_x [lindex $centroide 0];# valeur 'x' du centroide
        set translate_y [lindex $centroide 1];# valeur 'y' du centroide
        #
        set transmat "2 [mrows $x] [mcols $x] "
        #tk_messageBox -message "Centroide: $centroide, \nHume de transmat = $transmat" -type ok
        for {set i 0} {$i < [expr {[mcols $x] * 1/2}]} {incr i} {
            append transmat "[expr {0 - $translate_x}] [expr {0 - $translate_y}] "
        }
        #tk_messageBox -message "[llength [vtrim $transmat]] \n$transmat" -type ok
        #
        append translatedmat "[vtrim [madd [mrange $x 0 end $j $j] $transmat]] "
    }
    #
    # conversion liste -> matrice de Hume
    set hume "2 [mrows $x] [mcols $x] "
    set translatedmat "$hume $translatedmat"
    #
    ################################################################################
    #     rouge "\n\n---------------------------"
    #     #
    #     # La matrice centree contient encore les coordonnees du point centroide (0,0)
    #     rouge "\nMatrice centree (le premier point est le centroide)\n[show $translatedmat   %1.2f]"
    #     rouge "\n---------------------------"
    #     #
    #     #
    ################################################################################
    return $translatedmat
}
#
# une matrice de Hume est centree
#
# Procedure CENTRAGE - fin


#Procedure CANJUST - debut
#
proc canjust {tot largeur hauteur} {
    
    #
    # Tous les x et tous les y dans deux listes separees, l'ordre est preserve
    #
    set sumx 0
    set sumy 0
    set listex ""
    set listey ""
    foreach {x y} [lrange $tot 3 end] {
        set sumx [expr {$sumx + $x}]
        set sumy [expr {$sumy + $y}]
        lappend listex $x
        lappend listey $y
    }
    
    #
    # Pour x et pour y: minimum et maximum reels
    #
    set rangex [expr {[lindex [lsort -real $listex] end]  - [lindex [lsort -real $listex] 0]}]
    set rangey [expr {[lindex [lsort -real $listey] end]  - [lindex [lsort -real $listey] 0]}]
    #debug "Minimum et maximum reels: \nrangex $rangex \nrangey $rangey"
    #
    
    # Coefficients du canvas
    set cocan 1000
    
    # Multiplier x et y par leur coefficient respectif
    set prenvtot ""
    foreach {x y} [vtrim $tot] {
        append prenvtot "[expr {$x * $cocan}] [expr {$y * $cocan}]  "
    }
    set hume "2 [mrows $tot] [mcols $tot] "
    set nvtot "$hume $prenvtot"
    # #
    return $nvtot
}
#
# Procedure CANJUST - fin

# Procedure GROTL - start
#
#
# Estimate outline contours from coefficients
#
#
proc  grotl {x} {
    global S p fp coefa chevalet otl_liste pret prot Ao Co harm_nb
    #
    # On va restaurer la variable indicee coefa($j,$k) avec j l'individu-contour et k l'harmonique
    #
    set coeff_nb [mcols $x]
    if {$harm_nb > $S(harm_nb)} {set harm_nb $S(harm_nb)}
    set indiv_nb [expr {[mrows $x] / $harm_nb}]
    #tk_messageBox -message "Nombre de coefficients $coeff_nb\nNombre k d'harmoniques =$harm_nb\nNombre j de contours =$indiv_nb" -type ok
    for {set j 0} {$j < $indiv_nb} {incr j} {
        for {set k 0} {$k < $harm_nb} {incr k} {
            set coefa($j,$k) [vtrim [mrange $x 0 end $k $k ] ]
            #tk_messageBox -message "coefa($j,$k) <-> [expr {$harm_nb - 1}] = [mrows $x] ?" -type ok
            #debug "coefa($j,$k) $coefa($j,$k)"
            append x_cfa "$coefa($j,$k) "
        }
    }
    #
    # On va aussi convertir la matrice actuelle en celle (cfr. x_cfa) telle qu'elle etait construite pour CFA (Coventional etc.)
    #
    set hume "2 $indiv_nb $harm_nb "
    set x "$hume $x_cfa"
    
    #
    # The elliptic Fourier transformation can easily be inverted so that one can construct x,y coordinates from a series of coefficients
    #
    for {set j 0} {$j < [mrows $x]} {incr j} {
        #
        # D'un INDIVIDU a l'autre
        #
        #
        #$fp.buttons.suivi flash
        $fp.buttons.suivi configure -fg red -bg yellow -text "Outline [expr {$j+1}]"
        #
        set perimetre($j) [lindex $S(perimeter) $j]
        
        set 2pi_T [expr {6.283185307 * 1.000 / $perimetre($j)}];#  se lit '2 pi sur T'
        #
        set contour [expr {[lindex $otl_liste $j] /2 - 1}]
        #tk_messageBox -message "perimetre($j) = [lindex $S(perimeter) $j], contour = $contour" -type ok
        #
        for {set i 1} {$i < [expr {$contour}]} {incr i} {
            #
            # D'un POINT a l'autre de l'INDIVIDU $j
            #
            #set t $prot($j,$i)
            set t $perimetre($j)
            #
            set sumX 0
            set sumY 0
            #
            for {set k 1} {$k < $harm_nb} {incr k} {
                #
                # D'une HARMONIQUE a l'autre (au point $i de l'individu $j)
                #
                set 2pik_T [expr {$k * $2pi_T}];# lire 2 pi k sur T
                set 2pikt_T [expr {$t * $2pik_T}]
                #
                set A [lindex $coefa($j,$k) 0]
                set B [lindex $coefa($j,$k) 1]
                set terme1x [expr {$A * cos($2pikt_T)}]
                set terme2x [expr {$B * sin($2pikt_T)}]
                set sumX [expr {$sumX + $terme1x - $terme2x }]
                #
                set C [lindex $coefa($j,$k) 2]
                set D [lindex $coefa($j,$k) 3]
                set terme1y [expr {$C * cos($2pikt_T)}]
                set terme2y [expr {$D * sin($2pikt_T)}]
                set sumY [expr {$sumY + $terme1y - $terme2y }]
            }
            set Ao($j) [lindex $S(Ao) $j]
            set x_estimated($j) [expr {$Ao($j) + $sumX}]
            set Co($j) [lindex $S(Co) $j]
            set y_estimated($j) [expr {$Co($j) + $sumY}]
            append outline_estimated($j) "$x_estimated($j) $y_estimated($j) "
        }
        
        rouge "\n####\n#########\n###############\n####################\
                \nIndividu $j \
                \nESTIMATED OUTLINE: \n[llength $outline_estimated($j)] points\n$outline_estimated($j)"
        
        ################################################################################
        # ----------------------------------------------------------------------
        # Ajustement au canvas
        set numero $j
        #
        # # La courbe n'est pas complete, il faut repeter le premier point en fin de liste
        append outline_estimated($j) [lrange $outline_estimated($j) 0 1]
        #
        # Pour l'ajustement au canvas, on va travailler sur une matrice de Hume
        set hume "2 [llength $outline_estimated($j)] 1 "
        set totale "$hume $outline_estimated($j)"
        
        # Calcul du centroide
        #
        set centroid [centroide [vtrim $totale]];# N'EST SANS DOUTE PAS NECESSAIRE
        #tk_messageBox -message "centroide $centroid\nde totale:\n[show $totale]" -type ok
        
        set totale [centrage $totale $centroid]
        
        # 1. Connaitre la valeur maximum et minimum, pour x, et pour y
        # 2. Coefficient du canvas pour x = largeur du canvas divisee par l'ecart maximum des x
        # 3. Coefficient du canvas pour y = hauteur du canvas divisee par l'ecart maximum des y
        # 4. Multiplier x et y par leur coefficient respectif
        
        # Les points 1. 2. 3. 4. sont realises par CANJUST
        #
        set canlargeur 500
        set canhauteur 500
        set adjustedtotale [canjust $totale $canlargeur $canhauteur]
        # Ajustement au canvas -- FIN
        
        # Dessin de la courbe
        #
        set c $chevalet
        set etiquette et($j)
        #
        $c create line [vtrim $adjustedtotale] -fill blue -tag $etiquette
        #
        # Et des etiquettes, vraiment
        set compte 0
        set sumx 0
        set sumy 0
        foreach {xxx yyy} [vtrim $adjustedtotale] {
            incr compte
            set sumx [expr {$sumx + $xxx}]
            set sumy [expr {$sumy + $yyy}]
        }
        set moyx [expr {$sumx * 1.0 / $compte}]
        set moyy [expr {$sumy * 1.0 / $compte}]
        $c create text $moyx $moyy -fill red -text "Individual $j" -tag $etiquette
        #
        # now going to the next individual
    }
    #
}
#
# Procedure GROTL - end

# Procedure PCAOTL
#
proc pcaotl {} {
    global S p fogmat
    #
    $p insert end "\n\n\t\t -- -- -- -- -- -- -- -- -- -- -- -- -- --"
    $p insert end "\n\n\t\t&&&&&&&&&&&&&&&&&&&&"
    rouge "\n\n\t\tPRINCIPAL COMPONENT ANALYSIS"
    $p insert end "\n\n\t\t&&&&&&&&&&&&&&&&&&&&"
    $p insert end "\n\n\t\t -- -- -- -- -- -- -- -- -- -- -- -- -- --"
    # Matrice totale (des coefficients)
    set hume "2 [expr {$S(otl_nb) - 1}] [mcols $fogmat(1)] "
    for {set i 1} {$i < $S(otl_nb)} {incr i} {
        append hume "[vtrim $fogmat($i)] "
    }
    #debug "HUME\n$hume\nmmm?\n[mcols $fogmat(1)]  = [llength $hume] ??\n$hume\n[show $hume]"
    # Matrice partielle (un nombre 'raisonnable' de colonnes)
    if {[mcols $fogmat(1)] > 40} {
        set S(fogmat) [mrange $hume 0 39 0 end]
    } else  {
        set S(fogmat) $hume
    }
    $p insert end "PCA sur [mcols $S(fogmat)] coefficients"
    #
    # ACP
    #
    if {[mrows $S(fogmat)] > 1} {}
    toplevel .msg
    wm geometry .msg +100+200
    message .msg.t -text "PCA ... \non [mcols $S(fogmat)] EFA coefficients\nusing [expr {[mcols $S(fogmat)] / 4}] harmonics"
    pack .msg.t
    update
    #
    set S(cp) [compoprin $S(fogmat)]
    #bleu "CP\n[show $S(cp)]" <- c'est deja rapporte
    #
}
#
# # Procedure PCAOTL - end

# Procedure ACPOTL_SF
#
# appelee depuis MVA after GRAPH
#
proc acpotl_sf {} {
    #
    global S p fogmat harm_nb infile references
    #
    rouge "\n\n\t\tPCA of FOURIER COEFFICIENTS - SIZE SCALED (after Procrustes superposition)"
    # Matrice totale (des coefficients)
    $p insert end "\n\nNombre de figures (specimens, individus): $S(otl_nb)"
    
    set pcamat [mrange $S(pafmatall_sf) 4 end 0 end];# j'enleve la premiere harmonique
    $p insert end "\nNombre (total) de coefficients, en omettant la premiere harmonique ([mcols $pcamat]) (Ao et Co NE sont PAS inclus)\n"
    if {[mcols $pcamat] > $S(otl_nb)} { set pcamat [mrange $pcamat 0 [expr {$S(otl_nb)-2}] 0 end]}
    # si le nombre de coefficients n'est plus pair, on corrige
    if {[expr {fmod([mcols $pcamat],2)}] != 0} {set pcamat [mrange $pcamat 0 [expr {$S(otl_nb)-3}] 0 end]}
    #
    bleu "\nNombre choisi de coefficients pour l'analyse en composantes principales: [mcols $pcamat]"
    $p insert end "\nSize-free PCA on [mcols $pcamat] coefficients \
            \ni.e. [expr {[mcols $pcamat] / 4 + 1}] harmonics, beginning with the second one\n"
    #
    # ACP size scaled
    #
    if {[mrows $pcamat] > 1} {}
    toplevel .msg
    wm geometry .msg +100+200
    message .msg.t -text "PCA ... \non [mcols $pcamat] EFA SIZE SCALED coefficients\nusing [expr {([mcols $pcamat] -2 ) / 4 + 1}] harmonics"
    pack .msg.t
    update
    #log "\n[file tail $infile] : input data for PCA size free \n$pcamat"
    #
    set S(cp_sf) [compoprin $pcamat]
    #
    # Enregistrer ces composantes dans un fichier ... _FOGcpsf.txt
    savefogcpsf $S(cp_sf)
}
#
# Procedure ACPOTL_SF - end

# Procedure ACPNEF - start
#
proc acpnef {nefhume} {
    global S p infile reference
    $p configure -wrap no
    $p see end
    set panneau ""
    #
    bleu "\n\n\t\tPCA of NORMALIZED FOURIER COEFFICIENTS - "
    append panneau "\nPCA of NORMALIZED FOURIER COEFFICIENT"
    # Matrice totale (des coefficients)
    $p insert end "\n\nNombre de figures (specimens, individus): $S(otl_nb)"
    append panneau "\n$S(otl_nb) objects"
    #
    set pcamat [mrange $nefhume 3 end 0 end];# j'enleve les coefficients A,B et C de la premiere harmonique (a1, b1, c1 SAUF d1).
    #
    $p insert end "\nNombre (total) de coefficients, en omettant les 3 premiers coefficients \
            de la premiere harmonique ([mcols $pcamat]) (Ao et Co NE sont PAS inclus)\n"
    append panneau "\n\nNombre total de coefficients: [expr {[mcols $pcamat] + 3}] \
            (Ao et Co NE sont PAS inclus)\n"
    #
    # Limitation du nombre de variables en fonction de l'echantillon total - start
    #
    if {[mcols $pcamat] > $S(otl_nb)} { set pcamat [mrange $pcamat 0 [expr {$S(otl_nb)-2}] 0 end]}
    # si le nombre de coefficients n'est plus pair, on corrige
    if {[expr {fmod([mcols $pcamat],2)}] != 0} {set pcamat [mrange $pcamat 0 [expr {$S(otl_nb)-3}] 0 end]}
    #
    bleu "\nNombre choisi de coefficients pour l'analyse en composantes principales: [mcols $pcamat]"
    append panneau "\nNombre retenu de coefficients pour l'ACP: [mcols $pcamat]\
            \nLes 3 premiers coefficients de la premiere harmonique ne sont pas inclus"
    #affiche 10 100 "PCA on [mcols $pcamat] NEF coefficients"
    append panneau "\n\nPCA on [mcols $pcamat] NEF coefficients"
    
    $p insert end "\nSize-free PCA on [mcols $pcamat] coefficients \
            \ni.e. [expr {[mcols $pcamat] / 4 + 1}] harmonics, beginning with \
            the d1 of the first harmonic, then the second harmonic, and so on\n"
    #
    # Limitation du nombre de variables en fonction de l'echantillon total - end
    #
    
    #
    # ACP des NORMALIZED COEFFICIENTS of FOURIER (NEF)
    #
    update
    global fp
    $fp.buttons.suivi configure -text " -- Performing PCA on [mcols $pcamat] NEF coefficients --"
    #
    set cp [acp $pcamat]
    set S(nefcp) $cp
    #
    global lignes colonnes individusfog;# Jan 2013
    rouge "\nNORMALIZATION... and PCA on NEF coefficients\n"
    if {[info exists individusfog] == 1} {
        # Jan 2013
        global pad
        set pad 0
        #
        gribouille $individusfog;# Jan 2013
        destroy .msg
    }
    #
    # ACP des NORMALIZED COEFFICIENTS
    #
    affiche 500 500 $panneau
}
#
# Procedure ACPNEF - end

# Procedure ACPOTL_SI
#
proc acpotl_si {} {
    global S p fogmat fp infile references
    #
    $p insert end "\n\n\t\t -- -- -- -- -- -- -- -- -- -- -- -- -- --"
    $p insert end "\n\n\t\t&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&"
    rouge "\n\n\t\tPRINCIPAL COMPONENT ANALYSIS OF ELLIPTIC COEFFICIENTS (A,B,C,D)"
    $p insert end "\n\n\t\t&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&"
    $p insert end "\n\n\t\t -- -- -- -- -- -- -- -- -- -- -- -- -- --"
    # Matrice totale (des coefficients)
    set pcamat [mrange $S(pafmatall) 3 end 0 end];# j'enleve le perimetre, Ao et Co !!
    #debug "\nPCA sur [mcols $pcamat] coefficients\n$S(pafmatall)\n$pcamat"
    if {[mcols $pcamat] > 36} { set pcamat [mrange $pcamat 0 35 0 end]}
    $p insert end "\nPCA sur [mcols $pcamat] coefficients"
    #
    # ACP
    #
    if {[mrows $pcamat] > 1} {}
    toplevel .msg
    wm geometry .msg +100+200
    message .msg.t -text "PCA ... \non [mcols $pcamat] EFA coefficients\nusing [expr {[mcols $pcamat] / 4}] harmonics\nThis can take time..."
    pack .msg.t
    #
    update
    $fp.buttons.suivi configure -text " -- Performing PCA --"
    #
    #log "\n[file tail $infile] : input data for PCA size in \n$pcamat"
    #
    set S(cp_si) [compoprin $pcamat]
    #
    # Enregistrer ces composantes dans un fichier ... _FOGcp.txt
    set a [file dirname $infile]
    set queue [file tail $infile]
    if {[string first "_FOG" $queue] > -1} {
        set b [string range $queue 0 [string first "_FOG" $queue] ]
        set c "FOGcp.txt"
    } else {
        set b  [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
        set c "_FOGcp.txt"
    }
    set infile_cp [file join $a $b$c]
    #debug "CPSF\na = $a\nqueue = $queue \nb = $b\nc = $c\n$infile_cp"
    set filename $infile_cp
    # OPEN THE FILE
    set fileid [open $filename w]
    # FILL THE FILE
    puts -nonewline $fileid "$references - Size-in Principal Components - elliptic method \n"
    puts -nonewline $fileid [show $S(cp_si)]
    # CLOSE THE FILE
    close $fileid
}
#
# Procedure ACPOTL_SI - end



# Proc CROQUIS_CIFRA - start
#
# calcule un contour a partir des coefficients de Fourier  (methode elliptique) - pour l'inverse, voir COF
#
proc croquis_cifra  {x specimen p Ao Co} {
    #
    # X, ici, represente la matrice des COEFFICIENTS de FOURIER
    #
    global S p fp harm_nb
    # --------------------------------------------------------------------------------------------------------
    #
    # ESTIMATE OUTLINE FROM COEFFICIENTS - pour un seul individu (j = 0, donc)
    #
    #  --------------------------------------------------------------------------------------------------------
    #
    #
    #debug "SHOWING X\n[show $x]\nmcols x [mcols $x]"
    #
    set contour [expr {int($pmoy)}];#debug "pmoy (Nombre de points) $contour";# nombre de points (ajuste a la moyenne)
    #
    set perimetre(0) $perimoy;#debug "perimoy (perimetre moyen) $perimetre(0)";# perimetre moyen
    #
    # Construction de prot($j,$i)
    set tmoy [expr {$perimetre(0) * 1.0 / $contour}]
    set sumt 0
    for {set i 1} {$i < [expr {$contour}]} {incr i} {
        set sumt [expr {$sumt + $tmoy}]
        set prot(0,$i) $sumt
    }
    #
    set j 0;# un seul individu
    #
    # construction des coefa($j,$k)
    set k 1
    foreach {a b c d} [vtrim $x] {
        set coefa($j,$k) "$a $b $c $d"
        incr k
    }
    #
    # Nombre d'harmoniques
    set harm_nb [expr {[mcols $x] / 4}]
    if {$harm_nb > $S(harm_nb)}  {set harm_nb $S(harm_nb)}
    #
    # Moyenne des A0 et Co
    set Ao(0) $Aomoy;#debug "Ao(0) $Aomoy"
    set Co(0) $Comoy;#debug "Co(0) $Comoy"
    #
    # The elliptic Fourier transformation can easily be inverted so that one can construct x,y coordinates from a series of coefficients
    #
    set j 0
    #
    # Un seul INDIVIDU
    #
    set 2pi_T [expr {6.283185307 * 1.000 / $perimetre($j)}];#  se lit '2 pi sur T'
    #
    for {set i 1} {$i < [expr {$contour}]} {incr i} {
        #
        # D'un POINT a l'autre de l'INDIVIDU $j
        #
        set t $prot($j,$i);# <- faudra diviser le perimetre par le nombre de points choisis (t, c'est la corde)
        #
        #
        set sumX 0
        set sumY 0
        #
        for {set k 1} {$k < $harm_nb} {incr k} {
            #
            # D'une HARMONIQUE a l'autre (au point $i de l'individu $j)
            #
            set 2pik_T [expr {$k * $2pi_T}];# lire 2 pi k sur T
            set 2pikt_T [expr {$t * $2pik_T}]
            #
            set A [lindex $coefa($j,$k) 0]
            set B [lindex $coefa($j,$k) 1]
            set terme1x [expr {$A * cos($2pikt_T)}]
            set terme2x [expr {$B * sin($2pikt_T)}]
            set sumX [expr {$sumX + $terme1x - $terme2x }]
            #
            set C [lindex $coefa($j,$k) 2]
            set D [lindex $coefa($j,$k) 3]
            set terme1y [expr {$C * cos($2pikt_T)}]
            set terme2y [expr {$D * sin($2pikt_T)}]
            set sumY [expr {$sumY + $terme1y - $terme2y }]
        }
        set x_estimated($j) [expr {$Ao($j) + $sumX}]
        set y_estimated($j) [expr {$Co($j) + $sumY}]
        append outline_estimated($j) "$x_estimated($j) $y_estimated($j) "
    }
    rouge "\n####\
            \nCROQUIS: \n[llength $outline_estimated($j)]\n$outline_estimated($j)"
    return $outline_estimated($j)
}
#
# Procedure CROQUIS_CIFRA - end


# Proc CROQUIS - iefourier de R J. Claude
#
# calcule un contour a partir des coefficients de Fourier  (methode elliptique) - pour l'inverse, voir COF ou EFA
#
proc croquis  {x perimoy pmoy Aomoy Comoy} {
    #
    # X, ici, represente la matrice des COEFFICIENTS de FOURIER
    #
    global S p fp harm_nb
    # --------------------------------------------------------------------------------------------------------
    #
    # ESTIMATE OUTLINE FROM COEFFICIENTS - pour un seul individu (j = 0, donc)
    #
    #  --------------------------------------------------------------------------------------------------------
    #
    #
    #debug "SHOWING X\n[show $x]\nmcols x [mcols $x]"
    #
    set contour [expr {int($pmoy)}];#debug "pmoy (Nombre de points) $contour";# nombre de points (ajuste a la moyenne)
    #
    set perimetre(0) $perimoy;#debug "perimoy (perimetre moyen) $perimetre(0)";# perimetre moyen
    #
    # Construction de prot($j,$i)
    set tmoy [expr {$perimetre(0) * 1.0 / $contour}]
    set sumt 0
    for {set i 1} {$i < [expr {$contour}]} {incr i} {
        set sumt [expr {$sumt + $tmoy}]
        set prot(0,$i) $sumt
    }
    #debug "prot(0,$i) $prot(0,[expr {$i-1}])"
    #
    set j 0;# un seul individu
    #
    # construction des coefa($j,$k)
    set k 1
    foreach {a b c d} [vtrim $x] {
        set coefa($j,$k) "$a $b $c $d"
        incr k
    }
    #
    # Nombre d'harmoniques
    set harm_nb [expr {[mcols $x] / 4}]
    if {$harm_nb > $S(harm_nb)}  {set harm_nb $S(harm_nb)}
    #
    # Moyenne des A0 et Co
    set Ao(0) $Aomoy;#debug "Ao(0) $Aomoy"
    set Co(0) $Comoy;#debug "Co(0) $Comoy"
    #
    # The elliptic Fourier transformation can easily be inverted so that one can construct x,y coordinates from a series of coefficients
    #
    set j 0
    #
    # Un seul INDIVIDU
    #
    set 2pi_T [expr {6.283185307 * 1.000 / $perimetre($j)}];#  se lit '2 pi sur T'
    #
    for {set i 1} {$i < [expr {$contour}]} {incr i} {
        #
        # D'un POINT a l'autre de l'INDIVIDU $j
        #
        set t $prot($j,$i);# <- faudra diviser le perimetre par le nombre de points choisis (t, c'est la corde)
        #
        #
        set sumX 0
        set sumY 0
        #
        for {set k 1} {$k < $harm_nb} {incr k} {
            #
            # D'une HARMONIQUE a l'autre (au point $i de l'individu $j)
            #
            set 2pik_T [expr {$k * $2pi_T}];# lire 2 pi k sur T
            set 2pikt_T [expr {$t * $2pik_T}]
            #
            set A [lindex $coefa($j,$k) 0]
            set B [lindex $coefa($j,$k) 1]
            set terme1x [expr {$A * cos($2pikt_T)}]
            set terme2x [expr {$B * sin($2pikt_T)}]
            #set sumX [expr {$sumX + $terme1x - $terme2x }]
            set sumX [expr {$sumX + $terme1x + $terme2x }];# j'ai change la soustraction en addition, et ... rien ne change!
            #
            set C [lindex $coefa($j,$k) 2]
            set D [lindex $coefa($j,$k) 3]
            set terme1y [expr {$C * cos($2pikt_T)}]
            set terme2y [expr {$D * sin($2pikt_T)}]
            #set sumY [expr {$sumY + $terme1y - $terme2y }]
            set sumY [expr {$sumY + $terme1y + $terme2y }];# j'ai change la soustraction en addition, et ... rien ne change!
        }
        set x_estimated($j) [expr {$Ao($j)/2 + $sumX}];;# j'ai divise Ao par deux, et les tailles relatives changent sur les graphes
        set y_estimated($j) [expr {$Co($j)/2 + $sumY}];;# j'ai divise Co par deux, et les tailles relatives changent sur les graphes
        append outline_estimated($j) "$x_estimated($j) $y_estimated($j) "
        #debug "Ao($j) $Ao($j) Co($j) $Co($j)"
    }
    #
    return $outline_estimated($j)
}
#
# Procedure CROQUIS


# Procedure COF - debut
#
# Procedure appelee par PAF, par le bouton H
#
# COF calcule les COefficients de Fourier a partir d'un contour donne (methode elliptique)
# COF utilise le nombre de points de ce contour - "POINTS" est soit "observe", soit "moyen", soit "impose".
#
# (apres ce calcul, COF appelle CROQUIS pour estimer le contour en fonction des coefficients)
#
# EFA et COF c'est un peu (beaucoup) KIFKIF
#
proc cof {x harm_nb} {
    #
    # ' x ', ici, represente la MATRICE des coordonnees du contour (2 1 coordonnees_nb ... ... ... ... )
    #
    global p S cifra totalpower
    set S(harm_nb) 29
    #set S(pre_pafmatall_sf) ""
    #
    #---------------------------------------------------------------------------------------------------------------------------------
    # ELLIPTIC FOURIER ANALYSIS
    # # Calcul des cordes, de leur orientation, et du perimetre
    # ensuite
    # # Calculs des COEFFICIENTS A et B (pour x), C et D (pour y). Pas de z, on est en bidimensionel.
    #---------------------------------------------------------------------------------------------------------------------------------
    # x = outline coordinates
    # Enlever les coordonnees des centroides (un centroide par individu) - LE CENTROIDE EST ENLEVE
    # set x [mrange $x 2 end 0 end]
    #
    set contour [expr {[mcols $x] * 1 / 2}];# LE NOMBRE DE POINTS (= 'p' = 'number of steps' in NTSYS)
    set points $contour
    #debug "COF x \n$x"
    #
    # Le pas angulaire (theta)
    set theta [expr {6.283185307 * 1.0 / $contour}]
    #
    for {set j 0} {$j < [mrows $x]} {incr j} {
        #debug "nb indiv mrows x = [mrows $x]"
        # d'un INDIVIDU a l'autre - mais bon il n'y en a qu'un seul
        #
        set prot($j,0) 0
        set prot_scaled($j,0) 0
        set sumchorde 0
        set compteur 0
        set perimetre($j) 0
        #
        for {set i 0} {$i < [expr {$contour * 2 - 2}]} {incr i 2} {
            #
            # d'un POINT a l'AUTRE
            #
            #rouge "\n->POINT $compteur (individu $j)"
            #
            set pt [vtrim [mrange $x [expr {$i + 2}] [expr {$i + 3}] $j $j]]
            #
            # Preparation de l'analyse elliptique de Fourier (EFA) ----------------------------- Preparation EFA
            #
            # deltax et deltay (au point $compteur)
            #
            set yy2 [expr [lindex [vtrim [mrange $x [expr {$i + 2}] [expr {$i + 3}] $j $j ] ]  1] ]
            set yy1 [expr [lindex [vtrim [mrange $x $i [expr {$i + 1}] $j $j] ] 1 ] ]
            set xx2 [expr [lindex [vtrim [mrange $x [expr {$i + 2}] [expr {$i + 3}] $j $j] ] 0 ] ]
            set xx1 [expr [lindex [vtrim [mrange $x $i [expr {$i + 1}] $j $j] ] 0] ]
            set deltax($j,$compteur) [expr {$xx2 - $xx1}];# DISPLACEMENT ALONG THE X-AXIS OF THE CONTOUR BETWEEN STEPS i-1 and i
            set deltay($j,$compteur) [expr {$yy2 - $yy1}];# .........................................................Y-AXIS .....etc.
            #$p insert end "\n-> [vtrim [mrange $x $i [expr {$i + 3}] $j $j ] ]\
            \n deltax at point $compteur, soit deltax($j,$compteur): $xx2 - $xx1 = $deltax($j,$compteur)\
                    \n deltay at point $compteur, soit deltay($j,$compteur): $yy2 - $yy1 = $deltay($j,$compteur)"
            #
            # 'pret', the chordal distance along the curve from one point to the next one
            #
            set pret($j,$compteur) [disteuclid [vtrim [mrange $x $i [expr {$i+1}] $j $j]] $pt];# 'deltati' LENGTH OF SEGMENT BETWEEN STEPS i-1 and i
            #$p insert end "\n-> Chordal distance from $compteur to [expr {$compteur+1}]"
            #rouge " i.e. \tpret($j,$compteur) : $pret($j,$compteur)"
            #
            # 'prot', the cumulative chordal distance along the curve ... ('pret', 'prot' pour arriver a 't')
            #
            set sumchorde [expr {$sumchorde + $pret($j,$compteur)}]
            set prot($j,$compteur) $sumchorde;#;# 'ti' THE ACCUMULATED LENGTH OF SUCH SEGMENTS
            #$p insert end "\n-> Cumulative chordal distance at point $compteur, i.e. prot($j,$compteur) :$prot($j,$compteur) "
            #if {$compteur > 1} {bleu "\nat point [expr {$compteur-1}], i.e. prot($j,[expr {$compteur-1}]) : $prot($j,[expr {$compteur-1}])"}
            #
            # Calcul progressif du perimetre T, il a ici exactement la meme valeur que prot($j,$compteur)
            set perimetre($j) [ expr { $perimetre($j) + [ disteuclid [vtrim [mrange $x $i [ expr { $i+1 } ] $j $j]] $pt ]  } ];# 'T' = t . p
            #
            incr compteur;# cfr. 'd'un point a l'autre'
            #$p see end
            #
        }
        #
        # d'un POINT a l'AUTRE - FIN
        #
        
        # !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        # ATTENTION la distance entre le dernier point et le premier n'a pas ete calculee dans la boucle ci-dessus...
        set pt_dernier [vtrim [mrange $x [expr {$contour * 2 - 2}] [expr {$contour * 2 - 1}] $j $j]]
        set pt_premier [vtrim [mrange $x 0 1 $j $j]]
        # deltax et deltay (au point [expr {$contour-1}])
        set yy2 [lindex $pt_dernier 1]
        set yy1 [lindex $pt_premier 1]
        set xx2 [lindex $pt_dernier 0]
        set xx1 [lindex $pt_premier 0]
        set deltax($j,[expr {$contour-1}]) [expr {$xx1 - $xx2}];# le sens de cette difference est important
        set deltay($j,[expr {$contour-1}]) [expr {$yy1 - $yy2}];# difference avec signe, non difference absolue!
        #rouge "\n-> POINT [expr {$contour-1}]"
        #$p insert end "\n-> PREMIER ($pt_premier) et DERNIER ($pt_dernier) POINTS\
        \n deltax between point [expr {$contour-1}] and $contour , i.e. deltax($j,[expr {$contour-1}]): $xx2 et $xx1 = $deltax($j,[expr {$contour-1}])\
                \n deltay at point $compteur : $yy1 - $yy2 = $deltay($j,[expr {$contour-1}])"
        #'pret', the chordal distance along the curve from one point to the next one ('pret' at point [expr {$contour-1}])
        #
        set pret($j,[expr {$contour-1}]) [disteuclid $pt_dernier $pt_premier]
        #$p insert end "\n-> Chordal distance from [expr {$contour-1}] to $contour"
        #rouge " i.e. \tpret($j,[expr {$contour-1}]) : $pret($j,[expr {$contour-1}])"
        #
        set sumchorde [expr {$sumchorde + $pret($j,[expr {$contour-1}])}]
        set prot($j,[expr {$contour-1}]) $sumchorde
        $p insert end "\n-> Cumulative chordal distance \nat point [expr {$contour-1}], i.e. prot($j,[expr {$contour-1}]) :$prot($j,[expr {$contour-1}]) "
        #if {$compteur > 1} {bleu "\nat point [expr {$contour-2}], i.e. prot($j,[expr {$contour-2}]) : $prot($j,[expr {$contour-2}])"}
        #
        # Perimeter $perimetre($j) should be like last cumulative chordal distance: prot($j,$i) = $prot($j,$i)
        set perimetre($j) $prot($j,[expr {$contour-1}])
        #append S(perimeter) "$perimetre($j) "
        # !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        #
    };# d'un INDIVIDU a l'autre, FIN#
    
    
    # --------------------------------------------------------------------------------------------------------------------------------
    #
    # Calculs des COEFFICIENTS A et B (pour x), C et D (pour y). Pas de z, on est en bidimensionel.
    # Elliptic Fourier Analysis
    # -------------------------------------------------------------------------------------------------------------------------------
    # Le calcul est realise pour chaque harmonique
    if {$harm_nb > $S(harm_nb)} {set harm_nb $S(harm_nb)};# sans quoi les calculs prennent trop de temps, et $S(harm_nb) harmoniques, c'est qd mm pas mal...
    #
    for {set j 0} {$j < [mrows $x]} {incr j} {
        #
        # D'un INDIVIDU a l'autre - mais il n'y en a en principe qu'un seul
        #
        set 2pi_T [expr {6.283185307 * 1.000 / $perimetre($j)}];#  cfr. T = p. t in NTSYS techn. det.
        #
        #
        for {set k 1} {$k < $harm_nb} {incr k} {
            #
            # D'une HARMONIQUE a l'autre
            #
            set T_2p2pi2 [expr {$perimetre($j) * 1.000/ (2 * $k * $k * 3.141592654 * 3.141592654)}];# lire T sur 2n au carre 2 pi au carre
            set 2pik_T [expr {$k * $2pi_T}];# lire 2 pi k sur T
            #
            set sumA 0
            set sumB 0
            set sumC 0
            set sumD 0
            #
            #debug "Contour = $contour"
            #
            for {set i 1} {$i < $contour} {incr i} {
                #
                # D'un POINT  a l'AUTRE, pour l'harmonique k
                #
                set a [expr {cos($2pik_T * $prot($j,$i))}]
                set b [expr {cos($2pik_T * $prot($j,[expr {$i-1}]))}]
                if {$pret($j,$i) > 0} {
                    set sumA [expr {$sumA + ( ( $deltax($j,$i) * 1.0 / $pret($j,$i) ) * ($a - $b) )}]
                    set sumC [expr {$sumC + ( ( $deltay($j,$i) * 1.0 / $pret($j,$i) ) * ($a - $b) )}]
                }
            }
            for {set i 1} {$i < $contour} {incr i} {
                #
                # D'un POINT  a l'AUTRE, pour l'harmonique k
                #
                set a [expr {sin($2pik_T * $prot($j,$i))}]
                set b [expr {sin($2pik_T * $prot($j,[expr {$i-1}]))}]
                if {$pret($j,$i) > 0} {
                    set sumB [expr {$sumB + ( ( $deltax($j,$i) * 1.0 / $pret($j,$i) ) * ($a - $b) )}]
                    set sumD [expr {$sumD + ( ( $deltay($j,$i) * 1.0 / $pret($j,$i) ) * ($a - $b) )}]
                }
            }
            #debug "Individu $cifra: sumA $sumA sumB $sumB sumC $sumC et sumD $sumD"
            # -------------------------------------------------------------------
            # Calcul de A de l'individu 'j' pour l'harmonique 'k'
            # -------------------------------------------------------------------
            set sumA [expr {$T_2p2pi2 * $sumA}]
            append coefa($j,$k) "$sumA "
            # -------------------------------------------------------------------
            # Calcul de B de l'individu j pour l'harmonique k
            # -------------------------------------------------------------------
            set sumB [expr {$T_2p2pi2 * $sumB}]
            #rouge "\nEFA, individu $j, harmonique $k, B: $sumB "
            append coefa($j,$k) "$sumB "
            # -------------------------------------------------------------------
            # Calcul de C de l'individu j pour l'harmonique k
            # -------------------------------------------------------------------
            set sumC [expr {$T_2p2pi2 * $sumC}]
            append coefa($j,$k) "$sumC "
            # -------------------------------------------------------------------
            # Calcul de D de l'individu j pour l'harmonique k
            # -------------------------------------------------------------------
            set sumD [expr {$T_2p2pi2 * $sumD}]
            append coefa($j,$k) "$sumD "
        }
        # D'une HARMONIQUE a l'autre -- fin
        
        # -------------------------------------------------------------------
        # Calcul de Ao et de Co (Bo = Do = 0) selon NTSYS techn. det.
        # -------------------------------------------------------------------
        #
        set 1_T  [expr {1.0 * 1.0 / $perimetre($j)}];# NTSYS techn. det.
        #
        set pt_premier [vtrim [mrange $x 0 1 $j $j]]
        set yo [lindex $pt_premier 1]
        set xo [lindex $pt_premier 0]
        #
        set sumAo 0
        for {set i 1} {$i < [expr {$contour}]} {incr i} {
            if {$pret($j,$i) > 0} {
                set tp $prot($j,$i)
                set tp-1 $prot($j,[expr {$i-1}])
                set t2p [expr {$tp * $tp}]
                set t2p-1 [expr {$tp-1 * $tp-1}]
                
                set sumdeltax 0
                for {set g 1} {$g <  [expr {$i - 1}]} {incr g} {
                    set sumdeltax [expr {$sumdeltax + $deltax($j,$g)}]
                }
                set dx_dt [expr {$deltax($j,$i) * 1.0 / $pret($j,$i) }]
                set dx_dtdtimoins1 [expr {$dx_dt * $pret($j,[expr {$i-1}])}]
                set dti $pret($j,$i)
                set alphap [expr {($sumdeltax - $dx_dtdtimoins1) * $dti}]
                
                # Attention: alphap=1 == 0
                if {$i == 1} {set alphap 0}
                
                set dx_2dt [expr {($deltax($j,$i) * 1.0 / (2 * $pret($j,$i) ) )}]
                set sumAo [expr {$sumAo + $dx_2dt  * ($t2p - $t2p-1) + $alphap}]
            }
        }
        #
        set Ao($j) [expr {$xo + $1_T * $sumAo}]
        
        set sumCo 0
        for {set i 1} {$i < [expr {$contour}]} {incr i} {
            if {$pret($j,$i) > 0} {
                set tp $prot($j,$i)
                set tp-1 $prot($j,[expr {$i-1}])
                set t2p [expr {$tp * $tp}]
                set t2p-1 [expr {$tp-1 * $tp-1}]
                
                set sumdeltay 0
                for {set g 1} {$g <  [expr {$i - 1}]} {incr g} {
                    set sumdeltay [expr {$sumdeltay + $deltay($j,$g)}]
                }
                set dy_dt [expr {$deltay($j,$i) * 1.0 / $pret($j,$i) }]
                set dy_dtdtimoins1 [expr {$dy_dt * $pret($j,[expr {$i-1}])}]
                set dti $pret($j,$i)
                set alphap [expr {($sumdeltay - $dy_dtdtimoins1) * $dti}]
                
                # Attention: alphap=1 == 0
                if {$i == 1} {set alphap 0}
                
                set dy_2dt [expr {($deltay($j,$i) * 1.0 / (2 * $pret($j,$i) ) )}]
                set sumCo [expr {$sumCo + $dy_2dt  * ($t2p - $t2p-1) + $alphap}]
            }
        }
        #
        set Co($j) [expr {$yo + $1_T * $sumCo}]
    }
    $p insert end "\nProcedure COF: Ao $Ao(0) Co $Co(0)"
    #
    # Armer une matrice de coefficients par individus,
    #
    set coefa_mat "$Ao(0) $Co(0) "
    set coefa_mat ""
    for {set j 0} {$j < [mrows $x]} {incr j} {
        # D'un INDIVIDU a l'autre
        set 2pi_T [expr {6.283185307 * 1.000 / $perimetre($j)}];#  cfr. T = p. t in NTSYS techn. det. <- ???
        for {set k 1} {$k < $harm_nb} {incr k} {
            # D'une HARMONIQUE a l'autre
            append coefa_mat  "$coefa($j,$k) "
        }
    }
    bleu "\ncoefa_mat nombre de coefficients [llength $coefa_mat]"
    #debug "\ncoefa_mat nombre de coefficients [llength $coefa_mat]"
    # Attention le S(pafmatall_ne se remplit qu'une fois)
    #tk_messageBox -message "J'appende coefa_mat dans S(pre_pafmatall_sf)" -type ok
    append S(pre_pafmatall_sf) "$coefa_mat ";#  <- enregistres dans ..._OTL_FOGsf.txt (cfr. viewing .spe) <- POURQUOI SIZE FREE ??
    #debug "S(pafmatall_sf) dans COF: [llength $S(pafmatall_sf)] \n$S(pafmatall_sf)"
    #
    set hume "2 [mrows $x] [expr {4 * ($harm_nb - 1)}]"
    set coefa_mat "$hume $coefa_mat"
    #$p insert end [show $coefa_mat]
    $p insert end "\n(Procedure COF) ... croquis from\n$coefa_mat"
    #
    croquis $coefa_mat 1 $points $Ao(0) $Co(0)
}
#
# Procedure COF - fin

# Procedure ALGOR -- debut
proc algor {x cifra} {
    
    #ATTENTION CO ET AO MAL ENREGISTRES DANS OTL-FOG
    
    global profil coeff_AO coeff_CO
    #debug "matrice no centree: [show $profil]\nx $x" PAS SUR
    global S p totalpower puissance fp chevalet Ao Co harm_nb infile
    #
    # AIRE du polygone digitalise PAS SUR
    #set S(otl_aire,$cifra) [expr {abs([polygonArea $x])}]
    # L'aire de l'ellipse de la premiere harmonique necessite d'abord le calcul des coefficients, pues!
    #debug "aire de la figure $cifra: $S(otl_aire,$cifra)"
    #
    # Enlever les coordonnees des centroides (un centroide par individu, 0.0 puisque centre) - SI
    set x [mrange $x 2 end 0 end]
    #debug "CENTROIDE = $S(centroid)"
    #
    # [mcols $x] = [expr {$contour * 2}]  SI
    set contour [expr {[mcols $x] * 1 / 2}];# LE NOMBRE DE POINTS (= 'p' = 'number of steps' in NTSYS)
    #
    # Le pas angulaire (theta) PAS SUR
    #set theta [expr {6.283185307 * 1.0 / $contour}];#cela avait ete calcule (inutilement) dans la procedure HAND...
    #
    #
    set temps [time {
        #
        for {set j 0} {$j < [mrows $x]} {incr j} {
            set totalpower($cifra) 0
            #
            # D'un INDIVIDU 'j' a l'autre =========================== INDIVIDUS ===============================
            # Autre forme possible de calcul, peut-etre plus rapide
            #
            set my [join_cols [mrange $x 2 end 0 end] [mrange $x 0 1 0 end]]
            set mx "2 [expr {[mcols $x]/2}] 2 [vtrim $x]";#passage a deux colonnes x et y
            set my "2 [expr {[mcols $x]/2}] 2 [vtrim $my]"
            set Dx [msub [mrange $my 0 0 0 end] [mrange $mx 0 0 0 end]]
            set Dy [msub [mrange $my 1 1 0 end] [mrange $mx 1 1 0 end]]
            set Dx2 [mprod $Dx $Dx]
            set Dy2 [mprod $Dy $Dy]
            set proDt [madd $Dx2 $Dy2];#faut la racine carree de ces elements
            #
            set compteur 0
            set liste [vtrim $proDt]
            set brot [vtrim $proDt]
            foreach item $liste {
                set liste [listassign $liste $compteur [expr {sqrt($item)}]]
                if {$compteur > 0} {
                    set b [expr {sqrt([lindex $brot $compteur] )}]
                    set a [lindex $brot [expr {$compteur - 1}] ]
                    #if {$compteur <4} {#debug "$compteur: a = $a b = $b"}
                    set brot [listassign $brot $compteur [expr {$a+$b}] ]
                } else  {
                    set brot [listassign $brot $compteur [expr {sqrt($item)}] ]
                    #debug "$compteur: a = [expr {sqrt($item)}]"
                }
                incr compteur
            }
            #
            set Dt "2 [mrows $proDt] [mcols $proDt] $liste";#racines carrees dans la matrice monocolonne Dt = chordal distances = pret(ind,point)
            set cumsumDt [msum $Dt]
            set t1 "2 [mrows $proDt] [mcols $proDt] $brot"
            set t1m1 "2 [mrows $proDt] [mcols $proDt] 0 [lrange $brot 0 end-1]"
            
            $p insert end "\n"
            #$p see end
            
            set Dx_Dt [mdiv $Dx $Dt]
            set Dy_Dt [mdiv $Dy $Dt]
            set pi 3.141592654
            set T $cumsumDt
            set Tscale [expr {1 * 1.000000 / $T}]
            set t1_T [mscale $t1 $Tscale]
            #
            #
            # COEFFICIENTS AO et CO
            # ao<-2*sum(M[,1]*Dt/T)
            # co<-2*sum(M[,2]*Dt/T)
            set fil [mrange $profil 2 end 0 end]
            set M12 "2 [expr {[mcols $fil]/2}] 2 [vtrim $fil]"
            set a [mscale $Dt $Tscale]
            set b [mrange $M12 0 0 0 end]
            set coeff_AO($j) [mscale [msum [mprod $a $b]] 2 ]
            set b [mrange $M12 1 1 0 end]
            set coeff_CO($j) [mscale [msum [mprod $a $b]] 2 ]
            #debug "Ao $coeff_AO($j), Co $coeff_CO($j)"
            #
            ################################################################################
            #             for {set k 1} {$k < [expr {($contour * 1 / 2) - 1}]} {incr k} {
            #                 #
            #                 # D'une HARMONIQUE 'k' a l'autre =========================== HARMONIQUES ====================================
            #                 #
            #                 # Test algo R - de J. Claude - debut
            #                 #
            #                 set scale [expr {2 * $k * $pi}]
            #                 set 2kpi_t1_T [mscale $t1_T $scale]
            #                 # Pour A ou C, chaque valeur de 2kpi_t1_T, on en prend le cosinus .- start <- cos(2*k*pi*t1/T)
            #                 set compteur 0
            #                 set rawet [vtrim $2kpi_t1_T]
            #                 foreach item $rawet {
            #                     set rawet [listassign $rawet $compteur [expr {cos($item)}] ]
            #                     incr compteur
            #                 }
            #                 set cos_2kpi_t1_T "[lrange $2kpi_t1_T 0 2] $rawet"
            #                 # Pour A ou C, chaque valeur de 2kpi_t1_T, on en prend le cosinus .- END t1_T
            #                 #
            #                 set t1m1_T [mscale $t1m1 $Tscale]
            #                 set 2kpi_t1m1_T [mscale $t1m1_T $scale]
            #
            #                 # Pour A ou C, chaque valeur de 2kpi_t1m1_T, on en prend le cosinus .- start
            #                 #
            #                 set compteur 0
            #                 set rawet [vtrim $2kpi_t1m1_T]
            #                 foreach item $rawet {
            #                     set rawet [listassign $rawet $compteur [expr {cos($item)}] ]
            #                     incr compteur
            #                 }
            #                 set cos_2kpi_t1m1_T "[lrange $2kpi_t1m1_T 0 2] $rawet"
            #                 # Pour A ou C, chaque valeur de 2kpi_t1m1_T, on en prend le cosinus .- END t1m1_T
            #                 #
            #                 # Pour B ou D, chaque valeur de 2kpi_t1_T, on en prend le sinus .- start <- sin(2*k*pi*t1/T)
            #                 set compteur 0
            #                 set rawet [vtrim $2kpi_t1_T]
            #                 foreach item $rawet {
            #                     set rawet [listassign $rawet $compteur [expr {sin($item)}] ]
            #                     incr compteur
            #                 }
            #                 set sin_2kpi_t1_T "[lrange $2kpi_t1_T 0 2] $rawet"
            #                 #
            #                 # Pour B ou D, chaque valeur de 2kpi_t1_T, on en prend le sinus .- END t1_T
            #                 #
            #                 set t1m1_T [mscale $t1m1 $Tscale]
            #                 set 2kpi_t1m1_T [mscale $t1m1_T $scale]
            #                 # Pour B ou D, chaque valeur de 2kpi_t1m1_T, on en prend le sinus .- start
            #                 #
            #                 set compteur 0
            #                 set rawet [vtrim $2kpi_t1m1_T]
            #                 foreach item $rawet {
            #                     set rawet [listassign $rawet $compteur [expr {sin($item)}] ]
            #                     incr compteur
            #                 }
            #                 set sin_2kpi_t1m1_T "[lrange $2kpi_t1m1_T 0 2] $rawet"
            #                 # Chaque valeur de 2kpi_t1m1_T, on en prend le sinus .- END t1m1_T
            #
            #                 # Calcul final :
            #
            #                 # Premier facteur, le meme pour chaque coeffcient: T/(2*pi^2*i^2))
            #                 set facteur_b [expr {$T * 1.000 / (2*$pi*$pi*$k*$k) } ]
            #                 #
            #                 # COEFFICIENT A - START
            #                 #
            #                 # an[i]<- (T/(2*pi^2*i^2))*sum((Dx/Dt)*(cos(2*i*pi*t1/T)-cos(2*pi*i*t1m1/T)))
            #                 #
            #                 # [msum [msub [mprod $Dx_Dt $cos_2kpi_t1_T] $cos_2kpi_t1m1_T]]
            #                 set facteur_a [msum [mprod $Dx_Dt [msub $cos_2kpi_t1_T $cos_2kpi_t1m1_T] ] ]
            #                 set coeff_a($k) [expr {$facteur_b * $facteur_a}]
            #                 #
            #                 # COEFFICIENT A - END
            #                 #
            #                 # COEFFICIENT B - START
            #                 #
            #                 # bn[i]<- (T/(2*pi^2*i^2))*sum((Dx/Dt)*(sin(2*i*pi*t1/T)-sin(2*pi*i*t1m1/T)))
            #                 #
            #                 # [msum [msub [mprod $Dx_Dt $cos_2kpi_t1_T] $cos_2kpi_t1m1_T]]
            #                 set facteur_a [msum [mprod $Dx_Dt [msub $sin_2kpi_t1_T $sin_2kpi_t1m1_T] ] ]
            #                 set coeff_b($k) [expr {$facteur_b * $facteur_a}]
            #                 #
            #                 # COEFFICIENT B - END
            #                 #
            #                 # COEFFICIENT C - START
            #                 #
            #                 # cn[i]<- (T/(2*pi^2*i^2))*sum((Dy/Dt)*(cos(2*i*pi*t1/T)-cos(2*pi*i*t1m1/T)))
            #                 #
            #                 # [msum [msub [mprod $Dx_Dt $cos_2kpi_t1_T] $cos_2kpi_t1m1_T]]
            #                 set facteur_a [msum [mprod $Dy_Dt [msub $cos_2kpi_t1_T $cos_2kpi_t1m1_T] ] ]
            #                 set coeff_c($k) [expr {$facteur_b * $facteur_a}]
            #                 #
            #                 # COEFFICIENT C - END
            #                 #
            #                 # COEFFICIENT D - START
            #                 #
            #                 # dn[i]<- (T/(2*pi^2*i^2))*sum((Dy/Dt)*(sin(2*i*pi*t1/T)-sin(2*pi*i*t1m1/T)))
            #                 #
            #                 # [msum [msub [mprod $Dx_Dt $sin_2kpi_t1_T] $sin_2kpi_t1m1_T]]
            #                 set facteur_a [msum [mprod $Dy_Dt [msub $sin_2kpi_t1_T $sin_2kpi_t1m1_T] ] ]
            #                 set coeff_d($k) [expr {$facteur_b * $facteur_a}]
            #                 #
            #                 # COEFFICIENT D - END
            #
            #             };# Fin d'une H a l'autre
            #             # -----------------------------------------------------------------------------------------------
            ################################################################################
        }
        append S(perimeter) "$cumsumDt "
        for {set dot 0} {$dot < [mrows $proDt]} {incr dot} {
            set rpret($j,$p) [lindex [vtrim $Dt] $dot]
            set rprot($j,$p) [lindex [vtrim $t1] $dot]
        }
    } ];#fin du decompte de la duree
    $p insert end "\n\nCalculation time of algor: $temps\n"
    #debug "\ntemps $temps\
    \nprot(0,dernier point) \t$cumsumDt = $S(perimeter) ?\
            \nt1 = prot(ind,point) \n $t1 \
            \nt1m1 \n $t1m1 \
            \nproDt \n $proDt \
            \nDt = pret(ind,point)\n $Dt"
    append S(perimeter) "$cumsumDt "
    #
}
# Procedure ALGOR -- fin

# Procedure EFA - start
#
# ... procedure appelee par HAND (qui centralise la matrice des coordonnees), elle-meme sollicitee par OTLMAIN
#
proc efa {x cifra} {
    
    #ATTENTION CO ET AO MAL ENREGISTRES DANS OTL-FOG
    
    global profil coeff_AO coeff_CO
    #debug "matrice no centree: [show $profil]\nx $x"
    global S totalpower p puissance fp chevalet Ao Co harm_nb infile
    #
    # AIRE du polygone digitalise
    set S(otl_aire,$cifra) [expr {abs([polygonArea $x])}]
    # L'aire de l'ellipse de la premiere harmonique necessite d'abord le calcul des coefficients, pues!
    #debug "aire de la figure $cifra: $S(otl_aire,$cifra)"
    #
    # Enlever les coordonnees des centroides (un centroide par individu, 0.0 puisque centre) - LE CENTROIDE EST ENLEVE
    set x [mrange $x 2 end 0 end]
    #debug "CENTROIDE = $S(centroid)"
    #
    # [mcols $x] = [expr {$contour * 2}]
    set contour [expr {[mcols $x] * 1 / 2}];# LE NOMBRE DE POINTS (= 'p' = 'number of steps' in NTSYS)
    #
    # Le pas angulaire (theta)
    set theta [expr {6.283185307 * 1.0 / $contour}];#cela avait ete calcule (inutilement) dans la procedure HAND...
    #
    #
    #
    #
    set duree [time {
        for {set j 0} {$j < [mrows $x]} {incr j} {
            set miniduree [time {
                # d'un INDIVIDU a l'autre ================================== =================================== ========================
                set prot($j,0) 0
                set prot_scaled($j,0) 0
                set sumchorde 0
                set compteur 0
                set perimetre($j) 0
                
                for {set i 0} {$i < [expr {$contour * 2 - 2}]} {incr i 2} {
                    #
                    # d'un POINT a l'autre # =====================================================================
                    #
                    #rouge "\n->POINT $compteur (individu [expr {$cifra+1}])"
                    #
                    set pt [vtrim [mrange $x [expr {$i + 2}] [expr {$i + 3}] $j $j]]
                    #
                    # Preparation de l'analyse elliptique de Fourier (EFA) ------------------------ Preparation EFA
                    #
                    # deltax et deltay (au point $compteur)
                    #
                    set yy2 [expr [lindex [vtrim [mrange $x [expr {$i + 2}] [expr {$i + 3}] $j $j ] ]  1] ]
                    set yy1 [expr [lindex [vtrim [mrange $x $i [expr {$i + 1}] $j $j] ] 1 ] ]
                    set xx2 [expr [lindex [vtrim [mrange $x [expr {$i + 2}] [expr {$i + 3}] $j $j] ] 0 ] ]
                    set xx1 [expr [lindex [vtrim [mrange $x $i [expr {$i + 1}] $j $j] ] 0] ]
                    set deltax($j,$compteur) [expr {$xx2 - $xx1}];# Displacement along the x-axis of the contour between steps i-1 and i
                    set deltay($j,$compteur) [expr {$yy2 - $yy1}];# .......................................Y-axis .....etc.
                    #$p insert end "\n-> [vtrim [mrange $x $i [expr {$i + 3}] $j $j ] ]\
                    \n deltax at point $compteur, soit deltax($j,$compteur): $xx2 - $xx1 = $deltax($j,$compteur)\
                            \n deltay at point $compteur, soit deltay($j,$compteur): $yy2 - $yy1 = $deltay($j,$compteur)"
                    #
                    # 'pret', the chordal distance along the curve from one point to the next one
                    # //////////////////////
                    set pret($j,$compteur) [disteuclid [vtrim [mrange $x $i [expr {$i+1}] $j $j]] $pt];# 'deltati' LENGTH OF SEGMENT BETWEEN STEPS i-1 and i
                    #$p insert end "\n-> Chordal distance from $compteur to [expr {$compteur+1}]"
                    #rouge " i.e. \tpret($j,$compteur) : $pret($j,$compteur)"
                    set ficelle($cifra,$compteur) $pret($j,$compteur)
                    # ///////////////////////
                    # 'prot', the cumulative chordal distance along the curve ... ('pre-t', 'pro-t' pour arriver a 't')
                    #
                    set sumchorde [expr {$sumchorde + $pret($j,$compteur)}]
                    # ///////////////////////
                    set prot($j,$compteur) $sumchorde;#;# 'ti' THE ACCUMULATED LENGTH OF SUCH SEGMENTS
                    #$p insert end "\n-> Cumulative chordal distance at point $compteur, i.e. prot($j,$compteur) :$prot($j,$compteur) "
                    #if {$compteur > 1} {bleu "\nat point [expr {$compteur-1}], i.e. prot($j,[expr {$compteur-1}]) : $prot($j,[expr {$compteur-1}])"}
                    #
                    # Calcul progressif du perimetre T, il a ici exactement la meme valeur que prot($j,$compteur)
                    set perimetre($j) [ expr { $perimetre($j) + [ disteuclid [vtrim [mrange $x $i [ expr { $i+1 } ] $j $j]] $pt ]  } ];# 'T' = t . p
                    # ///////////////////////
                    incr compteur;# D'UN POINT A L'AUTRE
                    #$p see end
                };# d'un point a l'autre, fin. ===================================================================
                
                # !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                # ATTENTION la distance entre le dernier point et le premier n'a pas ete calculee dans la boucle ci-dessus...
                set pt_dernier [vtrim [mrange $x [expr {$contour * 2 - 2}] [expr {$contour * 2 - 1}] $j $j]]
                set pt_premier [vtrim [mrange $x 0 1 $j $j]]
                # deltax et deltay (au point [expr {$contour-1}])
                set yy2 [lindex $pt_dernier 1]
                set yy1 [lindex $pt_premier 1]
                set xx2 [lindex $pt_dernier 0]
                set xx1 [lindex $pt_premier 0]
                set deltax($j,[expr {$contour-1}]) [expr {$xx1 - $xx2}];# le sens de cette difference est important
                set deltay($j,[expr {$contour-1}]) [expr {$yy1 - $yy2}];# la difference avec signe, non la difference absolue!
                #rouge "\n-> POINT [expr {$contour-1}]"
                #$p insert end "\n-> PREMIER ($pt_premier) et DERNIER ($pt_dernier) POINTS\
                \n deltax between point [expr {$contour-1}] and $contour , i.e. deltax($j,[expr {$contour-1}]): $xx2 et $xx1 = $deltax($j,[expr {$contour-1}])\
                        \n deltay at point $compteur : $yy1 - $yy2 = $deltay($j,[expr {$contour-1}])"
                #'pret', the chordal distance along the curve from one point to the next one (pret at point [expr {$contour-1}])
                #
                set pret($j,[expr {$contour-1}]) [disteuclid $pt_dernier $pt_premier]
                #$p insert end "\n-> Chordal distance from [expr {$contour-1}] to $contour"
                #rouge " i.e. \tpret($j,[expr {$contour-1}]) : $pret($j,[expr {$contour-1}])"
                #
                set sumchorde [expr {$sumchorde + $pret($j,[expr {$contour-1}])}]
                set prot($j,[expr {$contour-1}]) $sumchorde
                #$p insert end "\n-> Cumulative chordal distance \nat point [expr {$contour-1}], i.e. prot($j,[expr {$contour-1}]) :$prot($j,[expr {$contour-1}]) "
                #if {$compteur > 1} {bleu "\nat point [expr {$contour-2}], i.e. prot($j,[expr {$contour-2}]) : $prot($j,[expr {$contour-2}])"}
                #
                # Perimeter $perimetre($j) should be like last cumulative chordal distance: prot($j,$i) = $prot($j,$i)
                #////////////////////////
                set perimetre($j) $prot($j,[expr {$contour-1}])
                append S(perimeter) "$perimetre($j) "
                #debug "S(perimeter) $S(perimeter)"
                # ///////////////////////
                # !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                #
            }]
            $p insert end "\n\nCalculation minitime of EFA miniduree $miniduree"
            
        };# d'un INDIVIDU a l'autre, FIN ================================== =================================== ========================
        
        ###############################################################################
        #debug "S(perimeter) in EFA \n$S(perimeter)"
        
        #
        
        #$p see end
        #
        for {set j 0} {$j < [mrows $x]} {incr j} {
            set totalpower($cifra) 0
            #
            # D'un INDIVIDU 'j' a l'autre
            
            # ---------------------------------------------------------------------------------------------------------------------------------------
            #
            # Calculs des COEFFICIENTS A et B (pour x), C et D (pour y). Rien pour z, on est en bidimensionel.
            #
            # ---------------------------------------------------------------------------------------------------------------------------------------
            #
            #
            # Ce calcul est realise pour chaque harmonique
            
            ################################################################################
            set 2pi_T [expr {6.283185307 * 1.000000 / $perimetre($j)}];#  cfr. T = p. t in NTSYS techn. det.
            ################################################################################
            #
            for {set k 1} {$k < [expr {($contour * 1 / 2) - 1}]} {incr k} {
                #
                # D'une HARMONIQUE 'k' a l'autre ---------------------------------------------------------------
                #
                ################################################################################
                set T_2p2pi2 [expr {$perimetre($j) * 1.000/ (2 * $k * $k * 3.141592654 * 3.141592654)}]
                # lire ci-dessus: ' T sur 2n au carre 2 pi au carre ' (le 'n' ici est le 'p' ci-dessus)
                set 2pik_T [expr {$k * $2pi_T}];# lire 2 pi k sur T
                
                
                set sumA 0
                set sumB 0
                set sumC 0
                set sumD 0
                #
                # ---------------------------------------------------------------------------------------------------------
                #
                for {set i 1} {$i < $contour} {incr i} {
                    #
                    # D'un POINT  'i' a l'AUTRE, pour l'harmonique k -- pre-calcul de A et de C
                    #
                    set a [expr {cos($2pik_T * $prot($j,$i))}]
                    set b [expr {cos($2pik_T * $prot($j,[expr {$i-1}]))}]
                    #debug "A et C: a $a et b $b et deltax($j,$i) = $deltax($j,$i) et pret($j,$i)  = $pret($j,$i)  "
                    if {$pret($j,$i) > 0} {
                        set sumA [expr {$sumA + ( ( $deltax($j,$i) * 1.0 / $pret($j,$i) ) * ($a - $b) )}]
                        set sumC [expr {$sumC + ( ( $deltay($j,$i) * 1.0 / $pret($j,$i) ) * ($a - $b) )}]
                    }
                }
                #
                # ---------------------------------------------------------------------------------------------------------
                #
                for {set i 1} {$i < $contour} {incr i} {
                    #
                    # D'un POINT  a l'AUTRE, pour l'harmonique k -- pre-calcul de B et de D
                    #
                    set a [expr {sin($2pik_T * $prot($j,$i))}]
                    set b [expr {sin($2pik_T * $prot($j,[expr {$i-1}]))}]
                    #debug "B et D: a $a et b $b et deltax($j,$i) = $deltax($j,$i) et pret($j,$i)  = $pret($j,$i)  "
                    if {$pret($j,$i) > 0} {
                        set sumB [expr {$sumB + ( ( $deltax($j,$i) * 1.0 / $pret($j,$i) ) * ($a - $b) )}]
                        set sumD [expr {$sumD + ( ( $deltay($j,$i) * 1.0 / $pret($j,$i) ) * ($a - $b) )}]
                    }
                }
                #
                # ---------------------------------------------------------------------------------------------------------
                #
                
                # -------------------------------------------------------------------
                # Calcul de A de l'individu 'j' pour l'harmonique 'k'
                # -------------------------------------------------------------------
                set sumA [expr {$T_2p2pi2 * $sumA}]
                if {$k < $harm_nb} {append coefa($j,$k) "$sumA "}
                # -------------------------------------------------------------------
                # Calcul de B de l'individu j pour l'harmonique k
                # -------------------------------------------------------------------
                set sumB [expr {$T_2p2pi2 * $sumB}]
                #rouge "\nEFA, individu $j, harmonique $k, B: $sumB "
                if {$k < $harm_nb} {append coefa($j,$k) "$sumB "}
                # -------------------------------------------------------------------
                # Calcul de C de l'individu j pour l'harmonique k
                # -------------------------------------------------------------------
                set sumC [expr {$T_2p2pi2 * $sumC}]
                if {$k < $harm_nb} {append coefa($j,$k) "$sumC "}
                # -------------------------------------------------------------------
                # Calcul de D de l'individu j pour l'harmonique k
                # -------------------------------------------------------------------
                set sumD [expr {$T_2p2pi2 * $sumD}]
                if {$k < $harm_nb} {append coefa($j,$k) "$sumD "}
                #
                # -- calcul de la puissance totale
                #
                set puissance($cifra,$k) [expr {pow($sumA,2) + pow($sumB,2) + pow($sumC,2) + pow($sumD,2)}]
                set puissance($cifra,$k) [expr {$puissance($cifra,$k) * 1.0 / 2}]
                
                if {$k > 1} {
                    set totalpower($cifra) [expr {$totalpower($cifra) + $puissance($cifra,$k)}]
                    append S(totpow,$cifra) "$totalpower($cifra) "
                    # comme le nb total d'harmoniques differe, les listes totpow n'ont pas la mm longueur
                    #debug "S(totpow,$cifra)\t$S(totpow,$cifra)\nIndiv $cifra, harm $k: \nA $sumA\nB $sumB\nC $sumC\nD $sumD\ntotalpower($cifra) $totalpower($cifra)"
                }
            }
            # D'une HARMONIQUE (k) a l'autre (k+1) -> harm_nb -- fin
            
            # -------------------------------------------------------------------
            # Calcul de Ao et de Co (Bo = Do = 0) selon NTSYS techn. det.
            # -------------------------------------------------------------------
            #############################################################################
            ###############################################################################
            #
            #remplacer x par les donnees non centrees (profil)
            set fil [mrange $profil 2 end 0 end]
            set x $fil
            set 1_T  [expr {1.0 * 1.0 / $perimetre($j)}];# NTSYS techn. det.
            #
            set pt_premier [vtrim [mrange $x 0 1 $j $j]]
            set yo [lindex $pt_premier 1]
            set xo [lindex $pt_premier 0]
            #
            set sumAo 0
            for {set i 1} {$i < [expr {$contour}]} {incr i} {
                if {$pret($j,$i) > 0} {
                    set tp $prot($j,$i)
                    set tp-1 $prot($j,[expr {$i-1}])
                    set t2p [expr {$tp * $tp}]
                    set t2p-1 [expr {$tp-1 * $tp-1}]
                    
                    set sumdeltax 0
                    for {set g 1} {$g <  [expr {$i - 1}]} {incr g} {
                        set sumdeltax [expr {$sumdeltax + $deltax($j,$g)}]
                    }
                    set dx_dt [expr {$deltax($j,$i) * 1.0 / $pret($j,$i) }]
                    set dx_dtdtimoins1 [expr {$dx_dt * $pret($j,[expr {$i-1}])}]
                    set dti $pret($j,$i)
                    set alphap [expr {($sumdeltax - $dx_dtdtimoins1) * $dti}]
                    
                    # Attention: alphap=1 == 0
                    if {$i == 1} {set alphap 0}
                    
                    set dx_2dt [expr {($deltax($j,$i) * 1.0 / (2 * $pret($j,$i) ) )}]
                    set sumAo [expr {$sumAo + $dx_2dt  * ($t2p - $t2p-1) + $alphap}]
                }
            }
            #
            #tk_messageBox -message "Ao($j) = $xo + $1_T x $sumAo"
            #
            set Ao($j) [expr {$xo + $1_T * $sumAo}]
            #
            
            
            
            
            #set Ao($j) [vtrim $coeff_AO($j)]
            append S(Ao) "$Ao($j) "
            
            
            
            
            
            ###############################################################################
            set sumCo 0
            for {set i 1} {$i < [expr {$contour}]} {incr i} {
                if {$pret($j,$i) > 0} {
                    set tp $prot($j,$i)
                    set tp-1 $prot($j,[expr {$i-1}])
                    set t2p [expr {$tp * $tp}]
                    set t2p-1 [expr {$tp-1 * $tp-1}]
                    
                    set sumdeltay 0
                    for {set g 1} {$g <  [expr {$i - 1}]} {incr g} {
                        set sumdeltay [expr {$sumdeltay + $deltay($j,$g)}]
                    }
                    set dy_dt [expr {$deltay($j,$i) * 1.0 / $pret($j,$i) }]
                    set dy_dtdtimoins1 [expr {$dy_dt * $pret($j,[expr {$i-1}])}]
                    set dti $pret($j,$i)
                    set alphap [expr {($sumdeltay - $dy_dtdtimoins1) * $dti}]
                    
                    # Attention: alphap=1 == 0
                    if {$i == 1} {set alphap 0}
                    
                    set dy_2dt [expr {($deltay($j,$i) * 1.0 / (2 * $pret($j,$i) ) )}]
                    set sumCo [expr {$sumCo + $dy_2dt  * ($t2p - $t2p-1) + $alphap}]
                }
            }
            #
            #tk_messageBox -message "Co($j) = $yo + $1_T x $sumCo"
            #
            set Co($j) [expr {$yo + $1_T * $sumCo}]
            ###############################################################################
            
            #set Co($j) [vtrim $coeff_CO($j)]
            append S(Co) "$Co($j) "
            #
            for {set k 1} {$k < $harm_nb} {incr k} {
                $p insert end "\nEFA Individu [expr {$cifra +1}], h $k: $coefa($j,$k)"
            }
            bleu "\nEFA Individu [expr {$cifra +1}], : Ao = $Ao($j) Co = $Co($j)\n"
        }
        #
        #$p see end
        
        # La partie ci-dessous se joue probablement en FOGMAIN
        # Armer une matrice de coefficients par individus,
        # chacun defini par harm_nb * 4 coefficients - harm_nb reduit a 10 <- ??
        for {set j 0} {$j < [mrows $x]} {incr j} {
            # D'un INDIVIDU a l'autre
            set 2pi_T [expr {6.283185307 * 1.000 / $perimetre($j)}];#  cfr. T = p. t in NTSYS techn. det. <- ??
            for {set k 1} {$k < $harm_nb} {incr k} {
                # D'une HARMONIQUE a l'autre
                append coefa_mat  "$coefa($j,$k) "
            }
        }
        set hume "2 [mrows $x] [expr {4 * ($harm_nb - 1)}]"
        set coefa_mat "$hume $coefa_mat"
        #
    }]
    $p insert end "DUREE $duree"
    return $coefa_mat;# coefa_mat retourne a HAND qui le retourne a OTLMAIN
    #
}
#
# Procedure EFA - end

#Procedure LPGE - start
#
proc  lpge {contour} {
    #
    # Le plus grand ecart des x, et le plus grand ecart des y, pour obliger les figures a tenir dans un cadre
    #
    # Tous les x et tous les y dans deux listes separees, l'ordre est preserve
    #
    set xliste ""
    set yliste ""
    foreach {xcontour ycontour} $contour {
        lappend xliste $xcontour
        lappend yliste $ycontour
    }
    #
    set new_x ""
    set xordre [lsort -real -decreasing $xliste]
    set xmax [lindex $xordre 0]
    set xmin  [lindex $xordre end]
    #
    set new_y ""
    set yordre [lsort -real -decreasing $yliste]
    set ymax [lindex $yordre 0]
    set ymin  [lindex $yordre end]
    #
    # Le plus grand ecart des x, et le plus grand ecart des y
    #
    set lpgex [expr {$xmax - $xmin}]
    set lpgey [expr {$ymax - $ymin}]
    #
    #tk_messageBox -message  [list $lpgex $lpgey] -type ok
    return [list $lpgex $lpgey]
}
#
#Procedure LPGE - end

# Procedure CADRE - debut
#
proc cadre {contour cote ratio} {
    #
    # Le "ratio" est le pourcentage de la taille maximum, tjrs <=1; si c'est 1 (on ecrit 2), c'est que la taille est la meme pour tous...
    #
    # Tenir dans un cadre de (cote =) 450 de cotes - debut
    if {$ratio < 2} {
        #
        # LPGE calcule la plus grande difference entre les coordonnees x, et de meme entre les y
        set lpgexlpgey [lpge $contour];# appel a la procedure LPGE
        set lpgex [lindex $lpgexlpgey 0]
        set lpgey [lindex $lpgexlpgey 1]
        if {$lpgex > $lpgey} {set denom $lpgex} else {set denom $lpgey}
        #
        set cuadro ""
        #debug "denom = $denom"
        if {$denom > 0} {
            # depuis fognorm...
            foreach item $contour {
                append cuadro "[expr {$item * $cote * $ratio * 1.0 / $denom}] "
            }
            #
            return $cuadro
        } else  {
            return
        }
        #
        # mais si la proportion est de 1 ...
    } else  {
        #
        set cuadro ""
        foreach item $contour {
            append cuadro "[expr {$item * $cote * $ratio * 1}] "
        }
        return $cuadro
    }
    # Tenir dans un cadre - fin
}
#
# Procedure CADRE - end



# Procedure CANAD - debut
#
# canvas adjust - ne sera sans doute bientot plus necessaire
#
proc  canad {qui tot canlargeur canhauteur} {
    global S
    # tot est une matrice de HUME
    #
    set S(deplacementx) ""
    set S(deplacementy) ""
    # Tous les x et tous les y dans deux listes separees, l'ordre est preserve
    #
    set sumx 0
    set sumy 0
    set listex ""
    set listey ""
    foreach {x y} [lrange $tot 3 end] {
        set sumx [expr {$sumx + $x}]
        set sumy [expr {$sumy + $y}]
        lappend listex $x
        lappend listey $y
    }
    #
    # Avant d'inserer la figure dans le canvas aux dimensions 'canlargeur' et 'canhauteur' (le 'cadre')
    # il faudrait deplacer x et y pour eviter les valeurs negatives...
    ################################################################################
    #     if {[lindex [lsort -real $listex] 0] < 0} {set deplacementx [lindex [lsort -real $listex] 0]}
    #     if {[lindex [lsort -real $listey] 0] < 0} {set deplacementy [lindex [lsort -real $listey] 0]}
    ################################################################################
    set deplacementx [lindex [lsort -real $listex] 0]
    set deplacementy [lindex [lsort -real $listey] 0]
    lappend S(deplacementx) [expr {abs($deplacementx) + ($canlargeur / 2)}]
    lappend S(deplacementy) [expr {abs($deplacementy) + ($canhauteur / 6)}]
    #
    # CANAD le deplacement MAXIMUM est sera choisi,
    # commun a toutes les figures en X et en Y
    # CANADOR: de ce deplacement, il faudra(it) ensuite deduire
    # les coordonnees du CENTROIDE propre a chaque figure
    return
}
#
# Procedure CANAD - end

# Procedrue CANADOR
#
# canvas adjustor - CANADOR centre les coordonnees (matrice de HUME)
#
proc  canador {qui tot} {
    global S
    # tot est une matrice de Hume !
    #
    # Le positionnement: calcul de deplx et deply (cfr CANAD ci-dessus)
    update
    #
    # Tous les x et tous les y dans deux listes separees, l'ordre est preserve
    #
    set sumx 0
    set sumy 0
    set listex ""
    set listey ""
    foreach {x y} [lrange $tot 3 end] {
        set sumx [expr {$sumx + $x}]
        set sumy [expr {$sumy + $y}]
        lappend listex $x
        lappend listey $y
    }
    # Coordonnees du centroide - necessaire pour CENTRER les figures
    set moyx [expr {$sumx * 1.0 / [mrows $tot]}]
    set moyy [expr {$sumy * 1.0 / [mrows $tot]}]
    #
    # Centrage
    #
    update
    #
    # On centre ...
    set listex ""
    set listey ""
    foreach {x y} [vtrim $tot] {
        set x [expr {$x - $moyx + 450}]
        set y [expr {$y - $moyy + 225}]
        lappend listex $x
        lappend listey $y
    }
    # On replace
    set pre_tot_new ""
    for {set compteur 0} {$compteur < [llength $listex]} {incr compteur} {
        append pre_tot_new "[lindex $listex $compteur] [lindex $listey $compteur] "
    }
    return $pre_tot_new
}
#
# Procedure CANADOR - end


# Procedure ESQUISSE -- start
#
proc esquisse {numero etiquette couleur c liste_r liste_a liste_b} {
    
    global p gribouillis
    #tk_messageBox -message "[llength $liste_r] rayons" -type ok
    
    # average of all radius vectors
    set hume "2 [llength $liste_r] 1 "
    set mat_r "$hume $liste_r"
    set r [lindex [vtrim [mnorms $mat_r ]] 0]
    
    # Perimetre
    set perim [expr {$r * [llength $liste_r]}]
    #
    
    
    # Verification
    if {[llength $liste_a] != [llength $liste_b]} {tk_messageBox -message "unbalanced coefficients" -type ok}
    
    # Nombre de coefficients de Fourier
    set coeffou_nb [expr {[llength $liste_a] - 1}]
    #debug "NOMBRE DE COEFF FOURIER:\t $coeffou_nb"
    #debug "\nLISTE DES COEFF FOURIER: 'a' = \n"
    set boulier 1
    foreach item $liste_a {
        #debug "\n$boulier:\t$item"
        incr boulier
    }
    #
    
    # Mise en array des coefficients
    for {set i 0} {$i < $coeffou_nb} {incr i} {
        set a($i) [lindex $liste_a $i]
        set b($i) [lindex $liste_b $i]
    }
    
    # Harmoniques
    for  {set i 0} {$i < $coeffou_nb} {incr i} {
        set h($i) [expr {sqrt(pow($a($i),2)+pow($b($i),2))}]
        append liste_h "$h($i) "
    }
    
    # Phase angles
    for  {set i 0} {$i < $coeffou_nb} {incr i} {
        set phi($i) [expr {atan($b($i) * 1.0 / $a($i))}]
        if {$b($i) > 0 && $a($i) > 0} {set phi($i) $phi($i)}
        if {$b($i) < 0 && $a($i) > 0} {set phi($i) [expr {$phi($i)+ 180}]}
        if {$b($i) < 0 && $a($i) < 0} {set phi($i) [expr {$phi($i)+ 180}]}
        if {$b($i) > 0 && $a($i) < 0} {set phi($i) [expr {$phi($i)+ 360}]}
        if {$b($i) == 0 && $a($i) > 0} {set phi($i) 90}
        if {$b($i) == 0 && $a($i) < 0} {set phi($i) 270}
        append liste_phi "$phi($i) "
    }
    #
    
    # Nombre de points
    set points_nb [llength $liste_r]
    
    #NOMBRE DE POINTS POUR LE DESSIN
    set puntos 90
    
    # Pas angulaire
    set pas [expr {6.283185307 * 1.0 / $puntos}]
    
    # Ao
    set azero $r
    #tk_messageBox -message "rayon moyen $r" -type ok
    
    # # couleurs de courbe
    #
    set color(0) red
    set color(1) pink
    set color(2) black
    set color(3) blue
    set color(4) green
    set color(5) yellow
    set color(6) orange
    set color(7) grey50
    set color(8) orange
    set color(9) green
    set color(10) blue
    set color(11) red
    set color(12) "dark blue"
    set color(13) pink
    
    ###############################################################################
    # La courbe selon les coefficients a et b
    #
    # somme des cosinus pour chaque coordonnee
    for {set i 0} {$i < $puntos} {incr i} {
        set sum_cos 0
        for {set j 1} {$j < $coeffou_nb } {incr j} {
            set sum_cos [expr {$sum_cos + $a($j) * cos($pas * $i * $j)}]
        }
        set coord_cospolar($i) $sum_cos;# coordonnees polaires
    }
    # somme des sinus pour chaque coordonnee
    for {set i 0} {$i < $puntos} {incr i} {
        set sum_sin 0
        for {set j 1} {$j < $coeffou_nb } {incr j} {
            set sum_sin [expr {$sum_sin + $b($j) * sin($pas * $i * $j)}]
        }
        set coord_sinpolar($i) $sum_sin;# coordonnees polaires
    }
    # coordonnees polaires de chaque point (on utilise les sommes plus haut en y ajoutant la moyenne des rayons)
    for {set i 0} {$i < $puntos} {incr i} {
        set coordpolar($i) [expr {$r + $coord_cospolar($i) + $coord_sinpolar($i)}]
    }
    # coordonnees rectangulaires de chaque point
    set pretotale ""
    for {set i 0} {$i < $puntos} {incr i} {
        set xxx($i) [expr {$coordpolar($i) * cos($pas * $i)}]
        set yyy($i) [expr {$coordpolar($i) * sin($pas * $i)}]
        append pretotale "$xxx($i) $yyy($i) "
    }
    
    # Ajout du premier point en fin de liste ... pour boucler la boucle
    set premierpt [lrange $pretotale 0 1]
    set totale "$pretotale $premierpt "
    #
    # Ajout du premier point en fin de liste ... OK
    
    set hume "2 [expr {$puntos * 2}] 1 "
    set totale "$hume $totale"
    #debug "Nombre de points $puntos et TOTALE : [llength $totale]\n$totale"
    
    ################################################################################
    #     # version _06: composantes principales des coordonnees
    #     $p insert end "\nAvant alignement\n"
    #     bleu "\n[show $totale]"
    #     set totale [copri $totale]
    #     $p insert end "\nApres alignement\n"
    #     rouge "\n[show $totale]"
    ################################################################################
    # ----------------------------------------------------------------------
    # Ajustement au canvas
    set adjustedtotale [canad $numero $totale 1000 500];# tot et adjustedtot sont des matrices de hume
    # Ajustement au canvas -- FIN
    # ----------------------------------------------------------------------
    #tk_messageBox -message "$adjustedtotale" -type ok
    ###############################################################################
    # Dessin de la courbe
    ###############################################################################
    #
    #$c create line [vtrim $adjustedtotale] -fill $color($etiquette) -tag $etiquette
    $c create line [vtrim $adjustedtotale] -fill blue -tag $etiquette
    
    set compte 0
    set sumx 0
    set sumy 0
    foreach {x y} [vtrim $adjustedtotale] {
        incr compte
        set sumx [expr {$sumx + $x}]
        set sumy [expr {$sumy + $y}]
    }
    set moyx [expr {$sumx * 1.0 / $compte}]
    set moyy [expr {$sumy * 1.0 / $compte}]
    $c create text $moyx $moyy -fill red -text "$etiquette $numero" -tag $etiquette
    #set zou ha
    #$c create line [vtrim $adjustedtotale] -fill $couleur -tag $zou
    #append gribouillis " $zou "
    ###############################################################################
}
#
# Procedure ESQUISSE -- end

# Procedure SAVELISTING - start
#
proc  savelisting {dequoi} {
    # ***************************************************************
    # Tentative d'ecriture d'un fichier DE RAPPORT en CSV
    # ***************************************************************
    global S
    global p infile
    set infile $S(datadir)
    $p insert end "\nData directory $S(datadir) <-> $infile"
    set megainfo "\nFichier : $infile\n"
    set megatexte [$p get 1.0 {end}]
    # pourquoi je me répète ?
    global infile
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    #debug
    #puts "chemin = $dirinfile"
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    #debug
    #puts "\ntail = $tailfile"
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    #debug
    #puts "root = $rootfile"
    set fin $dequoi
    set filename "$dirinfile$rootfile$fin"
    #debug
    #puts "filename = $filename"
    
    wm title . $filename
    # OPEN THE FILE
    set fileid [open $filename w]
    # FILL THE FILE
    puts -nonewline $fileid $megainfo
    puts -nonewline $fileid $megatexte
    # CLOSE THE FILE
    close $fileid
}
#
# Procedure SAVELISTING - end


# Procedure OTLFILE - start
#
# prend le nom du fichier nu, sans extension et sans repertoire,
# et le transforme en fichier _OTL.txt, avec extension et repertoire
#
proc otlfile {fichier} {
    global infile fp
    set fileotl [string first "_OTL" $fichier]
    #debug "Your input file is $fichier\nfileotl $fileotl"
    set fileotl [string range $fichier 0 $fileotl]
    #debug "fileotl $fileotl"
    set fin "OTL.txt"
    set fileotl [file join [file dirname $infile] $fileotl$fin]
    #debug "fileotl $fileotl"
    #
    return $fileotl
}
#
# Procedure OTLFILE - end


# Procedure OUVRIR (de VAR)
#
proc ouvrir {} {
    global p S data
    set typeList {
        {{"Text files"} {.seq .txt .nts .TXT .NTS .csv .CSV .tps .TPS} }
    }
    global infile texte dossier primeralinea
    
    ################################################################################
    #     # Chercher le chemin dans un fichier de configuration
    #     # 1. verifier que le fichier de configuration existe
    #     set chemin "[pwd]/dossier_fog.txt"
    #     #puts "chemin $chemin"
    #     # 2. s'il n'existe pas, voir ci-dessus
    #     if {[file exists $chemin] == 0} {
    #         set candidat_dossier [pwd]
    #     } else  {
    #         #puts "La conf existe"
    #         # 3. s'il existe reccueillir le dernier chemin parcouru
    #         # open le fichier pour lire
    #         catch [
    #         set fid [open $chemin r]
    #         set candidat_dossier [read -nonewline $fid]
    #         close $fid
    #         ] ici
    #         #puts "candidat_dossier $candidat_dossier"
    #         set candidat_dossier [lindex [split $candidat_dossier \n] 1]
    #         #debug "dossier = $candidat_dossier"
    #     }
    ################################################################################
    
    
    # Chercher sa route dans un fichier de configuration: il y en a un dans le dossier FOG (chemin), et un dans le dossier CLIC (route)
    # dans le dossier MOG
    set chemin "[pwd]/dossier_fog.txt"
    # dans le dossier CLIC
    set route $S(dirclic)/dossier_CLIC.txt
    #
    # On lit d'abord le fichier dossier_CLIC, s'il existe
    # sinon
    # on lit le fichier du script, s'il existe
    #
    # 1. verifier que les fichiers de routage existent
    if {[file exists $route] == 0} {
        # dans le cas ou il n'y a pas de fichier de routage dans le dossier CLIC
        set candidat_dossier_CLIC [pwd]
        catch [
        set fid [open $route w+]
        puts -nonewline $fid "Dernier dossier de donnees:\n"
        puts -nonewline $fid [pwd]
        close $fid
        ] ici
    } else  {
        # 3. si le fichier de routage existe dans le dossier CLIC, reccueillir alors le dernier chemin parcouru
        # open le fichier pour lire
        catch [
        set fid [open $route r]
        set candidat_dossier_CLIC [read -nonewline $fid]
        close $fid
        ] ici
        set candidat_dossier_CLIC [lindex [split $candidat_dossier_CLIC \n] 1]
        #debug "\ndossier selon CLIC = $candidat_dossier_CLIC"
    }
    
    #debug "chemin $chemin"
    # 2. s'il n'existe pas, voir ci-dessus
    if {[file exists $chemin] == 0} {
        set candidat_dossier [pwd]
    } else  {
        # 3. si le fichier de routage du MODULE existe reccueillir le dernier chemin parcouru
        # open le fichier pour lire
        catch [
        set fid [open $chemin r]
        set candidat_dossier [read -nonewline $fid]
        close $fid
        ] ici
        set candidat_dossier [lindex [split $candidat_dossier \n] 1]
    }
    
    # A present, on a le choix entre candidat_dossier_CLIC et candidat_dossier
    if {$candidat_dossier_CLIC != "./"} {
        #debug "Pas PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        # si le dossier_CLIC n'est pas le dossier en cours (CLIC_XX)
        set candidat_dossier $candidat_dossier_CLIC
        #debug "Pas PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilise par FOG:\n"
        puts -nonewline $fid $candidat_dossier
        close $fid
        ] ici
    } else  {
        # sinon, on adopte le candidat_dossier
        #debug "PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        set candidat_dossier_CLIC $candidat_dossier
        #debug "PWD: candidat_dossier $candidat_dossier   \n...   \ncandidat_dossier_CLIC $candidat_dossier_CLIC"
        catch [
        set fid [open $route w+]
        puts -nonewline $fid "Dernier dossier de donnees:\n"
        puts -nonewline $fid $candidat_dossier_CLIC
        close $fid
        ] ici
    }
    
    
    # On va chercher les donnees --------------------------------------------------------
    #catch [
    set infile [tk_getOpenFile -initialdir $candidat_dossier -filetypes $typeList]
    set fid [open $infile]
    set texte [read -nonewline $fid]
    close $fid
    set S(infile) $infile
    #] ici
    
    # Enlever la premiere valeur si le fichier a ete cree par MOG
    # set seuil [trebuche]
    set seuil 1
    #debug
    #puts "seuil $seuil"
    
    # ajoute pour tenter de supprimer les lignes vides
    foreach line [split $texte \n] {
        if  {$line != ""} {
            append newtexte "$line\n"
        }
    }
    set datos ""
    set contador -1
    foreach item [split $newtexte "\n"] {
        if  {$item != ""} { incr contador}
        if {$contador > 0} {
            
            if  {$item != "" && $contador == $seuil || $contador > $seuil } {
                append datos "$item "
                #debug
                #puts "contador $contador"
            }
            
        } else  {
            set primeralinea $item
        }
    }
    
    $p insert end "\n$primeralinea\n"
    
    $p insert end "\nNombre de données : $contador\n"
    
    
    #debug
    #puts "\ndatos--------------- \n$datos\n ----------------\n"
    # ------------------------------------------------------------------------------------------
    
    #infile contient le chemin et le nom du fichier des donnees
    set dossier "[file dirname $infile]/";#repertoire des donnees
    # 4 si ce n'est pas le chemin indique par candidat_dossier, il faut reecrire le fichier de configuration
    if {$dossier != $candidat_dossier} {
        # open le fichier de conf pour ecrire
        catch [
        set fid [open $chemin w+]
        puts -nonewline $fid "Dernier dossier de donnees utilisees par VAR:\n"
        puts -nonewline $fid $dossier
        close $fid
        ] ici
    }
    #debug
    #puts "chemin = $dirinfile"
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    #debug
    #puts "\ntail = $tailfile"
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    #debug
    #puts "root = $rootfile"
    
    #.fdbuttonsdt configure -text $infile
    
    #tk_messageBox -message "string first _PER $infile [string first "_PER" $infile]" -type ok
    
    #Verification du type de fichier --- debut
    if {[string first "_ALIGNED" $infile] < 0 } {set S(fichier_aligned) 0} else {set S(fichier_aligned) 1}
    if {[string first "_CS" $infile] < 0 } {set S(fichier_cs) 0} else {set S(fichier_cs) 1}
    if {[string first "_PER" $infile] < 0 } {set S(fichier_per) 0} else {set S(fichier_per) 1}
    if {[string first "_ARE" $infile] < 0 } {set S(fichier_are) 0} else {set S(fichier_are) 1}
    if {[string first "_RW" $infile] < 0 } {set S(fichier_rw) 0} else {set S(fichier_rw) 1}
    set fichier_pw_cs 0
    if {[string first "_PW_CS" $infile] < 0 } {set S(fichier_pw_cs) 0} else {set S(fichier_pw_cs) 1;set S(fichier_rw) 0;set S(fichier_cs) 0}
    #debug " \nfichier_pw_cs == $fichier_pw_cs\tfichier_cs = $fichier_cs\tfichier_rw = $fichier_rw\n"
    if {$S(fichier_cs) == 0 &&  $S(fichier_rw) == 0 && $S(fichier_aligned) == 0  && $S(fichier_per) == 0  && $S(fichier_are) == 0} {
        set nm [tk_messageBox -message "[file tail $infile]\nThe name of your file does not suggest it contains size data\
                do you want to continue ?" -icon warning -type yesno]
        if {$nm == no} {exit}
    }
    #Verification du type de fichier --- fin
    
    set data $datos
    return $datos
}
#
# procedure OUVRIR - fin




# PROCEDURE loadfile - DEBUT
#
proc loadfile {pathname} {
    
    if {$pathname != ""} {
        global S
        set S(dist_nopar) 0
        set S(datadir) $pathname
        set fid [open $pathname]
        set text [read -nonewline $fid]
        close $fid
        set rowcount 0
        set colcount 0
        global references
        set compteur 0
        set lignes 0
        set data ""
        foreach line [split $text \n] {
            incr compteur
            if {$compteur >1} {
                if  {$line != ""} {
                    set colcount [llength $line]
                }
            }
            if {$compteur>1} {
                foreach item [split $line] { if {$item != ""} {
                        incr lignes
                        append data "[string trim $item]\t"
                    }
                }
            } else {set references $line}
        }
        set rowcount [expr {$lignes / $colcount}]
        set result [concat 2 $rowcount $colcount $data]
        #debug
        #puts "Commentaire brut :\n$references"
        # -- Formater le commentaire
        # -- 1. Enlever d'eventuelles tabulations
        foreach mot $references {
            if {$mot != ""} {
                append comentario_sin_tab "$mot "
            }
        }
        set references $comentario_sin_tab
        set S(references) $references
        # -- FIN du formatage de la premiere ligne
        
        # --------------------------------------------------------------------------------
        #
        # Il faudrait creer le meme fichier en .nts (pour TPSregr) - debut
        #
        set datos ""
        set compteur 0
        foreach truc [split $text "\n"] {
            if {$compteur > 0} {
                if {$truc != ""} {lappend datos "$truc\n"}
            } else {
                #lappend datos "\"$truc\n"
                set premligne $truc
            }
            incr compteur
        }
        # Enlever les curved brackets
        set datos [regsub -all {\{|\}} $datos ""]
        #
        set ntscode "1 $rowcount $colcount 0\n"
        set ntsmatrix $ntscode$datos
        #debug
        #rouge "NTSNTSNTS\n$ntsmatrix\nNTSNTSNTS\n"
        # puis l'enregistrer ...
        # OPEN THE FILE
        set extension ".nts"
        set nameoffile "/[file tail [file rootname $pathname]]"
        set filename [file dirname $pathname]$nameoffile$extension
        set fileid [open $filename w]
        # FILL THE FILE
        puts -nonewline $fileid "\" $premligne \" "
        puts -nonewline $fileid "\n$ntsmatrix"
        # CLOSE THE FILE
        close $fileid
        #
        # Il faudrait creer le meme fichier en .nts (pour TPSregr) - fin
        #
        # --------------------------------------------------------------------------------
        
        return $result
    }
}
#
# PROCEDURE loadfile - FIN


# PROCEDURE loadotl - DEBUT
#
proc loadotl {pathname} {
    #
    if {$pathname != ""} {
        global p S references otl otl_contour
        set S(dist_nopar) 0
        set S(datadir) $pathname
        #
        set fid [open $pathname]
        set text [read -nonewline $fid]
        close $fid
        #
        set compteur -1
        #
        foreach line [split $text \n] {
            if {[string trim $line] != ""} {
                if {$compteur > -1} {
                    set otl($compteur) [lindex $line 0]
                    set otl_contour($compteur) [lrange $line 1 end]
                    set otl_contour($compteur) [regsub -all {NA} $otl_contour($compteur) ""]
                    #debug "otl($compteur) = $otl($compteur) points\notl_contour($compteur) <- [llength $otl_contour($compteur)] coordonnees"
                    incr compteur
                } else  {
                    set references $line
                    incr compteur
                }
            }
        }
        set S(otl_nb) $compteur
        
        #
        # -- Formater le commentaire ('references') - Enlever d'eventuelles tabulations
        foreach mot $references {
            if {$mot != "\t"} {
                append comentario_sin_tab "$mot "
            }
        }
        if {[info exists comentario_sin_tab]} {set references $comentario_sin_tab}
        set S(references) $references
        # -- FIN du formatage de la premiere ligne
        
        #
        # Il faudrait creer le meme fichier en .DTA (pour EFAW), centroide exclu - debut
        #
        set data ""
        append data "\"$references - Centroid removed\" "
        for {set i 0} {$i < $S(otl_nb)} {incr i} {
            append data "\n[expr {$otl($i) - 1}]\n";# Nombre de points (points, pas coordonnees)
            set compteur 0
            foreach {x y} $otl_contour($i) {
                # on saute les coordonnees du point centroide
                if {$compteur > 0} {append data "$x $y\n"}
                incr compteur
            }
        }
        #
        
        # puis l'enregistrer ...
        # OPEN THE FILE
        set extension ".DTA"
        set nameoffile "/[file tail [file rootname $pathname]]"
        set filename [file dirname $pathname]$nameoffile$extension
        set fileid [open $filename w]
        # FILL THE FILE
        puts -nonewline $fileid "\n$data"
        # CLOSE THE FILE
        close $fileid
        #
        # Il faudrait creer le meme fichier en .DTA (pour EFAW) - fin
        #
        # --------------------------------------------------------------------------------
        return $data
    }
}
#
# PROCEDURE loadotl - FIN


# Procedure EUCLID - start
#
proc euclid {table} {
    # La table est une matrice de partial warps correspondant à un groupe donné
    # (cfr.    foreach table $xsubd    du menu_name add casc IDD)
    #
    # Une variable globale si le but est d'obtenir la liste non formatée des distances
    global S subdivision groupe_ordre
    #
    set S(euclist) "";# nettoyage important, sans quoi il y a accumulation
    #
    # En lignes, les groupes ou populations
    set gro [mrows $table]
    # En colonnes, les variables ou characteres
    set var [mcols $table]
    #
    # fenetre de suivi (celle des effectifs des groupes)- debut
    if {[catch { if {$S(perm) == 0} {.question.l1 configure -text "0/$gro"} }] ==1} {
        set on setrompe
    } else  {
        if {$S(perm) == 0} {.question.l1 configure -text "0/$gro"}
    }
    # fenetre de suivi - end
    #
    # Quelles sont les distances euclidiennes entre les lignes (gro) sur la base de toutes les colonnes (var) ?
    set tableucl "0 "
    set zero " 0 "
    for {set l 0} {$l < $gro} {incr l} {
        for {set k [expr {$l+1}]} {$k < $gro} {incr k} {
            set bonclid 0
            #
            for {set c 0} {$c < $var} {incr c} {
                # valeurs de chaque individu sur un axe factoriel
                set m1 [lindex [mrange $table $c $c $l $l] 3]
                set m2 [lindex [mrange $table $c $c $k $k ] 3 ]
                # difference arithmetique entre deux moyennes (celles de deux populations)
                set diff [expr {$m1  -  $m2}]
                # cette difference elevee au carre
                set cardiff [expr {$diff * $diff}]
                # cette valeur ajoutee a la distance totale (pour toutes les variables) entre ces deux populations
                set bonclid [expr {$bonclid + $cardiff}]
            }
            # fenetre de suivi - debut
            if {[catch { if {$S(perm) == 0} {.question.l1 configure -text "$l/$gro"} }] ==1} {
                set on setrompe
            } else  {
                update
                if {$S(perm) == 0} {.question.l1 configure -text "... /$gro"}
            }
            # fenetre de suivi - fin
            
            set bonclid [expr {sqrt($bonclid)} ]
            lappend tableucl $bonclid
            # A ne pas enlever !!!!!!!!!!!!!!!!!!!!!
            
            # Une variable globale si le but est d'obtenir la liste non formatée des distances
            lappend S(euclist) $bonclid
            append S(disfo) "\n[expr {$l+1}] - [expr {$k+1}]  :\t $bonclid"
            if {[info exists groupe_ordre]} {
                lappend S(euclist_doc) "$bonclid [expr {$S(n) + $l}] [expr {$S(n) + $k}] $groupe_ordre $groupe_ordre"
                #debug
                #puts "EUCLI: (groupe $groupe_ordre) $l $k distance-w $bonclid >>> euclist_doc = $S(euclist_doc)"
            }
        }
        
        # Pour gérer les zeros (si on crée une vraie 'matrice' de distances)
        if {$l < [expr {$gro-1}]} {
            append zero " 0 "
            append tableucl $zero
        }
    }
    
    # Si on veut retourner une matrice des distances
    set matdist [concat 2 $gro $gro $tableucl]
    set matdist [transpose $matdist]
    # La matrice des distances (cfr. RETURN) est sous le format HUME
    # La LISTE des distances se trouve dans la variable globale S(euclist), remise à zero à chaque passage ici
    #debug
    # vert "\nPROCEDURE EUCLID $matdist\n\n"
    return $matdist
}
#
# Procedure EUCLID - fin


# Procedure VARCOV - debut
#
proc varcov  {newpop} {
    
    set newcolonnes [mcols $newpop]
    set newlignes [mrows $newpop]
    
    # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
    # IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
    set popones "2 1 $newcolonnes 1"
    set x 1
    set y $newcolonnes
    while {$x < $y} {lappend popones 1; set x [expr {$x + 1} ] }
    
    # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
    mnorms_br newpop newpopmeans newpopsigmas
    
    # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
    set Z [mnormalize $newpop $newpopmeans $popones]
    # ici, div vaut en fait [expr {$newlignes -1}]]
    #set div  [expr {$eff($compte) - 1}]
    set div [expr {$newlignes -1}]
    set scale [expr {1.0 / $div}]
    ## BUG CORRIGE LE 19 AVRIL 2006
    ##$p insert end "\n++++++++++++++++++++++++++ scale $div -> $scale\n"
    #set Zsc [mscale $Z $scale]
    ## MATRICE des VARIANCES - COVARIANCES du GROUPE
    #set ZZ [mmult [transpose $Zsc] $Zsc]
    # MATRICE des VARIANCES - COVARIANCES du GROUPE
    set ZZ [mmult [transpose $Z] $Z]
    set ZZsc [mscale $ZZ $scale]
    return $ZZsc
}
#
# Procedure VARCOV - fin


# Procedure silent_DESCRIPTION pop subdivision - debut
#
proc description_silent {pop subdivision} {
    global S lignes colonnes
    set colonnes [mcols $pop]
    set lignes [mrows $pop]
    #puts "Procedure description_silent : colonnes = $colonnes et lignes = $lignes"
    set effectifs $subdivision
    set gr [llength $subdivision]
    # B prepare la table des moyennes
    set B "2 $gr $colonnes"
    # SEPARER LA MATRICE DE CHAQUE GROUPE
    set compte 0
    set correction 0
    set x-subd ""; # superliste qui va contenir les differentes sous-matrices
    foreach item [split $subdivision] {
        set correction [expr {$correction + $item}]
        set newpop [mrange $pop 0 [expr {$colonnes - 1}] [expr {$correction - $item}] [expr {$correction - 1}] ]
        lappend x_subd $newpop
        # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
        mnorms_br newpop newpopmeans newpopsigmas
        if {$S(dist_nopar) == 0} {
            # Appel a la procedure VARCOV pour le calcul de la matrice des variances-covariances
            set ZZ [varcov $newpop]
        }
        incr compte
        # Ici, on prepare une table des moyennes de chaque sous-matrice
        set newpopmeans [lrange $newpopmeans 3 end]
        foreach item [split $newpopmeans] {lappend B $item}
    }
    # Table des moyennes
    foreach item [split $B] {lappend newB $item}
    return $newB
}
#
# Procedure silent_DESCRIPTION - fin

# Procedure FOGHELP
#
proc foghelp {filename} {
    update
    global license l
    set l ".licayu"
    toplevel $l
    wm geometry $l 640x550+10+10
    focus -force $l
    
    frame $l.buttons; ## EN BAS DE CETTE FENETRE, UNE FRAME POUR LOGER des BOUTONS
    pack $l.buttons -side bottom -fill x -pady 2m
    
    button $l.buttons.start -text "OK" -bg "light yellow" -command {
        destroy $l
        wm deiconify .
    }
    
    pack $l.buttons.start -side left -expand 1
    
    set scblicayu [scrollbar $l.scrollAlicayu -command "$l.t yview"]
    ## A GAUCHE DE LA FENETRE, UNE SCROLLBAR
    pack $scblicayu -side left -fill y
    
    set preslicayu [text $l.t -background "light yellow" -wrap word\
            -yscrollcommand "$l.scrollAlicayu set"]
    ## PUIS ENFIN LE TEXTE il n'est plus necessaire d'indiquer -SIDE, mais -FILL BOTH
    pack $preslicayu -fill both -expand 1
    
    #set filename "+/foghelp.txt" <- non
    set fid [open $filename r]
    set foghelp [read -nonewline $fid]
    close $fid
    
    $l.t insert end "\n$foghelp"
}
### Procedure FOGHELP



############# Progress Bar : fenetre # DEBUT
proc gauge_create {win {color ""}} {
    global p S chevalet
    option add *Gauge.borderWidth 10 widgetDefault
    option add *Gauge.relief raised widgetDefault
    option add *Gauge.length 230 widgetDefault
    option add *Gauge.color gray widgetDefault
    update
    frame $win -class Gauge
    $p window create end -window $win -align center
    set len [option get $win length Length]
    canvas $win.display -borderwidth 0 -bg white -highlightthickness 0 -width 300 -height 20
    pack $win.display
    if {$color == ""}  {
        set color [option get $win color Color]
    }
    $win.display create rectangle 0 0 0 20 -outline "" -fill $color -tags bar
    $win.display create text [expr 0.5 * 300] 10 -anchor c -text "0%" -tags value
    return $win
}
############# Progress Bar : fenetre # FIN

############# Progress Bar : value # DEBUT
proc gauge_value {win val taille} {
    set progres [expr 100 * $val * 1.0/$taille]
    set msg [format "%3.0f%%" $progres]
    update
    $win.display itemconfigure value -text $msg
    set w [expr 0.01*$progres*[winfo width $win.display]]
    set h [winfo height $win.display]
    $win.display coords bar 0 0 $w $h
}
############# Progress Bar : value # FIN


# Procedure LOG
#
proc log {rapport} {
    global S infile
    set nom [string range [file rootname $infile] 0 [string first "_O" [file rootname $infile]]]
    set des "LOG.txt"
    set filename $nom$des
    # open le fichier de conf pour ecrire
    catch [
    set fid [open $filename a+]
    puts -nonewline $fid $rapport
    close $fid
    ] ici
}
#
# Procedure LOG


# Procedure JGCJP - jegraphecommejepeux - START
#
proc jgcjp {liste mx my} {
    global references infile
    set references "blabla"
    
    # Il faut construire chaque point du graphique (une paire de valeurs: les coordonnees x et y)
    # Chaque point est une matrice '2 1 2' a deux colonnes et une seule ligne
    # (ce n'est pourtant pas indispensable puisque le 100La.tcl n'est pas source !)
    
    
    #foreach {x y} $liste {
    #append proindividus "[expr {$x-[lindex $liste 0]}] [expr {$y-[lindex $liste 1]}] "
    #    append proindividus "[expr {$x-$mx}] [expr {$y-$my}] "
    #}
    
    #for  {set i 0} {$i < [llength $liste]} {incr i 2} {
    #    set x [lindex $proindividus $i]
    #    set y [lindex $proindividus [expr $i+1]]
    #    lappend individus "2 1 2 $x $y"
    #}
    
    
    #TEST
    foreach {x y} $liste {
        lappend individus "2 1 2 $x $y "
    }
    #debug $individus
    
    # il faut les tailles des groupes
    set effectifs [expr {[llength $liste] / 2}]
    
    ebauche $individus
    #
}

#
# Procedure JGCJP - jegraphecommejepeux - START



# Procedure ACP -- debut
#
proc acp {x} {
    #
    set p .muestreo.debut
    #
    global S pop lignes colonnes fp
    update
    $fp.buttons.suivi configure -text " -- Performing PCA --"
    #
    set pop $x
    #
    set colonnes [mcols $pop]
    set lignes [mrows $pop]
    set cellules [expr {$lignes * $colonnes}]
    #CREER n-1 POUR CALCULER (plus tard) LES VARIANCES (eigenvalues)
    set obsminusone [expr {$lignes - 1}]
    # ------------------------------------------
    # ACP de la MATRICE OBSERVEE (procedure ACP)
    # ------------------------------------------
    # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
    mnorms_br pop popmeans popsigmas
    # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
    # IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
    set popones "2 1 $colonnes 1"
    set x 1
    set y $colonnes
    while {$x < $y} {lappend popones 1; set x [expr {$x + 1} ] }
    # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
    # ------------------------------------------------
    set Z [mnormalize $pop $popmeans $popones]
    # ---------------------------------------------------
    # essai de la methode naive, qui je suppose prend moins de temps ....
    # ---------------------------------------------------
    # SINGULAR VALUE DECOMPOSITION SUR LA MATRICE varcov
    # ---------------------------------------------------
    bleu "\nPromedios\n"
    $p insert end "[show $popmeans %8.6f]"
    bleu "\n\nDesviaciones estandard\n"
    $p insert end "[show $popsigmas %8.6f]\n"
    $p insert end "\nLes donnees sont ensuite 'centrees' (chaque colonne par sa moyenne)"
    $p insert end "\n[show $Z]"
    set ZZ [mmult [transpose $Z] $Z]
    $p insert end "\n\nThe varcov matrix, or matrix of mean square VCM = (Zt)(Z)/(n-1)\
            \n\tIl s'agit d'une multiplication de Z (la matrice des donnees centrees) par sa transposee (Zt),\
            \n\tAttention, dans cette multiplication, la transposée (Zt) est à gauche: \t Zt by Z"
    $p insert end "\n[show $ZZ]"
    $p insert end  "\n\nChaque element de la matrice resultante (ici : [mrows $ZZ] x [mcols $ZZ]) est divisé ensuite \
            par le nombre d'individus moins un (perte de un degré de liberté)\nOn obtient alors la matrice de \
            variances - covariances\n"
    set nless1 [expr {1./$obsminusone}]
    #
    vert "\nVariance - covariance matrix"
    $p insert end "\nVariances are the diagonal elements of the variance-covariance matrix"
    vert "\n[show [set vcm [mscale $ZZ $nless1]] %8.6f]"
    set vcm [mscale $ZZ $nless1]
    $p see end
    # Continuing the naive example use VARCOV for the eigensolution
    #
    set V $vcm
    mevsvd_br V evals
    $p insert end "\n\nEIGENVALUES  (evals <- ' mevsvd_br V evals ' )\n[lrange $evals 3 end]"
    vert "\nThe sum of eigenvalues is the sum of the diagonal elements of the variance-covariance matrix"
    #
    set long [llength $evals]
    set sumevals 0
    for {set i 3} {$i < $long} {incr i} {set sumevals [expr {[lindex $evals $i] + $sumevals} ] }
    vert "\nSum of EIGENVALUES "
    $p insert end "[format %1.6f $sumevals]\n"
    $p insert end "\nNumber of EIGENVALUES"
    $p insert end " [expr {$long - 3}]"
    #
    set I [mident 3]
    rouge "\n\nIdentity matrix \n[show $I]"
    #
    set propevals(name) 0
    for {set i 3} {$i < $long} {incr i} {
        set prop [expr {[lindex $evals $i] / $sumevals} ]
        set name [expr {$i - 3}]
        set propevals($name) $prop
    }
    $p insert end "\n"
    global nbcp_nonull
    for {set i 3} {$i < $long} {incr i} {
        set name [expr {$i - 3}]
        bleu "\ncontribucion pc[expr {$name + 1} ]"
        $p insert end " [format %1.2f  $propevals($name)] \t\t($propevals($name))"
        if  {$propevals($name) < 0.0000001} {set nbcp_nonull $name} else {set nbcp_nonull [expr {$long-3}]}
    }
    #
    # Eigenvectors - presentation
    #
    bleu "\n\nCoeficientes para los 3 primeros componentes principales\
            \no ' E I G E N V E C T O R E S' (V de <- mevsvd_br V evals)\
            \n(au depart V c'est la matrice de variances-covariances) \n"
    bleu "CP1\t\tCP2\t\tCP3\n"
    bleu "---\t\t---\t\t---\n"
    set Vpres [lrange $V 3 end]
    set compteur -1
    foreach item $Vpres {
        incr compteur
        if {$compteur < 3} {
            set item [format %1.3f $item]
            $p insert end "$item\t\t"
        }
        if {$compteur == [expr {$colonnes-1} ] } {
            set compteur -1
            $p insert end "\n"
        }
    }
    #
    bleu "\n\nCoeficientes para "
    rouge "todos "
    bleu "los componentes principales o ' E I G E N V E C T O R E S ' ([mrows $V] x [mcols $V])\n"
    $p insert end "[show $V %1.3f]"
    
    # COMPOSANTES PRINCIPALES (cp) (procedure ACP)
    # ---------------------------------------------
    global cp
    set cp [mmult $pop $V ]
    #
    bleu "\n\nPrincipal components\n[show $cp]"
    #
    # CENTRER LES COMPOSANTES PRINCIPALES ...
    mnorms_br cp cpmeans cpsigma
    set copri [mnormalize $cp $cpmeans $popones]
    $p insert end "\n"
    #
    bleu "\nPrincipal components (centered)\tComponentes principales (centrados)\n"
    #
    global cpcentrados
    set cpcentrados [show $copri]
    set prescopri [lrange $copri 3 end]
    set compteur -1
    foreach item $prescopri {
        incr compteur
        set item [format %1.7f $item]
        $p insert end "$item\t"
        if {$compteur == [expr {$colonnes-1} ] } {set compteur "-1";$p insert end "\n"}
    }
    #
    # Pour ne pas que les deux cartes factorielles n'interferent l'une sur l'autre, une condition:
    #
    if {$S(mvagrap) == 1} {
        # Si c'est ACPNEF qui appelle
        global individus;# Jan 2013
        set individus "";# Jan 2013
        for {set u 0} {$u < $lignes} {incr u} {
            lappend individus [mrange $copri 0 end $u $u];# Jan 2013
        }
    } else  {
        # Si c'est ACPNEF qui appelle
        global individusfog;# Jan 2013
        set individusfog "";# Jan 2013
        for {set u 0} {$u < $lignes} {incr u} {
            lappend individusfog [mrange $copri 0 end $u $u];# Jan 2013
        }
    }
    
    #ajouté Anillaco February 2008
    #
    update
    $fp.buttons.suivi configure -text " -- PCA : End --"
    #
    return $copri
}
#
# Procedure ACP - end

# Procedure COPrI -- debut
#
proc copri {x} {
    # Cette procedure obtient les composantes principales
    # et pourrait s'appeler silent_pca
    set pop_silent_pca $x
    set colonnes [mcols $pop_silent_pca]
    set lignes [mrows $pop_silent_pca]
    set cellules [expr {$lignes * $colonnes}]
    #CREER n-1 POUR CALCULER (plus tard) LES VARIANCES (eigenvalues)
    set obsminusone [expr {$lignes - 1}]
    # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
    mnorms_br pop_silent_pca popmeans popsigmas
    # ... CREER UN VECTEUR AVEC AUTANT DE 1 QUE DE VARIABLES ...
    # IL SERVIRA POUR CREER UNE MATRICE CENTREE au lieu de NORMALISEE
    set popones "2 1 $colonnes 1"
    set x 1
    set y $colonnes
    while {$x < $y} {lappend popones 1; set x [expr {$x + 1} ] }
    # CENTRER LES DONNEES PLUTOT QUE DE LES NORMALISER
    #Les donnees sont ensuite 'centrees' (chaque colonne par sa moyenne)\
    #cfr. Hume |'normalizing each column by substracting its corresponding mean'|\n"
    set Z [mnormalize $pop_silent_pca $popmeans $popones]
    set ZZ [mmult [transpose $Z] $Z]
    # The varcov matrix, or matrix of mean square VCM = (Zt)(Z)/(n-1) :
    # Il s'agit d'une multiplication de la matrice des donnees centrees par sa transposee,
    # chaque element de la matrice resultante ([mrows $ZZ] x [mcols $ZZ]) est divise ensuite
    # par le nombre d'individus moins un.
    set nless1 [expr {1./$obsminusone}]
    set vcm [mscale $ZZ $nless1]
    # Continuing the naive example use V = VARCOV for the eigensolution
    # SINGULAR VALUE DECOMPOSITION SUR LA MATRICE varcov (vcm)
    #
    set V $vcm
    mevsvd_br V evals
    # evals contient les eigenvalues
    # V contient les eigenvectors (coefficients)
    #
    # COMPOSANTES PRINCIPALES (cp)
    # ---------------------------------------------
    global cp
    set cp [mmult $pop_silent_pca $V ]
    #
    # CENTRER LES COMPOSANTES PRINCIPALES ...
    mnorms_br cp cpmeans cpsigma
    set copri [mnormalize $cp $cpmeans $popones]
    # Scores individuels = individus
    global individus
    set individus ""
    for {set u 0} {$u < $lignes} {incr u} {
        lappend individus [mrange $copri 0 end $u $u]
    }
    return $copri
}
#
# Procedure COPRI - end

# Procedure COMPOPRIN - start
#
proc compoprin {x_acp_total} {
    #
    global S drapeau individus
    set S(save) "_INFO_Fourier.txt"
    set S(info_pw) 0
    #
    global nbcp_nonull;#sinon on ne peut correler tous les CP aux variables
    global dossier
    global infile pad
    #
    if {$x_acp_total != ""} {
        set cp [acp $x_acp_total]
        #
        global lignes colonnes
        if {[info exists individus] == 1} {
            if {[info exists pad]} {unset pad}
            #debug "COMPOPRIN S(mvagrap) = $S(mvagrap)"
            dessine $individus 1
            #destroy .msg
        }
        return $cp
    }
}
#
# Procedure COMPOPRIN - end



# Procedure ANGLE_HORIZ - start
#
# angle d'une droite (4 coordonnees) avec l'horizontale
#
proc angle_horiz {droite} {
    # coordonnées cartésiennes du point de référence (XR,YR)
    set XR [lindex $droite 0]
    set YR [lindex $droite 1]
    # celles d'un autre point (XP,YP)
    set XP [lindex $droite 2]
    set YP [lindex $droite 3]
    #
    # Calcul de l'angle A .
    #
    #Si XP > XR alors
    #A = arctan ((YP - YR) / (XP - XR))
    if {$XP > $XR} {
        set A [expr {atan(($YP - $YR) / ($XP - $XR))}]
        # Si A < 0 alors A = A + 2Pi
        if {$A < 0} {set A [expr {$A + 2 * 3.141592654}]}
        return $A
    }
    #Si XP < XR alors
    #A = arctan ((YP - YR) / (XP - XR)) +Pi
    if {$XP > $XR} {
        set A [expr {atan(($YP - $YR) / ($XP - $XR)) + 3.141592654}]
        # Si A < 0 alors A = A + 2Pi
        if {$A < 0} {set A [expr {$A + 2 * 3.141592654}]}
        return $A
    }
    #Si XP = XR alors
    if {$XP == $XR} {
        #si YP > YR alors A = Pi/2
        if {$YP > $YR} {
            set A [expr {3.141592654 * 1.0/2}]
            # Si A < 0 alors A = A + 2Pi
            if {$A < 0} {set A [expr {$A + 2 * 3.141592654}]}
            return $A
        }
        #si YP < YR alors A = 3Pi/2
        if {$YP < $YR} {
            set A [expr {3 * 3.141592654 * 1.0/2}]
            # Si A < 0 alors A = A + 2Pi
            if {$A < 0} {set A [expr {$A + 2 * 3.141592654}]}
            return $A
        }
    }
    # Si A < 0 alors A = A + 2Pi
    if {$A < 0} {set A [expr {$A + 2 * 3.141592654}]}
}
#
#
# angle d'une droite avec l'horizontale
#
# Procedure ANGLE_HORIZ - end

# Procedure ROTATE - start
#
proc rotate {x ref} {
    set x1t [transpose $ref]
    set ttrantran [mmult $x1t $x]
    # singular value decomposition
    set U $ttrantran
    msvd_br U S V
    set S "2 2 2 1 0 0 1"
    set H [mmult [mmult $V $S] $U]
    set rot [mmult $x $H]
    return " [lrange $rot 3 end]"
}
#
# Procedure ROTATE - end


# Procedure ROUE - start
#
proc roue {troispoints} {
    global coord
    #Il faut calculer l'angle entre les deux droites
    #
    set droite_un [lrange $troispoints 0 3]
    set a1 [angle_horiz $droite_un]
    set droite_deux "[lrange $troispoints 0 1] [lrange $troispoints 4 5]"
    set a2 [angle_horiz $droite_deux]
    set theta [expr {$a2 - $a1}]
    #
    # On notera xx et yy les coordonées du startingpoint,
    # X et Y les différences qui reviennent dans les deux formules de rotation à appliquer.
    set xcentre [lindex $troispoints 0]
    set ycentre [lindex $troispoints 1]
    set xx [lindex $troispoints 4]
    set yy [lindex $troispoints 5]
    set X [expr $xx-$xcentre]
    set Y [expr $yy-$ycentre]
    set xp [expr $xcentre + $X * cos($theta) - $Y * sin($theta)]
    set yp [expr $ycentre + $X * sin($theta) + $Y * cos($theta)]
    #xp et yp = les nouvelles coordonnées
    .can create line "[lrange $troispoints 0 1] $xp $yp" -fill red
    #tk_messageBox -message "hm...\n$coord" -type ok
}
#
# Procedure ROUE - end

# Procedure DISTEUCLID - start
#
proc disteuclid {a b} {
    set xa [lindex $a 0]
    set xb [lindex $b 0]
    set ya [lindex $a 1]
    set yb [lindex $b 1]
    set cote1 [expr {$xa - $xb}]
    set cote2 [expr {$ya - $yb}]
    #global p;$p insert end "\n$a et $b: \txa - xb $cote1 et ya - yb $cote2"
    set dist [expr {hypot($cote1,$cote2)}]
    return $dist
}
#
# Procedure DISTEUCLID - end


# Procedure FOU - start
#
proc fou {rho pas coeff_nb} {
    global p;# nombre de landmarks sur le contour
    #
    set contour $coeff_nb
    set coeff_nb [expr {$contour * 1/2}]
    set sqr2surp [expr {sqrt(2 * 1.0 / $contour)}]
    set 1sursqrtp [expr {sqrt(1 * 1.0 / $contour)}]
    #
    # Coeff. 'a' = sum 'sqr2surp * rho * cos (numero_du_coefficient * theta)'
    # Coeff. 'b' = sum 'sqr2surp * rho * sin (numero_du_coefficient * theta)'
    #
    $p insert end "\n\nCoefficients a et b a chaque harmonique"
    #
    for {set k 0} {$k < [expr {$coeff_nb + 1}]} {incr k} {
        #d'un coefficient a l'autre
        set suma 0
        set sumb 0
        for {set l 0} {$l < $contour} {incr l} {
            set i [lindex $rho $l]
            set j [expr {cos($k * [lindex $pas $l])}]
            #$p insert end "\ncoefficient $k, rho $i angle [lindex $pas $l] cos($k * [lindex $pas $l]) : [expr {$sqr2surp * $i * $j}]"
            set suma [expr {$suma +  $sqr2surp * $i * $j}]
            set j [expr {sin($k * [lindex $pas $l])}]
            set sumb [expr {$sumb +   $sqr2surp * $i * $j}]
        }
        bleu "\na($k): $suma et b($k): $sumb"
        set sumb [expr {$sumb * $sqr2surp}]
        set suma [expr {$suma * $sqr2surp}]
        set harm [expr {sqrt($suma*$suma + $sumb*$sumb)}]
        lappend coeff "$suma \t $sumb \t $harm"
    }
    return $coeff
}
#
# Procedure FOU - end

# Procedure AFFICHE - debut
#
# Permet de faire apparaitre un petit avis
#
proc affiche {x y avis} {
    # x est la position sur l'axe horizontal de l'ecran
    # y est la position sur l'axe vertical de l'ecran
    # missive contient le message qu'on veut afficher
    destroy .avis
    toplevel .avis
    wm geometry .avis +$x+$y
    message .avis.t -bg "light yellow" -fg blue -aspect 1000 -text $avis
    pack .avis.t
}
#
# Procedure AFFICHE - fin

# Procedure AFFICHE - debut
#
# Permet de faire apparaitre un avis pour YA
#
proc affiche_ya {x y avis} {
    # x est la position sur l'axe horizontal de l'ecran
    # y est la position sur l'axe vertical de l'ecran
    # avis contient le message qu'on veut afficher
    #puts "help"
    destroy .avis
    toplevel .avis
    wm geometry .avis +$x+$y
    message .avis.t -text $avis
    button .avis.hlp -text HELP -command {help_sf&a}
    button .avis.fin -text Dismiss -command {
        destroy .avis
    }
    pack .avis.t -side top
    pack .avis.hlp .avis.fin -side left -expand yes -fill x
}
#
# Procedure AFFICHE_YA - fin

# Procedure PICASSO - fin
#
proc picasso {} {
    global magritte
    # Creer des couleurs
    for {set i 0} {$i < 40} {incr i} {
        set rcol [expr int(rand()*65535)]
        set gcol [expr int(rand()*65535)]
        set bcol [expr int(rand()*65535)]
        set magritte($i) [format "#%.4x%.4x%.4x" $rcol $gcol $bcol]
    }
}
#
# Procedure PICASSO - fin



# procedure CORRELATION - debut
#
proc correlation {corps} {
    global p
    set lignes [mrows $corps]
    set pasdecorr 0
    # CALCULER MOYENNES ET DEVIATIONS STANDARD DES VARIABLES, et ...
    mnorms_br corps corpsmeans corpssigmas
    #debug
    #vert "nouveau corps ? \n[show $corps] \nmoyennes ? $corpsmeans std ? $corpssigmas"
    #DEBUG correction pour sigma nul
    set sigmanul [lrange $corpssigmas 3 end]
    foreach item $sigmanul {
        if {$item < 0.0001} {set pasdecorr 1}
    }
    if {$pasdecorr == 0} {
        # NORMALISER LES DONNEES (MOYENNES = 0, VARIANCES = 1)
        set Z [mnormalize $corps $corpsmeans $corpssigmas]
        #debug
        #rouge "donnees normalisees  ? \n[show $Z]"
        # MATRICE des VARIANCES - COVARIANCES
        set ZZ [mmult [transpose $Z] $Z]
        #debug
        #$p insert end "\nzTz ... \n [show $ZZ %8.3f]"
        set denom [expr {$lignes - 1}]
        set R [mscale $ZZ [expr {1.0 / $denom}] ]
    } else  {
        set R "2 2 0 8888 9999"
    }
    # on montre
    return $R
}
#
# procedure CORRELATION - fin


# Procedure ALOCS - debut
#
proc alocs {individualites} {
    
    global S p sentier references_cs individus numero size infile
    set a [file dirname $infile]
    set queue [file tail $infile]
    if {[string first "_FOG" $queue] > -1} {
        set b [string range $queue 0 [string first "_FOG" $queue] ]
        set c "PER.txt"
    } else {
        set b  [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
        set c "_PER.txt"
    }
    
    set infile_cs [file join $a $b$c]
    #debug "perimetres\na = $a\nqueue = $queue \nb = $b\nc = $c\n$infile_cs"
    #
    # usage de LOADFILE_PER pour chercher les donnees
    set pop_cs [loadfile_per "$infile_cs"]
    #
    bleu "\n\nArchivo"
    rouge "\t$infile_cs"
    bleu "\nComentario"
    rouge "\n$references_cs\n\n"
    bleu "\nDatos son:\tPERIMETERS\tPERIMETROS\tPERIMETRES"
    bleu "\n----------------- - - - - - - - - - - -----------------\n"
    bleu "\nDatos, en parte:\n"
    $p insert end "[show [mrange $pop_cs 0 0 0 3]]\tetc.\n..."
    #
    #####################################
    # JE PREPARE LA REGRESSION
    #####################################
    set y1 ""
    set y2 ""
    #debug "individualites \n$individualites"
    foreach item $individualites {
        lappend y1 [lrange $item 3 3]
        lappend y2 [lrange $item 4 4]
        #debug "item\n$item\ny1 \n$y1 \ny2\n$y2"
    }
    set size $pop_cs;#cfr loadfile_per "$infile_cs"
    #
    #####################################
    # J'AI FINI DE PREPARER LA REGRESSION
    #####################################
    #
    set avis "La palabra 'SIZE' para el eje \
            \nhorizontal se aplica si el archivo \
            \n[file tail $infile_cs] \
            \ncontiene los tamanos.\
            \n\n'Y' = primer o segundo component principal de las variables de conformacion \
            \n\n\nLe mot 'SIZE' de l'abscisse ne \
            \ns'applique que si le fichier \
            \n[file tail $infile_cs] \
            \ncontient les tailles.\
            \n\n'Y' = premiere ou deuxieme composante principale des variables de forme \
            \n\n\n'SIZE' is size because it is assumed \
            \nthat [file tail $infile_cs] \
            \ncontains the sizes \
            \n\n'Y' = first or second size free principal component"
    affiche 770 134 $avis
    picasso
    global magritte effectifs
    if {[info exists S(grupos)]} {set effectifs $S(grupos)} else {
        #tk_messageBox -message "Please graph groups first, or indicate groups after PCA" -type ok
        global S
        askforg [llength [vtrim $pop_cs]]
        set effectifs $S(grupos)
        #
        #.toile.buttons.spe invoke
        #destroy .avis
        #return
    }
    set numero 1
    set size [lrange $size 3 end]
    #debug "\ny...\nsize = $size"
    #
    mogregresse $y1 $y2 $size
}
#
# Procedure ALOCS - fin



# Procedure LOADFILE_PER - debut
#
proc loadfile_per {pathname} {
    global S
    global text_cs data_cs references_cs premligne_cs
    set fid [open $pathname]
    set text_cs [read -nonewline $fid]
    
    close $fid
    set rowcount_cs 0
    set colcount_cs 0
    
    set compteur 0
    set lignes_cs 0
    set data_cs ""
    #
    set seuil 1
    foreach line [split $text_cs \n] {
        incr compteur
        if {$compteur > $seuil} {
            if  {$line != ""} {
                set colcount_cs [llength $line]
            }
        }
        if {$compteur > $seuil} {
            foreach item [split $line] { if {$item != ""} {
                    incr lignes_cs
                    append data_cs "[string trim $item]\t"
                }
            }
        } else {append premligne_cs "SAMPLE INFO: $line\n"}
    }
    set rowcount_cs [expr $lignes_cs/$colcount_cs]
    set result [concat 2 $rowcount_cs $colcount_cs $data_cs]
    set references_cs $premligne_cs
    return $result
}
#
# Procedure LOADFILE_PER - fin


# Procedure OTLMAIN - start
#
proc otlmain {} {
    #
    global p S otl otl_contour fp contour fogmat fogmatall harm_nb infile references
    #
    set S(harm_nb) 29
    #
    set pour_x [whichotl];# pour_x contient le commentaire puis les coordonnes au format .DTA (mais ce n'est pas utilise ensuite...)
    #
    # NEW MAY03
    #
    
    #set S(otl_peri) "2 $S(otl_nb) 1 $S(perimeter) "
    #
    # NEW MAY03
    #
    
    # WHICHOTL a genere pour chaque individu la liste otl_contour() des coordonnees, mais aussi otl() et S(otl_nb)
    #
    # Il faut construire a present S(otl_nb) matrices de Hume
    for {set i 0} {$i < $S(otl_nb)} {incr i} {
        # otl_contour($i) contient les coordonnees des points d'intersection des RADII avec le polygone digitalise (module COO), centroide inclu.
        # otl_contour($i) est une liste; on en fait donc une matrice de HUME
        set otl_mat($i) "2 1 [expr {$otl($i) * 2}] $otl_contour($i)"
        #
        $p insert end "\n\nCoordonnees des points d'intersection des RADII avec le polygone digitalise,"
        $p insert end "\nIndividu [expr {$i+1}] (centroide inclu). Le format ci-dessous est celui de l'extension LA de HUME"
        $p insert end "\n$otl_mat($i)\n"
        bleu "\n\
                \n------------------- &&&&&&&&&&&&&&&&&&& -------------------------------"
        bleu "\nIndividu [expr {$i+1}] :\n"
        bleu "\nPreparation de l'analyse elliptique de Fourier (EFA) \
                \n------------------- &&&&&&&&&&&&&&&&&&& ------------------------------\n"
        # ---------------------------------------------------------------------------------
        # CALCUL DES COEFFICIENTS DE FOURIER <- Procedures: HAND -> EFA
        # ---------------------------------------------------------------------------------
        set fogmat($i) [hand $otl_mat($i) $i]
        #
        # ---------------------------------------------------------------------------------
        #debug "Individu $i: Matrice de [mcols $fogmat($i)] coefficients <-> \n$fogmat($i)\
        \nAo [lindex $S(Ao) $i] et Co [lindex $S(Co) $i]  \net... [vtrim [mrange $fogmat($i) 0 3 0 0]]"
        # ---------------------------------------------------------------------------------
        #
        $fp.buttons.suivi configure -fg red -bg yellow -text "[expr {$i + 1 }] / $S(otl_nb)"
        # PRE-ARMER LA MATRICE DES COEFFICIENTS
        #
        #bleu "\n$S(scaling)"
        #
        # NEW MAY03
        #
        #set S(otl_aire) "2 $S(otl_nb) 1 "
        #append S(otl_aire) "$S(otl_aire,$i) "
        # Nouvelle aire: celle de la premiere ellipse
        #set airellipse [ellarea $otl_contour($i) $i]
        #append S(otl_aire) "$airellipse "
        #
        # NEW MAY03
        #
        update
    }
    set S(otl_peri) "2 $S(otl_nb) 1 $S(perimeter) "
    #debug "S(perimeter) in otlmain \n$S(perimeter) \n...and S(otl_peri) in otlmain \n$S(otl_peri)"
    #
    # NEW MAY03
    #
    #
    #Unir les differentes matrices
    #
    # PAC FOG PAF
    #
    # Une matrice PAC pour trois parametres: Perimetres Ao et Co ('pac') <- ajouter les puissances en prem col ??
    for {set i 0} {$i < $S(otl_nb)} {incr i} {
        append pacmatall "[lindex $S(perimeter) $i] [lindex $S(Ao) $i] [lindex $S(Co) $i] "
        #debug "S(Ao) $S(Ao) S(Co) $S(Co) pacmatall $pacmatall"
    }
    set pacmatall "2 $S(otl_nb) 3 $pacmatall";# 3 colonnes: peri, Ao, Co
    #
    # La matrice FOG des coefficients de Fourier (sans Ao et Co)
    for {set i 0} {$i < $S(otl_nb)} {incr i} {
        #append fogmatall "[lrange [vtrim $fogmat($i)] 0 $harm_DA_limit] "
        append fogmatall "[vtrim $fogmat($i)] "
    }
    #tk_messageBox -message "[llength [lrange [vtrim $fogmat(1)] 0 $harm_DA_limit]] <-> [llength [vtrim $fogmat(1)]]" -type ok
    #set fogmatall "2 $S(otl_nb)  [llength [lrange [vtrim $fogmat(1)] 0 $harm_DA_limit]] $fogmatall"
    set fogmatall "2 $S(otl_nb) [llength [vtrim $fogmat(0)]] $fogmatall"
    #
    # Une matrice PAF totale, concatenation des deux matrices precedentes
    #
    #debug "pacmatall \n$pacmatall \nfogmatall \n$fogmatall"
    set S(pafmatall) [join_cols $pacmatall $fogmatall]
    # ' S(pafmatall)  ' a 3 colonnes de plus que ' fogmatall ', pcq : perimetre, Ao et Co
    #
    
    # ---------------------------------------------------------------------------------
    # On ENREGISTRE, PAF = S(pafmatall) dans FOG et perimetres dans PER
    # ---------------------------------------------------------------------------------
    set end "_FOG.txt"
    set harm "[file rootname $infile]$end"
    set filename $harm
    # OPEN THE FILE
    set fileid [open $filename w]
    # FILL THE FILE
    puts -nonewline $fileid "$references - Perimeter + Ao + Co + Fourier coefficients (A, B, C, D) - elliptic method \n"
    puts -nonewline $fileid [show $S(pafmatall)]
    # CLOSE THE FILE
    close $fileid
    # -------------------------------------------------------------------------------------------------------------
    
    # -----------------------------------------------------------------------------------------------------------
    # On enregistre les perimetres = fichier PER = [mrange $S(pafmatall) 0 0 0 end] , soit le fichier des tailles
    # ------------------------------------------------------------------------------------------------------------
    set end "_PER.txt"
    set per "[file rootname $infile]$end"
    set filename $per
    # OPEN THE FILE
    set fileid [open $filename w]
    # FILL THE FILE
    puts -nonewline $fileid "$references - Observed Perimeters  - elliptic method \n"
    puts -nonewline $fileid [show [mrange $S(pafmatall) 0 0 0 end]]
    # CLOSE THE FILE
    close $fileid
    # -------------------------------------------------------------------------------------------------------------
    
    # -----------------------------------------------------------------------------------------------------------
    # On enregistre les 'totalpower' = fichier P0W = totpow_mat, soit le fichier des puissances
    # -----------------------------------------------------------------------------------------------------------
    set totpow_mat ""
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        append totpow_mat "[lindex $S(totpow,$j) end]\n"
    }
    set end "_POW.txt"
    set pow "[file rootname $infile]$end"
    set filename $pow
    # OPEN THE FILE
    set fileid [open $filename w]
    # FILL THE FILE
    puts -nonewline $fileid "$references - Total powers  - elliptic method \n"
    puts -nonewline $fileid $totpow_mat
    # CLOSE THE FILE
    close $fileid
    # -------------------------------------------------------------------------------------------------------------
    
    # Menu GRAPH
    #$fp.f.l5 configure -state active
    #$fp.f.b1 configure -state active
    $fp.menus.nef configure -state active
    $fp.menus.ere configure -state active
}
#
# Procedure OTLMAIN - fin


# Procedure FOGMAIN - start
#
proc fogmain {} {
    global p S puissance totalpower otl otl_contour fp contour fogmat fogmatall harm_nb infile
    #
    # Menu GRAPH
    #$fp.f.l5 configure -state active
    #
    set S(pafmatall) [whichfog]
    if {$S(pafmatall) == ""} {
        set cancelar [tk_messageBox -message "You did not select a file" -type abortretryignore]
        switch -- $cancelar {
            abort {exit}
            retry {return}
            ignore {}
        }
    } else  {
        update
        #debug [show $S(pafmatall)]
    }
    #
    set S(fogfile) 1
    # Nombre de figures
    set S(otl_nb) [mrows $S(pafmatall)]
    $p insert end "\nFrom [file tail $infile] : $S(otl_nb) outlines\n"
    # Les coefficients sans Ao et Co
    set fogmatall [mrange $S(pafmatall) 3 end 0 end]
    $p insert end  "\nFrom [file tail $infile] : [mcols $fogmatall] coefficients (sans Ao ni Co) "
    # Les fogmat individuels
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        set fogmat($j) [mrange $fogmatall 0 end $j $j]
        #debug "Les coefficients (sans Ao ni Co) de l'individu $j\n[show $fogmat($j)] "
    }
    # Les perimetres dans une liste
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        append S(perimeter) "[vtrim [mrange $S(pafmatall) 0 0 $j $j]] "
        #debug "Les perimetres $S(perimeter)"
    }
    # Les Ao dans une liste, les Co dans une liste
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        append S(Ao) "[vtrim [mrange $S(pafmatall) 1 1 $j $j]] "
        append S(Co) "[vtrim [mrange $S(pafmatall) 2 2 $j $j]] "
        #debug "Les Ao $S(Ao)\nLes Co: $S(Co)"
    }
    # Les puissances
    # #
    # -- La puissance TOTALE de chaque figure est retiree du fichier ...OTL__POW.txt
    #
    #debug "[string range  [file rootname $infile] 0 end-4]_POW.txt"
    set filename [string range  [file rootname $infile] 0 end-4]_POW.txt
    set fid [open $filename]
    set text [read -nonewline $fid]
    close $fid
    set compteur 1
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        set totalpower($j) [lindex [split $text \n] $compteur]
        incr compteur
    }
    #
    set harm_nb 29
    #
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        #debug "totalpower($j) $totalpower($j)"
        set char 0
        for {set har 1} {$har < $harm_nb} {incr har} {
            set A [lindex [vtrim $fogmat($j)] [expr {$char+0}]]
            set B [lindex [vtrim $fogmat($j)] [expr {$char+1}]]
            set C [lindex [vtrim $fogmat($j)] [expr {$char+2}]]
            set D [lindex [vtrim $fogmat($j)] [expr {$char+3}]]
            set puissance($j,$har) [expr {pow($A,2) + pow($B,2) + pow($C,2) + pow($D,2)}]
            set puissance($j,$har) [expr {$puissance($j,$har) * 1.0 / 2}]
            #
            ################################################################################
            #             if {$har > 1} {
            #                 set totalpower($j) [expr {$totalpower($j) + $puissance($j,$har)}]
            #                 debug "Indiv $j, harmonique $har: \nA $A\nB $B\nC $C\nD $D\ntotalpower($j) = $totalpower($j)\n"
            #             }
            ################################################################################
            incr char 4
        }
    }
    #
    #fognorm $fogmatall;# pas encore pret
    #$fp.f.b1 configure -state active
    $fp.menus.nef configure -state active
    $fp.menus.ere configure -state active
}
#
# Procedure FOGMAIN - fin


# Procedure FOGNORM - start
#
proc fognorm {fogmatall} {
    #
    global p S chevalet
    
    #
    # chacune des 28 harmoniques (a b c d) de chaque individu
    #
    #tk_messageBox -message "[expr {[mcols $fogmatall] / 4}] est le nombre total d'harmoniques" -type ok
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        #rouge "\nIndividu $j, "
        set harmonique 0
        for {set i 0} {$i < [mcols $fogmatall]} {incr i 4} {
            # 'mcols $fogmatall' est le nombre total d'harmoniques
            incr harmonique
            set abcd($j,$harmonique) [mrange $fogmatall $i [expr {$i+3}] $j $j]
            #$p insert end "\nProcedure FOGNORM: Harmonique $harmonique individu $j \t $abcd($j,$harmonique)"
        }
    }
    # Donc, a present, abcd(2,6) est une MATRICE de HUME, elle donne les 4 coefficients de Fourier de l'harmonique 6 pour l'individu 2 ...
    
    #
    #Calcul de "NORMALIZED coefficients"
    #
    
    # ------------------------------------------------------------------------------------------
    # Calcul de normalized elliptic Foiurier coefficients NEF (Rohlf & Archie, 1984)      DEBUT
    # -------------------------------------------------------------------------------------------
    
    
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        # --------------------------------------------------------------------------------
        # Calcul de THETA (Rohlf & Archie, 1984)  = le 'psi' de J. Claude p.225    DEBUT
        # Computing the ROTATION of the starting point from the end of the ellipse
        # --------------------------------------------------------------------------------
        
        # Coefficients de la premiere harmonique de chaque individu
        set a1 [vtrim [mrange $abcd($j,1) 0 0 0 0]]
        set b1 [vtrim [mrange $abcd($j,1) 1 1 0 0]]
        set c1 [vtrim [mrange $abcd($j,1) 2 2 0 0]]
        set d1 [vtrim [mrange $abcd($j,1) 3 3 0 0]]
        set alors "2 2 2 $a1 $b1 $c1 $d1"
        #
        # Calcul de la fraction
        set a1b1 [expr {$a1 * $b1}]
        set c1d1 [expr {$c1 * $d1}]
        set a12 [expr {$a1 * $a1}]
        set b12 [expr {$b1 * $b1}]
        set c12 [expr {$c1 * $c1}]
        set d12 [expr {$d1 * $d1}]
        set fraction [expr {(2*($a1b1 + $c1d1)) * 1.0 / ($a12 + $c12 - $b12 - $d12)}]
        # arctan de la fraction
        set arctan_fraction [expr {atan($fraction)}]
        #
        # theta
        set theta [expr {0.5 * $arctan_fraction}]
        # 'THETA', c'est PRESQUE le 'theta' de J. Claude (version INTERNET, pas le livre ou le theta s'appelle psi), car manque 'modulo(pi)'
        # Ici j'entre le 'modulo(pi)' a la maniere de R
        #
        if {$theta > 3.141593} {
            set theta [expr {3.141593 - fmod($theta,3.141593)}]
        }
        if {$theta < 0} {
            set theta [expr {3.141593 + fmod($theta,3.141593)}]
        }
        #
        set cossintheta  "2 2 2 [expr {cos($theta)}] [expr {sin($theta)}] [expr {-sin($theta)}] [expr {cos($theta)}]";# phaseshift of Julien C.
        #
        # --------------------------------------------------------------
        # Calcul de THETA (Rohlf & Archie, 1984)   + Julien C.     F I N
        # --------------------------------------------------------------
        
        # --------------------------------------------------------------
        # Calcul de THETA  Julien C.    ... R ...              S T A R T
        # --------------------------------------------------------------
        # M2 - utilisation de 'phaseshift', ici 'cossintheta'
        set M2 [mmult $alors $cossintheta]
        # Elever au carre chaque element de M2 -> M22
        set compteur 0
        set liste [vtrim $M2]
        foreach item $liste {
            set liste [listassign $liste $compteur [expr {$item * $item}]]
            incr compteur
        }
        set M22 "2 [mrows $M2] [mcols $M2] $liste"
        # Somme des colonnes
        set v [msum $M22]
        #
        set v1 [vtrim [mrange $v 0 0 0 0]]
        set v2 [vtrim [mrange $v 0 0 1 1]]
        set pi_2 [expr {(3.141593 * 1.0 / 2)}]
        if {$v1 < $v2} {set theta [expr {$theta + $pi_2}]}
        #
        set theta [expr {$theta + $pi_2}]
        set theta [expr {fmod($theta,3.141593)}]
        set theta [expr {$theta - $pi_2}]
        # -------------------------------------------------------
        # Calcul de a*,a*^2 et c*,c*^2 et E*         DEBUT
        # Computing the magnitude of the semimajor axis of the best fitting ellipse, SCALE = Estar
        # -------------------------------------------------------
        #
        # Calcul de astar et de astar2
        set astar [expr {$a1*cos($theta) + $b1*sin($theta)}]
        set astar2 [expr {$astar * $astar}];# c'est le 'a*2' de J. Claude p.225, et theta c'est le psi
        # Calcul de cstar et de cstar2
        set cstar [expr {$c1*cos($theta) + $d1*sin($theta)}]
        set cstar2 [expr {$cstar * $cstar}];# c'est le 'c*2' de J. Claude p.225, et theta c'est le psi
        #
        set sum_stars [expr {$astar2 + $cstar2}]
        set Estar [expr {sqrt($sum_stars)}];# c'est le 'scale' de J. Claude p.225, et theta c'est le psi
        # -------------------------------------------------------
        # Calcul de a*,a*^2 et c*,c*^2 et E*            FIN
        # -------------------------------------------------------
        
        
        # -------------------------------------------------------
        # Calcul de PHI (Rohlf & Archie, 1984)          DEBUT
        # The ORIENTATION od the ELLIPSE in RADIANS
        # -------------------------------------------------------
        set fraction [expr {$cstar * 1.0 / $astar}]
        set phi [expr {atan($fraction)}];# c'est le 'psi' de J. Claude INTERNET
        #debug "\npsi de JClaude $phi"
        #if (Aa<0){psi<-psi+pi}
        if {$astar < 0} {set phi [expr {$phi + 3.141593}]}
        # size scaling
        set scalar [expr {1.0 / $Estar}]
        #
        # Ici j'entre pour PHI le 'modulo(pi)' pas vraiment tel qu'il est calcule par le R - je renonce
        # if {$phi < 0} {set phi 0} else {set phi [expr {fmod($phi,6.283186)}]}
        #
        set cossinphi  "2 2 2 [expr {cos($phi)}] [expr {sin($phi)}] [expr {-sin($phi)}] [expr {cos($phi)}]";# nommee rotation par Julien C.
        #
        # -------------------------------------------------------
        # Calcul de PHI (Rohlf & Archie, 1984)           FIN
        # -------------------------------------------------------
        
        # -------------------------------------------------------
        # Pour l'individu j, d'une harmonique a l'autre (29 harm)
        # -------------------------------------------------------
        for {set n 1} {$n < 29} {incr n} {
            #
            # Matrice HUME des coefficients pour cet individu, pour cette harmonique (abcd(individu,harmonique))
            set matricecoef "2 2 2 [vtrim $abcd($j,$n)]"
            #
            # Calcul de la matrice HUME pour cette harmonique, pour cet individu
            set mat_n "2 2 2 [expr {cos($n*$theta)}] [expr {(-sin($n*$theta))}] [expr {(sin($n*$theta))}] [expr {cos($n*$theta)}]"
            #
            # mat de R - produitmatriciel
            set produit_matriciel [mmult $cossinphi [mmult $matricecoef $mat_n ]]
            #
            # Size scaling ('scalar' plus haut) -> NORMALIZED coefficients de l'INDIVIDU j
            append normcoef($j) "[vtrim [mscale $produit_matriciel $scalar]] "
        }
        # -------------------------------------------------------
        # Pour l'individu j, d'une harmonique a l'autre - FIN
        # -------------------------------------------------------
        #
        ################################################################################
        #         set S(harm_nb) 29
        #         set coefa_mat "2 1 [expr {[llength $normcoef($j)] - 4}] [lrange $normcoef($j) 4 end]"
        #         set normoutline($j) [croquis $coefa_mat 1 400 0 0]
        ################################################################################
    }
    #
    set S(normfogall) "2 $S(otl_nb) [llength $normcoef(1)] "
    set S(harm_nb) 29
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        append S(normfogall) "$normcoef($j) "
    }
    return $S(normfogall)
}
#
# Procedure FOGNORM - end

# Procedure HELP_sf&a - start
#
proc help_sf&a {} {
    foghelp "+/fogsfa_help.txt"
    foghelp [file join $S(clicdir) "+/fogsfa_help.txt"]
}
#
# Procedure HELP_sf&a - end

# Procedure HAND - start
#
# ... procedure appelee par OTLMAIN; HAND appellera EFA avant de retourner a OTLMAIN
#
proc hand {x cifra} {
    global S p fp contour profil
    #
    # Calculer l'angle 'theta' # -------------- debut ------------
    #
    # Le nombre total de points (incluant donc le centroide); points, pas coordonnees...
    set centroide_contour [expr {[mcols $x] * 1/2}]
    #
    # Le nombre de points le long du contour (excluant donc le centroide); points, pas coordonnees...
    set contour [expr {$centroide_contour - 1}]
    # Le pas angulaire (theta)
    set theta [expr {6.283185307 * 1.0 / $contour}]
    bleu "\nL'angle theta (6.283185307 divise par le nb de points)= $theta"
    #
    # Calculer l'angle 'theta' # -------------- fin --------------
    
    
    # -----------------------------------------------------------
    # Translation des coordonnees au point zero
    #
    # -----------------------------------------------------------
    # X (centroide inclu) va devenir une matrice CENTREE sur 0,0
    # -----------------------------------------------------------
    for {set j 0} {$j < [mrows $x]} {incr j} {
        update
        set profil $x
        #debug "\n$x"
        set translate_x [vtrim [mrange $x 0 0 $j $j]];# valeur 'x' du centroide
        #debug "x du centroide $translate_x"
        set translate_y [vtrim [mrange $x 1 1 $j $j]];# valeur 'y' du centroide
        #debug "y du centroide $translate_y"
        #
        set transmat "2 1 [expr {2 * ($contour + 1)}] "
        for {set i 0} {$i < [expr {[mcols $x] * 1/2}]} {incr i} {
            append transmat "[expr {0 - $translate_x}] [expr {0 - $translate_y}] "
        }
        #
        append translatedmat "[vtrim [madd [mrange $x 0 end $j $j] $transmat]] "
    }
    #
    # conversion liste -> matrice de Hume
    set hume "2 [mrows $x] [mcols $x] "
    set translatedmat "$hume $translatedmat"
    #
    rouge "\n\n---------------------------"
    #
    # La matrice centree contient encore les coordonnees du point centroide (0,0)
    rouge "\nMatrice centree (le premier point est le centroide)\n[show $translatedmat   %1.2f]"
    rouge "\n---------------------------"
    #
    #
    set x $translatedmat
    #
    # X EST DEVENU une matrice CENTREE sur 0,0 et elle contient encore le point centroide
    # -----------------------------------------------------------
    #
    # -----------------------------------------------------------
    set compteur 0
    
    # -----------------------------------------------------------
    # CALCUL DES COEFFICIENTS DE FOURIER ( EFA 'x cifra' )
    #
    # -----------------------------------------------------------
    # Attention, la matrice x CENTREE sur 0,0 contient le centroide !
    #
    set S(scaling) "Centre, non ajuste"
    
    # TENTATIVE ALGOR
    #algor $x $cifra
    return [efa $x $cifra];# cifra c'est le numero de l'individu (EFA returns coefficients, HAND returns them to fogmat in OTLMAIN)
    #
    #  -------------------------
}
#
# Procedure HAND - start


# Procedure PE - fait usage de la procedure CROQUIS - start - appelee par le bouton SF
#
proc pe {} {
    #
    # PE calcule les contours estimes en utilisant arbitrairement 400 points (800 coordonnees estimees)
    # Il les garde dans la variable globale S(outline_estimated,$j), si elle n'existe deja
    #
    # PE calcule les size-free elliptic coefficients en divisant chaque coordonnee (estimee) par le perimetre (estime)
    # outline_estimated_scaled($j)
    # Il garde les coordonnees des contours correspondants dans la variable globale S(pe,$j)
    #
    #
    global S p x chevalet fogmat harm_nb infile references
    update
    
    #tk_messageBox -message  "mm? $check" -type ok
    if {[info exists S(pe,0)]} {
        $chevalet delete dibujos
        for {set j 0} {$j < $S(otl_nb)} {incr j} {
            $chevalet delete fig
            $chevalet create text 200 375 -text "SIZE-FREE FIGURE [expr {$j+1}]" -tag fig
            $chevalet  itemconfigure fig -anchor nw -justify c -width 650
            $chevalet create line $S(pe,$j) -fill orange -tag dibujos
        }
    } else  {
        $chevalet delete dibujos
        # Nb de points choisi ici a 400, arbitrairement
        set pind 400
        
        #
        for {set j 0} {$j < $S(otl_nb)} {incr j} {
            #.toile.buttons.cnt configure -text "[expr {$j + 1}] / $S(otl_nb)" -state active
            .toile.ht.panneau.cpte configure -text "[expr {$j + 1}] / $S(otl_nb)" -fg red -state active
            update
            set perind [lindex $S(perimeter) $j];# variable creee dans FOGMAIN a partir du fichier _FOG.txt <-> S(pafmatall) from OTL.txt
            set Aoind [lindex $S(Ao) $j];# variable creee dans FOGMAIN a partir du fichier _FOG.txt <-> S(pafmatall) from OTL.txt
            set Coind [lindex $S(Co) $j];# variable creee dans FOGMAIN a partir du fichier _FOG.txt <-> S(pafmatall) from OTL.txt
            #
            # Le fogmat($j) contient les coefficients A, B, C , D (sans Ao ni Co) de l'individu $j,
            #         variable creee a partir de  S(pafmatall) cfr. _FOG.txt <-> S(pafmatall) from OTL.txt
            #
            set S(outline_estimated,$j) [croquis $fogmat($j) $perind $pind $Aoind $Coind]
            #tk_messageBox -message  "PE:  lpge S(outline_estimated,$j) = [lpge $S(outline_estimated,$j)]" -type ok
            #$chevalet create line $S(outline_estimated,$j) -fill black -tag dibujos;# doit etre deplace
            #
            # REMARQUE:
            # S(outline_estimated,$j) est un CONTOUR CALCULE a partir de COEFFICIENTS OBSERVES, enregistres precedemment
            # Ce contour est calcule selon un NOMBRE DE POINTS IMPOSES (cfr. ici 'pind = 400'), et
            # ses coordonnees ne sont plus identiques a celles du contour observe dont sont issus les COEFFICIENTS
            # Ces derniers en effet ont ete obtenus a partir d'un contour OBSERVE AVEC UN NB DE PTS DIFFERENT
            # par consequent ...
            # Les nouveaux coefficients, estimes ici (cof $pourcof $S(harm_nb)) a partir d'un contour calcule, non du contour observe,
            # ne sont PAS IDENTIQUES aux COEFFICIENTS ENREGISTRES dans ...OTL_FOG.txt
            #
            #debug "[llength $S(outline_estimated,$j)] \n->$S(outline_estimated,$j)"
            
            #
            # REMARQUE a propos du PERIMETRE
            set outline_estimated_scaled($j) ""
            set outline_estimated_pescaled($j) ""
            set outline_estimated_arscaled($j) ""
            # Le perimetre de S(pafmatall) est celui du contour OBSERVE, il n'est pas identique a celui du contour CALCULE,
            # Je recalcule donc un perimetre propre au contour calcule (celui dont il est question ici, d'ailleurs), le S(outline_estimated,$j)
            set perimetro($j) [perimetre "2 1 [llength $S(outline_estimated,$j)] $S(outline_estimated,$j)"]
            # AIRE, alternative au perimetre - Helas l'algorithme ci-dessous ne fonctionne pas pour les polygones complexes...
            #set aire($j) [area $S(outline_estimated,$j)]
            # l'algorithme polygonArea est peut-etre le bon, mais c'est a tester...!
            #set aire($j) [polygonArea $S(outline_estimated,$j)]
            #set aire($j) [expr {abs([polygonArea $S(outline_estimated,$j)])}]
            #
            set aire($j) [expr {sqrt([ellarea $S(outline_estimated,$j) $j])}]
            #
            #debug "perimetre et aire de la figure estimee $j: $perimetro($j) $aire($j)"
            #
            #debug "S(denom) $S(denom)\nperimetre $perimetro($j)"
            #
            # NEW MAY 02
            #
            append S(pear) "$perimetro($j) $aire($j) "
            #
            if {$S(taille) == "p"} {set tamanho $perimetro($j)} else {set tamanho $aire($j)}
            foreach item  $S(outline_estimated,$j) {
                # S(outline_estimated,$j) est un CONTOUR CALCULE
                append outline_estimated_scaled($j) "[expr {$item  * 1.0 / $tamanho}] "
                #
                # NEW MAY 02
                #
                append outline_estimated_pescaled($j) "[expr {$item  * 1.0 / $perimetro($j)}] "
                append outline_estimated_arscaled($j) "[expr {$item  * 1.0 / $aire($j)}] "
            }
            
            # Pour verification ...
            set perimetro_sf($j) [perimetre "2 1 [llength $outline_estimated_scaled($j)] $outline_estimated_scaled($j)"]
            #set perimetro_sf($j) [perimetre "2 1 [llength $outline_estimated_pescaled($j)] $outline_estimated_pescaled($j)"]
            #debug "SCALED perimetro_sf($j) $perimetro_sf($j) "
            #
            ############### tentative PE ##################################
            #
            # croquis, cadre, canad, canador
            #
            #
            # Cadrer (faire tenir dans un cadre)
            # La taille n'est plus perturbee (cfr. viewing) puisque identique d'une figure a l'autre
            #
            #debug "Avant cadrage: OES outline_estimated_scaled($j)\n$outline_estimated_scaled($j)"
            #debug "Avant cadrage: OES outline_estimated_pescaled($j)\n$outline_estimated_pescaled($j)"
            #debug "Avant cadrage: OES outline_estimated_arscaled($j)\n$outline_estimated_arscaled($j)"
            #
            set S(outline_estimated_scaled,$j)  $outline_estimated_scaled($j)
            #[cadre $outline_estimated_scaled($j) 450 1]
            # Pour visualiser
            set lpgexlpgey [lpge $outline_estimated_scaled($j)];# appel a la procedure LPGE
            set lpgex [lindex $lpgexlpgey 0]
            set lpgey [lindex $lpgexlpgey 1]
            if {$lpgex > $lpgey} {set denom $lpgex} else {set denom $lpgey}
            # recadrage a la volee a 450 maximum
            set cuadro ""
            foreach item $outline_estimated_scaled($j) {
                append cuadro "[expr {$item * 1 * 450 * 1.0 / $denom}] ";# meme taille !!
            }
            set outline_estimated_scaled($j)  $cuadro
            
            #
            set S(outline_estimated_pescaled,$j)  [cadre $outline_estimated_pescaled($j) 450 1]
            # Pour visualiser
            set lpgexlpgey [lpge $outline_estimated_pescaled($j)];# appel a la procedure LPGE
            set lpgex [lindex $lpgexlpgey 0]
            set lpgey [lindex $lpgexlpgey 1]
            if {$lpgex > $lpgey} {set denom $lpgex} else {set denom $lpgey}
            # recadrage a la volee a 450 maximum
            set cuadro ""
            foreach item $outline_estimated_pescaled($j) {
                append cuadro "[expr {$item * 1 * 450 * 1.0 / $denom}] ";# meme taille !!
            }
            set outline_estimated_pescaled($j)  $cuadro
            
            #
            set S(outline_estimated_arscaled,$j)  [cadre $outline_estimated_arscaled($j) 450 1]
            # Pour visualiser
            set lpgexlpgey [lpge $outline_estimated_arscaled($j)];# appel a la procedure LPGE
            set lpgex [lindex $lpgexlpgey 0]
            set lpgey [lindex $lpgexlpgey 1]
            if {$lpgex > $lpgey} {set denom $lpgex} else {set denom $lpgey}
            # recadrage a la volee a 450 maximum
            set cuadro ""
            foreach item $outline_estimated_arscaled($j) {
                append cuadro "[expr {$item * 1 * 450 * 1.0 / $denom}] ";# meme taille !!
            }
            set outline_estimated_arscaled($j)  $cuadro
            
            #
            ################################################################################
            #
            # Calculer la position du croquis
            #
            set deuxcol "2 [expr {[llength $outline_estimated_scaled($j)] / 2}] 2 ";# coordonnees en deux colonnes, x et y THE ONE
            set deuxcolpe "2 [expr {[llength $outline_estimated_pescaled($j)] / 2}] 2 ";# coordonnees en deux colonnes, x et y
            set deuxcolar "2 [expr {[llength $outline_estimated_arscaled($j)] / 2}] 2 ";# coordonnees en deux colonnes, x et y
            set mat_otl "$deuxcol $outline_estimated_scaled($j) ";# THE ONE
            set mat_otlpe "$deuxcolpe $outline_estimated_pescaled($j) "
            set mat_otlar "$deuxcolar $outline_estimated_arscaled($j) "
            #
            update
            #debug "Position x et y pour OES: $S(deplacementx) et $S(deplacementy)"
            #
            # (Re)centrer le croquis
            #
            set outline_estimated_scaled($j)  [canador $j $mat_otl];# THE ONE
            set outline_estimated_pescaled($j)  [canador $j $mat_otlpe]
            set outline_estimated_arscaled($j)  [canador $j $mat_otlar]
            #LOG
            #if {$j < 3} {log "\n$j, Taille = $S(taille)\noutline_estimated_scaled($j) [lrange $outline_estimated_scaled($j) 0 10]\n"}
            #
            # Dessiner (croquer)
            #
            set compteurssa 0
            foreach {xssa yssa} $outline_estimated_scaled($j) {
                #
                incr compteurssa
                if {[expr {fmod($compteurssa,2) == 0}] } {
                    $chevalet create oval [expr {$xssa-1}] [expr {$yssa-1}]  [expr {$xssa+1}] [expr {$yssa+1}]  -outline orange -width 1 -tag dibujos
                }
            }
            #
            #
            #
            ############### tentative ##################################
            
            #  matrice de Hume (oes = outline estimated scaled)
            set deuxcol "2 [expr {[llength $outline_estimated_scaled($j)] / 2}] 2 ";# coordonnees en deux colonnes, x et y THE ONE
            set S(mat_oes,$j) "$deuxcol $S(outline_estimated_scaled,$j)";# THE ONE
            #debug "Apres cadrage: OES S()outline_estimated_scaled($j)\n$S(outline_estimated_scaled,$j)"
            #debug "Apres cadrage: OES S()outline_estimated_pescaled($j)\n$S(outline_estimated_pescaled,$j)"
            #debug "Apres cadrage: OES S()outline_estimated_arscaled($j)\n$S(outline_estimated_arscaled,$j)"
            #  matrice de Hume (oes = outline estimated scaled)
            set deuxcolpe "2 [expr {[llength $outline_estimated_pescaled($j)] / 2}] 2 ";# coordonnees en deux colonnes, x et y
            set S(mat_oespe,$j) "$deuxcolpe $S(outline_estimated_pescaled,$j)"
            #  matrice de Hume (oes = outline estimated scaled)
            set deuxcolar "2 [expr {[llength $outline_estimated_arscaled($j)] / 2}] 2 ";# coordonnees en deux colonnes, x et y
            set S(mat_oesar,$j) "$deuxcolar $S(outline_estimated_arscaled,$j)"
            #LOG
            if {$j < 1} {
                #log "\n\[PE\]\nS(mat_oes,$j) = [lrange $S(mat_oes,$j) 0 10]\nS(mat_oespe,$j) = [lrange $S(mat_oespe,$j) 0 10]\nS(mat_oesar,$j) = [lrange $S(mat_oesar,$j) 0 10]"
            }
            #
        }
        #
        # fin d'une boucle sur les figures
    }
}
#
# Procedure PE - end


# Procedure PAF - start - Procedure appelee par le bouton SF&A
#
proc paf {} {
    #
    # PAF calcule les contours estimes en utilisant arbitrairement 400 points (800 coordonnees estimees)
    # Il garde les contours estimes dans la variable globale S(outline,$j) <- DEVRAIT LES GARDER AILLEURS, non ???
    #
    # # PAF aligne les contours
    #
    # PAF calcule les size-free elliptic coefficients a partir des coordonnees (estimees) ajustees pour la taille,
    #     soit le perimetre (estime)
    #     soit la racine carree de l'aire de l'ellipse definie par la premiere harmonique
    #
    #
    # PAF garde les size-free elliptic coefficients dans la variable globale S(pafmatall_sf)
    # Il les enregistre dans un fichier ..._OTL_FOGsf.txt
    #
    #
    global S p x chevalet fogmat harm_nb infile references
    #
    if {[info exists S(pero,0)]} {
        # les SFA contours et corresponding SFA coefficients ont deja ete calcules
        for {set j 0} {$j < $S(otl_nb)} {incr j} {
            update
            set pero($j) $S(pero,$j)
            #
            # Le croquis est peut-etre trop grand, peut-etre trop petit, il faut le cadrer (Procedure CADRE ... justement, NON !!)
            #
            set lpgexlpgey [lpge $pero($j)];# appel a la procedure LPGE, pour mesurer l'ampleur de la figure
            set lpgex [lindex $lpgexlpgey 0]
            set lpgey [lindex $lpgexlpgey 1]
            if {$lpgex > $lpgey} {set denom $lpgex} else {set denom $lpgey}
            # On recadre la figure pour une ampleur maximum de 450
            set cuadro ""
            foreach item $pero($j) {
                append cuadro "[expr {$item * 1 * 450 * 1.0 / $denom}] "
            }
            set pero($j)  $cuadro
            #
            # (Re)centrer la figure (Procedure CANADOR)
            #
            set deuxcol "2 [expr {[llength $pero($j)] / 2}] 2 ";# coordonnees en deux colonnes, x et y
            set mat_pero "$deuxcol $pero($j) "
            set pero($j)  [canador $j $mat_pero]
            $chevalet delete fig
            $chevalet create text 200 375 -text "SIZE-FREE & ALIGNED FIGURE [expr {$j+1}]" -tag fig
            $chevalet  itemconfigure fig -anchor se -justify c -width 650
            $chevalet create line $pero($j) -fill blue -tag dibujos;# on ne montre plus les normalized outlines, cfr button SS&A
        }
    } else  {
        if {[info exists S(mat_oes,0)]} {
            set S(pre_pafmatall_sf) "";#correction du bug d'accumulation des coefficients SF (post-Panama)
            #
            # FIGURE de REFERENCE (premiere figure): deux colonnes (x,y)
            set ref $S(mat_oes,0)
            #LOG
            #log "\nProcedure PAF... taille = $S(taille), S(mat_oes,0) = $S(mat_oes,0)\n"
            set ref [copri $S(mat_oes,0)];# si on les veut avec le grand axe horizontal ... ...
            #
            # ROTATION sur la premiere figure (ou les CP de la premiere figure, mm ?)
            #
            for {set j 0} {$j < $S(otl_nb)} {incr j} {
                #
                set rot [rotate $S(mat_oes,$j) $ref]
                set rot_mat "[lrange $S(mat_oes,$j) 0 2] $rot"
                #set S(pero,$j) [canador $j $rot_mat];# RE-CENTRAGE
                set S(pero,$j) $rot
                
                set pero($j) $S(pero,$j)
                # #
                # Le croquis est peut-etre trop grand, peut-etre trop petit, il faut le cadrer (Procedure CADRE ... justement, NON !!)
                #
                set lpgexlpgey [lpge $pero($j)];# appel a la procedure LPGE, pour mesurer l'ampleur de la figure
                set lpgex [lindex $lpgexlpgey 0]
                set lpgey [lindex $lpgexlpgey 1]
                if {$lpgex > $lpgey} {set denom $lpgex} else {set denom $lpgey}
                # On recadre la figure pour une ampleur maximum de 450
                set cuadro ""
                foreach item $pero($j) {
                    append cuadro "[expr {$item * 1 * 450 * 1.0 / $denom}] "
                }
                set pero($j)  $cuadro
                
                #
                # (Re)centrer la figure (Procedure CANADOR)
                #
                set deuxcol "2 [expr {[llength $S(pero,$j)] / 2}] 2 ";# coordonnees en deux colonnes, x et y
                set mat_pero "$deuxcol $pero($j) "
                set pero($j)  [canador $j $mat_pero]
                
                #
                # visualisation des contours de meme perimetre et alignes, 1 POINT SUR 2 (on a fait un recadrage a la volee, puis un CANADOR))
                #
                update
                $chevalet delete fig
                $chevalet create text 200 375 -text "SIZE-FREE & ALIGNED FIGURE [expr {$j+1}]" -tag fig
                $chevalet  itemconfigure fig -anchor nw -justify c -width 650
                #
                set compteurssa 0
                foreach {xssa yssa} $pero($j) {
                    #
                    incr compteurssa
                    if {[expr {fmod($compteurssa,2) == 0}] } {
                        # 1 POINT SUR 2
                        $chevalet create oval [expr {$xssa-1}] [expr {$yssa-1}]  [expr {$xssa+1}] [expr {$yssa+1}]  -outline red -width 1 -tag dibujos
                    }
                }
                # ATTENTION, JE RECALCULE DES COEFFICIENTS (SF et, en principe, .ALIGNES)
                # J'envoie au COF des coordonnees ajustees pour la taille ... !
                # COF en derive les "SF coefficients" et les accumule dans S(pre_pafmatall_sf)
                #
                set pourcof "2 1 [llength $S(pero,$j)] $S(pero,$j)"
                # APPEL a la procedure COF
                set coefasf [cof $pourcof $S(harm_nb)];# COF accumule les "SF coefficients" dans S(pafmatall_sf)
                #
                .toile.ht.panneau.cpte configure -text "[expr {$j + 1}] / $S(otl_nb)" -fg red -state active
                #
            }
            set S(pafmatall_sf) "2 $S(otl_nb) [expr { 4 * ($S(harm_nb) -1)}] $S(pre_pafmatall_sf)"
            # ON ENREGISTRE DANS UN FICHIER
            savefogsf $S(pafmatall_sf)
        } else  {
            #
        };# FIN de ' Si S(mat_oes,0) n'existe pas ... MAIS JE CROIS QU'IL EXISTE TOUJOURS'
        #
    };# FIN de ' Si S(pero,0) n'existe pas... ELSE ...' <- cfr. tout debut de la procedure PAF
}
#
# Procedure PAF - end


# Procedure SAVEFOGSF - debut
#
proc savefogsf {pafmatall_sf} {
    global S infile references
    # Enregistrement des size-free coefficients: nom du fichier ..._OTL_FOGsf.txt
    set a [file dirname $infile]
    set queue [file tail $infile]
    if {[string first "_FOG" $queue] > -1} {
        set b [string range $queue 0 [string first "_FOG" $queue] ]
        set c "FOGsf.txt"
    } else {
        set b  [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
        set c "_FOGsf.txt"
    }
    #
    set outfile_sf [file join $a $b$c]
    #
    #debug "SF\na = $a\nqueue = $queue \nb = $b\nc = $c\n$outfile_sf"
    #tk_messageBox -message "PAF: Je sauve S(pafmatall_sf) dans $outfile_sf ..."
    #
    #debug "2 $S(otl_nb) [expr {[llength $pafmatall_sf] * 1 / $S(otl_nb)}]"
    set filename $outfile_sf
    # OPEN THE FILE
    set fileid [open $filename w]
    # FILL THE FILE
    puts -nonewline $fileid "[mcols $pafmatall_sf] Size Free Coefficients - [expr {[mcols $pafmatall_sf] / 4}] Harmonics - elliptic method (cfr. [string range $references 0 30] etc.)\n"
    puts -nonewline $fileid [show $pafmatall_sf]
    # CLOSE THE FILE
    close $fileid
}
#
# Procedure SAVEFOGSF - fin


# Procedure SAVEFOGCPSF - debut
#
proc savefogcpsf {cpsf} {
    global S infile references
    #
    set a [file dirname $infile]
    set queue [file tail $infile]
    if {[string first "_FOG" $queue] > -1} {
        set b [string range $queue 0 [string first "_FOG" $queue] ]
        set c "FOGcpsf.txt"
    } else {
        set b  [string range $queue 0 [expr {[string first ".txt" $queue] - 1 }]]
        set c "_FOGcpsf.txt"
    }
    set infile_cpsf [file join $a $b$c]
    #tk_messageBox -message "CPSF\na = $a\nqueue = $queue \nb = $b\nc = $c\n$infile_cpsf" -type ok
    set filename $infile_cpsf
    # OPEN THE FILE
    set fileid [open $filename w]
    # FILL THE FILE
    puts -nonewline $fileid "Size Free Principal Components - elliptic method (cfr [string range $references 0 40] Etc.)\n"
    puts -nonewline $fileid [show $cpsf]
    # CLOSE THE FILE
    close $fileid
}
#
# Procedure SAVEFOGCPSF - fin

# Procedure SAVEOTLNEF - debut
#
proc saveotlnef {nefhume} {
    global S infile references
    #
    set a [file dirname $infile]
    set queue [file tail $infile]
    set b [string range $queue 0 [string first "_OTL" $queue] ]
    set c "OTL_NEF.txt"
    set infile_nefhume [file join $a $b$c]
    #tk_messageBox -message "NEFHUME\na = $a\nqueue = $queue \nb = $b\nc = $c\n$infile_nefhume" -type ok
    #debug "nefhume\n$nefhume"
    set filename $infile_nefhume
    # OPEN THE FILE
    set fileid [open $filename w]
    # FILL THE FILE
    puts -nonewline $fileid "Normalized coefficients - Fourier elliptic method (cfr [string range $references 0 40] Etc.)\n"
    puts -nonewline $fileid [show $nefhume]
    # CLOSE THE FILE
    close $fileid
}
#
# Procedure SAVEOTLNEF - fin


# Procedure VIEWING_CIFRA - start
#
proc viewing_cifra {} {
    #
    # VIEWING_CIFRA calcule les contours estimes
    # en utilisant les points ...OTL (ficelle(indiviu,point)
    # Il les garde dans la variable globale S(contour,$j)
    # IL LES MONTRE en ligne continue
    #
    global S p x chevalet color fogmat
    
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        
        # NOMBRE DE POINTS de l'INDIVIDU $j
        set pind [lindex $otl_liste $j]
        #
        #.toile.buttons.cnt configure -text "[expr {$j + 1}] / $S(otl_nb)" -state active
        .toile.ht.panneau.cpte configure -text "[expr {$j + 1}] / $S(otl_nb)" -fg red -state active
        update
        #set perind [lindex $S(perimeter) $j];# variable creee dans FOGMAIN a partir du fichier _FOG.txt <- S(pafmatall) from OTL.txt
        set Aoind [lindex $S(Ao) $j];# variable creee dans FOGMAIN a partir du fichier _FOG.txt <- S(pafmatall) from OTL.txt
        set Coind [lindex $S(Co) $j];# variable creee dans FOGMAIN a partir du fichier _FOG.txt <- S(pafmatall) from OTL.txt
        #
        # Le fogmat($j) contient les coefficients (sans Ao ni Co) de l'individu $j,
        #                         variable creee a partir de  S(pafmatall) cfr. _FOG.txt etc.
        #
        #tk_messageBox -message "fogmat($j) : [llength [vtrim $fogmat($j)]] coefficients" -type ok
        set S(contour,$j) [croquis_cifra $fogmat($j) $j $pind $Aoind $Coind]
        set onvoit "2 1 [llength $S(contour,$j)] "
        append onvoit $S(contour,$j)
        set onvoit [canad $j $onvoit 450 450];# on liste les deplacements
        #
        # REMARQUE:
        # S(contour,$j) est un CONTOUR CALCULE a partir de COEFFICIENTS OBSERVES,
        # enregistres precedemment,
        # ses coordonnees seront ici (cifra) identiques a celles du contour observe dont sont issus les COEFFICIENTS
        #
    }
    #
    set S(deplx) [lindex [lsort -real -decreasing $S(deplacementx)] 0];# autre nom de variable ?
    set S(deply) [lindex [lsort -real -decreasing $S(deplacementy)] 0]
    #
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        update
        flush stdout
        #.toile.buttons.cnt configure -text "[expr {$j + 1}] / $S(otl_nb)" -state active
        .toile.ht.panneau.cpte configure -text "[expr {$j + 1}] / $S(otl_nb)" -fg red -state active
        # ...
        set deuxcol "2 [expr {[llength $S(contour,$j)] / 2}] 2 ";# coordonnees en deux colonnes, x et y
        set mat_otl "$deuxcol $S(contour,$j)"
        #
        #set pc_otl [copri $mat_otl];# la bascule ne se fait pas tjrs dans le meme sens !!
        #
        # On deplace ...
        set listex ""
        set listey ""
        foreach {x y} [vtrim $mat_otl] {
            set x [expr {$x + $S(deplx)}]
            set y [expr {$y + $S(deply)}]
            lappend listex $x
            lappend listey $y
        }
        # On replace
        set pre_tot_new ""
        for {set compteur 0} {$compteur < [llength $listex]} {incr compteur} {
            append pre_tot_new "[lindex $listex $compteur] [lindex $listey $compteur] "
        }
        # On dessine
        $chevalet create line $pre_tot_new -fill red -tag dibujos;# c'est dans le canvas, et ON A le centrage
        
    }
}
#
# Procedure VIEWING_CIFRA - end


# Procedure VIEWING - start
#
proc viewing {} {
    
    #
    # Comme PAF, VIEWING calcule les contours estimes en utilisant arbitrairement 400 points (800 coordonnees estimees)
    # Il les garde dans la variable globale S(outline,$j)
    # IL LES MONTRE
    #
    global S p x chevalet color fogmat gr group_nb harm_nb infile otlmoy ptn_mat references selharm ww
    
    destroy .toile.ht.indicht.tsfa
    #.toile.ht.indicht.tsfa configure -bg yellow
    label .toile.ht.indicht.tsfa -fg brown -text "RELATIVE SIZE OF FIGURES IS RESPECTED, AS WELL AS THEIR ORIENTATION"
    pack .toile.ht.indicht.tsfa -side left -padx 1
    
    
    set S(xecart) "";# pour contraindre le plus grand
    set S(yecart) ""
    
    if {[info exists S(grupos)] && $S(grupos) == $S(gr)} {
        #On va tenter de donner a chacun la couleur du groupe...
        $chevalet delete dibujos
        set i 0
        set greff 0
        set g 0
        foreach item  $S(gr) {
            set greff [expr {$greff + $item}]
            while {$i < $greff} {
                update
                flush stdout
                #.toile.buttons.cnt configure -text "[expr {$i + 1}] / $S(otl_nb)" -state active
                .toile.ht.panneau.cpte configure -text "[expr {$i + 1}] / $S(otl_nb)" -fg red -state active
                if {[info exists S(outline,$i)]} {
                    #
                    set deuxcol "2 [expr {[llength $S(outline,$i)] / 2}] 2 ";# coordonnees en deux colonnes, x et y
                    set mat_otl "$deuxcol $S(outline,$i)"
                    #set pc_otl_ind($g,$i) [copri $mat_otl];# On retire cette bascule sur le grand axe, car le sens n'est as controle
                    set otl_ind($g,$i) $mat_otl
                    #
                    $chevalet create line $S(outline,$i) -fill $color($g) -width 2 -tag dibujos
                    incr i
                } else  {
                    tk_messageBox -message "Please estimate outlines first\n(Menu button GRAPH)" -type ok
                }
            }
            incr g
        }
    } else  {
        # Visionner chaque contour estime
        #
        $chevalet delete dibujos
        #
        # NOMBRE DE POINTS FIXES A 400
        set pind 400
        #
        set S(new_perimeter) ""
        set perordre [lsort -real -decreasing $S(perimeter)];# S(perimeter) cree ds FOGMAIN a partir du fichier _FOG.txt <- S(pafmatall) from OTL.txt
        set permax [lindex $perordre 0]
        set S(permax) [lindex $perordre 0]
        foreach item $S(perimeter) {
            append S(new_perimeter) "[expr {int($item * 1000 / $permax)}] "
        }
        
        #
        #
        for {set j 0} {$j < $S(otl_nb)} {incr j} {
            #
            .toile.ht.panneau.cpte configure -text "[expr {$j + 1}] / $S(otl_nb)" -fg red -state active
            update
            set perind [lindex $S(new_perimeter) $j];# apparemment le new_ est sans effet !!
            set Aoind [lindex $S(Ao) $j];# variable creee dans FOGMAIN a partir du fichier _FOG.txt <- S(pafmatall) from OTL.txt
            set Coind [lindex $S(Co) $j];# variable creee dans FOGMAIN a partir du fichier _FOG.txt <- S(pafmatall) from OTL.txt
            #
            # Le fogmat($j) contient les coefficients (sans Ao ni Co) de l'individu $j, variable creee a partir de  S(pafmatall) cfr. _FOG.txt etc.
            #
            #if {[info exists S(normfogall)] == 0} {
            set S(outline,$j) [croquis $fogmat($j) $perind $pind $Aoind $Coind];#croquis engrange les ecarts maximum des x et des y
            #} else  {
            #set S(outline,$j) [croquis $fogmat($j) 1 $pind 0 0];
            #}
            
            #debug "Individu j = $j, [llength $S(outline,$j)]\n$S(outline,$j)"
            #
            # REMARQUE:
            # Les COEFFICIENTS ENREGISTRES sont les coefficients "observes", cad calcules a partir des contours observes (Procedure EFA).
            # S(outline,$j) est un CONTOUR ESTIME a partir de ces coefficients, enregistres precedemment (Procedure EFA)
            # Ce contour est calcule selon un NOMBRE DE POINTS IMPOSES (cfr. ici 'pind = 400'), et
            # ses coordonnees ne sont donc plus celles du contour observe dont sont issus les COEFFICIENTS (OBSERVES)
            # Ces derniers en effet ont ete obtenus a partir d'un contour OBSERVE AVEC UN NB DE PTS DIFFERENT a des LOCALISATIONS differentes.
            # Par consequent ...
            # Les nouveaux coefficients, estimes ici a partir d'un contour calcule, non du contour observe,
            # ne seront donc PAS IDENTIQUES aux COEFFICIENTS ENREGISTRES.
            #
            
            ########################################################
            
            # CADRE, CANADOR
            #
            #
            # Cadrer (faire tenir dans un cadre) -------------- CADRE --------------------------------------
            #
            #tk_messageBox -message "S(perimeter) / permax = [lindex $S(perimeter) $j] / $permax" -type ok
            set proportion [expr {[lindex $S(perimeter) $j] * 1.0 / $S(permax)}]
            #
            #if {[info exists S(normfogall)] == 0} {set S(outline,$j)  [cadre $S(outline,$j) 450 $proportion]}
            set S(outline,$j)  [cadre $S(outline,$j) 450 $proportion]
            
            # Cadrer (faire tenir dans un cadre) -------------- CADRE --------------------------------------
            
            
            # Calculer la position du croquis ----------------- CANADOR ------------------------------------
            #
            set deuxcol "2 [expr {[llength $S(outline,$j)] / 2}] 2 ";# coordonnees en deux colonnes, x et y
            set mat_otl "$deuxcol $S(outline,$j) "
            #
            # (Re)centrer le croquis
            #
            #if {[info exists S(normfogall)] == 0} {set S(outline,$j)  [canador $j $mat_otl]}
            set S(outline,$j)  [canador $j $mat_otl]
            #debug "FOG 4: Individu $j CENTRE (cfr CANADOR), [llength $S(outline,$j)]\n$S(outline,$j)"
            #
            # Calculer la position du croquis ----------------- CANADOR ------------------------------------
            
            #
            #
            # CADRE, CANADOR
            
            #
            # Dessiner (croquer)------------------------------- CHEVALET -----------------------------------
            #
            set compteurssa 0
            foreach {xssa yssa} $S(outline,$j) {
                #
                incr compteurssa
                if {[expr {fmod($compteurssa,2) == 0}] } {
                    $chevalet create oval [expr {$xssa-1}] [expr {$yssa-1}]  [expr {$xssa+1}] [expr {$yssa+1}]  -outline black -width 1 -tag dibujos
                }
            }
            #
            # Dessiner (croquer)------------------------------- CHEVALET -----------------------------------
            
        };# Individu S(outline,$j) suivant
    }
    
    # Calcul de l'aire de l'ellipse definie par la premiere harmonique
    $ww.buttons.vie configure -state disabled;#mettre le bouton viewing hors d'usage
    $ww.buttons.sf configure -state disabled;#mettre le bouton SF momentanement hors d'usage
    set S(otl_aire) "2 $S(otl_nb) 1 "
    $ww.ht.indicht.tsfa configure -text "Please wait until outline $S(otl_nb)"
    for {set j 0} {$j < $S(otl_nb)} {incr j} {
        append S(otl_aire) "[expr {sqrt([ellarea $S(outline,$j) $j])}] "
        update
        $ww.buttons.sf configure -text "$j" -bg yellow
        .toile.ht.panneau.cpte  configure -fg red -text "[expr {$j + 1}]"  -state active
    }
    #
    $ww.buttons.sf configure -text "SF" -bg white -state active
    #
    $ww.ht.indicht.tsfa configure -text "The \"SF\" bottom button allows you to select SIZE (perimeter, of area)"
    #
    $ww.buttons.sf invoke
    #debug "S(otl_aire) \n$S(otl_aire)"
    #
    # NEW MAY03
    #
    # On enregistre les aires = fichier ARE, soit un autre fichier des tailles
    #
    #debug $S(otl_aire)
    set end "_ARE.txt"
    set are "[file rootname $infile]$end"
    set filename $are
    # OPEN THE FILE
    set fileid [open $filename w]
    # FILL THE FILE
    puts -nonewline $fileid "$references - sqrt of the area of the ellipse defined by the first harmonic (from observed outlines)\n"
    puts -nonewline $fileid [show $S(otl_aire)]
    # CLOSE THE FILE
    close $fileid
    #
    # NEW MAY 03
    #
}
#
# Procedure VIEWING - end

# DEUX PROCEDURES POUR L'AIRE D'UN POLYGONE -- debut

# Richard Suchenwirth 2004-07-23 - Given a convex polygon represented as {x y x y ...} list of its corner coordinates, \
I wanted to calculate its area. This is simple for the special case of the triangle, using the 'Heronic formula'
proc triangle'area coords {
    foreach {xa ya xb yb xc yc} $coords break
    set a [expr {hypot($yb-$yc, $xb-$xc)}]
    set b [expr {hypot($ya-$yc, $xa-$xc)}]
    set c [expr {hypot($ya-$yb, $xa-$xb)}]
    set s [expr {($a+$b+$c)/2.}]
    expr {sqrt($s*($s-$a)*($s-$b)*($s-$c))} ;# Heronic formula
}
#For the general polygon I devised this recursive approach, which de facto does a triangulation, \
by measuring the area between the first three points, \
        and then calling itself with the second corner's coordinates removed from the list

proc area coords {
    # coords est ici la liste des points du contour
    expr {
        [llength $coords]<6? 0 :
        [triangle'area [lrange $coords 0 5]]
        + [area [lreplace $coords 2 3]]
    }
}

# DEUX PROCEDURES POUR L'AIRE D'UN POLYGONE -- fin


# Une autre procedure pour l'aire d'un polygone
#
# POLYGONAREA - start
#
# compute the area of a polygon given its coordinates
#
# Argument: coords -> list of coordinates
#
# Returns: Area of polygon (taking care of holes inside the polygon)
#
proc polygonArea {coords}  {
    # make sure we have a closed set of coords:
    if {[lindex $coords 0] != [lindex $coords end-1] \
                || [lindex $coords 1] != [lindex $coords end]} {
        lappend coords [lindex $coords 0] [lindex $coords 1]
    }
    # append another point for the calculation:
    lappend coords [lindex $coords 2] [lindex $coords 3]
    # area:
    set area 0
    # number of vertices:
    set n [expr {([llength $coords]-4)/2}]
    # build lists with x and y coordinates only:
    foreach {x y} $coords {
        lappend xList $x
        lappend yList $y
    }
    for {set i 1; set j 2; set k 0} {$i <= $n} {incr i; incr j; incr k} {
        set area [expr {$area + ([lindex $xList $i] * ([lindex $yList $j] - [lindex $yList $k]))}]
    }
    return [expr {$area/2.0}]
}
#
# POLYGONAREA - end


# Procedure ELLAREA - start
#
# appelee par OTLMAIN: on calcule l'aire de l'ellipse (harmonique 1)
#
proc ellarea {contour j} {
    # input = les coordonnees x et y du centroide, de l'extremite d'un grand axe et de l'extremite d'un petit axe
    #
    # contour = soit S(outline,$j) soit S(outline_estimated,$j)
    #
    # j = l'individu (son numero d'ordre, comme cifra dans la procedure  HAND 'x cifra' qui ensuite appelle EFA 'x cifra'
    
    global chevalet S selharm totalpower ptn_mat puissance totalpower fogmat
    
    # COF ... EST-CE A FAIRE POUR DES CONTOURS DEJA "ESTIMES" ? PEUT-ETRE GARDER LE H3 - style outline_ell - LORS DES ESTIMATIONS ANTERIEURES? <- OUI!!!
    #
    # J'envoie au COF les coordonnees du contour, COF en derive les coefficients de Fourier (methode elliptique) ...
    set pourcof "2 1 [llength $contour] $contour"
    #
    set h 3
    # la procedure COF appelle la procedure CROQUIS, qui, elle, retourne (RETURN) le contour estime
    set selharm($j,$h) [cof $pourcof $h]
    #
    #debug "ELLAREA selharm($j,$h) : \n$selharm($j,$h)"
    set hume_selharm($j,$h) "2 [expr {[llength $$selharm($j,$h)] / 2}] 2 $selharm($j,$h)"
    set pc_selharm($j,$h) [copri $hume_selharm($j,$h)]
    #debug "ELLAREA pc_selharm($j,$h) $pc_selharm($j,$h)"
    
    set lpgexy [lpge [vtrim $pc_selharm($j,$h)]]
    set lpgex [lindex $lpgexy 0]
    set lpgey [lindex $lpgexy 1]
    #debug "grand axe $lpgex \npetit axe $lpgey\nAREA [expr {3.14 * $lpgex * 1.0/2 * $lpgey * 1.0/2}]"
    #
    return [expr {3.14 * $lpgex * 1.0/2 * $lpgey * 1.0/2}]
    
}


#
# Procedure ELLAREA - end


# Procedure PERIMETRE (d'un polygone) - debut
#
proc perimetre {x} {
    #
    # 'x' est une matrice de hume pour un seul contour ( '2 1 nombre_de_coordonnees coordonnees')
    #
    # ATTENTION, X EST DEPOURVU DU POINT CENTROIDE
    set x_centroidless $x
    #
    set contour [expr {[llength [vtrim [mrange $x_centroidless 0 end 0 0]]] * 1/2}]
    #
    for {set j 0} {$j < [mrows $x]} {incr j} {
        set perimetre($j) 0
        for {set i 0} {$i < [expr {$contour*2 - 2}]} {incr i 2} {
            set pt [vtrim [mrange $x_centroidless [expr {$i+2}] [expr {$i + 3}] $j $j]]
            set perimetre($j) [expr {$perimetre($j) + [disteuclid [vtrim [mrange $x_centroidless $i [expr {$i+1}] $j $j]] $pt]}]
        }
        # Et BIEN ENTENDU, ajouter le RETOUR du polygone au point de DEPART
        set pt_dernier [vtrim [mrange $x_centroidless [expr {$contour * 2 - 2}] [expr {$contour * 2 - 1}] $j $j]]
        set pt_premier [vtrim [mrange $x_centroidless 0 1 $j $j]]
        set dernierecorde [disteuclid $pt_dernier $pt_premier]
        set perimetre($j) [expr {$perimetre($j) + $dernierecorde}]
        #
    }
    return $perimetre(0)
}
#
# Procedure PERIMETRE - fin


# Procedure MAIN - start
#
proc main {} {
    global p fp contour
    #
    set x [whichmatrix]
    #
    #  ------------------------------------------
    # EFA sur la matrice NON CENTREE, NON AJUSTEE, et qui contient le point centroide
    #efa $x
    # -------------------------------------------
    
    
    # Calculer l'angle 'theta' # -------------- debut ------------
    #
    # Le nombre total de LM (incluant donc le centroide)
    set centroide_contour [expr {[llength [vtrim [mrange $x 0 end 0 0]]] * 1/2}]
    # Le nombre de LM le long du contour (excluant donc le centroide)
    set contour [expr {$centroide_contour - 1}]
    # Le pas angulaire (theta)
    set theta [expr {6.283185307 * 1.0 / $contour}]
    bleu "\nL'angle theta = $theta"
    #
    # Calculer l'angle 'theta' # -------------- fin --------------
    
    
    # -----------------------------------------------------------
    # Translation des coordonnees au point zero
    #
    # -----------------------------------------------------------
    # X devient une matrice CENTREE sur 0,0
    # -----------------------------------------------------------
    for {set j 0} {$j < [mrows $x]} {incr j} {
        update
        set translate_x [vtrim [mrange $x 0 0 $j $j]];# valeur 'x' du centroide
        set translate_y [vtrim [mrange $x 1 1 $j $j]];# valeur 'y' du centroide
        #
        set transmat "2 1 [expr {2 * ($contour + 1)}] "
        for {set i 0} {$i < [expr {[mcols $x] * 1/2}]} {incr i} {
            append transmat "[expr {0 - $translate_x}] [expr {0 - $translate_y}] "
        }
        #
        append translatedmat "[vtrim [madd [mrange $x 0 end $j $j] $transmat]] "
    }
    #
    # conversion liste -> matrice de Hume
    set hume "2 [mrows $x] [mcols $x] "
    set translatedmat "$hume $translatedmat"
    #
    rouge "\n\n---------------------------"
    #
    # La matrice centree contient encore les coordonnees du point centroide (0,0)
    rouge "\nMatrice centree (le premier point est le centroide)\n[show $translatedmat   %1.2f]"
    rouge "\n---------------------------"
    #
    #
    set x $translatedmat
    # ------------------------------------------------------------------------------------------------------------------------------
    # X EST DEVENU une matrice CENTREE sur 0,0 et elle contient encore le point centroide
    # -----------------------------------------------------------
    #
    # -----------------------------------------------------------
    set compteur 0
    
    # Attention, la matrice x contient le centroide !
    #
    #  -------------------------
    # EFA sur la matrice CENTREE sur 0,0 et qui contient encore le point centroide
    # efa $x
    #
    #  -------------------------
    
    
    # + + +
    #
    # Calculer les PERIMETRES ... (aussi dans EFA) MAIS auparavant, BIEN ENTENDU,  ENLEVER LE POINT CENTROIDE
    set x_centroidless [mrange $x 2 end 0 end]
    for {set j 0} {$j < [mrows $x]} {incr j} {
        set perimetre($j) 0
        for {set i 0} {$i < [expr {$contour*2 - 2}]} {incr i 2} {
            set pt [vtrim [mrange $x_centroidless [expr {$i+2}] [expr {$i + 3}] $j $j]]
            set perimetre($j) [expr {$perimetre($j) + [disteuclid [vtrim [mrange $x_centroidless $i [expr {$i+1}] $j $j]] $pt]}]
        }
        # Et BIEN ENTENDU, ajouter le RETOUR du polygone au point de DEPART
        set pt_dernier [vtrim [mrange $x_centroidless [expr {$contour * 2 - 2}] [expr {$contour * 2 - 1}] $j $j]]
        set pt_premier [vtrim [mrange $x_centroidless 0 1 $j $j]]
        set dernierecorde [disteuclid $pt_dernier $pt_premier]
        set perimetre($j) [expr {$perimetre($j) + $dernierecorde}]
        #tk_messageBox -message "MAIN Perimetre individu $j : $perimetre($j)"
    }
    #
    # + + +
    #
    
    
    # + + +
    #
    # Calculer les aires ... <--- ENCORE A FAIRE
    
    # on peut calculer l'aire de l'ellipse principale cfr. NTSYS technical details
    # max range of x max range of y etc.
    
    #
    # + + +
    #
    
    # ----------------------------------------------------------------
    # Diviser chaque coordonnee par l'aire de l'ellipse correspondante
    #
    # ----------------------------------------------------------------
    # X devient une matrice CENTREE sur 0,0 et DE TAILLE UNITAIRE
    # ----------------------------------------------------------------
    
    # Attention, la matrice x contient le centroide !
    #
    #  ------------------------------------------
    # EFA sur la matrice CENTREE et AJUSTEE (aire), elle contient toujours le centroide
    # efa $x
    #
    #  ------------------------------------------
    
    $fp.buttons.suivi flash
    $fp.buttons.suivi configure -fg red -bg grey -text "[mrows $x]"
    
    # -----------------------------------------------------------
    # Diviser chaque coordonnee par le perimetre correspondant
    #
    # -----------------------------------------------------------
    # X devient une matrice CENTREE sur 0,0 et DE TAILLE UNITAIRE
    # -----------------------------------------------------------
    set hume "2 [mrows $x] [mcols $x] "
    for {set j 0} {$j < [mrows $x]} {incr j} {
        set k [mrange $x 0 end $j $j]
        set scaled_k [vtrim [mscale $k [expr 1.0 / $perimetre($j)]]]
        append hume "$scaled_k "
    }
    bleu "\n\n---------------------------"
    #rouge "\n
    bleu "\nMatrice centree et ajustee (perimetre) - Scaling for size using the perimeter\n[show $hume   %1.2f] \n"
    bleu "\n---------------------------\n"
    #
    #
    set x $hume
    # -----------------------------------------------------------
    # X EST DEVENU une metrice CENTREE sur 0,0 et AJUSTEE
    # -----------------------------------------------------------
    
    # Attention, la matrice x contient le centroide !
    #
    #  ------------------------------------------------
    # EFA sur la matrice CENTREE et AJUSTEE (perimetre)
    #efa $x
    #
    #  ------------------------------------------------
    
    # ------------------------- RAYONS -------------------------------
    # Calculer les 'rho', ou distance du centroide a chacun des points
    #
    for {set j 0} {$j < [mrows $x]} {incr j} {
        #
        set mat_rho($j) "2 1 $contour "
        # d'un individu ($j) a l'autre
        set compteur 0
        #set perimetre($j) 0
        for {set i 0} {$i < [expr {$contour*2}]} {incr i 2} {
            # d'un point ($i) a l'autre
            set centroide [vtrim [mrange $x 0 1 $j $j]];#vert "\nIndividu $j: centroide $centroide ..."
            set pt [vtrim [mrange $x [expr {$i+2}] [expr {$i + 3}] $j $j]]
            set centroide_pt [disteuclid $centroide $pt]
            #$p insert end "\nINDIVIDU $j: distance entre centroide $centroide et point $pt: \t$centroide_pt"
            if {$i == 0} {set centroide_pt1 $centroide_pt}
            append rho($j) "$centroide_pt "
            append pas($j) "[expr {$compteur * $theta}] "
            append rho_angle($j) "$centroide_pt [expr {$compteur * $theta}] "
            incr compteur
            #
        }
        append mat_rho($j) "$rho($j) "
        #vert "\nMAT_RHO \n$mat_rho($j)"
        # A present on ferme le contour sur le premier point:
        # il faut ajouter la derniere fraction angulaire et, pour elle, la distance a l'angle zero entre centroide et premier point.
        append rho($j) "$centroide_pt1"
        append pas($j) "[expr {$compteur * $theta}] "
        append rho_angle($j) "$centroide_pt1 [expr {$compteur * $theta}]"
        vert "\n\n========================================================\
                \nIndividu [expr {$j+1}], mesure des rayons:\n$rho($j)\n"
        bleu "\nPas angulaires:\n$pas($j)\n"
        
        # Liste des rayons
        set liste_r($j) [vtrim $mat_rho($j)]
        
        # VERIFICATION - passage polaire rectangulaire - debut
        bleu $liste_r($j)
        for {set pr 0} {$pr < 30} {incr pr} {
            #debug "polar_to_rect [lindex $liste_r($j) $pr] [lindex $pas($j) $pr]"
            set rect [polar_to_rect [lindex $liste_r($j) $pr] [lindex $pas($j) $pr]]
            append coordrect($j) "$rect "
        }
        bleu "\nIndividu "
        rouge "$j ,"
        $p insert end " Coordonnees\n"
        bleu [vtrim [mrange $x 2 end $j $j]]
        $p insert end " \nCoordonnees a partir des rayons: \n"
        bleu $coordrect($j)
        #
        # VERIFICATION - passage polaire rectanfulaire - fin --
        
        # REEssai dune EFA a partir des coordonnees rectangulaires (dont celles du centroide)
        #tk_messageBox -message "Nombre de colonnes [mcols $x]" -type ok
        #efa [mrange $x 0 end $j $j]
        
        # Essai dune EFA a partir des rayons <-------------- POUR PLUS TARD
        #efa2 $liste_r($j)
        # Essai dune EFA a partir des rayons <-------------- POUR PLUS TARD
        
        # Presentation de la matrice Z
        #
        #set z($j) [transpose $mat_rho($j)]
        #vert "\n[show $z($j)]"
        #
        
        #
        set coeffou($j) [fou $rho($j) $pas($j) $contour]
        #update
        flush stdout
        rouge "\n\nIndividu [expr {$j+1}], "
        $p insert end "PERIMETRE $perimetre($j)\n"
        rouge "\ncoefficients (a et b) et amplitude"
        foreach item $coeffou($j) {
            rouge "\n$item"
            append a_liste "[lindex $item 0] "
            append b_liste "[lindex $item 1] "
            append ampl_liste "[lindex $item 2] "
        }
        # On passe a l'individu suivant
    }
    
    set coeff_nb [llength $coeffou(0)];# pour le message d'attente PCA
    
    ###############################################################################
    # Matrice des rayons (pour les moyennes des groupes)
    set hume "2 [mrows $x] $contour "
    global matrice_r
    for {set j 0} {$j < [mrows $x]} {incr j} {
        append matrice_r "[vtrim $mat_rho($j)] "
    }
    set matrice_r "$hume $matrice_r"
    $p insert end "\n\n&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&\
            \nMATRICE DES RAYONS\
            \n&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&\n"
    $p insert end  "\n[show $matrice_r  %1.4f]\n"
    #bleu "\n$matrice_r\n"
    #
    ###############################################################################
    # Matrice des amplitudes (pour la PCA)
    set hume "2 [mrows $x] [expr {1 + $contour * 1/2}] "
    set ampl_mat "$hume $ampl_liste"
    bleu "\n\n&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&\
            \nMATRICE DES AMPLITUDES\
            \n&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&\n"
    bleu "\n[show $ampl_mat  %1.4f]\n"
    #
    ###############################################################################
    #
    global matrice_a
    set matrice_a "$hume $a_liste"
    vert "\n\n&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&\
            \nMATRICE DES coefficients a\
            \n&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&\n"
    vert "\n[show $matrice_a  %1.4f]\n"
    #
    global matrice_b
    set matrice_b "$hume $b_liste"
    rouge "\n\n&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&\
            \nMATRICE DES coefficients b\
            \n&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&\n"
    rouge "\n[show $matrice_b  %1.4f]\n"
    
    # On sauve les resultats --------------------------------- debut ---------------
    #
    global infile
    #
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    set fin _coeffou.txt
    set filename "$dirinfile$rootfile$fin"
    #
    set output [join_cols $matrice_a $matrice_b]
    $p insert end "\n-------------------\nMatrices a et b jointes\n"
    rouge "\n[show $output]"
    
    wm title . $filename
    # OPEN THE FILE
    set fileid [open $filename w]
    # FILL THE FILE
    puts -nonewline $fileid "[mrows $matrice_a] images; [mcols $matrice_a] coeff. 'a' and [mcols $matrice_b] coeff. 'b' by image\n"
    puts -nonewline $fileid [show $output]
    # CLOSE THE FILE
    close $fileid
    #
    # On sauve les resultats --------------------------- fin -----------------------
    
    ########### APPEL A LA PROCEDURE ESQUISSE A FAIRE##### debut ###################
    # Il faut envoyer la liste_r, la liste_a et la liste_b des coefficients de chaque individu, successivement - ou a la demande -
    # ou alors, successivement, puis une esquisse moyenne sera montree pour chaque groupe...?
    global trepied;# c'est le nom du canvas
    #
    ################################################################################
    #     for {set j 0} {$j < [mrows $x]} {incr j} {
    #     set liste_a [vtrim [mrange $matrice_a 0 end $j $j]]
    #     set liste_b [vtrim [mrange $matrice_b 0 end $j $j]]
    #     #
    #     set couleur black
    #     esquisse $j "individus" $couleur $trepied $liste_r($j) $liste_a $liste_b
    #     $trepied delete all
    #     }
    ################################################################################
    #
    for {set j 0} {$j < [mrows $x]} {incr j} {
        
        set liste_a [vtrim [mrange $matrice_a 0 end $j $j]]
        set liste_b [vtrim [mrange $matrice_b 0 end $j $j]]
        #
        set couleur black
        #esquisse [expr {$j+1}] "individual" $couleur $trepied $liste_r($j) $liste_a $liste_b;# il faudra pe dire : ' set indiv1 [esquisse etc.] '
        #
        #
    }
    #
    ########### APPEL A LA PROCEDURE ESQUISSE A FAIRE################ fin ###################
    
    
    
}
#
# Procedure MAIN - end

# Procedures associees a l'AIDE R ------------------------- start
#
# r_rouge, r_bleu, r_brun, r_vert, faar, fiar, afficheinfo, erela
# Il faut y ajouter en debut de source: "font create onlist -family courier -size 13 -weight normal -slant roman" et S(liwiclic)
#
# Procedures associees a l'AIDE R ------------------------- start
#
# Ces procedures sont appelees a partir du menu R
#
################### r_bleu ##### Procedure ## Debut ##
proc r_bleu {mesg args} {
    global S
    $S(ere) insert end $mesg "bleu"
    $S(ere) tag configure bleu -foreground blue
}
################### r_bleu ####### PROCEDURE ## FIN ###
#
################### r_brun ##### Procedure ## Debut ##
proc r_brun {mesg args} {
    global S
    $S(ere) insert end $mesg "brun"
    $S(ere) tag configure brun -foreground brown
}
################### r_brun ####### PROCEDURE ## FIN ###
#
################### r_vert ##### Procedure ## Debut ##
proc r_vert {mesg args} {
    global S
    $S(ere) insert end $mesg "vert"
    $S(ere) tag configure vert -foreground "dark green"
}
################### r_vert ####### PROCEDURE ## FIN ###
#
################### r_rouge ##### Procedure ## Debut ##
proc r_rouge {mesg args} {
    global S
    $S(ere) insert end $mesg "rouge"
    $S(ere) tag configure rouge -foreground red
}
################### r_rouge ####### PROCEDURE ## FIN ###
# Procedure EDIT_COPY
#
# cfr Eric Foster-Johnson, Second Edition, p.295
#
proc edit_copy {textwidget} {
    #tk_messageBox -message "J'ouvre le clipboard" -type ok
    set owner [selection own]
    if {$owner == $textwidget} {
        clipboard clear
        catch {
            clipboard append [selection get]
        }
    }
}
#
# Procedure EDIT_COPY

# Procedure EDIT_PASTE - start
#
# cfr Eric Foster-Johnson, Second Edition, p.297
#
proc edit_paste {textwidget} {
    catch {
        set clip [selection get -selection CLIPBOARD]
    }
    set idx [$textwidget index insert]
    set owner [selection own];# check if any text is selected in textwidget
    if {$owner == $textwidget} {
        catch {
            set idx [$owner index sel.first]
            $textwidget delete sel.first sel.last
        }
    }
    catch {
        $textwidget insert $idx $clip
    }
}
#
# Procedure EDIT_PASTE - fin
#
# Procedure FAAR - Fenetre d'aide au R - start
#
proc faar {} {
    global S infile
    #
    #
    wm iconify .
    #
    #
    destroy .rwidget
    toplevel .rwidget
    wm title .rwidget "R help"
    wm geometry .rwidget 850x600+550+50
    global S
    set S(ere) [text .rwidget.t -wrap word -height 22 -font onlist \
            -bg ivory \
            -fg black\
            -tabs "3c left"\
            -yscrollcommand ".rwidget.v_scroll set" \
            -xscrollcommand ".rwidget.h_scroll set"]
    scrollbar .rwidget.v_scroll -command ".rwidget.t yview"
    scrollbar .rwidget.h_scroll -command ".rwidget.t xview" -orient horizontal
    pack .rwidget.v_scroll -side right -fill y
    pack .rwidget.h_scroll -side bottom -fill x
    pack .rwidget.t -side bottom -fill both -expand 1
    #
    set S(rhelp) Rhelp
    #
    bind .rwidget.t <Control-Key-c> "edit_copy .rwidget.t; break"
    #
}
# Procedure FAAR - Fenetre d'aide au R - end
#
# Procedure FIAR - Fichier d'aide au R - start
#
proc fiar {analyse} {
    global S
    set fileraide  [file join $S(dirclic) $S(rhelp) $analyse]
    tk_messageBox -message "$fileraide" -type ok
    set fid [open $fileraide r]
    set raide [read -nonewline $fid]
    close $fid
    #
    $S(ere) insert end $raide
    #
}
#
# Procedure FIAR - Fichier d'aide au R - end
#
# Procedure AFFICHEINFO - debut - Appelee par la procedure ERELA
#
proc afficheinfo {id} {
    global attente
    if {[eof $id]} {
        set attente 1
        close $id
        return
    }
    gets $id ligne
}
#
# Procedure AFFICHEINFO - fin
#
# Procedure ERELA -- DEBUT
#
proc erela {} {
    global S
    update
    flush stdout
    
    if { [catch {
            #
            if {$S(liwiclic) == "linclic"} {
                global attente numli
                set fid [open "| xterm R"]
                fconfigure $fid -buffering line
                catch [fileevent $fid readable "afficheinfo $fid"] ici
            } else  {
                set fid [open "| \"C:/Program Files/R/R-2.14.2/bin/i386/Rgui.exe\""]
                fconfigure $fid -buffering line
                catch [fileevent $fid readable "afficheinfo $fid"] ici
            }
            #
            update
            flush stdout
        } result] } {
        # There is an error
        #
        # Preparer une fenetre de recherche dans le disque dur pour localiser le programme R - NE MARCHE PAS ...
        #
        if {$S(liwiclic) == "linclic"} {
            tk_messageBox -message "CLIC did not find xterm, or did not find R\
                    \nhttp://cran.r-project.org/" -type ok
            set S(erela) 1
            return
        } else  {
            set endroit "C:/Program Files/R/R-2.14.2/bin/i386/Rgui.exe"
            tk_messageBox -message "CLIC did not find R here: \n$endroit\
                    \n\nhttp://cran.r-project.org/" -type ok
            set S(erela) 1
            return
        }
        
    } else  {
        # R is running !!
        set S(erela) 1
        return
    }
}
#
# Procedure ERELA -- fin
#
#
# Procedures associees a l'AIDE R --------------------------- end
# r_rouge, r_bleu, r_brun, r_vert, fiar, farr, afficheinfo, erela
# Procedures associees a l'AIDE R --------------------------- end



# Procedure BEQUILLE_CHULL
#
proc bequille_chull {subdivision} {
    set nbgr [llength $subdivision]
    #
    # Le nombre de groupes dans la variable 'gr'
    # Les effectifs de chaque groupe dans la variable indicee 'eff($gr)'
    set gr 0
    foreach item [split $subdivision] {
        incr gr
        set eff($gr) $item
    }
    #
    #append avis "Subdivision: \n$subdivision\n"
    set avis "\n> "
    set depuis 1
    set compteur 0
    foreach item $subdivision {
        incr compteur
        append avis "c$compteur <- convex.hull(PC\$score\[$depuis:[expr {$eff($compteur)+$depuis-1}],1\],PC\$score\[$depuis:[expr {$eff($compteur)+$depuis-1}],2\])\;"
        set depuis [expr {$eff($compteur) + $depuis}]
    }
    #
    return [string trimright $avis ";"]
}
#
# Procedure BEQUILLE_CHULL


#-------------------------------------------------------------------------------------------------------------------
#
# Script principal - devenu en fait une procedure: CABALE, appelee par le menubutton GRAPH
#
#-------------------------------------------------------------------------------------------------------------------

# ------------------------------------------------------------------------------------------------------------------
proc cabale {} {
    #
    # Preparation du canvas CHEVALET pour EFA = ELLIPTIC FOURIER ANALYSIS
    #
    global chevalet S gr ww
    set ww .toile
    catch {destroy $ww}
    toplevel $ww
    wm geometry $ww 1000x575+350+100
    
    set chevalet $ww.c
    
    wm title $ww "EFA Reproduction du contour"
    
    # Une frame pour les indications du haut
    frame $ww.ht
    pack $ww.ht -side top -pady 2m -expand no
    # Deux frames sur la frame du haut
    frame $ww.ht.panneau -bg white;# pour le decompte des operations, en haut a gauche
    frame $ww.ht.indicht
    pack $ww.ht.panneau $ww.ht.indicht -side left -padx 4m -expand yes
    # Une frame pour les boutons du bas
    frame $ww.buttons
    pack $ww.buttons -side bottom -pady 2m -expand no -fill x
    
    # un panneau (indications en haut, a gauche)
    label $ww.ht.panneau.cpte -bg yellow -foreground red -width 14 -text "n / N"
    pack $ww.ht.panneau.cpte -expand no
    # un bandeau (indications en haut, a droite)
    label $ww.ht.indicht.tsfa
    pack $ww.ht.indicht.tsfa -side left -padx 1 -expand yes -fill x
    $ww.ht.indicht.tsfa configure -fg brown -text "Please hit the \"VIEWING\" button";# 11050
    
    button $ww.buttons.zoomoins -text "Z -" -command {
        global zoomoins
        set zoomoins 1
        $chevalet scale all 0 0 0.75 0.75
        set lc [$chevalet find withtag zou]
        $chevalet configure -scrollregion [$chevalet bbox all] -xscrollincrement 1.0i -yscrollincrement 1.0i
    }
    
    button $ww.buttons.zoomplus -text "Z +" -command {
        global zoomplus
        set zoomplus 1
        $chevalet scale all 0 0 1.5 1.5
        set lc [$chevalet find withtag zou]
        $chevalet configure -scrollregion [$chevalet bbox all] -xscrollincrement 1.0i -yscrollincrement 1.0i
    }
    
    button $ww.buttons.ind -text "I" -state disabled -command {
        global p S group_nb fogmat otlmoy chevalet
        #On va tenter de donner a chacun la couleur du groupe...
        $chevalet delete dibujos
        set i 0
        set greff 0
        set g 0
        foreach item  $(gr) {
            set greff [expr {$greff + $item}]
            while {$i < $greff} {
                update
                flush stdout
                #.toile.buttons.cnt configure -text "[expr {$i + 1}] / $S(otl_nb)" -state active
                .toile.ht.panneau.cpte configure -text "[expr {$i + 1}] / $S(otl_nb)" -fg red -state active
                if {[info exists S(outline,$i)]} {
                    #
                    set deuxcol "2 [expr {[llength $S(outline,$i)] / 2}] 2 ";# coordonnees en deux colonnes, x et y
                    set mat_otl "$deuxcol $S(outline,$i)"
                    #set pc_otl_ind($g,$i) [copri $mat_otl];# On retire cette bascule sur le grand axe, car le sens n'est as controle
                    set otl_ind($g,$i) $mat_otl
                    #
                    # On deplace ...
                    set listex ""
                    set listey ""
                    foreach {x y} [vtrim $otl_ind($g,$i)] {
                        set x [expr {$x + $S(deplx)}]
                        set y [expr {$y + $S(deply)}]
                        lappend listex $x
                        lappend listey $y
                    }
                    # On replace
                    set pre_tot_new ""
                    for {set compteur 0} {$compteur < [llength $listex]} {incr compteur} {
                        append pre_tot_new "[lindex $listex $compteur] [lindex $listey $compteur] "
                    }
                    $chevalet create line $pre_tot_new -fill $color($g) -width 2 -tag dibujos;# c'est dans le canvas, et on a le centrage
                    incr i
                } else  {
                    tk_messageBox -message "Please estimate outlines first\n(Menu button GRAPH)" -type ok
                }
            }
            incr g
        }
    }
    
    
    # Bouton gSP - DEBUT
    #
    button $ww.buttons.gsf -text "gSF" -state disabled -command {
        global p S group_nb otlmoy chevalet
        $ww.buttons.gsfa configure -state active
        #
        # otlmoy_periscaled() SERA un contour moyen SF CALCULE a partir des MOYENNES des COEFFICIENTS OBSERVES
        # (fogmat())
        # Les coordonnees correspondantes ne seront pas celles utilisees pour les analyses multivariees, il s'agit ici de
        # '' v i e w i n g "
        #
        if {[info exists S(P)] && $S(categ) == $S(grupos)} {
            $chevalet delete dibujos
            for {set i 0} {$i < $group_nb} {incr i} {
                $chevalet create line $otlmoy_periscaled($i) -fill $color($i) -width 2 -tag dibujos
            }
        } else  {
            if {[info exists otlmoy_periscaled]} {unset otlmoy_periscaled}
            set S(categ) $S(grupos)
            $chevalet delete dibujos
            
            for {set i 0} {$i < $group_nb} {incr i} {
                set bord($i) 0
                #
                set pt1_x 0
                for {set dot 0} {$dot < [expr {[llength $otlmoy($i)] / 2 - 1}]} {incr dot} {
                    #
                    set xxx [lindex $otlmoy($i) $pt1_x]
                    set pt1_y [expr {$pt1_x + 1}]
                    set yyy [lindex $otlmoy($i) $pt1_y]
                    set vvv [lindex $otlmoy($i) [expr {$pt1_x + 2}]]
                    set www [lindex $otlmoy($i) [expr {$pt1_y + 2}]]
                    set a "$xxx $yyy"
                    set b "$vvv $www"
                    set cuerda [disteuclid $a $b]
                    set bord($i) [expr {$bord($i) + $cuerda}]
                    incr pt1_x 2
                }
                #debug "bord <-> perigr $bord($i) <-> $perigroup($i)"
                #
            }
            #
            
            #
            # Puis les CROQUIS de perimetre unitaire
            rouge "ESTIMATED OUTLINES:\tCroquis centres et de perimetre unitaire"
            for {set i 0} {$i < $group_nb} {incr i} {
                # On donne a tous le meme perimetre...
                foreach item $otlmoy($i) {
                    #append otlmoy_periscaled($i) "[expr {$item * 1.0 / $perigroup($i)}] "
                    append otlmoy_periscaled($i) "[expr {$item * 1.0 / $bord($i)}] "
                }
                # gSP # croquis, cadre, canad, canador
                #
                #
                # Cadrer (faire tenir dans un cadre)
                #
                #debug "Avant cadrage: $otlmoy_periscaled($i)"
                #set otlmoy_periscaled($i)  [cadre $otlmoy_periscaled($i) 450 2]
                # Pour visualiser
                set lpgexlpgey [lpge $otlmoy_periscaled($i)];# appel a la procedure LPGE
                set lpgex [lindex $lpgexlpgey 0]
                set lpgey [lindex $lpgexlpgey 1]
                if {$lpgex > $lpgey} {set denom $lpgex} else {set denom $lpgey}
                # recadrage a la volee a 450 maximum
                set cuadro ""
                foreach item $otlmoy_periscaled($i) {
                    append cuadro "[expr {$item * 1 * 450 * 1.0 / $denom}] ";# meme taille !!
                }
                set otlmoy_periscaled($i)  $cuadro
                update
                #debug "Apres cadrage: $otlmoy_periscaled($i)"
                #
                # Calculer la position du croquis
                #
                set deuxcol "2 [expr {[llength $otlmoy_periscaled($i))] / 2}] 2 ";# coordonnees en deux colonnes, x et y
                set mat_otl "$deuxcol $otlmoy_periscaled($i) "
                #canad $i $mat_otl 450 450
                update
                #debug "Position x et y pour groupes: $S(deplacementx) et $S(deplacementy)"
                #
                # (Re)centrer le croquis
                #
                set otlmoy_periscaled($i)  [canador $i $mat_otl]
                #
                # Dessiner (croquer)
                #
                $chevalet create line $otlmoy_periscaled($i) -fill $color($i) -width 2 -tag dibujos
                #
                
                # gSP tentative ############################# fin
                
            }
            set S(P) 1
        }
        #tk_messageBox -message "S(grupos) $S(grupos)"
    }
    #
    # Bouton gSF - FIN
    
    
    # Bouton gSFA - DEBUT
    #
    button $ww.buttons.gsfa -text "gSF&A " -state disabled -command {
        global p S fp
        #
        #
        if {[info exists S(pero,0)]} {
            $chevalet delete dibujos
            #tk_messageBox -message "S(pero,0) existe ... [lrange $S(pero,0) 0 7]\nOui mais\nS(grupos)? $S(grupos)\ngr? $gr" -type ok
            if {[info exists S(grupos)] && $S(grupos) == $S(gr)} {
                #On va tenter de donner a chaque MOYENNE des SF&A la couleur du groupe...
                set g 0
                set debut 0
                set fin 0
                set boulier 0
                foreach item $S(gr) {
                    set sumpero($g) $S(pero,$debut);# le premier SF&A outline du groupe
                    #tk_messageBox -message "set sumpero($g) S(pero,$debut): [lrange $sumpero($g) 0 7]" -type ok
                    set fin [expr {$fin + $item}]
                    for {set m $debut} {$m < $fin} {incr m} {
                        set ou 0
                        foreach coordinate $S(pero,$m) {
                            if {$m != $debut} {
                                append  a "[expr {[lindex $sumpero($g) $ou] + $coordinate}] "
                                incr ou
                            }
                        }
                        if {$m != $debut} {set sumpero($g) $a}
                        set a ""
                    }
                    incr g
                    incr debut $item
                }
            }
        }
        #
        # Apres la somme, la moyenne
        #
        set g 0
        foreach item $S(gr) {
            set m ""
            set where 0
            foreach coordinate $sumpero($g) {
                append m "[expr {[lindex $sumpero($g) $where] * 1.0 / $item}] "
                incr where
            }
            #tk_messageBox -message "Groupe $g, divise par $item" -type ok
            set moypero($g) $m
            incr g
        }
        #
        # Pour visualiser
        #
        for {set g 0} {$g < [llength $S(gr)]} {incr g} {
            set lpgexlpgey [lpge $moypero($g)];# appel a la procedure LPGE
            set lpgex [lindex $lpgexlpgey 0]
            set lpgey [lindex $lpgexlpgey 1]
            if {$lpgex > $lpgey} {set denom $lpgex} else {set denom $lpgey}
            # recadrage a la volee a 450 maximum
            set cuadro ""
            foreach item $moypero($g) {
                append cuadro "[expr {$item * 1 * 450 * 1.0 / $denom}] ";# meme taille !!
            }
            set moypero($g)  $cuadro
            #
            # (Re)centrer la figure (Procedure CANADOR)
            #
            set deuxcol "2 [expr {[llength $moypero($g)] / 2}] 2 ";# coordonnees en deux colonnes, x et y
            set mat_moypero "$deuxcol $moypero($g) "
            set moypero($g)  [canador $g $mat_moypero]
        }
        #
        # La presentation
        #
        for {set g 0} {$g < [llength $S(gr)]} {incr g} {
            update
            $chevalet create line $moypero($g) -fill $color($g) -width 2 -tag dibujos
        }
    }
    #
    # Bouton gSF&A - FIN
    
    
    button .toile.buttons.cnt -text " ...  ..." -bg yellow -fg red -state disabled
    
    
    button $ww.buttons.con -text "EFA Consensus" -state disabled -command {
        global S p x gribouillis fogmat harm_nb
        # Matrice des coefficients
        set hume "2 $S(otl_nb) [mcols $fogmat(1)] "
        for {set i 0} {$i < $S(otl_nb)} {incr i} {
            append hume "[vtrim $fogmat($i)] "
        }
        # Moyenne des x premiers jeux de coefficients (non celle des contours puisque pas le meme nb de pts)
        set humoy [mrange [mnorms $hume] 0 end 0 0]
        #Moyenne des perimetres
        set sumperi 0
        foreach item $S(perimeter) {
            set sumperi [expr {$sumperi + $item}]
        }
        set perimoy [expr {$sumperi * 1.0 / [llength $S(perimeter)]}]
        #Moyenne des points
        if {[info exists otl_liste] && [llength $otl_liste] > 1} {
            # Input file: _OTL.txt
            set sump 0
            foreach item  $otl_liste {
                set sump [expr {$sump + $item}]
            }
            set pmoy [expr {int($sump * 1.0 / [llength  $otl_liste])}]
        } else  {
            # Input file: _FOG.txt
            set pmoy 400
        }
        #Moyennes des Ao et Co
        set sumao 0
        foreach item $S(Ao) {
            set sumao [expr {$sumao + $item}]
        }
        set Aomoy [expr {$sumao * 1.0 / [llength $S(Ao)]}]
        set sumco 0
        foreach item $S(Co) {
            set sumco [expr {$sumco + $item}]
        }
        set Comoy [expr {$sumco * 1.0 / [llength $S(Co)]}]
        #
        # Envoyer les coefficients moyens au casse-pipe
        set otl_consensus [croquis $humoy $perimoy $pmoy $Aomoy $Comoy]
        # Aligner l'outline sur son grand axe
        set hume "2 [expr {int($pmoy - 1)}] 2 "
        set mat_otl_consensus "$hume $otl_consensus"
        #
        #set pc_otl_consensus [copri $mat_otl_consensus];# Pas de PCA car c'est aussi le consensus des orientations... !!
        #
        # On deplace ...
        set listex ""
        set listey ""
        foreach {x y} [vtrim $mat_otl_consensus] {
            set x [expr {$x + $S(deplx)}]
            set y [expr {$y + $S(deply)}]
            lappend listex $x
            lappend listey $y
        }
        # On replace
        set pre_tot_new ""
        for {set compteur 0} {$compteur < [llength $listex]} {incr compteur} {
            append pre_tot_new "[lindex $listex $compteur] [lindex $listey $compteur] "
        }
        # On efface
        $chevalet delete dibujos
        # On dessine
        $chevalet create line $pre_tot_new -fill blue -tag dibujos;# c'est dans le canvas, et ON A le centrage
    }
    
    button $ww.buttons.sf -text "SF" -state disabled -command {
        global S
        update
        $ww.buttons.zoomplus configure -state disabled
        $ww.buttons.zoomoins configure -state disabled
        $ww.buttons.vie configure -state disabled
        $ww.buttons.sf configure -state disabled
        $ww.buttons.hrm configure -state disabled
        
        #
        # NEW MAY 02
        #
        
        $ww.ht.indicht.tsfa configure -bg grey
        $ww.ht.indicht.tsfa configure -text "WHICH SIZE ? \t" -fg brown
        checkbutton $ww.ht.indicht.pear1 -text "Perimeter" -fg brown -variable check -command {global S;set S(taille) "p"}
        checkbutton $ww.ht.indicht.pear2 -text "Area <- ellipse H1" -fg brown -variable check -command {global S;set S(taille) "a"}
        pack $ww.ht.indicht.pear1 $ww.ht.indicht.pear2 -side left
        vwait S(taille)
        #
        set S(pear) ""
        destroy $ww.ht.indicht.pear1
        destroy $ww.ht.indicht.pear2
        #
        if {$S(taille) == "p"} {
            set ampleur "PERIMETER";#la taille est le PERIMETRE
        } else {
            set ampleur "AREA of ELLIPSE H1";#la taille est l'AIRE
        }
        $ww.ht.indicht.tsfa configure -text "SIZE IS THE $ampleur.\tEach coordinate is scaled by size estimator \tFigures are NOT aligned"
        pack $ww.ht.indicht.tsfa -side left -padx 1
        #
        # NEW MAY 02
        #
        
        #
        pe;# appel a la procedure PE (contours oranges)
        #
        #
        $ww.buttons.zoomplus configure -state active
        $ww.buttons.zoomoins configure -state active
        #$ww.buttons.vie configure -state active
        #$ww.buttons.sf configure -state active
        $ww.buttons.hrm configure -state active
        $ww.buttons.sfa configure -state active
        $ww.ht.indicht.tsfa configure -text "Please hit the \"SF&A\" button to align figures"
    }
    # fin du bouton SF -- $ww.buttons.sf
    
    
    # Bouton .SF&A - fait usage de la procedure PAF -- DEBUT
    #
    button $ww.buttons.sfa -text "SF&A" -state disabled -command {
        global S
        update
        $ww.buttons.zoomplus configure -state disabled
        $ww.buttons.zoomoins configure -state disabled
        $ww.buttons.grp configure -state disabled
        $ww.buttons.sfa configure -state disabled
        $ww.buttons.sf configure -state disabled
        $ww.buttons.hrm configure -state disabled
        $ww.buttons.vie configure -state disabled
        #
        if {[info exists S(pero,0)]} {
            $chevalet delete dibujos
            if {[info exists S(grupos)] && $S(grupos) == $gr} {
                #On va tenter de donner a chacun la couleur du groupe...
                $chevalet delete dibujos
                set i 0
                set greff 0
                set g 0
                foreach item  $S(gr) {
                    set greff [expr {$greff + $item}]
                    while {$i < $greff} {
                        update
                        flush stdout
                        #.toile.buttons.cnt configure -text "[expr {$i + 1}] / $S(otl_nb)" -fg red -state active
                        .toile.ht.panneau.cpte  configure -text "[expr {$i + 1}] / $S(otl_nb)"  -fg red -state active
                        update
                        #tk_messageBox -message "[expr {$i + 1}] / $S(otl_nb): groupe $g, couleur $g" -type ok
                        set pero($i) $S(pero,$i)
                        #
                        # Le croquis est peut-etre trop grand, peut-etre trop petit, il faut le cadrer (Procedure CADRE ... justement, NON !!)
                        #
                        set lpgexlpgey [lpge $pero($i)];# appel a la procedure LPGE, pour mesurer l'ampleur de la figure
                        set lpgex [lindex $lpgexlpgey 0]
                        set lpgey [lindex $lpgexlpgey 1]
                        if {$lpgex > $lpgey} {set denom $lpgex} else {set denom $lpgey}
                        # On recadre la figure pour une ampleur maximum de 450
                        set cuadro ""
                        foreach item $pero($i) {
                            append cuadro "[expr {$item * 1 * 450 * 1.0 / $denom}] "
                        }
                        set pero($i)  $cuadro
                        #
                        # (Re)centrer la figure (Procedure CANADOR)
                        #
                        set deuxcol "2 [expr {[llength $pero($i)] / 2}] 2 ";# coordonnees en deux colonnes, x et y
                        set mat_pero "$deuxcol $pero($i) "
                        set pero($i)  [canador $i $mat_pero]
                        $chevalet create line $pero($i) -fill $color($g) -width 2 -tag dibujos
                        incr i
                    }
                    incr g
                    if {[expr {$i + 1}] > $S(otl_nb)} {
                        $chevalet delete fig
                        $ww.buttons.zoomplus configure -state active
                        $ww.buttons.zoomoins configure -state active
                        $ww.buttons.vie configure -state active
                        $ww.buttons.hrm configure -state active
                        $ww.buttons.sf configure -state active
                        $ww.buttons.sfa configure -state active
                        $ww.buttons.grp configure -state active
                    }
                }
            } else  {
                update
                paf
                $ww.buttons.zoomplus configure -state active
                $ww.buttons.zoomoins configure -state active
                $ww.buttons.vie configure -state active
                $ww.buttons.hrm configure -state active
                $ww.buttons.sf configure -state active
                $ww.buttons.sfa configure -state active
                $ww.buttons.grp configure -state active
            }
        } else  {
            #destroy $ww.ht.indicht.tsfa
            #
            if {$S(taille) == "p"} {set ampleur "PERIMETER"} else {set ampleur "AREA"}
            set bandeau "Step 1. Each outline scaled by size ($ampleur)  Step 2. All outlines (400 landmarks type III) rotated along the PC of the first one."
            $ww.ht.indicht.tsfa configure -text $bandeau
            #pack $ww.ht.indicht.tsfa -side left -padx 1 -expand yes -fill both
            #
            $chevalet delete dibujos
            # appel a la procedure PAF
            paf
            #
            update
            $chevalet delete fig
            $ww.buttons.zoomplus configure -state active
            $ww.buttons.zoomoins configure -state active
            #$ww.buttons.vie configure -state active
            $ww.buttons.hrm configure -state active
            #$ww.buttons.sf configure -state active
            $ww.buttons.grp configure -state active
            #$ww.buttons.sfa configure -state active
        }
        #$fp.menus.mva configure -state active
        $fp.menus.size  configure -state active
        $ww.ht.indicht.tsfa configure -text "You can enter groups (\"EFA groups\" button)"
    }
    # fin du bouton SFA -- $ww.buttons.sfa
    
    #button EFA GROUPS
    button $ww.buttons.grp -text "EFA GROUPS" -state disabled -command {
        #
        .toile.ht.panneau.cpte  configure -text "$S(otl_nb) outlines"  -fg red -state active
        destroy $ww.ht.indicht.tsfa;# efface l'aide commentaire du bouton .sfa (SP&A)
        #
        global x S p fogmat gribouillis otlmoy group_nb
        
        #
        # Des groupes n'ont pas encore ete definis
        if  {$S(gr) == ""} {
            # On n'a meme pas fait de propositions de groupes ! S(gr) est un 'entry' button
            tk_messageBox -message "Enter group sizes first" -type ok
            return
        } else  {
            set group_nb [llength $S(gr)]
            #######################################
            #   La palette des couleurs # couleurs de courbe
            global gilimana jepeins
            #set gilimana ""
            #set jepeins ""
            if {[info exists fix] != 1} {
                set coul 0
                foreach item [split $S(gr)] {
                    set rcol [expr {int(rand() * 65535)}]
                    set gcol [expr {int(rand() * 65535)}]
                    set bcol [expr {int(rand() * 65535)}]
                    set color($coul) [format "#%.4x%.4x%.4x" $rcol $gcol $bcol]
                    lappend gilimana $color($coul)
                    incr coul
                }
            }
        }
        
        #
        #
        if {[info exists gr] != 1}  {set gr [llength $S(gr)]}
        
        #
        # otlmoy() SERA un contour moyen CALCULE a partir des MOYENNES des COEFFICIENTS OBSERVES <- fogmat()
        #
        
        if {[info exists S(grupos)] && $S(grupos) == $S(gr)} {
            #tk_messageBox -message "S(grupos) = $S(grupos) = S(gr) = $S(gr)"
            #
            $ww.buttons.gsf configure -state active
            #
            # On efface les esquisses precedentes
            $chevalet delete dibujos
            #######################################
            #   La palette des couleurs # couleurs de courbe
            global gilimana jepeins
            if {[info exists fix] != 1} {
                set coul 0
                foreach item [split $gr] {
                    set rcol [expr {int(rand() * 65535)}]
                    set gcol [expr {int(rand() * 65535)}]
                    set bcol [expr {int(rand() * 65535)}]
                    set color($coul) [format "#%.4x%.4x%.4x" $rcol $gcol $bcol]
                    lappend gilimana $color($coul)
                    incr coul
                }
            }
            # Assigner AU HASARD des couleurs differentes a chaque groupe
            # -----------------------------------------------------------
            global gilimana jepeins
            set gilimana ""
            #tk_messageBox -message "info exists jepeins = [info exists jepeins]" -type ok
            if {[info exists jepeins] == 0} {
                if {[info exists fix]} {
                    if {$fix == 0} {
                        set coul 0
                        foreach item [split $gr] {
                            set rcol [expr {int(rand() * 65535)}]
                            set gcol [expr {int(rand() * 65535)}]
                            set bcol [expr {int(rand() * 65535)}]
                            set color($coul) [format "#%.4x%.4x%.4x" $rcol $gcol $bcol]
                            lappend gilimana $color($coul)
                            incr coul
                        }
                    }
                }
            } else {
                #tk_messageBox -message "jepeins = $jepeins" -type ok
                if {$jepeins == 1} {
                    # Assigner des couleurs differentes a chaque groupe
                    set coul 0
                    foreach item [split $effectifs] {
                        set color($coul) [tk_chooseColor]
                        incr coul
                    }
                    unset jepeins
                }
            }
            #
            for {set i 0} {$i < $group_nb} {incr i} {
                #
                $chevalet create line $otlmoy($i) -fill $color($i) -tag dibujos
                #
                $ww.buttons.col configure -state active
                destroy $ww.ht.indicht.$i $ww.ht.indicht.t$i
                label $ww.ht.indicht.$i -bg $color($i)
                label $ww.ht.indicht.t$i -text [lindex $S(grupos) $i]
                pack $ww.ht.indicht.$i $ww.ht.indicht.t$i -side left -padx 1
            }
            
        } else  {
            #tk_messageBox -message "S(grupos) ... n'existe pas = S(gr) existe? --> $S(gr) ?"
            #
            set S(ppl) 1;# 'ppl' passe par la ...
            #
            # On a fait des propositions de groupes ...
            set group_nb [llength $S(gr)]
            set mat_group "2 $group_nb 1 $S(gr)"
            set total [msum $mat_group];# Le total des individus (le nombre total de figures)
            #
            # Matrice des coefficients  de Fourier <- fogmat()
            set humeg "2 $S(otl_nb) [mcols $fogmat(1)] "
            for {set i 0} {$i < $S(otl_nb)} {incr i} {
                append humeg "[vtrim $fogmat($i)] "
            }
            #debug "MATRICE DES COEFFICIENTS OBSERVES\n[show $humeg]"
            
            # Separer les matrices (r, a, b) de chaque groupe (matrices de Hume)
            #
            set debut 0
            set fin 0
            set boulier 0
            foreach item $S(gr) {
                set fin [expr {$fin + $item}]
                set group($boulier) [mrange $humeg 0 end $debut [expr {$fin - 1}]]
                #debug "group($boulier): $group($boulier)"
                incr boulier
                incr debut $item
            }
            
            # A present calculer les moyennes de chaque groupe (matrices)
            #debug "Les moyennes de chaque groupe (matrices)"
            for {set i 0} {$i < $group_nb} {incr i} {
                set humoyg($i) [mrange [mnorms $group($i)] 0 end 0 0]
                #debug "Group $i: $humoyg($i)"
            }
            
            #Moyenne des PERIMETRES dans chaque groupe
            #debug "Liste des perimetres in CABALE\n$S(perimeter)"
            set debut 0
            set fin 0
            set boulier 0
            foreach item $S(gr) {
                #set cordelette 0
                set sumgroup 0
                set fin [expr {$fin + $item}]
                for {set m $debut} {$m < $fin} {incr m} {
                    #debug "for set m $debut ... $m < [expr {$fin - 1}] ou fin? $fin ... incr m"
                    set sumgroup [expr {$sumgroup + [lindex $S(perimeter) $m]}]
                    #incr cordelette
                }
                #debug "item = $item cordelette = $cordelette"
                set perigroup($boulier) [expr {$sumgroup * 1.0 / $item}]
                lappend grouperi "$perigroup($boulier) "
                #debug "PERIMETRES\nperigroup($boulier) $perigroup($boulier)"
                incr boulier
                incr debut $item
            }
            
            # Calcul du perimetre maximum pour le calcul du ratio pour le cadrage
            set grouperi_ordre [lsort -real -decreasing $grouperi]
            set grouperimax [lindex $grouperi_ordre 0]
            
            #Moyenne des points <- attention, c'est calcule sur le total, ce qui n'est peut-etre pas tjrs optimal
            if {[info exists otl_liste] && [llength $otl_liste] > 1} {
                # Input file : _OTL.txt
                set sump 0
                foreach item  $otl_liste {
                    set sump [expr {$sump + $item}]
                }
                set pmoyg [expr {int($sump * 1.0 / [llength  $otl_liste])}];# c'est une valeur entiere
            } else  {
                # Input file : _FOG.txt
                set pmoyg 400
            }
            #debug "nb de pts choisi, le meme pour chaque groupe = $pmoyg"
            
            #Moyennes des Ao et Co <- appliquer le meme script que pour les perimetres, si ce script est bon
            # ...
            #debug "Ao et Co\n$S(Ao) \net\n $S(Co)"
            set debut 0
            set fin 0
            set boulier 0
            foreach item $S(gr) {
                set sumgAo 0
                set sumgCo 0
                set fin [expr {$fin + $item}]
                for {set m $debut} {$m < $fin} {incr m} {
                    set sumgAo [expr {$sumgAo + [lindex $S(Ao) $m]}]
                    set sumgCo [expr {$sumgCo + [lindex $S(Co) $m]}]
                }
                set Aomoyg($boulier) [expr {$sumgAo * 1.0 / $item}]
                set Comoyg($boulier) [expr {$sumgCo * 1.0 / $item}]
                #debug "Ao et Co\n$Aomoyg($boulier) et $Comoyg($boulier)"
                incr boulier
                incr debut $item
            }
            
            #######################################
            #   La palette des couleurs # couleurs de courbe
            global gilimana jepeins
            if {[info exists fix] != 1} {
                set coul 0
                foreach item [split $gr] {
                    set rcol [expr {int(rand() * 65535)}]
                    set gcol [expr {int(rand() * 65535)}]
                    set bcol [expr {int(rand() * 65535)}]
                    set color($coul) [format "#%.4x%.4x%.4x" $rcol $gcol $bcol]
                    lappend gilimana $color($coul)
                    incr coul
                }
            }
            #
            # Assigner AU HASARD des couleurs differentes a chaque groupe
            # -----------------------------------------------------------
            set gilimana ""
            #tk_messageBox -message "info exists jepeins = [info exists jepeins]" -type ok
            if {[info exists jepeins] == 0} {
                if {[info exists fix]} {
                    if {$fix == 0} {
                        set coul 0
                        foreach item [split $gr] {
                            set rcol [expr {int(rand() * 65535)}]
                            set gcol [expr {int(rand() * 65535)}]
                            set bcol [expr {int(rand() * 65535)}]
                            set color($coul) [format "#%.4x%.4x%.4x" $rcol $gcol $bcol]
                            lappend gilimana $color($coul)
                            incr coul
                        }
                    }
                }
            } else {
                #tk_messageBox -message "jepeins = $jepeins" -type ok
                if {$jepeins == 1} {
                    # Assigner des couleurs differentes a chaque groupe
                    set coul 0
                    foreach item [split $effectifs] {
                        set color($coul) [tk_chooseColor]
                        incr coul
                    }
                    unset jepeins
                }
            }
            ###############################################################################
            
            
            # On efface les esquisses precedentes
            $chevalet delete dibujos
            
            # Puis les CROQUIS
            #
            for {set i 0} {$i < $group_nb} {incr i} {
                set otlmoy($i) [croquis $humoyg($i) $perigroup($i) $pmoyg $Aomoyg($i) $Comoyg($i)]
                append otlmoy($i) [lrange $otlmoy($i) 0 1];# de 798 a 800 coord
                #
                # Cadrer (faire tenir dans un cadre) (<-> NON pour preserver les tailles ??)
                #
                set proportion [expr {$perigroup($i) * 1.0 / $grouperimax}]
                #debug "(grouperimax $grouperimax) $perigroup($i) ... proportion $proportion"
                set otlmoy($i) [cadre $otlmoy($i) 450 $proportion]
                #debug "Apres cadrage $otlmoy($i)"
                #
                # Calculer la position du croquis
                #
                set deuxcol "2 [expr {[llength $otlmoy($i)] / 2}] 2 ";# coordonnees en deux colonnes, x et y
                set mat_otl "$deuxcol $otlmoy($i)"
                #
                # (Re)centrer le croquis
                #
                set otlmoy($i) [canador $i $mat_otl]
                #
                # Dessiner (croquer)
                #
                $chevalet create line $otlmoy($i) -fill $color($i) -tag dibujos;# CHE BON CHA !!!!!!!!
            }
            #
            set S(grupos) $S(gr)
            tk_messageBox -message "gSF for group's contours scaled by size\
                    \ngSF&A for them to be aligned" -type ok
            $ww.buttons.grp invoke
            
        }
        # otlmoy() est un contour moyen CALCULE a partir des MOYENNES des COEFFICIENTS OBSERVES (fogmat())
    }
    
    label $ww.buttons.lab -fg blue -text "<- indiv.   groups ->"
    
    button $ww.buttons.tag -text "No pic" -command {$chevalet delete dibujos}
    
    button $ww.buttons.txt -text "No T" -command {$chevalet delete data_info}
    
    button $ww.buttons.col -text "C" -fg red -state disabled -command {
        #Fixer les couleurs
        if {[info exists fix]} {
            if {$fix == 0} {
                set fix 1
                tk_messageBox -message "Colors selected" -type ok
            } else {
                set fix 0
                tk_messageBox -message "Colors unselected" -type ok
            }
        } else {
            set fix 1
            #tk_messageBox -message "Colors are set" -type ok
        }
        
    }
    #
    # Fin du button 'EFA groups'
    
    # ENTRY button
    entry $ww.buttons.eff -text "GROUPS" -textvariable S(gr)
    
    # VIEWING button
    button $ww.buttons.vie -text "Viewing " -command {
        global S
        viewing
        $ww.buttons.vie configure -state disabled
        $ww.buttons.sf configure -state active
        $ww.buttons.hrm configure -state active
    }
    
    # H movie button
    button $ww.buttons.hrm -text "H " -state disabled -command {
        global S selharm totalpower ptn_mat puissance totalpower fogmat cifra
        #
        $chevalet create text 80 20 -text "HARMONIC POWER, \nbeginning with the second harmonic" -font 18 -anchor w -tag tt
        #
        for {set j 0} {$j < $S(otl_nb)} {incr j} {
            # --- --- --- Convertir d'abord les outlines en MATRICES de Hume --- --- ---
            # J'envoie au COF des coordonnees estimees a partir des contours observes
            # COF en derive les coefficients de Fourier (methode elliptique) ... ?? et les accumule dans S(pre_pafmatall_sf)
            set pourcof "2 1 [llength $S(outline,$j)] $S(outline,$j)"
            #
            set cifra $j
            set sumpower 0
            $chevalet delete dibujos
            $chevalet delete t
            for {set h 2} {$h < 29} {incr h 1} {
                update
                # la procedure COF appelle la procedure CROQUIS, qui, elle, retourne (RETURN) le contour
                set selharm($j,$h) [cof $pourcof $h]
                #debug "H: selharm($j,$h) : \n$selharm($j,$h)"
                #
                $chevalet delete dibujos
                #
                set compteurssa 0
                foreach {xssa yssa} $selharm($j,$h) {
                    # H <- bouton
                    incr compteurssa
                    if {[expr {fmod($compteurssa,2) == 0}] } {
                        $chevalet create oval [expr {$xssa-1}] [expr {$yssa-1}]  [expr {$xssa+1}] [expr {$yssa+1}]  -outline blue -width 1 -tag dibujos
                    }
                }
                #
                set sumpower [expr {$sumpower + $puissance($j,$h)}]
                set percentpower [expr {$sumpower * 1.0 / $totalpower($j)}]
                #
                $chevalet create text 150 [expr {20+15*$h}] -text "\n$h Harmonics:\t [format %1.4f $percentpower]" -anchor center -tag t
            }
            set encore [tk_messageBox -message "This was object [expr {$j + 1}].\nNext one ?  " -type yesnocancel]
            switch -- $encore {
                yes {}
                no {$chevalet delete tt;$chevalet delete t;break}
                cancel {set j $S(otl_nb); $chevalet delete tt;$chevalet delete t;break}
            }
        }
    }
    # Fin du bouton .hrm "H"
    
    
    # Bouton premiere harmonique
    button $ww.buttons.hrm1 -text "h" -state active -command {
        
        global S selharm totalpower ptn_mat puissance totalpower fogmat;#cifra
        
        #$chevalet create text 80 20 -text "HARMONIC POWER, \nFIRST HARMONIC" -font 18 -anchor w -tag tt
        
        for {set j 0} {$j < $S(otl_nb)} {incr j} {
            # --- --- --- Convertir d'abord les outlines en MATRICES de Hume --- --- ---
            # J'envoie au COF des coordonnees estimees a partir des contours observes
            # COF en derive les coefficients de Fourier (methode elliptique) ... ?? et les accumule dans S(pafmatall_sf) ?? <- POURQUOI SF??
            set pourcof "2 1 [llength $S(outline,$j)] $S(outline,$j)"
            #
            #set cifra $j
            set sumpower 0
            $chevalet delete dibujos
            $chevalet delete t
            #
            set S(nh) 6
            $ww.buttons.hrm1 configure -text "h [expr {$S(nh) - 5}]"
            for {set h [expr {$S(nh) - 3}]} {$h < $S(nh)} {incr h 1} {
                update
                # la procedure COF appelle la procedure CROQUIS, qui, elle, retourne (RETURN) le contour
                set selharm($j,$h) [cof $pourcof $h]
                #
                $chevalet delete dibujos
                #
                set compteurssa 0
                foreach {xssa yssa} [vtrim $selharm($j,$h)] {
                    # h <- bouton
                    incr compteurssa
                    if {[expr {fmod($compteurssa,2) == 0}] } {
                        $chevalet create oval [expr {$xssa-1}] [expr {$yssa-1}]  [expr {$xssa+1}] [expr {$yssa+1}]  -outline blue -width 1 -tag dibujos
                    }
                }
                #
                #debug "puissance($j,$h) $puissance($j,$h) \ntotalpower($j) $totalpower($j)"
                set sumpower [expr {$sumpower + $puissance($j,$h)}]
                set percentpower [expr {$sumpower * 1.0 / $totalpower($j)}]
                
                $chevalet create text 150 [expr {20+15*$h}] -text "\n$h Harmonics:\t [format %1.4f $percentpower]" -anchor center -tag t
                set encore [tk_messageBox -message "Next hatmonic ?  " -type yesno]
                switch -- $encore {
                    yes {
                        incr S(nh)
                        $ww.buttons.hrm1 configure -text "h [expr {$S(nh) - 5}]"
                    }
                    no {$chevalet delete tt;$chevalet delete t;break}
                }
            }
            set encore [tk_messageBox -message "This was object [expr {$j + 1}].\nNext one ?  " -type yesnocancel]
            switch -- $encore {
                yes {}
                no {$chevalet delete tt;$chevalet delete t;break}
                cancel {set j $S(otl_nb); $chevalet delete tt;$chevalet delete t;break}
            }
        }
    }
    # Fin du bouton .hrm1 "h"
    
    
    
    #pack $ww.buttons.cnt $ww.buttons.zoomoins $ww.buttons.zoomplus $ww.buttons.vie $ww.buttons.hrm \
    $ww.buttons.sf  $ww.buttons.sfa $ww.buttons.lab $ww.buttons.grp \
            $ww.buttons.col $ww.buttons.eff   $ww.buttons.gsf $ww.buttons.gsfa -side left
    pack $ww.buttons.zoomoins $ww.buttons.zoomplus $ww.buttons.vie \
            $ww.buttons.sf  $ww.buttons.sfa $ww.buttons.lab $ww.buttons.grp \
            $ww.buttons.col $ww.buttons.eff   $ww.buttons.gsf $ww.buttons.gsfa $ww.buttons.cnt $ww.buttons.hrm -side left
    
    balloonhelp_for $ww.buttons.cnt "Yellow"
    balloonhelp_for $ww.buttons.zoomoins "Zoom in"
    balloonhelp_for $ww.buttons.zoomplus "Zoom out"
    balloonhelp_for $ww.buttons.vie "Estimated outlines"
    balloonhelp_for $ww.buttons.hrm "Each figure\nharmonic by harmonic"
    balloonhelp_for $ww.buttons.sf "Size Free"
    balloonhelp_for $ww.buttons.sfa "Size Free and Aligned "
    balloonhelp_for $ww.buttons.grp "Average outlines by groups"
    balloonhelp_for $ww.buttons.col "To stabilize color selection\nAdoptar los colores"
    balloonhelp_for $ww.buttons.eff "Enter successive groups (number of individuals)\nseparated by space"
    
    balloonhelp_for $ww.buttons.gsf "Groups: size free"
    balloonhelp_for $ww.buttons.gsfa "Groups: size free\nand aligned"
    
    # On pose a present la toile sur le chevalet
    #
    canvas $chevalet -width 450 -height 450 -relief raised -background "light yellow" -cursor cross\
            -yscrollcommand "$ww.v_scroll_tut set" \
            -xscrollcommand "$ww.h_scroll_tut set"
    scrollbar $ww.v_scroll_tut -command "$chevalet yview"
    scrollbar $ww.h_scroll_tut -command "$chevalet xview" -orient horizontal
    pack $ww.v_scroll_tut -side right -fill y
    pack $ww.h_scroll_tut -side bottom -fill x
    
    pack $chevalet -expand yes -fill both
    
    $chevalet configure -scrollregion [$chevalet bbox all] -xscrollincrement 1.0i -yscrollincrement 1.0i
    
}
#wm iconify .toile

# ----------------------------------------------------- Fin de la preparation des canvas TREPIED et CHEVALET ----------

#global p
#main;# (pour CFC)
#fogmain;# (pour EFA)
