# COPYRIGHTS

# Jean-Pierre Dujardin
# The jpdraw v. 0.991 software is copyrighted by Jean-Pierre Dujardin, 2002, Unité de Recherches 062- Unité Mixte de Recherches UMR9926, Institut de Recherches pour le Développement (IRD, France).
# jpdraw is provided under the GPL license'
# Institut de Recherches pour le Développement.
# L'IRD (Institut de Recherches pour le Développement) représenté par Madame Marianne BERTHOD-WURMSER, Directrice du DEV, déclare par la présente ne pas revendiquer de droits patrimoniaux du programme jpdraw.tcl réalisé par Jean-Pierre Dujardin et l'autorise ainsi à en assurer la diffusion sous licence GPL (http://www.fsf.org/copyleft/gpl.html).

# VERSION DU JPDRAW
global version
set verjpd "jpdraw 0 10"

# v 0 01 fait suite a 0.995; la procedure RANGE est reconstruite avec des variables locales
# v 0 02 les procedure zoom doivent etre changees
# v 0 03 - 0 06 procedures zoom changees; extensive use of tags was added
# v 0 07a tentative de procedure range_by
# v 0 08a-9 convex hulls
# v 0 09a-1 histogramme

# COPYRIGHT ---------------------------------------------------------------
# The CLIC software is being distributed under terms and conditions similar to TclTk.          #
# The following terms apply to all files associated with the software unless explicitly disclaimed \ #
# in individual files. The author hereby grants permission to use, copy, modify, distribute, and \   #
# license this software and its documentation for any purpose, provided that existing copyright \    #
# notices are retained in all copies and that this notice is included verbatim in any distributions.\#
# No written agreement, license, or royalty fee is required for any of the authorized uses. \        #
# Modifications to this software may be copyrighted by their authors and need not follow the \       #
# licensing terms described here, provided that the new terms are clearly indicated on the first \   #
# page of each file where they apply.                                                                #
# IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, \       #
# SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, \
# ITS DOCUMENTATION, OR ANY DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE \      #
# POSSIBILITY OF SUCH DAMAGE.                                                                        #
# THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,INCLUDING, BUT NOT LIMITED TO, \ #
# THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT. #
# THIS SOFTWARE IS PROVIDED ON AN 'AS IS' BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE NO OBLIGATION\#
# TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.                          #
# -------------------------------------------------------------------------#

# Procedure MEUNON
#
proc meunon {quoi} {
    toplevel .non
    wm geometry .non +100+100
    text .non.t -width 25 -height 4 -wrap word
    pack .non.t
    button .non.ok -text OK -command "destroy .non"
    pack .non.ok -side bottom
    .non.t insert end $quoi
}
#
# proc MEUNON - fin

############## procedure lformat ######## debut
proc lformat {ainsi liste} {
    foreach item $liste {
        set item [format $ainsi $item]
        lappend fliste $item
    }
    return $fliste
}
############## procedure lformat ######## fin


# PROCEDURE etiquetage - DEBUT
#
proc etiquetage {pathname} {
    global text data references
    set fid [open $pathname]
    set text [read -nonewline $fid]
    #debug
    #puts "text = \n$text"
    close $fid
    set rowcount 0
    set colcount 0
    
    set compteur 0
    set lignes 0
    set data ""
    foreach line [split $text \n] {
        incr compteur
        if {$compteur > 1} {
            if  {$line != ""} {
                set colcount [llength $line]
            }
        }
        if {$compteur > 1} {
            foreach item [split $line] { if {$item != ""} {
                    incr lignes;lappend data $item
                }
            }
        } else {set gchangdavi "ouais"};#append references "Sample info: $line"
    }
    #set colcount [llength $line]
    set rowcount [expr {$lignes/$colcount}]
    set result [concat 2 $rowcount $colcount $data]
    set meunon "$rowcount individuos ?"
    return $data
}
#
# PROCEDURE etiquetage - FIN


######################## PROCEDURE numind #### DEBUT###
proc numind {individus} {
    #debug
    #puts "individus\n$individus"
    destroy .subd
    
    #chull
    global effectifs
    global envind
    set envind $individus
    #debug chull
    #if {[info exists effectifs]} {puts "effectifs \n$effectifs\nindividus\n$envind"}
    global gr pad verjpd references
    
    update
    flush stdout
    
    # VALEUR MINIMUM de l'abscisse
    # -----------------------------------------------
    set ordre {}
    
    foreach item $individus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc1 [lindex $ordre 0]
    ## ajout August 2002
    set minpc1 $minimumpc1
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de l'ordonnee
    # (procedure NUMIND)
    # -----------------------------------------------
    set ordre {}
    foreach item $individus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc2 [lindex $ordre 0]
    ## ajout August 2002
    set minpc2 $minimumpc2
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # MINIMUM SUR ZERO pour l'abscisse
    # (procedure NUMIND)
    # --------------------------------------
    
    foreach item $individus {
        set somme {}
        lappend somme [expr {[lindex $item 3] - $minimumpc1}]
        lappend individuscentPC1 $somme
    }
    #debug
    #puts "debug numind individuscentPC1 $individuscentPC1"
    
    # MINIMUM SUR ZERO pour l'ordonnee
    # (procedure NUMIND)
    # --------------------------------------
    foreach item $individus {
        set somme {}
        lappend somme [expr {[lindex $item 4] - $minimumpc2}]
        lappend individuscentPC2 $somme
    }
    
    
    # VALEUR MAXIMUM DE l'abscisse centree
    # (procedure NUMIND)
    # -------------------------------------------------------
    set ordre [lsort -real $individuscentPC1]
    set maximumpc1 [lindex $ordre end]
    
    # VALEUR MAXIMUM de l'ordonnee centree
    # (procedure NUMIND)
    # -------------------------------------------------------
    set ordre [lsort -real $individuscentPC2]
    set maximumpc2 [lindex $ordre end]
    
    set corrx [expr {300.0/$maximumpc1}]
    set corry [expr {300.0/$maximumpc2}]
    
    ###################################################
    # preparation du graphique de la procedure NUMIND
    ###################################################
    
    set w .plottnumind
    catch {destroy $w}
    toplevel $w
    wm geometry $w 550x485+205+10
    wm title $w "X = factor 1, Y = factor 2"
    wm iconname $w "factor 1 en X, factor 2 en Y"
    
    set c $w.c
    
    set Font {Helvetica 6}
    
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    # chull
    button $w.buttons.chull -background red -foreground white -text "C. Hulls" \
            -command {
                global effectifs envind
                # Effectifs ou pas
                destroy .subd
                set fen .subd
                catch {destroy $fen}
                toplevel $fen
                wm geometry $fen 220x90+280+380
                if {[info exists effectifs]} {wm iconname $fen "$effectifs"}
                set appel [entry .subd.entree -background white -textvariable valeurs]
                set commando [button .subd.bouton -background grey25 -foreground white \
                -text "Enter group sizes separated \nby a space, \nthen press me" \
                -font "Helvetica 12" \
                -command {global effectifs envind; set effectifs $valeurs;numind $envind}]
                pack $appel $commando
            }
    button $w.buttons.cancel -text "Volver" -command "destroy $w"
    button $w.buttons.zoom -text "Z" -command {
        .plottnumind.c scale all 0 0 1.5 1.5
        .plottnumind.c configure -scrollregion [.plottnumind.c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    }
    button $w.buttons.ps -text "Guardar (post-script)" -bg white -command {
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile\
                -defaultextension .ps]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottnumind.c postscript]
        close $outputGraphe
    }
    pack $w.buttons.ps $w.buttons.chull $w.buttons.zoom $w.buttons.cancel -side left -expand 1
    balloonhelp_for $w.buttons.chull "Convex Hulls \nConnexion de los valores mas externos de cada grupo"
    
    canvas $c -width 450 -height 450 -relief raised -background white
    pack $w.c -side top -fill x
    
    set plotFont {Helvetica 8}
    
    ########################################################################
    # SSi c'est una AD, le plot est carre
    if {[info exists pad]} {
        set blup 300.0
        set xgauche 100
        set plic [expr {(400 - $blup)/2}]
        $c create line 100 [expr {400 - $plic}] 400 [expr {400 - $plic}] \
                -width 1 -tag axe_x
        ##### axe des x croit de g a droite (procedure DESSINE)
        $c create line 100 [expr {400 - $plic}] 100 [expr {(400 - $plic - $blup)}] \
                -width 1 -tag axe_y
        ##### axe des y decroit de bas en ht
        set corry [expr {($blup/$maximumpc2)}]
        
        for {set i 0} {$i <= 10} {incr i} {
            set x [expr {100 + ($i*30)}]
            $c create line $x [expr {400 - $plic}] $x [expr {395 - $plic}] -width 1 -tag axe_x
            ##### subdividions sur l'axe des x
        }
        set hauteurY $blup
        set subdivisionY [expr {$hauteurY / 10}]
        for {set i 0} {$i <= 10} {incr i} {
            set y [expr {400 - $plic - ($i*$subdivisionY)}]
            $c create line 100 $y 105 $y -width 1 -tag axe_y
            ##### subdividions sur l'axe des y
        }
        # sinon on fait un plot aux axes proportionels
    } else  {
        
        if {$maximumpc1 > $maximumpc2} {
            set blup [expr {300.0 * $maximumpc2 / $maximumpc1}]
            set xgauche 100
            set plic [expr {(400 - $blup) / 2}]
            $c create line 100 [expr {400 - $plic}] 400 [expr {400 - $plic}] \
                    -width 1 -tag axe_x
            ##### axe des x croit de g a droite (procedure NUMIND)
            $c create line 100 [expr {400 - $plic}] 100 [expr {(400 - $plic - $blup)}] \
                    -width 1 -tag axe_y
            ##### axe des y decroit de bas en ht
            set corry [expr ($blup/$maximumpc2)]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {100 + ($i*30)}]
                $c create line $x [expr {400 - $plic}] $x [expr {395 - $plic}] -width 1 -tag axe_x
                ##### subdividions sur l'axe des x
            }
            set hauteurY $blup
            set subdivisionY [expr {$hauteurY / 10}]
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {400 - $plic - ($i * $subdivisionY)}]
                $c create line 100 $y 105 $y -width 1 -tag axe_y
                ##### subdividions sur l'axe des y
            }
        } else {
            set blup [expr {300.0 * $maximumpc1 / $maximumpc2}]
            set plic  50
            set ploc [expr {(450 - $blup) / 2}]
            set xgauche [expr {450 - $ploc - $blup}]
            $c create line [expr {450 - $ploc - $blup}] 350 [expr {450 - $ploc}] 350 \
                    -width 2 -tag axe_x
            ##### axe des x croit de g a droite (procedure NUMIND)
            $c create line [expr {450 - $ploc - $blup}] 350 [expr {450 - $ploc - $blup}] 50 \
                    -width 2 -tag axe_y
            ##### axe des y croit de ht en bas
            set corrx [expr {($blup / $maximumpc1)}]
            
            set longueurX $blup
            set subdivisionX [expr {$longueurX / 10}]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {(450 - $ploc - $blup) + ($i * $subdivisionX)}]
                $c create line $x 350 $x 345 -width 2 -tag axe_x
                ##### subdividions sur l'axe des x
            }
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {350 - ($i * 30)}]
                $c create line $xgauche $y [expr {$xgauche + 5}] $y -width 2 -tag axe_y
                ##### subdividions sur l'axe des y
            }
        }
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update
    set textFont {Helvetica 8}
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr {$sumpc1 + [lindex $pc1 $i] } ]
    }
    set moypc1 [expr {$sumpc1 * 1.0 / $npc}]
    set minMpc1 [expr {$minpc1 - $moypc1}]
    set maxMpc1 [expr {$maxpc1 - $moypc1}]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr {$sumpc2 + [lindex $pc2 $i] } ]
    }
    set moypc2 [expr {$sumpc2 * 1.0 / $npc}]
    set minMpc2 [expr {$minpc2 - $moypc1}]
    set maxMpc2 [expr {$maxpc2 - $moypc1}]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    
    set tc "Factor 1 = desde $minF1  a  $maxF1  -  Factor 2 = desde $minF2  a  $maxF2"
    $c create text 45 375 -text "$tc ($verjpd)" -font $textFont -anchor w -fill black
    $c create text 45 425 -text $references -font "Courrier 9" -anchor w -fill red -tag data_info
    $c itemconfigure data_info -width 450
    
    ########################################################################
    # S'il n'y a que deux groupes, et s'il s'agit d'une AD
    # signaler que le facteur 2 est une plaisanterie
    set iciFont "Helvetica 10"
    if {[info exists gr]} {
        if {$gr == 2} {
            if {[info exists pad]} {
                if  {[info exists lm] == 0} {
                    update
                    set c .plottnumind.c
                    set lc [$c find withtag axe_y]
                    foreach item $lc {$c delete $item}
                    $c create text 260 10 -text "El segundo factor (vertical) no es valido" \
                            -anchor n -font "Helvetica 18" -fill red
                }
            }
        }
    }
    ########################################################################
    
    
    set long [llength $individuscentPC1]
    set coul 0
    set quidam 0
    #chull
    # Si le bouton CHULL est active
    if {[info exists effectifs]} {
        if {[llength $effectifs] > 1} {
            set legion [lindex $effectifs $coul]
            set canvas_g ""
        }
    }
    
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        # Si le bouton CHULL est active
        if {[info exists effectifs]} {
            if {[llength $effectifs] > 1} {
                if {$quidam > $legion} {
                    #chull
                    set convexhulls [env::chull $canvas_g]
                    $c create line $convexhulls  -fill red -tag all
                    set canvas_g ""
                    incr coul
                    incr legion [lindex $effectifs $coul]
                }
            }
        }
        # BOUTON chull, fin
        set indpc1 [ lindex $individuscentPC1 $i ]
        set indpc2 [ lindex $individuscentPC2 $i ]
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        #set item [$c create oval [expr {$x-1}] [expr {$y-1}] [expr {$x+1}] [expr {$y+1}] \
        #        -width 1 -outline black]
        $c create text [expr $x+7] $y -text $quidam -anchor n -font "Helvetica 8"
        #$c addtag point withtag $item
        # chull
        append canvas_g "$x $y "
    }
    #---------- Fin des numeros individuels
    if {[info exists effectifs]} {
        if {[llength $effectifs] > 1} {
            set convexhulls [env::chull $canvas_g]
            $c create line $convexhulls -fill red -tag all
            set canvas_g ""
        }
    }
}
####################numind######## PROCEDURE ## FIN ###

#################### subextractcol ######## PROCEDURE ## DEBUT ##
proc subextractcol {individus} {
    global lm lignes effectifs references adda_lignes
    
    destroy .subd
    set fen .subd
    catch {destroy $fen}
    toplevel $fen
    wm geometry $fen 220x90+280+380
    if {[info exists effectifs] == 1} {
        if {[info exists adda_lignes]} {lappend effectifs $adda_lignes}
        wm title $fen "$effectifs"
    } else  {
        wm title $fen "$lignes indiv."
    }
    wm iconname $fen "Subdivisions"

    
    entry .subd.entree -background white -textvariable valeurs
    button .subd.bouton -background black -foreground white \
            -text "Enter group sizes separated \nby a space,\
            \nthen press me" \
            -font "Helvetica 10" \
            -command {
                global effectifs
                if {[info exists effectifs]} {set oldeff $effectifs}
                if {[info exists lm] == 1} {
                    set neweff ""
                    foreach item $effectifs {
                        lappend neweff [expr $item * $lm]
                    }
                    set oldeff $neweff
                }
                if {$valeurs == ""} {
                    set valeurs [string trim $oldeff]
                    set valeurs [tremplincol $valeurs]
                } else  {
                    set valeurs [string trim $valeurs];
                    set valeurs [tremplincol $valeurs]
                }
            }
    pack  .subd.entree .subd.bouton
}
####################subextractcol######## PROCEDURE ## FIN ###


####################subextractgro######## PROCEDURE ## DEBUT ###
proc subextractgro {individus} {
    global lm lignes effectifs references adda_lignes
    destroy .subd
    toplevel .subd
    set fen .subd
    catch {destroy $fen}
    toplevel $fen
    wm geometry $fen 170x90+330+380
    if {[info exists effectifs] == 1} {
        if {[info exists adda_lignes]} {lappend effectifs $adda_lignes}
        wm title $fen "$effectifs"
    } else  {
        wm title $fen "$lignes indiv."
    }
    wm iconname $fen "Subdivisions"
    
    set appel [entry .subd.entree -background white -textvariable valeurs]
    set commando [button .subd.bouton -background grey25 -foreground white \
            -text "Enter group sizes separated \nby a space, \
            \nthen press me" \
            -font "Helvetica 10" \
            -command {
                global effectifs
                if {[info exists effectifs]} {set oldeff $effectifs}
                if {[info exists lm] == 1} {
                    set neweff ""
                    foreach item $effectifs {
                        lappend neweff [expr $item * $lm]
                    }
                    set oldeff $neweff
                }
                if {$valeurs == ""} {
                    set valeurs [string trim $oldeff]
                    set valeurs [tremplingro $valeurs]
                } else  {
                    set valeurs [string trim $valeurs];
                    set valeurs [tremplingro $valeurs]
                }
            }
    ]
    pack  $appel $commando
}
####################subextractgro######## PROCEDURE ## FIN ###


####################tremplincol######## PROCEDURE ## DEBUT ###
proc tremplincol {valeurs} {
    global individus references adda_lignes lignes
    colore $valeurs $individus
}
####################tremplincol######## PROCEDURE ## FIN ###


####################tremplingro######## PROCEDURE ## DEBUT ###
proc tremplingro {valeurs} {
    global individus references
    numgroup $valeurs $individus
}
####################tremplingro######## PROCEDURE ## FIN ###


######################## PROCEDURE colore #### DEBUT###
proc colore {effectifs points args} {
    # Cette procedure est appelee par trempincol ou par MOG - va de 557 à 1340 !
    #
    # Il y a des ditinctions en fonction de la procédure qui appelle
    # - si c'est MOG qui appelle ... cfr lignes 753 a 942 et 1144 a 1275
    #
    global effectifs_colore individus_colore references
    global adda adda_lignes lignes
    
    set effectifs_colore $effectifs
    set individus_colore $points
    # Cette procedure est appelee par tremplincol $valeurs $individus
    # valeurs devient la variable effectifs -> effectifs_colore
    # individus devient la variable points -> individus_colore -> individus
    # (mais celle-ci redevient individus ensuite, bref que du simple)
    destroy .subd .plottcolore
    global  p lm gr pad verjpd polygone lignes individus coul
    global suit_rot suit_cons consensus objet_cons susnesnoc
    global individuscentPC1 individuscentPC2 xgauche corrx corry plic c
    #debug
    #puts $individuscentPC1
    # points redevient individus
    set individus $points
    #--------------------------------------------------------------------
    # Cette procedure peut aussi etre appelee par MOG
    # Si ce n'est PAS le programme MOG qui appelle ...
    # Assigner AU HASARD des couleurs differentes a chaque groupe
    # -----------------------------------------------------------
    global gilimana
    set gilimana ""
    if {[info exists lm] == 0} {
        set coul 0
        foreach item [split $effectifs] {
            set rcol [expr {int(rand() * 65535)}]
            set gcol [expr {int(rand() * 65535)}]
            set bcol [expr {int(rand() * 65535)}]
            set name($coul) [format "#%.4x%.4x%.4x" $rcol $gcol $bcol]
            lappend gilimana $name($coul)
            incr coul
        }
    } else {
        global name
    }
    
    # VALEUR MINIMUM de l'abscisse
    # -----------------------------
    set ordre {}
    foreach item $individus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    set ordre [lsort -real $ordre]
    set minimumpc1 [lindex $ordre 0]
    ## ajout August 2002
    set minpc1 $minimumpc1
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de l'ordonnee
    # -----------------------------
    set ordre {}
    foreach item $individus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    set ordre [lsort -real $ordre]
    set minimumpc2 [lindex $ordre 0]
    ## ajout August 2002
    set minpc2 $minimumpc2
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # CENTRAGE DES VALEURS SUR ZERO pour l'abscisse
    # ---------------------------------------------
    set individuscentPC1 ""
    foreach item $individus {
        set somme {}
        lappend somme [expr {[lindex $item 3] - $minimumpc1}]
        lappend individuscentPC1 $somme
    }
    
    # CENTRAGE DES VALEURS SUR ZERO pour l'ordonnee
    # ---------------------------------------------
    set individuscentPC2 ""
    foreach item $individus {
        set somme {}
        lappend somme [expr {[lindex $item 4] - $minimumpc2}]
        lappend individuscentPC2 $somme
    }
    
    # VALEUR MAXIMUM l'abscisse centree
    # -----------------------------------
    set ordre [lsort -real $individuscentPC1]
    set maximumpc1 [lindex $ordre end]
    ## ajout August 2002
    set maxpc1centre $maximumpc1
    set minpc1centre [lindex $ordre 0]
    
    # VALEUR MAXIMUM DE l'ordonnee centree
    # -------------------------------------
    set ordre [lsort -real $individuscentPC2]
    set maximumpc2 [lindex $ordre end]
    ## ajout August 2002
    set maxpc1centre $maximumpc2
    set minpc2centre [lindex $ordre 0]
    
    set corrx [expr {300.0/$maximumpc1}]
    set corry [expr {300.0/$maximumpc2}]
    
    #################################################
    # preparation du graphique de la procedure COLORE
    #################################################
    
    set w .plottcolore
    catch {destroy $w}
    toplevel $w
    wm geometry $w 550x485+205+10
    # Adapter le titre de .plottcolore selon la procedure qui appelle, tremplincol ou mog
    if {[info exists lm] == 0} {
        wm title $w "X = factor 1, Y = factor 2"
    } else  {
        wm title $w "Cada individuo esta compuesto de $lm puntos (landmarks)"
    }
    
    wm iconname $w "X = factor 1, Y = factor 2"
    
    set c $w.c ; # donc c = .plottcolore.c
    
    set Font {Helvetica 10}
    
    # Une frame pour les boutons
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    
    # Boutons quand la procedure n'est pas appelee par MOG
    button $w.buttons.zoom -text "Z" -command {
        set w .plottcolore
        $w.buttons.gris configure -state disabled
        $w.buttons.colgr configure -state disabled
        $w.buttons.jepeins configure -state disabled
        $w.buttons.color configure -state disabled
        
        set c .plottcolore.c
        $c scale all 0 0 1.5 1.5
        set lc [$c find withtag zou]
        foreach item $lc {
            set x [lindex [$c coords $item] 0]
            set y [lindex [$c coords $item] 1]
            $c create oval $x [expr {$y-10}] [expr {$x+10}] $y \
                    -fill [lindex [$c itemconfigure $item -fill ] end] -outline black -tag zou
            $c delete $item
        }
        $c configure -scrollregion [$c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    }
    
    button $w.buttons.colgr -text "OG" -bg red -fg white \
            -command "subextractcol {$individus}"
    button $w.buttons.color -text "Otros Colores ?" -bg red -fg white\
            -command "colore {$effectifs} {$individus}"
    button $w.buttons.gris -text "TG" -bg red -fg white\
            -command "gris {$effectifs} {$individus}"
    button $w.buttons.jepeins -text "SC" -bg red -fg white\
            -command "jecolore {$effectifs} {$individus}"
    button $w.buttons.cancel -text "Volver" -command {
        destroy .plottcolore
        set polygone 0
        dessine $individus
    }
    button $w.buttons.ps -text "Guardar (.eps)" -bg white -command {
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottcolore.c postscript]
        close $outputGraphe
    }
    
    # Si c'est MOG qui appelle ... on place differents boutons ----------------
    #
    if  {[info exists lm] == 1} {
        
        button $w.buttons.coloriage -text "SC" -bg white -fg green\
                -command {
                    # Changement des couleurs de cette session
                    global name coul consensus polygone individus neweff aveff suit_cons lignes
                    set coul 0
                    set consensus 0
                    set suit_cons 0
                    set lc [$c find withtag zou]
                    # Appel a la procedure tupeins pour choisir des couleurs
                    #
                    
                    #
                    tupeins $neweff $individus
                }
        
        
        
        button $w.buttons.zoomog -text "Z" -command {
            # drapeau (2 lignes) pour le bouton 'exit'
            global zoomog
            set zoomog 1
            set w .plottcolore
            $w.buttons.connect configure -state disabled
            $w.buttons.col configure -state disabled
            set c .plottcolore.c
            $c scale all 0 0 1.5 1.5
            set lc [$c find withtag zou]
            $c configure -scrollregion [$c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
        }
        
        button $w.buttons.exit -text "X" -command {
            global lm zoomog effectifs_colore individus_colore susnesnoc
            if  {[info exists lm] == 1} {
                if {[info exists zoomog] == 1} {
                    unset zoomog
                    set polygone 0
                    set consensus 0
                    set susnesnoc 1
                    colore $effectifs_colore $individus_colore
                } else  {
                    # permettre de revoir le consensus
                    global consensus objet_cons
                    if {$consensus == 0} {
                        #debug
                        #puts "consensus ETAIT $consensus, susnesnoc ETAIT $susnesnoc"
                        if {[info exists objet_cons]} {
                            global polygone consensus susnecnoc
                            set polygone 0
                            set susnesnoc 1
                            #debug
                            #puts "consensus DEVENU $consensus \tOBJET_CONS = \t$objet_cons \tsusnesnoc DEVENU $susnesnoc"
                            colore $effectifs_colore $individus_colore
                        }
                    } else  {
                        global polygone consensus susnecnoc
                        set polygone 0
                        set consensus 0
                        set susnesnoc 1
                        colore $effectifs_colore $individus_colore
                    }
                }
            } else  {
                global polygone consensus susnecnoc
                destroy .plottcolore
                set polygone 0
                set consensus 0
                set susnesnoc 0
            }
            
        }
        
        button $w.buttons.cons -bg "light yellow" -fg green -text "Consensus ?" \
                -command {
                    if {[info exists objet_cons]} {
                        global consensus polygone neweff suit_cons name
                        global yesno suit_rot objet_cons coul etiquettes
                        set polygone 0
                        set consensus 1
                        #debug
                        #puts "proc colore button consensus: suit_rot == $suit_rot should be 1 ???"
                        #puts "button consensus: susnesnoc == $susnesnoc should be 1 ???"
                        if {$suit_rot == 1} {
                            if  {$susnesnoc == 1} {
                                if {[info exists yesno]} {
                                    if {$yesno == 1} {set yesno 0; .buttons.rotation invoke} else {set yesno 1}
                                } else  {
                                    set yesno 1
                                }
                                colore $neweff $individus
                            }
                        }
                    } else  {
                        meunon "Despues de la rotacion, pf\nAfter rotation, please."
                    }
                    
                }
        
        button $w.buttons.avo -bg "light yellow" -fg green -text "Mean objects ?" \
                -command {
                    global individus
                    if {[info exists individus]} {
                        global consensus neweff objet_cons coul suit_cons \
                        name etiquettes
                        global lm polygone lignes effectifs indivmoy lignes
                        set polygone 1
                        set consensus 0
                        set lon [llength $individus]
                        # debug
                        # $p insert end "\nbouton.avo il y a $lon points ...\t et les effectifs actuels sont\
                        #        \n$effectifs"
                        
                        # De {2 1 2 10 20} {2 1 2 11 21} {2 1 2 9 19} etc a 10 20 11 21 9 19 etc.
                        set preavo ""
                        for  {set i 0} {$i < $lon} {incr i} {
                            set landmark [lindex $individus $i]
                            append preavo "[lrange $landmark 3 end] "
                        }
                        
                        # Decoupage de la nouvelle matrice en groupes
                        set compteur 0
                        set boulier 0
                        foreach item $effectifs {
                            set groupe($boulier) \
                            [lrange $preavo $compteur [expr {$compteur + $item * 2 * $lm - 1}]]
                            incr compteur [expr {$item * 2 * $lm}]
                            incr boulier
                        }
                        
                        # Decoupage de chaque groupe en individus MOYENS (avec chacun lm landmarks)
                        set groupes [llength $effectifs]
                        set proavo ""
                        set avo ""
                        for  {set i 0} {$i < $groupes} {incr i} {
                            set llignes [lindex $effectifs $i]
                            set preavo $groupe($i)
                            for  {set j 0} {$j < [expr {$llignes * $lm * 2}]} {incr j [expr {$lm * 2}]} {
                                append proavo "[lrange $preavo $j [expr {$j + $lm * 2 - 1}]] "
                            }
                            set proavo [concat "2 $llignes [expr {$lm * 2}] " $preavo]
                            set protoavo [mnorms $proavo]
                            set paravo [lrange $protoavo 3 [expr 3+$lm*2-1]]
                            #$p insert end "\nFormation des "individus" (les points du graphique)"
                            set n [llength $paravo]
                            for  {set k 0} {$k < $n} {incr k 2} {
                                set item [lrange $paravo $k [expr {$k + 1}]]
                                lappend avo "2 1 2 $item"
                            }
                        }
                        
                        set lignes $groupes
                        # informe
                        if {[info exists indivmoy]} {
                            if {$indivmoy == 0} {
                                $p insert end "\n\nCONFIGURACIONES MEDIAS\n"
                                set compteur -1
                                foreach item $avo {
                                    incr compteur
                                    $p insert end "\n[show $item]"
                                    if {$compteur > 11} {set compteur -1;$p insert end "\n\n"}
                                }
                            }
                        }
                        set aveff ""
                        foreach item $effectifs {lappend aveff $lm}
                        # debug
                        # $p insert end "\nICI LE BOUTON avo MEANOBJECTS ....\nLA COMMANDE EST CELLE DE\
                        #            \n[llength $avo] POINTS\tavec EFFECTIFS $aveff"
                        set indivmoy 1
                        # Appel a la procedure colmoy pour s'occuper des configurations moyennes
                        colmoy $aveff $avo
                    }
                }
        
        button $w.buttons.connect -bg "light yellow" -fg green -text "Conectar ?" \
                -command {
                    global polygone suit_cons individus neweff aveff consensus coul name nosi
                    if {[info exists objet_cons]} {global objet_cons}
                    if {[info exists nosi]} {
                        if {$nosi == 1} {set nosi 0} else {set nosi 1}
                    } else  {
                        set nosi 1
                    }
                    set consensus 0
                    set suit_cons 0
                    set polygone 1
                    # Appel a la procedure connecte pour les connections d'Imhotep
                    connecte $neweff $individus
                }
        
        button $w.buttons.col -background "light yellow" -foreground green -text "Color" \
                -command {
                    
                    # Changement des couleurs de cette session
                    global name coul consensus polygone individus neweff aveff suit_cons lignes
                    
                    #debug
                    #puts "Procedure COLORE, Bouton 'Color': $name (ligne 953)"
                    
                    set coul 0
                    set consensus 0
                    set suit_cons 0
                    set lc [$c find withtag zou]
                    # Appel a la procedure tucolore pour redonner des couleurs
                    puts "on est ici ?"
                    tucolore $neweff $individus
                }
        balloonhelp_for $w.buttons.zoomog "zoom ?"
    }
    #
    # Si c'est MOG qui appelle ... FIN --------------------------------
    
    
    if {[llength $effectifs] < 8} {
        if {[info exists lm] == 0} {
            pack $w.buttons.ps $w.buttons.colgr $w.buttons.color \
                    $w.buttons.gris $w.buttons.jepeins $w.buttons.zoom \
                    $w.buttons.cancel -side left -expand 1
        } else {
            pack $w.buttons.ps $w.buttons.connect $w.buttons.col $w.buttons.coloriage\
                    $w.buttons.cons $w.buttons.avo $w.buttons.zoomog \
                    $w.buttons.exit -side left -expand 1
        }
    } else  {
        if {[info exists lm] == 0} {
            pack $w.buttons.ps $w.buttons.colgr $w.buttons.color \
                    $w.buttons.jepeins $w.buttons.zoom\
                    $w.buttons.cancel -side left -expand 1
        } else {
            pack $w.buttons.ps $w.buttons.connect $w.buttons.col $w.buttons.coloriage $w.buttons.cons \
                    $w.buttons.avo $w.buttons.zoomog $w.buttons.cancel -side left -expand 1
        }
    }
    
    
    balloonhelp_for $w.buttons.colgr "seleccionar otros grupos ?"
    balloonhelp_for $w.buttons.color "otros colores ?"
    balloonhelp_for $w.buttons.gris "tonos de gris ?"
    balloonhelp_for $w.buttons.jepeins "seleccionar los colores ?"
    balloonhelp_for $w.buttons.coloriage "seleccionar los colores ?"
    balloonhelp_for $w.buttons.zoom "zoom ?"
    
    # On pose a present la toile sur le trepied
    #
    canvas $c -width 450 -height 450 -relief raised -background white -cursor cross\
            -yscrollcommand "$w.v_scroll_tut set" \
            -xscrollcommand "$w.h_scroll_tut set"
    scrollbar $w.v_scroll_tut -command "$c yview"
    scrollbar $w.h_scroll_tut -command "$c xview" -orient horizontal
    pack $w.v_scroll_tut -side right -fill y
    pack $w.h_scroll_tut -side bottom -fill x
    
    pack $c -side top -fill both -expand 1
    
    $c configure -scrollregion [$c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    
    
    set plotFont {Helvetica 12}
    
    ########################################################################
    # Si c'est une AD, on reste carre
    if {[info exists pad]} {
        set blup 300.0
        set xgauche 100
        set plic [expr {(400 - $blup) / 2}]
        $c create line 100 [expr {400 - $plic}] 400 [expr {400 - $plic}] -width 1 -tag axe_x
        ##### axe des x croit de g a droite
        $c create line 100 [expr {400 - $plic}] 100 [expr {(400 - $plic - $blup)}] -width 1 -tag axe_y
        ##### axe des y decroit de bas en ht
        
        set corry [expr $blup/$maximumpc2]
        for {set i 0} {$i <= 10} {incr i} {
            set x [expr {100 + ($i * 30)}]
            $c create line $x [expr {400 - $plic}] $x [expr {395 - $plic}] -width 1 -tag axe_x
        }
        
        set hauteurY $blup
        set subdivisionY [expr {$hauteurY / 10}]
        for {set i 0} {$i <= 10} {incr i} {
            set y [expr {400 - $plic - ($i * $subdivisionY)}]
            $c create line 100 $y 105 $y -width 1 -tag axe_y
        }
        # sinon on devient proportionel
    } else  {
        if {$maximumpc1 > $maximumpc2} {
            set blup [expr {300.0 * $maximumpc2 / $maximumpc1}]
            set xgauche 100
            set plic [expr (400 - $blup)/2]
            if {[info exists lm] == 0} {
                $c create line 100 [expr {400 - $plic}] 400 [expr {400 - $plic}] \
                        -width 1 -tag axe_x
                ##### axe des x croit de g a droite (procedure COLORE)
                $c create line 100 [expr {400 - $plic}] 100 [expr {400 - $plic - $blup}] \
                        -width 1 -tag axe_y
                ##### axe des y decroit de bas en ht
            }
            set corry [expr {$blup / $maximumpc2}]
            if {[info exists lm] == 0} {
                for {set i 0} {$i <= 10} {incr i} {
                    set x [expr {100 + ($i * 30)}]
                    $c create line $x [expr {400 - $plic}] $x [expr {395 - $plic}] -width 1 -tag axe_x
                }
            }
            set hauteurY $blup
            set subdivisionY [expr {$hauteurY / 10}]
            if {[info exists lm] == 0} {
                for {set i 0} {$i <= 10} {incr i} {
                    set y [expr {400 - $plic - ($i * $subdivisionY)}]
                    $c create line 100 $y 105 $y -width 1 -tag axe_y
                }
            }
        } else {
            set blup [expr {300.0 * $maximumpc1 / $maximumpc2}]
            set plic  50
            set ploc [expr {(450 - $blup) / 2}]
            set xgauche [expr {450 - $ploc - $blup}]
            if {[info exists lm] == 0} {
                $c create line [expr {450 - $ploc - $blup}] 350 [expr {450 - $ploc}] 350 \
                        -width 2 -tag axe_x
                ##### axe des x croit de g a droite (procedure COLORE)
                $c create line [expr {450 - $ploc - $blup}] 350 [expr {450 - $ploc - $blup}] 50\
                        -width 2 -tag axe_y
                ##### axe des y decroit de bas en ht
            }
            set corrx [expr {$blup / $maximumpc1}]
            
            set longueurX $blup
            set subdivisionX [expr {$longueurX / 10}]
            if {[info exists lm] == 0} {
                for {set i 0} {$i <= 10} {incr i} {
                    set x [expr {(450- $ploc - $blup) + ($i * $subdivisionX)}]
                    $c create line $x 350 $x 345 -width 2 -tag axe_x
                }
                for {set i 0} {$i <= 10} {incr i} {
                    set y [expr {350 - ($i * 30)}]
                    $c create line $xgauche $y [expr {$xgauche + 5}] $y -width 2 -tag axe_y
                }
            }
        }
    }
    
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update
    set textFont {Helvetica 8}
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr {$sumpc1 + [lindex $pc1 $i]}]
    }
    set moypc1 [expr {$sumpc1 * (1.0 / $npc)}]
    set minMpc1 [expr {$minpc1 - $moypc1}]
    set maxMpc1 [expr {$maxpc1 - $moypc1}]
    for  {set i 0} {$i < $npc} {incr i} {
        set sumpc2 [expr {$sumpc2 + [lindex $pc2 $i]}]
    }
    set moypc2 [expr {$sumpc2 * (1.0 / $npc)}]
    set minMpc2 [expr {$minpc2 - $moypc1}]
    set maxMpc2 [expr {$maxpc2 - $moypc1}]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    if {[info exists lm]} {
        set tc "X = desde $minF1  a  $maxF1\tY = desde $minF2  a  $maxF2"
    } else  {
        set tc "X (Factor I) = desde $minF1  a  $maxF1\tY (Factor II)= desde $minF2  a  $maxF2"
    }
    $c create text 45 375 -text "$tc ($verjpd)" -font $textFont -anchor nw -justify left  -fill black
    $c create text 45 405 -text $references -font "Courrier 9" -anchor nw -justify left  -fill red -tag data_info
    $c itemconfigure data_info -anchor nw -justify left -width 450
    
    ############################################################################
    # S'il ny a que deux groupes pour une AD, signaler que le facteur 2 est une plaisanterie
    if {[info exists lm] == 0} {
        if {[info exists pad]} {
            if {$gr == 2} {
                update
                set c .plottcolore.c
                set lc [$c find withtag axe_y]
                foreach item $lc {$c delete $item}
                $c create text 260 10 -text "El segundo factor (vertical) no es valido" \
                        -anchor n -font "Helvetica 18" -fill red
            }
        }
    }
    ########################################################################
    
    ########################################################################
    # Indiquer sur le cote et dans l'ordre les differentes couleurs choisies
    set coul [llength $effectifs]
    for {set i 0} {$i < $coul} {incr i} {
        set item [$c create oval 40 [expr {60 + ($i * 20)}]  50 [expr {70 + ($i * 20)}]  \
                -width 1 -outline black -fill $name($i) -tag hehe]
        $c addtag point withtag $item
        if  {[info exists lm] == 1} {
            set indic ""
            foreach item $effectifs {lappend indic [expr $item/$lm]}
            #puts "\ncoul $coul\t i $i\teffectifs $effectifs\t item/lm $item/$lm"
            $c create text 20 [expr {56 + ($i * 20)}] -text [lindex $indic $i] -anchor n \
                    -font "helvetica 18"
        } else  {
            $c create text 20 [expr {56 + ($i * 20)}] -text [lindex $effectifs $i] -anchor n \
                    -font "helvetica 18"
        }
    }
    
    
    # Si c'est MOG qui appelle ------------------------------------------------------------
    #
    if {[info exists lm] == 1} {
        
        # Si on veut connecter des points-reperes (bouton conectar active)
        #
        if {[info exists polygone] == 1} {
            # polygone peut etre 0 ou 1
            #debug
            #puts "Colore : lm = $lm ------ polygone = $polygone"
            
            if {$polygone == 1} {
                set coul 0
                set quidam 0
                set neweff ""
                
                foreach item $effectifs {
                    lappend neweff [expr {$item / $lm}]
                }
                
                set newlegion [lindex $neweff $coul]
                set colonnes [expr $lm*2]
                set b 0;# c'est le boulier
                
                for  {set i 0} {$i < $lignes} {incr i} {
                    set trancheX($i) [lrange $individuscentPC1 [expr {$i + $b}] [expr {$i + $b + $lm - 1}]]
                    set trancheY($i) [lrange $individuscentPC2 [expr {$i + $b}] [expr {$i + $b + $lm - 1}]]
                    incr b [expr {$lm - 1}]
                }
                
                for  {set j 0} {$j < $lignes} {incr j} {
                    update; flush stdout
                    set poligono ""
                    
                    for {set i 0} {$i < $lm} {incr i} {
                        set indpc1 [ lindex $trancheX($j) $i ]
                        set indpc2 [ lindex $trancheY($j) $i ]
                        set pointX($i) [expr { $xgauche + ( $corrx * $indpc1 )}]
                        set pointY($i) [expr { 400 - $plic - ( $corry * $indpc2 )}]
                        append poligono "$pointX($i) $pointY($i) "
                    }
                    
                    set retour [lrange $poligono 0 1]
                    append poligono "$retour"
                    incr quidam
                    if {$quidam > $newlegion} {incr coul; incr newlegion [lindex $neweff $coul]}
                    $c create line $poligono -fill $name($coul) -tag imhotep
                }
            }
            # ----- 'if polygone == 1' ----- FIN cfr. 2828
            
            if  {$consensus == 1} {
                # ---------------------------------------------------------------------------
                # Dessiner l'objet consensus - si la rotation a ete faite et le bouton appuye
                # ---------------------------------------------------------------------------
                if  {[info exists objet_cons] == 1} {
                    
                    global yesno
                    
                    # Centrage des valeurs X du consensus sur 0
                    foreach item $objet_cons {
                        set somme ""
                        lappend somme [expr {[lindex $item 3] - $minimumpc1}]
                        lappend objet_consPC1 $somme
                    }
                    
                    # Centrage des valeurs Y du consensus sur 0
                    foreach item $objet_cons {
                        set somme ""
                        lappend somme [expr {[lindex $item 4] - $minimumpc2}]
                        lappend objet_consPC2 $somme
                    }
                    
                    #
                    # Colorier quoi
                    set ovo 3
                    set long [llength $objet_consPC1]
                    
                    for {set i 0} {$i < $long} {incr i} {
                        set indpc1 [ lindex $objet_consPC1 $i ]
                        set indpc2 [ lindex $objet_consPC2 $i ]
                        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
                        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
                        set item [$c create oval [expr {$x+$ovo}] [expr {$y-$ovo}] [expr {$x-$ovo}] \
                                [expr {$y+$ovo}] -width 1 -outline red -tag zou]
                        $c addtag point withtag $item
                    }
                    
                    # connecter les points-reperes de l'objet consensus
                    set tranche_consX [lrange $objet_consPC1 0 $lm]
                    set tranche_consY [lrange $objet_consPC2 0 $lm]
                    update
                    flush stdout
                    set poligono ""
                    
                    for {set i 0} {$i < $lm} {incr i} {
                        set indpc1 [ lindex $tranche_consX $i ]
                        set indpc2 [ lindex $tranche_consY $i ]
                        set pointX($i) [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
                        set pointY($i) [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
                        append poligono "$pointX($i) $pointY($i) "
                    }
                    
                    set retour [lrange $poligono 0 1]
                    append poligono "$retour"
                    #if {$yesno == 1} {set matisse "black"} else {set matisse "white"}
                    set matisse "black"
                    $c create line $poligono -fill $matisse -width 2 -tag imhotep
                    
                    set compteur 0
                    for {set i 0} {$i < 1} {incr i} {
                        incr compteur
                        set indpc1 [ lindex $objet_consPC1 $i ]
                        set indpc2 [ lindex $objet_consPC2 $i ]
                        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
                        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
                        incr compteur
                        $c create text [expr {$x - 45}] [expr {$y - 10}] -text "LM 1 -->" \
                                -anchor n -font "Helvetica 18"
                    }
                    #set consensus 0
                }
                # ---- 'info exists objet_cons' ------------------- F I N -- cfr. 2872
            }
            # ---- 'if consensus == 1' -------------- FIN cfr. 2868
        }
        # ---- 'info exists polygone' ------ FIN -- cfr. 2825
    }
    # ----- 'info exists lm' ------- FIN -- cfr. 2823
    #
    #
    # Si c'est MOG qui appelle -------------------------------------------------------- fin ----
    
    # -------- coloriage des points
    #
    #
    # Si on montre le consensus on efface les boules
    
    if {[info exists consensus] == 1 && $consensus == 1} {
        #debug
        #puts "Consensus == $consensus"
        if  {[info exists objet_cons] == 1} {
            update
            set lc [$c find withtag zou]
            foreach item $lc {$c delete $item}
            set consensus 0
        }
    } else  {
        # Colorier quoi
        set ovo 3
        set long [ llength $individuscentPC1 ]
        set coul 0
        set quidam 0
        set legion [lindex $effectifs $coul]
        set onpresente [lformat %1.3f $individuscentPC1]
        #chull
        set canvas_g ""
        for {set i 0} {$i < $long} {incr i} {
            incr quidam
            if {$quidam > $legion} {
                #chull - pas necessaire si c'est MOG qui appelle
                if {[info exists lm] == 0} {
                    set convexhulls [env::chull $canvas_g]
                    $c create line $convexhulls  -fill $name($coul) -tag all
                    set canvas_g ""
                }
                incr coul
                incr legion [lindex $effectifs $coul]
            }
            #debug
            #puts "On en est AU POINT $quidam, a l'effectif $legion, a la couleur $name($coul)"
            set indpc1 [ lindex $individuscentPC1 $i ]
            set indpc2 [ lindex $individuscentPC2 $i ]
            set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
            set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
            set item [$c create oval [expr {$x-$ovo}] [expr {$y+$ovo}] [expr {$x+$ovo}] [expr {$y-$ovo}]\
                    -width 1 -outline black -fill $name($coul) -tag all]
            $c addtag point withtag $item
            # chull
            append canvas_g "$x $y "
        }
        
        #-----------FIN DU COLORIAGE DES POINTS
        #chull - pas necessaire si c'est MOG qui appelle
        if {[info exists lm] == 0} {
            set convexhulls [env::chull $canvas_g]
            $c create line $convexhulls -fill $name($coul) -tag all
            set canvas_g ""
        }
    }
    ###############################
    # Documentation
    if {[info exists pad]} {
        if {[info exists lm]} {
            bind $c <ButtonPress> { procrustes }
            balloonhelp_for .plottcolore.c "Clic sobre la figura -> etapas y comentarios"
        } else  {
            bind $c <ButtonPress> { discrimine }
            balloonhelp_for .plottcolore.c "Clic sobre la figura -> etapas y comentarios"
        }
    }
}
####################colore######## PROCEDURE ## FIN ####

#################### tucolore ##########
proc tucolore {effectifs individus } {
    
    update
    
    global lm polygone individuscentPC1 individuscentPC2 xgauche corrx corry plic c name consensus
    global lignes nosi
    
    set lc [$c find withtag zou]
    #debug
    #puts "Avant tucolore delete tag: zou =\n$lc"
    foreach item $lc {$c delete $item}
    
    #debug
    #puts "debug tucolore individuscentPC1 $individuscentPC1"
    #puts "Apres tucolore delete tag:zou =\n$lc"
    
    # Colorier quoi
    set ovo 3
    set coul 0
    foreach item [split $effectifs] {
        set rcol [expr {int( rand() * 65535)}]
        set gcol [expr {int( rand() * 65535)}]
        set bcol [expr {int( rand() * 65535)}]
        set name($coul) [format "#%.4x%.4x%.4x" $rcol $gcol $bcol]
        incr coul
    }
    
    ########################################################################
    # Indiquer sur le cote et dans l'ordre les differentes couleurs choisies
    set coul [llength $effectifs]
    for {set i 0} {$i < $coul} {incr i} {
        set item [$c create oval 40 [expr 60 + ($i * 20)]  50 [expr 70 + ($i * 20)]  \
                -width 1 -outline black -fill $name($i)]
        $c addtag point withtag $item
        if  {[info exists lm] == 1} {
            set indic ""
            foreach item $effectifs {lappend indic [expr $item/$lm]}
            $c create text 20 [expr 56 + ($i * 20)] -text [lindex $indic $i] -anchor n \
                    -font "Helvetica 18"
        } else  {
            $c create text 20 [expr 56 + ($i * 20)] -text [lindex $effectifs $i] -anchor n \
                    -font "Helvetica 18"
        }
    }
    ########################################################################
    
    
    set long [llength $individuscentPC1]
    #puts "\nlong = $long"
    set coul 0
    set quidam 0
    set legion [lindex $effectifs $coul]
    set onpresente [lformat %1.3f $individuscentPC1]
    
    #puts "\nlong $long"
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        #puts "Tucolores \nquidam $quidam\nlegion $legion\neffectifs $effectifs \ncoul $coul"
        if {$quidam > $legion} {incr coul; incr legion [lindex $effectifs $coul]}
        set indpc1 [ lindex $individuscentPC1 $i ]
        set indpc2 [ lindex $individuscentPC2 $i ]
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        set item [$c create oval [expr {$x-$ovo}] [expr {$y-$ovo}] [expr {$x+$ovo}] [expr {$y+$ovo}] \
                -width 1 -outline black -fill $name($coul) -tag zou]
        $c addtag point withtag $item
    }
    
    # Si on veut connecter des points-reperes (bouton conectar active)
    if {[info exists lm] == 1} {
        if {[info exists nosi] == 1} {
            if {$nosi == 1} {
                set neweff ""
                foreach item $effectifs {
                    lappend neweff [expr $item/$lm]
                }
                
                set colonnes [expr $lm*2]
                set b 0;# c'est le boulier
                for  {set i 0} {$i < $lignes} {incr i} {
                    set trancheX($i) [lrange $individuscentPC1 [expr $i+$b] \
                            [expr $i+$b+$lm-1]]
                    set trancheY($i) [lrange $individuscentPC2 [expr $i+$b] \
                            [expr $i+$b+$lm-1]]
                    incr b [expr $lm-1]
                }
                set quidam 0
                set coul 0
                set legion [lindex $neweff $coul]
                for  {set j 0} {$j < $lignes} {incr j} {
                    update
                    flush stdout
                    set poligono ""
                    for {set i 0} {$i < $lm} {incr i} {
                        set indpc1 [ lindex $trancheX($j) $i ]
                        set indpc2 [ lindex $trancheY($j) $i ]
                        set pointX($i) [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
                        set pointY($i) [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
                        append poligono "$pointX($i) $pointY($i) "
                    }
                    set retour [lrange $poligono 0 1]
                    append poligono "$retour"
                    incr quidam
                    # debug
                    #puts "Tucolores \nquidam $quidam\nlegion $legion\neffectifs $effectifs \ncoul $coul"
                    if {$quidam > $legion} {incr coul; incr legion [lindex $neweff $coul]}
                    $c create line $poligono -fill $name($coul) -tag imhotep
                }
            }
            # ----dessin de l'objet consensus ------------------- DEBUT
            if  {$consensus == 1} {
                if  {[info exists objet_cons] == 1} {
                    # Centrage des valeurs X du consensus sur 0
                    foreach item $objet_cons {
                        set somme ""
                        lappend somme [expr [lindex $item 3] - $minimumpc1]
                        lappend objet_consPC1 $somme
                    }
                    # Centrage des valeurs X du consensus sur 0
                    foreach item $objet_cons {
                        set somme ""
                        lappend somme [expr [lindex $item 4] - $minimumpc2]
                        lappend objet_consPC2 $somme
                    }
                    # Colorier quoi
                    set ovo 3
                    set long [llength $objet_consPC1]
                    for {set i 0} {$i < $long} {incr i} {
                        set indpc1 [ lindex $objet_consPC1 $i ]
                        set indpc2 [ lindex $objet_consPC2 $i ]
                        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
                        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
                        set item [$c create oval [expr {$x-$ovo}] [expr {$y-10}] [expr {$x+10}] [expr {$x+$ovo}]\
                                -width 1 -outline black -fill white -tag zou]
                        $c addtag point withtag $item
                    }
                    # connecter les points-reperes de l'objet consensus
                    set tranche_consX [lrange $objet_consPC1 0 $lm]
                    set tranche_consY [lrange $objet_consPC2 0 $lm]
                    update
                    flush stdout
                    set poligono ""
                    for {set i 0} {$i < $lm} {incr i} {
                        set indpc1 [ lindex $tranche_consX $i ]
                        set indpc2 [ lindex $tranche_consY $i ]
                        set pointX($i) [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
                        set pointY($i) [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
                        append poligono "$pointX($i) $pointY($i) "
                    }
                    set retour [lrange $poligono 0 1]
                    append poligono "$retour"
                    $c create line $poligono -fill black -tag imhotep
                    
                    set compteur 0
                    for {set i 0} {$i < 1} {incr i} {
                        incr compteur
                        set indpc1 [ lindex $objet_consPC1 $i ]
                        set indpc2 [ lindex $objet_consPC2 $i ]
                        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
                        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
                        incr compteur
                        $c create text [expr $x-30] [expr $y-10] -text "1" \
                                -anchor n -font "Helvetica 18"
                    }
                    set consensus 0
                }
                # ----dessin de l'objet consensus ------------------- F I N
            }
        }
    }
}
######################################### tucolore 


#################### tupeins ##########
#
proc tupeins {effectifs individus } {
    
    update
    
    global lm polygone individuscentPC1 individuscentPC2 xgauche corrx corry plic c name consensus
    global lignes nosi
    
    set lc [$c find withtag zou]
    #debug
    #puts "Avant tupeins delete tag: zou =\n$lc"
    foreach item $lc {$c delete $item}
    
    #debug
    #puts "debug tupeins individuscentPC1 $individuscentPC1"
    #puts "Apres tupeins delete tag:zou =\n$lc"
    
    # Colorier quoi
    set ovo 3
    set coul 0
    ## Ce qui suit permet de choisir des couleurs au hasard (Procedure TUCOLORE)
    # 
    #foreach item [split $effectifs] {
    #    set rcol [expr {int( rand() * 65535)}]
    #    set gcol [expr {int( rand() * 65535)}]
    #    set bcol [expr {int( rand() * 65535)}]
    #    set name($coul) [format "#%.4x%.4x%.4x" $rcol $gcol $bcol]
    #    incr coul
    #}
    
    #
    # Assigner des couleurs differentes a chaque groupe
    # -------------------------------------------------
    set coul 0
    foreach item [split $effectifs] {
        set name($coul) [tk_chooseColor]
        incr coul
    }
    #
    
    ########################################################################
    # Indiquer sur le cote et dans l'ordre les differentes couleurs choisies
    set coul [llength $effectifs]
    for {set i 0} {$i < $coul} {incr i} {
        set item [$c create oval 40 [expr 60 + ($i * 20)]  50 [expr 70 + ($i * 20)]  \
                -width 1 -outline black -fill $name($i)]
        $c addtag point withtag $item
        if  {[info exists lm] == 1} {
            set indic ""
            foreach item $effectifs {lappend indic [expr $item/$lm]}
            $c create text 20 [expr 56 + ($i * 20)] -text [lindex $indic $i] -anchor n \
                    -font "Helvetica 18"
        } else  {
            $c create text 20 [expr 56 + ($i * 20)] -text [lindex $effectifs $i] -anchor n \
                    -font "Helvetica 18"
        }
    }
    ########################################################################
    
    
    set long [llength $individuscentPC1]
    #puts "\nlong = $long"
    set coul 0
    set quidam 0
    set legion [lindex $effectifs $coul]
    set onpresente [lformat %1.3f $individuscentPC1]
    
    #puts "\nlong $long"
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        #puts "Tucolores \nquidam $quidam\nlegion $legion\neffectifs $effectifs \ncoul $coul"
        if {$quidam > $legion} {incr coul; incr legion [lindex $effectifs $coul]}
        set indpc1 [ lindex $individuscentPC1 $i ]
        set indpc2 [ lindex $individuscentPC2 $i ]
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        set item [$c create oval [expr {$x-$ovo}] [expr {$y-$ovo}] [expr {$x+$ovo}] [expr {$y+$ovo}] \
                -width 1 -outline black -fill $name($coul) -tag zou]
        $c addtag point withtag $item
    }
    
    # Si on veut connecter des points-reperes (bouton conectar active)
    if {[info exists lm] == 1} {
        if {[info exists nosi] == 1} {
            if {$nosi == 1} {
                set neweff ""
                foreach item $effectifs {
                    lappend neweff [expr $item/$lm]
                }
                
                set colonnes [expr $lm*2]
                set b 0;# c'est le boulier
                for  {set i 0} {$i < $lignes} {incr i} {
                    set trancheX($i) [lrange $individuscentPC1 [expr $i+$b] \
                            [expr $i+$b+$lm-1]]
                    set trancheY($i) [lrange $individuscentPC2 [expr $i+$b] \
                            [expr $i+$b+$lm-1]]
                    incr b [expr $lm-1]
                }
                set quidam 0
                set coul 0
                set legion [lindex $neweff $coul]
                for  {set j 0} {$j < $lignes} {incr j} {
                    update
                    flush stdout
                    set poligono ""
                    for {set i 0} {$i < $lm} {incr i} {
                        set indpc1 [ lindex $trancheX($j) $i ]
                        set indpc2 [ lindex $trancheY($j) $i ]
                        set pointX($i) [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
                        set pointY($i) [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
                        append poligono "$pointX($i) $pointY($i) "
                    }
                    set retour [lrange $poligono 0 1]
                    append poligono "$retour"
                    incr quidam
                    # debug
                    #puts "Tucolores \nquidam $quidam\nlegion $legion\neffectifs $effectifs \ncoul $coul"
                    if {$quidam > $legion} {incr coul; incr legion [lindex $neweff $coul]}
                    $c create line $poligono -fill $name($coul) -tag imhotep
                }
            }
            # ----dessin de l'objet consensus ------------------- DEBUT
            if  {$consensus == 1} {
                if  {[info exists objet_cons] == 1} {
                    # Centrage des valeurs X du consensus sur 0
                    foreach item $objet_cons {
                        set somme ""
                        lappend somme [expr [lindex $item 3] - $minimumpc1]
                        lappend objet_consPC1 $somme
                    }
                    # Centrage des valeurs X du consensus sur 0
                    foreach item $objet_cons {
                        set somme ""
                        lappend somme [expr [lindex $item 4] - $minimumpc2]
                        lappend objet_consPC2 $somme
                    }
                    # Colorier quoi
                    set ovo 3
                    set long [llength $objet_consPC1]
                    for {set i 0} {$i < $long} {incr i} {
                        set indpc1 [ lindex $objet_consPC1 $i ]
                        set indpc2 [ lindex $objet_consPC2 $i ]
                        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
                        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
                        set item [$c create oval [expr {$x-$ovo}] [expr {$y-10}] [expr {$x+10}] [expr {$x+$ovo}]\
                                -width 1 -outline black -fill white -tag zou]
                        $c addtag point withtag $item
                    }
                    # connecter les points-reperes de l'objet consensus
                    set tranche_consX [lrange $objet_consPC1 0 $lm]
                    set tranche_consY [lrange $objet_consPC2 0 $lm]
                    update
                    flush stdout
                    set poligono ""
                    for {set i 0} {$i < $lm} {incr i} {
                        set indpc1 [ lindex $tranche_consX $i ]
                        set indpc2 [ lindex $tranche_consY $i ]
                        set pointX($i) [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
                        set pointY($i) [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
                        append poligono "$pointX($i) $pointY($i) "
                    }
                    set retour [lrange $poligono 0 1]
                    append poligono "$retour"
                    $c create line $poligono -fill black -tag imhotep
                    
                    set compteur 0
                    for {set i 0} {$i < 1} {incr i} {
                        incr compteur
                        set indpc1 [ lindex $objet_consPC1 $i ]
                        set indpc2 [ lindex $objet_consPC2 $i ]
                        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
                        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
                        incr compteur
                        $c create text [expr $x-30] [expr $y-10] -text "1" \
                                -anchor n -font "Helvetica 18"
                    }
                    set consensus 0
                }
                # ----dessin de l'objet consensus ------------------- F I N
            }
        }
    }
        .buttons.rotation invoke
}
######################################### tupeins



######################## PROCEDURE gris #### DEBUT###
proc gris {effectifs individus args} {
    
    destroy .subd .plotintin
    global gr pad verjpd references
    
    # Assigner des couleurs differentes a chaque groupe
    # -------------------------------------------------
    #set coul 0
    #foreach item [split $effectifs] {
    #    set name($coul) [tk_chooseColor]
    #    incr coul
    #   }
    # Assigner AU HASARD des couleurs differentes a chaque groupe
    # -----------------------------------------------------------
    
    set gris(0) white
    set gris(1) black
    set gris(2) grey91
    set gris(3) grey29
    set gris(4) grey61
    set gris(5) grey44
    set gris(6) grey77
    
    set coul 0
    foreach item [split $effectifs] {
        set name($coul) $gris($coul)
        incr coul
    }
    
    # VALEUR MINIMUM de la 1ere COMPOSANTE PRINCIPALE
    # -----------------------------------------------
    set ordre {}
    foreach item $individus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc1 [lindex $ordre 0]
    ## ajout August 2002
    set minpc1 $minimumpc1
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de la 2eme COMPOSANTE PRINCIPALE
    # (procedure COLORE)
    # -----------------------------------------------
    set ordre {}
    foreach item $individus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc2 [lindex $ordre 0]
    ## ajout August 2002
    set minpc2 $minimumpc2
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # CENTRAGE DES VALEURS SUR ZERO pour PC1
    # --------------------------------------
    
    foreach item $individus {
        set somme {}
        lappend somme [expr [lindex $item 3] - $minimumpc1]
        lappend individuscentPC1 $somme
    }
    
    # CENTRAGE DES VALEURS SUR ZERO pour PC2
    # (procedure COLORE)
    # --------------------------------------
    foreach item $individus {
        set somme {}
        lappend somme [expr [lindex $item 4] - $minimumpc2]
        lappend individuscentPC2 $somme
    }
    
    # VALEUR MAXIMUM DE la 1ere COMPOSANTE PRINCIPALE centree
    # ----------------------------------------------
    set ordre [lsort -real $individuscentPC1]
    set maximumpc1 [lindex $ordre end]
    ## ajout August 2002
    set maxpc1centre $maximumpc1
    set minpc1centre [lindex $ordre 0]
    
    # VALEUR MAXIMUM DE la 2eme COMPOSANTE PRINCIPALE centree
    # ----------------------------------------------
    set ordre [lsort -real $individuscentPC2]
    set maximumpc2 [lindex $ordre end]
    ## ajout August 2002
    set maxpc1centre $maximumpc2
    set minpc2centre [lindex $ordre 0]
    
    set corrx [expr {300.0/$maximumpc1}]
    set corry [expr {300.0/$maximumpc2}]
    
    #################################################
    # preparation du graphique de la procedure COLORE
    #################################################
    
    set w .plotintin
    catch {destroy $w}
    toplevel $w
    wm geometry $w 550x485+205+10
    wm title $w "X = factor 1, Y = factor 2"
    wm iconname $w "X = factor 1, Y = factor 2"
    
    set c $w.c
    
    set Font {Helvetica 10}
    
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    
    button $w.buttons.indiv -background red -foreground white -text "INDIVIDUOS ?" \
            -command "numind {$individus}"
    
    button $w.buttons.cancel -text "Volver" -command "destroy $w"
    
    #button $w.buttons.aide -text "AYUDA" -background white -foreground blue -command "graphelp"
    
    button $w.buttons.ps -bg white -text "guardar" -command {
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile \
                -defaultextension .ps]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plotintin.c postscript]
        close $outputGraphe
    }
    pack $w.buttons.ps $w.buttons.indiv $w.buttons.cancel -side left -expand 1
    
    canvas $c -width 450 -height 450 -relief raised -background "light yellow"; #####-relief raised
    pack $w.c -side top -fill x
    
    set plotFont {Helvetica 12}
    
    
    ########################################################################
    # Si c'est une AD, on reste carre
    if {[info exists pad]} {
        set blup 300.0
        set xgauche 100
        set plic [expr (400 - $blup)/2]
        $c create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] -width 1 ;##### axe des x croit de g a droite (procedure DESSINE)
        $c create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] -width 1 ;##### axe des y decroit de bas en ht
        set corry [expr ($blup/$maximumpc2)]
        for {set i 0} {$i <= 10} {incr i} {
            set x [expr {100 + ($i*30)}]
            $c create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1
        }
        set hauteurY [expr ($blup)]
        set subdivisionY [expr $hauteurY/10]
        for {set i 0} {$i <= 10} {incr i} {
            set y [expr {400 - $plic - ($i*$subdivisionY)}]
            $c create line 100 $y 105 $y -width 1
        }
        # sinon on devient proportionel
    } else  {
        if {$maximumpc1 > $maximumpc2} {
            set blup [expr 300.0 * $maximumpc2/$maximumpc1]
            set xgauche 100
            set plic [expr (400 - $blup)/2]
            $c create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] -width 1 ;##### axe des x croit de g a droite (procedure DESSINE)
            $c create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] -width 1 ;##### axe des y decroit de bas en ht
            set corry [expr ($blup/$maximumpc2)]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {100 + ($i*30)}]
                $c create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1
            }
            set hauteurY [expr ($blup)]
            set subdivisionY [expr $hauteurY/10]
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {400 - $plic - ($i*$subdivisionY)}]
                $c create line 100 $y 105 $y -width 1
            }
        } else {
            set blup [expr 300.0 * $maximumpc1/$maximumpc2]
            set plic  50
            set ploc [expr (450 - $blup)/2]
            set xgauche [expr 450-$ploc-$blup]
            $c create line [expr 450-$ploc-$blup] 350 [expr 450 - $ploc] 350 -width 2 ;##### axe des x croit de g a droite (procedure DESSINE)
            $c create line [expr 450-$ploc-$blup] 350 [expr 450-$ploc-$blup] 50 -width 2 ;##### axe des y decroit de bas en ht
            set corrx [expr ($blup/$maximumpc1)]
            
            set longueurX [expr ($blup)]
            set subdivisionX [expr $longueurX/10]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {(450-$ploc-$blup) + ($i*$subdivisionX)}]
                $c create line $x 350 $x 345 -width 2
            }
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {350 - ($i*30)}]
                $c create line $xgauche $y [expr $xgauche + 5] $y -width 2
            }
        }
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update
    set textFont {Helvetica 8}
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr $sumpc1 + [lindex $pc1 $i]]
    }
    set moypc1 [expr $sumpc1 * 1.0/$npc]
    set minMpc1 [expr $minpc1 - $moypc1]
    set maxMpc1 [expr $maxpc1 - $moypc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr $sumpc2 + [lindex $pc2 $i]]
    }
    set moypc2 [expr $sumpc2 * 1.0/$npc]
    set minMpc2 [expr $minpc2 - $moypc1]
    set maxMpc2 [expr $maxpc2 - $moypc1]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    
    set tc "Factor 1 = desde $minF1  a  $maxF1  -  Factor 2 = desde $minF2  a  $maxF2"
    $c create text 45 375 -text "$tc ($verjpd)" -font $textFont -anchor nw -justify left  -fill black
    $c create text 45 425 -text $references -font "Courrier 9" -anchor nw -justify left  -fill red -tag data_info
    $c itemconfigure data_info -anchor nw -justify left -width 450
    
    ############################################################################
    # S'il ny a que deux groupes, signaler que le facteur 2 est une plaisanterie
    if {[info exists pad]} {
        update
        if {$gr == 2} {$c create text 260 10 \
                    -text "El segundo factor (vertical) no es valido" -anchor n -font $textFont}
    }
    ########################################################################
    
    ########################################################################
    # Indiquer sur le cote et dans l'ordre les differentes couleurs choisies
    
    for {set i 0} {$i < $coul} {incr i} {
        set item [$c create oval 40 [expr 60 + ($i * 20)]  50 [expr 70 + ($i * 20)]  \
                -width 1 -outline black -fill $name($i)]
        $c addtag point withtag $item
        $c create text 20 [expr 56 + ($i * 20)] -text [lindex $effectifs $i] -anchor n \
                -font $plotFont
    }
    
    ########################################################################
    # Colorier quoi
    #debug
    #puts "debug gris individuscentPC1 $individuscentPC1"
    set ovo 3
    set long [llength $individuscentPC1]
    set coul 0
    set quidam 0
    set legion [lindex $effectifs $coul]
    #chull
    set canvas_g ""
    
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        if {$quidam > $legion} {
            #chull
            set convexhulls [env::chull $canvas_g]
            $c create line $convexhulls  -fill black -tag all
            set canvas_g ""
            incr coul
            incr legion [lindex $effectifs $coul]
        }
        #puts "\nOn en est a l'individu $quidam, a l'effectif $legion et a la couleur $name($coul)"
        set indpc1 [ lindex $individuscentPC1 $i ]
        set indpc2 [ lindex $individuscentPC2 $i ]
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        set item [$c create oval [expr {$x-$ovo}] [expr {$y+$ovo}] [expr {$x+$ovo}] [expr {$y-$ovo}] \
                -width 1 -outline black -fill $name($coul)]
        $c addtag point withtag $item
        # chull
        append canvas_g "$x $y "
    }
    #----------- fin de la grisaille
    set convexhulls [env::chull $canvas_g]
    $c create line $convexhulls -fill black -tag all
    set canvas_g ""
}

#################### gris ######## PROCEDURE ## FIN ####



######################## PROCEDURE je colore #### DEBUT###
proc jecolore {effectifs individus args} {
    
    destroy .subd
    global gr pad verjpd references
    
    # Assigner des couleurs differentes a chaque groupe
    # -------------------------------------------------
    set coul 0
    foreach item [split $effectifs] {
        set name($coul) [tk_chooseColor]
        incr coul
    }
    
    # VALEUR MINIMUM de la 1ere COMPOSANTE PRINCIPALE
    # -----------------------------------------------
    set ordre {}
    foreach item $individus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc1 [lindex $ordre 0]
    ## ajout August 2002
    set minpc1 $minimumpc1
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de la 2eme COMPOSANTE PRINCIPALE
    # (procedure COLORE)
    # -----------------------------------------------
    set ordre {}
    foreach item $individus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc2 [lindex $ordre 0]
    ## ajout August 2002
    set minpc2 $minimumpc2
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # CENTRAGE DES VALEURS SUR ZERO pour PC1
    # --------------------------------------
    
    foreach item $individus {
        set somme {}
        lappend somme [expr [lindex $item 3] - $minimumpc1]
        lappend individuscentPC1 $somme
    }
    #debug
    #puts "debug jecolore individuscentPC1 $individuscentPC1"
    
    # CENTRAGE DES VALEURS SUR ZERO pour PC2
    # (procedure COLORE)
    # --------------------------------------
    foreach item $individus {
        set somme {}
        lappend somme [expr [lindex $item 4] - $minimumpc2]
        lappend individuscentPC2 $somme
    }
    
    # VALEUR MAXIMUM DE la 1ere COMPOSANTE PRINCIPALE centree
    # ----------------------------------------------
    set ordre [lsort -real $individuscentPC1]
    set maximumpc1 [lindex $ordre end]
    ## ajout August 2002
    set maxpc1centre $maximumpc1
    set minpc1centre [lindex $ordre 0]
    
    # VALEUR MAXIMUM DE la 2eme COMPOSANTE PRINCIPALE centree
    # ----------------------------------------------
    set ordre [lsort -real $individuscentPC2]
    set maximumpc2 [lindex $ordre end]
    ## ajout August 2002
    set maxpc1centre $maximumpc2
    set minpc2centre [lindex $ordre 0]
    
    set corrx [expr {300.0/$maximumpc1}]
    set corry [expr {300.0/$maximumpc2}]
    
    #################################################
    # preparation du graphique de la procedure COLORE
    #################################################
    
    catch {destroy .plottjecolore}
    set w .plottjecolore
    toplevel $w
    wm geometry $w 550x485+205+10
    wm title $w "X = factor 1, Y = factor 2"
    wm iconname $w "X = factor 1, Y = factor 2"
    
    set c $w.c
    
    set Font {Helvetica 10}
    
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    
    button $w.buttons.colgr -text "Otros\nGRUPOS ?" -bg red -fg white\
            -command "subextractcol {$individus}"
    
    button $w.buttons.color -text "Otros\nCOLORES ?" -bg red -fg white\
            -command "colore {$effectifs} {$individus}"
    
    button $w.buttons.gris -text "Tonos de\nGRIS ?" -bg red -fg white\
            -command "gris {$effectifs} {$individus}"
    
    button $w.buttons.cancel -text "Volver\n "\
            -command "destroy $w"
    
    button $w.buttons.ps -text "Guardar\n(formato .ps)" -bg white \
            -command {
                # NAME THE FILE
                set file_types {
                    {"All Files" * }
                }
                
                global infile
                set dirinfile "[file dirname $infile]/";#repertoire des donnees
                #debug
                #puts "chemin = $dirinfile"
                set tailfile [file tail $infile];#fichier nu, avec l'extension
                #debug
                #puts "\ntail = $tailfile"
                set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
                #debug
                #puts "root = $rootfile"
                set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile \
                -defaultextension .ps]
                wm title . $filename
                # OPEN THE FILE
                set outputGraphe [open $filename w]
                puts -nonewline $outputGraphe [.plottjecolore.c postscript]
                close $outputGraphe
            }
    
    if {[llength $effectifs] < 7} {
        pack $w.buttons.ps $w.buttons.colgr $w.buttons.color \
                $w.buttons.gris \
                $w.buttons.cancel -side left -expand 1
    } else  {
        pack $w.buttons.ps $w.buttons.colgr $w.buttons.color \
                $w.buttons.cancel \
                -side left -expand 1
    }
    
    #canvas $c -width 450 -height 450 -relief raised -background white
    canvas $c -relief raised -background white
    pack $w.c -side top -fill both -expand 1
    
    set plotFont {Helvetica 12}
    
    ########################################################################
    # Si c'est une AD, on reste carre
    if {[info exists pad]} {
        set blup 300.0
        set xgauche 100
        set plic [expr (400 - $blup)/2]
        $c create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] -width 1 ;##### axe des x croit de g a droite (procedure DESSINE)
        $c create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] -width 1 ;##### axe des y decroit de bas en ht
        set corry [expr ($blup/$maximumpc2)]
        for {set i 0} {$i <= 10} {incr i} {
            set x [expr {100 + ($i*30)}]
            $c create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1
        }
        set hauteurY [expr ($blup)]
        set subdivisionY [expr $hauteurY/10]
        for {set i 0} {$i <= 10} {incr i} {
            set y [expr {400 - $plic - ($i*$subdivisionY)}]
            $c create line 100 $y 105 $y -width 1
        }
        # sinon on devient proportionel
    } else  {
        if {$maximumpc1 > $maximumpc2} {
            set blup [expr 300.0 * $maximumpc2/$maximumpc1]
            set xgauche 100
            set plic [expr (400 - $blup)/2]
            $c create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] -width 1 ;##### axe des x croit de g a droite (procedure DESSINE)
            $c create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] -width 1 ;##### axe des y decroit de bas en ht
            set corry [expr ($blup/$maximumpc2)]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {100 + ($i*30)}]
                $c create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1
            }
            set hauteurY [expr ($blup)]
            set subdivisionY [expr $hauteurY/10]
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {400 - $plic - ($i*$subdivisionY)}]
                $c create line 100 $y 105 $y -width 1
            }
        } else {
            set blup [expr 300.0 * $maximumpc1/$maximumpc2]
            set plic  50
            set ploc [expr (450 - $blup)/2]
            set xgauche [expr 450-$ploc-$blup]
            $c create line [expr 450-$ploc-$blup] 350 [expr 450 - $ploc] 350 -width 2 ;##### axe des x croit de g a droite (procedure DESSINE)
            $c create line [expr 450-$ploc-$blup] 350 [expr 450-$ploc-$blup] 50 -width 2 ;##### axe des y decroit de bas en ht
            set corrx [expr ($blup/$maximumpc1)]
            
            set longueurX [expr ($blup)]
            set subdivisionX [expr $longueurX/10]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {(450-$ploc-$blup) + ($i*$subdivisionX)}]
                $c create line $x 350 $x 345 -width 2
            }
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {350 - ($i*30)}]
                $c create line $xgauche $y [expr $xgauche + 5] $y -width 2
            }
        }
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update
    set textFont {Helvetica 8}
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr $sumpc1 + [lindex $pc1 $i]]
    }
    set moypc1 [expr $sumpc1 * 1.0/$npc]
    set minMpc1 [expr $minpc1 - $moypc1]
    set maxMpc1 [expr $maxpc1 - $moypc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr $sumpc2 + [lindex $pc2 $i]]
    }
    set moypc2 [expr $sumpc2 * 1.0/$npc]
    set minMpc2 [expr $minpc2 - $moypc1]
    set maxMpc2 [expr $maxpc2 - $moypc1]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    
    set tc "Factor 1 = desde $minF1  a  $maxF1  -  Factor 2 = desde $minF2  a  $maxF2"
    $c create text 45 425 -text $tc -font $textFont -anchor nw -justify left  -fill black
    $c create text 45 445 -text $verjpd -font $textFont -anchor nw -justify left  -fill red
    $c create text 45 495 -text $references -font "Courrier 9" -anchor nw -justify left  -fill red -tag data_info
    $c itemconfigure data_info -anchor nw -justify left -width 450
    
    ############################################################################
    # S'il ny a que deux groupes, signaler que le facteur 2 est une plaisanterie
    if {[info exists pad]} {
        update
        if {$gr == 2} {$c create text 260 10 \
                    -text "El segundo factor (vertical) no es valido" -anchor n -font $textFont}
    }
    ########################################################################
    
    ########################################################################
    # Indiquer sur le cote et dans l'ordre les differentes couleurs choisies
    
    for {set i 0} {$i < $coul} {incr i} {
        set item [$c create oval 40 [expr 60 + ($i * 20)]  50 [expr 70 + ($i * 20)]  \
                -width 1 -outline black -fill $name($i)]
        $c addtag point withtag $item
        $c create text 20 [expr 56 + ($i * 20)] -text [lindex $effectifs $i] -anchor n \
                -font $plotFont
    }
    
    ########################################################################
    # Colorier quoi
    
    set ovo 3
    set long [llength $individuscentPC1]
    set coul 0
    set quidam 0
    set legion [lindex $effectifs $coul]
    #chull
    set canvas_g ""
    
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        if {$quidam > $legion} {
            #chull
            set convexhulls [env::chull $canvas_g]
            $c create line $convexhulls  -fill $name($coul) -tag all
            set canvas_g ""
            incr coul
            incr legion [lindex $effectifs $coul]
        }
        #puts "\nOn en est a l'individu $quidam, a l'effectif $legion et a la couleur $name($coul)"
        set indpc1 [ lindex $individuscentPC1 $i ]
        set indpc2 [ lindex $individuscentPC2 $i ]
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        set item [$c create oval [expr {$x-$ovo}] [expr {$y+$ovo}] [expr {$x+$ovo}] [expr {$y-$ovo}] \
                -width 1 -outline black -fill $name($coul)]
        $c addtag point withtag $item
        append canvas_g "$x $y "
    }
    # Fin du portrait
    set convexhulls [env::chull $canvas_g]
    $c create line $convexhulls -fill $name($coul) -tag all
    set canvas_g ""
}

#################### je colore ######## PROCEDURE ## FIN ####



#################### connecte ######### PROCEDURE ## debut ####
proc connecte {effectifs individus } {
    
    update
    flush stdout
    
    global lm lm_attente polygone individuscentPC1 individuscentPC2 xgauche corrx corry plic c consensus
    global name p nosi lignes
    #debug
    #puts "debug connecte individuscentPC1 $individuscentPC1"
    set ovo 3
    set mmm [llength $individus]
    set lignes [expr $mmm /$lm]
    # debug
    #$p insert end "\nProc connecte : nb points = $mmm\t lm = $lm\t lignes = $lignes"
    
    #-----------------------------------------------------------------------
    # Indiquer sur le cote et dans l'ordre les differentes couleurs choisies
    set coul [llength $effectifs]
    for {set i 0} {$i < $coul} {incr i} {
        set item [$c create oval 40 [expr 60 + ($i * 20)]  50 [expr 70 + ($i * 20)]  \
                -width 1 -outline black -fill $name($i)]
        $c addtag point withtag $item
        if  {[info exists lm] == 1} {
            set indic ""
            foreach item $effectifs {lappend indic [expr $item/$lm]}
            $c create text 20 [expr 56 + ($i * 20)] -text [lindex $indic $i] -anchor n \
                    -font "Helvetica 18"
        } else  {
            $c create text 20 [expr 56 + ($i * 20)] -text [lindex $effectifs $i] -anchor n \
                    -font "Helvetica 18"
        }
    }
    
    if {$nosi == 1} {
        # ----------------------------------------------------------------------------
        # connecter
        set neweff ""
        foreach item $effectifs {
            lappend neweff [expr $item/$lm]
        }
        set colonnes [expr $lm*2]
        set b 0;# c'est le boulier
        for  {set i 0} {$i < $lignes} {incr i} {
            set trancheX($i) [lrange $individuscentPC1 [expr $i+$b] [expr $i+$b+$lm-1]]
            set trancheY($i) [lrange $individuscentPC2 [expr $i+$b] [expr $i+$b+$lm-1]]
            incr b [expr $lm-1]
        }
        set quidam 0
        set coul 0
        set legion [lindex $neweff $coul]
        
        for  {set j 0} {$j < $lignes} {incr j} {
            update
            flush stdout
            set poligono ""
            for {set i 0} {$i < $lm} {incr i} {
                set indpc1 [ lindex $trancheX($j) $i ]
                set indpc2 [ lindex $trancheY($j) $i ]
                set pointX($i) [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
                set pointY($i) [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
                append poligono "$pointX($i) $pointY($i) "
            }
            set retour [lrange $poligono 0 1]
            append poligono "$retour"
            incr quidam
            # debug
            # $p insert end "\nConnecte"
            # $p insert end "\nlignes $lignes\tquidam $quidam\tlegion $legion\teff $effectifs\tcoul $coul"
            if {$quidam > $legion} {incr coul; incr legion [lindex $neweff $coul]}
            #if {$nosi ==1} {set matisse $name($coul)} else {set matisse "white"}
            set matisse $name($coul)
            $c create line $poligono -fill $matisse -tag imhotep
        }
    } else  {
        #debug
        #puts "Effacer les connexions"
        # Effacer les connexions d'imhotep
        set lc [$c find withtag imhotep]
        #debug
        #puts "imhotep = \n$lc"
        foreach item $lc {$c delete $item}
        #set lc [$c find withtag peinture]
        #foreach item $lc {$c delete $item}
    }
}
############################### PROCEDURE connecte #### Fin


############################### PROCEDURE colmoy ###### Debut
proc colmoy {effectifs points args} {
    
    destroy .subd .plottmoy
    global  c p lm gr pad verjpd polygone lignes coul
    global suit_rot suit_cons consensus objet_cons consensus
    
    set indim $points
    # debug
    #$p insert end "\n-----\n\n(Proc colmoy) Il y a [llength $indim] points ('individus')\n"
    #$p insert end "\n----->>> (Proc colmoy) Et voici les effectifs\t$effectifs\n"
    #$p insert end "\nsuit_cons $suit_cons"
    
    global name
    
    # VALEUR MINIMUM de l'abscisse
    # -----------------------------
    set ordre {}
    foreach item $indim {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    set ordre [lsort -real $ordre]
    set minimumpc1 [lindex $ordre 0]
    ## ajout August 2002
    set minpc1 $minimumpc1
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de l'ordonnee
    # -----------------------------
    set ordre {}
    foreach item $indim {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    set ordre [lsort -real $ordre]
    set minimumpc2 [lindex $ordre 0]
    ## ajout August 2002
    set minpc2 $minimumpc2
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # CENTRAGE DES VALEURS SUR ZERO pour l'abscisse
    # ---------------------------------------------
    set indimcentPC1 ""
    foreach item $indim {
        set somme {}
        lappend somme [expr [lindex $item 3] - $minimumpc1]
        lappend indimcentPC1 $somme
    }
    # CENTRAGE DES VALEURS SUR ZERO pour l'ordonnee
    # ---------------------------------------------
    set indimcentPC2 ""
    foreach item $indim {
        set somme {}
        lappend somme [expr [lindex $item 4] - $minimumpc2]
        lappend indimcentPC2 $somme
    }
    # VALEUR MAXIMUM l'abscisse centree
    # -----------------------------------
    set ordre [lsort -real $indimcentPC1]
    set maximumpc1 [lindex $ordre end]
    ## ajout August 2002
    set maxpc1centre $maximumpc1
    set minpc1centre [lindex $ordre 0]
    
    # VALEUR MAXIMUM DE l'ordonnee centree
    # -------------------------------------
    set ordre [lsort -real $indimcentPC2]
    set maximumpc2 [lindex $ordre end]
    ## ajout August 2002
    set maxpc1centre $maximumpc2
    set minpc2centre [lindex $ordre 0]
    
    set corrxm [expr {300.0/$maximumpc1}]
    set corrym [expr {300.0/$maximumpc2}]
    
    #################################
    # Preparation du graphique de la procedure COLMOY
    #################################
    
    set wm .plottmoy
    catch {destroy $wm}
    toplevel $wm
    wm geometry $wm 440x330+370+280
    wm title $wm " O B J E T O S   P R O M E D I O S"
    wm iconname $wm "MOG means"
    
    set cm $wm.c
    
    set Font {Helvetica 10}
    
    frame $wm.buttons
    pack $wm.buttons -side bottom -fill x -pady 2m
    
    button $wm.buttons.cancel -text "Volver / Back" -command {
        destroy .plottmoy
        set polygone 0
    }
    
    button $wm.buttons.zoomoy -text "Z O O M " -command {
        set cm .plottmoy.c
        $cm scale all 0 0 1.5 1.5
        set lc [$cm find withtag zou]
        foreach item $lc {
            set x [lindex [$cm coords $item] 0]
            set y [lindex [$cm coords $item] 1]
            $cm create oval [expr {$x-5}] [expr {$y-5}] [expr {$x+5}] [expr {$y+5}] \
                    -fill [lindex [$cm itemconfigure $item -fill ] end] \
                    -tag zou -tag peinture
            $cm delete $item
        }
        $cm configure -scrollregion [$cm bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    }
    
    button $wm.buttons.ps -text "Guardar / Save (please put .eps extension)" -bg white -command {
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile \
                -defaultextension .ps]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottmoy.c postscript]
        close $outputGraphe
    }
    pack $wm.buttons.zoomoy $wm.buttons.cancel $wm.buttons.ps -side left -expand 1
    
    # On pose a present la toile sur le trepied
    #
    canvas $cm -width 450 -height 450 -relief raised -background white -cursor cross\
            -yscrollcommand "$wm.v_scroll_tut set" \
            -xscrollcommand "$wm.h_scroll_tut set"
    scrollbar $wm.v_scroll_tut -command "$cm yview"
    scrollbar $wm.h_scroll_tut -command "$cm xview" -orient horizontal
    pack $wm.v_scroll_tut -side right -fill y
    pack $wm.h_scroll_tut -side bottom -fill x
    
    pack $wm.c -side top -fill both -expand 1
    
    $c configure -scrollregion [$c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    
    #canvas $cm -width 450 -height 450 -relief raised -background white -cursor dot
    #pack $wm.c -side top -fill x
    
    set plotFont {Helvetica 12}
    
    ########################################################################
    if {$maximumpc1 > $maximumpc2} {
        set blup [expr 300.0 * $maximumpc2/$maximumpc1]
        set xgauchem 100
        set plicm [expr (400 - $blup)/2]
        if {[info exists lm] == 0} {
            $cm create line 100 [expr 400 - $plicm] 400 [expr 400 - $plicm] \
                    -width 1 ;##### axe des x croit de g a droite (procedure COLORE)
            $cm create line 100 [expr 400 - $plicm] 100 [expr (400 - $plicm - $blup)] \
                    -width 1 ;##### axe des y decroit de bas en ht
        }
        set corrym [expr ($blup/$maximumpc2)]
        if {[info exists lm] == 0} {
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {100 + ($i*30)}]
                $cm create line $x [expr 400 - $plicm] $x [expr 395 - $plicm] -width 1
            }
        }
        set hauteurY [expr ($blup)]
        set subdivisionY [expr $hauteurY/10]
        if {[info exists lm] == 0} {
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {400 - $plicm - ($i*$subdivisionY)}]
                $cm create line 100 $y 105 $y -width 1
            }
        }
    } else {
        set blup [expr 300.0 * $maximumpc1/$maximumpc2]
        set plicm  50
        set ploc [expr (450 - $blup)/2]
        set xgauchem [expr 450-$ploc-$blup]
        if {[info exists lm] == 0} {
            $cm create line [expr 450-$ploc-$blup] 350 [expr 450 - $ploc] 350 \
                    -width 2 ;##### axe des x croit de g a droite (procedure COLORE)
            $cm create line [expr 450-$ploc-$blup] 350 [expr 450-$ploc-$blup] 50\
                    -width 2 ;##### axe des y decroit de bas en ht
        }
        set corrxm [expr ($blup/$maximumpc1)]
        
        set longueurX [expr ($blup)]
        set subdivisionX [expr $longueurX/10]
        if {[info exists lm] == 0} {
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {(450-$ploc-$blup) + ($i*$subdivisionX)}]
                $cm create line $x 350 $x 345 -width 2
            }
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {350 - ($i*30)}]
                $cm create line $xgauche $y [expr $xgauche + 5] $y -width 2
            }
        }
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update
    set textFont {Helvetica 8}
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr $sumpc1 + [lindex $pc1 $i]]
    }
    set moypc1 [expr $sumpc1 * 1.0/$npc]
    set minMpc1 [expr $minpc1 - $moypc1]
    set maxMpc1 [expr $maxpc1 - $moypc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr $sumpc2 + [lindex $pc2 $i]]
    }
    set moypc2 [expr $sumpc2 * 1.0/$npc]
    set minMpc2 [expr $minpc2 - $moypc1]
    set maxMpc2 [expr $maxpc2 - $moypc1]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    set tc "X = desde $minF1  a  $maxF1\tY = desde $minF2  a  $maxF2"
    $cm create text 95 425 -text $tc -font $textFont -anchor w -fill black
    $cm create text 95 445 -text $verjpd -font $textFont -anchor w -fill red
    
    
    ########################################################################
    # Indiquer sur le cote et dans l'ordre les differentes couleurs choisies
    set coul [llength $effectifs]
    for {set i 0} {$i < $coul} {incr i} {
        set item [$cm create oval 40 [expr 60 + ($i * 20)]  50 [expr 70 + ($i * 20)]  \
                -width 1 -fill $name($i)]
        $cm addtag point withtag $item
    }
    
    ########################################################################
    # Colorier quoi
    
    set ovo 3
    set long [llength $indimcentPC1]
    set coul 0
    set quidam 0
    set legion [lindex $effectifs $coul]
    set onpresente [lformat %1.3f $indimcentPC1]
    # debug
    #$p insert end "Proc colmoy: effectifs = $effectifs\nlegion = $legion\ncoul = $coul\nlong = $long"
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        if {$quidam > $legion} {incr coul; incr legion [lindex $effectifs $coul]}
        # debug
        #$p insert end "(colmoy)i = $i\n"
        #$p insert end "(colmoy)On en est AU POINT $quidam, a l'effectif $legion, a la couleur $name($coul)"
        set indpc1 [ lindex $indimcentPC1 $i ]
        set indpc2 [ lindex $indimcentPC2 $i ]
        set x [ expr { $xgauchem + ( $corrxm * $indpc1 ) } ]
        set y [ expr { 400 - $plicm - ( $corrym * $indpc2 ) } ]
        set item [$cm create oval [expr {$x-$ovo}] [expr {$y-$ovo}] [expr {$x+$ovo}] [expr {$y+$ovo}]\
                -width 1 -fill $name($coul) -tag zoumoy -tag peinture]
        $cm addtag point withtag $item
    }
    
    # Si on veut connecter des points-reperes (bouton conectar active)
    set coul 0
    set quidam 0
    set neweff ""
    foreach item $effectifs {
        lappend neweff [expr $item/$lm]
    }
    set newlegion [lindex $neweff $coul]
    set colonnes [expr $lm*2]
    set b 0;# c'est le boulier
    for  {set i 0} {$i < $lignes} {incr i} {
        set trancheX($i) [lrange $indimcentPC1 [expr $i+$b] \
                [expr $i+$b+$lm-1]]
        set trancheY($i) [lrange $indimcentPC2 [expr $i+$b] \
                [expr $i+$b+$lm-1]]
        incr b [expr $lm-1]
    }
    for  {set j 0} {$j < $lignes} {incr j} {
        #puts "\n$lignes lignes et j=$j, PLUS BAS ..."
        update
        flush stdout
        set poligono ""
        for {set i 0} {$i < $lm} {incr i} {
            set indpc1 [ lindex $trancheX($j) $i ]
            set indpc2 [ lindex $trancheY($j) $i ]
            set pointX($i) [ expr { $xgauchem + ( $corrxm * $indpc1 ) } ]
            set pointY($i) [ expr { 400 - $plicm - ( $corrym * $indpc2 ) } ]
            append poligono "$pointX($i) $pointY($i) "
        }
        set retour [lrange $poligono 0 1]
        append poligono "$retour"
        incr quidam
        if {$quidam > $newlegion} {incr coul; incr newlegion [lindex $neweff $coul]}
        $cm create line $poligono -fill $name($coul) -tag imhotep
    }
    
    
    ###############################
    # Documentation
    if {[info exists pad]} {
        if {[info exists lm]} {
            bind $cm <ButtonPress> { procrustes }
            balloonhelp_for .plottcolore.c "Clic sobre la figura -> etapas y comentarios"
        } else  {
            bind $cm <ButtonPress> { discrimine }
            balloonhelp_for .plottcolore.c "Clic sobre la figura -> etapas y comentarios"
        }
    }
}

####################colmoy######## PROCEDURE ## FIN ####


######################## PROCEDURE numgroup #### DEBUT###
proc numgroup {effectifs individus args} {
    global effectifs_numgroup references
    set effectifs_numgroup $effectifs
    destroy .subd
    global gr pad verjpd
    
    # VALEUR MINIMUM de la 1ere COMPOSANTE PRINCIPALE
    # -----------------------------------------------
    set ordre {}
    foreach item $individus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc1 [lindex $ordre 0]
    ## ajout August 2002
    set minpc1 $minimumpc1
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de la 2eme COMPOSANTE PRINCIPALE
    # (procedure NUMGROUP)
    # -----------------------------------------------
    set ordre {}
    foreach item $individus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minimumpc2 [lindex $ordre 0]
    ## ajout August 2002
    set minpc2 $minimumpc2
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # CENTRAGE DES VALEURS SUR ZERO pour PC1
    # --------------------------------------
    
    foreach item $individus {
        set somme {}
        lappend somme [expr [lindex $item 3] - $minimumpc1]
        lappend individuscentPC1 $somme
    }
    
    
    
    
    # CENTRAGE DES VALEURS SUR ZERO pour PC2
    # (procedure COLORE)
    # --------------------------------------
    foreach item $individus {
        set somme {}
        lappend somme [expr [lindex $item 4] - $minimumpc2]
        lappend individuscentPC2 $somme
    }
    
    # VALEUR MAXIMUM DE la 1ere COMPOSANTE PRINCIPALE
    # ----------------------------------------------
    set ordre [lsort -real $individuscentPC1]
    set maximumpc1 [lindex $ordre end]
    
    
    
    # VALEUR MAXIMUM DE la 2eme COMPOSANTE PRINCIPALE
    # ----------------------------------------------
    set ordre [lsort -real $individuscentPC2]
    set maximumpc2 [lindex $ordre end]
    
    set corrx [expr {300.0/$maximumpc1}]
    set corry [expr {300.0/$maximumpc2}]
    
    ###################################################
    # preparation du graphique de la procedure NUMGROUP
    ###################################################
    
    set w .plottnumgroup
    catch {destroy $w}
    toplevel $w
    wm geometry $w 550x485+205+10
    wm title $w "X = factor 1, Y = factor 2"
    wm iconname $w "factor 1 en X, factor 2 en Y"
    
    set c $w.c
    
    set Font {Helvetica 6}
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    button $w.buttons.group -text "OTROS ?" -bg red -fg white \
            -command "subextractgro {$individus}"
    button $w.buttons.zoom -text "Z" \
            -command {
                .plottnumgroup.c scale all 0 0 1.5 1.5
                .plottnumgroup.c configure -scrollregion [.plottnumgroup.c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
                #zoomnumgroup $effectifs_numgroup $individus
            }
    button $w.buttons.cancel -text "Volver" -command "destroy $w"
    button $w.buttons.ps -text "Guardar (post-script)" -bg white -command {
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile\
                -defaultextension .ps]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottnumgroup.c postscript]
        close $outputGraphe
    }
    pack $w.buttons.ps $w.buttons.group  $w.buttons.zoom $w.buttons.cancel -side left -expand 1
    
    canvas $c -width 450 -height 450 -relief raised -background white
    pack $w.c -side top -fill x
    
    set plotFont {Helvetica 8}
    ########################################################################
    # SSi c'est una AD, le plot est carre
    if {[info exists pad]} {
        set blup 300.0
        set xgauche 100
        set plic [expr (400 - $blup)/2]
        $c create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] -width 1 -tag axe_x
        ##### axe des x croit de g a droite (procedure DESSINE)
        $c create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] -width 1 -tag axe_y
        ##### axe des y decroit de bas en ht
        set corry [expr ($blup/$maximumpc2)]
        
        for {set i 0} {$i <= 10} {incr i} {
            set x [expr {100 + ($i*30)}]
            $c create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1 -tag axe_x
            ##### subdividions sur l'axe des x
        }
        set hauteurY [expr ($blup)]
        set subdivisionY [expr $hauteurY/10]
        for {set i 0} {$i <= 10} {incr i} {
            set y [expr {400 - $plic - ($i*$subdivisionY)}]
            $c create line 100 $y 105 $y -width 1 -tag axe_y
            ##### subdividions sur l'axe des y
        }
        # sinon on fait un plot aux axes proportionels
    } else  {
        
        if {$maximumpc1 > $maximumpc2} {
            set blup [expr 300.0 * $maximumpc2/$maximumpc1]
            set xgauche 100
            set plic [expr (400 - $blup)/2]
            $c create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] \
                    -width 1 -tag axe_x
            ##### axe des x croit de g a droite (procedure DESSINE)
            $c create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] \
                    -width 1 -tag axe_y
            ##### axe des y decroit de bas en ht
            set corry [expr ($blup/$maximumpc2)]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {100 + ($i*30)}]
                $c create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1 -tag axe_x
                ##### subdividions sur l'axe des x
            }
            set hauteurY [expr ($blup)]
            set subdivisionY [expr $hauteurY/10]
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {400 - $plic - ($i*$subdivisionY)}]
                $c create line 100 $y 105 $y -width 1 -tag axe_y
                ##### subdividions sur l'axe des y
            }
        } else {
            set blup [expr 300.0 * $maximumpc1/$maximumpc2]
            set plic  50
            set ploc [expr (450 - $blup)/2]
            set xgauche [expr 450-$ploc-$blup]
            $c create line [expr 450-$ploc-$blup] 350 [expr 450 - $ploc] 350 \
                    -width 2 -tag axe_x
            ##### axe des x croit de g a droite (procedure NUMGROUP)
            $c create line [expr 450-$ploc-$blup] 350 [expr 450-$ploc-$blup] 50 \
                    -width 2 -tag axe_y
            ##### axe des y decroit de bas en ht
            set corrx [expr ($blup/$maximumpc1)]
            
            set longueurX [expr ($blup)]
            set subdivisionX [expr $longueurX/10]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {(450-$ploc-$blup) + ($i*$subdivisionX)}]
                $c create line $x 350 $x 345 -width 2  -tag axe_x
                ##### subdividions sur l'axe des x
            }
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {350 - ($i*30)}]
                $c create line $xgauche $y [expr $xgauche + 5] $y -width 2 -tag axe_y
                ##### subdividions sur l'axe des y
            }
        }
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update
    set textFont {Helvetica 8}
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr $sumpc1 + [lindex $pc1 $i]]
    }
    set moypc1 [expr $sumpc1 * 1.0/$npc]
    set minMpc1 [expr $minpc1 - $moypc1]
    set maxMpc1 [expr $maxpc1 - $moypc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr $sumpc2 + [lindex $pc2 $i]]
    }
    set moypc2 [expr $sumpc2 * 1.0/$npc]
    set minMpc2 [expr $minpc2 - $moypc1]
    set maxMpc2 [expr $maxpc2 - $moypc1]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    
    set tc "Factor 1 = desde $minF1  a  $maxF1  -  Factor 2 = desde $minF2  a  $maxF2"
    $c create text 45 375 -text "$tc ($verjpd)" -font $textFont -anchor w -fill black
    $c create text 45 425 -text $references -font "Courrier 9" -anchor w -fill red -tag data_info
    $c itemconfigure data_info -width 450
    
    ########################################################################
    # S'il ny a que deux groupes, signaler que le facteur 2 est une plaisanterie
    set iciFont "Helvetica 8"
    if {[info exists pad]} {
        if {$gr == 2} {
            update
            set c .plottnumgroup.c
            set lc [$c find withtag axe_y]
            foreach item $lc {$c delete $item}
            $c create text 260 10 -text "El segundo factor (vertical) no es valido" \
                    -anchor n -font "Helvetica 18" -fill red
        }
    }
    ########################################################################
    
    set long [llength $individuscentPC1]
    set coul 0
    set quidam 0
    set legion [lindex $effectifs $coul]
    #chull
    set canvas_g ""
    
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        if {$quidam > $legion} {
            #chull
            set convexhulls [env::chull $canvas_g]
            $c create line $convexhulls  -fill black -tag all
            set canvas_g ""
            incr coul
            incr legion [lindex $effectifs $coul]
        }
        #puts "\nOn en est a l'individu $quidam, a l'effectif $legion et a la couleur $name($coul)"
        set indpc1 [ lindex $individuscentPC1 $i ]
        set indpc2 [ lindex $individuscentPC2 $i ]
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        set item [$c create oval [expr {$x-1}] [expr {$y-1}] [expr {$x+1}] [expr {$y+1}] -width 1 -outline black]
        $c create text [expr $x+7] $y -text [expr $coul + 1] -anchor n -font "Helvetica 10"
        $c addtag point withtag $item
        # chull
        append canvas_g "$x $y "
    }
    # Fin de la numeration
    set convexhulls [env::chull $canvas_g]
    $c create line $convexhulls -fill black -tag all
    set canvas_g ""
}

#################### numgroup ############# PROCEDURE ## FIN ###


# Procedure HISTOGRABE
#
proc  histograbe {data1 data2 valclass c} {
    global references
    #
    # La variable c contient le nom du CANVAS des graphiques
    #
    # Recherche des limites + valeur maximale de l'ensemble des donnees des 2 histogrammes
    set data_tot [concat $data1 $data2]
    set data_tot_ordre [lsort -real -increasing $data_tot]
    #puts "data_tot_ordre \n$data_tot_ordre"
    set max [expr {int([lindex $data_tot_ordre end])}]
    #puts "max $max"
    set min [expr {int([lindex $data_tot_ordre 0])}]
    #puts "min $min"
    set envergure [expr {$max - $min}]
    set epaisseur [expr {int(round($envergure / $valclass))}]
    #puts "epaisseur $epaisseur"
    for {set i [expr {$min + $epaisseur}]} {$i < [expr {$max + $epaisseur}]} {incr i $epaisseur} {
        lappend limits $i
        #debug
        #puts "Limites $limits"
    }
    #puts "limites $limits"
    
    # Calcul des hauteurs des rectangles pour les limites choisies
    set counts_1 [::math::statistics::histogram $limits $data1]
    set counts_2 [::math::statistics::histogram $limits $data2]
    
    # ---------------------------------------------------------------------------------------------
    #puts "DATA\ndata1\n$data1\ndata2\n$data2"
    set i 0
    set sum1 0
    set sum2 0
    set sum_share 0
    foreach item $limits {
        set a [lindex $counts_1 $i]
        set b [lindex $counts_2 $i]
        set sum1 [expr {$sum1 + $a}]
        set sum2 [expr {$sum2 + $b}]
        incr i
        if {$a > 0 && $b > 0} {set sum_share [expr {$sum_share + $a + $b}]}
    }
    
    # ------------------------------------------------------------------------------------------------
    
    set counts_tot [concat $counts_1 $counts_2]
    set counts_tot_ordre [lsort -real -increasing $counts_tot]
    #puts "counts_tot_ordre \n$counts_tot_ordre"
    set counts_max [lindex $counts_tot_ordre end]
    #puts "max $counts_max"
    
    # On cree le canvas et on le colle a l'aide de GRID
    #grid [canvas .c -width 450 -height 250 -bg "light yellow"]
    
    set add [expr {int(0.25 * (400 / $valclass))}]
    #puts "add = $add"
    
    set ht 290
    set htt [expr {$ht - 10}]
    
    # Trace du premier histogramme
    set x [expr {65}]
    foreach v $counts_1 {
        set y [expr {$ht - ($htt * $v * (1.0 / $counts_max))}]; # la hauteur de v corrigee en fonction de la valeur maximale
        set x2 [expr {$x+$add}];# de x a x2 la largeur d'un rectangle
        $c create rectangle $x $y $x2 $ht -outline black -fill black
        set x [expr $x2+$add+$add]; # le x du prochain rectangle est deplace vers la droite
    }
    # Trace du second histogramme
    set x [expr {65 + $add + $add}]
    foreach v $counts_2 {
        set y [expr {$ht - ($htt * $v * (1.0 / $counts_max))}]; # la hauteur de v corrigee en fonction de la valeur maximale
        set x2 [expr {$x+$add}];# de x a x2 la largeur d'un rectangle
        $c create rectangle $x $y $x2 $ht -outline black -fill {}
        set x [expr $x2+$add+$add]; # le x du prochain rectangle est deplace vers la droite
    }
    
    # dessiner l'echelle verticale sur la gauche de l'histogramme
    $c create line 40 0 40 [expr {$ht + 10}] -fill black
    # Dessiner la ligne de base de l'histogramme
    $c create line 40 $ht 480 $ht -fill black -width 3
    # Dessiner l'echelle des classes
    for {set i [expr {65+ $add + $add}]} {$i < 440} {incr i [expr {$add*2}]} {
        $c create line $i $ht $i [expr {$ht + 10}] -fill black
    }
    set addy 20
    # Dessiner l'echelle de l'ordonnee
    for {set i -10} {$i < $htt} {incr i [expr {$addy}]} {
        $c create line 40 [expr $i + $addy] 50 [expr $i + $addy] -fill black
    }
    
    # Comentaires
    $c create text 40 [expr {$ht + 35}] -text "Black = \tGroup 1 \t$sum1" -anchor nw -justify left
    $c create text 40  [expr {$ht + 55}] -text "White = \tGroup 2  \t$sum2" -anchor nw -justify left
    $c create text 40 [expr {$ht +75}] -text "Number of individuals of different groups sharing the same interval" -anchor nw  -justify left
    $c create text 40 [expr {$ht + 95}] -text $sum_share -anchor nw -justify left
    $c create text 40  [expr {$ht + 115}] -text "Number of intervals \t$valclass" -anchor nw -justify left
}
#
# Procedure HISTOGRABE

######################## dessine ## PROCEDURE ## DEBUT###
proc dessine {individus} {
    
    # Je crois que la procedure dessine n'est pas appelee par MOG
    # Si c'est vrai, il y a du nettoyage a faire !! Helas, c'est vrai !!
    global infile references base_effectifs effectifs lm_attente
    
    #debug
    #puts "(début) effectifs $effectifs"
    
    #Histogramme
    global valclass
    
    #chull
    #global effectifs
    global envind
    set envind $individus
    
    #debug
    #puts "Au debut du dessin $references"
    global gr pad verjpd adda_lignes lignes polygone
    global etiquette doc
    
    set dirinfile "[file dirname $infile]/";#repertoire des donnees
    set tailfile [file tail $infile];#fichier nu, avec l'extension
    set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
    
    update idletasks
    flush stdout
    
    if {[info exists gr] == 1} {global gr}
    global lm
    
    
    if  {[info exists lm] == 0} {set lm $lm_attente}
    
    destroy .muestreo.entree
    destroy .muestreo.boutonBac
    destroy .progres
    destroy .subd
    
    set subdipop $individus
    
    # VALEUR MINIMUM de l'abscisse
    # -----------------------------
    set ordre {}
    foreach item $individus {
        set A [lrange $item 3 3]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minpc1 [lindex $ordre 0]
    set maxpc1 [lindex $ordre end]
    set pc1 $ordre
    
    # VALEUR MINIMUM de l'ordonnee
    # -----------------------------
    set ordre {}
    foreach item $individus {
        set A [lrange $item 4 4]
        set B [lsort -real $A]
        set C [lindex $B 0]
        lappend ordre $C
    }
    
    set ordre [lsort -real $ordre]
    set minpc2 [lindex $ordre 0]
    set maxpc2 [lindex $ordre end]
    set pc2 $ordre
    
    # CENTRAGE DES VALEURS SUR ZERO pour l'abscisse
    # ---------------------------------------------
    foreach item $individus {
        set somme {}
        lappend somme [expr [lindex $item 3] - $minpc1]
        lappend individuscentPC1 $somme
    }
    #debug
    #puts "debug dessine individuscentPC1 $individuscentPC1"
    
    # CENTRAGE DES VALEURS SUR ZERO pour l'ordonnee
    # ---------------------------------------------
    
    foreach item $individus {
        set somme {}
        lappend somme [expr [lindex $item 4] - $minpc2]
        lappend individuscentPC2 $somme
    }
    
    #debug chull
    #puts "individus PC1 = \n$individuscentPC1\nindividus PC2 = \n$individuscentPC2"
    
    #VALEUR MAXIMUM de l'abscisse centree
    # ------------------------------------
    set ordre [lsort -real $individuscentPC1]
    set maxpcc1 [lindex $ordre end]
    set minpcc1 [lindex $ordre 0]
    
    #VALEUR MAXIMUM de l'ordonnee centree
    # ------------------------------------
    set ordre [lsort -real $individuscentPC2]
    set maxpcc2 [lindex $ordre end]
    set minpcc2 [lindex $ordre 0]
    
    set corrx [expr {300.0/$maxpcc1}]
    set corry [expr {300.0/$maxpcc2}]
    
    
    # ------------------------------------------------
    # preparation du graphique de la procedure DESSINE
    # ------------------------------------------------
    set w .plottdessine
    catch {destroy $w}
    toplevel $w
    wm geometry $w 550x485+205+10
    wm title $w "X = factor 1, Y = factor 2"
    wm iconname $w "factor 1 en X, factor 2 en Y"
    
    set Font {Helvetica 10}
    
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    button $w.buttons.color -background red -foreground white -text "Colores" \
            -command {
                global polygone references adda_lignes base_effectifs
                if {[info exists adda_lignes]} {set effectifs $base_effectifs}
                #debug
                puts "Bouton colore: effectifs $effectifs base_effectifs $base_effectifs"
                set polygone 0
                subextractcol $individus
            }
    button $w.buttons.group -background red -foreground white -text "Numeros" \
            -command {
                global polygone references base_effectifs
                set polygone 0
                if {[info exists adda_lignes]} {set effectifs $base_effectifs}
                subextractgro $individus
            }
    # chull
    button $w.buttons.chull -background red -foreground white -text "C. Hulls" \
            -command {
                global base_effectifs effectifs envind
                #set effectifs $base_effectifs
                # Effectifs ou pas
                destroy .subd
                set fen .subd
                catch {destroy $fen}
                toplevel $fen
                wm geometry $fen 220x90+280+380
                if {[info exists effectifs]} {wm iconname $fen "$effectifs"}
                set llamada [entry .subd.entree -background white -textvariable subd_effectifs]
                set orden [button .subd.bouton -background grey25 -foreground white \
                -text "Enter group sizes separated \nby a space, \nthen press me" \
                -font "Helvetica 12" \
                -command {global effectifs envind; set effectifs $subd_effectifs;dessine $envind}]
                pack $llamada $orden
            }
    button $w.buttons.indiv -background red -foreground white -text "Individuos" \
            -command {
                global polygone references
                set polygone 0
                numind $individus
            }
    if  {[info exists lm] == 1} {
        button $w.buttons.connecter -background red -foreground white -text "Conectar" \
                -command {
                    global polygone individus
                    set polygone 1
                    dessine $individus
                }
    }
    if {[info exists etiquette] != 0} {
        # On peut zoomer si on a ecrit les etiquettes
        button $w.buttons.zoomet -text "Z" -command {
            global individus etiquette doc
            .plottdessine.c scale all 0 0 1.5 1.5
            .plottdessine.c itemconfigure zou -fill red
            .plottdessine.c configure -scrollregion [.plottdessine.c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
            
            #zoomet $individus
        }
    }
    button $w.buttons.doc -background red -foreground white -text "ET" \
            -command {
                global infile polygone individus etiquette doc references
                set dirinfile "[file dirname $infile]/";#repertoire des donnees
                set tailfile [file tail $infile];#fichier nu, avec l'extension
                set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
                # ne sais quoi faire de ce polygone en ce moment
                set polygone 0
                # le laisse donc
                # --------------
                # ouvrir le fichier _ET, et creer la liste doc
                set fin "_ET.txt"
                set rootfile_ET $rootfile$fin
                set docinfile $dirinfile$rootfile_ET
                set doc [etiquetage $docinfile]
                
                # recommencer le dessin avec le drapeau etiquette hisse
                set etiquette 1
                # etiquette = 1, donc info exists etc. = [info exists etiquette]
                dessine $individus
            }
    set fin "_ET.txt"
    set rootfile_ET $rootfile$fin
    update
    balloonhelp_for $w.buttons.doc "Etiquetas...\nEsta opcion requiere un archivo\n$rootfile_ET\nen el folder : $dirinfile"
    
    image create bitmap fleche_haut -file +/fleche_haut.xbm
    image create bitmap fleche_bas -file +/fleche_bas.xbm
    
    button $w.buttons.class_haut -image  fleche_haut -command {
        global valclass
        set valclass [expr {$valclass + 2}]
        if {$valclass > 50} {
            tk_messageBox -message "50 instead of $valclass classes have been accepted" -icon warning -type ok
            set valclass 50
        }
        dessine $individus
    }
    
    button $w.buttons.class_bas -image  fleche_bas -command {
        global valclass
        set valclass [expr {$valclass - 2}]
        if {$valclass < 6} {
            tk_messageBox -message "1 instead of $valclass classes have been accepted" -icon warning -type ok
            set valclass 6
        }
        dessine $individus
    }
    
    button $w.buttons.cancel -foreground black -text "X " -command {
        if {[info exists etiquette] != 0} {unset etiquette}
        destroy .plottdessine
    }
    
    button $w.buttons.ps -text "guardar (.eps)" -command {
        # #debug
        # Pour etre sur de ce que j'enregistre en postscript
        # je vais placer ici une procedure de verification
        # qui montrera ce que presente le canvas .plottdessine.c
        # verifdebug
        # fin du debug
        update idletasks
        flush stdout
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile \
                -defaultextension .eps]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottdessine.c postscript]
        close $outputGraphe
        #debug
        ## OPEN THE FILE aa.svg
        ##---Tclwiki-start
        #source /home/jepi/mytcl/Developpement/BAClin/can2svg-1.tcl
        ##---Tclwiki-end
        #set outputGraphe [open /home/jepi/mytcl/Developpement/BAClin/aa.svg w]
        #::can2svg::canvas2file .plottdessine.c /home/jepi/mytcl/Developpement/BAClin/aa.svg
        #close $outputGraphe
    }
    
    # debug
    #puts "info exists etiquette [info exists etiquette]"
    if {[info exists lm] == 0} {
        # debug
        #puts "info exists etiquette [info exists etiquette]"
        if {[info exists gr]} {
            if {$gr == 2} {
                if {[info exists pad]} {
                    pack $w.buttons.ps $w.buttons.class_haut  $w.buttons.class_bas  $w.buttons.cancel -side left -expand 1
                }
            } else  {
                pack $w.buttons.ps $w.buttons.doc $w.buttons.color $w.buttons.group\
                        $w.buttons.indiv $w.buttons.cancel \
                        -side left -expand 1
            }
        } else  {
            if {[info exists etiquette] == 0} {
                pack $w.buttons.ps $w.buttons.doc $w.buttons.color $w.buttons.group\
                        $w.buttons.indiv $w.buttons.cancel \
                        -side left -expand 1
            } else  {
                pack $w.buttons.ps $w.buttons.doc $w.buttons.zoomet $w.buttons.chull $w.buttons.color $w.buttons.group \
                        $w.buttons.indiv $w.buttons.cancel \
                        -side left -expand 1
            }
        }
    } else {
        pack $w.buttons.ps $w.buttons.doc $w.buttons.connecter $w.buttons.color $w.buttons.group \
                $w.buttons.indiv $w.buttons.cancel -side left -expand 1
    }
    
    set c .plottdessine.c
    # La variable w contient .plottdessine
    
    canvas $c -width 450 -height 450 -relief raised -background "light yellow"\
            -yscrollcommand "$w.v_scroll_tut set" \
            -xscrollcommand "$w.h_scroll_tut set"
    scrollbar $w.v_scroll_tut -command "$c yview" -orient vertical
    scrollbar $w.h_scroll_tut -command "$c xview" -orient horizontal
    pack $w.v_scroll_tut -side right -fill y
    pack $w.h_scroll_tut -side bottom -fill x
    pack $c -side top -fill both -expand 1
    
    
    set plotFont {Helvetica 16}
    
    #################################################################################
    # Si c'est une AD, ou si on ne veut pas d'axes proportionnels, le plot est carre
    if {[info exists pad]} {
        set blup 300.0
        set xgauche 100
        set plic [expr (400 - $blup)/2]
        $c create line 100 [expr 400 - $plic] 400 [expr 400 - $plic]\
                -width 1 -fill blue -tag axe_x
        ##### axe des x croit de g a droite (procedure DESSINE)
        $c create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)]\
                -width 1 -fill blue -tag axe_y
        ##### axe des y decroit de bas en ht
        set corry [expr ($blup/$maxpcc2)]
        for {set i 0} {$i <= 10} {incr i} {
            set x [expr {100 + ($i*30)}]
            $c create line $x [expr 400 - $plic] $x [expr 395 - $plic] \
                    -width 1 -fill blue -tag axe_x
        }
        set hauteurY [expr ($blup)]
        set subdivisionY [expr $hauteurY/10]
        for {set i 0} {$i <= 10} {incr i} {
            set y [expr {400 - $plic - ($i*$subdivisionY)}]
            $c create line 100 $y 105 $y -width 1 -fill blue -tag axe_y
        }
        # sinon on fait un plot aux axes proportionels
    } else  {
        if {$maxpcc1 > $maxpcc2} {
            set blup [expr 300.0 * $maxpcc2/$maxpcc1]
            set xgauche 100
            set plic [expr (400 - $blup)/2]
            $c create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] \
                    -width 1  -fill blue;##### axe des x croit de g a droite (procedure DESSINE)
            $c create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] \
                    -width 1  -fill blue;##### axe des y decroit de bas en ht
            set corry [expr ($blup/$maxpcc2)]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {100 + ($i*30)}]
                $c create line $x [expr 400 - $plic] $x [expr 395 - $plic] \
                        -width 1 -fill blue -tag axe_x
            }
            set hauteurY [expr ($blup)]
            set subdivisionY [expr $hauteurY/10]
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {400 - $plic - ($i*$subdivisionY)}]
                $c create line 100 $y 105 $y -width 1 -fill blue -tag axe_y
            }
        } else {
            set blup [expr 300.0 * $maxpcc1/$maxpcc2]
            set plic  50
            set ploc [expr (450 - $blup)/2]
            set xgauche [expr 450-$ploc-$blup]
            $c create line [expr 450-$ploc-$blup] 350 [expr 450 - $ploc] 350 \
                    -width 2  -fill blue;##### axe des x croit de g a droite (procedure DESSINE)
            $c create line [expr 450-$ploc-$blup] 350 [expr 450-$ploc-$blup] 50 \
                    -width 2  -fill blue;##### axe des y decroit de bas en ht
            set corrx [expr ($blup/$maxpcc1)]
            
            set longueurX [expr ($blup)]
            set subdivisionX [expr $longueurX/10]
            for {set i 0} {$i <= 10} {incr i} {
                set x [expr {(450-$ploc-$blup) + ($i*$subdivisionX)}]
                $c create line $x 350 $x 345 -width 2 -fill blue -tag axe_x
            }
            for {set i 0} {$i <= 10} {incr i} {
                set y [expr {350 - ($i*30)}]
                $c create line $xgauche $y [expr $xgauche + 5] $y -width 2 -fill blue -tag axe_y
            }
        }
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update idletasks
    set textFont {Helvetica 8}
    
    ## Centrage des composantes 1 et 2 sur leur moyennes
    set sumpc1 0
    set sumpc2 0
    set npc [llength $pc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc1 [expr $sumpc1 + [lindex $pc1 $i]]
    }
    set moypc1 [expr $sumpc1 * 1.0/$npc]
    set minMpc1 [expr $minpc1 - $moypc1]
    set maxMpc1 [expr $maxpc1 - $moypc1]
    for  {set i 0} {$i<$npc} {incr i} {
        set sumpc2 [expr $sumpc2 + [lindex $pc2 $i]]
    }
    set moypc2 [expr $sumpc2 * 1.0/$npc]
    set minMpc2 [expr $minpc2 - $moypc1]
    set maxMpc2 [expr $maxpc2 - $moypc1]
    ## Fin du centrage sur les moyennes
    
    set minF1 [format %1.3f $minMpc1]
    set minF2 [format %1.3f $minMpc2]
    set maxF1 [format %1.3f $maxMpc1]
    set maxF2 [format %1.3f $maxMpc2]
    
    set tc "Factor 1 = desde $minF1  a  $maxF1  -  Factor 2 = desde $minF2  a  $maxF2"
    $c create text 40 375 -text "$tc ($verjpd)" -font $textFont -anchor w -fill blue -tag facteurs
    $c create text 40 435 -text $references -font "Courrier 9" -anchor w -fill red -tag data_info
    $c itemconfigure data_info -anchor nw -justify left -width 450
    
    ########################################################################
    # S'il ne s'agit pas d'une autre analyse que l'AD, et s'il n' y a que deux groupes,
    # Effacer ce qu'il y a deja sur le canvas, et dessiner un histogramme
    if  {[info exists lm] == 0} {
        if {[info exists pad]} {
            if {$gr == 2} {
                # J'efface
                set c .plottdessine.c
                set lc [$c find withtag axe_y]
                foreach item $lc {$c delete $item}
                set lc [$c find withtag axe_x]
                foreach item $lc {$c delete $item}
                set lc [$c find withtag facteurs]
                foreach item $lc {$c delete $item}
                # Je dessine l'histogramme
                set coul 0
                set quidam 0
                set legion [lindex $effectifs $coul]
                set long [llength $individuscentPC1]
                for {set i 0} {$i < $long} {incr i} {
                    incr quidam
                    if {$quidam > $legion} {
                        set ind [ lindex $individuscentPC1 $i ]
                        lappend data1 [expr {$ind * 100}]
                    } else  {
                        set ind [ lindex $individuscentPC1 $i ]
                        lappend data2 [expr {$ind * 100}]
                    }
                }
                # ... dont les argument incluent le nom du canvas
                if {[info exists valclass] == 0} {set valclass 10}
                histograbe $data1 $data2 $valclass $c
                return
            }
        }
    }
    ########################################################################
    #debug 
    #puts "(fond jaunatre) effectifs $effectifs"
    # -------------------------------------------------------------------------------
    # Ecriture sur fond jaunatre des points bleus de la carte factorielle
    # ------------------------------------------------------------------------------
    set ovo 3
    set long [llength $individuscentPC1]
    set coul 0
    set quidam 0
    #chull
    # Si le bouton CHULL est active
    if {[info exists effectifs]} {
        if {[llength $effectifs] > 1} {
            set legion [lindex $effectifs $coul]
            set canvas_g ""
        }
    }
    if {[info exists adda_lignes] == 1} {
        set long [expr {$long - $adda_lignes}]
    }
    #debug
    puts "Procedure dessine: effectifs $effectifs coul $coul legion $legion"
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        # Si le bouton CHULL est active
        if {[info exists effectifs]} {
            if {[llength $effectifs] > 1} {
                if {$quidam > $legion} {
                    #chull
                    set convexhulls [env::chull $canvas_g]
                    $c create line $convexhulls  -fill red -tag all
                    set canvas_g ""
                    incr coul
                    incr legion [lindex $effectifs $coul]
                }
            }
        }
        # BOUTON chull, fin
        set indpc1 [ lindex $individuscentPC1 $i ]
        set indpc2 [ lindex $individuscentPC2 $i ]
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        if {[info exists etiquette] == 0} {
            set item [$c create oval [expr {$x-$ovo}] [expr {$y+$ovo}] [expr {$x+$ovo}] [expr {$y-$ovo}] \
                    -width 1 -outline blue -tag zou -tag peinture]
            $c addtag point withtag $item
            append canvas_g "$x $y "
        } else  {
            # AJOUT TEST - debut
            set eti [lindex $doc $i]
            set item [$c create text $x $y -text $eti -fill blue]
            $c addtag point withtag $item
            # AJOUT TEST - fin
            #chull
            append canvas_g "$x $y "
        }
        
    }
    # Fin des boutons bleus
    if {[info exists effectifs]} {
        if {[llength $effectifs] > 1} {
            #puts $canvas_g
            set convexhulls [env::chull $canvas_g]
            $c create line $convexhulls -fill red -tag all
            set canvas_g ""
        }
    }
    # Si on veut connecter des points-reperes (MOG, bouton conectar active)
    if {[info exists lm] == 1} {
        if {[info exists polygone] == 1} {
            if {$polygone == 1} {
                set colonnes [expr $lm*2]
                set b 0;# c'est le boulier
                for  {set i 0} {$i < $lignes} {incr i} {
                    set trancheX($i) [lrange $individuscentPC1 [expr $i+$b] \
                            [expr $i+$b+$lm-1]]
                    set trancheY($i) [lrange $individuscentPC2 [expr $i+$b] \
                            [expr $i+$b+$lm-1]]
                    incr b [expr $lm-1]
                }
                for  {set j 0} {$j < $lignes} {incr j} {
                    update
                    flush stdout
                    set poligono ""
                    for {set i 0} {$i < $lm} {incr i} {
                        set indpc1 [ lindex $trancheX($j) $i ]
                        set indpc2 [ lindex $trancheY($j) $i ]
                        set pointX($i) [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
                        set pointY($i) [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
                        append poligono "$pointX($i) $pointY($i) "
                    }
                    set retour [lrange $poligono 0 1]
                    append poligono "$retour"
                    $c create line $poligono -tag imhotep
                }
            }
        }
    }
    
    # s'il y a des individus supplementaires apres une analyse discriminante
    if {[info exists adda_lignes] == 1} {
        # Projet njaram - debut
        # Si on veut documenter les individus sur le graphique
        # il faut ici charger les donnees incluant les individus additionnels
        # Projet njaram - fin
        set adda_long $long
        # je suppose que long contenait le numero d'individus sans les externes
        # on lui donne ensuite la valeur du nombre total d'individus
        set long [llength $individuscentPC1]
        for {set i $adda_long} {$i < $long} {incr i} {
            set indpc1 [ lindex $individuscentPC1 $i ]
            set indpc2 [ lindex $individuscentPC2 $i ]
            set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
            set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
            set item [$c create oval $x [expr {$y-10}] [expr {$x+10}] $y \
                    -width 1 -fill red -tag zou -tag peinture]
            $c addtag point withtag $item
        }
    }
    
    set plot(lastX) 0
    set plot(lastY) 0
    
    if  {[info exists adda_lignes] != 0} {
        $c configure -cursor dot
        bind $c <ButtonPress> { datosext }
        balloonhelp_for .plottdessine.c "Clic sobre la figura -> etapas y comentarios"
    }
    
    $c configure -scrollregion [$c bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    
}

####################dessine######## PROCEDURE ## FIN ###


# Procedures Tclwiki - start
#
proc canvas2svg c {
    set res "<svg[att width [$c cget -width]][att height [$c cget -height]]>\n"
    foreach item [$c find all] {
        set type [$c type $item]
        set atts ""
        foreach {x0 y0 x1 y1} \
                [string map {".0 " " "} "[$c coords $item] "] break
        set fill [rgb2xcolor [$c itemcget $item -fill]]
        catch {set stroke [rgb2xcolor [$c itemcget $item -outline]]}
        catch {set width [expr round([$c itemcget $item -width])]}
        set pts {}
        foreach {x y} [$c coords $item] {
            lappend pts [list [expr {round($x)}] [expr {round($y)}]]
        }
        switch -- $type {
            line {
                set type polyline
                append atts [att points [join $pts ", "]]
                append atts [att stroke $fill #000000]
                append atts [att stroke-width $width 1]
            }
            oval {
                set type ellipse
                append atts [att cx [expr {($x0+$x1)/2}]]
                append atts [att cy [expr {($y0+$y1)/2}]]
                append atts [att rx [expr {($x1-$x0)/2}]]
                append atts [att ry [expr {($y1-$y0)/2}]]
                append atts [att fill $fill #000000][att stroke $stroke none]
                append atts [att stroke-width $width 1]
            }
            polygon {
                append atts [att points [join $pts ", "]]
                append atts [att fill $fill #000000][att stroke $stroke none]
                append atts [att stroke-width $width 1]
            }
            rectangle {
                set type rect
                append atts [att x $x0][att y $y0]
                append atts [att width  [expr {$x1-$x0}]]
                append atts [att height [expr {$y1-$y0}]]
                append atts [att fill $fill #000000][att stroke $stroke none]
                append atts [att stroke-width $width 1]
            }
            text {
                append atts [att x $x0][att y $y0][att fill $fill #000000]
                set text [$c itemcget $item -text]
            }
            default {error "type $type not(yet) dumpable to SVG"}
        }
        append res "  <$type$atts"
        if {$type=="text"} {
            append res ">$text</$type>\n"
        } else {
            append res " />\n"
        }
    }
    append res "</svg>"
}
proc att {name value {default -}} {
    if {$value != $default} {return " $name=\"$value\""}
}
proc rgb2xcolor rgb {
    if {$rgb == ""} {return none}
    foreach {r g b} [winfo rgb . $rgb] break
    format #%02x%02x%02x [expr {$r/256}] [expr {$g/256}] [expr {$b/256}]
}
# Procedures Tclwiki - end



# procedure verifdebug
proc verifdebug {} {
    .plottdessine.c configure -background green
}
# fin de la procedure verifdebug

######################## regresse ## PROCEDURE ## DEBUT###
proc regresse {igrec ixe} {
    
    global w p gr pad verjpd adda_lignes cv1 cv2 size numero effectifs magritte axeX
    update
    flush stdout
    
    if {[info exists gr] == 1} {global gr}
    
    destroy .muestreo.entree
    destroy .muestreo.boutonBac
    destroy .progres
    destroy .subd
    
    set lignes [llength $igrec]
    
    # VALEUR MINIMUM de l'axe des X (ixe)
    # ------------------------------------
    set axeX $ixe
    set ordre [lsort -real $axeX]
    #$p insert end "\nAxe des X $axeX\n"
    set minaxeX [lindex $ordre 0]
    set maxaxeX [lindex $ordre end]
    #$p insert end "\nAxe des X $axeX\n"
    #$p insert end "\nMinimum X = $minaxeX\n"
    
    # VALEUR MINIMUM de l'axe des Y (igrec1)
    # ----------------------------------
    set axeY $igrec
    set ordre [lsort -real $axeY]
    #$p insert end "\nAxe des Y $axeY\n"
    set minaxeY [lindex $ordre 0]
    set maxaxeY [lindex $ordre end]
    #$p insert end "\nAxe des Y $axeY"
    #$p insert end "\nMinimum Y = $minaxeY\n"
    
    
    # axe X: Translation des VALEURS SUR ZERO
    # ---------------------------------------
    set enliste ""
    foreach item $axeX {
        lappend enliste [expr $item - $minaxeX]
    }
    set centaxeX $enliste
    #$p insert end "\nAxe X centre $centaxeX\n"
    
    # axe YTranslation des VALEURS SUR ZERO
    # -------------------------------------
    set enliste ""
    foreach item $axeY {
        lappend enliste [expr $item - $minaxeY]
    }
    set centaxeY $enliste
    #$p insert end "\nAxe Y centre $centaxeY\n"
    
    #VALEUR MAXIMUM de l'axe X centre
    # -------------------------------
    set ordre [lsort -real $centaxeX]
    set maxcentaxeX [lindex $ordre end]
    set mincentaxeX [lindex $ordre 0]
    
    #VALEUR MAXIMUM de l'axe Y centre
    # -------------------------------
    set ordre [lsort -real $centaxeY]
    set maxcentaxeY [lindex $ordre end]
    set mincentaxeY [lindex $ordre 0]
    
    set corrx [expr {300.0/$maxcentaxeX}]
    set corry [expr {300.0/$maxcentaxeY}]
    
    # -----------------------------------------------
    # Preparer la formule de la droite de regression
    set ixe2 ""
    set igrec2 ""
    set ixeigrec ""
    update
    set Sx 0
    set Sx2 0
    foreach item $centaxeX {
        set Sx [expr $Sx + $item]
        lappend ixe2 [expr pow($item,2)]
        set Sx2 [expr $Sx2 + [expr pow($item,2)]]
    }
    #$p insert end "\nSomme des X $Sx"
    #$p insert end "\nSomme des X2 $Sx2"
    set Sy 0
    set Sy2 0
    foreach item $centaxeY {
        set Sy [expr $Sy+$item]
        lappend igrec2 [expr pow($item,2)]
        set Sy2 [expr $Sy2 + [expr pow($item,2)]]
    }
    #$p insert end "\nSomme des Y $Sy"
    #$p insert end "\nSomme des Y2 $Sy2"
    set Sxy 0
    #$p insert end "\nNombre de lignes $lignes\n"
    for  {set i 0} {$i < $lignes} {incr i} {
        set lun [lindex $centaxeX $i]
        set lautre [lindex $centaxeY $i]
        set lunlautre [expr $lun * $lautre]
        #$p insert end "\nlun $lun * lautre $lautre = $lunlautre"
        lappend ixeigrec $lunlautre
        set Sxy [expr {$Sxy + $lunlautre}]
    }
    #$p insert end "\nSomme des XY $Sxy"
    set denom [expr [expr $lignes * $Sx2] - [expr pow($Sx,2)] ]
    set divis [expr {1.0 / $denom}]
    set a [expr {($Sy*$Sx2 - $Sx*$Sxy) * $divis}]
    set b [expr {($lignes*$Sxy - $Sx*$Sy) * $divis}]
    
    #$p insert end "\nVALEURS PREDITES\n-------------------\n"
    #$p insert end "\nY = $a\t+\t$b";$p insert end "X\n"
    
    # Prediction des Y
    set predictY ""
    set long [llength $igrec]
    for {set i 0} {$i < $long} {incr i} {
        set indx [ lindex $centaxeX $i ]
        lappend predictY [ expr $a + ($b * $indx) ]
        #$p insert end "$indx  -->  [ expr $a + ($b * $indx) ]\n"
    }
    
    # VALEUR MAXIMUM de l'axe des Y predits
    set ordre [lsort -real $predictY]
    set maxpredictY [lindex $ordre end]
    set minpredictY [lindex $ordre 0]
    
    # Translation des VALEURS sur ZERO pour l'axe des Y predits
    # ---------------------------------------------------------
    set enliste ""
    foreach item $predictY {
        lappend enliste [expr $item - $minpredictY]
    }
    set centpredictY $enliste
    #$p insert end "\nAxe Y predit C E N T R E ... \n"
    
    #set corrx [expr {300.0/$maxcentaxeX}]
    #set corrPy [expr 300.0/$maxpredictY]
    
    # Preparer la droite de regression, fin.
    # --------------------------------------
    
    # -----------------------------------------------
    # Preparer la formule de la correlation, DEBUT
    # -----------------------------------------------
    set denomG [expr [expr $lignes * $Sx2] - [expr pow($Sx,2)] ]
    set denomD [expr [expr $lignes * $Sy2] - [expr pow($Sy,2)] ]
    set denom [expr sqrt($denomG*$denomD)]
    set divis [expr 1.0 / $denom]
    set r [expr ($lignes*$Sxy - $Sx*$Sy) * $divis]
    bleu "\n\nRegresion de CV$numero (y) sobre el tamano (x)"
    bleu "\ny = a + bx"
    #$p insert end "\na\t=\t$a"
    #$p insert end "\nb\t=\t$b"
    set r [format %1.3f $r]
    $p insert end "\n Coeficiente de correlacion\t$r"
    set r2 [expr $r * $r]
    set r2 [format %1.3f $r2]
    $p insert end "\n Coeficiente de determinacion\t$r2"
    set ddl [expr $lignes - 2]
    set t [expr ( $r*sqrt($ddl) ) / sqrt(1-$r2) ]
    set t [format %1.2f $t]
    $p insert end "\n t de Student \t\t[expr abs($t)],\tcon $ddl grados de libertad\n"
    # -----------------------------------------------
    # Formule de la correlation, FIN
    # -----------------------------------------------
    
    
    ###################################################
    # Preparation du graphique de la procedure REGRESSE
    ###################################################
    set w .plottregresse
    catch {destroy $w}
    toplevel $w
    wm geometry $w 550x500+205+10
    wm title $w "X = tamano, Y = factor canonico"
    wm iconname $w "X = tamano, Y = factor canonico"
    set c $w.c
    
    set Font {Helvetica 10}
    
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    button $w.buttons.cancel -foreground black -text "SALIR" \
            -command "destroy $w"
    button $w.buttons.grey -background "dark green" -foreground white \
            -text "Tonos de gris ?" \
            -command {
                if {$gr < 7} {
                    global cv1 cv2 size
                    if {$numero == 1} {reggrise $cv1 $size}
                    if {$numero == 2} {reggrise $cv2 $size}
                } else  {
                    set jedis "Con mas de 7 grupos, no se puede...\n(los tonos de gris se confunden)"
                    tk_messageBox -message $jedis -parent $w -title "no no" -type ok \
                    -icon warning
                }
            }
    button $w.buttons.cv2 -background "dark green" -foreground white \
            -text "CV2" \
            -command {
                if {$gr > 2} {
                    set numero 2
                    global cv1 cv2 size
                    regresse $cv2 $size
                } else  {
                    set jedis "Con 2 grupos,\ntienes un solo\nfactor discriminante"
                    tk_messageBox -message $jedis -parent $w -title "no no" -type ok -icon warning
                }
            }
    button $w.buttons.cv1 -background "dark green" -foreground white \
            -text "CV1" \
            -command {
                set numero 1
                global cv1 cv2 size
                regresse $cv1 $size
            }
    button $w.buttons.ps -text "GUARDAR" -bg "light green" -command {
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile \
                -defaultextension .ps]
        wm title . $filename
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottregresse.c postscript]
        close $outputGraphe
    }
    pack $w.buttons.cv1 $w.buttons.cv2 $w.buttons.grey $w.buttons.cancel $w.buttons.ps -side left -expand 1
    
    canvas $c -width 450 -height 450 -relief raised -background "light green" -cursor dot
    pack $w.c -side top -fill x
    update
    set plotFont {Helvetica 16}
    
    ########################################################################
    # Le plot est carre de toutes facons; dessin des axes
    set blup 300.0
    set xgauche 100
    set plic [expr (400 - $blup)/2]
    $c create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] -width 1 ;\
            # axe des x croit de g a droite
            $c create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] -width 1 ;\
            # axe des y decroit de bas en ht
            set corry [expr ($blup/$maxcentaxeY)]
    set corrPy [expr ($blup/$maxpredictY)]
    for {set i 0} {$i <= 10} {incr i} {
        set x [expr {100 + ($i*30)}]
        $c create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1
    }
    set hauteurY [expr ($blup)]
    set subdivisionY [expr $hauteurY/10]
    for {set i 0} {$i <= 10} {incr i} {
        set y [expr {400 - $plic - ($i*$subdivisionY)}]
        $c create line 100 $y 105 $y -width 1
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update
    set textFont {Helvetica 8}
    
    ## Centrage des composantes 1 et 2 sur leur moyennes
    #set sumaxeX 0
    #set sumaxeY 0
    #set npc [llength $axeX]
    #for  {set i 0} {$i<$npc} {incr i} {
    #    set sumpc1 [expr $sumaxeX + [lindex $axeX $i]]
    #}
    #set moypc1 [expr $sumpc1 * 1.0/$npc]
    #set minMpc1 [expr $minpc1 - $moypc1]
    #set maxMpc1 [expr $maxpc1 - $moypc1]
    #for  {set i 0} {$i<$npc} {incr i} {
    #    set sumpc2 [expr $sumpc2 + [lindex $pc2 $i]]
    #}
    #set moypc2 [expr $sumpc2 * 1.0/$npc]
    ##set maxMpc2 [expr $maxpc2 - $moypc1]
    ## Fin du centrage sur les moyennes
    
    #set minF1 [format %1.3f $minMpc1]
    #set minF2 [format %1.3f $minMpc2]
    #set maxF1 [format %1.3f $maxMpc1]
    #set maxF2 [format %1.3f $maxMpc2]
    
    #set tc "Axe X = desde $minF1  a  $maxF1  -  Factor 2 = desde $minF2  a  $maxF2"
    #$c create text 65 425 -text $tc -font $textFont -anchor w -fill white
    #$c create text 65 445 -text " ( $verjpd ) " -font $textFont -anchor w -fill "light yellow"
    
    #$c create text 225 20 -text "CP1 en X, CP2 en Y" -font $plotFont -fill brown
    
    # Dessin des points OBSERVES sur le graphique
    set long [llength $centaxeX]
    # Creer des couleurs
    set coul 0
    foreach item [split $effectifs] {
        set rcol [expr int(rand()*65535)]
        set gcol [expr int(rand()*65535)]
        set bcol [expr int(rand()*65535)]
        set name($coul) [format "#%.4x%.4x%.4x" $rcol $gcol $bcol]
        incr coul
    }
    # if {[info exists adda_lignes] == 1} {set long [expr $long - $adda_lignes]}
    # Preparer la fragmentation de l'echantillon total
    set coul 0
    set quidam 0
    set legion [lindex $effectifs $coul]
    # plotter
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        if {$quidam > $legion} {incr coul; incr legion [lindex $effectifs $coul]}
        #puts "\nOn en est a l'individu $quidam, a l'effectif $legion et a la couleur $name($coul)"
        set indpc1 [ lindex $centaxeX $i ]
        set indpc2 [ lindex $centaxeY $i ]
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        #$p insert end "\nAU DEBUT ... $plic    et   $corry"
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        set item [$c create rectangle [expr {$x-3}] [expr {$y-3}] [expr {$x+3}] [expr {$y+3}] \
                -width 1 -outline black -fill $magritte($coul)]
        $c addtag point withtag $item
    }
    
    
    # Dessin des points PREDITS sur le graphique (DROITE DE REGRESSION)
    #set long [llength $centaxeX]
    #for {set i 0} {$i < $long} {incr i} {
    #    set indpc1 [ lindex $centaxeX $i ]
    #    set indpc2 [ expr $a + ($b * $indpc1) ]
    #    set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
    #    #$p insert end "\nENSUITE... $plic    et   $corrPy"
    #    set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
    #    #set item [$c create text $x $y -text $i]
    #    set item [$c create oval [expr {$x-1}] [expr {$y-1}] [expr {$x+1}] [expr {$y+1}] \
    #            -width 1 -outline red -fill red]
    #    $c addtag point withtag $item
    #}
    
    # Dessin de la DROITE DE REGRESSION
    set x1 $mincentaxeX
    set y1 [ expr $a + ($b * $x1) ]
    set x2 $maxcentaxeX
    set y2 [ expr $a + ($b * $x2) ]
    set x1 [ expr { $xgauche + ( $corrx * $x1 ) } ]
    set y1 [ expr { 400 - $plic - ( $corry * $y1 ) } ]
    set x2 [ expr { $xgauche + ( $corrx * $x2 ) } ]
    set y2 [ expr { 400 - $plic - ( $corry * $y2 ) } ]
    set item [$c create line $x1 $y1 $x2 $y2 -width 1 -fill red]
    $c addtag point withtag $item
    
    # Nommer les axes
    $c create text 50 45 -text "CV $numero" -font $plotFont
    $c create text 380 380 -text "S  I  Z  E" -font $plotFont
    $c create text 260 410 -text "Contribucion del tamano a la variacion\
            del CV $numero    =     [expr int($r * $r *100)]%"
    
    # Indiquer sur le cote et dans l'ordre les differentes couleurs choisies
    
    for {set i 0} {$i < [expr $coul+1]} {incr i} {
        set item [$c create rectangle 55 [expr 71 + ($i * 20)]  65 [expr 81 + ($i * 20)] \
                -width 1 -outline black -fill $magritte($i)]
        $c addtag point withtag $item
        $c create text 25 [expr 66 + ($i * 20)] -text [lindex $effectifs $i] -anchor n\
                -font 12
    }
    bind $c <ButtonPress> { residalom }
    balloonhelp_for .plottregresse.c "Clic sobre la figura -> etapas y comentarios"
}

#################### regresse ######## PROCEDURE ## FIN ###


######################## reggrise ## PROCEDURE ## DEBUT###
proc reggrise {igrec ixe} {
    
    global w p gr pad verjpd adda_lignes cv1 cv2 size numero effectifs magritte
    update
    flush stdout
    
    if {[info exists gr] == 1} {global gr}
    
    destroy .muestreo.entree
    destroy .muestreo.boutonBac
    destroy .progres
    destroy .subd
    
    set lignes [llength $igrec]
    
    # VALEUR MINIMUM de l'axe des X (ixe)
    # ------------------------------------
    set axeX $ixe
    set ordre [lsort -real $axeX]
    #$p insert end "\nAxe des X $axeX\n"
    set minaxeX [lindex $ordre 0]
    set maxaxeX [lindex $ordre end]
    #$p insert end "\nAxe des X $axeX\n"
    #$p insert end "\nMinimum X = $minaxeX\n"
    
    # VALEUR MINIMUM de l'axe des Y (igrec1)
    # ----------------------------------
    set axeY $igrec
    set ordre [lsort -real $axeY]
    #$p insert end "\nAxe des Y $axeY\n"
    set minaxeY [lindex $ordre 0]
    set maxaxeY [lindex $ordre end]
    #$p insert end "\nAxe des Y $axeY"
    #$p insert end "\nMinimum Y = $minaxeY\n"
    
    
    # axe X: Translation des VALEURS SUR ZERO
    # ---------------------------------------
    set enliste ""
    foreach item $axeX {
        lappend enliste [expr $item - $minaxeX]
    }
    set centaxeX $enliste
    #$p insert end "\nAxe X centre $centaxeX\n"
    
    # axe YTranslation des VALEURS SUR ZERO
    # -------------------------------------
    set enliste ""
    foreach item $axeY {
        lappend enliste [expr $item - $minaxeY]
    }
    set centaxeY $enliste
    #$p insert end "\nAxe Y centre $centaxeY\n"
    
    #VALEUR MAXIMUM de l'axe X centre
    # -------------------------------
    set ordre [lsort -real $centaxeX]
    set maxcentaxeX [lindex $ordre end]
    set mincentaxeX [lindex $ordre 0]
    
    #VALEUR MAXIMUM de l'axe Y centre
    # -------------------------------
    set ordre [lsort -real $centaxeY]
    set maxcentaxeY [lindex $ordre end]
    set mincentaxeY [lindex $ordre 0]
    
    set corrx [expr {300.0/$maxcentaxeX}]
    set corry [expr {300.0/$maxcentaxeY}]
    
    # -----------------------------------------------
    # Preparer la formule de la droite de regression
    set ixe2 ""
    set igrec2 ""
    set ixeigrec ""
    update
    set Sx 0
    set Sx2 0
    foreach item $centaxeX {
        set Sx [expr $Sx + $item]
        lappend ixe2 [expr pow($item,2)]
        set Sx2 [expr $Sx2 + [expr pow($item,2)]]
    }
    #$p insert end "\nSomme des X $Sx"
    #$p insert end "\nSomme des X2 $Sx2"
    set Sy 0
    set Sy2 0
    foreach item $centaxeY {
        set Sy [expr $Sy+$item]
        lappend igrec2 [expr pow($item,2)]
        set Sy2 [expr $Sy2 + [expr pow($item,2)]]
    }
    #$p insert end "\nSomme des Y $Sy"
    #$p insert end "\nSomme des Y2 $Sy2"
    set Sxy 0
    #$p insert end "\nNombre de lignes $lignes\n"
    for  {set i 0} {$i < $lignes} {incr i} {
        set lun [lindex $centaxeX $i]
        set lautre [lindex $centaxeY $i]
        set lunlautre [expr $lun * $lautre]
        #$p insert end "\nlun $lun * lautre $lautre = $lunlautre"
        lappend ixeigrec $lunlautre
        set Sxy [expr $Sxy + $lunlautre]
    }
    #$p insert end "\nSomme des XY $Sxy"
    set denom [expr [expr $lignes * $Sx2] - [expr pow($Sx,2)] ]
    set divis [expr 1.0 / $denom]
    set a [expr ($Sy*$Sx2 - $Sx*$Sxy) * $divis]
    set b [expr ($lignes*$Sxy - $Sx*$Sy) * $divis]
    
    #$p insert end "\nVALEURS PREDITES\n-------------------\n"
    #$p insert end "\nY = $a\t+\t$b";$p insert end "X\n"
    
    # Prediction des Y
    set predictY ""
    set long [llength $igrec]
    for {set i 0} {$i < $long} {incr i} {
        set indx [ lindex $centaxeX $i ]
        lappend predictY [ expr $a + ($b * $indx) ]
        #$p insert end "$indx  -->  [ expr $a + ($b * $indx) ]\n"
    }
    
    # VALEUR MAXIMUM de l'axe des Y predits
    set ordre [lsort -real $predictY]
    set maxpredictY [lindex $ordre end]
    set minpredictY [lindex $ordre 0]
    
    # Translation des VALEURS sur ZERO pour l'axe des Y predits
    # ---------------------------------------------------------
    set enliste ""
    foreach item $predictY {
        lappend enliste [expr $item - $minpredictY]
    }
    set centpredictY $enliste
    #$p insert end "\nAxe Y predit C E N T R E ... \n"
    
    #set corrx [expr {300.0/$maxcentaxeX}]
    #set corrPy [expr 300.0/$maxpredictY]
    
    # Preparer la droite de regression, fin.
    # --------------------------------------
    
    # -----------------------------------------------
    # Preparer la formule de la correlation, DEBUT
    # -----------------------------------------------
    set denomG [expr [expr $lignes * $Sx2] - [expr pow($Sx,2)] ]
    set denomD [expr [expr $lignes * $Sy2] - [expr pow($Sy,2)] ]
    set denom [expr sqrt($denomG*$denomD)]
    set divis [expr 1.0 / $denom]
    set r [expr ($lignes*$Sxy - $Sx*$Sy) * $divis]
    #$p insert end "\n\nRegresion de CV$numero sobre el tamano"
    #$p insert end "\n --------------------------------------"
    #$p insert end "\nY = a + bX"
    #$p insert end "\na\t=\t$a"
    #$p insert end "\nb\t=\t$b"
    #$p insert end "\n Coeficiente de correlacion\t$r"
    set r2 [expr $r * $r]
    #$p insert end "\n Coeficiente de determinacion\t$r2"
    set ddl [expr $lignes - 2]
    set t [expr ( $r*sqrt($ddl) ) / sqrt(1-$r2) ]
    #$p insert end "\n t de Student \t\t[expr abs($t)],\tcon $ddl grados de libertad\n"
    # -----------------------------------------------
    # Formule de la correlation, FIN
    # -----------------------------------------------
    
    
    ###################################################
    # Preparation du graphique de la procedure REGRESSE
    ###################################################
    set w .plottreggrise
    catch {destroy $w}
    toplevel $w
    wm geometry $w 550x500+205+10
    wm title $w "X = tamano, Y = factor canonico"
    wm iconname $w "X = tamano, Y = factor canonico"
    set c $w.c
    
    set Font {Helvetica 10}
    
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    
    button $w.buttons.cancel -foreground white \
            -text "VOLVER" \
            -command "destroy $w"
    
    button $w.buttons.ps -text "GUARDAR" -bg "light green" -command {
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile \
                -defaultextension .ps]
        wm title . $filename
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [.plottreggrise.c postscript]
        close $outputGraphe
    }
    pack $w.buttons.cancel $w.buttons.ps -side left -expand 1
    
    canvas $c -width 450 -height 450 -relief raised -background "light green" -cursor dot
    pack $w.c -side top -fill x
    
    set plotFont {Helvetica 16}
    
    ########################################################################
    # Le plot est carre de toutes facons; dessin des axes
    set blup 300.0
    set xgauche 100
    set plic [expr (400 - $blup)/2]
    $c create line 100 [expr 400 - $plic] 400 [expr 400 - $plic] -width 1 ;\
            # axe des x croit de g a droite
            $c create line 100 [expr 400 - $plic] 100 [expr (400 - $plic - $blup)] -width 1 ;\
            # axe des y decroit de bas en ht
            set corry [expr ($blup/$maxcentaxeY)]
    set corrPy [expr ($blup/$maxpredictY)]
    for {set i 0} {$i <= 10} {incr i} {
        set x [expr {100 + ($i*30)}]
        $c create line $x [expr 400 - $plic] $x [expr 395 - $plic] -width 1
    }
    set hauteurY [expr ($blup)]
    set subdivisionY [expr $hauteurY/10]
    for {set i 0} {$i <= 10} {incr i} {
        set y [expr {400 - $plic - ($i*$subdivisionY)}]
        $c create line 100 $y 105 $y -width 1
    }
    
    ## L'instruction ci-dessous permet d'ecrire sur le canvas, en bas
    ## ajout August 2002
    update
    set textFont {Helvetica 8}
    
    # Table des gris
    set gris(0) white
    set gris(1) black
    set gris(2) grey86
    set gris(3) grey21
    set gris(4) grey55
    set gris(5) grey39
    set gris(6) grey70
    
    set coul 0
    foreach item [split $effectifs] {
        set grisatre($coul) $gris($coul)
        incr coul
    }
    
    # Dessin des points OBSERVES sur le graphique
    set long [llength $centaxeX]
    # Creer des couleurs
    set coul 0
    foreach item [split $effectifs] {
        set rcol [expr int(rand()*65535)]
        set gcol [expr int(rand()*65535)]
        set bcol [expr int(rand()*65535)]
        set name($coul) [format "#%.4x%.4x%.4x" $rcol $gcol $bcol]
        incr coul
    }
    # if {[info exists adda_lignes] == 1} {set long [expr $long - $adda_lignes]}
    # Preparer la fragmentation de l'echantillon total
    set coul 0
    set quidam 0
    set legion [lindex $effectifs $coul]
    # plotter
    for {set i 0} {$i < $long} {incr i} {
        incr quidam
        if {$quidam > $legion} {incr coul; incr legion [lindex $effectifs $coul]}
        #puts "\nOn en est a l'individu $quidam, a l'effectif $legion et a la couleur $name($coul)"
        set indpc1 [ lindex $centaxeX $i ]
        set indpc2 [ lindex $centaxeY $i ]
        set x [ expr { $xgauche + ( $corrx * $indpc1 ) } ]
        #$p insert end "\nAU DEBUT ... $plic    et   $corry"
        set y [ expr { 400 - $plic - ( $corry * $indpc2 ) } ]
        set item [$c create rectangle [expr {$x-3}] [expr {$y-3}] [expr {$x+3}] [expr {$y+3}] \
                -width 1 -outline black -fill $grisatre($coul)]
        $c addtag point withtag $item
    }
    
    # Dessin de la DROITE DE REGRESSION
    set x1 $mincentaxeX
    set y1 [ expr $a + ($b * $x1) ]
    set x2 $maxcentaxeX
    set y2 [ expr $a + ($b * $x2) ]
    set x1 [ expr { $xgauche + ( $corrx * $x1 ) } ]
    set y1 [ expr { 400 - $plic - ( $corry * $y1 ) } ]
    set x2 [ expr { $xgauche + ( $corrx * $x2 ) } ]
    set y2 [ expr { 400 - $plic - ( $corry * $y2 ) } ]
    set item [$c create line $x1 $y1 $x2 $y2 -width 1 -fill yellow]
    $c addtag point withtag $item
    
    # Nommer les axes
    $c create text 50 45 -text "CV $numero" -font $plotFont
    $c create text 380 380 -text "S  I  Z  E" -font $plotFont
    $c create text 260 410 -text "Contribucion del tamano a la variacion\
            del CV $numero    =     [expr int($r * $r *100)]%"
    
    # Indiquer sur le cote et dans l'ordre les differentes couleurs choisies
    
    for {set i 0} {$i < [expr $coul+1]} {incr i} {
        set item [$c create rectangle 55 [expr 71 + ($i * 20)]  65 [expr 81 + ($i * 20)] \
                -width 1 -outline black -fill $grisatre($i)]
        $c addtag point withtag $item
        $c create text 25 [expr 66 + ($i * 20)] -text [lindex $effectifs $i] -anchor n\
                -font 12
    }
    bind $c <ButtonPress> { conforme }
    balloonhelp_for .plottreggrise.c "Clic sobre la figura \n-> etapas y comentarios"
}

#################### reggrise ######## PROCEDURE ## FIN ###

# Procedure RANGE ##start
#
proc range {groupes valeurs effectifs} {
    update
    # La variable globale compall vaut 1 lorsque des populations sont comparees pour l'allometrie de leurs caracteres
    global compall
    #unset next
    # TOUT CE QU'IL FAUT PREPARER EST
    # UNE VARIABLE 'groupes' pour le nombre de groupes ou populations; colonnes, si allometry sur une seule ACP avec bootstrap;
    # bref, 'nbvar' (nombre de variables) ou 'nbacp' (si plusieurs acp se suivent avec bootstrap)
    # UNE LISTE 'valeurs' pour ... les valeurs qui se suivent dans l'ordre de chaque groupe; bref, 'contvar' (contenu des variables)
    # UNE DEUXIEME LISTE 'effectifs' = les effectifs de chaque groupe; bref, 'listnbvalvar' (liste des nb de valeurs par variable)
    # - par exemple le nombre de bootstraps impose le nombre de valeurs obtenues par une variable
    #  - et effectifs ressemblera a 5 5 5 5 5 s'il y avait 5 bootstraps (nb de valeurs par variable)  et 6 variables ( = groupes, ou nbvar).
    # Exemple BAC pc1, etc. (liste ?) = valeurs (); groupes = 6 (six characteres); effectifs = 5 5 5 5 5 5 (cfr. BAC, 5 bootstraps)
    global nbvar contvar nbvalvar references colonnes numfen
    if {[info exists numfen]} {puts "yadel'info"} else {set numfen 1}
    set nbvar $groupes
    set contvar $valeurs
    set nbvalvar $effectifs
    # numfen c'est pour generer une fenetre differente a chaque acp ... si on compare l'allometrie entre populations
    #
    #debug
    #puts "nbvar =\t$nbvar = groupes, soit : $groupes, ou alors colonnes, soit : $colonnes, ou alors nb d'ACP ...";# une erreur ici
    #puts "contvar =\n$contvar"
    #puts "nbvalvar =\t$nbvalvar"
    
    global caractere
    if  {[info exists caractere] == 1} {
        set caractero $caractere
    }
    
    # Pour connaitre les valeurs extremes de l'abscisse du graphique
    set valeursordre [lsort -real $valeurs]
    global p975max p025min
    set p975max [lindex $valeursordre end]
    set p025min  [lindex $valeursordre 0]
    
    global sip25p75 sip10p90 sidata sip025p975
    set sip25p75 1
    set sip10p90 1
    set sidata 1
    set sip025p975 1
    
    # rangement des effectifs dans une variable indicee selon le nombre de variables : 'efectivo(indice)'
    # - chaque 'efectivo(indice)' contient le nombre de valeurs correspondant a la variable reperee par l'indice
    global efectivo
    for {set i 0} {$i < $groupes} {incr i} {
        set efectivo($i) [lindex $effectifs $i]
    }
    
    # Calcul des percentiles selon le nombre de valeurs dans chaque variable ...
    # ou, si c'est MOG qui apelle, selon le nombre d'individus dans chaque population
    
    # Positions des percentiles 0 et 100 (min et max)
    for {set i 0} {$i < $groupes} {incr i} {
        set p000($i) [expr {int($efectivo($i) * 0)}]
        set p1000($i) [expr {int(($efectivo($i) * 1) - 1)}]
    }
    # Positions des percentiles 25 et 75
    for {set i 0} {$i < $groupes} {incr i} {
        set p750($i) [expr {int($efectivo($i) * 0.750)}]
        set p250($i) [expr {int($efectivo($i) * 0.250)}]
    }
    # Positions des percentiles 10 et 90
    for {set i 0} {$i < $groupes} {incr i} {
        set p900($i) [expr {int($efectivo($i) * 0.900)}]
        set p100($i) [expr {int($efectivo($i) * 0.100)}]
    }
    # Position de la mediane
    for {set i 0} {$i < $groupes} {incr i} {
        set p500($i) [expr {int($efectivo($i) * 0.500)}]
    }
    
    # pieces = les listes des valeurs ('valeurs', ou contenu d'une variable) dans chaque population ou variable ('groupes', 'nbvar')
    global pieces
    set compteur 0
    for  {set i 0} {$i < $groupes} {incr i} {
        set pieces($i) [lrange $valeurs $compteur [expr {$compteur + $efectivo($i) - 1}] ]
        set compteur [expr {$compteur + $efectivo($i)}]
    }
    
    # Calcul des moyennes (a placer dans la liste alomoy)
    # il s'agit des moyennes
    global alomoy
    set alomoy ""
    for {set i 0} {$i < $groupes} {incr i} {
        set sumitem 0
        foreach item $pieces($i) {set sumitem [expr {$sumitem + $item}]}
        set moyenne [expr {$sumitem / $efectivo($i)}]
        lappend alomoy $moyenne
    }
    
    # Preparation de la FENETRE ou sera trace le graphique a l'aide d'un canvas
    # (pour le canvas, voir 200 lignes en-dessous, approximativement)
    global cuantiles
    #catch {destroy $w}
    set w ".plottquantiles$numfen"
    toplevel $w
    wm title $w "R a n g o s     c o m p a r a t i v o s - V a r i a b l e  $numfen"
    set x [expr {205 + ($numfen * 9)}]
    set y [expr {10 + ($numfen * 9)}]
    wm geometry $w 510x500+$x+$y
    wm iconname $w "Plot $numfen"
    set cuantiles $w.c$numfen
    #debug
    #puts "cuantiles = .plottquantiles.cX avec X un numero (numfen) = $cuantiles ??"
    set Font {Arial 14}
    
    # Une FRAME pour placer des BOUTONS
    frame $w.tirette$numfen
    pack $w.tirette$numfen -side top -fill x -pady 2m
    
    # La variable intervalle est definie dans la procedure qui appelle
    global intervalle
    
    # Preparation des BOUTONS a placer dans la FRAME tirette (elle est en haut de la fenetre)
    #
    # BOUTON next au cas ou on compare des populations
    set bef [button $w.tirette$numfen.next -text "-->>" -background grey22 -foreground green -width 8 -command {
        #destroy $cuantiles
        # SALAYA 13 JUIN 2007
        .buttons.rotation invoke
        destroy .plottquantiles$numfen
    }
    ]
    # BOUTON BIF Montrer les individus sous forme de traits verticaux
    set bif [button $w.tirette$numfen.data -text "data" -background grey22 -foreground green -width 8 -command {
        destroy .plottquantiles$numfen.tirette$numfen.next
        update
        global groupes valeurs effectifs
        global nbvar contvar nbvalvar
        #debug
        #puts "bouton data cuantiles = $cuantiles"
        # Montrer les individus (data)
        set range_corrx [expr {400.0 / ($p975max - $p025min)}]
        for  {set i 0} {$i < $nbvar} {incr i} {
            set y [expr {330 - ($i * $intervalle)}]
            for  {set a 0} {$a < $efectivo($i)} {incr a} {
                set valeur [lindex $pieces($i) $a]
                set x [ expr {50 + ($range_corrx * ($valeur - $p025min))}]
                $cuantiles create rectangle $x [expr {$y + 4}] $x [expr {$y - 4}] -width 1 -outline blue -tag range_data
            }
        }
        # aide en dessous de l'abscisse : on efface l'aide
        set c $cuantiles
        set lc [$c find withtag help]
        foreach item $lc {$c delete $item}
    };# fin de la commande
    ]
    # Fin du BOUTON BIF  Montrer les individus sous forme de traits verticaux
    
    
    # BOUTON BOF
    # Percentiles les plus communs, p25 et p75
    set bof [button $w.tirette$numfen.p25 -text "p25-p75" -background grey22 -foreground green -width 8 -command {
        destroy .plottquantiles$numfen.tirette$numfen.next
        update
        global nbvar contvar nbvalvar
        
        # Effacer les quantiles 10-90
        set c $cuantiles
        set lc [$c find withtag range_p10_90]
        foreach item $lc {$c delete $item}
        
        # Tracer les quantiles 25-75 Noter le tag specifique range_p25_75
        set range_corrx [expr {400.0 / ($p975max-$p025min)}]
        for  {set i 0} {$i < $nbvar} {incr i} {
            set alop250 $varp250($i)
            set alop750 $varp750($i)
            set alop500 $varp500($i)
            set y [expr {310 - ( $i * $intervalle) } ]
            set x [ expr {50 + ($range_corrx * ($alop250 - $p025min) ) }]
            set etendue [expr {($range_corrx * ($alop750 - $p025min) ) } ]
            $cuantiles create rectangle $x [expr {$y + 7}] [expr {50 + $etendue}] [expr {$y - 7}] \
                    -width 1 -outline "red" -tag range_p25_75
        }
        # Je colorie la mediane en rouge
        $cuantiles itemconfigure mediane -outline red
        
        # aide en dessous de l'abscisse
        set c $cuantiles
        set lc [$c find withtag help]
        foreach item $lc {$c delete $item}
        
        set x1help 200
        set x2help 300
        set yhelp 410
        set xmedhelp 250
        set item [$cuantiles create rectangle \
                [expr $xmedhelp] [expr {$yhelp - 6}] [expr $xmedhelp] [expr {$yhelp + 6}] -width 1 -outline red -tag help]
        $cuantiles create rectangle $x1help $yhelp $x2help $yhelp -width 1 -outline grey33 -tag help
        $cuantiles create rectangle $x1help [expr {$yhelp + 5}] [expr {$x1help - 1}] [expr {$yhelp - 5}] -outline grey33 -tag help
        $cuantiles create rectangle $x2help [expr {$yhelp + 5}] [expr {$x2help - 1}] [expr {$yhelp - 5}] -outline grey33 -tag help
        set item [$cuantiles create rectangle [expr {$xmedhelp - 25}] [expr {$yhelp - 7}] [expr {$xmedhelp + 25}]\
                [expr {$yhelp + 7}] -width 1 -outline red -tag help]
        $cuantiles create text [expr {$x1help - 20}] [expr {$yhelp + 15}]  -text "Minimum" -fill black -tag help
        $cuantiles create text $xmedhelp [expr {$yhelp + 15}] -text "Median" -fill red -tag help
        $cuantiles create text [expr {$x2help + 20}] [expr {$yhelp + 15}] -text "Maximum" -fill black -tag help
        $cuantiles create text [expr {$x1help + 15}] [expr {$yhelp + 30}] -text "P 25%" -fill red -tag help
        $cuantiles create text [expr {$x2help - 10}] [expr {$yhelp + 30}] -text "P 75%" -fill red -tag help
        $cuantiles create rectangle 120 390 390 450 -outline black -tag help
    }
    ]
    # Fin du bouton BOF
    
    
    # BOUTON BAF
    # Percentiles p10 et p90
    set baf [button $w.tirette$numfen.p10 -text "p10-p90" -background grey22 -foreground green \
            -width 8 -command {
                destroy .plottquantiles$numfen.tirette$numfen.next
                update
                global groupes valeurs effectifs
                global nbvar contvar nbvalvar
                
                # Effacer les quantiles 25 - 75
                set c $cuantiles
                set lc [$c find withtag range_p25_75]
                foreach item $lc {$c delete $item}
                
                # Garder les p000-p1000 (la ligne noire)!
                set range_corrx [expr {400.0 / ($p975max - $p025min) } ]
                for  {set i 0} {$i < $nbvar} {incr i} {
                    set alop000 $varp000($i)
                    set alop1000 $varp1000($i)
                    set alop500 $varp500($i)
                    set lesset [expr {$alop500 - $alop000}]
                    set moreet [expr {$alop500 + $alop1000}]
                    set x1 [ expr {50 + ($range_corrx * ($alop000 - $p025min) ) } ]
                    set x2 [ expr {50 + ($range_corrx * ($alop1000 - $p025min) ) } ]
                    
                    set y [expr {310 - ($i * $intervalle) } ]
                    $cuantiles create rectangle $x1 $y $x2 $y -width 1 -outline black
                    $cuantiles create rectangle $x1 [expr {$y + 5}] [expr {$x1 - 1}] [expr {$y - 5}] -outline black
                    $cuantiles create rectangle $x2 [expr {$y + 5}] [expr {$x2 - 1}] [expr {$y - 5}] -outline black
                }
                
                # Tracer les quantiles p10 - p90 Noter le tag specifique range_p10_p90
                set range_corrx [expr {400.0 / ($p975max - $p025min) } ]
                for  {set i 0} {$i < $nbvar} {incr i} {
                    set alop10 $varp100($i)
                    set alop90 $varp900($i)
                    set alop500 $varp500($i)
                    set y [expr {310 - ($i * $intervalle) } ]
                    set x [ expr {50 + ($range_corrx * ($alop10 - $p025min) ) } ]
                    set etendue [expr {($range_corrx * ($alop90 - $p025min) ) }]
                    $cuantiles create rectangle $x [expr {$y + 7}] [expr {50 + $etendue}] [expr {$y - 7}] \
                    -width 1 -outline orange -tag range_p10_90
                }
                # Je colorie la mediane en orange
                $cuantiles itemconfigure mediane -outline orange
                
                # aide en dessous de l'abscisse --------------------------------------------------
                #
                set c $cuantiles
                set lc [$c find withtag help]
                foreach item $lc {$c delete $item}
                
                set x1help 200
                set x2help 300
                set yhelp 410
                set xmedhelp 250
                
                $cuantiles create rectangle $xmedhelp [expr {$yhelp - 6}] $xmedhelp [expr $yhelp+6] -width 1 -outline orange -tag help
                $cuantiles create rectangle $x1help $yhelp $x2help $yhelp -width 1 -outline grey33 -tag help
                $cuantiles create rectangle $x1help [expr $yhelp+5] [expr $x1help-1] [expr $yhelp-5] -outline grey33 -tag help
                $cuantiles create rectangle $x2help [expr $yhelp+5] [expr $x2help -1] [expr $yhelp-5] -outline grey33 -tag help
                set item [$cuantiles create rectangle [expr {$xmedhelp - 35}] [expr {$yhelp - 7}] [expr {$xmedhelp + 35}]\
                [expr $yhelp+7] -width 1 -outline orange -tag help]
                $cuantiles create text [expr {$x1help - 20}] [expr {$yhelp + 15}] -text "Minimum" -fill black -tag help
                $cuantiles create text $xmedhelp [expr {$yhelp + 15}] -text "Median" -fill orange -tag help
                $cuantiles create text [expr {$x2help + 20}] [expr {$yhelp + 15}] -text "Maximum" -fill black -tag help
                $cuantiles create text [expr {$x1help + 10}] [expr {$yhelp + 30}] -text "P 10%" -fill orange -tag help
                $cuantiles create text [expr {$x2help + 0}] [expr {$yhelp + 30}] -text "P 90%" -fill orange -tag help
                $cuantiles create rectangle 120 390 390 450 -outline black -tag help
            }
    ]
    
    pack $w.tirette$numfen.data $w.tirette$numfen.p10 $w.tirette$numfen.p25 -side left -expand 1
    
    # ENCORE un BOUTON
    # Enlever la fenetre de l'ecran
    button $w.tirette$numfen.cancel -background grey22 -foreground green -text "ICONIFY" -command "update; wm iconify $w"
    
    # ENCORE un BOUTON
    # Sauver le graphe
    button $w.tirette$numfen.ps -text "Guardar" -command {
        update
        # NAME THE FILE
        set file_types {
            {"All Files" * }
        }
        global infile
        set dirinfile "[file dirname $infile]/";#repertoire des donnees
        #debug
        #puts "chemin = $dirinfile"
        set tailfile [file tail $infile];#fichier nu, avec l'extension
        #debug
        #puts "\ntail = $tailfile"
        set rootfile [file rootname $tailfile];#fichier nu, sans l'extension
        #debug
        #puts "root = $rootfile"
        set filename [tk_getSaveFile -filetypes $file_types -initialdir $dirinfile]
        wm title . $filename
        # OPEN THE FILE
        set outputGraphe [open $filename w]
        puts -nonewline $outputGraphe [$cuantiles postscript]
        close $outputGraphe
    }
    pack $w.tirette$numfen.cancel $w.tirette$numfen.ps $w.tirette$numfen.next -side left -expand 1
    
    # Le CANVAS, enfin
    # canvas avec ascenseur vertical
    #destroy .ysbar
    canvas $cuantiles -height 450 -relief raised -background white -yscrollcommand {$cuantiles.ysbar$numfen set}
    scrollbar $cuantiles.ysbar$numfen -orient vertical -command {
        #global c
        $cuantiles yview}
    pack $cuantiles.ysbar$numfen -side right -fill y
    pack $cuantiles -side top -fill both -expand yes
    
    set plotFont {Helvetica 10}
    
    # Trace de l'abscisse (sa longueur est fixe: 400 = 450 - 50)
    $cuantiles create line 50 350 450 350 -fill black -width 2 ;# axe des x croit de g a droite
    
    
    # Calcul des graphes correspondant a chaque variable (metric trait), ou chaque CS (chaque population) si c'est MOG qui appelle
    # Le nombre de variables se trouve dans la variable globale 'nbvar', ou dans la variable 'groupes'
    for {set i 0} {$i < $nbvar} {incr i} {
        
        set allob [lindex $alomoy $i]
        
        set orderedalometries [lsort -real $pieces($i)]
        global varp000 varp1000 varp100 varp900 varp250 varp750 varp500 varp025 varp975
        set varp000($i) [lindex $orderedalometries $p000($i)]
        set varp1000($i) [lindex $orderedalometries $p1000($i)]
        set varp100($i) [lindex $orderedalometries $p100($i)]
        set varp900($i) [lindex $orderedalometries $p900($i)]
        set varp250($i) [lindex $orderedalometries $p250($i)]
        set varp750($i) [lindex $orderedalometries $p750($i)]
        set varp500($i) [lindex $orderedalometries $p500($i)]
        
        # Valeurs de l'echelle sur l'abscisse
        set cool $p025min
        set cool [format "%3.2f" $cool]
        $cuantiles create text 60 370 -text $cool -fill black -anchor n -font $plotFont
        
        set cool [expr {$p025min + ($p975max - $p025min)/8}]
        set cool [format "%3.2f" $cool]
        $cuantiles create text 107.5 370 -text $cool -fill black -anchor n -font $plotFont
        
        set cool [expr {$p025min + ($p975max - $p025min)/4}]
        set cool [format "%3.2f" $cool]
        $cuantiles create text 155 370 -text $cool -fill black -anchor n -font $plotFont
        
        set cool [expr {$p025min + ($p975max - $p025min) * 3.0/8}]
        set cool [format "%3.2f" $cool]
        $cuantiles create text 202.5 370 -text $cool -fill black -anchor n -font $plotFont
        
        set cool [expr {$p025min + ($p975max-$p025min)/2}]
        set cool [format "%3.2f" $cool]
        $cuantiles create text 250 370 -text $cool -fill black -anchor n -font $plotFont
        
        set cool [expr {$p025min + ($p975max-$p025min) * 5.0/8}]
        set cool [format "%3.2f" $cool]
        $cuantiles create text 297.5 370 -text $cool -fill black -anchor n -font $plotFont
        
        set cool [expr {$p025min + ($p975max-$p025min) * 3.0/4}]
        set cool [format "%3.2f" $cool]
        $cuantiles create text 345 370 -text $cool -fill black -anchor n -font $plotFont
        
        set cool [expr {$p025min + ($p975max-$p025min) * 7.0/8}]
        set cool [format "%3.2f" $cool]
        $cuantiles create text 392.5 370 -text $cool -fill black -anchor n -font $plotFont
        
        set cool $p975max
        set cool [format "%3.2f" $cool]
        $cuantiles create text 440 370 -text $cool -fill black -anchor n -font $plotFont
        
        set x "60 107.5 155 202.5 250 297.5 345 392.5 440"
        set y 360
        foreach item $x {
            $cuantiles create rectangle $item $y $item [expr {$y - 9}] -width 1 -outline black
        }
        
        # -----------------------------
        # aide en dessous de l'abscisse
        # -----------------------------
        set x1help 200
        set x2help 300
        set yhelp 410
        $cuantiles create rectangle $x1help $yhelp $x2help $yhelp -width 1 -outline grey33 -tag help
        $cuantiles create rectangle $x1help [expr {$yhelp+5}] [expr {$x1help - 1}] [expr {$yhelp - 5}] -outline grey33 -tag help
        $cuantiles create rectangle $x2help [expr {$yhelp + 5}] [expr {$x2help - 1}] [expr {$yhelp - 5}] -outline grey33 -tag help
        set xmedhelp 250
        set item [$cuantiles create rectangle [expr {$xmedhelp - 2}] [expr {$yhelp - 7}] [expr {$xmedhelp + 2}] [expr {$yhelp + 7}]\
                -width 1 -outline red -tag help]
        $cuantiles create text [expr {$x1help - 20}] [expr {$yhelp + 15}] -text "Minimum" -fill black -tag help
        $cuantiles create text $xmedhelp [expr {$yhelp + 15}] -text "MEDIAN" -fill red -tag help
        $cuantiles create text [expr {$x2help + 20}] [expr {$yhelp + 15}] -text "Maximum" -fill black -tag help
        $cuantiles create rectangle 120 390 390 450 -outline black -tag help
        
        # trace des percentiles P000 et P1000 (minimum et maximum)
        set alop000 $varp000($i)
        set alop1000 $varp1000($i)
        set alop500 $varp500($i)
        set lesset [expr {$alop500 - $alop000}]
        set moreet [expr {$alop500 + $alop1000}]
        
        set range_corrx [expr {400.0 / ($p975max - $p025min) } ]
        set x1 [ expr {50 + ($range_corrx * ($alop000 - $p025min) ) } ]
        set x2 [ expr {50 + ($range_corrx * ($alop1000 - $p025min) ) } ]
        set y [expr {310 - ($i * $intervalle) } ]
        $cuantiles create rectangle $x1 $y $x2 $y -width 1 -outline black
        $cuantiles create rectangle $x1 [expr {$y + 5}] [expr {$x1 - 1}] [expr {$y - 5}] -outline black
        $cuantiles create rectangle $x2 [expr $y+5] [expr $x2 -1] [expr $y-5] -outline black
        
        # Indiquer la MEDIANE !
        set xmed [expr {50 + ( ($alop500 - $p025min) * $range_corrx) } ]
        set item [$cuantiles create rectangle $xmed [expr {$y - 7}] [expr {$xmed + 1}] [expr {$y + 7}] -width 1 -outline red -tag mediane]
        
        # Indiquer le numero de la population (a gauche)
        set y [expr {310 - ($i * $intervalle)}]
        # S'il y a plusieurs ACP avec bootstrap, l'attribution du numero des variables fait usage de 'colonnes'
        global colonnes
        set cool [expr {int(fmod($i,$colonnes) + 1)}]
        $cuantiles create text 10 [expr {$y - 10}] -text $cool -fill red -anchor n -font $plotFont
        
        # Signaler le numero 1
        if  {$cool == 1} {
            $cuantiles create text 20 [expr {$y - 5}] -text "->" -fill red
        }
    }
    global infile
    $cuantiles create text 39 485 -text "[file tail $infile]" -font "Courrier 9" -anchor w -fill red
    if {[info exists compall]} {$cuantiles create text 39 495 -text "Variable [expr {$numfen+1}]" -font "Courrier 9" -anchor w -fill blue}
    $cuantiles create text 5 535 -text $references -font "Courrier 9" -anchor w -fill red
    $cuantiles configure -scrollregion [$cuantiles bbox all] -xscrollincrement 0.1i -yscrollincrement 0.1i
    
    if {[info exists compall]} {
        # Montrer les individus (data)
        set range_corrx [expr {400.0 / ($p975max - $p025min)}]
        for  {set i 0} {$i < $nbvar} {incr i} {
            set y [expr {330 - ($i * $intervalle)}]
            for  {set a 0} {$a < $efectivo($i)} {incr a} {
                set valeur [lindex $pieces($i) $a]
                set x [ expr {50 + ($range_corrx * ($valeur - $p025min))}]
                $cuantiles create rectangle $x [expr {$y + 4}] $x [expr {$y - 4}] -width 1 -outline blue -tag range_data
            }
        }
        # Tracer les quantiles 25-75 Noter le tag specifique range_p25_75
        set range_corrx [expr {400.0 / ($p975max-$p025min)}]
        for  {set i 0} {$i < $nbvar} {incr i} {
            set alop250 $varp250($i)
            set alop750 $varp750($i)
            set alop500 $varp500($i)
            set y [expr {310 - ( $i * $intervalle) } ]
            set x [ expr {50 + ($range_corrx * ($alop250 - $p025min) ) }]
            set etendue [expr {($range_corrx * ($alop750 - $p025min) ) } ]
            $cuantiles create rectangle $x [expr {$y + 7}] [expr {50 + $etendue}] [expr {$y - 7}] \
                    -width 1 -outline "red" -tag range_p25_75
        }
        # Je colorie la mediane en rouge
        $cuantiles itemconfigure mediane -outline red
        # aide en dessous de l'abscisse
        set c $cuantiles
        set lc [$c find withtag help]
        foreach item $lc {$c delete $item}
        
        set x1help 200
        set x2help 300
        set yhelp 410
        set xmedhelp 250
        set item [$cuantiles create rectangle \
                [expr $xmedhelp] [expr {$yhelp - 6}] [expr $xmedhelp] [expr {$yhelp + 6}] -width 1 -outline red -tag help]
        $cuantiles create rectangle $x1help $yhelp $x2help $yhelp -width 1 -outline grey33 -tag help
        $cuantiles create rectangle $x1help [expr {$yhelp + 5}] [expr {$x1help - 1}] [expr {$yhelp - 5}] -outline grey33 -tag help
        $cuantiles create rectangle $x2help [expr {$yhelp + 5}] [expr {$x2help - 1}] [expr {$yhelp - 5}] -outline grey33 -tag help
        set item [$cuantiles create rectangle [expr {$xmedhelp - 25}] [expr {$yhelp - 7}] [expr {$xmedhelp + 25}]\
                [expr {$yhelp + 7}] -width 1 -outline red -tag help]
        $cuantiles create text [expr {$x1help - 20}] [expr {$yhelp + 15}]  -text "Minimum" -fill black -tag help
        $cuantiles create text $xmedhelp [expr {$yhelp + 15}] -text "Median" -fill red -tag help
        $cuantiles create text [expr {$x2help + 20}] [expr {$yhelp + 15}] -text "Maximum" -fill black -tag help
        $cuantiles create text [expr {$x1help + 15}] [expr {$yhelp + 30}] -text "P 25%" -fill red -tag help
        $cuantiles create text [expr {$x2help - 10}] [expr {$yhelp + 30}] -text "P 75%" -fill red -tag help
        $cuantiles create rectangle 120 390 390 450 -outline black -tag help
    }
    
    tkwait window $cuantiles
}
#
# procedure RANGE ## FIN ###


